#include "sbarcbzip2.h"

void SB_CALLBACK TSBBzip2ProgressEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t Processed, int64_t Total, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zProcessed;
	zval * zTotal;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zProcessed);
	ZVAL_LONG(zProcessed, (long)Processed);
	MAKE_STD_ZVAL(zTotal);
	ZVAL_LONG(zTotal, (long)Total);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zProcessed;
	params[2] = &zTotal;
	params[3] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zProcessed);
	zval_ptr_dtor(&zTotal);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBBzip2UserActionNeededEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t ForEvent, const char * pcDescription, int32_t szDescription, int32_t * UserAction)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zForEvent;
	zval * zDescription;
	zval * zUserAction;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zForEvent);
	ZVAL_LONG(zForEvent, (long)ForEvent);
	MAKE_STD_ZVAL(zDescription);
	ZVAL_STRINGL(zDescription, pcDescription, szDescription, 1);
	MAKE_STD_ZVAL(zUserAction);
	ZVAL_LONG(zUserAction, (long)*UserAction);

	params[0] = &zSender;
	params[1] = &zForEvent;
	params[2] = &zDescription;
	params[3] = &zUserAction;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zForEvent);
	zval_ptr_dtor(&zDescription);
	*UserAction = (int32_t)Z_LVAL_P(zUserAction);
	zval_ptr_dtor(&zUserAction);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBBZip2ExtractionStreamNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle * Stream)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zStream;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, *Stream TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zStream;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBBZip2CompressionStreamNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle * Stream)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zStream;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, *Stream TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zStream;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBBZip2ArchiveErrorEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t ErrorCode, const char * pcErrorMessage, int32_t szErrorMessage, int8_t * TryContinue)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zErrorCode;
	zval * zErrorMessage;
	zval * zTryContinue;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)ErrorCode);
	MAKE_STD_ZVAL(zErrorMessage);
	ZVAL_STRINGL(zErrorMessage, pcErrorMessage, szErrorMessage, 1);
	MAKE_STD_ZVAL(zTryContinue);
	ZVAL_BOOL(zTryContinue, (zend_bool)*TryContinue);

	params[0] = &zSender;
	params[1] = &zErrorCode;
	params[2] = &zErrorMessage;
	params[3] = &zTryContinue;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zErrorCode);
	zval_ptr_dtor(&zErrorMessage);
	*TryContinue = (int8_t)Z_BVAL_P(zTryContinue);
	zval_ptr_dtor(&zTryContinue);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElBZip2DecompressingUnit_ce_ptr = NULL;

SB_PHP_METHOD(TElBZip2DecompressingUnit, InitializeProcessing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBZip2DecompressingUnit_InitializeProcessing(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2DecompressingUnit, ProcessBlock)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBZip2DecompressingUnit_ProcessBlock(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2DecompressingUnit, FinalizeProcessing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBZip2DecompressingUnit_FinalizeProcessing(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2DecompressingUnit, get_Verbosity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElBZip2DecompressingUnit_get_Verbosity(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2DecompressingUnit, set_Verbosity)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElBZip2DecompressingUnit_set_Verbosity(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2DecompressingUnit, get_Small)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBZip2DecompressingUnit_get_Small(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2DecompressingUnit, set_Small)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBZip2DecompressingUnit_set_Small(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2DecompressingUnit, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBZip2DecompressingUnit_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2DecompressingUnit_InitializeProcessing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2DecompressingUnit_ProcessBlock, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2DecompressingUnit_FinalizeProcessing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2DecompressingUnit_get_Verbosity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2DecompressingUnit_set_Verbosity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2DecompressingUnit_get_Small, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2DecompressingUnit_set_Small, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2DecompressingUnit___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElBZip2DecompressingUnit_methods[] = {
	PHP_ME(TElBZip2DecompressingUnit, InitializeProcessing, arginfo_TElBZip2DecompressingUnit_InitializeProcessing, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2DecompressingUnit, ProcessBlock, arginfo_TElBZip2DecompressingUnit_ProcessBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2DecompressingUnit, FinalizeProcessing, arginfo_TElBZip2DecompressingUnit_FinalizeProcessing, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2DecompressingUnit, get_Verbosity, arginfo_TElBZip2DecompressingUnit_get_Verbosity, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2DecompressingUnit, set_Verbosity, arginfo_TElBZip2DecompressingUnit_set_Verbosity, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2DecompressingUnit, get_Small, arginfo_TElBZip2DecompressingUnit_get_Small, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2DecompressingUnit, set_Small, arginfo_TElBZip2DecompressingUnit_set_Small, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2DecompressingUnit, __construct, arginfo_TElBZip2DecompressingUnit___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBZip2DecompressingUnit(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBZip2DecompressingUnit_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBZip2DecompressingUnit", TElBZip2DecompressingUnit_methods);
	if (NULL == TElArcProcessingUnit_ce_ptr)
		Register_TElArcProcessingUnit(TSRMLS_C);
	TElBZip2DecompressingUnit_ce_ptr = zend_register_internal_class_ex(&ce, TElArcProcessingUnit_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBZip2CompressingUnit_ce_ptr = NULL;

SB_PHP_METHOD(TElBZip2CompressingUnit, InitializeProcessing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBZip2CompressingUnit_InitializeProcessing(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2CompressingUnit, ProcessBlock)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElBZip2CompressingUnit_ProcessBlock(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4Index, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2CompressingUnit, FinalizeProcessing)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBZip2CompressingUnit_FinalizeProcessing(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2CompressingUnit, get_CompressionLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElBZip2CompressingUnit_get_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2CompressingUnit, set_CompressionLevel)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElBZip2CompressingUnit_set_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2CompressingUnit, get_Verbosity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElBZip2CompressingUnit_get_Verbosity(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2CompressingUnit, set_Verbosity)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElBZip2CompressingUnit_set_Verbosity(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2CompressingUnit, get_WorkFactor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElBZip2CompressingUnit_get_WorkFactor(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2CompressingUnit, set_WorkFactor)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElBZip2CompressingUnit_set_WorkFactor(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2CompressingUnit, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBZip2CompressingUnit_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2CompressingUnit_InitializeProcessing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2CompressingUnit_ProcessBlock, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2CompressingUnit_FinalizeProcessing, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2CompressingUnit_get_CompressionLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2CompressingUnit_set_CompressionLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2CompressingUnit_get_Verbosity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2CompressingUnit_set_Verbosity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2CompressingUnit_get_WorkFactor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2CompressingUnit_set_WorkFactor, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2CompressingUnit___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElBZip2CompressingUnit_methods[] = {
	PHP_ME(TElBZip2CompressingUnit, InitializeProcessing, arginfo_TElBZip2CompressingUnit_InitializeProcessing, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2CompressingUnit, ProcessBlock, arginfo_TElBZip2CompressingUnit_ProcessBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2CompressingUnit, FinalizeProcessing, arginfo_TElBZip2CompressingUnit_FinalizeProcessing, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2CompressingUnit, get_CompressionLevel, arginfo_TElBZip2CompressingUnit_get_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2CompressingUnit, set_CompressionLevel, arginfo_TElBZip2CompressingUnit_set_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2CompressingUnit, get_Verbosity, arginfo_TElBZip2CompressingUnit_get_Verbosity, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2CompressingUnit, set_Verbosity, arginfo_TElBZip2CompressingUnit_set_Verbosity, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2CompressingUnit, get_WorkFactor, arginfo_TElBZip2CompressingUnit_get_WorkFactor, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2CompressingUnit, set_WorkFactor, arginfo_TElBZip2CompressingUnit_set_WorkFactor, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2CompressingUnit, __construct, arginfo_TElBZip2CompressingUnit___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBZip2CompressingUnit(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBZip2CompressingUnit_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBZip2CompressingUnit", TElBZip2CompressingUnit_methods);
	if (NULL == TElArcProcessingUnit_ce_ptr)
		Register_TElArcProcessingUnit(TSRMLS_C);
	TElBZip2CompressingUnit_ce_ptr = zend_register_internal_class_ex(&ce, TElArcProcessingUnit_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBZip2Reader_ce_ptr = NULL;

SB_PHP_METHOD(TElBZip2Reader, Open)
{
	char *sFileName;
	int sFileName_len;
	zend_bool bReadOnly;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sFileName, &sFileName_len, &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElBZip2Reader_Open(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int8_t)bReadOnly) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBZip2Reader_Open_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBZip2Reader_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, Extract)
{
	char *sOutputFile;
	int sOutputFile_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sOutputFile, &sOutputFile_len) == SUCCESS)
	{
		SBCheckError(TElBZip2Reader_Extract(SBGetObjectHandle(getThis() TSRMLS_CC), sOutputFile, (int32_t)sOutputFile_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBZip2Reader_Extract_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, get_CompressedSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElBZip2Reader_get_CompressedSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, get_Small)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBZip2Reader_get_Small(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, set_Small)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBZip2Reader_set_Small(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, get_IgnoreArchiveErrors)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBZip2Reader_get_IgnoreArchiveErrors(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, set_IgnoreArchiveErrors)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBZip2Reader_set_IgnoreArchiveErrors(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, get_FileSystemAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBZip2Reader_get_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, set_FileSystemAdapter)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomFileSystemAdapter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBZip2Reader_set_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomFileSystemAdapter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, get_OnExtractionStreamNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBZip2ExtractionStreamNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElBZip2Reader_get_OnExtractionStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, set_OnExtractionStreamNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElBZip2Reader_set_OnExtractionStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBBZip2ExtractionStreamNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBBZip2ExtractionStreamNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBzip2ProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElBZip2Reader_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElBZip2Reader_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBBzip2ProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBBzip2ProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, get_OnUserActionNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBzip2UserActionNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElBZip2Reader_get_OnUserActionNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, set_OnUserActionNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElBZip2Reader_set_OnUserActionNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBBzip2UserActionNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBBzip2UserActionNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, get_OnArchiveError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBZip2ArchiveErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElBZip2Reader_get_OnArchiveError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, set_OnArchiveError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElBZip2Reader_set_OnArchiveError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBBZip2ArchiveErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBBZip2ArchiveErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Reader, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBZip2Reader_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_Open, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_Extract, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutputFile_or_Stream, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_get_CompressedSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_get_Small, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_set_Small, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_get_IgnoreArchiveErrors, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_set_IgnoreArchiveErrors, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_get_FileSystemAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_set_FileSystemAdapter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomFileSystemAdapter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_get_OnExtractionStreamNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_set_OnExtractionStreamNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_get_OnUserActionNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_set_OnUserActionNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_get_OnArchiveError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader_set_OnArchiveError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Reader___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBZip2Reader_methods[] = {
	PHP_ME(TElBZip2Reader, Open, arginfo_TElBZip2Reader_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, Close, arginfo_TElBZip2Reader_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, Extract, arginfo_TElBZip2Reader_Extract, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, get_CompressedSize, arginfo_TElBZip2Reader_get_CompressedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, get_Small, arginfo_TElBZip2Reader_get_Small, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, set_Small, arginfo_TElBZip2Reader_set_Small, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, get_IgnoreArchiveErrors, arginfo_TElBZip2Reader_get_IgnoreArchiveErrors, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, set_IgnoreArchiveErrors, arginfo_TElBZip2Reader_set_IgnoreArchiveErrors, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, get_FileSystemAdapter, arginfo_TElBZip2Reader_get_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, set_FileSystemAdapter, arginfo_TElBZip2Reader_set_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, get_OnExtractionStreamNeeded, arginfo_TElBZip2Reader_get_OnExtractionStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, set_OnExtractionStreamNeeded, arginfo_TElBZip2Reader_set_OnExtractionStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, get_OnProgress, arginfo_TElBZip2Reader_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, set_OnProgress, arginfo_TElBZip2Reader_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, get_OnUserActionNeeded, arginfo_TElBZip2Reader_get_OnUserActionNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, set_OnUserActionNeeded, arginfo_TElBZip2Reader_set_OnUserActionNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, get_OnArchiveError, arginfo_TElBZip2Reader_get_OnArchiveError, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, set_OnArchiveError, arginfo_TElBZip2Reader_set_OnArchiveError, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Reader, __construct, arginfo_TElBZip2Reader___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBZip2Reader(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBZip2Reader_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBZip2Reader", TElBZip2Reader_methods);
	if (NULL == TElBaseArchive_ce_ptr)
		Register_TElBaseArchive(TSRMLS_C);
	TElBZip2Reader_ce_ptr = zend_register_internal_class_ex(&ce, TElBaseArchive_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBZip2Writer_ce_ptr = NULL;

SB_PHP_METHOD(TElBZip2Writer, CreateArchive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBZip2Writer_CreateArchive(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, Open)
{
	char *sFileName;
	int sFileName_len;
	zend_bool bReadOnly;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sFileName, &sFileName_len, &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElBZip2Writer_Open(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int8_t)bReadOnly) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBZip2Writer_Open_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, Add)
{
	char *sFileName;
	int sFileName_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBZip2Writer_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBZip2Writer_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, Compress)
{
	char *sDestination;
	int sDestination_len;
	zval *oDestination;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestination, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBZip2Writer_Compress(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDestination, &sDestination_len) == SUCCESS)
	{
		SBCheckError(TElBZip2Writer_Compress_1(SBGetObjectHandle(getThis() TSRMLS_CC), sDestination, (int32_t)sDestination_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBZip2Writer_Compress_2(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (string) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBZip2Writer_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, get_NewArchive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBZip2Writer_get_NewArchive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, get_FileSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElBZip2Writer_get_FileSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, get_CompressionLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElBZip2Writer_get_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, set_CompressionLevel)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElBZip2Writer_set_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, get_WorkFactor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElBZip2Writer_get_WorkFactor(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, set_WorkFactor)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElBZip2Writer_set_WorkFactor(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, get_OnCompressionStreamNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBZip2CompressionStreamNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElBZip2Writer_get_OnCompressionStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, set_OnCompressionStreamNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElBZip2Writer_set_OnCompressionStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBBZip2CompressionStreamNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBBZip2CompressionStreamNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBZip2Writer, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBZip2Writer_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_CreateArchive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_Open, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Stream, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_Compress, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Destination, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_get_NewArchive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_get_FileSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_get_CompressionLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_set_CompressionLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_get_WorkFactor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_set_WorkFactor, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_get_OnCompressionStreamNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer_set_OnCompressionStreamNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBZip2Writer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBZip2Writer_methods[] = {
	PHP_ME(TElBZip2Writer, CreateArchive, arginfo_TElBZip2Writer_CreateArchive, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, Open, arginfo_TElBZip2Writer_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, Add, arginfo_TElBZip2Writer_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, Compress, arginfo_TElBZip2Writer_Compress, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, Close, arginfo_TElBZip2Writer_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, get_NewArchive, arginfo_TElBZip2Writer_get_NewArchive, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, get_FileSize, arginfo_TElBZip2Writer_get_FileSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, get_CompressionLevel, arginfo_TElBZip2Writer_get_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, set_CompressionLevel, arginfo_TElBZip2Writer_set_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, get_WorkFactor, arginfo_TElBZip2Writer_get_WorkFactor, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, set_WorkFactor, arginfo_TElBZip2Writer_set_WorkFactor, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, get_OnCompressionStreamNeeded, arginfo_TElBZip2Writer_get_OnCompressionStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, set_OnCompressionStreamNeeded, arginfo_TElBZip2Writer_set_OnCompressionStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElBZip2Writer, __construct, arginfo_TElBZip2Writer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBZip2Writer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBZip2Writer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBZip2Writer", TElBZip2Writer_methods);
	if (NULL == TElBZip2Reader_ce_ptr)
		Register_TElBZip2Reader(TSRMLS_C);
	TElBZip2Writer_ce_ptr = zend_register_internal_class_ex(&ce, TElBZip2Reader_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBArcBZip2_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBArcBZip2, BZIP2_BUFFER_SIZE, SB_BZIP2_BUFFER_SIZE, SB_BZIP2_BUFFER_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBArcBZip2, BZIP_EVENT_EXTRACTION_FAILED, SB_BZIP_EVENT_EXTRACTION_FAILED, SB_BZIP_EVENT_EXTRACTION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBArcBZip2, BZIP_EVENT_FILE_ALREADY_EXISTS, SB_BZIP_EVENT_FILE_ALREADY_EXISTS, SB_BZIP_EVENT_FILE_ALREADY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBArcBZip2, BZIP_EVENT_CANNOT_CREATE_FILE, SB_BZIP_EVENT_CANNOT_CREATE_FILE, SB_BZIP_EVENT_CANNOT_CREATE_FILE);
	SB_REGISTER_LONG_CONSTANT(SBArcBZip2, BZIP_EVENT_DIR_ALREADY_EXISTS, SB_BZIP_EVENT_DIR_ALREADY_EXISTS, SB_BZIP_EVENT_DIR_ALREADY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBArcBZip2, BZIP_EVENT_FILE_ALREADY_ADDED, SB_BZIP_EVENT_FILE_ALREADY_ADDED, SB_BZIP_EVENT_FILE_ALREADY_ADDED);
	SB_REGISTER_LONG_CONSTANT(SBArcBZip2, BZIP_EVENT_CRC_MISMATCH, SB_BZIP_EVENT_CRC_MISMATCH, SB_BZIP_EVENT_CRC_MISMATCH);
	SB_REGISTER_LONG_CONSTANT(SBArcBZip2, BZIP_ACTION_IGNORE, SB_BZIP_ACTION_IGNORE, SB_BZIP_ACTION_IGNORE);
	SB_REGISTER_LONG_CONSTANT(SBArcBZip2, BZIP_ACTION_ABORT, SB_BZIP_ACTION_ABORT, SB_BZIP_ACTION_ABORT);
	SB_REGISTER_LONG_CONSTANT(SBArcBZip2, BZIP_ACTION_RETRY, SB_BZIP_ACTION_RETRY, SB_BZIP_ACTION_RETRY);
	SB_REGISTER_LONG_CONSTANT(SBArcBZip2, BZIP_ACTION_SKIP, SB_BZIP_ACTION_SKIP, SB_BZIP_ACTION_SKIP);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SFileAlreadyExists, SB_SFileAlreadyExists, SB_SFileAlreadyExists);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SInvalidPath, SB_SInvalidPath, SB_SInvalidPath);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SNotExtractNewArchive, SB_SNotExtractNewArchive, SB_SNotExtractNewArchive);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SCannotCreateFile, SB_SCannotCreateFile, SB_SCannotCreateFile);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SInvalidActionRequested, SB_SInvalidActionRequested, SB_SInvalidActionRequested);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SInvalidOutputFile, SB_SInvalidOutputFile, SB_SInvalidOutputFile);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SNoOutputStream, SB_SNoOutputStream, SB_SNoOutputStream);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SInvalidCompressionLevel, SB_SInvalidCompressionLevel, SB_SInvalidCompressionLevel);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SInvalidWorkFactor, SB_SInvalidWorkFactor, SB_SInvalidWorkFactor);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SArchiveAlreadyHaveFile, SB_SArchiveAlreadyHaveFile, SB_SArchiveAlreadyHaveFile);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SNoInputForCompression, SB_SNoInputForCompression, SB_SNoInputForCompression);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SArchiveNotOpened, SB_SArchiveNotOpened, SB_SArchiveNotOpened);
	SB_REGISTER_STRING_CONSTANT(SBArcBZip2, SArchiveNotAssign, SB_SArchiveNotAssign, SB_SArchiveNotAssign);
}

void Register_SBArcBZip2_Aliases(TSRMLS_D)
{
	if (NULL == TElBZip2DecompressingUnit_ce_ptr)
		Register_TElBZip2DecompressingUnit(TSRMLS_C);
	zend_register_class_alias("ElBZip2DecompressingUnit", TElBZip2DecompressingUnit_ce_ptr);
	if (NULL == TElBZip2CompressingUnit_ce_ptr)
		Register_TElBZip2CompressingUnit(TSRMLS_C);
	zend_register_class_alias("ElBZip2CompressingUnit", TElBZip2CompressingUnit_ce_ptr);
	if (NULL == TElBZip2Reader_ce_ptr)
		Register_TElBZip2Reader(TSRMLS_C);
	zend_register_class_alias("ElBZip2Reader", TElBZip2Reader_ce_ptr);
	if (NULL == TElBZip2Writer_ce_ptr)
		Register_TElBZip2Writer(TSRMLS_C);
	zend_register_class_alias("ElBZip2Writer", TElBZip2Writer_ce_ptr);
}

