#include "sbauthenticode.h"

SB_PHP_METHOD(TChecksumContext, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TChecksumContext));
		intern->len = sizeof(TChecksumContext);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TChecksumContext, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TChecksumContext));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TChecksumContext, get_Current)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TChecksumContext, set_Current)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TChecksumContext, get_Buffer)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

SB_PHP_METHOD(TChecksumContext, set_Buffer)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 4);
}

zend_class_entry *TChecksumContext_ce_ptr = NULL;

static zend_function_entry TChecksumContext_methods[] = {
	PHP_ME(TChecksumContext, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TChecksumContext, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TChecksumContext, get_Current, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TChecksumContext, set_Current, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TChecksumContext, get_Buffer, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TChecksumContext, set_Buffer, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TChecksumContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TChecksumContext_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TChecksumContext", TChecksumContext_methods);
	TChecksumContext_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBAuthenticodeDigestAlgorithm_ce_ptr = NULL;

zend_class_entry *TSBAuthenticodeDigestEncryptionAlgorithm_ce_ptr = NULL;

zend_class_entry *TSBAuthenticodeStatementType_ce_ptr = NULL;

void SB_CALLBACK TSBAuthenticodeTimestampNeededRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pRequest[], int32_t szRequest, uint8_t pReply[], int32_t * szReply, int8_t * Succeeded)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zRequest;
	zval * zReply;
	SBArrayZValInfo aiReply;
	zval * zSucceeded;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRequest);
	ZVAL_STRINGL(zRequest, pRequest, szRequest, 1);
	MAKE_STD_ZVAL(zReply);
	ZVAL_STRINGL(zReply, pReply, *szReply, 1);
	MAKE_STD_ZVAL(zSucceeded);
	ZVAL_BOOL(zSucceeded, (zend_bool)*Succeeded);

	params[0] = &zSender;
	params[1] = &zRequest;
	params[2] = &zReply;
	params[3] = &zSucceeded;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zRequest);
	if (SBGetByteArrayFromZVal(zReply, &aiReply TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(3, aiReply.data, aiReply.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiReply);
	zval_ptr_dtor(&zReply);
	*Succeeded = (int8_t)Z_BVAL_P(zSucceeded);
	zval_ptr_dtor(&zSucceeded);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElAuthenticodeProcessor_ce_ptr = NULL;

SB_PHP_METHOD(TElAuthenticodeProcessor, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAuthenticodeProcessor_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeProcessor___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAuthenticodeProcessor_methods[] = {
	PHP_ME(TElAuthenticodeProcessor, __construct, arginfo_TElAuthenticodeProcessor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAuthenticodeProcessor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAuthenticodeProcessor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAuthenticodeProcessor", TElAuthenticodeProcessor_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElAuthenticodeProcessor_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAuthenticodeSigner_ce_ptr = NULL;

SB_PHP_METHOD(TElAuthenticodeSigner, AddCertificate)
{
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAuthenticodeSigner_AddCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeSigner, AddAuthenticode)
{
	long fDigestAlgorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fDigestAlgorithm) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAuthenticodeSigner_AddAuthenticode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAuthenticodeDigestAlgorithmRaw)fDigestAlgorithm, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeSigner, AddSignature)
{
	char *sDescription;
	char *sURL;
	int sDescription_len;
	int sURL_len;
	long fAlgorithm;
	zend_bool bAddSigner;
	zend_bool bAddTimestamp;
	zend_bool bTrustedTimestamp;
	zval *oSigner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslO!bbb", &sDescription, &sDescription_len, &sURL, &sURL_len, &fAlgorithm, &oSigner, TElX509Certificate_ce_ptr, &bAddSigner, &bAddTimestamp, &bTrustedTimestamp) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAuthenticodeSigner_AddSignature(SBGetObjectHandle(getThis() TSRMLS_CC), sDescription, (int32_t)sDescription_len, sURL, (int32_t)sURL_len, (TSBAuthenticodeDigestAlgorithmRaw)fAlgorithm, SBGetObjectHandle(oSigner TSRMLS_CC), (int8_t)bAddSigner, (int8_t)bAddTimestamp, (int8_t)bTrustedTimestamp, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, integer, TElX509Certificate, bool, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeSigner, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAuthenticodeSigner_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeSigner, CloseFile)
{
	zend_bool bApply;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bApply) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAuthenticodeSigner_CloseFile(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bApply, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeSigner, OpenFile)
{
	char *sFileName;
	int sFileName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAuthenticodeSigner_OpenFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeSigner, OpenStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAuthenticodeSigner_OpenStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeSigner, get_StatementType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAuthenticodeStatementTypeRaw fOutResultRaw = 0;
		SBCheckError(TElAuthenticodeSigner_get_StatementType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeSigner, set_StatementType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElAuthenticodeSigner_set_StatementType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAuthenticodeStatementTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeSigner, get_OnTimestampNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAuthenticodeTimestampNeeded pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElAuthenticodeSigner_get_OnTimestampNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeSigner, set_OnTimestampNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElAuthenticodeSigner_set_OnTimestampNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBAuthenticodeTimestampNeededRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBAuthenticodeTimestampNeeded|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeSigner, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAuthenticodeSigner_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeSigner_AddCertificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeSigner_AddAuthenticode, 0, 0, 1)
	ZEND_ARG_INFO(0, DigestAlgorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeSigner_AddSignature, 0, 0, 7)
	ZEND_ARG_INFO(0, Description)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_OBJ_INFO(0, Signer, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, AddSigner)
	ZEND_ARG_INFO(0, AddTimestamp)
	ZEND_ARG_INFO(0, TrustedTimestamp)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeSigner_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeSigner_CloseFile, 0, 0, 1)
	ZEND_ARG_INFO(0, Apply)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeSigner_OpenFile, 0, 0, 1)
	ZEND_ARG_INFO(0, FileName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeSigner_OpenStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeSigner_get_StatementType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeSigner_set_StatementType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeSigner_get_OnTimestampNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeSigner_set_OnTimestampNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeSigner___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAuthenticodeSigner_methods[] = {
	PHP_ME(TElAuthenticodeSigner, AddCertificate, arginfo_TElAuthenticodeSigner_AddCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeSigner, AddAuthenticode, arginfo_TElAuthenticodeSigner_AddAuthenticode, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeSigner, AddSignature, arginfo_TElAuthenticodeSigner_AddSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeSigner, Clear, arginfo_TElAuthenticodeSigner_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeSigner, CloseFile, arginfo_TElAuthenticodeSigner_CloseFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeSigner, OpenFile, arginfo_TElAuthenticodeSigner_OpenFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeSigner, OpenStream, arginfo_TElAuthenticodeSigner_OpenStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeSigner, get_StatementType, arginfo_TElAuthenticodeSigner_get_StatementType, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeSigner, set_StatementType, arginfo_TElAuthenticodeSigner_set_StatementType, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeSigner, get_OnTimestampNeeded, arginfo_TElAuthenticodeSigner_get_OnTimestampNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeSigner, set_OnTimestampNeeded, arginfo_TElAuthenticodeSigner_set_OnTimestampNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeSigner, __construct, arginfo_TElAuthenticodeSigner___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAuthenticodeSigner(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAuthenticodeSigner_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAuthenticodeSigner", TElAuthenticodeSigner_methods);
	if (NULL == TElAuthenticodeProcessor_ce_ptr)
		Register_TElAuthenticodeProcessor(TSRMLS_C);
	TElAuthenticodeSigner_ce_ptr = zend_register_internal_class_ex(&ce, TElAuthenticodeProcessor_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAuthenticodeVerifier_ce_ptr = NULL;

SB_PHP_METHOD(TElAuthenticodeVerifier, CloseFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAuthenticodeVerifier_CloseFile(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, GetSignatureInfo)
{
	char *sDescription = NULL;
	char *sURL = NULL;
	int32_t sDescription_len = 0;
	int32_t sURL_len = 0;
	int64_t dtTimeStampRaw = 0;
	long l4Index;
	TElClassHandle hoTrustedTimeStamp = SB_NULL_HANDLE;
	uint32_t _err;
	zval *dtTimeStamp;
	zval *oTrustedTimeStamp;
	zval *zsDescription;
	zval *zsURL;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzOO", &l4Index, &zsDescription, &zsURL, &dtTimeStamp, php_date_get_date_ce(), &oTrustedTimeStamp, TElClientTSPInfo_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zsDescription) && (IS_STRING == Z_TYPE_P(zsDescription)) && PZVAL_IS_REF(zsURL) && (IS_STRING == Z_TYPE_P(zsURL)) && PZVAL_IS_REF(dtTimeStamp) && PZVAL_IS_REF(oTrustedTimeStamp) && (IS_OBJECT == Z_TYPE_P(oTrustedTimeStamp)))
	{
		int8_t bOutResultRaw = 0;
		_err = TElAuthenticodeVerifier_GetSignatureInfo(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sDescription, &sDescription_len, sURL, &sURL_len, &dtTimeStampRaw, &hoTrustedTimeStamp, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sDescription = emalloc(sDescription_len + 1);
			SBCheckError(SBGetLastReturnStringA(-186150365, 2, sDescription, &sDescription_len) TSRMLS_CC);
			zval_dtor(zsDescription);
			sURL = emalloc(sURL_len + 1);
			SBCheckError(SBGetLastReturnStringA(-186150365, 3, sURL, &sURL_len) TSRMLS_CC);
			zval_dtor(zsURL);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sDescription[sDescription_len] = 0;
		ZVAL_STRINGL(zsDescription, sDescription, sDescription_len, 0);
		sURL[sURL_len] = 0;
		ZVAL_STRINGL(zsURL, sURL, sURL_len, 0);
		SBSetDateTime(dtTimeStamp, dtTimeStampRaw TSRMLS_CC);
		SBUpdateObjectHandle(oTrustedTimeStamp, hoTrustedTimeStamp TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, &string, &string, &DateTime, &TElClientTSPInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, OpenFile)
{
	char *sFileName;
	int sFileName_len;
	zend_bool bOpenReadOnly;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sFileName, &sFileName_len, &bOpenReadOnly) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAuthenticodeVerifier_OpenFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int8_t)bOpenReadOnly, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, OpenStream)
{
	zend_bool bOpenReadOnly;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bOpenReadOnly) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAuthenticodeVerifier_OpenStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOpenReadOnly, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, RemoveAuthenticode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAuthenticodeVerifier_RemoveAuthenticode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, VerifySignature)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAuthenticodeVerifier_VerifySignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, get_ActualChecksum)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElAuthenticodeVerifier_get_ActualChecksum(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, get_ActualDigest)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElAuthenticodeVerifier_get_ActualDigest(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1296312408, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, get_Certificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAuthenticodeVerifier_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, get_Checksum)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElAuthenticodeVerifier_get_Checksum(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, get_Digest)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElAuthenticodeVerifier_get_Digest(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2082278174, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, get_DigestAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAuthenticodeDigestAlgorithmRaw fOutResultRaw = 0;
		SBCheckError(TElAuthenticodeVerifier_get_DigestAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, get_SignatureCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAuthenticodeVerifier_get_SignatureCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, get_Signatures)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAuthenticodeVerifier_get_Signatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS7Signer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, get_Timestamps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElAuthenticodeVerifier_get_Timestamps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, get_TrustedTimestamps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAuthenticodeVerifier_get_TrustedTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAuthenticodeVerifier_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAuthenticodeVerifier_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAuthenticodeVerifier, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAuthenticodeVerifier_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_CloseFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_GetSignatureInfo, 0, 0, 5)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(1, Description)
	ZEND_ARG_INFO(1, URL)
	ZEND_ARG_OBJ_INFO(1, TimeStamp, DateTime, 0)
	ZEND_ARG_OBJ_INFO(1, TrustedTimeStamp, TElClientTSPInfo, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_OpenFile, 0, 0, 2)
	ZEND_ARG_INFO(0, FileName)
	ZEND_ARG_INFO(0, OpenReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_OpenStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, OpenReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_RemoveAuthenticode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_VerifySignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_get_ActualChecksum, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_get_ActualDigest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_get_Certificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_get_Checksum, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_get_Digest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_get_DigestAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_get_SignatureCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_get_Signatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_get_Timestamps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_get_TrustedTimestamps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAuthenticodeVerifier___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAuthenticodeVerifier_methods[] = {
	PHP_ME(TElAuthenticodeVerifier, CloseFile, arginfo_TElAuthenticodeVerifier_CloseFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, GetSignatureInfo, arginfo_TElAuthenticodeVerifier_GetSignatureInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, OpenFile, arginfo_TElAuthenticodeVerifier_OpenFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, OpenStream, arginfo_TElAuthenticodeVerifier_OpenStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, RemoveAuthenticode, arginfo_TElAuthenticodeVerifier_RemoveAuthenticode, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, VerifySignature, arginfo_TElAuthenticodeVerifier_VerifySignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, get_ActualChecksum, arginfo_TElAuthenticodeVerifier_get_ActualChecksum, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, get_ActualDigest, arginfo_TElAuthenticodeVerifier_get_ActualDigest, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, get_Certificates, arginfo_TElAuthenticodeVerifier_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, get_Checksum, arginfo_TElAuthenticodeVerifier_get_Checksum, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, get_Digest, arginfo_TElAuthenticodeVerifier_get_Digest, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, get_DigestAlgorithm, arginfo_TElAuthenticodeVerifier_get_DigestAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, get_SignatureCount, arginfo_TElAuthenticodeVerifier_get_SignatureCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, get_Signatures, arginfo_TElAuthenticodeVerifier_get_Signatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, get_Timestamps, arginfo_TElAuthenticodeVerifier_get_Timestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, get_TrustedTimestamps, arginfo_TElAuthenticodeVerifier_get_TrustedTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, get_CertStorage, arginfo_TElAuthenticodeVerifier_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, set_CertStorage, arginfo_TElAuthenticodeVerifier_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElAuthenticodeVerifier, __construct, arginfo_TElAuthenticodeVerifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAuthenticodeVerifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAuthenticodeVerifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAuthenticodeVerifier", TElAuthenticodeVerifier_methods);
	if (NULL == TElAuthenticodeProcessor_ce_ptr)
		Register_TElAuthenticodeProcessor(TSRMLS_C);
	TElAuthenticodeVerifier_ce_ptr = zend_register_internal_class_ex(&ce, TElAuthenticodeProcessor_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBAuthenticode_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_BASE, SB_AUTHENTICODE_ERROR_BASE, SB_AUTHENTICODE_ERROR_BASE);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_SUCCESS, SB_AUTHENTICODE_ERROR_SUCCESS, SB_AUTHENTICODE_ERROR_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_UNKNOWN, SB_AUTHENTICODE_ERROR_UNKNOWN, SB_AUTHENTICODE_ERROR_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_CANNOT_OPEN_FILE, SB_AUTHENTICODE_ERROR_CANNOT_OPEN_FILE, SB_AUTHENTICODE_ERROR_CANNOT_OPEN_FILE);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_FILE_TOO_SMALL, SB_AUTHENTICODE_ERROR_FILE_TOO_SMALL, SB_AUTHENTICODE_ERROR_FILE_TOO_SMALL);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_CANNOT_READ_FILE, SB_AUTHENTICODE_ERROR_CANNOT_READ_FILE, SB_AUTHENTICODE_ERROR_CANNOT_READ_FILE);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_CANNOT_WRITE_FILE, SB_AUTHENTICODE_ERROR_CANNOT_WRITE_FILE, SB_AUTHENTICODE_ERROR_CANNOT_WRITE_FILE);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_INVALID_EXECUTABLE, SB_AUTHENTICODE_ERROR_INVALID_EXECUTABLE, SB_AUTHENTICODE_ERROR_INVALID_EXECUTABLE);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_INVALID_PE_FORMAT, SB_AUTHENTICODE_ERROR_INVALID_PE_FORMAT, SB_AUTHENTICODE_ERROR_INVALID_PE_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_FILE_NOT_SIGNED, SB_AUTHENTICODE_ERROR_FILE_NOT_SIGNED, SB_AUTHENTICODE_ERROR_FILE_NOT_SIGNED);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_SIGNATURE_CORRUPTED, SB_AUTHENTICODE_ERROR_SIGNATURE_CORRUPTED, SB_AUTHENTICODE_ERROR_SIGNATURE_CORRUPTED);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_INVALID_ALGORITHM, SB_AUTHENTICODE_ERROR_INVALID_ALGORITHM, SB_AUTHENTICODE_ERROR_INVALID_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_INVALID_DIGEST_SIZE, SB_AUTHENTICODE_ERROR_INVALID_DIGEST_SIZE, SB_AUTHENTICODE_ERROR_INVALID_DIGEST_SIZE);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_INVALID_INDEX, SB_AUTHENTICODE_ERROR_INVALID_INDEX, SB_AUTHENTICODE_ERROR_INVALID_INDEX);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_NO_SIGNER_CERTIFICATE, SB_AUTHENTICODE_ERROR_NO_SIGNER_CERTIFICATE, SB_AUTHENTICODE_ERROR_NO_SIGNER_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_INVALID_SIGNATURE, SB_AUTHENTICODE_ERROR_INVALID_SIGNATURE, SB_AUTHENTICODE_ERROR_INVALID_SIGNATURE);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_INVALID_CERTIFICATE, SB_AUTHENTICODE_ERROR_INVALID_CERTIFICATE, SB_AUTHENTICODE_ERROR_INVALID_CERTIFICATE);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_FILE_ALREADY_SIGNED, SB_AUTHENTICODE_ERROR_FILE_ALREADY_SIGNED, SB_AUTHENTICODE_ERROR_FILE_ALREADY_SIGNED);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_INVALID_ARGUMENT, SB_AUTHENTICODE_ERROR_INVALID_ARGUMENT, SB_AUTHENTICODE_ERROR_INVALID_ARGUMENT);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_INVALID_DATA, SB_AUTHENTICODE_ERROR_INVALID_DATA, SB_AUTHENTICODE_ERROR_INVALID_DATA);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_NO_SIGNATURES, SB_AUTHENTICODE_ERROR_NO_SIGNATURES, SB_AUTHENTICODE_ERROR_NO_SIGNATURES);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_NO_COUNTERSIGNATURES, SB_AUTHENTICODE_ERROR_NO_COUNTERSIGNATURES, SB_AUTHENTICODE_ERROR_NO_COUNTERSIGNATURES);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_FILE_NOT_OPEN, SB_AUTHENTICODE_ERROR_FILE_NOT_OPEN, SB_AUTHENTICODE_ERROR_FILE_NOT_OPEN);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_SIGNATURE_NOT_LAST, SB_AUTHENTICODE_ERROR_SIGNATURE_NOT_LAST, SB_AUTHENTICODE_ERROR_SIGNATURE_NOT_LAST);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_INVALID_AUTHENTICODE, SB_AUTHENTICODE_ERROR_INVALID_AUTHENTICODE, SB_AUTHENTICODE_ERROR_INVALID_AUTHENTICODE);
	SB_REGISTER_LONG_CONSTANT(SBAuthenticode, SB_AUTHENTICODE_ERROR_NO_TIMESTAMP, SB_AUTHENTICODE_ERROR_NO_TIMESTAMP, SB_AUTHENTICODE_ERROR_NO_TIMESTAMP);
}

void Register_SBAuthenticode_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBAuthenticodeDigestAlgorithm", NULL);
	TSBAuthenticodeDigestAlgorithm_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAuthenticodeDigestAlgorithm_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticodeDigestAlgorithm_ce_ptr, "acMD5", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticodeDigestAlgorithm_ce_ptr, "acSHA1", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticodeDigestAlgorithm_ce_ptr, "acSHA224", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticodeDigestAlgorithm_ce_ptr, "acSHA256", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticodeDigestAlgorithm_ce_ptr, "acSHA384", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticodeDigestAlgorithm_ce_ptr, "acSHA512", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBAuthenticodeDigestEncryptionAlgorithm", NULL);
	TSBAuthenticodeDigestEncryptionAlgorithm_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAuthenticodeDigestEncryptionAlgorithm_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticodeDigestEncryptionAlgorithm_ce_ptr, "acRSA", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticodeDigestEncryptionAlgorithm_ce_ptr, "acDSA", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBAuthenticodeStatementType", NULL);
	TSBAuthenticodeStatementType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAuthenticodeStatementType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticodeStatementType_ce_ptr, "acPrivate", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAuthenticodeStatementType_ce_ptr, "acCommercial", 1)
}

void Register_SBAuthenticode_Aliases(TSRMLS_D)
{
	if (NULL == TElAuthenticodeProcessor_ce_ptr)
		Register_TElAuthenticodeProcessor(TSRMLS_C);
	zend_register_class_alias("ElAuthenticodeProcessor", TElAuthenticodeProcessor_ce_ptr);
	if (NULL == TElAuthenticodeSigner_ce_ptr)
		Register_TElAuthenticodeSigner(TSRMLS_C);
	zend_register_class_alias("ElAuthenticodeSigner", TElAuthenticodeSigner_ce_ptr);
	if (NULL == TElAuthenticodeVerifier_ce_ptr)
		Register_TElAuthenticodeVerifier(TSRMLS_C);
	zend_register_class_alias("ElAuthenticodeVerifier", TElAuthenticodeVerifier_ce_ptr);
}

