#include "sbbcrypt.h"

zend_class_entry *TElBCrypt_ce_ptr = NULL;

SB_PHP_METHOD(TElBCrypt, GenerateSalt_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElBCrypt_GenerateSalt_1(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1543422591, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBCrypt, GenerateSalt)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElBCrypt_GenerateSalt(u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1543422591, 0, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBCrypt, EncryptPassword_Inst)
{
	char *sPassword;
	int sPassword_len;
	long l4Rounds;
	SBArrayZValInfo aiSalt;
	uint32_t _err;
	zval *zaSalt;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPassword, &sPassword_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBCrypt_EncryptPassword_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPassword, (int32_t)sPassword_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(621264648, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sPassword, &sPassword_len, &zaSalt) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSalt)) || (IS_ARRAY == Z_TYPE_P(zaSalt)) || (IS_NULL == Z_TYPE_P(zaSalt))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaSalt, &aiSalt TSRMLS_CC)) RETURN_FALSE;
		_err = TElBCrypt_EncryptPassword_3(SBGetObjectHandle(getThis() TSRMLS_CC), sPassword, (int32_t)sPassword_len, aiSalt.data, aiSalt.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(863859830, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiSalt);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szl", &sPassword, &sPassword_len, &zaSalt, &l4Rounds) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSalt)) || (IS_ARRAY == Z_TYPE_P(zaSalt)) || (IS_NULL == Z_TYPE_P(zaSalt))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaSalt, &aiSalt TSRMLS_CC)) RETURN_FALSE;
		_err = TElBCrypt_EncryptPassword_5(SBGetObjectHandle(getThis() TSRMLS_CC), sPassword, (int32_t)sPassword_len, aiSalt.data, aiSalt.len, (int32_t)l4Rounds, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(132746051, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiSalt);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, array of byte|string|NULL) or (string, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBCrypt, EncryptPassword)
{
	char *sPassword;
	int sPassword_len;
	long l4Rounds;
	SBArrayZValInfo aiSalt;
	uint32_t _err;
	zval *zaSalt;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPassword, &sPassword_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBCrypt_EncryptPassword(sPassword, (int32_t)sPassword_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(621264648, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sPassword, &sPassword_len, &zaSalt) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSalt)) || (IS_ARRAY == Z_TYPE_P(zaSalt)) || (IS_NULL == Z_TYPE_P(zaSalt))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaSalt, &aiSalt TSRMLS_CC)) RETURN_FALSE;
		_err = TElBCrypt_EncryptPassword_2(sPassword, (int32_t)sPassword_len, aiSalt.data, aiSalt.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(863859830, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiSalt);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szl", &sPassword, &sPassword_len, &zaSalt, &l4Rounds) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSalt)) || (IS_ARRAY == Z_TYPE_P(zaSalt)) || (IS_NULL == Z_TYPE_P(zaSalt))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaSalt, &aiSalt TSRMLS_CC)) RETURN_FALSE;
		_err = TElBCrypt_EncryptPassword_4(sPassword, (int32_t)sPassword_len, aiSalt.data, aiSalt.len, (int32_t)l4Rounds, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(132746051, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiSalt);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, array of byte|string|NULL) or (string, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBCrypt, CheckPassword_Inst)
{
	char *sEncryptedPassword;
	char *sPassword;
	int sEncryptedPassword_len;
	int sPassword_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sPassword, &sPassword_len, &sEncryptedPassword, &sEncryptedPassword_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBCrypt_CheckPassword_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPassword, (int32_t)sPassword_len, sEncryptedPassword, (int32_t)sEncryptedPassword_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBCrypt, CheckPassword)
{
	char *sEncryptedPassword;
	char *sPassword;
	int sEncryptedPassword_len;
	int sPassword_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sPassword, &sPassword_len, &sEncryptedPassword, &sEncryptedPassword_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBCrypt_CheckPassword(sPassword, (int32_t)sPassword_len, sEncryptedPassword, (int32_t)sEncryptedPassword_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBCrypt, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBCrypt_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBCrypt_GenerateSalt_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBCrypt_GenerateSalt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBCrypt_EncryptPassword_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_TYPE_INFO(0, Salt, 0, 1)
	ZEND_ARG_INFO(0, Rounds)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBCrypt_EncryptPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_TYPE_INFO(0, Salt, 0, 1)
	ZEND_ARG_INFO(0, Rounds)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBCrypt_CheckPassword_Inst, 0, 0, 2)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_INFO(0, EncryptedPassword)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBCrypt_CheckPassword, 0, 0, 2)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_INFO(0, EncryptedPassword)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBCrypt___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElBCrypt_methods[] = {
	PHP_ME(TElBCrypt, GenerateSalt_Inst, arginfo_TElBCrypt_GenerateSalt_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElBCrypt, GenerateSalt, arginfo_TElBCrypt_GenerateSalt, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBCrypt, EncryptPassword_Inst, arginfo_TElBCrypt_EncryptPassword_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElBCrypt, EncryptPassword, arginfo_TElBCrypt_EncryptPassword, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBCrypt, CheckPassword_Inst, arginfo_TElBCrypt_CheckPassword_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElBCrypt, CheckPassword, arginfo_TElBCrypt_CheckPassword, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElBCrypt, __construct, arginfo_TElBCrypt___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBCrypt(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBCrypt_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBCrypt", TElBCrypt_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBCrypt_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBBCrypt_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBBCrypt, SInvalidRoundsNumber, SB_SInvalidRoundsNumber, SB_SInvalidRoundsNumber);
	SB_REGISTER_STRING_CONSTANT(SBBCrypt, SInvalidSaltSize, SB_SInvalidSaltSize, SB_SInvalidSaltSize);
	SB_REGISTER_STRING_CONSTANT(SBBCrypt, SInvalidPasswordLength, SB_SInvalidPasswordLength, SB_SInvalidPasswordLength);
	SB_REGISTER_STRING_CONSTANT(SBBCrypt, SInvalidBase64Encoding, SB_SInvalidBase64Encoding, SB_SInvalidBase64Encoding);
	SB_REGISTER_STRING_CONSTANT(SBBCrypt, SInvalidEncryptedPassword, SB_SInvalidEncryptedPassword, SB_SInvalidEncryptedPassword);
}

