#include "sbchsunicode.h"

zend_class_entry *TPlCharType_ce_ptr = NULL;

SB_PHP_FUNCTION(SBChSUnicode, WideUpperCase)
{
	char *sC;
	char *sS;
	int sS_len;
	int32_t sC_len;
	uint32_t _err;
	zval *zsC;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zsC) == SUCCESS) && PZVAL_IS_REF(zsC) && (IS_STRING == Z_TYPE_P(zsC)))
	{
		sC = Z_STRVAL_P(zsC);
		sC_len = (int32_t)Z_STRLEN_P(zsC);
		_err = SBChSUnicode_WideUpperCase(sC, &sC_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sC = emalloc(sC_len + 1);
			SBCheckError(SBGetLastReturnStringA(588306843, 0, sC, &sC_len) TSRMLS_CC);
			zval_dtor(zsC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sC[sC_len] = 0;
		ZVAL_STRINGL(zsC, sC, sC_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBChSUnicode_WideUpperCase_1(sS, (int32_t)sS_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1090267963, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(&string) or (string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSUnicode, WideTitleCase)
{
	char *sC;
	char *sS;
	int sS_len;
	int32_t sC_len;
	uint32_t _err;
	zval *zsC;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zsC) == SUCCESS) && PZVAL_IS_REF(zsC) && (IS_STRING == Z_TYPE_P(zsC)))
	{
		sC = Z_STRVAL_P(zsC);
		sC_len = (int32_t)Z_STRLEN_P(zsC);
		_err = SBChSUnicode_WideTitleCase(sC, &sC_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sC = emalloc(sC_len + 1);
			SBCheckError(SBGetLastReturnStringA(463060894, 0, sC, &sC_len) TSRMLS_CC);
			zval_dtor(zsC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sC[sC_len] = 0;
		ZVAL_STRINGL(zsC, sC, sC_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBChSUnicode_WideTitleCase_1(sS, (int32_t)sS_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-315320298, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(&string) or (string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSUnicode, GetCharType)
{
	char *sC;
	int sC_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sC, &sC_len) == SUCCESS)
	{
		TPlCharTypeRaw fOutResultRaw = 0;
		SBCheckError(SBChSUnicode_GetCharType(sC, (int32_t)sC_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSUnicode, WideLowerCase)
{
	char *sC;
	char *sS;
	int sS_len;
	int32_t sC_len;
	uint32_t _err;
	zval *zsC;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zsC) == SUCCESS) && PZVAL_IS_REF(zsC) && (IS_STRING == Z_TYPE_P(zsC)))
	{
		sC = Z_STRVAL_P(zsC);
		sC_len = (int32_t)Z_STRLEN_P(zsC);
		_err = SBChSUnicode_WideLowerCase(sC, &sC_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sC = emalloc(sC_len + 1);
			SBCheckError(SBGetLastReturnStringA(-644165709, 0, sC, &sC_len) TSRMLS_CC);
			zval_dtor(zsC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sC[sC_len] = 0;
		ZVAL_STRINGL(zsC, sC, sC_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBChSUnicode_WideLowerCase_1(sS, (int32_t)sS_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-662402316, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(&string) or (string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSUnicode, Normalize_NFD)
{
	char *sAString;
	int sAString_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAString, &sAString_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBChSUnicode_Normalize_NFD(sAString, (int32_t)sAString_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1802691262, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSUnicode, Normalize_NFC)
{
	char *sAString;
	int sAString_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAString, &sAString_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBChSUnicode_Normalize_NFC(sAString, (int32_t)sAString_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-499874324, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSUnicode, Normalize_NFKD)
{
	char *sAString;
	int sAString_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAString, &sAString_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBChSUnicode_Normalize_NFKD(sAString, (int32_t)sAString_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(193978565, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSUnicode, Normalize_NFKC)
{
	char *sAString;
	int sAString_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAString, &sAString_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBChSUnicode_Normalize_NFKC(sAString, (int32_t)sAString_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2100721771, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSUnicode, CheckProhibit)
{
	char *sstr;
	int sstr_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sstr, &sstr_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBChSUnicode_CheckProhibit(sstr, (int32_t)sstr_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(415522769, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSUnicode, CheckBidi)
{
	char *sstr;
	int sstr_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sstr, &sstr_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBChSUnicode_CheckBidi(sstr, (int32_t)sstr_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(499945083, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSUnicode, GetCharCode)
{
	char *sInCh;
	int sInCh_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sInCh, &sInCh_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBChSUnicode_GetCharCode(sInCh, (int32_t)sInCh_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBChSUnicode, GetCharValue)
{
	long u4Code;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Code) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBChSUnicode_GetCharValue((uint32_t)u4Code, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(676923482, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

void Register_SBChSUnicode_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBChSUnicode, SInvalidChar, SB_SInvalidChar, SB_SInvalidChar);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_SBASE, SB_HANGUL_SBASE, SB_HANGUL_SBASE);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_LBASE, SB_HANGUL_LBASE, SB_HANGUL_LBASE);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_VBASE, SB_HANGUL_VBASE, SB_HANGUL_VBASE);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_TBASE, SB_HANGUL_TBASE, SB_HANGUL_TBASE);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_LCOUNT, SB_HANGUL_LCOUNT, SB_HANGUL_LCOUNT);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_VCOUNT, SB_HANGUL_VCOUNT, SB_HANGUL_VCOUNT);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_TCOUNT, SB_HANGUL_TCOUNT, SB_HANGUL_TCOUNT);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_NCOUNT, SB_HANGUL_NCOUNT, SB_HANGUL_NCOUNT);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_SCOUNT, SB_HANGUL_SCOUNT, SB_HANGUL_SCOUNT);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_L_START, SB_HANGUL_L_START, SB_HANGUL_L_START);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_L_END, SB_HANGUL_L_END, SB_HANGUL_L_END);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_L_FILLER, SB_HANGUL_L_FILLER, SB_HANGUL_L_FILLER);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_V_START, SB_HANGUL_V_START, SB_HANGUL_V_START);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_V_END, SB_HANGUL_V_END, SB_HANGUL_V_END);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_T_START, SB_HANGUL_T_START, SB_HANGUL_T_START);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_T_END, SB_HANGUL_T_END, SB_HANGUL_T_END);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_S_START, SB_HANGUL_S_START, SB_HANGUL_S_START);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, HANGUL_S_END, SB_HANGUL_S_END, SB_HANGUL_S_END);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, UnassignedCodesCount, SB_UnassignedCodesCount, SB_UnassignedCodesCount);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, DeprecatedCodesCount, SB_DeprecatedCodesCount, SB_DeprecatedCodesCount);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, PrivateCodesCount, SB_PrivateCodesCount, SB_PrivateCodesCount);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, NonCharacterCodesCount, SB_NonCharacterCodesCount, SB_NonCharacterCodesCount);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, SurrogateCodesCount, SB_SurrogateCodesCount, SB_SurrogateCodesCount);
	SB_REGISTER_LONG_CONSTANT(SBChSUnicode, BidiControlCount, SB_BidiControlCount, SB_BidiControlCount);
}

void Register_SBChSUnicode_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TPlCharType", NULL);
	TPlCharType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TPlCharType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TPlCharType_ce_ptr, "ctOther", 0)
	SB_DECLARE_CLASS_LONG_CONST(TPlCharType_ce_ptr, "ctLetterUpper", 1)
	SB_DECLARE_CLASS_LONG_CONST(TPlCharType_ce_ptr, "ctLetterLower", 2)
	SB_DECLARE_CLASS_LONG_CONST(TPlCharType_ce_ptr, "ctLetterTitle", 3)
	SB_DECLARE_CLASS_LONG_CONST(TPlCharType_ce_ptr, "ctLetterOther", 4)
	SB_DECLARE_CLASS_LONG_CONST(TPlCharType_ce_ptr, "ctNumber", 5)
	SB_DECLARE_CLASS_LONG_CONST(TPlCharType_ce_ptr, "ctPunctuation", 6)
	SB_DECLARE_CLASS_LONG_CONST(TPlCharType_ce_ptr, "ctSpace", 7)
	SB_DECLARE_CLASS_LONG_CONST(TPlCharType_ce_ptr, "ctControl", 8)
	SB_DECLARE_CLASS_LONG_CONST(TPlCharType_ce_ptr, "ctMark", 9)
}

