#include "sbcryptoprovutils.h"

SB_PHP_FUNCTION(SBCryptoProvUtils, CryptoProvGetBoolParam)
{
	SBArrayZValInfo aiName;
	zend_bool bDefault;
	zval *oParams;
	zval *zaName;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zb", &oParams, TElRelativeDistinguishedName_ce_ptr, &zaName, &bDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaName)) || (IS_ARRAY == Z_TYPE_P(zaName)) || (IS_NULL == Z_TYPE_P(zaName))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaName, &aiName TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBCryptoProvUtils_CryptoProvGetBoolParam(SBGetObjectHandle(oParams TSRMLS_CC), aiName.data, aiName.len, (int8_t)bDefault, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiName);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName, array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, GetIntegerPropFromBuffer)
{
	long l4Default;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaValue, &l4Default) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBCryptoProvUtils_GetIntegerPropFromBuffer(aiValue.data, aiValue.len, (int32_t)l4Default, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, GetInt64PropFromBuffer)
{
	long l4Default;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaValue, &l4Default) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		int64_t l8OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBCryptoProvUtils_GetInt64PropFromBuffer(aiValue.data, aiValue.len, (int32_t)l4Default, &l8OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, GetBufferFromInteger)
{
	long l4Value;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBCryptoProvUtils_GetBufferFromInteger((int32_t)l4Value, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1312942614, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, GetBufferFromInt64)
{
	long l8Value;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBCryptoProvUtils_GetBufferFromInt64((int64_t)l8Value, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1140203866, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, GetBoolFromBuffer)
{
	SBArrayZValInfo aiValue;
	zend_bool bDefault;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zb", &zaValue, &bDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBCryptoProvUtils_GetBoolFromBuffer(aiValue.data, aiValue.len, (int8_t)bDefault, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, GetBufferFromBool)
{
	uint32_t _err;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBCryptoProvUtils_GetBufferFromBool((int8_t)bValue, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(89731480, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, GetPointerFromBuffer)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		void * poOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBCryptoProvUtils_GetPointerFromBuffer(aiValue.data, aiValue.len, &poOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, GetBufferFromPointer)
{
	SBArrayZValInfo piValue;
	uint32_t _err;
	zval *zpValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpValue) == SUCCESS) && ((Z_TYPE_P(zpValue) == IS_STRING) || (Z_TYPE_P(zpValue) == IS_ARRAY) || (Z_TYPE_P(zpValue) == IS_NULL) || ((Z_TYPE_P(zpValue) == IS_OBJECT) && (Z_OBJCE_P(zpValue) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetPointerFromZVal(zpValue, &piValue TSRMLS_CC)) RETURN_FALSE;
		_err = SBCryptoProvUtils_GetBufferFromPointer(piValue.data, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1522195694, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piValue);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, ExtractSymmetricCipherParams)
{
	int32_t l4KeyLenRaw;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo aiIV;
	uint32_t _err;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zaIV;
	zval *zl4KeyLen;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzzz", &zaAlgOID, &zaAlgParams, &zl4KeyLen, &zaIV) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && PZVAL_IS_REF(zl4KeyLen) && (IS_LONG == Z_TYPE_P(zl4KeyLen)) && PZVAL_IS_REF(zaIV) && ((IS_STRING == Z_TYPE_P(zaIV)) || (IS_ARRAY == Z_TYPE_P(zaIV))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		l4KeyLenRaw = (int32_t)Z_LVAL_P(zl4KeyLen);
		if (!SBGetByteArrayFromZVal(zaIV, &aiIV TSRMLS_CC)) RETURN_FALSE;
		_err = SBCryptoProvUtils_ExtractSymmetricCipherParams(aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, &l4KeyLenRaw, aiIV.data, &aiIV.len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaIV, &aiIV TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1731458637, 3, aiIV.data, &aiIV.len) TSRMLS_CC);
			((char *)aiIV.data)[aiIV.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiIV);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		ZVAL_LONG(zl4KeyLen, (long)l4KeyLenRaw);
		SBSetByteArrayToZVal(&aiIV, zaIV);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL, &integer, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, SerializeParams)
{
	uint32_t _err;
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBCryptoProvUtils_SerializeParams(SBGetObjectHandle(oParams TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2116481043, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, UnserializeParams)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBCryptoProvUtils_UnserializeParams(piBuffer.data, (int32_t)l4Size, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, IsKeyDrivenOperation)
{
	long l4OpType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4OpType) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBCryptoProvUtils_IsKeyDrivenOperation((int32_t)l4OpType, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, IsSecretKeyOperation)
{
	long l4OpType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4OpType) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBCryptoProvUtils_IsSecretKeyOperation((int32_t)l4OpType, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBCryptoProvUtils, IsAlgorithmIndependentOperation)
{
	long l4OpType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4OpType) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBCryptoProvUtils_IsAlgorithmIndependentOperation((int32_t)l4OpType, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

