#include "sbdefs.h"
#ifdef SB_WINDOWS
#include "sbcryptoprovwin32.h"

zend_class_entry *TElWin32CryptoProviderOptions_ce_ptr = NULL;

SB_PHP_METHOD(TElWin32CryptoProviderOptions, Assign)
{
	zval *oOptions;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOptions, TElCustomCryptoProviderOptions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOptions TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderOptions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseForPublicKeyOperations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseForPublicKeyOperations(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseForPublicKeyOperations)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseForPublicKeyOperations(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseForSymmetricKeyOperations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseForSymmetricKeyOperations(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseForSymmetricKeyOperations)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseForSymmetricKeyOperations(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseForHashingOperations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseForHashingOperations(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseForHashingOperations)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseForHashingOperations(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseForNonPrivateOperations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseForNonPrivateOperations(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseForNonPrivateOperations)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseForNonPrivateOperations(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_ThreadSafe)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_ThreadSafe(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_ThreadSafe)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_ThreadSafe(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseBaseCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseBaseCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseBaseCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseBaseCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseStrongCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseStrongCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseStrongCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseStrongCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseEnhancedCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseEnhancedCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseEnhancedCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseEnhancedCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseAESCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseAESCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseAESCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseAESCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseDSSCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseDSSCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseDSSCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseDSSCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseBaseDSSDHCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseBaseDSSDHCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseBaseDSSDHCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseBaseDSSDHCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseEnhancedDSSDHCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseEnhancedDSSDHCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseEnhancedDSSDHCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseEnhancedDSSDHCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseRSASchannelCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseRSASchannelCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseRSASchannelCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseRSASchannelCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseRSASignatureCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseRSASignatureCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseRSASignatureCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseRSASignatureCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseECDSASigCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseECDSASigCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseECDSASigCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseECDSASigCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseECNRASigCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseECNRASigCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseECNRASigCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseECNRASigCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseECDSAFullCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseECDSAFullCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseECDSAFullCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseECDSAFullCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseECNRAFullCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseECNRAFullCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseECNRAFullCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseECNRAFullCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseDHSchannelCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseDHSchannelCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseDHSchannelCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseDHSchannelCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseCPGOST)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseCPGOST(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseCPGOST)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseCPGOST(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseCNGProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseCNGProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseCNGProvider)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseCNGProvider(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_FIPSMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_FIPSMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_FIPSMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_FIPSMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_CacheKeyContexts)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_CacheKeyContexts(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_CacheKeyContexts)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_CacheKeyContexts(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_StorePublicKeysInMemoryContainers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_StorePublicKeysInMemoryContainers(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_StorePublicKeysInMemoryContainers)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_StorePublicKeysInMemoryContainers(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_ForceEnhancedCSPForLongKeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_ForceEnhancedCSPForLongKeys(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_ForceEnhancedCSPForLongKeys)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_ForceEnhancedCSPForLongKeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_AutoSelectEnhancedCSP)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_AutoSelectEnhancedCSP(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_AutoSelectEnhancedCSP)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_AutoSelectEnhancedCSP(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_TryAlternativeKeySpecOnFailure)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_TryAlternativeKeySpecOnFailure(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_TryAlternativeKeySpecOnFailure)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_TryAlternativeKeySpecOnFailure(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_GenerateExportablePrivateKeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_GenerateExportablePrivateKeys(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_GenerateExportablePrivateKeys)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_GenerateExportablePrivateKeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, get_UseLocalMachineAccount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProviderOptions_get_UseLocalMachineAccount(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, set_UseLocalMachineAccount)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProviderOptions_set_UseLocalMachineAccount(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProviderOptions, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWin32CryptoProviderOptions_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Options, TElCustomCryptoProviderOptions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseForPublicKeyOperations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseForPublicKeyOperations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseForSymmetricKeyOperations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseForSymmetricKeyOperations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseForHashingOperations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseForHashingOperations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseForNonPrivateOperations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseForNonPrivateOperations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_ThreadSafe, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_ThreadSafe, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseBaseCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseBaseCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseStrongCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseStrongCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseEnhancedCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseEnhancedCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseAESCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseAESCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseDSSCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseDSSCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseBaseDSSDHCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseBaseDSSDHCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseEnhancedDSSDHCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseEnhancedDSSDHCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseRSASchannelCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseRSASchannelCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseRSASignatureCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseRSASignatureCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseECDSASigCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseECDSASigCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseECNRASigCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseECNRASigCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseECDSAFullCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseECDSAFullCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseECNRAFullCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseECNRAFullCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseDHSchannelCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseDHSchannelCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseCPGOST, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseCPGOST, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseCNGProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseCNGProvider, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_FIPSMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_FIPSMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_CacheKeyContexts, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_CacheKeyContexts, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_StorePublicKeysInMemoryContainers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_StorePublicKeysInMemoryContainers, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_ForceEnhancedCSPForLongKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_ForceEnhancedCSPForLongKeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_AutoSelectEnhancedCSP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_AutoSelectEnhancedCSP, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_TryAlternativeKeySpecOnFailure, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_TryAlternativeKeySpecOnFailure, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_GenerateExportablePrivateKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_GenerateExportablePrivateKeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_get_UseLocalMachineAccount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions_set_UseLocalMachineAccount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProviderOptions___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWin32CryptoProviderOptions_methods[] = {
	PHP_ME(TElWin32CryptoProviderOptions, Assign, arginfo_TElWin32CryptoProviderOptions_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseForPublicKeyOperations, arginfo_TElWin32CryptoProviderOptions_get_UseForPublicKeyOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseForPublicKeyOperations, arginfo_TElWin32CryptoProviderOptions_set_UseForPublicKeyOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseForSymmetricKeyOperations, arginfo_TElWin32CryptoProviderOptions_get_UseForSymmetricKeyOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseForSymmetricKeyOperations, arginfo_TElWin32CryptoProviderOptions_set_UseForSymmetricKeyOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseForHashingOperations, arginfo_TElWin32CryptoProviderOptions_get_UseForHashingOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseForHashingOperations, arginfo_TElWin32CryptoProviderOptions_set_UseForHashingOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseForNonPrivateOperations, arginfo_TElWin32CryptoProviderOptions_get_UseForNonPrivateOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseForNonPrivateOperations, arginfo_TElWin32CryptoProviderOptions_set_UseForNonPrivateOperations, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_ThreadSafe, arginfo_TElWin32CryptoProviderOptions_get_ThreadSafe, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_ThreadSafe, arginfo_TElWin32CryptoProviderOptions_set_ThreadSafe, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseBaseCSP, arginfo_TElWin32CryptoProviderOptions_get_UseBaseCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseBaseCSP, arginfo_TElWin32CryptoProviderOptions_set_UseBaseCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseStrongCSP, arginfo_TElWin32CryptoProviderOptions_get_UseStrongCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseStrongCSP, arginfo_TElWin32CryptoProviderOptions_set_UseStrongCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseEnhancedCSP, arginfo_TElWin32CryptoProviderOptions_get_UseEnhancedCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseEnhancedCSP, arginfo_TElWin32CryptoProviderOptions_set_UseEnhancedCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseAESCSP, arginfo_TElWin32CryptoProviderOptions_get_UseAESCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseAESCSP, arginfo_TElWin32CryptoProviderOptions_set_UseAESCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseDSSCSP, arginfo_TElWin32CryptoProviderOptions_get_UseDSSCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseDSSCSP, arginfo_TElWin32CryptoProviderOptions_set_UseDSSCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseBaseDSSDHCSP, arginfo_TElWin32CryptoProviderOptions_get_UseBaseDSSDHCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseBaseDSSDHCSP, arginfo_TElWin32CryptoProviderOptions_set_UseBaseDSSDHCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseEnhancedDSSDHCSP, arginfo_TElWin32CryptoProviderOptions_get_UseEnhancedDSSDHCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseEnhancedDSSDHCSP, arginfo_TElWin32CryptoProviderOptions_set_UseEnhancedDSSDHCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseRSASchannelCSP, arginfo_TElWin32CryptoProviderOptions_get_UseRSASchannelCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseRSASchannelCSP, arginfo_TElWin32CryptoProviderOptions_set_UseRSASchannelCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseRSASignatureCSP, arginfo_TElWin32CryptoProviderOptions_get_UseRSASignatureCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseRSASignatureCSP, arginfo_TElWin32CryptoProviderOptions_set_UseRSASignatureCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseECDSASigCSP, arginfo_TElWin32CryptoProviderOptions_get_UseECDSASigCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseECDSASigCSP, arginfo_TElWin32CryptoProviderOptions_set_UseECDSASigCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseECNRASigCSP, arginfo_TElWin32CryptoProviderOptions_get_UseECNRASigCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseECNRASigCSP, arginfo_TElWin32CryptoProviderOptions_set_UseECNRASigCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseECDSAFullCSP, arginfo_TElWin32CryptoProviderOptions_get_UseECDSAFullCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseECDSAFullCSP, arginfo_TElWin32CryptoProviderOptions_set_UseECDSAFullCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseECNRAFullCSP, arginfo_TElWin32CryptoProviderOptions_get_UseECNRAFullCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseECNRAFullCSP, arginfo_TElWin32CryptoProviderOptions_set_UseECNRAFullCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseDHSchannelCSP, arginfo_TElWin32CryptoProviderOptions_get_UseDHSchannelCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseDHSchannelCSP, arginfo_TElWin32CryptoProviderOptions_set_UseDHSchannelCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseCPGOST, arginfo_TElWin32CryptoProviderOptions_get_UseCPGOST, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseCPGOST, arginfo_TElWin32CryptoProviderOptions_set_UseCPGOST, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseCNGProvider, arginfo_TElWin32CryptoProviderOptions_get_UseCNGProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseCNGProvider, arginfo_TElWin32CryptoProviderOptions_set_UseCNGProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_FIPSMode, arginfo_TElWin32CryptoProviderOptions_get_FIPSMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_FIPSMode, arginfo_TElWin32CryptoProviderOptions_set_FIPSMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_CacheKeyContexts, arginfo_TElWin32CryptoProviderOptions_get_CacheKeyContexts, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_CacheKeyContexts, arginfo_TElWin32CryptoProviderOptions_set_CacheKeyContexts, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_StorePublicKeysInMemoryContainers, arginfo_TElWin32CryptoProviderOptions_get_StorePublicKeysInMemoryContainers, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_StorePublicKeysInMemoryContainers, arginfo_TElWin32CryptoProviderOptions_set_StorePublicKeysInMemoryContainers, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_ForceEnhancedCSPForLongKeys, arginfo_TElWin32CryptoProviderOptions_get_ForceEnhancedCSPForLongKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_ForceEnhancedCSPForLongKeys, arginfo_TElWin32CryptoProviderOptions_set_ForceEnhancedCSPForLongKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_AutoSelectEnhancedCSP, arginfo_TElWin32CryptoProviderOptions_get_AutoSelectEnhancedCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_AutoSelectEnhancedCSP, arginfo_TElWin32CryptoProviderOptions_set_AutoSelectEnhancedCSP, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_TryAlternativeKeySpecOnFailure, arginfo_TElWin32CryptoProviderOptions_get_TryAlternativeKeySpecOnFailure, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_TryAlternativeKeySpecOnFailure, arginfo_TElWin32CryptoProviderOptions_set_TryAlternativeKeySpecOnFailure, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_GenerateExportablePrivateKeys, arginfo_TElWin32CryptoProviderOptions_get_GenerateExportablePrivateKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_GenerateExportablePrivateKeys, arginfo_TElWin32CryptoProviderOptions_set_GenerateExportablePrivateKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, get_UseLocalMachineAccount, arginfo_TElWin32CryptoProviderOptions_get_UseLocalMachineAccount, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, set_UseLocalMachineAccount, arginfo_TElWin32CryptoProviderOptions_set_UseLocalMachineAccount, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProviderOptions, __construct, arginfo_TElWin32CryptoProviderOptions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWin32CryptoProviderOptions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWin32CryptoProviderOptions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWin32CryptoProviderOptions", TElWin32CryptoProviderOptions_methods);
	if (NULL == TElCustomCryptoProviderOptions_ce_ptr)
		Register_TElCustomCryptoProviderOptions(TSRMLS_C);
	TElWin32CryptoProviderOptions_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomCryptoProviderOptions_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWin32CryptoProvider_ce_ptr = NULL;

SB_PHP_METHOD(TElWin32CryptoProvider, Init)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProvider_Init(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, Deinit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProvider_Deinit(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, SetAsDefault_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProvider_SetAsDefault_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, SetAsDefault)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProvider_SetAsDefault() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, IsAlgorithmSupported)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Algorithm, &l4Mode) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProvider_IsAlgorithmSupported(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zaAlgOID, &zaAlgParams, &l4Mode) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_IsAlgorithmSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (array of byte|string|NULL, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, IsOperationSupported)
{
	long l4Algorithm;
	long l4Mode;
	long l4Operation;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lllO!O!", &l4Operation, &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProvider_IsOperationSupported(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Operation, (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzzlO!O!", &l4Operation, &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_IsOperationSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Operation, aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName) or (integer, array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, GetAlgorithmProperty)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llz", &l4Algorithm, &l4Mode, &zaPropID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		_err = TElWin32CryptoProvider_GetAlgorithmProperty(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, aiPropID.data, aiPropID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1786601234, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlz", &zaAlgOID, &zaAlgParams, &l4Mode, &zaPropID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		_err = TElWin32CryptoProvider_GetAlgorithmProperty_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, aiPropID.data, aiPropID.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1265803293, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreeArrayZValInfo(&aiPropID);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, GetAlgorithmClass)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWin32CryptoProvider_GetAlgorithmClass(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaAlgOID, &zaAlgParams) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_GetAlgorithmClass_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, GetDefaultInstance)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWin32CryptoProvider_GetDefaultInstance(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, CreateKey)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!", &l4Algorithm, &l4Mode, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWin32CryptoProvider_CreateKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!", &zaAlgOID, &zaAlgParams, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_CreateKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElRelativeDistinguishedName) or (array of byte|string|NULL, array of byte|string|NULL, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, CloneKey)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWin32CryptoProvider_CloneKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, ReleaseKey)
{
	TElClassHandle hoKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKey) && (IS_OBJECT == Z_TYPE_P(oKey)))
	{
		hoKey = SBGetObjectHandle(oKey TSRMLS_CC);
		SBCheckError(TElWin32CryptoProvider_ReleaseKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKey) TSRMLS_CC);
		SBUpdateObjectHandle(oKey, hoKey TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, DeleteKey)
{
	TElClassHandle hoKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKey) && (IS_OBJECT == Z_TYPE_P(oKey)))
	{
		hoKey = SBGetObjectHandle(oKey TSRMLS_CC);
		SBCheckError(TElWin32CryptoProvider_DeleteKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKey) TSRMLS_CC);
		SBUpdateObjectHandle(oKey, hoKey TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, DecryptKey)
{
	long l4EncKeySize;
	SBArrayZValInfo aiEncKeyAlgOID;
	SBArrayZValInfo aiEncKeyAlgParams;
	SBArrayZValInfo aiKeyAlgOID;
	SBArrayZValInfo aiKeyAlgParams;
	SBArrayZValInfo piEncKey;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaEncKeyAlgOID;
	zval *zaEncKeyAlgParams;
	zval *zaKeyAlgOID;
	zval *zaKeyAlgParams;
	zval *zpEncKey;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzO!zzO!zz", &zpEncKey, &l4EncKeySize, &zaEncKeyAlgOID, &zaEncKeyAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &zaKeyAlgOID, &zaKeyAlgParams, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpEncKey) == IS_STRING) || (Z_TYPE_P(zpEncKey) == IS_ARRAY) || (Z_TYPE_P(zpEncKey) == IS_NULL) || ((Z_TYPE_P(zpEncKey) == IS_OBJECT) && (Z_OBJCE_P(zpEncKey) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zaEncKeyAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaEncKeyAlgOID)) || (IS_NULL == Z_TYPE_P(zaEncKeyAlgOID))) && ((IS_STRING == Z_TYPE_P(zaEncKeyAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaEncKeyAlgParams)) || (IS_NULL == Z_TYPE_P(zaEncKeyAlgParams))) && ((IS_STRING == Z_TYPE_P(zaKeyAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaKeyAlgOID)) || (IS_NULL == Z_TYPE_P(zaKeyAlgOID))) && ((IS_STRING == Z_TYPE_P(zaKeyAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaKeyAlgParams)) || (IS_NULL == Z_TYPE_P(zaKeyAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpEncKey, &piEncKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaEncKeyAlgOID, &aiEncKeyAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaEncKeyAlgParams, &aiEncKeyAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyAlgOID, &aiKeyAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaKeyAlgParams, &aiKeyAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_DecryptKey(SBGetObjectHandle(getThis() TSRMLS_CC), piEncKey.data, (int32_t)l4EncKeySize, aiEncKeyAlgOID.data, aiEncKeyAlgOID.len, aiEncKeyAlgParams.data, aiEncKeyAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), aiKeyAlgOID.data, aiKeyAlgOID.len, aiKeyAlgParams.data, aiKeyAlgParams.len, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piEncKey);
		SBFreeArrayZValInfo(&aiEncKeyAlgOID);
		SBFreeArrayZValInfo(&aiEncKeyAlgParams);
		SBFreeArrayZValInfo(&aiKeyAlgOID);
		SBFreeArrayZValInfo(&aiKeyAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, array of byte|string|NULL, array of byte|string|NULL, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, EncryptInit)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!zz", &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_EncryptInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlO!O!zz", &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_EncryptInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, DecryptInit)
{
	long l4Algorithm;
	long l4Mode;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llO!O!zz", &l4Algorithm, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_DecryptInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzlO!O!zz", &zaAlgOID, &zaAlgParams, &l4Mode, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_DecryptInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, (int32_t)l4Mode, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, SignInit)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zend_bool bDetached;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!bO!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &bDetached, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_SignInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bDetached, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!bO!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &bDetached, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_SignInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bDetached, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, bool, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, bool, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, VerifyInit)
{
	long l4Algorithm;
	long l4SigSize;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	SBArrayZValInfo piSigBuffer;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	zval *zpSigBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!zlO!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &zpSigBuffer, &l4SigSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpSigBuffer) == IS_STRING) || (Z_TYPE_P(zpSigBuffer) == IS_ARRAY) || (Z_TYPE_P(zpSigBuffer) == IS_NULL) || ((Z_TYPE_P(zpSigBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpSigBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpSigBuffer, &piSigBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_VerifyInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), piSigBuffer.data, (int32_t)l4SigSize, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piSigBuffer);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!zlO!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &zpSigBuffer, &l4SigSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((Z_TYPE_P(zpSigBuffer) == IS_STRING) || (Z_TYPE_P(zpSigBuffer) == IS_ARRAY) || (Z_TYPE_P(zpSigBuffer) == IS_NULL) || ((Z_TYPE_P(zpSigBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpSigBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSigBuffer, &piSigBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_VerifyInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), piSigBuffer.data, (int32_t)l4SigSize, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piSigBuffer);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, EncryptUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_EncryptUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, DecryptUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_DecryptUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, SignUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_SignUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, VerifyUpdate)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlzzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_VerifyUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, EncryptFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_EncryptFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, DecryptFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_DecryptFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, SignFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_SignFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, VerifyFinal)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zl4Size;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &zl4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_VerifyFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, &l4SizeRaw, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		SBFreePointerZValInfo(&piProgressData);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, &integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, HashInit)
{
	long l4Algorithm;
	SBArrayZValInfo aiAlgOID;
	SBArrayZValInfo aiAlgParams;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oKey;
	zval *oParams;
	zval *zaAlgOID;
	zval *zaAlgParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!zz", &l4Algorithm, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_HashInit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO!O!zz", &zaAlgOID, &zaAlgParams, &oKey, TElCustomCryptoKey_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAlgOID)) || (IS_ARRAY == Z_TYPE_P(zaAlgOID)) || (IS_NULL == Z_TYPE_P(zaAlgOID))) && ((IS_STRING == Z_TYPE_P(zaAlgParams)) || (IS_ARRAY == Z_TYPE_P(zaAlgParams)) || (IS_NULL == Z_TYPE_P(zaAlgParams))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAlgOID, &aiAlgOID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAlgParams, &aiAlgParams TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_HashInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiAlgOID.data, aiAlgOID.len, aiAlgParams.data, aiAlgParams.len, SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAlgOID);
		SBFreeArrayZValInfo(&aiAlgParams);
		SBFreePointerZValInfo(&piProgressData);
		SBInitObject(return_value, TElCustomCryptoContext_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, TElCustomCryptoKey, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, HashUpdate)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piProgressData;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zpBuffer;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlO!zz", &oContext, TElCustomCryptoContext_ce_ptr, &zpBuffer, &l4Size, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_HashUpdate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), piBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piProgressData);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, HashFinal)
{
	SBArrayZValInfo piProgressData;
	uint32_t _err;
	void *pzProgressFunc;
	zval *oContext;
	zval *oParams;
	zval *zpProgressData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zz", &oContext, TElCustomCryptoContext_ce_ptr, &oParams, TElRelativeDistinguishedName_ce_ptr, &zProgressFunc, &zpProgressData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpProgressData) == IS_STRING) || (Z_TYPE_P(zpProgressData) == IS_ARRAY) || (Z_TYPE_P(zpProgressData) == IS_NULL) || ((Z_TYPE_P(zpProgressData) == IS_OBJECT) && (Z_OBJCE_P(zpProgressData) == TSBPointer_ce_ptr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpProgressData, &piProgressData TSRMLS_CC)) RETURN_FALSE;
		_err = TElWin32CryptoProvider_HashFinal(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContext TSRMLS_CC), SBGetObjectHandle(oParams TSRMLS_CC), pzProgressFunc ? &TSBProgressFuncRaw : NULL, pzProgressFunc, piProgressData.data, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-615541526, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piProgressData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoContext, TElRelativeDistinguishedName, TSBProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, ReleaseCryptoContext)
{
	TElClassHandle hoContext;
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TElCustomCryptoContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext) && (IS_OBJECT == Z_TYPE_P(oContext)))
	{
		hoContext = SBGetObjectHandle(oContext TSRMLS_CC);
		SBCheckError(TElWin32CryptoProvider_ReleaseCryptoContext(SBGetObjectHandle(getThis() TSRMLS_CC), &hoContext) TSRMLS_CC);
		SBUpdateObjectHandle(oContext, hoContext TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoContext)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, CreateKeyStorage)
{
	zend_bool bPersistent;
	zval *oParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!", &bPersistent, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWin32CryptoProvider_CreateKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bPersistent, SBGetObjectHandle(oParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKeyStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, ReleaseKeyStorage)
{
	TElClassHandle hoKeyStorage;
	zval *oKeyStorage;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKeyStorage, TElCustomCryptoKeyStorage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKeyStorage) && (IS_OBJECT == Z_TYPE_P(oKeyStorage)))
	{
		hoKeyStorage = SBGetObjectHandle(oKeyStorage TSRMLS_CC);
		SBCheckError(TElWin32CryptoProvider_ReleaseKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKeyStorage) TSRMLS_CC);
		SBUpdateObjectHandle(oKeyStorage, hoKeyStorage TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, DeleteKeyStorage)
{
	TElClassHandle hoKeyStorage;
	zval *oKeyStorage;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oKeyStorage, TElCustomCryptoKeyStorage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oKeyStorage) && (IS_OBJECT == Z_TYPE_P(oKeyStorage)))
	{
		hoKeyStorage = SBGetObjectHandle(oKeyStorage TSRMLS_CC);
		SBCheckError(TElWin32CryptoProvider_DeleteKeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoKeyStorage) TSRMLS_CC);
		SBUpdateObjectHandle(oKeyStorage, hoKeyStorage TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElCustomCryptoKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, RandomInit)
{
	long l4BaseDataSize;
	SBArrayZValInfo piBaseData;
	zval *oParams;
	zval *zpBaseData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO!", &zpBaseData, &l4BaseDataSize, &oParams, TElRelativeDistinguishedName_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBaseData) == IS_STRING) || (Z_TYPE_P(zpBaseData) == IS_ARRAY) || (Z_TYPE_P(zpBaseData) == IS_NULL) || ((Z_TYPE_P(zpBaseData) == IS_OBJECT) && (Z_OBJCE_P(zpBaseData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBaseData, &piBaseData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_RandomInit(SBGetObjectHandle(getThis() TSRMLS_CC), piBaseData.data, (int32_t)l4BaseDataSize, SBGetObjectHandle(oParams TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piBaseData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, RandomSeed)
{
	long l4DataSize;
	SBArrayZValInfo piData;
	zval *zpData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpData, &l4DataSize) == SUCCESS) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_RandomSeed(SBGetObjectHandle(getThis() TSRMLS_CC), piData.data, (int32_t)l4DataSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, RandomGenerate)
{
	long l4MaxValue;
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_RandomGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4MaxValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWin32CryptoProvider_RandomGenerate_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4MaxValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, GetProviderProp)
{
	SBArrayZValInfo aiDefault;
	SBArrayZValInfo aiPropID;
	uint32_t _err;
	zval *zaDefault;
	zval *zaPropID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaDefault) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaDefault)) || (IS_ARRAY == Z_TYPE_P(zaDefault)) || (IS_NULL == Z_TYPE_P(zaDefault))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDefault, &aiDefault TSRMLS_CC)) RETURN_FALSE;
		_err = TElWin32CryptoProvider_GetProviderProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiDefault.data, aiDefault.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1365357043, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiDefault);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, SetProviderProp)
{
	SBArrayZValInfo aiPropID;
	SBArrayZValInfo aiValue;
	zval *zaPropID;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaPropID, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPropID)) || (IS_ARRAY == Z_TYPE_P(zaPropID)) || (IS_NULL == Z_TYPE_P(zaPropID))) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaPropID, &aiPropID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElWin32CryptoProvider_SetProviderProp(SBGetObjectHandle(getThis() TSRMLS_CC), aiPropID.data, aiPropID.len, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPropID);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWin32CryptoProvider_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, get_TryEnhancedCryptoProvider)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProvider_get_TryEnhancedCryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, set_TryEnhancedCryptoProvider)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProvider_set_TryEnhancedCryptoProvider(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, get_NativeSizeCalculation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWin32CryptoProvider_get_NativeSizeCalculation(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, set_NativeSizeCalculation)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWin32CryptoProvider_set_NativeSizeCalculation(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWin32CryptoProvider, __construct)
{
	zval *oAOwner;
	zval *oOptions;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWin32CryptoProvider_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oOptions, TElCustomCryptoProviderOptions_ce_ptr, &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWin32CryptoProvider_Create_1(SBGetObjectHandle(oOptions TSRMLS_CC), SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent) or (TElCustomCryptoProviderOptions, TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_Init, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_Deinit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_SetAsDefault_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_SetAsDefault, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_IsAlgorithmSupported, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_INFO(0, Mode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_IsOperationSupported, 0, 0, 5)
	ZEND_ARG_INFO(0, Operation)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_GetAlgorithmProperty, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, PropID_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_GetAlgorithmClass, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AlgParams, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_GetDefaultInstance, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_CreateKey, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_CloneKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_ReleaseKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Key, TElCustomCryptoKey, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_DeleteKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Key, TElCustomCryptoKey, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_DecryptKey, 0, 0, 10)
	ZEND_ARG_TYPE_INFO(0, EncKey, 0, 1)
	ZEND_ARG_INFO(0, EncKeySize)
	ZEND_ARG_TYPE_INFO(0, EncKeyAlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, EncKeyAlgParams, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
	ZEND_ARG_TYPE_INFO(0, KeyAlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, KeyAlgParams, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_EncryptInit, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_DecryptInit, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Mode_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_SignInit, 0, 0, 6)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Detached_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Detached, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_VerifyInit, 0, 0, 7)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SigBuffer_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SigSize_or_SigBuffer, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_SigSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_EncryptUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_DecryptUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_SignUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_VerifyUpdate, 0, 0, 8)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, InBuffer, 0, 1)
	ZEND_ARG_INFO(0, InSize)
	ZEND_ARG_TYPE_INFO(0, OutBuffer, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_EncryptFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_DecryptFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_SignFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_VerifyFinal, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_HashInit, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Algorithm_or_AlgOID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_AlgParams, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Params_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc_or_Params, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData_or_ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_HashUpdate, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_HashFinal, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Context, TElCustomCryptoContext, 1)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressFunc, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ProgressData, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_ReleaseCryptoContext, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Context, TElCustomCryptoContext, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_CreateKeyStorage, 0, 0, 2)
	ZEND_ARG_INFO(0, Persistent)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_ReleaseKeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, KeyStorage, TElCustomCryptoKeyStorage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_DeleteKeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, KeyStorage, TElCustomCryptoKeyStorage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_RandomInit, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, BaseData, 0, 1)
	ZEND_ARG_INFO(0, BaseDataSize)
	ZEND_ARG_OBJ_INFO(0, Params, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_RandomSeed, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
	ZEND_ARG_INFO(0, DataSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_RandomGenerate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_MaxValue, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_GetProviderProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Default, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_SetProviderProp, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PropID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_get_TryEnhancedCryptoProvider, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_set_TryEnhancedCryptoProvider, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_get_NativeSizeCalculation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider_set_NativeSizeCalculation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWin32CryptoProvider___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AOwner_or_Options, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWin32CryptoProvider_methods[] = {
	PHP_ME(TElWin32CryptoProvider, Init, arginfo_TElWin32CryptoProvider_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, Deinit, arginfo_TElWin32CryptoProvider_Deinit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, SetAsDefault_Inst, arginfo_TElWin32CryptoProvider_SetAsDefault_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, SetAsDefault, arginfo_TElWin32CryptoProvider_SetAsDefault, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElWin32CryptoProvider, IsAlgorithmSupported, arginfo_TElWin32CryptoProvider_IsAlgorithmSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, IsOperationSupported, arginfo_TElWin32CryptoProvider_IsOperationSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, GetAlgorithmProperty, arginfo_TElWin32CryptoProvider_GetAlgorithmProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, GetAlgorithmClass, arginfo_TElWin32CryptoProvider_GetAlgorithmClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, GetDefaultInstance, arginfo_TElWin32CryptoProvider_GetDefaultInstance, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, CreateKey, arginfo_TElWin32CryptoProvider_CreateKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, CloneKey, arginfo_TElWin32CryptoProvider_CloneKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, ReleaseKey, arginfo_TElWin32CryptoProvider_ReleaseKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, DeleteKey, arginfo_TElWin32CryptoProvider_DeleteKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, DecryptKey, arginfo_TElWin32CryptoProvider_DecryptKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, EncryptInit, arginfo_TElWin32CryptoProvider_EncryptInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, DecryptInit, arginfo_TElWin32CryptoProvider_DecryptInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, SignInit, arginfo_TElWin32CryptoProvider_SignInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, VerifyInit, arginfo_TElWin32CryptoProvider_VerifyInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, EncryptUpdate, arginfo_TElWin32CryptoProvider_EncryptUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, DecryptUpdate, arginfo_TElWin32CryptoProvider_DecryptUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, SignUpdate, arginfo_TElWin32CryptoProvider_SignUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, VerifyUpdate, arginfo_TElWin32CryptoProvider_VerifyUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, EncryptFinal, arginfo_TElWin32CryptoProvider_EncryptFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, DecryptFinal, arginfo_TElWin32CryptoProvider_DecryptFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, SignFinal, arginfo_TElWin32CryptoProvider_SignFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, VerifyFinal, arginfo_TElWin32CryptoProvider_VerifyFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, HashInit, arginfo_TElWin32CryptoProvider_HashInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, HashUpdate, arginfo_TElWin32CryptoProvider_HashUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, HashFinal, arginfo_TElWin32CryptoProvider_HashFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, ReleaseCryptoContext, arginfo_TElWin32CryptoProvider_ReleaseCryptoContext, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, CreateKeyStorage, arginfo_TElWin32CryptoProvider_CreateKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, ReleaseKeyStorage, arginfo_TElWin32CryptoProvider_ReleaseKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, DeleteKeyStorage, arginfo_TElWin32CryptoProvider_DeleteKeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, RandomInit, arginfo_TElWin32CryptoProvider_RandomInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, RandomSeed, arginfo_TElWin32CryptoProvider_RandomSeed, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, RandomGenerate, arginfo_TElWin32CryptoProvider_RandomGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, GetProviderProp, arginfo_TElWin32CryptoProvider_GetProviderProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, SetProviderProp, arginfo_TElWin32CryptoProvider_SetProviderProp, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, ClassType, arginfo_TElWin32CryptoProvider_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElWin32CryptoProvider, get_TryEnhancedCryptoProvider, arginfo_TElWin32CryptoProvider_get_TryEnhancedCryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, set_TryEnhancedCryptoProvider, arginfo_TElWin32CryptoProvider_set_TryEnhancedCryptoProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, get_NativeSizeCalculation, arginfo_TElWin32CryptoProvider_get_NativeSizeCalculation, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, set_NativeSizeCalculation, arginfo_TElWin32CryptoProvider_set_NativeSizeCalculation, ZEND_ACC_PUBLIC)
	PHP_ME(TElWin32CryptoProvider, __construct, arginfo_TElWin32CryptoProvider___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWin32CryptoProvider(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWin32CryptoProvider_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWin32CryptoProvider", TElWin32CryptoProvider_methods);
	if (NULL == TElExternalCryptoProvider_ce_ptr)
		Register_TElExternalCryptoProvider(TSRMLS_C);
	TElWin32CryptoProvider_ce_ptr = zend_register_internal_class_ex(&ce, TElExternalCryptoProvider_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCNGCryptoProviderHandleInfo_ce_ptr = NULL;

void Register_TElCNGCryptoProviderHandleInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCNGCryptoProviderHandleInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCNGCryptoProviderHandleInfo", NULL);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCNGCryptoProviderHandleInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCNGCryptoProviderHandleManager_ce_ptr = NULL;

SB_PHP_METHOD(TElCNGCryptoProviderHandleManager, FreeCNGStorageProvider)
{
#ifndef CPU64
	long u4hProvider;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4hProvider) == SUCCESS)
#else
	long l8hProvider;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8hProvider) == SUCCESS)
#endif
	{
#ifndef CPU64
		SBCheckError(TElCNGCryptoProviderHandleManager_FreeCNGStorageProvider(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4hProvider) TSRMLS_CC);
#else
		SBCheckError(TElCNGCryptoProviderHandleManager_FreeCNGStorageProvider(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8hProvider) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCNGCryptoProviderHandleManager, CNGStorageProviderAddRef)
{
#ifndef CPU64
	long u4hProvider;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4hProvider) == SUCCESS)
#else
	long l8hProvider;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8hProvider) == SUCCESS)
#endif
	{
#ifndef CPU64
		SBCheckError(TElCNGCryptoProviderHandleManager_CNGStorageProviderAddRef(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4hProvider) TSRMLS_CC);
#else
		SBCheckError(TElCNGCryptoProviderHandleManager_CNGStorageProviderAddRef(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8hProvider) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCNGCryptoProviderHandleManager, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCNGCryptoProviderHandleManager_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCNGCryptoProviderHandleManager_FreeCNGStorageProvider, 0, 0, 1)
	ZEND_ARG_INFO(0, hProvider)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCNGCryptoProviderHandleManager_CNGStorageProviderAddRef, 0, 0, 1)
	ZEND_ARG_INFO(0, hProvider)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCNGCryptoProviderHandleManager___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCNGCryptoProviderHandleManager_methods[] = {
	PHP_ME(TElCNGCryptoProviderHandleManager, FreeCNGStorageProvider, arginfo_TElCNGCryptoProviderHandleManager_FreeCNGStorageProvider, ZEND_ACC_PUBLIC)
	PHP_ME(TElCNGCryptoProviderHandleManager, CNGStorageProviderAddRef, arginfo_TElCNGCryptoProviderHandleManager_CNGStorageProviderAddRef, ZEND_ACC_PUBLIC)
	PHP_ME(TElCNGCryptoProviderHandleManager, __construct, arginfo_TElCNGCryptoProviderHandleManager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCNGCryptoProviderHandleManager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCNGCryptoProviderHandleManager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCNGCryptoProviderHandleManager", TElCNGCryptoProviderHandleManager_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCNGCryptoProviderHandleManager_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBCryptoProvWin32, Win32CryptoProvider)
{
	zval *oOptionsTemplate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBCryptoProvWin32_Win32CryptoProvider(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOptionsTemplate, TElWin32CryptoProviderOptions_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBCryptoProvWin32_Win32CryptoProvider_1(SBGetObjectHandle(oOptionsTemplate TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProvider_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElWin32CryptoProviderOptions)" TSRMLS_CC);
	}
}
#endif
