#include "sbcustomcrypto.h"

zend_class_entry *TElKeyMaterial_ce_ptr = NULL;

SB_PHP_METHOD(TElKeyMaterial, Generate)
{
	long l4Bits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Bits) == SUCCESS)
	{
		SBCheckError(TElKeyMaterial_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, Save)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElKeyMaterial_Save(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, Load)
{
	long l4Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElKeyMaterial_Load(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElKeyMaterial_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, Equals)
{
	zend_bool bPublicOnly;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oSource, TElKeyMaterial_ce_ptr, &bPublicOnly) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElKeyMaterial_Equals(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bPublicOnly, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElKeyMaterial_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, AssignCryptoKey)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElCustomCryptoKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElKeyMaterial_AssignCryptoKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, Persistentiate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElKeyMaterial_Persistentiate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, get_Exportable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElKeyMaterial_get_Exportable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, get_Valid)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElKeyMaterial_get_Valid(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, get_Bits)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElKeyMaterial_get_Bits(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, get_Key)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElKeyMaterial_get_Key(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElKeyMaterial_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, get_KeyID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElKeyMaterial_get_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1359329758, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, set_KeyID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElKeyMaterial_set_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, get_KeySubject)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElKeyMaterial_get_KeySubject(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(529649310, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, set_KeySubject)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElKeyMaterial_set_KeySubject(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElKeyMaterial, get_ProviderName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElKeyMaterial_get_ProviderName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1172539159, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterial, set_ProviderName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElKeyMaterial_set_ProviderName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElKeyMaterial, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElKeyMaterial_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_Generate, 0, 0, 1)
	ZEND_ARG_INFO(0, Bits)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_Save, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Stream, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_Load, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Stream, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_Equals, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Source, TElKeyMaterial, 1)
	ZEND_ARG_INFO(0, PublicOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_AssignCryptoKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElCustomCryptoKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_Persistentiate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_get_Exportable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_get_Valid, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_get_Bits, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_get_Key, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_get_KeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_set_KeyID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_get_KeySubject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_set_KeySubject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_get_ProviderName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial_set_ProviderName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterial___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElKeyMaterial_methods[] = {
	PHP_ME(TElKeyMaterial, Generate, arginfo_TElKeyMaterial_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, Save, arginfo_TElKeyMaterial_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, Load, arginfo_TElKeyMaterial_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, Assign, arginfo_TElKeyMaterial_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, Equals, arginfo_TElKeyMaterial_Equals, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, Clone, arginfo_TElKeyMaterial_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, AssignCryptoKey, arginfo_TElKeyMaterial_AssignCryptoKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, Persistentiate, arginfo_TElKeyMaterial_Persistentiate, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, get_Exportable, arginfo_TElKeyMaterial_get_Exportable, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, get_Valid, arginfo_TElKeyMaterial_get_Valid, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, get_Bits, arginfo_TElKeyMaterial_get_Bits, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, get_Key, arginfo_TElKeyMaterial_get_Key, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, get_Algorithm, arginfo_TElKeyMaterial_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, get_KeyID, arginfo_TElKeyMaterial_get_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, set_KeyID, arginfo_TElKeyMaterial_set_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, get_KeySubject, arginfo_TElKeyMaterial_get_KeySubject, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, set_KeySubject, arginfo_TElKeyMaterial_set_KeySubject, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElKeyMaterial, get_ProviderName, arginfo_TElKeyMaterial_get_ProviderName, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterial, set_ProviderName, arginfo_TElKeyMaterial_set_ProviderName, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElKeyMaterial, __construct, arginfo_TElKeyMaterial___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElKeyMaterial(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElKeyMaterial_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElKeyMaterial", TElKeyMaterial_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElKeyMaterial_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomCrypto_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomCrypto, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomCrypto_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomCrypto___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomCrypto_methods[] = {
	PHP_ME(TElCustomCrypto, __construct, arginfo_TElCustomCrypto___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomCrypto(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomCrypto_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomCrypto", TElCustomCrypto_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomCrypto_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElKeyMaterialStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElKeyMaterialStorage, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElKeyMaterialStorage_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterialStorage, ImportFrom)
{
	zval *oKeyStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeyStorage, TElKeyMaterialStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElKeyMaterialStorage_ImportFrom(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyStorage TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterialStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterialStorage, Add)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElKeyMaterialStorage_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterialStorage, Remove)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElKeyMaterialStorage_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterialStorage, get_KeyList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElKeyMaterialStorage_get_KeyList(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TSBObjectList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterialStorage, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElKeyMaterialStorage_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterialStorage, get_Keys)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElKeyMaterialStorage_get_Keys(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElKeyMaterialStorage, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElKeyMaterialStorage_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterialStorage_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterialStorage_ImportFrom, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, KeyStorage, TElKeyMaterialStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterialStorage_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterialStorage_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterialStorage_get_KeyList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterialStorage_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterialStorage_get_Keys, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElKeyMaterialStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElKeyMaterialStorage_methods[] = {
	PHP_ME(TElKeyMaterialStorage, Clear, arginfo_TElKeyMaterialStorage_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterialStorage, ImportFrom, arginfo_TElKeyMaterialStorage_ImportFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterialStorage, Add, arginfo_TElKeyMaterialStorage_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterialStorage, Remove, arginfo_TElKeyMaterialStorage_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterialStorage, get_KeyList, arginfo_TElKeyMaterialStorage_get_KeyList, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterialStorage, get_Count, arginfo_TElKeyMaterialStorage_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterialStorage, get_Keys, arginfo_TElKeyMaterialStorage_get_Keys, ZEND_ACC_PUBLIC)
	PHP_ME(TElKeyMaterialStorage, __construct, arginfo_TElKeyMaterialStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElKeyMaterialStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElKeyMaterialStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElKeyMaterialStorage", TElKeyMaterialStorage_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElKeyMaterialStorage_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBCustomCrypto_Aliases(TSRMLS_D)
{
	if (NULL == TElKeyMaterial_ce_ptr)
		Register_TElKeyMaterial(TSRMLS_C);
	zend_register_class_alias("ElKeyMaterial", TElKeyMaterial_ce_ptr);
	if (NULL == TElCustomCrypto_ce_ptr)
		Register_TElCustomCrypto(TSRMLS_C);
	zend_register_class_alias("ElCustomCrypto", TElCustomCrypto_ce_ptr);
	if (NULL == TElKeyMaterialStorage_ce_ptr)
		Register_TElKeyMaterialStorage(TSRMLS_C);
	zend_register_class_alias("ElKeyMaterialStorage", TElKeyMaterialStorage_ce_ptr);
}
