#include "sbdatastorageutils.h"

void SB_CALLBACK TSBProxyStreamBeforeWriteEventRaw(void * _ObjectData, TObjectHandle Sender, void * Buffer, int32_t Size, int8_t * Skip)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zBuffer;
	zval * zSize;
	zval * zSkip;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);
	MAKE_STD_ZVAL(zSkip);
	ZVAL_BOOL(zSkip, (zend_bool)*Skip);

	params[0] = &zSender;
	params[1] = &zBuffer;
	params[2] = &zSize;
	params[3] = &zSkip;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zSize);
	*Skip = (int8_t)Z_BVAL_P(zSkip);
	zval_ptr_dtor(&zSkip);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBProxyStreamReadWriteEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t Count)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zCount;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCount);
	ZVAL_LONG(zCount, (long)Count);

	params[0] = &zSender;
	params[1] = &zCount;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCount);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBProtectedObjectMetadataLocation_ce_ptr = NULL;

void SB_CALLBACK TSBProtectedObjectWriteEventRaw(void * _ObjectData, TObjectHandle Sender, void * Buffer, int32_t Size)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zBuffer;
	zval * zSize;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);

	params[0] = &zSender;
	params[1] = &zBuffer;
	params[2] = &zSize;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zSize);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBProtectedObjectMetadataNeededEventRaw(void * _ObjectData, TObjectHandle Sender, uint8_t pMetadata[], int32_t * szMetadata)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zMetadata;
	SBArrayZValInfo aiMetadata;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zMetadata);
	ZVAL_STRINGL(zMetadata, pMetadata, *szMetadata, 1);

	params[0] = &zSender;
	params[1] = &zMetadata;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	if (SBGetByteArrayFromZVal(zMetadata, &aiMetadata TSRMLS_CC))
		SBCheckError(SBSetEventReturnBuffer(2, aiMetadata.data, aiMetadata.len) TSRMLS_CC);
	SBFreeArrayZValInfo(&aiMetadata);
	zval_ptr_dtor(&zMetadata);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBProtectedObjectReadStrategy_ce_ptr = NULL;

void SB_CALLBACK TSBProtectedObjectBlockReadEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t Offset, void * Buffer, int32_t MaxSize, int32_t * Read, int8_t * Last)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zOffset;
	zval * zBuffer;
	zval * zMaxSize;
	zval * zRead;
	zval * zLast;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zOffset);
	ZVAL_LONG(zOffset, (long)Offset);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zMaxSize);
	ZVAL_LONG(zMaxSize, (long)MaxSize);
	MAKE_STD_ZVAL(zRead);
	ZVAL_LONG(zRead, (long)*Read);
	MAKE_STD_ZVAL(zLast);
	ZVAL_BOOL(zLast, (zend_bool)*Last);

	params[0] = &zSender;
	params[1] = &zOffset;
	params[2] = &zBuffer;
	params[3] = &zMaxSize;
	params[4] = &zRead;
	params[5] = &zLast;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zOffset);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zMaxSize);
	*Read = (int32_t)Z_LVAL_P(zRead);
	zval_ptr_dtor(&zRead);
	*Last = (int8_t)Z_BVAL_P(zLast);
	zval_ptr_dtor(&zLast);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBProtectedObjectStreamReadEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t Offset, TStreamHandle DestStream, int64_t MaxCount, int64_t * Read, int8_t * Last)
{
	zval *retval_ptr;
	zval **params[6];
	zval * zSender;
	zval * zOffset;
	zval * zDestStream;
	zval * zMaxCount;
	zval * zRead;
	zval * zLast;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zOffset);
	ZVAL_LONG(zOffset, (long)Offset);
	MAKE_STD_ZVAL(zDestStream);
	SBInitObject(zDestStream, TStream_ce_ptr, DestStream TSRMLS_CC);
	MAKE_STD_ZVAL(zMaxCount);
	ZVAL_LONG(zMaxCount, (long)MaxCount);
	MAKE_STD_ZVAL(zRead);
	ZVAL_LONG(zRead, (long)*Read);
	MAKE_STD_ZVAL(zLast);
	ZVAL_BOOL(zLast, (zend_bool)*Last);

	params[0] = &zSender;
	params[1] = &zOffset;
	params[2] = &zDestStream;
	params[3] = &zMaxCount;
	params[4] = &zRead;
	params[5] = &zLast;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 6, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zOffset);
	zval_ptr_dtor(&zDestStream);
	zval_ptr_dtor(&zMaxCount);
	*Read = (int64_t)Z_LVAL_P(zRead);
	zval_ptr_dtor(&zRead);
	*Last = (int8_t)Z_BVAL_P(zLast);
	zval_ptr_dtor(&zLast);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBProtectedObjectBodyBlockEventRaw(void * _ObjectData, TObjectHandle Sender, void * Buffer, int32_t Size)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zBuffer;
	zval * zSize;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);

	params[0] = &zSender;
	params[1] = &zBuffer;
	params[2] = &zSize;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zSize);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBProtectedObjectOutputStreamNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle * Stream)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zStream;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, *Stream TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zStream;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBProtectedObjectReadEventRaw(void * _ObjectData, TObjectHandle Sender, void * Buffer, int32_t Size)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zBuffer;
	zval * zSize;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zBuffer);
	SBInitPointerObject(zBuffer, Buffer TSRMLS_CC);
	MAKE_STD_ZVAL(zSize);
	ZVAL_LONG(zSize, (long)Size);

	params[0] = &zSender;
	params[1] = &zBuffer;
	params[2] = &zSize;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zBuffer);
	zval_ptr_dtor(&zSize);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBProtectedObjectMetadataReceivedEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pMetadata[], int32_t szMetadata)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zMetadata;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zMetadata);
	ZVAL_STRINGL(zMetadata, pMetadata, szMetadata, 1);

	params[0] = &zSender;
	params[1] = &zMetadata;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zMetadata);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBProtectedObjectMetadataObjectNameReceivedEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcObjName, int32_t szObjName)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zObjName;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zObjName);
	ZVAL_STRINGL(zObjName, pcObjName, szObjName, 1);

	params[0] = &zSender;
	params[1] = &zObjName;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zObjName);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElProxyStream_ce_ptr = NULL;

SB_PHP_METHOD(TElProxyStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElProxyStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElProxyStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElProxyStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElProxyStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, get_ClientStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElProxyStream_get_ClientStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, get_TotalRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElProxyStream_get_TotalRead(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, get_OnBeforeRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProxyStreamReadWriteEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProxyStream_get_OnBeforeRead(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, set_OnBeforeRead)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProxyStream_set_OnBeforeRead(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProxyStreamReadWriteEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProxyStreamReadWriteEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, get_OnAfterRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProxyStreamReadWriteEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProxyStream_get_OnAfterRead(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, set_OnAfterRead)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProxyStream_set_OnAfterRead(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProxyStreamReadWriteEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProxyStreamReadWriteEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, get_OnBeforeWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProxyStreamBeforeWriteEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProxyStream_get_OnBeforeWrite(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, set_OnBeforeWrite)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProxyStream_set_OnBeforeWrite(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProxyStreamBeforeWriteEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProxyStreamBeforeWriteEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, get_OnAfterWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProxyStreamReadWriteEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProxyStream_get_OnAfterWrite(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, set_OnAfterWrite)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProxyStream_set_OnAfterWrite(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProxyStreamReadWriteEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProxyStreamReadWriteEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProxyStream, __construct)
{
	long l8Size;
	long l8StartOffset;
	zend_bool bTreatSizeAsMaxSize;
	zval *oAClientStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAClientStream, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElProxyStream_Create(SBGetObjectHandle(oAClientStream TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llb", &oAClientStream, TStream_ce_ptr, &l8StartOffset, &l8Size, &bTreatSizeAsMaxSize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElProxyStream_Create_1(SBGetObjectHandle(oAClientStream TSRMLS_CC), (int64_t)l8StartOffset, (int64_t)l8Size, (int8_t)bTreatSizeAsMaxSize, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (TStream, integer, integer, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_get_ClientStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_get_TotalRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_get_OnBeforeRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_set_OnBeforeRead, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_get_OnAfterRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_set_OnAfterRead, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_get_OnBeforeWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_set_OnBeforeWrite, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_get_OnAfterWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream_set_OnAfterWrite, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProxyStream___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AClientStream, TStream, 1)
	ZEND_ARG_INFO(0, StartOffset)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(0, TreatSizeAsMaxSize)
ZEND_END_ARG_INFO()

static zend_function_entry TElProxyStream_methods[] = {
	PHP_ME(TElProxyStream, Read, arginfo_TElProxyStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, Write, arginfo_TElProxyStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, Seek, arginfo_TElProxyStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, get_ClientStream, arginfo_TElProxyStream_get_ClientStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, get_TotalRead, arginfo_TElProxyStream_get_TotalRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, get_OnBeforeRead, arginfo_TElProxyStream_get_OnBeforeRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, set_OnBeforeRead, arginfo_TElProxyStream_set_OnBeforeRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, get_OnAfterRead, arginfo_TElProxyStream_get_OnAfterRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, set_OnAfterRead, arginfo_TElProxyStream_set_OnAfterRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, get_OnBeforeWrite, arginfo_TElProxyStream_get_OnBeforeWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, set_OnBeforeWrite, arginfo_TElProxyStream_set_OnBeforeWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, get_OnAfterWrite, arginfo_TElProxyStream_get_OnAfterWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, set_OnAfterWrite, arginfo_TElProxyStream_set_OnAfterWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElProxyStream, __construct, arginfo_TElProxyStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElProxyStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElProxyStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElProxyStream", TElProxyStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElProxyStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElMetadataCache_ce_ptr = NULL;

SB_PHP_METHOD(TElMetadataCache, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElMetadataCache_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMetadataCache, Delete)
{
	long l4Count;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Count) == SUCCESS)
	{
		SBCheckError(TElMetadataCache_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMetadataCache, GetMetadata)
{
	char *sAObjectID;
	int sAObjectID_len;
	SBArrayZValInfo aiAMetadata;
	uint32_t _err;
	zval *zaAMetadata;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sAObjectID, &sAObjectID_len, &zaAMetadata) == SUCCESS) && PZVAL_IS_REF(zaAMetadata) && ((IS_STRING == Z_TYPE_P(zaAMetadata)) || (IS_ARRAY == Z_TYPE_P(zaAMetadata))))
	{
		int8_t bOutResultRaw = 0;
		SBInitArrayZValInfo(&aiAMetadata);
		_err = TElMetadataCache_GetMetadata(SBGetObjectHandle(getThis() TSRMLS_CC), sAObjectID, (int32_t)sAObjectID_len, aiAMetadata.data, &aiAMetadata.len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaAMetadata, &aiAMetadata TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1507669838, 2, aiAMetadata.data, &aiAMetadata.len) TSRMLS_CC);
			((char *)aiAMetadata.data)[aiAMetadata.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiAMetadata);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiAMetadata, zaAMetadata);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMetadataCache, GetMetadataID)
{
	char *sAMetadataID = NULL;
	char *sAObjectID;
	int sAObjectID_len;
	int32_t sAMetadataID_len = 0;
	uint32_t _err;
	zval *zsAMetadataID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sAObjectID, &sAObjectID_len, &zsAMetadataID) == SUCCESS) && PZVAL_IS_REF(zsAMetadataID) && (IS_STRING == Z_TYPE_P(zsAMetadataID)))
	{
		int8_t bOutResultRaw = 0;
		_err = TElMetadataCache_GetMetadataID(SBGetObjectHandle(getThis() TSRMLS_CC), sAObjectID, (int32_t)sAObjectID_len, sAMetadataID, &sAMetadataID_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sAMetadataID = emalloc(sAMetadataID_len + 1);
			SBCheckError(SBGetLastReturnStringA(-951079619, 2, sAMetadataID, &sAMetadataID_len) TSRMLS_CC);
			zval_dtor(zsAMetadataID);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sAMetadataID[sAMetadataID_len] = 0;
		ZVAL_STRINGL(zsAMetadataID, sAMetadataID, sAMetadataID_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMetadataCache, SetMetadata)
{
	char *sAObjectID;
	int sAObjectID_len;
	SBArrayZValInfo aiAMetadata;
	zval *zaAMetadata;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sAObjectID, &sAObjectID_len, &zaAMetadata) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAMetadata)) || (IS_ARRAY == Z_TYPE_P(zaAMetadata)) || (IS_NULL == Z_TYPE_P(zaAMetadata))))
	{
		if (!SBGetByteArrayFromZVal(zaAMetadata, &aiAMetadata TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElMetadataCache_SetMetadata(SBGetObjectHandle(getThis() TSRMLS_CC), sAObjectID, (int32_t)sAObjectID_len, aiAMetadata.data, aiAMetadata.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAMetadata);
	}
	else
	{
		SBErrorExpectsArguments("(string, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMetadataCache, SetMetadataID)
{
	char *sAMetadataID;
	char *sAObjectID;
	int sAMetadataID_len;
	int sAObjectID_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sAObjectID, &sAObjectID_len, &sAMetadataID, &sAMetadataID_len) == SUCCESS)
	{
		SBCheckError(TElMetadataCache_SetMetadataID(SBGetObjectHandle(getThis() TSRMLS_CC), sAObjectID, (int32_t)sAObjectID_len, sAMetadataID, (int32_t)sAMetadataID_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMetadataCache, get_MaxEntries)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElMetadataCache_get_MaxEntries(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMetadataCache, set_MaxEntries)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElMetadataCache_set_MaxEntries(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMetadataCache, __construct)
{
	long l4AMaxEntries;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4AMaxEntries) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMetadataCache_Create((int32_t)l4AMaxEntries, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMetadataCache_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMetadataCache_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMetadataCache_GetMetadata, 0, 0, 2)
	ZEND_ARG_INFO(0, AObjectID)
	ZEND_ARG_INFO(1, AMetadata)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMetadataCache_GetMetadataID, 0, 0, 2)
	ZEND_ARG_INFO(0, AObjectID)
	ZEND_ARG_INFO(1, AMetadataID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMetadataCache_SetMetadata, 0, 0, 2)
	ZEND_ARG_INFO(0, AObjectID)
	ZEND_ARG_TYPE_INFO(0, AMetadata, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMetadataCache_SetMetadataID, 0, 0, 2)
	ZEND_ARG_INFO(0, AObjectID)
	ZEND_ARG_INFO(0, AMetadataID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMetadataCache_get_MaxEntries, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMetadataCache_set_MaxEntries, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMetadataCache___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AMaxEntries)
ZEND_END_ARG_INFO()

static zend_function_entry TElMetadataCache_methods[] = {
	PHP_ME(TElMetadataCache, Clear, arginfo_TElMetadataCache_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElMetadataCache, Delete, arginfo_TElMetadataCache_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElMetadataCache, GetMetadata, arginfo_TElMetadataCache_GetMetadata, ZEND_ACC_PUBLIC)
	PHP_ME(TElMetadataCache, GetMetadataID, arginfo_TElMetadataCache_GetMetadataID, ZEND_ACC_PUBLIC)
	PHP_ME(TElMetadataCache, SetMetadata, arginfo_TElMetadataCache_SetMetadata, ZEND_ACC_PUBLIC)
	PHP_ME(TElMetadataCache, SetMetadataID, arginfo_TElMetadataCache_SetMetadataID, ZEND_ACC_PUBLIC)
	PHP_ME(TElMetadataCache, get_MaxEntries, arginfo_TElMetadataCache_get_MaxEntries, ZEND_ACC_PUBLIC)
	PHP_ME(TElMetadataCache, set_MaxEntries, arginfo_TElMetadataCache_set_MaxEntries, ZEND_ACC_PUBLIC)
	PHP_ME(TElMetadataCache, __construct, arginfo_TElMetadataCache___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElMetadataCache(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElMetadataCache_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElMetadataCache", TElMetadataCache_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElMetadataCache_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElProtectedObjectUploadStream_ce_ptr = NULL;

SB_PHP_METHOD(TElProtectedObjectUploadStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElProtectedObjectUploadStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElProtectedObjectUploadStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElProtectedObjectUploadStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElProtectedObjectUploadStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, get_Tag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElProtectedObjectUploadStream_get_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, set_Tag)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElProtectedObjectUploadStream_set_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, get_OnObjectWriteBegin)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectUploadStream_get_OnObjectWriteBegin(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, set_OnObjectWriteBegin)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectUploadStream_set_OnObjectWriteBegin(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, get_OnObjectWriteEnd)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectUploadStream_get_OnObjectWriteEnd(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, set_OnObjectWriteEnd)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectUploadStream_set_OnObjectWriteEnd(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, get_OnObjectWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectWriteEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectUploadStream_get_OnObjectWrite(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, set_OnObjectWrite)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectUploadStream_set_OnObjectWrite(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProtectedObjectWriteEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProtectedObjectWriteEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, get_OnMetadataNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectMetadataNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectUploadStream_get_OnMetadataNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, set_OnMetadataNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectUploadStream_set_OnMetadataNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProtectedObjectMetadataNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProtectedObjectMetadataNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, get_OnTrailerNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectMetadataNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectUploadStream_get_OnTrailerNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, set_OnTrailerNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectUploadStream_set_OnTrailerNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProtectedObjectMetadataNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProtectedObjectMetadataNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectUploadStream, __construct)
{
	char *sExternalMetadataObjectName;
	int sExternalMetadataObjectName_len;
	long fMetadataLocation;
	long l4MaxPostfixSize;
	long l4MaxPrefixSize;
	long l8Count;
	long l8MaxObjectSize;
	SBArrayZValInfo aiMetadata;
	zend_bool bReleaseSourceStream;
	zval *oSourceStream;
	zval *zaMetadata;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llllzslb", &oSourceStream, TStream_ce_ptr, &fMetadataLocation, &l4MaxPrefixSize, &l8MaxObjectSize, &l4MaxPostfixSize, &zaMetadata, &sExternalMetadataObjectName, &sExternalMetadataObjectName_len, &l8Count, &bReleaseSourceStream) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMetadata)) || (IS_ARRAY == Z_TYPE_P(zaMetadata)) || (IS_NULL == Z_TYPE_P(zaMetadata))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaMetadata, &aiMetadata TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElProtectedObjectUploadStream_Create(SBGetObjectHandle(oSourceStream TSRMLS_CC), (TSBProtectedObjectMetadataLocationRaw)fMetadataLocation, (int32_t)l4MaxPrefixSize, (int64_t)l8MaxObjectSize, (int32_t)l4MaxPostfixSize, aiMetadata.data, aiMetadata.len, sExternalMetadataObjectName, (int32_t)sExternalMetadataObjectName_len, (int64_t)l8Count, (int8_t)bReleaseSourceStream, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMetadata);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, integer, integer, integer, array of byte|string|NULL, string, integer, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_get_Tag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_set_Tag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_get_OnObjectWriteBegin, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_set_OnObjectWriteBegin, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_get_OnObjectWriteEnd, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_set_OnObjectWriteEnd, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_get_OnObjectWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_set_OnObjectWrite, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_get_OnMetadataNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_set_OnMetadataNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_get_OnTrailerNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream_set_OnTrailerNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectUploadStream___construct, 0, 0, 9)
	ZEND_ARG_OBJ_INFO(0, SourceStream, TStream, 1)
	ZEND_ARG_INFO(0, MetadataLocation)
	ZEND_ARG_INFO(0, MaxPrefixSize)
	ZEND_ARG_INFO(0, MaxObjectSize)
	ZEND_ARG_INFO(0, MaxPostfixSize)
	ZEND_ARG_TYPE_INFO(0, Metadata, 0, 1)
	ZEND_ARG_INFO(0, ExternalMetadataObjectName)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, ReleaseSourceStream)
ZEND_END_ARG_INFO()

static zend_function_entry TElProtectedObjectUploadStream_methods[] = {
	PHP_ME(TElProtectedObjectUploadStream, Read, arginfo_TElProtectedObjectUploadStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, Write, arginfo_TElProtectedObjectUploadStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, Seek, arginfo_TElProtectedObjectUploadStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, get_Tag, arginfo_TElProtectedObjectUploadStream_get_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, set_Tag, arginfo_TElProtectedObjectUploadStream_set_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, get_OnObjectWriteBegin, arginfo_TElProtectedObjectUploadStream_get_OnObjectWriteBegin, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, set_OnObjectWriteBegin, arginfo_TElProtectedObjectUploadStream_set_OnObjectWriteBegin, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, get_OnObjectWriteEnd, arginfo_TElProtectedObjectUploadStream_get_OnObjectWriteEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, set_OnObjectWriteEnd, arginfo_TElProtectedObjectUploadStream_set_OnObjectWriteEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, get_OnObjectWrite, arginfo_TElProtectedObjectUploadStream_get_OnObjectWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, set_OnObjectWrite, arginfo_TElProtectedObjectUploadStream_set_OnObjectWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, get_OnMetadataNeeded, arginfo_TElProtectedObjectUploadStream_get_OnMetadataNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, set_OnMetadataNeeded, arginfo_TElProtectedObjectUploadStream_set_OnMetadataNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, get_OnTrailerNeeded, arginfo_TElProtectedObjectUploadStream_get_OnTrailerNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, set_OnTrailerNeeded, arginfo_TElProtectedObjectUploadStream_set_OnTrailerNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectUploadStream, __construct, arginfo_TElProtectedObjectUploadStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElProtectedObjectUploadStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElProtectedObjectUploadStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElProtectedObjectUploadStream", TElProtectedObjectUploadStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElProtectedObjectUploadStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElProtectedObjectReader_ce_ptr = NULL;

SB_PHP_METHOD(TElProtectedObjectReader, ReadObjectInfo)
{
	long fReadStrategy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fReadStrategy) == SUCCESS)
	{
		SBCheckError(TElProtectedObjectReader_ReadObjectInfo(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBProtectedObjectReadStrategyRaw)fReadStrategy) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, Write)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElProtectedObjectReader_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, FlushCachedData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElProtectedObjectReader_FlushCachedData(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_MetadataLocation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectMetadataLocationRaw fOutResultRaw = 0;
		SBCheckError(TElProtectedObjectReader_get_MetadataLocation(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_Metadata)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElProtectedObjectReader_get_Metadata(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1089604366, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_Trailer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElProtectedObjectReader_get_Trailer(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-542634248, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_MaxMetadataSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElProtectedObjectReader_get_MaxMetadataSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_MaxObjectSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElProtectedObjectReader_get_MaxObjectSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_ObjectSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElProtectedObjectReader_get_ObjectSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_MaxTrailerSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElProtectedObjectReader_get_MaxTrailerSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_ExternalMetadataObjectName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElProtectedObjectReader_get_ExternalMetadataObjectName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(305526718, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_MetadataLengthThreshold)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElProtectedObjectReader_get_MetadataLengthThreshold(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_MetadataLengthThreshold)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElProtectedObjectReader_set_MetadataLengthThreshold(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_Tag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_get_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_Tag)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElProtectedObjectReader_set_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_DestStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_get_DestStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_ObjectInfoBlockSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElProtectedObjectReader_get_ObjectInfoBlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_ObjectInfoBlockSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElProtectedObjectReader_set_ObjectInfoBlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_OnReadBlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectBlockReadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_get_OnReadBlock(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_OnReadBlock)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectReader_set_OnReadBlock(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProtectedObjectBlockReadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProtectedObjectBlockReadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_OnReadStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectStreamReadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_get_OnReadStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_OnReadStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectReader_set_OnReadStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProtectedObjectStreamReadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProtectedObjectStreamReadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_OnHeaderProcessed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_get_OnHeaderProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_OnHeaderProcessed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectReader_set_OnHeaderProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_OnMetadataReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_get_OnMetadataReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_OnMetadataReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectReader_set_OnMetadataReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_OnMetadataObjectNameReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_get_OnMetadataObjectNameReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_OnMetadataObjectNameReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectReader_set_OnMetadataObjectNameReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_OnTrailerReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_get_OnTrailerReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_OnTrailerReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectReader_set_OnTrailerReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_OnObjectBodyBegin)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_get_OnObjectBodyBegin(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_OnObjectBodyBegin)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectReader_set_OnObjectBodyBegin(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_OnObjectBodyEnd)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_get_OnObjectBodyEnd(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_OnObjectBodyEnd)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectReader_set_OnObjectBodyEnd(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_OnObjectBodyBlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectBodyBlockEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_get_OnObjectBodyBlock(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_OnObjectBodyBlock)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectReader_set_OnObjectBodyBlock(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProtectedObjectBodyBlockEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProtectedObjectBodyBlockEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, get_OnOutputStreamNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectOutputStreamNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_get_OnOutputStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, set_OnOutputStreamNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectReader_set_OnOutputStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProtectedObjectOutputStreamNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProtectedObjectOutputStreamNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectReader, __construct)
{
	zval *oDestStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestStream, TStream_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElProtectedObjectReader_Create_1(SBGetObjectHandle(oDestStream TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TStream)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_ReadObjectInfo, 0, 0, 1)
	ZEND_ARG_INFO(0, ReadStrategy)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_FlushCachedData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_MetadataLocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_Metadata, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_Trailer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_MaxMetadataSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_MaxObjectSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_ObjectSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_MaxTrailerSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_ExternalMetadataObjectName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_MetadataLengthThreshold, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_MetadataLengthThreshold, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_Tag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_Tag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_DestStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_ObjectInfoBlockSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_ObjectInfoBlockSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_OnReadBlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_OnReadBlock, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_OnReadStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_OnReadStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_OnHeaderProcessed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_OnHeaderProcessed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_OnMetadataReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_OnMetadataReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_OnMetadataObjectNameReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_OnMetadataObjectNameReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_OnTrailerReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_OnTrailerReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_OnObjectBodyBegin, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_OnObjectBodyBegin, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_OnObjectBodyEnd, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_OnObjectBodyEnd, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_OnObjectBodyBlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_OnObjectBodyBlock, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_get_OnOutputStreamNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader_set_OnOutputStreamNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectReader___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, DestStream, TStream, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElProtectedObjectReader_methods[] = {
	PHP_ME(TElProtectedObjectReader, ReadObjectInfo, arginfo_TElProtectedObjectReader_ReadObjectInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, Write, arginfo_TElProtectedObjectReader_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, FlushCachedData, arginfo_TElProtectedObjectReader_FlushCachedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_MetadataLocation, arginfo_TElProtectedObjectReader_get_MetadataLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_Metadata, arginfo_TElProtectedObjectReader_get_Metadata, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_Trailer, arginfo_TElProtectedObjectReader_get_Trailer, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_MaxMetadataSize, arginfo_TElProtectedObjectReader_get_MaxMetadataSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_MaxObjectSize, arginfo_TElProtectedObjectReader_get_MaxObjectSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_ObjectSize, arginfo_TElProtectedObjectReader_get_ObjectSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_MaxTrailerSize, arginfo_TElProtectedObjectReader_get_MaxTrailerSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_ExternalMetadataObjectName, arginfo_TElProtectedObjectReader_get_ExternalMetadataObjectName, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_MetadataLengthThreshold, arginfo_TElProtectedObjectReader_get_MetadataLengthThreshold, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_MetadataLengthThreshold, arginfo_TElProtectedObjectReader_set_MetadataLengthThreshold, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_Tag, arginfo_TElProtectedObjectReader_get_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_Tag, arginfo_TElProtectedObjectReader_set_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_DestStream, arginfo_TElProtectedObjectReader_get_DestStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_ObjectInfoBlockSize, arginfo_TElProtectedObjectReader_get_ObjectInfoBlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_ObjectInfoBlockSize, arginfo_TElProtectedObjectReader_set_ObjectInfoBlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_OnReadBlock, arginfo_TElProtectedObjectReader_get_OnReadBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_OnReadBlock, arginfo_TElProtectedObjectReader_set_OnReadBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_OnReadStream, arginfo_TElProtectedObjectReader_get_OnReadStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_OnReadStream, arginfo_TElProtectedObjectReader_set_OnReadStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_OnHeaderProcessed, arginfo_TElProtectedObjectReader_get_OnHeaderProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_OnHeaderProcessed, arginfo_TElProtectedObjectReader_set_OnHeaderProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_OnMetadataReceived, arginfo_TElProtectedObjectReader_get_OnMetadataReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_OnMetadataReceived, arginfo_TElProtectedObjectReader_set_OnMetadataReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_OnMetadataObjectNameReceived, arginfo_TElProtectedObjectReader_get_OnMetadataObjectNameReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_OnMetadataObjectNameReceived, arginfo_TElProtectedObjectReader_set_OnMetadataObjectNameReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_OnTrailerReceived, arginfo_TElProtectedObjectReader_get_OnTrailerReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_OnTrailerReceived, arginfo_TElProtectedObjectReader_set_OnTrailerReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_OnObjectBodyBegin, arginfo_TElProtectedObjectReader_get_OnObjectBodyBegin, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_OnObjectBodyBegin, arginfo_TElProtectedObjectReader_set_OnObjectBodyBegin, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_OnObjectBodyEnd, arginfo_TElProtectedObjectReader_get_OnObjectBodyEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_OnObjectBodyEnd, arginfo_TElProtectedObjectReader_set_OnObjectBodyEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_OnObjectBodyBlock, arginfo_TElProtectedObjectReader_get_OnObjectBodyBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_OnObjectBodyBlock, arginfo_TElProtectedObjectReader_set_OnObjectBodyBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, get_OnOutputStreamNeeded, arginfo_TElProtectedObjectReader_get_OnOutputStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, set_OnOutputStreamNeeded, arginfo_TElProtectedObjectReader_set_OnOutputStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectReader, __construct, arginfo_TElProtectedObjectReader___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElProtectedObjectReader(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElProtectedObjectReader_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElProtectedObjectReader", TElProtectedObjectReader_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElProtectedObjectReader_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElProtectedObjectDownloadStream_ce_ptr = NULL;

SB_PHP_METHOD(TElProtectedObjectDownloadStream, FlushCachedData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElProtectedObjectDownloadStream_FlushCachedData(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElProtectedObjectDownloadStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElProtectedObjectDownloadStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElProtectedObjectDownloadStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElProtectedObjectDownloadStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, get_DestStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElProtectedObjectDownloadStream_get_DestStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, get_Tag)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElProtectedObjectDownloadStream_get_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, set_Tag)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElProtectedObjectDownloadStream_set_Tag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, get_Reader)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElProtectedObjectDownloadStream_get_Reader(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElProtectedObjectReader_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, get_OnHeaderProcessed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectDownloadStream_get_OnHeaderProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, set_OnHeaderProcessed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectDownloadStream_set_OnHeaderProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, get_OnObjectReadBegin)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectDownloadStream_get_OnObjectReadBegin(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, set_OnObjectReadBegin)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectDownloadStream_set_OnObjectReadBegin(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, get_OnObjectReadEnd)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectDownloadStream_get_OnObjectReadEnd(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, set_OnObjectReadEnd)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectDownloadStream_set_OnObjectReadEnd(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, get_OnObjectRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectReadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectDownloadStream_get_OnObjectRead(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, set_OnObjectRead)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectDownloadStream_set_OnObjectRead(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProtectedObjectReadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProtectedObjectReadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, get_OnMetadataReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectMetadataReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectDownloadStream_get_OnMetadataReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, set_OnMetadataReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectDownloadStream_set_OnMetadataReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProtectedObjectMetadataReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProtectedObjectMetadataReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, get_OnMetadataObjectNameReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectMetadataObjectNameReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectDownloadStream_get_OnMetadataObjectNameReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, set_OnMetadataObjectNameReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectDownloadStream_set_OnMetadataObjectNameReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProtectedObjectMetadataObjectNameReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProtectedObjectMetadataObjectNameReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, get_OnTrailerReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectMetadataReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectDownloadStream_get_OnTrailerReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, set_OnTrailerReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectDownloadStream_set_OnTrailerReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProtectedObjectMetadataReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProtectedObjectMetadataReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, get_OnOutputStreamNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProtectedObjectOutputStreamNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElProtectedObjectDownloadStream_get_OnOutputStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, set_OnOutputStreamNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElProtectedObjectDownloadStream_set_OnOutputStreamNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProtectedObjectOutputStreamNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProtectedObjectOutputStreamNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElProtectedObjectDownloadStream, __construct)
{
	zend_bool bReleaseDestStream;
	zval *oDestStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oDestStream, TStream_ce_ptr, &bReleaseDestStream) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElProtectedObjectDownloadStream_Create(SBGetObjectHandle(oDestStream TSRMLS_CC), (int8_t)bReleaseDestStream, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_FlushCachedData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_get_DestStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_get_Tag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_set_Tag, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_get_Reader, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_get_OnHeaderProcessed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_set_OnHeaderProcessed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_get_OnObjectReadBegin, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_set_OnObjectReadBegin, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_get_OnObjectReadEnd, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_set_OnObjectReadEnd, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_get_OnObjectRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_set_OnObjectRead, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_get_OnMetadataReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_set_OnMetadataReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_get_OnMetadataObjectNameReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_set_OnMetadataObjectNameReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_get_OnTrailerReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_set_OnTrailerReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_get_OnOutputStreamNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream_set_OnOutputStreamNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElProtectedObjectDownloadStream___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, DestStream, TStream, 1)
	ZEND_ARG_INFO(0, ReleaseDestStream)
ZEND_END_ARG_INFO()

static zend_function_entry TElProtectedObjectDownloadStream_methods[] = {
	PHP_ME(TElProtectedObjectDownloadStream, FlushCachedData, arginfo_TElProtectedObjectDownloadStream_FlushCachedData, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, Read, arginfo_TElProtectedObjectDownloadStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, Write, arginfo_TElProtectedObjectDownloadStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, Seek, arginfo_TElProtectedObjectDownloadStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, get_DestStream, arginfo_TElProtectedObjectDownloadStream_get_DestStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, get_Tag, arginfo_TElProtectedObjectDownloadStream_get_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, set_Tag, arginfo_TElProtectedObjectDownloadStream_set_Tag, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, get_Reader, arginfo_TElProtectedObjectDownloadStream_get_Reader, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, get_OnHeaderProcessed, arginfo_TElProtectedObjectDownloadStream_get_OnHeaderProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, set_OnHeaderProcessed, arginfo_TElProtectedObjectDownloadStream_set_OnHeaderProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, get_OnObjectReadBegin, arginfo_TElProtectedObjectDownloadStream_get_OnObjectReadBegin, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, set_OnObjectReadBegin, arginfo_TElProtectedObjectDownloadStream_set_OnObjectReadBegin, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, get_OnObjectReadEnd, arginfo_TElProtectedObjectDownloadStream_get_OnObjectReadEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, set_OnObjectReadEnd, arginfo_TElProtectedObjectDownloadStream_set_OnObjectReadEnd, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, get_OnObjectRead, arginfo_TElProtectedObjectDownloadStream_get_OnObjectRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, set_OnObjectRead, arginfo_TElProtectedObjectDownloadStream_set_OnObjectRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, get_OnMetadataReceived, arginfo_TElProtectedObjectDownloadStream_get_OnMetadataReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, set_OnMetadataReceived, arginfo_TElProtectedObjectDownloadStream_set_OnMetadataReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, get_OnMetadataObjectNameReceived, arginfo_TElProtectedObjectDownloadStream_get_OnMetadataObjectNameReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, set_OnMetadataObjectNameReceived, arginfo_TElProtectedObjectDownloadStream_set_OnMetadataObjectNameReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, get_OnTrailerReceived, arginfo_TElProtectedObjectDownloadStream_get_OnTrailerReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, set_OnTrailerReceived, arginfo_TElProtectedObjectDownloadStream_set_OnTrailerReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, get_OnOutputStreamNeeded, arginfo_TElProtectedObjectDownloadStream_get_OnOutputStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, set_OnOutputStreamNeeded, arginfo_TElProtectedObjectDownloadStream_set_OnOutputStreamNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElProtectedObjectDownloadStream, __construct, arginfo_TElProtectedObjectDownloadStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElProtectedObjectDownloadStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElProtectedObjectDownloadStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElProtectedObjectDownloadStream", TElProtectedObjectDownloadStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElProtectedObjectDownloadStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBDataStorageUtils, TryGetStreamSize)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(SBDataStorageUtils_TryGetStreamSize(SBGetObjectHandle(oStream TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDataStorageUtils, PathAddExtension)
{
	char *sExtension;
	char *sPathName;
	int sExtension_len;
	int sPathName_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sPathName, &sPathName_len, &sExtension, &sExtension_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBDataStorageUtils_PathAddExtension(sPathName, (int32_t)sPathName_len, sExtension, (int32_t)sExtension_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1368763655, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

void Register_SBDataStorageUtils_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBDataStorageUtils, DefaultMetadataCacheLimit, SB_DefaultMetadataCacheLimit, SB_DefaultMetadataCacheLimit);
}

void Register_SBDataStorageUtils_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBProtectedObjectMetadataLocation", NULL);
	TSBProtectedObjectMetadataLocation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBProtectedObjectMetadataLocation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBProtectedObjectMetadataLocation_ce_ptr, "omlUnprotectedObject", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBProtectedObjectMetadataLocation_ce_ptr, "omlNoMetadata", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBProtectedObjectMetadataLocation_ce_ptr, "omlExternal", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBProtectedObjectMetadataLocation_ce_ptr, "omlExternalObject", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBProtectedObjectMetadataLocation_ce_ptr, "omlBeginning", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBProtectedObjectMetadataLocation_ce_ptr, "omlEnd", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBProtectedObjectReadStrategy", NULL);
	TSBProtectedObjectReadStrategy_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBProtectedObjectReadStrategy_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBProtectedObjectReadStrategy_ce_ptr, "orsMinimizeBlockReads", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBProtectedObjectReadStrategy_ce_ptr, "orsMinimizeTraffic", 1)
}

