#include "sbdcdef.h"

zend_class_entry *TElDCPKCS7SignParameters_ce_ptr = NULL;

SB_PHP_METHOD(TElDCPKCS7SignParameters, SaveToRDN)
{
	zval *oRdn;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oRdn, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_SaveToRDN(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRdn TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, LoadFromRDN)
{
	zval *oRdn;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oRdn, TElRelativeDistinguishedName_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_LoadFromRDN(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRdn TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElRelativeDistinguishedName)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDCPKCS7SignParameters_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1664227776, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_ContentType)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDCPKCS7SignParameters_set_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_SgnDataVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_SgnDataVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_SgnDataVersion)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_SgnDataVersion(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_SigningTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_SigningTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_SigningTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_SigningTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_Timestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_Timestamp)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_TimestampServiceID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElDCPKCS7SignParameters_get_TimestampServiceID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1260075343, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_TimestampServiceID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDCPKCS7SignParameters_set_TimestampServiceID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_TimestampHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_TimestampHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_TimestampHashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_TimestampHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_IncludeCertsToSgnData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_IncludeCertsToSgnData(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_IncludeCertsToSgnData)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_IncludeCertsToSgnData(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_IncludeCRLsToSgnData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_IncludeCRLsToSgnData(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_IncludeCRLsToSgnData)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_IncludeCRLsToSgnData(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_IncludeRevInfoToAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_IncludeRevInfoToAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_IncludeRevInfoToAttributes)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_IncludeRevInfoToAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_IncludeCertChain)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_IncludeCertChain(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_IncludeCertChain)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_IncludeCertChain(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_InsertMessageDigests)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_InsertMessageDigests(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_InsertMessageDigests)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_InsertMessageDigests(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_InsertSigningTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_InsertSigningTime(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_InsertSigningTime)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_InsertSigningTime(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_InsertContentType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_InsertContentType(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_InsertContentType)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_InsertContentType(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_InsertSigningCertificateAttr)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_InsertSigningCertificateAttr(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_InsertSigningCertificateAttr)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_InsertSigningCertificateAttr(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_IgnoreTimestampFailure)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_IgnoreTimestampFailure(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_IgnoreTimestampFailure)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_IgnoreTimestampFailure(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_UseGeneralizedTimeFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_UseGeneralizedTimeFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_UseGeneralizedTimeFormat)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_UseGeneralizedTimeFormat(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_ForceSigningCertificateV2Usage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_ForceSigningCertificateV2Usage(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_ForceSigningCertificateV2Usage)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_ForceSigningCertificateV2Usage(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_UseUndefSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCPKCS7SignParameters_get_UseUndefSize(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, set_UseUndefSize)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElDCPKCS7SignParameters_set_UseUndefSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_CustomSignedAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCPKCS7SignParameters_get_CustomSignedAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS7Attributes_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_CustomUnsignedAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCPKCS7SignParameters_get_CustomUnsignedAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPKCS7Attributes_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, get_CustomOptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCPKCS7SignParameters_get_CustomOptions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElRelativeDistinguishedName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCPKCS7SignParameters, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCPKCS7SignParameters_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_SaveToRDN, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Rdn, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_LoadFromRDN, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Rdn, TElRelativeDistinguishedName, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_ContentType, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_SgnDataVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_SgnDataVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_SigningTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_SigningTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_Timestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_Timestamp, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_TimestampServiceID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_TimestampServiceID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_TimestampHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_TimestampHashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_IncludeCertsToSgnData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_IncludeCertsToSgnData, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_IncludeCRLsToSgnData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_IncludeCRLsToSgnData, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_IncludeRevInfoToAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_IncludeRevInfoToAttributes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_IncludeCertChain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_IncludeCertChain, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_InsertMessageDigests, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_InsertMessageDigests, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_InsertSigningTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_InsertSigningTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_InsertContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_InsertContentType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_InsertSigningCertificateAttr, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_InsertSigningCertificateAttr, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_IgnoreTimestampFailure, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_IgnoreTimestampFailure, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_UseGeneralizedTimeFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_UseGeneralizedTimeFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_ForceSigningCertificateV2Usage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_ForceSigningCertificateV2Usage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_UseUndefSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_set_UseUndefSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_CustomSignedAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_CustomUnsignedAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters_get_CustomOptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCPKCS7SignParameters___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCPKCS7SignParameters_methods[] = {
	PHP_ME(TElDCPKCS7SignParameters, SaveToRDN, arginfo_TElDCPKCS7SignParameters_SaveToRDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, LoadFromRDN, arginfo_TElDCPKCS7SignParameters_LoadFromRDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_ContentType, arginfo_TElDCPKCS7SignParameters_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_ContentType, arginfo_TElDCPKCS7SignParameters_set_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_SgnDataVersion, arginfo_TElDCPKCS7SignParameters_get_SgnDataVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_SgnDataVersion, arginfo_TElDCPKCS7SignParameters_set_SgnDataVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_SigningTime, arginfo_TElDCPKCS7SignParameters_get_SigningTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_SigningTime, arginfo_TElDCPKCS7SignParameters_set_SigningTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_Timestamp, arginfo_TElDCPKCS7SignParameters_get_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_Timestamp, arginfo_TElDCPKCS7SignParameters_set_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_TimestampServiceID, arginfo_TElDCPKCS7SignParameters_get_TimestampServiceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_TimestampServiceID, arginfo_TElDCPKCS7SignParameters_set_TimestampServiceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_TimestampHashAlgorithm, arginfo_TElDCPKCS7SignParameters_get_TimestampHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_TimestampHashAlgorithm, arginfo_TElDCPKCS7SignParameters_set_TimestampHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_IncludeCertsToSgnData, arginfo_TElDCPKCS7SignParameters_get_IncludeCertsToSgnData, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_IncludeCertsToSgnData, arginfo_TElDCPKCS7SignParameters_set_IncludeCertsToSgnData, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_IncludeCRLsToSgnData, arginfo_TElDCPKCS7SignParameters_get_IncludeCRLsToSgnData, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_IncludeCRLsToSgnData, arginfo_TElDCPKCS7SignParameters_set_IncludeCRLsToSgnData, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_IncludeRevInfoToAttributes, arginfo_TElDCPKCS7SignParameters_get_IncludeRevInfoToAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_IncludeRevInfoToAttributes, arginfo_TElDCPKCS7SignParameters_set_IncludeRevInfoToAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_IncludeCertChain, arginfo_TElDCPKCS7SignParameters_get_IncludeCertChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_IncludeCertChain, arginfo_TElDCPKCS7SignParameters_set_IncludeCertChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_InsertMessageDigests, arginfo_TElDCPKCS7SignParameters_get_InsertMessageDigests, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_InsertMessageDigests, arginfo_TElDCPKCS7SignParameters_set_InsertMessageDigests, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_InsertSigningTime, arginfo_TElDCPKCS7SignParameters_get_InsertSigningTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_InsertSigningTime, arginfo_TElDCPKCS7SignParameters_set_InsertSigningTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_InsertContentType, arginfo_TElDCPKCS7SignParameters_get_InsertContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_InsertContentType, arginfo_TElDCPKCS7SignParameters_set_InsertContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_InsertSigningCertificateAttr, arginfo_TElDCPKCS7SignParameters_get_InsertSigningCertificateAttr, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_InsertSigningCertificateAttr, arginfo_TElDCPKCS7SignParameters_set_InsertSigningCertificateAttr, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_IgnoreTimestampFailure, arginfo_TElDCPKCS7SignParameters_get_IgnoreTimestampFailure, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_IgnoreTimestampFailure, arginfo_TElDCPKCS7SignParameters_set_IgnoreTimestampFailure, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_UseGeneralizedTimeFormat, arginfo_TElDCPKCS7SignParameters_get_UseGeneralizedTimeFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_UseGeneralizedTimeFormat, arginfo_TElDCPKCS7SignParameters_set_UseGeneralizedTimeFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_ForceSigningCertificateV2Usage, arginfo_TElDCPKCS7SignParameters_get_ForceSigningCertificateV2Usage, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_ForceSigningCertificateV2Usage, arginfo_TElDCPKCS7SignParameters_set_ForceSigningCertificateV2Usage, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_UseUndefSize, arginfo_TElDCPKCS7SignParameters_get_UseUndefSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, set_UseUndefSize, arginfo_TElDCPKCS7SignParameters_set_UseUndefSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_CustomSignedAttributes, arginfo_TElDCPKCS7SignParameters_get_CustomSignedAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_CustomUnsignedAttributes, arginfo_TElDCPKCS7SignParameters_get_CustomUnsignedAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, get_CustomOptions, arginfo_TElDCPKCS7SignParameters_get_CustomOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCPKCS7SignParameters, __construct, arginfo_TElDCPKCS7SignParameters___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCPKCS7SignParameters(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCPKCS7SignParameters_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCPKCS7SignParameters", TElDCPKCS7SignParameters_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDCPKCS7SignParameters_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCDefaultRequestFactory_ce_ptr = NULL;

SB_PHP_METHOD(TElDCDefaultRequestFactory, CreatePKCS1SignRequest)
{
	char *sOpName;
	int sOpName_len;
	long l4HashAlgorithm;
	SBArrayZValInfo aiSource;
	zend_bool bIncludeKeysInResponse;
	zval *zaSource;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szlb", &sOpName, &sOpName_len, &zaSource, &l4HashAlgorithm, &bIncludeKeysInResponse) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSource)) || (IS_ARRAY == Z_TYPE_P(zaSource)) || (IS_NULL == Z_TYPE_P(zaSource))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaSource, &aiSource TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDCDefaultRequestFactory_CreatePKCS1SignRequest(SBGetObjectHandle(getThis() TSRMLS_CC), sOpName, (int32_t)sOpName_len, aiSource.data, aiSource.len, (int32_t)l4HashAlgorithm, (int8_t)bIncludeKeysInResponse, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSource);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, array of byte|string|NULL, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCDefaultRequestFactory, CreatePKCS7SignRequest)
{
	char *sOpName;
	int sOpName_len;
	long l4HashAlgorithm;
	SBArrayZValInfo aiSource;
	zval *oPars;
	zval *zaSource;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szlO!", &sOpName, &sOpName_len, &zaSource, &l4HashAlgorithm, &oPars, TElDCPKCS7SignParameters_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSource)) || (IS_ARRAY == Z_TYPE_P(zaSource)) || (IS_NULL == Z_TYPE_P(zaSource))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaSource, &aiSource TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElDCDefaultRequestFactory_CreatePKCS7SignRequest(SBGetObjectHandle(getThis() TSRMLS_CC), sOpName, (int32_t)sOpName_len, aiSource.data, aiSource.len, (int32_t)l4HashAlgorithm, SBGetObjectHandle(oPars TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSource);
		SBInitObject(return_value, TElDCAsyncState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, array of byte|string|NULL, integer, TElDCPKCS7SignParameters)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCDefaultRequestFactory, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCDefaultRequestFactory_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCDefaultRequestFactory_CreatePKCS1SignRequest, 0, 0, 4)
	ZEND_ARG_INFO(0, OpName)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
	ZEND_ARG_INFO(0, HashAlgorithm)
	ZEND_ARG_INFO(0, IncludeKeysInResponse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCDefaultRequestFactory_CreatePKCS7SignRequest, 0, 0, 4)
	ZEND_ARG_INFO(0, OpName)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
	ZEND_ARG_INFO(0, HashAlgorithm)
	ZEND_ARG_OBJ_INFO(0, Pars, TElDCPKCS7SignParameters, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCDefaultRequestFactory___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCDefaultRequestFactory_methods[] = {
	PHP_ME(TElDCDefaultRequestFactory, CreatePKCS1SignRequest, arginfo_TElDCDefaultRequestFactory_CreatePKCS1SignRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCDefaultRequestFactory, CreatePKCS7SignRequest, arginfo_TElDCDefaultRequestFactory_CreatePKCS7SignRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCDefaultRequestFactory, __construct, arginfo_TElDCDefaultRequestFactory___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCDefaultRequestFactory(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCDefaultRequestFactory_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCDefaultRequestFactory", TElDCDefaultRequestFactory_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDCDefaultRequestFactory_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBDCDef, DefaultDCRequestFactory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBDCDef_DefaultDCRequestFactory(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCDefaultRequestFactory_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

