#include "sbdcenc.h"

zend_class_entry *TElDCEncoding_ce_ptr = NULL;

SB_PHP_METHOD(TElDCEncoding, Encode)
{
	zval *oRoot;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oRoot, TElDCNode_ce_ptr, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCEncoding_Encode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRoot TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCNode, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCEncoding, Decode)
{
	long l4Count;
	zval *oRoot;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oRoot, TElDCNode_ce_ptr, &oStream, TStream_ce_ptr, &l4Count) == SUCCESS)
	{
		SBCheckError(TElDCEncoding_Decode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRoot TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCNode, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCEncoding, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCEncoding_GetName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1811729735, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCEncoding, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCEncoding_GetDescription(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(966803341, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCEncoding, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCEncoding_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCEncoding_Encode, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Root, TElDCNode, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCEncoding_Decode, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Root, TElDCNode, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCEncoding_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCEncoding_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCEncoding___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCEncoding_methods[] = {
	PHP_ME(TElDCEncoding, Encode, arginfo_TElDCEncoding_Encode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCEncoding, Decode, arginfo_TElDCEncoding_Decode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCEncoding, GetName, arginfo_TElDCEncoding_GetName, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCEncoding, GetDescription, arginfo_TElDCEncoding_GetDescription, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCEncoding, __construct, arginfo_TElDCEncoding___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCEncoding(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCEncoding_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCEncoding", TElDCEncoding_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDCEncoding_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDCNode_ce_ptr = NULL;

SB_PHP_METHOD(TElDCNode, AddNode)
{
	char *sElemName;
	char *sName;
	char *sValue;
	int sElemName_len;
	int sName_len;
	int sValue_len;
	long l4Value;
	zend_bool bValue;
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCNode_AddNode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sName, &sName_len, &sValue, &sValue_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCNode_AddNode_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sValue, (int32_t)sValue_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sName, &sName_len, &l4Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCNode_AddNode_2(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int32_t)l4Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sName, &sName_len, &bValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCNode_AddNode_3(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!s", &sName, &sName_len, &oValue, TElRelativeDistinguishedName_ce_ptr, &sElemName, &sElemName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCNode_AddNode_4(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oValue TSRMLS_CC), sElemName, (int32_t)sElemName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!s", &sName, &sName_len, &oValue, TStringList_ce_ptr, &sElemName, &sElemName_len) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!s", &sName, &sName_len, &oValue, TElStringList_ce_ptr, &sElemName, &sElemName_len) == SUCCESS)
#endif
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCNode_AddNode_5(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oValue TSRMLS_CC), sElemName, (int32_t)sElemName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("() or (string, string) or (string, integer) or (string, bool) or (string, TElRelativeDistinguishedName, string) or (string, TStringList, string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("() or (string, string) or (string, integer) or (string, bool) or (string, TElRelativeDistinguishedName, string) or (string, TElStringList, string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElDCNode, RemoveNode)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElDCNode_RemoveNode(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElDCNode_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, ReadString)
{
	char *sDefault;
	char *sName;
	int sDefault_len;
	int sName_len;
	uint32_t _err;
	zend_bool bRaiseExceptionIfNotFound;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sName, &sName_len, &sDefault, &sDefault_len, &bRaiseExceptionIfNotFound) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCNode_ReadString(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sDefault, (int32_t)sDefault_len, (int8_t)bRaiseExceptionIfNotFound, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1344574873, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, ReadInteger)
{
	char *sName;
	int sName_len;
	long l4Default;
	zend_bool bRaiseExceptionIfNotFound;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slb", &sName, &sName_len, &l4Default, &bRaiseExceptionIfNotFound) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCNode_ReadInteger(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int32_t)l4Default, (int8_t)bRaiseExceptionIfNotFound, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, ReadBoolean)
{
	char *sName;
	int sName_len;
	zend_bool bDefault;
	zend_bool bRaiseExceptionIfNotFound;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbb", &sName, &sName_len, &bDefault, &bRaiseExceptionIfNotFound) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElDCNode_ReadBoolean(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int8_t)bDefault, (int8_t)bRaiseExceptionIfNotFound, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, ReadRDN)
{
	char *sName;
	int sName_len;
	zend_bool bRaiseExceptionIfNotFound;
	zval *oRdn;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!b", &sName, &sName_len, &oRdn, TElRelativeDistinguishedName_ce_ptr, &bRaiseExceptionIfNotFound) == SUCCESS)
	{
		SBCheckError(TElDCNode_ReadRDN(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oRdn TSRMLS_CC), (int8_t)bRaiseExceptionIfNotFound) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElRelativeDistinguishedName, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, ReadStringList)
{
	char *sName;
	int sName_len;
	zend_bool bRaiseExceptionIfNotFound;
	zval *oLst;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!b", &sName, &sName_len, &oLst, TStringList_ce_ptr, &bRaiseExceptionIfNotFound) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!b", &sName, &sName_len, &oLst, TElStringList_ce_ptr, &bRaiseExceptionIfNotFound) == SUCCESS)
#endif
	{
		SBCheckError(TElDCNode_ReadStringList(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oLst TSRMLS_CC), (int8_t)bRaiseExceptionIfNotFound) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList, bool)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList, bool)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElDCNode, LoadFromStream)
{
	long l4Count;
	zval *oEncoding;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!", &oStream, TStream_ce_ptr, &l4Count, &oEncoding, TElDCEncoding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCNode_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int32_t)l4Count, SBGetObjectHandle(oEncoding TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, TElDCEncoding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, SaveToStream)
{
	zval *oEncoding;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oStream, TStream_ce_ptr, &oEncoding, TElDCEncoding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElDCNode_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), SBGetObjectHandle(oEncoding TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TElDCEncoding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, get_Nodes)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCNode_get_Nodes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, get_NodeCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElDCNode_get_NodeCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCNode_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(723413890, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDCNode_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElDCNode_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(634768789, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElDCNode_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, get_Params)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCNode_get_Params(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDCNode, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDCNode_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_AddNode, 0, 0, 0)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
	ZEND_ARG_INFO(0, ElemName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_RemoveNode, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_ReadString, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Default)
	ZEND_ARG_INFO(0, RaiseExceptionIfNotFound)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_ReadInteger, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Default)
	ZEND_ARG_INFO(0, RaiseExceptionIfNotFound)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_ReadBoolean, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Default)
	ZEND_ARG_INFO(0, RaiseExceptionIfNotFound)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_ReadRDN, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_OBJ_INFO(0, Rdn, TElRelativeDistinguishedName, 1)
	ZEND_ARG_INFO(0, RaiseExceptionIfNotFound)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_ReadStringList, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Lst, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Lst, TElStringList, 1)
#endif
	ZEND_ARG_INFO(0, RaiseExceptionIfNotFound)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_LoadFromStream, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_OBJ_INFO(0, Encoding, TElDCEncoding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_SaveToStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_OBJ_INFO(0, Encoding, TElDCEncoding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_get_Nodes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_get_NodeCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode_get_Params, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDCNode___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDCNode_methods[] = {
	PHP_ME(TElDCNode, AddNode, arginfo_TElDCNode_AddNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, RemoveNode, arginfo_TElDCNode_RemoveNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, Clear, arginfo_TElDCNode_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, ReadString, arginfo_TElDCNode_ReadString, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, ReadInteger, arginfo_TElDCNode_ReadInteger, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, ReadBoolean, arginfo_TElDCNode_ReadBoolean, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, ReadRDN, arginfo_TElDCNode_ReadRDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, ReadStringList, arginfo_TElDCNode_ReadStringList, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, LoadFromStream, arginfo_TElDCNode_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, SaveToStream, arginfo_TElDCNode_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, get_Nodes, arginfo_TElDCNode_get_Nodes, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, get_NodeCount, arginfo_TElDCNode_get_NodeCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, get_Name, arginfo_TElDCNode_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, set_Name, arginfo_TElDCNode_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, get_Value, arginfo_TElDCNode_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, set_Value, arginfo_TElDCNode_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, get_Params, arginfo_TElDCNode_get_Params, ZEND_ACC_PUBLIC)
	PHP_ME(TElDCNode, __construct, arginfo_TElDCNode___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDCNode(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDCNode_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDCNode", TElDCNode_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElDCNode_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBDCEnc, SetDefaultDCEncoding)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElDCEncoding_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBDCEnc_SetDefaultDCEncoding(SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCEncoding)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBDCEnc, GetDefaultDCEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBDCEnc_GetDefaultDCEncoding(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDCEncoding_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
