#include "sbelgamal.h"

SB_PHP_FUNCTION(SBElgamal, Generate)
{
	long l4Bits;
	SBArrayZValInfo piData;
	void *pzProgressFunc;
	zval *oG;
	zval *oP;
	zval *oX;
	zval *oY;
	zval *zpData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!O!O!zz", &l4Bits, &oP, TLInt_ce_ptr, &oG, TLInt_ce_ptr, &oX, TLInt_ce_ptr, &oY, TLInt_ce_ptr, &zProgressFunc, &zpData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBElgamal_Generate((int32_t)l4Bits, (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oG TSRMLS_CC), (TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oY TSRMLS_CC), pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TLInt, TLInt, TLInt, TLInt, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBElgamal, ExternalGenerate)
{
	long l4Bits;
	SBArrayZValInfo piData;
	void *pzProgressFunc;
	zval *oG;
	zval *oP;
	zval *oX;
	zval *oY;
	zval *zpData;
	zval *zProgressFunc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!O!O!O!zz", &l4Bits, &oP, TLInt_ce_ptr, &oG, TLInt_ce_ptr, &oX, TLInt_ce_ptr, &oY, TLInt_ce_ptr, &zProgressFunc, &zpData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zProgressFunc)) || (IS_ARRAY == Z_TYPE_P(zProgressFunc)) || (IS_CALLABLE == Z_TYPE_P(zProgressFunc)) || (IS_NULL == Z_TYPE_P(zProgressFunc))) && ((Z_TYPE_P(zpData) == IS_STRING) || (Z_TYPE_P(zpData) == IS_ARRAY) || (Z_TYPE_P(zpData) == IS_NULL) || ((Z_TYPE_P(zpData) == IS_OBJECT) && (Z_OBJCE_P(zpData) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		pzProgressFunc = SBSetEventData(zProgressFunc TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpData, &piData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBElgamal_ExternalGenerate((int32_t)l4Bits, (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oG TSRMLS_CC), (TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oY TSRMLS_CC), pzProgressFunc ? &TSBMathProgressFuncRaw : NULL, pzProgressFunc, piData.data, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piData);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TLInt, TLInt, TLInt, TLInt, TSBMathProgressFunc|callable|NULL, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBElgamal, ExternalGenerationSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBElgamal_ExternalGenerationSupported(&bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBElgamal, Encrypt)
{
	zval *oA;
	zval *oB;
	zval *oG;
	zval *oP;
	zval *oSrc;
	zval *oY;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!", &oSrc, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oG, TLInt_ce_ptr, &oY, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBElgamal_Encrypt((TLInt *)SBGetStructPointer(oSrc TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oG TSRMLS_CC), (TLInt *)SBGetStructPointer(oY TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBElgamal, Decrypt)
{
	zval *oA;
	zval *oB;
	zval *oDest;
	zval *oG;
	zval *oP;
	zval *oX;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!", &oP, TLInt_ce_ptr, &oG, TLInt_ce_ptr, &oX, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr, &oDest, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBElgamal_Decrypt((TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oG TSRMLS_CC), (TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), (TLInt *)SBGetStructPointer(oDest TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBElgamal, Sign)
{
	zval *oA;
	zval *oB;
	zval *oG;
	zval *oP;
	zval *oSrc;
	zval *oX;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!", &oSrc, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oG, TLInt_ce_ptr, &oX, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBElgamal_Sign((TLInt *)SBGetStructPointer(oSrc TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oG TSRMLS_CC), (TLInt *)SBGetStructPointer(oX TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBElgamal, Verify)
{
	zval *oA;
	zval *oB;
	zval *oG;
	zval *oP;
	zval *oSrc;
	zval *oY;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!", &oSrc, TLInt_ce_ptr, &oP, TLInt_ce_ptr, &oG, TLInt_ce_ptr, &oY, TLInt_ce_ptr, &oA, TLInt_ce_ptr, &oB, TLInt_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBElgamal_Verify((TLInt *)SBGetStructPointer(oSrc TSRMLS_CC), (TLInt *)SBGetStructPointer(oP TSRMLS_CC), (TLInt *)SBGetStructPointer(oG TSRMLS_CC), (TLInt *)SBGetStructPointer(oY TSRMLS_CC), (TLInt *)SBGetStructPointer(oA TSRMLS_CC), (TLInt *)SBGetStructPointer(oB TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TLInt, TLInt, TLInt, TLInt, TLInt)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBElgamal, EncodeResult)
{
	int32_t l4BlobSizeRaw;
	long l4RSize;
	long l4SSize;
	SBArrayZValInfo piBlob;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	zval *zl4BlobSize;
	zval *zpBlob;
	zval *zpR;
	zval *zpS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzz", &zpR, &l4RSize, &zpS, &l4SSize, &zpBlob, &zl4BlobSize) == SUCCESS) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4BlobSize) && (IS_LONG == Z_TYPE_P(zl4BlobSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		l4BlobSizeRaw = (int32_t)Z_LVAL_P(zl4BlobSize);
		SBCheckError(SBElgamal_EncodeResult(piR.data, (int32_t)l4RSize, piS.data, (int32_t)l4SSize, piBlob.data, &l4BlobSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piR);
		SBFreePointerZValInfo(&piS);
		SBFreePointerZValInfo(&piBlob);
		ZVAL_LONG(zl4BlobSize, (long)l4BlobSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBElgamal, DecodeResult)
{
	int32_t l4RSizeRaw;
	int32_t l4SSizeRaw;
	long l4Size;
	SBArrayZValInfo piBlob;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	zval *zl4RSize;
	zval *zl4SSize;
	zval *zpBlob;
	zval *zpR;
	zval *zpS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzz", &zpBlob, &l4Size, &zpR, &zl4RSize, &zpS, &zl4SSize) == SUCCESS) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4RSize) && (IS_LONG == Z_TYPE_P(zl4RSize)) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SSize) && (IS_LONG == Z_TYPE_P(zl4SSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		l4RSizeRaw = (int32_t)Z_LVAL_P(zl4RSize);
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		l4SSizeRaw = (int32_t)Z_LVAL_P(zl4SSize);
		SBCheckError(SBElgamal_DecodeResult(piBlob.data, (int32_t)l4Size, piR.data, &l4RSizeRaw, piS.data, &l4SSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBlob);
		SBFreePointerZValInfo(&piR);
		ZVAL_LONG(zl4RSize, (long)l4RSizeRaw);
		SBFreePointerZValInfo(&piS);
		ZVAL_LONG(zl4SSize, (long)l4SSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBElgamal, EncodePublicKey)
{
	int32_t l4OutSizeRaw;
	long l4GSize;
	long l4PSize;
	long l4YSize;
	SBArrayZValInfo piG;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piP;
	SBArrayZValInfo piY;
	zval *zl4OutSize;
	zval *zpG;
	zval *zpOutBuffer;
	zval *zpP;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzz", &zpP, &l4PSize, &zpG, &l4GSize, &zpY, &l4YSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBElgamal_EncodePublicKey(piP.data, (int32_t)l4PSize, piG.data, (int32_t)l4GSize, piY.data, (int32_t)l4YSize, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piY);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBElgamal, EncodePrivateKey)
{
	int32_t l4OutSizeRaw;
	long l4GSize;
	long l4PSize;
	long l4XSize;
	SBArrayZValInfo piG;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piP;
	SBArrayZValInfo piX;
	zval *zl4OutSize;
	zval *zpG;
	zval *zpOutBuffer;
	zval *zpP;
	zval *zpX;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzz", &zpP, &l4PSize, &zpG, &l4GSize, &zpX, &l4XSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpX) == IS_STRING) || (Z_TYPE_P(zpX) == IS_ARRAY) || (Z_TYPE_P(zpX) == IS_NULL) || ((Z_TYPE_P(zpX) == IS_OBJECT) && (Z_OBJCE_P(zpX) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpX, &piX TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBElgamal_EncodePrivateKey(piP.data, (int32_t)l4PSize, piG.data, (int32_t)l4GSize, piX.data, (int32_t)l4XSize, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piX);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

