#include "sbencstream.h"

zend_class_entry *TElChunkedEncryptingStream_ce_ptr = NULL;

SB_PHP_METHOD(TElChunkedEncryptingStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElChunkedEncryptingStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedEncryptingStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElChunkedEncryptingStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedEncryptingStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElChunkedEncryptingStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElChunkedEncryptingStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedEncryptingStream, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElChunkedEncryptingStream_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedEncryptingStream, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElChunkedEncryptingStream_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedEncryptingStream, get_HashResult)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElChunkedEncryptingStream_get_HashResult(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1577905369, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedEncryptingStream, get_SourceStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElChunkedEncryptingStream_get_SourceStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedEncryptingStream, get_Finalized)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElChunkedEncryptingStream_get_Finalized(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedEncryptingStream, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElChunkedEncryptingStream_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedEncryptingStream, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElChunkedEncryptingStream_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedEncryptingStream, get_OnHashResultAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElChunkedEncryptingStream_get_OnHashResultAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedEncryptingStream, set_OnHashResultAvailable)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElChunkedEncryptingStream_set_OnHashResultAvailable(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedEncryptingStream, __construct)
{
	long fMode;
	long l4Algorithm;
	long l8Count;
	long l8Offset;
	SBArrayZValInfo aiIV;
	SBArrayZValInfo aiKey;
	zend_bool bReleaseSourceStream;
	zval *oManager;
	zval *oSourceStream;
	zval *zaIV;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lzzlO!b", &oSourceStream, TStream_ce_ptr, &l4Algorithm, &zaKey, &zaIV, &l8Count, &oManager, TElCustomCryptoProviderManager_ce_ptr, &bReleaseSourceStream) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && ((IS_STRING == Z_TYPE_P(zaIV)) || (IS_ARRAY == Z_TYPE_P(zaIV)) || (IS_NULL == Z_TYPE_P(zaIV))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaIV, &aiIV TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElChunkedEncryptingStream_Create(SBGetObjectHandle(oSourceStream TSRMLS_CC), (int32_t)l4Algorithm, aiKey.data, aiKey.len, aiIV.data, aiIV.len, (int64_t)l8Count, SBGetObjectHandle(oManager TSRMLS_CC), (int8_t)bReleaseSourceStream, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBFreeArrayZValInfo(&aiIV);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzzlO!b", &oSourceStream, TStream_ce_ptr, &l4Algorithm, &fMode, &zaKey, &zaIV, &l8Count, &oManager, TElCustomCryptoProviderManager_ce_ptr, &bReleaseSourceStream) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && ((IS_STRING == Z_TYPE_P(zaIV)) || (IS_ARRAY == Z_TYPE_P(zaIV)) || (IS_NULL == Z_TYPE_P(zaIV))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaIV, &aiIV TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElChunkedEncryptingStream_Create_1(SBGetObjectHandle(oSourceStream TSRMLS_CC), (int32_t)l4Algorithm, (TSBSymmetricCryptoModeRaw)fMode, aiKey.data, aiKey.len, aiIV.data, aiIV.len, (int64_t)l8Count, SBGetObjectHandle(oManager TSRMLS_CC), (int8_t)bReleaseSourceStream, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBFreeArrayZValInfo(&aiIV);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzzllO!b", &oSourceStream, TStream_ce_ptr, &l4Algorithm, &fMode, &zaKey, &zaIV, &l8Offset, &l8Count, &oManager, TElCustomCryptoProviderManager_ce_ptr, &bReleaseSourceStream) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && ((IS_STRING == Z_TYPE_P(zaIV)) || (IS_ARRAY == Z_TYPE_P(zaIV)) || (IS_NULL == Z_TYPE_P(zaIV))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaIV, &aiIV TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElChunkedEncryptingStream_Create_2(SBGetObjectHandle(oSourceStream TSRMLS_CC), (int32_t)l4Algorithm, (TSBSymmetricCryptoModeRaw)fMode, aiKey.data, aiKey.len, aiIV.data, aiIV.len, (int64_t)l8Offset, (int64_t)l8Count, SBGetObjectHandle(oManager TSRMLS_CC), (int8_t)bReleaseSourceStream, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBFreeArrayZValInfo(&aiIV);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoProviderManager, bool) or (TStream, integer, integer, array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoProviderManager, bool) or (TStream, integer, integer, array of byte|string|NULL, array of byte|string|NULL, integer, integer, TElCustomCryptoProviderManager, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream_get_HashResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream_get_SourceStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream_get_Finalized, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream_get_OnHashResultAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream_set_OnHashResultAvailable, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedEncryptingStream___construct, 0, 0, 7)
	ZEND_ARG_OBJ_INFO(0, SourceStream, TStream, 1)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, IV_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Count_or_IV, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Manager_or_Count_or_Offset, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ReleaseSourceStream_or_Manager_or_Count, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ReleaseSourceStream_or_Manager, 0, 1)
	ZEND_ARG_INFO(0, ReleaseSourceStream)
ZEND_END_ARG_INFO()

static zend_function_entry TElChunkedEncryptingStream_methods[] = {
	PHP_ME(TElChunkedEncryptingStream, Read, arginfo_TElChunkedEncryptingStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedEncryptingStream, Write, arginfo_TElChunkedEncryptingStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedEncryptingStream, Seek, arginfo_TElChunkedEncryptingStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedEncryptingStream, get_HashAlgorithm, arginfo_TElChunkedEncryptingStream_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedEncryptingStream, set_HashAlgorithm, arginfo_TElChunkedEncryptingStream_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedEncryptingStream, get_HashResult, arginfo_TElChunkedEncryptingStream_get_HashResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedEncryptingStream, get_SourceStream, arginfo_TElChunkedEncryptingStream_get_SourceStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedEncryptingStream, get_Finalized, arginfo_TElChunkedEncryptingStream_get_Finalized, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedEncryptingStream, get_OnProgress, arginfo_TElChunkedEncryptingStream_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedEncryptingStream, set_OnProgress, arginfo_TElChunkedEncryptingStream_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedEncryptingStream, get_OnHashResultAvailable, arginfo_TElChunkedEncryptingStream_get_OnHashResultAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedEncryptingStream, set_OnHashResultAvailable, arginfo_TElChunkedEncryptingStream_set_OnHashResultAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedEncryptingStream, __construct, arginfo_TElChunkedEncryptingStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElChunkedEncryptingStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElChunkedEncryptingStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElChunkedEncryptingStream", TElChunkedEncryptingStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElChunkedEncryptingStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElChunkedDecryptingStream_ce_ptr = NULL;

SB_PHP_METHOD(TElChunkedDecryptingStream, FinalizeOutput)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElChunkedDecryptingStream_FinalizeOutput(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedDecryptingStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElChunkedDecryptingStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedDecryptingStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElChunkedDecryptingStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedDecryptingStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElChunkedDecryptingStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElChunkedDecryptingStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedDecryptingStream, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElChunkedDecryptingStream_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedDecryptingStream, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElChunkedDecryptingStream_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedDecryptingStream, get_HashResult)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElChunkedDecryptingStream_get_HashResult(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(742145809, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedDecryptingStream, get_ExpectFinalize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElChunkedDecryptingStream_get_ExpectFinalize(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedDecryptingStream, set_ExpectFinalize)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElChunkedDecryptingStream_set_ExpectFinalize(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedDecryptingStream, get_DestStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElChunkedDecryptingStream_get_DestStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedDecryptingStream, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElChunkedDecryptingStream_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedDecryptingStream, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElChunkedDecryptingStream_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElChunkedDecryptingStream, __construct)
{
	long fMode;
	long l4Algorithm;
	long l8Count;
	long l8Offset;
	SBArrayZValInfo aiIV;
	SBArrayZValInfo aiKey;
	zend_bool bReleaseDestStream;
	zval *oDestStream;
	zval *oManager;
	zval *zaIV;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lzzlO!b", &oDestStream, TStream_ce_ptr, &l4Algorithm, &zaKey, &zaIV, &l8Count, &oManager, TElCustomCryptoProviderManager_ce_ptr, &bReleaseDestStream) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && ((IS_STRING == Z_TYPE_P(zaIV)) || (IS_ARRAY == Z_TYPE_P(zaIV)) || (IS_NULL == Z_TYPE_P(zaIV))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaIV, &aiIV TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElChunkedDecryptingStream_Create(SBGetObjectHandle(oDestStream TSRMLS_CC), (int32_t)l4Algorithm, aiKey.data, aiKey.len, aiIV.data, aiIV.len, (int64_t)l8Count, SBGetObjectHandle(oManager TSRMLS_CC), (int8_t)bReleaseDestStream, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBFreeArrayZValInfo(&aiIV);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzzlO!b", &oDestStream, TStream_ce_ptr, &l4Algorithm, &fMode, &zaKey, &zaIV, &l8Count, &oManager, TElCustomCryptoProviderManager_ce_ptr, &bReleaseDestStream) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && ((IS_STRING == Z_TYPE_P(zaIV)) || (IS_ARRAY == Z_TYPE_P(zaIV)) || (IS_NULL == Z_TYPE_P(zaIV))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaIV, &aiIV TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElChunkedDecryptingStream_Create_1(SBGetObjectHandle(oDestStream TSRMLS_CC), (int32_t)l4Algorithm, (TSBSymmetricCryptoModeRaw)fMode, aiKey.data, aiKey.len, aiIV.data, aiIV.len, (int64_t)l8Count, SBGetObjectHandle(oManager TSRMLS_CC), (int8_t)bReleaseDestStream, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBFreeArrayZValInfo(&aiIV);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzzllO!b", &oDestStream, TStream_ce_ptr, &l4Algorithm, &fMode, &zaKey, &zaIV, &l8Offset, &l8Count, &oManager, TElCustomCryptoProviderManager_ce_ptr, &bReleaseDestStream) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && ((IS_STRING == Z_TYPE_P(zaIV)) || (IS_ARRAY == Z_TYPE_P(zaIV)) || (IS_NULL == Z_TYPE_P(zaIV))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaIV, &aiIV TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElChunkedDecryptingStream_Create_2(SBGetObjectHandle(oDestStream TSRMLS_CC), (int32_t)l4Algorithm, (TSBSymmetricCryptoModeRaw)fMode, aiKey.data, aiKey.len, aiIV.data, aiIV.len, (int64_t)l8Offset, (int64_t)l8Count, SBGetObjectHandle(oManager TSRMLS_CC), (int8_t)bReleaseDestStream, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBFreeArrayZValInfo(&aiIV);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoProviderManager, bool) or (TStream, integer, integer, array of byte|string|NULL, array of byte|string|NULL, integer, TElCustomCryptoProviderManager, bool) or (TStream, integer, integer, array of byte|string|NULL, array of byte|string|NULL, integer, integer, TElCustomCryptoProviderManager, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream_FinalizeOutput, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream_get_HashResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream_get_ExpectFinalize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream_set_ExpectFinalize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream_get_DestStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElChunkedDecryptingStream___construct, 0, 0, 7)
	ZEND_ARG_OBJ_INFO(0, DestStream, TStream, 1)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_TYPE_INFO(0, Key_or_Mode, 0, 1)
	ZEND_ARG_TYPE_INFO(0, IV_or_Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Count_or_IV, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Manager_or_Count_or_Offset, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ReleaseDestStream_or_Manager_or_Count, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ReleaseDestStream_or_Manager, 0, 1)
	ZEND_ARG_INFO(0, ReleaseDestStream)
ZEND_END_ARG_INFO()

static zend_function_entry TElChunkedDecryptingStream_methods[] = {
	PHP_ME(TElChunkedDecryptingStream, FinalizeOutput, arginfo_TElChunkedDecryptingStream_FinalizeOutput, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedDecryptingStream, Read, arginfo_TElChunkedDecryptingStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedDecryptingStream, Write, arginfo_TElChunkedDecryptingStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedDecryptingStream, Seek, arginfo_TElChunkedDecryptingStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedDecryptingStream, get_HashAlgorithm, arginfo_TElChunkedDecryptingStream_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedDecryptingStream, set_HashAlgorithm, arginfo_TElChunkedDecryptingStream_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedDecryptingStream, get_HashResult, arginfo_TElChunkedDecryptingStream_get_HashResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedDecryptingStream, get_ExpectFinalize, arginfo_TElChunkedDecryptingStream_get_ExpectFinalize, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedDecryptingStream, set_ExpectFinalize, arginfo_TElChunkedDecryptingStream_set_ExpectFinalize, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedDecryptingStream, get_DestStream, arginfo_TElChunkedDecryptingStream_get_DestStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedDecryptingStream, get_OnProgress, arginfo_TElChunkedDecryptingStream_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedDecryptingStream, set_OnProgress, arginfo_TElChunkedDecryptingStream_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElChunkedDecryptingStream, __construct, arginfo_TElChunkedDecryptingStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElChunkedDecryptingStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElChunkedDecryptingStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElChunkedDecryptingStream", TElChunkedDecryptingStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElChunkedDecryptingStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

