#include "sbidea.h"

SB_PHP_METHOD(TIDEAKey, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TIDEAKey));
		intern->len = sizeof(TIDEAKey);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TIDEAKey, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TIDEAKey));
}

zend_class_entry *TIDEAKey_ce_ptr = NULL;

static zend_function_entry TIDEAKey_methods[] = {
	PHP_ME(TIDEAKey, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TIDEAKey, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TIDEAKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TIDEAKey_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TIDEAKey", TIDEAKey_methods);
	TIDEAKey_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TIDEAExpandedKey, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TIDEAExpandedKey));
		intern->len = sizeof(TIDEAExpandedKey);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TIDEAExpandedKey, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TIDEAExpandedKey));
}

zend_class_entry *TIDEAExpandedKey_ce_ptr = NULL;

static zend_function_entry TIDEAExpandedKey_methods[] = {
	PHP_ME(TIDEAExpandedKey, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TIDEAExpandedKey, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TIDEAExpandedKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TIDEAExpandedKey_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TIDEAExpandedKey", TIDEAExpandedKey_methods);
	TIDEAExpandedKey_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBIDEA, ExpandKeyForEncryption)
{
	zval *oExpandedKey;
	zval *oKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oKey, TIDEAKey_ce_ptr, &oExpandedKey, TIDEAExpandedKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oExpandedKey))
	{
		SBCheckError(SBIDEA_ExpandKeyForEncryption((TIDEAKey *)SBGetStructPointer(oKey TSRMLS_CC), (TIDEAExpandedKey *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TIDEAKey, &TIDEAExpandedKey)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBIDEA, ExpandKeyForDecryption)
{
	zval *oCipherKey;
	zval *oDecipherKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oCipherKey, TIDEAExpandedKey_ce_ptr, &oDecipherKey, TIDEAExpandedKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oDecipherKey))
	{
		SBCheckError(SBIDEA_ExpandKeyForDecryption((TIDEAExpandedKey *)SBGetStructPointer(oCipherKey TSRMLS_CC), (TIDEAExpandedKey *)SBGetStructPointer(oDecipherKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TIDEAExpandedKey, &TIDEAExpandedKey)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBIDEA, Encrypt)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	zval *oKey;
	zval *zu4B0;
	zval *zu4B1;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzO", &zu4B0, &zu4B1, &oKey, TIDEAExpandedKey_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		SBCheckError(SBIDEA_Encrypt(&u4B0Raw, &u4B1Raw, (TIDEAExpandedKey *)SBGetStructPointer(oKey TSRMLS_CC)) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer, &integer, TIDEAExpandedKey)" TSRMLS_CC);
	}
}

void Register_SBIDEA_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBIDEA, TIDEAExpandedKeySize, SB_TIDEAExpandedKeySize, SB_TIDEAExpandedKeySize);
}

