#include "sbldapsclient.h"

zend_class_entry *TSBLDAPAuthenticationType_ce_ptr = NULL;

zend_class_entry *TSBLDAPSEquality_ce_ptr = NULL;

zend_class_entry *TSBLDAPSLogicalOperator_ce_ptr = NULL;

zend_class_entry *TElLDAPSSearchFilter_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPSSearchFilter, ToString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPSSearchFilter_ToString(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(63601799, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSSearchFilter, AddCondition)
{
	char *sAttribute;
	char *sValue;
	int sAttribute_len;
	int sValue_len;
	long fEquality;
	long fLogicalOperator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsls", &fLogicalOperator, &sAttribute, &sAttribute_len, &fEquality, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElLDAPSSearchFilter_AddCondition(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBLDAPSLogicalOperatorRaw)fLogicalOperator, sAttribute, (int32_t)sAttribute_len, (TSBLDAPSEqualityRaw)fEquality, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSSearchFilter, get_IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPSSearchFilter_get_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSSearchFilter, __construct)
{
	char *sAttribute;
	char *sValue;
	int sAttribute_len;
	int sValue_len;
	long fEquality;
	long fLogicalOperator;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSSearchFilter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsls", &fLogicalOperator, &sAttribute, &sAttribute_len, &fEquality, &sValue, &sValue_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSSearchFilter_Create_1((TSBLDAPSLogicalOperatorRaw)fLogicalOperator, sAttribute, (int32_t)sAttribute_len, (TSBLDAPSEqualityRaw)fEquality, sValue, (int32_t)sValue_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer, string, integer, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSSearchFilter_ToString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSSearchFilter_AddCondition, 0, 0, 4)
	ZEND_ARG_INFO(0, LogicalOperator)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Equality)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSSearchFilter_get_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSSearchFilter___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, LogicalOperator)
	ZEND_ARG_INFO(0, Attribute)
	ZEND_ARG_INFO(0, Equality)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPSSearchFilter_methods[] = {
	PHP_ME(TElLDAPSSearchFilter, ToString, arginfo_TElLDAPSSearchFilter_ToString, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSSearchFilter, AddCondition, arginfo_TElLDAPSSearchFilter_AddCondition, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSSearchFilter, get_IsEmpty, arginfo_TElLDAPSSearchFilter_get_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSSearchFilter, __construct, arginfo_TElLDAPSSearchFilter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPSSearchFilter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPSSearchFilter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPSSearchFilter", TElLDAPSSearchFilter_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElLDAPSSearchFilter_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPResponse_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPResponse, Add)
{
	TElClassHandle hoMsg;
	zval *oMsg;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oMsg, TElLDAPMessage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oMsg) && (IS_OBJECT == Z_TYPE_P(oMsg)))
	{
		hoMsg = SBGetObjectHandle(oMsg TSRMLS_CC);
		SBCheckError(TElLDAPResponse_Add(SBGetObjectHandle(getThis() TSRMLS_CC), &hoMsg) TSRMLS_CC);
		SBUpdateObjectHandle(oMsg, hoMsg TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElLDAPMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResponse, Remove)
{
	TElClassHandle hoMsg;
	zval *oMsg;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oMsg, TElLDAPMessage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oMsg) && (IS_OBJECT == Z_TYPE_P(oMsg)))
	{
		hoMsg = SBGetObjectHandle(oMsg TSRMLS_CC);
		SBCheckError(TElLDAPResponse_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), &hoMsg) TSRMLS_CC);
		SBUpdateObjectHandle(oMsg, hoMsg TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElLDAPMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResponse, get_Messages)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPResponse_get_Messages(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResponse, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElLDAPResponse_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResponse, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPResponse_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResponse_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Msg, TElLDAPMessage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResponse_Remove, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Msg, TElLDAPMessage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResponse_get_Messages, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResponse_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResponse___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPResponse_methods[] = {
	PHP_ME(TElLDAPResponse, Add, arginfo_TElLDAPResponse_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResponse, Remove, arginfo_TElLDAPResponse_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResponse, get_Messages, arginfo_TElLDAPResponse_get_Messages, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResponse, get_Count, arginfo_TElLDAPResponse_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResponse, __construct, arginfo_TElLDAPResponse___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPResponse(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPResponse_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPResponse", TElLDAPResponse_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElLDAPResponse_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPURL_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPURL, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPURL_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-483263983, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPURL, get_Host)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPURL_get_Host(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-349866096, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPURL, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElLDAPURL_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPURL, get_DN)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPURL_get_DN(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(355040411, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPURL, get_Attributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPURL_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPURL, get_Scope)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBLDAPScopeRaw fOutResultRaw = 0;
		SBCheckError(TElLDAPURL_get_Scope(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPURL, get_Filter)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPURL_get_Filter(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1533945525, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPURL, get_Extensions)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPURL_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(698865332, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPURL, __construct)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPURL_Create(sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPURL_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPURL_get_Host, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPURL_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPURL_get_DN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPURL_get_Attributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPURL_get_Scope, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPURL_get_Filter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPURL_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPURL___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPURL_methods[] = {
	PHP_ME(TElLDAPURL, get_URL, arginfo_TElLDAPURL_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPURL, get_Host, arginfo_TElLDAPURL_get_Host, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPURL, get_Port, arginfo_TElLDAPURL_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPURL, get_DN, arginfo_TElLDAPURL_get_DN, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPURL, get_Attributes, arginfo_TElLDAPURL_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPURL, get_Scope, arginfo_TElLDAPURL_get_Scope, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPURL, get_Filter, arginfo_TElLDAPURL_get_Filter, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPURL, get_Extensions, arginfo_TElLDAPURL_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPURL, __construct, arginfo_TElLDAPURL___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPURL(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPURL_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPURL", TElLDAPURL_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElLDAPURL_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPSClient_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPSClient, Bind)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_Bind(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, Unbind)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_Unbind(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, Search)
{
	char *sBaseDN;
	char *sFilter;
	int sBaseDN_len;
	int sFilter_len;
	long fScope;
	zend_bool bAttrsOnly;
	zval *oAttrs;
	zval *oFilter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slsO!b", &sBaseDN, &sBaseDN_len, &fScope, &sFilter, &sFilter_len, &oAttrs, TStringList_ce_ptr, &bAttrsOnly) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSClient_Search(SBGetObjectHandle(getThis() TSRMLS_CC), sBaseDN, (int32_t)sBaseDN_len, (TSBLDAPScopeRaw)fScope, sFilter, (int32_t)sFilter_len, SBGetObjectHandle(oAttrs TSRMLS_CC), (int8_t)bAttrsOnly, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!O!b", &sBaseDN, &sBaseDN_len, &fScope, &oFilter, TElLDAPSSearchFilter_ce_ptr, &oAttrs, TStringList_ce_ptr, &bAttrsOnly) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSClient_Search_1(SBGetObjectHandle(getThis() TSRMLS_CC), sBaseDN, (int32_t)sBaseDN_len, (TSBLDAPScopeRaw)fScope, SBGetObjectHandle(oFilter TSRMLS_CC), SBGetObjectHandle(oAttrs TSRMLS_CC), (int8_t)bAttrsOnly, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSClient_Search_2(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, string, TStringList, bool) or (string, integer, TElLDAPSSearchFilter, TStringList, bool) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, SearchURL_Inst)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSClient_SearchURL_1(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, SearchURL)
{
	char *sURL;
	int sURL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSClient_SearchURL(sURL, (int32_t)sURL_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, Remove)
{
	char *sDN;
	int sDN_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDN, &sDN_len) == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), sDN, (int32_t)sDN_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, Add)
{
	char *sDN;
	int sDN_len;
	SBArrayZValInfo aiAttrs;
	zval *zaAttrs;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sDN, &sDN_len, &zaAttrs, TElLDAPPartialAttribute_ce_ptr) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaAttrs)) || (IS_NULL == Z_TYPE_P(zaAttrs))))
	{
		if (!SBGetObjectArrayFromZVal(zaAttrs, TElLDAPPartialAttribute_ce_ptr, &aiAttrs TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElLDAPSClient_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sDN, (int32_t)sDN_len, aiAttrs.data, aiAttrs.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAttrs);
	}
	else
	{
		SBErrorExpectsArguments("(string, &array of TElLDAPPartialAttribute|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, Modify)
{
	char *sDN;
	int sDN_len;
	SBArrayZValInfo aiAttrs;
	zval *zaAttrs;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sDN, &sDN_len, &zaAttrs, TElLDAPPartialAttribute_ce_ptr) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaAttrs)) || (IS_NULL == Z_TYPE_P(zaAttrs))))
	{
		if (!SBGetObjectArrayFromZVal(zaAttrs, TElLDAPPartialAttribute_ce_ptr, &aiAttrs TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElLDAPSClient_Modify(SBGetObjectHandle(getThis() TSRMLS_CC), sDN, (int32_t)sDN_len, aiAttrs.data, aiAttrs.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAttrs);
	}
	else
	{
		SBErrorExpectsArguments("(string, &array of TElLDAPPartialAttribute|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, get_ReceiveTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElLDAPSClient_get_ReceiveTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, set_ReceiveTimeout)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_set_ReceiveTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, get_LDAPDN)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPSClient_get_LDAPDN(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-167696367, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, set_LDAPDN)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_set_LDAPDN(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, get_Password)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPSClient_get_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1813415573, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, set_Password)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_set_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, get_AuthType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBLDAPAuthenticationTypeRaw fOutResultRaw = 0;
		SBCheckError(TElLDAPSClient_get_AuthType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, set_AuthType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_set_AuthType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBLDAPAuthenticationTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, get_SASLMechanism)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPSClient_get_SASLMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(756900575, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, set_SASLMechanism)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_set_SASLMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, get_BaseDN)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPSClient_get_BaseDN(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1112998332, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, set_BaseDN)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_set_BaseDN(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, get_Scope)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBLDAPScopeRaw fOutResultRaw = 0;
		SBCheckError(TElLDAPSClient_get_Scope(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, set_Scope)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_set_Scope(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBLDAPScopeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, get_Filter)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPSClient_get_Filter(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1608052615, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, set_Filter)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_set_Filter(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, get_Attributes)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPSClient_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1134394193, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, set_Attributes)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_set_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, get_AttributesOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPSClient_get_AttributesOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, set_AttributesOnly)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElLDAPSClient_set_AttributesOnly(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_Bind, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_Unbind, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_Search, 0, 0, 0)
	ZEND_ARG_INFO(1, BaseDN)
	ZEND_ARG_INFO(0, Scope)
	ZEND_ARG_TYPE_INFO(0, Filter, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attrs, TStringList, 1)
	ZEND_ARG_INFO(0, AttrsOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_SearchURL_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_SearchURL, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_Remove, 0, 0, 1)
	ZEND_ARG_INFO(0, DN)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_Add, 0, 0, 2)
	ZEND_ARG_INFO(0, DN)
	ZEND_ARG_ARRAY_INFO(0, Attrs, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_Modify, 0, 0, 2)
	ZEND_ARG_INFO(0, DN)
	ZEND_ARG_ARRAY_INFO(0, Attrs, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_get_ReceiveTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_set_ReceiveTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_get_LDAPDN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_set_LDAPDN, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_get_Password, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_set_Password, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_get_AuthType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_set_AuthType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_get_SASLMechanism, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_set_SASLMechanism, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_get_BaseDN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_set_BaseDN, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_get_Scope, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_set_Scope, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_get_Filter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_set_Filter, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_get_Attributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_set_Attributes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_get_AttributesOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient_set_AttributesOnly, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPSClient_methods[] = {
	PHP_ME(TElLDAPSClient, Bind, arginfo_TElLDAPSClient_Bind, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, Unbind, arginfo_TElLDAPSClient_Unbind, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, Search, arginfo_TElLDAPSClient_Search, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, SearchURL_Inst, arginfo_TElLDAPSClient_SearchURL_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, SearchURL, arginfo_TElLDAPSClient_SearchURL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElLDAPSClient, Remove, arginfo_TElLDAPSClient_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, Add, arginfo_TElLDAPSClient_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, Modify, arginfo_TElLDAPSClient_Modify, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, get_ReceiveTimeout, arginfo_TElLDAPSClient_get_ReceiveTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, set_ReceiveTimeout, arginfo_TElLDAPSClient_set_ReceiveTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, get_LDAPDN, arginfo_TElLDAPSClient_get_LDAPDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, set_LDAPDN, arginfo_TElLDAPSClient_set_LDAPDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, get_Password, arginfo_TElLDAPSClient_get_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, set_Password, arginfo_TElLDAPSClient_set_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, get_AuthType, arginfo_TElLDAPSClient_get_AuthType, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, set_AuthType, arginfo_TElLDAPSClient_set_AuthType, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, get_SASLMechanism, arginfo_TElLDAPSClient_get_SASLMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, set_SASLMechanism, arginfo_TElLDAPSClient_set_SASLMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, get_BaseDN, arginfo_TElLDAPSClient_get_BaseDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, set_BaseDN, arginfo_TElLDAPSClient_set_BaseDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, get_Scope, arginfo_TElLDAPSClient_get_Scope, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, set_Scope, arginfo_TElLDAPSClient_set_Scope, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, get_Filter, arginfo_TElLDAPSClient_get_Filter, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, set_Filter, arginfo_TElLDAPSClient_set_Filter, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, get_Attributes, arginfo_TElLDAPSClient_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, set_Attributes, arginfo_TElLDAPSClient_set_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, get_AttributesOnly, arginfo_TElLDAPSClient_get_AttributesOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, set_AttributesOnly, arginfo_TElLDAPSClient_set_AttributesOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSClient, __construct, arginfo_TElLDAPSClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPSClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPSClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPSClient", TElLDAPSClient_methods);
	if (NULL == TElSimpleSSLClient_ce_ptr)
		Register_TElSimpleSSLClient(TSRMLS_C);
	TElLDAPSClient_ce_ptr = zend_register_internal_class_ex(&ce, TElSimpleSSLClient_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBLDAPSClient_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBLDAPSClient, SB_LDAP_PORT, SB_LDAP_PORT, SB_LDAP_PORT);
}

void Register_SBLDAPSClient_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBLDAPAuthenticationType", NULL);
	TSBLDAPAuthenticationType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBLDAPAuthenticationType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPAuthenticationType_ce_ptr, "autSimple", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPAuthenticationType_ce_ptr, "autSASL", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBLDAPSEquality", NULL);
	TSBLDAPSEquality_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBLDAPSEquality_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSEquality_ce_ptr, "leEqual", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSEquality_ce_ptr, "leNotEqual", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSEquality_ce_ptr, "leAny", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSEquality_ce_ptr, "leContains", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSEquality_ce_ptr, "leDoesNotContain", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSEquality_ce_ptr, "leLessOrEqual", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSEquality_ce_ptr, "leGreaterOrEqual", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSEquality_ce_ptr, "leApproximately", 7)
	
	INIT_CLASS_ENTRY(ce, "TSBLDAPSLogicalOperator", NULL);
	TSBLDAPSLogicalOperator_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBLDAPSLogicalOperator_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSLogicalOperator_ce_ptr, "loAnd", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPSLogicalOperator_ce_ptr, "loOr", 1)
}

void Register_SBLDAPSClient_Aliases(TSRMLS_D)
{
	if (NULL == TElLDAPSSearchFilter_ce_ptr)
		Register_TElLDAPSSearchFilter(TSRMLS_C);
	zend_register_class_alias("ElLDAPSSearchFilter", TElLDAPSSearchFilter_ce_ptr);
	if (NULL == TElLDAPResponse_ce_ptr)
		Register_TElLDAPResponse(TSRMLS_C);
	zend_register_class_alias("ElLDAPResponse", TElLDAPResponse_ce_ptr);
	if (NULL == TElLDAPURL_ce_ptr)
		Register_TElLDAPURL(TSRMLS_C);
	zend_register_class_alias("ElLDAPURL", TElLDAPURL_ce_ptr);
	if (NULL == TElLDAPSClient_ce_ptr)
		Register_TElLDAPSClient(TSRMLS_C);
	zend_register_class_alias("ElLDAPSClient", TElLDAPSClient_ce_ptr);
}
