#include "sbldapscore.h"

zend_class_entry *TSBLDAPScope_ce_ptr = NULL;

zend_class_entry *TSBLDAPModifyOperation_ce_ptr = NULL;

zend_class_entry *TElLDAPMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPMessage, SaveToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuf;
	zval *zl4Size;
	zval *zpBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuf, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElLDAPMessage_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuf.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPMessage, get_Code)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElLDAPMessage_get_Code(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPMessage, get_ID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElLDAPMessage_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPMessage, __construct)
{
	long l4Code;
	long l4MessageID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPMessage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4MessageID, &l4Code) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPMessage_Create_1((int32_t)l4MessageID, (int32_t)l4Code, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPMessage_SaveToBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPMessage_get_Code, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPMessage_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPMessage___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, MessageID)
	ZEND_ARG_INFO(0, Code)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPMessage_methods[] = {
	PHP_ME(TElLDAPMessage, SaveToBuffer, arginfo_TElLDAPMessage_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPMessage, get_Code, arginfo_TElLDAPMessage_get_Code, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPMessage, get_ID, arginfo_TElLDAPMessage_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPMessage, __construct, arginfo_TElLDAPMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPMessage", TElLDAPMessage_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElLDAPMessage_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPSimpleBindMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPSimpleBindMessage, __construct)
{
	char *sLDAPDN;
	char *sPassword;
	int sLDAPDN_len;
	int sPassword_len;
	long l4MessageID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lss", &l4MessageID, &sLDAPDN, &sLDAPDN_len, &sPassword, &sPassword_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSimpleBindMessage_Create((int32_t)l4MessageID, sLDAPDN, (int32_t)sLDAPDN_len, sPassword, (int32_t)sPassword_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSimpleBindMessage___construct, 0, 0, 3)
	ZEND_ARG_INFO(0, MessageID)
	ZEND_ARG_INFO(0, LDAPDN)
	ZEND_ARG_INFO(0, Password)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPSimpleBindMessage_methods[] = {
	PHP_ME(TElLDAPSimpleBindMessage, __construct, arginfo_TElLDAPSimpleBindMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPSimpleBindMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPSimpleBindMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPSimpleBindMessage", TElLDAPSimpleBindMessage_methods);
	if (NULL == TElLDAPMessage_ce_ptr)
		Register_TElLDAPMessage(TSRMLS_C);
	TElLDAPSimpleBindMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElLDAPMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPSASLBindMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPSASLBindMessage, __construct)
{
	char *sLDAPDN;
	char *sMechanism;
	char *sPassword;
	int sLDAPDN_len;
	int sMechanism_len;
	int sPassword_len;
	long l4CredLen;
	long l4MessageID;
	SBArrayZValInfo aiCredentials;
	zval *zaCredentials;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lssszl", &l4MessageID, &sLDAPDN, &sLDAPDN_len, &sPassword, &sPassword_len, &sMechanism, &sMechanism_len, &zaCredentials, &l4CredLen) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaCredentials)) || (IS_ARRAY == Z_TYPE_P(zaCredentials)) || (IS_NULL == Z_TYPE_P(zaCredentials))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaCredentials, &aiCredentials TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElLDAPSASLBindMessage_Create((int32_t)l4MessageID, sLDAPDN, (int32_t)sLDAPDN_len, sPassword, (int32_t)sPassword_len, sMechanism, (int32_t)sMechanism_len, aiCredentials.data, aiCredentials.len, (int32_t)l4CredLen, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiCredentials);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, string, string, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSASLBindMessage___construct, 0, 0, 6)
	ZEND_ARG_INFO(0, MessageID)
	ZEND_ARG_INFO(0, LDAPDN)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_INFO(0, Mechanism)
	ZEND_ARG_TYPE_INFO(0, Credentials, 0, 1)
	ZEND_ARG_INFO(0, CredLen)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPSASLBindMessage_methods[] = {
	PHP_ME(TElLDAPSASLBindMessage, __construct, arginfo_TElLDAPSASLBindMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPSASLBindMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPSASLBindMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPSASLBindMessage", TElLDAPSASLBindMessage_methods);
	if (NULL == TElLDAPMessage_ce_ptr)
		Register_TElLDAPMessage(TSRMLS_C);
	TElLDAPSASLBindMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElLDAPMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPUnbindMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPUnbindMessage, __construct)
{
	long l4MessageID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4MessageID) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPUnbindMessage_Create((int32_t)l4MessageID, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPUnbindMessage___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, MessageID)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPUnbindMessage_methods[] = {
	PHP_ME(TElLDAPUnbindMessage, __construct, arginfo_TElLDAPUnbindMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPUnbindMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPUnbindMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPUnbindMessage", TElLDAPUnbindMessage_methods);
	if (NULL == TElLDAPMessage_ce_ptr)
		Register_TElLDAPMessage(TSRMLS_C);
	TElLDAPUnbindMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElLDAPMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPResult_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPResult, get_ResultCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElLDAPResult_get_ResultCode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResult, get_MatchedDN)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPResult_get_MatchedDN(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(335939101, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResult, get_DiagnosticMessage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPResult_get_DiagnosticMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1120898225, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResult, get_Referal)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPResult_get_Referal(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResult, get_HasReferal)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPResult_get_HasReferal(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResult, get_Success)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPResult_get_Success(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResult, __construct)
{
	TElClassHandle hoTag;
	zval *oTag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oTag, TElASN1ConstrainedTag_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oTag) && (IS_OBJECT == Z_TYPE_P(oTag)))
	{
		TElClassHandle hoOutResult = NULL;
		hoTag = SBGetObjectHandle(oTag TSRMLS_CC);
		SBCheckError(TElLDAPResult_Create(&hoTag, &hoOutResult) TSRMLS_CC);
		SBUpdateObjectHandle(oTag, hoTag TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElASN1ConstrainedTag)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResult_get_ResultCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResult_get_MatchedDN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResult_get_DiagnosticMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResult_get_Referal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResult_get_HasReferal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResult_get_Success, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResult___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Tag, TElASN1ConstrainedTag, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPResult_methods[] = {
	PHP_ME(TElLDAPResult, get_ResultCode, arginfo_TElLDAPResult_get_ResultCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResult, get_MatchedDN, arginfo_TElLDAPResult_get_MatchedDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResult, get_DiagnosticMessage, arginfo_TElLDAPResult_get_DiagnosticMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResult, get_Referal, arginfo_TElLDAPResult_get_Referal, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResult, get_HasReferal, arginfo_TElLDAPResult_get_HasReferal, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResult, get_Success, arginfo_TElLDAPResult_get_Success, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResult, __construct, arginfo_TElLDAPResult___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPResult(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPResult_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPResult", TElLDAPResult_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElLDAPResult_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPResultMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPResultMessage, get_ResultCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElLDAPResultMessage_get_ResultCode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResultMessage, get_MatchedDN)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPResultMessage_get_MatchedDN(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1914530973, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResultMessage, get_DiagnosticMessage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPResultMessage_get_DiagnosticMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(388385405, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResultMessage, get_Referal)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPResultMessage_get_Referal(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResultMessage, get_HasReferal)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPResultMessage_get_HasReferal(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResultMessage, get_Success)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPResultMessage_get_Success(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPResultMessage, __construct)
{
	long l4Size;
	SBArrayZValInfo piBuf;
	zval *zpBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuf, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElLDAPResultMessage_Create(piBuf.data, (int32_t)l4Size, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResultMessage_get_ResultCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResultMessage_get_MatchedDN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResultMessage_get_DiagnosticMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResultMessage_get_Referal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResultMessage_get_HasReferal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResultMessage_get_Success, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPResultMessage___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPResultMessage_methods[] = {
	PHP_ME(TElLDAPResultMessage, get_ResultCode, arginfo_TElLDAPResultMessage_get_ResultCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResultMessage, get_MatchedDN, arginfo_TElLDAPResultMessage_get_MatchedDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResultMessage, get_DiagnosticMessage, arginfo_TElLDAPResultMessage_get_DiagnosticMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResultMessage, get_Referal, arginfo_TElLDAPResultMessage_get_Referal, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResultMessage, get_HasReferal, arginfo_TElLDAPResultMessage_get_HasReferal, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResultMessage, get_Success, arginfo_TElLDAPResultMessage_get_Success, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPResultMessage, __construct, arginfo_TElLDAPResultMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPResultMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPResultMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPResultMessage", TElLDAPResultMessage_methods);
	if (NULL == TElLDAPMessage_ce_ptr)
		Register_TElLDAPMessage(TSRMLS_C);
	TElLDAPResultMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElLDAPMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPBindResponseMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPBindResponseMessage, get_ResultCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElLDAPBindResponseMessage_get_ResultCode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPBindResponseMessage, get_MatchedDN)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPBindResponseMessage_get_MatchedDN(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(833661266, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPBindResponseMessage, get_DiagnosticMessage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPBindResponseMessage_get_DiagnosticMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-970739861, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPBindResponseMessage, get_Referal)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPBindResponseMessage_get_Referal(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPBindResponseMessage, get_HasReferal)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPBindResponseMessage_get_HasReferal(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPBindResponseMessage, get_Success)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPBindResponseMessage_get_Success(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPBindResponseMessage, get_ServerSaslCreds)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPBindResponseMessage_get_ServerSaslCreds(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1693513638, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPBindResponseMessage, __construct)
{
	long l4Size;
	SBArrayZValInfo piBuf;
	zval *zpBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuf, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElLDAPBindResponseMessage_Create(piBuf.data, (int32_t)l4Size, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPBindResponseMessage_get_ResultCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPBindResponseMessage_get_MatchedDN, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPBindResponseMessage_get_DiagnosticMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPBindResponseMessage_get_Referal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPBindResponseMessage_get_HasReferal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPBindResponseMessage_get_Success, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPBindResponseMessage_get_ServerSaslCreds, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPBindResponseMessage___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPBindResponseMessage_methods[] = {
	PHP_ME(TElLDAPBindResponseMessage, get_ResultCode, arginfo_TElLDAPBindResponseMessage_get_ResultCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPBindResponseMessage, get_MatchedDN, arginfo_TElLDAPBindResponseMessage_get_MatchedDN, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPBindResponseMessage, get_DiagnosticMessage, arginfo_TElLDAPBindResponseMessage_get_DiagnosticMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPBindResponseMessage, get_Referal, arginfo_TElLDAPBindResponseMessage_get_Referal, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPBindResponseMessage, get_HasReferal, arginfo_TElLDAPBindResponseMessage_get_HasReferal, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPBindResponseMessage, get_Success, arginfo_TElLDAPBindResponseMessage_get_Success, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPBindResponseMessage, get_ServerSaslCreds, arginfo_TElLDAPBindResponseMessage_get_ServerSaslCreds, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPBindResponseMessage, __construct, arginfo_TElLDAPBindResponseMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPBindResponseMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPBindResponseMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPBindResponseMessage", TElLDAPBindResponseMessage_methods);
	if (NULL == TElLDAPMessage_ce_ptr)
		Register_TElLDAPMessage(TSRMLS_C);
	TElLDAPBindResponseMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElLDAPMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPSearchMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPSearchMessage, __construct)
{
	char *sBaseDN;
	char *sFilter;
	int sBaseDN_len;
	int sFilter_len;
	long fScope;
	long l4MessageID;
	zend_bool bAttrsOnly;
	zval *oAttrs;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lslsO!b", &l4MessageID, &sBaseDN, &sBaseDN_len, &fScope, &sFilter, &sFilter_len, &oAttrs, TStringList_ce_ptr, &bAttrsOnly) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSearchMessage_Create((int32_t)l4MessageID, sBaseDN, (int32_t)sBaseDN_len, (TSBLDAPScopeRaw)fScope, sFilter, (int32_t)sFilter_len, SBGetObjectHandle(oAttrs TSRMLS_CC), (int8_t)bAttrsOnly, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, integer, string, TStringList, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSearchMessage___construct, 0, 0, 6)
	ZEND_ARG_INFO(0, MessageID)
	ZEND_ARG_INFO(0, BaseDN)
	ZEND_ARG_INFO(0, Scope)
	ZEND_ARG_INFO(0, Filter)
	ZEND_ARG_OBJ_INFO(0, Attrs, TStringList, 1)
	ZEND_ARG_INFO(0, AttrsOnly)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPSearchMessage_methods[] = {
	PHP_ME(TElLDAPSearchMessage, __construct, arginfo_TElLDAPSearchMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPSearchMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPSearchMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPSearchMessage", TElLDAPSearchMessage_methods);
	if (NULL == TElLDAPMessage_ce_ptr)
		Register_TElLDAPMessage(TSRMLS_C);
	TElLDAPSearchMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElLDAPMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPAttributeValue_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPAttributeValue, ToString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPAttributeValue_ToString(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2001832453, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPAttributeValue, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElLDAPAttributeValue_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-621316634, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPAttributeValue, set_Value)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElLDAPAttributeValue_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPAttributeValue, __construct)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElLDAPAttributeValue_Create(aiValue.data, aiValue.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPAttributeValue_ToString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPAttributeValue_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPAttributeValue_set_Value, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPAttributeValue___construct, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPAttributeValue_methods[] = {
	PHP_ME(TElLDAPAttributeValue, ToString, arginfo_TElLDAPAttributeValue_ToString, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPAttributeValue, get_Value, arginfo_TElLDAPAttributeValue_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPAttributeValue, set_Value, arginfo_TElLDAPAttributeValue_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPAttributeValue, __construct, arginfo_TElLDAPAttributeValue___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPAttributeValue(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPAttributeValue_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPAttributeValue", TElLDAPAttributeValue_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElLDAPAttributeValue_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPPartialAttribute_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPPartialAttribute, Add)
{
	SBArrayZValInfo aiValue;
	zval *oValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElLDAPPartialAttribute_Add(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElLDAPAttributeValue_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElLDAPPartialAttribute_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (TElLDAPAttributeValue)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPPartialAttribute, Save)
{
	TElClassHandle hoTag;
	zval *oTag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oTag, TElASN1ConstrainedTag_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oTag) && (IS_OBJECT == Z_TYPE_P(oTag)))
	{
		hoTag = SBGetObjectHandle(oTag TSRMLS_CC);
		SBCheckError(TElLDAPPartialAttribute_Save(SBGetObjectHandle(getThis() TSRMLS_CC), &hoTag) TSRMLS_CC);
		SBUpdateObjectHandle(oTag, hoTag TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElASN1ConstrainedTag)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPPartialAttribute, get_Operation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBLDAPModifyOperationRaw fOutResultRaw = 0;
		SBCheckError(TElLDAPPartialAttribute_get_Operation(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPPartialAttribute, get_Binary)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElLDAPPartialAttribute_get_Binary(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPPartialAttribute, get_Type_)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPPartialAttribute_get_Type_(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(198710722, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPPartialAttribute, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElLDAPPartialAttribute_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPPartialAttribute, get_Values)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPPartialAttribute_get_Values(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPAttributeValue_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPPartialAttribute, __construct)
{
	char *sType_;
	int sType__len;
	long fOperation;
	TElClassHandle hoTag;
	zval *oTag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sType_, &sType__len, &fOperation) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPPartialAttribute_Create(sType_, (int32_t)sType__len, (TSBLDAPModifyOperationRaw)fOperation, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oTag, TElASN1ConstrainedTag_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oTag) && (IS_OBJECT == Z_TYPE_P(oTag)))
	{
		TElClassHandle hoOutResult = NULL;
		hoTag = SBGetObjectHandle(oTag TSRMLS_CC);
		SBCheckError(TElLDAPPartialAttribute_Create_1(&hoTag, &hoOutResult) TSRMLS_CC);
		SBUpdateObjectHandle(oTag, hoTag TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer) or (&TElASN1ConstrainedTag)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPPartialAttribute_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPPartialAttribute_Save, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Tag, TElASN1ConstrainedTag, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPPartialAttribute_get_Operation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPPartialAttribute_get_Binary, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPPartialAttribute_get_Type_, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPPartialAttribute_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPPartialAttribute_get_Values, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPPartialAttribute___construct, 0, 0, 1)
	ZEND_ARG_INFO(1, Type__or_Tag)
	ZEND_ARG_INFO(0, Operation)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPPartialAttribute_methods[] = {
	PHP_ME(TElLDAPPartialAttribute, Add, arginfo_TElLDAPPartialAttribute_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPPartialAttribute, Save, arginfo_TElLDAPPartialAttribute_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPPartialAttribute, get_Operation, arginfo_TElLDAPPartialAttribute_get_Operation, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPPartialAttribute, get_Binary, arginfo_TElLDAPPartialAttribute_get_Binary, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPPartialAttribute, get_Type_, arginfo_TElLDAPPartialAttribute_get_Type_, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPPartialAttribute, get_Count, arginfo_TElLDAPPartialAttribute_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPPartialAttribute, get_Values, arginfo_TElLDAPPartialAttribute_get_Values, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPPartialAttribute, __construct, arginfo_TElLDAPPartialAttribute___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPPartialAttribute(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPPartialAttribute_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPPartialAttribute", TElLDAPPartialAttribute_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElLDAPPartialAttribute_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPSearchEntryMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPSearchEntryMessage, get_ObjectName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElLDAPSearchEntryMessage_get_ObjectName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1167646591, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSearchEntryMessage, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElLDAPSearchEntryMessage_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSearchEntryMessage, get_Attributes)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSearchEntryMessage_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPPartialAttribute_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSearchEntryMessage, get_ByType)
{
	char *sIndex;
	int sIndex_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sIndex, &sIndex_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSearchEntryMessage_get_ByType(SBGetObjectHandle(getThis() TSRMLS_CC), sIndex, (int32_t)sIndex_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPPartialAttribute_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSearchEntryMessage, __construct)
{
	long l4Size;
	SBArrayZValInfo piBuf;
	zval *zpBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuf, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElLDAPSearchEntryMessage_Create(piBuf.data, (int32_t)l4Size, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSearchEntryMessage_get_ObjectName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSearchEntryMessage_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSearchEntryMessage_get_Attributes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSearchEntryMessage_get_ByType, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSearchEntryMessage___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPSearchEntryMessage_methods[] = {
	PHP_ME(TElLDAPSearchEntryMessage, get_ObjectName, arginfo_TElLDAPSearchEntryMessage_get_ObjectName, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSearchEntryMessage, get_Count, arginfo_TElLDAPSearchEntryMessage_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSearchEntryMessage, get_Attributes, arginfo_TElLDAPSearchEntryMessage_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSearchEntryMessage, get_ByType, arginfo_TElLDAPSearchEntryMessage_get_ByType, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSearchEntryMessage, __construct, arginfo_TElLDAPSearchEntryMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPSearchEntryMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPSearchEntryMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPSearchEntryMessage", TElLDAPSearchEntryMessage_methods);
	if (NULL == TElLDAPMessage_ce_ptr)
		Register_TElLDAPMessage(TSRMLS_C);
	TElLDAPSearchEntryMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElLDAPMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPSearchReferenceMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPSearchReferenceMessage, get_URIs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPSearchReferenceMessage_get_URIs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElLDAPSearchReferenceMessage, __construct)
{
	long l4Size;
	SBArrayZValInfo piBuf;
	zval *zpBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuf, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElLDAPSearchReferenceMessage_Create(piBuf.data, (int32_t)l4Size, &hoOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSearchReferenceMessage_get_URIs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPSearchReferenceMessage___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buf, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPSearchReferenceMessage_methods[] = {
	PHP_ME(TElLDAPSearchReferenceMessage, get_URIs, arginfo_TElLDAPSearchReferenceMessage_get_URIs, ZEND_ACC_PUBLIC)
	PHP_ME(TElLDAPSearchReferenceMessage, __construct, arginfo_TElLDAPSearchReferenceMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPSearchReferenceMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPSearchReferenceMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPSearchReferenceMessage", TElLDAPSearchReferenceMessage_methods);
	if (NULL == TElLDAPMessage_ce_ptr)
		Register_TElLDAPMessage(TSRMLS_C);
	TElLDAPSearchReferenceMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElLDAPMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPDeleteMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPDeleteMessage, __construct)
{
	char *sLDAPDN;
	int sLDAPDN_len;
	long l4MessageID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4MessageID, &sLDAPDN, &sLDAPDN_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElLDAPDeleteMessage_Create((int32_t)l4MessageID, sLDAPDN, (int32_t)sLDAPDN_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPDeleteMessage___construct, 0, 0, 2)
	ZEND_ARG_INFO(0, MessageID)
	ZEND_ARG_INFO(0, LDAPDN)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPDeleteMessage_methods[] = {
	PHP_ME(TElLDAPDeleteMessage, __construct, arginfo_TElLDAPDeleteMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPDeleteMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPDeleteMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPDeleteMessage", TElLDAPDeleteMessage_methods);
	if (NULL == TElLDAPMessage_ce_ptr)
		Register_TElLDAPMessage(TSRMLS_C);
	TElLDAPDeleteMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElLDAPMessage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElLDAPModifyMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElLDAPModifyMessage, __construct)
{
	char *sDN;
	int sDN_len;
	long l4MessageID;
	SBArrayZValInfo aiAttributes;
	zval *zaAttributes;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lsz", &l4MessageID, &sDN, &sDN_len, &zaAttributes, TElLDAPPartialAttribute_ce_ptr) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaAttributes)) || (IS_NULL == Z_TYPE_P(zaAttributes))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetObjectArrayFromZVal(zaAttributes, TElLDAPPartialAttribute_ce_ptr, &aiAttributes TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElLDAPModifyMessage_Create((int32_t)l4MessageID, sDN, (int32_t)sDN_len, aiAttributes.data, aiAttributes.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAttributes);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, &array of TElLDAPPartialAttribute|NULL)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElLDAPModifyMessage___construct, 0, 0, 3)
	ZEND_ARG_INFO(0, MessageID)
	ZEND_ARG_INFO(0, DN)
	ZEND_ARG_ARRAY_INFO(0, Attributes, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElLDAPModifyMessage_methods[] = {
	PHP_ME(TElLDAPModifyMessage, __construct, arginfo_TElLDAPModifyMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElLDAPModifyMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElLDAPModifyMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElLDAPModifyMessage", TElLDAPModifyMessage_methods);
	if (NULL == TElLDAPMessage_ce_ptr)
		Register_TElLDAPMessage(TSRMLS_C);
	TElLDAPModifyMessage_ce_ptr = zend_register_internal_class_ex(&ce, TElLDAPMessage_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBLDAPSCore, AttrFromString)
{
	char *sType_;
	char *sValue;
	int sType__len;
	int sValue_len;
	long fOperation;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssl", &sType_, &sType__len, &sValue, &sValue_len, &fOperation) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBLDAPSCore_AttrFromString(sType_, (int32_t)sType__len, sValue, (int32_t)sValue_len, (TSBLDAPModifyOperationRaw)fOperation, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElLDAPPartialAttribute_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, AttrFromBuffer)
{
	char *sType_;
	int sType__len;
	long fOperation;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szl", &sType_, &sType__len, &zaValue, &fOperation) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBLDAPSCore_AttrFromBuffer(sType_, (int32_t)sType__len, aiValue.data, aiValue.len, (TSBLDAPModifyOperationRaw)fOperation, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
		SBInitObject(return_value, TElLDAPPartialAttribute_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, PutSimpleFilter)
{
	char *ss;
	int ss_len;
	TElClassHandle hoTag;
	zval *oTag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Os", &oTag, TElASN1ConstrainedTag_ce_ptr, &ss, &ss_len) == SUCCESS) && PZVAL_IS_REF(oTag) && (IS_OBJECT == Z_TYPE_P(oTag)))
	{
		hoTag = SBGetObjectHandle(oTag TSRMLS_CC);
		SBCheckError(SBLDAPSCore_PutSimpleFilter(&hoTag, ss, (int32_t)ss_len) TSRMLS_CC);
		SBUpdateObjectHandle(oTag, hoTag TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElASN1ConstrainedTag, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, PutSubstringFilter)
{
	char *sType_;
	char *sValue;
	int sType__len;
	int sValue_len;
	long l4TagId;
	TElClassHandle hoTag;
	zval *oTag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Olss", &oTag, TElASN1ConstrainedTag_ce_ptr, &l4TagId, &sType_, &sType__len, &sValue, &sValue_len) == SUCCESS) && PZVAL_IS_REF(oTag) && (IS_OBJECT == Z_TYPE_P(oTag)))
	{
		hoTag = SBGetObjectHandle(oTag TSRMLS_CC);
		SBCheckError(SBLDAPSCore_PutSubstringFilter(&hoTag, (int32_t)l4TagId, sType_, (int32_t)sType__len, sValue, (int32_t)sValue_len) TSRMLS_CC);
		SBUpdateObjectHandle(oTag, hoTag TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElASN1ConstrainedTag, integer, string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, SplitValue)
{
	char *ss;
	int ss_len;
	TElClassHandle hoList;
	zval *oList;
#ifdef SB_WINDOWS
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Os", &oList, TStringList_ce_ptr, &ss, &ss_len) == SUCCESS) && PZVAL_IS_REF(oList) && (IS_OBJECT == Z_TYPE_P(oList)))
#else
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Os", &oList, TElStringList_ce_ptr, &ss, &ss_len) == SUCCESS) && PZVAL_IS_REF(oList) && (IS_OBJECT == Z_TYPE_P(oList)))
#endif
	{
		hoList = SBGetObjectHandle(oList TSRMLS_CC);
		SBCheckError(SBLDAPSCore_SplitValue(&hoList, ss, (int32_t)ss_len) TSRMLS_CC);
		SBUpdateObjectHandle(oList, hoList TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(&TStringList, string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(&TElStringList, string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, PutFilterList)
{
	char *ss;
	int ss_len;
	TElClassHandle hoTag;
	zval *oTag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Os", &oTag, TElASN1ConstrainedTag_ce_ptr, &ss, &ss_len) == SUCCESS) && PZVAL_IS_REF(oTag) && (IS_OBJECT == Z_TYPE_P(oTag)))
	{
		hoTag = SBGetObjectHandle(oTag TSRMLS_CC);
		SBCheckError(SBLDAPSCore_PutFilterList(&hoTag, ss, (int32_t)ss_len) TSRMLS_CC);
		SBUpdateObjectHandle(oTag, hoTag TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElASN1ConstrainedTag, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, IsDigit)
{
	char *cc;
	int cc_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cc, &cc_len) == SUCCESS) && (1 == cc_len))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBLDAPSCore_IsDigit(cc[0], &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, IsHexLower)
{
	char *cc;
	int cc_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cc, &cc_len) == SUCCESS) && (1 == cc_len))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBLDAPSCore_IsHexLower(cc[0], &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, IsHexUpper)
{
	char *cc;
	int cc_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cc, &cc_len) == SUCCESS) && (1 == cc_len))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBLDAPSCore_IsHexUpper(cc[0], &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, IsHex)
{
	char *cc;
	int cc_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cc, &cc_len) == SUCCESS) && (1 == cc_len))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBLDAPSCore_IsHex(cc[0], &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, IsLower)
{
	char *cc;
	int cc_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cc, &cc_len) == SUCCESS) && (1 == cc_len))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBLDAPSCore_IsLower(cc[0], &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, IsUpper)
{
	char *cc;
	int cc_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cc, &cc_len) == SUCCESS) && (1 == cc_len))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBLDAPSCore_IsUpper(cc[0], &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, IsAlpha)
{
	char *cc;
	int cc_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cc, &cc_len) == SUCCESS) && (1 == cc_len))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBLDAPSCore_IsAlpha(cc[0], &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, IsAlnum)
{
	char *cc;
	int cc_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cc, &cc_len) == SUCCESS) && (1 == cc_len))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBLDAPSCore_IsAlnum(cc[0], &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, IsLdh)
{
	char *cc;
	int cc_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cc, &cc_len) == SUCCESS) && (1 == cc_len))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBLDAPSCore_IsLdh(cc[0], &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, IsSpace)
{
	char *cc;
	int cc_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cc, &cc_len) == SUCCESS) && (1 == cc_len))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBLDAPSCore_IsSpace(cc[0], &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, Hex2Value)
{
	char *cc;
	int cc_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cc, &cc_len) == SUCCESS) && (1 == cc_len))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBLDAPSCore_Hex2Value(cc[0], &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, GetMessageLenSize)
{
	long l4Size;
	SBArrayZValInfo aiBuf;
	uint32_t _err;
	zval *zaBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaBuf, &l4Size) == SUCCESS) && PZVAL_IS_REF(zaBuf) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBLDAPSCore_GetMessageLenSize(aiBuf.data, &aiBuf.len, (int32_t)l4Size, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuf, &aiBuf TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-2037887006, 0, aiBuf.data, &aiBuf.len) TSRMLS_CC);
			((char *)aiBuf.data)[aiBuf.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuf);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuf, zaBuf);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, GetMessageLen)
{
	long l4Size;
	SBArrayZValInfo aiBuf;
	uint32_t _err;
	zval *zaBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaBuf, &l4Size) == SUCCESS) && PZVAL_IS_REF(zaBuf) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBLDAPSCore_GetMessageLen(aiBuf.data, &aiBuf.len, (int32_t)l4Size, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuf, &aiBuf TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(821225493, 0, aiBuf.data, &aiBuf.len) TSRMLS_CC);
			((char *)aiBuf.data)[aiBuf.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuf);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuf, zaBuf);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBLDAPSCore, GetMessageType)
{
	long l4Size;
	SBArrayZValInfo aiBuf;
	uint32_t _err;
	zval *zaBuf;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaBuf, &l4Size) == SUCCESS) && PZVAL_IS_REF(zaBuf) && ((IS_STRING == Z_TYPE_P(zaBuf)) || (IS_ARRAY == Z_TYPE_P(zaBuf))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuf, &aiBuf TSRMLS_CC)) RETURN_FALSE;
		_err = SBLDAPSCore_GetMessageType(aiBuf.data, &aiBuf.len, (int32_t)l4Size, &l4OutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuf, &aiBuf TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1459204673, 0, aiBuf.data, &aiBuf.len) TSRMLS_CC);
			((char *)aiBuf.data)[aiBuf.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuf);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuf, zaBuf);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, integer)" TSRMLS_CC);
	}
}

void Register_SBLDAPSCore_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBLDAPSCore, SWrongMessageError, SB_SWrongMessageError, SB_SWrongMessageError);
	SB_REGISTER_STRING_CONSTANT(SBLDAPSCore, SBindError, SB_SBindError, SB_SBindError);
	SB_REGISTER_STRING_CONSTANT(SBLDAPSCore, SSASLError, SB_SSASLError, SB_SSASLError);
	SB_REGISTER_STRING_CONSTANT(SBLDAPSCore, SWrongResponse, SB_SWrongResponse, SB_SWrongResponse);
	SB_REGISTER_STRING_CONSTANT(SBLDAPSCore, SServerError, SB_SServerError, SB_SServerError);
	SB_REGISTER_STRING_CONSTANT(SBLDAPSCore, SNotImplemented, SB_SNotImplemented, SB_SNotImplemented);
	SB_REGISTER_STRING_CONSTANT(SBLDAPSCore, SInvalidFilterString, SB_SInvalidFilterString, SB_SInvalidFilterString);
	SB_REGISTER_STRING_CONSTANT(SBLDAPSCore, SInvalidFilterSequence, SB_SInvalidFilterSequence, SB_SInvalidFilterSequence);
	SB_REGISTER_STRING_CONSTANT(SBLDAPSCore, SInvalidLdapUrl, SB_SInvalidLdapUrl, SB_SInvalidLdapUrl);
	SB_REGISTER_STRING_CONSTANT(SBLDAPSCore, SWrongParameter, SB_SWrongParameter, SB_SWrongParameter);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_VERSION, SB_LDAP_VERSION, SB_LDAP_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_UNKNOWN, SB_LDAP_UNKNOWN, SB_LDAP_UNKNOWN);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_REQ_BIND, SB_LDAP_REQ_BIND, SB_LDAP_REQ_BIND);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_REQ_UNBIND, SB_LDAP_REQ_UNBIND, SB_LDAP_REQ_UNBIND);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_REQ_SEARCH, SB_LDAP_REQ_SEARCH, SB_LDAP_REQ_SEARCH);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_REQ_MODIFY, SB_LDAP_REQ_MODIFY, SB_LDAP_REQ_MODIFY);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_REQ_ADD, SB_LDAP_REQ_ADD, SB_LDAP_REQ_ADD);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_REQ_DELETE, SB_LDAP_REQ_DELETE, SB_LDAP_REQ_DELETE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_REQ_MODDN, SB_LDAP_REQ_MODDN, SB_LDAP_REQ_MODDN);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_REQ_MODRDN, SB_LDAP_REQ_MODRDN, SB_LDAP_REQ_MODRDN);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_REQ_RENAME, SB_LDAP_REQ_RENAME, SB_LDAP_REQ_RENAME);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_REQ_COMPARE, SB_LDAP_REQ_COMPARE, SB_LDAP_REQ_COMPARE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_REQ_ABANDON, SB_LDAP_REQ_ABANDON, SB_LDAP_REQ_ABANDON);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_REQ_EXTENDED, SB_LDAP_REQ_EXTENDED, SB_LDAP_REQ_EXTENDED);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_BIND, SB_LDAP_RES_BIND, SB_LDAP_RES_BIND);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_SEARCH_ENTRY, SB_LDAP_RES_SEARCH_ENTRY, SB_LDAP_RES_SEARCH_ENTRY);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_SEARCH_REFERENCE, SB_LDAP_RES_SEARCH_REFERENCE, SB_LDAP_RES_SEARCH_REFERENCE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_SEARCH_RESULT, SB_LDAP_RES_SEARCH_RESULT, SB_LDAP_RES_SEARCH_RESULT);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_MODIFY, SB_LDAP_RES_MODIFY, SB_LDAP_RES_MODIFY);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_ADD, SB_LDAP_RES_ADD, SB_LDAP_RES_ADD);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_DELETE, SB_LDAP_RES_DELETE, SB_LDAP_RES_DELETE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_MODDN, SB_LDAP_RES_MODDN, SB_LDAP_RES_MODDN);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_MODRDN, SB_LDAP_RES_MODRDN, SB_LDAP_RES_MODRDN);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_RENAME, SB_LDAP_RES_RENAME, SB_LDAP_RES_RENAME);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_COMPARE, SB_LDAP_RES_COMPARE, SB_LDAP_RES_COMPARE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_EXTENDED, SB_LDAP_RES_EXTENDED, SB_LDAP_RES_EXTENDED);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RES_INTERMEDIATE, SB_LDAP_RES_INTERMEDIATE, SB_LDAP_RES_INTERMEDIATE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_AND, SB_LDAP_FILTER_AND, SB_LDAP_FILTER_AND);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_OR, SB_LDAP_FILTER_OR, SB_LDAP_FILTER_OR);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_NOT, SB_LDAP_FILTER_NOT, SB_LDAP_FILTER_NOT);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_EQUALITY, SB_LDAP_FILTER_EQUALITY, SB_LDAP_FILTER_EQUALITY);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_SUBSTRINGS, SB_LDAP_FILTER_SUBSTRINGS, SB_LDAP_FILTER_SUBSTRINGS);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_GE, SB_LDAP_FILTER_GE, SB_LDAP_FILTER_GE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_LE, SB_LDAP_FILTER_LE, SB_LDAP_FILTER_LE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_PRESENT, SB_LDAP_FILTER_PRESENT, SB_LDAP_FILTER_PRESENT);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_APPROX, SB_LDAP_FILTER_APPROX, SB_LDAP_FILTER_APPROX);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_EXT, SB_LDAP_FILTER_EXT, SB_LDAP_FILTER_EXT);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_EXT_OID, SB_LDAP_FILTER_EXT_OID, SB_LDAP_FILTER_EXT_OID);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_EXT_TYPE, SB_LDAP_FILTER_EXT_TYPE, SB_LDAP_FILTER_EXT_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_EXT_VALUE, SB_LDAP_FILTER_EXT_VALUE, SB_LDAP_FILTER_EXT_VALUE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_FILTER_EXT_DNATTRS, SB_LDAP_FILTER_EXT_DNATTRS, SB_LDAP_FILTER_EXT_DNATTRS);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_SUBSTRING_INITIAL, SB_LDAP_SUBSTRING_INITIAL, SB_LDAP_SUBSTRING_INITIAL);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_SUBSTRING_ANY, SB_LDAP_SUBSTRING_ANY, SB_LDAP_SUBSTRING_ANY);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, LDAP_SUBSTRING_FINAL, SB_LDAP_SUBSTRING_FINAL, SB_LDAP_SUBSTRING_FINAL);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_SUCCESS, SB_LDAP_RESULT_SUCCESS, SB_LDAP_RESULT_SUCCESS);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_OPERATIONS_ERROR, SB_LDAP_RESULT_OPERATIONS_ERROR, SB_LDAP_RESULT_OPERATIONS_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_PROTOCOL_ERROR, SB_LDAP_RESULT_PROTOCOL_ERROR, SB_LDAP_RESULT_PROTOCOL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_TIME_LIMIT, SB_LDAP_RESULT_TIME_LIMIT, SB_LDAP_RESULT_TIME_LIMIT);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_SIZE_LIMIT, SB_LDAP_RESULT_SIZE_LIMIT, SB_LDAP_RESULT_SIZE_LIMIT);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_COMPARE_FALSE, SB_LDAP_RESULT_COMPARE_FALSE, SB_LDAP_RESULT_COMPARE_FALSE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_COMPARE_TRUE, SB_LDAP_RESULT_COMPARE_TRUE, SB_LDAP_RESULT_COMPARE_TRUE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_AUTH_METHOD_NOT_SUPPORTED, SB_LDAP_RESULT_AUTH_METHOD_NOT_SUPPORTED, SB_LDAP_RESULT_AUTH_METHOD_NOT_SUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_STRONGER_AUTH_REQUIRED, SB_LDAP_RESULT_STRONGER_AUTH_REQUIRED, SB_LDAP_RESULT_STRONGER_AUTH_REQUIRED);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_REFERRAL, SB_LDAP_RESULT_REFERRAL, SB_LDAP_RESULT_REFERRAL);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_ADMIN_LIMIT, SB_LDAP_RESULT_ADMIN_LIMIT, SB_LDAP_RESULT_ADMIN_LIMIT);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_UNAVALIABLE_CRITICAL_EXTENSION, SB_LDAP_RESULT_UNAVALIABLE_CRITICAL_EXTENSION, SB_LDAP_RESULT_UNAVALIABLE_CRITICAL_EXTENSION);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_CONFIDENTIALITY_REQUIRED, SB_LDAP_RESULT_CONFIDENTIALITY_REQUIRED, SB_LDAP_RESULT_CONFIDENTIALITY_REQUIRED);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_SASL_BIND_IN_PROGRESS, SB_LDAP_RESULT_SASL_BIND_IN_PROGRESS, SB_LDAP_RESULT_SASL_BIND_IN_PROGRESS);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_NO_SUCH_ATTRIBUTE, SB_LDAP_RESULT_NO_SUCH_ATTRIBUTE, SB_LDAP_RESULT_NO_SUCH_ATTRIBUTE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_UNDEFINED_ATTRIBUTE_TYPE, SB_LDAP_RESULT_UNDEFINED_ATTRIBUTE_TYPE, SB_LDAP_RESULT_UNDEFINED_ATTRIBUTE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_INAPPROPRIATE_MATCHING, SB_LDAP_RESULT_INAPPROPRIATE_MATCHING, SB_LDAP_RESULT_INAPPROPRIATE_MATCHING);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_CONSTRAINT_VIOLATION, SB_LDAP_RESULT_CONSTRAINT_VIOLATION, SB_LDAP_RESULT_CONSTRAINT_VIOLATION);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_ATTRIBUTE_OR_VALUE_EXISTS, SB_LDAP_RESULT_ATTRIBUTE_OR_VALUE_EXISTS, SB_LDAP_RESULT_ATTRIBUTE_OR_VALUE_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_INVALID_ATTRIBUTE_SYNTAX, SB_LDAP_RESULT_INVALID_ATTRIBUTE_SYNTAX, SB_LDAP_RESULT_INVALID_ATTRIBUTE_SYNTAX);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_NO_SUCH_OBJECT, SB_LDAP_RESULT_NO_SUCH_OBJECT, SB_LDAP_RESULT_NO_SUCH_OBJECT);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_ALIAS_PROBLEM, SB_LDAP_RESULT_ALIAS_PROBLEM, SB_LDAP_RESULT_ALIAS_PROBLEM);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_INVALID_DN_SYNTAX, SB_LDAP_RESULT_INVALID_DN_SYNTAX, SB_LDAP_RESULT_INVALID_DN_SYNTAX);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_ALIAS_DEREFERENCING_PROBLEM, SB_LDAP_RESULT_ALIAS_DEREFERENCING_PROBLEM, SB_LDAP_RESULT_ALIAS_DEREFERENCING_PROBLEM);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_INAPPROPRIATE_AUTHENTICATION, SB_LDAP_RESULT_INAPPROPRIATE_AUTHENTICATION, SB_LDAP_RESULT_INAPPROPRIATE_AUTHENTICATION);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_INVALID_CREDENTIALS, SB_LDAP_RESULT_INVALID_CREDENTIALS, SB_LDAP_RESULT_INVALID_CREDENTIALS);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_INSUFFICIENT_ACCESS_RIGHTS, SB_LDAP_RESULT_INSUFFICIENT_ACCESS_RIGHTS, SB_LDAP_RESULT_INSUFFICIENT_ACCESS_RIGHTS);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_BUSY, SB_LDAP_RESULT_BUSY, SB_LDAP_RESULT_BUSY);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_UNAVAILABLE, SB_LDAP_RESULT_UNAVAILABLE, SB_LDAP_RESULT_UNAVAILABLE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_UNWILLING_TO_PERFORM, SB_LDAP_RESULT_UNWILLING_TO_PERFORM, SB_LDAP_RESULT_UNWILLING_TO_PERFORM);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_LOOP_DETECT, SB_LDAP_RESULT_LOOP_DETECT, SB_LDAP_RESULT_LOOP_DETECT);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_NAMING_VIOLATION, SB_LDAP_RESULT_NAMING_VIOLATION, SB_LDAP_RESULT_NAMING_VIOLATION);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_OBJECT_CLASS_VIOLATION, SB_LDAP_RESULT_OBJECT_CLASS_VIOLATION, SB_LDAP_RESULT_OBJECT_CLASS_VIOLATION);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_NOT_ALLOWED_ON_NON_LEAF, SB_LDAP_RESULT_NOT_ALLOWED_ON_NON_LEAF, SB_LDAP_RESULT_NOT_ALLOWED_ON_NON_LEAF);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_NOT_ALLOWED_ON_RDN, SB_LDAP_RESULT_NOT_ALLOWED_ON_RDN, SB_LDAP_RESULT_NOT_ALLOWED_ON_RDN);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_ENTRY_ALREADY_EXISTS, SB_LDAP_RESULT_ENTRY_ALREADY_EXISTS, SB_LDAP_RESULT_ENTRY_ALREADY_EXISTS);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_OBJECT_CLASS_MODS_PROHIBITED, SB_LDAP_RESULT_OBJECT_CLASS_MODS_PROHIBITED, SB_LDAP_RESULT_OBJECT_CLASS_MODS_PROHIBITED);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_AFFECTS_MULTIPLE_DSAS, SB_LDAP_RESULT_AFFECTS_MULTIPLE_DSAS, SB_LDAP_RESULT_AFFECTS_MULTIPLE_DSAS);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_RESULT_OTHER, SB_LDAP_RESULT_OTHER, SB_LDAP_RESULT_OTHER);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_ERROR_INTERNAL, SB_LDAP_ERROR_INTERNAL, SB_LDAP_ERROR_INTERNAL);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_ERROR_WRONG_MESSAGE, SB_LDAP_ERROR_WRONG_MESSAGE, SB_LDAP_ERROR_WRONG_MESSAGE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_ERROR_BIND, SB_LDAP_ERROR_BIND, SB_LDAP_ERROR_BIND);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_ERROR_SEARCH, SB_LDAP_ERROR_SEARCH, SB_LDAP_ERROR_SEARCH);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_ERROR_SEARCH_FILTER, SB_LDAP_ERROR_SEARCH_FILTER, SB_LDAP_ERROR_SEARCH_FILTER);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_ERROR_FILTER_SEQUENCE, SB_LDAP_ERROR_FILTER_SEQUENCE, SB_LDAP_ERROR_FILTER_SEQUENCE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_ERROR_GET_RESPONSE, SB_LDAP_ERROR_GET_RESPONSE, SB_LDAP_ERROR_GET_RESPONSE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_ERROR_SASL, SB_LDAP_ERROR_SASL, SB_LDAP_ERROR_SASL);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_WRONG_LDAP_URL, SB_LDAP_WRONG_LDAP_URL, SB_LDAP_WRONG_LDAP_URL);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_ERROR_DELETE, SB_LDAP_ERROR_DELETE, SB_LDAP_ERROR_DELETE);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_ERROR_ADD, SB_LDAP_ERROR_ADD, SB_LDAP_ERROR_ADD);
	SB_REGISTER_LONG_CONSTANT(SBLDAPSCore, SB_LDAP_ERROR_MODIFY, SB_LDAP_ERROR_MODIFY, SB_LDAP_ERROR_MODIFY);
}

void Register_SBLDAPSCore_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBLDAPScope", NULL);
	TSBLDAPScope_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBLDAPScope_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPScope_ce_ptr, "scBase", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPScope_ce_ptr, "scOneLevel", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPScope_ce_ptr, "scSubTree", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBLDAPModifyOperation", NULL);
	TSBLDAPModifyOperation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBLDAPModifyOperation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPModifyOperation_ce_ptr, "moNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPModifyOperation_ce_ptr, "moAdd", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPModifyOperation_ce_ptr, "moDelete", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBLDAPModifyOperation_ce_ptr, "moReplace", 3)
}

void Register_SBLDAPSCore_Aliases(TSRMLS_D)
{
	if (NULL == TElLDAPMessage_ce_ptr)
		Register_TElLDAPMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPMessage", TElLDAPMessage_ce_ptr);
	if (NULL == TElLDAPSimpleBindMessage_ce_ptr)
		Register_TElLDAPSimpleBindMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPSimpleBindMessage", TElLDAPSimpleBindMessage_ce_ptr);
	if (NULL == TElLDAPSASLBindMessage_ce_ptr)
		Register_TElLDAPSASLBindMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPSASLBindMessage", TElLDAPSASLBindMessage_ce_ptr);
	if (NULL == TElLDAPUnbindMessage_ce_ptr)
		Register_TElLDAPUnbindMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPUnbindMessage", TElLDAPUnbindMessage_ce_ptr);
	if (NULL == TElLDAPResult_ce_ptr)
		Register_TElLDAPResult(TSRMLS_C);
	zend_register_class_alias("ElLDAPResult", TElLDAPResult_ce_ptr);
	if (NULL == TElLDAPResultMessage_ce_ptr)
		Register_TElLDAPResultMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPResultMessage", TElLDAPResultMessage_ce_ptr);
	if (NULL == TElLDAPResultMessage_ce_ptr)
		Register_TElLDAPResultMessage(TSRMLS_C);
	zend_register_class_alias("TElLDAPSearchResultDoneMessage", TElLDAPResultMessage_ce_ptr);
	if (NULL == TElLDAPResultMessage_ce_ptr)
		Register_TElLDAPResultMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPSearchResultDoneMessage", TElLDAPResultMessage_ce_ptr);
	if (NULL == TElLDAPBindResponseMessage_ce_ptr)
		Register_TElLDAPBindResponseMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPBindResponseMessage", TElLDAPBindResponseMessage_ce_ptr);
	if (NULL == TElLDAPSearchMessage_ce_ptr)
		Register_TElLDAPSearchMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPSearchMessage", TElLDAPSearchMessage_ce_ptr);
	if (NULL == TElLDAPAttributeValue_ce_ptr)
		Register_TElLDAPAttributeValue(TSRMLS_C);
	zend_register_class_alias("ElLDAPAttributeValue", TElLDAPAttributeValue_ce_ptr);
	if (NULL == TElLDAPPartialAttribute_ce_ptr)
		Register_TElLDAPPartialAttribute(TSRMLS_C);
	zend_register_class_alias("ElLDAPPartialAttribute", TElLDAPPartialAttribute_ce_ptr);
	if (NULL == TElLDAPPartialAttribute_ce_ptr)
		Register_TElLDAPPartialAttribute(TSRMLS_C);
	zend_register_class_alias("TElLDAPAttribute", TElLDAPPartialAttribute_ce_ptr);
	if (NULL == TElLDAPPartialAttribute_ce_ptr)
		Register_TElLDAPPartialAttribute(TSRMLS_C);
	zend_register_class_alias("ElLDAPAttribute", TElLDAPPartialAttribute_ce_ptr);
	if (NULL == TElLDAPSearchEntryMessage_ce_ptr)
		Register_TElLDAPSearchEntryMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPSearchEntryMessage", TElLDAPSearchEntryMessage_ce_ptr);
	if (NULL == TElLDAPSearchReferenceMessage_ce_ptr)
		Register_TElLDAPSearchReferenceMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPSearchReferenceMessage", TElLDAPSearchReferenceMessage_ce_ptr);
	if (NULL == TElLDAPDeleteMessage_ce_ptr)
		Register_TElLDAPDeleteMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPDeleteMessage", TElLDAPDeleteMessage_ce_ptr);
	if (NULL == TElLDAPResultMessage_ce_ptr)
		Register_TElLDAPResultMessage(TSRMLS_C);
	zend_register_class_alias("TElLDAPDeleteResponseMessage", TElLDAPResultMessage_ce_ptr);
	if (NULL == TElLDAPResultMessage_ce_ptr)
		Register_TElLDAPResultMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPDeleteResponseMessage", TElLDAPResultMessage_ce_ptr);
	if (NULL == TElLDAPModifyMessage_ce_ptr)
		Register_TElLDAPModifyMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPModifyMessage", TElLDAPModifyMessage_ce_ptr);
	if (NULL == TElLDAPModifyMessage_ce_ptr)
		Register_TElLDAPModifyMessage(TSRMLS_C);
	zend_register_class_alias("TElLDAPAddMessage", TElLDAPModifyMessage_ce_ptr);
	if (NULL == TElLDAPModifyMessage_ce_ptr)
		Register_TElLDAPModifyMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPAddMessage", TElLDAPModifyMessage_ce_ptr);
	if (NULL == TElLDAPResultMessage_ce_ptr)
		Register_TElLDAPResultMessage(TSRMLS_C);
	zend_register_class_alias("TElLDAPAddResponseMessage", TElLDAPResultMessage_ce_ptr);
	if (NULL == TElLDAPResultMessage_ce_ptr)
		Register_TElLDAPResultMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPAddResponseMessage", TElLDAPResultMessage_ce_ptr);
	if (NULL == TElLDAPResultMessage_ce_ptr)
		Register_TElLDAPResultMessage(TSRMLS_C);
	zend_register_class_alias("TElLDAPModifyResponseMessage", TElLDAPResultMessage_ce_ptr);
	if (NULL == TElLDAPResultMessage_ce_ptr)
		Register_TElLDAPResultMessage(TSRMLS_C);
	zend_register_class_alias("ElLDAPModifyResponseMessage", TElLDAPResultMessage_ce_ptr);
}
