#include "sbmimestream.h"

zend_class_entry *TElCustomMIMEStream_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomMIMEStream, Flush)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomMIMEStream_Flush(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMIMEStream, CopyFrom)
{
	long l8Count;
	zval *oSrcStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oSrcStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomMIMEStream_CopyFrom(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSrcStream TSRMLS_CC), (int64_t)l8Count, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMIMEStream, _CopyTo)
{
	long l8Count;
	zval *oDestStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oDestStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomMIMEStream__CopyTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestStream TSRMLS_CC), (int64_t)l8Count, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMIMEStream, Squeeze)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomMIMEStream_Squeeze(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMIMEStream, Reserve)
{
	long l4Count;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Count) == SUCCESS)
	{
		SBCheckError(TElCustomMIMEStream_Reserve(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMIMEStream, get_Capacity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomMIMEStream_get_Capacity(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMIMEStream, set_Capacity)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElCustomMIMEStream_set_Capacity(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMIMEStream, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomMIMEStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMIMEStream_Flush, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMIMEStream_CopyFrom, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, SrcStream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMIMEStream__CopyTo, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, DestStream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMIMEStream_Squeeze, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMIMEStream_Reserve, 0, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMIMEStream_get_Capacity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMIMEStream_set_Capacity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMIMEStream___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomMIMEStream_methods[] = {
	PHP_ME(TElCustomMIMEStream, Flush, arginfo_TElCustomMIMEStream_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMIMEStream, CopyFrom, arginfo_TElCustomMIMEStream_CopyFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMIMEStream, _CopyTo, arginfo_TElCustomMIMEStream__CopyTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMIMEStream, Squeeze, arginfo_TElCustomMIMEStream_Squeeze, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMIMEStream, Reserve, arginfo_TElCustomMIMEStream_Reserve, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMIMEStream, get_Capacity, arginfo_TElCustomMIMEStream_get_Capacity, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMIMEStream, set_Capacity, arginfo_TElCustomMIMEStream_set_Capacity, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMIMEStream, __construct, arginfo_TElCustomMIMEStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomMIMEStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomMIMEStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomMIMEStream", TElCustomMIMEStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElCustomMIMEStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TNullMIMEStream_ce_ptr = NULL;

SB_PHP_METHOD(TNullMIMEStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TNullMIMEStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TNullMIMEStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TNullMIMEStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TNullMIMEStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TNullMIMEStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TNullMIMEStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TNullMIMEStream, __construct)
{
	long l8ASize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TNullMIMEStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8ASize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TNullMIMEStream_Create_1((int64_t)l8ASize, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TNullMIMEStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TNullMIMEStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TNullMIMEStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TNullMIMEStream___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, ASize)
ZEND_END_ARG_INFO()

static zend_function_entry TNullMIMEStream_methods[] = {
	PHP_ME(TNullMIMEStream, Read, arginfo_TNullMIMEStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TNullMIMEStream, Write, arginfo_TNullMIMEStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TNullMIMEStream, Seek, arginfo_TNullMIMEStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TNullMIMEStream, __construct, arginfo_TNullMIMEStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TNullMIMEStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TNullMIMEStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TNullMIMEStream", TNullMIMEStream_methods);
	if (NULL == TElCustomMIMEStream_ce_ptr)
		Register_TElCustomMIMEStream(TSRMLS_C);
	TNullMIMEStream_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomMIMEStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomMemoryMIMEStream_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomMemoryMIMEStream, SetMemory)
{
	long l8ASize;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaValue, &l8ASize) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomMemoryMIMEStream_SetMemory(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len, (int64_t)l8ASize) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, SaveToStream)
{
	long l8Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomMemoryMIMEStream_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8Count, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, SaveToFileEx)
{
	char *sFileName;
	int sFileName_len;
	long l8Count;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sFileName, &sFileName_len, &l8Count) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomMemoryMIMEStream_SaveToFileEx(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int64_t)l8Count, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, SaveToFile)
{
	char *sFileName;
	int sFileName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TElCustomMemoryMIMEStream_SaveToFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, LoadFromStream)
{
	long l8Count;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStream, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomMemoryMIMEStream_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8Count, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, LoadFromFileEx)
{
	char *sFileName;
	int sFileName_len;
	long l8Count;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sFileName, &sFileName_len, &l8Count) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomMemoryMIMEStream_LoadFromFileEx(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int64_t)l8Count, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, LoadFromFile)
{
	char *sFileName;
	int sFileName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TElCustomMemoryMIMEStream_LoadFromFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomMemoryMIMEStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomMemoryMIMEStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomMemoryMIMEStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomMemoryMIMEStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, Clear)
{
	long l8NewCapacity;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8NewCapacity) == SUCCESS)
	{
		SBCheckError(TElCustomMemoryMIMEStream_Clear(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8NewCapacity) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, Squeeze)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElCustomMemoryMIMEStream_Squeeze(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, Reserve)
{
	long l4Count;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Count) == SUCCESS)
	{
		SBCheckError(TElCustomMemoryMIMEStream_Reserve(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Count) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, SizePos)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElCustomMemoryMIMEStream_SizePos(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, get_Memory)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElCustomMemoryMIMEStream_get_Memory(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-747273016, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, set_Memory)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomMemoryMIMEStream_set_Memory(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, get_MemoryDelta)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElCustomMemoryMIMEStream_get_MemoryDelta(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, set_MemoryDelta)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElCustomMemoryMIMEStream_set_MemoryDelta(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomMemoryMIMEStream, __construct)
{
	long l8ACapacity;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomMemoryMIMEStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8ACapacity) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomMemoryMIMEStream_Create_1((int64_t)l8ACapacity, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_SetMemory, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
	ZEND_ARG_INFO(0, ASize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_SaveToStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_SaveToFileEx, 0, 0, 2)
	ZEND_ARG_INFO(0, FileName)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_SaveToFile, 0, 0, 1)
	ZEND_ARG_INFO(0, FileName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_LoadFromStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_LoadFromFileEx, 0, 0, 2)
	ZEND_ARG_INFO(0, FileName)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_LoadFromFile, 0, 0, 1)
	ZEND_ARG_INFO(0, FileName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_Clear, 0, 0, 1)
	ZEND_ARG_INFO(0, NewCapacity)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_Squeeze, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_Reserve, 0, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_SizePos, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_get_Memory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_set_Memory, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_get_MemoryDelta, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream_set_MemoryDelta, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomMemoryMIMEStream___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, ACapacity)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomMemoryMIMEStream_methods[] = {
	PHP_ME(TElCustomMemoryMIMEStream, SetMemory, arginfo_TElCustomMemoryMIMEStream_SetMemory, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, SaveToStream, arginfo_TElCustomMemoryMIMEStream_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, SaveToFileEx, arginfo_TElCustomMemoryMIMEStream_SaveToFileEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, SaveToFile, arginfo_TElCustomMemoryMIMEStream_SaveToFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, LoadFromStream, arginfo_TElCustomMemoryMIMEStream_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, LoadFromFileEx, arginfo_TElCustomMemoryMIMEStream_LoadFromFileEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, LoadFromFile, arginfo_TElCustomMemoryMIMEStream_LoadFromFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, Read, arginfo_TElCustomMemoryMIMEStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, Write, arginfo_TElCustomMemoryMIMEStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, Seek, arginfo_TElCustomMemoryMIMEStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, Clear, arginfo_TElCustomMemoryMIMEStream_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, Squeeze, arginfo_TElCustomMemoryMIMEStream_Squeeze, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, Reserve, arginfo_TElCustomMemoryMIMEStream_Reserve, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, SizePos, arginfo_TElCustomMemoryMIMEStream_SizePos, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, get_Memory, arginfo_TElCustomMemoryMIMEStream_get_Memory, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, set_Memory, arginfo_TElCustomMemoryMIMEStream_set_Memory, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, get_MemoryDelta, arginfo_TElCustomMemoryMIMEStream_get_MemoryDelta, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, set_MemoryDelta, arginfo_TElCustomMemoryMIMEStream_set_MemoryDelta, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomMemoryMIMEStream, __construct, arginfo_TElCustomMemoryMIMEStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomMemoryMIMEStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomMemoryMIMEStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomMemoryMIMEStream", TElCustomMemoryMIMEStream_methods);
	if (NULL == TElCustomMIMEStream_ce_ptr)
		Register_TElCustomMIMEStream(TSRMLS_C);
	TElCustomMemoryMIMEStream_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomMIMEStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElMemoryMIMEStream_ce_ptr = NULL;

SB_PHP_METHOD(TElMemoryMIMEStream, get_Memory)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElMemoryMIMEStream_get_Memory(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2036445676, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryMIMEStream, set_Memory)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElMemoryMIMEStream_set_Memory(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryMIMEStream, get_Bytes)
{
	long l8Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Index) == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElMemoryMIMEStream_get_Bytes(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryMIMEStream, set_Bytes)
{
	long l8Index;
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Index, &u1Value) == SUCCESS)
	{
		SBCheckError(TElMemoryMIMEStream_set_Bytes(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryMIMEStream, get_Words)
{
	long l8Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Index) == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TElMemoryMIMEStream_get_Words(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryMIMEStream, set_Words)
{
	long l8Index;
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Index, &u2Value) == SUCCESS)
	{
		SBCheckError(TElMemoryMIMEStream_set_Words(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMemoryMIMEStream, __construct)
{
	long l8ACapacity;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMemoryMIMEStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8ACapacity) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMemoryMIMEStream_Create_1((int64_t)l8ACapacity, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryMIMEStream_get_Memory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryMIMEStream_set_Memory, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryMIMEStream_get_Bytes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryMIMEStream_set_Bytes, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryMIMEStream_get_Words, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryMIMEStream_set_Words, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMemoryMIMEStream___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, ACapacity)
ZEND_END_ARG_INFO()

static zend_function_entry TElMemoryMIMEStream_methods[] = {
	PHP_ME(TElMemoryMIMEStream, get_Memory, arginfo_TElMemoryMIMEStream_get_Memory, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryMIMEStream, set_Memory, arginfo_TElMemoryMIMEStream_set_Memory, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryMIMEStream, get_Bytes, arginfo_TElMemoryMIMEStream_get_Bytes, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryMIMEStream, set_Bytes, arginfo_TElMemoryMIMEStream_set_Bytes, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryMIMEStream, get_Words, arginfo_TElMemoryMIMEStream_get_Words, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryMIMEStream, set_Words, arginfo_TElMemoryMIMEStream_set_Words, ZEND_ACC_PUBLIC)
	PHP_ME(TElMemoryMIMEStream, __construct, arginfo_TElMemoryMIMEStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElMemoryMIMEStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElMemoryMIMEStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElMemoryMIMEStream", TElMemoryMIMEStream_methods);
	if (NULL == TElCustomMemoryMIMEStream_ce_ptr)
		Register_TElCustomMemoryMIMEStream(TSRMLS_C);
	TElMemoryMIMEStream_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomMemoryMIMEStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TAnsiStringMIMEStream_ce_ptr = NULL;

SB_PHP_METHOD(TAnsiStringMIMEStream, GetAnsiStringMIMEStream_Inst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TAnsiStringMIMEStream_GetAnsiStringMIMEStream_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TAnsiStringMIMEStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TAnsiStringMIMEStream, GetAnsiStringMIMEStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TAnsiStringMIMEStream_GetAnsiStringMIMEStream(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TAnsiStringMIMEStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TAnsiStringMIMEStream, WriteChar)
{
	char *cch;
	int cch_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cch, &cch_len) == SUCCESS) && (1 == cch_len))
	{
		SBCheckError(TAnsiStringMIMEStream_WriteChar(SBGetObjectHandle(getThis() TSRMLS_CC), cch[0]) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TAnsiStringMIMEStream, WriteString)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TAnsiStringMIMEStream_WriteString(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TAnsiStringMIMEStream, get_AnsiLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TAnsiStringMIMEStream_get_AnsiLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TAnsiStringMIMEStream, set_AnsiLength)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TAnsiStringMIMEStream_set_AnsiLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TAnsiStringMIMEStream, get_AnsiData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TAnsiStringMIMEStream_get_AnsiData(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1252582510, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TAnsiStringMIMEStream, set_AnsiData)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TAnsiStringMIMEStream_set_AnsiData(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TAnsiStringMIMEStream, get_Bytes)
{
	long l8Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Index) == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TAnsiStringMIMEStream_get_Bytes(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TAnsiStringMIMEStream, set_Bytes)
{
	long l8Index;
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Index, &u1Value) == SUCCESS)
	{
		SBCheckError(TAnsiStringMIMEStream_set_Bytes(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TAnsiStringMIMEStream, get_Chars)
{
	long l8Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Index) == SUCCESS)
	{
		char cOutResult = '\0';
		SBCheckError(TAnsiStringMIMEStream_get_Chars(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, &cOutResult) TSRMLS_CC);
		RETURN_STRINGL(&cOutResult, 1, 1);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TAnsiStringMIMEStream, set_Chars)
{
	char *cValue;
	int cValue_len;
	long l8Index;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l8Index, &cValue, &cValue_len) == SUCCESS) && (1 == cValue_len))
	{
		SBCheckError(TAnsiStringMIMEStream_set_Chars(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, cValue[0]) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, char)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TAnsiStringMIMEStream, __construct)
{
	char *ssValue;
	int ssValue_len;
	long l8ACapacity;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TAnsiStringMIMEStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &ssValue, &ssValue_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TAnsiStringMIMEStream_Create_1(ssValue, (int32_t)ssValue_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8ACapacity) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TAnsiStringMIMEStream_Create_2((int64_t)l8ACapacity, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream_GetAnsiStringMIMEStream_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream_GetAnsiStringMIMEStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream_WriteChar, 0, 0, 1)
	ZEND_ARG_INFO(0, ch)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream_WriteString, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream_get_AnsiLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream_set_AnsiLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream_get_AnsiData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream_set_AnsiData, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream_get_Bytes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream_set_Bytes, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream_get_Chars, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream_set_Chars, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TAnsiStringMIMEStream___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, sValue_or_ACapacity)
ZEND_END_ARG_INFO()

static zend_function_entry TAnsiStringMIMEStream_methods[] = {
	PHP_ME(TAnsiStringMIMEStream, GetAnsiStringMIMEStream_Inst, arginfo_TAnsiStringMIMEStream_GetAnsiStringMIMEStream_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TAnsiStringMIMEStream, GetAnsiStringMIMEStream, arginfo_TAnsiStringMIMEStream_GetAnsiStringMIMEStream, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TAnsiStringMIMEStream, WriteChar, arginfo_TAnsiStringMIMEStream_WriteChar, ZEND_ACC_PUBLIC)
	PHP_ME(TAnsiStringMIMEStream, WriteString, arginfo_TAnsiStringMIMEStream_WriteString, ZEND_ACC_PUBLIC)
	PHP_ME(TAnsiStringMIMEStream, get_AnsiLength, arginfo_TAnsiStringMIMEStream_get_AnsiLength, ZEND_ACC_PUBLIC)
	PHP_ME(TAnsiStringMIMEStream, set_AnsiLength, arginfo_TAnsiStringMIMEStream_set_AnsiLength, ZEND_ACC_PUBLIC)
	PHP_ME(TAnsiStringMIMEStream, get_AnsiData, arginfo_TAnsiStringMIMEStream_get_AnsiData, ZEND_ACC_PUBLIC)
	PHP_ME(TAnsiStringMIMEStream, set_AnsiData, arginfo_TAnsiStringMIMEStream_set_AnsiData, ZEND_ACC_PUBLIC)
	PHP_ME(TAnsiStringMIMEStream, get_Bytes, arginfo_TAnsiStringMIMEStream_get_Bytes, ZEND_ACC_PUBLIC)
	PHP_ME(TAnsiStringMIMEStream, set_Bytes, arginfo_TAnsiStringMIMEStream_set_Bytes, ZEND_ACC_PUBLIC)
	PHP_ME(TAnsiStringMIMEStream, get_Chars, arginfo_TAnsiStringMIMEStream_get_Chars, ZEND_ACC_PUBLIC)
	PHP_ME(TAnsiStringMIMEStream, set_Chars, arginfo_TAnsiStringMIMEStream_set_Chars, ZEND_ACC_PUBLIC)
	PHP_ME(TAnsiStringMIMEStream, __construct, arginfo_TAnsiStringMIMEStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TAnsiStringMIMEStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TAnsiStringMIMEStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TAnsiStringMIMEStream", TAnsiStringMIMEStream_methods);
	if (NULL == TElCustomMemoryMIMEStream_ce_ptr)
		Register_TElCustomMemoryMIMEStream(TSRMLS_C);
	TAnsiStringMIMEStream_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomMemoryMIMEStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TWideStringMIMEStream_ce_ptr = NULL;

SB_PHP_METHOD(TWideStringMIMEStream, WriteWChar)
{
	char *sch;
	int sch_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sch, &sch_len) == SUCCESS)
	{
		SBCheckError(TWideStringMIMEStream_WriteWChar(SBGetObjectHandle(getThis() TSRMLS_CC), sch, (int32_t)sch_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TWideStringMIMEStream, WriteWString)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TWideStringMIMEStream_WriteWString(SBGetObjectHandle(getThis() TSRMLS_CC), sS, (int32_t)sS_len, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TWideStringMIMEStream, get_CurrentWord)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TWideStringMIMEStream_get_CurrentWord(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TWideStringMIMEStream, get_WideData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TWideStringMIMEStream_get_WideData(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-917883751, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TWideStringMIMEStream, set_WideData)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TWideStringMIMEStream_set_WideData(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TWideStringMIMEStream, get_WideLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TWideStringMIMEStream_get_WideLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TWideStringMIMEStream, set_WideLength)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TWideStringMIMEStream_set_WideLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TWideStringMIMEStream, get_Words)
{
	long l8Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Index) == SUCCESS)
	{
		uint16_t u2OutResultRaw = 0;
		SBCheckError(TWideStringMIMEStream_get_Words(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, &u2OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TWideStringMIMEStream, set_Words)
{
	long l8Index;
	long u2Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Index, &u2Value) == SUCCESS)
	{
		SBCheckError(TWideStringMIMEStream_set_Words(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, (uint16_t)u2Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TWideStringMIMEStream, get_WChars)
{
	long l8Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TWideStringMIMEStream_get_WChars(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1940501803, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TWideStringMIMEStream, set_WChars)
{
	char *sValue;
	int sValue_len;
	long l8Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l8Index, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TWideStringMIMEStream_set_WChars(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Index, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TWideStringMIMEStream, __construct)
{
	char *swsValue;
	int swsValue_len;
	long l8ACapacity;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TWideStringMIMEStream_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &swsValue, &swsValue_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TWideStringMIMEStream_Create_1(swsValue, (int32_t)swsValue_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8ACapacity) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TWideStringMIMEStream_Create_2((int64_t)l8ACapacity, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string) or (integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TWideStringMIMEStream_WriteWChar, 0, 0, 1)
	ZEND_ARG_INFO(0, ch)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TWideStringMIMEStream_WriteWString, 0, 0, 1)
	ZEND_ARG_INFO(0, S)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TWideStringMIMEStream_get_CurrentWord, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TWideStringMIMEStream_get_WideData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TWideStringMIMEStream_set_WideData, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TWideStringMIMEStream_get_WideLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TWideStringMIMEStream_set_WideLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TWideStringMIMEStream_get_Words, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TWideStringMIMEStream_set_Words, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TWideStringMIMEStream_get_WChars, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TWideStringMIMEStream_set_WChars, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TWideStringMIMEStream___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, wsValue_or_ACapacity)
ZEND_END_ARG_INFO()

static zend_function_entry TWideStringMIMEStream_methods[] = {
	PHP_ME(TWideStringMIMEStream, WriteWChar, arginfo_TWideStringMIMEStream_WriteWChar, ZEND_ACC_PUBLIC)
	PHP_ME(TWideStringMIMEStream, WriteWString, arginfo_TWideStringMIMEStream_WriteWString, ZEND_ACC_PUBLIC)
	PHP_ME(TWideStringMIMEStream, get_CurrentWord, arginfo_TWideStringMIMEStream_get_CurrentWord, ZEND_ACC_PUBLIC)
	PHP_ME(TWideStringMIMEStream, get_WideData, arginfo_TWideStringMIMEStream_get_WideData, ZEND_ACC_PUBLIC)
	PHP_ME(TWideStringMIMEStream, set_WideData, arginfo_TWideStringMIMEStream_set_WideData, ZEND_ACC_PUBLIC)
	PHP_ME(TWideStringMIMEStream, get_WideLength, arginfo_TWideStringMIMEStream_get_WideLength, ZEND_ACC_PUBLIC)
	PHP_ME(TWideStringMIMEStream, set_WideLength, arginfo_TWideStringMIMEStream_set_WideLength, ZEND_ACC_PUBLIC)
	PHP_ME(TWideStringMIMEStream, get_Words, arginfo_TWideStringMIMEStream_get_Words, ZEND_ACC_PUBLIC)
	PHP_ME(TWideStringMIMEStream, set_Words, arginfo_TWideStringMIMEStream_set_Words, ZEND_ACC_PUBLIC)
	PHP_ME(TWideStringMIMEStream, get_WChars, arginfo_TWideStringMIMEStream_get_WChars, ZEND_ACC_PUBLIC)
	PHP_ME(TWideStringMIMEStream, set_WChars, arginfo_TWideStringMIMEStream_set_WChars, ZEND_ACC_PUBLIC)
	PHP_ME(TWideStringMIMEStream, __construct, arginfo_TWideStringMIMEStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TWideStringMIMEStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TWideStringMIMEStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TWideStringMIMEStream", TWideStringMIMEStream_methods);
	if (NULL == TElCustomMemoryMIMEStream_ce_ptr)
		Register_TElCustomMemoryMIMEStream(TSRMLS_C);
	TWideStringMIMEStream_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomMemoryMIMEStream_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBMIMEStream, WriteStringToStream)
{
	char *sS;
	int sS_len;
	long l8Count;
	long l8LPos;
	SBArrayZValInfo aiS;
	zval *oStream;
	zval *zaS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!ll", &zaS, &oStream, TStream_ce_ptr, &l8LPos, &l8Count) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		int64_t l8OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBMIMEStream_WriteStringToStream(aiS.data, aiS.len, SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8LPos, (int64_t)l8Count, &l8OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!ll", &sS, &sS_len, &oStream, TStream_ce_ptr, &l8LPos, &l8Count) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(SBMIMEStream_WriteStringToStream_1(sS, (int32_t)sS_len, SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8LPos, (int64_t)l8Count, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TStream, integer, integer) or (string, TStream, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMIMEStream, WriteWideStringToStream)
{
	char *sS;
	int sS_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sS, &sS_len, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(SBMIMEStream_WriteWideStringToStream(sS, (int32_t)sS_len, SBGetObjectHandle(oStream TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TStream)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMIMEStream, WriteStreamToStream)
{
	long l8Count;
	zval *oDest;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oSource, TStream_ce_ptr, &oDest, TStream_ce_ptr, &l8Count) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(SBMIMEStream_WriteStreamToStream(SBGetObjectHandle(oSource TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC), (int64_t)l8Count, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMIMEStream, ReadLineFromStream)
{
	char *ssDest;
	int32_t l4iLineLengthRaw;
	int32_t ssDest_len;
	long l4MaxLineLength;
	uint32_t _err;
	zend_bool bbReadLongLine;
	zend_bool bbSeekLongToEOL;
	zval *osmDest;
	zval *oSource;
	zval *zl4iLineLength;
	zval *zssDest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!zlbb", &oSource, TStream_ce_ptr, &osmDest, TStream_ce_ptr, &zl4iLineLength, &l4MaxLineLength, &bbReadLongLine, &bbSeekLongToEOL) == SUCCESS) && PZVAL_IS_REF(zl4iLineLength) && (IS_LONG == Z_TYPE_P(zl4iLineLength)))
	{
		int8_t bOutResultRaw = 0;
		l4iLineLengthRaw = (int32_t)Z_LVAL_P(zl4iLineLength);
		SBCheckError(SBMIMEStream_ReadLineFromStream(SBGetObjectHandle(oSource TSRMLS_CC), SBGetObjectHandle(osmDest TSRMLS_CC), &l4iLineLengthRaw, (int32_t)l4MaxLineLength, (int8_t)bbReadLongLine, (int8_t)bbSeekLongToEOL, &bOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zl4iLineLength, (long)l4iLineLengthRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlbb", &oSource, TStream_ce_ptr, &zssDest, &l4MaxLineLength, &bbReadLongLine, &bbSeekLongToEOL) == SUCCESS) && PZVAL_IS_REF(zssDest) && (IS_STRING == Z_TYPE_P(zssDest)))
	{
		int8_t bOutResultRaw = 0;
		ssDest = Z_STRVAL_P(zssDest);
		ssDest_len = (int32_t)Z_STRLEN_P(zssDest);
		_err = SBMIMEStream_ReadLineFromStream_1(SBGetObjectHandle(oSource TSRMLS_CC), ssDest, &ssDest_len, (int32_t)l4MaxLineLength, (int8_t)bbReadLongLine, (int8_t)bbSeekLongToEOL, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			ssDest = emalloc(ssDest_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1199552189, 1, ssDest, &ssDest_len) TSRMLS_CC);
			zval_dtor(zssDest);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ssDest[ssDest_len] = 0;
		ZVAL_STRINGL(zssDest, ssDest, ssDest_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream, &integer, integer, bool, bool) or (TStream, &string, integer, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMIMEStream, SeekStreamToEnd)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(SBMIMEStream_SeekStreamToEnd(SBGetObjectHandle(oStream TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

void Register_SBMIMEStream_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBMIMEStream, rsStreamReadError, SB_rsStreamReadError, SB_rsStreamReadError);
	SB_REGISTER_STRING_CONSTANT(SBMIMEStream, rsCannotOpenFile, SB_rsCannotOpenFile, SB_rsCannotOpenFile);
}

void Register_SBMIMEStream_Aliases(TSRMLS_D)
{
	if (NULL == TElCustomMIMEStream_ce_ptr)
		Register_TElCustomMIMEStream(TSRMLS_C);
	zend_register_class_alias("ElCustomStream", TElCustomMIMEStream_ce_ptr);
	if (NULL == TElMemoryMIMEStream_ce_ptr)
		Register_TElMemoryMIMEStream(TSRMLS_C);
	zend_register_class_alias("ElMemoryStream", TElMemoryMIMEStream_ce_ptr);
	if (NULL == TElCustomMemoryMIMEStream_ce_ptr)
		Register_TElCustomMemoryMIMEStream(TSRMLS_C);
	zend_register_class_alias("ElCustomMemoryStream", TElCustomMemoryMIMEStream_ce_ptr);
}

