#include "sbmskeyblob.h"

SB_PHP_FUNCTION(SBMSKeyBlob, WriteMSPublicKeyBlob)
{
	int32_t l4OutSizeRaw;
	long l4BlobType;
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzl", &zpBuffer, &l4Size, &zpOutBuffer, &zl4OutSize, &l4BlobType) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBMSKeyBlob_WriteMSPublicKeyBlob(piBuffer.data, (int32_t)l4Size, piOutBuffer.data, &l4OutSizeRaw, (int32_t)l4BlobType, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMSKeyBlob, WriteMSDSSPublicKeyBlob)
{
	int32_t l4OutSizeRaw;
	long l4GSize;
	long l4PSize;
	long l4QSize;
	long l4YSize;
	SBArrayZValInfo piG;
	SBArrayZValInfo piOutBuffer;
	SBArrayZValInfo piP;
	SBArrayZValInfo piQ;
	SBArrayZValInfo piY;
	zval *zl4OutSize;
	zval *zpG;
	zval *zpOutBuffer;
	zval *zpP;
	zval *zpQ;
	zval *zpY;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzlzlzz", &zpP, &l4PSize, &zpQ, &l4QSize, &zpG, &l4GSize, &zpY, &l4YSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpQ) == IS_STRING) || (Z_TYPE_P(zpQ) == IS_ARRAY) || (Z_TYPE_P(zpQ) == IS_NULL) || ((Z_TYPE_P(zpQ) == IS_OBJECT) && (Z_OBJCE_P(zpQ) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpG) == IS_STRING) || (Z_TYPE_P(zpG) == IS_ARRAY) || (Z_TYPE_P(zpG) == IS_NULL) || ((Z_TYPE_P(zpG) == IS_OBJECT) && (Z_OBJCE_P(zpG) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpY) == IS_STRING) || (Z_TYPE_P(zpY) == IS_ARRAY) || (Z_TYPE_P(zpY) == IS_NULL) || ((Z_TYPE_P(zpY) == IS_OBJECT) && (Z_OBJCE_P(zpY) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpQ, &piQ TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpG, &piG TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpY, &piY TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBMSKeyBlob_WriteMSDSSPublicKeyBlob(piP.data, (int32_t)l4PSize, piQ.data, (int32_t)l4QSize, piG.data, (int32_t)l4GSize, piY.data, (int32_t)l4YSize, piOutBuffer.data, &l4OutSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		SBFreePointerZValInfo(&piQ);
		SBFreePointerZValInfo(&piG);
		SBFreePointerZValInfo(&piY);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMSKeyBlob, ParseMSKeyBlob)
{
	int32_t l4BlobTypeRaw = 0;
	int32_t l4OutSizeRaw;
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *zl4BlobType;
	zval *zl4OutSize;
	zval *zpBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzz", &zpBuffer, &l4Size, &zpOutBuffer, &zl4OutSize, &zl4BlobType) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)) && PZVAL_IS_REF(zl4BlobType) && (IS_LONG == Z_TYPE_P(zl4BlobType)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBMSKeyBlob_ParseMSKeyBlob(piBuffer.data, (int32_t)l4Size, piOutBuffer.data, &l4OutSizeRaw, &l4BlobTypeRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		ZVAL_LONG(zl4BlobType, (long)l4BlobTypeRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMSKeyBlob, WriteMSKeyBlob)
{
	int32_t l4OutSizeRaw;
	long l4Size;
	long u1BlobType;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *zl4OutSize;
	zval *zpBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzl", &zpBuffer, &l4Size, &zpOutBuffer, &zl4OutSize, &u1BlobType) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBMSKeyBlob_WriteMSKeyBlob(piBuffer.data, (int32_t)l4Size, piOutBuffer.data, &l4OutSizeRaw, (uint8_t)u1BlobType, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBMSKeyBlob, WriteMSKeyBlobEx)
{
	int32_t l4OutSizeRaw;
	long l4Size;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *oAlgorithm;
	zval *zl4OutSize;
	zval *zpBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzO!", &zpBuffer, &l4Size, &zpOutBuffer, &zl4OutSize, &oAlgorithm, TElAlgorithmIdentifier_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(SBMSKeyBlob_WriteMSKeyBlobEx(piBuffer.data, (int32_t)l4Size, piOutBuffer.data, &l4OutSizeRaw, SBGetObjectHandle(oAlgorithm TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TElAlgorithmIdentifier)" TSRMLS_CC);
	}
}

void Register_SBMSKeyBlob_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBMSKeyBlob, SB_MSKEYBLOB_ERROR_UNSUPPORTED_BLOB_TYPE, SB_MSKEYBLOB_ERROR_UNSUPPORTED_BLOB_TYPE, SB_MSKEYBLOB_ERROR_UNSUPPORTED_BLOB_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBMSKeyBlob, SB_MSKEYBLOB_ERROR_INVALID_FORMAT, SB_MSKEYBLOB_ERROR_INVALID_FORMAT, SB_MSKEYBLOB_ERROR_INVALID_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBMSKeyBlob, SB_MSKEYBLOB_ERROR_UNSUPPORTED_VERSION, SB_MSKEYBLOB_ERROR_UNSUPPORTED_VERSION, SB_MSKEYBLOB_ERROR_UNSUPPORTED_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBMSKeyBlob, SB_MSKEYBLOB_ERROR_BUFFER_TOO_SMALL, SB_MSKEYBLOB_ERROR_BUFFER_TOO_SMALL, SB_MSKEYBLOB_ERROR_BUFFER_TOO_SMALL);
	SB_REGISTER_LONG_CONSTANT(SBMSKeyBlob, SB_MSKEYBLOB_ERROR_NO_PRIVATE_KEY, SB_MSKEYBLOB_ERROR_NO_PRIVATE_KEY, SB_MSKEYBLOB_ERROR_NO_PRIVATE_KEY);
	SB_REGISTER_LONG_CONSTANT(SBMSKeyBlob, SB_MSKEYBLOB_ERROR_UNSUPPORTED_ALGORITHM, SB_MSKEYBLOB_ERROR_UNSUPPORTED_ALGORITHM, SB_MSKEYBLOB_ERROR_UNSUPPORTED_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBMSKeyBlob, SB_KEY_BLOB_RSA, SB_KEY_BLOB_RSA, SB_KEY_BLOB_RSA);
	SB_REGISTER_LONG_CONSTANT(SBMSKeyBlob, SB_KEY_BLOB_DSS, SB_KEY_BLOB_DSS, SB_KEY_BLOB_DSS);
}

