#include "sbofficecommon.h"

zend_class_entry *TSBOfficeDocumentFormat_ce_ptr = NULL;

zend_class_entry *TSBOfficeBinaryDocumentType_ce_ptr = NULL;

zend_class_entry *TSBOfficeOpenXMLDocumentType_ce_ptr = NULL;

zend_class_entry *TSBOpenOfficeDocumentType_ce_ptr = NULL;

SB_PHP_METHOD(TSBOfficeVersion, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBOfficeVersion));
		intern->len = sizeof(TSBOfficeVersion);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBOfficeVersion, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBOfficeVersion));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TSBOfficeVersion, get_Major)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBOfficeVersion, set_Major)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TSBOfficeVersion, get_Minor)
{
	SBStuctGetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

SB_PHP_METHOD(TSBOfficeVersion, set_Minor)
{
	SBStuctSetFieldUInt16(INTERNAL_FUNCTION_PARAM_PASSTHRU, 2);
}

zend_class_entry *TSBOfficeVersion_ce_ptr = NULL;

static zend_function_entry TSBOfficeVersion_methods[] = {
	PHP_ME(TSBOfficeVersion, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBOfficeVersion, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TSBOfficeVersion, get_Major, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBOfficeVersion, set_Major, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBOfficeVersion, get_Minor, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TSBOfficeVersion, set_Minor, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBOfficeVersion(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBOfficeVersion_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBOfficeVersion", TSBOfficeVersion_methods);
	TSBOfficeVersion_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

void SB_CALLBACK TSBOfficeCreateTemporaryStreamEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t ExpectedSize, TStreamHandle * Stream, int8_t * FreeOnClose)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zExpectedSize;
	zval * zStream;
	zval * zFreeOnClose;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zExpectedSize);
	ZVAL_LONG(zExpectedSize, (long)ExpectedSize);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, *Stream TSRMLS_CC);
	MAKE_STD_ZVAL(zFreeOnClose);
	ZVAL_BOOL(zFreeOnClose, (zend_bool)*FreeOnClose);

	params[0] = &zSender;
	params[1] = &zExpectedSize;
	params[2] = &zStream;
	params[3] = &zFreeOnClose;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zExpectedSize);
	*Stream = SBGetObjectHandleCE(zStream, TStream_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zStream TSRMLS_CC);
	zval_ptr_dtor(&zStream);
	*FreeOnClose = (int8_t)Z_BVAL_P(zFreeOnClose);
	zval_ptr_dtor(&zFreeOnClose);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBOfficeCloseTemporaryStreamEventRaw(void * _ObjectData, TObjectHandle Sender, TStreamHandle Stream)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zStream;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zStream);
	SBInitObject(zStream, TStream_ce_ptr, Stream TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zStream;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zStream);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBOfficeProgressEventRaw(void * _ObjectData, TObjectHandle Sender, int32_t Percent, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zPercent;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zPercent);
	ZVAL_LONG(zPercent, (long)Percent);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zPercent;
	params[2] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zPercent);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void Register_SBOfficeCommon_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBOfficeDocumentFormat", NULL);
	TSBOfficeDocumentFormat_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBOfficeDocumentFormat_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeDocumentFormat_ce_ptr, "dfUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeDocumentFormat_ce_ptr, "dfBinary", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeDocumentFormat_ce_ptr, "dfOpenXML", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeDocumentFormat_ce_ptr, "dfOpenXPS", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeDocumentFormat_ce_ptr, "dfOpenDocument", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBOfficeBinaryDocumentType", NULL);
	TSBOfficeBinaryDocumentType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBOfficeBinaryDocumentType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeBinaryDocumentType_ce_ptr, "dtUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeBinaryDocumentType_ce_ptr, "dtDocument", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeBinaryDocumentType_ce_ptr, "dtSpreadsheet", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeBinaryDocumentType_ce_ptr, "dtPresentation", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBOfficeOpenXMLDocumentType", NULL);
	TSBOfficeOpenXMLDocumentType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBOfficeOpenXMLDocumentType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLDocumentType_ce_ptr, "xdtUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLDocumentType_ce_ptr, "xdtDocument", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLDocumentType_ce_ptr, "xdtDocumentTemplate", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLDocumentType_ce_ptr, "xdtSpreadsheet", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLDocumentType_ce_ptr, "xdtSpreadsheetTemplate", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLDocumentType_ce_ptr, "xdtSpreadsheetBinary", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLDocumentType_ce_ptr, "xdtSpreadsheetAddIn", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLDocumentType_ce_ptr, "xdtPresentation", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLDocumentType_ce_ptr, "xdtPresentationTemplate", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLDocumentType_ce_ptr, "xdtPresentationSlideshow", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLDocumentType_ce_ptr, "xdtPresentationAddIn", 10)
	
	INIT_CLASS_ENTRY(ce, "TSBOpenOfficeDocumentType", NULL);
	TSBOpenOfficeDocumentType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBOpenOfficeDocumentType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtText", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtTextTemplate", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtTextMaster", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtTextWeb", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtSpreadsheet", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtSpreadsheetTemplate", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtDrawing", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtDrawingTemplate", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtPresentation", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtPresentationTemplate", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtChart", 11)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtChartTemplate", 12)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtImage", 13)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtImageTemplate", 14)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtFormula", 15)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtFormulaTemplate", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBOpenOfficeDocumentType_ce_ptr, "odtDatabase", 17)
}

