#include "sbotpclient.h"

zend_class_entry *TElOTPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElOTPClient, get_KeySecret)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOTPClient_get_KeySecret(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-167926331, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPClient, set_KeySecret)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOTPClient_set_KeySecret(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPClient, get_PasswordLen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOTPClient_get_PasswordLen(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPClient, set_PasswordLen)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOTPClient_set_PasswordLen(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOTPClient, __construct)
{
	long l4PasswordLength;
	SBArrayZValInfo aiKeySecret;
	zval *zaKeySecret;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaKeySecret, &l4PasswordLength) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKeySecret)) || (IS_ARRAY == Z_TYPE_P(zaKeySecret)) || (IS_NULL == Z_TYPE_P(zaKeySecret))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKeySecret, &aiKeySecret TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOTPClient_Create(aiKeySecret.data, aiKeySecret.len, (int32_t)l4PasswordLength, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKeySecret);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPClient_get_KeySecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPClient_set_KeySecret, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPClient_get_PasswordLen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPClient_set_PasswordLen, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPClient___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, KeySecret, 0, 1)
	ZEND_ARG_INFO(0, PasswordLength)
ZEND_END_ARG_INFO()

static zend_function_entry TElOTPClient_methods[] = {
	PHP_ME(TElOTPClient, get_KeySecret, arginfo_TElOTPClient_get_KeySecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPClient, set_KeySecret, arginfo_TElOTPClient_set_KeySecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPClient, get_PasswordLen, arginfo_TElOTPClient_get_PasswordLen, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPClient, set_PasswordLen, arginfo_TElOTPClient_set_PasswordLen, ZEND_ACC_PUBLIC)
	PHP_ME(TElOTPClient, __construct, arginfo_TElOTPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOTPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOTPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOTPClient", TElOTPClient_methods);
	if (NULL == TElOTPClass_ce_ptr)
		Register_TElOTPClass(TSRMLS_C);
	TElOTPClient_ce_ptr = zend_register_internal_class_ex(&ce, TElOTPClass_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHOTPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElHOTPClient, GetPassword)
{
	long l4Counter;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Counter) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHOTPClient_GetPassword(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Counter, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(663750392, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPClient, __construct)
{
	long l4PasswordLength;
	SBArrayZValInfo aiKeySecret;
	zval *zaKeySecret;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaKeySecret, &l4PasswordLength) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKeySecret)) || (IS_ARRAY == Z_TYPE_P(zaKeySecret)) || (IS_NULL == Z_TYPE_P(zaKeySecret))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKeySecret, &aiKeySecret TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElHOTPClient_Create(aiKeySecret.data, aiKeySecret.len, (int32_t)l4PasswordLength, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKeySecret);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPClient_GetPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Counter)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPClient___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, KeySecret, 0, 1)
	ZEND_ARG_INFO(0, PasswordLength)
ZEND_END_ARG_INFO()

static zend_function_entry TElHOTPClient_methods[] = {
	PHP_ME(TElHOTPClient, GetPassword, arginfo_TElHOTPClient_GetPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElHOTPClient, __construct, arginfo_TElHOTPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHOTPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHOTPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHOTPClient", TElHOTPClient_methods);
	if (NULL == TElOTPClient_ce_ptr)
		Register_TElOTPClient(TSRMLS_C);
	TElHOTPClient_ce_ptr = zend_register_internal_class_ex(&ce, TElOTPClient_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElTOTPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElTOTPClient, GetPassword)
{
	uint32_t _err;
	zval *dtTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTOTPClient_GetPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(466775757, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtTime, php_date_get_date_ce()) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTOTPClient_GetPassword_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtTime TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-142408417, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("() or (DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPClient, get_TimeInterval)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTOTPClient_get_TimeInterval(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPClient, set_TimeInterval)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTOTPClient_set_TimeInterval(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPClient, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTOTPClient_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPClient, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTOTPClient_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPClient, __construct)
{
	long l4PasswordLength;
	SBArrayZValInfo aiKeySecret;
	zval *zaKeySecret;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaKeySecret, &l4PasswordLength) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKeySecret)) || (IS_ARRAY == Z_TYPE_P(zaKeySecret)) || (IS_NULL == Z_TYPE_P(zaKeySecret))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKeySecret, &aiKeySecret TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElTOTPClient_Create(aiKeySecret.data, aiKeySecret.len, (int32_t)l4PasswordLength, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKeySecret);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPClient_GetPassword, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Time, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPClient_get_TimeInterval, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPClient_set_TimeInterval, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPClient_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPClient_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPClient___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, KeySecret, 0, 1)
	ZEND_ARG_INFO(0, PasswordLength)
ZEND_END_ARG_INFO()

static zend_function_entry TElTOTPClient_methods[] = {
	PHP_ME(TElTOTPClient, GetPassword, arginfo_TElTOTPClient_GetPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPClient, get_TimeInterval, arginfo_TElTOTPClient_get_TimeInterval, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPClient, set_TimeInterval, arginfo_TElTOTPClient_set_TimeInterval, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPClient, get_HashAlgorithm, arginfo_TElTOTPClient_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPClient, set_HashAlgorithm, arginfo_TElTOTPClient_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPClient, __construct, arginfo_TElTOTPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTOTPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTOTPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTOTPClient", TElTOTPClient_methods);
	if (NULL == TElOTPClient_ce_ptr)
		Register_TElOTPClient(TSRMLS_C);
	TElTOTPClient_ce_ptr = zend_register_internal_class_ex(&ce, TElOTPClient_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBOTPClient_Aliases(TSRMLS_D)
{
	if (NULL == TElOTPClient_ce_ptr)
		Register_TElOTPClient(TSRMLS_C);
	zend_register_class_alias("ElOTPClient", TElOTPClient_ce_ptr);
	if (NULL == TElHOTPClient_ce_ptr)
		Register_TElHOTPClient(TSRMLS_C);
	zend_register_class_alias("ElHOTPClient", TElHOTPClient_ce_ptr);
	if (NULL == TElTOTPClient_ce_ptr)
		Register_TElTOTPClient(TSRMLS_C);
	zend_register_class_alias("ElTOTPClient", TElTOTPClient_ce_ptr);
}

