#include "sbotpcommon.h"

zend_class_entry *TElOTPClass_ce_ptr = NULL;

SB_PHP_METHOD(TElOTPClass, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOTPClass_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOTPClass___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOTPClass_methods[] = {
	PHP_ME(TElOTPClass, __construct, arginfo_TElOTPClass___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOTPClass(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOTPClass_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOTPClass", TElOTPClass_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElOTPClass_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElHOTPPasswordGenerator_ce_ptr = NULL;

SB_PHP_METHOD(TElHOTPPasswordGenerator, GeneratePassword)
{
	long l4Counter;
	SBArrayZValInfo aiHashedData;
	uint32_t _err;
	zval *zaHashedData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHashedData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHashedData)) || (IS_ARRAY == Z_TYPE_P(zaHashedData)) || (IS_NULL == Z_TYPE_P(zaHashedData))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaHashedData, &aiHashedData TSRMLS_CC)) RETURN_FALSE;
		_err = TElHOTPPasswordGenerator_GeneratePassword(SBGetObjectHandle(getThis() TSRMLS_CC), aiHashedData.data, aiHashedData.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-618202767, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiHashedData);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Counter) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElHOTPPasswordGenerator_GeneratePassword_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Counter, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(252697245, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPPasswordGenerator, get_KeySecret)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElHOTPPasswordGenerator_get_KeySecret(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1042395144, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPPasswordGenerator, set_KeySecret)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElHOTPPasswordGenerator_set_KeySecret(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPPasswordGenerator, get_PasswordLen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElHOTPPasswordGenerator_get_PasswordLen(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPPasswordGenerator, set_PasswordLen)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElHOTPPasswordGenerator_set_PasswordLen(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElHOTPPasswordGenerator, __construct)
{
	long l4PasswordLength;
	SBArrayZValInfo aiKeySecret;
	zval *zaKeySecret;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaKeySecret, &l4PasswordLength) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKeySecret)) || (IS_ARRAY == Z_TYPE_P(zaKeySecret)) || (IS_NULL == Z_TYPE_P(zaKeySecret))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKeySecret, &aiKeySecret TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElHOTPPasswordGenerator_Create(aiKeySecret.data, aiKeySecret.len, (int32_t)l4PasswordLength, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKeySecret);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPPasswordGenerator_GeneratePassword, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, HashedData_or_Counter, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPPasswordGenerator_get_KeySecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPPasswordGenerator_set_KeySecret, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPPasswordGenerator_get_PasswordLen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPPasswordGenerator_set_PasswordLen, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElHOTPPasswordGenerator___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, KeySecret, 0, 1)
	ZEND_ARG_INFO(0, PasswordLength)
ZEND_END_ARG_INFO()

static zend_function_entry TElHOTPPasswordGenerator_methods[] = {
	PHP_ME(TElHOTPPasswordGenerator, GeneratePassword, arginfo_TElHOTPPasswordGenerator_GeneratePassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElHOTPPasswordGenerator, get_KeySecret, arginfo_TElHOTPPasswordGenerator_get_KeySecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElHOTPPasswordGenerator, set_KeySecret, arginfo_TElHOTPPasswordGenerator_set_KeySecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElHOTPPasswordGenerator, get_PasswordLen, arginfo_TElHOTPPasswordGenerator_get_PasswordLen, ZEND_ACC_PUBLIC)
	PHP_ME(TElHOTPPasswordGenerator, set_PasswordLen, arginfo_TElHOTPPasswordGenerator_set_PasswordLen, ZEND_ACC_PUBLIC)
	PHP_ME(TElHOTPPasswordGenerator, __construct, arginfo_TElHOTPPasswordGenerator___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElHOTPPasswordGenerator(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElHOTPPasswordGenerator_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElHOTPPasswordGenerator", TElHOTPPasswordGenerator_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElHOTPPasswordGenerator_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElTOTPPasswordGenerator_ce_ptr = NULL;

SB_PHP_METHOD(TElTOTPPasswordGenerator, GeneratePassword)
{
	long l4Counter;
	SBArrayZValInfo aiHashedData;
	uint32_t _err;
	zval *dtTime;
	zval *zaHashedData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtTime, php_date_get_date_ce()) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTOTPPasswordGenerator_GeneratePassword(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtTime TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1775725731, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHashedData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHashedData)) || (IS_ARRAY == Z_TYPE_P(zaHashedData)) || (IS_NULL == Z_TYPE_P(zaHashedData))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaHashedData, &aiHashedData TSRMLS_CC)) RETURN_FALSE;
		_err = TElTOTPPasswordGenerator_GeneratePassword_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiHashedData.data, aiHashedData.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-618202767, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiHashedData);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Counter) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElTOTPPasswordGenerator_GeneratePassword_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Counter, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(252697245, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime) or (array of byte|string|NULL) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPPasswordGenerator, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTOTPPasswordGenerator_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPPasswordGenerator, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTOTPPasswordGenerator_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPPasswordGenerator, get_TimeInterval)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTOTPPasswordGenerator_get_TimeInterval(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPPasswordGenerator, set_TimeInterval)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTOTPPasswordGenerator_set_TimeInterval(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTOTPPasswordGenerator, __construct)
{
	long l4PasswordLength;
	SBArrayZValInfo aiKeySecret;
	zval *zaKeySecret;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaKeySecret, &l4PasswordLength) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKeySecret)) || (IS_ARRAY == Z_TYPE_P(zaKeySecret)) || (IS_NULL == Z_TYPE_P(zaKeySecret))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaKeySecret, &aiKeySecret TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElTOTPPasswordGenerator_Create(aiKeySecret.data, aiKeySecret.len, (int32_t)l4PasswordLength, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKeySecret);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPPasswordGenerator_GeneratePassword, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Time_or_HashedData_or_Counter, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPPasswordGenerator_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPPasswordGenerator_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPPasswordGenerator_get_TimeInterval, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPPasswordGenerator_set_TimeInterval, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTOTPPasswordGenerator___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, KeySecret, 0, 1)
	ZEND_ARG_INFO(0, PasswordLength)
ZEND_END_ARG_INFO()

static zend_function_entry TElTOTPPasswordGenerator_methods[] = {
	PHP_ME(TElTOTPPasswordGenerator, GeneratePassword, arginfo_TElTOTPPasswordGenerator_GeneratePassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPPasswordGenerator, get_HashAlgorithm, arginfo_TElTOTPPasswordGenerator_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPPasswordGenerator, set_HashAlgorithm, arginfo_TElTOTPPasswordGenerator_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPPasswordGenerator, get_TimeInterval, arginfo_TElTOTPPasswordGenerator_get_TimeInterval, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPPasswordGenerator, set_TimeInterval, arginfo_TElTOTPPasswordGenerator_set_TimeInterval, ZEND_ACC_PUBLIC)
	PHP_ME(TElTOTPPasswordGenerator, __construct, arginfo_TElTOTPPasswordGenerator___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTOTPPasswordGenerator(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTOTPPasswordGenerator_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTOTPPasswordGenerator", TElTOTPPasswordGenerator_methods);
	if (NULL == TElHOTPPasswordGenerator_ce_ptr)
		Register_TElHOTPPasswordGenerator(TSRMLS_C);
	TElTOTPPasswordGenerator_ce_ptr = zend_register_internal_class_ex(&ce, TElHOTPPasswordGenerator_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBOTPCommon_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBOTPCommon, SB_OTP_ERROR_NOT_SUPPORTED_ALGORITHM, SB_OTP_ERROR_NOT_SUPPORTED_ALGORITHM, SB_OTP_ERROR_NOT_SUPPORTED_ALGORITHM);
	SB_REGISTER_STRING_CONSTANT(SBOTPCommon, SB_OTP_ERROR_KEY_EMPTY, SB_OTP_ERROR_KEY_EMPTY, SB_OTP_ERROR_KEY_EMPTY);
	SB_REGISTER_STRING_CONSTANT(SBOTPCommon, SB_OTP_ERROR_NO_PASSWORD_LENGTH, SB_OTP_ERROR_NO_PASSWORD_LENGTH, SB_OTP_ERROR_NO_PASSWORD_LENGTH);
	SB_REGISTER_STRING_CONSTANT(SBOTPCommon, SB_OTP_ERROR_DATA_TOO_LONG, SB_OTP_ERROR_DATA_TOO_LONG, SB_OTP_ERROR_DATA_TOO_LONG);
	SB_REGISTER_STRING_CONSTANT(SBOTPCommon, SB_OTP_ERROR_DATA_EMPTY, SB_OTP_ERROR_DATA_EMPTY, SB_OTP_ERROR_DATA_EMPTY);
	SB_REGISTER_STRING_CONSTANT(SBOTPCommon, SB_OTP_ERROR_COUNTER_INCORRECT, SB_OTP_ERROR_COUNTER_INCORRECT, SB_OTP_ERROR_COUNTER_INCORRECT);
	SB_REGISTER_STRING_CONSTANT(SBOTPCommon, SB_OTP_NO_USER_STORAGE, SB_OTP_NO_USER_STORAGE, SB_OTP_NO_USER_STORAGE);
	SB_REGISTER_STRING_CONSTANT(SBOTPCommon, SB_OTP_EMPTY_USER_STORAGE, SB_OTP_EMPTY_USER_STORAGE, SB_OTP_EMPTY_USER_STORAGE);
	SB_REGISTER_STRING_CONSTANT(SBOTPCommon, SB_OTP_NO_FIND_USER, SB_OTP_NO_FIND_USER, SB_OTP_NO_FIND_USER);
	SB_REGISTER_STRING_CONSTANT(SBOTPCommon, SB_OTP_NOT_IMPLEMENTED, SB_OTP_NOT_IMPLEMENTED, SB_OTP_NOT_IMPLEMENTED);
	SB_REGISTER_STRING_CONSTANT(SBOTPCommon, SB_OTP_INVALID_TYPE_CAST, SB_OTP_INVALID_TYPE_CAST, SB_OTP_INVALID_TYPE_CAST);
	SB_REGISTER_LONG_CONSTANT(SBOTPCommon, SB_ALGORITHM_OTP_BASE, SB_ALGORITHM_OTP_BASE, SB_ALGORITHM_OTP_BASE);
	SB_REGISTER_LONG_CONSTANT(SBOTPCommon, SB_ALGORITHM_OTP_HMAC_BASED, SB_ALGORITHM_OTP_HMAC_BASED, SB_ALGORITHM_OTP_HMAC_BASED);
	SB_REGISTER_LONG_CONSTANT(SBOTPCommon, SB_ALGORITHM_OTP_TIME_BASED, SB_ALGORITHM_OTP_TIME_BASED, SB_ALGORITHM_OTP_TIME_BASED);
}

void Register_SBOTPCommon_Aliases(TSRMLS_D)
{
	if (NULL == TElOTPClass_ce_ptr)
		Register_TElOTPClass(TSRMLS_C);
	zend_register_class_alias("ElOTPClass", TElOTPClass_ce_ptr);
	if (NULL == TElHOTPPasswordGenerator_ce_ptr)
		Register_TElHOTPPasswordGenerator(TSRMLS_C);
	zend_register_class_alias("ElHOTPPasswordGenerator", TElHOTPPasswordGenerator_ce_ptr);
	if (NULL == TElTOTPPasswordGenerator_ce_ptr)
		Register_TElTOTPPasswordGenerator(TSRMLS_C);
	zend_register_class_alias("ElTOTPPasswordGenerator", TElTOTPPasswordGenerator_ce_ptr);
}

