#include "sbpkcs12.h"

zend_class_entry *TElPKCS12Message_ce_ptr = NULL;

SB_PHP_METHOD(TElPKCS12Message, LoadFromBuffer)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPKCS12Message_LoadFromBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, SaveToBuffer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(TElPKCS12Message_SaveToBuffer(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, &l4SizeRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, get_Iterations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS12Message_get_Iterations(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, set_Iterations)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPKCS12Message_set_Iterations(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, get_Password)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPKCS12Message_get_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1830180685, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, set_Password)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPKCS12Message_set_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, get_Certificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS12Message_get_Certificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMemoryCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, get_CRLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS12Message_get_CRLs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElMemoryCRLStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, get_KeyEncryptionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS12Message_get_KeyEncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, set_KeyEncryptionAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPKCS12Message_set_KeyEncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, get_CertEncryptionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS12Message_get_CertEncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, set_CertEncryptionAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPKCS12Message_set_CertEncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, get_CRLEncryptionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPKCS12Message_get_CRLEncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, set_CRLEncryptionAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPKCS12Message_set_CRLEncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, get_UseEmptyPasswordWorkaround)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPKCS12Message_get_UseEmptyPasswordWorkaround(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, set_UseEmptyPasswordWorkaround)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPKCS12Message_set_UseEmptyPasswordWorkaround(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS12Message_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPKCS12Message_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPKCS12Message, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPKCS12Message_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_LoadFromBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_SaveToBuffer, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_get_Iterations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_set_Iterations, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_get_Password, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_set_Password, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_get_Certificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_get_CRLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_get_KeyEncryptionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_set_KeyEncryptionAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_get_CertEncryptionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_set_CertEncryptionAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_get_CRLEncryptionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_set_CRLEncryptionAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_get_UseEmptyPasswordWorkaround, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_set_UseEmptyPasswordWorkaround, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPKCS12Message___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPKCS12Message_methods[] = {
	PHP_ME(TElPKCS12Message, LoadFromBuffer, arginfo_TElPKCS12Message_LoadFromBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, SaveToBuffer, arginfo_TElPKCS12Message_SaveToBuffer, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, get_Iterations, arginfo_TElPKCS12Message_get_Iterations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, set_Iterations, arginfo_TElPKCS12Message_set_Iterations, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, get_Password, arginfo_TElPKCS12Message_get_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, set_Password, arginfo_TElPKCS12Message_set_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, get_Certificates, arginfo_TElPKCS12Message_get_Certificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, get_CRLs, arginfo_TElPKCS12Message_get_CRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, get_KeyEncryptionAlgorithm, arginfo_TElPKCS12Message_get_KeyEncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, set_KeyEncryptionAlgorithm, arginfo_TElPKCS12Message_set_KeyEncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, get_CertEncryptionAlgorithm, arginfo_TElPKCS12Message_get_CertEncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, set_CertEncryptionAlgorithm, arginfo_TElPKCS12Message_set_CertEncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, get_CRLEncryptionAlgorithm, arginfo_TElPKCS12Message_get_CRLEncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, set_CRLEncryptionAlgorithm, arginfo_TElPKCS12Message_set_CRLEncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, get_UseEmptyPasswordWorkaround, arginfo_TElPKCS12Message_get_UseEmptyPasswordWorkaround, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, set_UseEmptyPasswordWorkaround, arginfo_TElPKCS12Message_set_UseEmptyPasswordWorkaround, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, get_CryptoProviderManager, arginfo_TElPKCS12Message_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, set_CryptoProviderManager, arginfo_TElPKCS12Message_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElPKCS12Message, __construct, arginfo_TElPKCS12Message___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPKCS12Message(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPKCS12Message_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPKCS12Message", TElPKCS12Message_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElPKCS12Message_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBPKCS12, BufToInt)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPKCS12_BufToInt(piBuffer.data, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPKCS12, IntToBuf)
{
	long l4Number;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Number) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBPKCS12_IntToBuf((int32_t)l4Number, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1000526241, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPKCS12, RaisePKCS12Error)
{
	long l4ErrorCode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4ErrorCode) == SUCCESS)
	{
		SBCheckError(SBPKCS12_RaisePKCS12Error((int32_t)l4ErrorCode) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

void Register_SBPKCS12_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, ERROR_FACILITY_PKCS12, SB_ERROR_FACILITY_PKCS12, SB_ERROR_FACILITY_PKCS12);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_ASN_DATA, SB_PKCS12_ERROR_INVALID_ASN_DATA, SB_PKCS12_ERROR_INVALID_ASN_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_NO_DATA, SB_PKCS12_ERROR_NO_DATA, SB_PKCS12_ERROR_NO_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_DATA, SB_PKCS12_ERROR_INVALID_DATA, SB_PKCS12_ERROR_INVALID_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_VERSION, SB_PKCS12_ERROR_INVALID_VERSION, SB_PKCS12_ERROR_INVALID_VERSION);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_CONTENT, SB_PKCS12_ERROR_INVALID_CONTENT, SB_PKCS12_ERROR_INVALID_CONTENT);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_AUTHENTICATED_SAFE_DATA, SB_PKCS12_ERROR_INVALID_AUTHENTICATED_SAFE_DATA, SB_PKCS12_ERROR_INVALID_AUTHENTICATED_SAFE_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_MAC_DATA, SB_PKCS12_ERROR_INVALID_MAC_DATA, SB_PKCS12_ERROR_INVALID_MAC_DATA);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_SAFE_CONTENTS, SB_PKCS12_ERROR_INVALID_SAFE_CONTENTS, SB_PKCS12_ERROR_INVALID_SAFE_CONTENTS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_SAFE_BAG, SB_PKCS12_ERROR_INVALID_SAFE_BAG, SB_PKCS12_ERROR_INVALID_SAFE_BAG);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_SHROUDED_KEY_BAG, SB_PKCS12_ERROR_INVALID_SHROUDED_KEY_BAG, SB_PKCS12_ERROR_INVALID_SHROUDED_KEY_BAG);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_UNKNOWN_PBE_ALGORITHM, SB_PKCS12_ERROR_UNKNOWN_PBE_ALGORITHM, SB_PKCS12_ERROR_UNKNOWN_PBE_ALGORITHM);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INTERNAL_ERROR, SB_PKCS12_ERROR_INTERNAL_ERROR, SB_PKCS12_ERROR_INTERNAL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_PBE_ALGORITHM_PARAMS, SB_PKCS12_ERROR_INVALID_PBE_ALGORITHM_PARAMS, SB_PKCS12_ERROR_INVALID_PBE_ALGORITHM_PARAMS);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_CERT_BAG, SB_PKCS12_ERROR_INVALID_CERT_BAG, SB_PKCS12_ERROR_INVALID_CERT_BAG);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_UNSUPPORTED_CERTIFICATE_TYPE, SB_PKCS12_ERROR_UNSUPPORTED_CERTIFICATE_TYPE, SB_PKCS12_ERROR_UNSUPPORTED_CERTIFICATE_TYPE);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_PRIVATE_KEY, SB_PKCS12_ERROR_INVALID_PRIVATE_KEY, SB_PKCS12_ERROR_INVALID_PRIVATE_KEY);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_MAC, SB_PKCS12_ERROR_INVALID_MAC, SB_PKCS12_ERROR_INVALID_MAC);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_NO_CERTIFICATES, SB_PKCS12_ERROR_NO_CERTIFICATES, SB_PKCS12_ERROR_NO_CERTIFICATES);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_PASSWORD, SB_PKCS12_ERROR_INVALID_PASSWORD, SB_PKCS12_ERROR_INVALID_PASSWORD);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_BUFFER_TOO_SMALL, SB_PKCS12_ERROR_BUFFER_TOO_SMALL, SB_PKCS12_ERROR_BUFFER_TOO_SMALL);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_INVALID_CRL_BAG, SB_PKCS12_ERROR_INVALID_CRL_BAG, SB_PKCS12_ERROR_INVALID_CRL_BAG);
	SB_REGISTER_LONG_CONSTANT(SBPKCS12, SB_PKCS12_ERROR_UNSUPPORTED_CRL_TYPE, SB_PKCS12_ERROR_UNSUPPORTED_CRL_TYPE, SB_PKCS12_ERROR_UNSUPPORTED_CRL_TYPE);
}

void Register_SBPKCS12_Aliases(TSRMLS_D)
{
	if (NULL == TElPKCS12Message_ce_ptr)
		Register_TElPKCS12Message(TSRMLS_C);
	zend_register_class_alias("ElPKCS12Message", TElPKCS12Message_ce_ptr);
}

