#include "sbpoly1305.h"

SB_PHP_METHOD(TSBPoly1305Part, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBPoly1305Part));
		intern->len = sizeof(TSBPoly1305Part);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBPoly1305Part, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBPoly1305Part));
}

zend_class_entry *TSBPoly1305Part_ce_ptr = NULL;

static zend_function_entry TSBPoly1305Part_methods[] = {
	PHP_ME(TSBPoly1305Part, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPoly1305Part, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSBPoly1305Part(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBPoly1305Part_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBPoly1305Part", TSBPoly1305Part_methods);
	TSBPoly1305Part_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSBPoly1305MultRes, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBPoly1305MultRes));
		intern->len = sizeof(TSBPoly1305MultRes);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBPoly1305MultRes, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBPoly1305MultRes));
}

zend_class_entry *TSBPoly1305MultRes_ce_ptr = NULL;

static zend_function_entry TSBPoly1305MultRes_methods[] = {
	PHP_ME(TSBPoly1305MultRes, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPoly1305MultRes, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSBPoly1305MultRes(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBPoly1305MultRes_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBPoly1305MultRes", TSBPoly1305MultRes_methods);
	TSBPoly1305MultRes_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TSBPoly1305Tag, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TSBPoly1305Tag));
		intern->len = sizeof(TSBPoly1305Tag);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TSBPoly1305Tag, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TSBPoly1305Tag));
}

zend_class_entry *TSBPoly1305Tag_ce_ptr = NULL;

static zend_function_entry TSBPoly1305Tag_methods[] = {
	PHP_ME(TSBPoly1305Tag, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TSBPoly1305Tag, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TSBPoly1305Tag(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBPoly1305Tag_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TSBPoly1305Tag", TSBPoly1305Tag_methods);
	TSBPoly1305Tag_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBPoly1305Mode_ce_ptr = NULL;

SB_PHP_FUNCTION(SBPoly1305, Poly1305Clamp)
{
	zval *oR;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oR, TSBPoly1305Part_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oR))
	{
		SBCheckError(SBPoly1305_Poly1305Clamp((TSBPoly1305Part *)SBGetStructPointer(oR TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBPoly1305Part)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPoly1305, Poly1305Add)
{
	zval *oA;
	zval *oB;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oB, TSBPoly1305Part_ce_ptr, &oA, TSBPoly1305Part_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		SBCheckError(SBPoly1305_Poly1305Add((TSBPoly1305Part *)SBGetStructPointer(oB TSRMLS_CC), (TSBPoly1305Part *)SBGetStructPointer(oA TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPoly1305Part, &TSBPoly1305Part)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPoly1305, Poly1305Mult)
{
	zval *oA;
	zval *oB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oB, TSBPoly1305Part_ce_ptr, &oA, TSBPoly1305Part_ce_ptr) == SUCCESS)
	{
		TSBPoly1305MultRes roOutResult;
		SBCheckError(SBPoly1305_Poly1305Mult((TSBPoly1305Part *)SBGetStructPointer(oB TSRMLS_CC), (TSBPoly1305Part *)SBGetStructPointer(oA TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPoly1305MultRes_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBPoly1305MultRes) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPoly1305Part, TSBPoly1305Part)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPoly1305, Poly1305Squeeze)
{
	zval *oB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oB, TSBPoly1305MultRes_ce_ptr) == SUCCESS)
	{
		TSBPoly1305Part roOutResult;
		SBCheckError(SBPoly1305_Poly1305Squeeze((TSBPoly1305MultRes *)SBGetStructPointer(oB TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPoly1305Part_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBPoly1305Part) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPoly1305MultRes)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPoly1305, Poly1305Final)
{
	zval *oA;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oA, TSBPoly1305Part_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oA))
	{
		SBCheckError(SBPoly1305_Poly1305Final((TSBPoly1305Part *)SBGetStructPointer(oA TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TSBPoly1305Part)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBPoly1305, GeneratePoly1305)
{
	SBArrayZValInfo aiKey;
	SBArrayZValInfo aiMsg;
	zval *zaKey;
	zval *zaMsg;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaKey, &zaMsg) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && ((IS_STRING == Z_TYPE_P(zaMsg)) || (IS_ARRAY == Z_TYPE_P(zaMsg)) || (IS_NULL == Z_TYPE_P(zaMsg))))
	{
		TSBPoly1305Tag roOutResult;
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaMsg, &aiMsg TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBPoly1305_GeneratePoly1305(aiKey.data, aiKey.len, aiMsg.data, aiMsg.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
		SBFreeArrayZValInfo(&aiMsg);
		object_init_ex(return_value, TSBPoly1305Tag_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBPoly1305Tag) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

void Register_SBPoly1305_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBPoly1305, TPoly1305PartSize, SB_TPoly1305PartSize, SB_TPoly1305PartSize);
	SB_REGISTER_LONG_CONSTANT(SBPoly1305, TPoly1305KeySize, SB_TPoly1305KeySize, SB_TPoly1305KeySize);
}

void Register_SBPoly1305_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPoly1305Mode", NULL);
	TSBPoly1305Mode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPoly1305Mode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPoly1305Mode_ce_ptr, "pmDefault", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPoly1305Mode_ce_ptr, "pmOpenSSH", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPoly1305Mode_ce_ptr, "pmSSL", 2)
}

