#include "sbrc4.h"

SB_PHP_METHOD(TRC4ExpandedKey, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TRC4ExpandedKey));
		intern->len = sizeof(TRC4ExpandedKey);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TRC4ExpandedKey, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TRC4ExpandedKey));
}

zend_class_entry *TRC4ExpandedKey_ce_ptr = NULL;

static zend_function_entry TRC4ExpandedKey_methods[] = {
	PHP_ME(TRC4ExpandedKey, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4ExpandedKey, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TRC4ExpandedKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TRC4ExpandedKey_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TRC4ExpandedKey", TRC4ExpandedKey_methods);
	TRC4ExpandedKey_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_METHOD(TRC4Context, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TRC4Context));
		intern->len = sizeof(TRC4Context);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TRC4Context, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TRC4Context));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TRC4Context, get_L)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TRC4Context, set_L)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 0);
}

SB_PHP_METHOD(TRC4Context, get_K)
{
	SBStuctGetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

SB_PHP_METHOD(TRC4Context, set_K)
{
	SBStuctSetFieldUInt8(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1);
}

zend_class_entry *TRC4Context_ce_ptr = NULL;

static zend_function_entry TRC4Context_methods[] = {
	PHP_ME(TRC4Context, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4Context, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TRC4Context, get_L, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4Context, set_L, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4Context, get_K, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TRC4Context, set_K, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TRC4Context(TSRMLS_D)
{
	zend_class_entry ce;
	if (TRC4Context_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TRC4Context", TRC4Context_methods);
	TRC4Context_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBRC4, Initialize)
{
	SBArrayZValInfo aiKey;
	zval *oContext;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Oz", &oContext, TRC4Context_ce_ptr, &zaKey) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))))
	{
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRC4_Initialize((TRC4Context *)SBGetStructPointer(oContext TSRMLS_CC), aiKey.data, aiKey.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
	}
	else
	{
		SBErrorExpectsArguments("(&TRC4Context, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRC4, Encrypt)
{
	long l4Size;
	long u4Size;
	SBArrayZValInfo piBuf;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuf;
	SBArrayZValInfo piOutBuffer;
	zval *oContext;
	zval *oExpandedKey;
	zval *zpBuf;
	zval *zpInBuffer;
	zval *zpOutBuf;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozzl", &oContext, TRC4Context_ce_ptr, &zpBuf, &zpOutBuf, &u4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuf) == IS_STRING) || (Z_TYPE_P(zpOutBuf) == IS_ARRAY) || (Z_TYPE_P(zpOutBuf) == IS_NULL) || ((Z_TYPE_P(zpOutBuf) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuf) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuf, &piOutBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRC4_Encrypt((TRC4Context *)SBGetStructPointer(oContext TSRMLS_CC), piBuf.data, piOutBuf.data, (uint32_t)u4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		SBFreePointerZValInfo(&piOutBuf);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlOz", &zpInBuffer, &l4Size, &oExpandedKey, TRC4ExpandedKey_ce_ptr, &zpOutBuffer) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRC4_Encrypt_1(piInBuffer.data, (int32_t)l4Size, (TRC4ExpandedKey *)SBGetStructPointer(oExpandedKey TSRMLS_CC), piOutBuffer.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(&TRC4Context, TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer, TRC4ExpandedKey, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRC4, Decrypt)
{
	long l4Size;
	long u4Size;
	SBArrayZValInfo piBuf;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuf;
	SBArrayZValInfo piOutBuffer;
	zval *oContext;
	zval *oExpandedKey;
	zval *zpBuf;
	zval *zpInBuffer;
	zval *zpOutBuf;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozzl", &oContext, TRC4Context_ce_ptr, &zpBuf, &zpOutBuf, &u4Size) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpBuf) == IS_STRING) || (Z_TYPE_P(zpBuf) == IS_ARRAY) || (Z_TYPE_P(zpBuf) == IS_NULL) || ((Z_TYPE_P(zpBuf) == IS_OBJECT) && (Z_OBJCE_P(zpBuf) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuf) == IS_STRING) || (Z_TYPE_P(zpOutBuf) == IS_ARRAY) || (Z_TYPE_P(zpOutBuf) == IS_NULL) || ((Z_TYPE_P(zpOutBuf) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuf) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuf, &piBuf TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuf, &piOutBuf TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRC4_Decrypt((TRC4Context *)SBGetStructPointer(oContext TSRMLS_CC), piBuf.data, piOutBuf.data, (uint32_t)u4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuf);
		SBFreePointerZValInfo(&piOutBuf);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlOz", &zpInBuffer, &l4Size, &oExpandedKey, TRC4ExpandedKey_ce_ptr, &zpOutBuffer) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBRC4_Decrypt_1(piInBuffer.data, (int32_t)l4Size, (TRC4ExpandedKey *)SBGetStructPointer(oExpandedKey TSRMLS_CC), piOutBuffer.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(&TRC4Context, TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string|NULL, integer) or (TSBPointer|array of byte|string|NULL, integer, TRC4ExpandedKey, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBRC4, NFinalize)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TRC4Context_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBRC4_NFinalize((TRC4Context *)SBGetStructPointer(oContext TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&TRC4Context)" TSRMLS_CC);
	}
}

