#include "sbrestclient.h"

zend_class_entry *TSBRESTResponseType_ce_ptr = NULL;

zend_class_entry *TElRESTClient_ce_ptr = NULL;

SB_PHP_METHOD(TElRESTClient, Post)
{
	char *sContent;
	char *sURL;
	int sContent_len;
	int sURL_len;
	SBArrayZValInfo aiContent;
	zend_bool bCloseStream;
	zval *oContent;
	zval *zaContent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oContent, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRESTClient_Post(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oContent TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oContent, TElJsonEntity_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRESTClient_Post_1(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oContent TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRESTClient_Post_2(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sURL, &sURL_len, &sContent, &sContent_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRESTClient_Post_3(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sContent, (int32_t)sContent_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sURL, &sURL_len, &zaContent) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaContent)) || (IS_ARRAY == Z_TYPE_P(zaContent)) || (IS_NULL == Z_TYPE_P(zaContent))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaContent, &aiContent TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRESTClient_Post_4(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, aiContent.data, aiContent.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiContent);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!b", &sURL, &sURL_len, &oContent, TStream_ce_ptr, &bCloseStream) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRESTClient_Post_5(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oContent TSRMLS_CC), (int8_t)bCloseStream, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXMLDOMDocument) or (string, TElJsonEntity) or (string) or (string, string) or (string, array of byte|string|NULL) or (string, TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, Put)
{
	char *sContent;
	char *sURL;
	int sContent_len;
	int sURL_len;
	long l4Count;
	long l4StartIndex;
	SBArrayZValInfo aiContent;
	zend_bool bCloseStream;
	zval *oContent;
	zval *zaContent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oContent, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRESTClient_Put(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oContent TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sURL, &sURL_len, &oContent, TElJsonEntity_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRESTClient_Put_1(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oContent TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURL, &sURL_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRESTClient_Put_2(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sURL, &sURL_len, &sContent, &sContent_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRESTClient_Put_3(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, sContent, (int32_t)sContent_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sURL, &sURL_len, &zaContent) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaContent)) || (IS_ARRAY == Z_TYPE_P(zaContent)) || (IS_NULL == Z_TYPE_P(zaContent))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaContent, &aiContent TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRESTClient_Put_4(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, aiContent.data, aiContent.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiContent);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szll", &sURL, &sURL_len, &zaContent, &l4StartIndex, &l4Count) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaContent)) || (IS_ARRAY == Z_TYPE_P(zaContent)) || (IS_NULL == Z_TYPE_P(zaContent))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaContent, &aiContent TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElRESTClient_Put_5(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, aiContent.data, aiContent.len, (int32_t)l4StartIndex, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiContent);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!b", &sURL, &sURL_len, &oContent, TStream_ce_ptr, &bCloseStream) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRESTClient_Put_6(SBGetObjectHandle(getThis() TSRMLS_CC), sURL, (int32_t)sURL_len, SBGetObjectHandle(oContent TSRMLS_CC), (int8_t)bCloseStream, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElXMLDOMDocument) or (string, TElJsonEntity) or (string) or (string, string) or (string, array of byte|string|NULL) or (string, array of byte|string|NULL, integer, integer) or (string, TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, get_XMLCanonicalizationMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLCanonicalizationMethodRaw fOutResultRaw = 0;
		SBCheckError(TElRESTClient_get_XMLCanonicalizationMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, set_XMLCanonicalizationMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElRESTClient_set_XMLCanonicalizationMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, get_XMLCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElRESTClient_get_XMLCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-33353051, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, set_XMLCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElRESTClient_set_XMLCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, get_JSONIndentChar)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char cOutResult = '\0';
		SBCheckError(TElRESTClient_get_JSONIndentChar(SBGetObjectHandle(getThis() TSRMLS_CC), &cOutResult) TSRMLS_CC);
		RETURN_STRINGL(&cOutResult, 1, 1);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, set_JSONIndentChar)
{
	char *cValue;
	int cValue_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cValue, &cValue_len) == SUCCESS) && (1 == cValue_len))
	{
		SBCheckError(TElRESTClient_set_JSONIndentChar(SBGetObjectHandle(getThis() TSRMLS_CC), cValue[0]) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, get_JSONCharsPerIndentLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElRESTClient_get_JSONCharsPerIndentLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, set_JSONCharsPerIndentLevel)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElRESTClient_set_JSONCharsPerIndentLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, get_ResponseType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBRESTResponseTypeRaw fOutResultRaw = 0;
		SBCheckError(TElRESTClient_get_ResponseType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, get_ResponseXML)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRESTClient_get_ResponseXML(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMDocument_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, get_ResponseJSON)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRESTClient_get_ResponseJSON(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElJsonEntity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, get_ResponseText)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElRESTClient_get_ResponseText(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1164557465, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElRESTClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElRESTClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_Post, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_TYPE_INFO(0, Content, 0, 1)
	ZEND_ARG_INFO(0, CloseStream)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_Put, 0, 0, 1)
	ZEND_ARG_INFO(0, URL)
	ZEND_ARG_TYPE_INFO(0, Content, 0, 1)
	ZEND_ARG_INFO(0, StartIndex_or_CloseStream)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_get_XMLCanonicalizationMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_set_XMLCanonicalizationMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_get_XMLCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_set_XMLCharset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_get_JSONIndentChar, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_set_JSONIndentChar, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_get_JSONCharsPerIndentLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_set_JSONCharsPerIndentLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_get_ResponseType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_get_ResponseXML, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_get_ResponseJSON, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient_get_ResponseText, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElRESTClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElRESTClient_methods[] = {
	PHP_ME(TElRESTClient, Post, arginfo_TElRESTClient_Post, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, Put, arginfo_TElRESTClient_Put, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, get_XMLCanonicalizationMethod, arginfo_TElRESTClient_get_XMLCanonicalizationMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, set_XMLCanonicalizationMethod, arginfo_TElRESTClient_set_XMLCanonicalizationMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, get_XMLCharset, arginfo_TElRESTClient_get_XMLCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, set_XMLCharset, arginfo_TElRESTClient_set_XMLCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, get_JSONIndentChar, arginfo_TElRESTClient_get_JSONIndentChar, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, set_JSONIndentChar, arginfo_TElRESTClient_set_JSONIndentChar, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, get_JSONCharsPerIndentLevel, arginfo_TElRESTClient_get_JSONCharsPerIndentLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, set_JSONCharsPerIndentLevel, arginfo_TElRESTClient_set_JSONCharsPerIndentLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, get_ResponseType, arginfo_TElRESTClient_get_ResponseType, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, get_ResponseXML, arginfo_TElRESTClient_get_ResponseXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, get_ResponseJSON, arginfo_TElRESTClient_get_ResponseJSON, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, get_ResponseText, arginfo_TElRESTClient_get_ResponseText, ZEND_ACC_PUBLIC)
	PHP_ME(TElRESTClient, __construct, arginfo_TElRESTClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElRESTClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElRESTClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElRESTClient", TElRESTClient_methods);
	if (NULL == TElHTTPSClient_ce_ptr)
		Register_TElHTTPSClient(TSRMLS_C);
	TElRESTClient_ce_ptr = zend_register_internal_class_ex(&ce, TElHTTPSClient_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBRESTClient_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBRESTResponseType", NULL);
	TSBRESTResponseType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBRESTResponseType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBRESTResponseType_ce_ptr, "rrtUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBRESTResponseType_ce_ptr, "rrtXML", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBRESTResponseType_ce_ptr, "rrtJSON", 2)
}

void Register_SBRESTClient_Aliases(TSRMLS_D)
{
	if (NULL == TElRESTClient_ce_ptr)
		Register_TElRESTClient(TSRMLS_C);
	zend_register_class_alias("ElRESTClient", TElRESTClient_ce_ptr);
}

