#include "sbsimpleftpsserver.h"

void SB_CALLBACK TSBSimpleFTPSServerNewConnectionEventRaw(void * _ObjectData, TObjectHandle Sender, TElSimpleFTPSServerSessionThreadHandle Session)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zSession;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSession);
	SBInitObject(zSession, TElSimpleFTPSServerSessionThread_ce_ptr, Session TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSession;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSession);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSimpleFTPSServerCloseConnectionEventRaw(void * _ObjectData, TObjectHandle Sender, TElSimpleFTPSServerSessionThreadHandle Session)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zSession;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSession);
	SBInitObject(zSession, TElSimpleFTPSServerSessionThread_ce_ptr, Session TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSession;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSession);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBFTPSServerExceptionEventRaw(void * _ObjectData, TObjectHandle Sender, TElClassHandle Ex)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zEx;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zEx);
	SBInitObject(zEx, TObject_ce_ptr, Ex TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zEx;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zEx);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSimpleFTPSListenerNewConnectionEventRaw(void * _ObjectData, TObjectHandle Sender, TElSocketHandle Socket, int8_t * Reject)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zSocket;
	zval * zReject;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSocket);
	SBInitObject(zSocket, TElSocket_ce_ptr, Socket TSRMLS_CC);
	MAKE_STD_ZVAL(zReject);
	ZVAL_BOOL(zReject, (zend_bool)*Reject);

	params[0] = &zSender;
	params[1] = &zSocket;
	params[2] = &zReject;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSocket);
	*Reject = (int8_t)Z_BVAL_P(zReject);
	zval_ptr_dtor(&zReject);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSimpleFTPSServerBeforeNewConnectionEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcRemoteIP, int32_t szRemoteIP, int32_t RemotePort, int8_t * Reject)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zRemoteIP;
	zval * zRemotePort;
	zval * zReject;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zRemoteIP);
	ZVAL_STRINGL(zRemoteIP, pcRemoteIP, szRemoteIP, 1);
	MAKE_STD_ZVAL(zRemotePort);
	ZVAL_LONG(zRemotePort, (long)RemotePort);
	MAKE_STD_ZVAL(zReject);
	ZVAL_BOOL(zReject, (zend_bool)*Reject);

	params[0] = &zSender;
	params[1] = &zRemoteIP;
	params[2] = &zRemotePort;
	params[3] = &zReject;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zRemoteIP);
	zval_ptr_dtor(&zRemotePort);
	*Reject = (int8_t)Z_BVAL_P(zReject);
	zval_ptr_dtor(&zReject);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSimpleFTPSServerAuthAttemptEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcUsername, int32_t szUsername, const char * pcPassword, int32_t szPassword, int8_t * Allow)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zUsername;
	zval * zPassword;
	zval * zAllow;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUsername);
	ZVAL_STRINGL(zUsername, pcUsername, szUsername, 1);
	MAKE_STD_ZVAL(zPassword);
	ZVAL_STRINGL(zPassword, pcPassword, szPassword, 1);
	MAKE_STD_ZVAL(zAllow);
	ZVAL_BOOL(zAllow, (zend_bool)*Allow);

	params[0] = &zSender;
	params[1] = &zUsername;
	params[2] = &zPassword;
	params[3] = &zAllow;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUsername);
	zval_ptr_dtor(&zPassword);
	*Allow = (int8_t)Z_BVAL_P(zAllow);
	zval_ptr_dtor(&zAllow);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElSimpleFTPSServerSessionThread_ce_ptr = NULL;

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_Socket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_Socket(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSocket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_FTPSServer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_FTPSServer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElFTPSServer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_ListenAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleFTPSServerSessionThread_get_ListenAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(874621573, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_ListenAddress)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_ListenAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_PassiveModeAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleFTPSServerSessionThread_get_PassiveModeAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1665518132, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_PassiveModeAddress)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_PassiveModeAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_SessionTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_SessionTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_SessionTimeout)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_SessionTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_SocketTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_SocketTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_SocketTimeout)
{
	long u4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_SocketTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (uint32_t)u4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_IncomingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_IncomingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OutgoingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OutgoingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_DataPortRangeFrom)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_DataPortRangeFrom(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_DataPortRangeFrom)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_DataPortRangeFrom(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_DataPortRangeTo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_DataPortRangeTo(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_DataPortRangeTo)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_DataPortRangeTo(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_AllowAnonymous)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_AllowAnonymous(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_AllowAnonymous)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_AllowAnonymous(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_RootDirectory)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleFTPSServerSessionThread_get_RootDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1617174827, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_RootDirectory)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_RootDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_CurrentDirectory)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleFTPSServerSessionThread_get_CurrentDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1353375132, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_CurrentDirectory)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_CurrentDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_AnonymousLogin)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_AnonymousLogin(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_DataConnectionOpened)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_DataConnectionOpened(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_FileSystemAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_FileSystemAdapter)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomFileSystemAdapter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomFileSystemAdapter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_ReleaseFileSystemAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_ReleaseFileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_ReleaseFileSystemAdapter)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_ReleaseFileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OutgoingLocalBinding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OutgoingLocalBinding(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientSocketBinding_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OutgoingLocalBinding)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElClientSocketBinding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OutgoingLocalBinding(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientSocketBinding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OnAuthAttempt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSimpleFTPSServerAuthAttemptEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OnAuthAttempt(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OnAuthAttempt)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OnAuthAttempt(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSimpleFTPSServerAuthAttemptEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSimpleFTPSServerAuthAttemptEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OnCommandReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerCommandReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OnCommandReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OnCommandReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OnCommandReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerCommandReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerCommandReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OnBeforeSendReply)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerBeforeSendReplyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OnBeforeSendReply(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OnBeforeSendReply)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OnBeforeSendReply(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerBeforeSendReplyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerBeforeSendReplyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OnCommandProcessed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerCommandProcessedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OnCommandProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OnCommandProcessed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OnCommandProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerCommandProcessedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerCommandProcessedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OnTransferProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerTransferProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OnTransferProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OnTransferProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OnTransferProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerTransferProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerTransferProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OnTransferCompleted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OnTransferCompleted(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OnTransferCompleted)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OnTransferCompleted(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OnClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OnClose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OnClose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OnClose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OnException)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerExceptionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OnException(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OnException)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OnException(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerExceptionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerExceptionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OnCommandUnhandled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerCommandUnhandledEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OnCommandUnhandled(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OnCommandUnhandled)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OnCommandUnhandled(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerCommandUnhandledEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerCommandUnhandledEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OnSiteCommand)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerSiteCommandEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OnSiteCommand(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OnSiteCommand)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OnSiteCommand(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerSiteCommandEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerSiteCommandEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, get_OnFileAllocate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerFileAllocateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_get_OnFileAllocate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, set_OnFileAllocate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerSessionThread_set_OnFileAllocate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerFileAllocateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerFileAllocateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerSessionThread, __construct)
{
	zval *oSocket;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSocket, TElSocket_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerSessionThread_Create(SBGetObjectHandle(oSocket TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSocket)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_Socket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_FTPSServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_ListenAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_ListenAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_PassiveModeAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_PassiveModeAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_SessionTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_SessionTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_SocketTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_SocketTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_IncomingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_IncomingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OutgoingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OutgoingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_DataPortRangeFrom, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_DataPortRangeFrom, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_DataPortRangeTo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_DataPortRangeTo, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_AllowAnonymous, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_AllowAnonymous, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_RootDirectory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_RootDirectory, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_CurrentDirectory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_CurrentDirectory, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_AnonymousLogin, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_DataConnectionOpened, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_FileSystemAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_FileSystemAdapter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomFileSystemAdapter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_ReleaseFileSystemAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_ReleaseFileSystemAdapter, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OutgoingLocalBinding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OutgoingLocalBinding, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElClientSocketBinding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OnAuthAttempt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OnAuthAttempt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OnCommandReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OnCommandReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OnBeforeSendReply, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OnBeforeSendReply, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OnCommandProcessed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OnCommandProcessed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OnTransferProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OnTransferProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OnTransferCompleted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OnTransferCompleted, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OnClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OnClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OnException, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OnException, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OnCommandUnhandled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OnCommandUnhandled, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OnSiteCommand, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OnSiteCommand, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_get_OnFileAllocate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread_set_OnFileAllocate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerSessionThread___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Socket, TElSocket, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSimpleFTPSServerSessionThread_methods[] = {
	PHP_ME(TElSimpleFTPSServerSessionThread, get_Socket, arginfo_TElSimpleFTPSServerSessionThread_get_Socket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_FTPSServer, arginfo_TElSimpleFTPSServerSessionThread_get_FTPSServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_ListenAddress, arginfo_TElSimpleFTPSServerSessionThread_get_ListenAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_ListenAddress, arginfo_TElSimpleFTPSServerSessionThread_set_ListenAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_PassiveModeAddress, arginfo_TElSimpleFTPSServerSessionThread_get_PassiveModeAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_PassiveModeAddress, arginfo_TElSimpleFTPSServerSessionThread_set_PassiveModeAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_SessionTimeout, arginfo_TElSimpleFTPSServerSessionThread_get_SessionTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_SessionTimeout, arginfo_TElSimpleFTPSServerSessionThread_set_SessionTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_SocketTimeout, arginfo_TElSimpleFTPSServerSessionThread_get_SocketTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_SocketTimeout, arginfo_TElSimpleFTPSServerSessionThread_set_SocketTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_IncomingSpeedLimit, arginfo_TElSimpleFTPSServerSessionThread_get_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_IncomingSpeedLimit, arginfo_TElSimpleFTPSServerSessionThread_set_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OutgoingSpeedLimit, arginfo_TElSimpleFTPSServerSessionThread_get_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OutgoingSpeedLimit, arginfo_TElSimpleFTPSServerSessionThread_set_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_DataPortRangeFrom, arginfo_TElSimpleFTPSServerSessionThread_get_DataPortRangeFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_DataPortRangeFrom, arginfo_TElSimpleFTPSServerSessionThread_set_DataPortRangeFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_DataPortRangeTo, arginfo_TElSimpleFTPSServerSessionThread_get_DataPortRangeTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_DataPortRangeTo, arginfo_TElSimpleFTPSServerSessionThread_set_DataPortRangeTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_AllowAnonymous, arginfo_TElSimpleFTPSServerSessionThread_get_AllowAnonymous, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_AllowAnonymous, arginfo_TElSimpleFTPSServerSessionThread_set_AllowAnonymous, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_RootDirectory, arginfo_TElSimpleFTPSServerSessionThread_get_RootDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_RootDirectory, arginfo_TElSimpleFTPSServerSessionThread_set_RootDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_CurrentDirectory, arginfo_TElSimpleFTPSServerSessionThread_get_CurrentDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_CurrentDirectory, arginfo_TElSimpleFTPSServerSessionThread_set_CurrentDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_AnonymousLogin, arginfo_TElSimpleFTPSServerSessionThread_get_AnonymousLogin, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_DataConnectionOpened, arginfo_TElSimpleFTPSServerSessionThread_get_DataConnectionOpened, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_FileSystemAdapter, arginfo_TElSimpleFTPSServerSessionThread_get_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_FileSystemAdapter, arginfo_TElSimpleFTPSServerSessionThread_set_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_ReleaseFileSystemAdapter, arginfo_TElSimpleFTPSServerSessionThread_get_ReleaseFileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_ReleaseFileSystemAdapter, arginfo_TElSimpleFTPSServerSessionThread_set_ReleaseFileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OutgoingLocalBinding, arginfo_TElSimpleFTPSServerSessionThread_get_OutgoingLocalBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OutgoingLocalBinding, arginfo_TElSimpleFTPSServerSessionThread_set_OutgoingLocalBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OnAuthAttempt, arginfo_TElSimpleFTPSServerSessionThread_get_OnAuthAttempt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OnAuthAttempt, arginfo_TElSimpleFTPSServerSessionThread_set_OnAuthAttempt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OnCommandReceived, arginfo_TElSimpleFTPSServerSessionThread_get_OnCommandReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OnCommandReceived, arginfo_TElSimpleFTPSServerSessionThread_set_OnCommandReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OnBeforeSendReply, arginfo_TElSimpleFTPSServerSessionThread_get_OnBeforeSendReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OnBeforeSendReply, arginfo_TElSimpleFTPSServerSessionThread_set_OnBeforeSendReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OnCommandProcessed, arginfo_TElSimpleFTPSServerSessionThread_get_OnCommandProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OnCommandProcessed, arginfo_TElSimpleFTPSServerSessionThread_set_OnCommandProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OnTransferProgress, arginfo_TElSimpleFTPSServerSessionThread_get_OnTransferProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OnTransferProgress, arginfo_TElSimpleFTPSServerSessionThread_set_OnTransferProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OnTransferCompleted, arginfo_TElSimpleFTPSServerSessionThread_get_OnTransferCompleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OnTransferCompleted, arginfo_TElSimpleFTPSServerSessionThread_set_OnTransferCompleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OnClose, arginfo_TElSimpleFTPSServerSessionThread_get_OnClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OnClose, arginfo_TElSimpleFTPSServerSessionThread_set_OnClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OnException, arginfo_TElSimpleFTPSServerSessionThread_get_OnException, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OnException, arginfo_TElSimpleFTPSServerSessionThread_set_OnException, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OnCommandUnhandled, arginfo_TElSimpleFTPSServerSessionThread_get_OnCommandUnhandled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OnCommandUnhandled, arginfo_TElSimpleFTPSServerSessionThread_set_OnCommandUnhandled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OnSiteCommand, arginfo_TElSimpleFTPSServerSessionThread_get_OnSiteCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OnSiteCommand, arginfo_TElSimpleFTPSServerSessionThread_set_OnSiteCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, get_OnFileAllocate, arginfo_TElSimpleFTPSServerSessionThread_get_OnFileAllocate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, set_OnFileAllocate, arginfo_TElSimpleFTPSServerSessionThread_set_OnFileAllocate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerSessionThread, __construct, arginfo_TElSimpleFTPSServerSessionThread___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSimpleFTPSServerSessionThread(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSimpleFTPSServerSessionThread_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSimpleFTPSServerSessionThread", TElSimpleFTPSServerSessionThread_methods);
	if (NULL == TThread_ce_ptr)
		Register_TThread(TSRMLS_C);
	TElSimpleFTPSServerSessionThread_ce_ptr = zend_register_internal_class_ex(&ce, TThread_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSimpleFTPSServer_ce_ptr = NULL;

SB_PHP_METHOD(TElSimpleFTPSServer, Start)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_Start(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, Stop)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_Stop(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_MessageTable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_MessageTable(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElFTPSServerMessageTable_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OutgoingLocalBinding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OutgoingLocalBinding(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientSocketBinding_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OutgoingLocalBinding)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElClientSocketBinding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_OutgoingLocalBinding(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientSocketBinding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_SocketSettings)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_SocketSettings(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSocketSettings_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_CipherSuites)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_CipherSuites(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_CipherSuites)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_CipherSuites(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_CipherSuitePriorities)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_CipherSuitePriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_CipherSuitePriorities)
{
	long l4Value;
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_CipherSuitePriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_CompressionAlgorithms)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_CompressionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_CompressionAlgorithms)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_CompressionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_Versions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBVersionsRaw fOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_Versions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBVersionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_ClientAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_ClientAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_ClientAuthentication)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_ClientAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_AuthenticationLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAuthenticationLevelRaw fOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_AuthenticationLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_AuthenticationLevel)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_AuthenticationLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAuthenticationLevelRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_ForceCertificateChain)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_ForceCertificateChain(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_ForceCertificateChain)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_ForceCertificateChain(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_SessionPool)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_SessionPool(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSessionPool_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_SessionPool)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSessionPool_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_SessionPool(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSessionPool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_ClientCertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_ClientCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_ClientCertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_ClientCertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_Host)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleFTPSServer_get_Host(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1601017945, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_Host)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_Host(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_PassiveModeHost)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleFTPSServer_get_PassiveModeHost(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(335640102, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_PassiveModeHost)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_PassiveModeHost(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_DataHost)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleFTPSServer_get_DataHost(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-197029138, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_DataHost)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_DataHost(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_Port)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_DataPortRangeFrom)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_DataPortRangeFrom(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_DataPortRangeFrom)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_DataPortRangeFrom(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_DataPortRangeTo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_DataPortRangeTo(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_DataPortRangeTo)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_DataPortRangeTo(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSimpleFTPSServer, get_UseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_UseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSimpleFTPSServer, get_SessionTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_SessionTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_SessionTimeout)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_SessionTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_RootDirectory)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleFTPSServer_get_RootDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(865367131, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_RootDirectory)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_RootDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_ReadOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_ReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_ReadOnly)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_ReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_IncomingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_IncomingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OutgoingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OutgoingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_FileSystemAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_FileSystemAdapter)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomFileSystemAdapter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomFileSystemAdapter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_AllowAnonymous)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_AllowAnonymous(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_AllowAnonymous)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_AllowAnonymous(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_ImplicitSSL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_ImplicitSSL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_ImplicitSSL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_ImplicitSSL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_UseUTF8)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleFTPSServer_get_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_UseUTF8)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServer_set_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_Users)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_Users(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElFTPSUsers_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnBeforeNewConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSimpleFTPSServerBeforeNewConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnBeforeNewConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnBeforeNewConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnBeforeNewConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSimpleFTPSServerBeforeNewConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSimpleFTPSServerBeforeNewConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnNewConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSimpleFTPSServerNewConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnNewConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnNewConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnNewConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSimpleFTPSServerNewConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSimpleFTPSServerNewConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnCloseConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSimpleFTPSServerCloseConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnCloseConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSimpleFTPSServerCloseConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSimpleFTPSServerCloseConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnAuthAttempt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSimpleFTPSServerAuthAttemptEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnAuthAttempt(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnAuthAttempt)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnAuthAttempt(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSimpleFTPSServerAuthAttemptEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSimpleFTPSServerAuthAttemptEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnCommandReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerCommandReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnCommandReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnCommandReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnCommandReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerCommandReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerCommandReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnBeforeSendReply)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerBeforeSendReplyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnBeforeSendReply(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnBeforeSendReply)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnBeforeSendReply(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerBeforeSendReplyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerBeforeSendReplyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnCommandProcessed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerCommandProcessedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnCommandProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnCommandProcessed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnCommandProcessed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerCommandProcessedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerCommandProcessedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnTransferProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerTransferProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnTransferProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnTransferProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnTransferProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerTransferProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerTransferProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnTransferCompleted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnTransferCompleted(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnTransferCompleted)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnTransferCompleted(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnSessionException)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerExceptionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnSessionException(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnSessionException)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnSessionException(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerExceptionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerExceptionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnCommandUnhandled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerCommandUnhandledEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnCommandUnhandled(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnCommandUnhandled)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnCommandUnhandled(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerCommandUnhandledEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerCommandUnhandledEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnSiteCommand)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerSiteCommandEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnSiteCommand(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnSiteCommand)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnSiteCommand(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerSiteCommandEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerSiteCommandEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, get_OnFileAllocate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBFTPSServerFileAllocateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_get_OnFileAllocate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, set_OnFileAllocate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServer_set_OnFileAllocate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBFTPSServerFileAllocateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBFTPSServerFileAllocateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServer, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServer_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_Start, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_Stop, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_MessageTable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OutgoingLocalBinding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OutgoingLocalBinding, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElClientSocketBinding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_SocketSettings, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_CipherSuites, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_CipherSuites, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_CipherSuitePriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_CipherSuitePriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_CompressionAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_CompressionAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_Versions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_Versions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_ClientAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_ClientAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_AuthenticationLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_AuthenticationLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_ForceCertificateChain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_ForceCertificateChain, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_SessionPool, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_SessionPool, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSessionPool, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_ClientCertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_ClientCertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_Host, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_Host, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_PassiveModeHost, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_PassiveModeHost, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_DataHost, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_DataHost, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_DataPortRangeFrom, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_DataPortRangeFrom, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_DataPortRangeTo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_DataPortRangeTo, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_UseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_UseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_SessionTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_SessionTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_RootDirectory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_RootDirectory, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_ReadOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_ReadOnly, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_IncomingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_IncomingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OutgoingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OutgoingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_FileSystemAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_FileSystemAdapter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomFileSystemAdapter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_AllowAnonymous, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_AllowAnonymous, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_ImplicitSSL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_ImplicitSSL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_UseUTF8, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_UseUTF8, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_Users, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnBeforeNewConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnBeforeNewConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnNewConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnNewConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnCloseConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnCloseConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnAuthAttempt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnAuthAttempt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnCommandReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnCommandReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnBeforeSendReply, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnBeforeSendReply, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnCommandProcessed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnCommandProcessed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnTransferProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnTransferProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnTransferCompleted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnTransferCompleted, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnSessionException, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnSessionException, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnCommandUnhandled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnCommandUnhandled, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnSiteCommand, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnSiteCommand, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_get_OnFileAllocate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer_set_OnFileAllocate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSimpleFTPSServer_methods[] = {
	PHP_ME(TElSimpleFTPSServer, Start, arginfo_TElSimpleFTPSServer_Start, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, Stop, arginfo_TElSimpleFTPSServer_Stop, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_Active, arginfo_TElSimpleFTPSServer_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_MessageTable, arginfo_TElSimpleFTPSServer_get_MessageTable, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OutgoingLocalBinding, arginfo_TElSimpleFTPSServer_get_OutgoingLocalBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OutgoingLocalBinding, arginfo_TElSimpleFTPSServer_set_OutgoingLocalBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_SocketSettings, arginfo_TElSimpleFTPSServer_get_SocketSettings, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_CipherSuites, arginfo_TElSimpleFTPSServer_get_CipherSuites, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_CipherSuites, arginfo_TElSimpleFTPSServer_set_CipherSuites, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_CipherSuitePriorities, arginfo_TElSimpleFTPSServer_get_CipherSuitePriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_CipherSuitePriorities, arginfo_TElSimpleFTPSServer_set_CipherSuitePriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_CompressionAlgorithms, arginfo_TElSimpleFTPSServer_get_CompressionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_CompressionAlgorithms, arginfo_TElSimpleFTPSServer_set_CompressionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_Versions, arginfo_TElSimpleFTPSServer_get_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_Versions, arginfo_TElSimpleFTPSServer_set_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_ClientAuthentication, arginfo_TElSimpleFTPSServer_get_ClientAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_ClientAuthentication, arginfo_TElSimpleFTPSServer_set_ClientAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_AuthenticationLevel, arginfo_TElSimpleFTPSServer_get_AuthenticationLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_AuthenticationLevel, arginfo_TElSimpleFTPSServer_set_AuthenticationLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_ForceCertificateChain, arginfo_TElSimpleFTPSServer_get_ForceCertificateChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_ForceCertificateChain, arginfo_TElSimpleFTPSServer_set_ForceCertificateChain, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_CertStorage, arginfo_TElSimpleFTPSServer_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_CertStorage, arginfo_TElSimpleFTPSServer_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_SessionPool, arginfo_TElSimpleFTPSServer_get_SessionPool, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_SessionPool, arginfo_TElSimpleFTPSServer_set_SessionPool, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_ClientCertStorage, arginfo_TElSimpleFTPSServer_get_ClientCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_ClientCertStorage, arginfo_TElSimpleFTPSServer_set_ClientCertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_Host, arginfo_TElSimpleFTPSServer_get_Host, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_Host, arginfo_TElSimpleFTPSServer_set_Host, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_PassiveModeHost, arginfo_TElSimpleFTPSServer_get_PassiveModeHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_PassiveModeHost, arginfo_TElSimpleFTPSServer_set_PassiveModeHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_DataHost, arginfo_TElSimpleFTPSServer_get_DataHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_DataHost, arginfo_TElSimpleFTPSServer_set_DataHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_Port, arginfo_TElSimpleFTPSServer_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_Port, arginfo_TElSimpleFTPSServer_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_DataPortRangeFrom, arginfo_TElSimpleFTPSServer_get_DataPortRangeFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_DataPortRangeFrom, arginfo_TElSimpleFTPSServer_set_DataPortRangeFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_DataPortRangeTo, arginfo_TElSimpleFTPSServer_get_DataPortRangeTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_DataPortRangeTo, arginfo_TElSimpleFTPSServer_set_DataPortRangeTo, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSimpleFTPSServer, get_UseIPv6, arginfo_TElSimpleFTPSServer_get_UseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_UseIPv6, arginfo_TElSimpleFTPSServer_set_UseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSimpleFTPSServer, get_SessionTimeout, arginfo_TElSimpleFTPSServer_get_SessionTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_SessionTimeout, arginfo_TElSimpleFTPSServer_set_SessionTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_RootDirectory, arginfo_TElSimpleFTPSServer_get_RootDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_RootDirectory, arginfo_TElSimpleFTPSServer_set_RootDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_ReadOnly, arginfo_TElSimpleFTPSServer_get_ReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_ReadOnly, arginfo_TElSimpleFTPSServer_set_ReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_IncomingSpeedLimit, arginfo_TElSimpleFTPSServer_get_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_IncomingSpeedLimit, arginfo_TElSimpleFTPSServer_set_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OutgoingSpeedLimit, arginfo_TElSimpleFTPSServer_get_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OutgoingSpeedLimit, arginfo_TElSimpleFTPSServer_set_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_FileSystemAdapter, arginfo_TElSimpleFTPSServer_get_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_FileSystemAdapter, arginfo_TElSimpleFTPSServer_set_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_AllowAnonymous, arginfo_TElSimpleFTPSServer_get_AllowAnonymous, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_AllowAnonymous, arginfo_TElSimpleFTPSServer_set_AllowAnonymous, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_ImplicitSSL, arginfo_TElSimpleFTPSServer_get_ImplicitSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_ImplicitSSL, arginfo_TElSimpleFTPSServer_set_ImplicitSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_UseUTF8, arginfo_TElSimpleFTPSServer_get_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_UseUTF8, arginfo_TElSimpleFTPSServer_set_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_Users, arginfo_TElSimpleFTPSServer_get_Users, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnBeforeNewConnection, arginfo_TElSimpleFTPSServer_get_OnBeforeNewConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnBeforeNewConnection, arginfo_TElSimpleFTPSServer_set_OnBeforeNewConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnNewConnection, arginfo_TElSimpleFTPSServer_get_OnNewConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnNewConnection, arginfo_TElSimpleFTPSServer_set_OnNewConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnCloseConnection, arginfo_TElSimpleFTPSServer_get_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnCloseConnection, arginfo_TElSimpleFTPSServer_set_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnAuthAttempt, arginfo_TElSimpleFTPSServer_get_OnAuthAttempt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnAuthAttempt, arginfo_TElSimpleFTPSServer_set_OnAuthAttempt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnCommandReceived, arginfo_TElSimpleFTPSServer_get_OnCommandReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnCommandReceived, arginfo_TElSimpleFTPSServer_set_OnCommandReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnBeforeSendReply, arginfo_TElSimpleFTPSServer_get_OnBeforeSendReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnBeforeSendReply, arginfo_TElSimpleFTPSServer_set_OnBeforeSendReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnCommandProcessed, arginfo_TElSimpleFTPSServer_get_OnCommandProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnCommandProcessed, arginfo_TElSimpleFTPSServer_set_OnCommandProcessed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnTransferProgress, arginfo_TElSimpleFTPSServer_get_OnTransferProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnTransferProgress, arginfo_TElSimpleFTPSServer_set_OnTransferProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnTransferCompleted, arginfo_TElSimpleFTPSServer_get_OnTransferCompleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnTransferCompleted, arginfo_TElSimpleFTPSServer_set_OnTransferCompleted, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnSessionException, arginfo_TElSimpleFTPSServer_get_OnSessionException, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnSessionException, arginfo_TElSimpleFTPSServer_set_OnSessionException, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnCommandUnhandled, arginfo_TElSimpleFTPSServer_get_OnCommandUnhandled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnCommandUnhandled, arginfo_TElSimpleFTPSServer_set_OnCommandUnhandled, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnSiteCommand, arginfo_TElSimpleFTPSServer_get_OnSiteCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnSiteCommand, arginfo_TElSimpleFTPSServer_set_OnSiteCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, get_OnFileAllocate, arginfo_TElSimpleFTPSServer_get_OnFileAllocate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, set_OnFileAllocate, arginfo_TElSimpleFTPSServer_set_OnFileAllocate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServer, __construct, arginfo_TElSimpleFTPSServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSimpleFTPSServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSimpleFTPSServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSimpleFTPSServer", TElSimpleFTPSServer_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElSimpleFTPSServer_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSimpleFTPSServerListeningThread_ce_ptr = NULL;

SB_PHP_METHOD(TElSimpleFTPSServerListeningThread, get_Socket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerListeningThread_get_Socket(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSocket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerListeningThread, set_Socket)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSocket_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleFTPSServerListeningThread_set_Socket(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSocket)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerListeningThread, get_OnNewConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSimpleFTPSListenerNewConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerListeningThread_get_OnNewConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerListeningThread, set_OnNewConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerListeningThread_set_OnNewConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSimpleFTPSListenerNewConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSimpleFTPSListenerNewConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerListeningThread, get_OnClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerListeningThread_get_OnClose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerListeningThread, set_OnClose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleFTPSServerListeningThread_set_OnClose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleFTPSServerListeningThread, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElSimpleFTPSServer_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleFTPSServerListeningThread_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSimpleFTPSServer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerListeningThread_get_Socket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerListeningThread_set_Socket, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSocket, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerListeningThread_get_OnNewConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerListeningThread_set_OnNewConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerListeningThread_get_OnClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerListeningThread_set_OnClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleFTPSServerListeningThread___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElSimpleFTPSServer, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSimpleFTPSServerListeningThread_methods[] = {
	PHP_ME(TElSimpleFTPSServerListeningThread, get_Socket, arginfo_TElSimpleFTPSServerListeningThread_get_Socket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerListeningThread, set_Socket, arginfo_TElSimpleFTPSServerListeningThread_set_Socket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerListeningThread, get_OnNewConnection, arginfo_TElSimpleFTPSServerListeningThread_get_OnNewConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerListeningThread, set_OnNewConnection, arginfo_TElSimpleFTPSServerListeningThread_set_OnNewConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerListeningThread, get_OnClose, arginfo_TElSimpleFTPSServerListeningThread_get_OnClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerListeningThread, set_OnClose, arginfo_TElSimpleFTPSServerListeningThread_set_OnClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleFTPSServerListeningThread, __construct, arginfo_TElSimpleFTPSServerListeningThread___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSimpleFTPSServerListeningThread(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSimpleFTPSServerListeningThread_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSimpleFTPSServerListeningThread", TElSimpleFTPSServerListeningThread_methods);
	if (NULL == TThread_ce_ptr)
		Register_TThread(TSRMLS_C);
	TElSimpleFTPSServerListeningThread_ce_ptr = zend_register_internal_class_ex(&ce, TThread_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElFTPSUsers_ce_ptr = NULL;

SB_PHP_METHOD(TElFTPSUsers, AddFTPSUser)
{
	char *sBasePath;
	char *sPassword;
	char *sUserName;
	int sBasePath_len;
	int sPassword_len;
	int sUserName_len;
	long l4IncomingSpeedLimit;
	long l4OutgoingSpeedLimit;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sUserName, &sUserName_len, &sPassword, &sPassword_len) == SUCCESS)
	{
		SBCheckError(TElFTPSUsers_AddFTPSUser(SBGetObjectHandle(getThis() TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sUserName, &sUserName_len, &sPassword, &sPassword_len, &sBasePath, &sBasePath_len) == SUCCESS)
	{
		SBCheckError(TElFTPSUsers_AddFTPSUser_1(SBGetObjectHandle(getThis() TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len, sBasePath, (int32_t)sBasePath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssll", &sUserName, &sUserName_len, &sPassword, &sPassword_len, &sBasePath, &sBasePath_len, &l4OutgoingSpeedLimit, &l4IncomingSpeedLimit) == SUCCESS)
	{
		SBCheckError(TElFTPSUsers_AddFTPSUser_2(SBGetObjectHandle(getThis() TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len, sBasePath, (int32_t)sBasePath_len, (int32_t)l4OutgoingSpeedLimit, (int32_t)l4IncomingSpeedLimit) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (string, string, string) or (string, string, string, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUsers, UpdateFTPSUser)
{
	char *sPassword;
	char *sUserName;
	int sPassword_len;
	int sUserName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sUserName, &sUserName_len, &sPassword, &sPassword_len) == SUCCESS)
	{
		SBCheckError(TElFTPSUsers_UpdateFTPSUser(SBGetObjectHandle(getThis() TSRMLS_CC), sUserName, (int32_t)sUserName_len, sPassword, (int32_t)sPassword_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUsers, FindFTPSUser)
{
	char *sUserName;
	int sUserName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sUserName, &sUserName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSUsers_FindFTPSUser(SBGetObjectHandle(getThis() TSRMLS_CC), sUserName, (int32_t)sUserName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElFTPSUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUsers, get_FTPSUsers)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSUsers_get_FTPSUsers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElFTPSUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElFTPSUsers, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElFTPSUsers_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUsers_AddFTPSUser, 0, 0, 2)
	ZEND_ARG_INFO(0, UserName)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_INFO(0, BasePath)
	ZEND_ARG_INFO(0, OutgoingSpeedLimit)
	ZEND_ARG_INFO(0, IncomingSpeedLimit)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUsers_UpdateFTPSUser, 0, 0, 2)
	ZEND_ARG_INFO(0, UserName)
	ZEND_ARG_INFO(0, Password)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUsers_FindFTPSUser, 0, 0, 1)
	ZEND_ARG_INFO(0, UserName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUsers_get_FTPSUsers, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElFTPSUsers___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElFTPSUsers_methods[] = {
	PHP_ME(TElFTPSUsers, AddFTPSUser, arginfo_TElFTPSUsers_AddFTPSUser, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUsers, UpdateFTPSUser, arginfo_TElFTPSUsers_UpdateFTPSUser, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUsers, FindFTPSUser, arginfo_TElFTPSUsers_FindFTPSUser, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUsers, get_FTPSUsers, arginfo_TElFTPSUsers_get_FTPSUsers, ZEND_ACC_PUBLIC)
	PHP_ME(TElFTPSUsers, __construct, arginfo_TElFTPSUsers___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElFTPSUsers(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElFTPSUsers_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElFTPSUsers", TElFTPSUsers_methods);
	if (NULL == TElUsers_ce_ptr)
		Register_TElUsers(TSRMLS_C);
	TElFTPSUsers_ce_ptr = zend_register_internal_class_ex(&ce, TElUsers_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSimpleFTPSServer_Aliases(TSRMLS_D)
{
	if (NULL == TElSimpleFTPSServerListeningThread_ce_ptr)
		Register_TElSimpleFTPSServerListeningThread(TSRMLS_C);
	zend_register_class_alias("ElSimpleFTPSServerListeningThread", TElSimpleFTPSServerListeningThread_ce_ptr);
	if (NULL == TElSimpleFTPSServerSessionThread_ce_ptr)
		Register_TElSimpleFTPSServerSessionThread(TSRMLS_C);
	zend_register_class_alias("ElSimpleFTPSServerSessionThread", TElSimpleFTPSServerSessionThread_ce_ptr);
	if (NULL == TElSimpleFTPSServer_ce_ptr)
		Register_TElSimpleFTPSServer(TSRMLS_C);
	zend_register_class_alias("ElSimpleFTPSServer", TElSimpleFTPSServer_ce_ptr);
}
