#include "sbsimplesftpserver.h"

zend_class_entry *TElSimpleSFTPServer_ce_ptr = NULL;

SB_PHP_METHOD(TElSimpleSFTPServer, get_AllowSftp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPServer_get_AllowSftp(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_AllowSftp)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPServer_set_AllowSftp(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_ReadOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPServer_get_ReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_ReadOnly)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPServer_set_ReadOnly(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_SFTPBaseDir)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPServer_get_SFTPBaseDir(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1241708897, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_SFTPBaseDir)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPServer_set_SFTPBaseDir(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_FilenameCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPServer_get_FilenameCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-552675492, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_FilenameCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPServer_set_FilenameCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_FileSystemAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_FileSystemAdapter)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomFileSystemAdapter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPServer_set_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomFileSystemAdapter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_Versions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpVersionsRaw fOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPServer_get_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_Versions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPServer_set_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSftpVersionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_DefaultOwnerUsername)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPServer_get_DefaultOwnerUsername(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-109429593, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_DefaultOwnerUsername)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPServer_set_DefaultOwnerUsername(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_DefaultOwnerGroup)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPServer_get_DefaultOwnerGroup(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1995622441, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_DefaultOwnerGroup)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPServer_set_DefaultOwnerGroup(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPBlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerBlockEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPBlock(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPBlock)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPBlock(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerBlockEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerBlockEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPUnblock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerUnblockEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPUnblock(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPUnblock)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPUnblock(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerUnblockEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerUnblockEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPClose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPClose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPClose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPCloseHandle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerCloseHandleEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPCloseHandle(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPCloseHandle)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPCloseHandle(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerCloseHandleEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerCloseHandleEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPCreateDirectory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerCreateDirectoryEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPCreateDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPCreateDirectory)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPCreateDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerCreateDirectoryEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerCreateDirectoryEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPCreateSymLink)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerCreateSymLinkEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPCreateSymLink(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPCreateSymLink)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPCreateSymLink(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerCreateSymLinkEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerCreateSymLinkEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPCreateHardLink)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerCreateHardLinkEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPCreateHardLink(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPCreateHardLink)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPCreateHardLink(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerCreateHardLinkEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerCreateHardLinkEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPFindClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerFindCloseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPFindClose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPFindClose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPFindClose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerFindCloseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerFindCloseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPFindFirst)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerFindFirstEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPFindFirst(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPFindFirst)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPFindFirst(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerFindFirstEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerFindFirstEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPFindNext)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerFindNextEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPFindNext(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPFindNext)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPFindNext(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerFindNextEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerFindNextEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPOpen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPOpen(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPOpen)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPOpen(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPOpenFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerOpenFileEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPOpenFile(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPOpenFile)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPOpenFile(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerOpenFileEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerOpenFileEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPReadFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerReadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPReadFile(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPReadFile)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPReadFile(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerReadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerReadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPReadSymLink)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerReadSymLinkEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPReadSymLink(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPReadSymLink)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPReadSymLink(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerReadSymLinkEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerReadSymLinkEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPReceive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerReceiveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPReceive(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPReceive)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPReceive(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerReceiveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerReceiveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPRemove)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRemoveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPRemove(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPRemove)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPRemove(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRemoveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRemoveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPRenameFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRenameFileEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPRenameFile(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPRenameFile)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPRenameFile(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRenameFileEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRenameFileEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPRequestAbsolutePath)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestAbsolutePathEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPRequestAbsolutePath(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPRequestAbsolutePath)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPRequestAbsolutePath(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestAbsolutePathEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestAbsolutePathEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPRequestAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestAttributesEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPRequestAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPRequestAttributes)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPRequestAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestAttributesEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestAttributesEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPRequestAttributes2)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestAttributes2Event pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPRequestAttributes2(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPRequestAttributes2)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPRequestAttributes2(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestAttributes2EventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestAttributes2Event|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPSend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerSendEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPSend(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPSend)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPSend(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerSendEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerSendEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPSetAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerSetAttributesEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPSetAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPSetAttributes)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPSetAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerSetAttributesEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerSetAttributesEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPSetAttributes2)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerSetAttributes2Event pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPSetAttributes2(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPSetAttributes2)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPSetAttributes2(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerSetAttributes2EventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerSetAttributes2Event|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPTextSeek)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerTextSeekEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPTextSeek(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPTextSeek)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPTextSeek(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerTextSeekEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerTextSeekEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPWriteFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerWriteEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPWriteFile(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPWriteFile)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPWriteFile(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerWriteEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerWriteEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPExtendedRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerExtendedRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPExtendedRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPExtendedRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPExtendedRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerExtendedRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerExtendedRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPVersionChange)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSftpServerVersionChangeEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPVersionChange(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPVersionChange)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPVersionChange(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSftpServerVersionChangeEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSftpServerVersionChangeEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPSendVendorID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerSendVendorIDEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPSendVendorID(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPSendVendorID)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPSendVendorID(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerSendVendorIDEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerSendVendorIDEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPRequestFileHash)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestFileHashEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPRequestFileHash(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPRequestFileHash)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPRequestFileHash(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestFileHashEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestFileHashEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPRequestFileHashByHandle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestFileHashByHandleEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPRequestFileHashByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPRequestFileHashByHandle)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPRequestFileHashByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestFileHashByHandleEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestFileHashByHandleEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPRequestAvailableSpace)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestAvailableSpaceEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPRequestAvailableSpace(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPRequestAvailableSpace)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPRequestAvailableSpace(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestAvailableSpaceEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestAvailableSpaceEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPRequestStatVFS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestStatVFSEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPRequestStatVFS(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPRequestStatVFS)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPRequestStatVFS(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestStatVFSEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestStatVFSEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPRequestHomeDirectory)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerRequestHomeDirectoryEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPRequestHomeDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPRequestHomeDirectory)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPRequestHomeDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerRequestHomeDirectoryEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerRequestHomeDirectoryEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPCopyRemoteFile)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerCopyRemoteFileEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPCopyRemoteFile(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPCopyRemoteFile)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPCopyRemoteFile(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerCopyRemoteFileEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerCopyRemoteFileEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPCopyRemoteData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerCopyRemoteDataEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPCopyRemoteData(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPCopyRemoteData)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPCopyRemoteData(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerCopyRemoteDataEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerCopyRemoteDataEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPMakeTempFolder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerReturnPathEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPMakeTempFolder(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPMakeTempFolder)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPMakeTempFolder(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerReturnPathEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerReturnPathEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, get_OnSFTPRequestTempFolder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSFTPServerReturnPathEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_get_OnSFTPRequestTempFolder(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, set_OnSFTPRequestTempFolder)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPServer_set_OnSFTPRequestTempFolder(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSFTPServerReturnPathEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSFTPServerReturnPathEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServer, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPServer_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_AllowSftp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_AllowSftp, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_ReadOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_ReadOnly, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_SFTPBaseDir, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_SFTPBaseDir, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_FilenameCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_FilenameCharset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_FileSystemAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_FileSystemAdapter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomFileSystemAdapter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_Versions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_Versions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_DefaultOwnerUsername, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_DefaultOwnerUsername, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_DefaultOwnerGroup, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_DefaultOwnerGroup, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPBlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPBlock, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPUnblock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPUnblock, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPCloseHandle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPCloseHandle, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPCreateDirectory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPCreateDirectory, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPCreateSymLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPCreateSymLink, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPCreateHardLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPCreateHardLink, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPFindClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPFindClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPFindFirst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPFindFirst, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPFindNext, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPFindNext, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPOpen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPOpen, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPOpenFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPOpenFile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPReadFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPReadFile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPReadSymLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPReadSymLink, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPReceive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPReceive, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPRemove, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPRemove, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPRenameFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPRenameFile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPRequestAbsolutePath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPRequestAbsolutePath, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPRequestAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPRequestAttributes, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPRequestAttributes2, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPRequestAttributes2, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPSend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPSend, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPSetAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPSetAttributes, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPSetAttributes2, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPSetAttributes2, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPTextSeek, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPTextSeek, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPWriteFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPWriteFile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPExtendedRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPExtendedRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPVersionChange, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPVersionChange, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPSendVendorID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPSendVendorID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPRequestFileHash, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPRequestFileHash, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPRequestFileHashByHandle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPRequestFileHashByHandle, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPRequestAvailableSpace, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPRequestAvailableSpace, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPRequestStatVFS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPRequestStatVFS, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPRequestHomeDirectory, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPRequestHomeDirectory, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPCopyRemoteFile, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPCopyRemoteFile, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPCopyRemoteData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPCopyRemoteData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPMakeTempFolder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPMakeTempFolder, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_get_OnSFTPRequestTempFolder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer_set_OnSFTPRequestTempFolder, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServer___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSimpleSFTPServer_methods[] = {
	PHP_ME(TElSimpleSFTPServer, get_AllowSftp, arginfo_TElSimpleSFTPServer_get_AllowSftp, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_AllowSftp, arginfo_TElSimpleSFTPServer_set_AllowSftp, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_ReadOnly, arginfo_TElSimpleSFTPServer_get_ReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_ReadOnly, arginfo_TElSimpleSFTPServer_set_ReadOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_SFTPBaseDir, arginfo_TElSimpleSFTPServer_get_SFTPBaseDir, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_SFTPBaseDir, arginfo_TElSimpleSFTPServer_set_SFTPBaseDir, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_FilenameCharset, arginfo_TElSimpleSFTPServer_get_FilenameCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_FilenameCharset, arginfo_TElSimpleSFTPServer_set_FilenameCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_FileSystemAdapter, arginfo_TElSimpleSFTPServer_get_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_FileSystemAdapter, arginfo_TElSimpleSFTPServer_set_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_Versions, arginfo_TElSimpleSFTPServer_get_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_Versions, arginfo_TElSimpleSFTPServer_set_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_DefaultOwnerUsername, arginfo_TElSimpleSFTPServer_get_DefaultOwnerUsername, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_DefaultOwnerUsername, arginfo_TElSimpleSFTPServer_set_DefaultOwnerUsername, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_DefaultOwnerGroup, arginfo_TElSimpleSFTPServer_get_DefaultOwnerGroup, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_DefaultOwnerGroup, arginfo_TElSimpleSFTPServer_set_DefaultOwnerGroup, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPBlock, arginfo_TElSimpleSFTPServer_get_OnSFTPBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPBlock, arginfo_TElSimpleSFTPServer_set_OnSFTPBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPUnblock, arginfo_TElSimpleSFTPServer_get_OnSFTPUnblock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPUnblock, arginfo_TElSimpleSFTPServer_set_OnSFTPUnblock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPClose, arginfo_TElSimpleSFTPServer_get_OnSFTPClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPClose, arginfo_TElSimpleSFTPServer_set_OnSFTPClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPCloseHandle, arginfo_TElSimpleSFTPServer_get_OnSFTPCloseHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPCloseHandle, arginfo_TElSimpleSFTPServer_set_OnSFTPCloseHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPCreateDirectory, arginfo_TElSimpleSFTPServer_get_OnSFTPCreateDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPCreateDirectory, arginfo_TElSimpleSFTPServer_set_OnSFTPCreateDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPCreateSymLink, arginfo_TElSimpleSFTPServer_get_OnSFTPCreateSymLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPCreateSymLink, arginfo_TElSimpleSFTPServer_set_OnSFTPCreateSymLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPCreateHardLink, arginfo_TElSimpleSFTPServer_get_OnSFTPCreateHardLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPCreateHardLink, arginfo_TElSimpleSFTPServer_set_OnSFTPCreateHardLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPError, arginfo_TElSimpleSFTPServer_get_OnSFTPError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPError, arginfo_TElSimpleSFTPServer_set_OnSFTPError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPFindClose, arginfo_TElSimpleSFTPServer_get_OnSFTPFindClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPFindClose, arginfo_TElSimpleSFTPServer_set_OnSFTPFindClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPFindFirst, arginfo_TElSimpleSFTPServer_get_OnSFTPFindFirst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPFindFirst, arginfo_TElSimpleSFTPServer_set_OnSFTPFindFirst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPFindNext, arginfo_TElSimpleSFTPServer_get_OnSFTPFindNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPFindNext, arginfo_TElSimpleSFTPServer_set_OnSFTPFindNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPOpen, arginfo_TElSimpleSFTPServer_get_OnSFTPOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPOpen, arginfo_TElSimpleSFTPServer_set_OnSFTPOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPOpenFile, arginfo_TElSimpleSFTPServer_get_OnSFTPOpenFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPOpenFile, arginfo_TElSimpleSFTPServer_set_OnSFTPOpenFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPReadFile, arginfo_TElSimpleSFTPServer_get_OnSFTPReadFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPReadFile, arginfo_TElSimpleSFTPServer_set_OnSFTPReadFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPReadSymLink, arginfo_TElSimpleSFTPServer_get_OnSFTPReadSymLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPReadSymLink, arginfo_TElSimpleSFTPServer_set_OnSFTPReadSymLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPReceive, arginfo_TElSimpleSFTPServer_get_OnSFTPReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPReceive, arginfo_TElSimpleSFTPServer_set_OnSFTPReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPRemove, arginfo_TElSimpleSFTPServer_get_OnSFTPRemove, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPRemove, arginfo_TElSimpleSFTPServer_set_OnSFTPRemove, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPRenameFile, arginfo_TElSimpleSFTPServer_get_OnSFTPRenameFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPRenameFile, arginfo_TElSimpleSFTPServer_set_OnSFTPRenameFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPRequestAbsolutePath, arginfo_TElSimpleSFTPServer_get_OnSFTPRequestAbsolutePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPRequestAbsolutePath, arginfo_TElSimpleSFTPServer_set_OnSFTPRequestAbsolutePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPRequestAttributes, arginfo_TElSimpleSFTPServer_get_OnSFTPRequestAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPRequestAttributes, arginfo_TElSimpleSFTPServer_set_OnSFTPRequestAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPRequestAttributes2, arginfo_TElSimpleSFTPServer_get_OnSFTPRequestAttributes2, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPRequestAttributes2, arginfo_TElSimpleSFTPServer_set_OnSFTPRequestAttributes2, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPSend, arginfo_TElSimpleSFTPServer_get_OnSFTPSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPSend, arginfo_TElSimpleSFTPServer_set_OnSFTPSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPSetAttributes, arginfo_TElSimpleSFTPServer_get_OnSFTPSetAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPSetAttributes, arginfo_TElSimpleSFTPServer_set_OnSFTPSetAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPSetAttributes2, arginfo_TElSimpleSFTPServer_get_OnSFTPSetAttributes2, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPSetAttributes2, arginfo_TElSimpleSFTPServer_set_OnSFTPSetAttributes2, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPTextSeek, arginfo_TElSimpleSFTPServer_get_OnSFTPTextSeek, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPTextSeek, arginfo_TElSimpleSFTPServer_set_OnSFTPTextSeek, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPWriteFile, arginfo_TElSimpleSFTPServer_get_OnSFTPWriteFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPWriteFile, arginfo_TElSimpleSFTPServer_set_OnSFTPWriteFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPExtendedRequest, arginfo_TElSimpleSFTPServer_get_OnSFTPExtendedRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPExtendedRequest, arginfo_TElSimpleSFTPServer_set_OnSFTPExtendedRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPVersionChange, arginfo_TElSimpleSFTPServer_get_OnSFTPVersionChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPVersionChange, arginfo_TElSimpleSFTPServer_set_OnSFTPVersionChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPSendVendorID, arginfo_TElSimpleSFTPServer_get_OnSFTPSendVendorID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPSendVendorID, arginfo_TElSimpleSFTPServer_set_OnSFTPSendVendorID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPRequestFileHash, arginfo_TElSimpleSFTPServer_get_OnSFTPRequestFileHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPRequestFileHash, arginfo_TElSimpleSFTPServer_set_OnSFTPRequestFileHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPRequestFileHashByHandle, arginfo_TElSimpleSFTPServer_get_OnSFTPRequestFileHashByHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPRequestFileHashByHandle, arginfo_TElSimpleSFTPServer_set_OnSFTPRequestFileHashByHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPRequestAvailableSpace, arginfo_TElSimpleSFTPServer_get_OnSFTPRequestAvailableSpace, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPRequestAvailableSpace, arginfo_TElSimpleSFTPServer_set_OnSFTPRequestAvailableSpace, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPRequestStatVFS, arginfo_TElSimpleSFTPServer_get_OnSFTPRequestStatVFS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPRequestStatVFS, arginfo_TElSimpleSFTPServer_set_OnSFTPRequestStatVFS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPRequestHomeDirectory, arginfo_TElSimpleSFTPServer_get_OnSFTPRequestHomeDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPRequestHomeDirectory, arginfo_TElSimpleSFTPServer_set_OnSFTPRequestHomeDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPCopyRemoteFile, arginfo_TElSimpleSFTPServer_get_OnSFTPCopyRemoteFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPCopyRemoteFile, arginfo_TElSimpleSFTPServer_set_OnSFTPCopyRemoteFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPCopyRemoteData, arginfo_TElSimpleSFTPServer_get_OnSFTPCopyRemoteData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPCopyRemoteData, arginfo_TElSimpleSFTPServer_set_OnSFTPCopyRemoteData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPMakeTempFolder, arginfo_TElSimpleSFTPServer_get_OnSFTPMakeTempFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPMakeTempFolder, arginfo_TElSimpleSFTPServer_set_OnSFTPMakeTempFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, get_OnSFTPRequestTempFolder, arginfo_TElSimpleSFTPServer_get_OnSFTPRequestTempFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, set_OnSFTPRequestTempFolder, arginfo_TElSimpleSFTPServer_set_OnSFTPRequestTempFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServer, __construct, arginfo_TElSimpleSFTPServer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSimpleSFTPServer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSimpleSFTPServer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSimpleSFTPServer", TElSimpleSFTPServer_methods);
	if (NULL == TElSimpleSSHServer_ce_ptr)
		Register_TElSimpleSSHServer(TSRMLS_C);
	TElSimpleSFTPServer_ce_ptr = zend_register_internal_class_ex(&ce, TElSimpleSSHServer_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSimpleSSHsftpSearchRec_ce_ptr = NULL;

SB_PHP_METHOD(TElSimpleSSHsftpSearchRec, get_Current)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSSHsftpSearchRec_get_Current(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSHsftpSearchRec, set_Current)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSSHsftpSearchRec_set_Current(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSHsftpSearchRec, get_InfoList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSSHsftpSearchRec_get_InfoList(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElVFSEntryInformationList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSHsftpSearchRec, set_InfoList)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElVFSEntryInformationList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSSHsftpSearchRec_set_InfoList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElVFSEntryInformationList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSSHsftpSearchRec, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSSHsftpSearchRec_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSHsftpSearchRec_get_Current, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSHsftpSearchRec_set_Current, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSHsftpSearchRec_get_InfoList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSHsftpSearchRec_set_InfoList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElVFSEntryInformationList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSSHsftpSearchRec___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSimpleSSHsftpSearchRec_methods[] = {
	PHP_ME(TElSimpleSSHsftpSearchRec, get_Current, arginfo_TElSimpleSSHsftpSearchRec_get_Current, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSHsftpSearchRec, set_Current, arginfo_TElSimpleSSHsftpSearchRec_set_Current, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSHsftpSearchRec, get_InfoList, arginfo_TElSimpleSSHsftpSearchRec_get_InfoList, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSHsftpSearchRec, set_InfoList, arginfo_TElSimpleSSHsftpSearchRec_set_InfoList, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSSHsftpSearchRec, __construct, arginfo_TElSimpleSSHsftpSearchRec___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSimpleSSHsftpSearchRec(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSimpleSSHsftpSearchRec_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSimpleSSHsftpSearchRec", TElSimpleSSHsftpSearchRec_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSimpleSSHsftpSearchRec_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSimpleSFTPServerSessionThread_ce_ptr = NULL;

SB_PHP_METHOD(TElSimpleSFTPServerSessionThread, get_SFTPServer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPServerSessionThread_get_SFTPServer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSimpleSFTPServer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServerSessionThread, set_SFTPServer)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSimpleSFTPServer_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPServerSessionThread_set_SFTPServer(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSimpleSFTPServer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServerSessionThread, get_FSAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPServerSessionThread_get_FSAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPServerSessionThread, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPServerSessionThread_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServerSessionThread_get_SFTPServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServerSessionThread_set_SFTPServer, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSimpleSFTPServer, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServerSessionThread_get_FSAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPServerSessionThread___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSimpleSFTPServerSessionThread_methods[] = {
	PHP_ME(TElSimpleSFTPServerSessionThread, get_SFTPServer, arginfo_TElSimpleSFTPServerSessionThread_get_SFTPServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServerSessionThread, set_SFTPServer, arginfo_TElSimpleSFTPServerSessionThread_set_SFTPServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServerSessionThread, get_FSAdapter, arginfo_TElSimpleSFTPServerSessionThread_get_FSAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPServerSessionThread, __construct, arginfo_TElSimpleSFTPServerSessionThread___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSimpleSFTPServerSessionThread(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSimpleSFTPServerSessionThread_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSimpleSFTPServerSessionThread", TElSimpleSFTPServerSessionThread_methods);
	if (NULL == TElSimpleSSHServerSessionThread_ce_ptr)
		Register_TElSimpleSSHServerSessionThread(TSRMLS_C);
	TElSimpleSFTPServerSessionThread_ce_ptr = zend_register_internal_class_ex(&ce, TElSimpleSSHServerSessionThread_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSimpleSFTPServer_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBSimpleSFTPServer, SFileNotFound, SB_SFileNotFound, SB_SFileNotFound);
	SB_REGISTER_STRING_CONSTANT(SBSimpleSFTPServer, SPermissionDenied, SB_SPermissionDenied, SB_SPermissionDenied);
	SB_REGISTER_STRING_CONSTANT(SBSimpleSFTPServer, SOperationFailed, SB_SOperationFailed, SB_SOperationFailed);
	SB_REGISTER_STRING_CONSTANT(SBSimpleSFTPServer, SFileWriteOpFailed, SB_SFileWriteOpFailed, SB_SFileWriteOpFailed);
}

