#include "sbsmimecades.h"

void SB_CALLBACK TSBSMimeCAdESSignRaw(void * _ObjectData, TObjectHandle Sender, TElCAdESSignatureProcessorHandle Processor)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zProcessor;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zProcessor);
	SBInitObject(zProcessor, TElCAdESSignatureProcessor_ce_ptr, Processor TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zProcessor;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zProcessor);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSMimeCAdESValidateRaw(void * _ObjectData, TObjectHandle Sender, TElCAdESSignatureProcessorHandle Processor)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zProcessor;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zProcessor);
	SBInitObject(zProcessor, TElCAdESSignatureProcessor_ce_ptr, Processor TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zProcessor;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zProcessor);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElMessagePartHandlerSMimeCAdES_ce_ptr = NULL;

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, GetDescription_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElMessagePartHandlerSMimeCAdES_GetDescription_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2012487970, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, GetDescription)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElMessagePartHandlerSMimeCAdES_GetDescription(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2012487970, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMessagePartHandlerSMimeCAdES_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, get_UseCAdES)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMimeCAdES_get_UseCAdES(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, set_UseCAdES)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElMessagePartHandlerSMimeCAdES_set_UseCAdES(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, get_CAdESValidity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCAdESSignatureValidityRaw fOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMimeCAdES_get_CAdESValidity(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, get_CAdESErrorCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMimeCAdES_get_CAdESErrorCode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, get_CAdESCertValidity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidityRaw fOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMimeCAdES_get_CAdESCertValidity(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, get_CAdESReason)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidityReasonRaw fOutResultRaw = 0;
		SBCheckError(TElMessagePartHandlerSMimeCAdES_get_CAdESReason(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, get_OnSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSMimeCAdESSign pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElMessagePartHandlerSMimeCAdES_get_OnSign(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, set_OnSign)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElMessagePartHandlerSMimeCAdES_set_OnSign(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSMimeCAdESSignRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSMimeCAdESSign|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, get_OnValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSMimeCAdESValidate pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElMessagePartHandlerSMimeCAdES_get_OnValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, set_OnValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElMessagePartHandlerSMimeCAdES_set_OnValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSMimeCAdESValidateRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSMimeCAdESValidate|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElMessagePartHandlerSMimeCAdES, __construct)
{
	zval *oaParams;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oaParams, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElMessagePartHandlerSMimeCAdES_Create(SBGetObjectHandle(oaParams TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_GetDescription_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_GetDescription, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_get_UseCAdES, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_set_UseCAdES, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_get_CAdESValidity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_get_CAdESErrorCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_get_CAdESCertValidity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_get_CAdESReason, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_get_OnSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_set_OnSign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_get_OnValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES_set_OnValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElMessagePartHandlerSMimeCAdES___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, aParams, TObject, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElMessagePartHandlerSMimeCAdES_methods[] = {
	PHP_ME(TElMessagePartHandlerSMimeCAdES, GetDescription_Inst, arginfo_TElMessagePartHandlerSMimeCAdES_GetDescription_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, GetDescription, arginfo_TElMessagePartHandlerSMimeCAdES_GetDescription, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, ClassType, arginfo_TElMessagePartHandlerSMimeCAdES_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, get_UseCAdES, arginfo_TElMessagePartHandlerSMimeCAdES_get_UseCAdES, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, set_UseCAdES, arginfo_TElMessagePartHandlerSMimeCAdES_set_UseCAdES, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, get_CAdESValidity, arginfo_TElMessagePartHandlerSMimeCAdES_get_CAdESValidity, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, get_CAdESErrorCode, arginfo_TElMessagePartHandlerSMimeCAdES_get_CAdESErrorCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, get_CAdESCertValidity, arginfo_TElMessagePartHandlerSMimeCAdES_get_CAdESCertValidity, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, get_CAdESReason, arginfo_TElMessagePartHandlerSMimeCAdES_get_CAdESReason, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, get_OnSign, arginfo_TElMessagePartHandlerSMimeCAdES_get_OnSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, set_OnSign, arginfo_TElMessagePartHandlerSMimeCAdES_set_OnSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, get_OnValidate, arginfo_TElMessagePartHandlerSMimeCAdES_get_OnValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, set_OnValidate, arginfo_TElMessagePartHandlerSMimeCAdES_set_OnValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElMessagePartHandlerSMimeCAdES, __construct, arginfo_TElMessagePartHandlerSMimeCAdES___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElMessagePartHandlerSMimeCAdES(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElMessagePartHandlerSMimeCAdES_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElMessagePartHandlerSMimeCAdES", TElMessagePartHandlerSMimeCAdES_methods);
	if (NULL == TElMessagePartHandlerSMime_ce_ptr)
		Register_TElMessagePartHandlerSMime(TSRMLS_C);
	TElMessagePartHandlerSMimeCAdES_ce_ptr = zend_register_internal_class_ex(&ce, TElMessagePartHandlerSMime_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSMIMECAdES_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBSMIMECAdES, SB_SMIME_ERROR_CADES_BASE, SB_SMIME_ERROR_CADES_BASE, SB_SMIME_ERROR_CADES_BASE);
	SB_REGISTER_LONG_CONSTANT(SBSMIMECAdES, SB_SMIME_ERROR_NO_CADESREVOCATION_INFO, SB_SMIME_ERROR_NO_CADESREVOCATION_INFO, SB_SMIME_ERROR_NO_CADESREVOCATION_INFO);
}

