#include "sbsmimesignatures.h"

zend_class_entry *TElSMIMEMessageSigner_ce_ptr = NULL;

SB_PHP_METHOD(TElSMIMEMessageSigner, Sign)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	long l8InCount;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zend_bool bDetached;
	zval *oInStream;
	zval *oOutStream;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzb", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize, &bDetached) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElSMIMEMessageSigner_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, (int8_t)bDetached, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bl", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &bDetached, &l8InCount) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSMIMEMessageSigner_Sign_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int8_t)bDetached, (int64_t)l8InCount, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, bool) or (TStream, TStream, bool, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMIMEMessageSigner, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSMIMEMessageSigner_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMIMEMessageSigner_Sign, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_Detached, 0, 1)
	ZEND_ARG_INFO(1, OutSize_or_InCount)
	ZEND_ARG_INFO(0, Detached)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMIMEMessageSigner___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSMIMEMessageSigner_methods[] = {
	PHP_ME(TElSMIMEMessageSigner, Sign, arginfo_TElSMIMEMessageSigner_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMIMEMessageSigner, __construct, arginfo_TElSMIMEMessageSigner___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSMIMEMessageSigner(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSMIMEMessageSigner_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSMIMEMessageSigner", TElSMIMEMessageSigner_methods);
	if (NULL == TElMessageSigner_ce_ptr)
		Register_TElMessageSigner(TSRMLS_C);
	TElSMIMEMessageSigner_ce_ptr = zend_register_internal_class_ex(&ce, TElMessageSigner_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSMIMEMessageVerifier_ce_ptr = NULL;

SB_PHP_METHOD(TElSMIMEMessageVerifier, Verify)
{
	int32_t l4OutSizeRaw;
	long l4InSize;
	long l8InCount;
	SBArrayZValInfo piInBuffer;
	SBArrayZValInfo piOutBuffer;
	zval *oInStream;
	zval *oOutStream;
	zval *zl4OutSize;
	zval *zpInBuffer;
	zval *zpOutBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzz", &zpInBuffer, &l4InSize, &zpOutBuffer, &zl4OutSize) == SUCCESS) && ((Z_TYPE_P(zpInBuffer) == IS_STRING) || (Z_TYPE_P(zpInBuffer) == IS_ARRAY) || (Z_TYPE_P(zpInBuffer) == IS_NULL) || ((Z_TYPE_P(zpInBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpInBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpOutBuffer) == IS_STRING) || (Z_TYPE_P(zpOutBuffer) == IS_ARRAY) || (Z_TYPE_P(zpOutBuffer) == IS_NULL) || ((Z_TYPE_P(zpOutBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpOutBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4OutSize) && (IS_LONG == Z_TYPE_P(zl4OutSize)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpInBuffer, &piInBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpOutBuffer, &piOutBuffer TSRMLS_CC)) RETURN_FALSE;
		l4OutSizeRaw = (int32_t)Z_LVAL_P(zl4OutSize);
		SBCheckError(TElSMIMEMessageVerifier_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), piInBuffer.data, (int32_t)l4InSize, piOutBuffer.data, &l4OutSizeRaw, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piInBuffer);
		SBFreePointerZValInfo(&piOutBuffer);
		ZVAL_LONG(zl4OutSize, (long)l4OutSizeRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oInStream, TStream_ce_ptr, &oOutStream, TStream_ce_ptr, &l8InCount) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSMIMEMessageVerifier_Verify_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oOutStream TSRMLS_CC), (int64_t)l8InCount, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer) or (TStream, TStream, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMIMEMessageVerifier, VerifyDetached)
{
	long l4SignatureSize;
	long l4Size;
	long l8InCount;
	long l8SigCount;
	SBArrayZValInfo piBuffer;
	SBArrayZValInfo piSignature;
	zval *oInStream;
	zval *oSigStream;
	zval *zpBuffer;
	zval *zpSignature;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zpBuffer, &l4Size, &zpSignature, &l4SignatureSize) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpSignature) == IS_STRING) || (Z_TYPE_P(zpSignature) == IS_ARRAY) || (Z_TYPE_P(zpSignature) == IS_NULL) || ((Z_TYPE_P(zpSignature) == IS_OBJECT) && (Z_OBJCE_P(zpSignature) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpSignature, &piSignature TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSMIMEMessageVerifier_VerifyDetached(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Size, piSignature.data, (int32_t)l4SignatureSize, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		SBFreePointerZValInfo(&piSignature);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ll", &oInStream, TStream_ce_ptr, &oSigStream, TStream_ce_ptr, &l8InCount, &l8SigCount) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSMIMEMessageVerifier_VerifyDetached_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInStream TSRMLS_CC), SBGetObjectHandle(oSigStream TSRMLS_CC), (int64_t)l8InCount, (int64_t)l8SigCount, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer) or (TStream, TStream, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSMIMEMessageVerifier, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSMIMEMessageVerifier_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMIMEMessageVerifier_Verify, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, InBuffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InSize_or_OutStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OutBuffer_or_InCount, 0, 1)
	ZEND_ARG_INFO(1, OutSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMIMEMessageVerifier_VerifyDetached, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Buffer_or_InStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Size_or_SigStream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Signature_or_InCount, 0, 1)
	ZEND_ARG_INFO(0, SignatureSize_or_SigCount)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSMIMEMessageVerifier___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSMIMEMessageVerifier_methods[] = {
	PHP_ME(TElSMIMEMessageVerifier, Verify, arginfo_TElSMIMEMessageVerifier_Verify, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMIMEMessageVerifier, VerifyDetached, arginfo_TElSMIMEMessageVerifier_VerifyDetached, ZEND_ACC_PUBLIC)
	PHP_ME(TElSMIMEMessageVerifier, __construct, arginfo_TElSMIMEMessageVerifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSMIMEMessageVerifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSMIMEMessageVerifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSMIMEMessageVerifier", TElSMIMEMessageVerifier_methods);
	if (NULL == TElMessageVerifier_ce_ptr)
		Register_TElMessageVerifier(TSRMLS_C);
	TElSMIMEMessageVerifier_ce_ptr = zend_register_internal_class_ex(&ce, TElMessageVerifier_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSMIMESignatures_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBSMIMESignatures, SB_MESSAGE_ERROR_INVALID_MESSAGE_DIGEST, SB_MESSAGE_ERROR_INVALID_MESSAGE_DIGEST, SB_MESSAGE_ERROR_INVALID_MESSAGE_DIGEST);
	SB_REGISTER_LONG_CONSTANT(SBSMIMESignatures, SB_MESSAGE_WARNING_OMITTED_MESSAGE_DIGEST, SB_MESSAGE_WARNING_OMITTED_MESSAGE_DIGEST, SB_MESSAGE_WARNING_OMITTED_MESSAGE_DIGEST);
}

void Register_SBSMIMESignatures_Aliases(TSRMLS_D)
{
	if (NULL == TElSMIMEMessageSigner_ce_ptr)
		Register_TElSMIMEMessageSigner(TSRMLS_C);
	zend_register_class_alias("ElSMIMEMessageSigner", TElSMIMEMessageSigner_ce_ptr);
	if (NULL == TElSMIMEMessageVerifier_ce_ptr)
		Register_TElSMIMEMessageVerifier(TSRMLS_C);
	zend_register_class_alias("ElSMIMEMessageVerifier", TElSMIMEMessageVerifier_ce_ptr);
}

