#include "sbsshauthagent.h"

SB_PHP_METHOD(TElSSHAuthAgentSSH2Key, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TElSSHAuthAgentSSH2Key));
		intern->len = sizeof(TElSSHAuthAgentSSH2Key);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TElSSHAuthAgentSSH2Key, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TElSSHAuthAgentSSH2Key));
}

zend_class_entry *TElSSHAuthAgentSSH2Key_ce_ptr = NULL;

static zend_function_entry TElSSHAuthAgentSSH2Key_methods[] = {
	PHP_ME(TElSSHAuthAgentSSH2Key, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHAuthAgentSSH2Key, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElSSHAuthAgentSSH2Key(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHAuthAgentSSH2Key_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TElSSHAuthAgentSSH2Key", TElSSHAuthAgentSSH2Key_methods);
	TElSSHAuthAgentSSH2Key_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHAuthAgent_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHAuthAgent, CalculateSignature)
{
	long l4AKeyIndex;
	SBArrayZValInfo aiAPacket;
	SBArrayZValInfo aiASessionID;
	uint32_t _err;
	zval *zaAPacket;
	zval *zaASessionID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &l4AKeyIndex, &zaASessionID, &zaAPacket) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaASessionID)) || (IS_ARRAY == Z_TYPE_P(zaASessionID)) || (IS_NULL == Z_TYPE_P(zaASessionID))) && ((IS_STRING == Z_TYPE_P(zaAPacket)) || (IS_ARRAY == Z_TYPE_P(zaAPacket)) || (IS_NULL == Z_TYPE_P(zaAPacket))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaASessionID, &aiASessionID TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaAPacket, &aiAPacket TSRMLS_CC)) RETURN_FALSE;
		_err = TElSSHAuthAgent_CalculateSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4AKeyIndex, aiASessionID.data, aiASessionID.len, aiAPacket.data, aiAPacket.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(423864573, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiASessionID);
		SBFreeArrayZValInfo(&aiAPacket);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHAuthAgent, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHAuthAgent_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHAuthAgent, get_SSH2Keys)
{
	long l4AIndex;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4AIndex) == SUCCESS)
	{
		TElSSHAuthAgentSSH2Key roOutResult;
		SBCheckError(TElSSHAuthAgent_get_SSH2Keys(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4AIndex, &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TElSSHAuthAgentSSH2Key_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TElSSHAuthAgentSSH2Key) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHAuthAgent, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHAuthAgent_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHAuthAgent_CalculateSignature, 0, 0, 3)
	ZEND_ARG_INFO(0, AKeyIndex)
	ZEND_ARG_TYPE_INFO(0, ASessionID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, APacket, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHAuthAgent_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHAuthAgent_get_SSH2Keys, 0, 0, 1)
	ZEND_ARG_INFO(0, AIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHAuthAgent___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHAuthAgent_methods[] = {
	PHP_ME(TElSSHAuthAgent, CalculateSignature, arginfo_TElSSHAuthAgent_CalculateSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHAuthAgent, get_Count, arginfo_TElSSHAuthAgent_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHAuthAgent, get_SSH2Keys, arginfo_TElSSHAuthAgent_get_SSH2Keys, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHAuthAgent, __construct, arginfo_TElSSHAuthAgent___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHAuthAgent(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHAuthAgent_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHAuthAgent", TElSSHAuthAgent_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSSHAuthAgent_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

#ifdef SB_WINDOWS
zend_class_entry *TElPageantAuthAgent_ce_ptr = NULL;

SB_PHP_METHOD(TElPageantAuthAgent, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPageantAuthAgent_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPageantAuthAgent___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPageantAuthAgent_methods[] = {
	PHP_ME(TElPageantAuthAgent, __construct, arginfo_TElPageantAuthAgent___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPageantAuthAgent(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPageantAuthAgent_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPageantAuthAgent", TElPageantAuthAgent_methods);
	if (NULL == TElSSHAuthAgent_ce_ptr)
		Register_TElSSHAuthAgent(TSRMLS_C);
	TElPageantAuthAgent_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHAuthAgent_ce_ptr, NULL TSRMLS_CC);
}
#endif

zend_class_entry *TElOpenSSHAuthAgent_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenSSHAuthAgent, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenSSHAuthAgent_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenSSHAuthAgent___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenSSHAuthAgent_methods[] = {
	PHP_ME(TElOpenSSHAuthAgent, __construct, arginfo_TElOpenSSHAuthAgent___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenSSHAuthAgent(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenSSHAuthAgent_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenSSHAuthAgent", TElOpenSSHAuthAgent_methods);
	if (NULL == TElSSHAuthAgent_ce_ptr)
		Register_TElSSHAuthAgent(TSRMLS_C);
	TElOpenSSHAuthAgent_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHAuthAgent_ce_ptr, NULL TSRMLS_CC);
#ifdef SB_WINDOWS
}

SB_PHP_FUNCTION(SBSSHAuthAgent, PageantAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBSSHAuthAgent_PageantAvailable(&bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBSSHAuthAgent, ParseAccessInfo)
{
	char *sAInfo;
	int sAInfo_len;
	int32_t l4PortRaw;
	SBArrayZValInfo aiMagic;
	uint32_t _err;
	zval *zaMagic;
	zval *zl4Port;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szz", &sAInfo, &sAInfo_len, &zl4Port, &zaMagic) == SUCCESS) && PZVAL_IS_REF(zl4Port) && (IS_LONG == Z_TYPE_P(zl4Port)) && PZVAL_IS_REF(zaMagic) && ((IS_STRING == Z_TYPE_P(zaMagic)) || (IS_ARRAY == Z_TYPE_P(zaMagic))))
	{
		int8_t bOutResultRaw = 0;
		l4PortRaw = (int32_t)Z_LVAL_P(zl4Port);
		if (!SBGetByteArrayFromZVal(zaMagic, &aiMagic TSRMLS_CC)) RETURN_FALSE;
		_err = SBSSHAuthAgent_ParseAccessInfo(sAInfo, (int32_t)sAInfo_len, &l4PortRaw, aiMagic.data, &aiMagic.len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaMagic, &aiMagic TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(2113152331, 2, aiMagic.data, &aiMagic.len) TSRMLS_CC);
			((char *)aiMagic.data)[aiMagic.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiMagic);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl4Port, (long)l4PortRaw);
		SBSetByteArrayToZVal(&aiMagic, zaMagic);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &integer, &array of byte|string)" TSRMLS_CC);
	}
#endif
}
