#include "sbsshpubkeyclient.h"

zend_class_entry *TElSSHPublicKeyClient_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHPublicKeyClient, Add)
{
	zend_bool bOverwrite;
	zval *oAttributes;
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oKey, TElSSHKey_ce_ptr, &oAttributes, TElSSHPublicKeyAttributes_ce_ptr, &bOverwrite) == SUCCESS)
	{
		SBCheckError(TElSSHPublicKeyClient_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oAttributes TSRMLS_CC), (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHKey, TElSSHPublicKeyAttributes, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, Remove)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElSSHKey_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHPublicKeyClient_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, List)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHPublicKeyClient_List(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, ListAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHPublicKeyClient_ListAttributes(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHPublicKeyClient_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, get_RemoteVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHPublicKeyClient_get_RemoteVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHPublicKeyClient_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, get_Tunnel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPublicKeyClient_get_Tunnel(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSubsystemSSHTunnel_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, set_Tunnel)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSubsystemSSHTunnel_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHPublicKeyClient_set_Tunnel(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSubsystemSSHTunnel)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, get_Subsystem)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHPublicKeyClient_get_Subsystem(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(196420681, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, set_Subsystem)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHPublicKeyClient_set_Subsystem(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, get_OnOpenConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHPublicKeyClient_get_OnOpenConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, set_OnOpenConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHPublicKeyClient_set_OnOpenConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, get_OnCloseConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHPublicKeyClient_get_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, set_OnCloseConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHPublicKeyClient_set_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, get_OnError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHPublicKeyErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHPublicKeyClient_get_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, set_OnError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHPublicKeyClient_set_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHPublicKeyErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHPublicKeyErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, get_OnStatus)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHPublicKeyStatusEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHPublicKeyClient_get_OnStatus(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, set_OnStatus)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHPublicKeyClient_set_OnStatus(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHPublicKeyStatusEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHPublicKeyStatusEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, get_OnPublicKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHPublicKeyPublicKeyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHPublicKeyClient_get_OnPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, set_OnPublicKey)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHPublicKeyClient_set_OnPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHPublicKeyPublicKeyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHPublicKeyPublicKeyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, get_OnAttribute)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHPublicKeyAttributeEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHPublicKeyClient_get_OnAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, set_OnAttribute)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHPublicKeyClient_set_OnAttribute(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHPublicKeyAttributeEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHPublicKeyAttributeEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHPublicKeyClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHPublicKeyClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_Add, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Key, TElSSHKey, 1)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSSHPublicKeyAttributes, 1)
	ZEND_ARG_INFO(0, Overwrite)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_Remove, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElSSHKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_List, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_ListAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_get_RemoteVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_get_Tunnel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_set_Tunnel, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSubsystemSSHTunnel, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_get_Subsystem, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_set_Subsystem, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_get_OnOpenConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_set_OnOpenConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_get_OnCloseConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_set_OnCloseConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_get_OnError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_set_OnError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_get_OnStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_set_OnStatus, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_get_OnPublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_set_OnPublicKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_get_OnAttribute, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient_set_OnAttribute, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHPublicKeyClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHPublicKeyClient_methods[] = {
	PHP_ME(TElSSHPublicKeyClient, Add, arginfo_TElSSHPublicKeyClient_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, Remove, arginfo_TElSSHPublicKeyClient_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, List, arginfo_TElSSHPublicKeyClient_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, ListAttributes, arginfo_TElSSHPublicKeyClient_ListAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, get_Active, arginfo_TElSSHPublicKeyClient_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, get_RemoteVersion, arginfo_TElSSHPublicKeyClient_get_RemoteVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, get_Version, arginfo_TElSSHPublicKeyClient_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, get_Tunnel, arginfo_TElSSHPublicKeyClient_get_Tunnel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, set_Tunnel, arginfo_TElSSHPublicKeyClient_set_Tunnel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, get_Subsystem, arginfo_TElSSHPublicKeyClient_get_Subsystem, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, set_Subsystem, arginfo_TElSSHPublicKeyClient_set_Subsystem, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, get_OnOpenConnection, arginfo_TElSSHPublicKeyClient_get_OnOpenConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, set_OnOpenConnection, arginfo_TElSSHPublicKeyClient_set_OnOpenConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, get_OnCloseConnection, arginfo_TElSSHPublicKeyClient_get_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, set_OnCloseConnection, arginfo_TElSSHPublicKeyClient_set_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, get_OnError, arginfo_TElSSHPublicKeyClient_get_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, set_OnError, arginfo_TElSSHPublicKeyClient_set_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, get_OnStatus, arginfo_TElSSHPublicKeyClient_get_OnStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, set_OnStatus, arginfo_TElSSHPublicKeyClient_set_OnStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, get_OnPublicKey, arginfo_TElSSHPublicKeyClient_get_OnPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, set_OnPublicKey, arginfo_TElSSHPublicKeyClient_set_OnPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, get_OnAttribute, arginfo_TElSSHPublicKeyClient_get_OnAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, set_OnAttribute, arginfo_TElSSHPublicKeyClient_set_OnAttribute, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHPublicKeyClient, __construct, arginfo_TElSSHPublicKeyClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHPublicKeyClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHPublicKeyClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHPublicKeyClient", TElSSHPublicKeyClient_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElSSHPublicKeyClient_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSSHPubKeyClient_Aliases(TSRMLS_D)
{
	if (NULL == TElSSHPublicKeyClient_ce_ptr)
		Register_TElSSHPublicKeyClient(TSRMLS_C);
	zend_register_class_alias("ElSSHPublicKeyClient", TElSSHPublicKeyClient_ce_ptr);
}

