#include "sbstringlist.h"

zend_class_entry *TSBTokenizerMode_ce_ptr = NULL;

zend_class_entry *TElStringTokenizer_ce_ptr = NULL;

SB_PHP_METHOD(TElStringTokenizer, GetAll)
{
	zval *oResultList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElStringTokenizer_GetAll(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oResultList, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oResultList, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElStringTokenizer_GetAll_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oResultList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("() or (TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("() or (TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElStringTokenizer, GetNext)
{
	char *sValue;
	int32_t sValue_len;
	uint32_t _err;
	zval *zsValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zsValue) == SUCCESS) && PZVAL_IS_REF(zsValue) && (IS_STRING == Z_TYPE_P(zsValue)))
	{
		int8_t bOutResultRaw = 0;
		sValue = Z_STRVAL_P(zsValue);
		sValue_len = (int32_t)Z_STRLEN_P(zsValue);
		_err = TElStringTokenizer_GetNext(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, &sValue_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sValue = emalloc(sValue_len + 1);
			SBCheckError(SBGetLastReturnStringA(1193243616, 1, sValue, &sValue_len) TSRMLS_CC);
			zval_dtor(zsValue);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sValue[sValue_len] = 0;
		ZVAL_STRINGL(zsValue, sValue, sValue_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, GetRest)
{
	char *sValue;
	int32_t sValue_len;
	uint32_t _err;
	zval *zsValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zsValue) == SUCCESS) && PZVAL_IS_REF(zsValue) && (IS_STRING == Z_TYPE_P(zsValue)))
	{
		int8_t bOutResultRaw = 0;
		sValue = Z_STRVAL_P(zsValue);
		sValue_len = (int32_t)Z_STRLEN_P(zsValue);
		_err = TElStringTokenizer_GetRest(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, &sValue_len, &bOutResultRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sValue = emalloc(sValue_len + 1);
			SBCheckError(SBGetLastReturnStringA(-469236171, 1, sValue, &sValue_len) TSRMLS_CC);
			zval_dtor(zsValue);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sValue[sValue_len] = 0;
		ZVAL_STRINGL(zsValue, sValue, sValue_len, 0);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElStringTokenizer_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, get_ClosingQuote)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char cOutResult = '\0';
		SBCheckError(TElStringTokenizer_get_ClosingQuote(SBGetObjectHandle(getThis() TSRMLS_CC), &cOutResult) TSRMLS_CC);
		RETURN_STRINGL(&cOutResult, 1, 1);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, set_ClosingQuote)
{
	char *cValue;
	int cValue_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cValue, &cValue_len) == SUCCESS) && (1 == cValue_len))
	{
		SBCheckError(TElStringTokenizer_set_ClosingQuote(SBGetObjectHandle(getThis() TSRMLS_CC), cValue[0]) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, get_ReturnEmptyTokens)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElStringTokenizer_get_ReturnEmptyTokens(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, set_ReturnEmptyTokens)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElStringTokenizer_set_ReturnEmptyTokens(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, get_Delimiters)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElStringTokenizer_get_Delimiters(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1469019188, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, set_Delimiters)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElStringTokenizer_set_Delimiters(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, get_EscapeChar)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char cOutResult = '\0';
		SBCheckError(TElStringTokenizer_get_EscapeChar(SBGetObjectHandle(getThis() TSRMLS_CC), &cOutResult) TSRMLS_CC);
		RETURN_STRINGL(&cOutResult, 1, 1);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, set_EscapeChar)
{
	char *cValue;
	int cValue_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cValue, &cValue_len) == SUCCESS) && (1 == cValue_len))
	{
		SBCheckError(TElStringTokenizer_set_EscapeChar(SBGetObjectHandle(getThis() TSRMLS_CC), cValue[0]) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, get_OpeningQuote)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char cOutResult = '\0';
		SBCheckError(TElStringTokenizer_get_OpeningQuote(SBGetObjectHandle(getThis() TSRMLS_CC), &cOutResult) TSRMLS_CC);
		RETURN_STRINGL(&cOutResult, 1, 1);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, set_OpeningQuote)
{
	char *cValue;
	int cValue_len;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &cValue, &cValue_len) == SUCCESS) && (1 == cValue_len))
	{
		SBCheckError(TElStringTokenizer_set_OpeningQuote(SBGetObjectHandle(getThis() TSRMLS_CC), cValue[0]) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(char)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, get_SourceString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElStringTokenizer_get_SourceString(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-566352019, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, set_SourceString)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElStringTokenizer_set_SourceString(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, get_TrimQuotes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElStringTokenizer_get_TrimQuotes(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, set_TrimQuotes)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElStringTokenizer_set_TrimQuotes(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, get_TrimSpaces)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElStringTokenizer_get_TrimSpaces(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, set_TrimSpaces)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElStringTokenizer_set_TrimSpaces(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElStringTokenizer, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElStringTokenizer_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_GetAll, 0, 0, 0)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, ResultList, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, ResultList, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_GetNext, 0, 0, 1)
	ZEND_ARG_INFO(1, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_GetRest, 0, 0, 1)
	ZEND_ARG_INFO(1, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_get_ClosingQuote, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_set_ClosingQuote, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_get_ReturnEmptyTokens, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_set_ReturnEmptyTokens, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_get_Delimiters, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_set_Delimiters, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_get_EscapeChar, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_set_EscapeChar, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_get_OpeningQuote, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_set_OpeningQuote, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_get_SourceString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_set_SourceString, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_get_TrimQuotes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_set_TrimQuotes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_get_TrimSpaces, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer_set_TrimSpaces, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringTokenizer___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElStringTokenizer_methods[] = {
	PHP_ME(TElStringTokenizer, GetAll, arginfo_TElStringTokenizer_GetAll, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, GetNext, arginfo_TElStringTokenizer_GetNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, GetRest, arginfo_TElStringTokenizer_GetRest, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, Reset, arginfo_TElStringTokenizer_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, get_ClosingQuote, arginfo_TElStringTokenizer_get_ClosingQuote, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, set_ClosingQuote, arginfo_TElStringTokenizer_set_ClosingQuote, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, get_ReturnEmptyTokens, arginfo_TElStringTokenizer_get_ReturnEmptyTokens, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, set_ReturnEmptyTokens, arginfo_TElStringTokenizer_set_ReturnEmptyTokens, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, get_Delimiters, arginfo_TElStringTokenizer_get_Delimiters, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, set_Delimiters, arginfo_TElStringTokenizer_set_Delimiters, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, get_EscapeChar, arginfo_TElStringTokenizer_get_EscapeChar, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, set_EscapeChar, arginfo_TElStringTokenizer_set_EscapeChar, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, get_OpeningQuote, arginfo_TElStringTokenizer_get_OpeningQuote, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, set_OpeningQuote, arginfo_TElStringTokenizer_set_OpeningQuote, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, get_SourceString, arginfo_TElStringTokenizer_get_SourceString, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, set_SourceString, arginfo_TElStringTokenizer_set_SourceString, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, get_TrimQuotes, arginfo_TElStringTokenizer_get_TrimQuotes, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, set_TrimQuotes, arginfo_TElStringTokenizer_set_TrimQuotes, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, get_TrimSpaces, arginfo_TElStringTokenizer_get_TrimSpaces, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, set_TrimSpaces, arginfo_TElStringTokenizer_set_TrimSpaces, ZEND_ACC_PUBLIC)
	PHP_ME(TElStringTokenizer, __construct, arginfo_TElStringTokenizer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElStringTokenizer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElStringTokenizer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElStringTokenizer", TElStringTokenizer_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElStringTokenizer_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBStringList_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBTokenizerMode", NULL);
	TSBTokenizerMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBTokenizerMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBTokenizerMode_ce_ptr, "tAll", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBTokenizerMode_ce_ptr, "tNext", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBTokenizerMode_ce_ptr, "tRest", 2)
}

void Register_SBStringList_Aliases(TSRMLS_D)
{
#ifdef SB_WINDOWS
	if (NULL == TStringList_ce_ptr)
		Register_TStringList(TSRMLS_C);
	zend_register_class_alias("ElStringList", TStringList_ce_ptr);
#else
	if (NULL == TElStringList_ce_ptr)
		Register_TElStringList(TSRMLS_C);
	zend_register_class_alias("ElStringList", TElStringList_ce_ptr);
#endif
}
