#include "sbtspcommon.h"

zend_class_entry *TElTSPInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElTSPInfo, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElTSPInfo_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElTSPInfo_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, get_SerialNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElTSPInfo_get_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-469869359, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, set_SerialNumber)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElTSPInfo_set_SerialNumber(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, get_Nonce)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElTSPInfo_get_Nonce(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(48250253, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, set_Nonce)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElTSPInfo_set_Nonce(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, get_Time)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElTSPInfo_get_Time(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, set_Time)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElTSPInfo_set_Time(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, get_AccuracySec)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTSPInfo_get_AccuracySec(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, set_AccuracySec)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTSPInfo_set_AccuracySec(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, get_AccuracyMilli)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTSPInfo_get_AccuracyMilli(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, set_AccuracyMilli)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTSPInfo_set_AccuracyMilli(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, get_AccuracyMicro)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElTSPInfo_get_AccuracyMicro(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, set_AccuracyMicro)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElTSPInfo_set_AccuracyMicro(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, get_AccuracySet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTSPInfo_get_AccuracySet(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, set_AccuracySet)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTSPInfo_set_AccuracySet(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, get_TSAName)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTSPInfo_get_TSAName(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGeneralName_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, get_TSANameSet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElTSPInfo_get_TSANameSet(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, set_TSANameSet)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElTSPInfo_set_TSANameSet(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTSPInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_get_SerialNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_set_SerialNumber, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_get_Nonce, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_set_Nonce, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_get_Time, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_set_Time, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_get_AccuracySec, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_set_AccuracySec, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_get_AccuracyMilli, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_set_AccuracyMilli, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_get_AccuracyMicro, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_set_AccuracyMicro, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_get_AccuracySet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_set_AccuracySet, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_get_TSAName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_get_TSANameSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo_set_TSANameSet, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElTSPInfo_methods[] = {
	PHP_ME(TElTSPInfo, Assign, arginfo_TElTSPInfo_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, Reset, arginfo_TElTSPInfo_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, get_SerialNumber, arginfo_TElTSPInfo_get_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, set_SerialNumber, arginfo_TElTSPInfo_set_SerialNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, get_Nonce, arginfo_TElTSPInfo_get_Nonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, set_Nonce, arginfo_TElTSPInfo_set_Nonce, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, get_Time, arginfo_TElTSPInfo_get_Time, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, set_Time, arginfo_TElTSPInfo_set_Time, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, get_AccuracySec, arginfo_TElTSPInfo_get_AccuracySec, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, set_AccuracySec, arginfo_TElTSPInfo_set_AccuracySec, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, get_AccuracyMilli, arginfo_TElTSPInfo_get_AccuracyMilli, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, set_AccuracyMilli, arginfo_TElTSPInfo_set_AccuracyMilli, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, get_AccuracyMicro, arginfo_TElTSPInfo_get_AccuracyMicro, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, set_AccuracyMicro, arginfo_TElTSPInfo_set_AccuracyMicro, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, get_AccuracySet, arginfo_TElTSPInfo_get_AccuracySet, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, set_AccuracySet, arginfo_TElTSPInfo_set_AccuracySet, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, get_TSAName, arginfo_TElTSPInfo_get_TSAName, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, get_TSANameSet, arginfo_TElTSPInfo_get_TSANameSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, set_TSANameSet, arginfo_TElTSPInfo_set_TSANameSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPInfo, __construct, arginfo_TElTSPInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTSPInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTSPInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTSPInfo", TElTSPInfo_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElTSPInfo_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElTSPClass_ce_ptr = NULL;

SB_PHP_METHOD(TElTSPClass, ValidateImprint)
{
	long l4Algorithm;
	SBArrayZValInfo aiHashedData;
	SBArrayZValInfo aiImprint;
	zval *zaHashedData;
	zval *zaImprint;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &l4Algorithm, &zaHashedData, &zaImprint) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHashedData)) || (IS_ARRAY == Z_TYPE_P(zaHashedData)) || (IS_NULL == Z_TYPE_P(zaHashedData))) && ((IS_STRING == Z_TYPE_P(zaImprint)) || (IS_ARRAY == Z_TYPE_P(zaImprint)) || (IS_NULL == Z_TYPE_P(zaImprint))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHashedData, &aiHashedData TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaImprint, &aiImprint TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElTSPClass_ValidateImprint(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Algorithm, aiHashedData.data, aiHashedData.len, aiImprint.data, aiImprint.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHashedData);
		SBFreeArrayZValInfo(&aiImprint);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElTSPClass, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElTSPClass_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPClass_ValidateImprint, 0, 0, 3)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_TYPE_INFO(0, HashedData, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Imprint, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElTSPClass___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElTSPClass_methods[] = {
	PHP_ME(TElTSPClass, ValidateImprint, arginfo_TElTSPClass_ValidateImprint, ZEND_ACC_PUBLIC)
	PHP_ME(TElTSPClass, __construct, arginfo_TElTSPClass___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElTSPClass(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElTSPClass_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElTSPClass", TElTSPClass_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElTSPClass_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBTSPCommon_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, ERROR_FACILITY_TSP, SB_ERROR_FACILITY_TSP, SB_ERROR_FACILITY_TSP);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, ERROR_TSP_PROTOCOL_ERROR_FLAG, SB_ERROR_TSP_PROTOCOL_ERROR_FLAG, SB_ERROR_TSP_PROTOCOL_ERROR_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_ABORTED, SB_TSP_ERROR_ABORTED, SB_TSP_ERROR_ABORTED);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_NO_REPLY, SB_TSP_ERROR_NO_REPLY, SB_TSP_ERROR_NO_REPLY);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_NO_PARAMETERS, SB_TSP_ERROR_NO_PARAMETERS, SB_TSP_ERROR_NO_PARAMETERS);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_NO_CERTIFICATES, SB_TSP_ERROR_NO_CERTIFICATES, SB_TSP_ERROR_NO_CERTIFICATES);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_WRONG_DATA, SB_TSP_ERROR_WRONG_DATA, SB_TSP_ERROR_WRONG_DATA);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_WRONG_IMPRINT, SB_TSP_ERROR_WRONG_IMPRINT, SB_TSP_ERROR_WRONG_IMPRINT);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_WRONG_NONCE, SB_TSP_ERROR_WRONG_NONCE, SB_TSP_ERROR_WRONG_NONCE);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_UNEXPECTED_CERTIFICATES, SB_TSP_ERROR_UNEXPECTED_CERTIFICATES, SB_TSP_ERROR_UNEXPECTED_CERTIFICATES);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_UNRECOGNIZED_FORMAT, SB_TSP_ERROR_UNRECOGNIZED_FORMAT, SB_TSP_ERROR_UNRECOGNIZED_FORMAT);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_DATA_TOO_LONG, SB_TSP_ERROR_DATA_TOO_LONG, SB_TSP_ERROR_DATA_TOO_LONG);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_UNSUPPORTED_REPLY, SB_TSP_ERROR_UNSUPPORTED_REPLY, SB_TSP_ERROR_UNSUPPORTED_REPLY);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_GENERAL_ERROR, SB_TSP_ERROR_GENERAL_ERROR, SB_TSP_ERROR_GENERAL_ERROR);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, SB_TSP_ERROR_REQUEST_REJECTED, SB_TSP_ERROR_REQUEST_REJECTED, SB_TSP_ERROR_REQUEST_REJECTED);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, tfiBadAlg, SB_tfiBadAlg, SB_tfiBadAlg);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, tfiBadRequest, SB_tfiBadRequest, SB_tfiBadRequest);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, tfiBadDataFormat, SB_tfiBadDataFormat, SB_tfiBadDataFormat);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, tfiTimeNotAvailable, SB_tfiTimeNotAvailable, SB_tfiTimeNotAvailable);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, tfiUnacceptedPolicy, SB_tfiUnacceptedPolicy, SB_tfiUnacceptedPolicy);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, tfiUnacceptedExtension, SB_tfiUnacceptedExtension, SB_tfiUnacceptedExtension);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, tfiAddInfoNotAvailable, SB_tfiAddInfoNotAvailable, SB_tfiAddInfoNotAvailable);
	SB_REGISTER_LONG_CONSTANT(SBTSPCommon, tfiSystemFailure, SB_tfiSystemFailure, SB_tfiSystemFailure);
	SB_REGISTER_STRING_CONSTANT(SBTSPCommon, SB_TSP_OID_AUTHENTICODE_TIMESTAMP, SB_TSP_OID_AUTHENTICODE_TIMESTAMP, SB_TSP_OID_AUTHENTICODE_TIMESTAMP);
	SB_REGISTER_STRING_CONSTANT(SBTSPCommon, SB_TSP_OID_PKCS7_DATA, SB_TSP_OID_PKCS7_DATA, SB_TSP_OID_PKCS7_DATA);
}

void Register_SBTSPCommon_Aliases(TSRMLS_D)
{
	if (NULL == TElTSPInfo_ce_ptr)
		Register_TElTSPInfo(TSRMLS_C);
	zend_register_class_alias("ElTSPInfo", TElTSPInfo_ce_ptr);
	if (NULL == TElTSPClass_ce_ptr)
		Register_TElTSPClass(TSRMLS_C);
	zend_register_class_alias("ElTSPClass", TElTSPClass_ce_ptr);
}

