#include "sbtwofish.h"

SB_PHP_METHOD(TTwofishExpandedKey, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TTwofishExpandedKey));
		intern->len = sizeof(TTwofishExpandedKey);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TTwofishExpandedKey, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TTwofishExpandedKey));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TTwofishExpandedKey, get_KeyLen)
{
	SBStuctGetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1200);
}

SB_PHP_METHOD(TTwofishExpandedKey, set_KeyLen)
{
	SBStuctSetFieldInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 1200);
}

zend_class_entry *TTwofishExpandedKey_ce_ptr = NULL;

static zend_function_entry TTwofishExpandedKey_methods[] = {
	PHP_ME(TTwofishExpandedKey, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TTwofishExpandedKey, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TTwofishExpandedKey, get_KeyLen, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TTwofishExpandedKey, set_KeyLen, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TTwofishExpandedKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TTwofishExpandedKey_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TTwofishExpandedKey", TTwofishExpandedKey_methods);
	TTwofishExpandedKey_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBTwofish, ExpandKey)
{
	SBArrayZValInfo aiKey;
	zval *oExpandedKey;
	zval *zaKey;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO", &zaKey, &oExpandedKey, TTwofishExpandedKey_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKey)) || (IS_ARRAY == Z_TYPE_P(zaKey)) || (IS_NULL == Z_TYPE_P(zaKey))) && PZVAL_IS_REF(oExpandedKey))
	{
		if (!SBGetByteArrayFromZVal(zaKey, &aiKey TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBTwofish_ExpandKey(aiKey.data, aiKey.len, (TTwofishExpandedKey *)SBGetStructPointer(oExpandedKey TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKey);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &TTwofishExpandedKey)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBTwofish, EncryptBlock)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	uint32_t u4B2Raw;
	uint32_t u4B3Raw;
	zval *oExpandedKey;
	zval *zu4B0;
	zval *zu4B1;
	zval *zu4B2;
	zval *zu4B3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozzzz", &oExpandedKey, TTwofishExpandedKey_ce_ptr, &zu4B0, &zu4B1, &zu4B2, &zu4B3) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(zu4B2) && (IS_LONG == Z_TYPE_P(zu4B2)) && PZVAL_IS_REF(zu4B3) && (IS_LONG == Z_TYPE_P(zu4B3)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		u4B2Raw = (uint32_t)Z_LVAL_P(zu4B2);
		u4B3Raw = (uint32_t)Z_LVAL_P(zu4B3);
		SBCheckError(SBTwofish_EncryptBlock((TTwofishExpandedKey *)SBGetStructPointer(oExpandedKey TSRMLS_CC), &u4B0Raw, &u4B1Raw, &u4B2Raw, &u4B3Raw) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
		ZVAL_LONG(zu4B2, (long)u4B2Raw);
		ZVAL_LONG(zu4B3, (long)u4B3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(TTwofishExpandedKey, &integer, &integer, &integer, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBTwofish, DecryptBlock)
{
	uint32_t u4B0Raw;
	uint32_t u4B1Raw;
	uint32_t u4B2Raw;
	uint32_t u4B3Raw;
	zval *oExpandedKey;
	zval *zu4B0;
	zval *zu4B1;
	zval *zu4B2;
	zval *zu4B3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozzzz", &oExpandedKey, TTwofishExpandedKey_ce_ptr, &zu4B0, &zu4B1, &zu4B2, &zu4B3) == SUCCESS) && PZVAL_IS_REF(zu4B0) && (IS_LONG == Z_TYPE_P(zu4B0)) && PZVAL_IS_REF(zu4B1) && (IS_LONG == Z_TYPE_P(zu4B1)) && PZVAL_IS_REF(zu4B2) && (IS_LONG == Z_TYPE_P(zu4B2)) && PZVAL_IS_REF(zu4B3) && (IS_LONG == Z_TYPE_P(zu4B3)))
	{
		u4B0Raw = (uint32_t)Z_LVAL_P(zu4B0);
		u4B1Raw = (uint32_t)Z_LVAL_P(zu4B1);
		u4B2Raw = (uint32_t)Z_LVAL_P(zu4B2);
		u4B3Raw = (uint32_t)Z_LVAL_P(zu4B3);
		SBCheckError(SBTwofish_DecryptBlock((TTwofishExpandedKey *)SBGetStructPointer(oExpandedKey TSRMLS_CC), &u4B0Raw, &u4B1Raw, &u4B2Raw, &u4B3Raw) TSRMLS_CC);
		ZVAL_LONG(zu4B0, (long)u4B0Raw);
		ZVAL_LONG(zu4B1, (long)u4B1Raw);
		ZVAL_LONG(zu4B2, (long)u4B2Raw);
		ZVAL_LONG(zu4B3, (long)u4B3Raw);
	}
	else
	{
		SBErrorExpectsArguments("(TTwofishExpandedKey, &integer, &integer, &integer, &integer)" TSRMLS_CC);
	}
}

