#include "sbusers.h"

zend_class_entry *TElCustomUserClass_ce_ptr = NULL;

void SB_CALLBACK TSBOnCreateNewUserEventRaw(void * _ObjectData, TElCustomUserHandle * OutResult)
{
	zval * pzOutResult = NULL;
	TSRMLS_FETCH();

	SBCallEvent((zval *)_ObjectData, &pzOutResult, 0, NULL TSRMLS_CC);

	if (pzOutResult)
	{
		*OutResult = SBGetObjectHandleCE(pzOutResult, TElCustomUser_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(pzOutResult TSRMLS_CC);
		zval_ptr_dtor(&pzOutResult);
	}
}

zend_class_entry *TElUsers_ce_ptr = NULL;

SB_PHP_METHOD(TElUsers, AddUser)
{
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUser, TElCustomUser_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElUsers_AddUser(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomUser)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElUsers_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, DeleteUser)
{
	char *sUserName;
	int sUserName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sUserName, &sUserName_len) == SUCCESS)
	{
		SBCheckError(TElUsers_DeleteUser(SBGetObjectHandle(getThis() TSRMLS_CC), sUserName, (int32_t)sUserName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, FindUser)
{
	char *sUserName;
	int sUserName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sUserName, &sUserName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUsers_FindUser(SBGetObjectHandle(getThis() TSRMLS_CC), sUserName, (int32_t)sUserName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, IsValidPassword)
{
	char *sAPassword;
	char *sAUserName;
	int sAPassword_len;
	int sAUserName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sAUserName, &sAUserName_len, &sAPassword, &sAPassword_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElUsers_IsValidPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sAUserName, (int32_t)sAUserName_len, sAPassword, (int32_t)sAPassword_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, Lock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElUsers_Lock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, Unlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElUsers_Unlock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, LockUser)
{
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUser, TElCustomUser_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElUsers_LockUser(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomUser)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, UnlockUser)
{
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUser, TElCustomUser_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElUsers_UnlockUser(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomUser)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, Load)
{
	char *sAFileName;
	char *sAPassword;
	int sAFileName_len;
	int sAPassword_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElUsers_Load(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sAFileName, &sAFileName_len, &sAPassword, &sAPassword_len) == SUCCESS)
	{
		SBCheckError(TElUsers_Load_1(SBGetObjectHandle(getThis() TSRMLS_CC), sAFileName, (int32_t)sAFileName_len, sAPassword, (int32_t)sAPassword_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, Save)
{
	char *sAFileName;
	char *sAPassword;
	int sAFileName_len;
	int sAPassword_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElUsers_Save(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sAFileName, &sAFileName_len, &sAPassword, &sAPassword_len) == SUCCESS)
	{
		SBCheckError(TElUsers_Save_1(SBGetObjectHandle(getThis() TSRMLS_CC), sAFileName, (int32_t)sAFileName_len, sAPassword, (int32_t)sAPassword_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, LoadFromStream)
{
	char *sAPassword;
	int sAPassword_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElUsers_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oStream, TStream_ce_ptr, &sAPassword, &sAPassword_len) == SUCCESS)
	{
		SBCheckError(TElUsers_LoadFromStream_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sAPassword, (int32_t)sAPassword_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (TStream, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, SaveToStream)
{
	char *sAPassword;
	int sAPassword_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElUsers_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oStream, TStream_ce_ptr, &sAPassword, &sAPassword_len) == SUCCESS)
	{
		SBCheckError(TElUsers_SaveToStream_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sAPassword, (int32_t)sAPassword_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (TStream, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, get_Users)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUsers_get_Users(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElUsers_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, get_FileName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElUsers_get_FileName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1584925678, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, set_FileName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElUsers_set_FileName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, get_FilePassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElUsers_get_FilePassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1070182089, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, set_FilePassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElUsers_set_FilePassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, get_OnCreateNewUser)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOnCreateNewUserEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElUsers_get_OnCreateNewUser(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, set_OnCreateNewUser)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElUsers_set_OnCreateNewUser(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOnCreateNewUserEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOnCreateNewUserEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElUsers, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElUsers_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_AddUser, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, User, TElCustomUser, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_DeleteUser, 0, 0, 1)
	ZEND_ARG_INFO(0, UserName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_FindUser, 0, 0, 1)
	ZEND_ARG_INFO(0, UserName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_IsValidPassword, 0, 0, 2)
	ZEND_ARG_INFO(0, AUserName)
	ZEND_ARG_INFO(0, APassword)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_Lock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_Unlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_LockUser, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, User, TElCustomUser, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_UnlockUser, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, User, TElCustomUser, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_Load, 0, 0, 0)
	ZEND_ARG_INFO(0, AFileName)
	ZEND_ARG_INFO(0, APassword)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_Save, 0, 0, 0)
	ZEND_ARG_INFO(0, AFileName)
	ZEND_ARG_INFO(0, APassword)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, APassword)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, APassword)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_get_Users, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_get_FileName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_set_FileName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_get_FilePassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_set_FilePassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_get_OnCreateNewUser, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers_set_OnCreateNewUser, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElUsers___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElUsers_methods[] = {
	PHP_ME(TElUsers, AddUser, arginfo_TElUsers_AddUser, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, Clear, arginfo_TElUsers_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, DeleteUser, arginfo_TElUsers_DeleteUser, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, FindUser, arginfo_TElUsers_FindUser, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, IsValidPassword, arginfo_TElUsers_IsValidPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, Lock, arginfo_TElUsers_Lock, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, Unlock, arginfo_TElUsers_Unlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, LockUser, arginfo_TElUsers_LockUser, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, UnlockUser, arginfo_TElUsers_UnlockUser, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, Load, arginfo_TElUsers_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, Save, arginfo_TElUsers_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, LoadFromStream, arginfo_TElUsers_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, SaveToStream, arginfo_TElUsers_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, get_Users, arginfo_TElUsers_get_Users, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, get_Count, arginfo_TElUsers_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, get_FileName, arginfo_TElUsers_get_FileName, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, set_FileName, arginfo_TElUsers_set_FileName, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, get_FilePassword, arginfo_TElUsers_get_FilePassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, set_FilePassword, arginfo_TElUsers_set_FilePassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, get_OnCreateNewUser, arginfo_TElUsers_get_OnCreateNewUser, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, set_OnCreateNewUser, arginfo_TElUsers_set_OnCreateNewUser, ZEND_ACC_PUBLIC)
	PHP_ME(TElUsers, __construct, arginfo_TElUsers___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElUsers(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElUsers_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElUsers", TElUsers_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElUsers_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomUser_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomUser, GetData)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zl4Size) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		_err = TElCustomUser_GetData(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, &aiBuffer.len, &l4SizeRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-2135880145, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&array of byte|string, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomUser, SetData)
{
	long l4Size;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaValue, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElCustomUser_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomUser, IsValidPassword)
{
	char *sAPassword;
	int sAPassword_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAPassword, &sAPassword_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElCustomUser_IsValidPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sAPassword, (int32_t)sAPassword_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomUser, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomUser_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomUser, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomUser_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(192092321, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomUser, get_Password)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElCustomUser_get_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(702216136, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomUser, set_Password)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElCustomUser_set_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElCustomUser, __construct)
{
	char *sUserName;
	int sUserName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sUserName, &sUserName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomUser_Create(sUserName, (int32_t)sUserName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomUser_GetData, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(1, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomUser_SetData, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomUser_IsValidPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, APassword)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomUser_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomUser_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomUser_get_Password, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomUser_set_Password, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomUser___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, UserName)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomUser_methods[] = {
	PHP_ME(TElCustomUser, GetData, arginfo_TElCustomUser_GetData, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomUser, SetData, arginfo_TElCustomUser_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomUser, IsValidPassword, arginfo_TElCustomUser_IsValidPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomUser, ClassType, arginfo_TElCustomUser_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElCustomUser, get_Name, arginfo_TElCustomUser_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomUser, get_Password, arginfo_TElCustomUser_get_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomUser, set_Password, arginfo_TElCustomUser_set_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElCustomUser, __construct, arginfo_TElCustomUser___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomUser(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomUser_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomUser", TElCustomUser_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomUser_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBUsers_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBUsers, SUserExists, SB_SUserExists, SB_SUserExists);
	SB_REGISTER_STRING_CONSTANT(SBUsers, SCannotCreateNewUser, SB_SCannotCreateNewUser, SB_SCannotCreateNewUser);
	SB_REGISTER_STRING_CONSTANT(SBUsers, SCanNotLoadUsers, SB_SCanNotLoadUsers, SB_SCanNotLoadUsers);
	SB_REGISTER_STRING_CONSTANT(SBUsers, SInvalidUserFile, SB_SInvalidUserFile, SB_SInvalidUserFile);
	SB_REGISTER_STRING_CONSTANT(SBUsers, SCanNotSaveUsers, SB_SCanNotSaveUsers, SB_SCanNotSaveUsers);
	SB_REGISTER_STRING_CONSTANT(SBUsers, rsCannotCreateFile, SB_rsCannotCreateFile, SB_rsCannotCreateFile);
	SB_REGISTER_STRING_CONSTANT(SBUsers, rsCannotOpenFile, SB_rsCannotOpenFile, SB_rsCannotOpenFile);
	SB_REGISTER_STRING_CONSTANT(SBUsers, SCannotEditUser, SB_SCannotEditUser, SB_SCannotEditUser);
}

void Register_SBUsers_Aliases(TSRMLS_D)
{
	TElCustomUserClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TElCustomUserClass", TElCustomUserClass_ce_ptr);
}

