#include "sbwhirlpool.h"

SB_PHP_METHOD(TWhirlpoolContext, __construct)
{
	if (ZEND_NUM_ARGS() == 0)
	{
		php_sbb_struct * intern = (php_sbb_struct *)zend_object_store_get_object(getThis() TSRMLS_CC);
		intern->data = emalloc(sizeof(TWhirlpoolContext));
		intern->len = sizeof(TWhirlpoolContext);
		intern->ownData = 1;
	}
	else
		ZEND_WRONG_PARAM_COUNT();
}

SB_PHP_METHOD(TWhirlpoolContext, getSizeOf)
{
	if (ZEND_NUM_ARGS() > 0)
		ZEND_WRONG_PARAM_COUNT();

	RETURN_LONG(sizeof(TWhirlpoolContext));
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_GetField, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBBaseStruct_SetField, 0, 0, 1)
	ZEND_ARG_INFO(0, value)
ZEND_END_ARG_INFO()

SB_PHP_METHOD(TWhirlpoolContext, get_BufferSize)
{
	SBStuctGetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

SB_PHP_METHOD(TWhirlpoolContext, set_BufferSize)
{
	SBStuctSetFieldUInt32(INTERNAL_FUNCTION_PARAM_PASSTHRU, 8);
}

zend_class_entry *TWhirlpoolContext_ce_ptr = NULL;

static zend_function_entry TWhirlpoolContext_methods[] = {
	PHP_ME(TWhirlpoolContext, __construct, NULL, ZEND_ACC_PUBLIC)
	PHP_ME(TWhirlpoolContext, getSizeOf, NULL, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TWhirlpoolContext, get_BufferSize, arginfo_TSBBaseStruct_GetField, ZEND_ACC_PUBLIC)
	PHP_ME(TWhirlpoolContext, set_BufferSize, arginfo_TSBBaseStruct_SetField, ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TWhirlpoolContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TWhirlpoolContext_ce_ptr != NULL)
		return;
	INIT_CLASS_ENTRY(ce, "TWhirlpoolContext", TWhirlpoolContext_methods);
	TWhirlpoolContext_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseStruct_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBWhirlpool, InitializeWhirlpool)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TWhirlpoolContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		SBCheckError(SBWhirlpool_InitializeWhirlpool((TWhirlpoolContext *)SBGetStructPointer(oContext TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TWhirlpoolContext)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBWhirlpool, HashWhirlpool)
{
	long u4ChunkOffset;
	long u4ChunkSize;
	SBArrayZValInfo aiChunk;
	SBArrayZValInfo piChunk;
	zval *oContext;
	zval *zaChunk;
	zval *zpChunk;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oContext, TWhirlpoolContext_ce_ptr, &zpChunk, &u4ChunkSize) == SUCCESS) && PZVAL_IS_REF(oContext) && ((Z_TYPE_P(zpChunk) == IS_STRING) || (Z_TYPE_P(zpChunk) == IS_ARRAY) || (Z_TYPE_P(zpChunk) == IS_NULL) || ((Z_TYPE_P(zpChunk) == IS_OBJECT) && (Z_OBJCE_P(zpChunk) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpChunk, &piChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBWhirlpool_HashWhirlpool((TWhirlpoolContext *)SBGetStructPointer(oContext TSRMLS_CC), piChunk.data, (uint32_t)u4ChunkSize) TSRMLS_CC);
		SBFreePointerZValInfo(&piChunk);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozll", &oContext, TWhirlpoolContext_ce_ptr, &zaChunk, &u4ChunkOffset, &u4ChunkSize) == SUCCESS) && PZVAL_IS_REF(oContext) && ((IS_STRING == Z_TYPE_P(zaChunk)) || (IS_ARRAY == Z_TYPE_P(zaChunk)) || (IS_NULL == Z_TYPE_P(zaChunk))))
	{
		if (!SBGetByteArrayFromZVal(zaChunk, &aiChunk TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBWhirlpool_HashWhirlpool_1((TWhirlpoolContext *)SBGetStructPointer(oContext TSRMLS_CC), aiChunk.data, aiChunk.len, (uint32_t)u4ChunkOffset, (uint32_t)u4ChunkSize) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiChunk);
	}
	else
	{
		SBErrorExpectsArguments("(&TWhirlpoolContext, TSBPointer|array of byte|string|NULL, integer) or (&TWhirlpoolContext, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBWhirlpool, FinalizeWhirlpool)
{
	zval *oContext;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContext, TWhirlpoolContext_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContext))
	{
		TMessageDigest512 roOutResult;
		SBCheckError(SBWhirlpool_FinalizeWhirlpool((TWhirlpoolContext *)SBGetStructPointer(oContext TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TMessageDigest512_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TMessageDigest512) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TWhirlpoolContext)" TSRMLS_CC);
	}
}

