#ifndef __INC_SBALGORITHMIDENTIFIER
#define __INC_SBALGORITHMIDENTIFIER

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbconstants.h"
#include "sbasn1.h"
#include "sbasn1tree.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstrutils.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElAlgorithmIdentifierHandle;

typedef TElClassHandle TElRSAAlgorithmIdentifierHandle;

typedef TElClassHandle TElRSAPSSAlgorithmIdentifierHandle;

typedef TElClassHandle TElRSAOAEPAlgorithmIdentifierHandle;

typedef TElClassHandle TElDSAAlgorithmIdentifierHandle;

typedef TElClassHandle TElDHAlgorithmIdentifierHandle;

typedef TElClassHandle TElECAlgorithmIdentifierHandle;

typedef TElClassHandle TElECDSAAlgorithmIdentifierHandle;

typedef TElClassHandle TElGOST3411AlgorithmIdentifierHandle;

typedef TElClassHandle TElGOST3410AlgorithmIdentifierHandle;

typedef TElClassHandle TElGOST3411WithGOST3410AlgorithmIdentifierHandle;

#ifdef SB_USE_CLASS_TELALGORITHMIDENTIFIER
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_Assign(TElAlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_Clone(TElAlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_Equals(TElAlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle Algorithm, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_CreateFromBuffer(void * Buffer, int32_t Size, TElAlgorithmIdentifierHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_CreateFromBuffer_1(TElAlgorithmIdentifierHandle _Handle, void * Buffer, int32_t Size, TElAlgorithmIdentifierHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_CreateFromTag(TElASN1ConstrainedTagHandle Tag, TElAlgorithmIdentifierHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_CreateFromTag_1(TElAlgorithmIdentifierHandle _Handle, TElASN1ConstrainedTagHandle Tag, TElAlgorithmIdentifierHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_CreateByAlgorithm(int32_t Algorithm, TElAlgorithmIdentifierHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_CreateByAlgorithm_1(TElAlgorithmIdentifierHandle _Handle, int32_t Algorithm, TElAlgorithmIdentifierHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_CreateByAlgorithmOID(const uint8_t pOID[], int32_t szOID, TElAlgorithmIdentifierHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_CreateByAlgorithmOID_1(TElAlgorithmIdentifierHandle _Handle, const uint8_t pOID[], int32_t szOID, TElAlgorithmIdentifierHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_IsAlgorithmSupported(TElAlgorithmIdentifierHandle _Handle, int32_t Algorithm, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_LoadFromBuffer(TElAlgorithmIdentifierHandle _Handle, void * Buffer, int32_t Size);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_SaveToBuffer(TElAlgorithmIdentifierHandle _Handle, void * Buffer, int32_t * Size);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_LoadFromTag(TElAlgorithmIdentifierHandle _Handle, TElASN1ConstrainedTagHandle Tag);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_SaveToTag(TElAlgorithmIdentifierHandle _Handle, TElASN1ConstrainedTagHandle Tag);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_WriteParameters(TElAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_get_AlgorithmOID(TElAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_set_AlgorithmOID(TElAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_get_Algorithm(TElAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_set_Algorithm(TElAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_get_SignatureHashAlgorithm(TElAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_get_IsSignatureAlgorithm(TElAlgorithmIdentifierHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_get_IsPublicKeyAlgorithm(TElAlgorithmIdentifierHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_get_IsEncryptionAlgorithm(TElAlgorithmIdentifierHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_get_IsHashAlgorithm(TElAlgorithmIdentifierHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAlgorithmIdentifier_Create(TElAlgorithmIdentifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELRSAALGORITHMIDENTIFIER
SB_IMPORT uint32_t SB_APIENTRY TElRSAAlgorithmIdentifier_Assign(TElRSAAlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElRSAAlgorithmIdentifier_get_HashAlgorithm(TElRSAAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRSAAlgorithmIdentifier_set_HashAlgorithm(TElRSAAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElRSAAlgorithmIdentifier_Create(TElRSAAlgorithmIdentifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELRSAALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELRSAPSSALGORITHMIDENTIFIER
SB_IMPORT uint32_t SB_APIENTRY TElRSAPSSAlgorithmIdentifier_Assign(TElRSAPSSAlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElRSAPSSAlgorithmIdentifier_get_HashAlgorithm(TElRSAPSSAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRSAPSSAlgorithmIdentifier_set_HashAlgorithm(TElRSAPSSAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElRSAPSSAlgorithmIdentifier_get_SaltSize(TElRSAPSSAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRSAPSSAlgorithmIdentifier_set_SaltSize(TElRSAPSSAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElRSAPSSAlgorithmIdentifier_get_TrailerField(TElRSAPSSAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRSAPSSAlgorithmIdentifier_set_TrailerField(TElRSAPSSAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElRSAPSSAlgorithmIdentifier_get_MGF(TElRSAPSSAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRSAPSSAlgorithmIdentifier_set_MGF(TElRSAPSSAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElRSAPSSAlgorithmIdentifier_get_MGFHashAlgorithm(TElRSAPSSAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRSAPSSAlgorithmIdentifier_set_MGFHashAlgorithm(TElRSAPSSAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElRSAPSSAlgorithmIdentifier_Create(TElRSAPSSAlgorithmIdentifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELRSAPSSALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELRSAOAEPALGORITHMIDENTIFIER
SB_IMPORT uint32_t SB_APIENTRY TElRSAOAEPAlgorithmIdentifier_Assign(TElRSAOAEPAlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElRSAOAEPAlgorithmIdentifier_get_HashAlgorithm(TElRSAOAEPAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRSAOAEPAlgorithmIdentifier_set_HashAlgorithm(TElRSAOAEPAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElRSAOAEPAlgorithmIdentifier_get_MGF(TElRSAOAEPAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRSAOAEPAlgorithmIdentifier_set_MGF(TElRSAOAEPAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElRSAOAEPAlgorithmIdentifier_get_MGFHashAlgorithm(TElRSAOAEPAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRSAOAEPAlgorithmIdentifier_set_MGFHashAlgorithm(TElRSAOAEPAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElRSAOAEPAlgorithmIdentifier_get_StrLabel(TElRSAOAEPAlgorithmIdentifierHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRSAOAEPAlgorithmIdentifier_set_StrLabel(TElRSAOAEPAlgorithmIdentifierHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElRSAOAEPAlgorithmIdentifier_get_WriteDefaults(TElRSAOAEPAlgorithmIdentifierHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElRSAOAEPAlgorithmIdentifier_set_WriteDefaults(TElRSAOAEPAlgorithmIdentifierHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElRSAOAEPAlgorithmIdentifier_Create(TElRSAOAEPAlgorithmIdentifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELRSAOAEPALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELDSAALGORITHMIDENTIFIER
SB_IMPORT uint32_t SB_APIENTRY TElDSAAlgorithmIdentifier_Assign(TElDSAAlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElDSAAlgorithmIdentifier_get_P(TElDSAAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDSAAlgorithmIdentifier_set_P(TElDSAAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDSAAlgorithmIdentifier_get_Q(TElDSAAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDSAAlgorithmIdentifier_set_Q(TElDSAAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDSAAlgorithmIdentifier_get_G(TElDSAAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDSAAlgorithmIdentifier_set_G(TElDSAAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDSAAlgorithmIdentifier_Create(TElDSAAlgorithmIdentifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELDSAALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELDHALGORITHMIDENTIFIER
SB_IMPORT uint32_t SB_APIENTRY TElDHAlgorithmIdentifier_Assign(TElDHAlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElDHAlgorithmIdentifier_get_P(TElDHAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDHAlgorithmIdentifier_set_P(TElDHAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDHAlgorithmIdentifier_get_Q(TElDHAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDHAlgorithmIdentifier_set_Q(TElDHAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDHAlgorithmIdentifier_get_G(TElDHAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDHAlgorithmIdentifier_set_G(TElDHAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDHAlgorithmIdentifier_Create(TElDHAlgorithmIdentifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELDHALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELECALGORITHMIDENTIFIER
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_Assign(TElECAlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_Version(TElECAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_Version(TElECAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_Curve(TElECAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_Curve(TElECAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_FieldID(TElECAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_FieldID(TElECAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_FieldType(TElECAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_FieldType(TElECAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_Basis(TElECAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_Basis(TElECAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_M(TElECAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_M(TElECAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_K1(TElECAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_K1(TElECAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_K2(TElECAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_K2(TElECAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_K3(TElECAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_K3(TElECAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_HashAlgorithm(TElECAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_HashAlgorithm(TElECAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_SpecifiedCurve(TElECAlgorithmIdentifierHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_SpecifiedCurve(TElECAlgorithmIdentifierHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_CompressPoints(TElECAlgorithmIdentifierHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_CompressPoints(TElECAlgorithmIdentifierHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_HybridPoints(TElECAlgorithmIdentifierHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_HybridPoints(TElECAlgorithmIdentifierHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_ImplicitCurve(TElECAlgorithmIdentifierHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_ImplicitCurve(TElECAlgorithmIdentifierHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_Seed(TElECAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_Seed(TElECAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_P(TElECAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_P(TElECAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_N(TElECAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_N(TElECAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_H(TElECAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_H(TElECAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_A(TElECAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_A(TElECAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_B(TElECAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_B(TElECAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_X(TElECAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_X(TElECAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_Y(TElECAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_Y(TElECAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_get_Base(TElECAlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_set_Base(TElECAlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElECAlgorithmIdentifier_Create(TElECAlgorithmIdentifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELECALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELECDSAALGORITHMIDENTIFIER
SB_IMPORT uint32_t SB_APIENTRY TElECDSAAlgorithmIdentifier_Assign(TElECDSAAlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElECDSAAlgorithmIdentifier_get_HashAlgorithm(TElECDSAAlgorithmIdentifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElECDSAAlgorithmIdentifier_set_HashAlgorithm(TElECDSAAlgorithmIdentifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElECDSAAlgorithmIdentifier_Create(TElECDSAAlgorithmIdentifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELECDSAALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELGOST3411ALGORITHMIDENTIFIER
SB_IMPORT uint32_t SB_APIENTRY TElGOST3411AlgorithmIdentifier_Assign(TElGOST3411AlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElGOST3411AlgorithmIdentifier_Create(TElGOST3411AlgorithmIdentifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOST3411ALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELGOST3410ALGORITHMIDENTIFIER
SB_IMPORT uint32_t SB_APIENTRY TElGOST3410AlgorithmIdentifier_Assign(TElGOST3410AlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElGOST3410AlgorithmIdentifier_get_PublicKeyParamSet(TElGOST3410AlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOST3410AlgorithmIdentifier_set_PublicKeyParamSet(TElGOST3410AlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGOST3410AlgorithmIdentifier_get_DigestParamSet(TElGOST3410AlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOST3410AlgorithmIdentifier_set_DigestParamSet(TElGOST3410AlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGOST3410AlgorithmIdentifier_get_EncryptionParamSet(TElGOST3410AlgorithmIdentifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOST3410AlgorithmIdentifier_set_EncryptionParamSet(TElGOST3410AlgorithmIdentifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGOST3410AlgorithmIdentifier_Create(TElGOST3410AlgorithmIdentifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOST3410ALGORITHMIDENTIFIER */

#ifdef SB_USE_CLASS_TELGOST3411WITHGOST3410ALGORITHMIDENTIFIER
SB_IMPORT uint32_t SB_APIENTRY TElGOST3411WithGOST3410AlgorithmIdentifier_Assign(TElGOST3411WithGOST3410AlgorithmIdentifierHandle _Handle, TElAlgorithmIdentifierHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElGOST3411WithGOST3410AlgorithmIdentifier_Create(TElGOST3411WithGOST3410AlgorithmIdentifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOST3411WITHGOST3410ALGORITHMIDENTIFIER */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElAlgorithmIdentifier_ce_ptr;
extern zend_class_entry *TElRSAAlgorithmIdentifier_ce_ptr;
extern zend_class_entry *TElRSAPSSAlgorithmIdentifier_ce_ptr;
extern zend_class_entry *TElRSAOAEPAlgorithmIdentifier_ce_ptr;
extern zend_class_entry *TElDSAAlgorithmIdentifier_ce_ptr;
extern zend_class_entry *TElDHAlgorithmIdentifier_ce_ptr;
extern zend_class_entry *TElECAlgorithmIdentifier_ce_ptr;
extern zend_class_entry *TElECDSAAlgorithmIdentifier_ce_ptr;
extern zend_class_entry *TElGOST3411AlgorithmIdentifier_ce_ptr;
extern zend_class_entry *TElGOST3410AlgorithmIdentifier_ce_ptr;
extern zend_class_entry *TElGOST3411WithGOST3410AlgorithmIdentifier_ce_ptr;

void Register_TElAlgorithmIdentifier(TSRMLS_D);
void Register_TElRSAAlgorithmIdentifier(TSRMLS_D);
void Register_TElRSAPSSAlgorithmIdentifier(TSRMLS_D);
void Register_TElRSAOAEPAlgorithmIdentifier(TSRMLS_D);
void Register_TElDSAAlgorithmIdentifier(TSRMLS_D);
void Register_TElDHAlgorithmIdentifier(TSRMLS_D);
void Register_TElECAlgorithmIdentifier(TSRMLS_D);
void Register_TElECDSAAlgorithmIdentifier(TSRMLS_D);
void Register_TElGOST3411AlgorithmIdentifier(TSRMLS_D);
void Register_TElGOST3410AlgorithmIdentifier(TSRMLS_D);
void Register_TElGOST3411WithGOST3410AlgorithmIdentifier(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBALGORITHMIDENTIFIER */

