#ifndef __INC_SBAS2
#define __INC_SBAS2

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstrutils.h"
#include "sbstreams.h"
#include "sbconstants.h"
#include "sbsocket.h"
#include "sbcustomcertstorage.h"
#include "sbsslcommon.h"
#include "sbsslconstants.h"
#include "sbsslclient.h"
#include "sbx509.h"
#include "sbmime.h"
#include "sbhttpscommon.h"
#include "sbhttpsclient.h"
#include "sbhttpsconstants.h"
#ifdef SB_WINDOWS
#include "sbdnssecconsts.h"
#include "sbdnssectypes.h"
#endif
#include "sbascommon.h"
#include "sbasutils.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElAS2ReceiptRequestHandle;

typedef TElClassHandle TElAS2EncryptionHandle;

typedef TElClassHandle TElAS2SignatureHandle;

typedef TElClassHandle TElAS2CompressionHandle;

typedef TElClassHandle TElAS2ReceiptHandle;

typedef TElClassHandle TElAS2MessageHandle;

typedef TElClassHandle TElAS2HTTPOptionsHandle;

typedef TElClassHandle TElAS2ProxyOptionsHandle;

typedef TElClassHandle TElAS2SocketOptionsHandle;

typedef TElClassHandle TElAS2SocksOptionsHandle;

typedef TElClassHandle TElAS2SSLOptionsHandle;

typedef TElClassHandle TElAS2WebTunnelOptionsHandle;

typedef TElClassHandle TElAS2ClientHandle;

typedef uint8_t TSBAS2VersionRaw;

typedef enum
{
	as2Ver10 = 0,
	as2Ver11 = 1,
	as2Ver12 = 2
} TSBAS2Version;

#ifdef SB_USE_CLASS_TELAS2RECEIPTREQUEST
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_Assign(TElAS2ReceiptRequestHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_get_AsyncReceipt(TElAS2ReceiptRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_set_AsyncReceipt(TElAS2ReceiptRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_get_DigestAlgorithm(TElAS2ReceiptRequestHandle _Handle, TSBASSignatureDigestAlgorithmRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_set_DigestAlgorithm(TElAS2ReceiptRequestHandle _Handle, TSBASSignatureDigestAlgorithmRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_get_DigestAlgorithmOnly(TElAS2ReceiptRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_set_DigestAlgorithmOnly(TElAS2ReceiptRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_get_DigestAlgorithmRequired(TElAS2ReceiptRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_set_DigestAlgorithmRequired(TElAS2ReceiptRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_get_Enabled(TElAS2ReceiptRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_set_Enabled(TElAS2ReceiptRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_get_SignatureProtocolRequired(TElAS2ReceiptRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_set_SignatureProtocolRequired(TElAS2ReceiptRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_get_Signed(TElAS2ReceiptRequestHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_set_Signed(TElAS2ReceiptRequestHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_get_URL(TElAS2ReceiptRequestHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_set_URL(TElAS2ReceiptRequestHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ReceiptRequest_Create(TElAS2ReceiptRequestHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2RECEIPTREQUEST */

#ifdef SB_USE_CLASS_TELAS2ENCRYPTION
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_get_Algorithm(TElAS2EncryptionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_set_Algorithm(TElAS2EncryptionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_get_AlignEncryptedKey(TElAS2EncryptionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_set_AlignEncryptedKey(TElAS2EncryptionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_get_BitsInKey(TElAS2EncryptionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_set_BitsInKey(TElAS2EncryptionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_get_CertStorage(TElAS2EncryptionHandle _Handle, TElCustomCertStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_set_CertStorage(TElAS2EncryptionHandle _Handle, TElCustomCertStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_get_Enabled(TElAS2EncryptionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_set_Enabled(TElAS2EncryptionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_get_Encoding(TElAS2EncryptionHandle _Handle, TSBASEncryptionTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_set_Encoding(TElAS2EncryptionHandle _Handle, TSBASEncryptionTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_get_UseUndefSize(TElAS2EncryptionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_set_UseUndefSize(TElAS2EncryptionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Encryption_Create(TComponentHandle AOwner, TElASSMIMEEncryptionHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2ENCRYPTION */

#ifdef SB_USE_CLASS_TELAS2SIGNATURE
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_get_VerificationResult(TElAS2SignatureHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_get_CertStorage(TElAS2SignatureHandle _Handle, TElCustomCertStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_set_CertStorage(TElAS2SignatureHandle _Handle, TElCustomCertStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_get_Compressed(TElAS2SignatureHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_set_Compressed(TElAS2SignatureHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_get_DigestAlgorithm(TElAS2SignatureHandle _Handle, TSBASSignatureDigestAlgorithmRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_set_DigestAlgorithm(TElAS2SignatureHandle _Handle, TSBASSignatureDigestAlgorithmRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_get_Enabled(TElAS2SignatureHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_set_Enabled(TElAS2SignatureHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_get_Encoding(TElAS2SignatureHandle _Handle, TSBASSignatureTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_set_Encoding(TElAS2SignatureHandle _Handle, TSBASSignatureTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_get_IncludeChain(TElAS2SignatureHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_set_IncludeChain(TElAS2SignatureHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_get_Time(TElAS2SignatureHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_set_Time(TElAS2SignatureHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_get_UseUndefSize(TElAS2SignatureHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_set_UseUndefSize(TElAS2SignatureHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_get_VerificationOptions(TElAS2SignatureHandle _Handle, TSBASSMIMEVerificationOptionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_set_VerificationOptions(TElAS2SignatureHandle _Handle, TSBASSMIMEVerificationOptionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Signature_Create(TComponentHandle AOwner, TElASSMIMESignatureHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2SIGNATURE */

#ifdef SB_USE_CLASS_TELAS2COMPRESSION
SB_IMPORT uint32_t SB_APIENTRY TElAS2Compression_get_Enabled(TElAS2CompressionHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Compression_set_Enabled(TElAS2CompressionHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Compression_get_Encoding(TElAS2CompressionHandle _Handle, TSBASCompressionTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Compression_set_Encoding(TElAS2CompressionHandle _Handle, TSBASCompressionTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Compression_get_Level(TElAS2CompressionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Compression_set_Level(TElAS2CompressionHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Compression_Create(TComponentHandle AOwner, TElASSMIMECompressionHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2COMPRESSION */

#ifdef SB_USE_CLASS_TELAS2RECEIPT
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_Assign(TElAS2ReceiptHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_Errors(TElAS2ReceiptHandle _Handle, TElASMessageErrorListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_ReceivedContentDigest(TElAS2ReceiptHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_ReceivedContentDigest(TElAS2ReceiptHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_ReceivedContentDigestAlgorithm(TElAS2ReceiptHandle _Handle, TSBASSignatureDigestAlgorithmRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_ReceivedContentDigestAlgorithm(TElAS2ReceiptHandle _Handle, TSBASSignatureDigestAlgorithmRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_ActionMode(TElAS2ReceiptHandle _Handle, TSBASDispositionActionModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_ActionMode(TElAS2ReceiptHandle _Handle, TSBASDispositionActionModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_AS2From(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_AS2From(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_AS2To(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_AS2To(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_Date(TElAS2ReceiptHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_Date(TElAS2ReceiptHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_DetailedErrors(TElAS2ReceiptHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_DetailedErrors(TElAS2ReceiptHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_FinalRecipient(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_FinalRecipient(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_MDNGateway(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_MDNGateway(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_MessageID(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_MessageID(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_OriginalMessageID(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_OriginalMessageID(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_OriginalRecipient(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_OriginalRecipient(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_ReportCharset(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_ReportCharset(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_ReportCharsetMode(TElAS2ReceiptHandle _Handle, TSBASCharsetModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_ReportCharsetMode(TElAS2ReceiptHandle _Handle, TSBASCharsetModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_ReportEncoding(TElAS2ReceiptHandle _Handle, TSBASHeaderTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_ReportEncoding(TElAS2ReceiptHandle _Handle, TSBASHeaderTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_ReportingUA(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_ReportingUA(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_SendingMode(TElAS2ReceiptHandle _Handle, TSBASDispositionSendingModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_SendingMode(TElAS2ReceiptHandle _Handle, TSBASDispositionSendingModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_Signature(TElAS2ReceiptHandle _Handle, TElAS2SignatureHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_Signature(TElAS2ReceiptHandle _Handle, TElAS2SignatureHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_SortErrors(TElAS2ReceiptHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_SortErrors(TElAS2ReceiptHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_Subject(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_Subject(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_Text(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_Text(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_TextCharset(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_TextCharset(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_TextCharsetMode(TElAS2ReceiptHandle _Handle, TSBASCharsetModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_TextCharsetMode(TElAS2ReceiptHandle _Handle, TSBASCharsetModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_TextContentType(TElAS2ReceiptHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_TextContentType(TElAS2ReceiptHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_TextEncoding(TElAS2ReceiptHandle _Handle, TSBASHeaderTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_TextEncoding(TElAS2ReceiptHandle _Handle, TSBASHeaderTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_UseFolding(TElAS2ReceiptHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_UseFolding(TElAS2ReceiptHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_Version(TElAS2ReceiptHandle _Handle, TSBAS2VersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_Version(TElAS2ReceiptHandle _Handle, TSBAS2VersionRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_OnError(TElAS2ReceiptHandle _Handle, TSBASReceiptErrorEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_OnError(TElAS2ReceiptHandle _Handle, TSBASReceiptErrorEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_OnHeaderAssembled(TElAS2ReceiptHandle _Handle, TSBASHeaderEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_OnHeaderAssembled(TElAS2ReceiptHandle _Handle, TSBASHeaderEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_OnHeaderParsed(TElAS2ReceiptHandle _Handle, TSBASHeaderEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_OnHeaderParsed(TElAS2ReceiptHandle _Handle, TSBASHeaderEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_OnSign(TElAS2ReceiptHandle _Handle, TSBASMessageSignEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_OnSign(TElAS2ReceiptHandle _Handle, TSBASMessageSignEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_OnSigning(TElAS2ReceiptHandle _Handle, TSBASMessageSignEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_OnSigning(TElAS2ReceiptHandle _Handle, TSBASMessageSignEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_OnStepStart(TElAS2ReceiptHandle _Handle, TSBASProcessingStepStart * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_OnStepStart(TElAS2ReceiptHandle _Handle, TSBASProcessingStepStart pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_OnVerify(TElAS2ReceiptHandle _Handle, TSBASMessageVerifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_OnVerify(TElAS2ReceiptHandle _Handle, TSBASMessageVerifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_OnVerifyIDs(TElAS2ReceiptHandle _Handle, TSBASMessageVerifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_OnVerifyIDs(TElAS2ReceiptHandle _Handle, TSBASMessageVerifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_get_OnVerifying(TElAS2ReceiptHandle _Handle, TSBASMessageVerifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_set_OnVerifying(TElAS2ReceiptHandle _Handle, TSBASMessageVerifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Receipt_Create(TComponentHandle AOwner, TElAS2ReceiptHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2RECEIPT */

#ifdef SB_USE_CLASS_TELAS2MESSAGE
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_Assign(TElAS2MessageHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_Cancelled(TElAS2MessageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_ContentDigest(TElAS2MessageHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_ContentDigestAlgorithm(TElAS2MessageHandle _Handle, TSBASSignatureDigestAlgorithmRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_Errors(TElAS2MessageHandle _Handle, TElASMessageErrorListHandle * OutResult);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_Features(TElAS2MessageHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_Features(TElAS2MessageHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_AS2From(TElAS2MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_AS2From(TElAS2MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_AS2To(TElAS2MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_AS2To(TElAS2MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_Charset(TElAS2MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_Charset(TElAS2MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_CharsetMode(TElAS2MessageHandle _Handle, TSBASCharsetModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_CharsetMode(TElAS2MessageHandle _Handle, TSBASCharsetModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_Compression(TElAS2MessageHandle _Handle, TElAS2CompressionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_Compression(TElAS2MessageHandle _Handle, TElAS2CompressionHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_ContentType(TElAS2MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_ContentType(TElAS2MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_DataEncoding(TElAS2MessageHandle _Handle, TSBASDataTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_DataEncoding(TElAS2MessageHandle _Handle, TSBASDataTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_Date(TElAS2MessageHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_Date(TElAS2MessageHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_Encryption(TElAS2MessageHandle _Handle, TElAS2EncryptionHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_Encryption(TElAS2MessageHandle _Handle, TElAS2EncryptionHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_FileCreated(TElAS2MessageHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_FileCreated(TElAS2MessageHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_FileModified(TElAS2MessageHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_FileModified(TElAS2MessageHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_FileName(TElAS2MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_FileName(TElAS2MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_HeaderEncoding(TElAS2MessageHandle _Handle, TSBASHeaderTransferEncodingRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_HeaderEncoding(TElAS2MessageHandle _Handle, TSBASHeaderTransferEncodingRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_IgnoreFileWarnings(TElAS2MessageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_IgnoreFileWarnings(TElAS2MessageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_MessageID(TElAS2MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_MessageID(TElAS2MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_ReceiptRequest(TElAS2MessageHandle _Handle, TElAS2ReceiptRequestHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_ReceiptRequest(TElAS2MessageHandle _Handle, TElAS2ReceiptRequestHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_Signature(TElAS2MessageHandle _Handle, TElAS2SignatureHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_Signature(TElAS2MessageHandle _Handle, TElAS2SignatureHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_Subject(TElAS2MessageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_Subject(TElAS2MessageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_UseFolding(TElAS2MessageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_UseFolding(TElAS2MessageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_Version(TElAS2MessageHandle _Handle, TSBAS2VersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_Version(TElAS2MessageHandle _Handle, TSBAS2VersionRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnDecrypt(TElAS2MessageHandle _Handle, TSBASMessageDecryptEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnDecrypt(TElAS2MessageHandle _Handle, TSBASMessageDecryptEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnDecryptIDs(TElAS2MessageHandle _Handle, TSBASMessageDecryptEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnDecryptIDs(TElAS2MessageHandle _Handle, TSBASMessageDecryptEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnDecrypting(TElAS2MessageHandle _Handle, TSBASMessageDecryptEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnDecrypting(TElAS2MessageHandle _Handle, TSBASMessageDecryptEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnEncrypt(TElAS2MessageHandle _Handle, TSBASMessageEncryptEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnEncrypt(TElAS2MessageHandle _Handle, TSBASMessageEncryptEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnEncrypting(TElAS2MessageHandle _Handle, TSBASMessageEncryptEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnEncrypting(TElAS2MessageHandle _Handle, TSBASMessageEncryptEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnError(TElAS2MessageHandle _Handle, TSBASMessageErrorEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnError(TElAS2MessageHandle _Handle, TSBASMessageErrorEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnHeaderAssembled(TElAS2MessageHandle _Handle, TSBASHeaderEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnHeaderAssembled(TElAS2MessageHandle _Handle, TSBASHeaderEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnHeaderParsed(TElAS2MessageHandle _Handle, TSBASHeaderEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnHeaderParsed(TElAS2MessageHandle _Handle, TSBASHeaderEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnProgress(TElAS2MessageHandle _Handle, TSBProgressEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnProgress(TElAS2MessageHandle _Handle, TSBProgressEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnSign(TElAS2MessageHandle _Handle, TSBASMessageSignEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnSign(TElAS2MessageHandle _Handle, TSBASMessageSignEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnSigning(TElAS2MessageHandle _Handle, TSBASMessageSignEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnSigning(TElAS2MessageHandle _Handle, TSBASMessageSignEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnStepStart(TElAS2MessageHandle _Handle, TSBASProcessingStepStart * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnStepStart(TElAS2MessageHandle _Handle, TSBASProcessingStepStart pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnTempRelease(TElAS2MessageHandle _Handle, TSBASStreamReleaseEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnTempRelease(TElAS2MessageHandle _Handle, TSBASStreamReleaseEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnTempRequest(TElAS2MessageHandle _Handle, TSBASStreamRequestEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnTempRequest(TElAS2MessageHandle _Handle, TSBASStreamRequestEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnVerify(TElAS2MessageHandle _Handle, TSBASMessageVerifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnVerify(TElAS2MessageHandle _Handle, TSBASMessageVerifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnVerifyIDs(TElAS2MessageHandle _Handle, TSBASMessageVerifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnVerifyIDs(TElAS2MessageHandle _Handle, TSBASMessageVerifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_get_OnVerifying(TElAS2MessageHandle _Handle, TSBASMessageVerifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_set_OnVerifying(TElAS2MessageHandle _Handle, TSBASMessageVerifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Message_Create(TComponentHandle AOwner, TElAS2MessageHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2MESSAGE */

#ifdef SB_USE_CLASS_TELAS2HTTPOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_Assign(TElAS2HTTPOptionsHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_get_KeepAlivePolicy(TElAS2HTTPOptionsHandle _Handle, TSBHTTPKeepAlivePolicyRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_set_KeepAlivePolicy(TElAS2HTTPOptionsHandle _Handle, TSBHTTPKeepAlivePolicyRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_get_MaxRedirections(TElAS2HTTPOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_set_MaxRedirections(TElAS2HTTPOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_get_Password(TElAS2HTTPOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_set_Password(TElAS2HTTPOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_get_UseCompression(TElAS2HTTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_set_UseCompression(TElAS2HTTPOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_get_UseDigestAuth(TElAS2HTTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_set_UseDigestAuth(TElAS2HTTPOptionsHandle _Handle, int8_t Value);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_get_UseNTLMAuth(TElAS2HTTPOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_set_UseNTLMAuth(TElAS2HTTPOptionsHandle _Handle, int8_t Value);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_get_UserAgent(TElAS2HTTPOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_set_UserAgent(TElAS2HTTPOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_get_UserName(TElAS2HTTPOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_set_UserName(TElAS2HTTPOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_get_Version(TElAS2HTTPOptionsHandle _Handle, TSBHTTPVersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_set_Version(TElAS2HTTPOptionsHandle _Handle, TSBHTTPVersionRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2HTTPOptions_Create(TElHTTPSClientHandle AClient, TElAS2HTTPOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2HTTPOPTIONS */

#ifdef SB_USE_CLASS_TELAS2PROXYOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElAS2ProxyOptions_Assign(TElAS2ProxyOptionsHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ProxyOptions_get_Enabled(TElAS2ProxyOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ProxyOptions_set_Enabled(TElAS2ProxyOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ProxyOptions_get_Host(TElAS2ProxyOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ProxyOptions_set_Host(TElAS2ProxyOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ProxyOptions_get_Password(TElAS2ProxyOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ProxyOptions_set_Password(TElAS2ProxyOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ProxyOptions_get_Port(TElAS2ProxyOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ProxyOptions_set_Port(TElAS2ProxyOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ProxyOptions_get_UserName(TElAS2ProxyOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ProxyOptions_set_UserName(TElAS2ProxyOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2ProxyOptions_Create(TElHTTPSClientHandle AClient, TElAS2ProxyOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2PROXYOPTIONS */

#ifdef SB_USE_CLASS_TELAS2SOCKETOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_Assign(TElAS2SocketOptionsHandle _Handle, TPersistentHandle Source);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_UsingIPv6(TElAS2SocketOptionsHandle _Handle, int8_t * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_Binding(TElAS2SocketOptionsHandle _Handle, TElClientSocketBindingHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_set_Binding(TElAS2SocketOptionsHandle _Handle, TElClientSocketBindingHandle Value);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_DNS(TElAS2SocketOptionsHandle _Handle, TElDNSSettingsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_set_DNS(TElAS2SocketOptionsHandle _Handle, TElDNSSettingsHandle Value);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_IncomingSpeedLimit(TElAS2SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_set_IncomingSpeedLimit(TElAS2SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_OutgoingSpeedLimit(TElAS2SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_set_OutgoingSpeedLimit(TElAS2SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_Timeout(TElAS2SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_set_Timeout(TElAS2SocketOptionsHandle _Handle, int32_t Value);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_UseIPv6(TElAS2SocketOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_set_UseIPv6(TElAS2SocketOptionsHandle _Handle, int8_t Value);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_AutoAdjustBuffersSize(TElAS2SocketOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_set_AutoAdjustBuffersSize(TElAS2SocketOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_BuffersAdjustStep(TElAS2SocketOptionsHandle _Handle, double * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_set_BuffersAdjustStep(TElAS2SocketOptionsHandle _Handle, double Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_MaxBufferSize(TElAS2SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_set_MaxBufferSize(TElAS2SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_MinBufferSize(TElAS2SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_set_MinBufferSize(TElAS2SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_RecvBufferSize(TElAS2SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_set_RecvBufferSize(TElAS2SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_get_SendBufferSize(TElAS2SocketOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_set_SendBufferSize(TElAS2SocketOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocketOptions_Create(TElHTTPSClientHandle AClient, TElAS2SocketOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2SOCKETOPTIONS */

#ifdef SB_USE_CLASS_TELAS2SOCKSOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_Assign(TElAS2SocksOptionsHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_get_Authentication(TElAS2SocksOptionsHandle _Handle, TElSocksAuthenticationRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_set_Authentication(TElAS2SocksOptionsHandle _Handle, TElSocksAuthenticationRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_get_Enabled(TElAS2SocksOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_set_Enabled(TElAS2SocksOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_get_Host(TElAS2SocksOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_set_Host(TElAS2SocksOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_get_Password(TElAS2SocksOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_set_Password(TElAS2SocksOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_get_Port(TElAS2SocksOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_set_Port(TElAS2SocksOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_get_ResolveAddress(TElAS2SocksOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_set_ResolveAddress(TElAS2SocksOptionsHandle _Handle, int8_t Value);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_get_UseIPv6(TElAS2SocksOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_set_UseIPv6(TElAS2SocksOptionsHandle _Handle, int8_t Value);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_get_UserCode(TElAS2SocksOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_set_UserCode(TElAS2SocksOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_get_Version(TElAS2SocksOptionsHandle _Handle, TElSocksVersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_set_Version(TElAS2SocksOptionsHandle _Handle, TElSocksVersionRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SocksOptions_Create(TElHTTPSClientHandle AClient, TElAS2SocksOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2SOCKSOPTIONS */

#ifdef SB_USE_CLASS_TELAS2SSLOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_Assign(TElAS2SSLOptionsHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_InternalValidate(TElAS2SSLOptionsHandle _Handle, TSBCertificateValidityRaw * Validity, TSBCertificateValidityReasonRaw * Reason);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_RenegotiateCiphers(TElAS2SSLOptionsHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_Active(TElAS2SSLOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_CurrentCipherSuite(TElAS2SSLOptionsHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_CurrentCompression(TElAS2SSLOptionsHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_CurrentVersion(TElAS2SSLOptionsHandle _Handle, TSBVersionRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_ServerExtensions(TElAS2SSLOptionsHandle _Handle, TElCustomSSLExtensionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_set_ServerExtensions(TElAS2SSLOptionsHandle _Handle, TElCustomSSLExtensionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_Extensions(TElAS2SSLOptionsHandle _Handle, TElClientSSLExtensionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_set_Extensions(TElAS2SSLOptionsHandle _Handle, TElClientSSLExtensionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_Options(TElAS2SSLOptionsHandle _Handle, TSBSSLOptionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_set_Options(TElAS2SSLOptionsHandle _Handle, TSBSSLOptionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_CipherSuitePriorities(TElAS2SSLOptionsHandle _Handle, uint8_t Index, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_set_CipherSuitePriorities(TElAS2SSLOptionsHandle _Handle, uint8_t Index, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_CipherSuites(TElAS2SSLOptionsHandle _Handle, uint8_t Index, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_set_CipherSuites(TElAS2SSLOptionsHandle _Handle, uint8_t Index, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_CompressionAlgorithms(TElAS2SSLOptionsHandle _Handle, uint8_t Index, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_set_CompressionAlgorithms(TElAS2SSLOptionsHandle _Handle, uint8_t Index, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_CertStorage(TElAS2SSLOptionsHandle _Handle, TElCustomCertStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_set_CertStorage(TElAS2SSLOptionsHandle _Handle, TElCustomCertStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_ClientCertStorage(TElAS2SSLOptionsHandle _Handle, TElCustomCertStorageHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_set_ClientCertStorage(TElAS2SSLOptionsHandle _Handle, TElCustomCertStorageHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_SRPPassword(TElAS2SSLOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_set_SRPPassword(TElAS2SSLOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_SRPUserName(TElAS2SSLOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_set_SRPUserName(TElAS2SSLOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_Versions(TElAS2SSLOptionsHandle _Handle, TSBVersionsRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_set_Versions(TElAS2SSLOptionsHandle _Handle, TSBVersionsRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_get_RenegotiationAttackPreventionMode(TElAS2SSLOptionsHandle _Handle, TSBRenegotiationAttackPreventionModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_set_RenegotiationAttackPreventionMode(TElAS2SSLOptionsHandle _Handle, TSBRenegotiationAttackPreventionModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2SSLOptions_Create(TElHTTPSClientHandle AClient, TElAS2SSLOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2SSLOPTIONS */

#ifdef SB_USE_CLASS_TELAS2WEBTUNNELOPTIONS
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_Assign(TElAS2WebTunnelOptionsHandle _Handle, TPersistentHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_get_ServerResult(TElAS2WebTunnelOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_get_Authentication(TElAS2WebTunnelOptionsHandle _Handle, TElWebTunnelAuthenticationRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_set_Authentication(TElAS2WebTunnelOptionsHandle _Handle, TElWebTunnelAuthenticationRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_get_Enabled(TElAS2WebTunnelOptionsHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_set_Enabled(TElAS2WebTunnelOptionsHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_get_Host(TElAS2WebTunnelOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_set_Host(TElAS2WebTunnelOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_get_Password(TElAS2WebTunnelOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_set_Password(TElAS2WebTunnelOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_get_Port(TElAS2WebTunnelOptionsHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_set_Port(TElAS2WebTunnelOptionsHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_get_UserID(TElAS2WebTunnelOptionsHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_set_UserID(TElAS2WebTunnelOptionsHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2WebTunnelOptions_Create(TElHTTPSClientHandle AClient, TElAS2WebTunnelOptionsHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2WEBTUNNELOPTIONS */

#ifdef SB_USE_CLASS_TELAS2CLIENT
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_Send(TElAS2ClientHandle _Handle, const char * pcURL, int32_t szURL, TStreamHandle Message, TStreamHandle Receipt, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_Send_1(TElAS2ClientHandle _Handle, const char * pcURL, int32_t szURL, const char * pcMessageFile, int32_t szMessageFile, const char * pcReceiptFile, int32_t szReceiptFile, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_SendReceipt(TElAS2ClientHandle _Handle, const char * pcURL, int32_t szURL, TStreamHandle Receipt, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_SendReceipt_1(TElAS2ClientHandle _Handle, const char * pcURL, int32_t szURL, const char * pcReceiptFile, int32_t szReceiptFile, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_HTTP(TElAS2ClientHandle _Handle, TElAS2HTTPOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_HTTP(TElAS2ClientHandle _Handle, TElAS2HTTPOptionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_Proxy(TElAS2ClientHandle _Handle, TElAS2ProxyOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_Proxy(TElAS2ClientHandle _Handle, TElAS2ProxyOptionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_Socket(TElAS2ClientHandle _Handle, TElAS2SocketOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_Socket(TElAS2ClientHandle _Handle, TElAS2SocketOptionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_Socks(TElAS2ClientHandle _Handle, TElAS2SocksOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_Socks(TElAS2ClientHandle _Handle, TElAS2SocksOptionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_SSL(TElAS2ClientHandle _Handle, TElAS2SSLOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_SSL(TElAS2ClientHandle _Handle, TElAS2SSLOptionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_WebTunnel(TElAS2ClientHandle _Handle, TElAS2WebTunnelOptionsHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_WebTunnel(TElAS2ClientHandle _Handle, TElAS2WebTunnelOptionsHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnCertificateChoose(TElAS2ClientHandle _Handle, TSBChooseCertificateEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnCertificateChoose(TElAS2ClientHandle _Handle, TSBChooseCertificateEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnCertificateNeededEx(TElAS2ClientHandle _Handle, TSBCertificateNeededExEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnCertificateNeededEx(TElAS2ClientHandle _Handle, TSBCertificateNeededExEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnCertificateStatus(TElAS2ClientHandle _Handle, TSBCertificateStatusEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnCertificateStatus(TElAS2ClientHandle _Handle, TSBCertificateStatusEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnCertificateValidate(TElAS2ClientHandle _Handle, TSBCertificateValidateEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnCertificateValidate(TElAS2ClientHandle _Handle, TSBCertificateValidateEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnCiphersNegotiated(TElAS2ClientHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnCiphersNegotiated(TElAS2ClientHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnCloseConnection(TElAS2ClientHandle _Handle, TSBCloseConnectionEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnCloseConnection(TElAS2ClientHandle _Handle, TSBCloseConnectionEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnCookie(TElAS2ClientHandle _Handle, TSBHTTPCookieEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnCookie(TElAS2ClientHandle _Handle, TSBHTTPCookieEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnData(TElAS2ClientHandle _Handle, TSBDataEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnData(TElAS2ClientHandle _Handle, TSBDataEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnDocumentBegin(TElAS2ClientHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnDocumentBegin(TElAS2ClientHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnDocumentEnd(TElAS2ClientHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnDocumentEnd(TElAS2ClientHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnError(TElAS2ClientHandle _Handle, TSBErrorEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnError(TElAS2ClientHandle _Handle, TSBErrorEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnExtensionsReceived(TElAS2ClientHandle _Handle, TSBExtensionsReceivedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnExtensionsReceived(TElAS2ClientHandle _Handle, TSBExtensionsReceivedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnExtensionsPrepared(TElAS2ClientHandle _Handle, TSBExtensionsPreparedEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnExtensionsPrepared(TElAS2ClientHandle _Handle, TSBExtensionsPreparedEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnKeyNeeded(TElAS2ClientHandle _Handle, TSBClientKeyNeededEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnKeyNeeded(TElAS2ClientHandle _Handle, TSBClientKeyNeededEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnPreparedHeaders(TElAS2ClientHandle _Handle, TSBHTTPHeadersEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnPreparedHeaders(TElAS2ClientHandle _Handle, TSBHTTPHeadersEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnProgress(TElAS2ClientHandle _Handle, TSBProgressEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnProgress(TElAS2ClientHandle _Handle, TSBProgressEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnReceivingHeaders(TElAS2ClientHandle _Handle, TSBHTTPHeadersEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnReceivingHeaders(TElAS2ClientHandle _Handle, TSBHTTPHeadersEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnRedirection(TElAS2ClientHandle _Handle, TSBHTTPRedirectionEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnRedirection(TElAS2ClientHandle _Handle, TSBHTTPRedirectionEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnRenegotiationRequest(TElAS2ClientHandle _Handle, TSBRenegotiationRequestEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnRenegotiationRequest(TElAS2ClientHandle _Handle, TSBRenegotiationRequestEvent pMethodValue, void * pDataValue);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnDNSKeyNeded(TElAS2ClientHandle _Handle, TSBDNSKeyNeededEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnDNSKeyNeded(TElAS2ClientHandle _Handle, TSBDNSKeyNeededEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnDNSKeyValidate(TElAS2ClientHandle _Handle, TSBDNSKeyValidateEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnDNSKeyValidate(TElAS2ClientHandle _Handle, TSBDNSKeyValidateEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_get_OnDNSResolve(TElAS2ClientHandle _Handle, TSBDNSResolveEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_set_OnDNSResolve(TElAS2ClientHandle _Handle, TSBDNSResolveEvent pMethodValue, void * pDataValue);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElAS2Client_Create(TComponentHandle AOwner, TElAS2ClientHandle * OutResult);
#endif /* SB_USE_CLASS_TELAS2CLIENT */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElAS2ReceiptRequest_ce_ptr;
extern zend_class_entry *TElAS2Encryption_ce_ptr;
extern zend_class_entry *TElAS2Signature_ce_ptr;
extern zend_class_entry *TElAS2Compression_ce_ptr;
extern zend_class_entry *TElAS2Receipt_ce_ptr;
extern zend_class_entry *TElAS2Message_ce_ptr;
extern zend_class_entry *TElAS2HTTPOptions_ce_ptr;
extern zend_class_entry *TElAS2ProxyOptions_ce_ptr;
extern zend_class_entry *TElAS2SocketOptions_ce_ptr;
extern zend_class_entry *TElAS2SocksOptions_ce_ptr;
extern zend_class_entry *TElAS2SSLOptions_ce_ptr;
extern zend_class_entry *TElAS2WebTunnelOptions_ce_ptr;
extern zend_class_entry *TElAS2Client_ce_ptr;

void Register_TElAS2ReceiptRequest(TSRMLS_D);
void Register_TElAS2Encryption(TSRMLS_D);
void Register_TElAS2Signature(TSRMLS_D);
void Register_TElAS2Compression(TSRMLS_D);
void Register_TElAS2Receipt(TSRMLS_D);
void Register_TElAS2Message(TSRMLS_D);
void Register_TElAS2HTTPOptions(TSRMLS_D);
void Register_TElAS2ProxyOptions(TSRMLS_D);
void Register_TElAS2SocketOptions(TSRMLS_D);
void Register_TElAS2SocksOptions(TSRMLS_D);
void Register_TElAS2SSLOptions(TSRMLS_D);
void Register_TElAS2WebTunnelOptions(TSRMLS_D);
void Register_TElAS2Client(TSRMLS_D);
SB_PHP_FUNCTION(SBAS2, AS2NameNeedsQuoting);
SB_PHP_FUNCTION(SBAS2, DequoteAS2Name);
SB_PHP_FUNCTION(SBAS2, QuoteAS2Name);
SB_PHP_FUNCTION(SBAS2, ValidAS2Name);
void Register_SBAS2_Enum_Flags(TSRMLS_D);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_AS2
SB_IMPORT uint32_t SB_APIENTRY SBAS2_AS2NameNeedsQuoting(const char * pcAS2Name, int32_t szAS2Name, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBAS2_DequoteAS2Name(const char * pcValue, int32_t szValue, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBAS2_QuoteAS2Name(const char * pcAS2Name, int32_t szAS2Name, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBAS2_ValidAS2Name(const char * pcName, int32_t szName, int8_t * OutResult);
#endif /* SB_USE_GLOBAL_PROCS_AS2 */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBAS2 */
