#ifndef __INC_SBASUTILS
#define __INC_SBASUTILS

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbstreams.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbconstants.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#ifdef __cplusplus
};	/* extern "C" */
#endif

SB_PHP_FUNCTION(SBASUtils, CopyStream);
SB_PHP_FUNCTION(SBASUtils, QuoteMessageID);
SB_PHP_FUNCTION(SBASUtils, WriteField);
SB_PHP_FUNCTION(SBASUtils, WriteLineA);
SB_PHP_FUNCTION(SBASUtils, WriteLine);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_ASUTILS
SB_IMPORT uint32_t SB_APIENTRY SBASUtils_CopyStream(TStreamHandle Source, TStreamHandle Dest, int64_t Offset, int64_t Count, int8_t PreservePosition, TSBProgressEvent pMethodProgressEvent, void * pDataProgressEvent, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBASUtils_QuoteMessageID(const char * pcMessageID, int32_t szMessageID, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBASUtils_WriteField(TStreamHandle Stream, const char * pcName, int32_t szName, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY SBASUtils_WriteLineA(TStreamHandle Stream, const char * pcLine, int32_t szLine);
SB_IMPORT uint32_t SB_APIENTRY SBASUtils_WriteLine(TStreamHandle Stream, const char * pcLine, int32_t szLine);
#endif /* SB_USE_GLOBAL_PROCS_ASUTILS */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBASUTILS */

