#ifndef __INC_SBDCSERVER
#define __INC_SBDCSERVER

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbstringlist.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbconstants.h"
#include "sbstreams.h"
#include "sbrdn.h"
#include "sbdc.h"
#include "sbdcenc.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElDCOperationHandlerHandle;

typedef TElClassHandle TElDCSignOperationHandlerHandle;

typedef TElClassHandle TElDCGenericSignOperationHandlerHandle;

typedef TElClassHandle TElDCStandardServerHandle;

typedef void (SB_CALLBACK *TSBDCSignRequestEvent)(void * _ObjectData, TObjectHandle Sender, const uint8_t pData[], int32_t szData, const uint8_t pHashAlg[], int32_t szHashAlg, int8_t IncludeKeys, TElRelativeDistinguishedNameHandle InputPars, TElRelativeDistinguishedNameHandle Keys, TElRelativeDistinguishedNameHandle OutputPars, uint8_t pSignResult[], int32_t * szSignResult);

#ifdef SB_USE_CLASS_TELDCOPERATIONHANDLER
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElDCOperationHandler_get_AcceptedOperationIDs(TElDCOperationHandlerHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElDCOperationHandler_get_AcceptedOperationIDs(TElDCOperationHandlerHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElDCOperationHandler_Create(TElDCOperationHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELDCOPERATIONHANDLER */

#ifdef SB_USE_CLASS_TELDCSIGNOPERATIONHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElDCSignOperationHandler_get_OnSignRequest(TElDCSignOperationHandlerHandle _Handle, TSBDCSignRequestEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDCSignOperationHandler_set_OnSignRequest(TElDCSignOperationHandlerHandle _Handle, TSBDCSignRequestEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElDCSignOperationHandler_Create(TElDCOperationHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELDCSIGNOPERATIONHANDLER */

#ifdef SB_USE_CLASS_TELDCGENERICSIGNOPERATIONHANDLER
SB_IMPORT uint32_t SB_APIENTRY TElDCGenericSignOperationHandler_Create(TElDCOperationHandlerHandle * OutResult);
#endif /* SB_USE_CLASS_TELDCGENERICSIGNOPERATIONHANDLER */

#ifdef SB_USE_CLASS_TELDCSTANDARDSERVER
SB_IMPORT uint32_t SB_APIENTRY TElDCStandardServer_Process(TElDCStandardServerHandle _Handle, TStreamHandle InStream, TStreamHandle OutStream, TElDCEncodingHandle InEncoding, TElDCEncodingHandle OutEncoding);
SB_IMPORT uint32_t SB_APIENTRY TElDCStandardServer_AddOperationHandler(TElDCStandardServerHandle _Handle, TElDCOperationHandlerHandle Handler, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDCStandardServer_RemoveOperationHandler(TElDCStandardServerHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElDCStandardServer_ClearOperationHandlers(TElDCStandardServerHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElDCStandardServer_get_OperationHandlers(TElDCStandardServerHandle _Handle, int32_t Index, TElDCOperationHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDCStandardServer_get_OperationHandlerCount(TElDCStandardServerHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDCStandardServer_Create(TElDCStandardServerHandle * OutResult);
#endif /* SB_USE_CLASS_TELDCSTANDARDSERVER */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElDCOperationHandler_ce_ptr;
extern zend_class_entry *TElDCSignOperationHandler_ce_ptr;
extern zend_class_entry *TElDCGenericSignOperationHandler_ce_ptr;
extern zend_class_entry *TElDCStandardServer_ce_ptr;

void SB_CALLBACK TSBDCSignRequestEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pData[], int32_t szData, const uint8_t pHashAlg[], int32_t szHashAlg, int8_t IncludeKeys, TElRelativeDistinguishedNameHandle InputPars, TElRelativeDistinguishedNameHandle Keys, TElRelativeDistinguishedNameHandle OutputPars, uint8_t pSignResult[], int32_t * szSignResult);
void Register_TElDCOperationHandler(TSRMLS_D);
void Register_TElDCSignOperationHandler(TSRMLS_D);
void Register_TElDCGenericSignOperationHandler(TSRMLS_D);
void Register_TElDCStandardServer(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBDCSERVER */
