#ifndef __INC_SBDROPBOXDATASTORAGE
#define __INC_SBDROPBOXDATASTORAGE

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbconstants.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbstreams.h"
#include "sbencoding.h"
#include "sbstringlist.h"
#include "sbdatastorage.h"
#include "sbdatastorageutils.h"
#include "sbstrutils.h"
#include "sbrandom.h"
#include "sbhashfunction.h"
#include "sbjson.h"
#include "sboauth2.h"
#include "sbhttpsconstants.h"
#include "sbhttpscommon.h"
#include "sbhttpsclient.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElDropboxDataStorageHandle;

typedef TElClassHandle TElDropboxDataStorageObjectHandle;

typedef TElClassHandle TElDropboxAccountInfoHandle;

typedef uint8_t TSBDropboxImageSizeRaw;

typedef enum
{
	disDefault = 0,
	disXS = 1,
	disS = 2,
	disM = 3,
	disL = 4,
	disXL = 5
} TSBDropboxImageSize;

typedef void (SB_CALLBACK *TSBDropboxBeforeRequestSigningEvent)(void * _ObjectData, TObjectHandle Sender, TElHTTPSClientHandle HttpClient);

typedef uint8_t TSBDropboxMetadataLocationRaw;

typedef enum
{
	dmlColocatedObjects = 0,
	dmlMetadataSubdir = 1,
	dmlMetadataDir = 2
} TSBDropboxMetadataLocation;

typedef uint8_t TSBDropboxSignatureMethodRaw;

typedef enum
{
	dsmHMACSHA1 = 0
} TSBDropboxSignatureMethod;

#ifdef SB_USE_CLASS_TELDROPBOXDATASTORAGE
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_StartAuthorization(TElDropboxDataStorageHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetAuthorizationURL(TElDropboxDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetAuthorizationURL_1(TElDropboxDataStorageHandle _Handle, const char * pcCallback, int32_t szCallback, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetAuthorizationURL_2(TElDropboxDataStorageHandle _Handle, const char * pcCallback, int32_t szCallback, const char * pcLocale, int32_t szLocale, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_RequestAccessToken(TElDropboxDataStorageHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_StartAuthorization2(TElDropboxDataStorageHandle _Handle, const char * pcRedirectURL, int32_t szRedirectURL, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CompleteAuthorization2(TElDropboxDataStorageHandle _Handle, const char * pcAuthorizationCode, int32_t szAuthorizationCode);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CancelAuthorization2(TElDropboxDataStorageHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetAccountInfoStr(TElDropboxDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetAccountInfoStr_1(TElDropboxDataStorageHandle _Handle, const char * pcLocale, int32_t szLocale, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetAccountInfo(TElDropboxDataStorageHandle _Handle, TElDropboxAccountInfoHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetAccountInfo_1(TElDropboxDataStorageHandle _Handle, const char * pcLocale, int32_t szLocale, TElDropboxAccountInfoHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_AcquireObject(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, TElDropboxDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_AcquireObject_1(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, const char * pcRev, int32_t szRev, TElDropboxDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_AcquireObject_2(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_List(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_List_1(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Dir, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_List_2(TElCustomDataStorageHandle _Handle, TElDataStorageObjectListHandle Objs);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CreateObject(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, TElDropboxDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CreateObject_1(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, TElCustomDataStorageSecurityHandlerHandle Handler, TElDropboxDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_DeleteObject(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_DeleteObject_1(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle * Obj);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_DeleteObject_2(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle * Obj);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ObjectExists(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ObjectExists_1(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, const char * pcRev, int32_t szRev, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ObjectExists_2(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_RefreshObject(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_WriteObject(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, int8_t Overwrite, const char * pcParentRev, int32_t szParentRev, TStreamHandle Data, TElCustomDataStorageSecurityHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_WriteObject_1(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, TStreamHandle Data, TElCustomDataStorageSecurityHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_WriteObject_2(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj, TStreamHandle Data, TElCustomDataStorageSecurityHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_WriteObject_3(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle Obj, TStreamHandle Strm, TElCustomDataStorageSecurityHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ReadObject(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ReadObject_1(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, const char * pcRev, int32_t szRev, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ReadObject_2(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ReadObject_3(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj, const char * pcRev, int32_t szRev, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ReadObject_4(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle Obj, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ReadBlock(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, TStreamHandle Strm, int64_t Offset, int64_t Size, int64_t * Read);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ReadBlock_1(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, TStreamHandle Strm, int64_t Offset, int64_t Size, int64_t * Read, const char * pcRev, int32_t szRev);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ReadBlock_2(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle Obj, TStreamHandle Strm, int64_t Offset, int64_t Size, int64_t * Read);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_Search(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, const char * pcQuery, int32_t szQuery, int8_t IncludeDeleted, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_Search_1(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, const char * pcQuery, int32_t szQuery, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CopyObject(TElDropboxDataStorageHandle _Handle, const char * pcSourcePath, int32_t szSourcePath, const char * pcDestPath, int32_t szDestPath, TElCustomDataStorageSecurityHandlerHandle NewHandler, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CopyObject_1(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj, const char * pcDestPath, int32_t szDestPath, TElCustomDataStorageSecurityHandlerHandle NewHandler, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CopyObject_2(TElDropboxDataStorageHandle _Handle, const char * pcSourcePath, int32_t szSourcePath, const char * pcDestPath, int32_t szDestPath, TElCustomDataStorageSecurityHandlerHandle NewHandler, int8_t AcquireObject, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CopyObject_3(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj, const char * pcDestPath, int32_t szDestPath, TElCustomDataStorageSecurityHandlerHandle NewHandler, int8_t AcquireObject, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CopyObject_4(TElCustomDataStorageHandle _Handle, TElCustomDataStorageObjectHandle Obj, TElCustomDataStorageSecurityHandlerHandle NewHandler, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CopyObjectFromRef(TElDropboxDataStorageHandle _Handle, const char * pcCopyRef, int32_t szCopyRef, const char * pcDestPath, int32_t szDestPath, TElCustomDataStorageSecurityHandlerHandle NewHandler, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CopyObjectFromRef_1(TElDropboxDataStorageHandle _Handle, const char * pcCopyRef, int32_t szCopyRef, const char * pcDestPath, int32_t szDestPath, TElCustomDataStorageSecurityHandlerHandle NewHandler, int8_t AcquireObject, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CreateCopyReference(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CreateCopyReference_1(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetDirectLink(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetDirectLink_1(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetPreviewLink(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, int8_t Short, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetPreviewLink_1(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj, int8_t Short, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetThumbnail(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, const char * pcImageFormat, int32_t szImageFormat, TSBDropboxImageSizeRaw Size, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_GetThumbnail_1(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj, const char * pcFormat, int32_t szFormat, TSBDropboxImageSizeRaw Size, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_CreateFolder(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_RenameObject(TElDropboxDataStorageHandle _Handle, const char * pcSourcePath, int32_t szSourcePath, const char * pcDestPath, int32_t szDestPath);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_RenameObject_1(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj, const char * pcDestPath, int32_t szDestPath);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_RestoreObject(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, const char * pcRev, int32_t szRev, TElDropboxDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_RestoreObject_1(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, const char * pcRev, int32_t szRev, int8_t AcquireObject, TElDropboxDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ListRevisions(TElDropboxDataStorageHandle _Handle, const char * pcPath, int32_t szPath, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_ListRevisions_1(TElDropboxDataStorageHandle _Handle, TElDropboxDataStorageObjectHandle Obj, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_HTTPClient(TElDropboxDataStorageHandle _Handle, TElHTTPSClientHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_HTTPClient(TElDropboxDataStorageHandle _Handle, TElHTTPSClientHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_AccessToken(TElDropboxDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_AccessToken(TElDropboxDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_AppKey(TElDropboxDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_AppKey(TElDropboxDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_AppSecret(TElDropboxDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_AppSecret(TElDropboxDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_AuthToken(TElDropboxDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_AuthToken(TElDropboxDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_AuthTokenSecret(TElDropboxDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_AuthTokenSecret(TElDropboxDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_Root(TElDropboxDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_Root(TElDropboxDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_MetadataLocation(TElDropboxDataStorageHandle _Handle, TSBDropboxMetadataLocationRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_MetadataLocation(TElDropboxDataStorageHandle _Handle, TSBDropboxMetadataLocationRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_MetadataExtension(TElDropboxDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_MetadataExtension(TElDropboxDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_MetadataDirName(TElDropboxDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_MetadataDirName(TElDropboxDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_SignatureMethod(TElDropboxDataStorageHandle _Handle, TSBDropboxSignatureMethodRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_SignatureMethod(TElDropboxDataStorageHandle _Handle, TSBDropboxSignatureMethodRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_ChunkedUploadThreshold(TElDropboxDataStorageHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_ChunkedUploadThreshold(TElDropboxDataStorageHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_ChunkedUploadChunkSize(TElDropboxDataStorageHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_ChunkedUploadChunkSize(TElDropboxDataStorageHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_DefaultLocale(TElDropboxDataStorageHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_DefaultLocale(TElDropboxDataStorageHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_HideMetadataObjects(TElDropboxDataStorageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_HideMetadataObjects(TElDropboxDataStorageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_PickMetadataOnList(TElDropboxDataStorageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_PickMetadataOnList(TElDropboxDataStorageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_Overwrite(TElDropboxDataStorageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_Overwrite(TElDropboxDataStorageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_PassthroughMode(TElDropboxDataStorageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_PassthroughMode(TElDropboxDataStorageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_EmbeddedMetadataMode(TElDropboxDataStorageHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_EmbeddedMetadataMode(TElDropboxDataStorageHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_get_OnBeforeRequestSigning(TElDropboxDataStorageHandle _Handle, TSBDropboxBeforeRequestSigningEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_set_OnBeforeRequestSigning(TElDropboxDataStorageHandle _Handle, TSBDropboxBeforeRequestSigningEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorage_Create(TComponentHandle AOwner, TElDropboxDataStorageHandle * OutResult);
#endif /* SB_USE_CLASS_TELDROPBOXDATASTORAGE */

#ifdef SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Assign(TElDropboxDataStorageObjectHandle _Handle, TElCustomDataStorageObjectHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Clone(TElDropboxDataStorageObjectHandle _Handle, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Clear(TElDropboxDataStorageObjectHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_IsMetadataObject(TElDropboxDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_IsMetadataDirectory(TElDropboxDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Delete(TElDropboxDataStorageObjectHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Exists(TElDropboxDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Refresh(TElDropboxDataStorageObjectHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Write(TElDropboxDataStorageObjectHandle _Handle, int8_t Overwrite, const char * pcParentRev, int32_t szParentRev, TStreamHandle Data, TElCustomDataStorageSecurityHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Write_1(TElDropboxDataStorageObjectHandle _Handle, TStreamHandle Data, TElCustomDataStorageSecurityHandlerHandle Handler);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Read(TElDropboxDataStorageObjectHandle _Handle, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Read_1(TElDropboxDataStorageObjectHandle _Handle, const char * pcRev, int32_t szRev, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_ReadBlock(TElDropboxDataStorageObjectHandle _Handle, TStreamHandle Strm, int64_t Offset, int64_t Size, int64_t * Read);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Copy(TElDropboxDataStorageObjectHandle _Handle, const char * pcDestPath, int32_t szDestPath, TElCustomDataStorageSecurityHandlerHandle NewHandler, TElCustomDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_CreateCopyReference(TElDropboxDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_GetDirectLink(TElDropboxDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_GetPreviewLink(TElDropboxDataStorageObjectHandle _Handle, int8_t Short, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_GetThumbnail(TElDropboxDataStorageObjectHandle _Handle, const char * pcFormat, int32_t szFormat, TSBDropboxImageSizeRaw Size, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Rename(TElDropboxDataStorageObjectHandle _Handle, const char * pcDestPath, int32_t szDestPath);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Restore(TElDropboxDataStorageObjectHandle _Handle, const char * pcRev, int32_t szRev);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_ListRevisions(TElDropboxDataStorageObjectHandle _Handle, TElDataStorageObjectListHandle Objects);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Path(TElDropboxDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Locale(TElDropboxDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Rev(TElDropboxDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_SizeStr(TElDropboxDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_ThumbExists(TElDropboxDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Size(TElDropboxDataStorageObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Modified(TElDropboxDataStorageObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_ClientModified(TElDropboxDataStorageObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Directory(TElDropboxDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Icon(TElDropboxDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Root(TElDropboxDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_MimeType(TElDropboxDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Revision(TElDropboxDataStorageObjectHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_IsDeleted(TElDropboxDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Hash(TElDropboxDataStorageObjectHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Listed(TElDropboxDataStorageObjectHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Objects(TElDropboxDataStorageObjectHandle _Handle, int32_t Index, TElDropboxDataStorageObjectHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_get_Count(TElDropboxDataStorageObjectHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxDataStorageObject_Create(TElDropboxDataStorageHandle Owner, TElDropboxDataStorageObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELDROPBOXDATASTORAGEOBJECT */

#ifdef SB_USE_CLASS_TELDROPBOXACCOUNTINFO
SB_IMPORT uint32_t SB_APIENTRY TElDropboxAccountInfo_get_DisplayName(TElDropboxAccountInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxAccountInfo_get_UID(TElDropboxAccountInfoHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxAccountInfo_get_Country(TElDropboxAccountInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxAccountInfo_get_ReferralLink(TElDropboxAccountInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxAccountInfo_get_QuotaAvailable(TElDropboxAccountInfoHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxAccountInfo_get_RegularFiles(TElDropboxAccountInfoHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxAccountInfo_get_SharedFiles(TElDropboxAccountInfoHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElDropboxAccountInfo_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELDROPBOXACCOUNTINFO */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElDropboxDataStorage_ce_ptr;
extern zend_class_entry *TElDropboxDataStorageObject_ce_ptr;
extern zend_class_entry *TElDropboxAccountInfo_ce_ptr;

void SB_CALLBACK TSBDropboxBeforeRequestSigningEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPSClientHandle HttpClient);
void Register_TElDropboxDataStorage(TSRMLS_D);
void Register_TElDropboxDataStorageObject(TSRMLS_D);
void Register_TElDropboxAccountInfo(TSRMLS_D);
void Register_SBDropboxDataStorage_Enum_Flags(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBDROPBOXDATASTORAGE */

