#ifndef __INC_SBGOST2814789
#define __INC_SBGOST2814789

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbconstants.h"
#include "sbstreams.h"
#include "sbgostcommon.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElGOSTHandle;

typedef uint8_t TElGOSTModeRaw;

typedef enum
{
	GOSTMode_ECB = 0,
	GOSTMode_OFB = 1,
	GOSTMode_CFB = 2,
	GOSTMode_CBC = 3
} TElGOSTMode;

#ifdef SB_USE_CLASS_TELGOST
SB_IMPORT uint32_t SB_APIENTRY TElGOST_BlockSize(int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_BlockSize_1(TElGOSTHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_KeySize(int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_KeySize_1(TElGOSTHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_Reset(TElGOSTHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_Clone(TElGOSTHandle _Handle, TElGOSTBaseHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_Encrypt_Block(TElGOSTHandle _Handle, const uint8_t pInBuf[], int32_t szInBuf, int32_t In_StartIdx, int32_t In_Len, uint8_t pOutBuf[], int32_t * szOutBuf, int32_t * Out_Len, int32_t Out_StartIdx);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_Decrypt_Block(TElGOSTHandle _Handle, const uint8_t pInBuf[], int32_t szInBuf, int32_t In_StartIdx, int32_t In_Len, uint8_t pOutBuf[], int32_t * szOutBuf, int32_t * Out_Len, int32_t Out_StartIdx);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_Encrypt_Finalize(TElGOSTHandle _Handle, uint8_t pOutBuf[], int32_t * szOutBuf, int32_t * Out_Len, int32_t Out_StartIdx);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_Decrypt_Finalize(TElGOSTHandle _Handle, uint8_t pOutBuf[], int32_t * szOutBuf, int32_t * Out_Len, int32_t Out_StartIdx);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_EncryptBuf(TElGOSTHandle _Handle, const uint8_t pInBuf[], int32_t szInBuf, int32_t In_StartIdx, int32_t In_Len, uint8_t pOutBuf[], int32_t * szOutBuf, int32_t * Out_Len, int32_t Out_StartIdx);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_EncryptBuf_1(TElGOSTHandle _Handle, const uint8_t pInBuf[], int32_t szInBuf, uint8_t pOutBuf[], int32_t * szOutBuf);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_DecryptBuf(TElGOSTHandle _Handle, const uint8_t pInBuf[], int32_t szInBuf, int32_t In_StartIdx, int32_t In_Len, uint8_t pOutBuf[], int32_t * szOutBuf, int32_t * Out_Len, int32_t Out_StartIdx);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_DecryptBuf_1(TElGOSTHandle _Handle, const uint8_t pInBuf[], int32_t szInBuf, uint8_t pOutBuf[], int32_t * szOutBuf);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_EncryptStream(TElGOSTHandle _Handle, TStreamHandle Source, uint32_t Count, TStreamHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_DecryptStream(TElGOSTHandle _Handle, TStreamHandle Source, uint32_t Count, TStreamHandle Dest);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_MAC_Block(TElGOSTHandle _Handle, void * InBuf, int32_t In_Len);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_MAC_Block_1(TElGOSTHandle _Handle, const uint8_t pInBuf[], int32_t szInBuf, int32_t In_StartIdx, int32_t In_Len);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_MAC_Finalize(TElGOSTHandle _Handle, int32_t Qnt_Bits, uint8_t pMAC[], int32_t * szMAC);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_MAC_Stream(TElGOSTHandle _Handle, TStreamHandle Source, uint32_t Count, int32_t Qnt_Bits, uint8_t pMAC[], int32_t * szMAC);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_get_Key(TElGOSTHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_set_Key(TElGOSTHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_get_IV(TElGOSTHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_set_IV(TElGOSTHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_get_Mode(TElGOSTHandle _Handle, TElGOSTModeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_set_Mode(TElGOSTHandle _Handle, TElGOSTModeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_Create(TElGOSTHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOST_Create_1(const TElGostSubstBlock * SubstBlock, TElGOSTHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOST */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElGOST_ce_ptr;

void Register_TElGOST(TSRMLS_D);
SB_PHP_FUNCTION(SBGOST2814789, KeyWrap28147);
SB_PHP_FUNCTION(SBGOST2814789, KeyUnwrap28147);
SB_PHP_FUNCTION(SBGOST2814789, KeyWrapCryptoPro);
SB_PHP_FUNCTION(SBGOST2814789, KeyUnwrapCryptoPro);
SB_PHP_FUNCTION(SBGOST2814789, gost28147IMIT);
SB_PHP_FUNCTION(SBGOST2814789, KeyDiversifyCryptoPro);
void Register_SBGOST2814789_Enum_Flags(TSRMLS_D);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_GOST2814789
SB_IMPORT uint32_t SB_APIENTRY SBGOST2814789_KeyWrap28147(const uint8_t pUKM[], int32_t szUKM, const uint8_t pCEK[], int32_t szCEK, const uint8_t pKEK[], int32_t szKEK, uint8_t pWCEK[], int32_t * szWCEK, int32_t * WCEKSize, uint8_t pCEK_MAC[], int32_t * szCEK_MAC, int32_t * CEKMACSize, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBGOST2814789_KeyUnwrap28147(const uint8_t pUKM[], int32_t szUKM, const uint8_t pWCEK[], int32_t szWCEK, const uint8_t pKEK[], int32_t szKEK, const uint8_t pCEK_MAC[], int32_t szCEK_MAC, uint8_t pCEK[], int32_t * szCEK, int32_t * CEKSize, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBGOST2814789_KeyWrapCryptoPro(const uint8_t pUKM[], int32_t szUKM, const uint8_t pCEK[], int32_t szCEK, const uint8_t pKEK[], int32_t szKEK, uint8_t pWCEK[], int32_t * szWCEK, int32_t * WCEKSize, uint8_t pCEK_MAC[], int32_t * szCEK_MAC, int32_t * CEKMACSize, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBGOST2814789_KeyUnwrapCryptoPro(const uint8_t pUKM[], int32_t szUKM, const uint8_t pWCEK[], int32_t szWCEK, const uint8_t pKEK[], int32_t szKEK, const uint8_t pCEK_MAC[], int32_t szCEK_MAC, uint8_t pCEK[], int32_t * szCEK, int32_t * CEKSize, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBGOST2814789_gost28147IMIT(const uint8_t pIV[], int32_t szIV, const uint8_t pK[], int32_t szK, const uint8_t pD[], int32_t szD, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBGOST2814789_KeyDiversifyCryptoPro(const uint8_t pUKM[], int32_t szUKM, const uint8_t pKEK[], int32_t szKEK, uint8_t pDKEK[], int32_t * szDKEK, int32_t * DKEKSize, int8_t * OutResult);
#endif /* SB_USE_GLOBAL_PROCS_GOST2814789 */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBGOST2814789 */

