#ifndef __INC_SBGOST341194
#define __INC_SBGOST341194

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbconstants.h"
#include "sbstreams.h"
#include "sbgostcommon.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#define SB_c_GOST_DigestSize 	32

typedef TElClassHandle TElGOSTMDHandle;

#ifdef SB_USE_CLASS_TELGOSTMD
SB_IMPORT uint32_t SB_APIENTRY TElGOSTMD_DigestSize(int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOSTMD_DigestSize_1(TElGOSTMDHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOSTMD_Reset(TElGOSTMDHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElGOSTMD_Clone(TElGOSTMDHandle _Handle, TElGOSTBaseHandle Source);
SB_IMPORT uint32_t SB_APIENTRY TElGOSTMD_Update(TElGOSTMDHandle _Handle, void * In_Buf, uint32_t Len);
SB_IMPORT uint32_t SB_APIENTRY TElGOSTMD_Update_1(TElGOSTMDHandle _Handle, const uint8_t pIn_Buf[], int32_t szIn_Buf, uint32_t StartIndex, uint32_t Len);
SB_IMPORT uint32_t SB_APIENTRY TElGOSTMD_Final(TElGOSTMDHandle _Handle, uint8_t pDigest[], int32_t * szDigest);
SB_IMPORT uint32_t SB_APIENTRY TElGOSTMD_Calculate(TElGOSTMDHandle _Handle, const uint8_t pIn_Buf[], int32_t szIn_Buf, uint32_t StartIndex, uint32_t Len, uint8_t pDigest[], int32_t * szDigest);
SB_IMPORT uint32_t SB_APIENTRY TElGOSTMD_Calculate_1(TElGOSTMDHandle _Handle, TStreamHandle Source, uint32_t Count, uint8_t pDigest[], int32_t * szDigest);
SB_IMPORT uint32_t SB_APIENTRY TElGOSTMD_Create(TElGOSTMDHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElGOSTMD_Create_1(const TElGostSubstBlock * SubstBlock, TElGOSTMDHandle * OutResult);
#endif /* SB_USE_CLASS_TELGOSTMD */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElGOSTMD_ce_ptr;

void Register_TElGOSTMD(TSRMLS_D);
void Register_SBGOST341194_Constants(int module_number TSRMLS_DC);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBGOST341194 */

