#ifndef __INC_SBOFFICEBINARYCORE
#define __INC_SBOFFICEBINARYCORE

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbofficeconstants.h"
#include "sbofficecommon.h"
#include "sbofficeresources.h"
#include "sbstreams.h"
#include "sbtypes.h"
#include "sbutils.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#define SB_OFFICE_ENCRYPTION_HEADER_FLAG_CRYPTOAPI 	4
#define SB_OFFICE_ENCRYPTION_HEADER_FLAG_DOC_PROPS 	8
#define SB_OFFICE_ENCRYPTION_HEADER_FLAG_EXTERNAL 	16
#define SB_OFFICE_ENCRYPTION_HEADER_FLAG_AES 	32
#define SB_OFFICE_ENCRYPTION_HEADER_FLAGS_CRYPTOAPI_AES 	36
#define SB_OFFICE_ENCRYPTION_HEADER_FLAGS_CRYPTOAPI_DOCPROPS_AES 	44
#define SB_OFFICE_ENCRYPTED_STREAM_DESCRIPTOR_FLAG_STREAM 	1
#define SB_OFFICE_WORD_DOCUMENT_FIB_BASE_FLAG_ENCRYPTED 	256
#define SB_OFFICE_WORD_DOCUMENT_FIB_BASE_FLAG_OBFUSCATED 	32768
#define SB_OFFICE_WORD_DOCUMENT_FIB_BASE_FLAG_WHICH_TABLE_STREAM 	512
#define SB_OFFICE_WORKBOOK_RECORD_INFO_SIZE 	4
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_BOF 	2057
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_BOUND_SHEET8 	133
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_EOF 	10
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_EXT_SST 	255
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_FILE_LOCK 	405
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_FILE_PASS 	47
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_INDEX 	523
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_INTERFACE_HDR 	225
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_RRD_HEAD 	312
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_RRD_INFO 	406
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_USR_EXCL 	404
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_WRITE_ACCESS 	92
#define SB_OFFICE_WORKBOOK_RECORD_TYPE_WRITE_PROTECT 	134
#define SB_OFFICE_WORKBOOK_ENCRYPTION_TYPE_XOR_OBFUSCATION 	0
#define SB_OFFICE_WORKBOOK_ENCRYPTION_TYPE_RC4 	1
#define SB_OFFICE_POWERPOINT_RECORD_HEADER_SIZE 	8
#define SB_OFFICE_ART_RECORD_HEADER_SIZE 	8
#define SB_OFFICE_POWERPOINT_RECORD_TYPE_USER_EDIT_ATOM 	4085
#define SB_OFFICE_POWERPOINT_RECORD_TYPE_PERSIST_DIRECTORY_ATOM 	6002
#define SB_OFFICE_POWERPOINT_RECORD_TYPE_CRYPT_SESSION10_CONTAINER 	12052

typedef TElClassHandle TElOfficeBinaryObjectHandle;

typedef TElClassHandle TElOfficeDataSpaceVersionInfoHandle;

typedef TElClassHandle TElOfficeDataSpaceReferenceComponentHandle;

typedef TElClassHandle TElOfficeDataSpaceMapEntryHandle;

typedef TElClassHandle TElOfficeDataSpaceMapHandle;

typedef TElClassHandle TElOfficeDataSpaceDefinitionHandle;

typedef TElClassHandle TElOfficeTransformInfoHeaderHandle;

typedef TElClassHandle TElOfficeEncryptionTransformInfoHandle;

typedef TElClassHandle TElOfficeExtensibilityHeaderHandle;

typedef TElClassHandle TElOfficeIRMDSTransformInfoHandle;

typedef TElClassHandle TElOfficeEndUserLicenseHeaderHandle;

typedef TElClassHandle TElOfficeEncryptionHeaderHandle;

typedef TElClassHandle TElOfficeEncryptionVerifierHandle;

typedef TElClassHandle TElOfficeEncryptionInfoHandle;

typedef TElClassHandle TElOfficeEncryptionInfoV1Handle;

typedef TElClassHandle TElOfficeEncryptionInfoV2Handle;

typedef TElClassHandle TElOfficeEncryptionInfoV3Handle;

typedef TElClassHandle TElOfficeEncryptionInfoV4Handle;

typedef TElClassHandle TElOfficeXORObfuscationHandle;

typedef TElClassHandle TElOfficeEncryptedStreamDescriptorHandle;

typedef TElClassHandle TElOfficeCertificateInfoHandle;

typedef TElClassHandle TElOfficeCertStoreCertificateGroupHandle;

typedef TElClassHandle TElOfficeDocSigSerializedCertStoreHandle;

typedef TElClassHandle TElOfficeCryptoAPIDigitalSignatureHandle;

typedef TElClassHandle TElOfficeWordFIBBaseHandle;

typedef TElClassHandle TElOfficeWordFIBRgFcLcbHandle;

typedef TElClassHandle TElOfficeWordFIBHandle;

typedef TElClassHandle TElOfficeWorkbookRecordInfoHandle;

typedef TElClassHandle TElOfficeWorkbookBOFHandle;

typedef TElClassHandle TElOfficeWorkbookFilePassHandle;

typedef TElClassHandle TElOfficePowerPointRecordHeaderHandle;

typedef TElOfficePowerPointRecordHeaderHandle TElOfficeArtRecordHeaderHandle;

typedef TElClassHandle TElOfficePowerPointUserEditAtomHandle;

typedef TElClassHandle TElOfficePowerPointPersistDirectoryEntryHandle;

typedef TElClassHandle TElOfficePowerPointPersistDirectoryAtomHandle;

#ifdef SB_USE_CLASS_TELOFFICEBINARYOBJECT
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryObject_LoadFromStream(TElOfficeBinaryObjectHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryObject_SaveToStream(TElOfficeBinaryObjectHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeBinaryObject_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEBINARYOBJECT */

#ifdef SB_USE_CLASS_TELOFFICEDATASPACEVERSIONINFO
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceVersionInfo_LoadFromStream(TElOfficeDataSpaceVersionInfoHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceVersionInfo_SaveToStream(TElOfficeDataSpaceVersionInfoHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceVersionInfo_get_FeatureIdentifier(TElOfficeDataSpaceVersionInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceVersionInfo_set_FeatureIdentifier(TElOfficeDataSpaceVersionInfoHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceVersionInfo_Create(TElOfficeDataSpaceVersionInfoHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEDATASPACEVERSIONINFO */

#ifdef SB_USE_CLASS_TELOFFICEDATASPACEREFERENCECOMPONENT
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceReferenceComponent_LoadFromStream(TElOfficeDataSpaceReferenceComponentHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceReferenceComponent_SaveToStream(TElOfficeDataSpaceReferenceComponentHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceReferenceComponent_get_ReferenceComponentType(TElOfficeDataSpaceReferenceComponentHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceReferenceComponent_set_ReferenceComponentType(TElOfficeDataSpaceReferenceComponentHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceReferenceComponent_get_ReferenceComponent(TElOfficeDataSpaceReferenceComponentHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceReferenceComponent_set_ReferenceComponent(TElOfficeDataSpaceReferenceComponentHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceReferenceComponent_Create(TElOfficeDataSpaceReferenceComponentHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEDATASPACEREFERENCECOMPONENT */

#ifdef SB_USE_CLASS_TELOFFICEDATASPACEMAPENTRY
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMapEntry_LoadFromStream(TElOfficeDataSpaceMapEntryHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMapEntry_SaveToStream(TElOfficeDataSpaceMapEntryHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMapEntry_Clear(TElOfficeDataSpaceMapEntryHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMapEntry_Add(TElOfficeDataSpaceMapEntryHandle _Handle, TElOfficeDataSpaceReferenceComponentHandle ARef, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMapEntry_Insert(TElOfficeDataSpaceMapEntryHandle _Handle, int32_t Index, TElOfficeDataSpaceReferenceComponentHandle ARef);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMapEntry_Delete(TElOfficeDataSpaceMapEntryHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMapEntry_get_Count(TElOfficeDataSpaceMapEntryHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMapEntry_get_ReferenceComponents(TElOfficeDataSpaceMapEntryHandle _Handle, int32_t Index, TElOfficeDataSpaceReferenceComponentHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMapEntry_get_DataSpaceName(TElOfficeDataSpaceMapEntryHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMapEntry_set_DataSpaceName(TElOfficeDataSpaceMapEntryHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMapEntry_Create(TElOfficeDataSpaceMapEntryHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEDATASPACEMAPENTRY */

#ifdef SB_USE_CLASS_TELOFFICEDATASPACEMAP
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMap_LoadFromStream(TElOfficeDataSpaceMapHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMap_SaveToStream(TElOfficeDataSpaceMapHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMap_Clear(TElOfficeDataSpaceMapHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMap_Add(TElOfficeDataSpaceMapHandle _Handle, TElOfficeDataSpaceMapEntryHandle AEntry, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMap_Insert(TElOfficeDataSpaceMapHandle _Handle, int32_t Index, TElOfficeDataSpaceMapEntryHandle AEntry);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMap_Delete(TElOfficeDataSpaceMapHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMap_get_Count(TElOfficeDataSpaceMapHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMap_get_MapEntries(TElOfficeDataSpaceMapHandle _Handle, int32_t Index, TElOfficeDataSpaceMapEntryHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceMap_Create(TElOfficeDataSpaceMapHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEDATASPACEMAP */

#ifdef SB_USE_CLASS_TELOFFICEDATASPACEDEFINITION
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceDefinition_LoadFromStream(TElOfficeDataSpaceDefinitionHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceDefinition_SaveToStream(TElOfficeDataSpaceDefinitionHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceDefinition_Clear(TElOfficeDataSpaceDefinitionHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceDefinition_Add(TElOfficeDataSpaceDefinitionHandle _Handle, const char * pcARef, int32_t szARef, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceDefinition_Insert(TElOfficeDataSpaceDefinitionHandle _Handle, int32_t Index, const char * pcARef, int32_t szARef);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceDefinition_Delete(TElOfficeDataSpaceDefinitionHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceDefinition_get_Count(TElOfficeDataSpaceDefinitionHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceDefinition_get_TransformReferences(TElOfficeDataSpaceDefinitionHandle _Handle, int32_t Index, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDataSpaceDefinition_Create(TElOfficeDataSpaceDefinitionHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEDATASPACEDEFINITION */

#ifdef SB_USE_CLASS_TELOFFICETRANSFORMINFOHEADER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_LoadFromStream(TElOfficeTransformInfoHeaderHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_SaveToStream(TElOfficeTransformInfoHeaderHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_get_TransformID(TElOfficeTransformInfoHeaderHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_set_TransformID(TElOfficeTransformInfoHeaderHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_get_TransformName(TElOfficeTransformInfoHeaderHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_set_TransformName(TElOfficeTransformInfoHeaderHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_get_TransformType(TElOfficeTransformInfoHeaderHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_set_TransformType(TElOfficeTransformInfoHeaderHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_get_ReaderVersion(TElOfficeTransformInfoHeaderHandle _Handle, TSBOfficeVersion * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_set_ReaderVersion(TElOfficeTransformInfoHeaderHandle _Handle, TSBOfficeVersion Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_get_UpdaterVersion(TElOfficeTransformInfoHeaderHandle _Handle, TSBOfficeVersion * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_set_UpdaterVersion(TElOfficeTransformInfoHeaderHandle _Handle, TSBOfficeVersion Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_get_WriterVersion(TElOfficeTransformInfoHeaderHandle _Handle, TSBOfficeVersion * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_set_WriterVersion(TElOfficeTransformInfoHeaderHandle _Handle, TSBOfficeVersion Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeTransformInfoHeader_Create(TElOfficeTransformInfoHeaderHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICETRANSFORMINFOHEADER */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONTRANSFORMINFO
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionTransformInfo_LoadFromStream(TElOfficeEncryptionTransformInfoHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionTransformInfo_SaveToStream(TElOfficeEncryptionTransformInfoHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionTransformInfo_get_EncryptionName(TElOfficeEncryptionTransformInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionTransformInfo_set_EncryptionName(TElOfficeEncryptionTransformInfoHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionTransformInfo_get_EncryptionBlockSize(TElOfficeEncryptionTransformInfoHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionTransformInfo_set_EncryptionBlockSize(TElOfficeEncryptionTransformInfoHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionTransformInfo_get_CipherMode(TElOfficeEncryptionTransformInfoHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionTransformInfo_set_CipherMode(TElOfficeEncryptionTransformInfoHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionTransformInfo_Create(TElOfficeEncryptionTransformInfoHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONTRANSFORMINFO */

#ifdef SB_USE_CLASS_TELOFFICEEXTENSIBILITYHEADER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeExtensibilityHeader_LoadFromStream(TElOfficeExtensibilityHeaderHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeExtensibilityHeader_SaveToStream(TElOfficeExtensibilityHeaderHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeExtensibilityHeader_get_Length(TElOfficeExtensibilityHeaderHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeExtensibilityHeader_set_Length(TElOfficeExtensibilityHeaderHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeExtensibilityHeader_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEEXTENSIBILITYHEADER */

#ifdef SB_USE_CLASS_TELOFFICEIRMDSTRANSFORMINFO
SB_IMPORT uint32_t SB_APIENTRY TElOfficeIRMDSTransformInfo_LoadFromStream(TElOfficeIRMDSTransformInfoHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeIRMDSTransformInfo_SaveToStream(TElOfficeIRMDSTransformInfoHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeIRMDSTransformInfo_get_TransformInfoHeader(TElOfficeIRMDSTransformInfoHandle _Handle, TElOfficeTransformInfoHeaderHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeIRMDSTransformInfo_get_ExtensibilityHeader(TElOfficeIRMDSTransformInfoHandle _Handle, TElOfficeExtensibilityHeaderHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeIRMDSTransformInfo_get_XrMLLicense(TElOfficeIRMDSTransformInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeIRMDSTransformInfo_set_XrMLLicense(TElOfficeIRMDSTransformInfoHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeIRMDSTransformInfo_Create(TElOfficeIRMDSTransformInfoHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEIRMDSTRANSFORMINFO */

#ifdef SB_USE_CLASS_TELOFFICEENDUSERLICENSEHEADER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEndUserLicenseHeader_LoadFromStream(TElOfficeEndUserLicenseHeaderHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEndUserLicenseHeader_SaveToStream(TElOfficeEndUserLicenseHeaderHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEndUserLicenseHeader_get_ID_String(TElOfficeEndUserLicenseHeaderHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEndUserLicenseHeader_set_ID_String(TElOfficeEndUserLicenseHeaderHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEndUserLicenseHeader_Create(TElOfficeEndUserLicenseHeaderHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEENDUSERLICENSEHEADER */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONHEADER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_LoadFromStream(TElOfficeEncryptionHeaderHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_LoadFromStream_1(TElOfficeEncryptionHeaderHandle _Handle, TStreamHandle Stream, uint32_t Length);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_SaveToStream(TElOfficeEncryptionHeaderHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_get_Flags(TElOfficeEncryptionHeaderHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_set_Flags(TElOfficeEncryptionHeaderHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_get_AlgID(TElOfficeEncryptionHeaderHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_set_AlgID(TElOfficeEncryptionHeaderHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_get_AlgIDHash(TElOfficeEncryptionHeaderHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_set_AlgIDHash(TElOfficeEncryptionHeaderHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_get_KeySize(TElOfficeEncryptionHeaderHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_set_KeySize(TElOfficeEncryptionHeaderHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_get_ProviderType(TElOfficeEncryptionHeaderHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_set_ProviderType(TElOfficeEncryptionHeaderHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_get_CSPName(TElOfficeEncryptionHeaderHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_set_CSPName(TElOfficeEncryptionHeaderHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionHeader_Create(TElOfficeEncryptionHeaderHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONHEADER */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONVERIFIER
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_LoadFromStream(TElOfficeEncryptionVerifierHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_SaveToStream(TElOfficeEncryptionVerifierHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_get_Salt(TElOfficeEncryptionVerifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_set_Salt(TElOfficeEncryptionVerifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_get_EncryptedVerifier(TElOfficeEncryptionVerifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_set_EncryptedVerifier(TElOfficeEncryptionVerifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_get_VerifierHashSize(TElOfficeEncryptionVerifierHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_set_VerifierHashSize(TElOfficeEncryptionVerifierHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_get_EncryptedVerifierHash(TElOfficeEncryptionVerifierHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_set_EncryptedVerifierHash(TElOfficeEncryptionVerifierHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_get_ExpectedEncryptedVerifierHashSize(TElOfficeEncryptionVerifierHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_set_ExpectedEncryptedVerifierHashSize(TElOfficeEncryptionVerifierHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionVerifier_Create(TElOfficeEncryptionVerifierHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONVERIFIER */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONINFO
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfo_LoadFromStream(TElOfficeEncryptionInfoHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfo_SaveToStream(TElOfficeEncryptionInfoHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfo_get_EncryptionVersionInfo(TElOfficeEncryptionInfoHandle _Handle, TSBOfficeVersion * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfo_set_EncryptionVersionInfo(TElOfficeEncryptionInfoHandle _Handle, TSBOfficeVersion Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfo_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONINFO */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV1
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV1_LoadFromStream(TElOfficeEncryptionInfoV1Handle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV1_SaveToStream(TElOfficeEncryptionInfoV1Handle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV1_get_Salt(TElOfficeEncryptionInfoV1Handle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV1_set_Salt(TElOfficeEncryptionInfoV1Handle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV1_get_EncryptedVerifier(TElOfficeEncryptionInfoV1Handle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV1_set_EncryptedVerifier(TElOfficeEncryptionInfoV1Handle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV1_get_EncryptedVerifierHash(TElOfficeEncryptionInfoV1Handle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV1_set_EncryptedVerifierHash(TElOfficeEncryptionInfoV1Handle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV1_Create(TElOfficeEncryptionInfoV1Handle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV1 */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV2
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV2_LoadFromStream(TElOfficeEncryptionInfoV2Handle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV2_SaveToStream(TElOfficeEncryptionInfoV2Handle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV2_get_EncryptionHeaderFlags(TElOfficeEncryptionInfoV2Handle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV2_set_EncryptionHeaderFlags(TElOfficeEncryptionInfoV2Handle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV2_get_EncryptionHeader(TElOfficeEncryptionInfoV2Handle _Handle, TElOfficeEncryptionHeaderHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV2_set_EncryptionHeader(TElOfficeEncryptionInfoV2Handle _Handle, TElOfficeEncryptionHeaderHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV2_get_EncryptionVerifier(TElOfficeEncryptionInfoV2Handle _Handle, TElOfficeEncryptionVerifierHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV2_set_EncryptionVerifier(TElOfficeEncryptionInfoV2Handle _Handle, TElOfficeEncryptionVerifierHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV2_Create(TElOfficeEncryptionInfoV2Handle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV2 */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV3
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV3_LoadFromStream(TElOfficeEncryptionInfoV3Handle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV3_SaveToStream(TElOfficeEncryptionInfoV3Handle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV3_get_EncryptionHeaderFlags(TElOfficeEncryptionInfoV3Handle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV3_set_EncryptionHeaderFlags(TElOfficeEncryptionInfoV3Handle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV3_get_EncryptionHeader(TElOfficeEncryptionInfoV3Handle _Handle, TElOfficeEncryptionHeaderHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV3_set_EncryptionHeader(TElOfficeEncryptionInfoV3Handle _Handle, TElOfficeEncryptionHeaderHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV3_get_EncryptionInfo(TElOfficeEncryptionInfoV3Handle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV3_set_EncryptionInfo(TElOfficeEncryptionInfoV3Handle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV3_Create(TElOfficeEncryptionInfoV3Handle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV3 */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV4
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV4_LoadFromStream(TElOfficeEncryptionInfoV4Handle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV4_SaveToStream(TElOfficeEncryptionInfoV4Handle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV4_get_XmlEncryptionDescriptor(TElOfficeEncryptionInfoV4Handle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV4_set_XmlEncryptionDescriptor(TElOfficeEncryptionInfoV4Handle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptionInfoV4_Create(TElOfficeEncryptionInfoV4Handle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTIONINFOV4 */

#ifdef SB_USE_CLASS_TELOFFICEXOROBFUSCATION
SB_IMPORT uint32_t SB_APIENTRY TElOfficeXORObfuscation_LoadFromStream(TElOfficeXORObfuscationHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeXORObfuscation_SaveToStream(TElOfficeXORObfuscationHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeXORObfuscation_get_Key(TElOfficeXORObfuscationHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeXORObfuscation_set_Key(TElOfficeXORObfuscationHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeXORObfuscation_get_VerificationBytes(TElOfficeXORObfuscationHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeXORObfuscation_set_VerificationBytes(TElOfficeXORObfuscationHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeXORObfuscation_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEXOROBFUSCATION */

#ifdef SB_USE_CLASS_TELOFFICEENCRYPTEDSTREAMDESCRIPTOR
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_LoadFromStream(TElOfficeEncryptedStreamDescriptorHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_SaveToStream(TElOfficeEncryptedStreamDescriptorHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_get_StreamName(TElOfficeEncryptedStreamDescriptorHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_set_StreamName(TElOfficeEncryptedStreamDescriptorHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_get_StreamOffset(TElOfficeEncryptedStreamDescriptorHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_set_StreamOffset(TElOfficeEncryptedStreamDescriptorHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_get_StreamSize(TElOfficeEncryptedStreamDescriptorHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_set_StreamSize(TElOfficeEncryptedStreamDescriptorHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_get_Block(TElOfficeEncryptedStreamDescriptorHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_set_Block(TElOfficeEncryptedStreamDescriptorHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_get_Flags(TElOfficeEncryptedStreamDescriptorHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_set_Flags(TElOfficeEncryptedStreamDescriptorHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeEncryptedStreamDescriptor_Create(TElOfficeEncryptedStreamDescriptorHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEENCRYPTEDSTREAMDESCRIPTOR */

#ifdef SB_USE_CLASS_TELOFFICECERTIFICATEINFO
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_LoadFromStream(TElOfficeCertificateInfoHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_SaveToStream(TElOfficeCertificateInfoHandle _Handle, TStreamHandle Stream);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_get_ExpireTime(TElOfficeCertificateInfoHandle _Handle, windows_FILETIME * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_set_ExpireTime(TElOfficeCertificateInfoHandle _Handle, windows_FILETIME * Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_get_SignTime(TElOfficeCertificateInfoHandle _Handle, windows_FILETIME * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_set_SignTime(TElOfficeCertificateInfoHandle _Handle, windows_FILETIME * Value);
#else
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_get_ExpireTime(TElOfficeCertificateInfoHandle _Handle, _FILETIME * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_set_ExpireTime(TElOfficeCertificateInfoHandle _Handle, _FILETIME * Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_get_SignTime(TElOfficeCertificateInfoHandle _Handle, _FILETIME * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_set_SignTime(TElOfficeCertificateInfoHandle _Handle, _FILETIME * Value);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_get_AlgIDHash(TElOfficeCertificateInfoHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_set_AlgIDHash(TElOfficeCertificateInfoHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_get_SignerName(TElOfficeCertificateInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_set_SignerName(TElOfficeCertificateInfoHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_get_IssuerName(TElOfficeCertificateInfoHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_set_IssuerName(TElOfficeCertificateInfoHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_get_Signature(TElOfficeCertificateInfoHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_set_Signature(TElOfficeCertificateInfoHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_get_EncodedCertificate(TElOfficeCertificateInfoHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_set_EncodedCertificate(TElOfficeCertificateInfoHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_get_SerialNumber(TElOfficeCertificateInfoHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_set_SerialNumber(TElOfficeCertificateInfoHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_get_IssuerBlob(TElOfficeCertificateInfoHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_set_IssuerBlob(TElOfficeCertificateInfoHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertificateInfo_Create(TElOfficeCertificateInfoHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICECERTIFICATEINFO */

#ifdef SB_USE_CLASS_TELOFFICECERTSTORECERTIFICATEGROUP
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertStoreCertificateGroup_LoadFromStream(TElOfficeCertStoreCertificateGroupHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertStoreCertificateGroup_SaveToStream(TElOfficeCertStoreCertificateGroupHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertStoreCertificateGroup_get_CertificateData(TElOfficeCertStoreCertificateGroupHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertStoreCertificateGroup_set_CertificateData(TElOfficeCertStoreCertificateGroupHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertStoreCertificateGroup_get_EncodingType(TElOfficeCertStoreCertificateGroupHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertStoreCertificateGroup_set_EncodingType(TElOfficeCertStoreCertificateGroupHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCertStoreCertificateGroup_Create(TElOfficeCertStoreCertificateGroupHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICECERTSTORECERTIFICATEGROUP */

#ifdef SB_USE_CLASS_TELOFFICEDOCSIGSERIALIZEDCERTSTORE
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocSigSerializedCertStore_LoadFromStream(TElOfficeDocSigSerializedCertStoreHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocSigSerializedCertStore_SaveToStream(TElOfficeDocSigSerializedCertStoreHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocSigSerializedCertStore_Clear(TElOfficeDocSigSerializedCertStoreHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocSigSerializedCertStore_AddCertificate(TElOfficeDocSigSerializedCertStoreHandle _Handle, const uint8_t pBuf[], int32_t szBuf, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocSigSerializedCertStore_AddCertificate_1(TElOfficeDocSigSerializedCertStoreHandle _Handle, TElOfficeCertStoreCertificateGroupHandle Cert, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocSigSerializedCertStore_InsertCertificate(TElOfficeDocSigSerializedCertStoreHandle _Handle, int32_t Index, TElOfficeCertStoreCertificateGroupHandle Cert);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocSigSerializedCertStore_DeleteCertificate(TElOfficeDocSigSerializedCertStoreHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocSigSerializedCertStore_get_Count(TElOfficeDocSigSerializedCertStoreHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocSigSerializedCertStore_get_Certificates(TElOfficeDocSigSerializedCertStoreHandle _Handle, int32_t Index, TElOfficeCertStoreCertificateGroupHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeDocSigSerializedCertStore_Create(TElOfficeDocSigSerializedCertStoreHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEDOCSIGSERIALIZEDCERTSTORE */

#ifdef SB_USE_CLASS_TELOFFICECRYPTOAPIDIGITALSIGNATURE
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCryptoAPIDigitalSignature_LoadFromStream(TElOfficeCryptoAPIDigitalSignatureHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCryptoAPIDigitalSignature_SaveToStream(TElOfficeCryptoAPIDigitalSignatureHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCryptoAPIDigitalSignature_Clear(TElOfficeCryptoAPIDigitalSignatureHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCryptoAPIDigitalSignature_AddCertificateInfo(TElOfficeCryptoAPIDigitalSignatureHandle _Handle, TElOfficeCertificateInfoHandle CertInfo, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCryptoAPIDigitalSignature_InsertCertificateInfo(TElOfficeCryptoAPIDigitalSignatureHandle _Handle, int32_t Index, TElOfficeCertificateInfoHandle CertInfo);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCryptoAPIDigitalSignature_DeleteCertificateInfo(TElOfficeCryptoAPIDigitalSignatureHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCryptoAPIDigitalSignature_get_CertificateInfoCount(TElOfficeCryptoAPIDigitalSignatureHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCryptoAPIDigitalSignature_get_CertificateInfos(TElOfficeCryptoAPIDigitalSignatureHandle _Handle, int32_t Index, TElOfficeCertificateInfoHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCryptoAPIDigitalSignature_get_IntermediateCertificatesStore(TElOfficeCryptoAPIDigitalSignatureHandle _Handle, TElOfficeDocSigSerializedCertStoreHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeCryptoAPIDigitalSignature_Create(TElOfficeCryptoAPIDigitalSignatureHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICECRYPTOAPIDIGITALSIGNATURE */

#ifdef SB_USE_CLASS_TELOFFICEWORDFIBBASE
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_LoadFromStream(TElOfficeWordFIBBaseHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_SaveToStream(TElOfficeWordFIBBaseHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_get_Ident(TElOfficeWordFIBBaseHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_set_Ident(TElOfficeWordFIBBaseHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_get_FIB(TElOfficeWordFIBBaseHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_set_FIB(TElOfficeWordFIBBaseHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_get_LID(TElOfficeWordFIBBaseHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_set_LID(TElOfficeWordFIBBaseHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_get_Next(TElOfficeWordFIBBaseHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_set_Next(TElOfficeWordFIBBaseHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_get_Flags(TElOfficeWordFIBBaseHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_set_Flags(TElOfficeWordFIBBaseHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_get_FibBack(TElOfficeWordFIBBaseHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_set_FibBack(TElOfficeWordFIBBaseHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_get_Key(TElOfficeWordFIBBaseHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_set_Key(TElOfficeWordFIBBaseHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_get_Flags2(TElOfficeWordFIBBaseHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_set_Flags2(TElOfficeWordFIBBaseHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBBase_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEWORDFIBBASE */

#ifdef SB_USE_CLASS_TELOFFICEWORDFIBRGFCLCB
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBRgFcLcb_LoadFromStream(TElOfficeWordFIBRgFcLcbHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBRgFcLcb_SaveToStream(TElOfficeWordFIBRgFcLcbHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBRgFcLcb_ChangeOffsets(TElOfficeWordFIBRgFcLcbHandle _Handle, int32_t Shift);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBRgFcLcb_get_Blob(TElOfficeWordFIBRgFcLcbHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBRgFcLcb_set_Blob(TElOfficeWordFIBRgFcLcbHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIBRgFcLcb_Create(TElOfficeWordFIBRgFcLcbHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEWORDFIBRGFCLCB */

#ifdef SB_USE_CLASS_TELOFFICEWORDFIB
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIB_LoadFromStream(TElOfficeWordFIBHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIB_SaveToStream(TElOfficeWordFIBHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIB_get_FIBBase(TElOfficeWordFIBHandle _Handle, TElOfficeWordFIBBaseHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIB_get_FIBRgFcLcb(TElOfficeWordFIBHandle _Handle, TElOfficeWordFIBRgFcLcbHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWordFIB_Create(TElOfficeWordFIBHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEWORDFIB */

#ifdef SB_USE_CLASS_TELOFFICEWORKBOOKRECORDINFO
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookRecordInfo_LoadFromStream(TElOfficeWorkbookRecordInfoHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookRecordInfo_SaveToStream(TElOfficeWorkbookRecordInfoHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookRecordInfo_get_RecordType(TElOfficeWorkbookRecordInfoHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookRecordInfo_set_RecordType(TElOfficeWorkbookRecordInfoHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookRecordInfo_get_RecordSize(TElOfficeWorkbookRecordInfoHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookRecordInfo_set_RecordSize(TElOfficeWorkbookRecordInfoHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookRecordInfo_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEWORKBOOKRECORDINFO */

#ifdef SB_USE_CLASS_TELOFFICEWORKBOOKBOF
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_LoadFromStream(TElOfficeWorkbookBOFHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_SaveToStream(TElOfficeWorkbookBOFHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_get_Version(TElOfficeWorkbookBOFHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_set_Version(TElOfficeWorkbookBOFHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_get_DocumentType(TElOfficeWorkbookBOFHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_set_DocumentType(TElOfficeWorkbookBOFHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_get_RupBuild(TElOfficeWorkbookBOFHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_set_RupBuild(TElOfficeWorkbookBOFHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_get_RupYear(TElOfficeWorkbookBOFHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_set_RupYear(TElOfficeWorkbookBOFHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_get_Flags(TElOfficeWorkbookBOFHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_set_Flags(TElOfficeWorkbookBOFHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_get_VersionLowestBiff(TElOfficeWorkbookBOFHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_set_VersionLowestBiff(TElOfficeWorkbookBOFHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_get_VersionLastXLSaved(TElOfficeWorkbookBOFHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_set_VersionLastXLSaved(TElOfficeWorkbookBOFHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookBOF_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEWORKBOOKBOF */

#ifdef SB_USE_CLASS_TELOFFICEWORKBOOKFILEPASS
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookFilePass_LoadFromStream(TElOfficeWorkbookFilePassHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookFilePass_SaveToStream(TElOfficeWorkbookFilePassHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookFilePass_get_EncryptionType(TElOfficeWorkbookFilePassHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookFilePass_set_EncryptionType(TElOfficeWorkbookFilePassHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficeWorkbookFilePass_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEWORKBOOKFILEPASS */

#ifdef SB_USE_CLASS_TELOFFICEPOWERPOINTRECORDHEADER
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointRecordHeader_LoadFromStream(TElOfficePowerPointRecordHeaderHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointRecordHeader_SaveToStream(TElOfficePowerPointRecordHeaderHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointRecordHeader_get_RecordVersion(TElOfficePowerPointRecordHeaderHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointRecordHeader_set_RecordVersion(TElOfficePowerPointRecordHeaderHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointRecordHeader_get_RecordInstance(TElOfficePowerPointRecordHeaderHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointRecordHeader_set_RecordInstance(TElOfficePowerPointRecordHeaderHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointRecordHeader_get_RecordType(TElOfficePowerPointRecordHeaderHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointRecordHeader_set_RecordType(TElOfficePowerPointRecordHeaderHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointRecordHeader_get_RecordLength(TElOfficePowerPointRecordHeaderHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointRecordHeader_set_RecordLength(TElOfficePowerPointRecordHeaderHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointRecordHeader_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEPOWERPOINTRECORDHEADER */

#ifdef SB_USE_CLASS_TELOFFICEPOWERPOINTUSEREDITATOM
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_LoadFromStream(TElOfficePowerPointUserEditAtomHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_LoadFromStream_1(TElOfficePowerPointUserEditAtomHandle _Handle, TStreamHandle Stream, uint32_t RecordSize);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_SaveToStream(TElOfficePowerPointUserEditAtomHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_SaveToStream_1(TElOfficePowerPointUserEditAtomHandle _Handle, TStreamHandle Stream, int8_t IncludeEncryptSession);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_get_LastSlideIdRef(TElOfficePowerPointUserEditAtomHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_set_LastSlideIdRef(TElOfficePowerPointUserEditAtomHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_get_Version(TElOfficePowerPointUserEditAtomHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_set_Version(TElOfficePowerPointUserEditAtomHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_get_MinorVersion(TElOfficePowerPointUserEditAtomHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_set_MinorVersion(TElOfficePowerPointUserEditAtomHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_get_MajorVersion(TElOfficePowerPointUserEditAtomHandle _Handle, uint8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_set_MajorVersion(TElOfficePowerPointUserEditAtomHandle _Handle, uint8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_get_OffsetLastEdit(TElOfficePowerPointUserEditAtomHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_set_OffsetLastEdit(TElOfficePowerPointUserEditAtomHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_get_OffsetPersistDirectory(TElOfficePowerPointUserEditAtomHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_set_OffsetPersistDirectory(TElOfficePowerPointUserEditAtomHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_get_DocPersistIdRef(TElOfficePowerPointUserEditAtomHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_set_DocPersistIdRef(TElOfficePowerPointUserEditAtomHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_get_PersistIdSeed(TElOfficePowerPointUserEditAtomHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_set_PersistIdSeed(TElOfficePowerPointUserEditAtomHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_get_LastView(TElOfficePowerPointUserEditAtomHandle _Handle, uint16_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_set_LastView(TElOfficePowerPointUserEditAtomHandle _Handle, uint16_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_get_EncryptSessionPersistIdRef(TElOfficePowerPointUserEditAtomHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_set_EncryptSessionPersistIdRef(TElOfficePowerPointUserEditAtomHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointUserEditAtom_Create(TObjectHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEPOWERPOINTUSEREDITATOM */

#ifdef SB_USE_CLASS_TELOFFICEPOWERPOINTPERSISTDIRECTORYENTRY
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryEntry_LoadFromStream(TElOfficePowerPointPersistDirectoryEntryHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryEntry_SaveToStream(TElOfficePowerPointPersistDirectoryEntryHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryEntry_get_PersistId(TElOfficePowerPointPersistDirectoryEntryHandle _Handle, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryEntry_set_PersistId(TElOfficePowerPointPersistDirectoryEntryHandle _Handle, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryEntry_get_PersistOffsets(TElOfficePowerPointPersistDirectoryEntryHandle _Handle, uint32_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryEntry_set_PersistOffsets(TElOfficePowerPointPersistDirectoryEntryHandle _Handle, const uint32_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryEntry_Create(TElOfficePowerPointPersistDirectoryEntryHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEPOWERPOINTPERSISTDIRECTORYENTRY */

#ifdef SB_USE_CLASS_TELOFFICEPOWERPOINTPERSISTDIRECTORYATOM
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryAtom_LoadFromStream(TElOfficePowerPointPersistDirectoryAtomHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryAtom_LoadFromStream_1(TElOfficePowerPointPersistDirectoryAtomHandle _Handle, TStreamHandle Stream, uint32_t RecordSize);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryAtom_SaveToStream(TElOfficePowerPointPersistDirectoryAtomHandle _Handle, TStreamHandle Stream);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryAtom_Clear(TElOfficePowerPointPersistDirectoryAtomHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryAtom_Add(TElOfficePowerPointPersistDirectoryAtomHandle _Handle, TElOfficePowerPointPersistDirectoryEntryHandle AEntry, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryAtom_Insert(TElOfficePowerPointPersistDirectoryAtomHandle _Handle, int32_t Index, TElOfficePowerPointPersistDirectoryEntryHandle AEntry);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryAtom_Delete(TElOfficePowerPointPersistDirectoryAtomHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryAtom_AddPersistId(TElOfficePowerPointPersistDirectoryAtomHandle _Handle, uint32_t PersistId, uint32_t Offset);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryAtom_GetOffsetById(TElOfficePowerPointPersistDirectoryAtomHandle _Handle, uint32_t PersistId, uint32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryAtom_get_Count(TElOfficePowerPointPersistDirectoryAtomHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryAtom_get_Entries(TElOfficePowerPointPersistDirectoryAtomHandle _Handle, int32_t Index, TElOfficePowerPointPersistDirectoryEntryHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElOfficePowerPointPersistDirectoryAtom_Create(TElOfficePowerPointPersistDirectoryAtomHandle * OutResult);
#endif /* SB_USE_CLASS_TELOFFICEPOWERPOINTPERSISTDIRECTORYATOM */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElOfficeBinaryObject_ce_ptr;
extern zend_class_entry *TElOfficeDataSpaceVersionInfo_ce_ptr;
extern zend_class_entry *TElOfficeDataSpaceReferenceComponent_ce_ptr;
extern zend_class_entry *TElOfficeDataSpaceMapEntry_ce_ptr;
extern zend_class_entry *TElOfficeDataSpaceMap_ce_ptr;
extern zend_class_entry *TElOfficeDataSpaceDefinition_ce_ptr;
extern zend_class_entry *TElOfficeTransformInfoHeader_ce_ptr;
extern zend_class_entry *TElOfficeEncryptionTransformInfo_ce_ptr;
extern zend_class_entry *TElOfficeExtensibilityHeader_ce_ptr;
extern zend_class_entry *TElOfficeIRMDSTransformInfo_ce_ptr;
extern zend_class_entry *TElOfficeEndUserLicenseHeader_ce_ptr;
extern zend_class_entry *TElOfficeEncryptionHeader_ce_ptr;
extern zend_class_entry *TElOfficeEncryptionVerifier_ce_ptr;
extern zend_class_entry *TElOfficeEncryptionInfo_ce_ptr;
extern zend_class_entry *TElOfficeEncryptionInfoV1_ce_ptr;
extern zend_class_entry *TElOfficeEncryptionInfoV2_ce_ptr;
extern zend_class_entry *TElOfficeEncryptionInfoV3_ce_ptr;
extern zend_class_entry *TElOfficeEncryptionInfoV4_ce_ptr;
extern zend_class_entry *TElOfficeXORObfuscation_ce_ptr;
extern zend_class_entry *TElOfficeEncryptedStreamDescriptor_ce_ptr;
extern zend_class_entry *TElOfficeCertificateInfo_ce_ptr;
extern zend_class_entry *TElOfficeCertStoreCertificateGroup_ce_ptr;
extern zend_class_entry *TElOfficeDocSigSerializedCertStore_ce_ptr;
extern zend_class_entry *TElOfficeCryptoAPIDigitalSignature_ce_ptr;
extern zend_class_entry *TElOfficeWordFIBBase_ce_ptr;
extern zend_class_entry *TElOfficeWordFIBRgFcLcb_ce_ptr;
extern zend_class_entry *TElOfficeWordFIB_ce_ptr;
extern zend_class_entry *TElOfficeWorkbookRecordInfo_ce_ptr;
extern zend_class_entry *TElOfficeWorkbookBOF_ce_ptr;
extern zend_class_entry *TElOfficeWorkbookFilePass_ce_ptr;
extern zend_class_entry *TElOfficePowerPointRecordHeader_ce_ptr;
extern zend_class_entry *TElOfficePowerPointUserEditAtom_ce_ptr;
extern zend_class_entry *TElOfficePowerPointPersistDirectoryEntry_ce_ptr;
extern zend_class_entry *TElOfficePowerPointPersistDirectoryAtom_ce_ptr;

void Register_TElOfficeBinaryObject(TSRMLS_D);
void Register_TElOfficeDataSpaceVersionInfo(TSRMLS_D);
void Register_TElOfficeDataSpaceReferenceComponent(TSRMLS_D);
void Register_TElOfficeDataSpaceMapEntry(TSRMLS_D);
void Register_TElOfficeDataSpaceMap(TSRMLS_D);
void Register_TElOfficeDataSpaceDefinition(TSRMLS_D);
void Register_TElOfficeTransformInfoHeader(TSRMLS_D);
void Register_TElOfficeEncryptionTransformInfo(TSRMLS_D);
void Register_TElOfficeExtensibilityHeader(TSRMLS_D);
void Register_TElOfficeIRMDSTransformInfo(TSRMLS_D);
void Register_TElOfficeEndUserLicenseHeader(TSRMLS_D);
void Register_TElOfficeEncryptionHeader(TSRMLS_D);
void Register_TElOfficeEncryptionVerifier(TSRMLS_D);
void Register_TElOfficeEncryptionInfo(TSRMLS_D);
void Register_TElOfficeEncryptionInfoV1(TSRMLS_D);
void Register_TElOfficeEncryptionInfoV2(TSRMLS_D);
void Register_TElOfficeEncryptionInfoV3(TSRMLS_D);
void Register_TElOfficeEncryptionInfoV4(TSRMLS_D);
void Register_TElOfficeXORObfuscation(TSRMLS_D);
void Register_TElOfficeEncryptedStreamDescriptor(TSRMLS_D);
void Register_TElOfficeCertificateInfo(TSRMLS_D);
void Register_TElOfficeCertStoreCertificateGroup(TSRMLS_D);
void Register_TElOfficeDocSigSerializedCertStore(TSRMLS_D);
void Register_TElOfficeCryptoAPIDigitalSignature(TSRMLS_D);
void Register_TElOfficeWordFIBBase(TSRMLS_D);
void Register_TElOfficeWordFIBRgFcLcb(TSRMLS_D);
void Register_TElOfficeWordFIB(TSRMLS_D);
void Register_TElOfficeWorkbookRecordInfo(TSRMLS_D);
void Register_TElOfficeWorkbookBOF(TSRMLS_D);
void Register_TElOfficeWorkbookFilePass(TSRMLS_D);
void Register_TElOfficePowerPointRecordHeader(TSRMLS_D);
void Register_TElOfficePowerPointUserEditAtom(TSRMLS_D);
void Register_TElOfficePowerPointPersistDirectoryEntry(TSRMLS_D);
void Register_TElOfficePowerPointPersistDirectoryAtom(TSRMLS_D);
SB_PHP_FUNCTION(SBOfficeBinaryCore, BufferToInt32);
SB_PHP_FUNCTION(SBOfficeBinaryCore, BufferToInt64);
SB_PHP_FUNCTION(SBOfficeBinaryCore, Int32ToBuffer);
SB_PHP_FUNCTION(SBOfficeBinaryCore, UInt32ToBuffer);
SB_PHP_FUNCTION(SBOfficeBinaryCore, Int64ToBuffer);
SB_PHP_FUNCTION(SBOfficeBinaryCore, SwapTimeEncoding);
void Register_SBOfficeBinaryCore_Constants(int module_number TSRMLS_DC);
void Register_SBOfficeBinaryCore_Aliases(TSRMLS_D);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_OFFICEBINARYCORE
SB_IMPORT uint32_t SB_APIENTRY SBOfficeBinaryCore_BufferToInt32(const uint8_t pBuffer[], int32_t szBuffer, int32_t Index, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBOfficeBinaryCore_BufferToInt64(const uint8_t pBuffer[], int32_t szBuffer, int32_t Index, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBOfficeBinaryCore_Int32ToBuffer(uint8_t pBuffer[], int32_t * szBuffer, int32_t Index, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY SBOfficeBinaryCore_UInt32ToBuffer(uint8_t pBuffer[], int32_t * szBuffer, int32_t Index, uint32_t Value);
SB_IMPORT uint32_t SB_APIENTRY SBOfficeBinaryCore_Int64ToBuffer(uint8_t pBuffer[], int32_t * szBuffer, int32_t Index, int64_t Value);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY SBOfficeBinaryCore_SwapTimeEncoding(windows_FILETIME * Value, windows_FILETIME * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY SBOfficeBinaryCore_SwapTimeEncoding(_FILETIME * Value, _FILETIME * OutResult);
#endif
#endif /* SB_USE_GLOBAL_PROCS_OFFICEBINARYCORE */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBOFFICEBINARYCORE */
