#ifndef __INC_SBPGPSTREAMS
#define __INC_SBPGPSTREAMS

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbtypes.h"
#include "sbutils.h"
#include "sbconstants.h"
#include "sbencoding.h"
#include "sbstreams.h"
#include "sbpgpkeys.h"
#include "sbpgpentities.h"
#include "sbpgpconstants.h"
#include "sbzlib.h"
#include "sbbzip2.h"
#include "sbsymmetriccrypto.h"
#include "sbhashfunction.h"
#include "sbpgputils.h"
#include "sbpgpmd.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElPGPStreamHandle;

typedef TElPGPStreamHandle ElPGPStreamHandle;

typedef TElClassHandle TElPGPArmoringStreamHandle;

typedef TElPGPArmoringStreamHandle ElPGPArmoringStreamHandle;

typedef TElClassHandle TElPGPDearmoringStreamHandle;

typedef TElPGPDearmoringStreamHandle ElPGPDearmoringStreamHandle;

typedef TElClassHandle TElPGPEnvelopingStreamHandle;

typedef TElPGPEnvelopingStreamHandle ElPGPEnvelopingStreamHandle;

typedef TElClassHandle TElPGPUnenvelopingStreamHandle;

typedef TElPGPUnenvelopingStreamHandle ElPGPUnenvelopingStreamHandle;

typedef TElClassHandle TElPGPEncryptingStreamHandle;

typedef TElPGPEncryptingStreamHandle ElPGPEncryptingStreamHandle;

typedef TElClassHandle TElPGPDecryptingStreamHandle;

typedef TElPGPDecryptingStreamHandle ElPGPDecryptingStreamHandle;

typedef TElClassHandle TElPGPCompressingStreamHandle;

typedef TElPGPCompressingStreamHandle ElPGPCompressingStreamHandle;

typedef TElClassHandle TElPGPDecompressingStreamHandle;

typedef TElPGPDecompressingStreamHandle ElPGPDecompressingStreamHandle;

typedef TElClassHandle TElPGPSigningStreamHandle;

typedef TElPGPSigningStreamHandle ElPGPSigningStreamHandle;

typedef TElClassHandle TElPGPClearTextVerifyingStreamHandle;

typedef TElPGPClearTextVerifyingStreamHandle ElPGPClearTextVerifyingStreamHandle;

typedef TElClassHandle TElPGPEntityStreamHandle;

typedef TElPGPEntityStreamHandle ElPGPEntityStreamHandle;

typedef uint8_t TSBPGPSignatureValidityRaw;

typedef enum
{
	svValid = 0,
	svCorrupted = 1,
	svUnknownAlgorithm = 2,
	svNoKey = 3,
	svUnknown = 4
} TSBPGPSignatureValidity;

typedef void (SB_CALLBACK *TSBOutputFunc)(void * _ObjectData, void * Buffer, int32_t Size);

typedef void (SB_CALLBACK *TSBInputFunc)(void * _ObjectData, void * Buffer, int32_t Size, int8_t * Last, int32_t * OutResult);

typedef void (SB_CALLBACK *TSBPGPPassphraseEvent)(void * _ObjectData, TObjectHandle Sender, char * pcPassphrase, int32_t * szPassphrase, int8_t * Cancel);

typedef void (SB_CALLBACK *TSBPGPKeyPassphraseEvent)(void * _ObjectData, TObjectHandle Sender, TElPGPCustomSecretKeyHandle Key, char * pcPassphrase, int32_t * szPassphrase, int8_t * Cancel);

typedef void (SB_CALLBACK *TSBPGPSignaturesEvent)(void * _ObjectData, TObjectHandle Sender, const TElPGPSignatureHandle pSignatures[], int32_t szSignatures, const TSBPGPSignatureValidityRaw pValidities[], int32_t szValidities);

typedef void (SB_CALLBACK *TSBPGPKeyIDsEvent)(void * _ObjectData, TObjectHandle Sender, const uint8_t pKeyIDs[][8], int32_t szKeyIDs);

typedef TElClassHandle TElPGPStreamClassHandle;

typedef TElPGPStreamClassHandle ElPGPStreamClassHandle;

#ifdef SB_USE_CLASS_TELPGPSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_DataAvailable(TElPGPStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_Process(TElPGPStreamHandle _Handle, void * AReadUserData, void * AWriteUserData);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_ProcessStream(TElPGPStreamHandle _Handle, TStreamHandle AInputStream, TStreamHandle AOutputStream, int32_t Count);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_get_PassTo(TElPGPStreamHandle _Handle, TElPGPStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_set_PassTo(TElPGPStreamHandle _Handle, TElPGPStreamHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_get_UseOldPackets(TElPGPStreamHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_set_UseOldPackets(TElPGPStreamHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_get_ProcessedLength(TElPGPStreamHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_get_IgnoreDataPacketLengthTag(TElPGPStreamHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_set_IgnoreDataPacketLengthTag(TElPGPStreamHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_get_OnRead(TElPGPStreamHandle _Handle, TSBPGPReadEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_set_OnRead(TElPGPStreamHandle _Handle, TSBPGPReadEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_get_OnWrite(TElPGPStreamHandle _Handle, TSBPGPWriteEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_set_OnWrite(TElPGPStreamHandle _Handle, TSBPGPWriteEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_get_OnFinish(TElPGPStreamHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_set_OnFinish(TElPGPStreamHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_get_OnTemporaryStream(TElPGPStreamHandle _Handle, TSBPGPTemporaryStreamEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_set_OnTemporaryStream(TElPGPStreamHandle _Handle, TSBPGPTemporaryStreamEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPStream_Create(TElPGPStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSTREAM */

#ifdef SB_USE_CLASS_TELPGPARMORINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElPGPArmoringStream_DataAvailable(TElPGPArmoringStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPArmoringStream_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPArmoringStream_get_LineLength(TElPGPArmoringStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPArmoringStream_set_LineLength(TElPGPArmoringStreamHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPArmoringStream_get_Boundary(TElPGPArmoringStreamHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPArmoringStream_set_Boundary(TElPGPArmoringStreamHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPArmoringStream_get_Headers(TElPGPArmoringStreamHandle _Handle, TStringListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPArmoringStream_Create(TElPGPArmoringStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPARMORINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPDEARMORINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElPGPDearmoringStream_DataAvailable(TElPGPDearmoringStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDearmoringStream_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDearmoringStream_get_Boundary(TElPGPDearmoringStreamHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDearmoringStream_get_Headers(TElPGPDearmoringStreamHandle _Handle, TStringListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDearmoringStream_get_MultiPart(TElPGPDearmoringStreamHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDearmoringStream_set_MultiPart(TElPGPDearmoringStreamHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDearmoringStream_get_InputEncoding(TElPGPDearmoringStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDearmoringStream_set_InputEncoding(TElPGPDearmoringStreamHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDearmoringStream_get_OnInfo(TElPGPDearmoringStreamHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDearmoringStream_set_OnInfo(TElPGPDearmoringStreamHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDearmoringStream_Create(TElPGPDearmoringStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPDEARMORINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPENVELOPINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_DataAvailable(TElPGPEnvelopingStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_AddSignature(TElPGPEnvelopingStreamHandle _Handle, TElPGPSignatureHandle Signature, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_RemoveSignature(TElPGPEnvelopingStreamHandle _Handle, int32_t Index);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_ClearSignatures(TElPGPEnvelopingStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_get_Filename(TElPGPEnvelopingStreamHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_set_Filename(TElPGPEnvelopingStreamHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_get_Timestamp(TElPGPEnvelopingStreamHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_set_Timestamp(TElPGPEnvelopingStreamHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_get_TextMode(TElPGPEnvelopingStreamHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_set_TextMode(TElPGPEnvelopingStreamHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_get_Signatures(TElPGPEnvelopingStreamHandle _Handle, int32_t Index, TElPGPSignatureHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_get_SignatureCount(TElPGPEnvelopingStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_get_UseOnePassSignatures(TElPGPEnvelopingStreamHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_set_UseOnePassSignatures(TElPGPEnvelopingStreamHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEnvelopingStream_Create(TElPGPEnvelopingStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPENVELOPINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPUNENVELOPINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_DataAvailable(TElPGPUnenvelopingStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_DataCompleted(TElPGPUnenvelopingStreamHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_get_Filename(TElPGPUnenvelopingStreamHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_get_Timestamp(TElPGPUnenvelopingStreamHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_set_Timestamp(TElPGPUnenvelopingStreamHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_get_HashingPool(TElPGPUnenvelopingStreamHandle _Handle, TElPGPHashingPoolHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_set_HashingPool(TElPGPUnenvelopingStreamHandle _Handle, TElPGPHashingPoolHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_get_TextHashingPool(TElPGPUnenvelopingStreamHandle _Handle, TElPGPHashingPoolHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_set_TextHashingPool(TElPGPUnenvelopingStreamHandle _Handle, TElPGPHashingPoolHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_get_BuggyTextHashingPool(TElPGPUnenvelopingStreamHandle _Handle, TElPGPHashingPoolHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_set_BuggyTextHashingPool(TElPGPUnenvelopingStreamHandle _Handle, TElPGPHashingPoolHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_get_OnInfo(TElPGPUnenvelopingStreamHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_set_OnInfo(TElPGPUnenvelopingStreamHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPUnenvelopingStream_Create(TElPGPUnenvelopingStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPUNENVELOPINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPENCRYPTINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_DataAvailable(TElPGPEncryptingStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_get_Keyring(TElPGPEncryptingStreamHandle _Handle, TElPGPKeyringHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_set_Keyring(TElPGPEncryptingStreamHandle _Handle, TElPGPKeyringHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_get_Passphrases(TElPGPEncryptingStreamHandle _Handle, TStringListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_get_IntegrityProtected(TElPGPEncryptingStreamHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_set_IntegrityProtected(TElPGPEncryptingStreamHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_get_Algorithm(TElPGPEncryptingStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_set_Algorithm(TElPGPEncryptingStreamHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_get_PassphraseAlgorithm(TElPGPEncryptingStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_set_PassphraseAlgorithm(TElPGPEncryptingStreamHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_get_Protection(TElPGPEncryptingStreamHandle _Handle, TSBPGPProtectionTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_set_Protection(TElPGPEncryptingStreamHandle _Handle, TSBPGPProtectionTypeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEncryptingStream_Create(TElPGPEncryptingStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPENCRYPTINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPDECRYPTINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_DataAvailable(TElPGPDecryptingStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_get_Keyring(TElPGPDecryptingStreamHandle _Handle, TElPGPKeyringHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_set_Keyring(TElPGPDecryptingStreamHandle _Handle, TElPGPKeyringHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_get_IntegrityProtected(TElPGPDecryptingStreamHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_get_Algorithm(TElPGPDecryptingStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_get_Protection(TElPGPDecryptingStreamHandle _Handle, TSBPGPProtectionTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_get_SymmetricallyEncrypted(TElPGPDecryptingStreamHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_get_OnPassphrase(TElPGPDecryptingStreamHandle _Handle, TSBPGPPassphraseEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_set_OnPassphrase(TElPGPDecryptingStreamHandle _Handle, TSBPGPPassphraseEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_get_OnKeyPassphrase(TElPGPDecryptingStreamHandle _Handle, TSBPGPKeyPassphraseEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_set_OnKeyPassphrase(TElPGPDecryptingStreamHandle _Handle, TSBPGPKeyPassphraseEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_get_OnKeyIDs(TElPGPDecryptingStreamHandle _Handle, TSBPGPKeyIDsEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_set_OnKeyIDs(TElPGPDecryptingStreamHandle _Handle, TSBPGPKeyIDsEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_get_OnDecryptionStart(TElPGPDecryptingStreamHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_set_OnDecryptionStart(TElPGPDecryptingStreamHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecryptingStream_Create(TElPGPDecryptingStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPDECRYPTINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPCOMPRESSINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElPGPCompressingStream_DataAvailable(TElPGPCompressingStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCompressingStream_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCompressingStream_get_Algorithm(TElPGPCompressingStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCompressingStream_set_Algorithm(TElPGPCompressingStreamHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCompressingStream_get_CompressionLevel(TElPGPCompressingStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCompressingStream_set_CompressionLevel(TElPGPCompressingStreamHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPCompressingStream_Create(TElPGPCompressingStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPCOMPRESSINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPDECOMPRESSINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecompressingStream_DataAvailable(TElPGPDecompressingStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecompressingStream_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecompressingStream_get_Algorithm(TElPGPDecompressingStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecompressingStream_get_OnDecompressionStart(TElPGPDecompressingStreamHandle _Handle, TNotifyEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecompressingStream_set_OnDecompressionStart(TElPGPDecompressingStreamHandle _Handle, TNotifyEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPDecompressingStream_Create(TElPGPDecompressingStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPDECOMPRESSINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPSIGNINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElPGPSigningStream_DataAvailable(TElPGPSigningStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSigningStream_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSigningStream_get_HashAlgorithm(TElPGPSigningStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSigningStream_set_HashAlgorithm(TElPGPSigningStreamHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSigningStream_get_Keyring(TElPGPSigningStreamHandle _Handle, TElPGPKeyringHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSigningStream_set_Keyring(TElPGPSigningStreamHandle _Handle, TElPGPKeyringHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSigningStream_get_Headers(TElPGPSigningStreamHandle _Handle, TStringListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSigningStream_get_OnKeyPassphrase(TElPGPSigningStreamHandle _Handle, TSBPGPKeyPassphraseEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSigningStream_set_OnKeyPassphrase(TElPGPSigningStreamHandle _Handle, TSBPGPKeyPassphraseEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPSigningStream_Create(TElPGPSigningStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPSIGNINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPCLEARTEXTVERIFYINGSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElPGPClearTextVerifyingStream_DataAvailable(TElPGPClearTextVerifyingStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPClearTextVerifyingStream_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPClearTextVerifyingStream_get_Keyring(TElPGPClearTextVerifyingStreamHandle _Handle, TElPGPKeyringHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPClearTextVerifyingStream_set_Keyring(TElPGPClearTextVerifyingStreamHandle _Handle, TElPGPKeyringHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPClearTextVerifyingStream_get_InputEncoding(TElPGPClearTextVerifyingStreamHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPClearTextVerifyingStream_set_InputEncoding(TElPGPClearTextVerifyingStreamHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElPGPClearTextVerifyingStream_get_OnKeyIDs(TElPGPClearTextVerifyingStreamHandle _Handle, TSBPGPKeyIDsEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPClearTextVerifyingStream_set_OnKeyIDs(TElPGPClearTextVerifyingStreamHandle _Handle, TSBPGPKeyIDsEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPClearTextVerifyingStream_get_OnSignatures(TElPGPClearTextVerifyingStreamHandle _Handle, TSBPGPSignaturesEvent * pMethodOutResult, void * * pDataOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPClearTextVerifyingStream_set_OnSignatures(TElPGPClearTextVerifyingStreamHandle _Handle, TSBPGPSignaturesEvent pMethodValue, void * pDataValue);
SB_IMPORT uint32_t SB_APIENTRY TElPGPClearTextVerifyingStream_Create(TElPGPClearTextVerifyingStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPCLEARTEXTVERIFYINGSTREAM */

#ifdef SB_USE_CLASS_TELPGPENTITYSTREAM
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntityStream_DataAvailable(TElPGPEntityStreamHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntityStream_ClassType(TClassHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntityStream_get_Entity(TElPGPEntityStreamHandle _Handle, TElPGPEntityHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntityStream_Create(TElPGPEntityStreamHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElPGPEntityStream_Create_1(uint8_t PktType, TElPGPEntityStreamHandle * OutResult);
#endif /* SB_USE_CLASS_TELPGPENTITYSTREAM */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElPGPStreamClass_ce_ptr;
extern zend_class_entry *TElPGPStream_ce_ptr;
extern zend_class_entry *TElPGPArmoringStream_ce_ptr;
extern zend_class_entry *TElPGPDearmoringStream_ce_ptr;
extern zend_class_entry *TElPGPEnvelopingStream_ce_ptr;
extern zend_class_entry *TElPGPUnenvelopingStream_ce_ptr;
extern zend_class_entry *TElPGPEncryptingStream_ce_ptr;
extern zend_class_entry *TElPGPDecryptingStream_ce_ptr;
extern zend_class_entry *TElPGPCompressingStream_ce_ptr;
extern zend_class_entry *TElPGPDecompressingStream_ce_ptr;
extern zend_class_entry *TElPGPSigningStream_ce_ptr;
extern zend_class_entry *TElPGPClearTextVerifyingStream_ce_ptr;
extern zend_class_entry *TElPGPEntityStream_ce_ptr;

void SB_CALLBACK TSBOutputFuncRaw(void * _ObjectData, void * Buffer, int32_t Size);
void SB_CALLBACK TSBInputFuncRaw(void * _ObjectData, void * Buffer, int32_t Size, int8_t * Last, int32_t * OutResult);
void SB_CALLBACK TSBPGPPassphraseEventRaw(void * _ObjectData, TObjectHandle Sender, char * pcPassphrase, int32_t * szPassphrase, int8_t * Cancel);
void SB_CALLBACK TSBPGPKeyPassphraseEventRaw(void * _ObjectData, TObjectHandle Sender, TElPGPCustomSecretKeyHandle Key, char * pcPassphrase, int32_t * szPassphrase, int8_t * Cancel);
void SB_CALLBACK TSBPGPSignaturesEventRaw(void * _ObjectData, TObjectHandle Sender, const TElPGPSignatureHandle pSignatures[], int32_t szSignatures, const TSBPGPSignatureValidityRaw pValidities[], int32_t szValidities);
void SB_CALLBACK TSBPGPKeyIDsEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pKeyIDs[][8], int32_t szKeyIDs);
void Register_TElPGPStream(TSRMLS_D);
void Register_TElPGPArmoringStream(TSRMLS_D);
void Register_TElPGPDearmoringStream(TSRMLS_D);
void Register_TElPGPEnvelopingStream(TSRMLS_D);
void Register_TElPGPUnenvelopingStream(TSRMLS_D);
void Register_TElPGPEncryptingStream(TSRMLS_D);
void Register_TElPGPDecryptingStream(TSRMLS_D);
void Register_TElPGPCompressingStream(TSRMLS_D);
void Register_TElPGPDecompressingStream(TSRMLS_D);
void Register_TElPGPSigningStream(TSRMLS_D);
void Register_TElPGPClearTextVerifyingStream(TSRMLS_D);
void Register_TElPGPEntityStream(TSRMLS_D);
void Register_SBPGPStreams_Enum_Flags(TSRMLS_D);
void Register_SBPGPStreams_Aliases(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBPGPSTREAMS */

