#ifndef __INC_SBRC2
#define __INC_SBRC2

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbtypes.h"
#include "sbconstants.h"
#include "sbutils.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#define SB_TRC2BufferSize 	8
#define SB_TRC2ExpandedKeyLength 	64

typedef uint16_t TRC2ExpandedKey[64];

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TRC2ExpandedKey_ce_ptr;

void Register_TRC2ExpandedKey(TSRMLS_D);
SB_PHP_FUNCTION(SBRC2, ExpandKey);
SB_PHP_FUNCTION(SBRC2, Encrypt);
SB_PHP_FUNCTION(SBRC2, Decrypt);
SB_PHP_FUNCTION(SBRC2, ParseASN1Params);
SB_PHP_FUNCTION(SBRC2, WriteASN1Params);
void Register_SBRC2_Constants(int module_number TSRMLS_DC);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_RC2
SB_IMPORT uint32_t SB_APIENTRY SBRC2_ExpandKey(const uint8_t pKey[], int32_t szKey, TRC2ExpandedKey * ExpandedKey);
SB_IMPORT uint32_t SB_APIENTRY SBRC2_Encrypt(uint32_t * B0, uint32_t * B1, const TRC2ExpandedKey * ExpandedKey);
SB_IMPORT uint32_t SB_APIENTRY SBRC2_Decrypt(uint32_t * B0, uint32_t * B1, const TRC2ExpandedKey * ExpandedKey);
SB_IMPORT uint32_t SB_APIENTRY SBRC2_ParseASN1Params(const uint8_t pParams[], int32_t szParams, uint8_t pIV[], int32_t * szIV, int32_t * KeyBits, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBRC2_WriteASN1Params(const uint8_t pIV[], int32_t szIV, int32_t KeyBits, uint8_t pParams[], int32_t * szParams);
#endif /* SB_USE_GLOBAL_PROCS_RC2 */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBRC2 */

