#ifndef __INC_SBSSLCONSTANTS
#define __INC_SBSSLCONSTANTS

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbconstants.h"
#include "sbutils.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
#define SB_ERROR_FACILITY_SSL 	73728
#define SB_ERROR_SSL_PROTOCOL_ERROR_FLAG 	2048
#define SB_ERROR_SSL_CONNECTION_CANCELLED_BY_USER 	73729
#define SB_ERROR_SSL_TIMEOUT 	73730
#define SB_ERROR_SSL_UNSUPPORTED_MAC_ALGORITHM 	73731
#define SB_ERROR_SSL_CLIENT_KEX_COMPUTATION_ERROR 	73732
#define SB_ERROR_SSL_COMPRESSION_ERROR 	73733
#define SB_ERROR_SSL_CRYPTO_NOT_INITIALIZED 	73734
#define SB_ERROR_SSL_PRIVATE_KEY_OPERATION_FAILED 	73735
#define SB_ERROR_SSL_UNEXPECTED_MESSAGE 	75777
#define SB_ERROR_SSL_BAD_RECORD_MAC 	75778
#define SB_ERROR_SSL_DECRYPTION_FAILED 	75779
#define SB_ERROR_SSL_RECORD_OVERFLOW 	75780
#define SB_ERROR_SSL_DECOMPRESSION_FAILURE 	75781
#define SB_ERROR_SSL_HANDSHAKE_FAILURE 	75782
#define SB_ERROR_SSL_NO_CERTIFICATE 	75783
#define SB_ERROR_SSL_BAD_CERTIFICATE 	75784
#define SB_ERROR_SSL_UNSUPPORTED_CERTIFICATE 	75785
#define SB_ERROR_SSL_CERTIFICATE_REVOKED 	75786
#define SB_ERROR_SSL_CERTIFICATE_EXPIRED 	75787
#define SB_ERROR_SSL_CERTIFICATE_UNKNOWN 	75788
#define SB_ERROR_SSL_ILLEGAL_PARAMETER 	75789
#define SB_ERROR_SSL_UNKNOWN_CA 	75790
#define SB_ERROR_SSL_ACCESS_DENIED 	75791
#define SB_ERROR_SSL_DECODE_ERROR 	75792
#define SB_ERROR_SSL_DECRYPT_ERROR 	75793
#define SB_ERROR_SSL_EXPORT_RESTRICTION 	75794
#define SB_ERROR_SSL_PROTOCOL_VERSION 	75795
#define SB_ERROR_SSL_INSUFFICIENT_SECURITY 	75796
#define SB_ERROR_SSL_INTERNAL_ERROR 	75797
#define SB_ERROR_SSL_USER_CANCELED 	75798
#define SB_ERROR_SSL_NO_RENEGOTIATION 	75799
#define SB_ERROR_SSL_CLOSE_NOTIFY 	75800
#define SB_ERROR_SSL_UNKNOWN_PROTOCOL_ERROR 	75801
#define SB_ERROR_SSL_UNSUPPORTED_EXTENSION 	75802
#define SB_ERROR_SSL_NO_SHARED_CIPHER 	75803
#define SB_ERROR_SSL_INAPPROPRIATE_FALLBACK 	75804
#define SB_ERROR_SSL_UNKNOWN_PSK_IDENTITY 	75805
#define SB_SUITE_FIRST 	0
#define SB_SUITE_NULL_NULL_NULL 	0
#define SB_SUITE_RSA_NULL_MD5 	1
#define SB_SUITE_RSA_NULL_SHA 	2
#define SB_SUITE_RSA_RC4_MD5 	3
#define SB_SUITE_RSA_RC4_SHA 	4
#define SB_SUITE_RSA_RC2_MD5 	5
#define SB_SUITE_RSA_IDEA_MD5 	6
#define SB_SUITE_RSA_IDEA_SHA 	7
#define SB_SUITE_RSA_DES_MD5 	8
#define SB_SUITE_RSA_DES_SHA 	9
#define SB_SUITE_RSA_3DES_MD5 	10
#define SB_SUITE_RSA_3DES_SHA 	11
#define SB_SUITE_RSA_AES128_SHA 	12
#define SB_SUITE_RSA_AES256_SHA 	13
#define SB_SUITE_DH_DSS_DES_SHA 	14
#define SB_SUITE_DH_DSS_3DES_SHA 	15
#define SB_SUITE_DH_DSS_AES128_SHA 	16
#define SB_SUITE_DH_DSS_AES256_SHA 	17
#define SB_SUITE_DH_RSA_DES_SHA 	18
#define SB_SUITE_DH_RSA_3DES_SHA 	19
#define SB_SUITE_DH_RSA_AES128_SHA 	20
#define SB_SUITE_DH_RSA_AES256_SHA 	21
#define SB_SUITE_DHE_DSS_DES_SHA 	22
#define SB_SUITE_DHE_DSS_3DES_SHA 	23
#define SB_SUITE_DHE_DSS_AES128_SHA 	24
#define SB_SUITE_DHE_DSS_AES256_SHA 	25
#define SB_SUITE_DHE_RSA_DES_SHA 	26
#define SB_SUITE_DHE_RSA_3DES_SHA 	27
#define SB_SUITE_DHE_RSA_AES128_SHA 	28
#define SB_SUITE_DHE_RSA_AES256_SHA 	29
#define SB_SUITE_DH_ANON_RC4_MD5 	30
#define SB_SUITE_DH_ANON_DES_SHA 	31
#define SB_SUITE_DH_ANON_3DES_SHA 	32
#define SB_SUITE_DH_ANON_AES128_SHA 	33
#define SB_SUITE_DH_ANON_AES256_SHA 	34
#define SB_SUITE_RSA_RC2_MD5_EXPORT 	35
#define SB_SUITE_RSA_RC4_MD5_EXPORT 	36
#define SB_SUITE_RSA_DES_SHA_EXPORT 	37
#define SB_SUITE_DH_DSS_DES_SHA_EXPORT 	38
#define SB_SUITE_DH_RSA_DES_SHA_EXPORT 	39
#define SB_SUITE_DHE_DSS_DES_SHA_EXPORT 	40
#define SB_SUITE_DHE_RSA_DES_SHA_EXPORT 	41
#define SB_SUITE_DH_ANON_RC4_MD5_EXPORT 	42
#define SB_SUITE_DH_ANON_DES_SHA_EXPORT 	43
#define SB_SUITE_RSA_CAMELLIA128_SHA 	44
#define SB_SUITE_DH_DSS_CAMELLIA128_SHA 	45
#define SB_SUITE_DH_RSA_CAMELLIA128_SHA 	46
#define SB_SUITE_DHE_DSS_CAMELLIA128_SHA 	47
#define SB_SUITE_DHE_RSA_CAMELLIA128_SHA 	48
#define SB_SUITE_DH_ANON_CAMELLIA128_SHA 	49
#define SB_SUITE_RSA_CAMELLIA256_SHA 	50
#define SB_SUITE_DH_DSS_CAMELLIA256_SHA 	51
#define SB_SUITE_DH_RSA_CAMELLIA256_SHA 	52
#define SB_SUITE_DHE_DSS_CAMELLIA256_SHA 	53
#define SB_SUITE_DHE_RSA_CAMELLIA256_SHA 	54
#define SB_SUITE_DH_ANON_CAMELLIA256_SHA 	55
#define SB_SUITE_PSK_RC4_SHA 	56
#define SB_SUITE_PSK_3DES_SHA 	57
#define SB_SUITE_PSK_AES128_SHA 	58
#define SB_SUITE_PSK_AES256_SHA 	59
#define SB_SUITE_DHE_PSK_RC4_SHA 	60
#define SB_SUITE_DHE_PSK_3DES_SHA 	61
#define SB_SUITE_DHE_PSK_AES128_SHA 	62
#define SB_SUITE_DHE_PSK_AES256_SHA 	63
#define SB_SUITE_RSA_PSK_RC4_SHA 	64
#define SB_SUITE_RSA_PSK_3DES_SHA 	65
#define SB_SUITE_RSA_PSK_AES128_SHA 	66
#define SB_SUITE_RSA_PSK_AES256_SHA 	67
#define SB_SUITE_RSA_SEED_SHA 	68
#define SB_SUITE_DH_DSS_SEED_SHA 	69
#define SB_SUITE_DH_RSA_SEED_SHA 	70
#define SB_SUITE_DHE_DSS_SEED_SHA 	71
#define SB_SUITE_DHE_RSA_SEED_SHA 	72
#define SB_SUITE_DH_ANON_SEED_SHA 	73
#define SB_SUITE_SRP_SHA_3DES_SHA 	74
#define SB_SUITE_SRP_SHA_RSA_3DES_SHA 	75
#define SB_SUITE_SRP_SHA_DSS_3DES_SHA 	76
#define SB_SUITE_SRP_SHA_AES128_SHA 	77
#define SB_SUITE_SRP_SHA_RSA_AES128_SHA 	78
#define SB_SUITE_SRP_SHA_DSS_AES128_SHA 	79
#define SB_SUITE_SRP_SHA_AES256_SHA 	80
#define SB_SUITE_SRP_SHA_RSA_AES256_SHA 	81
#define SB_SUITE_SRP_SHA_DSS_AES256_SHA 	82
#define SB_SUITE_ECDH_ECDSA_NULL_SHA 	83
#define SB_SUITE_ECDH_ECDSA_RC4_SHA 	84
#define SB_SUITE_ECDH_ECDSA_3DES_SHA 	85
#define SB_SUITE_ECDH_ECDSA_AES128_SHA 	86
#define SB_SUITE_ECDH_ECDSA_AES256_SHA 	87
#define SB_SUITE_ECDHE_ECDSA_NULL_SHA 	88
#define SB_SUITE_ECDHE_ECDSA_RC4_SHA 	89
#define SB_SUITE_ECDHE_ECDSA_3DES_SHA 	90
#define SB_SUITE_ECDHE_ECDSA_AES128_SHA 	91
#define SB_SUITE_ECDHE_ECDSA_AES256_SHA 	92
#define SB_SUITE_ECDH_RSA_NULL_SHA 	93
#define SB_SUITE_ECDH_RSA_RC4_SHA 	94
#define SB_SUITE_ECDH_RSA_3DES_SHA 	95
#define SB_SUITE_ECDH_RSA_AES128_SHA 	96
#define SB_SUITE_ECDH_RSA_AES256_SHA 	97
#define SB_SUITE_ECDHE_RSA_NULL_SHA 	98
#define SB_SUITE_ECDHE_RSA_RC4_SHA 	99
#define SB_SUITE_ECDHE_RSA_3DES_SHA 	100
#define SB_SUITE_ECDHE_RSA_AES128_SHA 	101
#define SB_SUITE_ECDHE_RSA_AES256_SHA 	102
#define SB_SUITE_ECDH_ANON_NULL_SHA 	103
#define SB_SUITE_ECDH_ANON_RC4_SHA 	104
#define SB_SUITE_ECDH_ANON_3DES_SHA 	105
#define SB_SUITE_ECDH_ANON_AES128_SHA 	106
#define SB_SUITE_ECDH_ANON_AES256_SHA 	107
#define SB_SUITE_PRE_TLS12_LAST 	107
#define SB_SUITE_RSA_NULL_SHA256 	108
#define SB_SUITE_RSA_AES128_SHA256 	109
#define SB_SUITE_RSA_AES256_SHA256 	110
#define SB_SUITE_DH_DSS_AES128_SHA256 	111
#define SB_SUITE_DH_RSA_AES128_SHA256 	112
#define SB_SUITE_DHE_DSS_AES128_SHA256 	113
#define SB_SUITE_DHE_RSA_AES128_SHA256 	114
#define SB_SUITE_DH_DSS_AES256_SHA256 	115
#define SB_SUITE_DH_RSA_AES256_SHA256 	116
#define SB_SUITE_DHE_DSS_AES256_SHA256 	117
#define SB_SUITE_DHE_RSA_AES256_SHA256 	118
#define SB_SUITE_DH_ANON_AES128_SHA256 	119
#define SB_SUITE_DH_ANON_AES256_SHA256 	120
#define SB_SUITE_RSA_AES128_GCM_SHA256 	121
#define SB_SUITE_RSA_AES256_GCM_SHA384 	122
#define SB_SUITE_DHE_RSA_AES128_GCM_SHA256 	123
#define SB_SUITE_DHE_RSA_AES256_GCM_SHA384 	124
#define SB_SUITE_DH_RSA_AES128_GCM_SHA256 	125
#define SB_SUITE_DH_RSA_AES256_GCM_SHA384 	126
#define SB_SUITE_DHE_DSS_AES128_GCM_SHA256 	127
#define SB_SUITE_DHE_DSS_AES256_GCM_SHA384 	128
#define SB_SUITE_DH_DSS_AES128_GCM_SHA256 	129
#define SB_SUITE_DH_DSS_AES256_GCM_SHA384 	130
#define SB_SUITE_DH_ANON_AES128_GCM_SHA256 	131
#define SB_SUITE_DH_ANON_AES256_GCM_SHA384 	132
#define SB_SUITE_ECDHE_ECDSA_AES128_SHA256 	133
#define SB_SUITE_ECDHE_ECDSA_AES256_SHA384 	134
#define SB_SUITE_ECDH_ECDSA_AES128_SHA256 	135
#define SB_SUITE_ECDH_ECDSA_AES256_SHA384 	136
#define SB_SUITE_ECDHE_RSA_AES128_SHA256 	137
#define SB_SUITE_ECDHE_RSA_AES256_SHA384 	138
#define SB_SUITE_ECDH_RSA_AES128_SHA256 	139
#define SB_SUITE_ECDH_RSA_AES256_SHA384 	140
#define SB_SUITE_ECDHE_ECDSA_AES128_GCM_SHA256 	141
#define SB_SUITE_ECDHE_ECDSA_AES256_GCM_SHA384 	142
#define SB_SUITE_ECDH_ECDSA_AES128_GCM_SHA256 	143
#define SB_SUITE_ECDH_ECDSA_AES256_GCM_SHA384 	144
#define SB_SUITE_ECDHE_RSA_AES128_GCM_SHA256 	145
#define SB_SUITE_ECDHE_RSA_AES256_GCM_SHA384 	146
#define SB_SUITE_ECDH_RSA_AES128_GCM_SHA256 	147
#define SB_SUITE_ECDH_RSA_AES256_GCM_SHA384 	148
#define SB_SUITE_PSK_AES128_GCM_SHA256 	149
#define SB_SUITE_PSK_AES256_GCM_SHA384 	150
#define SB_SUITE_DHE_PSK_AES128_GCM_SHA256 	151
#define SB_SUITE_DHE_PSK_AES256_GCM_SHA384 	152
#define SB_SUITE_RSA_PSK_AES128_GCM_SHA256 	153
#define SB_SUITE_RSA_PSK_AES256_GCM_SHA384 	154
#define SB_SUITE_PSK_AES128_SHA256 	155
#define SB_SUITE_PSK_AES256_SHA384 	156
#define SB_SUITE_PSK_NULL_SHA256 	157
#define SB_SUITE_PSK_NULL_SHA384 	158
#define SB_SUITE_DHE_PSK_AES128_SHA256 	159
#define SB_SUITE_DHE_PSK_AES256_SHA384 	160
#define SB_SUITE_DHE_PSK_NULL_SHA256 	161
#define SB_SUITE_DHE_PSK_NULL_SHA384 	162
#define SB_SUITE_RSA_PSK_AES128_SHA256 	163
#define SB_SUITE_RSA_PSK_AES256_SHA384 	164
#define SB_SUITE_RSA_PSK_NULL_SHA256 	165
#define SB_SUITE_RSA_PSK_NULL_SHA384 	166
#define SB_SUITE_RSA_CAMELLIA128_SHA256 	167
#define SB_SUITE_DH_DSS_CAMELLIA128_SHA256 	168
#define SB_SUITE_DH_RSA_CAMELLIA128_SHA256 	169
#define SB_SUITE_DHE_DSS_CAMELLIA128_SHA256 	170
#define SB_SUITE_DHE_RSA_CAMELLIA128_SHA256 	171
#define SB_SUITE_DH_ANON_CAMELLIA128_SHA256 	172
#define SB_SUITE_RSA_CAMELLIA256_SHA256 	173
#define SB_SUITE_DH_DSS_CAMELLIA256_SHA256 	174
#define SB_SUITE_DH_RSA_CAMELLIA256_SHA256 	175
#define SB_SUITE_DHE_DSS_CAMELLIA256_SHA256 	176
#define SB_SUITE_DHE_RSA_CAMELLIA256_SHA256 	177
#define SB_SUITE_DH_ANON_CAMELLIA256_SHA256 	178
#define SB_SUITE_ECDHE_ECDSA_CAMELLIA128_SHA256 	179
#define SB_SUITE_ECDHE_ECDSA_CAMELLIA256_SHA384 	180
#define SB_SUITE_ECDH_ECDSA_CAMELLIA128_SHA256 	181
#define SB_SUITE_ECDH_ECDSA_CAMELLIA256_SHA384 	182
#define SB_SUITE_ECDHE_RSA_CAMELLIA128_SHA256 	183
#define SB_SUITE_ECDHE_RSA_CAMELLIA256_SHA384 	184
#define SB_SUITE_ECDH_RSA_CAMELLIA128_SHA256 	185
#define SB_SUITE_ECDH_RSA_CAMELLIA256_SHA384 	186
#define SB_SUITE_RSA_CAMELLIA128_GCM_SHA256 	187
#define SB_SUITE_RSA_CAMELLIA256_GCM_SHA384 	188
#define SB_SUITE_DHE_RSA_CAMELLIA128_GCM_SHA256 	189
#define SB_SUITE_DHE_RSA_CAMELLIA256_GCM_SHA384 	190
#define SB_SUITE_DH_RSA_CAMELLIA128_GCM_SHA256 	191
#define SB_SUITE_DH_RSA_CAMELLIA256_GCM_SHA384 	192
#define SB_SUITE_DHE_DSS_CAMELLIA128_GCM_SHA256 	193
#define SB_SUITE_DHE_DSS_CAMELLIA256_GCM_SHA384 	194
#define SB_SUITE_DH_DSS_CAMELLIA128_GCM_SHA256 	195
#define SB_SUITE_DH_DSS_CAMELLIA256_GCM_SHA384 	196
#define SB_SUITE_DH_anon_CAMELLIA128_GCM_SHA256 	197
#define SB_SUITE_DH_anon_CAMELLIA256_GCM_SHA384 	198
#define SB_SUITE_ECDHE_ECDSA_CAMELLIA128_GCM_SHA256 	199
#define SB_SUITE_ECDHE_ECDSA_CAMELLIA256_GCM_SHA384 	200
#define SB_SUITE_ECDH_ECDSA_CAMELLIA128_GCM_SHA256 	201
#define SB_SUITE_ECDH_ECDSA_CAMELLIA256_GCM_SHA384 	202
#define SB_SUITE_ECDHE_RSA_CAMELLIA128_GCM_SHA256 	203
#define SB_SUITE_ECDHE_RSA_CAMELLIA256_GCM_SHA384 	204
#define SB_SUITE_ECDH_RSA_CAMELLIA128_GCM_SHA256 	205
#define SB_SUITE_ECDH_RSA_CAMELLIA256_GCM_SHA384 	206
#define SB_SUITE_PSK_CAMELLIA128_GCM_SHA256 	207
#define SB_SUITE_PSK_CAMELLIA256_GCM_SHA384 	208
#define SB_SUITE_DHE_PSK_CAMELLIA128_GCM_SHA256 	209
#define SB_SUITE_DHE_PSK_CAMELLIA256_GCM_SHA384 	210
#define SB_SUITE_RSA_PSK_CAMELLIA128_GCM_SHA256 	211
#define SB_SUITE_RSA_PSK_CAMELLIA256_GCM_SHA384 	212
#define SB_SUITE_PSK_CAMELLIA128_SHA256 	213
#define SB_SUITE_PSK_CAMELLIA256_SHA384 	214
#define SB_SUITE_DHE_PSK_CAMELLIA128_SHA256 	215
#define SB_SUITE_DHE_PSK_CAMELLIA256_SHA384 	216
#define SB_SUITE_RSA_PSK_CAMELLIA128_SHA256 	217
#define SB_SUITE_RSA_PSK_CAMELLIA256_SHA384 	218
#define SB_SUITE_ECDHE_PSK_CAMELLIA128_SHA256 	219
#define SB_SUITE_ECDHE_PSK_CAMELLIA256_SHA384 	220
#define SB_SUITE_ECDHE_PSK_RC4_SHA 	221
#define SB_SUITE_ECDHE_PSK_3DES_SHA 	222
#define SB_SUITE_ECDHE_PSK_AES128_SHA 	223
#define SB_SUITE_ECDHE_PSK_AES256_SHA 	224
#define SB_SUITE_ECDHE_PSK_AES128_SHA256 	225
#define SB_SUITE_ECDHE_PSK_AES256_SHA384 	226
#define SB_SUITE_ECDHE_PSK_NULL_SHA 	227
#define SB_SUITE_ECDHE_PSK_NULL_SHA256 	228
#define SB_SUITE_ECDHE_PSK_NULL_SHA384 	229
#define SB_SUITE_ECDHE_RSA_CHACHA20_POLY1305_SHA256 	230
#define SB_SUITE_ECDHE_ECDSA_CHACHA20_POLY1305_SHA256 	231
#define SB_SUITE_DHE_RSA_CHACHA20_POLY1305_SHA256 	232
#define SB_SUITE_LAST 	232
#define SB_SUITE_UNKNOWN 	-1
#define SB_SUITE_SECURITY_LEVEL_INSECURE 	1
#define SB_SUITE_SECURITY_LEVEL_LOW 	2
#define SB_SUITE_SECURITY_LEVEL_ACCEPTABLE 	3
#define SB_SUITE_SECURITY_LEVEL_NORMAL 	4
#define SB_SUITE_SECURITY_LEVEL_HIGH 	5
#define SB_SUITE_SECURITY_LEVEL_HIGHEST 	6
#define SB_SSL_CA_FIRST 	0
#define SB_SSL_CA_NONE 	0
#define SB_SSL_CA_ZLIB 	1
#define SB_SSL_CA_LAST 	1
#define SB_SSL_EXT_SERVER_NAME 	0
#define SB_SSL_EXT_MAX_FRAGMENT_LENGTH 	1
#define SB_SSL_EXT_CLIENT_CERT_URL 	2
#define SB_SSL_EXT_TRUSTED_CA_KEYS 	3
#define SB_SSL_EXT_TRUNCATED_HMAC 	4
#define SB_SSL_EXT_STATUS_REQUEST 	5
#define SB_SSL_EXT_USER_NAME 	6
#define SB_SSL_EXT_CERTIFICATE_TYPE 	9
#define SB_SSL_EXT_EC_CURVES 	10
#define SB_SSL_EXT_EC_POINTS_FORMAT 	11
#define SB_SSL_EXT_SRP 	12
#define SB_SSL_EXT_SESSION_TICKET 	35
#define SB_SSL_EXT_CERT_HASH_TYPES 	1000
#define SB_SSL_EXT_RENEGOTIATION_INFO 	65281
#define SB_SSL_EXT_HEARTBEAT_HELLO 	15
#define SB_SSL_EXT_SIGNATURE_ALGORITHMS 	13
#define SB_SSL_EXT_STATUS_REQUEST_V2 	17
#define SB_SSL_EXT_CLIENT_CERTIFICATE_TYPE 	19
#define SB_SSL_EXT_SERVER_CERTIFICATE_TYPE 	20
#define SB_SSL_EXT_EXTENDED_MASTER_SECRET 	23
#define SB_HEARTBEAT_MODE_PEER_ALLOWED_TO_SEND 	1
#define SB_HEARTBEAT_MODE_PEER_NOT_ALLOWED_TO_SEND 	2
#define SB_HEARTBEAT_REQUEST 	1
#define SB_HEARTBEAT_RESPONSE 	2
#define SB_EC_TLS_NAMED_CURVE_FIRST 	1
#define SB_EC_TLS_SECT163K1 	1
#define SB_EC_TLS_SECT163R1 	2
#define SB_EC_TLS_SECT163R2 	3
#define SB_EC_TLS_SECT193R1 	4
#define SB_EC_TLS_SECT193R2 	5
#define SB_EC_TLS_SECT233K1 	6
#define SB_EC_TLS_SECT233R1 	7
#define SB_EC_TLS_SECT239K1 	8
#define SB_EC_TLS_SECT283K1 	9
#define SB_EC_TLS_SECT283R1 	10
#define SB_EC_TLS_SECT409K1 	11
#define SB_EC_TLS_SECT409R1 	12
#define SB_EC_TLS_SECT571K1 	13
#define SB_EC_TLS_SECT571R1 	14
#define SB_EC_TLS_SECP160K1 	15
#define SB_EC_TLS_SECP160R1 	16
#define SB_EC_TLS_SECP160R2 	17
#define SB_EC_TLS_SECP192K1 	18
#define SB_EC_TLS_SECP192R1 	19
#define SB_EC_TLS_SECP224K1 	20
#define SB_EC_TLS_SECP224R1 	21
#define SB_EC_TLS_SECP256K1 	22
#define SB_EC_TLS_SECP256R1 	23
#define SB_EC_TLS_SECP384R1 	24
#define SB_EC_TLS_SECP521R1 	25
#define SB_EC_TLS_BRAINPOOLP256R1 	26
#define SB_EC_TLS_BRAINPOOLP384R1 	27
#define SB_EC_TLS_BRAINPOOLP512R1 	28
#define SB_EC_TLS_NAMED_CURVE_LAST 	28
#define SB_EC_TLS_ARBITRARY_EXPLICIT_PRIME_CURVES 	65281
#define SB_EC_TLS_ARBITRARY_EXPLICIT_CHAR2_CURVES 	65282
#define SB_EC_TLS_POINT_FORMAT_FIRST 	0
#define SB_EC_TLS_POINT_UNCOMPRESSED 	0
#define SB_EC_TLS_POINT_COMPRESSED_PRIME 	1
#define SB_EC_TLS_POINT_COMPRESSED_CHAR2 	2
#define SB_EC_TLS_POINT_FORMAT_LAST 	2
#define SB_SLayer2ProtocolError 	"The data doesn\'t match SSL2 protocol standard"
#define SB_SUnknownCipherSuite 	"Unknown SSL/TLS cipher suite code [%s]"
#define SB_SUnknownMessage 	"Unknown SSL/TLS message [%s]"
#define SB_SServerVerifyFailed 	"Server verification failed"
#define SB_SUnknownError 	"Unknown error"
#define SB_SNoCipher 	"No cipher"
#define SB_SNoCertificate 	"No certificate"
#define SB_SBadCertificate 	"Bad certificate"
#define SB_SUnsupportedCertificate 	"Unsupported certificate type"
#define SB_SHandshakeFailure 	"Handshake failed"
#define SB_SInvalidMAC 	"Invalid MAC"
#define SB_SInvalidClientCertificate 	"Invalid client certificate or private key"
#define SB_SDecryptError 	"Decryption error"
#define SB_SSL_CLNT 	"CLNT"
#define SB_SSL_SRVR 	"SRVR"
#define SB_SSL_MASTER_SECRET 	"master secret"
#define SB_SSL_EXTENDED_MASTER_SECRET 	"extended master secret"
#define SB_SSL_KEY_EXPANSION 	"key expansion"
#define SB_SSL_CLIENT_WRITE_KEY 	"client write key"
#define SB_SSL_SERVER_WRITE_KEY 	"server write key"
#define SB_SSL_IV_BLOCK 	"IV block"
#define SB_SSL_CLIENT_FINISHED 	"client finished"
#define SB_SSL_SERVER_FINISHED 	"server finished"

typedef uint8_t TSBVersionRaw;

typedef enum
{
	sbSSL2 = 0,
	sbSSL3 = 1,
	sbTLS1 = 2,
	sbTLS11 = 3,
	sbTLS12 = 4
} TSBVersion;

typedef uint32_t TSBVersionsRaw;

typedef enum 
{
	f_sbSSL2 = 1,
	f_sbSSL3 = 2,
	f_sbTLS1 = 4,
	f_sbTLS11 = 8,
	f_sbTLS12 = 16
} TSBVersions;

#pragma pack(4)
typedef struct 
{
	uint8_t Major;
	uint8_t Minor;
} TSSLVersion;

typedef uint8_t TSBCertificateTypeExtensionRaw;

typedef enum
{
	cteAuto = 0,
	cteOld = 1,
	cteNew = 2
} TSBCertificateTypeExtension;

typedef uint8_t TElSSLCertificateTypeRaw;

typedef enum
{
	_ctX509 = 0,
	ctPGP = 1,
	ctRawKey = 2
} TElSSLCertificateType;

typedef uint8_t TElOpenPGPCertDescriptorTypeRaw;

typedef enum
{
	ctPGP_Cert_Fingerprint = 0,
	ctPGP_Cert = 1
} TElOpenPGPCertDescriptorType;

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TSSLVersion_ce_ptr;

void Register_TSSLVersion(TSRMLS_D);
void Register_SBSSLConstants_Constants(int module_number TSRMLS_DC);
void Register_SBSSLConstants_Enum_Flags(TSRMLS_D);

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBSSLCONSTANTS */

