#ifndef __INC_SBXMLSAMLMETADATA
#define __INC_SBXMLSAMLMETADATA

#if _MSC_VER > 1000
#  pragma once
#endif // _MSC_VER > 1000

#include "sbdefs.h"
#include "sbphpcore.h"
#include "sbsystem.h"
#include "sbcertvalidator.h"
#include "sbcustomcertstorage.h"
#include "sbx509.h"
#include "sbsharedresource.h"
#include "sbxmlcore.h"
#include "sbxmlsig.h"
#include "sbxmlenc.h"
#include "sbxmlsec.h"
#include "sbxmlutils.h"
#include "sbxmldefs.h"
#include "sbxmltransform.h"
#include "sbxmlcharsets.h"
#include "sbstreams.h"
#include "sbstrutils.h"
#include "sbrandom.h"
#include "sbutils.h"
#include "sbtypes.h"
#include "sbxmlsamlcore.h"
#include "sbxmlsamlbind.h"

#pragma pack(push, 1)

#ifdef __cplusplus
namespace SecureBlackbox {
#endif

#ifdef __cplusplus
extern "C" {
#endif
typedef TElClassHandle TElSAMLEntityDescriptorElementHandle;

typedef TElClassHandle TElSAMLLocalizedNameTypeHandle;

typedef TElClassHandle TElSAMLLocalizedURITypeHandle;

typedef TElClassHandle TElSAMLEndpointTypeHandle;

typedef TElClassHandle TElSAMLIndexedEndpointTypeHandle;

typedef TElClassHandle TElSAMLMetadataRootElementHandle;

typedef TElClassHandle TElSAMLEntitiesDescriptorElementHandle;

typedef TElClassHandle TElSAMLKeyDescriptorElementHandle;

typedef TElClassHandle TElSAMLOrganizationElementHandle;

typedef TElClassHandle TElSAMLContactPersonElementHandle;

typedef TElClassHandle TElSAMLRoleDescriptorElementHandle;

typedef TElClassHandle TElSAMLAuthnQueryServiceElementHandle;

typedef TElClassHandle TElSAMLAssertionIDRequestServiceElementHandle;

typedef TElClassHandle TElSAMLAuthnAuthorityDescriptorElementHandle;

typedef TElClassHandle TElSAMLAttributeServiceElementHandle;

typedef TElClassHandle TElSAMLAttributeAuthorityDescriptorElementHandle;

typedef TElClassHandle TElSAMLAuthzServiceElementHandle;

typedef TElClassHandle TElSAMLPDPDescriptorElementHandle;

typedef TElClassHandle TElSAMLAffiliationDescriptorElementHandle;

typedef TElClassHandle TElSAMLOrganizationNameElementHandle;

typedef TElClassHandle TElSAMLOrganizationDisplayNameElementHandle;

typedef TElClassHandle TElSAMLOrganizationURLElementHandle;

typedef TElClassHandle TElSAMLAdditionalMetadataLocationElementHandle;

typedef TElClassHandle TElSAMLArtifactResolutionServiceElementHandle;

typedef TElClassHandle TElSAMLSingleLogoutServiceElementHandle;

typedef TElClassHandle TElSAMLManageNameIDServiceElementHandle;

typedef TElClassHandle TElSAMLSingleSignOnServiceElementHandle;

typedef TElClassHandle TElSAMLNameIDMappingServiceElementHandle;

typedef TElClassHandle TElSAMLSSODescriptorTypeHandle;

typedef TElClassHandle TElSAMLIDPSSODescriptorElementHandle;

typedef TElClassHandle TElSAMLAssertionConsumerServiceElementHandle;

typedef TElClassHandle TElSAMLRequestedAttributeElementHandle;

typedef TElClassHandle TElSAMLServiceNameElementHandle;

typedef TElClassHandle TElSAMLServiceDescriptionElementHandle;

typedef TElClassHandle TElSAMLAttributeConsumingServiceElementHandle;

typedef TElClassHandle TElSAMLSPSSODescriptorElementHandle;

typedef TElClassHandle TElSAMLEncryptionMethodTypeHandle;

typedef TElClassHandle TElSAMLMetadataHandle;

typedef TElClassHandle TElSAMLEndpointHandle;

typedef void (SB_CALLBACK *TSBSAMLChooseMetadataDescriptorEvent)(void * _ObjectData, TObjectHandle Sender, TElSAMLEntityDescriptorElementHandle Descriptor, int8_t * Stop);

typedef uint8_t TSBSAMLMetaRootElementTypeRaw;

typedef enum
{
	mretUnknown = 0,
	mretSingleEntity = 1,
	mretMultipleEntities = 2
} TSBSAMLMetaRootElementType;

typedef uint8_t TSBSAMLKeyUseRaw;

typedef enum
{
	skuNone = 0,
	skuEncryption = 1,
	skuSigning = 2
} TSBSAMLKeyUse;

typedef uint8_t TSBSAMLContactTypeRaw;

typedef enum
{
	sctTechnical = 0,
	sctSupport = 1,
	sctAdministrative = 2,
	sctBilling = 3,
	sctOther = 4
} TSBSAMLContactType;

#ifdef SB_USE_CLASS_TELSAMLMETADATAROOTELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadataRootElement_DetectType(TElXMLDOMElementHandle Element, TSBSAMLMetaRootElementTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadataRootElement_DetectType_1(TElSAMLMetadataRootElementHandle _Handle, TElXMLDOMElementHandle Element, TSBSAMLMetaRootElementTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadataRootElement_Create(TElXMLCustomElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLMETADATAROOTELEMENT */

#ifdef SB_USE_CLASS_TELSAMLLOCALIZEDNAMETYPE
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedNameType_Clear(TElSAMLLocalizedNameTypeHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedNameType_LoadFromXML(TElSAMLLocalizedNameTypeHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedNameType_SaveToXML(TElSAMLLocalizedNameTypeHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedNameType_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedNameType_get_Lang(TElSAMLLocalizedNameTypeHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedNameType_set_Lang(TElSAMLLocalizedNameTypeHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedNameType_Create(TElSAMLLocalizedNameTypeHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLLOCALIZEDNAMETYPE */

#ifdef SB_USE_CLASS_TELSAMLLOCALIZEDURITYPE
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedURIType_Clear(TElSAMLLocalizedURITypeHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedURIType_LoadFromXML(TElSAMLLocalizedURITypeHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedURIType_SaveToXML(TElSAMLLocalizedURITypeHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedURIType_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedURIType_get_Lang(TElSAMLLocalizedURITypeHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedURIType_set_Lang(TElSAMLLocalizedURITypeHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLLocalizedURIType_Create(TElSAMLLocalizedURITypeHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLLOCALIZEDURITYPE */

#ifdef SB_USE_CLASS_TELSAMLENDPOINTTYPE
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpointType_Clear(TElSAMLEndpointTypeHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpointType_LoadFromXML(TElSAMLEndpointTypeHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpointType_SaveToXML(TElSAMLEndpointTypeHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpointType_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpointType_get_Binding(TElSAMLEndpointTypeHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpointType_set_Binding(TElSAMLEndpointTypeHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpointType_get_Location(TElSAMLEndpointTypeHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpointType_set_Location(TElSAMLEndpointTypeHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpointType_get_ResponseLocation(TElSAMLEndpointTypeHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpointType_set_ResponseLocation(TElSAMLEndpointTypeHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpointType_Create(TElSAMLEndpointTypeHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLENDPOINTTYPE */

#ifdef SB_USE_CLASS_TELSAMLINDEXEDENDPOINTTYPE
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIndexedEndpointType_Clear(TElSAMLIndexedEndpointTypeHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIndexedEndpointType_LoadFromXML(TElSAMLIndexedEndpointTypeHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIndexedEndpointType_SaveToXML(TElSAMLIndexedEndpointTypeHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIndexedEndpointType_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIndexedEndpointType_get__Index(TElSAMLIndexedEndpointTypeHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIndexedEndpointType_set__Index(TElSAMLIndexedEndpointTypeHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIndexedEndpointType_get_IsDefault(TElSAMLIndexedEndpointTypeHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIndexedEndpointType_set_IsDefault(TElSAMLIndexedEndpointTypeHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIndexedEndpointType_get_UseDefault(TElSAMLIndexedEndpointTypeHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIndexedEndpointType_set_UseDefault(TElSAMLIndexedEndpointTypeHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIndexedEndpointType_Create(TElSAMLIndexedEndpointTypeHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLINDEXEDENDPOINTTYPE */

#ifdef SB_USE_CLASS_TELSAMLENTITYDESCRIPTORELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_Clear(TElSAMLEntityDescriptorElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_LoadFromXML(TElSAMLEntityDescriptorElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_SaveToXML(TElSAMLEntityDescriptorElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_get_Signed(TElSAMLEntityDescriptorElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_set_Signed(TElSAMLEntityDescriptorElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_get_ID(TElSAMLEntityDescriptorElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_set_ID(TElSAMLEntityDescriptorElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_get_ValidUntil(TElSAMLEntityDescriptorElementHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_set_ValidUntil(TElSAMLEntityDescriptorElementHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_get_CacheDuration(TElSAMLEntityDescriptorElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_set_CacheDuration(TElSAMLEntityDescriptorElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_get_Signature(TElSAMLEntityDescriptorElementHandle _Handle, TElXMLSignatureHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_get_Extensions(TElSAMLEntityDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_get_EntityID(TElSAMLEntityDescriptorElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_set_EntityID(TElSAMLEntityDescriptorElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_get_AffiliationDescriptor(TElSAMLEntityDescriptorElementHandle _Handle, TElSAMLAffiliationDescriptorElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_set_AffiliationDescriptor(TElSAMLEntityDescriptorElementHandle _Handle, TElSAMLAffiliationDescriptorElementHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_get_Descriptors(TElSAMLEntityDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_get_Organization(TElSAMLEntityDescriptorElementHandle _Handle, TElSAMLOrganizationElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_set_Organization(TElSAMLEntityDescriptorElementHandle _Handle, TElSAMLOrganizationElementHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_get_ContactPersons(TElSAMLEntityDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_get_AdditionalMetadataLocations(TElSAMLEntityDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntityDescriptorElement_Create(TElSAMLEntityDescriptorElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLENTITYDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLENTITIESDESCRIPTORELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_Clear(TElSAMLEntitiesDescriptorElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_LoadFromXML(TElSAMLEntitiesDescriptorElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_SaveToXML(TElSAMLEntitiesDescriptorElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_get_Signed(TElSAMLEntitiesDescriptorElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_set_Signed(TElSAMLEntitiesDescriptorElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_get_ID(TElSAMLEntitiesDescriptorElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_set_ID(TElSAMLEntitiesDescriptorElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_get_ValidUntil(TElSAMLEntitiesDescriptorElementHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_set_ValidUntil(TElSAMLEntitiesDescriptorElementHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_get_CacheDuration(TElSAMLEntitiesDescriptorElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_set_CacheDuration(TElSAMLEntitiesDescriptorElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_get_Signature(TElSAMLEntitiesDescriptorElementHandle _Handle, TElXMLSignatureHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_get_Extensions(TElSAMLEntitiesDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_get_Name(TElSAMLEntitiesDescriptorElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_set_Name(TElSAMLEntitiesDescriptorElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_get_Entities(TElSAMLEntitiesDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEntitiesDescriptorElement_Create(TElSAMLEntitiesDescriptorElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLENTITIESDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLKEYDESCRIPTORELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLKeyDescriptorElement_Clear(TElSAMLKeyDescriptorElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLKeyDescriptorElement_LoadFromXML(TElSAMLKeyDescriptorElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLKeyDescriptorElement_SaveToXML(TElSAMLKeyDescriptorElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLKeyDescriptorElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLKeyDescriptorElement_Init(TElSAMLKeyDescriptorElementHandle _Handle, TElX509CertificateHandle Cert);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLKeyDescriptorElement_get_Use(TElSAMLKeyDescriptorElementHandle _Handle, TSBSAMLKeyUseRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLKeyDescriptorElement_set_Use(TElSAMLKeyDescriptorElementHandle _Handle, TSBSAMLKeyUseRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLKeyDescriptorElement_get_KeyInfo(TElSAMLKeyDescriptorElementHandle _Handle, TElXMLKeyInfoHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLKeyDescriptorElement_set_KeyInfo(TElSAMLKeyDescriptorElementHandle _Handle, TElXMLKeyInfoHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLKeyDescriptorElement_get_EncryptionMethods(TElSAMLKeyDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLKeyDescriptorElement_set_EncryptionMethods(TElSAMLKeyDescriptorElementHandle _Handle, TListHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLKeyDescriptorElement_Create(TElSAMLKeyDescriptorElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLKEYDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLORGANIZATIONELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLOrganizationElement_Clear(TElSAMLOrganizationElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLOrganizationElement_LoadFromXML(TElSAMLOrganizationElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLOrganizationElement_SaveToXML(TElSAMLOrganizationElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLOrganizationElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLOrganizationElement_get_Extensions(TElSAMLOrganizationElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLOrganizationElement_get_OrganizationNames(TElSAMLOrganizationElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLOrganizationElement_get_OrganizationDisplayNames(TElSAMLOrganizationElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLOrganizationElement_get_OrganizationURLs(TElSAMLOrganizationElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLOrganizationElement_Create(TElSAMLOrganizationElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLORGANIZATIONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLCONTACTPERSONELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_Clear(TElSAMLContactPersonElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_LoadFromXML(TElSAMLContactPersonElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_SaveToXML(TElSAMLContactPersonElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_get_ContactType(TElSAMLContactPersonElementHandle _Handle, TSBSAMLContactTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_set_ContactType(TElSAMLContactPersonElementHandle _Handle, TSBSAMLContactTypeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_get_Extensions(TElSAMLContactPersonElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_get_Company(TElSAMLContactPersonElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_set_Company(TElSAMLContactPersonElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_get_GivenName(TElSAMLContactPersonElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_set_GivenName(TElSAMLContactPersonElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_get_SurName(TElSAMLContactPersonElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_set_SurName(TElSAMLContactPersonElementHandle _Handle, const char * pcValue, int32_t szValue);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_get_EmailAddresses(TElSAMLContactPersonElementHandle _Handle, TStringListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_get_TelephoneNumbers(TElSAMLContactPersonElementHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_get_EmailAddresses(TElSAMLContactPersonElementHandle _Handle, TElStringListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_get_TelephoneNumbers(TElSAMLContactPersonElementHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElSAMLContactPersonElement_Create(TElSAMLContactPersonElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLCONTACTPERSONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLROLEDESCRIPTORELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_Clear(TElSAMLRoleDescriptorElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_LoadFromXML(TElSAMLRoleDescriptorElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_SaveToXML(TElSAMLRoleDescriptorElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_get_Signed(TElSAMLRoleDescriptorElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_set_Signed(TElSAMLRoleDescriptorElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_get_ID(TElSAMLRoleDescriptorElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_set_ID(TElSAMLRoleDescriptorElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_get_ValidUntil(TElSAMLRoleDescriptorElementHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_set_ValidUntil(TElSAMLRoleDescriptorElementHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_get_CacheDuration(TElSAMLRoleDescriptorElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_set_CacheDuration(TElSAMLRoleDescriptorElementHandle _Handle, const char * pcValue, int32_t szValue);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_get_ProtocolSupportEnumeration(TElSAMLRoleDescriptorElementHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_get_ProtocolSupportEnumeration(TElSAMLRoleDescriptorElementHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_get_ErrorURL(TElSAMLRoleDescriptorElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_set_ErrorURL(TElSAMLRoleDescriptorElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_get_Signature(TElSAMLRoleDescriptorElementHandle _Handle, TElXMLSignatureHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_get_Extensions(TElSAMLRoleDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_get_KeyDescriptors(TElSAMLRoleDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_get_Organization(TElSAMLRoleDescriptorElementHandle _Handle, TElSAMLOrganizationElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_set_Organization(TElSAMLRoleDescriptorElementHandle _Handle, TElSAMLOrganizationElementHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_get_ContactPersons(TElSAMLRoleDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRoleDescriptorElement_Create(TElSAMLRoleDescriptorElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLROLEDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUTHNQUERYSERVICEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAuthnQueryServiceElement_Create(TElSAMLAuthnQueryServiceElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLAUTHNQUERYSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLASSERTIONIDREQUESTSERVICEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAssertionIDRequestServiceElement_Create(TElSAMLAssertionIDRequestServiceElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLASSERTIONIDREQUESTSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUTHNAUTHORITYDESCRIPTORELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAuthnAuthorityDescriptorElement_Clear(TElSAMLAuthnAuthorityDescriptorElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAuthnAuthorityDescriptorElement_LoadFromXML(TElSAMLAuthnAuthorityDescriptorElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAuthnAuthorityDescriptorElement_SaveToXML(TElSAMLAuthnAuthorityDescriptorElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAuthnAuthorityDescriptorElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAuthnAuthorityDescriptorElement_get_AuthnQueryServices(TElSAMLAuthnAuthorityDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAuthnAuthorityDescriptorElement_get_AssertionIDRequestServices(TElSAMLAuthnAuthorityDescriptorElementHandle _Handle, TListHandle * OutResult);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAuthnAuthorityDescriptorElement_get_NameIDFormats(TElSAMLAuthnAuthorityDescriptorElementHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAuthnAuthorityDescriptorElement_get_NameIDFormats(TElSAMLAuthnAuthorityDescriptorElementHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAuthnAuthorityDescriptorElement_Create(TElSAMLAuthnAuthorityDescriptorElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLAUTHNAUTHORITYDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLATTRIBUTESERVICEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeServiceElement_Create(TElSAMLAttributeServiceElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLATTRIBUTESERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLATTRIBUTEAUTHORITYDESCRIPTORELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeAuthorityDescriptorElement_Clear(TElSAMLAttributeAuthorityDescriptorElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeAuthorityDescriptorElement_LoadFromXML(TElSAMLAttributeAuthorityDescriptorElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeAuthorityDescriptorElement_SaveToXML(TElSAMLAttributeAuthorityDescriptorElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeAuthorityDescriptorElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeAuthorityDescriptorElement_get_AttributeServices(TElSAMLAttributeAuthorityDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeAuthorityDescriptorElement_get_AssertionIDRequestServices(TElSAMLAttributeAuthorityDescriptorElementHandle _Handle, TListHandle * OutResult);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeAuthorityDescriptorElement_get_NameIDFormats(TElSAMLAttributeAuthorityDescriptorElementHandle _Handle, TStringListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeAuthorityDescriptorElement_get_AttributeProfiles(TElSAMLAttributeAuthorityDescriptorElementHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeAuthorityDescriptorElement_get_NameIDFormats(TElSAMLAttributeAuthorityDescriptorElementHandle _Handle, TElStringListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeAuthorityDescriptorElement_get_AttributeProfiles(TElSAMLAttributeAuthorityDescriptorElementHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeAuthorityDescriptorElement_get_Attributes(TElSAMLAttributeAuthorityDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeAuthorityDescriptorElement_Create(TElSAMLAttributeAuthorityDescriptorElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLATTRIBUTEAUTHORITYDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAUTHZSERVICEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAuthzServiceElement_Create(TElSAMLEndpointTypeHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLAUTHZSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLPDPDESCRIPTORELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLPDPDescriptorElement_Clear(TElSAMLPDPDescriptorElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLPDPDescriptorElement_LoadFromXML(TElSAMLPDPDescriptorElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLPDPDescriptorElement_SaveToXML(TElSAMLPDPDescriptorElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLPDPDescriptorElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLPDPDescriptorElement_get_AuthzServices(TElSAMLPDPDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLPDPDescriptorElement_get_AssertionIDRequestServices(TElSAMLPDPDescriptorElementHandle _Handle, TListHandle * OutResult);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElSAMLPDPDescriptorElement_get_NameIDFormats(TElSAMLPDPDescriptorElementHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElSAMLPDPDescriptorElement_get_NameIDFormats(TElSAMLPDPDescriptorElementHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElSAMLPDPDescriptorElement_Create(TElSAMLPDPDescriptorElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLPDPDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLAFFILIATIONDESCRIPTORELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_Clear(TElSAMLAffiliationDescriptorElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_LoadFromXML(TElSAMLAffiliationDescriptorElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_SaveToXML(TElSAMLAffiliationDescriptorElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_get_Signed(TElSAMLAffiliationDescriptorElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_set_Signed(TElSAMLAffiliationDescriptorElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_get_AffiliationOwnerID(TElSAMLAffiliationDescriptorElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_set_AffiliationOwnerID(TElSAMLAffiliationDescriptorElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_get_ID(TElSAMLAffiliationDescriptorElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_set_ID(TElSAMLAffiliationDescriptorElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_get_ValidUntil(TElSAMLAffiliationDescriptorElementHandle _Handle, int64_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_set_ValidUntil(TElSAMLAffiliationDescriptorElementHandle _Handle, int64_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_get_CacheDuration(TElSAMLAffiliationDescriptorElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_set_CacheDuration(TElSAMLAffiliationDescriptorElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_get_Signature(TElSAMLAffiliationDescriptorElementHandle _Handle, TElXMLSignatureHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_get_Extensions(TElSAMLAffiliationDescriptorElementHandle _Handle, TListHandle * OutResult);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_get_AffiliateMembers(TElSAMLAffiliationDescriptorElementHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_get_AffiliateMembers(TElSAMLAffiliationDescriptorElementHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_get_KeyDescriptors(TElSAMLAffiliationDescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAffiliationDescriptorElement_Create(TElSAMLAffiliationDescriptorElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLAFFILIATIONDESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLORGANIZATIONNAMEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLOrganizationNameElement_Create(TElSAMLOrganizationNameElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLORGANIZATIONNAMEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLORGANIZATIONDISPLAYNAMEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLOrganizationDisplayNameElement_Create(TElSAMLOrganizationDisplayNameElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLORGANIZATIONDISPLAYNAMEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLORGANIZATIONURLELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLOrganizationURLElement_Create(TElSAMLOrganizationURLElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLORGANIZATIONURLELEMENT */

#ifdef SB_USE_CLASS_TELSAMLADDITIONALMETADATALOCATIONELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAdditionalMetadataLocationElement_Clear(TElSAMLAdditionalMetadataLocationElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAdditionalMetadataLocationElement_LoadFromXML(TElSAMLAdditionalMetadataLocationElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAdditionalMetadataLocationElement_SaveToXML(TElSAMLAdditionalMetadataLocationElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAdditionalMetadataLocationElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAdditionalMetadataLocationElement_get__Namespace(TElSAMLAdditionalMetadataLocationElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAdditionalMetadataLocationElement_set__Namespace(TElSAMLAdditionalMetadataLocationElementHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAdditionalMetadataLocationElement_get_URI(TElSAMLAdditionalMetadataLocationElementHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAdditionalMetadataLocationElement_Create(TElSAMLAdditionalMetadataLocationElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLADDITIONALMETADATALOCATIONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLARTIFACTRESOLUTIONSERVICEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLArtifactResolutionServiceElement_Create(TElSAMLArtifactResolutionServiceElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLARTIFACTRESOLUTIONSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSINGLELOGOUTSERVICEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSingleLogoutServiceElement_Create(TElSAMLSingleLogoutServiceElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLSINGLELOGOUTSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLMANAGENAMEIDSERVICEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLManageNameIDServiceElement_Create(TElSAMLManageNameIDServiceElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLMANAGENAMEIDSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSINGLESIGNONSERVICEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSingleSignOnServiceElement_Create(TElSAMLSingleSignOnServiceElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLSINGLESIGNONSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLNAMEIDMAPPINGSERVICEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLNameIDMappingServiceElement_Create(TElSAMLNameIDMappingServiceElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLNAMEIDMAPPINGSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSSODESCRIPTORTYPE
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSSODescriptorType_Clear(TElSAMLSSODescriptorTypeHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSSODescriptorType_LoadFromXML(TElSAMLSSODescriptorTypeHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSSODescriptorType_SaveToXML(TElSAMLSSODescriptorTypeHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSSODescriptorType_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSSODescriptorType_get_ArtifactResolutionServices(TElSAMLSSODescriptorTypeHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSSODescriptorType_get_SingleLogoutServices(TElSAMLSSODescriptorTypeHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSSODescriptorType_get_ManageNameIDService(TElSAMLSSODescriptorTypeHandle _Handle, TListHandle * OutResult);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSSODescriptorType_get_NameIDFormats(TElSAMLSSODescriptorTypeHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSSODescriptorType_get_NameIDFormats(TElSAMLSSODescriptorTypeHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSSODescriptorType_get_AutoAssignIndexes(TElSAMLSSODescriptorTypeHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSSODescriptorType_set_AutoAssignIndexes(TElSAMLSSODescriptorTypeHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSSODescriptorType_Create(TElSAMLSSODescriptorTypeHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLSSODESCRIPTORTYPE */

#ifdef SB_USE_CLASS_TELSAMLIDPSSODESCRIPTORELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_Clear(TElSAMLIDPSSODescriptorElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_LoadFromXML(TElSAMLIDPSSODescriptorElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_SaveToXML(TElSAMLIDPSSODescriptorElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_get_WantAuthnRequestsSigned(TElSAMLIDPSSODescriptorElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_set_WantAuthnRequestsSigned(TElSAMLIDPSSODescriptorElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_get_UseWantAuthnRequestsSigned(TElSAMLIDPSSODescriptorElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_set_UseWantAuthnRequestsSigned(TElSAMLIDPSSODescriptorElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_get_SingleSignOnServices(TElSAMLIDPSSODescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_get_NameIDMappingServices(TElSAMLIDPSSODescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_get_AssertionIDRequestServices(TElSAMLIDPSSODescriptorElementHandle _Handle, TListHandle * OutResult);
#ifdef SB_WINDOWS
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_get_AttributeProfiles(TElSAMLIDPSSODescriptorElementHandle _Handle, TStringListHandle * OutResult);
#else
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_get_AttributeProfiles(TElSAMLIDPSSODescriptorElementHandle _Handle, TElStringListHandle * OutResult);
#endif
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_get_Attributes(TElSAMLIDPSSODescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLIDPSSODescriptorElement_Create(TElSAMLIDPSSODescriptorElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLIDPSSODESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLASSERTIONCONSUMERSERVICEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAssertionConsumerServiceElement_Create(TElSAMLAssertionConsumerServiceElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLASSERTIONCONSUMERSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLREQUESTEDATTRIBUTEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRequestedAttributeElement_Clear(TElSAMLRequestedAttributeElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRequestedAttributeElement_LoadFromXML(TElSAMLRequestedAttributeElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRequestedAttributeElement_SaveToXML(TElSAMLRequestedAttributeElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRequestedAttributeElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRequestedAttributeElement_get_IsRequired(TElSAMLRequestedAttributeElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRequestedAttributeElement_set_IsRequired(TElSAMLRequestedAttributeElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRequestedAttributeElement_get_UseIsRequired(TElSAMLRequestedAttributeElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRequestedAttributeElement_set_UseIsRequired(TElSAMLRequestedAttributeElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLRequestedAttributeElement_Create(TElSAMLRequestedAttributeElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLREQUESTEDATTRIBUTEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSERVICENAMEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLServiceNameElement_Create(TElSAMLServiceNameElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLSERVICENAMEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSERVICEDESCRIPTIONELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLServiceDescriptionElement_Create(TElSAMLServiceDescriptionElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLSERVICEDESCRIPTIONELEMENT */

#ifdef SB_USE_CLASS_TELSAMLATTRIBUTECONSUMINGSERVICEELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_Clear(TElSAMLAttributeConsumingServiceElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_LoadFromXML(TElSAMLAttributeConsumingServiceElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_SaveToXML(TElSAMLAttributeConsumingServiceElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_get_Index(TElSAMLAttributeConsumingServiceElementHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_set_Index(TElSAMLAttributeConsumingServiceElementHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_get_IsDefault(TElSAMLAttributeConsumingServiceElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_set_IsDefault(TElSAMLAttributeConsumingServiceElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_get_UseIsDefault(TElSAMLAttributeConsumingServiceElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_set_UseIsDefault(TElSAMLAttributeConsumingServiceElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_get_ServiceNames(TElSAMLAttributeConsumingServiceElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_get_ServiceDescriptions(TElSAMLAttributeConsumingServiceElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_get_RequestedAttributes(TElSAMLAttributeConsumingServiceElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLAttributeConsumingServiceElement_Create(TElSAMLAttributeConsumingServiceElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLATTRIBUTECONSUMINGSERVICEELEMENT */

#ifdef SB_USE_CLASS_TELSAMLSPSSODESCRIPTORELEMENT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_Clear(TElSAMLSPSSODescriptorElementHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_LoadFromXML(TElSAMLSPSSODescriptorElementHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_SaveToXML(TElSAMLSPSSODescriptorElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_get_AuthnRequestsSigned(TElSAMLSPSSODescriptorElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_set_AuthnRequestsSigned(TElSAMLSPSSODescriptorElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_get_UseAuthnRequestsSigned(TElSAMLSPSSODescriptorElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_set_UseAuthnRequestsSigned(TElSAMLSPSSODescriptorElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_get_WantAssertionsSigned(TElSAMLSPSSODescriptorElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_set_WantAssertionsSigned(TElSAMLSPSSODescriptorElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_get_UseWantAssertionsSigned(TElSAMLSPSSODescriptorElementHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_set_UseWantAssertionsSigned(TElSAMLSPSSODescriptorElementHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_get_AssertionConsumerServices(TElSAMLSPSSODescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_get_AttributeConsumingServices(TElSAMLSPSSODescriptorElementHandle _Handle, TListHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLSPSSODescriptorElement_Create(TElSAMLSPSSODescriptorElementHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLSPSSODESCRIPTORELEMENT */

#ifdef SB_USE_CLASS_TELSAMLENCRYPTIONMETHODTYPE
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_Clear(TElSAMLEncryptionMethodTypeHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_IsEmpty(TElSAMLEncryptionMethodTypeHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_LoadFromXML(TElSAMLEncryptionMethodTypeHandle _Handle, TElXMLDOMElementHandle Element);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_SaveToXML(TElSAMLEncryptionMethodTypeHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLCustomFormatterHandle Formatter, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_SaveToXML_1(TElXMLCustomElementHandle _Handle, TElXMLDOMDocumentHandle Document, TElXMLDOMElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_get_Algorithm(TElSAMLEncryptionMethodTypeHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_set_Algorithm(TElSAMLEncryptionMethodTypeHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_get_KeySize(TElSAMLEncryptionMethodTypeHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_set_KeySize(TElSAMLEncryptionMethodTypeHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_get_OAEPparams(TElSAMLEncryptionMethodTypeHandle _Handle, uint8_t pOutResult[], int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_set_OAEPparams(TElSAMLEncryptionMethodTypeHandle _Handle, const uint8_t pValue[], int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_get_DigestMethod(TElSAMLEncryptionMethodTypeHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_set_DigestMethod(TElSAMLEncryptionMethodTypeHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEncryptionMethodType_Create(TElSAMLEncryptionMethodTypeHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLENCRYPTIONMETHODTYPE */

#ifdef SB_USE_CLASS_TELSAMLMETADATA
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadata_Clear(TElSAMLMetadataHandle _Handle);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadata_LoadFromStream(TElSAMLMetadataHandle _Handle, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadata_SaveToStream(TElSAMLMetadataHandle _Handle, TStreamHandle Strm);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadata_get_Handler(TElSAMLMetadataHandle _Handle, TElSAMLSecurityHandlerHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadata_set_Handler(TElSAMLMetadataHandle _Handle, TElSAMLSecurityHandlerHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadata_get_Loaded(TElSAMLMetadataHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadata_get_RootElement(TElSAMLMetadataHandle _Handle, TElSAMLMetadataRootElementHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadata_set_RootElement(TElSAMLMetadataHandle _Handle, TElSAMLMetadataRootElementHandle Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadata_Create(TElSAMLMetadataHandle * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLMetadata_Create_1(int8_t OwnHandler, TElSAMLMetadataHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLMETADATA */

#ifdef SB_USE_CLASS_TELSAMLENDPOINT
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpoint_get_Binding(TElSAMLEndpointHandle _Handle, TSBSAMLBindingTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpoint_set_Binding(TElSAMLEndpointHandle _Handle, TSBSAMLBindingTypeRaw Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpoint_get_Location(TElSAMLEndpointHandle _Handle, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpoint_set_Location(TElSAMLEndpointHandle _Handle, const char * pcValue, int32_t szValue);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpoint_get__Index(TElSAMLEndpointHandle _Handle, int32_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpoint_set__Index(TElSAMLEndpointHandle _Handle, int32_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpoint_get_IsDefault(TElSAMLEndpointHandle _Handle, int8_t * OutResult);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpoint_set_IsDefault(TElSAMLEndpointHandle _Handle, int8_t Value);
SB_IMPORT uint32_t SB_APIENTRY TElSAMLEndpoint_Create(TElSAMLEndpointHandle * OutResult);
#endif /* SB_USE_CLASS_TELSAMLENDPOINT */

#ifdef __cplusplus
};	/* extern "C" */
#endif

extern zend_class_entry *TElSAMLMetadataRootElement_ce_ptr;
extern zend_class_entry *TElSAMLLocalizedNameType_ce_ptr;
extern zend_class_entry *TElSAMLLocalizedURIType_ce_ptr;
extern zend_class_entry *TElSAMLEndpointType_ce_ptr;
extern zend_class_entry *TElSAMLIndexedEndpointType_ce_ptr;
extern zend_class_entry *TElSAMLEntityDescriptorElement_ce_ptr;
extern zend_class_entry *TElSAMLEntitiesDescriptorElement_ce_ptr;
extern zend_class_entry *TElSAMLKeyDescriptorElement_ce_ptr;
extern zend_class_entry *TElSAMLOrganizationElement_ce_ptr;
extern zend_class_entry *TElSAMLContactPersonElement_ce_ptr;
extern zend_class_entry *TElSAMLRoleDescriptorElement_ce_ptr;
extern zend_class_entry *TElSAMLAuthnQueryServiceElement_ce_ptr;
extern zend_class_entry *TElSAMLAssertionIDRequestServiceElement_ce_ptr;
extern zend_class_entry *TElSAMLAuthnAuthorityDescriptorElement_ce_ptr;
extern zend_class_entry *TElSAMLAttributeServiceElement_ce_ptr;
extern zend_class_entry *TElSAMLAttributeAuthorityDescriptorElement_ce_ptr;
extern zend_class_entry *TElSAMLAuthzServiceElement_ce_ptr;
extern zend_class_entry *TElSAMLPDPDescriptorElement_ce_ptr;
extern zend_class_entry *TElSAMLAffiliationDescriptorElement_ce_ptr;
extern zend_class_entry *TElSAMLOrganizationNameElement_ce_ptr;
extern zend_class_entry *TElSAMLOrganizationDisplayNameElement_ce_ptr;
extern zend_class_entry *TElSAMLOrganizationURLElement_ce_ptr;
extern zend_class_entry *TElSAMLAdditionalMetadataLocationElement_ce_ptr;
extern zend_class_entry *TElSAMLArtifactResolutionServiceElement_ce_ptr;
extern zend_class_entry *TElSAMLSingleLogoutServiceElement_ce_ptr;
extern zend_class_entry *TElSAMLManageNameIDServiceElement_ce_ptr;
extern zend_class_entry *TElSAMLSingleSignOnServiceElement_ce_ptr;
extern zend_class_entry *TElSAMLNameIDMappingServiceElement_ce_ptr;
extern zend_class_entry *TElSAMLSSODescriptorType_ce_ptr;
extern zend_class_entry *TElSAMLIDPSSODescriptorElement_ce_ptr;
extern zend_class_entry *TElSAMLAssertionConsumerServiceElement_ce_ptr;
extern zend_class_entry *TElSAMLRequestedAttributeElement_ce_ptr;
extern zend_class_entry *TElSAMLServiceNameElement_ce_ptr;
extern zend_class_entry *TElSAMLServiceDescriptionElement_ce_ptr;
extern zend_class_entry *TElSAMLAttributeConsumingServiceElement_ce_ptr;
extern zend_class_entry *TElSAMLSPSSODescriptorElement_ce_ptr;
extern zend_class_entry *TElSAMLEncryptionMethodType_ce_ptr;
extern zend_class_entry *TElSAMLMetadata_ce_ptr;
extern zend_class_entry *TElSAMLEndpoint_ce_ptr;

void SB_CALLBACK TSBSAMLChooseMetadataDescriptorEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLEntityDescriptorElementHandle Descriptor, int8_t * Stop);
void Register_TElSAMLMetadataRootElement(TSRMLS_D);
void Register_TElSAMLLocalizedNameType(TSRMLS_D);
void Register_TElSAMLLocalizedURIType(TSRMLS_D);
void Register_TElSAMLEndpointType(TSRMLS_D);
void Register_TElSAMLIndexedEndpointType(TSRMLS_D);
void Register_TElSAMLEntityDescriptorElement(TSRMLS_D);
void Register_TElSAMLEntitiesDescriptorElement(TSRMLS_D);
void Register_TElSAMLKeyDescriptorElement(TSRMLS_D);
void Register_TElSAMLOrganizationElement(TSRMLS_D);
void Register_TElSAMLContactPersonElement(TSRMLS_D);
void Register_TElSAMLRoleDescriptorElement(TSRMLS_D);
void Register_TElSAMLAuthnQueryServiceElement(TSRMLS_D);
void Register_TElSAMLAssertionIDRequestServiceElement(TSRMLS_D);
void Register_TElSAMLAuthnAuthorityDescriptorElement(TSRMLS_D);
void Register_TElSAMLAttributeServiceElement(TSRMLS_D);
void Register_TElSAMLAttributeAuthorityDescriptorElement(TSRMLS_D);
void Register_TElSAMLAuthzServiceElement(TSRMLS_D);
void Register_TElSAMLPDPDescriptorElement(TSRMLS_D);
void Register_TElSAMLAffiliationDescriptorElement(TSRMLS_D);
void Register_TElSAMLOrganizationNameElement(TSRMLS_D);
void Register_TElSAMLOrganizationDisplayNameElement(TSRMLS_D);
void Register_TElSAMLOrganizationURLElement(TSRMLS_D);
void Register_TElSAMLAdditionalMetadataLocationElement(TSRMLS_D);
void Register_TElSAMLArtifactResolutionServiceElement(TSRMLS_D);
void Register_TElSAMLSingleLogoutServiceElement(TSRMLS_D);
void Register_TElSAMLManageNameIDServiceElement(TSRMLS_D);
void Register_TElSAMLSingleSignOnServiceElement(TSRMLS_D);
void Register_TElSAMLNameIDMappingServiceElement(TSRMLS_D);
void Register_TElSAMLSSODescriptorType(TSRMLS_D);
void Register_TElSAMLIDPSSODescriptorElement(TSRMLS_D);
void Register_TElSAMLAssertionConsumerServiceElement(TSRMLS_D);
void Register_TElSAMLRequestedAttributeElement(TSRMLS_D);
void Register_TElSAMLServiceNameElement(TSRMLS_D);
void Register_TElSAMLServiceDescriptionElement(TSRMLS_D);
void Register_TElSAMLAttributeConsumingServiceElement(TSRMLS_D);
void Register_TElSAMLSPSSODescriptorElement(TSRMLS_D);
void Register_TElSAMLEncryptionMethodType(TSRMLS_D);
void Register_TElSAMLMetadata(TSRMLS_D);
void Register_TElSAMLEndpoint(TSRMLS_D);
SB_PHP_FUNCTION(SBXMLSAMLMetadata, ContactTypeToStr);
SB_PHP_FUNCTION(SBXMLSAMLMetadata, StrToContactType);
SB_PHP_FUNCTION(SBXMLSAMLMetadata, KeyUsageToStr);
SB_PHP_FUNCTION(SBXMLSAMLMetadata, StrToKeyUsage);
void Register_SBXMLSAMLMetadata_Enum_Flags(TSRMLS_D);

#ifdef __cplusplus
extern "C" {
#endif

#ifdef SB_USE_GLOBAL_PROCS_XMLSAMLMETADATA
SB_IMPORT uint32_t SB_APIENTRY SBXMLSAMLMetadata_ContactTypeToStr(TSBSAMLContactTypeRaw T, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBXMLSAMLMetadata_StrToContactType(const char * pcS, int32_t szS, TSBSAMLContactTypeRaw * OutResult);
SB_IMPORT uint32_t SB_APIENTRY SBXMLSAMLMetadata_KeyUsageToStr(TSBSAMLKeyUseRaw U, char * pcOutResult, int32_t * szOutResult);
SB_IMPORT uint32_t SB_APIENTRY SBXMLSAMLMetadata_StrToKeyUsage(const char * pcS, int32_t szS, TSBSAMLKeyUseRaw * OutResult);
#endif /* SB_USE_GLOBAL_PROCS_XMLSAMLMETADATA */

#ifdef __cplusplus
};	/* extern "C" */
#endif

#ifdef __cplusplus
};	/* namespace SecureBlackbox */
#endif

#pragma pack(pop)

#endif  /* __INC_SBXMLSAMLMETADATA */
