<?php 
    date_default_timezone_set("UTC");

    if (isset($_POST["receive"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly"; 
            die;
        }

        $serv = $_POST["serv"];
        $port = $_POST["port"];
        $nossl = (isset($_POST['sslmode']) && $_POST['sslmode'] == 'mode1');
        $implicit = (isset($_POST['sslmode']) && $_POST['sslmode'] == 'mode2');
        $explicit = (isset($_POST['sslmode']) && $_POST['sslmode'] == 'mode3');
        $user = $_POST["user"];
        $password = $_POST["pass"];

        if ((strlen($serv) > 0) and (strlen($port) > 0) and ($nossl or $implicit or $explicit) and (strlen($user) > 0) and (strlen($password) > 0))
        {
            $client = new TElPOP3Client(NULL);

            $client->Address = $serv;
            $client->Port = $port;
            $client->UseSSL = !$nossl;
            if ($client->UseSSL)
            {
                if ($implicit)
                {
                    $client->SSLMode = 0;
                }
                else
                {
                    $client->SSLMode = 1;
                }
            }

            $client->Username = $user;
            $client->Password = $password;

            try
            {
                $client->Open();
                $client->Login();

                $allcount = 0;
                $allsize = 0;
                $client->GetMailboxInfo($allcount, $allsize);

                if ($allcount > 0)
                {
                    $client->ReceiveMessageIDList();
                    $header = new TElMessageHeader();
                    $charset = "";
                    $eprocess = "";

                    for ($i = 1; $i <= $allcount; $i++)
                    {
                        if ($client->ReceiveMessageHeader($i, $charset, false, $header) == SBMIME\EL_OK)
                        {
                            $Addresses = $header->GetMailAddressList("From", 0);
                            if ($Addresses != NULL)
                            {
                                if ($Addresses->TotalCount > 1)
                                {
                                    $from = "[Multiple addresses]";
                                }
                                else
                                {
                                    if ($Addresses->Count == 1)
                                    {
                                        if ($Addresses->GetAddress(0)->IsAlias())
                                        {
                                            $from = $Addresses->GetAddress(0)->Alias;
                                        }
                                        else
                                        {
                                            $from = $Addresses->GetAddress(0)->Address;
                                        }
                                    }
                                    else
                                    {
                                        $from = $Addresses->GetGroup(0).Name;
                                    }
                                }
                            }
                            else
                            {
                                $from = "unknown";
                            }

                            $hdate = $header->GetField("Date", 0);
                            if ($hdate != NULL)
                            {
                                $ldate = $hdate->Value;
                            }
                            else
                            {
                                $ldate = "unknown";
                            }
                            $hsubject = $header->GetField("Subject", 0);
                            if ($hsubject != NULL)
                            {
                                $lsubject = $hsubject->Value;
                            }
                            else
                            {
                                $lsubject = "None";
                            }
                            $lsize = $client->GetMessageSize($i);
                            $eprocess = $eprocess . "    From:  " . $from . "<br/>    Date:  " . $ldate . "<br/>    Subject:  " . $lsubject .
                                                    "<br/>    Size:  " . $lsize . "<br/>-----------------------<br/>";
                        }
                    }

                    print "Received letters: <br/><br/>" . $eprocess;
                }
                else
                {
                    print "Zero files were recieved";
                }

                $client->Close(false);

                return;
            }
            catch(SBException $e) 
            {
                print "Failed to send message : " . $e->getMessage() ." <br/>";
                return;
            }
        }
        else
        {
            $error_details = "";

            if (strlen($serv) == 0)
            {
                $error_details = $error_details . "POP3 server is not provided<br/>";
            }
            if (strlen($port) == 0)
            {
                $error_details = $error_details . "POP3 port is not provided<br/>";
            }
            if (!($nossl or $implicit or $explicit))
            {
                $error_details = $error_details . "SSL mode is not selected<br/>";
            }
            if (strlen($user) == 0)
            {
                $error_details = $error_details . "User is not provided<br/>";
            }
            if (strlen($password) == 0)
            {
                $error_details = $error_details . "Password is not provided<br/>";
            }

            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }
?>

<html>
<head>
  <title>EldoS OpenPGP protect demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox POP3 demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> This sample illustrates the use of SecureBlackbox POP3 components for receive letters. <br/>
              Please provide your pop3 server, login credential and click the 'Receive' button to receive letters. </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">            
              <form action="" method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="30">
                    <td width="40%" align="right"> Server: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="serv" value="" size="30" /> <td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> Port: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="port" value="" size="30" /> </td>
                  </tr>
                  <tr height="50">
                    <td width="40%" align="right"> SSL Mode: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> 
                      <input type="radio" name="sslmode" CHECKED value="mode1" size="30" /> <span class="mtx4">No SSL</span>
                      <input type="radio" name="sslmode" value="mode2" size="30" /> <span class="mtx4">Implicit</span>
                      <input type="radio" name="sslmode" value="mode3" size="30" /> <span class="mtx4">Explicit</span>
                    </td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> Username: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="user" value="" size="30" /> </td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> Password: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="password" name="pass" value="" size="30" /> </td>
                  </tr>
                  <tr height="45" valign="center">
                    <td colspan="3" align="center"> <input type="submit" name="receive" value="Receive"/> </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>  
</body>
</html>