<?php 
    date_default_timezone_set("UTC");

    function DoKeyPassword($Sender, $Key, &$Password)
    {
        $Password = $_POST["pass"];
    }

    if (isset($_POST["protect"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly"; 
            return;
        }

        $pkey = $_FILES["pkey"]["tmp_name"];
        $skey = $_FILES["skey"]["tmp_name"];
        $encrypt = (isset($_POST['encrypt']) && $_POST['encrypt'] == 'yes');
        $sign = (isset($_POST['sign']) && $_POST['sign'] == 'yes');
        $inputfile = $_FILES["inputfile"]["tmp_name"];
        $filename = $_FILES["inputfile"]["name"];

        if ((strlen($pkey) > 0) and (strlen($skey) > 0) and (strlen($inputfile) > 0) and ($sign or $encrypt))
        {
            $pgpKeyring = new TElPGPKeyring(NULL);

            try
            {
                $pgpKeyring->Load($pkey, $skey, true);
            }
            catch(SBException $e) 
            {
                print "Failed to load keyring : " . $e->getMessage() ." <br/>";
                return;
            }

            $writer = new TElPGPWriter(NULL);
            $writer->EncryptingKeys = $pgpKeyring;
            $writer->SigningKeys = $pgpKeyring;
            $writer->FileName = $filename;
            $writer->OnKeyPassphrase = "DoKeyPassword";

            if ($encrypt)
                $writer->SymmetricKeyAlgorithm = SBPGPConstants\SB_PGP_ALGORITHM_SK_AES256;
            // see the full list of algorithm constants at https://www.eldos.com/documentation/sbb/documentation/ref_cl_pgpwriter_prp_symmetrickeyalgorithm.html

            if ($sign)
                $writer->HashAlgorithm = SBPGPConstants\SB_PGP_ALGORITHM_MD_MD5;  
            // see the full list of algorithm constants at https://www.eldos.com/documentation/sbb/documentation/ref_cl_pgpwriter_prp_hashalgorithm.html

            $writer->SignBufferingMethod = TSBPGPSignBufferingMethod::sbmRewind;

            try
            {
                $yourfile = basename($filename) . ".pgp";
                $tempname = tempnam(sys_get_temp_dir(), $yourfile);

                $in = new TMemoryStream;
                $out = new TMemoryStream;

                $in->LoadFromFile($inputfile);

                if ($encrypt and $sign)
                {
                    $writer->EncryptAndSign($in, $out, 0);
                }
                else
                {
                    if ($encrypt)
                    {
                        $writer->Encrypt($in, $out, 0);
                    }
                    else
                    {
                        $writer->Sign($in, $out, false, 0);
                    }
                }

                $out->SaveToFile($tempname);
                readfile($tempname);

                header("Content-Disposition: attachment; filename=$yourfile");

                unlink($tempname);

                return;
            }
            catch(SBException $e) 
            {
                unlink($tempname);

                print "Failed to protect the file: " . $e->getMessage() ." <br/>";
            }
        }
        else
        {
            $error_details = "";

            if (strlen($pkey) == 0)
            {
                $error_details = $error_details . "Public keyring file is not provided<br/>";
            }
            if (strlen($skey) == 0)
            {
                $error_details = $error_details . " Secret keyring file is not provided <br/>";
            }
            if (strlen($inputfile) == 0)
            {
                $error_details = $error_details . "File to protect is not provided<br/>";
            }
            if (!($sign or $encrypt))
            {
                $error_details = $error_details . "Protection operation is not selected<br/>";
            }

            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }
?>

<html>
<head>
  <title>EldoS OpenPGP protect demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox OpenPGP protect demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> This sample illustrates the use of SecureBlackbox OpenPGP components for protecting files. <br/>
              Please provide your keyring files and the file to protect, choose the operation and click the 'Protect' button to protect the file. </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">            
              <form action="" method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="30">
                    <td width="40%" align="right"> Public keyring file: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="file" name="pkey" value="" size="30" /> <td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> Secret keyring file: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="file" name="skey" value="" size="30" /> </td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> Key password: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="password" name="pass" value="" size="30" /> </td>
                  </tr>
                  <tr height="30">
                    <td width="40%" align="right"> File to protect: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="file" name="inputfile" value="" size="30" /> </td>
                  </tr>
                  <tr height="50">
                    <td width="40%" align="right"> Protection operation: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> 
                      <input type="checkbox" name="encrypt" value="yes"> <span class="mtx4">Encrypt file</span>
                      <br/>
                      <input type="checkbox" name="sign" value="yes"> <span class="mtx4">Sign file</span> 
                    </td>
                  </tr>
                  <tr height="45" valign="center">
                    <td colspan="3" align="center"> <input type="submit" name="protect" value="Protect"/> </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>  
</body>
</html>