<?php

  // This is the index page of the Distributed PDF signer sample.
  // All it does it is welcomes the user and generates
  // a random ID for the user session. This ID is then used
  // to access session-specific data (presigned and signed
  // documents and the log). Data specific to a particular 
  // session is stored in the session directory, which is
  // <script_root>/work/<session_id>.
  //
  // Once the user clicks the 'Start Signing' link, this script
  // redirects them to the presign/ script, which initiates the
  // remote signing.
  //
  // Note that we aimed to keep the sample as simple as possible,
  // so its error handling is very basic and no data validation
  // is performed. This is something you might want to implement 
  // yourself.


  // generating a unique ID to act as session identifier
  $session_id = uniqid();

?>

<html>
<head>
  <title>EldoS PDF Distributed Signer demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox Distributed PDF Signer demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> 
                This sample illustrates the use of SecureBlackbox components for signing a PDF document remotely with Distributed Crypto functionality. 
                Documents signed remotely remain on the web server, but are signed with private keys residing on the clients' machines.
                <br/><br />
                By clicking 'Start signing' below you will be redirected to the first step of the DC protocol. You will be offered to accept an applet which
                will be used to access your private key (the private key will only be used for signing and never leave your machine). 
                Upon completion of the signing, the applet will redirect you to the page containing a link to the signed document.
                <br /><br />
                This instance of the script has been assigned with a unique identifier (<?php print $session_id; ?>) to act as a session ID,
                to preserve signing information between the script's counterparts.
              </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*" align="center" class="textnormal">
              <a href="presign/?sessionid=<?php print $session_id; ?>">Start signing</a>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>
</body>
</html>