<?php 
    date_default_timezone_set("UTC");

    $info = new TStringList();
    $logf = new TStringList();
    $client = new TElSimpleSSHClient(NULL);

    function ShowForm()
    {
        global $info;
        global $logf;

        echo '<html>';
        echo '<head>';
        echo '  <title>EldoS SSH Client demo</title>';
        echo '  <style type="text/css">';
        echo '  .textheader {';
        echo '    font-family: Arial;';
        echo '    font-size: 16;';
        echo '    font-weight: bold;';
        echo '  }';
        echo '  .textnormal {';
        echo '    font-family: Arial;';
        echo '    font-size: 12;';
        echo '  }';
        echo '  </style>';
        echo '</head>';
        echo '<body>';
        echo '  <div align="center">';
        echo '  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">';
        echo '    <tr height="*"></tr>';
        echo '    <tr height="400">';
        echo '      <td width="600" valign="top">';
        echo '        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">';
        echo '          <tr height="50">';
        echo '            <td width="100%" valign="center" bgcolor="#e6e6e6">';
        echo '              <div align="center" class="textheader">EldoS SecureBlackbox SSH Client demo</div>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="70">';
        echo '            <td width="100%" height="*" align="center" valign="center" class="textnormal">';
        echo '              <div align="center"> This sample illustrates the use of SecureBlackbox SSH Client components. <br/>';
        echo '              Please provide your command and click the "Send" button to send command to SSH server. </div>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="*">';
        echo '            <td width="100%" height="*">';
        echo '              <form action="SSHClient.php" method="post" enctype="multipart/form-data">';
        echo '                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">';
        echo '                  <tr height="30" valign="bottom">';
        echo '                    <td width="*" align="left"> <span class="mtx4">Logs:</span> </td>';
        echo '                    <td width="10"></td>';
        echo '                    <td width="30" align="right"></td>';
        echo '                  </tr>';
        echo '                  <tr height="50">';
        echo '                    <td colspan="3" align="center">';
        echo '                      <textarea readonly name="info" cols=90 rows=15>';

        for ($i = 0; $i <= $logf->Count - 1; $i++)
        {
            echo $logf->get_Strings($i) . "\r\n";
        }

        echo '                      </textarea>';
        echo '                    </td>';
        echo '                  </tr>';
        echo '                  <tr height="30" valign="bottom">';
        echo '                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>';
        echo '                  </tr>';
        echo '                </table>';
        echo '              </form>';
        echo '            </td>';
        echo '          </tr>';
        echo '          <tr height="20">';
        echo '            <td width="100%" valign="center" bgcolor="#e6e6e6">';
        echo '              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>';
        echo '            </td>';
        echo '          </tr>';
        echo '        </table>';
        echo '      </td>';
        echo '    </tr>';
        echo '    <tr height="*"></tr>';
        echo '  </table>';
        echo '  </div>';
        echo '</body>';
        echo '</html>';
    }

    function DoCertificateValidate($Sender, $X509Certificate, &$Validate)
    {
        $Validate = true;
    }

    function HandleClientCloseConnection($Sender)
    {
        global $logf;
        $logf->Add('Connection closed.');
    }

    function HandleClientError($Sender, $Error)
    {
        global $logf;
        $logf->Add('Error: ' . $Error);
    }

    function HandleClientAuthenticationSuccess($Sender)
    {
        global $logf;
        $logf->Add('Authentication succeeded');
    }

    function HandleClientAuthenticationFailed($Sender, $AuthType)
    {
        global $logf;
        $logf->Add('Authentication attempt failed, AuthType = ' . $AuthType);
    }

    function HandleKeyValidate($Sender, $ServerKey, &$Validate)
    {
        if ($ServerKey->Algorithm == SBSSHKeyStorage\ALGORITHM_RSA)
        {
            $AlgLine = 'RSA';
        }
        else if ($ServerKey->Algorithm == SBSSHKeyStorage\ALGORITHM_DSS)
        {
            $AlgLine = 'DSS';
        }
        else
        {
            $AlgLine = 'unknown';
        }

        global $logf;
        $logf->Add('Server key received (' . $AlgLine . '). Fingerprint is ' . SBUtils\BeautifyBinaryString(SBUtils\DigestToStr($ServerKey->FingerprintMD5, true), ':'));
        $Validate = True;
    }

    function IsChecked($chkname,$value)
    {
        if(!empty($_POST[$chkname]))
        {
            foreach($_POST[$chkname] as $chkval)
            {
                if($chkval == $value)
                {
                    return true;
                }
            }
        }
        return false;
    }

    if (isset($_POST["connect"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly"; 
            die;
        }

        $host = $_POST["host"];
        $port = $_POST["port"];
        $mode = $_POST["mode"];
        $username = $_POST["username"];
        $password = $_POST["password"];
        $keyfile = $_FILES["keyfile"]["tmp_name"];
        $message = $_POST["message"];

        if ((strlen($host) > 0) and (strlen($port) > 0) and (!empty($mode)) and
            (strlen($username) > 0) and (strlen($password) > 0))
        {
            $client->OnCloseConnection = "HandleClientCloseConnection";
            $client->OnError = "HandleClientError";
            $client->OnAuthenticationSuccess = "HandleClientAuthenticationSuccess";
            $client->OnAuthenticationFailed = "HandleClientAuthenticationFailed";
            $client->OnKeyValidate = "HandleKeyValidate";
            $keystorage = new TElSSHMemoryKeyStorage(NULL);
            $client->KeyStorage = $keystorage;

            $client->set_Versions(0);
            if (IsChecked("mode", "ssh1"))
            {
                $client->set_Versions($client->get_Versions() + 1);
            }
            if (IsChecked("mode", "ssh2"))
            {
                $client->set_Versions($client->get_Versions() + 2);
            }
            $client->UserName = $username;
            $client->Password = $password;

            $keystorage->Clear();

            $client->set_AuthenticationTypes(SBSSHConstants\SSH_AUTH_TYPE_PASSWORD + SBSSHConstants\SSH_AUTH_TYPE_KEYBOARD);

            $key = new TElSSHKey();
            if ((strlen($keyfile) > 0) and ($key->LoadPrivateKey($keyfile, $password)))
            {
                $keystorage->Add($key);
                $client->set_AuthenticationTypes($client->get_AuthenticationTypes() + SBSSHConstants\SSH_AUTH_TYPE_PUBLICKEY);
            }
            else
            {
                $client->set_AuthenticationTypes($client->get_AuthenticationTypes() + !SBSSHConstants\SSH_AUTH_TYPE_PUBLICKEY);
            }

            $client->Address = $host;
            $client->Port = $port;

            $info->Clear();
            $logf->Clear();

            try
            {
                $client->Open();

                if ($client->Active)
                {
                    $logf->Add("Connection started");
                    $logf->Add("Server: " . $client->ServerSoftwareName);
                    if ($client->Version == TSSHVersion::sbSSH1)
                    {
                        $logf->Add("Version: SSHv1");
                    }
                    else
                    {
                        $logf->Add("Version: SSHv2");
                    }
                    $logf->Add("PublicKey algorithm: " . $client->PublicKeyAlgorithm);
                    $logf->Add("Kex algorithm: " . $client->KexAlgorithm);
                    $logf->Add("Block algorithm: " . $client->EncryptionAlgorithmServerToClient);
                    $logf->Add("Compression algorithm: " . $client->CompressionAlgorithmServerToClient);
                    $logf->Add("MAC algorithm: " . $client->MacAlgorithmServerToClient);

                    if (strlen($message) > 0)
                    {
                        $client->SendData($message, strlen($message));
                        $logf->Add("");
                        $logf->Add("Send : " . $message);
                    }

                    ShowForm();
                }
            }
            catch(SBException $e) 
            {
                $logf->Add("SSH connection failed with message : " . $e->getMessage());
                $client->Close();
                ShowForm();
            }
        }
        else
        {
            $error_details = "";

            if (strlen($host) == 0)
            {
                $error_details = $error_details . "Host is not provided<br/>";
            }
            if (strlen($port) == 0)
            {
                $error_details = $error_details . "Port is not provided<br/>";
            }
            if (empty($mode))
            {
                $error_details = $error_details . "SSH Mode is not selected<br/>";
            }
            if (strlen($username) == 0)
            {
                $error_details = $error_details . "Username is not provided<br/>";
            }
            if (strlen($password) == 0)
            {
                $error_details = $error_details . "Password is not provided<br/>";
            }

            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }
?>