<?php 
    date_default_timezone_set("UTC");

    function DoCertificateValidate($Sender, $X509Certificate, &$Validate)
    {
        $Validate = true;
    }

    if (isset($_POST["connect"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly"; 
            die;
        }

        $URL = $_POST["URL"];
        $user = $_POST["user"];
        $password = $_POST["password"];

        if (strlen($URL) > 0)
        {
            $http = new TElHTTPSWebDAVClient(NULL);
            $webdav = new TElWebDAVClient(NULL);
            $http->OnCertificateValidate = "DoCertificateValidate";
            $webdav->HTTPSWebDAVClient = $http;

            try
            {
                $http->get_RequestParameters()->set_Username($user);
                $http->get_RequestParameters()->set_Password($password);
                $http->set_KeepAlivePolicy(TSBHTTPKeepAlivePolicy::kapStandardDefined);
                $http->set_HTTPVersion(TSBHTTPVersion::hvHTTP11);

                $webdav->set_BaseURL($URL);

                $objs = new TElWebDavObjectList();

                $webdav->List($objs);

                if ($objs->Count > 0)
                {
                    $eprocess = "";

                    for ($i = 0; $i <= $objs->Count - 1; $i++)
                    {
                        $obj = $objs->get_Objects($j);

                        $eprocess = $eprocess . "&nbsp;&nbsp;&nbsp;Name : " . $obj->DisplayName . "<br/>" .
                                                "&nbsp;&nbsp;&nbsp;Size : " . $obj->ContentLength . "<br/>" .
                                                "&nbsp;&nbsp;&nbsp;Creation date : " . $obj->CreationDate->format('d-m-Y H:i:s') . "<br/>" .
                                                "&nbsp;&nbsp;&nbsp;Location : " . $obj->ParentURL . "<br/>";
                        if ($obj->Locks->Count > 0)
                        {
                            $eprocess = $eprocess . "&nbsp;&nbsp;&nbsp;Locked : yes <br/>";
                        }
                        else
                        {
                            $eprocess = $eprocess . "&nbsp;&nbsp;&nbsp;Locked : no <br/>";
                        }

                        if ($obj->Collection)
                        {
                            $eprocess = $eprocess . "&nbsp;&nbsp;&nbsp;Type : folder <br/>";
                        }
                        else
                        {
                            $eprocess = $eprocess . "&nbsp;&nbsp;&nbsp;Type : file <br/>";
                        }
                        $eprocess = $eprocess . "&nbsp;&nbsp;&nbsp----------------------------<br/>";

                    }

                    print "All Files: <br/><br/>" . $eprocess;
                }
                else
                {
                    print "Zero files on server";
                }
            }
            catch(SBException $e) 
            {
                print "Failed to connect : " . $e->getMessage() ." <br/>";
                return;
            }
        }
        else
        {
            print "Base URL is not provided";
        }
    }
?>

<html>
<head>
  <title>EldoS WebDavClient demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox WebDav demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> This sample illustrates the use of SecureBlackbox WebDav components. <br/>
              Please provide your server URL, username, password and click the 'Connect' button to connect to server and receive list of files. </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">            
              <form action="" method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="30">
                    <td width="20%" align="right"> Base URL: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="URL" value="127.0.0.1/" size="30" /> <td>
                  </tr>
                  <tr height="30">
                    <td width="20%" align="right"> Username: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="text" name="user" value="" size="20" /> </td>
                  </tr>
                  <tr height="30">
                    <td width="20%" align="right"> Password: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="password" name="password" value="" size="20" /> </td>
                  </tr>
                  <tr height="45" valign="center">
                    <td colspan="3" align="center"> <input type="submit" name="connect" value="Connect"/> </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>  
</body>
</html>