<?php 
    date_default_timezone_set("UTC");

    function FormatElement($Sender, $Element, $Level, $Path, &$StartTagWhitespace, &$EndTagWhitespace)
    {
        $StartTagWhitespace = "\n";
        $s = '';
        for ($i = 0; $i <= $Level - 2; $i++)
        {
            $s = $s . "\t";
        }
        $StartTagWhitespace = $StartTagWhitespace . $s;

        if (!empty($Element->get_FirstChild()))
        {
            $HasElements = False;
            $Node = $Element->get_FirstChild();
            while (!empty($Node))
            {
                if ($Node->get_NodeType() == SBXMLCore\ntElement)
                {
                    $HasElements = True;
                    Break;
                }

                $Node = $Node->get_NextSibling();
            }

            if ($HasElements) { $EndTagWhitespace = "\n" . $s;}
        }
    }

    function FormatText($Sender, &$Text, $TextType, $Level, $Path)
    {
        if (($TextType == TElXMLTextType::ttBase64) and (strlen($Text) > 64))
        {
            $s = "\n";
            while (strlen($Text) > 0)
            {
                $s = $s . substr($Text, 1, 64) . "\n";
                $Text = substr($Text, 65);
            }

            for ($i = 0; $i <= $Level - 3; $i++)
            {
               $s = $s . "\t";
            }

            $Text = $s;
        }
    }

    if (isset($_POST["sign"])) 
    {
        if (!extension_loaded("sbb") && !function_exists('SBUtils\SetLicenseKey')) 
        {
            print "SecureBlackbox extension is not available, please check that you've set it up correctly";
            die;
        }

        $inputfile = $_FILES["inputfile"]["tmp_name"];
        $filename = $_FILES["inputfile"]["name"];
        $signtype = $_POST['signtype'];
        $canmethod = $_POST['canmethod'];
        $signmethod = $_POST['signmethod'];
        if (isset($_POST['hmacsel'])) {$hmacsel = $_POST['hmacsel'];}
        if (isset($_POST['signature'])) {$signature = $_POST['signature'];}
        $include = (isset($_POST['include']) && $_POST['include'] == 'yes');
        $keyname = $_POST['keyname'];
        $keyfile = $_FILES["keyfile"]["tmp_name"];
        if (isset($_POST['password'])) {$password = $_POST['password'];}

        if ((strlen($inputfile) > 0) and (strlen($keyfile) > 0))
        {
            $in = new TMemoryStream;
            $in->LoadFromFile($inputfile);

            $xmldoc = new TElXMLDOMDocument();
            try
            {
                $xmldoc->LoadFromStream($in);
            }
            catch(SBException $e) 
            {
                print $e->getMessage();
                return;
            }

            $node = $xmldoc->get_FirstChild();
            while (!empty($node))
            {
                if ($node->ClassName_Inst() == 'TElXMLDOMElement') {break;}

                $node = $node->get_NextSibling();
            }

            $signer = new TElXMLSigner(NULL);
            try
            {
                switch ($signtype)
                {
                    case 1 : $signer->set_SignatureType(TElXMLSignatureType::xstEnveloping); break;
                    case 2 : $signer->set_SignatureType(TElXMLSignatureType::xstDetached); break;
                    default : $signer->set_SignatureType(TElXMLSignatureType::xstEnveloped);
                }

                switch ($canmethod)
                {
                    case 0 : $signer->set_CanonicalizationMethod(TElXMLCanonicalizationMethod::xcmCanon); break;
                    case 1 : $signer->set_CanonicalizationMethod(TElXMLCanonicalizationMethod::xcmCanonComment); break;
                    case 2 : $signer->set_CanonicalizationMethod(TElXMLCanonicalizationMethod::xcmCanon_v1_1); break;
                    case 3 : $signer->set_CanonicalizationMethod(TElXMLCanonicalizationMethod::xcmCanonComment_v1_1); break;
                    case 4 : $signer->set_CanonicalizationMethod(TElXMLCanonicalizationMethod::xcmExclCanon); break;
                    case 5 : $signer->set_CanonicalizationMethod(TElXMLCanonicalizationMethod::xcmExclCanonComment); break;
                    case 6 : $signer->set_CanonicalizationMethod(TElXMLCanonicalizationMethod::xcmMinCanon); break;
                    default : $signer->set_CanonicalizationMethod(TElXMLCanonicalizationMethod::xcmCanon);
                }

                if ($signmethod == 1)
                {
                    $signer->set_SignatureMethodType(TElXMLSigMethodType::xmtSig);

                    switch ($signature)
                    {
                        case 0 : $signer->set_SignatureMethod(TElXMLSignatureMethod::xsmDSS); break;
                        case 1 : $signer->set_SignatureMethod(TElXMLSignatureMethod::xsmRSA_SHA1); break;
                        case 2 : $signer->set_SignatureMethod(TElXMLSignatureMethod::xsmRSA_MD5); break;
                        case 3 : $signer->set_SignatureMethod(TElXMLSignatureMethod::xsmRSA_SHA256); break;
                        case 4 : $signer->set_SignatureMethod(TElXMLSignatureMethod::xsmRSA_SHA384); break;
                        case 5 : $signer->set_SignatureMethod(TElXMLSignatureMethod::xsmRSA_SHA512); break;
                        case 6 : $signer->set_SignatureMethod(TElXMLSignatureMethod::xsmRSA_RIPEMD160); break;
                        default : $signer->set_SignatureMethod(TElXMLSignatureMethod::xsmRSA_SHA1);
                    }
                }
                else
                {
                    $signer->set_SignatureMethodType(TElXMLSigMethodType::xmtMAC);

                    switch ($hmacsel)
                    {
                        case 0 : $signer->set_MACMethod(TElXMLMACMethod::xmmHMAC_MD5); break;
                        case 1 : $signer->set_MACMethod(TElXMLMACMethod::xmmHMAC_SHA1); break;
                        case 2 : $signer->set_MACMethod(TElXMLMACMethod::xmmHMAC_SHA224); break;
                        case 3 : $signer->set_MACMethod(TElXMLMACMethod::xmmHMAC_SHA256); break;
                        case 4 : $signer->set_MACMethod(TElXMLMACMethod::xmmHMAC_SHA384); break;
                        case 5 : $signer->set_MACMethod(TElXMLMACMethod::xmmHMAC_SHA512); break;
                        case 6 : $signer->set_MACMethod(TElXMLMACMethod::xmmHMAC_RIPEMD160); break;
                        default : $signer->set_MACMethod(TElXMLMACMethod::xmmHMAC_SHA1);
                    }
                }

                $signer->set_KeyName($keyname);
                $signer->set_IncludeKey($include);

                $signer->OnFormatElement = "FormatElement";
                $signer->OnFormatText = "FormatText";

                if ($signer->get_SignatureMethodType() == TElXMLSigMethodType::xmtMAC)
                {
                    $HMACKeyData = new TElXMLKeyInfoHMACData(True);

                    $data = file_get_contents($keyfile);
 
                    $HMACKeyData->get_Key()->set_Key_ByteArray($data);
                    $signer->set_KeyData($HMACKeyData);
                }
                else
                {
                    $RSAKeyData = new TElXMLKeyInfoRSAData(True);
                    $RSAKeyData->get_RSAKeyMaterial()->set_Passphrase($password);
                    $x509keydata = new TElXMLKeyInfoX509Data(True);
                    $PGPKeyData = new TElXMLKeyInfoPGPData(True);

                    $keystream = new TMemoryStream;
                    $keystream->LoadFromFile($keyfile);
                    $keystream->set_Position(0);

                    try
                    {
                        // trying to load file as RSA key material
                        $RSAKeyData->get_RSAKeyMaterial()->LoadSecret($keystream, $keystream->Size);
                    }
                    catch(SBException $e) {}

                    if (!$RSAKeyData->get_RSAKeyMaterial()->get_SecretKey())
                    {
                        // trying to load file as Certificate
                        $cert = new TElX509Certificate(NULL);
                        $r = $cert->LoadFromFileAuto($keyfile, $password);
                        if ($r == 0)
                        {
                            $x509keydata->set_Certificate($cert);
                        }
                    }

                    if (!$RSAKeyData->get_RSAKeyMaterial()->get_SecretKey() and
                        empty($x509keydata->get_Certificate()))
                    {
                        // trying to load file as PGP key
                        $keystream->set_Position(0);
                        $PGPkey = new TElPGPSecretKey();
                        $PGPKeyData->set_SecretKey($PGPkey);
                        try
                        {
                            $PGPKeyData->get_SecretKey()->CastTo()->LoadFromStream($keystream);
                            $PGPKeyData->get_SecretKey()->set_Passphrase($password);
                        }
                        catch(SBException $e)
                        {
                            $PGPKeyData->set_SecretKey(NULL);
                        }
                    }

                    if ($RSAKeyData->get_RSAKeyMaterial()->get_SecretKey())
                    {
                        $signer->set_KeyData($RSAKeyData);
                    }
                    else
                    if (!empty($x509keydata->get_Certificate()))
                    {
                        if (!$x509keydata->get_Certificate()->get_PrivateKeyExists())
                        {
                            print "The selected certificate doesn't contain a private key.";
                            return;
                        }

                        $signer->set_KeyData($x509keydata);
                    }
                    else
                    if (!empty($PGPKeyData->get_SecretKey()))
                    {
                        $signer->set_KeyData($PGPKeyData);
                    }
                    else
                    {
                        print "No Key/Certificate loaded.";
                        return;
                    }

                    $RSAKeyData->detachHandle();
                    $x509keydata->detachHandle();
                    $PGPKeyData->detachHandle();
                }

                $signer->GenerateSignature();

                $signode = new TElXMLDOMNode();
                if ($signer->get_SignatureType() == TElXMLSignatureType::xstDetached)
                {
                    // detached signature is always placed in a new xml document
                    $xmldoc = NULL;
                    try
                    {
                        $xmldoc = $signer->SaveDetached();
                    }
                    catch(SBException $e)
                    {
                        print 'Failed to sign data and to save the signature: (' . $e->getMessage() . ')';
                        return;
                    }
                }
                else
                {
                    $signode = $node->CastTo();
                    if ($signode->ClassName_Inst() == 'TElXMLDOMDocument')
                    {
                        $signode = $signode->CastTo()->get_DocumentElement();
                    }

                    try
                    {
                        // If the signature type is enveloping, then the signature is placed into the passed node and the contents of the node are moved to inside of the signature.
                        // If the signature type is enveloped, the signature is placed as a child of the passed node.
                        $signer->Save($signode);
                    }
                    catch(SBException $e)
                    {
                        print 'Failed to sign data and to save the signature: (' . $e->getMessage() . ')';
                        return;
                    }
                }

                //$HMACKeyData->detachHandle();

                $out = new TMemoryStream;
                $xmldoc->SaveToStream($out);

                $yourfile = basename($filename) . ".tmp";
                $tempname = tempnam(sys_get_temp_dir(), $yourfile);

                $out->SaveToFile($tempname);

                if (ob_get_level()) 
                {
                    ob_end_clean();
                }

                header('Content-Description: File Transfer');
                header('Content-Type: application/octet-stream');
                header("Content-Disposition: attachment; filename=$filename");
                header('Content-Transfer-Encoding: binary');
                header('Expires: 0');
                header('Cache-Control: must-revalidate');
                header('Pragma: public');
                header('Content-Length: ' . filesize($tempname));
                readfile($tempname);

                unlink($tempname);

                //print "Ok";
                return;
            }
            catch(SBException $e) 
            {
                print $e->getMessage();
            }
        }
        else
        {
            $error_details = "";

            if (strlen($inputfile) == 0)
            {
                $error_details = $error_details . "XML file is not provided<br/>";
            }
            if (strlen($keyfile) == 0)
            {
                $error_details = $error_details . "Key/Certificate file is not provided <br/>";
            }

            print "Parameters missing: <br/><br/>" . $error_details;
        }
    }
?>

<html>
<head>
  <title>EldoS XML demo</title>
  <style type="text/css">
  .textheader {
    font-family: Arial;
    font-size: 16;
    font-weight: bold;
  }
  .textnormal {
    font-family: Arial;
    font-size: 12;
  }
  </style>
</head>
<body>
  <div align="center">
  <table border="0" cellspacing="0" cellpadding="0" width="600" height="100%">
    <tr height="*"></tr>
    <tr height="400">
      <td width="600" valign="top">
        <table border="0" cellspacing="0" cellpadding="10" width="100%" height="100%" style="border: 1px solid #bbbbbb;" bgcolor="#f6f6f6">
          <tr height="50">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textheader">EldoS SecureBlackbox XML demo</div>
            </td>
          </tr>
          <tr height="70">
            <td width="100%" height="*" align="center" valign="center" class="textnormal">
              <div align="center"> This sample illustrates the use of SecureBlackbox XML components for signing xml files. <br/>
              Please provide file, signature options and click the 'Sign' button to sign xml file. </div>
            </td>
          </tr>
          <tr height="*">
            <td width="100%" height="*">
              <form method="post" enctype="multipart/form-data">
                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                  <tr height="40">
                    <td width="40%" align="right"> XML file: </td>
                    <td width="10"></td>
                    <td width="*" align="left"> <input type="file" name="inputfile" value="" accept="application/xml" size="30" /> </td>
                  </tr>
                  <tr height="30">
                    <td colspan="3" align="left">
                      <fieldset>
                        <legend> Signature options </legend>
                        <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                          <tr height="30">
                            <td width="*">
                              <fieldset>
                                <legend> General  </legend>
                                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                                  <tr height="30">
                                    <td width="40%" align="right"> Signature type </td>
                                    <td width="10" > &nbsp;&nbsp; </td>
                                    <td width="*" align="left">
                                      <select name="signtype" size="1" >
                                        <option value=0 selected>Enveloped</option>
                                        <option value=1>Enveloping</option>
                                        <option value=2>Detached</option>
                                      </select>
                                    </td>
                                  </tr>
                                  <tr height="30">
                                    <td width="40%" align="right"> Canonicalization method </td>
                                    <td width="10" > </td>
                                    <td width="*" align="left">
                                      <select name="canmethod" size="1">
                                        <option value=0 selected>Canonical</option>
                                        <option value=1>Canonical with comments</option>
                                        <option value=2>Canonical v1.1</option>
                                        <option value=3>Canonical with comments v1.1</option>
                                        <option value=4>Exclusive canonical</option>
                                        <option value=5>Exclusive canonical with comments</option>
                                        <option value=6>Minimal canonical</option>
                                      </select>
                                    </td>
                                  </tr>
                                </table>
                              </fieldset>
                            </td>
                          </tr>
                          <tr height="30">
                            <td width="*">
                              <fieldset>
                                <legend> Signature method type </legend>
                                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                                  <tr height="30">
                                    <td width="40%" align="left"> <label> <input type="radio" name="signmethod" value="0" checked onchange="this.form.hmacsel.disabled=!this.form.signmethod[0].checked;this.form.signature.disabled=!this.form.signmethod[1].checked;this.form.password.disabled=!this.form.signmethod[1].checked"> HMAC method </label> </td>
                                    <td width="10"></td>
                                    <td width="*" align="left">
                                      <select name="hmacsel" size="1" >
                                        <option value=0>MD5</option>
                                        <option value=1 selected>SHA1</option>
                                        <option value=2>SHA224</option>
                                        <option value=3>SHA256</option>
                                        <option value=4>SHA384</option>
                                        <option value=5>SHA512</option>
                                        <option value=6>RIPEMD160</option>
                                      </select>
                                    </td>
                                  </tr>
                                  <tr height="30">
                                    <td width="40%" align="left"> <label> <input type="radio" name="signmethod" value="1" onchange="this.form.hmacsel.disabled=!this.form.signmethod[0].checked;this.form.signature.disabled=!this.form.signmethod[1].checked;this.form.password.disabled=!this.form.signmethod[1].checked"> Signature method </label> </td>
                                    <td width="10"></td>
                                    <td width="*" align="left">
                                      <select name="signature" size="1" disabled>
                                        <option value=0>DSS</option>
                                        <option value=1 selected>RSA SHA1</option>
                                        <option value=2>RSA MD5</option>
                                        <option value=3>RSA SHA256</option>
                                        <option value=4>RSA SHA384</option>
                                        <option value=5>RSA SHA512</option>
                                        <option value=6>RSA RIPEMD160</option>
                                      </select>
                                    </td>
                                  </tr>
                                </table>
                              </fieldset>
                            </td>
                          </tr>
                          <tr height="30">
                            <td width="*">
                              <fieldset>
                                <legend> Key Info </label> </legend>
                                <table border="0" cellspacing="0" cellpadding="0" width="100%" height="100%" class="textnormal">
                                  <tr height="30">
                                    <td colspan=3 align="left"> <label> <input type="checkbox" name="include" value="" size="25" checked/> Include Key (public part) </label> </td>
                                    <td colspan=2 align="left"> </td>
                                  </tr>
                                  <tr height="30">
                                    <td width="25%" align="left"> Key name </td>
                                    <td width="*" align="left"> <input type="text" name="keyname" value="" size="18"/> </td>
                                    <td width="10" > &nbsp;&nbsp; </td>
                                    <td width="30%" align="left"> Key/Certificate file </td>
                                    <td width="*" align="left"> <input type="file" name="keyfile" value="" size="25"/> </td>
                                  </tr>
                                  <tr height="30">
                                    <td width="25%" align="left"> </td>
                                    <td width="*" align="left"> </td>
                                    <td width="10" > &nbsp;&nbsp; </td>
                                    <td width="30%" align="left"> Key/Certificate password </td>
                                    <td colspan=4 align="left"> <input type="password" name="password" value="" size="25" disabled/> </td>
                                  </tr>
                                </table>
                              </fieldset>
                            </td>
                          </tr>
                        </table>
                      </fieldset>
                    </td>
                  </tr>
                  <tr height="45" valign="center">
                    <td colspan="3" align="center"> <input type="submit" name="sign" value="Sign"/> </td>
                  </tr>
                  <tr height="30" valign="bottom">
                    <td colspan="3" align="center"> Please inspect the source code of this script for more details. </td>
                  </tr>
                </table>
              </form>
            </td>
          </tr>
          <tr height="20">
            <td width="100%" valign="center" bgcolor="#e6e6e6">
              <div align="center" class="textnormal">Copyright &copy; EldoS Corporation <a href="http://www.eldos.com/">www.eldos.com</a></div>
            </td>
          </tr>
        </table>
      </td>
    </tr>
    <tr height="*"></tr>
  </table>
  </div>  
</body>
</html>