#include "sbawsdatastorage.h"

zend_class_entry *TSBAWSProtocol_ce_ptr = NULL;

zend_class_entry *TSBAWSAuthType_ce_ptr = NULL;

zend_class_entry *TSBAWSS3ReadObjectCondition_ce_ptr = NULL;

zend_class_entry *TSBAWSS3BucketAccessType_ce_ptr = NULL;

zend_class_entry *TSBAWSS3AccessControlGranteeType_ce_ptr = NULL;

zend_class_entry *TSBAWSS3AccessControlPermission_ce_ptr = NULL;

zend_class_entry *TSBAWSS3BucketVersioning_ce_ptr = NULL;

zend_class_entry *TSBAWSS3DataStorageOption_ce_ptr = NULL;

zend_class_entry *TSBAWSS3DataStorageOptions_ce_ptr = NULL;

zend_class_entry *TSBAWSS3Region_ce_ptr = NULL;

void SB_CALLBACK TSBAWSS3BeforeRequestSigningEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPSClientHandle HttpClient)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zHttpClient;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHttpClient);
	SBInitObject(zHttpClient, TElHTTPSClient_ce_ptr, HttpClient TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zHttpClient;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHttpClient);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElAWSS3DataStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElAWSS3DataStorage, AcquireObject)
{
	char *sBucketName;
	char *sKey;
	int sBucketName_len;
	int sKey_len;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sBucketName, &sBucketName_len, &sKey, &sKey_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_AcquireObject(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_AcquireObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &sKey, &sKey_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_AcquireObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), sKey, (int32_t)sKey_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_AcquireObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (string, string, TStringList) or (TElAWSS3DataStorageBucket, string) or ()" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (string, string, TElStringList) or (TElAWSS3DataStorageBucket, string) or ()" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, List)
{
	char *sBucketName;
	char *sDelimiter;
	char *sPrefix;
	int sBucketName_len;
	int sDelimiter_len;
	int sPrefix_len;
	long l4MaxCount;
	zval *oBucket;
	zval *oHeaders;
	zval *oObjects;
	zval *oObjs;
	zval *oPrefixes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_List(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sBucketName, &sBucketName_len, &oObjects, TElDataStorageObjectList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sBucketName, &sBucketName_len, &oObjects, TElDataStorageObjectList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_List_1(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oObjects TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_List_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sslO!O!", &sBucketName, &sBucketName_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sslO!O!", &sBucketName, &sBucketName_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_List_3(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oObjects TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, (int32_t)l4MaxCount, SBGetObjectHandle(oPrefixes TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjs, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_List_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjs TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TElDataStorageObjectList) or (string, TElDataStorageObjectList, TStringList) or (TElAWSS3DataStorageBucket, TElDataStorageObjectList) or (string, TElDataStorageObjectList, string, string, integer, TStringList, TStringList) or (TElDataStorageObjectList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElDataStorageObjectList) or (string, TElDataStorageObjectList, TElStringList) or (TElAWSS3DataStorageBucket, TElDataStorageObjectList) or (string, TElDataStorageObjectList, string, string, integer, TElStringList, TElStringList) or (TElDataStorageObjectList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, ListInit)
{
	char *sBucketName;
	char *sDelimiter;
	char *sPrefix;
	int sBucketName_len;
	int sDelimiter_len;
	int sPrefix_len;
	zval *oHeaders;
	zval *oPrefixes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_ListInit(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!O!", &sBucketName, &sBucketName_len, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!O!", &sBucketName, &sBucketName_len, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_ListInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, SBGetObjectHandle(oPrefixes TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (string, string, string, TStringList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (string, string, string, TElStringList, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, ListNext)
{
	long l4MaxCount;
	zval *oObjects;
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oState, TElAWSS3DataStorageListState_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_ListNext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oState, TElAWSS3DataStorageListState_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr, &l4MaxCount) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_ListNext_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC), (int32_t)l4MaxCount) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAWSS3DataStorageListState, TElDataStorageObjectList) or (TElAWSS3DataStorageListState, TElDataStorageObjectList, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, ListFinal)
{
	TElClassHandle hoState;
	zval *oState;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oState, TElAWSS3DataStorageListState_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oState) && (IS_OBJECT == Z_TYPE_P(oState)))
	{
		hoState = SBGetObjectHandle(oState TSRMLS_CC);
		SBCheckError(TElAWSS3DataStorage_ListFinal(SBGetObjectHandle(getThis() TSRMLS_CC), &hoState) TSRMLS_CC);
		SBUpdateObjectHandle(oState, hoState TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElAWSS3DataStorageListState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, CreateObject)
{
	char *sBucketName;
	char *sContentDisposition;
	char *sContentEncoding;
	char *sContentType;
	char *sObjName;
	char *sStorageClass;
	int sBucketName_len;
	int sContentDisposition_len;
	int sContentEncoding_len;
	int sContentType_len;
	int sObjName_len;
	int sStorageClass_len;
	zval *oBucket;
	zval *oHandler;
	zval *oHeaders;
	zval *oMetadata;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sBucketName, &sBucketName_len, &sObjName, &sObjName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sObjName, (int32_t)sObjName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &sObjName, &sObjName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CreateObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), sObjName, (int32_t)sObjName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sObjName, &sObjName_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CreateObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sObjName, (int32_t)sObjName_len, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &sObjName, &sObjName_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CreateObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), sObjName, (int32_t)sObjName_len, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!O!O!", &sBucketName, &sBucketName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!O!O!", &sBucketName, &sBucketName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CreateObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sObjName, (int32_t)sObjName_len, sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!O!O!", &sBucketName, &sBucketName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!O!O!", &sBucketName, &sBucketName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CreateObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sObjName, (int32_t)sObjName_len, sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssssO!O!O!", &sBucketName, &sBucketName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssssO!O!O!", &sBucketName, &sBucketName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CreateObject_6(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sObjName, (int32_t)sObjName_len, sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sContentEncoding, (int32_t)sContentEncoding_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (TElAWSS3DataStorageBucket, string) or (string, string, TElCustomDataStorageSecurityHandler) or (TElAWSS3DataStorageBucket, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (TElAWSS3DataStorageBucket, string) or (string, string, TElCustomDataStorageSecurityHandler) or (TElAWSS3DataStorageBucket, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, DeleteObject)
{
	char *sBucketName;
	char *sKey;
	int sBucketName_len;
	int sKey_len;
	TElClassHandle hoObj;
	zval *oHeaders;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sBucketName, &sBucketName_len, &sKey, &sKey_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_DeleteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oObj, TElAWSS3DataStorageObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oObj) && (IS_OBJECT == Z_TYPE_P(oObj)))
	{
		hoObj = SBGetObjectHandle(oObj TSRMLS_CC);
		SBCheckError(TElAWSS3DataStorage_DeleteObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoObj) TSRMLS_CC);
		SBUpdateObjectHandle(oObj, hoObj TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_DeleteObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oObj, TElCustomDataStorageObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oObj) && (IS_OBJECT == Z_TYPE_P(oObj)))
	{
		hoObj = SBGetObjectHandle(oObj TSRMLS_CC);
		SBCheckError(TElAWSS3DataStorage_DeleteObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), &hoObj) TSRMLS_CC);
		SBUpdateObjectHandle(oObj, hoObj TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (&TElAWSS3DataStorageObject) or (string, string, TStringList) or (&TElCustomDataStorageObject)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (&TElAWSS3DataStorageObject) or (string, string, TElStringList) or (&TElCustomDataStorageObject)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, ObjectExists)
{
	char *sBucketName;
	char *sKey;
	int sBucketName_len;
	int sKey_len;
	zval *oHeaders;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sBucketName, &sBucketName_len, &sKey, &sKey_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_ObjectExists(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElAWSS3DataStorageObject_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_ObjectExists_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_ObjectExists_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (TElAWSS3DataStorageObject) or (string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (TElAWSS3DataStorageObject) or (string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, RefreshObject)
{
	zval *oHeaders;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElAWSS3DataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_RefreshObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_RefreshObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TElAWSS3DataStorageObject) or (TElAWSS3DataStorageObject, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElAWSS3DataStorageObject) or (TElAWSS3DataStorageObject, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, WriteObject)
{
	char *sBucketName;
	char *sContentDisposition;
	char *sContentEncoding;
	char *sContentType;
	char *sKey;
	char *sNewETag;
	char *sStorageClass;
	int sBucketName_len;
	int sContentDisposition_len;
	int sContentEncoding_len;
	int sContentType_len;
	int sKey_len;
	int sStorageClass_len;
	int32_t sNewETag_len;
	uint32_t _err;
	zval *oData;
	zval *oHandler;
	zval *oHeaders;
	zval *oMetadata;
	zval *oObj;
	zval *oStrm;
	zval *zsNewETag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_WriteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!ssO!O!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!ssO!O!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_WriteObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sssO!O!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sssO!O!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_WriteObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!ssssO!O!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!ssssO!O!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_WriteObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sContentEncoding, (int32_t)sContentEncoding_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!ssssO!O!O!z", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &zsNewETag) == SUCCESS) && PZVAL_IS_REF(zsNewETag) && (IS_STRING == Z_TYPE_P(zsNewETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!ssssO!O!O!z", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &zsNewETag) == SUCCESS) && PZVAL_IS_REF(zsNewETag) && (IS_STRING == Z_TYPE_P(zsNewETag)))
#endif
	{
		sNewETag = Z_STRVAL_P(zsNewETag);
		sNewETag_len = (int32_t)Z_STRLEN_P(zsNewETag);
		_err = TElAWSS3DataStorage_WriteObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sContentEncoding, (int32_t)sContentEncoding_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), sNewETag, &sNewETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sNewETag = emalloc(sNewETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(530716965, 11, sNewETag, &sNewETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-52087068, 11, sNewETag, &sNewETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsNewETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sNewETag[sNewETag_len] = 0;
		ZVAL_STRINGL(zsNewETag, sNewETag, sNewETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ssO!O!O!", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ssO!O!O!", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_WriteObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!sssO!O!O!", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!sssO!O!O!", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_WriteObject_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ssssO!O!O!", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ssssO!O!O!", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_WriteObject_7(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sContentEncoding, (int32_t)sContentEncoding_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_WriteObject_8(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, TStream, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler, &string) or (TElAWSS3DataStorageObject, TStream, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler) or (TElAWSS3DataStorageObject, TStream, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler) or (TElAWSS3DataStorageObject, TStream, string, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler) or (TElCustomDataStorageObject, TStream, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, TStream, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler, &string) or (TElAWSS3DataStorageObject, TStream, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler) or (TElAWSS3DataStorageObject, TStream, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler) or (TElAWSS3DataStorageObject, TStream, string, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler) or (TElCustomDataStorageObject, TStream, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, ReadObject)
{
	char *sBucketName;
	char *sETag;
	char *sKey;
	char *sObjContentDisposition;
	char *sObjContentEncoding;
	char *sObjContentType;
	char *sObjETag;
	int sBucketName_len;
	int sETag_len;
	int sKey_len;
	int32_t sObjContentDisposition_len;
	int32_t sObjContentEncoding_len;
	int32_t sObjContentType_len;
	int32_t sObjETag_len;
	long fCondition;
	uint32_t _err;
	zval *dtDateTime;
	zval *oHeaders;
	zval *oMetadata;
	zval *oObj;
	zval *oStrm;
	zval *zsObjContentDisposition;
	zval *zsObjContentEncoding;
	zval *zsObjContentType;
	zval *zsObjETag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_ReadObject(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOs", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_ReadObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lOs", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_ReadObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOsO!O!zzz", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOsO!O!zzz", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorage_ReadObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(206883784, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1753820797, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(206883784, 10, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1753820797, 10, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(206883784, 11, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1753820797, 11, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOsO!O!zzzz", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOsO!O!zzzz", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorage_ReadObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjContentEncoding, &sObjContentEncoding_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1638228073, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-794524852, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1638228073, 10, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-794524852, 10, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1638228073, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-794524852, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1638228073, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-794524852, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lOsO!O!zzz", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lOsO!O!zzz", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorage_ReadObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1684606921, 8, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(152408534, 8, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1684606921, 9, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(152408534, 9, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1684606921, 10, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(152408534, 10, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lOsO!O!zzzz", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lOsO!O!zzzz", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorage_ReadObject_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjContentEncoding, &sObjContentEncoding_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1492720684, 8, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1306886139, 8, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1492720684, 9, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1306886139, 9, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1492720684, 10, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1306886139, 10, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1492720684, 11, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1306886139, 11, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_ReadObject_7(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, TStream) or (string, string, TStream, integer, DateTime, string) or (TElAWSS3DataStorageObject, TStream, integer, DateTime, string) or (string, string, TStream, integer, DateTime, string, TStringList, TStringList, &string, &string, &string) or (string, string, TStream, integer, DateTime, string, TStringList, TStringList, &string, &string, &string, &string) or (TElAWSS3DataStorageObject, TStream, integer, DateTime, string, TStringList, TStringList, &string, &string, &string) or (TElAWSS3DataStorageObject, TStream, integer, DateTime, string, TStringList, TStringList, &string, &string, &string, &string) or (TElCustomDataStorageObject, TStream)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, TStream) or (string, string, TStream, integer, DateTime, string) or (TElAWSS3DataStorageObject, TStream, integer, DateTime, string) or (string, string, TStream, integer, DateTime, string, TElStringList, TElStringList, &string, &string, &string) or (string, string, TStream, integer, DateTime, string, TElStringList, TElStringList, &string, &string, &string, &string) or (TElAWSS3DataStorageObject, TStream, integer, DateTime, string, TElStringList, TElStringList, &string, &string, &string) or (TElAWSS3DataStorageObject, TStream, integer, DateTime, string, TElStringList, TElStringList, &string, &string, &string, &string) or (TElCustomDataStorageObject, TStream)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, ReadBlock)
{
	char *sBucketName;
	char *sETag;
	char *sKey;
	char *sObjContentDisposition;
	char *sObjContentEncoding;
	char *sObjContentType;
	char *sObjETag;
	int sBucketName_len;
	int sETag_len;
	int sKey_len;
	int32_t sObjContentDisposition_len;
	int32_t sObjContentEncoding_len;
	int32_t sObjContentType_len;
	int32_t sObjETag_len;
	int64_t l8ReadRaw;
	long fCondition;
	long l8Offset;
	long l8Size;
	uint32_t _err;
	zval *dtDateTime;
	zval *oHeaders;
	zval *oMetadata;
	zval *oObj;
	zval *oStrm;
	zval *zl8Read;
	zval *zsObjContentDisposition;
	zval *zsObjContentEncoding;
	zval *zsObjContentType;
	zval *zsObjETag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llz", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElAWSS3DataStorage_ReadBlock(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOs", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElAWSS3DataStorage_ReadBlock_1(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llzlOs", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElAWSS3DataStorage_ReadBlock_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOsO!O!zzz", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOsO!O!zzz", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorage_ReadBlock_3(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1319450842, 12, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2086667181, 12, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1319450842, 13, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2086667181, 13, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1319450842, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2086667181, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOsO!O!zzzz", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOsO!O!zzzz", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorage_ReadBlock_4(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjContentEncoding, &sObjContentEncoding_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1947529052, 12, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(188541942, 12, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1947529052, 13, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(188541942, 13, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1947529052, 14, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(188541942, 14, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1947529052, 15, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(188541942, 15, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llzlOsO!O!zzz", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llzlOsO!O!zzz", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorage_ReadBlock_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-611486676, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1210353634, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-611486676, 12, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1210353634, 12, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-611486676, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1210353634, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llzlOsO!O!zzzz", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llzlOsO!O!zzzz", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorage_ReadBlock_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjContentEncoding, &sObjContentEncoding_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1036576927, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(771852346, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1036576927, 12, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(771852346, 12, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1036576927, 13, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(771852346, 13, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1036576927, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(771852346, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llz", &oObj, TElCustomDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElAWSS3DataStorage_ReadBlock_7(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, TStream, integer, integer, &integer) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string) or (TElAWSS3DataStorageObject, TStream, integer, integer, &integer, integer, DateTime, string) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, TStringList, TStringList, &string, &string, &string) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, TStringList, TStringList, &string, &string, &string, &string) or (TElAWSS3DataStorageObject, TStream, integer, integer, &integer, integer, DateTime, string, TStringList, TStringList, &string, &string, &string) or (TElAWSS3DataStorageObject, TStream, integer, integer, &integer, integer, DateTime, string, TStringList, TStringList, &string, &string, &string, &string) or (TElCustomDataStorageObject, TStream, integer, integer, &integer)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, TStream, integer, integer, &integer) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string) or (TElAWSS3DataStorageObject, TStream, integer, integer, &integer, integer, DateTime, string) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, TElStringList, TElStringList, &string, &string, &string) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, TElStringList, TElStringList, &string, &string, &string, &string) or (TElAWSS3DataStorageObject, TStream, integer, integer, &integer, integer, DateTime, string, TElStringList, TElStringList, &string, &string, &string) or (TElAWSS3DataStorageObject, TStream, integer, integer, &integer, integer, DateTime, string, TElStringList, TElStringList, &string, &string, &string, &string) or (TElCustomDataStorageObject, TStream, integer, integer, &integer)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, CopyObject)
{
	char *sDestBucketName;
	char *sDestKey;
	char *sETag;
	char *sSourceBucketName;
	char *sSourceKey;
	char *sStorageClass;
	int sDestBucketName_len;
	int sDestKey_len;
	int sETag_len;
	int sSourceBucketName_len;
	int sSourceKey_len;
	int sStorageClass_len;
	long fCondition;
	zend_bool bPreserveMetadata;
	zval *dtDateTime;
	zval *oHeaders;
	zval *oMetadata;
	zval *oNewHandler;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!", &sSourceBucketName, &sSourceBucketName_len, &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceBucketName, (int32_t)sSourceBucketName_len, sSourceKey, (int32_t)sSourceKey_len, sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssO!", &oObj, TElAWSS3DataStorageObject_ce_ptr, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CopyObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssbO!", &sSourceBucketName, &sSourceBucketName_len, &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssbO!", &sSourceBucketName, &sSourceBucketName_len, &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CopyObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceBucketName, (int32_t)sSourceBucketName_len, sSourceKey, (int32_t)sSourceKey_len, sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssslOsbO!O!", &sSourceBucketName, &sSourceBucketName_len, &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssslOsbO!O!", &sSourceBucketName, &sSourceBucketName_len, &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CopyObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceBucketName, (int32_t)sSourceBucketName_len, sSourceKey, (int32_t)sSourceKey_len, sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssslOssbO!O!", &sSourceBucketName, &sSourceBucketName_len, &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &sStorageClass, &sStorageClass_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssslOssbO!O!", &sSourceBucketName, &sSourceBucketName_len, &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &sStorageClass, &sStorageClass_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CopyObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceBucketName, (int32_t)sSourceBucketName_len, sSourceKey, (int32_t)sSourceKey_len, sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, sStorageClass, (int32_t)sStorageClass_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CopyObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, string, string, TElCustomDataStorageSecurityHandler) or (TElAWSS3DataStorageObject, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, bool, TStringList) or (string, string, string, string, integer, DateTime, string, bool, TStringList, TStringList) or (string, string, string, string, integer, DateTime, string, string, bool, TStringList, TStringList) or (TElCustomDataStorageObject, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, string, string, TElCustomDataStorageSecurityHandler) or (TElAWSS3DataStorageObject, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, bool, TElStringList) or (string, string, string, string, integer, DateTime, string, bool, TElStringList, TElStringList) or (string, string, string, string, integer, DateTime, string, string, bool, TElStringList, TElStringList) or (TElCustomDataStorageObject, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, GetObjectACL)
{
	char *sBucketName;
	char *sKey;
	int sBucketName_len;
	int sKey_len;
	uint32_t _err;
	zval *oHeaders;
	zval *oObj;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sBucketName, &sBucketName_len, &sKey, &sKey_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetObjectACL(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2055158354, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElAWSS3DataStorageObject_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetObjectACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(475682920, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetObjectACL_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oHeaders TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(300585446, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1837593342, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_GetObjectACL_3(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_GetObjectACL_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_GetObjectACL_5(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oPolicy TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (TElAWSS3DataStorageObject) or (string, string, TStringList) or (string, string, TElAWSS3AccessControlPolicy) or (TElAWSS3DataStorageObject, TElAWSS3AccessControlPolicy) or (string, string, TElAWSS3AccessControlPolicy, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (TElAWSS3DataStorageObject) or (string, string, TElStringList) or (string, string, TElAWSS3AccessControlPolicy) or (TElAWSS3DataStorageObject, TElAWSS3AccessControlPolicy) or (string, string, TElAWSS3AccessControlPolicy, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, SetObjectACL)
{
	char *sACL;
	char *sBucketName;
	char *sKey;
	int sACL_len;
	int sBucketName_len;
	int sKey_len;
	zval *oHeaders;
	zval *oObj;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &sACL, &sACL_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetObjectACL(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, sACL, (int32_t)sACL_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oObj, TElAWSS3DataStorageObject_ce_ptr, &sACL, &sACL_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetObjectACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sACL, (int32_t)sACL_len) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &sACL, &sACL_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &sACL, &sACL_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_SetObjectACL_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, sACL, (int32_t)sACL_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetObjectACL_3(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetObjectACL_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_SetObjectACL_5(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oPolicy TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, string) or (TElAWSS3DataStorageObject, string) or (string, string, string, TStringList) or (string, string, TElAWSS3AccessControlPolicy) or (TElAWSS3DataStorageObject, TElAWSS3AccessControlPolicy) or (string, string, TElAWSS3AccessControlPolicy, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, string) or (TElAWSS3DataStorageObject, string) or (string, string, string, TElStringList) or (string, string, TElAWSS3AccessControlPolicy) or (TElAWSS3DataStorageObject, TElAWSS3AccessControlPolicy) or (string, string, TElAWSS3AccessControlPolicy, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, GetLocalETag)
{
	char *sFilename;
	int sFilename_len;
	uint32_t _err;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetLocalETag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-494985657, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetLocalETag_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1944342101, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, GetRemoteETag)
{
	char *sBucketName;
	char *sKey;
	int sBucketName_len;
	int sKey_len;
	uint32_t _err;
	zval *oHeaders;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sBucketName, &sBucketName_len, &sKey, &sKey_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetRemoteETag(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(901340877, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElAWSS3DataStorageObject_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetRemoteETag_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(23751074, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetRemoteETag_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oHeaders TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1754411105, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1198221704, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (TElAWSS3DataStorageObject) or (string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (TElAWSS3DataStorageObject) or (string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, GetObjectTorrent)
{
	char *sBucketName;
	char *sKey;
	int sBucketName_len;
	int sKey_len;
	zval *oHeaders;
	zval *oObj;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_GetObjectTorrent(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElAWSS3DataStorageObject_ce_ptr, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_GetObjectTorrent_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oHeaders, TStringList_ce_ptr, &oStream, TStream_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sBucketName, &sBucketName_len, &sKey, &sKey_len, &oHeaders, TElStringList_ce_ptr, &oStream, TStream_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_GetObjectTorrent_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, TStream) or (TElAWSS3DataStorageObject, TStream) or (string, string, TStringList, TStream)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, TStream) or (TElAWSS3DataStorageObject, TStream) or (string, string, TElStringList, TStream)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, AcquireBucket)
{
	char *sBucketName;
	int sBucketName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_AcquireBucket(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageBucket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, ReleaseBucket)
{
	TElClassHandle hoBucket;
	zval *oBucket;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oBucket, TElAWSS3DataStorageBucket_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oBucket) && (IS_OBJECT == Z_TYPE_P(oBucket)))
	{
		hoBucket = SBGetObjectHandle(oBucket TSRMLS_CC);
		SBCheckError(TElAWSS3DataStorage_ReleaseBucket(SBGetObjectHandle(getThis() TSRMLS_CC), &hoBucket) TSRMLS_CC);
		SBUpdateObjectHandle(oBucket, hoBucket TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElAWSS3DataStorageBucket)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, CreateBucket)
{
	char *sACL;
	char *sBucketName;
	char *sLocation;
	int sACL_len;
	int sBucketName_len;
	int sLocation_len;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CreateBucket(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageBucket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sBucketName, &sBucketName_len, &sLocation, &sLocation_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CreateBucket_1(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sLocation, (int32_t)sLocation_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageBucket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sBucketName, &sBucketName_len, &sLocation, &sLocation_len, &sACL, &sACL_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CreateBucket_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sLocation, (int32_t)sLocation_len, sACL, (int32_t)sACL_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageBucket_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sLocation, &sLocation_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sLocation, &sLocation_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CreateBucket_3(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sLocation, (int32_t)sLocation_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageBucket_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sBucketName, &sBucketName_len, &sLocation, &sLocation_len, &sACL, &sACL_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sBucketName, &sBucketName_len, &sLocation, &sLocation_len, &sACL, &sACL_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_CreateBucket_4(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sLocation, (int32_t)sLocation_len, sACL, (int32_t)sACL_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageBucket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (string, string) or (string, string, string) or (string, string, TStringList) or (string, string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (string, string) or (string, string, string) or (string, string, TElStringList) or (string, string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, DeleteBucket)
{
	char *sBucketName;
	int sBucketName_len;
	TElClassHandle hoBucket;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_DeleteBucket(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oBucket, TElAWSS3DataStorageBucket_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oBucket) && (IS_OBJECT == Z_TYPE_P(oBucket)))
	{
		hoBucket = SBGetObjectHandle(oBucket TSRMLS_CC);
		SBCheckError(TElAWSS3DataStorage_DeleteBucket_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoBucket) TSRMLS_CC);
		SBUpdateObjectHandle(oBucket, hoBucket TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_DeleteBucket_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (&TElAWSS3DataStorageBucket) or (string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (&TElAWSS3DataStorageBucket) or (string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, BucketExists)
{
	char *sBucketName;
	int sBucketName_len;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_BucketExists(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_BucketExists_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_BucketExists_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, GetBucketLocation)
{
	char *sBucketName;
	int sBucketName_len;
	uint32_t _err;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetBucketLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1377544022, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetBucketLocation_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-74177289, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetBucketLocation_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(318667035, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1648657492, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, GetBucketACL)
{
	char *sBucketName;
	int sBucketName_len;
	uint32_t _err;
	zval *oBucket;
	zval *oHeaders;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetBucketACL(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-145215488, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetBucketACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(938038036, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetBucketACL_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-366339808, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-323285736, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_GetBucketACL_3(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_GetBucketACL_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sBucketName, &sBucketName_len, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sBucketName, &sBucketName_len, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_GetBucketACL_5(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oPolicy TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TStringList) or (string, TElAWSS3AccessControlPolicy) or (TElAWSS3DataStorageBucket, TElAWSS3AccessControlPolicy) or (string, TElAWSS3AccessControlPolicy, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TElStringList) or (string, TElAWSS3AccessControlPolicy) or (TElAWSS3DataStorageBucket, TElAWSS3AccessControlPolicy) or (string, TElAWSS3AccessControlPolicy, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, SetBucketACL)
{
	char *sACL;
	char *sBucketName;
	int sACL_len;
	int sBucketName_len;
	zval *oBucket;
	zval *oHeaders;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sBucketName, &sBucketName_len, &sACL, &sACL_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketACL(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sACL, (int32_t)sACL_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &sACL, &sACL_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), sACL, (int32_t)sACL_len) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sACL, &sACL_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sACL, &sACL_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketACL_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sACL, (int32_t)sACL_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketACL_3(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketACL_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sBucketName, &sBucketName_len, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sBucketName, &sBucketName_len, &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketACL_5(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oPolicy TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (TElAWSS3DataStorageBucket, string) or (string, string, TStringList) or (string, TElAWSS3AccessControlPolicy) or (TElAWSS3DataStorageBucket, TElAWSS3AccessControlPolicy) or (string, TElAWSS3AccessControlPolicy, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (TElAWSS3DataStorageBucket, string) or (string, string, TElStringList) or (string, TElAWSS3AccessControlPolicy) or (TElAWSS3DataStorageBucket, TElAWSS3AccessControlPolicy) or (string, TElAWSS3AccessControlPolicy, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, GetBucketPolicy)
{
	char *sBucketName;
	int sBucketName_len;
	uint32_t _err;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetBucketPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1401384711, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetBucketPolicy_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(672623441, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetBucketPolicy_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1655103081, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-939514165, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, SetBucketPolicy)
{
	char *sBucketName;
	char *sPolicy;
	int sBucketName_len;
	int sPolicy_len;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sBucketName, &sBucketName_len, &sPolicy, &sPolicy_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sPolicy, (int32_t)sPolicy_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &sPolicy, &sPolicy_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketPolicy_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), sPolicy, (int32_t)sPolicy_len) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sPolicy, &sPolicy_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sPolicy, &sPolicy_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketPolicy_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sPolicy, (int32_t)sPolicy_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (TElAWSS3DataStorageBucket, string) or (string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (TElAWSS3DataStorageBucket, string) or (string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, DeleteBucketPolicy)
{
	char *sBucketName;
	int sBucketName_len;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_DeleteBucketPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_DeleteBucketPolicy_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_DeleteBucketPolicy_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, SetBucketPaymentConfiguration)
{
	char *sBucketName;
	char *sPaymentConfig;
	int sBucketName_len;
	int sPaymentConfig_len;
	zend_bool bRequesterPays;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sBucketName, &sBucketName_len, &sPaymentConfig, &sPaymentConfig_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketPaymentConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sPaymentConfig, (int32_t)sPaymentConfig_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sBucketName, &sBucketName_len, &bRequesterPays) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketPaymentConfiguration_1(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, (int8_t)bRequesterPays) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &sPaymentConfig, &sPaymentConfig_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketPaymentConfiguration_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), sPaymentConfig, (int32_t)sPaymentConfig_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &bRequesterPays) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketPaymentConfiguration_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), (int8_t)bRequesterPays) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sPaymentConfig, &sPaymentConfig_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sBucketName, &sBucketName_len, &sPaymentConfig, &sPaymentConfig_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketPaymentConfiguration_4(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sPaymentConfig, (int32_t)sPaymentConfig_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (string, bool) or (TElAWSS3DataStorageBucket, string) or (TElAWSS3DataStorageBucket, bool) or (string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (string, bool) or (TElAWSS3DataStorageBucket, string) or (TElAWSS3DataStorageBucket, bool) or (string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, GetBucketPaymentConfiguration)
{
	char *sBucketName;
	int sBucketName_len;
	uint32_t _err;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetBucketPaymentConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(301626485, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetBucketPaymentConfiguration_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1899548040, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_GetBucketPaymentConfiguration_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-724326620, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1542559634, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, IsRequesterPaysBucket)
{
	char *sBucketName;
	int sBucketName_len;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_IsRequesterPaysBucket(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_IsRequesterPaysBucket_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_IsRequesterPaysBucket_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, GetBucketVersioning)
{
	char *sBucketName;
	int sBucketName_len;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		TSBAWSS3BucketVersioningRaw fOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_GetBucketVersioning(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr) == SUCCESS)
	{
		TSBAWSS3BucketVersioningRaw fOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_GetBucketVersioning_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TSBAWSS3BucketVersioningRaw fOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_GetBucketVersioning_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, SetBucketVersioning)
{
	char *sBucketName;
	int sBucketName_len;
	long fValue;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sBucketName, &sBucketName_len, &fValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketVersioning(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, (TSBAWSS3BucketVersioningRaw)fValue) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &fValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketVersioning_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), (TSBAWSS3BucketVersioningRaw)fValue) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sBucketName, &sBucketName_len, &fValue, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sBucketName, &sBucketName_len, &fValue, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketVersioning_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, (TSBAWSS3BucketVersioningRaw)fValue, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, integer) or (TElAWSS3DataStorageBucket, integer) or (string, integer, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, integer) or (TElAWSS3DataStorageBucket, integer) or (string, integer, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, GetBucketNotificationConfiguration)
{
	char *sBucketName;
	int sBucketName_len;
	zval *oBucket;
	zval *oEvents;
	zval *oHeaders;
	zval *oTopics;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sBucketName, &sBucketName_len, &oTopics, TStringList_ce_ptr, &oEvents, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sBucketName, &sBucketName_len, &oTopics, TElStringList_ce_ptr, &oEvents, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_GetBucketNotificationConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oTopics TSRMLS_CC), SBGetObjectHandle(oEvents TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &oTopics, TStringList_ce_ptr, &oEvents, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &oTopics, TElStringList_ce_ptr, &oEvents, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_GetBucketNotificationConfiguration_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), SBGetObjectHandle(oTopics TSRMLS_CC), SBGetObjectHandle(oEvents TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!O!", &sBucketName, &sBucketName_len, &oTopics, TStringList_ce_ptr, &oEvents, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!O!", &sBucketName, &sBucketName_len, &oTopics, TElStringList_ce_ptr, &oEvents, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_GetBucketNotificationConfiguration_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oTopics TSRMLS_CC), SBGetObjectHandle(oEvents TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList, TStringList) or (TElAWSS3DataStorageBucket, TStringList, TStringList) or (string, TStringList, TStringList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList, TElStringList) or (TElAWSS3DataStorageBucket, TElStringList, TElStringList) or (string, TElStringList, TElStringList, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, SetBucketNotificationConfiguration)
{
	char *sBucketName;
	int sBucketName_len;
	zval *oBucket;
	zval *oEvents;
	zval *oHeaders;
	zval *oTopics;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sBucketName, &sBucketName_len, &oTopics, TStringList_ce_ptr, &oEvents, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sBucketName, &sBucketName_len, &oTopics, TElStringList_ce_ptr, &oEvents, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketNotificationConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oTopics TSRMLS_CC), SBGetObjectHandle(oEvents TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &oTopics, TStringList_ce_ptr, &oEvents, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &oTopics, TElStringList_ce_ptr, &oEvents, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketNotificationConfiguration_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), SBGetObjectHandle(oTopics TSRMLS_CC), SBGetObjectHandle(oEvents TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!O!", &sBucketName, &sBucketName_len, &oTopics, TStringList_ce_ptr, &oEvents, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!O!", &sBucketName, &sBucketName_len, &oTopics, TElStringList_ce_ptr, &oEvents, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketNotificationConfiguration_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oTopics TSRMLS_CC), SBGetObjectHandle(oEvents TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList, TStringList) or (TElAWSS3DataStorageBucket, TStringList, TStringList) or (string, TStringList, TStringList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList, TElStringList) or (TElAWSS3DataStorageBucket, TElStringList, TElStringList) or (string, TElStringList, TElStringList, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, GetBucketWebSiteConfiguration)
{
	char *sBucketName;
	char *sErrorDocument;
	char *sIndexDocument;
	int sBucketName_len;
	int32_t sErrorDocument_len;
	int32_t sIndexDocument_len;
	uint32_t _err;
	zval *oBucket;
	zval *oHeaders;
	zval *zsErrorDocument;
	zval *zsIndexDocument;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szz", &sBucketName, &sBucketName_len, &zsIndexDocument, &zsErrorDocument) == SUCCESS) && PZVAL_IS_REF(zsIndexDocument) && (IS_STRING == Z_TYPE_P(zsIndexDocument)) && PZVAL_IS_REF(zsErrorDocument) && (IS_STRING == Z_TYPE_P(zsErrorDocument)))
	{
		sIndexDocument = Z_STRVAL_P(zsIndexDocument);
		sIndexDocument_len = (int32_t)Z_STRLEN_P(zsIndexDocument);
		sErrorDocument = Z_STRVAL_P(zsErrorDocument);
		sErrorDocument_len = (int32_t)Z_STRLEN_P(zsErrorDocument);
		_err = TElAWSS3DataStorage_GetBucketWebSiteConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sIndexDocument, &sIndexDocument_len, sErrorDocument, &sErrorDocument_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sIndexDocument = emalloc(sIndexDocument_len + 1);
			SBCheckError(SBGetLastReturnStringA(228582688, 2, sIndexDocument, &sIndexDocument_len) TSRMLS_CC);
			zval_dtor(zsIndexDocument);
			sErrorDocument = emalloc(sErrorDocument_len + 1);
			SBCheckError(SBGetLastReturnStringA(228582688, 3, sErrorDocument, &sErrorDocument_len) TSRMLS_CC);
			zval_dtor(zsErrorDocument);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sIndexDocument[sIndexDocument_len] = 0;
		ZVAL_STRINGL(zsIndexDocument, sIndexDocument, sIndexDocument_len, 0);
		sErrorDocument[sErrorDocument_len] = 0;
		ZVAL_STRINGL(zsErrorDocument, sErrorDocument, sErrorDocument_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &zsIndexDocument, &zsErrorDocument) == SUCCESS) && PZVAL_IS_REF(zsIndexDocument) && (IS_STRING == Z_TYPE_P(zsIndexDocument)) && PZVAL_IS_REF(zsErrorDocument) && (IS_STRING == Z_TYPE_P(zsErrorDocument)))
	{
		sIndexDocument = Z_STRVAL_P(zsIndexDocument);
		sIndexDocument_len = (int32_t)Z_STRLEN_P(zsIndexDocument);
		sErrorDocument = Z_STRVAL_P(zsErrorDocument);
		sErrorDocument_len = (int32_t)Z_STRLEN_P(zsErrorDocument);
		_err = TElAWSS3DataStorage_GetBucketWebSiteConfiguration_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), sIndexDocument, &sIndexDocument_len, sErrorDocument, &sErrorDocument_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sIndexDocument = emalloc(sIndexDocument_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1536525938, 2, sIndexDocument, &sIndexDocument_len) TSRMLS_CC);
			zval_dtor(zsIndexDocument);
			sErrorDocument = emalloc(sErrorDocument_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1536525938, 3, sErrorDocument, &sErrorDocument_len) TSRMLS_CC);
			zval_dtor(zsErrorDocument);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sIndexDocument[sIndexDocument_len] = 0;
		ZVAL_STRINGL(zsIndexDocument, sIndexDocument, sIndexDocument_len, 0);
		sErrorDocument[sErrorDocument_len] = 0;
		ZVAL_STRINGL(zsErrorDocument, sErrorDocument, sErrorDocument_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szzO!", &sBucketName, &sBucketName_len, &zsIndexDocument, &zsErrorDocument, &oHeaders, TStringList_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zsIndexDocument) && (IS_STRING == Z_TYPE_P(zsIndexDocument)) && PZVAL_IS_REF(zsErrorDocument) && (IS_STRING == Z_TYPE_P(zsErrorDocument)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szzO!", &sBucketName, &sBucketName_len, &zsIndexDocument, &zsErrorDocument, &oHeaders, TElStringList_ce_ptr) == SUCCESS) && PZVAL_IS_REF(zsIndexDocument) && (IS_STRING == Z_TYPE_P(zsIndexDocument)) && PZVAL_IS_REF(zsErrorDocument) && (IS_STRING == Z_TYPE_P(zsErrorDocument)))
#endif
	{
		sIndexDocument = Z_STRVAL_P(zsIndexDocument);
		sIndexDocument_len = (int32_t)Z_STRLEN_P(zsIndexDocument);
		sErrorDocument = Z_STRVAL_P(zsErrorDocument);
		sErrorDocument_len = (int32_t)Z_STRLEN_P(zsErrorDocument);
		_err = TElAWSS3DataStorage_GetBucketWebSiteConfiguration_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sIndexDocument, &sIndexDocument_len, sErrorDocument, &sErrorDocument_len, SBGetObjectHandle(oHeaders TSRMLS_CC));
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sIndexDocument = emalloc(sIndexDocument_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1987729931, 2, sIndexDocument, &sIndexDocument_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1530631711, 2, sIndexDocument, &sIndexDocument_len) TSRMLS_CC);
#endif
			zval_dtor(zsIndexDocument);
			sErrorDocument = emalloc(sErrorDocument_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1987729931, 3, sErrorDocument, &sErrorDocument_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1530631711, 3, sErrorDocument, &sErrorDocument_len) TSRMLS_CC);
#endif
			zval_dtor(zsErrorDocument);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sIndexDocument[sIndexDocument_len] = 0;
		ZVAL_STRINGL(zsIndexDocument, sIndexDocument, sIndexDocument_len, 0);
		sErrorDocument[sErrorDocument_len] = 0;
		ZVAL_STRINGL(zsErrorDocument, sErrorDocument, sErrorDocument_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, &string, &string) or (TElAWSS3DataStorageBucket, &string, &string) or (string, &string, &string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, &string, &string) or (TElAWSS3DataStorageBucket, &string, &string) or (string, &string, &string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, SetBucketWebSiteConfiguration)
{
	char *sBucketName;
	char *sErrorDocument;
	char *sIndexDocument;
	int sBucketName_len;
	int sErrorDocument_len;
	int sIndexDocument_len;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sBucketName, &sBucketName_len, &sIndexDocument, &sIndexDocument_len, &sErrorDocument, &sErrorDocument_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketWebSiteConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sIndexDocument, (int32_t)sIndexDocument_len, sErrorDocument, (int32_t)sErrorDocument_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oBucket, TElAWSS3DataStorageBucket_ce_ptr, &sIndexDocument, &sIndexDocument_len, &sErrorDocument, &sErrorDocument_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketWebSiteConfiguration_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC), sIndexDocument, (int32_t)sIndexDocument_len, sErrorDocument, (int32_t)sErrorDocument_len) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sBucketName, &sBucketName_len, &sIndexDocument, &sIndexDocument_len, &sErrorDocument, &sErrorDocument_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sBucketName, &sBucketName_len, &sIndexDocument, &sIndexDocument_len, &sErrorDocument, &sErrorDocument_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_SetBucketWebSiteConfiguration_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sIndexDocument, (int32_t)sIndexDocument_len, sErrorDocument, (int32_t)sErrorDocument_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, string) or (TElAWSS3DataStorageBucket, string, string) or (string, string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, string) or (TElAWSS3DataStorageBucket, string, string) or (string, string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, DeleteBucketWebSiteConfiguration)
{
	char *sBucketName;
	int sBucketName_len;
	zval *oBucket;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sBucketName, &sBucketName_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_DeleteBucketWebSiteConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBucket, TElAWSS3DataStorageBucket_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_DeleteBucketWebSiteConfiguration_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBucket TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sBucketName, &sBucketName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_DeleteBucketWebSiteConfiguration_2(SBGetObjectHandle(getThis() TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (TElAWSS3DataStorageBucket) or (string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, ListBuckets)
{
	zval *oBuckets;
	zval *oHeaders;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBuckets, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBuckets, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_ListBuckets(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBuckets TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oBuckets, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oBuckets, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_ListBuckets_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBuckets TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oBuckets, TElAWSS3DataStorageBucketList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_ListBuckets_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBuckets TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oBuckets, TElAWSS3DataStorageBucketList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oBuckets, TElAWSS3DataStorageBucketList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorage_ListBuckets_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oBuckets TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList) or (TStringList, TStringList) or (TElAWSS3DataStorageBucketList) or (TElAWSS3DataStorageBucketList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList) or (TElStringList, TElStringList) or (TElAWSS3DataStorageBucketList) or (TElAWSS3DataStorageBucketList, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, PerformIAMRequest)
{
	char *sAddress;
	int sAddress_len;
	uint32_t _err;
	zval *oHeaders;
	zval *oParameters;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sAddress, &sAddress_len, &oParameters, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sAddress, &sAddress_len, &oParameters, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_PerformIAMRequest(SBGetObjectHandle(getThis() TSRMLS_CC), sAddress, (int32_t)sAddress_len, SBGetObjectHandle(oParameters TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1865719826, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1330373004, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStringList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElStringList, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_OutputStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_get_OutputStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TMemoryStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_Protocol)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAWSProtocolRaw fOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_Protocol(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_Protocol)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_Protocol(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAWSProtocolRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_AuthType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAWSAuthTypeRaw fOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_AuthType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_AuthType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_AuthType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAWSAuthTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_KeyID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_get_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1951604880, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_KeyID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_AccessKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_get_AccessKey(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2073704803, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_AccessKey)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_AccessKey(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_SecurityToken)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_get_SecurityToken(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1219946926, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_SecurityToken)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_SecurityToken(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_UseSSL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_UseSSL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_UseSSL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_UseSSL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_HTTPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_get_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_HTTPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHTTPSClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_AWSHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_get_AWSHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_UseCRCCheck)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_UseCRCCheck(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_UseCRCCheck)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_UseCRCCheck(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_UseDelayedPut)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_UseDelayedPut(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_UseDelayedPut)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_UseDelayedPut(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_UseURLEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_UseURLEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_UseURLEncoding)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_UseURLEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_UseVersion4Signatures)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_UseVersion4Signatures(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_UseVersion4Signatures)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_UseVersion4Signatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_Version4SignatureHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_Version4SignatureHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_Version4SignatureHashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_Version4SignatureHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_SecMetadataID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_get_SecMetadataID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1746451766, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_SecMetadataID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_SecMetadataID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_MultipartUploadPartSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_MultipartUploadPartSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_MultipartUploadPartSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_MultipartUploadPartSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_MultipartUploadThreshold)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_MultipartUploadThreshold(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_MultipartUploadThreshold)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_MultipartUploadThreshold(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_RetryCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_RetryCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_RetryCount)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_RetryCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_Options)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAWSS3DataStorageOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_Options(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_Options)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_Options(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAWSS3DataStorageOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_Overwrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_Overwrite(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_Overwrite)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_Overwrite(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_PassthroughMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_PassthroughMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_PassthroughMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_PassthroughMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_BucketAccessType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAWSS3BucketAccessTypeRaw fOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_BucketAccessType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_BucketAccessType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_BucketAccessType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAWSS3BucketAccessTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_EmbeddedMetadataMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_EmbeddedMetadataMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_EmbeddedMetadataMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_EmbeddedMetadataMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_BaseURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_get_BaseURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(242297417, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_BaseURL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_BaseURL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_RegionID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorage_get_RegionID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1684817239, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_RegionID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_RegionID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_Region)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAWSS3RegionRaw fOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorage_get_Region(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_Region)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorage_set_Region(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAWSS3RegionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, get_OnBeforeRequestSigning)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAWSS3BeforeRequestSigningEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_get_OnBeforeRequestSigning(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, set_OnBeforeRequestSigning)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElAWSS3DataStorage_set_OnBeforeRequestSigning(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBAWSS3BeforeRequestSigningEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBAWSS3BeforeRequestSigningEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_AcquireObject, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
	ZEND_ARG_INFO(0, Key)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_List, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket_or_Objs, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_Prefix, 0, 1)
	ZEND_ARG_INFO(0, Delimiter)
	ZEND_ARG_INFO(0, MaxCount)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Prefixes, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Prefixes, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_ListInit, 0, 0, 1)
	ZEND_ARG_INFO(0, BucketName)
	ZEND_ARG_INFO(0, Prefix)
	ZEND_ARG_INFO(0, Delimiter)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Prefixes, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Prefixes, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_ListNext, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, State, TElAWSS3DataStorageListState, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
	ZEND_ARG_INFO(0, MaxCount)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_ListFinal, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, State, TElAWSS3DataStorageListState, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_CreateObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
	ZEND_ARG_INFO(0, ObjName)
	ZEND_ARG_TYPE_INFO(0, Handler_or_ContentType, 0, 1)
	ZEND_ARG_INFO(0, ContentDisposition)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_StorageClass_or_ContentEncoding, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_Metadata_or_StorageClass, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Headers_or_Metadata, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Headers, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_DeleteObject, 0, 0, 1)
	ZEND_ARG_INFO(1, BucketName_or_Obj)
	ZEND_ARG_INFO(0, Key)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_ObjectExists, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, Key)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_RefreshObject, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Obj, TElAWSS3DataStorageObject, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_WriteObject, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Data_or_Strm, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Data_or_ContentType_or_Handler, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_ContentType_or_ContentDisposition, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ContentDisposition_or_Metadata_or_StorageClass_or_ContentEncoding, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_StorageClass_or_ContentEncoding_or_Headers, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_Metadata_or_StorageClass_or_Handler, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Headers_or_Metadata, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Headers, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
	ZEND_ARG_INFO(1, NewETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_ReadObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Strm, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Strm_or_Condition, 0, 1)
	ZEND_ARG_INFO(0, Condition_or_DateTime)
	ZEND_ARG_INFO(0, DateTime_or_ETag)
	ZEND_ARG_TYPE_INFO(0, ETag_or_Metadata, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Metadata_or_Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Metadata_or_Headers, TElStringList, 1)
#endif
	ZEND_ARG_TYPE_INFO(1, Headers_or_ObjContentType, 0, 1)
	ZEND_ARG_INFO(1, ObjContentType_or_ObjContentDisposition)
	ZEND_ARG_INFO(1, ObjContentDisposition_or_ObjETag_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_ReadBlock, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Strm, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Strm_or_Offset, 0, 1)
	ZEND_ARG_INFO(0, Offset_or_Size)
	ZEND_ARG_INFO(1, Size_or_Read)
	ZEND_ARG_INFO(1, Read_or_Condition)
	ZEND_ARG_INFO(0, Condition_or_DateTime)
	ZEND_ARG_INFO(0, DateTime_or_ETag)
	ZEND_ARG_TYPE_INFO(0, ETag_or_Metadata, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Metadata_or_Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Metadata_or_Headers, TElStringList, 1)
#endif
	ZEND_ARG_TYPE_INFO(1, Headers_or_ObjContentType, 0, 1)
	ZEND_ARG_INFO(1, ObjContentType_or_ObjContentDisposition)
	ZEND_ARG_INFO(1, ObjContentDisposition_or_ObjETag_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_CopyObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, SourceBucketName_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SourceKey_or_DestBucketName_or_NewHandler, 0, 1)
	ZEND_ARG_INFO(0, DestBucketName_or_DestKey)
	ZEND_ARG_TYPE_INFO(0, DestKey_or_NewHandler, 0, 1)
	ZEND_ARG_TYPE_INFO(0, NewHandler_or_PreserveMetadata_or_Condition, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_DateTime, 0, 1)
	ZEND_ARG_INFO(0, ETag)
	ZEND_ARG_INFO(0, PreserveMetadata_or_StorageClass)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_PreserveMetadata, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers_or_Metadata, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers_or_Metadata, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_GetObjectACL, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Policy, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_Policy, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_SetObjectACL, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_ACL_or_Policy, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ACL_or_Policy, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_GetLocalETag, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Stream_or_Filename, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_GetRemoteETag, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, Key)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_GetObjectTorrent, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Stream, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Stream_or_Headers, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_AcquireBucket, 0, 0, 1)
	ZEND_ARG_INFO(0, BucketName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_ReleaseBucket, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Bucket, TElAWSS3DataStorageBucket, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_CreateBucket, 0, 0, 1)
	ZEND_ARG_INFO(0, BucketName)
	ZEND_ARG_INFO(0, Location)
	ZEND_ARG_TYPE_INFO(0, ACL_or_Headers, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_DeleteBucket, 0, 0, 1)
	ZEND_ARG_INFO(1, BucketName_or_Bucket)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_BucketExists, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_GetBucketLocation, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_GetBucketACL, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_Policy, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_SetBucketACL, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ACL_or_Policy, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_GetBucketPolicy, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_SetBucketPolicy, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
	ZEND_ARG_INFO(0, Policy)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_DeleteBucketPolicy, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_SetBucketPaymentConfiguration, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
	ZEND_ARG_INFO(0, PaymentConfig_or_RequesterPays)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_GetBucketPaymentConfiguration, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_IsRequesterPaysBucket, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_GetBucketVersioning, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_SetBucketVersioning, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
	ZEND_ARG_INFO(0, Value)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_GetBucketNotificationConfiguration, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Topics, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Events, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Topics, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Events, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_SetBucketNotificationConfiguration, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Topics, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Events, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Topics, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Events, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_GetBucketWebSiteConfiguration, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
	ZEND_ARG_INFO(1, IndexDocument)
	ZEND_ARG_INFO(1, ErrorDocument)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_SetBucketWebSiteConfiguration, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
	ZEND_ARG_INFO(0, IndexDocument)
	ZEND_ARG_INFO(0, ErrorDocument)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_DeleteBucketWebSiteConfiguration, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, BucketName_or_Bucket, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_ListBuckets, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Buckets, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_PerformIAMRequest, 0, 0, 3)
	ZEND_ARG_INFO(0, Address)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Parameters, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Parameters, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_OutputStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_Protocol, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_Protocol, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_AuthType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_AuthType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_KeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_KeyID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_AccessKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_AccessKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_SecurityToken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_SecurityToken, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_UseSSL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_UseSSL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_HTTPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_HTTPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHTTPSClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_AWSHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_UseCRCCheck, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_UseCRCCheck, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_UseDelayedPut, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_UseDelayedPut, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_UseURLEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_UseURLEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_UseVersion4Signatures, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_UseVersion4Signatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_Version4SignatureHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_Version4SignatureHashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_SecMetadataID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_SecMetadataID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_MultipartUploadPartSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_MultipartUploadPartSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_MultipartUploadThreshold, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_MultipartUploadThreshold, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_RetryCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_RetryCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_Options, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_Options, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_Overwrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_Overwrite, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_PassthroughMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_PassthroughMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_BucketAccessType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_BucketAccessType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_EmbeddedMetadataMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_EmbeddedMetadataMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_BaseURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_BaseURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_RegionID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_RegionID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_Region, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_Region, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_get_OnBeforeRequestSigning, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage_set_OnBeforeRequestSigning, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAWSS3DataStorage_methods[] = {
	PHP_ME(TElAWSS3DataStorage, AcquireObject, arginfo_TElAWSS3DataStorage_AcquireObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, List, arginfo_TElAWSS3DataStorage_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, ListInit, arginfo_TElAWSS3DataStorage_ListInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, ListNext, arginfo_TElAWSS3DataStorage_ListNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, ListFinal, arginfo_TElAWSS3DataStorage_ListFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, CreateObject, arginfo_TElAWSS3DataStorage_CreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, DeleteObject, arginfo_TElAWSS3DataStorage_DeleteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, ObjectExists, arginfo_TElAWSS3DataStorage_ObjectExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, RefreshObject, arginfo_TElAWSS3DataStorage_RefreshObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, WriteObject, arginfo_TElAWSS3DataStorage_WriteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, ReadObject, arginfo_TElAWSS3DataStorage_ReadObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, ReadBlock, arginfo_TElAWSS3DataStorage_ReadBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, CopyObject, arginfo_TElAWSS3DataStorage_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, GetObjectACL, arginfo_TElAWSS3DataStorage_GetObjectACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, SetObjectACL, arginfo_TElAWSS3DataStorage_SetObjectACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, GetLocalETag, arginfo_TElAWSS3DataStorage_GetLocalETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, GetRemoteETag, arginfo_TElAWSS3DataStorage_GetRemoteETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, GetObjectTorrent, arginfo_TElAWSS3DataStorage_GetObjectTorrent, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, AcquireBucket, arginfo_TElAWSS3DataStorage_AcquireBucket, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, ReleaseBucket, arginfo_TElAWSS3DataStorage_ReleaseBucket, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, CreateBucket, arginfo_TElAWSS3DataStorage_CreateBucket, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, DeleteBucket, arginfo_TElAWSS3DataStorage_DeleteBucket, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, BucketExists, arginfo_TElAWSS3DataStorage_BucketExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, GetBucketLocation, arginfo_TElAWSS3DataStorage_GetBucketLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, GetBucketACL, arginfo_TElAWSS3DataStorage_GetBucketACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, SetBucketACL, arginfo_TElAWSS3DataStorage_SetBucketACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, GetBucketPolicy, arginfo_TElAWSS3DataStorage_GetBucketPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, SetBucketPolicy, arginfo_TElAWSS3DataStorage_SetBucketPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, DeleteBucketPolicy, arginfo_TElAWSS3DataStorage_DeleteBucketPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, SetBucketPaymentConfiguration, arginfo_TElAWSS3DataStorage_SetBucketPaymentConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, GetBucketPaymentConfiguration, arginfo_TElAWSS3DataStorage_GetBucketPaymentConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, IsRequesterPaysBucket, arginfo_TElAWSS3DataStorage_IsRequesterPaysBucket, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, GetBucketVersioning, arginfo_TElAWSS3DataStorage_GetBucketVersioning, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, SetBucketVersioning, arginfo_TElAWSS3DataStorage_SetBucketVersioning, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, GetBucketNotificationConfiguration, arginfo_TElAWSS3DataStorage_GetBucketNotificationConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, SetBucketNotificationConfiguration, arginfo_TElAWSS3DataStorage_SetBucketNotificationConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, GetBucketWebSiteConfiguration, arginfo_TElAWSS3DataStorage_GetBucketWebSiteConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, SetBucketWebSiteConfiguration, arginfo_TElAWSS3DataStorage_SetBucketWebSiteConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, DeleteBucketWebSiteConfiguration, arginfo_TElAWSS3DataStorage_DeleteBucketWebSiteConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, ListBuckets, arginfo_TElAWSS3DataStorage_ListBuckets, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, PerformIAMRequest, arginfo_TElAWSS3DataStorage_PerformIAMRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_OutputStream, arginfo_TElAWSS3DataStorage_get_OutputStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_Protocol, arginfo_TElAWSS3DataStorage_get_Protocol, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_Protocol, arginfo_TElAWSS3DataStorage_set_Protocol, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_AuthType, arginfo_TElAWSS3DataStorage_get_AuthType, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_AuthType, arginfo_TElAWSS3DataStorage_set_AuthType, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_KeyID, arginfo_TElAWSS3DataStorage_get_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_KeyID, arginfo_TElAWSS3DataStorage_set_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_AccessKey, arginfo_TElAWSS3DataStorage_get_AccessKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_AccessKey, arginfo_TElAWSS3DataStorage_set_AccessKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_SecurityToken, arginfo_TElAWSS3DataStorage_get_SecurityToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_SecurityToken, arginfo_TElAWSS3DataStorage_set_SecurityToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_UseSSL, arginfo_TElAWSS3DataStorage_get_UseSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_UseSSL, arginfo_TElAWSS3DataStorage_set_UseSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_HTTPClient, arginfo_TElAWSS3DataStorage_get_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_HTTPClient, arginfo_TElAWSS3DataStorage_set_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_AWSHeaders, arginfo_TElAWSS3DataStorage_get_AWSHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_UseCRCCheck, arginfo_TElAWSS3DataStorage_get_UseCRCCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_UseCRCCheck, arginfo_TElAWSS3DataStorage_set_UseCRCCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_UseDelayedPut, arginfo_TElAWSS3DataStorage_get_UseDelayedPut, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_UseDelayedPut, arginfo_TElAWSS3DataStorage_set_UseDelayedPut, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_UseURLEncoding, arginfo_TElAWSS3DataStorage_get_UseURLEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_UseURLEncoding, arginfo_TElAWSS3DataStorage_set_UseURLEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_UseVersion4Signatures, arginfo_TElAWSS3DataStorage_get_UseVersion4Signatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_UseVersion4Signatures, arginfo_TElAWSS3DataStorage_set_UseVersion4Signatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_Version4SignatureHashAlgorithm, arginfo_TElAWSS3DataStorage_get_Version4SignatureHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_Version4SignatureHashAlgorithm, arginfo_TElAWSS3DataStorage_set_Version4SignatureHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_SecMetadataID, arginfo_TElAWSS3DataStorage_get_SecMetadataID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_SecMetadataID, arginfo_TElAWSS3DataStorage_set_SecMetadataID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_MultipartUploadPartSize, arginfo_TElAWSS3DataStorage_get_MultipartUploadPartSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_MultipartUploadPartSize, arginfo_TElAWSS3DataStorage_set_MultipartUploadPartSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_MultipartUploadThreshold, arginfo_TElAWSS3DataStorage_get_MultipartUploadThreshold, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_MultipartUploadThreshold, arginfo_TElAWSS3DataStorage_set_MultipartUploadThreshold, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_RetryCount, arginfo_TElAWSS3DataStorage_get_RetryCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_RetryCount, arginfo_TElAWSS3DataStorage_set_RetryCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_Options, arginfo_TElAWSS3DataStorage_get_Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_Options, arginfo_TElAWSS3DataStorage_set_Options, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_Overwrite, arginfo_TElAWSS3DataStorage_get_Overwrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_Overwrite, arginfo_TElAWSS3DataStorage_set_Overwrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_PassthroughMode, arginfo_TElAWSS3DataStorage_get_PassthroughMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_PassthroughMode, arginfo_TElAWSS3DataStorage_set_PassthroughMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_BucketAccessType, arginfo_TElAWSS3DataStorage_get_BucketAccessType, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_BucketAccessType, arginfo_TElAWSS3DataStorage_set_BucketAccessType, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_EmbeddedMetadataMode, arginfo_TElAWSS3DataStorage_get_EmbeddedMetadataMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_EmbeddedMetadataMode, arginfo_TElAWSS3DataStorage_set_EmbeddedMetadataMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_BaseURL, arginfo_TElAWSS3DataStorage_get_BaseURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_BaseURL, arginfo_TElAWSS3DataStorage_set_BaseURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_RegionID, arginfo_TElAWSS3DataStorage_get_RegionID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_RegionID, arginfo_TElAWSS3DataStorage_set_RegionID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_Region, arginfo_TElAWSS3DataStorage_get_Region, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_Region, arginfo_TElAWSS3DataStorage_set_Region, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, get_OnBeforeRequestSigning, arginfo_TElAWSS3DataStorage_get_OnBeforeRequestSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, set_OnBeforeRequestSigning, arginfo_TElAWSS3DataStorage_set_OnBeforeRequestSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorage, __construct, arginfo_TElAWSS3DataStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAWSS3DataStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAWSS3DataStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAWSS3DataStorage", TElAWSS3DataStorage_methods);
	if (NULL == TElCustomDataStorage_ce_ptr)
		Register_TElCustomDataStorage(TSRMLS_C);
	TElAWSS3DataStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAWSS3DataStorageObject_ce_ptr = NULL;

SB_PHP_METHOD(TElAWSS3DataStorageObject, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageObject_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageObject_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageObject_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, Exists)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorageObject_Exists(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageObject_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, Write)
{
	char *sContentDisposition;
	char *sContentEncoding;
	char *sContentType;
	char *sStorageClass;
	int sContentDisposition_len;
	int sContentEncoding_len;
	int sContentType_len;
	int sStorageClass_len;
	zval *oData;
	zval *oHandler;
	zval *oMetadata;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageObject_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssO!O!", &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssO!O!", &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorageObject_Write_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sssO!O!", &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sssO!O!", &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorageObject_Write_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssssO!O!", &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssssO!O!", &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorageObject_Write_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sContentEncoding, (int32_t)sContentEncoding_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStream, TElCustomDataStorageSecurityHandler) or (TStream, string, string, TStringList, TElCustomDataStorageSecurityHandler) or (TStream, string, string, string, TStringList, TElCustomDataStorageSecurityHandler) or (TStream, string, string, string, string, TStringList, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TStream, TElCustomDataStorageSecurityHandler) or (TStream, string, string, TElStringList, TElCustomDataStorageSecurityHandler) or (TStream, string, string, string, TElStringList, TElCustomDataStorageSecurityHandler) or (TStream, string, string, string, string, TElStringList, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, Read)
{
	char *sETag;
	char *sObjContentDisposition;
	char *sObjContentEncoding;
	char *sObjContentType;
	char *sObjETag;
	int sETag_len;
	int32_t sObjContentDisposition_len;
	int32_t sObjContentEncoding_len;
	int32_t sObjContentType_len;
	int32_t sObjETag_len;
	long fCondition;
	uint32_t _err;
	zval *dtDateTime;
	zval *oMetadata;
	zval *oStrm;
	zval *zsObjContentDisposition;
	zval *zsObjContentEncoding;
	zval *zsObjContentType;
	zval *zsObjETag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageObject_Read(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lOs", &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageObject_Read_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lOsO!zzz", &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lOsO!zzz", &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorageObject_Read_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-951804471, 6, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2021763404, 6, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-951804471, 7, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2021763404, 7, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-951804471, 8, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2021763404, 8, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lOsO!zzzz", &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lOsO!zzzz", &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorageObject_Read_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjContentEncoding, &sObjContentEncoding_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1624420168, 6, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-84240677, 6, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1624420168, 7, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-84240677, 7, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1624420168, 8, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-84240677, 8, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1624420168, 9, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-84240677, 9, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStream) or (TStream, integer, DateTime, string) or (TStream, integer, DateTime, string, TStringList, &string, &string, &string) or (TStream, integer, DateTime, string, TStringList, &string, &string, &string, &string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TStream) or (TStream, integer, DateTime, string) or (TStream, integer, DateTime, string, TElStringList, &string, &string, &string) or (TStream, integer, DateTime, string, TElStringList, &string, &string, &string, &string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, ReadBlock)
{
	char *sETag;
	char *sObjContentDisposition;
	char *sObjContentEncoding;
	char *sObjContentType;
	char *sObjETag;
	int sETag_len;
	int32_t sObjContentDisposition_len;
	int32_t sObjContentEncoding_len;
	int32_t sObjContentType_len;
	int32_t sObjETag_len;
	int64_t l8ReadRaw;
	long fCondition;
	long l8Offset;
	long l8Size;
	uint32_t _err;
	zval *dtDateTime;
	zval *oMetadata;
	zval *oStrm;
	zval *zl8Read;
	zval *zsObjContentDisposition;
	zval *zsObjContentEncoding;
	zval *zsObjContentType;
	zval *zsObjETag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llz", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElAWSS3DataStorageObject_ReadBlock(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzlOs", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElAWSS3DataStorageObject_ReadBlock_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzlOsO!zzz", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzlOsO!zzz", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorageObject_ReadBlock_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1033871525, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1318905708, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1033871525, 10, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1318905708, 10, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1033871525, 11, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1318905708, 11, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzlOsO!zzzz", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzlOsO!zzzz", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorageObject_ReadBlock_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjContentEncoding, &sObjContentEncoding_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(169796746, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-499592765, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(169796746, 10, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-499592765, 10, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(169796746, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-499592765, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(169796746, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-499592765, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStream, integer, integer, &integer) or (TStream, integer, integer, &integer, integer, DateTime, string) or (TStream, integer, integer, &integer, integer, DateTime, string, TStringList, &string, &string, &string) or (TStream, integer, integer, &integer, integer, DateTime, string, TStringList, &string, &string, &string, &string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TStream, integer, integer, &integer) or (TStream, integer, integer, &integer, integer, DateTime, string) or (TStream, integer, integer, &integer, integer, DateTime, string, TElStringList, &string, &string, &string) or (TStream, integer, integer, &integer, integer, DateTime, string, TElStringList, &string, &string, &string, &string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, Copy)
{
	char *sDestBucketName;
	char *sDestKey;
	char *sETag;
	char *sStorageClass;
	int sDestBucketName_len;
	int sDestKey_len;
	int sETag_len;
	int sStorageClass_len;
	long fCondition;
	zend_bool bPreserveMetadata;
	zval *dtDateTime;
	zval *oMetadata;
	zval *oNewHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageObject_Copy(SBGetObjectHandle(getThis() TSRMLS_CC), sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssbO!", &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssbO!", &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageObject_Copy_1(SBGetObjectHandle(getThis() TSRMLS_CC), sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslOsbO!", &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslOsbO!", &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageObject_Copy_2(SBGetObjectHandle(getThis() TSRMLS_CC), sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslOssbO!", &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &sStorageClass, &sStorageClass_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslOssbO!", &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &sStorageClass, &sStorageClass_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageObject_Copy_3(SBGetObjectHandle(getThis() TSRMLS_CC), sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, sStorageClass, (int32_t)sStorageClass_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, TElCustomDataStorageSecurityHandler) or (string, string, bool, TStringList) or (string, string, integer, DateTime, string, bool, TStringList) or (string, string, integer, DateTime, string, string, bool, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, TElCustomDataStorageSecurityHandler) or (string, string, bool, TElStringList) or (string, string, integer, DateTime, string, bool, TElStringList) or (string, string, integer, DateTime, string, string, bool, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, GetACL)
{
	uint32_t _err;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_GetACL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-399230345, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageObject_GetACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElAWSS3AccessControlPolicy)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, SetACL)
{
	char *sACL;
	int sACL_len;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sACL, &sACL_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageObject_SetACL(SBGetObjectHandle(getThis() TSRMLS_CC), sACL, (int32_t)sACL_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageObject_SetACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TElAWSS3AccessControlPolicy)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, GetLocalETag)
{
	char *sFilename;
	int sFilename_len;
	uint32_t _err;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_GetLocalETag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-403919905, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_GetLocalETag_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1884307227, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, GetRemoteETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_GetRemoteETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-627842509, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, GetTorrent)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageObject_GetTorrent(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_BucketName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_get_BucketName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1620957128, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_Key)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_get_Key(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1660008647, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_LastModified)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorageObject_get_LastModified(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-886893959, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorageObject_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_StorageClass)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_get_StorageClass(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(558224489, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_OwnerID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_get_OwnerID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1948391230, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_OwnerDisplayName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_get_OwnerDisplayName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-939045225, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1352520638, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_ContentDisposition)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_get_ContentDisposition(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1590714566, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_ContentEncoding)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageObject_get_ContentEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(395854118, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_Metadata)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageObject_get_Metadata(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, get_CustomHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageObject_get_CustomHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageObject, __construct)
{
	char *sBucketName;
	char *sKey;
	int sBucketName_len;
	int sKey_len;
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElAWSS3DataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageObject_Create(SBGetObjectHandle(oStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oStorage, TElAWSS3DataStorage_ce_ptr, &sBucketName, &sBucketName_len, &sKey, &sKey_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageObject_Create_1(SBGetObjectHandle(oStorage TSRMLS_CC), sBucketName, (int32_t)sBucketName_len, sKey, (int32_t)sKey_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAWSS3DataStorage) or (TElAWSS3DataStorage, string, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_Exists, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_Write, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Data, TStream, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_ContentType, 0, 1)
	ZEND_ARG_INFO(0, ContentDisposition)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_StorageClass_or_ContentEncoding, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Metadata_or_StorageClass, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Metadata, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_Read, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
	ZEND_ARG_INFO(0, Condition)
	ZEND_ARG_OBJ_INFO(0, DateTime, DateTime, 0)
	ZEND_ARG_INFO(0, ETag)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Metadata, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Metadata, TElStringList, 1)
#endif
	ZEND_ARG_INFO(1, ObjContentType)
	ZEND_ARG_INFO(1, ObjContentDisposition)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_ReadBlock, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(1, Read)
	ZEND_ARG_INFO(0, Condition)
	ZEND_ARG_OBJ_INFO(0, DateTime, DateTime, 0)
	ZEND_ARG_INFO(0, ETag)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Metadata, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Metadata, TElStringList, 1)
#endif
	ZEND_ARG_INFO(1, ObjContentType)
	ZEND_ARG_INFO(1, ObjContentDisposition)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_Copy, 0, 0, 3)
	ZEND_ARG_INFO(0, DestBucketName)
	ZEND_ARG_INFO(0, DestKey)
	ZEND_ARG_TYPE_INFO(0, NewHandler_or_PreserveMetadata_or_Condition, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_DateTime, 0, 1)
	ZEND_ARG_INFO(0, ETag)
	ZEND_ARG_INFO(0, PreserveMetadata_or_StorageClass)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_PreserveMetadata, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Metadata, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Metadata, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_GetACL, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Policy, TElAWSS3AccessControlPolicy, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_SetACL, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ACL_or_Policy, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_GetLocalETag, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Stream_or_Filename, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_GetRemoteETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_GetTorrent, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_BucketName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_Key, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_LastModified, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_StorageClass, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_OwnerID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_OwnerDisplayName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_ContentDisposition, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_ContentEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_Metadata, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject_get_CustomHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElAWSS3DataStorage, 1)
	ZEND_ARG_INFO(0, BucketName)
	ZEND_ARG_INFO(0, Key)
ZEND_END_ARG_INFO()

static zend_function_entry TElAWSS3DataStorageObject_methods[] = {
	PHP_ME(TElAWSS3DataStorageObject, Assign, arginfo_TElAWSS3DataStorageObject_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, Clone, arginfo_TElAWSS3DataStorageObject_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, Delete, arginfo_TElAWSS3DataStorageObject_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, Exists, arginfo_TElAWSS3DataStorageObject_Exists, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, Refresh, arginfo_TElAWSS3DataStorageObject_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, Write, arginfo_TElAWSS3DataStorageObject_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, Read, arginfo_TElAWSS3DataStorageObject_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, ReadBlock, arginfo_TElAWSS3DataStorageObject_ReadBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, Copy, arginfo_TElAWSS3DataStorageObject_Copy, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, GetACL, arginfo_TElAWSS3DataStorageObject_GetACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, SetACL, arginfo_TElAWSS3DataStorageObject_SetACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, GetLocalETag, arginfo_TElAWSS3DataStorageObject_GetLocalETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, GetRemoteETag, arginfo_TElAWSS3DataStorageObject_GetRemoteETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, GetTorrent, arginfo_TElAWSS3DataStorageObject_GetTorrent, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_BucketName, arginfo_TElAWSS3DataStorageObject_get_BucketName, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_Key, arginfo_TElAWSS3DataStorageObject_get_Key, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_LastModified, arginfo_TElAWSS3DataStorageObject_get_LastModified, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_ETag, arginfo_TElAWSS3DataStorageObject_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_Size, arginfo_TElAWSS3DataStorageObject_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_StorageClass, arginfo_TElAWSS3DataStorageObject_get_StorageClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_OwnerID, arginfo_TElAWSS3DataStorageObject_get_OwnerID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_OwnerDisplayName, arginfo_TElAWSS3DataStorageObject_get_OwnerDisplayName, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_ContentType, arginfo_TElAWSS3DataStorageObject_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_ContentDisposition, arginfo_TElAWSS3DataStorageObject_get_ContentDisposition, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_ContentEncoding, arginfo_TElAWSS3DataStorageObject_get_ContentEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_Metadata, arginfo_TElAWSS3DataStorageObject_get_Metadata, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, get_CustomHeaders, arginfo_TElAWSS3DataStorageObject_get_CustomHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageObject, __construct, arginfo_TElAWSS3DataStorageObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAWSS3DataStorageObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAWSS3DataStorageObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAWSS3DataStorageObject", TElAWSS3DataStorageObject_methods);
	if (NULL == TElCustomDataStorageObject_ce_ptr)
		Register_TElCustomDataStorageObject(TSRMLS_C);
	TElAWSS3DataStorageObject_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAWSS3DataStorageListState_ce_ptr = NULL;

SB_PHP_METHOD(TElAWSS3DataStorageListState, Completed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorageListState_Completed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageListState, __construct)
{
	char *sBucketName;
	char *sDelimiter;
	char *sPrefix;
	int sBucketName_len;
	int sDelimiter_len;
	int sPrefix_len;
	zval *oHeaders;
	zval *oPrefixes;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!O!", &sBucketName, &sBucketName_len, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!O!", &sBucketName, &sBucketName_len, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageListState_Create(sBucketName, (int32_t)sBucketName_len, sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, SBGetObjectHandle(oPrefixes TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, string, TStringList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, string, TElStringList, TElStringList)" TSRMLS_CC);
#endif
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageListState_Completed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageListState___construct, 0, 0, 5)
	ZEND_ARG_INFO(0, BucketName)
	ZEND_ARG_INFO(0, Prefix)
	ZEND_ARG_INFO(0, Delimiter)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Prefixes, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Prefixes, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

static zend_function_entry TElAWSS3DataStorageListState_methods[] = {
	PHP_ME(TElAWSS3DataStorageListState, Completed, arginfo_TElAWSS3DataStorageListState_Completed, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageListState, __construct, arginfo_TElAWSS3DataStorageListState___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAWSS3DataStorageListState(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAWSS3DataStorageListState_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAWSS3DataStorageListState", TElAWSS3DataStorageListState_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElAWSS3DataStorageListState_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAWSS3AccessControlGrant_ce_ptr = NULL;

SB_PHP_METHOD(TElAWSS3AccessControlGrant, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlGrant_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, SaveToXML)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3AccessControlGrant_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(437683595, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, LoadFromXML)
{
	char *sXml;
	int sXml_len;
	zval *oElem;
	zval *oXmlStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sXml, &sXml_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlGrant_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), sXml, (int32_t)sXml_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXmlStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlGrant_LoadFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oXmlStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElem, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlGrant_LoadFromXML_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElem TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStream) or (TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, get_GranteeType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAWSS3AccessControlGranteeTypeRaw fOutResultRaw = 0;
		SBCheckError(TElAWSS3AccessControlGrant_get_GranteeType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, set_GranteeType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlGrant_set_GranteeType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAWSS3AccessControlGranteeTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, get_UserID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3AccessControlGrant_get_UserID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-9114423, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, set_UserID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlGrant_set_UserID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, get_UserDisplayName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3AccessControlGrant_get_UserDisplayName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1936193574, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, set_UserDisplayName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlGrant_set_UserDisplayName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, get_GroupURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3AccessControlGrant_get_GroupURI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(798771002, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, set_GroupURI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlGrant_set_GroupURI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, get_Email)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3AccessControlGrant_get_Email(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1318828466, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, set_Email)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlGrant_set_Email(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, get_Permission)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAWSS3AccessControlPermissionRaw fOutResultRaw = 0;
		SBCheckError(TElAWSS3AccessControlGrant_get_Permission(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, set_Permission)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlGrant_set_Permission(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAWSS3AccessControlPermissionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, get_CustomPermission)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3AccessControlGrant_get_CustomPermission(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(220110599, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, set_CustomPermission)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlGrant_set_CustomPermission(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, get_CustomGrantee)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3AccessControlGrant_get_CustomGrantee(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2092723606, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, set_CustomGrantee)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlGrant_set_CustomGrantee(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlGrant, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3AccessControlGrant_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_SaveToXML, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_LoadFromXML, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Xml_or_XmlStream_or_Elem, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_get_GranteeType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_set_GranteeType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_get_UserID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_set_UserID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_get_UserDisplayName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_set_UserDisplayName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_get_GroupURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_set_GroupURI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_get_Email, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_set_Email, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_get_Permission, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_set_Permission, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_get_CustomPermission, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_set_CustomPermission, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_get_CustomGrantee, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant_set_CustomGrantee, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlGrant___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElAWSS3AccessControlGrant_methods[] = {
	PHP_ME(TElAWSS3AccessControlGrant, Reset, arginfo_TElAWSS3AccessControlGrant_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, SaveToXML, arginfo_TElAWSS3AccessControlGrant_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, LoadFromXML, arginfo_TElAWSS3AccessControlGrant_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, get_GranteeType, arginfo_TElAWSS3AccessControlGrant_get_GranteeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, set_GranteeType, arginfo_TElAWSS3AccessControlGrant_set_GranteeType, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, get_UserID, arginfo_TElAWSS3AccessControlGrant_get_UserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, set_UserID, arginfo_TElAWSS3AccessControlGrant_set_UserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, get_UserDisplayName, arginfo_TElAWSS3AccessControlGrant_get_UserDisplayName, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, set_UserDisplayName, arginfo_TElAWSS3AccessControlGrant_set_UserDisplayName, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, get_GroupURI, arginfo_TElAWSS3AccessControlGrant_get_GroupURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, set_GroupURI, arginfo_TElAWSS3AccessControlGrant_set_GroupURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, get_Email, arginfo_TElAWSS3AccessControlGrant_get_Email, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, set_Email, arginfo_TElAWSS3AccessControlGrant_set_Email, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, get_Permission, arginfo_TElAWSS3AccessControlGrant_get_Permission, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, set_Permission, arginfo_TElAWSS3AccessControlGrant_set_Permission, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, get_CustomPermission, arginfo_TElAWSS3AccessControlGrant_get_CustomPermission, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, set_CustomPermission, arginfo_TElAWSS3AccessControlGrant_set_CustomPermission, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, get_CustomGrantee, arginfo_TElAWSS3AccessControlGrant_get_CustomGrantee, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, set_CustomGrantee, arginfo_TElAWSS3AccessControlGrant_set_CustomGrantee, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlGrant, __construct, arginfo_TElAWSS3AccessControlGrant___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAWSS3AccessControlGrant(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAWSS3AccessControlGrant_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAWSS3AccessControlGrant", TElAWSS3AccessControlGrant_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElAWSS3AccessControlGrant_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAWSS3AccessControlPolicy_ce_ptr = NULL;

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, AddGrant)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAWSS3AccessControlPolicy_AddGrant(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, RemoveGrant)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlPolicy_RemoveGrant(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, ClearGrants)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlPolicy_ClearGrants(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, SaveToXML)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3AccessControlPolicy_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1258478561, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, LoadFromXML)
{
	char *sXml;
	int sXml_len;
	zval *oXmlStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sXml, &sXml_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlPolicy_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), sXml, (int32_t)sXml_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXmlStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlPolicy_LoadFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oXmlStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlPolicy_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, get_Grants)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3AccessControlPolicy_get_Grants(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3AccessControlGrant_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, get_GrantCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAWSS3AccessControlPolicy_get_GrantCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, get_OwnerID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3AccessControlPolicy_get_OwnerID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(775981921, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, set_OwnerID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlPolicy_set_OwnerID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, get_OwnerDisplayName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3AccessControlPolicy_get_OwnerDisplayName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1937457081, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, set_OwnerDisplayName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3AccessControlPolicy_set_OwnerDisplayName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3AccessControlPolicy, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3AccessControlPolicy_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy_AddGrant, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy_RemoveGrant, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy_ClearGrants, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy_SaveToXML, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy_LoadFromXML, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Xml_or_XmlStream, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy_get_Grants, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy_get_GrantCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy_get_OwnerID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy_set_OwnerID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy_get_OwnerDisplayName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy_set_OwnerDisplayName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3AccessControlPolicy___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElAWSS3AccessControlPolicy_methods[] = {
	PHP_ME(TElAWSS3AccessControlPolicy, AddGrant, arginfo_TElAWSS3AccessControlPolicy_AddGrant, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlPolicy, RemoveGrant, arginfo_TElAWSS3AccessControlPolicy_RemoveGrant, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlPolicy, ClearGrants, arginfo_TElAWSS3AccessControlPolicy_ClearGrants, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlPolicy, SaveToXML, arginfo_TElAWSS3AccessControlPolicy_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlPolicy, LoadFromXML, arginfo_TElAWSS3AccessControlPolicy_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlPolicy, Reset, arginfo_TElAWSS3AccessControlPolicy_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlPolicy, get_Grants, arginfo_TElAWSS3AccessControlPolicy_get_Grants, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlPolicy, get_GrantCount, arginfo_TElAWSS3AccessControlPolicy_get_GrantCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlPolicy, get_OwnerID, arginfo_TElAWSS3AccessControlPolicy_get_OwnerID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlPolicy, set_OwnerID, arginfo_TElAWSS3AccessControlPolicy_set_OwnerID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlPolicy, get_OwnerDisplayName, arginfo_TElAWSS3AccessControlPolicy_get_OwnerDisplayName, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlPolicy, set_OwnerDisplayName, arginfo_TElAWSS3AccessControlPolicy_set_OwnerDisplayName, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3AccessControlPolicy, __construct, arginfo_TElAWSS3AccessControlPolicy___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAWSS3AccessControlPolicy(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAWSS3AccessControlPolicy_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAWSS3AccessControlPolicy", TElAWSS3AccessControlPolicy_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElAWSS3AccessControlPolicy_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAWSS3DataStorageBucket_ce_ptr = NULL;

SB_PHP_METHOD(TElAWSS3DataStorageBucket, AcquireObject)
{
	char *sKey;
	int sKey_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKey, &sKey_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_AcquireObject(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, List)
{
	char *sDelimiter;
	char *sPrefix;
	int sDelimiter_len;
	int sPrefix_len;
	long l4MaxCount;
	zval *oHeaders;
	zval *oObjects;
	zval *oPrefixes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_List(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sslO!O!", &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sslO!O!", &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorageBucket_List_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, (int32_t)l4MaxCount, SBGetObjectHandle(oPrefixes TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TElDataStorageObjectList) or (TElDataStorageObjectList, string, string, integer, TStringList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElDataStorageObjectList) or (TElDataStorageObjectList, string, string, integer, TElStringList, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, ListInit)
{
	char *sDelimiter;
	char *sPrefix;
	int sDelimiter_len;
	int sPrefix_len;
	zval *oHeaders;
	zval *oPrefixes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_ListInit(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_ListInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, SBGetObjectHandle(oPrefixes TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("() or (string, string, TStringList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("() or (string, string, TElStringList, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, ListNext)
{
	long l4MaxCount;
	zval *oObjects;
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oState, TElAWSS3DataStorageListState_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_ListNext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oState, TElAWSS3DataStorageListState_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr, &l4MaxCount) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_ListNext_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC), (int32_t)l4MaxCount) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElAWSS3DataStorageListState, TElDataStorageObjectList) or (TElAWSS3DataStorageListState, TElDataStorageObjectList, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, ListFinal)
{
	TElClassHandle hoState;
	zval *oState;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oState, TElAWSS3DataStorageListState_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oState) && (IS_OBJECT == Z_TYPE_P(oState)))
	{
		hoState = SBGetObjectHandle(oState TSRMLS_CC);
		SBCheckError(TElAWSS3DataStorageBucket_ListFinal(SBGetObjectHandle(getThis() TSRMLS_CC), &hoState) TSRMLS_CC);
		SBUpdateObjectHandle(oState, hoState TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElAWSS3DataStorageListState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, CreateObject)
{
	char *sContentDisposition;
	char *sContentEncoding;
	char *sContentType;
	char *sObjName;
	char *sStorageClass;
	int sContentDisposition_len;
	int sContentEncoding_len;
	int sContentType_len;
	int sObjName_len;
	int sStorageClass_len;
	zval *oHandler;
	zval *oMetadata;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sObjName, &sObjName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_CreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), sObjName, (int32_t)sObjName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sObjName, &sObjName_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_CreateObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sObjName, (int32_t)sObjName_len, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!O!", &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!O!", &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_CreateObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sObjName, (int32_t)sObjName_len, sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!O!", &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!O!", &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_CreateObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sObjName, (int32_t)sObjName_len, sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!O!", &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!O!", &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_CreateObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), sObjName, (int32_t)sObjName_len, sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sContentEncoding, (int32_t)sContentEncoding_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (string, TElCustomDataStorageSecurityHandler) or (string, string, string, TStringList, TElCustomDataStorageSecurityHandler) or (string, string, string, string, TStringList, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, TStringList, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (string, TElCustomDataStorageSecurityHandler) or (string, string, string, TElStringList, TElCustomDataStorageSecurityHandler) or (string, string, string, string, TElStringList, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, TElStringList, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, DeleteObject)
{
	char *sKey;
	int sKey_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKey, &sKey_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_DeleteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, ObjectExists)
{
	char *sKey;
	int sKey_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKey, &sKey_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorageBucket_ObjectExists(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, WriteObject)
{
	char *sContentDisposition;
	char *sContentEncoding;
	char *sContentType;
	char *sKey;
	char *sStorageClass;
	int sContentDisposition_len;
	int sContentEncoding_len;
	int sContentType_len;
	int sKey_len;
	int sStorageClass_len;
	zval *oData;
	zval *oHandler;
	zval *oMetadata;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sKey, &sKey_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_WriteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!ssO!O!", &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!ssO!O!", &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorageBucket_WriteObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sssO!O!", &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sssO!O!", &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorageBucket_WriteObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!ssssO!O!", &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!ssssO!O!", &sKey, &sKey_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentDisposition, &sContentDisposition_len, &sContentEncoding, &sContentEncoding_len, &sStorageClass, &sStorageClass_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorageBucket_WriteObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentDisposition, (int32_t)sContentDisposition_len, sContentEncoding, (int32_t)sContentEncoding_len, sStorageClass, (int32_t)sStorageClass_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStream, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, TStringList, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, string, TStringList, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, string, string, TStringList, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TStream, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, TElStringList, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, string, TElStringList, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, string, string, TElStringList, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, ReadObject)
{
	char *sETag;
	char *sKey;
	char *sObjContentDisposition;
	char *sObjContentEncoding;
	char *sObjContentType;
	char *sObjETag;
	int sETag_len;
	int sKey_len;
	int32_t sObjContentDisposition_len;
	int32_t sObjContentEncoding_len;
	int32_t sObjContentType_len;
	int32_t sObjETag_len;
	long fCondition;
	uint32_t _err;
	zval *dtDateTime;
	zval *oMetadata;
	zval *oStrm;
	zval *zsObjContentDisposition;
	zval *zsObjContentEncoding;
	zval *zsObjContentType;
	zval *zsObjETag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sKey, &sKey_len, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_ReadObject(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOs", &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_ReadObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOsO!zzz", &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOsO!zzz", &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorageBucket_ReadObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1597557558, 7, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1772959875, 7, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1597557558, 8, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1772959875, 8, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1597557558, 9, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1772959875, 9, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOsO!zzzz", &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOsO!zzzz", &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorageBucket_ReadObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjContentEncoding, &sObjContentEncoding_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(605115752, 7, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(840363448, 7, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(605115752, 8, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(840363448, 8, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(605115752, 9, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(840363448, 9, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(605115752, 10, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(840363448, 10, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStream) or (string, TStream, integer, DateTime, string) or (string, TStream, integer, DateTime, string, TStringList, &string, &string, &string) or (string, TStream, integer, DateTime, string, TStringList, &string, &string, &string, &string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TStream) or (string, TStream, integer, DateTime, string) or (string, TStream, integer, DateTime, string, TElStringList, &string, &string, &string) or (string, TStream, integer, DateTime, string, TElStringList, &string, &string, &string, &string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, ReadBlock)
{
	char *sETag;
	char *sKey;
	char *sObjContentDisposition;
	char *sObjContentEncoding;
	char *sObjContentType;
	char *sObjETag;
	int sETag_len;
	int sKey_len;
	int32_t sObjContentDisposition_len;
	int32_t sObjContentEncoding_len;
	int32_t sObjContentType_len;
	int32_t sObjETag_len;
	int64_t l8ReadRaw;
	long fCondition;
	long l8Offset;
	long l8Size;
	uint32_t _err;
	zval *dtDateTime;
	zval *oMetadata;
	zval *oStrm;
	zval *zl8Read;
	zval *zsObjContentDisposition;
	zval *zsObjContentEncoding;
	zval *zsObjContentType;
	zval *zsObjETag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llz", &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElAWSS3DataStorageBucket_ReadBlock(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOs", &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElAWSS3DataStorageBucket_ReadBlock_1(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOsO!zzz", &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOsO!zzz", &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorageBucket_ReadBlock_2(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1412467291, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(521702182, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1412467291, 11, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(521702182, 11, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1412467291, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(521702182, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOsO!zzzz", &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOsO!zzzz", &sKey, &sKey_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentDisposition, &zsObjContentEncoding, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentDisposition) && (IS_STRING == Z_TYPE_P(zsObjContentDisposition)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentDisposition = Z_STRVAL_P(zsObjContentDisposition);
		sObjContentDisposition_len = (int32_t)Z_STRLEN_P(zsObjContentDisposition);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElAWSS3DataStorageBucket_ReadBlock_3(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentDisposition, &sObjContentDisposition_len, sObjContentEncoding, &sObjContentEncoding_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(2104347988, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1087252915, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentDisposition = emalloc(sObjContentDisposition_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(2104347988, 11, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1087252915, 11, sObjContentDisposition, &sObjContentDisposition_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentDisposition);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(2104347988, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1087252915, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(2104347988, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1087252915, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentDisposition[sObjContentDisposition_len] = 0;
		ZVAL_STRINGL(zsObjContentDisposition, sObjContentDisposition, sObjContentDisposition_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStream, integer, integer, &integer) or (string, TStream, integer, integer, &integer, integer, DateTime, string) or (string, TStream, integer, integer, &integer, integer, DateTime, string, TStringList, &string, &string, &string) or (string, TStream, integer, integer, &integer, integer, DateTime, string, TStringList, &string, &string, &string, &string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TStream, integer, integer, &integer) or (string, TStream, integer, integer, &integer, integer, DateTime, string) or (string, TStream, integer, integer, &integer, integer, DateTime, string, TElStringList, &string, &string, &string) or (string, TStream, integer, integer, &integer, integer, DateTime, string, TElStringList, &string, &string, &string, &string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, CopyObject)
{
	char *sDestBucketName;
	char *sDestKey;
	char *sETag;
	char *sSourceKey;
	char *sStorageClass;
	int sDestBucketName_len;
	int sDestKey_len;
	int sETag_len;
	int sSourceKey_len;
	int sStorageClass_len;
	long fCondition;
	zend_bool bPreserveMetadata;
	zval *dtDateTime;
	zval *oMetadata;
	zval *oNewHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceKey, (int32_t)sSourceKey_len, sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssbO!", &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssbO!", &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_CopyObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceKey, (int32_t)sSourceKey_len, sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssslOsbO!", &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssslOsbO!", &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_CopyObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceKey, (int32_t)sSourceKey_len, sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssslOssbO!", &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &sStorageClass, &sStorageClass_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssslOssbO!", &sSourceKey, &sSourceKey_len, &sDestBucketName, &sDestBucketName_len, &sDestKey, &sDestKey_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &sStorageClass, &sStorageClass_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_CopyObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceKey, (int32_t)sSourceKey_len, sDestBucketName, (int32_t)sDestBucketName_len, sDestKey, (int32_t)sDestKey_len, (TSBAWSS3ReadObjectConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, sStorageClass, (int32_t)sStorageClass_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, bool, TStringList) or (string, string, string, integer, DateTime, string, bool, TStringList) or (string, string, string, integer, DateTime, string, string, bool, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, bool, TElStringList) or (string, string, string, integer, DateTime, string, bool, TElStringList) or (string, string, string, integer, DateTime, string, string, bool, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, GetObjectACL)
{
	char *sKey;
	int sKey_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKey, &sKey_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageBucket_GetObjectACL(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1673063495, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, SetObjectACL)
{
	char *sACL;
	char *sKey;
	int sACL_len;
	int sKey_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sKey, &sKey_len, &sACL, &sACL_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_SetObjectACL(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, sACL, (int32_t)sACL_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, GetRemoteETag)
{
	char *sKey;
	int sKey_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKey, &sKey_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageBucket_GetRemoteETag(SBGetObjectHandle(getThis() TSRMLS_CC), sKey, (int32_t)sKey_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-861504477, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, Exists)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorageBucket_Exists(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, GetLocation)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageBucket_GetLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(252848241, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, GetACL)
{
	uint32_t _err;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageBucket_GetACL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-58472415, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_GetACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElAWSS3AccessControlPolicy)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, SetACL)
{
	char *sACL;
	int sACL_len;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sACL, &sACL_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_SetACL(SBGetObjectHandle(getThis() TSRMLS_CC), sACL, (int32_t)sACL_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPolicy, TElAWSS3AccessControlPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_SetACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TElAWSS3AccessControlPolicy)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, GetPolicy)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageBucket_GetPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1304740347, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, SetPolicy)
{
	char *sPolicy;
	int sPolicy_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPolicy, &sPolicy_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_SetPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), sPolicy, (int32_t)sPolicy_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, DeletePolicy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_DeletePolicy(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, SetPaymentConfiguration)
{
	char *sPaymentConfig;
	int sPaymentConfig_len;
	zend_bool bRequesterPays;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPaymentConfig, &sPaymentConfig_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_SetPaymentConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), sPaymentConfig, (int32_t)sPaymentConfig_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bRequesterPays) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_SetPaymentConfiguration_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bRequesterPays) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, GetPaymentConfiguration)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageBucket_GetPaymentConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2132684851, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, IsRequesterPaysBucket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorageBucket_IsRequesterPaysBucket(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, GetVersioning)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBAWSS3BucketVersioningRaw fOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorageBucket_GetVersioning(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, SetVersioning)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_SetVersioning(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBAWSS3BucketVersioningRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, GetNotificationConfiguration)
{
	zval *oEvents;
	zval *oTopics;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oTopics, TStringList_ce_ptr, &oEvents, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oTopics, TElStringList_ce_ptr, &oEvents, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorageBucket_GetNotificationConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTopics TSRMLS_CC), SBGetObjectHandle(oEvents TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, SetNotificationConfiguration)
{
	zval *oEvents;
	zval *oTopics;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oTopics, TStringList_ce_ptr, &oEvents, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oTopics, TElStringList_ce_ptr, &oEvents, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElAWSS3DataStorageBucket_SetNotificationConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTopics TSRMLS_CC), SBGetObjectHandle(oEvents TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, GetWebSiteConfiguration)
{
	char *sErrorDocument;
	char *sIndexDocument;
	int32_t sErrorDocument_len;
	int32_t sIndexDocument_len;
	uint32_t _err;
	zval *zsErrorDocument;
	zval *zsIndexDocument;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zsIndexDocument, &zsErrorDocument) == SUCCESS) && PZVAL_IS_REF(zsIndexDocument) && (IS_STRING == Z_TYPE_P(zsIndexDocument)) && PZVAL_IS_REF(zsErrorDocument) && (IS_STRING == Z_TYPE_P(zsErrorDocument)))
	{
		sIndexDocument = Z_STRVAL_P(zsIndexDocument);
		sIndexDocument_len = (int32_t)Z_STRLEN_P(zsIndexDocument);
		sErrorDocument = Z_STRVAL_P(zsErrorDocument);
		sErrorDocument_len = (int32_t)Z_STRLEN_P(zsErrorDocument);
		_err = TElAWSS3DataStorageBucket_GetWebSiteConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), sIndexDocument, &sIndexDocument_len, sErrorDocument, &sErrorDocument_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sIndexDocument = emalloc(sIndexDocument_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1573049520, 1, sIndexDocument, &sIndexDocument_len) TSRMLS_CC);
			zval_dtor(zsIndexDocument);
			sErrorDocument = emalloc(sErrorDocument_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1573049520, 2, sErrorDocument, &sErrorDocument_len) TSRMLS_CC);
			zval_dtor(zsErrorDocument);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sIndexDocument[sIndexDocument_len] = 0;
		ZVAL_STRINGL(zsIndexDocument, sIndexDocument, sIndexDocument_len, 0);
		sErrorDocument[sErrorDocument_len] = 0;
		ZVAL_STRINGL(zsErrorDocument, sErrorDocument, sErrorDocument_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(&string, &string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, SetWebSiteConfiguration)
{
	char *sErrorDocument;
	char *sIndexDocument;
	int sErrorDocument_len;
	int sIndexDocument_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sIndexDocument, &sIndexDocument_len, &sErrorDocument, &sErrorDocument_len) == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_SetWebSiteConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC), sIndexDocument, (int32_t)sIndexDocument_len, sErrorDocument, (int32_t)sErrorDocument_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, DeleteWebSiteConfiguration)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElAWSS3DataStorageBucket_DeleteWebSiteConfiguration(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageBucket_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(89746230, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, get_CreationDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorageBucket_get_CreationDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, get_CustomHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_get_CustomHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucket, __construct)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElAWSS3DataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucket_Create_1(SBGetObjectHandle(oStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElAWSS3DataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_AcquireObject, 0, 0, 1)
	ZEND_ARG_INFO(0, Key)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_List, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
	ZEND_ARG_INFO(0, Prefix)
	ZEND_ARG_INFO(0, Delimiter)
	ZEND_ARG_INFO(0, MaxCount)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Prefixes, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Prefixes, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_ListInit, 0, 0, 0)
	ZEND_ARG_INFO(0, Prefix)
	ZEND_ARG_INFO(0, Delimiter)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Prefixes, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Prefixes, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_ListNext, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, State, TElAWSS3DataStorageListState, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
	ZEND_ARG_INFO(0, MaxCount)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_ListFinal, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, State, TElAWSS3DataStorageListState, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_CreateObject, 0, 0, 1)
	ZEND_ARG_INFO(0, ObjName)
	ZEND_ARG_TYPE_INFO(0, Handler_or_ContentType, 0, 1)
	ZEND_ARG_INFO(0, ContentDisposition)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_StorageClass_or_ContentEncoding, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Metadata_or_StorageClass, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Metadata, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_DeleteObject, 0, 0, 1)
	ZEND_ARG_INFO(0, Key)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_ObjectExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Key)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_WriteObject, 0, 0, 3)
	ZEND_ARG_INFO(0, Key)
	ZEND_ARG_OBJ_INFO(0, Data, TStream, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_ContentType, 0, 1)
	ZEND_ARG_INFO(0, ContentDisposition)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_StorageClass_or_ContentEncoding, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Metadata_or_StorageClass, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Metadata, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_ReadObject, 0, 0, 2)
	ZEND_ARG_INFO(0, Key)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
	ZEND_ARG_INFO(0, Condition)
	ZEND_ARG_OBJ_INFO(0, DateTime, DateTime, 0)
	ZEND_ARG_INFO(0, ETag)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Metadata, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Metadata, TElStringList, 1)
#endif
	ZEND_ARG_INFO(1, ObjContentType)
	ZEND_ARG_INFO(1, ObjContentDisposition)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_ReadBlock, 0, 0, 5)
	ZEND_ARG_INFO(0, Key)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_INFO(1, Read)
	ZEND_ARG_INFO(0, Condition)
	ZEND_ARG_OBJ_INFO(0, DateTime, DateTime, 0)
	ZEND_ARG_INFO(0, ETag)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Metadata, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Metadata, TElStringList, 1)
#endif
	ZEND_ARG_INFO(1, ObjContentType)
	ZEND_ARG_INFO(1, ObjContentDisposition)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_CopyObject, 0, 0, 4)
	ZEND_ARG_INFO(0, SourceKey)
	ZEND_ARG_INFO(0, DestBucketName)
	ZEND_ARG_INFO(0, DestKey)
	ZEND_ARG_TYPE_INFO(0, NewHandler_or_PreserveMetadata_or_Condition, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_DateTime, 0, 1)
	ZEND_ARG_INFO(0, ETag)
	ZEND_ARG_INFO(0, PreserveMetadata_or_StorageClass)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_PreserveMetadata, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Metadata, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Metadata, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_GetObjectACL, 0, 0, 1)
	ZEND_ARG_INFO(0, Key)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_SetObjectACL, 0, 0, 2)
	ZEND_ARG_INFO(0, Key)
	ZEND_ARG_INFO(0, ACL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_GetRemoteETag, 0, 0, 1)
	ZEND_ARG_INFO(0, Key)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_Exists, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_GetLocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_GetACL, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Policy, TElAWSS3AccessControlPolicy, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_SetACL, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ACL_or_Policy, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_GetPolicy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_SetPolicy, 0, 0, 1)
	ZEND_ARG_INFO(0, Policy)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_DeletePolicy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_SetPaymentConfiguration, 0, 0, 1)
	ZEND_ARG_INFO(0, PaymentConfig_or_RequesterPays)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_GetPaymentConfiguration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_IsRequesterPaysBucket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_GetVersioning, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_SetVersioning, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_GetNotificationConfiguration, 0, 0, 2)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Topics, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Events, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Topics, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Events, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_SetNotificationConfiguration, 0, 0, 2)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Topics, TStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Events, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Topics, TElStringList, 1)
	ZEND_ARG_OBJ_INFO(0, Events, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_GetWebSiteConfiguration, 0, 0, 2)
	ZEND_ARG_INFO(1, IndexDocument)
	ZEND_ARG_INFO(1, ErrorDocument)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_SetWebSiteConfiguration, 0, 0, 2)
	ZEND_ARG_INFO(0, IndexDocument)
	ZEND_ARG_INFO(0, ErrorDocument)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_DeleteWebSiteConfiguration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_get_CreationDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket_get_CustomHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucket___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Storage, TElAWSS3DataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAWSS3DataStorageBucket_methods[] = {
	PHP_ME(TElAWSS3DataStorageBucket, AcquireObject, arginfo_TElAWSS3DataStorageBucket_AcquireObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, List, arginfo_TElAWSS3DataStorageBucket_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, ListInit, arginfo_TElAWSS3DataStorageBucket_ListInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, ListNext, arginfo_TElAWSS3DataStorageBucket_ListNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, ListFinal, arginfo_TElAWSS3DataStorageBucket_ListFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, CreateObject, arginfo_TElAWSS3DataStorageBucket_CreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, DeleteObject, arginfo_TElAWSS3DataStorageBucket_DeleteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, ObjectExists, arginfo_TElAWSS3DataStorageBucket_ObjectExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, WriteObject, arginfo_TElAWSS3DataStorageBucket_WriteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, ReadObject, arginfo_TElAWSS3DataStorageBucket_ReadObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, ReadBlock, arginfo_TElAWSS3DataStorageBucket_ReadBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, CopyObject, arginfo_TElAWSS3DataStorageBucket_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, GetObjectACL, arginfo_TElAWSS3DataStorageBucket_GetObjectACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, SetObjectACL, arginfo_TElAWSS3DataStorageBucket_SetObjectACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, GetRemoteETag, arginfo_TElAWSS3DataStorageBucket_GetRemoteETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, Delete, arginfo_TElAWSS3DataStorageBucket_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, Exists, arginfo_TElAWSS3DataStorageBucket_Exists, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, GetLocation, arginfo_TElAWSS3DataStorageBucket_GetLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, GetACL, arginfo_TElAWSS3DataStorageBucket_GetACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, SetACL, arginfo_TElAWSS3DataStorageBucket_SetACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, GetPolicy, arginfo_TElAWSS3DataStorageBucket_GetPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, SetPolicy, arginfo_TElAWSS3DataStorageBucket_SetPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, DeletePolicy, arginfo_TElAWSS3DataStorageBucket_DeletePolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, SetPaymentConfiguration, arginfo_TElAWSS3DataStorageBucket_SetPaymentConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, GetPaymentConfiguration, arginfo_TElAWSS3DataStorageBucket_GetPaymentConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, IsRequesterPaysBucket, arginfo_TElAWSS3DataStorageBucket_IsRequesterPaysBucket, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, GetVersioning, arginfo_TElAWSS3DataStorageBucket_GetVersioning, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, SetVersioning, arginfo_TElAWSS3DataStorageBucket_SetVersioning, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, GetNotificationConfiguration, arginfo_TElAWSS3DataStorageBucket_GetNotificationConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, SetNotificationConfiguration, arginfo_TElAWSS3DataStorageBucket_SetNotificationConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, GetWebSiteConfiguration, arginfo_TElAWSS3DataStorageBucket_GetWebSiteConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, SetWebSiteConfiguration, arginfo_TElAWSS3DataStorageBucket_SetWebSiteConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, DeleteWebSiteConfiguration, arginfo_TElAWSS3DataStorageBucket_DeleteWebSiteConfiguration, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, get_Name, arginfo_TElAWSS3DataStorageBucket_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, get_CreationDate, arginfo_TElAWSS3DataStorageBucket_get_CreationDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, get_CustomHeaders, arginfo_TElAWSS3DataStorageBucket_get_CustomHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucket, __construct, arginfo_TElAWSS3DataStorageBucket___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAWSS3DataStorageBucket(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAWSS3DataStorageBucket_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAWSS3DataStorageBucket", TElAWSS3DataStorageBucket_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElAWSS3DataStorageBucket_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElAWSS3DataStorageBucketList_ce_ptr = NULL;

SB_PHP_METHOD(TElAWSS3DataStorageBucketList, get_Buckets)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucketList_get_Buckets(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElAWSS3DataStorageBucket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucketList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElAWSS3DataStorageBucketList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucketList, get_OwnerID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageBucketList_get_OwnerID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1327126255, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucketList, get_OwnerDisplayName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElAWSS3DataStorageBucketList_get_OwnerDisplayName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-175379133, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElAWSS3DataStorageBucketList, __construct)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucketList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElAWSS3DataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElAWSS3DataStorageBucketList_Create_1(SBGetObjectHandle(oStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElAWSS3DataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucketList_get_Buckets, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucketList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucketList_get_OwnerID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucketList_get_OwnerDisplayName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElAWSS3DataStorageBucketList___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Storage, TElAWSS3DataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElAWSS3DataStorageBucketList_methods[] = {
	PHP_ME(TElAWSS3DataStorageBucketList, get_Buckets, arginfo_TElAWSS3DataStorageBucketList_get_Buckets, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucketList, get_Count, arginfo_TElAWSS3DataStorageBucketList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucketList, get_OwnerID, arginfo_TElAWSS3DataStorageBucketList_get_OwnerID, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucketList, get_OwnerDisplayName, arginfo_TElAWSS3DataStorageBucketList_get_OwnerDisplayName, ZEND_ACC_PUBLIC)
	PHP_ME(TElAWSS3DataStorageBucketList, __construct, arginfo_TElAWSS3DataStorageBucketList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElAWSS3DataStorageBucketList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElAWSS3DataStorageBucketList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElAWSS3DataStorageBucketList", TElAWSS3DataStorageBucketList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElAWSS3DataStorageBucketList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBAWSDataStorage, GetNodeInnerXML)
{
	uint32_t _err;
	zval *oXmlNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXmlNode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBAWSDataStorage_GetNodeInnerXML(SBGetObjectHandle(oXmlNode TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1303587692, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

void Register_SBAWSDataStorage_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBAWSProtocol", NULL);
	TSBAWSProtocol_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAWSProtocol_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSProtocol_ce_ptr, "awspREST", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSProtocol_ce_ptr, "awspSOAP", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBAWSAuthType", NULL);
	TSBAWSAuthType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAWSAuthType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSAuthType_ce_ptr, "awsaAccessKey", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSAuthType_ce_ptr, "awsaCertificate", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBAWSS3ReadObjectCondition", NULL);
	TSBAWSS3ReadObjectCondition_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAWSS3ReadObjectCondition_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3ReadObjectCondition_ce_ptr, "awsrNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3ReadObjectCondition_ce_ptr, "awsrIfModifiedSince", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3ReadObjectCondition_ce_ptr, "awsrIfUnmodifiedSince", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3ReadObjectCondition_ce_ptr, "awsrIfMatch", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3ReadObjectCondition_ce_ptr, "awsrIfNoneMatch", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBAWSS3BucketAccessType", NULL);
	TSBAWSS3BucketAccessType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAWSS3BucketAccessType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3BucketAccessType_ce_ptr, "awsbatAuto", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3BucketAccessType_ce_ptr, "awsbatVirtualHost", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3BucketAccessType_ce_ptr, "awsbatVirtualPath", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBAWSS3AccessControlGranteeType", NULL);
	TSBAWSS3AccessControlGranteeType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAWSS3AccessControlGranteeType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlGranteeType_ce_ptr, "acqtUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlGranteeType_ce_ptr, "acgtCanonicalUser", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlGranteeType_ce_ptr, "acgtAmazonCustomerByEmail", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlGranteeType_ce_ptr, "acgtGroup", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlGranteeType_ce_ptr, "acgtAuthenticatedUsersGroup", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlGranteeType_ce_ptr, "acgtAllUsersGroup", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlGranteeType_ce_ptr, "acgtLogDeliveryGroup", 6)
	
	INIT_CLASS_ENTRY(ce, "TSBAWSS3AccessControlPermission", NULL);
	TSBAWSS3AccessControlPermission_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAWSS3AccessControlPermission_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlPermission_ce_ptr, "acpUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlPermission_ce_ptr, "acpRead", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlPermission_ce_ptr, "acpWrite", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlPermission_ce_ptr, "acpReadACP", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlPermission_ce_ptr, "acpWriteACP", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3AccessControlPermission_ce_ptr, "acpFullControl", 5)
	
	INIT_CLASS_ENTRY(ce, "TSBAWSS3BucketVersioning", NULL);
	TSBAWSS3BucketVersioning_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAWSS3BucketVersioning_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3BucketVersioning_ce_ptr, "bvEnabled", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3BucketVersioning_ce_ptr, "bvSuspended", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3BucketVersioning_ce_ptr, "bvDisabled", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBAWSS3DataStorageOption", NULL);
	TSBAWSS3DataStorageOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAWSS3DataStorageOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3DataStorageOption_ce_ptr, "awsoptDetailedList", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3DataStorageOption_ce_ptr, "awsoptUseHeadRequests", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3DataStorageOption_ce_ptr, "awsoptLiberalBucketNaming", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBAWSS3DataStorageOptions", NULL);
	TSBAWSS3DataStorageOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBAWSS3DataStorageOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3DataStorageOptions_ce_ptr, "awsoptDetailedList", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3DataStorageOptions_ce_ptr, "awsoptUseHeadRequests", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3DataStorageOptions_ce_ptr, "awsoptLiberalBucketNaming", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBAWSS3Region", NULL);
	TSBAWSS3Region_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBAWSS3Region_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3Region_ce_ptr, "awsrCustom", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3Region_ce_ptr, "awsrDefault", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3Region_ce_ptr, "awsrUSStandard", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3Region_ce_ptr, "awsrUSWestOregon", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3Region_ce_ptr, "awsrUSWestNCalifornia", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3Region_ce_ptr, "awsrEUIreland", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3Region_ce_ptr, "awsrEUFrankfurt", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3Region_ce_ptr, "awsrAPSingapore", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3Region_ce_ptr, "awsrAPSydney", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3Region_ce_ptr, "awsrAPTokyo", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3Region_ce_ptr, "awsrSASaoPaulo", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBAWSS3Region_ce_ptr, "awsrAPSeoul", 11)
}
