#include "sbboxdatastorage.h"

zend_class_entry *TSBBoxGroupRole_ce_ptr = NULL;

zend_class_entry *TSBBoxUserRole_ce_ptr = NULL;

zend_class_entry *TSBBoxUserStatus_ce_ptr = NULL;

zend_class_entry *TSBBoxSyncState_ce_ptr = NULL;

zend_class_entry *TSBBoxSharedLinkAccess_ce_ptr = NULL;

zend_class_entry *TSBBoxObjectStatus_ce_ptr = NULL;

zend_class_entry *TSBBoxCollaborationStatus_ce_ptr = NULL;

zend_class_entry *TSBBoxCollaborationRole_ce_ptr = NULL;

zend_class_entry *TElBoxDataStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxDataStorage, StartAuthorization)
{
	char *sRedirectURL;
	int sRedirectURL_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sRedirectURL, &sRedirectURL_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxDataStorage_StartAuthorization(SBGetObjectHandle(getThis() TSRMLS_CC), sRedirectURL, (int32_t)sRedirectURL_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-362728436, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, CompleteAuthorization)
{
	char *sAuthorizationCode;
	int sAuthorizationCode_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAuthorizationCode, &sAuthorizationCode_len) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorage_CompleteAuthorization(SBGetObjectHandle(getThis() TSRMLS_CC), sAuthorizationCode, (int32_t)sAuthorizationCode_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, CloseSession)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxDataStorage_CloseSession(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, AcquireFile)
{
	char *sID;
	int sID_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sID, &sID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorage_AcquireFile(SBGetObjectHandle(getThis() TSRMLS_CC), sID, (int32_t)sID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxFile_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, AcquireFolder)
{
	char *sID;
	int sID_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sID, &sID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorage_AcquireFolder(SBGetObjectHandle(getThis() TSRMLS_CC), sID, (int32_t)sID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxFolder_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, CopyObject)
{
	char *sNewName;
	int sNewName_len;
	zval *oDestination;
	zval *oNewHandler;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElBoxDataStorageObject_ce_ptr, &oDestination, TElBoxFolder_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorage_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!s", &oObj, TElBoxDataStorageObject_ce_ptr, &oDestination, TElBoxFolder_ce_ptr, &sNewName, &sNewName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorage_CopyObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC), sNewName, (int32_t)sNewName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorage_CopyObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxDataStorageObject, TElBoxFolder) or (TElBoxDataStorageObject, TElBoxFolder, string) or (TElCustomDataStorageObject, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, GetAccountInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorage_GetAccountInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, ListTrashed)
{
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorage_ListTrashed(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, PurgeObject)
{
	TElClassHandle hoObj;
	zval *oObj;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oObj, TElBoxDataStorageObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oObj) && (IS_OBJECT == Z_TYPE_P(oObj)))
	{
		hoObj = SBGetObjectHandle(oObj TSRMLS_CC);
		SBCheckError(TElBoxDataStorage_PurgeObject(SBGetObjectHandle(getThis() TSRMLS_CC), &hoObj) TSRMLS_CC);
		SBUpdateObjectHandle(oObj, hoObj TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElBoxDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, RestoreObject)
{
	char *sNewName;
	int sNewName_len;
	zval *oNewParent;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElBoxDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorage_RestoreObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!s", &oObj, TElBoxDataStorageObject_ce_ptr, &oNewParent, TElBoxFolder_ce_ptr, &sNewName, &sNewName_len) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorage_RestoreObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oNewParent TSRMLS_CC), sNewName, (int32_t)sNewName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxDataStorageObject) or (TElBoxDataStorageObject, TElBoxFolder, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, get_AccessToken)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxDataStorage_get_AccessToken(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1498661929, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, get_Groups)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorage_get_Groups(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxGroups_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, get_Users)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorage_get_Users(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUsers_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, get_ClientID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxDataStorage_get_ClientID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1302764093, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, set_ClientID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorage_set_ClientID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, get_ClientSecret)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxDataStorage_get_ClientSecret(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1830670917, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, set_ClientSecret)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorage_set_ClientSecret(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, get_HTTPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorage_get_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, set_HTTPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHTTPSClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorage_set_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, get_PassthroughMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxDataStorage_get_PassthroughMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, set_PassthroughMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorage_set_PassthroughMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, get_RefreshToken)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxDataStorage_get_RefreshToken(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1983226843, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, set_RefreshToken)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorage_set_RefreshToken(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, get_UseETags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxDataStorage_get_UseETags(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, set_UseETags)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorage_set_UseETags(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_StartAuthorization, 0, 0, 1)
	ZEND_ARG_INFO(0, RedirectURL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_CompleteAuthorization, 0, 0, 1)
	ZEND_ARG_INFO(0, AuthorizationCode)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_CloseSession, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_AcquireFile, 0, 0, 1)
	ZEND_ARG_INFO(0, ID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_AcquireFolder, 0, 0, 1)
	ZEND_ARG_INFO(0, ID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_CopyObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Destination_or_NewHandler, 0, 1)
	ZEND_ARG_INFO(0, NewName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_GetAccountInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_ListTrashed, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_PurgeObject, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Obj, TElBoxDataStorageObject, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_RestoreObject, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Obj, TElBoxDataStorageObject, 1)
	ZEND_ARG_OBJ_INFO(0, NewParent, TElBoxFolder, 1)
	ZEND_ARG_INFO(0, NewName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_get_AccessToken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_get_Groups, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_get_Users, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_get_ClientID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_set_ClientID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_get_ClientSecret, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_set_ClientSecret, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_get_HTTPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_set_HTTPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHTTPSClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_get_PassthroughMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_set_PassthroughMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_get_RefreshToken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_set_RefreshToken, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_get_UseETags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage_set_UseETags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxDataStorage_methods[] = {
	PHP_ME(TElBoxDataStorage, StartAuthorization, arginfo_TElBoxDataStorage_StartAuthorization, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, CompleteAuthorization, arginfo_TElBoxDataStorage_CompleteAuthorization, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, CloseSession, arginfo_TElBoxDataStorage_CloseSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, AcquireFile, arginfo_TElBoxDataStorage_AcquireFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, AcquireFolder, arginfo_TElBoxDataStorage_AcquireFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, CopyObject, arginfo_TElBoxDataStorage_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, GetAccountInfo, arginfo_TElBoxDataStorage_GetAccountInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, ListTrashed, arginfo_TElBoxDataStorage_ListTrashed, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, PurgeObject, arginfo_TElBoxDataStorage_PurgeObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, RestoreObject, arginfo_TElBoxDataStorage_RestoreObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, get_AccessToken, arginfo_TElBoxDataStorage_get_AccessToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, get_Groups, arginfo_TElBoxDataStorage_get_Groups, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, get_Users, arginfo_TElBoxDataStorage_get_Users, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, get_ClientID, arginfo_TElBoxDataStorage_get_ClientID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, set_ClientID, arginfo_TElBoxDataStorage_set_ClientID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, get_ClientSecret, arginfo_TElBoxDataStorage_get_ClientSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, set_ClientSecret, arginfo_TElBoxDataStorage_set_ClientSecret, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, get_HTTPClient, arginfo_TElBoxDataStorage_get_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, set_HTTPClient, arginfo_TElBoxDataStorage_set_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, get_PassthroughMode, arginfo_TElBoxDataStorage_get_PassthroughMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, set_PassthroughMode, arginfo_TElBoxDataStorage_set_PassthroughMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, get_RefreshToken, arginfo_TElBoxDataStorage_get_RefreshToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, set_RefreshToken, arginfo_TElBoxDataStorage_set_RefreshToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, get_UseETags, arginfo_TElBoxDataStorage_get_UseETags, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, set_UseETags, arginfo_TElBoxDataStorage_set_UseETags, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorage, __construct, arginfo_TElBoxDataStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxDataStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxDataStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxDataStorage", TElBoxDataStorage_methods);
	if (NULL == TElCustomDataStorage_ce_ptr)
		Register_TElCustomDataStorage(TSRMLS_C);
	TElBoxDataStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxDataStorageObject_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxDataStorageObject, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorageObject_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, Copy)
{
	char *sNewName;
	int sNewName_len;
	zval *oDestination;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestination, TElBoxFolder_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorageObject_Copy(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oDestination, TElBoxFolder_ce_ptr, &sNewName, &sNewName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorageObject_Copy_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC), sNewName, (int32_t)sNewName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxFolder) or (TElBoxFolder, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxDataStorageObject_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, Move)
{
	zval *oDestination;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestination, TElBoxFolder_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorageObject_Move(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestination TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxFolder)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, Rename)
{
	char *sNewName;
	int sNewName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sNewName, &sNewName_len) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorageObject_Rename(SBGetObjectHandle(getThis() TSRMLS_CC), sNewName, (int32_t)sNewName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, Purge)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxDataStorageObject_Purge(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, TransferOwnership)
{
	zval *oNewOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNewOwner, TElBoxUserInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorageObject_TransferOwnership(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNewOwner TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxUserInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_ContentCreatedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObject_get_ContentCreatedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_ContentModifiedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObject_get_ContentModifiedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_CreatedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObject_get_CreatedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_CreatedBy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorageObject_get_CreatedBy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUserInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_Description)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxDataStorageObject_get_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-102291091, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, set_Description)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorageObject_set_Description(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxDataStorageObject_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(364122006, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxDataStorageObject_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-119831906, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_ModifiedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObject_get_ModifiedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_ModifiedBy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorageObject_get_ModifiedBy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUserInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_OwnedBy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorageObject_get_OwnedBy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUserInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_ParentID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxDataStorageObject_get_ParentID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1752510076, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_PurgedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObject_get_PurgedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_SequenceID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxDataStorageObject_get_SequenceID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(388772877, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_SharedLink)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorageObject_get_SharedLink(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxSharedLink_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObject_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_Status)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBoxObjectStatusRaw fOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObject_get_Status(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, get_TrashedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObject_get_TrashedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObject, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElBoxDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorageObject_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_Copy, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Destination, TElBoxFolder, 1)
	ZEND_ARG_INFO(0, NewName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_Move, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Destination, TElBoxFolder, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_Rename, 0, 0, 1)
	ZEND_ARG_INFO(0, NewName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_Purge, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_TransferOwnership, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, NewOwner, TElBoxUserInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_ContentCreatedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_ContentModifiedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_CreatedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_CreatedBy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_Description, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_set_Description, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_ModifiedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_ModifiedBy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_OwnedBy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_ParentID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_PurgedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_SequenceID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_SharedLink, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_Status, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject_get_TrashedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElBoxDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxDataStorageObject_methods[] = {
	PHP_ME(TElBoxDataStorageObject, Assign, arginfo_TElBoxDataStorageObject_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, Copy, arginfo_TElBoxDataStorageObject_Copy, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, Delete, arginfo_TElBoxDataStorageObject_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, Move, arginfo_TElBoxDataStorageObject_Move, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, Rename, arginfo_TElBoxDataStorageObject_Rename, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, Purge, arginfo_TElBoxDataStorageObject_Purge, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, TransferOwnership, arginfo_TElBoxDataStorageObject_TransferOwnership, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_ContentCreatedAt, arginfo_TElBoxDataStorageObject_get_ContentCreatedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_ContentModifiedAt, arginfo_TElBoxDataStorageObject_get_ContentModifiedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_CreatedAt, arginfo_TElBoxDataStorageObject_get_CreatedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_CreatedBy, arginfo_TElBoxDataStorageObject_get_CreatedBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_Description, arginfo_TElBoxDataStorageObject_get_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, set_Description, arginfo_TElBoxDataStorageObject_set_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_ETag, arginfo_TElBoxDataStorageObject_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_ID, arginfo_TElBoxDataStorageObject_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_ModifiedAt, arginfo_TElBoxDataStorageObject_get_ModifiedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_ModifiedBy, arginfo_TElBoxDataStorageObject_get_ModifiedBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_OwnedBy, arginfo_TElBoxDataStorageObject_get_OwnedBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_ParentID, arginfo_TElBoxDataStorageObject_get_ParentID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_PurgedAt, arginfo_TElBoxDataStorageObject_get_PurgedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_SequenceID, arginfo_TElBoxDataStorageObject_get_SequenceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_SharedLink, arginfo_TElBoxDataStorageObject_get_SharedLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_Size, arginfo_TElBoxDataStorageObject_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_Status, arginfo_TElBoxDataStorageObject_get_Status, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, get_TrashedAt, arginfo_TElBoxDataStorageObject_get_TrashedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObject, __construct, arginfo_TElBoxDataStorageObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxDataStorageObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxDataStorageObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxDataStorageObject", TElBoxDataStorageObject_methods);
	if (NULL == TElCustomDataStorageObject_ce_ptr)
		Register_TElCustomDataStorageObject(TSRMLS_C);
	TElBoxDataStorageObject_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxFile_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxFile, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxFile_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFile, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxFile_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFile, Write)
{
	zval *dtDataModifiedAt;
	zval *oData;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxFile_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!OO!", &oData, TStream_ce_ptr, &dtDataModifiedAt, php_date_get_date_ce(), &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxFile_Write_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), SBGetDateTime(dtDataModifiedAt TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TElCustomDataStorageSecurityHandler) or (TStream, DateTime, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFile, get_Comments)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxFile_get_Comments(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxComments_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFile, get_Sha1)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxFile_get_Sha1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-819425974, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFile, get_VersionNumber)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxFile_get_VersionNumber(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1278669773, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFile, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElBoxDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxFile_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFile_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFile_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFile_Write, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Data, TStream, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_DataModifiedAt, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFile_get_Comments, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFile_get_Sha1, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFile_get_VersionNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFile___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElBoxDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxFile_methods[] = {
	PHP_ME(TElBoxFile, Assign, arginfo_TElBoxFile_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFile, Clone, arginfo_TElBoxFile_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFile, Write, arginfo_TElBoxFile_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFile, get_Comments, arginfo_TElBoxFile_get_Comments, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFile, get_Sha1, arginfo_TElBoxFile_get_Sha1, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFile, get_VersionNumber, arginfo_TElBoxFile_get_VersionNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFile, __construct, arginfo_TElBoxFile___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxFile(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxFile_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxFile", TElBoxFile_methods);
	if (NULL == TElBoxDataStorageObject_ce_ptr)
		Register_TElBoxDataStorageObject(TSRMLS_C);
	TElBoxFile_ce_ptr = zend_register_internal_class_ex(&ce, TElBoxDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxFolder_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxFolder, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxFolder_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFolder, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxFolder_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFolder, CreateFolder)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxFolder_CreateFolder(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxFolder_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFolder, CreateObject)
{
	char *sName;
	int sName_len;
	zval *dtDataCreatedAt;
	zval *dtDataModifiedAt;
	zval *oData;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sName, &sName_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxFolder_CreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!OOO!", &sName, &sName_len, &oData, TStream_ce_ptr, &dtDataCreatedAt, php_date_get_date_ce(), &dtDataModifiedAt, php_date_get_date_ce(), &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxFolder_CreateObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetDateTime(dtDataCreatedAt TSRMLS_CC), SBGetDateTime(dtDataModifiedAt TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TStream, TElCustomDataStorageSecurityHandler) or (string, TStream, DateTime, DateTime, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFolder, Delete)
{
	zend_bool bRecursive;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bRecursive) == SUCCESS)
	{
		SBCheckError(TElBoxFolder_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bRecursive) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxFolder_Delete_1(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFolder, List)
{
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxFolder_List(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFolder, get_Collaborations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxFolder_get_Collaborations(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxCollaborations_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFolder, get_SyncState)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBoxSyncStateRaw fOutResultRaw = 0;
		SBCheckError(TElBoxFolder_get_SyncState(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFolder, set_SyncState)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElBoxFolder_set_SyncState(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBBoxSyncStateRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxFolder, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElBoxDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxFolder_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFolder_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFolder_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFolder_CreateFolder, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFolder_CreateObject, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_OBJ_INFO(0, Data, TStream, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_DataCreatedAt, 0, 1)
	ZEND_ARG_OBJ_INFO(0, DataModifiedAt, DateTime, 0)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFolder_Delete, 0, 0, 0)
	ZEND_ARG_INFO(0, Recursive)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFolder_List, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFolder_get_Collaborations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFolder_get_SyncState, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFolder_set_SyncState, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxFolder___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElBoxDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxFolder_methods[] = {
	PHP_ME(TElBoxFolder, Assign, arginfo_TElBoxFolder_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFolder, Clone, arginfo_TElBoxFolder_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFolder, CreateFolder, arginfo_TElBoxFolder_CreateFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFolder, CreateObject, arginfo_TElBoxFolder_CreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFolder, Delete, arginfo_TElBoxFolder_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFolder, List, arginfo_TElBoxFolder_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFolder, get_Collaborations, arginfo_TElBoxFolder_get_Collaborations, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFolder, get_SyncState, arginfo_TElBoxFolder_get_SyncState, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFolder, set_SyncState, arginfo_TElBoxFolder_set_SyncState, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxFolder, __construct, arginfo_TElBoxFolder___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxFolder(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxFolder_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxFolder", TElBoxFolder_methods);
	if (NULL == TElBoxDataStorageObject_ce_ptr)
		Register_TElBoxDataStorageObject(TSRMLS_C);
	TElBoxFolder_ce_ptr = zend_register_internal_class_ex(&ce, TElBoxDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxGroupInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxGroupInfo, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxGroupInfo_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-687892733, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupInfo, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxGroupInfo_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(194821972, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroupInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupInfo_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupInfo_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxGroupInfo_methods[] = {
	PHP_ME(TElBoxGroupInfo, get_ID, arginfo_TElBoxGroupInfo_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupInfo, get_Name, arginfo_TElBoxGroupInfo_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupInfo, __construct, arginfo_TElBoxGroupInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxGroupInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxGroupInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxGroupInfo", TElBoxGroupInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxGroupInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxUserInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxUserInfo, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElBoxUserInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxUserInfo_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxUserInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserInfo, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUserInfo_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUserInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserInfo, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxUserInfo_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1112955262, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserInfo, get_Login)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxUserInfo_get_Login(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1533063583, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserInfo, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxUserInfo_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-305019919, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserInfo, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUserInfo_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserInfo_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElBoxUserInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserInfo_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserInfo_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserInfo_get_Login, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserInfo_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserInfo___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxUserInfo_methods[] = {
	PHP_ME(TElBoxUserInfo, Assign, arginfo_TElBoxUserInfo_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserInfo, Clone, arginfo_TElBoxUserInfo_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserInfo, get_ID, arginfo_TElBoxUserInfo_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserInfo, get_Login, arginfo_TElBoxUserInfo_get_Login, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserInfo, get_Name, arginfo_TElBoxUserInfo_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserInfo, __construct, arginfo_TElBoxUserInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxUserInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxUserInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxUserInfo", TElBoxUserInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxUserInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxEnterprise_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxEnterprise, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxEnterprise_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(413544010, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxEnterprise, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxEnterprise_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1734701463, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxEnterprise, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxEnterprise_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxEnterprise_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxEnterprise_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxEnterprise___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxEnterprise_methods[] = {
	PHP_ME(TElBoxEnterprise, get_ID, arginfo_TElBoxEnterprise_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxEnterprise, get_Name, arginfo_TElBoxEnterprise_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxEnterprise, __construct, arginfo_TElBoxEnterprise___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxEnterprise(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxEnterprise_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxEnterprise", TElBoxEnterprise_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxEnterprise_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxUserEmailAlias_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxUserEmailAlias, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxUserEmailAlias_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserEmailAlias, MakePrimary)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxUserEmailAlias_MakePrimary(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserEmailAlias, get_Email)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxUserEmailAlias_get_Email(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1290029953, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserEmailAlias, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxUserEmailAlias_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1892904461, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserEmailAlias, get_IsConfirmed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxUserEmailAlias_get_IsConfirmed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserEmailAlias, get_IsPrimary)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxUserEmailAlias_get_IsPrimary(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserEmailAlias, get_Owner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUserEmailAlias_get_Owner(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserEmailAlias, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxUser_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUserEmailAlias_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxUser)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAlias_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAlias_MakePrimary, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAlias_get_Email, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAlias_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAlias_get_IsConfirmed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAlias_get_IsPrimary, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAlias_get_Owner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAlias___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxUser, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxUserEmailAlias_methods[] = {
	PHP_ME(TElBoxUserEmailAlias, Delete, arginfo_TElBoxUserEmailAlias_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserEmailAlias, MakePrimary, arginfo_TElBoxUserEmailAlias_MakePrimary, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserEmailAlias, get_Email, arginfo_TElBoxUserEmailAlias_get_Email, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserEmailAlias, get_ID, arginfo_TElBoxUserEmailAlias_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserEmailAlias, get_IsConfirmed, arginfo_TElBoxUserEmailAlias_get_IsConfirmed, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserEmailAlias, get_IsPrimary, arginfo_TElBoxUserEmailAlias_get_IsPrimary, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserEmailAlias, get_Owner, arginfo_TElBoxUserEmailAlias_get_Owner, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserEmailAlias, __construct, arginfo_TElBoxUserEmailAlias___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxUserEmailAlias(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxUserEmailAlias_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxUserEmailAlias", TElBoxUserEmailAlias_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxUserEmailAlias_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxUserEmailAliases_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxUserEmailAliases, Add)
{
	char *sEmail;
	int sEmail_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sEmail, &sEmail_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUserEmailAliases_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sEmail, (int32_t)sEmail_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUserEmailAlias_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserEmailAliases, IndexOf)
{
	char *sID;
	int sID_len;
	zval *oAlias;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAlias, TElBoxUserEmailAlias_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxUserEmailAliases_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAlias TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sID, &sID_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxUserEmailAliases_IndexOf_1(SBGetObjectHandle(getThis() TSRMLS_CC), sID, (int32_t)sID_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxUserEmailAlias) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserEmailAliases, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxUserEmailAliases_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserEmailAliases, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxUserEmailAliases_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserEmailAliases, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUserEmailAliases_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUserEmailAlias_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUserEmailAliases, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxUser_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUserEmailAliases_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxUser)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAliases_Add, 0, 0, 1)
	ZEND_ARG_INFO(0, Email)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAliases_IndexOf, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Alias_or_ID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAliases_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAliases_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAliases_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUserEmailAliases___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxUser, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxUserEmailAliases_methods[] = {
	PHP_ME(TElBoxUserEmailAliases, Add, arginfo_TElBoxUserEmailAliases_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserEmailAliases, IndexOf, arginfo_TElBoxUserEmailAliases_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserEmailAliases, Refresh, arginfo_TElBoxUserEmailAliases_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserEmailAliases, get_Count, arginfo_TElBoxUserEmailAliases_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserEmailAliases, get_Items, arginfo_TElBoxUserEmailAliases_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUserEmailAliases, __construct, arginfo_TElBoxUserEmailAliases___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxUserEmailAliases(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxUserEmailAliases_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxUserEmailAliases", TElBoxUserEmailAliases_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxUserEmailAliases_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxGroupMembership_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxGroupMembership, Discontinue)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxGroupMembership_Discontinue(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMembership, get_GroupID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxGroupMembership_get_GroupID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-554459209, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMembership, get_GroupName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxGroupMembership_get_GroupName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2047978282, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMembership, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxGroupMembership_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(951832057, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMembership, get_JoinedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxGroupMembership_get_JoinedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMembership, get_Role)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBoxGroupRoleRaw fOutResultRaw = 0;
		SBCheckError(TElBoxGroupMembership_get_Role(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMembership, set_Role)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElBoxGroupMembership_set_Role(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBBoxGroupRoleRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMembership, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxUser_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroupMembership_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxUser)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembership_Discontinue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembership_get_GroupID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembership_get_GroupName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembership_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembership_get_JoinedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembership_get_Role, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembership_set_Role, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembership___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxUser, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxGroupMembership_methods[] = {
	PHP_ME(TElBoxGroupMembership, Discontinue, arginfo_TElBoxGroupMembership_Discontinue, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMembership, get_GroupID, arginfo_TElBoxGroupMembership_get_GroupID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMembership, get_GroupName, arginfo_TElBoxGroupMembership_get_GroupName, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMembership, get_ID, arginfo_TElBoxGroupMembership_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMembership, get_JoinedAt, arginfo_TElBoxGroupMembership_get_JoinedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMembership, get_Role, arginfo_TElBoxGroupMembership_get_Role, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMembership, set_Role, arginfo_TElBoxGroupMembership_set_Role, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMembership, __construct, arginfo_TElBoxGroupMembership___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxGroupMembership(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxGroupMembership_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxGroupMembership", TElBoxGroupMembership_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxGroupMembership_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxGroupMemberships_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxGroupMemberships, Join)
{
	zval *oGroup;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oGroup, TElBoxGroup_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroupMemberships_Join(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oGroup TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxGroupMembership_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxGroup)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMemberships, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxGroupMemberships_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMemberships, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxGroupMemberships_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMemberships, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroupMemberships_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxGroupMembership_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMemberships, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxUser_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroupMemberships_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxUser)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMemberships_Join, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Group, TElBoxGroup, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMemberships_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMemberships_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMemberships_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMemberships___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxUser, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxGroupMemberships_methods[] = {
	PHP_ME(TElBoxGroupMemberships, Join, arginfo_TElBoxGroupMemberships_Join, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMemberships, Refresh, arginfo_TElBoxGroupMemberships_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMemberships, get_Count, arginfo_TElBoxGroupMemberships_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMemberships, get_Items, arginfo_TElBoxGroupMemberships_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMemberships, __construct, arginfo_TElBoxGroupMemberships___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxGroupMemberships(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxGroupMemberships_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxGroupMemberships", TElBoxGroupMemberships_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxGroupMemberships_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxUser_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxUser, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElBoxUserInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxUser_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxUserInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, BeginUpdate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxUser_BeginUpdate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUser_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUserInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxUser_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, EndUpdate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxUser_EndUpdate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, Refresh)
{
	zend_bool bRequestSpecialFields;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bRequestSpecialFields) == SUCCESS)
	{
		SBCheckError(TElBoxUser_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bRequestSpecialFields) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, RemoveFromEnterprise)
{
	zend_bool bNotify;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bNotify) == SUCCESS)
	{
		SBCheckError(TElBoxUser_RemoveFromEnterprise(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bNotify) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, RequestPasswordReset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxUser_RequestPasswordReset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxUser_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(150292373, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElBoxUser_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_CanSeeManagedUsers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxUser_get_CanSeeManagedUsers(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, set_CanSeeManagedUsers)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBoxUser_set_CanSeeManagedUsers(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_EmailAliases)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUser_get_EmailAliases(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUserEmailAliases_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_Enterprise)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUser_get_Enterprise(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxEnterprise_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxUser_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1779615977, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_IsExemptFromDeviceLimits)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxUser_get_IsExemptFromDeviceLimits(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, set_IsExemptFromDeviceLimits)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBoxUser_set_IsExemptFromDeviceLimits(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_IsExemptFromLoginVerification)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxUser_get_IsExemptFromLoginVerification(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, set_IsExemptFromLoginVerification)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBoxUser_set_IsExemptFromLoginVerification(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_IsSyncEnabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxUser_get_IsSyncEnabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, set_IsSyncEnabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElBoxUser_set_IsSyncEnabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_Login)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxUser_get_Login(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1146393142, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_Memberships)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUser_get_Memberships(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxGroupMemberships_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxUser_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-203126533, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElBoxUser_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_JobTitle)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxUser_get_JobTitle(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-121384467, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, set_JobTitle)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElBoxUser_set_JobTitle(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_Language)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxUser_get_Language(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(470217069, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, set_Language)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElBoxUser_set_Language(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_Phone)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxUser_get_Phone(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1441542407, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, set_Phone)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElBoxUser_set_Phone(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_Role)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBoxUserRoleRaw fOutResultRaw = 0;
		SBCheckError(TElBoxUser_get_Role(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, set_Role)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElBoxUser_set_Role(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBBoxUserRoleRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_SpaceAmount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElBoxUser_get_SpaceAmount(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, set_SpaceAmount)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElBoxUser_set_SpaceAmount(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_SpaceUsed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElBoxUser_get_SpaceUsed(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, get_Status)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBoxUserStatusRaw fOutResultRaw = 0;
		SBCheckError(TElBoxUser_get_Status(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, set_Status)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElBoxUser_set_Status(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBBoxUserStatusRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUser, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElBoxDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUser_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElBoxUserInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_BeginUpdate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_EndUpdate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_Refresh, 0, 0, 1)
	ZEND_ARG_INFO(0, RequestSpecialFields)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_RemoveFromEnterprise, 0, 0, 1)
	ZEND_ARG_INFO(0, Notify)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_RequestPasswordReset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_CanSeeManagedUsers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_set_CanSeeManagedUsers, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_EmailAliases, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_Enterprise, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_IsExemptFromDeviceLimits, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_set_IsExemptFromDeviceLimits, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_IsExemptFromLoginVerification, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_set_IsExemptFromLoginVerification, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_IsSyncEnabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_set_IsSyncEnabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_Login, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_Memberships, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_JobTitle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_set_JobTitle, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_Language, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_set_Language, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_Phone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_set_Phone, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_Role, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_set_Role, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_SpaceAmount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_set_SpaceAmount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_SpaceUsed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_get_Status, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser_set_Status, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUser___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElBoxDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxUser_methods[] = {
	PHP_ME(TElBoxUser, Assign, arginfo_TElBoxUser_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, BeginUpdate, arginfo_TElBoxUser_BeginUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, Clone, arginfo_TElBoxUser_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, Delete, arginfo_TElBoxUser_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, EndUpdate, arginfo_TElBoxUser_EndUpdate, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, Refresh, arginfo_TElBoxUser_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, RemoveFromEnterprise, arginfo_TElBoxUser_RemoveFromEnterprise, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, RequestPasswordReset, arginfo_TElBoxUser_RequestPasswordReset, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_Address, arginfo_TElBoxUser_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, set_Address, arginfo_TElBoxUser_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_CanSeeManagedUsers, arginfo_TElBoxUser_get_CanSeeManagedUsers, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, set_CanSeeManagedUsers, arginfo_TElBoxUser_set_CanSeeManagedUsers, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_EmailAliases, arginfo_TElBoxUser_get_EmailAliases, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_Enterprise, arginfo_TElBoxUser_get_Enterprise, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_ID, arginfo_TElBoxUser_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_IsExemptFromDeviceLimits, arginfo_TElBoxUser_get_IsExemptFromDeviceLimits, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, set_IsExemptFromDeviceLimits, arginfo_TElBoxUser_set_IsExemptFromDeviceLimits, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_IsExemptFromLoginVerification, arginfo_TElBoxUser_get_IsExemptFromLoginVerification, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, set_IsExemptFromLoginVerification, arginfo_TElBoxUser_set_IsExemptFromLoginVerification, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_IsSyncEnabled, arginfo_TElBoxUser_get_IsSyncEnabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, set_IsSyncEnabled, arginfo_TElBoxUser_set_IsSyncEnabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_Login, arginfo_TElBoxUser_get_Login, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_Memberships, arginfo_TElBoxUser_get_Memberships, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_Name, arginfo_TElBoxUser_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, set_Name, arginfo_TElBoxUser_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_JobTitle, arginfo_TElBoxUser_get_JobTitle, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, set_JobTitle, arginfo_TElBoxUser_set_JobTitle, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_Language, arginfo_TElBoxUser_get_Language, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, set_Language, arginfo_TElBoxUser_set_Language, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_Phone, arginfo_TElBoxUser_get_Phone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, set_Phone, arginfo_TElBoxUser_set_Phone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_Role, arginfo_TElBoxUser_get_Role, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, set_Role, arginfo_TElBoxUser_set_Role, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_SpaceAmount, arginfo_TElBoxUser_get_SpaceAmount, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, set_SpaceAmount, arginfo_TElBoxUser_set_SpaceAmount, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_SpaceUsed, arginfo_TElBoxUser_get_SpaceUsed, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, get_Status, arginfo_TElBoxUser_get_Status, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, set_Status, arginfo_TElBoxUser_set_Status, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUser, __construct, arginfo_TElBoxUser___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxUser(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxUser_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxUser", TElBoxUser_methods);
	if (NULL == TElBoxUserInfo_ce_ptr)
		Register_TElBoxUserInfo(TSRMLS_C);
	TElBoxUser_ce_ptr = zend_register_internal_class_ex(&ce, TElBoxUserInfo_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxUsers_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxUsers, Add)
{
	char *sLogin;
	char *sName;
	int sLogin_len;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sLogin, &sLogin_len, &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUsers_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sLogin, (int32_t)sLogin_len, sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUsers, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxUsers_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUsers, IndexOf)
{
	char *sID;
	int sID_len;
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUser, TElBoxUser_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxUsers_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sID, &sID_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxUsers_IndexOf_1(SBGetObjectHandle(getThis() TSRMLS_CC), sID, (int32_t)sID_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxUser) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUsers, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxUsers_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUsers, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxUsers_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUsers, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUsers_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUser_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxUsers, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElBoxDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxUsers_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUsers_Add, 0, 0, 2)
	ZEND_ARG_INFO(0, Login)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUsers_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUsers_IndexOf, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, User_or_ID, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUsers_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUsers_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUsers_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxUsers___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElBoxDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxUsers_methods[] = {
	PHP_ME(TElBoxUsers, Add, arginfo_TElBoxUsers_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUsers, Clear, arginfo_TElBoxUsers_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUsers, IndexOf, arginfo_TElBoxUsers_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUsers, Refresh, arginfo_TElBoxUsers_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUsers, get_Count, arginfo_TElBoxUsers_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUsers, get_Items, arginfo_TElBoxUsers_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxUsers, __construct, arginfo_TElBoxUsers___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxUsers(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxUsers_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxUsers", TElBoxUsers_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxUsers_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxGroupMember_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxGroupMember, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxGroupMember_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMember, Remove)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxGroupMember_Remove(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMember, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxGroupMember_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(550047643, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMember, get_JoinedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxGroupMember_get_JoinedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMember, get_Role)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBoxGroupRoleRaw fOutResultRaw = 0;
		SBCheckError(TElBoxGroupMember_get_Role(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMember, set_Role)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElBoxGroupMember_set_Role(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBBoxGroupRoleRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMember, get_UserID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxGroupMember_get_UserID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(752419307, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMember, get_UserLogin)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxGroupMember_get_UserLogin(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1344437753, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMember, get_UserName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxGroupMember_get_UserName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2074670361, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMember, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxGroup_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroupMember_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxGroup)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMember_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMember_Remove, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMember_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMember_get_JoinedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMember_get_Role, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMember_set_Role, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMember_get_UserID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMember_get_UserLogin, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMember_get_UserName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMember___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxGroup, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxGroupMember_methods[] = {
	PHP_ME(TElBoxGroupMember, Refresh, arginfo_TElBoxGroupMember_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMember, Remove, arginfo_TElBoxGroupMember_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMember, get_ID, arginfo_TElBoxGroupMember_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMember, get_JoinedAt, arginfo_TElBoxGroupMember_get_JoinedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMember, get_Role, arginfo_TElBoxGroupMember_get_Role, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMember, set_Role, arginfo_TElBoxGroupMember_set_Role, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMember, get_UserID, arginfo_TElBoxGroupMember_get_UserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMember, get_UserLogin, arginfo_TElBoxGroupMember_get_UserLogin, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMember, get_UserName, arginfo_TElBoxGroupMember_get_UserName, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMember, __construct, arginfo_TElBoxGroupMember___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxGroupMember(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxGroupMember_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxGroupMember", TElBoxGroupMember_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxGroupMember_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxGroupMembers_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxGroupMembers, Add)
{
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUser, TElBoxUser_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroupMembers_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxGroupMember_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxUser)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMembers, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxGroupMembers_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMembers, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxGroupMembers_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMembers, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroupMembers_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxGroupMember_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroupMembers, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxGroup_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroupMembers_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxGroup)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembers_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, User, TElBoxUser, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembers_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembers_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembers_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroupMembers___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxGroup, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxGroupMembers_methods[] = {
	PHP_ME(TElBoxGroupMembers, Add, arginfo_TElBoxGroupMembers_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMembers, Refresh, arginfo_TElBoxGroupMembers_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMembers, get_Count, arginfo_TElBoxGroupMembers_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMembers, get_Items, arginfo_TElBoxGroupMembers_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroupMembers, __construct, arginfo_TElBoxGroupMembers___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxGroupMembers(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxGroupMembers_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxGroupMembers", TElBoxGroupMembers_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxGroupMembers_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxGroup_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxGroup, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxGroup_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroup, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxGroup_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroup, get_CreatedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxGroup_get_CreatedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroup, get_Members)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroup_get_Members(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxGroupMembers_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroup, get_ModifiedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxGroup_get_ModifiedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroup, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxGroup_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-786722290, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroup, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElBoxGroup_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroup, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElBoxDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroup_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroup_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroup_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroup_get_CreatedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroup_get_Members, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroup_get_ModifiedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroup_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroup_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroup___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElBoxDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxGroup_methods[] = {
	PHP_ME(TElBoxGroup, Delete, arginfo_TElBoxGroup_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroup, Refresh, arginfo_TElBoxGroup_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroup, get_CreatedAt, arginfo_TElBoxGroup_get_CreatedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroup, get_Members, arginfo_TElBoxGroup_get_Members, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroup, get_ModifiedAt, arginfo_TElBoxGroup_get_ModifiedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroup, get_Name, arginfo_TElBoxGroup_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroup, set_Name, arginfo_TElBoxGroup_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroup, __construct, arginfo_TElBoxGroup___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxGroup(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxGroup_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxGroup", TElBoxGroup_methods);
	if (NULL == TElBoxGroupInfo_ce_ptr)
		Register_TElBoxGroupInfo(TSRMLS_C);
	TElBoxGroup_ce_ptr = zend_register_internal_class_ex(&ce, TElBoxGroupInfo_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxGroups_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxGroups, Add)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroups_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxGroup_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroups, IndexOf)
{
	char *sID;
	int sID_len;
	zval *oGroup;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sID, &sID_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxGroups_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), sID, (int32_t)sID_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oGroup, TElBoxGroup_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxGroups_IndexOf_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oGroup TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TElBoxGroup)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroups, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxGroups_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroups, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxGroups_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroups, get_Item)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroups_get_Item(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxGroup_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxGroups, __construct)
{
	zval *oAStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStorage, TElBoxDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxGroups_Create(SBGetObjectHandle(oAStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroups_Add, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroups_IndexOf, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ID_or_Group, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroups_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroups_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroups_get_Item, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxGroups___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AStorage, TElBoxDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxGroups_methods[] = {
	PHP_ME(TElBoxGroups, Add, arginfo_TElBoxGroups_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroups, IndexOf, arginfo_TElBoxGroups_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroups, Refresh, arginfo_TElBoxGroups_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroups, get_Count, arginfo_TElBoxGroups_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroups, get_Item, arginfo_TElBoxGroups_get_Item, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxGroups, __construct, arginfo_TElBoxGroups___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxGroups(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxGroups_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxGroups", TElBoxGroups_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxGroups_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxSharedLink_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxSharedLink, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElBoxSharedLink_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxSharedLink_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxSharedLink)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLink, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxSharedLink_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxSharedLink_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLink, get_Access)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBoxSharedLinkAccessRaw fOutResultRaw = 0;
		SBCheckError(TElBoxSharedLink_get_Access(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLink, get_DownloadCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElBoxSharedLink_get_DownloadCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLink, get_DownloadURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxSharedLink_get_DownloadURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1928362791, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLink, get_IsPasswordEnabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxSharedLink_get_IsPasswordEnabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLink, get_Permissions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxSharedLink_get_Permissions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxSharedLinkPermissions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLink, get_PreviewCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElBoxSharedLink_get_PreviewCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLink, get_UnsharedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxSharedLink_get_UnsharedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLink, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxSharedLink_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1268603232, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLink, get_VanityURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxSharedLink_get_VanityURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2011200463, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLink, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxDataStorageObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxSharedLink_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxDataStorageObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLink_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElBoxSharedLink, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLink_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLink_get_Access, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLink_get_DownloadCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLink_get_DownloadURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLink_get_IsPasswordEnabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLink_get_Permissions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLink_get_PreviewCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLink_get_UnsharedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLink_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLink_get_VanityURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLink___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxDataStorageObject, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxSharedLink_methods[] = {
	PHP_ME(TElBoxSharedLink, Assign, arginfo_TElBoxSharedLink_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLink, Clone, arginfo_TElBoxSharedLink_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLink, get_Access, arginfo_TElBoxSharedLink_get_Access, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLink, get_DownloadCount, arginfo_TElBoxSharedLink_get_DownloadCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLink, get_DownloadURL, arginfo_TElBoxSharedLink_get_DownloadURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLink, get_IsPasswordEnabled, arginfo_TElBoxSharedLink_get_IsPasswordEnabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLink, get_Permissions, arginfo_TElBoxSharedLink_get_Permissions, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLink, get_PreviewCount, arginfo_TElBoxSharedLink_get_PreviewCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLink, get_UnsharedAt, arginfo_TElBoxSharedLink_get_UnsharedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLink, get_URL, arginfo_TElBoxSharedLink_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLink, get_VanityURL, arginfo_TElBoxSharedLink_get_VanityURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLink, __construct, arginfo_TElBoxSharedLink___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxSharedLink(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxSharedLink_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxSharedLink", TElBoxSharedLink_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxSharedLink_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxSharedLinkPermissions_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxSharedLinkPermissions, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElBoxSharedLinkPermissions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxSharedLinkPermissions_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxSharedLinkPermissions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLinkPermissions, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxSharedLinkPermissions_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxSharedLinkPermissions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLinkPermissions, get_CanDownload)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxSharedLinkPermissions_get_CanDownload(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLinkPermissions, get_CanPreview)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxSharedLinkPermissions_get_CanPreview(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxSharedLinkPermissions, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxSharedLink_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxSharedLinkPermissions_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxSharedLink)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLinkPermissions_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElBoxSharedLinkPermissions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLinkPermissions_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLinkPermissions_get_CanDownload, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLinkPermissions_get_CanPreview, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxSharedLinkPermissions___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxSharedLink, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxSharedLinkPermissions_methods[] = {
	PHP_ME(TElBoxSharedLinkPermissions, Assign, arginfo_TElBoxSharedLinkPermissions_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLinkPermissions, Clone, arginfo_TElBoxSharedLinkPermissions_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLinkPermissions, get_CanDownload, arginfo_TElBoxSharedLinkPermissions_get_CanDownload, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLinkPermissions, get_CanPreview, arginfo_TElBoxSharedLinkPermissions_get_CanPreview, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxSharedLinkPermissions, __construct, arginfo_TElBoxSharedLinkPermissions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxSharedLinkPermissions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxSharedLinkPermissions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxSharedLinkPermissions", TElBoxSharedLinkPermissions_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxSharedLinkPermissions_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxCollaboration_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxCollaboration, Accept)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxCollaboration_Accept(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxCollaboration_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxCollaboration_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, Reject)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxCollaboration_Reject(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, get_AcknowledgedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxCollaboration_get_AcknowledgedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, get_CreatedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxCollaboration_get_CreatedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, get_CreatedBy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxCollaboration_get_CreatedBy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUserInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, get_ExpiresAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxCollaboration_get_ExpiresAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, get_Group)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxCollaboration_get_Group(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxGroupInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxCollaboration_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1514423917, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, get_ModifiedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxCollaboration_get_ModifiedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, get_Role)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBoxCollaborationRoleRaw fOutResultRaw = 0;
		SBCheckError(TElBoxCollaboration_get_Role(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, set_Role)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElBoxCollaboration_set_Role(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBBoxCollaborationRoleRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, get_Status)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBBoxCollaborationStatusRaw fOutResultRaw = 0;
		SBCheckError(TElBoxCollaboration_get_Status(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, get_User)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxCollaboration_get_User(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUserInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaboration, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxFolder_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxCollaboration_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxFolder)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_Accept, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_Reject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_get_AcknowledgedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_get_CreatedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_get_CreatedBy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_get_ExpiresAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_get_Group, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_get_ModifiedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_get_Role, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_set_Role, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_get_Status, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration_get_User, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaboration___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxFolder, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxCollaboration_methods[] = {
	PHP_ME(TElBoxCollaboration, Accept, arginfo_TElBoxCollaboration_Accept, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, Delete, arginfo_TElBoxCollaboration_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, Refresh, arginfo_TElBoxCollaboration_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, Reject, arginfo_TElBoxCollaboration_Reject, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, get_AcknowledgedAt, arginfo_TElBoxCollaboration_get_AcknowledgedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, get_CreatedAt, arginfo_TElBoxCollaboration_get_CreatedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, get_CreatedBy, arginfo_TElBoxCollaboration_get_CreatedBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, get_ExpiresAt, arginfo_TElBoxCollaboration_get_ExpiresAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, get_Group, arginfo_TElBoxCollaboration_get_Group, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, get_ID, arginfo_TElBoxCollaboration_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, get_ModifiedAt, arginfo_TElBoxCollaboration_get_ModifiedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, get_Role, arginfo_TElBoxCollaboration_get_Role, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, set_Role, arginfo_TElBoxCollaboration_set_Role, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, get_Status, arginfo_TElBoxCollaboration_get_Status, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, get_User, arginfo_TElBoxCollaboration_get_User, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaboration, __construct, arginfo_TElBoxCollaboration___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxCollaboration(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxCollaboration_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxCollaboration", TElBoxCollaboration_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxCollaboration_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxCollaborations_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxCollaborations, Add)
{
	char *sUserLogin;
	int sUserLogin_len;
	long fRole;
	zend_bool bNotify;
	zval *oGroup;
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lb", &oGroup, TElBoxGroupInfo_ce_ptr, &fRole, &bNotify) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxCollaborations_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oGroup TSRMLS_CC), (TSBBoxCollaborationRoleRaw)fRole, (int8_t)bNotify, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxCollaboration_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lb", &oUser, TElBoxUserInfo_ce_ptr, &fRole, &bNotify) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxCollaborations_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), (TSBBoxCollaborationRoleRaw)fRole, (int8_t)bNotify, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxCollaboration_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slb", &sUserLogin, &sUserLogin_len, &fRole, &bNotify) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxCollaborations_Add_2(SBGetObjectHandle(getThis() TSRMLS_CC), sUserLogin, (int32_t)sUserLogin_len, (TSBBoxCollaborationRoleRaw)fRole, (int8_t)bNotify, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxCollaboration_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxGroupInfo, integer, bool) or (TElBoxUserInfo, integer, bool) or (string, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaborations, IndexOf)
{
	char *sID;
	int sID_len;
	zval *oCollaboration;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sID, &sID_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxCollaborations_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), sID, (int32_t)sID_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCollaboration, TElBoxCollaboration_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxCollaborations_IndexOf_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCollaboration TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TElBoxCollaboration)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaborations, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxCollaborations_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaborations, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxCollaborations_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaborations, get_Item)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxCollaborations_get_Item(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxCollaboration_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxCollaborations, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxFolder_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxCollaborations_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxFolder)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaborations_Add, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Group_or_User_or_UserLogin, 0, 1)
	ZEND_ARG_INFO(0, Role)
	ZEND_ARG_INFO(0, Notify)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaborations_IndexOf, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ID_or_Collaboration, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaborations_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaborations_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaborations_get_Item, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxCollaborations___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxFolder, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxCollaborations_methods[] = {
	PHP_ME(TElBoxCollaborations, Add, arginfo_TElBoxCollaborations_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaborations, IndexOf, arginfo_TElBoxCollaborations_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaborations, Refresh, arginfo_TElBoxCollaborations_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaborations, get_Count, arginfo_TElBoxCollaborations_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaborations, get_Item, arginfo_TElBoxCollaborations_get_Item, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxCollaborations, __construct, arginfo_TElBoxCollaborations___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxCollaborations(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxCollaborations_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxCollaborations", TElBoxCollaborations_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxCollaborations_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxDataStorageObjectPermissions_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxDataStorageObjectPermissions, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElBoxDataStorageObjectPermissions_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElBoxDataStorageObjectPermissions_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxDataStorageObjectPermissions)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObjectPermissions, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorageObjectPermissions_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxDataStorageObjectPermissions_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObjectPermissions, get_CanComment)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObjectPermissions_get_CanComment(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObjectPermissions, get_CanDelete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObjectPermissions_get_CanDelete(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObjectPermissions, get_CanDownload)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObjectPermissions_get_CanDownload(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObjectPermissions, get_CanInviteCollaborator)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObjectPermissions_get_CanInviteCollaborator(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObjectPermissions, get_CanPreview)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObjectPermissions_get_CanPreview(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObjectPermissions, get_CanRename)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObjectPermissions_get_CanRename(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObjectPermissions, get_CanSetShareAccess)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObjectPermissions_get_CanSetShareAccess(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObjectPermissions, get_CanShare)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObjectPermissions_get_CanShare(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObjectPermissions, get_CanUpload)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxDataStorageObjectPermissions_get_CanUpload(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxDataStorageObjectPermissions, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxDataStorageObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxDataStorageObjectPermissions_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxDataStorageObject)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObjectPermissions_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElBoxDataStorageObjectPermissions, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObjectPermissions_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObjectPermissions_get_CanComment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObjectPermissions_get_CanDelete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObjectPermissions_get_CanDownload, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObjectPermissions_get_CanInviteCollaborator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObjectPermissions_get_CanPreview, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObjectPermissions_get_CanRename, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObjectPermissions_get_CanSetShareAccess, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObjectPermissions_get_CanShare, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObjectPermissions_get_CanUpload, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxDataStorageObjectPermissions___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxDataStorageObject, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxDataStorageObjectPermissions_methods[] = {
	PHP_ME(TElBoxDataStorageObjectPermissions, Assign, arginfo_TElBoxDataStorageObjectPermissions_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObjectPermissions, Clone, arginfo_TElBoxDataStorageObjectPermissions_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObjectPermissions, get_CanComment, arginfo_TElBoxDataStorageObjectPermissions_get_CanComment, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObjectPermissions, get_CanDelete, arginfo_TElBoxDataStorageObjectPermissions_get_CanDelete, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObjectPermissions, get_CanDownload, arginfo_TElBoxDataStorageObjectPermissions_get_CanDownload, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObjectPermissions, get_CanInviteCollaborator, arginfo_TElBoxDataStorageObjectPermissions_get_CanInviteCollaborator, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObjectPermissions, get_CanPreview, arginfo_TElBoxDataStorageObjectPermissions_get_CanPreview, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObjectPermissions, get_CanRename, arginfo_TElBoxDataStorageObjectPermissions_get_CanRename, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObjectPermissions, get_CanSetShareAccess, arginfo_TElBoxDataStorageObjectPermissions_get_CanSetShareAccess, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObjectPermissions, get_CanShare, arginfo_TElBoxDataStorageObjectPermissions_get_CanShare, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObjectPermissions, get_CanUpload, arginfo_TElBoxDataStorageObjectPermissions_get_CanUpload, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxDataStorageObjectPermissions, __construct, arginfo_TElBoxDataStorageObjectPermissions___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxDataStorageObjectPermissions(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxDataStorageObjectPermissions_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxDataStorageObjectPermissions", TElBoxDataStorageObjectPermissions_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxDataStorageObjectPermissions_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxComment_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxComment, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxComment_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxComment_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComment, Delete)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxComment_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComment, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxComment_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComment, Reply)
{
	char *sMessage;
	int sMessage_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMessage, &sMessage_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxComment_Reply(SBGetObjectHandle(getThis() TSRMLS_CC), sMessage, (int32_t)sMessage_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxComment_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComment, get_CreatedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxComment_get_CreatedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComment, get_CreatedBy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxComment_get_CreatedBy(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxUserInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComment, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxComment_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(177131509, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComment, get_IsReply)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElBoxComment_get_IsReply(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComment, get_Message)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxComment_get_Message(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(512250160, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComment, set_Message)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElBoxComment_set_Message(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComment, get_ModifiedAt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElBoxComment_get_ModifiedAt(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComment, get_TaggedMessage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElBoxComment_get_TaggedMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-786230306, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComment, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxComment_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment_Delete, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment_Reply, 0, 0, 1)
	ZEND_ARG_INFO(0, Message)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment_get_CreatedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment_get_CreatedBy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment_get_IsReply, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment_get_Message, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment_set_Message, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment_get_ModifiedAt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment_get_TaggedMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComment___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxComment_methods[] = {
	PHP_ME(TElBoxComment, Clone, arginfo_TElBoxComment_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComment, Delete, arginfo_TElBoxComment_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComment, Refresh, arginfo_TElBoxComment_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComment, Reply, arginfo_TElBoxComment_Reply, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComment, get_CreatedAt, arginfo_TElBoxComment_get_CreatedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComment, get_CreatedBy, arginfo_TElBoxComment_get_CreatedBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComment, get_ID, arginfo_TElBoxComment_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComment, get_IsReply, arginfo_TElBoxComment_get_IsReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComment, get_Message, arginfo_TElBoxComment_get_Message, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComment, set_Message, arginfo_TElBoxComment_set_Message, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComment, get_ModifiedAt, arginfo_TElBoxComment_get_ModifiedAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComment, get_TaggedMessage, arginfo_TElBoxComment_get_TaggedMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComment, __construct, arginfo_TElBoxComment___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxComment(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxComment_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxComment", TElBoxComment_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxComment_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElBoxComments_ce_ptr = NULL;

SB_PHP_METHOD(TElBoxComments, Add)
{
	char *sMessage;
	int sMessage_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMessage, &sMessage_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxComments_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sMessage, (int32_t)sMessage_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxComment_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComments, IndexOf)
{
	char *sID;
	int sID_len;
	zval *oComment;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sID, &sID_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxComments_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), sID, (int32_t)sID_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oComment, TElBoxComment_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxComments_IndexOf_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oComment TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TElBoxComment)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComments, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElBoxComments_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComments, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElBoxComments_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComments, get_Item)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxComments_get_Item(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElBoxComment_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElBoxComments, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TElBoxFile_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElBoxComments_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElBoxFile)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComments_Add, 0, 0, 1)
	ZEND_ARG_INFO(0, Message)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComments_IndexOf, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ID_or_Comment, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComments_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComments_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComments_get_Item, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElBoxComments___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TElBoxFile, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElBoxComments_methods[] = {
	PHP_ME(TElBoxComments, Add, arginfo_TElBoxComments_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComments, IndexOf, arginfo_TElBoxComments_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComments, Refresh, arginfo_TElBoxComments_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComments, get_Count, arginfo_TElBoxComments_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComments, get_Item, arginfo_TElBoxComments_get_Item, ZEND_ACC_PUBLIC)
	PHP_ME(TElBoxComments, __construct, arginfo_TElBoxComments___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElBoxComments(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElBoxComments_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElBoxComments", TElBoxComments_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElBoxComments_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBBoxDataStorage_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBBoxGroupRole", NULL);
	TSBBoxGroupRole_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBBoxGroupRole_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxGroupRole_ce_ptr, "bgrUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxGroupRole_ce_ptr, "bgrMember", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxGroupRole_ce_ptr, "bgrAdmin", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBBoxUserRole", NULL);
	TSBBoxUserRole_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBBoxUserRole_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxUserRole_ce_ptr, "burUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxUserRole_ce_ptr, "burAdmin", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxUserRole_ce_ptr, "burCoadmin", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxUserRole_ce_ptr, "burUser", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBBoxUserStatus", NULL);
	TSBBoxUserStatus_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBBoxUserStatus_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxUserStatus_ce_ptr, "busUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxUserStatus_ce_ptr, "busActive", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxUserStatus_ce_ptr, "busInactive", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBBoxSyncState", NULL);
	TSBBoxSyncState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBBoxSyncState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxSyncState_ce_ptr, "bssUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxSyncState_ce_ptr, "bssNotSynced", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxSyncState_ce_ptr, "bssPartiallySynced", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxSyncState_ce_ptr, "bssSynced", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBBoxSharedLinkAccess", NULL);
	TSBBoxSharedLinkAccess_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBBoxSharedLinkAccess_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxSharedLinkAccess_ce_ptr, "bslUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxSharedLinkAccess_ce_ptr, "bslOpen", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxSharedLinkAccess_ce_ptr, "bslCollaborators", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxSharedLinkAccess_ce_ptr, "bslCompany", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBBoxObjectStatus", NULL);
	TSBBoxObjectStatus_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBBoxObjectStatus_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxObjectStatus_ce_ptr, "bosUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxObjectStatus_ce_ptr, "bosActive", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxObjectStatus_ce_ptr, "bosTrashed", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBBoxCollaborationStatus", NULL);
	TSBBoxCollaborationStatus_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBBoxCollaborationStatus_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxCollaborationStatus_ce_ptr, "bcsUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxCollaborationStatus_ce_ptr, "bcsPending", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxCollaborationStatus_ce_ptr, "bcsRejected", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxCollaborationStatus_ce_ptr, "bcsAccepted", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBBoxCollaborationRole", NULL);
	TSBBoxCollaborationRole_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBBoxCollaborationRole_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxCollaborationRole_ce_ptr, "bcrUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxCollaborationRole_ce_ptr, "bcrEditor", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxCollaborationRole_ce_ptr, "bcrViewer", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxCollaborationRole_ce_ptr, "bcrPreviewer", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxCollaborationRole_ce_ptr, "bcrUploader", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxCollaborationRole_ce_ptr, "bcrPreviewerUploader", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxCollaborationRole_ce_ptr, "bcrViewerUploader", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBBoxCollaborationRole_ce_ptr, "bcrCoOwner", 7)
}

