#include "sbgoogledatastorage.h"

zend_class_entry *TSBGDataVersion_ce_ptr = NULL;

zend_class_entry *TSBGoogleAuthType_ce_ptr = NULL;

zend_class_entry *TSBGoogleEntryOrder_ce_ptr = NULL;

zend_class_entry *TSBGoogleDocType_ce_ptr = NULL;

zend_class_entry *TSBGoogleDataStorageEncoding_ce_ptr = NULL;

void SB_CALLBACK TSBGoogleAuthAttemptEventRaw(void * _ObjectData, TObjectHandle Sender)
{
	zval *retval_ptr;
	zval **params[1];
	zval * zSender;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);

	params[0] = &zSender;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 1, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBGoogleAuthCaptchaRequestEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcCaptchaUrl, int32_t szCaptchaUrl, const char * pcPageUrl, int32_t szPageUrl, char * pcCaptcha, int32_t * szCaptcha)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zCaptchaUrl;
	zval * zPageUrl;
	zval * zCaptcha;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCaptchaUrl);
	ZVAL_STRINGL(zCaptchaUrl, pcCaptchaUrl, szCaptchaUrl, 1);
	MAKE_STD_ZVAL(zPageUrl);
	ZVAL_STRINGL(zPageUrl, pcPageUrl, szPageUrl, 1);
	MAKE_STD_ZVAL(zCaptcha);
	ZVAL_STRINGL(zCaptcha, pcCaptcha, *szCaptcha, 1);

	params[0] = &zSender;
	params[1] = &zCaptchaUrl;
	params[2] = &zPageUrl;
	params[3] = &zCaptcha;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCaptchaUrl);
	zval_ptr_dtor(&zPageUrl);
	SBCheckError(SBSetEventReturnStringA(4, Z_STRVAL_P(zCaptcha), (int32_t)Z_STRLEN_P(zCaptcha)) TSRMLS_CC);
	zval_ptr_dtor(&zCaptcha);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBGoogleAuthAttemptFailedEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcErrorMsg, int32_t szErrorMsg, const char * pcPageUrl, int32_t szPageUrl, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zErrorMsg;
	zval * zPageUrl;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorMsg);
	ZVAL_STRINGL(zErrorMsg, pcErrorMsg, szErrorMsg, 1);
	MAKE_STD_ZVAL(zPageUrl);
	ZVAL_STRINGL(zPageUrl, pcPageUrl, szPageUrl, 1);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zErrorMsg;
	params[2] = &zPageUrl;
	params[3] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zErrorMsg);
	zval_ptr_dtor(&zPageUrl);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBGooglePrefixedMetadataProcessingStreamMetadataFuncRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pMetadata[], int32_t szMetadata)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zMetadata;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zMetadata);
	ZVAL_STRINGL(zMetadata, pMetadata, szMetadata, 1);

	params[0] = &zSender;
	params[1] = &zMetadata;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zMetadata);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElGoogleDataStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDataStorage, Authorize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_Authorize(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, SecondaryAuthorize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_SecondaryAuthorize(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, AcquireObject)
{
	char *sDocID;
	char *sTitle;
	int sDocID_len;
	int sTitle_len;
	long fDocType;
	zval *oFolder;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sTitle, &sTitle_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_AcquireObject(SBGetObjectHandle(getThis() TSRMLS_CC), sTitle, (int32_t)sTitle_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oFolder, TElGoogleDataStorageObject_ce_ptr, &sTitle, &sTitle_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_AcquireObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFolder TSRMLS_CC), sTitle, (int32_t)sTitle_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fDocType, &sDocID, &sDocID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_AcquireObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGoogleDocTypeRaw)fDocType, sDocID, (int32_t)sDocID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_AcquireObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TElGoogleDataStorageObject, string) or (integer, string) or ()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, List)
{
	char *sAlt;
	char *sAuthor;
	char *sCategory;
	char *sOwner;
	char *sQuery;
	char *sReader;
	char *sTitle;
	char *sWriter;
	int sAlt_len;
	int sAuthor_len;
	int sCategory_len;
	int sOwner_len;
	int sQuery_len;
	int sReader_len;
	int sTitle_len;
	int sWriter_len;
	long fOrderBy;
	long l8MaxResults;
	long l8StartIndex;
	zend_bool bExactTitle;
	zend_bool bShowDeleted;
	zend_bool bShowFolders;
	zval *dtOpenedMax;
	zval *dtOpenedMin;
	zval *dtUpdatedMax;
	zval *dtUpdatedMin;
	zval *oFolder;
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_List(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbblO!", &sQuery, &sQuery_len, &bShowFolders, &bShowDeleted, &fOrderBy, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_List_1(SBGetObjectHandle(getThis() TSRMLS_CC), sQuery, (int32_t)sQuery_len, (int8_t)bShowFolders, (int8_t)bShowDeleted, (TSBGoogleEntryOrderRaw)fOrderBy, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oFolder, TElGoogleDataStorageObject_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_List_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFolder TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sbblO!", &oFolder, TElGoogleDataStorageObject_ce_ptr, &sQuery, &sQuery_len, &bShowFolders, &bShowDeleted, &fOrderBy, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_List_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFolder TSRMLS_CC), sQuery, (int32_t)sQuery_len, (int8_t)bShowFolders, (int8_t)bShowDeleted, (TSBGoogleEntryOrderRaw)fOrderBy, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssllOOssbOOsssbblO!", &sQuery, &sQuery_len, &sAlt, &sAlt_len, &sAuthor, &sAuthor_len, &l8StartIndex, &l8MaxResults, &dtUpdatedMin, php_date_get_date_ce(), &dtUpdatedMax, php_date_get_date_ce(), &sCategory, &sCategory_len, &sTitle, &sTitle_len, &bExactTitle, &dtOpenedMin, php_date_get_date_ce(), &dtOpenedMax, php_date_get_date_ce(), &sOwner, &sOwner_len, &sWriter, &sWriter_len, &sReader, &sReader_len, &bShowFolders, &bShowDeleted, &fOrderBy, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_List_4(SBGetObjectHandle(getThis() TSRMLS_CC), sQuery, (int32_t)sQuery_len, sAlt, (int32_t)sAlt_len, sAuthor, (int32_t)sAuthor_len, (int64_t)l8StartIndex, (int64_t)l8MaxResults, SBGetDateTime(dtUpdatedMin TSRMLS_CC), SBGetDateTime(dtUpdatedMax TSRMLS_CC), sCategory, (int32_t)sCategory_len, sTitle, (int32_t)sTitle_len, (int8_t)bExactTitle, SBGetDateTime(dtOpenedMin TSRMLS_CC), SBGetDateTime(dtOpenedMax TSRMLS_CC), sOwner, (int32_t)sOwner_len, sWriter, (int32_t)sWriter_len, sReader, (int32_t)sReader_len, (int8_t)bShowFolders, (int8_t)bShowDeleted, (TSBGoogleEntryOrderRaw)fOrderBy, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sssllOOssbOOsssbblO!", &oFolder, TElGoogleDataStorageObject_ce_ptr, &sQuery, &sQuery_len, &sAlt, &sAlt_len, &sAuthor, &sAuthor_len, &l8StartIndex, &l8MaxResults, &dtUpdatedMin, php_date_get_date_ce(), &dtUpdatedMax, php_date_get_date_ce(), &sCategory, &sCategory_len, &sTitle, &sTitle_len, &bExactTitle, &dtOpenedMin, php_date_get_date_ce(), &dtOpenedMax, php_date_get_date_ce(), &sOwner, &sOwner_len, &sWriter, &sWriter_len, &sReader, &sReader_len, &bShowFolders, &bShowDeleted, &fOrderBy, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_List_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFolder TSRMLS_CC), sQuery, (int32_t)sQuery_len, sAlt, (int32_t)sAlt_len, sAuthor, (int32_t)sAuthor_len, (int64_t)l8StartIndex, (int64_t)l8MaxResults, SBGetDateTime(dtUpdatedMin TSRMLS_CC), SBGetDateTime(dtUpdatedMax TSRMLS_CC), sCategory, (int32_t)sCategory_len, sTitle, (int32_t)sTitle_len, (int8_t)bExactTitle, SBGetDateTime(dtOpenedMin TSRMLS_CC), SBGetDateTime(dtOpenedMax TSRMLS_CC), sOwner, (int32_t)sOwner_len, sWriter, (int32_t)sWriter_len, sReader, (int32_t)sReader_len, (int8_t)bShowFolders, (int8_t)bShowDeleted, (TSBGoogleEntryOrderRaw)fOrderBy, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDataStorageObjectList) or (string, bool, bool, integer, TElDataStorageObjectList) or (TElGoogleDataStorageObject, TElDataStorageObjectList) or (TElGoogleDataStorageObject, string, bool, bool, integer, TElDataStorageObjectList) or (string, string, string, integer, integer, DateTime, DateTime, string, string, bool, DateTime, DateTime, string, string, string, bool, bool, integer, TElDataStorageObjectList) or (TElGoogleDataStorageObject, string, string, string, integer, integer, DateTime, DateTime, string, string, bool, DateTime, DateTime, string, string, string, bool, bool, integer, TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, CreateObject)
{
	char *sContentType;
	char *sTitle;
	int sContentType_len;
	int sTitle_len;
	long fDocType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sls", &sTitle, &sTitle_len, &fDocType, &sContentType, &sContentType_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_CreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), sTitle, (int32_t)sTitle_len, (TSBGoogleDocTypeRaw)fDocType, sContentType, (int32_t)sContentType_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, CreateFolder)
{
	char *sTitle;
	int sTitle_len;
	zval *oParentFolder;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sTitle, &sTitle_len, &oParentFolder, TElGoogleDataStorageObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_CreateFolder(SBGetObjectHandle(getThis() TSRMLS_CC), sTitle, (int32_t)sTitle_len, SBGetObjectHandle(oParentFolder TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElGoogleDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, DeleteObject)
{
	char *sTitle;
	int sTitle_len;
	TElClassHandle hoObj;
	zend_bool bDeletePermanently;
	zval *oFolder;
	zval *oObj;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oObj, TElGoogleDataStorageObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oObj) && (IS_OBJECT == Z_TYPE_P(oObj)))
	{
		hoObj = SBGetObjectHandle(oObj TSRMLS_CC);
		SBCheckError(TElGoogleDataStorage_DeleteObject(SBGetObjectHandle(getThis() TSRMLS_CC), &hoObj) TSRMLS_CC);
		SBUpdateObjectHandle(oObj, hoObj TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &oObj, TElGoogleDataStorageObject_ce_ptr, &bDeletePermanently) == SUCCESS) && PZVAL_IS_REF(oObj) && (IS_OBJECT == Z_TYPE_P(oObj)))
	{
		hoObj = SBGetObjectHandle(oObj TSRMLS_CC);
		SBCheckError(TElGoogleDataStorage_DeleteObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoObj, (int8_t)bDeletePermanently) TSRMLS_CC);
		SBUpdateObjectHandle(oObj, hoObj TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oFolder, TElGoogleDataStorageObject_ce_ptr, &sTitle, &sTitle_len, &bDeletePermanently) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_DeleteObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFolder TSRMLS_CC), sTitle, (int32_t)sTitle_len, (int8_t)bDeletePermanently) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oObj, TElCustomDataStorageObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oObj) && (IS_OBJECT == Z_TYPE_P(oObj)))
	{
		hoObj = SBGetObjectHandle(oObj TSRMLS_CC);
		SBCheckError(TElGoogleDataStorage_DeleteObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), &hoObj) TSRMLS_CC);
		SBUpdateObjectHandle(oObj, hoObj TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElGoogleDataStorageObject) or (&TElGoogleDataStorageObject, bool) or (TElGoogleDataStorageObject, string, bool) or (&TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, ObjectExists)
{
	char *sDocID;
	char *sTitle;
	int sDocID_len;
	int sTitle_len;
	long fDocType;
	zval *oFolder;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElGoogleDataStorageObject_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorage_ObjectExists(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fDocType, &sDocID, &sDocID_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorage_ObjectExists_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGoogleDocTypeRaw)fDocType, sDocID, (int32_t)sDocID_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oFolder, TElGoogleDataStorageObject_ce_ptr, &sTitle, &sTitle_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorage_ObjectExists_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFolder TSRMLS_CC), sTitle, (int32_t)sTitle_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDataStorageObject) or (integer, string) or (TElGoogleDataStorageObject, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, RefreshObject)
{
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElGoogleDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_RefreshObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, WriteObject)
{
	char *sContentType;
	char *sTitle;
	int sContentType_len;
	int sTitle_len;
	long fDocType;
	long fEncoding;
	zend_bool bAppend;
	zend_bool bConvert;
	zend_bool bOverwriteChanges;
	zval *oData;
	zval *oHandler;
	zval *oObj;
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lsblO!", &sTitle, &sTitle_len, &oData, TStream_ce_ptr, &fDocType, &sContentType, &sContentType_len, &bConvert, &fEncoding, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_WriteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sTitle, (int32_t)sTitle_len, SBGetObjectHandle(oData TSRMLS_CC), (TSBGoogleDocTypeRaw)fDocType, sContentType, (int32_t)sContentType_len, (int8_t)bConvert, (TSBGoogleDataStorageEncodingRaw)fEncoding, SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lsO!", &sTitle, &sTitle_len, &oData, TStream_ce_ptr, &fDocType, &sContentType, &sContentType_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_WriteObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sTitle, (int32_t)sTitle_len, SBGetObjectHandle(oData TSRMLS_CC), (TSBGoogleDocTypeRaw)fDocType, sContentType, (int32_t)sContentType_len, SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!bbslO!", &oObj, TElGoogleDataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &bOverwriteChanges, &bAppend, &sContentType, &sContentType_len, &fEncoding, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_WriteObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), (int8_t)bOverwriteChanges, (int8_t)bAppend, sContentType, (int32_t)sContentType_len, (TSBGoogleDataStorageEncodingRaw)fEncoding, SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_WriteObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TStream, integer, string, bool, integer, TElCustomDataStorageSecurityHandler) or (string, TStream, integer, string, TElCustomDataStorageSecurityHandler) or (TElGoogleDataStorageObject, TStream, bool, bool, string, integer, TElCustomDataStorageSecurityHandler) or (TElCustomDataStorageObject, TStream, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, ReadObject)
{
	char *sFormat;
	char *sTitle;
	int sFormat_len;
	int sTitle_len;
	long fEncoding;
	zval *oFolder;
	zval *oObj;
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElGoogleDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_ReadObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oObj, TElGoogleDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &fEncoding) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_ReadObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBGoogleDataStorageEncodingRaw)fEncoding) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!sl", &oObj, TElGoogleDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &sFormat, &sFormat_len, &fEncoding) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_ReadObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), sFormat, (int32_t)sFormat_len, (TSBGoogleDataStorageEncodingRaw)fEncoding) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!sl", &oFolder, TElGoogleDataStorageObject_ce_ptr, &sTitle, &sTitle_len, &oStrm, TStream_ce_ptr, &sFormat, &sFormat_len, &fEncoding) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_ReadObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFolder TSRMLS_CC), sTitle, (int32_t)sTitle_len, SBGetObjectHandle(oStrm TSRMLS_CC), sFormat, (int32_t)sFormat_len, (TSBGoogleDataStorageEncodingRaw)fEncoding) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_ReadObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDataStorageObject, TStream) or (TElGoogleDataStorageObject, TStream, integer) or (TElGoogleDataStorageObject, TStream, string, integer) or (TElGoogleDataStorageObject, string, TStream, string, integer) or (TElCustomDataStorageObject, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, CopyObject)
{
	char *sDestTitle;
	char *sSrcTitle;
	int sDestTitle_len;
	int sSrcTitle_len;
	zval *oFolder;
	zval *oNewHandler;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oObj, TElGoogleDataStorageObject_ce_ptr, &sDestTitle, &sDestTitle_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sDestTitle, (int32_t)sDestTitle_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oFolder, TElGoogleDataStorageObject_ce_ptr, &sSrcTitle, &sSrcTitle_len, &sDestTitle, &sDestTitle_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_CopyObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFolder TSRMLS_CC), sSrcTitle, (int32_t)sSrcTitle_len, sDestTitle, (int32_t)sDestTitle_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_CopyObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDataStorageObject, string) or (TElGoogleDataStorageObject, string, string) or (TElCustomDataStorageObject, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, MoveObject)
{
	char *sTitle;
	int sTitle_len;
	zval *oDestFolder;
	zval *oFolder;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElGoogleDataStorageObject_ce_ptr, &oDestFolder, TElGoogleDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_MoveObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oDestFolder TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!", &oFolder, TElGoogleDataStorageObject_ce_ptr, &sTitle, &sTitle_len, &oDestFolder, TElGoogleDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_MoveObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFolder TSRMLS_CC), sTitle, (int32_t)sTitle_len, SBGetObjectHandle(oDestFolder TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDataStorageObject, TElGoogleDataStorageObject) or (TElGoogleDataStorageObject, string, TElGoogleDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, GetObjectFolder)
{
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElGoogleDataStorageObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_GetObjectFolder(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_AuthType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGoogleAuthTypeRaw fOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorage_get_AuthType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_AuthType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_AuthType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGoogleAuthTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_DefObjectEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGoogleDataStorageEncodingRaw fOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorage_get_DefObjectEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_DefObjectEncoding)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_DefObjectEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGoogleDataStorageEncodingRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGDataVersionRaw fOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorage_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_Version)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBGDataVersionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_UseSSL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorage_get_UseSSL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_UseSSL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_UseSSL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_HTTPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_get_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_HTTPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHTTPSClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_Username)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorage_get_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(414246903, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_Username)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_Password)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorage_get_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-718493867, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_Password)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_ServiceName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorage_get_ServiceName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1886817259, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_ServiceName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_ServiceName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_SecondaryServiceName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorage_get_SecondaryServiceName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1290846202, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_SecondaryServiceName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_SecondaryServiceName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_ServerAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorage_get_ServerAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1497765940, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_ServerAddress)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_ServerAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_AuthServerAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorage_get_AuthServerAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-545497130, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_AuthServerAddress)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_AuthServerAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_AuthSource)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorage_get_AuthSource(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1284800744, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_AuthSource)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_AuthSource(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_AuthToken)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorage_get_AuthToken(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-760242980, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_AuthToken)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_AuthToken(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_SecondaryAuthToken)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorage_get_SecondaryAuthToken(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1734172814, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_SecondaryAuthToken)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_SecondaryAuthToken(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_MaxAuthAttempts)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDataStorage_get_MaxAuthAttempts(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_MaxAuthAttempts)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_MaxAuthAttempts(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_SecMetadataID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorage_get_SecMetadataID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(664188437, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_SecMetadataID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_SecMetadataID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_UseURLEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorage_get_UseURLEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_UseURLEncoding)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_UseURLEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_IgnoreContentSrc)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorage_get_IgnoreContentSrc(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_IgnoreContentSrc)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorage_set_IgnoreContentSrc(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_OnAuthAttempt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGoogleAuthAttemptEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_get_OnAuthAttempt(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_OnAuthAttempt)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElGoogleDataStorage_set_OnAuthAttempt(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBGoogleAuthAttemptEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBGoogleAuthAttemptEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_OnAuthCaptchaRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGoogleAuthCaptchaRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_get_OnAuthCaptchaRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_OnAuthCaptchaRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElGoogleDataStorage_set_OnAuthCaptchaRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBGoogleAuthCaptchaRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBGoogleAuthCaptchaRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, get_OnAuthAttemptFailed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGoogleAuthAttemptFailedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_get_OnAuthAttemptFailed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, set_OnAuthAttemptFailed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElGoogleDataStorage_set_OnAuthAttemptFailed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBGoogleAuthAttemptFailedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBGoogleAuthAttemptFailedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_Authorize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_SecondaryAuthorize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_AcquireObject, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Title_or_Folder_or_DocType, 0, 1)
	ZEND_ARG_INFO(0, Title_or_DocID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_List, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Objects_or_Query_or_Folder, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ShowFolders_or_Objects_or_Query_or_Alt, 0, 1)
	ZEND_ARG_INFO(0, ShowDeleted_or_ShowFolders_or_Author_or_Alt)
	ZEND_ARG_INFO(0, OrderBy_or_ShowDeleted_or_StartIndex_or_Author)
	ZEND_ARG_TYPE_INFO(0, Objects_or_OrderBy_or_MaxResults_or_StartIndex, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Objects_or_UpdatedMin_or_MaxResults, 0, 1)
	ZEND_ARG_OBJ_INFO(0, UpdatedMax_or_UpdatedMin, DateTime, 0)
	ZEND_ARG_INFO(0, Category_or_UpdatedMax)
	ZEND_ARG_INFO(0, Title_or_Category)
	ZEND_ARG_INFO(0, ExactTitle_or_Title)
	ZEND_ARG_INFO(0, OpenedMin_or_ExactTitle)
	ZEND_ARG_OBJ_INFO(0, OpenedMax_or_OpenedMin, DateTime, 0)
	ZEND_ARG_INFO(0, Owner_or_OpenedMax)
	ZEND_ARG_INFO(0, Writer_or_Owner)
	ZEND_ARG_INFO(0, Reader_or_Writer)
	ZEND_ARG_INFO(0, ShowFolders_or_Reader)
	ZEND_ARG_INFO(0, ShowDeleted_or_ShowFolders)
	ZEND_ARG_INFO(0, OrderBy_or_ShowDeleted)
	ZEND_ARG_TYPE_INFO(0, Objects_or_OrderBy, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_CreateObject, 0, 0, 3)
	ZEND_ARG_INFO(0, Title)
	ZEND_ARG_INFO(0, DocType)
	ZEND_ARG_INFO(0, ContentType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_CreateFolder, 0, 0, 2)
	ZEND_ARG_INFO(0, Title)
	ZEND_ARG_OBJ_INFO(0, ParentFolder, TElGoogleDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_DeleteObject, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Obj_or_Folder, 0, 1)
	ZEND_ARG_INFO(0, DeletePermanently_or_Title)
	ZEND_ARG_INFO(0, DeletePermanently)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_ObjectExists, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Obj_or_DocType_or_Folder, 0, 1)
	ZEND_ARG_INFO(0, DocID_or_Title)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_RefreshObject, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Obj, TElGoogleDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_WriteObject, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Title_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Data_or_Strm, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DocType_or_OverwriteChanges_or_Handler, 0, 1)
	ZEND_ARG_INFO(0, ContentType_or_Append)
	ZEND_ARG_TYPE_INFO(0, Convert_or_Handler_or_ContentType, 0, 1)
	ZEND_ARG_INFO(0, Encoding)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_ReadObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Obj_or_Folder, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Strm_or_Title, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Encoding_or_Format_or_Strm, 0, 1)
	ZEND_ARG_INFO(0, Encoding_or_Format)
	ZEND_ARG_INFO(0, Encoding)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_CopyObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Obj_or_Folder, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DestTitle_or_SrcTitle_or_NewHandler, 0, 1)
	ZEND_ARG_INFO(0, DestTitle)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_MoveObject, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Obj_or_Folder, TElGoogleDataStorageObject, 1)
	ZEND_ARG_TYPE_INFO(0, DestFolder_or_Title, 0, 1)
	ZEND_ARG_OBJ_INFO(0, DestFolder, TElGoogleDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_GetObjectFolder, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Obj, TElGoogleDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_AuthType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_AuthType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_DefObjectEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_DefObjectEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_UseSSL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_UseSSL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_HTTPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_HTTPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHTTPSClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_Username, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_Username, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_Password, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_Password, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_ServiceName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_ServiceName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_SecondaryServiceName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_SecondaryServiceName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_ServerAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_ServerAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_AuthServerAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_AuthServerAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_AuthSource, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_AuthSource, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_AuthToken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_AuthToken, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_SecondaryAuthToken, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_SecondaryAuthToken, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_MaxAuthAttempts, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_MaxAuthAttempts, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_SecMetadataID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_SecMetadataID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_UseURLEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_UseURLEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_IgnoreContentSrc, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_IgnoreContentSrc, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_OnAuthAttempt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_OnAuthAttempt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_OnAuthCaptchaRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_OnAuthCaptchaRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_get_OnAuthAttemptFailed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage_set_OnAuthAttemptFailed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDataStorage_methods[] = {
	PHP_ME(TElGoogleDataStorage, Authorize, arginfo_TElGoogleDataStorage_Authorize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, SecondaryAuthorize, arginfo_TElGoogleDataStorage_SecondaryAuthorize, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, AcquireObject, arginfo_TElGoogleDataStorage_AcquireObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, List, arginfo_TElGoogleDataStorage_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, CreateObject, arginfo_TElGoogleDataStorage_CreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, CreateFolder, arginfo_TElGoogleDataStorage_CreateFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, DeleteObject, arginfo_TElGoogleDataStorage_DeleteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, ObjectExists, arginfo_TElGoogleDataStorage_ObjectExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, RefreshObject, arginfo_TElGoogleDataStorage_RefreshObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, WriteObject, arginfo_TElGoogleDataStorage_WriteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, ReadObject, arginfo_TElGoogleDataStorage_ReadObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, CopyObject, arginfo_TElGoogleDataStorage_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, MoveObject, arginfo_TElGoogleDataStorage_MoveObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, GetObjectFolder, arginfo_TElGoogleDataStorage_GetObjectFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_AuthType, arginfo_TElGoogleDataStorage_get_AuthType, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_AuthType, arginfo_TElGoogleDataStorage_set_AuthType, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_DefObjectEncoding, arginfo_TElGoogleDataStorage_get_DefObjectEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_DefObjectEncoding, arginfo_TElGoogleDataStorage_set_DefObjectEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_Version, arginfo_TElGoogleDataStorage_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_Version, arginfo_TElGoogleDataStorage_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_UseSSL, arginfo_TElGoogleDataStorage_get_UseSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_UseSSL, arginfo_TElGoogleDataStorage_set_UseSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_HTTPClient, arginfo_TElGoogleDataStorage_get_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_HTTPClient, arginfo_TElGoogleDataStorage_set_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_Username, arginfo_TElGoogleDataStorage_get_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_Username, arginfo_TElGoogleDataStorage_set_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_Password, arginfo_TElGoogleDataStorage_get_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_Password, arginfo_TElGoogleDataStorage_set_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_ServiceName, arginfo_TElGoogleDataStorage_get_ServiceName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_ServiceName, arginfo_TElGoogleDataStorage_set_ServiceName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_SecondaryServiceName, arginfo_TElGoogleDataStorage_get_SecondaryServiceName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_SecondaryServiceName, arginfo_TElGoogleDataStorage_set_SecondaryServiceName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_ServerAddress, arginfo_TElGoogleDataStorage_get_ServerAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_ServerAddress, arginfo_TElGoogleDataStorage_set_ServerAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_AuthServerAddress, arginfo_TElGoogleDataStorage_get_AuthServerAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_AuthServerAddress, arginfo_TElGoogleDataStorage_set_AuthServerAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_AuthSource, arginfo_TElGoogleDataStorage_get_AuthSource, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_AuthSource, arginfo_TElGoogleDataStorage_set_AuthSource, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_AuthToken, arginfo_TElGoogleDataStorage_get_AuthToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_AuthToken, arginfo_TElGoogleDataStorage_set_AuthToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_SecondaryAuthToken, arginfo_TElGoogleDataStorage_get_SecondaryAuthToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_SecondaryAuthToken, arginfo_TElGoogleDataStorage_set_SecondaryAuthToken, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_MaxAuthAttempts, arginfo_TElGoogleDataStorage_get_MaxAuthAttempts, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_MaxAuthAttempts, arginfo_TElGoogleDataStorage_set_MaxAuthAttempts, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_SecMetadataID, arginfo_TElGoogleDataStorage_get_SecMetadataID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_SecMetadataID, arginfo_TElGoogleDataStorage_set_SecMetadataID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_UseURLEncoding, arginfo_TElGoogleDataStorage_get_UseURLEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_UseURLEncoding, arginfo_TElGoogleDataStorage_set_UseURLEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_IgnoreContentSrc, arginfo_TElGoogleDataStorage_get_IgnoreContentSrc, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_IgnoreContentSrc, arginfo_TElGoogleDataStorage_set_IgnoreContentSrc, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_OnAuthAttempt, arginfo_TElGoogleDataStorage_get_OnAuthAttempt, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_OnAuthAttempt, arginfo_TElGoogleDataStorage_set_OnAuthAttempt, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_OnAuthCaptchaRequest, arginfo_TElGoogleDataStorage_get_OnAuthCaptchaRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_OnAuthCaptchaRequest, arginfo_TElGoogleDataStorage_set_OnAuthCaptchaRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, get_OnAuthAttemptFailed, arginfo_TElGoogleDataStorage_get_OnAuthAttemptFailed, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, set_OnAuthAttemptFailed, arginfo_TElGoogleDataStorage_set_OnAuthAttemptFailed, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorage, __construct, arginfo_TElGoogleDataStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDataStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDataStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDataStorage", TElGoogleDataStorage_methods);
	if (NULL == TElCustomDataStorage_ce_ptr)
		Register_TElCustomDataStorage(TSRMLS_C);
	TElGoogleDataStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDataStorageObjectCategories_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDataStorageObjectCategories, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElGoogleDataStorageObjectCategories_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObjectCategories_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDataStorageObjectCategories)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectCategories, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObjectCategories_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectCategories, get_Schemes)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObjectCategories_get_Schemes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1556140365, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectCategories, get_Terms)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObjectCategories_get_Terms(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1993641199, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectCategories, get_Labels)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObjectCategories_get_Labels(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-336505794, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectCategories, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObjectCategories_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectCategories, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorageObjectCategories_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectCategories_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElGoogleDataStorageObjectCategories, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectCategories_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectCategories_get_Schemes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectCategories_get_Terms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectCategories_get_Labels, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectCategories_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectCategories___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDataStorageObjectCategories_methods[] = {
	PHP_ME(TElGoogleDataStorageObjectCategories, Assign, arginfo_TElGoogleDataStorageObjectCategories_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectCategories, Clear, arginfo_TElGoogleDataStorageObjectCategories_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectCategories, get_Schemes, arginfo_TElGoogleDataStorageObjectCategories_get_Schemes, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectCategories, get_Terms, arginfo_TElGoogleDataStorageObjectCategories_get_Terms, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectCategories, get_Labels, arginfo_TElGoogleDataStorageObjectCategories_get_Labels, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectCategories, get_Count, arginfo_TElGoogleDataStorageObjectCategories_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectCategories, __construct, arginfo_TElGoogleDataStorageObjectCategories___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDataStorageObjectCategories(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDataStorageObjectCategories_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDataStorageObjectCategories", TElGoogleDataStorageObjectCategories_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGoogleDataStorageObjectCategories_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDataStorageObjectLinks_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDataStorageObjectLinks, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElGoogleDataStorageObjectLinks_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObjectLinks_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDataStorageObjectLinks)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectLinks, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObjectLinks_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectLinks, get_Rels)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObjectLinks_get_Rels(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1080938102, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectLinks, get_Types)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObjectLinks_get_Types(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-733272488, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectLinks, get_Hrefs)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObjectLinks_get_Hrefs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2147468209, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectLinks, get_Titles)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObjectLinks_get_Titles(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-587567184, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectLinks, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObjectLinks_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObjectLinks, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorageObjectLinks_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectLinks_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElGoogleDataStorageObjectLinks, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectLinks_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectLinks_get_Rels, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectLinks_get_Types, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectLinks_get_Hrefs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectLinks_get_Titles, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectLinks_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObjectLinks___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDataStorageObjectLinks_methods[] = {
	PHP_ME(TElGoogleDataStorageObjectLinks, Assign, arginfo_TElGoogleDataStorageObjectLinks_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectLinks, Clear, arginfo_TElGoogleDataStorageObjectLinks_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectLinks, get_Rels, arginfo_TElGoogleDataStorageObjectLinks_get_Rels, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectLinks, get_Types, arginfo_TElGoogleDataStorageObjectLinks_get_Types, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectLinks, get_Hrefs, arginfo_TElGoogleDataStorageObjectLinks_get_Hrefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectLinks, get_Titles, arginfo_TElGoogleDataStorageObjectLinks_get_Titles, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectLinks, get_Count, arginfo_TElGoogleDataStorageObjectLinks_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObjectLinks, __construct, arginfo_TElGoogleDataStorageObjectLinks___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDataStorageObjectLinks(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDataStorageObjectLinks_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDataStorageObjectLinks", TElGoogleDataStorageObjectLinks_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElGoogleDataStorageObjectLinks_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleDataStorageObject_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleDataStorageObject, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorageObject_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, ParseEntry)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_ParseEntry(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, Delete)
{
	zend_bool bDeletePermanently;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bDeletePermanently) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_Delete_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bDeletePermanently) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, Exists)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_Exists(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, Refresh)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, Copy)
{
	char *sDestTitle;
	int sDestTitle_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDestTitle, &sDestTitle_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorageObject_Copy(SBGetObjectHandle(getThis() TSRMLS_CC), sDestTitle, (int32_t)sDestTitle_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, Move)
{
	zval *oDestFolder;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDestFolder, TElGoogleDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_Move(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDestFolder TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, Write)
{
	char *sContentType;
	int sContentType_len;
	long fEncoding;
	zend_bool bAppend;
	zend_bool bOverwriteChanges;
	zval *oData;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bbslO!", &oData, TStream_ce_ptr, &bOverwriteChanges, &bAppend, &sContentType, &sContentType_len, &fEncoding, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), (int8_t)bOverwriteChanges, (int8_t)bAppend, sContentType, (int32_t)sContentType_len, (TSBGoogleDataStorageEncodingRaw)fEncoding, SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool, bool, string, integer, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, Read)
{
	char *sFormat;
	int sFormat_len;
	long fEncoding;
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_Read(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oStrm, TStream_ce_ptr, &fEncoding) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_Read_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBGoogleDataStorageEncodingRaw)fEncoding) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oStrm, TStream_ce_ptr, &sFormat, &sFormat_len, &fEncoding) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_Read_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), sFormat, (int32_t)sFormat_len, (TSBGoogleDataStorageEncodingRaw)fEncoding) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (TStream, integer) or (TStream, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, AcquireObject)
{
	char *sTitle;
	int sTitle_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sTitle, &sTitle_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorageObject_AcquireObject(SBGetObjectHandle(getThis() TSRMLS_CC), sTitle, (int32_t)sTitle_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, ReadObject)
{
	char *sFormat;
	char *sTitle;
	int sFormat_len;
	int sTitle_len;
	long fEncoding;
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sl", &sTitle, &sTitle_len, &oStrm, TStream_ce_ptr, &sFormat, &sFormat_len, &fEncoding) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_ReadObject(SBGetObjectHandle(getThis() TSRMLS_CC), sTitle, (int32_t)sTitle_len, SBGetObjectHandle(oStrm TSRMLS_CC), sFormat, (int32_t)sFormat_len, (TSBGoogleDataStorageEncodingRaw)fEncoding) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TStream, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, List)
{
	char *sAlt;
	char *sAuthor;
	char *sCategory;
	char *sOwner;
	char *sQuery;
	char *sReader;
	char *sTitle;
	char *sWriter;
	int sAlt_len;
	int sAuthor_len;
	int sCategory_len;
	int sOwner_len;
	int sQuery_len;
	int sReader_len;
	int sTitle_len;
	int sWriter_len;
	long fOrderBy;
	long l8MaxResults;
	long l8StartIndex;
	zend_bool bExactTitle;
	zend_bool bShowDeleted;
	zend_bool bShowFolders;
	zval *dtOpenedMax;
	zval *dtOpenedMin;
	zval *dtUpdatedMax;
	zval *dtUpdatedMin;
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_List(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbblO!", &sQuery, &sQuery_len, &bShowFolders, &bShowDeleted, &fOrderBy, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_List_1(SBGetObjectHandle(getThis() TSRMLS_CC), sQuery, (int32_t)sQuery_len, (int8_t)bShowFolders, (int8_t)bShowDeleted, (TSBGoogleEntryOrderRaw)fOrderBy, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssllOOssbOOsssbblO!", &sQuery, &sQuery_len, &sAlt, &sAlt_len, &sAuthor, &sAuthor_len, &l8StartIndex, &l8MaxResults, &dtUpdatedMin, php_date_get_date_ce(), &dtUpdatedMax, php_date_get_date_ce(), &sCategory, &sCategory_len, &sTitle, &sTitle_len, &bExactTitle, &dtOpenedMin, php_date_get_date_ce(), &dtOpenedMax, php_date_get_date_ce(), &sOwner, &sOwner_len, &sWriter, &sWriter_len, &sReader, &sReader_len, &bShowFolders, &bShowDeleted, &fOrderBy, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_List_2(SBGetObjectHandle(getThis() TSRMLS_CC), sQuery, (int32_t)sQuery_len, sAlt, (int32_t)sAlt_len, sAuthor, (int32_t)sAuthor_len, (int64_t)l8StartIndex, (int64_t)l8MaxResults, SBGetDateTime(dtUpdatedMin TSRMLS_CC), SBGetDateTime(dtUpdatedMax TSRMLS_CC), sCategory, (int32_t)sCategory_len, sTitle, (int32_t)sTitle_len, (int8_t)bExactTitle, SBGetDateTime(dtOpenedMin TSRMLS_CC), SBGetDateTime(dtOpenedMax TSRMLS_CC), sOwner, (int32_t)sOwner_len, sWriter, (int32_t)sWriter_len, sReader, (int32_t)sReader_len, (int8_t)bShowFolders, (int8_t)bShowDeleted, (TSBGoogleEntryOrderRaw)fOrderBy, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDataStorageObjectList) or (string, bool, bool, integer, TElDataStorageObjectList) or (string, string, string, integer, integer, DateTime, DateTime, string, string, bool, DateTime, DateTime, string, string, string, bool, bool, integer, TElDataStorageObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, DeleteObject)
{
	char *sTitle;
	int sTitle_len;
	zend_bool bDeletePermanently;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sTitle, &sTitle_len, &bDeletePermanently) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_DeleteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sTitle, (int32_t)sTitle_len, (int8_t)bDeletePermanently) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, ObjectExists)
{
	char *sTitle;
	int sTitle_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sTitle, &sTitle_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_ObjectExists(SBGetObjectHandle(getThis() TSRMLS_CC), sTitle, (int32_t)sTitle_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, CopyObject)
{
	char *sDestTitle;
	char *sSrcTitle;
	int sDestTitle_len;
	int sSrcTitle_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sSrcTitle, &sSrcTitle_len, &sDestTitle, &sDestTitle_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorageObject_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), sSrcTitle, (int32_t)sSrcTitle_len, sDestTitle, (int32_t)sDestTitle_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, MoveObject)
{
	char *sTitle;
	int sTitle_len;
	zval *oDestFolder;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sTitle, &sTitle_len, &oDestFolder, TElGoogleDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElGoogleDataStorageObject_MoveObject(SBGetObjectHandle(getThis() TSRMLS_CC), sTitle, (int32_t)sTitle_len, SBGetObjectHandle(oDestFolder TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElGoogleDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, GetFolder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorageObject_GetFolder(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_Folder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_Folder(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_ObjectType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_ObjectType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-955134422, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2065616811, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_Title)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_Title(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(259808738, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_Summary)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_Summary(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(783591315, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_ContentSrc)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_ContentSrc(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-617244686, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1629641286, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_AuthorName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_AuthorName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(870354700, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_AuthorEmail)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_AuthorEmail(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-718751466, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_Categories)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorageObject_get_Categories(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDataStorageObjectCategories_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_PublicationDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_PublicationDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_UpdateDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_UpdateDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_Links)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorageObject_get_Links(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGoogleDataStorageObjectLinks_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_ResourceID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_ResourceID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-700002501, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_CompleteResourceID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_CompleteResourceID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1688646427, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_ResourceType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_ResourceType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1420889089, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_LastModifiedByName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_LastModifiedByName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1251104707, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_LastModifiedByEmail)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_LastModifiedByEmail(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2073021429, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_LastViewedDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_LastViewedDate(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_QuotaBytesUsed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_QuotaBytesUsed(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_WritersCanInvite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_WritersCanInvite(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_Starred)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_Starred(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_Trashed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_Trashed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_Hidden)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_Hidden(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_Viewed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_Viewed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_Mine)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_Mine(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_PrivateObj)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_PrivateObj(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_SharedWithDomain)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_SharedWithDomain(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_ContainingFolders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorageObject_get_ContainingFolders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElGoogleDataStorageObject_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(416657289, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, get_DocType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBGoogleDocTypeRaw fOutResultRaw = 0;
		SBCheckError(TElGoogleDataStorageObject_get_DocType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleDataStorageObject, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElGoogleDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleDataStorageObject_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGoogleDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_ParseEntry, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_Delete, 0, 0, 0)
	ZEND_ARG_INFO(0, DeletePermanently)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_Exists, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_Refresh, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_Copy, 0, 0, 1)
	ZEND_ARG_INFO(0, DestTitle)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_Move, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, DestFolder, TElGoogleDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_Write, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, Data, TStream, 1)
	ZEND_ARG_INFO(0, OverwriteChanges)
	ZEND_ARG_INFO(0, Append)
	ZEND_ARG_INFO(0, ContentType)
	ZEND_ARG_INFO(0, Encoding)
	ZEND_ARG_OBJ_INFO(0, Handler, TElCustomDataStorageSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_Read, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
	ZEND_ARG_INFO(0, Encoding_or_Format)
	ZEND_ARG_INFO(0, Encoding)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_AcquireObject, 0, 0, 1)
	ZEND_ARG_INFO(0, Title)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_ReadObject, 0, 0, 4)
	ZEND_ARG_INFO(0, Title)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
	ZEND_ARG_INFO(0, Format)
	ZEND_ARG_INFO(0, Encoding)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_List, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Objects_or_Query, 0, 1)
	ZEND_ARG_INFO(0, ShowFolders_or_Alt)
	ZEND_ARG_INFO(0, ShowDeleted_or_Author)
	ZEND_ARG_INFO(0, OrderBy_or_StartIndex)
	ZEND_ARG_TYPE_INFO(0, Objects_or_MaxResults, 0, 1)
	ZEND_ARG_OBJ_INFO(0, UpdatedMin, DateTime, 0)
	ZEND_ARG_OBJ_INFO(0, UpdatedMax, DateTime, 0)
	ZEND_ARG_INFO(0, Category)
	ZEND_ARG_INFO(0, Title)
	ZEND_ARG_INFO(0, ExactTitle)
	ZEND_ARG_OBJ_INFO(0, OpenedMin, DateTime, 0)
	ZEND_ARG_OBJ_INFO(0, OpenedMax, DateTime, 0)
	ZEND_ARG_INFO(0, Owner)
	ZEND_ARG_INFO(0, Writer)
	ZEND_ARG_INFO(0, Reader)
	ZEND_ARG_INFO(0, ShowFolders)
	ZEND_ARG_INFO(0, ShowDeleted)
	ZEND_ARG_INFO(0, OrderBy)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_DeleteObject, 0, 0, 2)
	ZEND_ARG_INFO(0, Title)
	ZEND_ARG_INFO(0, DeletePermanently)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_ObjectExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Title)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_CopyObject, 0, 0, 2)
	ZEND_ARG_INFO(0, SrcTitle)
	ZEND_ARG_INFO(0, DestTitle)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_MoveObject, 0, 0, 2)
	ZEND_ARG_INFO(0, Title)
	ZEND_ARG_OBJ_INFO(0, DestFolder, TElGoogleDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_GetFolder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_Folder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_ObjectType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_Title, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_Summary, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_ContentSrc, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_AuthorName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_AuthorEmail, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_Categories, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_PublicationDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_UpdateDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_Links, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_ResourceID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_CompleteResourceID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_ResourceType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_LastModifiedByName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_LastModifiedByEmail, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_LastViewedDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_QuotaBytesUsed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_WritersCanInvite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_Starred, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_Trashed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_Hidden, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_Viewed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_Mine, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_PrivateObj, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_SharedWithDomain, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_ContainingFolders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject_get_DocType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleDataStorageObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElGoogleDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleDataStorageObject_methods[] = {
	PHP_ME(TElGoogleDataStorageObject, Assign, arginfo_TElGoogleDataStorageObject_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, Clone, arginfo_TElGoogleDataStorageObject_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, ParseEntry, arginfo_TElGoogleDataStorageObject_ParseEntry, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, Clear, arginfo_TElGoogleDataStorageObject_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, Delete, arginfo_TElGoogleDataStorageObject_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, Exists, arginfo_TElGoogleDataStorageObject_Exists, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, Refresh, arginfo_TElGoogleDataStorageObject_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, Copy, arginfo_TElGoogleDataStorageObject_Copy, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, Move, arginfo_TElGoogleDataStorageObject_Move, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, Write, arginfo_TElGoogleDataStorageObject_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, Read, arginfo_TElGoogleDataStorageObject_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, AcquireObject, arginfo_TElGoogleDataStorageObject_AcquireObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, ReadObject, arginfo_TElGoogleDataStorageObject_ReadObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, List, arginfo_TElGoogleDataStorageObject_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, DeleteObject, arginfo_TElGoogleDataStorageObject_DeleteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, ObjectExists, arginfo_TElGoogleDataStorageObject_ObjectExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, CopyObject, arginfo_TElGoogleDataStorageObject_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, MoveObject, arginfo_TElGoogleDataStorageObject_MoveObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, GetFolder, arginfo_TElGoogleDataStorageObject_GetFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_Folder, arginfo_TElGoogleDataStorageObject_get_Folder, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_ObjectType, arginfo_TElGoogleDataStorageObject_get_ObjectType, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_ID, arginfo_TElGoogleDataStorageObject_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_Title, arginfo_TElGoogleDataStorageObject_get_Title, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_Summary, arginfo_TElGoogleDataStorageObject_get_Summary, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_ContentSrc, arginfo_TElGoogleDataStorageObject_get_ContentSrc, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_ContentType, arginfo_TElGoogleDataStorageObject_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_AuthorName, arginfo_TElGoogleDataStorageObject_get_AuthorName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_AuthorEmail, arginfo_TElGoogleDataStorageObject_get_AuthorEmail, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_Categories, arginfo_TElGoogleDataStorageObject_get_Categories, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_PublicationDate, arginfo_TElGoogleDataStorageObject_get_PublicationDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_UpdateDate, arginfo_TElGoogleDataStorageObject_get_UpdateDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_Links, arginfo_TElGoogleDataStorageObject_get_Links, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_ResourceID, arginfo_TElGoogleDataStorageObject_get_ResourceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_CompleteResourceID, arginfo_TElGoogleDataStorageObject_get_CompleteResourceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_ResourceType, arginfo_TElGoogleDataStorageObject_get_ResourceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_LastModifiedByName, arginfo_TElGoogleDataStorageObject_get_LastModifiedByName, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_LastModifiedByEmail, arginfo_TElGoogleDataStorageObject_get_LastModifiedByEmail, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_LastViewedDate, arginfo_TElGoogleDataStorageObject_get_LastViewedDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_QuotaBytesUsed, arginfo_TElGoogleDataStorageObject_get_QuotaBytesUsed, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_WritersCanInvite, arginfo_TElGoogleDataStorageObject_get_WritersCanInvite, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_Starred, arginfo_TElGoogleDataStorageObject_get_Starred, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_Trashed, arginfo_TElGoogleDataStorageObject_get_Trashed, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_Hidden, arginfo_TElGoogleDataStorageObject_get_Hidden, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_Viewed, arginfo_TElGoogleDataStorageObject_get_Viewed, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_Mine, arginfo_TElGoogleDataStorageObject_get_Mine, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_PrivateObj, arginfo_TElGoogleDataStorageObject_get_PrivateObj, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_SharedWithDomain, arginfo_TElGoogleDataStorageObject_get_SharedWithDomain, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_ContainingFolders, arginfo_TElGoogleDataStorageObject_get_ContainingFolders, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_ETag, arginfo_TElGoogleDataStorageObject_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, get_DocType, arginfo_TElGoogleDataStorageObject_get_DocType, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleDataStorageObject, __construct, arginfo_TElGoogleDataStorageObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleDataStorageObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleDataStorageObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleDataStorageObject", TElGoogleDataStorageObject_methods);
	if (NULL == TElCustomDataStorageObject_ce_ptr)
		Register_TElCustomDataStorageObject(TSRMLS_C);
	TElGoogleDataStorageObject_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGooglePrefixedPostfixedUploadStream_ce_ptr = NULL;

SB_PHP_METHOD(TElGooglePrefixedPostfixedUploadStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGooglePrefixedPostfixedUploadStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGooglePrefixedPostfixedUploadStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGooglePrefixedPostfixedUploadStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGooglePrefixedPostfixedUploadStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGooglePrefixedPostfixedUploadStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGooglePrefixedPostfixedUploadStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGooglePrefixedPostfixedUploadStream, CreateMultipartRelated)
{
	char *sBoundary;
	char *sContentType;
	int sBoundary_len;
	int sContentType_len;
	long l8Count;
	SBArrayZValInfo aiAtomXmlPart;
	zend_bool bReleaseSourceStream;
	zval *oSourceStream;
	zval *zaAtomXmlPart;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!szslb", &oSourceStream, TStream_ce_ptr, &sBoundary, &sBoundary_len, &zaAtomXmlPart, &sContentType, &sContentType_len, &l8Count, &bReleaseSourceStream) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaAtomXmlPart)) || (IS_ARRAY == Z_TYPE_P(zaAtomXmlPart)) || (IS_NULL == Z_TYPE_P(zaAtomXmlPart))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaAtomXmlPart, &aiAtomXmlPart TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGooglePrefixedPostfixedUploadStream_CreateMultipartRelated(SBGetObjectHandle(oSourceStream TSRMLS_CC), sBoundary, (int32_t)sBoundary_len, aiAtomXmlPart.data, aiAtomXmlPart.len, sContentType, (int32_t)sContentType_len, (int64_t)l8Count, (int8_t)bReleaseSourceStream, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiAtomXmlPart);
		object_init_ex(return_value, TElGooglePrefixedPostfixedUploadStream_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string, array of byte|string|NULL, string, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGooglePrefixedPostfixedUploadStream, CreatePrefixed)
{
	long l8Count;
	SBArrayZValInfo aiPrefix;
	zend_bool bReleaseSourceStream;
	zval *oSourceStream;
	zval *zaPrefix;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zlb", &oSourceStream, TStream_ce_ptr, &zaPrefix, &l8Count, &bReleaseSourceStream) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaPrefix)) || (IS_ARRAY == Z_TYPE_P(zaPrefix)) || (IS_NULL == Z_TYPE_P(zaPrefix))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaPrefix, &aiPrefix TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGooglePrefixedPostfixedUploadStream_CreatePrefixed(SBGetObjectHandle(oSourceStream TSRMLS_CC), aiPrefix.data, aiPrefix.len, (int64_t)l8Count, (int8_t)bReleaseSourceStream, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiPrefix);
		object_init_ex(return_value, TElGooglePrefixedPostfixedUploadStream_ce_ptr);
		SBSetObjectHandle(return_value, hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, array of byte|string|NULL, integer, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGooglePrefixedPostfixedUploadStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGooglePrefixedPostfixedUploadStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGooglePrefixedPostfixedUploadStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGooglePrefixedPostfixedUploadStream_CreateMultipartRelated, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, SourceStream, TStream, 1)
	ZEND_ARG_INFO(0, Boundary)
	ZEND_ARG_TYPE_INFO(0, AtomXmlPart, 0, 1)
	ZEND_ARG_INFO(0, ContentType)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, ReleaseSourceStream)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGooglePrefixedPostfixedUploadStream_CreatePrefixed, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, SourceStream, TStream, 1)
	ZEND_ARG_TYPE_INFO(0, Prefix, 0, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, ReleaseSourceStream)
ZEND_END_ARG_INFO()

static zend_function_entry TElGooglePrefixedPostfixedUploadStream_methods[] = {
	PHP_ME(TElGooglePrefixedPostfixedUploadStream, Read, arginfo_TElGooglePrefixedPostfixedUploadStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElGooglePrefixedPostfixedUploadStream, Write, arginfo_TElGooglePrefixedPostfixedUploadStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElGooglePrefixedPostfixedUploadStream, Seek, arginfo_TElGooglePrefixedPostfixedUploadStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElGooglePrefixedPostfixedUploadStream, CreateMultipartRelated, arginfo_TElGooglePrefixedPostfixedUploadStream_CreateMultipartRelated, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElGooglePrefixedPostfixedUploadStream, CreatePrefixed, arginfo_TElGooglePrefixedPostfixedUploadStream_CreatePrefixed, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_FE_END
};

void Register_TElGooglePrefixedPostfixedUploadStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGooglePrefixedPostfixedUploadStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGooglePrefixedPostfixedUploadStream", TElGooglePrefixedPostfixedUploadStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElGooglePrefixedPostfixedUploadStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleBase64EncodingStream_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleBase64EncodingStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGoogleBase64EncodingStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleBase64EncodingStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGoogleBase64EncodingStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleBase64EncodingStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleBase64EncodingStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleBase64EncodingStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleBase64EncodingStream, __construct)
{
	long fEOL;
	long l4LineLen;
	long l8Count;
	zend_bool bReleaseSourceStream;
	zval *oSourceStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lllb", &oSourceStream, TStream_ce_ptr, &l8Count, &l4LineLen, &fEOL, &bReleaseSourceStream) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleBase64EncodingStream_Create(SBGetObjectHandle(oSourceStream TSRMLS_CC), (int64_t)l8Count, (int32_t)l4LineLen, (TSBEOLMarkerRaw)fEOL, (int8_t)bReleaseSourceStream, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, integer, integer, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleBase64EncodingStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleBase64EncodingStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleBase64EncodingStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleBase64EncodingStream___construct, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, SourceStream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, LineLen)
	ZEND_ARG_INFO(0, EOL)
	ZEND_ARG_INFO(0, ReleaseSourceStream)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleBase64EncodingStream_methods[] = {
	PHP_ME(TElGoogleBase64EncodingStream, Read, arginfo_TElGoogleBase64EncodingStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleBase64EncodingStream, Write, arginfo_TElGoogleBase64EncodingStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleBase64EncodingStream, Seek, arginfo_TElGoogleBase64EncodingStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleBase64EncodingStream, __construct, arginfo_TElGoogleBase64EncodingStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleBase64EncodingStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleBase64EncodingStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleBase64EncodingStream", TElGoogleBase64EncodingStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElGoogleBase64EncodingStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGoogleBase64DecodingStream_ce_ptr = NULL;

SB_PHP_METHOD(TElGoogleBase64DecodingStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGoogleBase64DecodingStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleBase64DecodingStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGoogleBase64DecodingStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleBase64DecodingStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGoogleBase64DecodingStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGoogleBase64DecodingStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleBase64DecodingStream, get_DestStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleBase64DecodingStream_get_DestStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGoogleBase64DecodingStream, __construct)
{
	long l8Count;
	zend_bool bReleaseDestStream;
	zval *oDestStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lb", &oDestStream, TStream_ce_ptr, &l8Count, &bReleaseDestStream) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGoogleBase64DecodingStream_Create(SBGetObjectHandle(oDestStream TSRMLS_CC), (int64_t)l8Count, (int8_t)bReleaseDestStream, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, integer, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleBase64DecodingStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleBase64DecodingStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleBase64DecodingStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleBase64DecodingStream_get_DestStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGoogleBase64DecodingStream___construct, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, DestStream, TStream, 1)
	ZEND_ARG_INFO(0, Count)
	ZEND_ARG_INFO(0, ReleaseDestStream)
ZEND_END_ARG_INFO()

static zend_function_entry TElGoogleBase64DecodingStream_methods[] = {
	PHP_ME(TElGoogleBase64DecodingStream, Read, arginfo_TElGoogleBase64DecodingStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleBase64DecodingStream, Write, arginfo_TElGoogleBase64DecodingStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleBase64DecodingStream, Seek, arginfo_TElGoogleBase64DecodingStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleBase64DecodingStream, get_DestStream, arginfo_TElGoogleBase64DecodingStream_get_DestStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElGoogleBase64DecodingStream, __construct, arginfo_TElGoogleBase64DecodingStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGoogleBase64DecodingStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGoogleBase64DecodingStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGoogleBase64DecodingStream", TElGoogleBase64DecodingStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElGoogleBase64DecodingStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElGooglePrefixedMetadataProcessingStream_ce_ptr = NULL;

SB_PHP_METHOD(TElGooglePrefixedMetadataProcessingStream, Read)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((PZVAL_IS_REF(zpBuffer) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY))) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGooglePrefixedMetadataProcessingStream_Read(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBSetPointerToZVal(&piBuffer, zpBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGooglePrefixedMetadataProcessingStream, Write)
{
	long l4Count;
	SBPointerZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Count) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElGooglePrefixedMetadataProcessingStream_Write(SBGetObjectHandle(getThis() TSRMLS_CC), piBuffer.data, (int32_t)l4Count, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGooglePrefixedMetadataProcessingStream, Seek)
{
	long fOrigin;
	long l4Offset;
	long l8Offset;
	long u2Origin;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Offset, &u2Origin) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElGooglePrefixedMetadataProcessingStream_Seek(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Offset, (uint16_t)u2Origin, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l8Offset, &fOrigin) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElGooglePrefixedMetadataProcessingStream_Seek_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Offset, (TSeekOriginRaw)fOrigin, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGooglePrefixedMetadataProcessingStream, get_DestStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElGooglePrefixedMetadataProcessingStream_get_DestStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGooglePrefixedMetadataProcessingStream, get_Metadata)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElGooglePrefixedMetadataProcessingStream_get_Metadata(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1393967539, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElGooglePrefixedMetadataProcessingStream, __construct)
{
	SBArrayZValInfo aiMetadataID;
	void *pzOnMetadata;
	void *pzOnNoMetadata;
	zend_bool bReleaseDestStream;
	zval *oDestStream;
	zval *zaMetadataID;
	zval *zOnMetadata;
	zval *zOnNoMetadata;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zzzb", &oDestStream, TStream_ce_ptr, &zaMetadataID, &zOnMetadata, &zOnNoMetadata, &bReleaseDestStream) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMetadataID)) || (IS_ARRAY == Z_TYPE_P(zaMetadataID)) || (IS_NULL == Z_TYPE_P(zaMetadataID))) && ((IS_STRING == Z_TYPE_P(zOnMetadata)) || (IS_ARRAY == Z_TYPE_P(zOnMetadata)) || (IS_CALLABLE == Z_TYPE_P(zOnMetadata)) || (IS_NULL == Z_TYPE_P(zOnMetadata))) && ((IS_STRING == Z_TYPE_P(zOnNoMetadata)) || (IS_ARRAY == Z_TYPE_P(zOnNoMetadata)) || (IS_CALLABLE == Z_TYPE_P(zOnNoMetadata)) || (IS_NULL == Z_TYPE_P(zOnNoMetadata))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaMetadataID, &aiMetadataID TSRMLS_CC)) RETURN_FALSE;
		pzOnMetadata = SBSetEventData(zOnMetadata TSRMLS_CC);
		pzOnNoMetadata = SBSetEventData(zOnNoMetadata TSRMLS_CC);
		SBCheckError(TElGooglePrefixedMetadataProcessingStream_Create(SBGetObjectHandle(oDestStream TSRMLS_CC), aiMetadataID.data, aiMetadataID.len, pzOnMetadata ? &TSBGooglePrefixedMetadataProcessingStreamMetadataFuncRaw : NULL, pzOnMetadata, pzOnNoMetadata ? &TNotifyEventRaw : NULL, pzOnNoMetadata, (int8_t)bReleaseDestStream, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMetadataID);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, array of byte|string|NULL, TSBGooglePrefixedMetadataProcessingStreamMetadataFunc|callable|NULL, TNotifyEvent|callable|NULL, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGooglePrefixedMetadataProcessingStream_Read, 0, 0, 2)
	ZEND_ARG_INFO(1, Buffer)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGooglePrefixedMetadataProcessingStream_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGooglePrefixedMetadataProcessingStream_Seek, 0, 0, 2)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Origin)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGooglePrefixedMetadataProcessingStream_get_DestStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGooglePrefixedMetadataProcessingStream_get_Metadata, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElGooglePrefixedMetadataProcessingStream___construct, 0, 0, 5)
	ZEND_ARG_OBJ_INFO(0, DestStream, TStream, 1)
	ZEND_ARG_TYPE_INFO(0, MetadataID, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OnMetadata, 0, 1)
	ZEND_ARG_TYPE_INFO(0, OnNoMetadata, 0, 1)
	ZEND_ARG_INFO(0, ReleaseDestStream)
ZEND_END_ARG_INFO()

static zend_function_entry TElGooglePrefixedMetadataProcessingStream_methods[] = {
	PHP_ME(TElGooglePrefixedMetadataProcessingStream, Read, arginfo_TElGooglePrefixedMetadataProcessingStream_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElGooglePrefixedMetadataProcessingStream, Write, arginfo_TElGooglePrefixedMetadataProcessingStream_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElGooglePrefixedMetadataProcessingStream, Seek, arginfo_TElGooglePrefixedMetadataProcessingStream_Seek, ZEND_ACC_PUBLIC)
	PHP_ME(TElGooglePrefixedMetadataProcessingStream, get_DestStream, arginfo_TElGooglePrefixedMetadataProcessingStream_get_DestStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElGooglePrefixedMetadataProcessingStream, get_Metadata, arginfo_TElGooglePrefixedMetadataProcessingStream_get_Metadata, ZEND_ACC_PUBLIC)
	PHP_ME(TElGooglePrefixedMetadataProcessingStream, __construct, arginfo_TElGooglePrefixedMetadataProcessingStream___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElGooglePrefixedMetadataProcessingStream(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElGooglePrefixedMetadataProcessingStream_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElGooglePrefixedMetadataProcessingStream", TElGooglePrefixedMetadataProcessingStream_methods);
	if (NULL == TStream_ce_ptr)
		Register_TStream(TSRMLS_C);
	TElGooglePrefixedMetadataProcessingStream_ce_ptr = zend_register_internal_class_ex(&ce, TStream_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBGoogleDataStorage_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBGDataVersion", NULL);
	TSBGDataVersion_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGDataVersion_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGDataVersion_ce_ptr, "gvV2", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGDataVersion_ce_ptr, "gvV3", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBGoogleAuthType", NULL);
	TSBGoogleAuthType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGoogleAuthType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleAuthType_ce_ptr, "gatClientLogin", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleAuthType_ce_ptr, "gatAuthSub", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleAuthType_ce_ptr, "gatOAuth", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBGoogleEntryOrder", NULL);
	TSBGoogleEntryOrder_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGoogleEntryOrder_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleEntryOrder_ce_ptr, "geoTitle", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleEntryOrder_ce_ptr, "geoStarred", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleEntryOrder_ce_ptr, "geoLastModified", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleEntryOrder_ce_ptr, "geoLastViewed", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleEntryOrder_ce_ptr, "geoUnspecified", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBGoogleDocType", NULL);
	TSBGoogleDocType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGoogleDocType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDocType_ce_ptr, "gdtDocument", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDocType_ce_ptr, "gdtSpreadsheet", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDocType_ce_ptr, "gdtPresentation", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDocType_ce_ptr, "gdtUnknown", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBGoogleDataStorageEncoding", NULL);
	TSBGoogleDataStorageEncoding_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBGoogleDataStorageEncoding_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDataStorageEncoding_ce_ptr, "gdeNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBGoogleDataStorageEncoding_ce_ptr, "gdeBase64", 1)
}
