#include "sbimapclient.h"

zend_class_entry *TSBIMAPLogDirection_ce_ptr = NULL;

void SB_CALLBACK TSBIMAPLogEventRaw(void * _ObjectData, TObjectHandle Sender, TSBIMAPLogDirectionRaw Direction, const char * pcInfo, int32_t szInfo)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zDirection;
	zval * zInfo;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zDirection);
	ZVAL_LONG(zDirection, (long)Direction);
	MAKE_STD_ZVAL(zInfo);
	ZVAL_STRINGL(zInfo, pcInfo, szInfo, 1);

	params[0] = &zSender;
	params[1] = &zDirection;
	params[2] = &zInfo;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zDirection);
	zval_ptr_dtor(&zInfo);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBIMAPAuthorization_ce_ptr = NULL;

zend_class_entry *TSBIMAPAuthorizations_ce_ptr = NULL;

zend_class_entry *TSBIMAPAutoCAPAMode_ce_ptr = NULL;

zend_class_entry *TSBIMAPState_ce_ptr = NULL;

zend_class_entry *TSBIMAPToken_ce_ptr = NULL;

zend_class_entry *TElIMAPFetchResponseItemType_ce_ptr = NULL;

zend_class_entry *TSBIMAPStoreFlagsOperation_ce_ptr = NULL;

zend_class_entry *TElIMAPMailBoxAttribute_ce_ptr = NULL;

zend_class_entry *TElIMAPMailBoxAttributes_ce_ptr = NULL;

zend_class_entry *TSBIMAPMessageFlag_ce_ptr = NULL;

zend_class_entry *TSBIMAPMessageFlags_ce_ptr = NULL;

zend_class_entry *TSBIMAPStatusItem_ce_ptr = NULL;

zend_class_entry *TSBIMAPStatusItems_ce_ptr = NULL;

void SB_CALLBACK TSBIMAPTextLineEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcInfo, int32_t szInfo)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zInfo;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zInfo);
	ZVAL_STRINGL(zInfo, pcInfo, szInfo, 1);

	params[0] = &zSender;
	params[1] = &zInfo;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zInfo);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBIMAPIdleEventRaw(void * _ObjectData, TObjectHandle Sender, TElIMAPIdleUpdateHandle Update)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zUpdate;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUpdate);
	SBInitObject(zUpdate, TElIMAPIdleUpdate_ce_ptr, Update TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zUpdate;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUpdate);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElIMAPLiteralContext_ce_ptr = NULL;

SB_PHP_METHOD(TElIMAPLiteralContext, get_Line)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElIMAPLiteralContext_get_Line(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1067686195, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPLiteralContext, set_Line)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElIMAPLiteralContext_set_Line(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPLiteralContext, get_IsLiteral)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIMAPLiteralContext_get_IsLiteral(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPLiteralContext, set_IsLiteral)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElIMAPLiteralContext_set_IsLiteral(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPLiteralContext, __construct)
{
	char *sLine;
	int sLine_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sLine, &sLine_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPLiteralContext_Create(sLine, (int32_t)sLine_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPLiteralContext_get_Line, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPLiteralContext_set_Line, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPLiteralContext_get_IsLiteral, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPLiteralContext_set_IsLiteral, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPLiteralContext___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, Line)
ZEND_END_ARG_INFO()

static zend_function_entry TElIMAPLiteralContext_methods[] = {
	PHP_ME(TElIMAPLiteralContext, get_Line, arginfo_TElIMAPLiteralContext_get_Line, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPLiteralContext, set_Line, arginfo_TElIMAPLiteralContext_set_Line, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPLiteralContext, get_IsLiteral, arginfo_TElIMAPLiteralContext_get_IsLiteral, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPLiteralContext, set_IsLiteral, arginfo_TElIMAPLiteralContext_set_IsLiteral, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPLiteralContext, __construct, arginfo_TElIMAPLiteralContext___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIMAPLiteralContext(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIMAPLiteralContext_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIMAPLiteralContext", TElIMAPLiteralContext_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElIMAPLiteralContext_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIMAPMailBoxState_ce_ptr = NULL;

SB_PHP_METHOD(TElIMAPMailBoxState, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPMailBoxState_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, CopyFrom)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElIMAPMailBoxState_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPMailBoxState_CopyFrom(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElIMAPMailBoxState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, get_ReadWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIMAPMailBoxState_get_ReadWrite(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, set_ReadWrite)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElIMAPMailBoxState_set_ReadWrite(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, get_TotalMessages)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPMailBoxState_get_TotalMessages(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, set_TotalMessages)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElIMAPMailBoxState_set_TotalMessages(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, get_RecentMessages)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPMailBoxState_get_RecentMessages(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, set_RecentMessages)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElIMAPMailBoxState_set_RecentMessages(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, get_UnseenMessages)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPMailBoxState_get_UnseenMessages(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, set_UnseenMessages)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElIMAPMailBoxState_set_UnseenMessages(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, get_Flags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBIMAPMessageFlagsRaw fOutResultRaw = 0;
		SBCheckError(TElIMAPMailBoxState_get_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, set_Flags)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElIMAPMailBoxState_set_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBIMAPMessageFlagsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, get_PermanentFlags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBIMAPMessageFlagsRaw fOutResultRaw = 0;
		SBCheckError(TElIMAPMailBoxState_get_PermanentFlags(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, set_PermanentFlags)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElIMAPMailBoxState_set_PermanentFlags(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBIMAPMessageFlagsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, get_NextUID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPMailBoxState_get_NextUID(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, set_NextUID)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElIMAPMailBoxState_set_NextUID(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, get_UIDValidity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPMailBoxState_get_UIDValidity(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, set_UIDValidity)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElIMAPMailBoxState_set_UIDValidity(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxState, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPMailBoxState_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_CopyFrom, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElIMAPMailBoxState, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_get_ReadWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_set_ReadWrite, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_get_TotalMessages, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_set_TotalMessages, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_get_RecentMessages, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_set_RecentMessages, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_get_UnseenMessages, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_set_UnseenMessages, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_get_Flags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_set_Flags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_get_PermanentFlags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_set_PermanentFlags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_get_NextUID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_set_NextUID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_get_UIDValidity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState_set_UIDValidity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxState___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElIMAPMailBoxState_methods[] = {
	PHP_ME(TElIMAPMailBoxState, Clear, arginfo_TElIMAPMailBoxState_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, CopyFrom, arginfo_TElIMAPMailBoxState_CopyFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, get_ReadWrite, arginfo_TElIMAPMailBoxState_get_ReadWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, set_ReadWrite, arginfo_TElIMAPMailBoxState_set_ReadWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, get_TotalMessages, arginfo_TElIMAPMailBoxState_get_TotalMessages, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, set_TotalMessages, arginfo_TElIMAPMailBoxState_set_TotalMessages, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, get_RecentMessages, arginfo_TElIMAPMailBoxState_get_RecentMessages, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, set_RecentMessages, arginfo_TElIMAPMailBoxState_set_RecentMessages, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, get_UnseenMessages, arginfo_TElIMAPMailBoxState_get_UnseenMessages, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, set_UnseenMessages, arginfo_TElIMAPMailBoxState_set_UnseenMessages, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, get_Flags, arginfo_TElIMAPMailBoxState_get_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, set_Flags, arginfo_TElIMAPMailBoxState_set_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, get_PermanentFlags, arginfo_TElIMAPMailBoxState_get_PermanentFlags, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, set_PermanentFlags, arginfo_TElIMAPMailBoxState_set_PermanentFlags, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, get_NextUID, arginfo_TElIMAPMailBoxState_get_NextUID, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, set_NextUID, arginfo_TElIMAPMailBoxState_set_NextUID, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, get_UIDValidity, arginfo_TElIMAPMailBoxState_get_UIDValidity, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, set_UIDValidity, arginfo_TElIMAPMailBoxState_set_UIDValidity, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxState, __construct, arginfo_TElIMAPMailBoxState___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIMAPMailBoxState(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIMAPMailBoxState_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIMAPMailBoxState", TElIMAPMailBoxState_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElIMAPMailBoxState_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIMAPMailBoxInfo_ce_ptr = NULL;

SB_PHP_METHOD(TElIMAPMailBoxInfo, get_Attributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElIMAPMailBoxAttributesRaw fOutResultRaw = 0;
		SBCheckError(TElIMAPMailBoxInfo_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxInfo, get_Delimiter)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElIMAPMailBoxInfo_get_Delimiter(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1361772936, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxInfo, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElIMAPMailBoxInfo_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(690021164, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxInfo, __construct)
{
	char *sADelimiter;
	char *sAName;
	int sADelimiter_len;
	int sAName_len;
	long fAAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lss", &fAAttributes, &sADelimiter, &sADelimiter_len, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPMailBoxInfo_Create((TElIMAPMailBoxAttributesRaw)fAAttributes, sADelimiter, (int32_t)sADelimiter_len, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxInfo_get_Attributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxInfo_get_Delimiter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxInfo_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxInfo___construct, 0, 0, 3)
	ZEND_ARG_INFO(0, AAttributes)
	ZEND_ARG_INFO(0, ADelimiter)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElIMAPMailBoxInfo_methods[] = {
	PHP_ME(TElIMAPMailBoxInfo, get_Attributes, arginfo_TElIMAPMailBoxInfo_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxInfo, get_Delimiter, arginfo_TElIMAPMailBoxInfo_get_Delimiter, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxInfo, get_Name, arginfo_TElIMAPMailBoxInfo_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxInfo, __construct, arginfo_TElIMAPMailBoxInfo___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIMAPMailBoxInfo(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIMAPMailBoxInfo_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIMAPMailBoxInfo", TElIMAPMailBoxInfo_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElIMAPMailBoxInfo_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIMAPMailBoxesList_ce_ptr = NULL;

SB_PHP_METHOD(TElIMAPMailBoxesList, Add)
{
	zval *oItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oItem, TElIMAPMailBoxInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPMailBoxesList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oItem TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElIMAPMailBoxInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxesList, Get)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPMailBoxesList_Get(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPMailBoxInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxesList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPMailBoxesList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxesList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPMailBoxesList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPMailBoxesList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPMailBoxesList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxesList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Item, TElIMAPMailBoxInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxesList_Get, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxesList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxesList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPMailBoxesList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElIMAPMailBoxesList_methods[] = {
	PHP_ME(TElIMAPMailBoxesList, Add, arginfo_TElIMAPMailBoxesList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxesList, Get, arginfo_TElIMAPMailBoxesList_Get, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxesList, Clear, arginfo_TElIMAPMailBoxesList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxesList, get_Count, arginfo_TElIMAPMailBoxesList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPMailBoxesList, __construct, arginfo_TElIMAPMailBoxesList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIMAPMailBoxesList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIMAPMailBoxesList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIMAPMailBoxesList", TElIMAPMailBoxesList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElIMAPMailBoxesList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIMAPFetchResponseItem_ce_ptr = NULL;

SB_PHP_METHOD(TElIMAPFetchResponseItem, SetData)
{
	char *sAName;
	char *sAValue;
	int sAName_len;
	int sAValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sAName, &sAName_len, &sAValue, &sAValue_len) == SUCCESS)
	{
		SBCheckError(TElIMAPFetchResponseItem_SetData(SBGetObjectHandle(getThis() TSRMLS_CC), sAName, (int32_t)sAName_len, sAValue, (int32_t)sAValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseItem, get_ItemType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElIMAPFetchResponseItemTypeRaw fOutResultRaw = 0;
		SBCheckError(TElIMAPFetchResponseItem_get_ItemType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseItem, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElIMAPFetchResponseItem_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-611588635, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseItem, get_RawValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElIMAPFetchResponseItem_get_RawValue(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1172411412, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseItem, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElIMAPFetchResponseItem_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-151802656, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseItem, get_DateTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElIMAPFetchResponseItem_get_DateTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseItem, get_Flags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBIMAPMessageFlagsRaw fOutResultRaw = 0;
		SBCheckError(TElIMAPFetchResponseItem_get_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseItem, get_Number)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElIMAPFetchResponseItem_get_Number(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseItem, get_Streamed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIMAPFetchResponseItem_get_Streamed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseItem, __construct)
{
	char *sAName;
	char *sAValue;
	int sAName_len;
	int sAValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sAName, &sAName_len, &sAValue, &sAValue_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPFetchResponseItem_Create(sAName, (int32_t)sAName_len, sAValue, (int32_t)sAValue_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseItem_SetData, 0, 0, 2)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, AValue)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseItem_get_ItemType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseItem_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseItem_get_RawValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseItem_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseItem_get_DateTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseItem_get_Flags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseItem_get_Number, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseItem_get_Streamed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseItem___construct, 0, 0, 2)
	ZEND_ARG_INFO(0, AName)
	ZEND_ARG_INFO(0, AValue)
ZEND_END_ARG_INFO()

static zend_function_entry TElIMAPFetchResponseItem_methods[] = {
	PHP_ME(TElIMAPFetchResponseItem, SetData, arginfo_TElIMAPFetchResponseItem_SetData, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseItem, get_ItemType, arginfo_TElIMAPFetchResponseItem_get_ItemType, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseItem, get_Name, arginfo_TElIMAPFetchResponseItem_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseItem, get_RawValue, arginfo_TElIMAPFetchResponseItem_get_RawValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseItem, get_Value, arginfo_TElIMAPFetchResponseItem_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseItem, get_DateTime, arginfo_TElIMAPFetchResponseItem_get_DateTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseItem, get_Flags, arginfo_TElIMAPFetchResponseItem_get_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseItem, get_Number, arginfo_TElIMAPFetchResponseItem_get_Number, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseItem, get_Streamed, arginfo_TElIMAPFetchResponseItem_get_Streamed, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseItem, __construct, arginfo_TElIMAPFetchResponseItem___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIMAPFetchResponseItem(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIMAPFetchResponseItem_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIMAPFetchResponseItem", TElIMAPFetchResponseItem_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElIMAPFetchResponseItem_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIMAPFetchResponseLine_ce_ptr = NULL;

SB_PHP_METHOD(TElIMAPFetchResponseLine, Add)
{
	zval *oItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oItem, TElIMAPFetchResponseItem_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPFetchResponseLine_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oItem TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElIMAPFetchResponseItem)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseLine, Get)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPFetchResponseLine_Get(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPFetchResponseItem_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseLine, GetByName)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPFetchResponseLine_GetByName(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPFetchResponseItem_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseLine, CopyFrom)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElIMAPFetchResponseLine_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPFetchResponseLine_CopyFrom(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElIMAPFetchResponseLine)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseLine, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPFetchResponseLine_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseLine, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPFetchResponseLine_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseLine, get_ID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPFetchResponseLine_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseLine, get_Items)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPFetchResponseLine_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPFetchResponseItem_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponseLine, __construct)
{
	long l4ID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4ID) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPFetchResponseLine_Create((int32_t)l4ID, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseLine_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Item, TElIMAPFetchResponseItem, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseLine_Get, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseLine_GetByName, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseLine_CopyFrom, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElIMAPFetchResponseLine, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseLine_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseLine_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseLine_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseLine_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponseLine___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, ID)
ZEND_END_ARG_INFO()

static zend_function_entry TElIMAPFetchResponseLine_methods[] = {
	PHP_ME(TElIMAPFetchResponseLine, Add, arginfo_TElIMAPFetchResponseLine_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseLine, Get, arginfo_TElIMAPFetchResponseLine_Get, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseLine, GetByName, arginfo_TElIMAPFetchResponseLine_GetByName, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseLine, CopyFrom, arginfo_TElIMAPFetchResponseLine_CopyFrom, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseLine, Clear, arginfo_TElIMAPFetchResponseLine_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseLine, get_Count, arginfo_TElIMAPFetchResponseLine_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseLine, get_ID, arginfo_TElIMAPFetchResponseLine_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseLine, get_Items, arginfo_TElIMAPFetchResponseLine_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponseLine, __construct, arginfo_TElIMAPFetchResponseLine___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIMAPFetchResponseLine(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIMAPFetchResponseLine_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIMAPFetchResponseLine", TElIMAPFetchResponseLine_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElIMAPFetchResponseLine_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIMAPFetchResponse_ce_ptr = NULL;

SB_PHP_METHOD(TElIMAPFetchResponse, Add)
{
	zval *oLine;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oLine, TElIMAPFetchResponseLine_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPFetchResponse_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLine TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElIMAPFetchResponseLine)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponse, Get)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPFetchResponse_Get(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPFetchResponseLine_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponse, GetByID)
{
	long l4ID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4ID) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPFetchResponse_GetByID(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ID, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPFetchResponseLine_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponse, Append)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElIMAPFetchResponse_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPFetchResponse_Append(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElIMAPFetchResponse)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponse, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPFetchResponse_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponse, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPFetchResponse_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponse, get_UID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIMAPFetchResponse_get_UID(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponse, get_Lines)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPFetchResponse_get_Lines(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPFetchResponseLine_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPFetchResponse, __construct)
{
	zend_bool bUID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bUID) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPFetchResponse_Create((int8_t)bUID, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponse_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Line, TElIMAPFetchResponseLine, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponse_Get, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponse_GetByID, 0, 0, 1)
	ZEND_ARG_INFO(0, ID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponse_Append, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElIMAPFetchResponse, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponse_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponse_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponse_get_UID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponse_get_Lines, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPFetchResponse___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, UID)
ZEND_END_ARG_INFO()

static zend_function_entry TElIMAPFetchResponse_methods[] = {
	PHP_ME(TElIMAPFetchResponse, Add, arginfo_TElIMAPFetchResponse_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponse, Get, arginfo_TElIMAPFetchResponse_Get, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponse, GetByID, arginfo_TElIMAPFetchResponse_GetByID, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponse, Append, arginfo_TElIMAPFetchResponse_Append, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponse, Clear, arginfo_TElIMAPFetchResponse_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponse, get_Count, arginfo_TElIMAPFetchResponse_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponse, get_UID, arginfo_TElIMAPFetchResponse_get_UID, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponse, get_Lines, arginfo_TElIMAPFetchResponse_get_Lines, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPFetchResponse, __construct, arginfo_TElIMAPFetchResponse___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIMAPFetchResponse(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIMAPFetchResponse_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIMAPFetchResponse", TElIMAPFetchResponse_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElIMAPFetchResponse_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIMAPIdleUpdate_ce_ptr = NULL;

SB_PHP_METHOD(TElIMAPIdleUpdate, Add)
{
	zval *oUpdate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUpdate, TElIMAPIdleUpdate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPIdleUpdate_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUpdate TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElIMAPIdleUpdate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPIdleUpdate, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPIdleUpdate_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPIdleUpdate, get_Token)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBIMAPTokenRaw fOutResultRaw = 0;
		SBCheckError(TElIMAPIdleUpdate_get_Token(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPIdleUpdate, set_Token)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElIMAPIdleUpdate_set_Token(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBIMAPTokenRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPIdleUpdate, get_MailBoxState)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPIdleUpdate_get_MailBoxState(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPMailBoxState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPIdleUpdate, get_ChangedMessages)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPIdleUpdate_get_ChangedMessages(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPFetchResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPIdleUpdate, get_ExpungedMessages)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPIdleUpdate_get_ExpungedMessages(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPFetchResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPIdleUpdate, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPIdleUpdate_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleUpdate_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Update, TElIMAPIdleUpdate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleUpdate_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleUpdate_get_Token, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleUpdate_set_Token, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleUpdate_get_MailBoxState, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleUpdate_get_ChangedMessages, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleUpdate_get_ExpungedMessages, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleUpdate___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElIMAPIdleUpdate_methods[] = {
	PHP_ME(TElIMAPIdleUpdate, Add, arginfo_TElIMAPIdleUpdate_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPIdleUpdate, Clear, arginfo_TElIMAPIdleUpdate_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPIdleUpdate, get_Token, arginfo_TElIMAPIdleUpdate_get_Token, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPIdleUpdate, set_Token, arginfo_TElIMAPIdleUpdate_set_Token, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPIdleUpdate, get_MailBoxState, arginfo_TElIMAPIdleUpdate_get_MailBoxState, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPIdleUpdate, get_ChangedMessages, arginfo_TElIMAPIdleUpdate_get_ChangedMessages, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPIdleUpdate, get_ExpungedMessages, arginfo_TElIMAPIdleUpdate_get_ExpungedMessages, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPIdleUpdate, __construct, arginfo_TElIMAPIdleUpdate___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIMAPIdleUpdate(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIMAPIdleUpdate_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIMAPIdleUpdate", TElIMAPIdleUpdate_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElIMAPIdleUpdate_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIMAPIdleThread_ce_ptr = NULL;

SB_PHP_METHOD(TElIMAPIdleThread, Execute)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPIdleThread_Execute(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPIdleThread, Start)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPIdleThread_Start(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPIdleThread, WaitStop)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPIdleThread_WaitStop(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPIdleThread, TryCallEvents)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPIdleThread_TryCallEvents(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPIdleThread, __construct)
{
	zval *oClient;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oClient, TElIMAPClient_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPIdleThread_Create(SBGetObjectHandle(oClient TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElIMAPClient)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleThread_Execute, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleThread_Start, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleThread_WaitStop, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleThread_TryCallEvents, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPIdleThread___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Client, TElIMAPClient, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElIMAPIdleThread_methods[] = {
	PHP_ME(TElIMAPIdleThread, Execute, arginfo_TElIMAPIdleThread_Execute, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPIdleThread, Start, arginfo_TElIMAPIdleThread_Start, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPIdleThread, WaitStop, arginfo_TElIMAPIdleThread_WaitStop, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPIdleThread, TryCallEvents, arginfo_TElIMAPIdleThread_TryCallEvents, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPIdleThread, __construct, arginfo_TElIMAPIdleThread___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIMAPIdleThread(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIMAPIdleThread_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIMAPIdleThread", TElIMAPIdleThread_methods);
	if (NULL == TThread_ce_ptr)
		Register_TThread(TSRMLS_C);
	TElIMAPIdleThread_ce_ptr = zend_register_internal_class_ex(&ce, TThread_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIMAPTimeoutThread_ce_ptr = NULL;

SB_PHP_METHOD(TElIMAPTimeoutThread, Execute)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPTimeoutThread_Execute(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPTimeoutThread, Start)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPTimeoutThread_Start(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPTimeoutThread, Stop)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPTimeoutThread_Stop(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPTimeoutThread, __construct)
{
	zval *oClient;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oClient, TElIMAPClient_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPTimeoutThread_Create(SBGetObjectHandle(oClient TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElIMAPClient)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPTimeoutThread_Execute, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPTimeoutThread_Start, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPTimeoutThread_Stop, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPTimeoutThread___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Client, TElIMAPClient, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElIMAPTimeoutThread_methods[] = {
	PHP_ME(TElIMAPTimeoutThread, Execute, arginfo_TElIMAPTimeoutThread_Execute, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPTimeoutThread, Start, arginfo_TElIMAPTimeoutThread_Start, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPTimeoutThread, Stop, arginfo_TElIMAPTimeoutThread_Stop, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPTimeoutThread, __construct, arginfo_TElIMAPTimeoutThread___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIMAPTimeoutThread(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIMAPTimeoutThread_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIMAPTimeoutThread", TElIMAPTimeoutThread_methods);
	if (NULL == TThread_ce_ptr)
		Register_TThread(TSRMLS_C);
	TElIMAPTimeoutThread_ce_ptr = zend_register_internal_class_ex(&ce, TThread_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElIMAPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElIMAPClient, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPClient_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, ObtainCapabilities)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPClient_ObtainCapabilities(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, Login)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPClient_Login(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, Close)
{
	zend_bool bSilent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSilent) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_Close(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bSilent) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, Noop)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPClient_Noop(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, List)
{
	char *sMailBox;
	char *sRefName;
	int sMailBox_len;
	int sRefName_len;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sRefName, &sRefName_len, &sMailBox, &sMailBox_len, &oList, TElIMAPMailBoxesList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_List(SBGetObjectHandle(getThis() TSRMLS_CC), sRefName, (int32_t)sRefName_len, sMailBox, (int32_t)sMailBox_len, SBGetObjectHandle(oList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, TElIMAPMailBoxesList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, LSub)
{
	char *sMailBox;
	char *sRefName;
	int sMailBox_len;
	int sRefName_len;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sRefName, &sRefName_len, &sMailBox, &sMailBox_len, &oList, TElIMAPMailBoxesList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_LSub(SBGetObjectHandle(getThis() TSRMLS_CC), sRefName, (int32_t)sRefName_len, sMailBox, (int32_t)sMailBox_len, SBGetObjectHandle(oList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, TElIMAPMailBoxesList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, SelectBox)
{
	char *sMailBox;
	int sMailBox_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMailBox, &sMailBox_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPClient_SelectBox(SBGetObjectHandle(getThis() TSRMLS_CC), sMailBox, (int32_t)sMailBox_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPMailBoxState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, ExamineBox)
{
	char *sMailBox;
	int sMailBox_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMailBox, &sMailBox_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPClient_ExamineBox(SBGetObjectHandle(getThis() TSRMLS_CC), sMailBox, (int32_t)sMailBox_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPMailBoxState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, StatusBox)
{
	char *sMailBox;
	int sMailBox_len;
	long fItems;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sMailBox, &sMailBox_len, &fItems) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPClient_StatusBox(SBGetObjectHandle(getThis() TSRMLS_CC), sMailBox, (int32_t)sMailBox_len, (TSBIMAPStatusItemsRaw)fItems, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPMailBoxState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, CloseBox)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPClient_CloseBox(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, Fetch)
{
	char *sDataItemNames;
	int sDataItemNames_len;
	long l4First;
	long l4Last;
	zend_bool bUID;
	zval *oSequence;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llbs", &l4First, &l4Last, &bUID, &sDataItemNames, &sDataItemNames_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPClient_Fetch(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4First, (int32_t)l4Last, (int8_t)bUID, sDataItemNames, (int32_t)sDataItemNames_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPFetchResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oSequence, TElIMAPFetchResponse_ce_ptr, &sDataItemNames, &sDataItemNames_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPClient_Fetch_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSequence TSRMLS_CC), sDataItemNames, (int32_t)sDataItemNames_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPFetchResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, bool, string) or (TElIMAPFetchResponse, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, Store)
{
	long fFlags;
	long fOperation;
	long l4First;
	long l4Last;
	zend_bool bSilent;
	zend_bool bUID;
	zval *oResponse;
	zval *oSequence;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llbllbO!", &l4First, &l4Last, &bUID, &fOperation, &fFlags, &bSilent, &oResponse, TElIMAPFetchResponse_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_Store(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4First, (int32_t)l4Last, (int8_t)bUID, (TSBIMAPStoreFlagsOperationRaw)fOperation, (TSBIMAPMessageFlagsRaw)fFlags, (int8_t)bSilent, SBGetObjectHandle(oResponse TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llbO!", &oSequence, TElIMAPFetchResponse_ce_ptr, &fOperation, &fFlags, &bSilent, &oResponse, TElIMAPFetchResponse_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_Store_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSequence TSRMLS_CC), (TSBIMAPStoreFlagsOperationRaw)fOperation, (TSBIMAPMessageFlagsRaw)fFlags, (int8_t)bSilent, SBGetObjectHandle(oResponse TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, bool, integer, integer, bool, TElIMAPFetchResponse) or (TElIMAPFetchResponse, integer, integer, bool, TElIMAPFetchResponse)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, Expunge)
{
	zval *oResponse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oResponse, TElIMAPFetchResponse_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_Expunge(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oResponse TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElIMAPFetchResponse)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, Copy)
{
	char *sMailBox;
	int sMailBox_len;
	long l4First;
	long l4Last;
	zend_bool bUID;
	zval *oSequence;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llbs", &l4First, &l4Last, &bUID, &sMailBox, &sMailBox_len) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_Copy(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4First, (int32_t)l4Last, (int8_t)bUID, sMailBox, (int32_t)sMailBox_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oSequence, TElIMAPFetchResponse_ce_ptr, &sMailBox, &sMailBox_len) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_Copy_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSequence TSRMLS_CC), sMailBox, (int32_t)sMailBox_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, bool, string) or (TElIMAPFetchResponse, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, FetchMessage)
{
	char *sBodyCharset;
	char *sHeaderCharset;
	int sBodyCharset_len;
	int sHeaderCharset_len;
	long fOptions;
	long l4ID;
	TElClassHandle hoMessage = SB_NULL_HANDLE;
	zend_bool bActivatePartHandlers;
	zend_bool bIgnoreBodyNativeCharset;
	zend_bool bIgnoreHeaderNativeCharset;
	zend_bool bUID;
	zval *oMessage;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbO!", &l4ID, &bUID, &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_FetchMessage(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ID, (int8_t)bUID, SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbsslbbbO", &l4ID, &bUID, &sHeaderCharset, &sHeaderCharset_len, &sBodyCharset, &sBodyCharset_len, &fOptions, &bIgnoreHeaderNativeCharset, &bIgnoreBodyNativeCharset, &bActivatePartHandlers, &oMessage, TElMessage_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oMessage) && (IS_OBJECT == Z_TYPE_P(oMessage)))
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPClient_FetchMessage_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4ID, (int8_t)bUID, sHeaderCharset, (int32_t)sHeaderCharset_len, sBodyCharset, (int32_t)sBodyCharset_len, (TElMessageParsingOptionsRaw)fOptions, (int8_t)bIgnoreHeaderNativeCharset, (int8_t)bIgnoreBodyNativeCharset, (int8_t)bActivatePartHandlers, &hoMessage, &l4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oMessage, hoMessage TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool, TStream) or (integer, bool, string, string, integer, bool, bool, bool, &TElMessage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, CreateBox)
{
	char *sMailBox;
	int sMailBox_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMailBox, &sMailBox_len) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_CreateBox(SBGetObjectHandle(getThis() TSRMLS_CC), sMailBox, (int32_t)sMailBox_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, RenameBox)
{
	char *sMailBox;
	char *sNewName;
	int sMailBox_len;
	int sNewName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sMailBox, &sMailBox_len, &sNewName, &sNewName_len) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_RenameBox(SBGetObjectHandle(getThis() TSRMLS_CC), sMailBox, (int32_t)sMailBox_len, sNewName, (int32_t)sNewName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, DeleteBox)
{
	char *sMailBox;
	int sMailBox_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMailBox, &sMailBox_len) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_DeleteBox(SBGetObjectHandle(getThis() TSRMLS_CC), sMailBox, (int32_t)sMailBox_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, Check)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPClient_Check(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, SubscribeBox)
{
	char *sMailBox;
	int sMailBox_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMailBox, &sMailBox_len) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_SubscribeBox(SBGetObjectHandle(getThis() TSRMLS_CC), sMailBox, (int32_t)sMailBox_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, UnsubscribeBox)
{
	char *sMailBox;
	int sMailBox_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMailBox, &sMailBox_len) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_UnsubscribeBox(SBGetObjectHandle(getThis() TSRMLS_CC), sMailBox, (int32_t)sMailBox_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, Search)
{
	char *sCharset;
	char *sCriteria;
	int sCharset_len;
	int sCriteria_len;
	zend_bool bUID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bs", &bUID, &sCriteria, &sCriteria_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPClient_Search(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bUID, sCriteria, (int32_t)sCriteria_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPFetchResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bss", &bUID, &sCriteria, &sCriteria_len, &sCharset, &sCharset_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPClient_Search_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bUID, sCriteria, (int32_t)sCriteria_len, sCharset, (int32_t)sCharset_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPFetchResponse_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, string) or (bool, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, Idle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPClient_Idle(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, IdleDone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElIMAPClient_IdleDone(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_Capabilities)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPClient_get_Capabilities(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_LoginDisabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIMAPClient_get_LoginDisabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_MailBox)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElIMAPClient_get_MailBox(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1647449821, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_MailBoxState)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPClient_get_MailBoxState(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElIMAPMailBoxState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_IdleSupported)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIMAPClient_get_IdleSupported(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_IdleActive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIMAPClient_get_IdleActive(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElIMAPClient_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-240198217, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_MaxLineLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPClient_get_MaxLineLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_MaxLineLength)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_set_MaxLineLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPClient_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_Port)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_SSLMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSLModeRaw fOutResultRaw = 0;
		SBCheckError(TElIMAPClient_get_SSLMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_SSLMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_set_SSLMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSSLModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_AutoCAPA)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBIMAPAutoCAPAModeRaw fOutResultRaw = 0;
		SBCheckError(TElIMAPClient_get_AutoCAPA(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_AutoCAPA)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_set_AutoCAPA(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBIMAPAutoCAPAModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElIMAPClient, get_UseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIMAPClient_get_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_UseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_set_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElIMAPClient, get_UseSSL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIMAPClient_get_UseSSL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_UseSSL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_set_UseSSL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_Username)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElIMAPClient_get_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-451240751, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_Username)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_set_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_Password)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElIMAPClient_get_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(679926899, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_Password)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_set_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_IdleAuto)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElIMAPClient_get_IdleAuto(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_IdleAuto)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_set_IdleAuto(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_IdleTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElIMAPClient_get_IdleTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_IdleTimeout)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElIMAPClient_set_IdleTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnCapability)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBIMAPTextLineEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnCapability(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnCapability)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnCapability(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBIMAPTextLineEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBIMAPTextLineEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnLog)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBIMAPLogEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnLog(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnLog)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnLog(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBIMAPLogEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBIMAPLogEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnIdle)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBIMAPIdleEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnIdle(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnIdle)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnIdle(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBIMAPIdleEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBIMAPIdleEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnCertificateChoose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBChooseCertificateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnCertificateChoose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnCertificateChoose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnCertificateChoose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBChooseCertificateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBChooseCertificateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnCertificateNeededEx)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateNeededExEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnCertificateNeededEx(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnCertificateNeededEx)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnCertificateNeededEx(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateNeededExEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateNeededExEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnCertificateValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnCertificateValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnCiphersNegotiated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnCiphersNegotiated(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnCiphersNegotiated)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnCiphersNegotiated(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnCloseConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCloseConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnCloseConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCloseConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCloseConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnExtensionsReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBExtensionsReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnExtensionsReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnExtensionsReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnExtensionsReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBExtensionsReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBExtensionsReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnCertificateStatus)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCertificateStatusEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnCertificateStatus(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnCertificateStatus)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnCertificateStatus(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCertificateStatusEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCertificateStatusEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBClientKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBClientKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBClientKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnRenegotiationRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBRenegotiationRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnRenegotiationRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnRenegotiationRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnRenegotiationRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBRenegotiationRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBRenegotiationRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElIMAPClient, get_OnDNSKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnDNSKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnDNSKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnDNSKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnDNSKeyValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnDNSKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnDNSKeyValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnDNSKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, get_OnDNSResolve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResolveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElIMAPClient_get_OnDNSResolve(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElIMAPClient, set_OnDNSResolve)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElIMAPClient_set_OnDNSResolve(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSResolveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSResolveEvent|callable|NULL)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElIMAPClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElIMAPClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_ObtainCapabilities, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_Login, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_Close, 0, 0, 1)
	ZEND_ARG_INFO(0, Silent)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_Noop, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_List, 0, 0, 3)
	ZEND_ARG_INFO(0, RefName)
	ZEND_ARG_INFO(0, MailBox)
	ZEND_ARG_OBJ_INFO(0, List, TElIMAPMailBoxesList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_LSub, 0, 0, 3)
	ZEND_ARG_INFO(0, RefName)
	ZEND_ARG_INFO(0, MailBox)
	ZEND_ARG_OBJ_INFO(0, List, TElIMAPMailBoxesList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_SelectBox, 0, 0, 1)
	ZEND_ARG_INFO(0, MailBox)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_ExamineBox, 0, 0, 1)
	ZEND_ARG_INFO(0, MailBox)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_StatusBox, 0, 0, 2)
	ZEND_ARG_INFO(0, MailBox)
	ZEND_ARG_INFO(0, Items)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_CloseBox, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_Fetch, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, First_or_Sequence, 0, 1)
	ZEND_ARG_INFO(0, Last_or_DataItemNames)
	ZEND_ARG_INFO(0, UID)
	ZEND_ARG_INFO(0, DataItemNames)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_Store, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, First_or_Sequence, 0, 1)
	ZEND_ARG_INFO(0, Last_or_Operation)
	ZEND_ARG_INFO(0, UID_or_Flags)
	ZEND_ARG_INFO(0, Operation_or_Silent)
	ZEND_ARG_TYPE_INFO(0, Flags_or_Response, 0, 1)
	ZEND_ARG_INFO(0, Silent)
	ZEND_ARG_OBJ_INFO(0, Response, TElIMAPFetchResponse, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_Expunge, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Response, TElIMAPFetchResponse, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_Copy, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, First_or_Sequence, 0, 1)
	ZEND_ARG_INFO(0, Last_or_MailBox)
	ZEND_ARG_INFO(0, UID)
	ZEND_ARG_INFO(0, MailBox)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_FetchMessage, 0, 0, 3)
	ZEND_ARG_INFO(0, ID)
	ZEND_ARG_INFO(0, UID)
	ZEND_ARG_TYPE_INFO(0, Stream_or_HeaderCharset, 0, 1)
	ZEND_ARG_INFO(0, BodyCharset)
	ZEND_ARG_INFO(0, Options)
	ZEND_ARG_INFO(0, IgnoreHeaderNativeCharset)
	ZEND_ARG_INFO(0, IgnoreBodyNativeCharset)
	ZEND_ARG_INFO(0, ActivatePartHandlers)
	ZEND_ARG_OBJ_INFO(1, Message, TElMessage, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_CreateBox, 0, 0, 1)
	ZEND_ARG_INFO(0, MailBox)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_RenameBox, 0, 0, 2)
	ZEND_ARG_INFO(0, MailBox)
	ZEND_ARG_INFO(0, NewName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_DeleteBox, 0, 0, 1)
	ZEND_ARG_INFO(0, MailBox)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_Check, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_SubscribeBox, 0, 0, 1)
	ZEND_ARG_INFO(0, MailBox)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_UnsubscribeBox, 0, 0, 1)
	ZEND_ARG_INFO(0, MailBox)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_Search, 0, 0, 2)
	ZEND_ARG_INFO(0, UID)
	ZEND_ARG_INFO(0, Criteria)
	ZEND_ARG_INFO(0, Charset)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_Idle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_IdleDone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_Capabilities, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_LoginDisabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_MailBox, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_MailBoxState, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_IdleSupported, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_IdleActive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_MaxLineLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_MaxLineLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_SSLMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_SSLMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_AutoCAPA, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_AutoCAPA, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_UseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_UseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_UseSSL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_UseSSL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_Username, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_Username, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_Password, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_Password, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_IdleAuto, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_IdleAuto, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_IdleTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_IdleTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnCapability, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnCapability, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnLog, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnLog, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnIdle, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnIdle, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnCertificateChoose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnCertificateChoose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnCertificateNeededEx, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnCertificateNeededEx, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnCertificateValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnCertificateValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnCiphersNegotiated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnCiphersNegotiated, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnCloseConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnCloseConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnExtensionsReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnExtensionsReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnCertificateStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnCertificateStatus, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnRenegotiationRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnRenegotiationRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnDNSKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnDNSKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnDNSKeyValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnDNSKeyValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_get_OnDNSResolve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient_set_OnDNSResolve, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElIMAPClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElIMAPClient_methods[] = {
	PHP_ME(TElIMAPClient, Open, arginfo_TElIMAPClient_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, ObtainCapabilities, arginfo_TElIMAPClient_ObtainCapabilities, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, Login, arginfo_TElIMAPClient_Login, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, Close, arginfo_TElIMAPClient_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, Noop, arginfo_TElIMAPClient_Noop, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, List, arginfo_TElIMAPClient_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, LSub, arginfo_TElIMAPClient_LSub, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, SelectBox, arginfo_TElIMAPClient_SelectBox, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, ExamineBox, arginfo_TElIMAPClient_ExamineBox, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, StatusBox, arginfo_TElIMAPClient_StatusBox, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, CloseBox, arginfo_TElIMAPClient_CloseBox, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, Fetch, arginfo_TElIMAPClient_Fetch, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, Store, arginfo_TElIMAPClient_Store, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, Expunge, arginfo_TElIMAPClient_Expunge, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, Copy, arginfo_TElIMAPClient_Copy, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, FetchMessage, arginfo_TElIMAPClient_FetchMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, CreateBox, arginfo_TElIMAPClient_CreateBox, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, RenameBox, arginfo_TElIMAPClient_RenameBox, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, DeleteBox, arginfo_TElIMAPClient_DeleteBox, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, Check, arginfo_TElIMAPClient_Check, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, SubscribeBox, arginfo_TElIMAPClient_SubscribeBox, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, UnsubscribeBox, arginfo_TElIMAPClient_UnsubscribeBox, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, Search, arginfo_TElIMAPClient_Search, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, Idle, arginfo_TElIMAPClient_Idle, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, IdleDone, arginfo_TElIMAPClient_IdleDone, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_Capabilities, arginfo_TElIMAPClient_get_Capabilities, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_LoginDisabled, arginfo_TElIMAPClient_get_LoginDisabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_MailBox, arginfo_TElIMAPClient_get_MailBox, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_MailBoxState, arginfo_TElIMAPClient_get_MailBoxState, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_IdleSupported, arginfo_TElIMAPClient_get_IdleSupported, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_IdleActive, arginfo_TElIMAPClient_get_IdleActive, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_Address, arginfo_TElIMAPClient_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_Address, arginfo_TElIMAPClient_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_MaxLineLength, arginfo_TElIMAPClient_get_MaxLineLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_MaxLineLength, arginfo_TElIMAPClient_set_MaxLineLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_Port, arginfo_TElIMAPClient_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_Port, arginfo_TElIMAPClient_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_SSLMode, arginfo_TElIMAPClient_get_SSLMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_SSLMode, arginfo_TElIMAPClient_set_SSLMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_AutoCAPA, arginfo_TElIMAPClient_get_AutoCAPA, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_AutoCAPA, arginfo_TElIMAPClient_set_AutoCAPA, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElIMAPClient, get_UseIPv6, arginfo_TElIMAPClient_get_UseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_UseIPv6, arginfo_TElIMAPClient_set_UseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElIMAPClient, get_UseSSL, arginfo_TElIMAPClient_get_UseSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_UseSSL, arginfo_TElIMAPClient_set_UseSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_Username, arginfo_TElIMAPClient_get_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_Username, arginfo_TElIMAPClient_set_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_Password, arginfo_TElIMAPClient_get_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_Password, arginfo_TElIMAPClient_set_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_IdleAuto, arginfo_TElIMAPClient_get_IdleAuto, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_IdleAuto, arginfo_TElIMAPClient_set_IdleAuto, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_IdleTimeout, arginfo_TElIMAPClient_get_IdleTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_IdleTimeout, arginfo_TElIMAPClient_set_IdleTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnCapability, arginfo_TElIMAPClient_get_OnCapability, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnCapability, arginfo_TElIMAPClient_set_OnCapability, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnLog, arginfo_TElIMAPClient_get_OnLog, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnLog, arginfo_TElIMAPClient_set_OnLog, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnProgress, arginfo_TElIMAPClient_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnProgress, arginfo_TElIMAPClient_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnIdle, arginfo_TElIMAPClient_get_OnIdle, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnIdle, arginfo_TElIMAPClient_set_OnIdle, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnCertificateChoose, arginfo_TElIMAPClient_get_OnCertificateChoose, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnCertificateChoose, arginfo_TElIMAPClient_set_OnCertificateChoose, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnCertificateNeededEx, arginfo_TElIMAPClient_get_OnCertificateNeededEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnCertificateNeededEx, arginfo_TElIMAPClient_set_OnCertificateNeededEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnCertificateValidate, arginfo_TElIMAPClient_get_OnCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnCertificateValidate, arginfo_TElIMAPClient_set_OnCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnCiphersNegotiated, arginfo_TElIMAPClient_get_OnCiphersNegotiated, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnCiphersNegotiated, arginfo_TElIMAPClient_set_OnCiphersNegotiated, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnCloseConnection, arginfo_TElIMAPClient_get_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnCloseConnection, arginfo_TElIMAPClient_set_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnError, arginfo_TElIMAPClient_get_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnError, arginfo_TElIMAPClient_set_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnExtensionsReceived, arginfo_TElIMAPClient_get_OnExtensionsReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnExtensionsReceived, arginfo_TElIMAPClient_set_OnExtensionsReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnCertificateStatus, arginfo_TElIMAPClient_get_OnCertificateStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnCertificateStatus, arginfo_TElIMAPClient_set_OnCertificateStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnKeyNeeded, arginfo_TElIMAPClient_get_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnKeyNeeded, arginfo_TElIMAPClient_set_OnKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnRenegotiationRequest, arginfo_TElIMAPClient_get_OnRenegotiationRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnRenegotiationRequest, arginfo_TElIMAPClient_set_OnRenegotiationRequest, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElIMAPClient, get_OnDNSKeyNeeded, arginfo_TElIMAPClient_get_OnDNSKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnDNSKeyNeeded, arginfo_TElIMAPClient_set_OnDNSKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnDNSKeyValidate, arginfo_TElIMAPClient_get_OnDNSKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnDNSKeyValidate, arginfo_TElIMAPClient_set_OnDNSKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, get_OnDNSResolve, arginfo_TElIMAPClient_get_OnDNSResolve, ZEND_ACC_PUBLIC)
	PHP_ME(TElIMAPClient, set_OnDNSResolve, arginfo_TElIMAPClient_set_OnDNSResolve, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElIMAPClient, __construct, arginfo_TElIMAPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElIMAPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElIMAPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElIMAPClient", TElIMAPClient_methods);
	if (NULL == TElCustomSimpleSSLClient_ce_ptr)
		Register_TElCustomSimpleSSLClient(TSRMLS_C);
	TElIMAPClient_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomSimpleSSLClient_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBIMAPClient_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, ERROR_FACILITY_IMAP, SB_ERROR_FACILITY_IMAP, SB_ERROR_FACILITY_IMAP);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, ERROR_IMAP_PROTOCOL_ERROR_FLAG, SB_ERROR_IMAP_PROTOCOL_ERROR_FLAG, SB_ERROR_IMAP_PROTOCOL_ERROR_FLAG);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, SB_IMAP_ERROR_NOT_CONNECTED, SB_IMAP_ERROR_NOT_CONNECTED, SB_IMAP_ERROR_NOT_CONNECTED);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, SB_IMAP_ERROR_ALREADY_CONNECTED, SB_IMAP_ERROR_ALREADY_CONNECTED, SB_IMAP_ERROR_ALREADY_CONNECTED);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, SB_IMAP_ERROR_NO_ADDRESS, SB_IMAP_ERROR_NO_ADDRESS, SB_IMAP_ERROR_NO_ADDRESS);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, SB_IMAP_ERROR_FAILURE, SB_IMAP_ERROR_FAILURE, SB_IMAP_ERROR_FAILURE);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, SB_IMAP_ERROR_PROTOCOL, SB_IMAP_ERROR_PROTOCOL, SB_IMAP_ERROR_PROTOCOL);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, SB_IMAP_ERROR_NO_REPLY, SB_IMAP_ERROR_NO_REPLY, SB_IMAP_ERROR_NO_REPLY);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, SB_IMAP_ERROR_BAD_REPLY, SB_IMAP_ERROR_BAD_REPLY, SB_IMAP_ERROR_BAD_REPLY);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, SB_IMAP_ERROR_INVALID_LENGTH, SB_IMAP_ERROR_INVALID_LENGTH, SB_IMAP_ERROR_INVALID_LENGTH);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, SB_IMAP_ERROR_SMALL_LENGTH, SB_IMAP_ERROR_SMALL_LENGTH, SB_IMAP_ERROR_SMALL_LENGTH);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, SB_IMAP_ERROR_TOO_LONG_LINE, SB_IMAP_ERROR_TOO_LONG_LINE, SB_IMAP_ERROR_TOO_LONG_LINE);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, SB_IMAP_ERROR_TLSNOTSUPPORTED, SB_IMAP_ERROR_TLSNOTSUPPORTED, SB_IMAP_ERROR_TLSNOTSUPPORTED);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, SB_IMAP_ERROR_INVALID_STATE, SB_IMAP_ERROR_INVALID_STATE, SB_IMAP_ERROR_INVALID_STATE);
	SB_REGISTER_LONG_CONSTANT(SBIMAPClient, imapLastMessage, SB_imapLastMessage, SB_imapLastMessage);
}

void Register_SBIMAPClient_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBIMAPLogDirection", NULL);
	TSBIMAPLogDirection_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBIMAPLogDirection_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPLogDirection_ce_ptr, "imapSent", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPLogDirection_ce_ptr, "imapReceived", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBIMAPAuthorization", NULL);
	TSBIMAPAuthorization_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBIMAPAuthorization_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPAuthorization_ce_ptr, "imapLOGIN", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPAuthorization_ce_ptr, "imapSASL", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBIMAPAuthorizations", NULL);
	TSBIMAPAuthorizations_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBIMAPAuthorizations_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPAuthorizations_ce_ptr, "imapLOGIN", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPAuthorizations_ce_ptr, "imapSASL", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBIMAPAutoCAPAMode", NULL);
	TSBIMAPAutoCAPAMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBIMAPAutoCAPAMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPAutoCAPAMode_ce_ptr, "capaNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPAutoCAPAMode_ce_ptr, "capaOnConnect", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPAutoCAPAMode_ce_ptr, "capaOnLogin", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPAutoCAPAMode_ce_ptr, "capaBoth", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBIMAPState", NULL);
	TSBIMAPState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBIMAPState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPState_ce_ptr, "imapNotAuthenticated", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPState_ce_ptr, "imapAuthenticated", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPState_ce_ptr, "imapSelected", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBIMAPToken", NULL);
	TSBIMAPToken_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBIMAPToken_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapUnknownToken", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapOkToken", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapOkFinalToken", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapBadToken", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapBadFinalToken", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapNoToken", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapNoFinalToken", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapPreAuthToken", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapByeToken", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapContinueToken", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapCapabilityToken", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapListToken", 11)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapLSubToken", 12)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapStatusToken", 13)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapSearchToken", 14)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapFlagsToken", 15)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapExistsToken", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapRecentToken", 17)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapExpungeToken", 18)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapFetchToken", 19)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapUidNextToken", 20)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapUidValidToken", 21)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapUnseenToken", 22)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapReadOnlyToken", 23)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapReadWriteToken", 24)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapPermanentFlagsToken", 25)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapTrycreateToken", 26)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapAlertToken", 27)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapBadcharsetToken", 28)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPToken_ce_ptr, "imapParseToken", 29)
	
	INIT_CLASS_ENTRY(ce, "TElIMAPFetchResponseItemType", NULL);
	TElIMAPFetchResponseItemType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElIMAPFetchResponseItemType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPFetchResponseItemType_ce_ptr, "imapFetchUunknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPFetchResponseItemType_ce_ptr, "imapFetchUid", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPFetchResponseItemType_ce_ptr, "imapFetchEnvelope", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPFetchResponseItemType_ce_ptr, "imapFetchFlags", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPFetchResponseItemType_ce_ptr, "imapFetchInternaldate", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPFetchResponseItemType_ce_ptr, "imapFetchRfc822", 5)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPFetchResponseItemType_ce_ptr, "imapFetchRfc822Header", 6)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPFetchResponseItemType_ce_ptr, "imapFetchRfc822Size", 7)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPFetchResponseItemType_ce_ptr, "imapFetchRfc822Text", 8)
	
	INIT_CLASS_ENTRY(ce, "TSBIMAPStoreFlagsOperation", NULL);
	TSBIMAPStoreFlagsOperation_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBIMAPStoreFlagsOperation_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStoreFlagsOperation_ce_ptr, "imapReplaceFlags", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStoreFlagsOperation_ce_ptr, "imapAddFlags", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStoreFlagsOperation_ce_ptr, "imapRemoveFlags", 2)
	
	INIT_CLASS_ENTRY(ce, "TElIMAPMailBoxAttribute", NULL);
	TElIMAPMailBoxAttribute_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElIMAPMailBoxAttribute_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPMailBoxAttribute_ce_ptr, "imapNoSelect", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPMailBoxAttribute_ce_ptr, "imapNoInferiors", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPMailBoxAttribute_ce_ptr, "imapMarked", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPMailBoxAttribute_ce_ptr, "imapUnmarked", 3)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPMailBoxAttribute_ce_ptr, "imapHasChildren", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPMailBoxAttribute_ce_ptr, "imapHasNoChildren", 5)
	
	INIT_CLASS_ENTRY(ce, "TElIMAPMailBoxAttributes", NULL);
	TElIMAPMailBoxAttributes_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TElIMAPMailBoxAttributes_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPMailBoxAttributes_ce_ptr, "imapNoSelect", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPMailBoxAttributes_ce_ptr, "imapNoInferiors", 2)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPMailBoxAttributes_ce_ptr, "imapMarked", 4)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPMailBoxAttributes_ce_ptr, "imapUnmarked", 8)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPMailBoxAttributes_ce_ptr, "imapHasChildren", 16)
	SB_DECLARE_CLASS_LONG_CONST(TElIMAPMailBoxAttributes_ce_ptr, "imapHasNoChildren", 32)
	
	INIT_CLASS_ENTRY(ce, "TSBIMAPMessageFlag", NULL);
	TSBIMAPMessageFlag_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBIMAPMessageFlag_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlag_ce_ptr, "imapUnknownFlag", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlag_ce_ptr, "imapAnsweredFlag", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlag_ce_ptr, "imapFlaggedFlag", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlag_ce_ptr, "imapDeletedFlag", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlag_ce_ptr, "imapSeenFlag", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlag_ce_ptr, "imapDraftFlag", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlag_ce_ptr, "imapSpecialFlag", 6)
	
	INIT_CLASS_ENTRY(ce, "TSBIMAPMessageFlags", NULL);
	TSBIMAPMessageFlags_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBIMAPMessageFlags_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlags_ce_ptr, "imapUnknownFlag", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlags_ce_ptr, "imapAnsweredFlag", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlags_ce_ptr, "imapFlaggedFlag", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlags_ce_ptr, "imapDeletedFlag", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlags_ce_ptr, "imapSeenFlag", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlags_ce_ptr, "imapDraftFlag", 32)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPMessageFlags_ce_ptr, "imapSpecialFlag", 64)
	
	INIT_CLASS_ENTRY(ce, "TSBIMAPStatusItem", NULL);
	TSBIMAPStatusItem_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBIMAPStatusItem_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStatusItem_ce_ptr, "imapStatusMessages", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStatusItem_ce_ptr, "imapStatusUnseen", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStatusItem_ce_ptr, "imapStatusRecent", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStatusItem_ce_ptr, "imapStatusUidNext", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStatusItem_ce_ptr, "imapStatusUidValidity", 4)
	
	INIT_CLASS_ENTRY(ce, "TSBIMAPStatusItems", NULL);
	TSBIMAPStatusItems_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBIMAPStatusItems_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStatusItems_ce_ptr, "imapStatusMessages", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStatusItems_ce_ptr, "imapStatusUnseen", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStatusItems_ce_ptr, "imapStatusRecent", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStatusItems_ce_ptr, "imapStatusUidNext", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBIMAPStatusItems_ce_ptr, "imapStatusUidValidity", 16)
}

void Register_SBIMAPClient_Aliases(TSRMLS_D)
{
	if (NULL == TElIMAPClient_ce_ptr)
		Register_TElIMAPClient(TSRMLS_C);
	zend_register_class_alias("ElIMAPClient", TElIMAPClient_ce_ptr);
}
