#include "sboffice.h"

zend_class_entry *TElOfficeSecurityHandlerClass_ce_ptr = NULL;

zend_class_entry *TElOfficeOpenXMLSignatureView_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLSignatureView, get_SignatureHandler)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLSignatureView_get_SignatureHandler(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLCustomSignatureHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureView, set_SignatureHandler)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElOfficeOpenXMLCustomSignatureHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLSignatureView_set_SignatureHandler(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeOpenXMLCustomSignatureHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureView, get_Package)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLSignatureView_get_Package(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLPackage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureView, __construct)
{
	zval *oAPackage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAPackage, TElOfficeOpenXMLPackage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLSignatureView_Create(SBGetObjectHandle(oAPackage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeOpenXMLPackage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureView_get_SignatureHandler, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureView_set_SignatureHandler, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElOfficeOpenXMLCustomSignatureHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureView_get_Package, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureView___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, APackage, TElOfficeOpenXMLPackage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLSignatureView_methods[] = {
	PHP_ME(TElOfficeOpenXMLSignatureView, get_SignatureHandler, arginfo_TElOfficeOpenXMLSignatureView_get_SignatureHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureView, set_SignatureHandler, arginfo_TElOfficeOpenXMLSignatureView_set_SignatureHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureView, get_Package, arginfo_TElOfficeOpenXMLSignatureView_get_Package, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureView, __construct, arginfo_TElOfficeOpenXMLSignatureView___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLSignatureView(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLSignatureView_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLSignatureView", TElOfficeOpenXMLSignatureView_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOfficeOpenXMLSignatureView_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeCustomSecurityHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeCustomSecurityHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeCustomSecurityHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-728522190, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeCustomSecurityHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeCustomSecurityHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-728522190, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeCustomSecurityHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeCustomSecurityHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeCustomSecurityHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeCustomSecurityHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeCustomSecurityHandler, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeCustomSecurityHandler_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeCustomSecurityHandler, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeCustomSecurityHandler_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeCustomSecurityHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeCustomSecurityHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomSecurityHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomSecurityHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomSecurityHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomSecurityHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomSecurityHandler_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomSecurityHandler_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomSecurityHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeCustomSecurityHandler_methods[] = {
	PHP_ME(TElOfficeCustomSecurityHandler, GetName_Inst, arginfo_TElOfficeCustomSecurityHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeCustomSecurityHandler, GetName, arginfo_TElOfficeCustomSecurityHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeCustomSecurityHandler, Reset, arginfo_TElOfficeCustomSecurityHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeCustomSecurityHandler, ClassType, arginfo_TElOfficeCustomSecurityHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeCustomSecurityHandler, get_CryptoProviderManager, arginfo_TElOfficeCustomSecurityHandler_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeCustomSecurityHandler, set_CryptoProviderManager, arginfo_TElOfficeCustomSecurityHandler_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeCustomSecurityHandler, __construct, arginfo_TElOfficeCustomSecurityHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeCustomSecurityHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeCustomSecurityHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeCustomSecurityHandler", TElOfficeCustomSecurityHandler_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElOfficeCustomSecurityHandler_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeCustomEncryptionHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeCustomEncryptionHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeCustomEncryptionHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeCustomEncryptionHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeCustomEncryptionHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomEncryptionHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomEncryptionHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeCustomEncryptionHandler_methods[] = {
	PHP_ME(TElOfficeCustomEncryptionHandler, ClassType, arginfo_TElOfficeCustomEncryptionHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeCustomEncryptionHandler, __construct, arginfo_TElOfficeCustomEncryptionHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeCustomEncryptionHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeCustomEncryptionHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeCustomEncryptionHandler", TElOfficeCustomEncryptionHandler_methods);
	if (NULL == TElOfficeCustomSecurityHandler_ce_ptr)
		Register_TElOfficeCustomSecurityHandler(TSRMLS_C);
	TElOfficeCustomEncryptionHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeCustomSecurityHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeBinaryCustomEncryptionHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeBinaryCustomEncryptionHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryCustomEncryptionHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryCustomEncryptionHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryCustomEncryptionHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryCustomEncryptionHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryCustomEncryptionHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeBinaryCustomEncryptionHandler_methods[] = {
	PHP_ME(TElOfficeBinaryCustomEncryptionHandler, ClassType, arginfo_TElOfficeBinaryCustomEncryptionHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeBinaryCustomEncryptionHandler, __construct, arginfo_TElOfficeBinaryCustomEncryptionHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeBinaryCustomEncryptionHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeBinaryCustomEncryptionHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeBinaryCustomEncryptionHandler", TElOfficeBinaryCustomEncryptionHandler_methods);
	if (NULL == TElOfficeCustomEncryptionHandler_ce_ptr)
		Register_TElOfficeCustomEncryptionHandler(TSRMLS_C);
	TElOfficeBinaryCustomEncryptionHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeCustomEncryptionHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLCustomEncryptionHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLCustomEncryptionHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCustomEncryptionHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCustomEncryptionHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCustomEncryptionHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCustomEncryptionHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCustomEncryptionHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLCustomEncryptionHandler_methods[] = {
	PHP_ME(TElOfficeOpenXMLCustomEncryptionHandler, ClassType, arginfo_TElOfficeOpenXMLCustomEncryptionHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeOpenXMLCustomEncryptionHandler, __construct, arginfo_TElOfficeOpenXMLCustomEncryptionHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLCustomEncryptionHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLCustomEncryptionHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLCustomEncryptionHandler", TElOfficeOpenXMLCustomEncryptionHandler_methods);
	if (NULL == TElOfficeCustomEncryptionHandler_ce_ptr)
		Register_TElOfficeCustomEncryptionHandler(TSRMLS_C);
	TElOfficeOpenXMLCustomEncryptionHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeCustomEncryptionHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOpenOfficeCustomEncryptionHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenOfficeCustomEncryptionHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeCustomEncryptionHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeCustomEncryptionHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeCustomEncryptionHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeCustomEncryptionHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeCustomEncryptionHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenOfficeCustomEncryptionHandler_methods[] = {
	PHP_ME(TElOpenOfficeCustomEncryptionHandler, ClassType, arginfo_TElOpenOfficeCustomEncryptionHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOpenOfficeCustomEncryptionHandler, __construct, arginfo_TElOpenOfficeCustomEncryptionHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenOfficeCustomEncryptionHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenOfficeCustomEncryptionHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenOfficeCustomEncryptionHandler", TElOpenOfficeCustomEncryptionHandler_methods);
	if (NULL == TElOfficeCustomEncryptionHandler_ce_ptr)
		Register_TElOfficeCustomEncryptionHandler(TSRMLS_C);
	TElOpenOfficeCustomEncryptionHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeCustomEncryptionHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeCustomSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeCustomSignatureHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeCustomSignatureHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeCustomSignatureHandler, CompleteAsyncSign)
{
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oState, TElDCAsyncState_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeCustomSignatureHandler_CompleteAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDCAsyncState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeCustomSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeCustomSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeCustomSignatureHandler, get_IsCalculated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeCustomSignatureHandler_get_IsCalculated(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeCustomSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeCustomSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomSignatureHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomSignatureHandler_CompleteAsyncSign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, State, TElDCAsyncState, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomSignatureHandler_get_IsCalculated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeCustomSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeCustomSignatureHandler_methods[] = {
	PHP_ME(TElOfficeCustomSignatureHandler, Reset, arginfo_TElOfficeCustomSignatureHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeCustomSignatureHandler, CompleteAsyncSign, arginfo_TElOfficeCustomSignatureHandler_CompleteAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeCustomSignatureHandler, ClassType, arginfo_TElOfficeCustomSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeCustomSignatureHandler, get_IsCalculated, arginfo_TElOfficeCustomSignatureHandler_get_IsCalculated, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeCustomSignatureHandler, __construct, arginfo_TElOfficeCustomSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeCustomSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeCustomSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeCustomSignatureHandler", TElOfficeCustomSignatureHandler_methods);
	if (NULL == TElOfficeCustomSecurityHandler_ce_ptr)
		Register_TElOfficeCustomSecurityHandler(TSRMLS_C);
	TElOfficeCustomSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeCustomSecurityHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeBinaryCustomSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeBinaryCustomSignatureHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryCustomSignatureHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryCustomSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryCustomSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryCustomSignatureHandler, get_Storage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryCustomSignatureHandler_get_Storage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCompoundFileStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryCustomSignatureHandler, get_SignatureStreamEntry)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryCustomSignatureHandler_get_SignatureStreamEntry(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCompoundFileStreamEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryCustomSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryCustomSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryCustomSignatureHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryCustomSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryCustomSignatureHandler_get_Storage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryCustomSignatureHandler_get_SignatureStreamEntry, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryCustomSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeBinaryCustomSignatureHandler_methods[] = {
	PHP_ME(TElOfficeBinaryCustomSignatureHandler, Reset, arginfo_TElOfficeBinaryCustomSignatureHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryCustomSignatureHandler, ClassType, arginfo_TElOfficeBinaryCustomSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeBinaryCustomSignatureHandler, get_Storage, arginfo_TElOfficeBinaryCustomSignatureHandler_get_Storage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryCustomSignatureHandler, get_SignatureStreamEntry, arginfo_TElOfficeBinaryCustomSignatureHandler_get_SignatureStreamEntry, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryCustomSignatureHandler, __construct, arginfo_TElOfficeBinaryCustomSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeBinaryCustomSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeBinaryCustomSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeBinaryCustomSignatureHandler", TElOfficeBinaryCustomSignatureHandler_methods);
	if (NULL == TElOfficeCustomSignatureHandler_ce_ptr)
		Register_TElOfficeCustomSignatureHandler(TSRMLS_C);
	TElOfficeBinaryCustomSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeCustomSignatureHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeBinaryUnsupportedSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeBinaryUnsupportedSignatureHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeBinaryUnsupportedSignatureHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(80769874, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryUnsupportedSignatureHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeBinaryUnsupportedSignatureHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(80769874, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryUnsupportedSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryUnsupportedSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryUnsupportedSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryUnsupportedSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryUnsupportedSignatureHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryUnsupportedSignatureHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryUnsupportedSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryUnsupportedSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeBinaryUnsupportedSignatureHandler_methods[] = {
	PHP_ME(TElOfficeBinaryUnsupportedSignatureHandler, GetName_Inst, arginfo_TElOfficeBinaryUnsupportedSignatureHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryUnsupportedSignatureHandler, GetName, arginfo_TElOfficeBinaryUnsupportedSignatureHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeBinaryUnsupportedSignatureHandler, ClassType, arginfo_TElOfficeBinaryUnsupportedSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeBinaryUnsupportedSignatureHandler, __construct, arginfo_TElOfficeBinaryUnsupportedSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeBinaryUnsupportedSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeBinaryUnsupportedSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeBinaryUnsupportedSignatureHandler", TElOfficeBinaryUnsupportedSignatureHandler_methods);
	if (NULL == TElOfficeBinaryCustomSignatureHandler_ce_ptr)
		Register_TElOfficeBinaryCustomSignatureHandler(TSRMLS_C);
	TElOfficeBinaryUnsupportedSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeBinaryCustomSignatureHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeBinaryInvalidSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeBinaryInvalidSignatureHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryInvalidSignatureHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryInvalidSignatureHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeBinaryInvalidSignatureHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-347074153, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryInvalidSignatureHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeBinaryInvalidSignatureHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-347074153, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryInvalidSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryInvalidSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryInvalidSignatureHandler, get_ErrorMessage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeBinaryInvalidSignatureHandler_get_ErrorMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1572764755, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryInvalidSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryInvalidSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryInvalidSignatureHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryInvalidSignatureHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryInvalidSignatureHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryInvalidSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryInvalidSignatureHandler_get_ErrorMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryInvalidSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeBinaryInvalidSignatureHandler_methods[] = {
	PHP_ME(TElOfficeBinaryInvalidSignatureHandler, Reset, arginfo_TElOfficeBinaryInvalidSignatureHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryInvalidSignatureHandler, GetName_Inst, arginfo_TElOfficeBinaryInvalidSignatureHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryInvalidSignatureHandler, GetName, arginfo_TElOfficeBinaryInvalidSignatureHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeBinaryInvalidSignatureHandler, ClassType, arginfo_TElOfficeBinaryInvalidSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeBinaryInvalidSignatureHandler, get_ErrorMessage, arginfo_TElOfficeBinaryInvalidSignatureHandler_get_ErrorMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryInvalidSignatureHandler, __construct, arginfo_TElOfficeBinaryInvalidSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeBinaryInvalidSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeBinaryInvalidSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeBinaryInvalidSignatureHandler", TElOfficeBinaryInvalidSignatureHandler_methods);
	if (NULL == TElOfficeBinaryCustomSignatureHandler_ce_ptr)
		Register_TElOfficeBinaryCustomSignatureHandler(TSRMLS_C);
	TElOfficeBinaryInvalidSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeBinaryCustomSignatureHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLCustomSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLCustomSignatureHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLCustomSignatureHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCustomSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCustomSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCustomSignatureHandler, get_Package)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCustomSignatureHandler_get_Package(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficePackage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCustomSignatureHandler, get_SignaturePart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCustomSignatureHandler_get_SignaturePart(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficePackagePart_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCustomSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCustomSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCustomSignatureHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCustomSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCustomSignatureHandler_get_Package, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCustomSignatureHandler_get_SignaturePart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCustomSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLCustomSignatureHandler_methods[] = {
	PHP_ME(TElOfficeOpenXMLCustomSignatureHandler, Reset, arginfo_TElOfficeOpenXMLCustomSignatureHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCustomSignatureHandler, ClassType, arginfo_TElOfficeOpenXMLCustomSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeOpenXMLCustomSignatureHandler, get_Package, arginfo_TElOfficeOpenXMLCustomSignatureHandler_get_Package, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCustomSignatureHandler, get_SignaturePart, arginfo_TElOfficeOpenXMLCustomSignatureHandler_get_SignaturePart, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCustomSignatureHandler, __construct, arginfo_TElOfficeOpenXMLCustomSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLCustomSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLCustomSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLCustomSignatureHandler", TElOfficeOpenXMLCustomSignatureHandler_methods);
	if (NULL == TElOfficeCustomSignatureHandler_ce_ptr)
		Register_TElOfficeCustomSignatureHandler(TSRMLS_C);
	TElOfficeOpenXMLCustomSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeCustomSignatureHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLUnsupportedSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLUnsupportedSignatureHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLUnsupportedSignatureHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-61776900, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLUnsupportedSignatureHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLUnsupportedSignatureHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-61776900, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLUnsupportedSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLUnsupportedSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLUnsupportedSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLUnsupportedSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLUnsupportedSignatureHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLUnsupportedSignatureHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLUnsupportedSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLUnsupportedSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLUnsupportedSignatureHandler_methods[] = {
	PHP_ME(TElOfficeOpenXMLUnsupportedSignatureHandler, GetName_Inst, arginfo_TElOfficeOpenXMLUnsupportedSignatureHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLUnsupportedSignatureHandler, GetName, arginfo_TElOfficeOpenXMLUnsupportedSignatureHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeOpenXMLUnsupportedSignatureHandler, ClassType, arginfo_TElOfficeOpenXMLUnsupportedSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeOpenXMLUnsupportedSignatureHandler, __construct, arginfo_TElOfficeOpenXMLUnsupportedSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLUnsupportedSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLUnsupportedSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLUnsupportedSignatureHandler", TElOfficeOpenXMLUnsupportedSignatureHandler_methods);
	if (NULL == TElOfficeOpenXMLCustomSignatureHandler_ce_ptr)
		Register_TElOfficeOpenXMLCustomSignatureHandler(TSRMLS_C);
	TElOfficeOpenXMLUnsupportedSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLCustomSignatureHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLInvalidSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLInvalidSignatureHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLInvalidSignatureHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLInvalidSignatureHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLInvalidSignatureHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-152851199, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLInvalidSignatureHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLInvalidSignatureHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-152851199, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLInvalidSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLInvalidSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLInvalidSignatureHandler, get_ErrorMessage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLInvalidSignatureHandler_get_ErrorMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1903465388, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLInvalidSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLInvalidSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLInvalidSignatureHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLInvalidSignatureHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLInvalidSignatureHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLInvalidSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLInvalidSignatureHandler_get_ErrorMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLInvalidSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLInvalidSignatureHandler_methods[] = {
	PHP_ME(TElOfficeOpenXMLInvalidSignatureHandler, Reset, arginfo_TElOfficeOpenXMLInvalidSignatureHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLInvalidSignatureHandler, GetName_Inst, arginfo_TElOfficeOpenXMLInvalidSignatureHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLInvalidSignatureHandler, GetName, arginfo_TElOfficeOpenXMLInvalidSignatureHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeOpenXMLInvalidSignatureHandler, ClassType, arginfo_TElOfficeOpenXMLInvalidSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeOpenXMLInvalidSignatureHandler, get_ErrorMessage, arginfo_TElOfficeOpenXMLInvalidSignatureHandler_get_ErrorMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLInvalidSignatureHandler, __construct, arginfo_TElOfficeOpenXMLInvalidSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLInvalidSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLInvalidSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLInvalidSignatureHandler", TElOfficeOpenXMLInvalidSignatureHandler_methods);
	if (NULL == TElOfficeOpenXMLCustomSignatureHandler_ce_ptr)
		Register_TElOfficeOpenXMLCustomSignatureHandler(TSRMLS_C);
	TElOfficeOpenXMLInvalidSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLCustomSignatureHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOpenOfficeCustomSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenOfficeCustomSignatureHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficeCustomSignatureHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeCustomSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeCustomSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeCustomSignatureHandler, get_Package)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeCustomSignatureHandler_get_Package(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOpenOfficePackage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeCustomSignatureHandler, get_XMLElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeCustomSignatureHandler_get_XMLElement(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeCustomSignatureHandler, get_SignaturePath)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeCustomSignatureHandler_get_SignaturePath(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-82730236, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeCustomSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeCustomSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeCustomSignatureHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeCustomSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeCustomSignatureHandler_get_Package, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeCustomSignatureHandler_get_XMLElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeCustomSignatureHandler_get_SignaturePath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeCustomSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenOfficeCustomSignatureHandler_methods[] = {
	PHP_ME(TElOpenOfficeCustomSignatureHandler, Reset, arginfo_TElOpenOfficeCustomSignatureHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeCustomSignatureHandler, ClassType, arginfo_TElOpenOfficeCustomSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOpenOfficeCustomSignatureHandler, get_Package, arginfo_TElOpenOfficeCustomSignatureHandler_get_Package, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeCustomSignatureHandler, get_XMLElement, arginfo_TElOpenOfficeCustomSignatureHandler_get_XMLElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeCustomSignatureHandler, get_SignaturePath, arginfo_TElOpenOfficeCustomSignatureHandler_get_SignaturePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeCustomSignatureHandler, __construct, arginfo_TElOpenOfficeCustomSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenOfficeCustomSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenOfficeCustomSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenOfficeCustomSignatureHandler", TElOpenOfficeCustomSignatureHandler_methods);
	if (NULL == TElOfficeCustomSignatureHandler_ce_ptr)
		Register_TElOfficeCustomSignatureHandler(TSRMLS_C);
	TElOpenOfficeCustomSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeCustomSignatureHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOpenOfficeUnsupportedSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenOfficeUnsupportedSignatureHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeUnsupportedSignatureHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2082098281, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeUnsupportedSignatureHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeUnsupportedSignatureHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2082098281, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeUnsupportedSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeUnsupportedSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeUnsupportedSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeUnsupportedSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeUnsupportedSignatureHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeUnsupportedSignatureHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeUnsupportedSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeUnsupportedSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenOfficeUnsupportedSignatureHandler_methods[] = {
	PHP_ME(TElOpenOfficeUnsupportedSignatureHandler, GetName_Inst, arginfo_TElOpenOfficeUnsupportedSignatureHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeUnsupportedSignatureHandler, GetName, arginfo_TElOpenOfficeUnsupportedSignatureHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOpenOfficeUnsupportedSignatureHandler, ClassType, arginfo_TElOpenOfficeUnsupportedSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOpenOfficeUnsupportedSignatureHandler, __construct, arginfo_TElOpenOfficeUnsupportedSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenOfficeUnsupportedSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenOfficeUnsupportedSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenOfficeUnsupportedSignatureHandler", TElOpenOfficeUnsupportedSignatureHandler_methods);
	if (NULL == TElOpenOfficeCustomSignatureHandler_ce_ptr)
		Register_TElOpenOfficeCustomSignatureHandler(TSRMLS_C);
	TElOpenOfficeUnsupportedSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOpenOfficeCustomSignatureHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOpenOfficeInvalidSignatureHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenOfficeInvalidSignatureHandler, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficeInvalidSignatureHandler_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeInvalidSignatureHandler, GetName_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeInvalidSignatureHandler_GetName_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(958219278, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeInvalidSignatureHandler, GetName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeInvalidSignatureHandler_GetName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(958219278, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeInvalidSignatureHandler, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeInvalidSignatureHandler_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeInvalidSignatureHandler, get_ErrorMessage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeInvalidSignatureHandler_get_ErrorMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-839361052, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeInvalidSignatureHandler, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeInvalidSignatureHandler_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeInvalidSignatureHandler_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeInvalidSignatureHandler_GetName_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeInvalidSignatureHandler_GetName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeInvalidSignatureHandler_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeInvalidSignatureHandler_get_ErrorMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeInvalidSignatureHandler___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenOfficeInvalidSignatureHandler_methods[] = {
	PHP_ME(TElOpenOfficeInvalidSignatureHandler, Reset, arginfo_TElOpenOfficeInvalidSignatureHandler_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeInvalidSignatureHandler, GetName_Inst, arginfo_TElOpenOfficeInvalidSignatureHandler_GetName_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeInvalidSignatureHandler, GetName, arginfo_TElOpenOfficeInvalidSignatureHandler_GetName, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOpenOfficeInvalidSignatureHandler, ClassType, arginfo_TElOpenOfficeInvalidSignatureHandler_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOpenOfficeInvalidSignatureHandler, get_ErrorMessage, arginfo_TElOpenOfficeInvalidSignatureHandler_get_ErrorMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeInvalidSignatureHandler, __construct, arginfo_TElOpenOfficeInvalidSignatureHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenOfficeInvalidSignatureHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenOfficeInvalidSignatureHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenOfficeInvalidSignatureHandler", TElOpenOfficeInvalidSignatureHandler_methods);
	if (NULL == TElOpenOfficeCustomSignatureHandler_ce_ptr)
		Register_TElOpenOfficeCustomSignatureHandler(TSRMLS_C);
	TElOpenOfficeInvalidSignatureHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElOpenOfficeCustomSignatureHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeBinaryDocument_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeBinaryDocument, Open)
{
	zend_bool bOwnStream;
	zend_bool bReadOnly;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryDocument_Open(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bOwnStream) == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryDocument_Open_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bb", &oStream, TStream_ce_ptr, &bOwnStream, &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryDocument_Open_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream, (int8_t)bReadOnly) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (TStream, bool) or (TStream, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryDocument_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, Flush)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryDocument_Flush(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, DecryptTo)
{
	zval *oNewStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNewStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryDocument_DecryptTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNewStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, EncryptTo)
{
	zval *oNewStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNewStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryDocument_EncryptTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNewStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, AddSignature)
{
	zend_bool bOwnHandler;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandler, TElOfficeBinaryCustomSignatureHandler_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeBinaryDocument_AddSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oHandler, TElOfficeBinaryCustomSignatureHandler_ce_ptr, &bOwnHandler) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeBinaryDocument_AddSignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int8_t)bOwnHandler, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeBinaryCustomSignatureHandler) or (TElOfficeBinaryCustomSignatureHandler, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, RemoveSignature)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryDocument_RemoveSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, CompleteAsyncSign)
{
	zval *oHandler;
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oHandler, TElOfficeBinaryCustomSignatureHandler_ce_ptr, &oState, TElDCAsyncState_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryDocument_CompleteAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeBinaryCustomSignatureHandler, TElDCAsyncState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, get_Encryptable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeBinaryDocument_get_Encryptable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, get_Signable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeBinaryDocument_get_Signable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, get_IsEncrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeBinaryDocument_get_IsEncrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, get_IsSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeBinaryDocument_get_IsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, get_DocumentFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeDocumentFormatRaw fOutResultRaw = 0;
		SBCheckError(TElOfficeBinaryDocument_get_DocumentFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, get_DocumentType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeBinaryDocumentTypeRaw fOutResultRaw = 0;
		SBCheckError(TElOfficeBinaryDocument_get_DocumentType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, get_EncryptionHandler)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryDocument_get_EncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeCustomEncryptionHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, set_EncryptionHandler)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElOfficeCustomEncryptionHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryDocument_set_EncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeCustomEncryptionHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, get_OwnEncryptionHandler)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeBinaryDocument_get_OwnEncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, set_OwnEncryptionHandler)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElOfficeBinaryDocument_set_OwnEncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, get_SignatureHandlerCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeBinaryDocument_get_SignatureHandlerCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, get_SignatureHandlers)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryDocument_get_SignatureHandlers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeBinaryCustomSignatureHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, get_Storage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryDocument_get_Storage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCompoundFileStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeBinaryDocument, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeBinaryDocument_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_Open, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, OwnStream)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_Flush, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_DecryptTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, NewStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_EncryptTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, NewStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_AddSignature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElOfficeBinaryCustomSignatureHandler, 1)
	ZEND_ARG_INFO(0, OwnHandler)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_RemoveSignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_CompleteAsyncSign, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Handler, TElOfficeBinaryCustomSignatureHandler, 1)
	ZEND_ARG_OBJ_INFO(0, State, TElDCAsyncState, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_get_Encryptable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_get_Signable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_get_IsEncrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_get_IsSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_get_DocumentFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_get_DocumentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_get_EncryptionHandler, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_set_EncryptionHandler, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElOfficeCustomEncryptionHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_get_OwnEncryptionHandler, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_set_OwnEncryptionHandler, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_get_SignatureHandlerCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_get_SignatureHandlers, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument_get_Storage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeBinaryDocument___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeBinaryDocument_methods[] = {
	PHP_ME(TElOfficeBinaryDocument, Open, arginfo_TElOfficeBinaryDocument_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, Close, arginfo_TElOfficeBinaryDocument_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, Flush, arginfo_TElOfficeBinaryDocument_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, DecryptTo, arginfo_TElOfficeBinaryDocument_DecryptTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, EncryptTo, arginfo_TElOfficeBinaryDocument_EncryptTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, AddSignature, arginfo_TElOfficeBinaryDocument_AddSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, RemoveSignature, arginfo_TElOfficeBinaryDocument_RemoveSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, CompleteAsyncSign, arginfo_TElOfficeBinaryDocument_CompleteAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, get_Encryptable, arginfo_TElOfficeBinaryDocument_get_Encryptable, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, get_Signable, arginfo_TElOfficeBinaryDocument_get_Signable, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, get_IsEncrypted, arginfo_TElOfficeBinaryDocument_get_IsEncrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, get_IsSigned, arginfo_TElOfficeBinaryDocument_get_IsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, get_DocumentFormat, arginfo_TElOfficeBinaryDocument_get_DocumentFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, get_DocumentType, arginfo_TElOfficeBinaryDocument_get_DocumentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, get_EncryptionHandler, arginfo_TElOfficeBinaryDocument_get_EncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, set_EncryptionHandler, arginfo_TElOfficeBinaryDocument_set_EncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, get_OwnEncryptionHandler, arginfo_TElOfficeBinaryDocument_get_OwnEncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, set_OwnEncryptionHandler, arginfo_TElOfficeBinaryDocument_set_OwnEncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, get_SignatureHandlerCount, arginfo_TElOfficeBinaryDocument_get_SignatureHandlerCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, get_SignatureHandlers, arginfo_TElOfficeBinaryDocument_get_SignatureHandlers, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, get_Storage, arginfo_TElOfficeBinaryDocument_get_Storage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeBinaryDocument, __construct, arginfo_TElOfficeBinaryDocument___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeBinaryDocument(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeBinaryDocument_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeBinaryDocument", TElOfficeBinaryDocument_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOfficeBinaryDocument_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLPackage_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLPackage, Open)
{
	zend_bool bOwnStream;
	zend_bool bReadOnly;
	zval *oAPackage;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAPackage, TElOfficePackage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLPackage_Open(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAPackage TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLPackage_Open_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bOwnStream) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLPackage_Open_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bb", &oStream, TStream_ce_ptr, &bOwnStream, &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLPackage_Open_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream, (int8_t)bReadOnly) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficePackage) or (TStream) or (TStream, bool) or (TStream, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLPackage_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, Flush)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLPackage_Flush(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, AddSignature)
{
	zend_bool bOwnHandler;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandler, TElOfficeOpenXMLCustomSignatureHandler_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLPackage_AddSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oHandler, TElOfficeOpenXMLCustomSignatureHandler_ce_ptr, &bOwnHandler) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLPackage_AddSignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int8_t)bOwnHandler, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeOpenXMLCustomSignatureHandler) or (TElOfficeOpenXMLCustomSignatureHandler, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, RemoveSignature)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLPackage_RemoveSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, CompleteAsyncSign)
{
	zval *oHandler;
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oHandler, TElOfficeOpenXMLCustomSignatureHandler_ce_ptr, &oState, TElDCAsyncState_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLPackage_CompleteAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeOpenXMLCustomSignatureHandler, TElDCAsyncState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, get_SignatureHandlerCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLPackage_get_SignatureHandlerCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, get_SignatureHandlers)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLPackage_get_SignatureHandlers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLCustomSignatureHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, get_Encryptable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLPackage_get_Encryptable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, get_Signable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLPackage_get_Signable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, get_IsSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLPackage_get_IsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, get_Package)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLPackage_get_Package(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficePackage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, get_CoreProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLPackage_get_CoreProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLCoreProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, get_ThumbnailPart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLPackage_get_ThumbnailPart(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficePackagePart_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, get_OnCreateTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeCreateTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLPackage_get_OnCreateTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, set_OnCreateTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOfficeOpenXMLPackage_set_OnCreateTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOfficeCreateTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOfficeCreateTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, get_OnCloseTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeCloseTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLPackage_get_OnCloseTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, set_OnCloseTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOfficeOpenXMLPackage_set_OnCloseTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOfficeCloseTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOfficeCloseTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLPackage, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLPackage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_Open, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, APackage_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, OwnStream)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_Flush, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_AddSignature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElOfficeOpenXMLCustomSignatureHandler, 1)
	ZEND_ARG_INFO(0, OwnHandler)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_RemoveSignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_CompleteAsyncSign, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Handler, TElOfficeOpenXMLCustomSignatureHandler, 1)
	ZEND_ARG_OBJ_INFO(0, State, TElDCAsyncState, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_get_SignatureHandlerCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_get_SignatureHandlers, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_get_Encryptable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_get_Signable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_get_IsSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_get_Package, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_get_CoreProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_get_ThumbnailPart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_get_OnCreateTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_set_OnCreateTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_get_OnCloseTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage_set_OnCloseTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLPackage___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLPackage_methods[] = {
	PHP_ME(TElOfficeOpenXMLPackage, Open, arginfo_TElOfficeOpenXMLPackage_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, Close, arginfo_TElOfficeOpenXMLPackage_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, Flush, arginfo_TElOfficeOpenXMLPackage_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, AddSignature, arginfo_TElOfficeOpenXMLPackage_AddSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, RemoveSignature, arginfo_TElOfficeOpenXMLPackage_RemoveSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, CompleteAsyncSign, arginfo_TElOfficeOpenXMLPackage_CompleteAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, get_SignatureHandlerCount, arginfo_TElOfficeOpenXMLPackage_get_SignatureHandlerCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, get_SignatureHandlers, arginfo_TElOfficeOpenXMLPackage_get_SignatureHandlers, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, get_Encryptable, arginfo_TElOfficeOpenXMLPackage_get_Encryptable, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, get_Signable, arginfo_TElOfficeOpenXMLPackage_get_Signable, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, get_IsSigned, arginfo_TElOfficeOpenXMLPackage_get_IsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, get_Package, arginfo_TElOfficeOpenXMLPackage_get_Package, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, get_CoreProperties, arginfo_TElOfficeOpenXMLPackage_get_CoreProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, get_ThumbnailPart, arginfo_TElOfficeOpenXMLPackage_get_ThumbnailPart, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, get_OnCreateTemporaryStream, arginfo_TElOfficeOpenXMLPackage_get_OnCreateTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, set_OnCreateTemporaryStream, arginfo_TElOfficeOpenXMLPackage_set_OnCreateTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, get_OnCloseTemporaryStream, arginfo_TElOfficeOpenXMLPackage_get_OnCloseTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, set_OnCloseTemporaryStream, arginfo_TElOfficeOpenXMLPackage_set_OnCloseTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLPackage, __construct, arginfo_TElOfficeOpenXMLPackage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLPackage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLPackage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLPackage", TElOfficeOpenXMLPackage_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOfficeOpenXMLPackage_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLSignatureLine_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLSignatureLine, get_AdditionalSignatureInfo)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLSignatureLine_get_AdditionalSignatureInfo(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1498062659, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureLine, get_AllowComments)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLSignatureLine_get_AllowComments(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureLine, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLSignatureLine_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(808423391, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureLine, get_ImageData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOfficeOpenXMLSignatureLine_get_ImageData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1568018585, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureLine, get_SignatureProviderId)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLSignatureLine_get_SignatureProviderId(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-853137454, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureLine, get_SignatureProviderUrl)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLSignatureLine_get_SignatureProviderUrl(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(632313711, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureLine, get_ShowSignDate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLSignatureLine_get_ShowSignDate(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureLine, get_SigningInstructions)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLSignatureLine_get_SigningInstructions(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-477562722, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureLine, get_SuggestedSigner)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLSignatureLine_get_SuggestedSigner(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-236238361, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureLine, get_SuggestedSigner2)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLSignatureLine_get_SuggestedSigner2(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-163001070, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureLine, get_SuggestedSignerEmail)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLSignatureLine_get_SuggestedSignerEmail(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(881412008, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLSignatureLine, __construct)
{
	zval *oAPackage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAPackage, TElOfficeOpenXMLPackage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLSignatureLine_Create(SBGetObjectHandle(oAPackage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeOpenXMLPackage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureLine_get_AdditionalSignatureInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureLine_get_AllowComments, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureLine_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureLine_get_ImageData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureLine_get_SignatureProviderId, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureLine_get_SignatureProviderUrl, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureLine_get_ShowSignDate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureLine_get_SigningInstructions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureLine_get_SuggestedSigner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureLine_get_SuggestedSigner2, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureLine_get_SuggestedSignerEmail, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLSignatureLine___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, APackage, TElOfficeOpenXMLPackage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLSignatureLine_methods[] = {
	PHP_ME(TElOfficeOpenXMLSignatureLine, get_AdditionalSignatureInfo, arginfo_TElOfficeOpenXMLSignatureLine_get_AdditionalSignatureInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureLine, get_AllowComments, arginfo_TElOfficeOpenXMLSignatureLine_get_AllowComments, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureLine, get_ID, arginfo_TElOfficeOpenXMLSignatureLine_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureLine, get_ImageData, arginfo_TElOfficeOpenXMLSignatureLine_get_ImageData, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureLine, get_SignatureProviderId, arginfo_TElOfficeOpenXMLSignatureLine_get_SignatureProviderId, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureLine, get_SignatureProviderUrl, arginfo_TElOfficeOpenXMLSignatureLine_get_SignatureProviderUrl, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureLine, get_ShowSignDate, arginfo_TElOfficeOpenXMLSignatureLine_get_ShowSignDate, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureLine, get_SigningInstructions, arginfo_TElOfficeOpenXMLSignatureLine_get_SigningInstructions, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureLine, get_SuggestedSigner, arginfo_TElOfficeOpenXMLSignatureLine_get_SuggestedSigner, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureLine, get_SuggestedSigner2, arginfo_TElOfficeOpenXMLSignatureLine_get_SuggestedSigner2, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureLine, get_SuggestedSignerEmail, arginfo_TElOfficeOpenXMLSignatureLine_get_SuggestedSignerEmail, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLSignatureLine, __construct, arginfo_TElOfficeOpenXMLSignatureLine___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLSignatureLine(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLSignatureLine_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLSignatureLine", TElOfficeOpenXMLSignatureLine_methods);
	if (NULL == TElOfficeOpenXMLSignatureView_ce_ptr)
		Register_TElOfficeOpenXMLSignatureView(TSRMLS_C);
	TElOfficeOpenXMLSignatureLine_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLSignatureView_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLDocument_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLDocument, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLDocument_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDocument, EncryptTo)
{
	zval *oNewStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNewStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLDocument_EncryptTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNewStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDocument, get_DocumentType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeOpenXMLDocumentTypeRaw fOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLDocument_get_DocumentType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDocument, get_OfficeDocumentPart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLDocument_get_OfficeDocumentPart(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficePackagePart_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDocument, get_EncryptionHandler)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLDocument_get_EncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeCustomEncryptionHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDocument, set_EncryptionHandler)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElOfficeCustomEncryptionHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLDocument_set_EncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeCustomEncryptionHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDocument, get_OwnEncryptionHandler)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLDocument_get_OwnEncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDocument, set_OwnEncryptionHandler)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLDocument_set_OwnEncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDocument, get_SignatureLineCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLDocument_get_SignatureLineCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDocument, get_SignatureLines)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLDocument_get_SignatureLines(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLSignatureLine_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDocument, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLDocument_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDocument_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDocument_EncryptTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, NewStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDocument_get_DocumentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDocument_get_OfficeDocumentPart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDocument_get_EncryptionHandler, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDocument_set_EncryptionHandler, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElOfficeCustomEncryptionHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDocument_get_OwnEncryptionHandler, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDocument_set_OwnEncryptionHandler, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDocument_get_SignatureLineCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDocument_get_SignatureLines, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDocument___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLDocument_methods[] = {
	PHP_ME(TElOfficeOpenXMLDocument, Close, arginfo_TElOfficeOpenXMLDocument_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDocument, EncryptTo, arginfo_TElOfficeOpenXMLDocument_EncryptTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDocument, get_DocumentType, arginfo_TElOfficeOpenXMLDocument_get_DocumentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDocument, get_OfficeDocumentPart, arginfo_TElOfficeOpenXMLDocument_get_OfficeDocumentPart, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDocument, get_EncryptionHandler, arginfo_TElOfficeOpenXMLDocument_get_EncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDocument, set_EncryptionHandler, arginfo_TElOfficeOpenXMLDocument_set_EncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDocument, get_OwnEncryptionHandler, arginfo_TElOfficeOpenXMLDocument_get_OwnEncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDocument, set_OwnEncryptionHandler, arginfo_TElOfficeOpenXMLDocument_set_OwnEncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDocument, get_SignatureLineCount, arginfo_TElOfficeOpenXMLDocument_get_SignatureLineCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDocument, get_SignatureLines, arginfo_TElOfficeOpenXMLDocument_get_SignatureLines, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDocument, __construct, arginfo_TElOfficeOpenXMLDocument___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLDocument(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLDocument_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLDocument", TElOfficeOpenXMLDocument_methods);
	if (NULL == TElOfficeOpenXMLPackage_ce_ptr)
		Register_TElOfficeOpenXMLPackage(TSRMLS_C);
	TElOfficeOpenXMLDocument_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLPackage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXPSSignatureDefinition_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, get_Intent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXPSSignatureDefinition_get_Intent(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-348093941, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, set_Intent)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_set_Intent(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, get_PageURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXPSSignatureDefinition_get_PageURI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1468624881, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, set_PageURI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_set_PageURI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, get_SignBy)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXPSSignatureDefinition_get_SignBy(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-229343387, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, get_SignByUTC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_get_SignByUTC(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, set_SignByUTC)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_set_SignByUTC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, get_SigningLocation)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXPSSignatureDefinition_get_SigningLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1984133370, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, set_SigningLocation)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_set_SigningLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, get_SignerName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXPSSignatureDefinition_get_SignerName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1813850503, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, set_SignerName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_set_SignerName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, get_SpotID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXPSSignatureDefinition_get_SpotID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-264433403, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, set_SpotID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_set_SpotID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, get_SpotIDGUID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TGuid roOutResult;
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_get_SpotIDGUID(SBGetObjectHandle(getThis() TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TGuid_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TGuid) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, set_SpotIDGUID)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oValue, TGuid_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_set_SpotIDGUID(SBGetObjectHandle(getThis() TSRMLS_CC), (TGuid *)SBGetStructPointer(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TGuid)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, get_StartX)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_get_StartX(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, set_StartX)
{
	double dValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dValue) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_set_StartX(SBGetObjectHandle(getThis() TSRMLS_CC), (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, get_StartY)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_get_StartY(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, set_StartY)
{
	double dValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dValue) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_set_StartY(SBGetObjectHandle(getThis() TSRMLS_CC), (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSSignatureDefinition, __construct)
{
	zval *oAPackage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAPackage, TElOfficeOpenXMLPackage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXPSSignatureDefinition_Create(SBGetObjectHandle(oAPackage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeOpenXMLPackage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_get_Intent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_set_Intent, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_get_PageURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_set_PageURI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_get_SignBy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_get_SignByUTC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_set_SignByUTC, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_get_SigningLocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_set_SigningLocation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_get_SignerName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_set_SignerName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_get_SpotID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_set_SpotID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_get_SpotIDGUID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_set_SpotIDGUID, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TGuid, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_get_StartX, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_set_StartX, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_get_StartY, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition_set_StartY, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSSignatureDefinition___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, APackage, TElOfficeOpenXMLPackage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXPSSignatureDefinition_methods[] = {
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, get_Intent, arginfo_TElOfficeOpenXPSSignatureDefinition_get_Intent, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, set_Intent, arginfo_TElOfficeOpenXPSSignatureDefinition_set_Intent, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, get_PageURI, arginfo_TElOfficeOpenXPSSignatureDefinition_get_PageURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, set_PageURI, arginfo_TElOfficeOpenXPSSignatureDefinition_set_PageURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, get_SignBy, arginfo_TElOfficeOpenXPSSignatureDefinition_get_SignBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, get_SignByUTC, arginfo_TElOfficeOpenXPSSignatureDefinition_get_SignByUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, set_SignByUTC, arginfo_TElOfficeOpenXPSSignatureDefinition_set_SignByUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, get_SigningLocation, arginfo_TElOfficeOpenXPSSignatureDefinition_get_SigningLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, set_SigningLocation, arginfo_TElOfficeOpenXPSSignatureDefinition_set_SigningLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, get_SignerName, arginfo_TElOfficeOpenXPSSignatureDefinition_get_SignerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, set_SignerName, arginfo_TElOfficeOpenXPSSignatureDefinition_set_SignerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, get_SpotID, arginfo_TElOfficeOpenXPSSignatureDefinition_get_SpotID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, set_SpotID, arginfo_TElOfficeOpenXPSSignatureDefinition_set_SpotID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, get_SpotIDGUID, arginfo_TElOfficeOpenXPSSignatureDefinition_get_SpotIDGUID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, set_SpotIDGUID, arginfo_TElOfficeOpenXPSSignatureDefinition_set_SpotIDGUID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, get_StartX, arginfo_TElOfficeOpenXPSSignatureDefinition_get_StartX, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, set_StartX, arginfo_TElOfficeOpenXPSSignatureDefinition_set_StartX, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, get_StartY, arginfo_TElOfficeOpenXPSSignatureDefinition_get_StartY, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, set_StartY, arginfo_TElOfficeOpenXPSSignatureDefinition_set_StartY, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSSignatureDefinition, __construct, arginfo_TElOfficeOpenXPSSignatureDefinition___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXPSSignatureDefinition(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXPSSignatureDefinition_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXPSSignatureDefinition", TElOfficeOpenXPSSignatureDefinition_methods);
	if (NULL == TElOfficeOpenXMLSignatureView_ce_ptr)
		Register_TElOfficeOpenXMLSignatureView(TSRMLS_C);
	TElOfficeOpenXPSSignatureDefinition_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLSignatureView_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXPSPageContent_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXPSPageContent, get_Package)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXPSPageContent_get_Package(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLPackage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSPageContent, get_Source)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXPSPageContent_get_Source(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-118405474, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSPageContent, get_Width)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXPSPageContent_get_Width(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSPageContent, get_Height)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXPSPageContent_get_Height(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSPageContent, __construct)
{
	zval *oAPackage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAPackage, TElOfficeOpenXMLPackage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXPSPageContent_Create(SBGetObjectHandle(oAPackage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeOpenXMLPackage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSPageContent_get_Package, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSPageContent_get_Source, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSPageContent_get_Width, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSPageContent_get_Height, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSPageContent___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, APackage, TElOfficeOpenXMLPackage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXPSPageContent_methods[] = {
	PHP_ME(TElOfficeOpenXPSPageContent, get_Package, arginfo_TElOfficeOpenXPSPageContent_get_Package, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSPageContent, get_Source, arginfo_TElOfficeOpenXPSPageContent_get_Source, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSPageContent, get_Width, arginfo_TElOfficeOpenXPSPageContent_get_Width, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSPageContent, get_Height, arginfo_TElOfficeOpenXPSPageContent_get_Height, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSPageContent, __construct, arginfo_TElOfficeOpenXPSPageContent___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXPSPageContent(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXPSPageContent_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXPSPageContent", TElOfficeOpenXPSPageContent_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOfficeOpenXPSPageContent_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXPSFixedDocument_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXPSFixedDocument, get_Package)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXPSFixedDocument_get_Package(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLPackage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSFixedDocument, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXPSFixedDocument_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-806878490, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSFixedDocument, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXPSFixedDocument_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSFixedDocument, get_PageContents)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXPSFixedDocument_get_PageContents(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXPSPageContent_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSFixedDocument, __construct)
{
	zval *oAPackage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAPackage, TElOfficeOpenXMLPackage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXPSFixedDocument_Create(SBGetObjectHandle(oAPackage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeOpenXMLPackage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSFixedDocument_get_Package, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSFixedDocument_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSFixedDocument_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSFixedDocument_get_PageContents, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSFixedDocument___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, APackage, TElOfficeOpenXMLPackage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXPSFixedDocument_methods[] = {
	PHP_ME(TElOfficeOpenXPSFixedDocument, get_Package, arginfo_TElOfficeOpenXPSFixedDocument_get_Package, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSFixedDocument, get_URI, arginfo_TElOfficeOpenXPSFixedDocument_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSFixedDocument, get_Count, arginfo_TElOfficeOpenXPSFixedDocument_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSFixedDocument, get_PageContents, arginfo_TElOfficeOpenXPSFixedDocument_get_PageContents, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSFixedDocument, __construct, arginfo_TElOfficeOpenXPSFixedDocument___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXPSFixedDocument(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXPSFixedDocument_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXPSFixedDocument", TElOfficeOpenXPSFixedDocument_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOfficeOpenXPSFixedDocument_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXPSDocument_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXPSDocument, AddSignatureDefinition)
{
	char *sIntent;
	char *sPageURI;
	char *sSignerLocation;
	char *sSignerName;
	double dStartX;
	double dStartY;
	int sIntent_len;
	int sPageURI_len;
	int sSignerLocation_len;
	int sSignerName_len;
	zval *dtSignBy;
	zval *oSigDef;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO", &sIntent, &sIntent_len, &sSignerName, &sSignerName_len, &sSignerLocation, &sSignerLocation_len, &dtSignBy, php_date_get_date_ce()) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXPSDocument_AddSignatureDefinition(SBGetObjectHandle(getThis() TSRMLS_CC), sIntent, (int32_t)sIntent_len, sSignerName, (int32_t)sSignerName_len, sSignerLocation, (int32_t)sSignerLocation_len, SBGetDateTime(dtSignBy TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssOsdd", &sIntent, &sIntent_len, &sSignerName, &sSignerName_len, &sSignerLocation, &sSignerLocation_len, &dtSignBy, php_date_get_date_ce(), &sPageURI, &sPageURI_len, &dStartX, &dStartY) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXPSDocument_AddSignatureDefinition_1(SBGetObjectHandle(getThis() TSRMLS_CC), sIntent, (int32_t)sIntent_len, sSignerName, (int32_t)sSignerName_len, sSignerLocation, (int32_t)sSignerLocation_len, SBGetDateTime(dtSignBy TSRMLS_CC), sPageURI, (int32_t)sPageURI_len, (double)dStartX, (double)dStartY, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSigDef, TElOfficeOpenXPSSignatureDefinition_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXPSDocument_AddSignatureDefinition_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigDef TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, string, DateTime) or (string, string, string, DateTime, string, double, double) or (TElOfficeOpenXPSSignatureDefinition)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSDocument, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXPSDocument_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSDocument, get_FixedDocumentCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXPSDocument_get_FixedDocumentCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSDocument, get_SignatureDefinitionCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXPSDocument_get_SignatureDefinitionCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSDocument, get_FixedDocuments)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXPSDocument_get_FixedDocuments(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXPSFixedDocument_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSDocument, get_SignatureDefinitions)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXPSDocument_get_SignatureDefinitions(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXPSSignatureDefinition_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXPSDocument, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXPSDocument_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSDocument_AddSignatureDefinition, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Intent_or_SigDef, 0, 1)
	ZEND_ARG_INFO(0, SignerName)
	ZEND_ARG_INFO(0, SignerLocation)
	ZEND_ARG_OBJ_INFO(0, SignBy, DateTime, 0)
	ZEND_ARG_INFO(0, PageURI)
	ZEND_ARG_INFO(0, StartX)
	ZEND_ARG_INFO(0, StartY)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSDocument_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSDocument_get_FixedDocumentCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSDocument_get_SignatureDefinitionCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSDocument_get_FixedDocuments, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSDocument_get_SignatureDefinitions, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXPSDocument___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXPSDocument_methods[] = {
	PHP_ME(TElOfficeOpenXPSDocument, AddSignatureDefinition, arginfo_TElOfficeOpenXPSDocument_AddSignatureDefinition, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSDocument, Close, arginfo_TElOfficeOpenXPSDocument_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSDocument, get_FixedDocumentCount, arginfo_TElOfficeOpenXPSDocument_get_FixedDocumentCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSDocument, get_SignatureDefinitionCount, arginfo_TElOfficeOpenXPSDocument_get_SignatureDefinitionCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSDocument, get_FixedDocuments, arginfo_TElOfficeOpenXPSDocument_get_FixedDocuments, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSDocument, get_SignatureDefinitions, arginfo_TElOfficeOpenXPSDocument_get_SignatureDefinitions, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXPSDocument, __construct, arginfo_TElOfficeOpenXPSDocument___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXPSDocument(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXPSDocument_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXPSDocument", TElOfficeOpenXPSDocument_methods);
	if (NULL == TElOfficeOpenXMLPackage_ce_ptr)
		Register_TElOfficeOpenXMLPackage(TSRMLS_C);
	TElOfficeOpenXPSDocument_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLPackage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOpenOfficeDocument_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenOfficeDocument, Open)
{
	long l8StreamOffset;
	zend_bool bOwnStream;
	zend_bool bReadOnly;
	zval *oAPackage;
	zval *oStream;
	zval *oZipReader;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAPackage, TElOpenOfficePackage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_Open(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAPackage TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_Open_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bOwnStream) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_Open_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bb", &oStream, TStream_ce_ptr, &bOwnStream, &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_Open_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream, (int8_t)bReadOnly) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lbbO!", &oStream, TStream_ce_ptr, &l8StreamOffset, &bOwnStream, &bReadOnly, &oZipReader, TElZipReader_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_Open_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int64_t)l8StreamOffset, (int8_t)bOwnStream, (int8_t)bReadOnly, SBGetObjectHandle(oZipReader TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOpenOfficePackage) or (TStream) or (TStream, bool) or (TStream, bool, bool) or (TStream, integer, bool, bool, TElZipReader)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, Flush)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_Flush(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, DecryptTo)
{
	zval *oNewStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNewStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_DecryptTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNewStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, EncryptTo)
{
	zval *oNewStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNewStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_EncryptTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNewStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, AddSignature)
{
	zend_bool bOwnHandler;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandler, TElOpenOfficeCustomSignatureHandler_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOpenOfficeDocument_AddSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oHandler, TElOpenOfficeCustomSignatureHandler_ce_ptr, &bOwnHandler) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOpenOfficeDocument_AddSignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int8_t)bOwnHandler, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOpenOfficeCustomSignatureHandler) or (TElOpenOfficeCustomSignatureHandler, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, RemoveSignature)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_RemoveSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, CompleteAsyncSign)
{
	zval *oHandler;
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oHandler, TElOpenOfficeCustomSignatureHandler_ce_ptr, &oState, TElDCAsyncState_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_CompleteAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOpenOfficeCustomSignatureHandler, TElDCAsyncState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, get_DocumentType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOpenOfficeDocumentTypeRaw fOutResultRaw = 0;
		SBCheckError(TElOpenOfficeDocument_get_DocumentType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, get_Encryptable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOpenOfficeDocument_get_Encryptable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, get_Signable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOpenOfficeDocument_get_Signable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, get_IsEncrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOpenOfficeDocument_get_IsEncrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, get_IsSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOpenOfficeDocument_get_IsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, get_EncryptionHandler)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeDocument_get_EncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeCustomEncryptionHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, set_EncryptionHandler)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElOfficeCustomEncryptionHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_set_EncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeCustomEncryptionHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, get_OwnEncryptionHandler)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOpenOfficeDocument_get_OwnEncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, set_OwnEncryptionHandler)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeDocument_set_OwnEncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, get_SignatureHandlerCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOpenOfficeDocument_get_SignatureHandlerCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, get_SignatureHandlers)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeDocument_get_SignatureHandlers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOpenOfficeCustomSignatureHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, get_Package)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeDocument_get_Package(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOpenOfficePackage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, get_OnCreateTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeCreateTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOpenOfficeDocument_get_OnCreateTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, set_OnCreateTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOpenOfficeDocument_set_OnCreateTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOfficeCreateTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOfficeCreateTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, get_OnCloseTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeCloseTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOpenOfficeDocument_get_OnCloseTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, set_OnCloseTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOpenOfficeDocument_set_OnCloseTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOfficeCloseTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOfficeCloseTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeDocument, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeDocument_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_Open, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, APackage_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, OwnStream_or_StreamOffset)
	ZEND_ARG_INFO(0, ReadOnly_or_OwnStream)
	ZEND_ARG_INFO(0, ReadOnly)
	ZEND_ARG_OBJ_INFO(0, ZipReader, TElZipReader, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_Flush, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_DecryptTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, NewStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_EncryptTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, NewStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_AddSignature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElOpenOfficeCustomSignatureHandler, 1)
	ZEND_ARG_INFO(0, OwnHandler)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_RemoveSignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_CompleteAsyncSign, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Handler, TElOpenOfficeCustomSignatureHandler, 1)
	ZEND_ARG_OBJ_INFO(0, State, TElDCAsyncState, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_get_DocumentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_get_Encryptable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_get_Signable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_get_IsEncrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_get_IsSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_get_EncryptionHandler, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_set_EncryptionHandler, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElOfficeCustomEncryptionHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_get_OwnEncryptionHandler, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_set_OwnEncryptionHandler, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_get_SignatureHandlerCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_get_SignatureHandlers, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_get_Package, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_get_OnCreateTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_set_OnCreateTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_get_OnCloseTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument_set_OnCloseTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeDocument___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenOfficeDocument_methods[] = {
	PHP_ME(TElOpenOfficeDocument, Open, arginfo_TElOpenOfficeDocument_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, Close, arginfo_TElOpenOfficeDocument_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, Flush, arginfo_TElOpenOfficeDocument_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, DecryptTo, arginfo_TElOpenOfficeDocument_DecryptTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, EncryptTo, arginfo_TElOpenOfficeDocument_EncryptTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, AddSignature, arginfo_TElOpenOfficeDocument_AddSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, RemoveSignature, arginfo_TElOpenOfficeDocument_RemoveSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, CompleteAsyncSign, arginfo_TElOpenOfficeDocument_CompleteAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, get_DocumentType, arginfo_TElOpenOfficeDocument_get_DocumentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, get_Encryptable, arginfo_TElOpenOfficeDocument_get_Encryptable, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, get_Signable, arginfo_TElOpenOfficeDocument_get_Signable, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, get_IsEncrypted, arginfo_TElOpenOfficeDocument_get_IsEncrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, get_IsSigned, arginfo_TElOpenOfficeDocument_get_IsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, get_EncryptionHandler, arginfo_TElOpenOfficeDocument_get_EncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, set_EncryptionHandler, arginfo_TElOpenOfficeDocument_set_EncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, get_OwnEncryptionHandler, arginfo_TElOpenOfficeDocument_get_OwnEncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, set_OwnEncryptionHandler, arginfo_TElOpenOfficeDocument_set_OwnEncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, get_SignatureHandlerCount, arginfo_TElOpenOfficeDocument_get_SignatureHandlerCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, get_SignatureHandlers, arginfo_TElOpenOfficeDocument_get_SignatureHandlers, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, get_Package, arginfo_TElOpenOfficeDocument_get_Package, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, get_OnCreateTemporaryStream, arginfo_TElOpenOfficeDocument_get_OnCreateTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, set_OnCreateTemporaryStream, arginfo_TElOpenOfficeDocument_set_OnCreateTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, get_OnCloseTemporaryStream, arginfo_TElOpenOfficeDocument_get_OnCloseTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, set_OnCloseTemporaryStream, arginfo_TElOpenOfficeDocument_set_OnCloseTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeDocument, __construct, arginfo_TElOpenOfficeDocument___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenOfficeDocument(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenOfficeDocument_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenOfficeDocument", TElOpenOfficeDocument_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOpenOfficeDocument_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeDocument_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeDocument, Open)
{
	char *sFileName;
	int sFileName_len;
	zend_bool bOwnStream;
	zend_bool bReadOnly;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TElOfficeDocument_Open(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sFileName, &sFileName_len, &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElOfficeDocument_Open_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int8_t)bReadOnly) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeDocument_Open_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bOwnStream) == SUCCESS)
	{
		SBCheckError(TElOfficeDocument_Open_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bb", &oStream, TStream_ce_ptr, &bOwnStream, &bReadOnly) == SUCCESS)
	{
		SBCheckError(TElOfficeDocument_Open_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bOwnStream, (int8_t)bReadOnly) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, bool) or (TStream) or (TStream, bool) or (TStream, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeDocument_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, Flush)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeDocument_Flush(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, DecryptTo)
{
	zval *oNewStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNewStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeDocument_DecryptTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNewStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, EncryptTo)
{
	zval *oNewStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNewStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeDocument_EncryptTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNewStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, AddSignature)
{
	zend_bool bOwnHandler;
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandler, TElOfficeCustomSignatureHandler_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeDocument_AddSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oHandler, TElOfficeCustomSignatureHandler_ce_ptr, &bOwnHandler) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeDocument_AddSignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int8_t)bOwnHandler, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeCustomSignatureHandler) or (TElOfficeCustomSignatureHandler, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, RemoveSignature)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOfficeDocument_RemoveSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, CompleteAsyncSign)
{
	zval *oHandler;
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oHandler, TElOfficeCustomSignatureHandler_ce_ptr, &oState, TElDCAsyncState_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeDocument_CompleteAsyncSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeCustomSignatureHandler, TElDCAsyncState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_DocumentFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeDocumentFormatRaw fOutResultRaw = 0;
		SBCheckError(TElOfficeDocument_get_DocumentFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_IsEncrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeDocument_get_IsEncrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_IsSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeDocument_get_IsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_Encryptable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeDocument_get_Encryptable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_Signable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeDocument_get_Signable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_SignatureHandlerCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeDocument_get_SignatureHandlerCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_SignatureHandlers)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeDocument_get_SignatureHandlers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeCustomSignatureHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_BinaryDocument)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeDocument_get_BinaryDocument(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeBinaryDocument_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_OpenXMLDocument)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeDocument_get_OpenXMLDocument(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLDocument_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_OpenXPSDocument)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeDocument_get_OpenXPSDocument(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXPSDocument_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_OpenDocument)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeDocument_get_OpenDocument(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOpenOfficeDocument_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_EncryptionHandler)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeDocument_get_EncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeCustomEncryptionHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, set_EncryptionHandler)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElOfficeCustomEncryptionHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeDocument_set_EncryptionHandler(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeCustomEncryptionHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_OnCreateTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeCreateTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOfficeDocument_get_OnCreateTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, set_OnCreateTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOfficeDocument_set_OnCreateTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOfficeCreateTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOfficeCreateTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, get_OnCloseTemporaryStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeCloseTemporaryStreamEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElOfficeDocument_get_OnCloseTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, set_OnCloseTemporaryStream)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElOfficeDocument_set_OnCloseTemporaryStream(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOfficeCloseTemporaryStreamEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOfficeCloseTemporaryStreamEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeDocument, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeDocument_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_Open, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FileName_or_Stream, 0, 1)
	ZEND_ARG_INFO(0, ReadOnly_or_OwnStream)
	ZEND_ARG_INFO(0, ReadOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_Flush, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_DecryptTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, NewStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_EncryptTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, NewStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_AddSignature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Handler, TElOfficeCustomSignatureHandler, 1)
	ZEND_ARG_INFO(0, OwnHandler)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_RemoveSignature, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_CompleteAsyncSign, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Handler, TElOfficeCustomSignatureHandler, 1)
	ZEND_ARG_OBJ_INFO(0, State, TElDCAsyncState, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_DocumentFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_IsEncrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_IsSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_Encryptable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_Signable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_SignatureHandlerCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_SignatureHandlers, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_BinaryDocument, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_OpenXMLDocument, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_OpenXPSDocument, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_OpenDocument, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_EncryptionHandler, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_set_EncryptionHandler, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElOfficeCustomEncryptionHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_OnCreateTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_set_OnCreateTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_get_OnCloseTemporaryStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument_set_OnCloseTemporaryStream, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeDocument___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeDocument_methods[] = {
	PHP_ME(TElOfficeDocument, Open, arginfo_TElOfficeDocument_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, Close, arginfo_TElOfficeDocument_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, Flush, arginfo_TElOfficeDocument_Flush, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, DecryptTo, arginfo_TElOfficeDocument_DecryptTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, EncryptTo, arginfo_TElOfficeDocument_EncryptTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, AddSignature, arginfo_TElOfficeDocument_AddSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, RemoveSignature, arginfo_TElOfficeDocument_RemoveSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, CompleteAsyncSign, arginfo_TElOfficeDocument_CompleteAsyncSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_DocumentFormat, arginfo_TElOfficeDocument_get_DocumentFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_IsEncrypted, arginfo_TElOfficeDocument_get_IsEncrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_IsSigned, arginfo_TElOfficeDocument_get_IsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_Encryptable, arginfo_TElOfficeDocument_get_Encryptable, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_Signable, arginfo_TElOfficeDocument_get_Signable, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_SignatureHandlerCount, arginfo_TElOfficeDocument_get_SignatureHandlerCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_SignatureHandlers, arginfo_TElOfficeDocument_get_SignatureHandlers, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_BinaryDocument, arginfo_TElOfficeDocument_get_BinaryDocument, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_OpenXMLDocument, arginfo_TElOfficeDocument_get_OpenXMLDocument, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_OpenXPSDocument, arginfo_TElOfficeDocument_get_OpenXPSDocument, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_OpenDocument, arginfo_TElOfficeDocument_get_OpenDocument, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_EncryptionHandler, arginfo_TElOfficeDocument_get_EncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, set_EncryptionHandler, arginfo_TElOfficeDocument_set_EncryptionHandler, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_OnCreateTemporaryStream, arginfo_TElOfficeDocument_get_OnCreateTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, set_OnCreateTemporaryStream, arginfo_TElOfficeDocument_set_OnCreateTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, get_OnCloseTemporaryStream, arginfo_TElOfficeDocument_get_OnCloseTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, set_OnCloseTemporaryStream, arginfo_TElOfficeDocument_set_OnCloseTemporaryStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeDocument, __construct, arginfo_TElOfficeDocument___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeDocument(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeDocument_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeDocument", TElOfficeDocument_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElOfficeDocument_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBOffice, RegisterSecurityHandler)
{
	zval *oHandlerClass;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandlerClass, TElOfficeSecurityHandlerClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBOffice_RegisterSecurityHandler(SBGetObjectHandle(oHandlerClass TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeSecurityHandlerClass)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOffice, UnregisterSecurityHandler)
{
	zval *oHandlerClass;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandlerClass, TElOfficeSecurityHandlerClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBOffice_UnregisterSecurityHandler(SBGetObjectHandle(oHandlerClass TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeSecurityHandlerClass)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOffice, DocumentFormatToString)
{
	long fDocumentFormat;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fDocumentFormat) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOffice_DocumentFormatToString((TSBOfficeDocumentFormatRaw)fDocumentFormat, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(810234296, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOffice, BinaryDocumentTypeToString)
{
	long fDocumentType;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fDocumentType) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOffice_BinaryDocumentTypeToString((TSBOfficeBinaryDocumentTypeRaw)fDocumentType, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1115096248, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOffice, OpenXMLDocumentTypeToString)
{
	long fDocumentType;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fDocumentType) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOffice_OpenXMLDocumentTypeToString((TSBOfficeOpenXMLDocumentTypeRaw)fDocumentType, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1764667792, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOffice, OpenDocumentTypeToString)
{
	long fDocumentType;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fDocumentType) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOffice_OpenDocumentTypeToString((TSBOpenOfficeDocumentTypeRaw)fDocumentType, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1904181607, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOffice, IsSharedWorkbook)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElCompoundFileStorage_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBOffice_IsSharedWorkbook(SBGetObjectHandle(oStorage TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCompoundFileStorage)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOffice, Initialize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBOffice_Initialize() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBOffice_Aliases(TSRMLS_D)
{
	TElOfficeSecurityHandlerClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TElOfficeSecurityHandlerClass", TElOfficeSecurityHandlerClass_ce_ptr);
}

