#include "sbofficexmlcore.h"

zend_class_entry *TSBOfficeOpenXMLTargetMode_ce_ptr = NULL;

zend_class_entry *TElOfficeOpenXMLElement_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLElement, get_IsModified)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLElement_get_IsModified(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLElement, set_IsModified)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLElement_set_IsModified(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLElement_get_IsModified, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLElement_set_IsModified, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLElement_methods[] = {
	PHP_ME(TElOfficeOpenXMLElement, Clear, arginfo_TElOfficeOpenXMLElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLElement, get_IsModified, arginfo_TElOfficeOpenXMLElement_get_IsModified, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLElement, set_IsModified, arginfo_TElOfficeOpenXMLElement_set_IsModified, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLElement, __construct, arginfo_TElOfficeOpenXMLElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLElement", TElOfficeOpenXMLElement_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElOfficeOpenXMLElement_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLRelationship_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLRelationship, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationship_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationship, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationship_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationship, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationship_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationship_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationship, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLRelationship_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1988139510, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationship, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationship_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationship, get_RelationshipType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLRelationship_get_RelationshipType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(658718039, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationship, set_RelationshipType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationship_set_RelationshipType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationship, get_Target)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLRelationship_get_Target(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1778460431, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationship, set_Target)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationship_set_Target(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationship, get_TargetMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOfficeOpenXMLTargetModeRaw fOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLRelationship_get_TargetMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationship, set_TargetMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationship_set_TargetMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBOfficeOpenXMLTargetModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationship, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationship_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationship_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationship_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationship_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationship_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationship_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationship_get_RelationshipType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationship_set_RelationshipType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationship_get_Target, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationship_set_Target, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationship_get_TargetMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationship_set_TargetMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationship___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLRelationship_methods[] = {
	PHP_ME(TElOfficeOpenXMLRelationship, Clear, arginfo_TElOfficeOpenXMLRelationship_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationship, LoadFromXML, arginfo_TElOfficeOpenXMLRelationship_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationship, SaveToXML, arginfo_TElOfficeOpenXMLRelationship_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationship, get_ID, arginfo_TElOfficeOpenXMLRelationship_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationship, set_ID, arginfo_TElOfficeOpenXMLRelationship_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationship, get_RelationshipType, arginfo_TElOfficeOpenXMLRelationship_get_RelationshipType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationship, set_RelationshipType, arginfo_TElOfficeOpenXMLRelationship_set_RelationshipType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationship, get_Target, arginfo_TElOfficeOpenXMLRelationship_get_Target, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationship, set_Target, arginfo_TElOfficeOpenXMLRelationship_set_Target, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationship, get_TargetMode, arginfo_TElOfficeOpenXMLRelationship_get_TargetMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationship, set_TargetMode, arginfo_TElOfficeOpenXMLRelationship_set_TargetMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationship, __construct, arginfo_TElOfficeOpenXMLRelationship___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLRelationship(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLRelationship_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLRelationship", TElOfficeOpenXMLRelationship_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOfficeOpenXMLRelationship_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLRelationships_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, Add)
{
	char *sID;
	char *sRelationshipType;
	char *sTarget;
	int sID_len;
	int sRelationshipType_len;
	int sTarget_len;
	zval *oARelationship;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oARelationship, TElOfficeOpenXMLRelationship_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLRelationships_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oARelationship TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sID, &sID_len, &sTarget, &sTarget_len, &sRelationshipType, &sRelationshipType_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLRelationships_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), sID, (int32_t)sID_len, sTarget, (int32_t)sTarget_len, sRelationshipType, (int32_t)sRelationshipType_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeOpenXMLRelationship) or (string, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, Insert)
{
	long l4Index;
	zval *oARelationship;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oARelationship, TElOfficeOpenXMLRelationship_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationships_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oARelationship TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElOfficeOpenXMLRelationship)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationships_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationships_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, CreateRelationship)
{
	char *sID;
	char *sRelationshipType;
	char *sTarget;
	int sID_len;
	int sRelationshipType_len;
	int sTarget_len;
	long fTargetMode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slss", &sTarget, &sTarget_len, &fTargetMode, &sRelationshipType, &sRelationshipType_len, &sID, &sID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationships_CreateRelationship(SBGetObjectHandle(getThis() TSRMLS_CC), sTarget, (int32_t)sTarget_len, (TSBOfficeOpenXMLTargetModeRaw)fTargetMode, sRelationshipType, (int32_t)sRelationshipType_len, sID, (int32_t)sID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLRelationship_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, GetRelationshipById)
{
	char *sID;
	int sID_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sID, &sID_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationships_GetRelationshipById(SBGetObjectHandle(getThis() TSRMLS_CC), sID, (int32_t)sID_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLRelationship_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, GetRelationshipByType)
{
	char *sRelType;
	int sRelType_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sRelType, &sRelType_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationships_GetRelationshipByType(SBGetObjectHandle(getThis() TSRMLS_CC), sRelType, (int32_t)sRelType_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLRelationship_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, SortRelationshipsById)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationships_SortRelationshipsById(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationships_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationships_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationships_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLRelationships_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, get_Relationships)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationships_get_Relationships(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLRelationship_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationships, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationships_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ARelationship_or_ID, 0, 1)
	ZEND_ARG_INFO(0, Target)
	ZEND_ARG_INFO(0, RelationshipType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, ARelationship, TElOfficeOpenXMLRelationship, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships_CreateRelationship, 0, 0, 4)
	ZEND_ARG_INFO(0, Target)
	ZEND_ARG_INFO(0, TargetMode)
	ZEND_ARG_INFO(0, RelationshipType)
	ZEND_ARG_INFO(0, ID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships_GetRelationshipById, 0, 0, 1)
	ZEND_ARG_INFO(0, ID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships_GetRelationshipByType, 0, 0, 1)
	ZEND_ARG_INFO(0, RelType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships_SortRelationshipsById, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships_get_Relationships, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationships___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLRelationships_methods[] = {
	PHP_ME(TElOfficeOpenXMLRelationships, Add, arginfo_TElOfficeOpenXMLRelationships_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationships, Insert, arginfo_TElOfficeOpenXMLRelationships_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationships, Delete, arginfo_TElOfficeOpenXMLRelationships_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationships, Clear, arginfo_TElOfficeOpenXMLRelationships_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationships, CreateRelationship, arginfo_TElOfficeOpenXMLRelationships_CreateRelationship, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationships, GetRelationshipById, arginfo_TElOfficeOpenXMLRelationships_GetRelationshipById, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationships, GetRelationshipByType, arginfo_TElOfficeOpenXMLRelationships_GetRelationshipByType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationships, SortRelationshipsById, arginfo_TElOfficeOpenXMLRelationships_SortRelationshipsById, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationships, LoadFromXML, arginfo_TElOfficeOpenXMLRelationships_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationships, SaveToXML, arginfo_TElOfficeOpenXMLRelationships_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationships, get_Count, arginfo_TElOfficeOpenXMLRelationships_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationships, get_Relationships, arginfo_TElOfficeOpenXMLRelationships_get_Relationships, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationships, __construct, arginfo_TElOfficeOpenXMLRelationships___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLRelationships(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLRelationships_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLRelationships", TElOfficeOpenXMLRelationships_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOfficeOpenXMLRelationships_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLDefault_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLDefault, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLDefault_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefault, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLDefault_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefault, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLDefault_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLDefault_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefault, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLDefault_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-578014713, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefault, set_ContentType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLDefault_set_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefault, get_Extension)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLDefault_get_Extension(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2136707027, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefault, set_Extension)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLDefault_set_Extension(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefault, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLDefault_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefault_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefault_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefault_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefault_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefault_set_ContentType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefault_get_Extension, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefault_set_Extension, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefault___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLDefault_methods[] = {
	PHP_ME(TElOfficeOpenXMLDefault, Clear, arginfo_TElOfficeOpenXMLDefault_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefault, LoadFromXML, arginfo_TElOfficeOpenXMLDefault_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefault, SaveToXML, arginfo_TElOfficeOpenXMLDefault_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefault, get_ContentType, arginfo_TElOfficeOpenXMLDefault_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefault, set_ContentType, arginfo_TElOfficeOpenXMLDefault_set_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefault, get_Extension, arginfo_TElOfficeOpenXMLDefault_get_Extension, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefault, set_Extension, arginfo_TElOfficeOpenXMLDefault_set_Extension, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefault, __construct, arginfo_TElOfficeOpenXMLDefault___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLDefault(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLDefault_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLDefault", TElOfficeOpenXMLDefault_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOfficeOpenXMLDefault_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLDefaultList_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLDefaultList, Add)
{
	zval *oADefault;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oADefault, TElOfficeOpenXMLDefault_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLDefaultList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oADefault TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeOpenXMLDefault)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefaultList, Insert)
{
	long l4Index;
	zval *oADefault;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oADefault, TElOfficeOpenXMLDefault_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLDefaultList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oADefault TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElOfficeOpenXMLDefault)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefaultList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLDefaultList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefaultList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLDefaultList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefaultList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLDefaultList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefaultList, get_DefaultItems)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLDefaultList_get_DefaultItems(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLDefault_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLDefaultList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLDefaultList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefaultList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ADefault, TElOfficeOpenXMLDefault, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefaultList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, ADefault, TElOfficeOpenXMLDefault, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefaultList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefaultList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefaultList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefaultList_get_DefaultItems, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLDefaultList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLDefaultList_methods[] = {
	PHP_ME(TElOfficeOpenXMLDefaultList, Add, arginfo_TElOfficeOpenXMLDefaultList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefaultList, Insert, arginfo_TElOfficeOpenXMLDefaultList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefaultList, Delete, arginfo_TElOfficeOpenXMLDefaultList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefaultList, Clear, arginfo_TElOfficeOpenXMLDefaultList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefaultList, get_Count, arginfo_TElOfficeOpenXMLDefaultList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefaultList, get_DefaultItems, arginfo_TElOfficeOpenXMLDefaultList_get_DefaultItems, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLDefaultList, __construct, arginfo_TElOfficeOpenXMLDefaultList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLDefaultList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLDefaultList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLDefaultList", TElOfficeOpenXMLDefaultList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOfficeOpenXMLDefaultList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLOverride_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLOverride, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLOverride_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverride, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLOverride_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverride, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLOverride_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLOverride_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverride, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLOverride_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1381049018, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverride, set_ContentType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLOverride_set_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverride, get_PartName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLOverride_get_PartName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1395948497, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverride, set_PartName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLOverride_set_PartName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverride, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLOverride_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverride_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverride_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverride_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverride_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverride_set_ContentType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverride_get_PartName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverride_set_PartName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverride___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLOverride_methods[] = {
	PHP_ME(TElOfficeOpenXMLOverride, Clear, arginfo_TElOfficeOpenXMLOverride_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverride, LoadFromXML, arginfo_TElOfficeOpenXMLOverride_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverride, SaveToXML, arginfo_TElOfficeOpenXMLOverride_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverride, get_ContentType, arginfo_TElOfficeOpenXMLOverride_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverride, set_ContentType, arginfo_TElOfficeOpenXMLOverride_set_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverride, get_PartName, arginfo_TElOfficeOpenXMLOverride_get_PartName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverride, set_PartName, arginfo_TElOfficeOpenXMLOverride_set_PartName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverride, __construct, arginfo_TElOfficeOpenXMLOverride___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLOverride(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLOverride_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLOverride", TElOfficeOpenXMLOverride_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOfficeOpenXMLOverride_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLOverrideList_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLOverrideList, Add)
{
	zval *oAOverride;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOverride, TElOfficeOpenXMLOverride_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLOverrideList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAOverride TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeOpenXMLOverride)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverrideList, Insert)
{
	long l4Index;
	zval *oAOverride;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAOverride, TElOfficeOpenXMLOverride_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLOverrideList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAOverride TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElOfficeOpenXMLOverride)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverrideList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLOverrideList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverrideList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLOverrideList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverrideList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLOverrideList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverrideList, get_OverrideItems)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLOverrideList_get_OverrideItems(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLOverride_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLOverrideList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLOverrideList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverrideList_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOverride, TElOfficeOpenXMLOverride, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverrideList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AOverride, TElOfficeOpenXMLOverride, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverrideList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverrideList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverrideList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverrideList_get_OverrideItems, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLOverrideList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLOverrideList_methods[] = {
	PHP_ME(TElOfficeOpenXMLOverrideList, Add, arginfo_TElOfficeOpenXMLOverrideList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverrideList, Insert, arginfo_TElOfficeOpenXMLOverrideList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverrideList, Delete, arginfo_TElOfficeOpenXMLOverrideList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverrideList, Clear, arginfo_TElOfficeOpenXMLOverrideList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverrideList, get_Count, arginfo_TElOfficeOpenXMLOverrideList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverrideList, get_OverrideItems, arginfo_TElOfficeOpenXMLOverrideList_get_OverrideItems, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLOverrideList, __construct, arginfo_TElOfficeOpenXMLOverrideList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLOverrideList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLOverrideList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLOverrideList", TElOfficeOpenXMLOverrideList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOfficeOpenXMLOverrideList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLContentTypes_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLContentTypes, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLContentTypes_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLContentTypes, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLContentTypes_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLContentTypes, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLContentTypes_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLContentTypes_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLContentTypes, get_Defaults)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLContentTypes_get_Defaults(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLDefaultList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLContentTypes, get_Overrides)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLContentTypes_get_Overrides(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeOpenXMLOverrideList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLContentTypes, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLContentTypes_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLContentTypes_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLContentTypes_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLContentTypes_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLContentTypes_get_Defaults, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLContentTypes_get_Overrides, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLContentTypes___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLContentTypes_methods[] = {
	PHP_ME(TElOfficeOpenXMLContentTypes, Clear, arginfo_TElOfficeOpenXMLContentTypes_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLContentTypes, LoadFromXML, arginfo_TElOfficeOpenXMLContentTypes_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLContentTypes, SaveToXML, arginfo_TElOfficeOpenXMLContentTypes_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLContentTypes, get_Defaults, arginfo_TElOfficeOpenXMLContentTypes_get_Defaults, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLContentTypes, get_Overrides, arginfo_TElOfficeOpenXMLContentTypes_get_Overrides, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLContentTypes, __construct, arginfo_TElOfficeOpenXMLContentTypes___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLContentTypes(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLContentTypes_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLContentTypes", TElOfficeOpenXMLContentTypes_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOfficeOpenXMLContentTypes_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLDCSimpleLiteral_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLDCSimpleLiteral, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLDCSimpleLiteral_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCSimpleLiteral, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeXMLDCSimpleLiteral_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCSimpleLiteral, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLDCSimpleLiteral_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCSimpleLiteral, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLDCSimpleLiteral_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLDCSimpleLiteral_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCSimpleLiteral, get_Language)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLDCSimpleLiteral_get_Language(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1717743294, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCSimpleLiteral, set_Language)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLDCSimpleLiteral_set_Language(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCSimpleLiteral, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLDCSimpleLiteral_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-455273086, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCSimpleLiteral, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLDCSimpleLiteral_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCSimpleLiteral, __construct)
{
	char *sAName;
	int sAName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLDCSimpleLiteral_Create(sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCSimpleLiteral_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCSimpleLiteral_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCSimpleLiteral_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCSimpleLiteral_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCSimpleLiteral_get_Language, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCSimpleLiteral_set_Language, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCSimpleLiteral_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCSimpleLiteral_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCSimpleLiteral___construct, 0, 0, 1)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLDCSimpleLiteral_methods[] = {
	PHP_ME(TElOfficeXMLDCSimpleLiteral, Clear, arginfo_TElOfficeXMLDCSimpleLiteral_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCSimpleLiteral, IsEmpty, arginfo_TElOfficeXMLDCSimpleLiteral_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCSimpleLiteral, LoadFromXML, arginfo_TElOfficeXMLDCSimpleLiteral_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCSimpleLiteral, SaveToXML, arginfo_TElOfficeXMLDCSimpleLiteral_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCSimpleLiteral, get_Language, arginfo_TElOfficeXMLDCSimpleLiteral_get_Language, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCSimpleLiteral, set_Language, arginfo_TElOfficeXMLDCSimpleLiteral_set_Language, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCSimpleLiteral, get_Value, arginfo_TElOfficeXMLDCSimpleLiteral_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCSimpleLiteral, set_Value, arginfo_TElOfficeXMLDCSimpleLiteral_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCSimpleLiteral, __construct, arginfo_TElOfficeXMLDCSimpleLiteral___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLDCSimpleLiteral(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLDCSimpleLiteral_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLDCSimpleLiteral", TElOfficeXMLDCSimpleLiteral_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOfficeXMLDCSimpleLiteral_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLDCDate_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLDCDate, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLDCDate_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCDate, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeXMLDCDate_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCDate, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLDCDate_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCDate, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLDCDate_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLDCDate_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCDate, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLDCDate_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(33401455, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCDate, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLDCDate_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCDate, get_ValueUTC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOfficeXMLDCDate_get_ValueUTC(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCDate, set_ValueUTC)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLDCDate_set_ValueUTC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCDate, get_DateTimeFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLDateTimeFormatRaw fOutResultRaw = 0;
		SBCheckError(TElOfficeXMLDCDate_get_DateTimeFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCDate, set_DateTimeFormat)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLDCDate_set_DateTimeFormat(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXMLDateTimeFormatRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCDate, get_IncludeTimeZone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeXMLDCDate_get_IncludeTimeZone(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCDate, set_IncludeTimeZone)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLDCDate_set_IncludeTimeZone(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDCDate, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLDCDate_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate_get_ValueUTC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate_set_ValueUTC, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate_get_DateTimeFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate_set_DateTimeFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate_get_IncludeTimeZone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate_set_IncludeTimeZone, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDCDate___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLDCDate_methods[] = {
	PHP_ME(TElOfficeXMLDCDate, Clear, arginfo_TElOfficeXMLDCDate_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCDate, IsEmpty, arginfo_TElOfficeXMLDCDate_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCDate, LoadFromXML, arginfo_TElOfficeXMLDCDate_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCDate, SaveToXML, arginfo_TElOfficeXMLDCDate_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCDate, get_Value, arginfo_TElOfficeXMLDCDate_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCDate, set_Value, arginfo_TElOfficeXMLDCDate_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCDate, get_ValueUTC, arginfo_TElOfficeXMLDCDate_get_ValueUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCDate, set_ValueUTC, arginfo_TElOfficeXMLDCDate_set_ValueUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCDate, get_DateTimeFormat, arginfo_TElOfficeXMLDCDate_get_DateTimeFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCDate, set_DateTimeFormat, arginfo_TElOfficeXMLDCDate_set_DateTimeFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCDate, get_IncludeTimeZone, arginfo_TElOfficeXMLDCDate_get_IncludeTimeZone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCDate, set_IncludeTimeZone, arginfo_TElOfficeXMLDCDate_set_IncludeTimeZone, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDCDate, __construct, arginfo_TElOfficeXMLDCDate___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLDCDate(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLDCDate_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLDCDate", TElOfficeXMLDCDate_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOfficeXMLDCDate_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLCoreProperties_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLCoreProperties_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLCoreProperties_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCoreProperties_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCoreProperties_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, get_Category)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLCoreProperties_get_Category(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-827807140, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, set_Category)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLCoreProperties_set_Category(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, get_ContentStatus)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLCoreProperties_get_ContentStatus(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1357645974, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, set_ContentStatus)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLCoreProperties_set_ContentStatus(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, get_Creator)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCoreProperties_get_Creator(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeXMLDCSimpleLiteral_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, get_Description)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCoreProperties_get_Description(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeXMLDCSimpleLiteral_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, get_Identifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCoreProperties_get_Identifier(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeXMLDCSimpleLiteral_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, get_Language)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCoreProperties_get_Language(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeXMLDCSimpleLiteral_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, get_LastModifiedBy)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLCoreProperties_get_LastModifiedBy(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2014039483, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, set_LastModifiedBy)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLCoreProperties_set_LastModifiedBy(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, get_Revision)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLCoreProperties_get_Revision(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1517836719, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, set_Revision)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLCoreProperties_set_Revision(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, get_Subject)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCoreProperties_get_Subject(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeXMLDCSimpleLiteral_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, get_Title)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCoreProperties_get_Title(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeXMLDCSimpleLiteral_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, get_Version)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLCoreProperties_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2087403817, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, set_Version)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLCoreProperties_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLCoreProperties, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLCoreProperties_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_get_Category, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_set_Category, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_get_ContentStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_set_ContentStatus, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_get_Creator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_get_Description, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_get_Identifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_get_Language, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_get_LastModifiedBy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_set_LastModifiedBy, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_get_Revision, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_set_Revision, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_get_Subject, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_get_Title, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLCoreProperties___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLCoreProperties_methods[] = {
	PHP_ME(TElOfficeOpenXMLCoreProperties, Clear, arginfo_TElOfficeOpenXMLCoreProperties_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, LoadFromXML, arginfo_TElOfficeOpenXMLCoreProperties_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, SaveToXML, arginfo_TElOfficeOpenXMLCoreProperties_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, get_Category, arginfo_TElOfficeOpenXMLCoreProperties_get_Category, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, set_Category, arginfo_TElOfficeOpenXMLCoreProperties_set_Category, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, get_ContentStatus, arginfo_TElOfficeOpenXMLCoreProperties_get_ContentStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, set_ContentStatus, arginfo_TElOfficeOpenXMLCoreProperties_set_ContentStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, get_Creator, arginfo_TElOfficeOpenXMLCoreProperties_get_Creator, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, get_Description, arginfo_TElOfficeOpenXMLCoreProperties_get_Description, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, get_Identifier, arginfo_TElOfficeOpenXMLCoreProperties_get_Identifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, get_Language, arginfo_TElOfficeOpenXMLCoreProperties_get_Language, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, get_LastModifiedBy, arginfo_TElOfficeOpenXMLCoreProperties_get_LastModifiedBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, set_LastModifiedBy, arginfo_TElOfficeOpenXMLCoreProperties_set_LastModifiedBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, get_Revision, arginfo_TElOfficeOpenXMLCoreProperties_get_Revision, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, set_Revision, arginfo_TElOfficeOpenXMLCoreProperties_set_Revision, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, get_Subject, arginfo_TElOfficeOpenXMLCoreProperties_get_Subject, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, get_Title, arginfo_TElOfficeOpenXMLCoreProperties_get_Title, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, get_Version, arginfo_TElOfficeOpenXMLCoreProperties_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, set_Version, arginfo_TElOfficeOpenXMLCoreProperties_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLCoreProperties, __construct, arginfo_TElOfficeOpenXMLCoreProperties___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLCoreProperties(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLCoreProperties_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLCoreProperties", TElOfficeOpenXMLCoreProperties_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOfficeOpenXMLCoreProperties_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLKeyData_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLKeyData, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyData_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyData_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLKeyData_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLKeyData_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, get_SaltSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLKeyData_get_SaltSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, set_SaltSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyData_set_SaltSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, get_BlockSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLKeyData_get_BlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, set_BlockSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyData_set_BlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, get_KeyBits)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLKeyData_get_KeyBits(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, set_KeyBits)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyData_set_KeyBits(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, get_HashSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLKeyData_get_HashSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, set_HashSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyData_set_HashSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, get_CipherAlgorithm)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLKeyData_get_CipherAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1567607358, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, set_CipherAlgorithm)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyData_set_CipherAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, get_CipherChaining)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLKeyData_get_CipherChaining(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-755038679, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, set_CipherChaining)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyData_set_CipherChaining(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, get_HashAlgorithm)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLKeyData_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1399059053, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, set_HashAlgorithm)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyData_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, get_SaltValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOfficeXMLKeyData_get_SaltValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1003988636, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, set_SaltValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOfficeXMLKeyData_set_SaltValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyData, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLKeyData_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_get_SaltSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_set_SaltSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_get_BlockSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_set_BlockSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_get_KeyBits, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_set_KeyBits, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_get_HashSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_set_HashSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_get_CipherAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_set_CipherAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_get_CipherChaining, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_set_CipherChaining, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_get_SaltValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData_set_SaltValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyData___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLKeyData_methods[] = {
	PHP_ME(TElOfficeXMLKeyData, Clear, arginfo_TElOfficeXMLKeyData_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, LoadFromXML, arginfo_TElOfficeXMLKeyData_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, SaveToXML, arginfo_TElOfficeXMLKeyData_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, get_SaltSize, arginfo_TElOfficeXMLKeyData_get_SaltSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, set_SaltSize, arginfo_TElOfficeXMLKeyData_set_SaltSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, get_BlockSize, arginfo_TElOfficeXMLKeyData_get_BlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, set_BlockSize, arginfo_TElOfficeXMLKeyData_set_BlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, get_KeyBits, arginfo_TElOfficeXMLKeyData_get_KeyBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, set_KeyBits, arginfo_TElOfficeXMLKeyData_set_KeyBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, get_HashSize, arginfo_TElOfficeXMLKeyData_get_HashSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, set_HashSize, arginfo_TElOfficeXMLKeyData_set_HashSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, get_CipherAlgorithm, arginfo_TElOfficeXMLKeyData_get_CipherAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, set_CipherAlgorithm, arginfo_TElOfficeXMLKeyData_set_CipherAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, get_CipherChaining, arginfo_TElOfficeXMLKeyData_get_CipherChaining, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, set_CipherChaining, arginfo_TElOfficeXMLKeyData_set_CipherChaining, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, get_HashAlgorithm, arginfo_TElOfficeXMLKeyData_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, set_HashAlgorithm, arginfo_TElOfficeXMLKeyData_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, get_SaltValue, arginfo_TElOfficeXMLKeyData_get_SaltValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, set_SaltValue, arginfo_TElOfficeXMLKeyData_set_SaltValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyData, __construct, arginfo_TElOfficeXMLKeyData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLKeyData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLKeyData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLKeyData", TElOfficeXMLKeyData_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElOfficeXMLKeyData_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLDataIntegrity_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLDataIntegrity, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLDataIntegrity_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDataIntegrity, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLDataIntegrity_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDataIntegrity, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLDataIntegrity_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLDataIntegrity_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDataIntegrity, get_EncryptedHmacKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOfficeXMLDataIntegrity_get_EncryptedHmacKey(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2134324377, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDataIntegrity, set_EncryptedHmacKey)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOfficeXMLDataIntegrity_set_EncryptedHmacKey(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDataIntegrity, get_EncryptedHmacValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOfficeXMLDataIntegrity_get_EncryptedHmacValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1147525899, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDataIntegrity, set_EncryptedHmacValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOfficeXMLDataIntegrity_set_EncryptedHmacValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLDataIntegrity, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLDataIntegrity_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDataIntegrity_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDataIntegrity_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDataIntegrity_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDataIntegrity_get_EncryptedHmacKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDataIntegrity_set_EncryptedHmacKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDataIntegrity_get_EncryptedHmacValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDataIntegrity_set_EncryptedHmacValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLDataIntegrity___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLDataIntegrity_methods[] = {
	PHP_ME(TElOfficeXMLDataIntegrity, Clear, arginfo_TElOfficeXMLDataIntegrity_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDataIntegrity, LoadFromXML, arginfo_TElOfficeXMLDataIntegrity_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDataIntegrity, SaveToXML, arginfo_TElOfficeXMLDataIntegrity_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDataIntegrity, get_EncryptedHmacKey, arginfo_TElOfficeXMLDataIntegrity_get_EncryptedHmacKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDataIntegrity, set_EncryptedHmacKey, arginfo_TElOfficeXMLDataIntegrity_set_EncryptedHmacKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDataIntegrity, get_EncryptedHmacValue, arginfo_TElOfficeXMLDataIntegrity_get_EncryptedHmacValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDataIntegrity, set_EncryptedHmacValue, arginfo_TElOfficeXMLDataIntegrity_set_EncryptedHmacValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLDataIntegrity, __construct, arginfo_TElOfficeXMLDataIntegrity___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLDataIntegrity(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLDataIntegrity_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLDataIntegrity", TElOfficeXMLDataIntegrity_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElOfficeXMLDataIntegrity_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLKeyEncryptor_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLKeyEncryptor, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLKeyEncryptor_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-104741397, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyEncryptor, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLKeyEncryptor_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyEncryptor_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyEncryptor___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLKeyEncryptor_methods[] = {
	PHP_ME(TElOfficeXMLKeyEncryptor, get_URI, arginfo_TElOfficeXMLKeyEncryptor_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyEncryptor, __construct, arginfo_TElOfficeXMLKeyEncryptor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLKeyEncryptor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLKeyEncryptor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLKeyEncryptor", TElOfficeXMLKeyEncryptor_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElOfficeXMLKeyEncryptor_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLKeyEncryptors_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLKeyEncryptors, Add)
{
	zval *oAKeyEncryptor;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAKeyEncryptor, TElOfficeXMLKeyEncryptor_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLKeyEncryptors_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAKeyEncryptor TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeXMLKeyEncryptor)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyEncryptors, Insert)
{
	long l4Index;
	zval *oAKeyEncryptor;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAKeyEncryptor, TElOfficeXMLKeyEncryptor_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyEncryptors_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAKeyEncryptor TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElOfficeXMLKeyEncryptor)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyEncryptors, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyEncryptors_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyEncryptors, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyEncryptors_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyEncryptors, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLKeyEncryptors_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyEncryptors, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLKeyEncryptors_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLKeyEncryptors_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyEncryptors, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLKeyEncryptors_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyEncryptors, get_KeyEncryptors)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLKeyEncryptors_get_KeyEncryptors(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeXMLKeyEncryptor_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLKeyEncryptors, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLKeyEncryptors_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyEncryptors_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AKeyEncryptor, TElOfficeXMLKeyEncryptor, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyEncryptors_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AKeyEncryptor, TElOfficeXMLKeyEncryptor, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyEncryptors_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyEncryptors_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyEncryptors_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyEncryptors_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyEncryptors_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyEncryptors_get_KeyEncryptors, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLKeyEncryptors___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLKeyEncryptors_methods[] = {
	PHP_ME(TElOfficeXMLKeyEncryptors, Add, arginfo_TElOfficeXMLKeyEncryptors_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyEncryptors, Insert, arginfo_TElOfficeXMLKeyEncryptors_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyEncryptors, Delete, arginfo_TElOfficeXMLKeyEncryptors_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyEncryptors, Clear, arginfo_TElOfficeXMLKeyEncryptors_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyEncryptors, LoadFromXML, arginfo_TElOfficeXMLKeyEncryptors_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyEncryptors, SaveToXML, arginfo_TElOfficeXMLKeyEncryptors_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyEncryptors, get_Count, arginfo_TElOfficeXMLKeyEncryptors_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyEncryptors, get_KeyEncryptors, arginfo_TElOfficeXMLKeyEncryptors_get_KeyEncryptors, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLKeyEncryptors, __construct, arginfo_TElOfficeXMLKeyEncryptors___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLKeyEncryptors(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLKeyEncryptors_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLKeyEncryptors", TElOfficeXMLKeyEncryptors_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElOfficeXMLKeyEncryptors_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLPasswordKeyEncryptor_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, get_SaltSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_get_SaltSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, set_SaltSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_set_SaltSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, get_BlockSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_get_BlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, set_BlockSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_set_BlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, get_KeyBits)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_get_KeyBits(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, set_KeyBits)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_set_KeyBits(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, get_HashSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_get_HashSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, set_HashSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_set_HashSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, get_CipherAlgorithm)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLPasswordKeyEncryptor_get_CipherAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1252187826, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, set_CipherAlgorithm)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_set_CipherAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, get_CipherChaining)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLPasswordKeyEncryptor_get_CipherChaining(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1488995694, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, set_CipherChaining)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_set_CipherChaining(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, get_HashAlgorithm)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLPasswordKeyEncryptor_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-166287736, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, set_HashAlgorithm)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, get_SaltValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOfficeXMLPasswordKeyEncryptor_get_SaltValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1900816166, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, set_SaltValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_set_SaltValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, get_SpinCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_get_SpinCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, set_SpinCount)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_set_SpinCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, get_EncryptedVerifierHashInput)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOfficeXMLPasswordKeyEncryptor_get_EncryptedVerifierHashInput(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-204195702, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, set_EncryptedVerifierHashInput)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_set_EncryptedVerifierHashInput(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, get_EncryptedVerifierHashValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOfficeXMLPasswordKeyEncryptor_get_EncryptedVerifierHashValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(915100265, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, set_EncryptedVerifierHashValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_set_EncryptedVerifierHashValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, get_EncryptedKeyValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOfficeXMLPasswordKeyEncryptor_get_EncryptedKeyValue(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1288739055, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, set_EncryptedKeyValue)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_set_EncryptedKeyValue(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPasswordKeyEncryptor, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLPasswordKeyEncryptor_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_get_SaltSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_set_SaltSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_get_BlockSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_set_BlockSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_get_KeyBits, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_set_KeyBits, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_get_HashSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_set_HashSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_get_CipherAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_set_CipherAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_get_CipherChaining, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_set_CipherChaining, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_get_SaltValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_set_SaltValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_get_SpinCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_set_SpinCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_get_EncryptedVerifierHashInput, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_set_EncryptedVerifierHashInput, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_get_EncryptedVerifierHashValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_set_EncryptedVerifierHashValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_get_EncryptedKeyValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor_set_EncryptedKeyValue, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPasswordKeyEncryptor___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLPasswordKeyEncryptor_methods[] = {
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, Clear, arginfo_TElOfficeXMLPasswordKeyEncryptor_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, LoadFromXML, arginfo_TElOfficeXMLPasswordKeyEncryptor_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, SaveToXML, arginfo_TElOfficeXMLPasswordKeyEncryptor_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, get_SaltSize, arginfo_TElOfficeXMLPasswordKeyEncryptor_get_SaltSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, set_SaltSize, arginfo_TElOfficeXMLPasswordKeyEncryptor_set_SaltSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, get_BlockSize, arginfo_TElOfficeXMLPasswordKeyEncryptor_get_BlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, set_BlockSize, arginfo_TElOfficeXMLPasswordKeyEncryptor_set_BlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, get_KeyBits, arginfo_TElOfficeXMLPasswordKeyEncryptor_get_KeyBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, set_KeyBits, arginfo_TElOfficeXMLPasswordKeyEncryptor_set_KeyBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, get_HashSize, arginfo_TElOfficeXMLPasswordKeyEncryptor_get_HashSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, set_HashSize, arginfo_TElOfficeXMLPasswordKeyEncryptor_set_HashSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, get_CipherAlgorithm, arginfo_TElOfficeXMLPasswordKeyEncryptor_get_CipherAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, set_CipherAlgorithm, arginfo_TElOfficeXMLPasswordKeyEncryptor_set_CipherAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, get_CipherChaining, arginfo_TElOfficeXMLPasswordKeyEncryptor_get_CipherChaining, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, set_CipherChaining, arginfo_TElOfficeXMLPasswordKeyEncryptor_set_CipherChaining, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, get_HashAlgorithm, arginfo_TElOfficeXMLPasswordKeyEncryptor_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, set_HashAlgorithm, arginfo_TElOfficeXMLPasswordKeyEncryptor_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, get_SaltValue, arginfo_TElOfficeXMLPasswordKeyEncryptor_get_SaltValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, set_SaltValue, arginfo_TElOfficeXMLPasswordKeyEncryptor_set_SaltValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, get_SpinCount, arginfo_TElOfficeXMLPasswordKeyEncryptor_get_SpinCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, set_SpinCount, arginfo_TElOfficeXMLPasswordKeyEncryptor_set_SpinCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, get_EncryptedVerifierHashInput, arginfo_TElOfficeXMLPasswordKeyEncryptor_get_EncryptedVerifierHashInput, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, set_EncryptedVerifierHashInput, arginfo_TElOfficeXMLPasswordKeyEncryptor_set_EncryptedVerifierHashInput, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, get_EncryptedVerifierHashValue, arginfo_TElOfficeXMLPasswordKeyEncryptor_get_EncryptedVerifierHashValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, set_EncryptedVerifierHashValue, arginfo_TElOfficeXMLPasswordKeyEncryptor_set_EncryptedVerifierHashValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, get_EncryptedKeyValue, arginfo_TElOfficeXMLPasswordKeyEncryptor_get_EncryptedKeyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, set_EncryptedKeyValue, arginfo_TElOfficeXMLPasswordKeyEncryptor_set_EncryptedKeyValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPasswordKeyEncryptor, __construct, arginfo_TElOfficeXMLPasswordKeyEncryptor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLPasswordKeyEncryptor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLPasswordKeyEncryptor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLPasswordKeyEncryptor", TElOfficeXMLPasswordKeyEncryptor_methods);
	if (NULL == TElOfficeXMLKeyEncryptor_ce_ptr)
		Register_TElOfficeXMLKeyEncryptor(TSRMLS_C);
	TElOfficeXMLPasswordKeyEncryptor_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeXMLKeyEncryptor_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLEncryption_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLEncryption, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLEncryption_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLEncryption, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLEncryption_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLEncryption, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLEncryption_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLEncryption_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLEncryption, get_DataIntegrity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLEncryption_get_DataIntegrity(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeXMLDataIntegrity_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLEncryption, get_KeyData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLEncryption_get_KeyData(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeXMLKeyData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLEncryption, get_KeyEncryptors)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLEncryption_get_KeyEncryptors(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeXMLKeyEncryptors_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLEncryption, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLEncryption_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLEncryption_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLEncryption_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLEncryption_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLEncryption_get_DataIntegrity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLEncryption_get_KeyData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLEncryption_get_KeyEncryptors, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLEncryption___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLEncryption_methods[] = {
	PHP_ME(TElOfficeXMLEncryption, Clear, arginfo_TElOfficeXMLEncryption_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLEncryption, LoadFromXML, arginfo_TElOfficeXMLEncryption_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLEncryption, SaveToXML, arginfo_TElOfficeXMLEncryption_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLEncryption, get_DataIntegrity, arginfo_TElOfficeXMLEncryption_get_DataIntegrity, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLEncryption, get_KeyData, arginfo_TElOfficeXMLEncryption_get_KeyData, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLEncryption, get_KeyEncryptors, arginfo_TElOfficeXMLEncryption_get_KeyEncryptors, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLEncryption, __construct, arginfo_TElOfficeXMLEncryption___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLEncryption(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLEncryption_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLEncryption", TElOfficeXMLEncryption_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElOfficeXMLEncryption_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLSignatureTime_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLSignatureTime, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureTime_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureTime, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureTime_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureTime, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLSignatureTime_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLSignatureTime_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureTime, get_Format)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureTime_get_Format(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1483281771, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureTime, set_Format)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureTime_set_Format(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureTime, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureTime_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-499268069, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureTime, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureTime_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureTime, get_ValueUTC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOfficeXMLSignatureTime_get_ValueUTC(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureTime, set_ValueUTC)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureTime_set_ValueUTC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureTime, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLSignatureTime_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureTime_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureTime_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureTime_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureTime_get_Format, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureTime_set_Format, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureTime_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureTime_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureTime_get_ValueUTC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureTime_set_ValueUTC, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureTime___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLSignatureTime_methods[] = {
	PHP_ME(TElOfficeXMLSignatureTime, Clear, arginfo_TElOfficeXMLSignatureTime_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureTime, LoadFromXML, arginfo_TElOfficeXMLSignatureTime_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureTime, SaveToXML, arginfo_TElOfficeXMLSignatureTime_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureTime, get_Format, arginfo_TElOfficeXMLSignatureTime_get_Format, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureTime, set_Format, arginfo_TElOfficeXMLSignatureTime_set_Format, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureTime, get_Value, arginfo_TElOfficeXMLSignatureTime_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureTime, set_Value, arginfo_TElOfficeXMLSignatureTime_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureTime, get_ValueUTC, arginfo_TElOfficeXMLSignatureTime_get_ValueUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureTime, set_ValueUTC, arginfo_TElOfficeXMLSignatureTime_set_ValueUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureTime, __construct, arginfo_TElOfficeXMLSignatureTime___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLSignatureTime(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLSignatureTime_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLSignatureTime", TElOfficeXMLSignatureTime_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElOfficeXMLSignatureTime_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeOpenXMLRelationshipTransform_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, GetDefaultTransformAlgorithmURI_Inst)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLRelationshipTransform_GetDefaultTransformAlgorithmURI_1(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2060801548, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, GetDefaultTransformAlgorithmURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLRelationshipTransform_GetDefaultTransformAlgorithmURI(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2060801548, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, IsTransformAlgorithmSupported_Inst)
{
	char *sAlgorithm;
	int sAlgorithm_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAlgorithm, &sAlgorithm_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_IsTransformAlgorithmSupported_1(SBGetObjectHandle(getThis() TSRMLS_CC), sAlgorithm, (int32_t)sAlgorithm_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, IsTransformAlgorithmSupported)
{
	char *sAlgorithm;
	int sAlgorithm_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAlgorithm, &sAlgorithm_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_IsTransformAlgorithmSupported(sAlgorithm, (int32_t)sAlgorithm_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, AddSourceId)
{
	char *sSourceId;
	int sSourceId_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSourceId, &sSourceId_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_AddSourceId(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceId, (int32_t)sSourceId_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, AddSourceType)
{
	char *sSourceType;
	int sSourceType_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSourceType, &sSourceType_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_AddSourceType(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceType, (int32_t)sSourceType_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, DeleteSourceId)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_DeleteSourceId(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, DeleteSourceType)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_DeleteSourceType(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, TransformData)
{
	SBArrayZValInfo aiData;
	SBArrayZValInfo aiReference;
	zval *oNode;
	zval *oNodes;
	zval *oReference;
	zval *zaData;
	zval *zaReference;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		TSBTransformedDataTypeRaw fOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_TransformData(SBGetObjectHandle(getThis() TSRMLS_CC), aiData.data, aiData.len, &fOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiData);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oNode, TElXMLDOMNode_ce_ptr, &oReference, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		TSBTransformedDataTypeRaw fOutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_TransformData_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC), SBGetObjectHandle(oReference TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oNodes, TElXMLDOMNodeList_ce_ptr, &zaReference, TElXMLDOMNode_ce_ptr) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaReference)) || (IS_NULL == Z_TYPE_P(zaReference))))
	{
		TSBTransformedDataTypeRaw fOutResultRaw = 0;
		if (!SBGetObjectArrayFromZVal(zaReference, TElXMLDOMNode_ce_ptr, &aiReference TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_TransformData_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNodes TSRMLS_CC), aiReference.data, aiReference.len, &fOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiReference);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (TElXMLDOMNode, TElXMLDOMNode) or (TElXMLDOMNodeList, &array of TElXMLDOMNode|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, TransformNode)
{
	zval *oNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oNode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_TransformNode(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oNode TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMNode_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, get_SourceIdCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_get_SourceIdCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, get_SourceTypeCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_get_SourceTypeCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, get_SourceIds)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLRelationshipTransform_get_SourceIds(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1766373945, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, get_SourceTypes)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeOpenXMLRelationshipTransform_get_SourceTypes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-933108686, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeOpenXMLRelationshipTransform, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeOpenXMLRelationshipTransform_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_GetDefaultTransformAlgorithmURI_Inst, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_GetDefaultTransformAlgorithmURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_IsTransformAlgorithmSupported_Inst, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_IsTransformAlgorithmSupported, 0, 0, 1)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_AddSourceId, 0, 0, 1)
	ZEND_ARG_INFO(0, SourceId)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_AddSourceType, 0, 0, 1)
	ZEND_ARG_INFO(0, SourceType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_DeleteSourceId, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_DeleteSourceType, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_TransformData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Data_or_Node_or_Nodes, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Reference, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_TransformNode, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Node, TElXMLDOMNode, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_get_SourceIdCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_get_SourceTypeCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_get_SourceIds, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform_get_SourceTypes, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeOpenXMLRelationshipTransform___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeOpenXMLRelationshipTransform_methods[] = {
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, GetDefaultTransformAlgorithmURI_Inst, arginfo_TElOfficeOpenXMLRelationshipTransform_GetDefaultTransformAlgorithmURI_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, GetDefaultTransformAlgorithmURI, arginfo_TElOfficeOpenXMLRelationshipTransform_GetDefaultTransformAlgorithmURI, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, IsTransformAlgorithmSupported_Inst, arginfo_TElOfficeOpenXMLRelationshipTransform_IsTransformAlgorithmSupported_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, IsTransformAlgorithmSupported, arginfo_TElOfficeOpenXMLRelationshipTransform_IsTransformAlgorithmSupported, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, Clear, arginfo_TElOfficeOpenXMLRelationshipTransform_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, AddSourceId, arginfo_TElOfficeOpenXMLRelationshipTransform_AddSourceId, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, AddSourceType, arginfo_TElOfficeOpenXMLRelationshipTransform_AddSourceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, DeleteSourceId, arginfo_TElOfficeOpenXMLRelationshipTransform_DeleteSourceId, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, DeleteSourceType, arginfo_TElOfficeOpenXMLRelationshipTransform_DeleteSourceType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, LoadFromXML, arginfo_TElOfficeOpenXMLRelationshipTransform_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, SaveToXML, arginfo_TElOfficeOpenXMLRelationshipTransform_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, TransformData, arginfo_TElOfficeOpenXMLRelationshipTransform_TransformData, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, TransformNode, arginfo_TElOfficeOpenXMLRelationshipTransform_TransformNode, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, ClassType, arginfo_TElOfficeOpenXMLRelationshipTransform_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, get_SourceIdCount, arginfo_TElOfficeOpenXMLRelationshipTransform_get_SourceIdCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, get_SourceTypeCount, arginfo_TElOfficeOpenXMLRelationshipTransform_get_SourceTypeCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, get_SourceIds, arginfo_TElOfficeOpenXMLRelationshipTransform_get_SourceIds, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, get_SourceTypes, arginfo_TElOfficeOpenXMLRelationshipTransform_get_SourceTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeOpenXMLRelationshipTransform, __construct, arginfo_TElOfficeOpenXMLRelationshipTransform___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeOpenXMLRelationshipTransform(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeOpenXMLRelationshipTransform_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeOpenXMLRelationshipTransform", TElOfficeOpenXMLRelationshipTransform_methods);
	if (NULL == TElXMLTransform_ce_ptr)
		Register_TElXMLTransform(TSRMLS_C);
	TElOfficeOpenXMLRelationshipTransform_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLTransform_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLSignatureInfoV1_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, CheckReferences)
{
	zval *oRefs;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oRefs, TElXMLReferenceList_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeXMLSignatureInfoV1_CheckReferences(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRefs TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLReferenceList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, CreateReferences)
{
	long fDigestMethod;
	zval *oRefs;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!l", &oRefs, TElXMLReferenceList_ce_ptr, &fDigestMethod) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_CreateReferences(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRefs TSRMLS_CC), (TElXMLDigestMethodRaw)fDigestMethod) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLReferenceList, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, CreateObjects)
{
	char *sTarget;
	int sTarget_len;
	zval *oDocument;
	zval *oFormatter;
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!O!", &oObjects, TElXMLObjectList_ce_ptr, &sTarget, &sTarget_len, &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_CreateObjects(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC), sTarget, (int32_t)sTarget_len, SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLObjectList, string, TElXMLDOMDocument, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, LoadFromObjectList)
{
	zval *oObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElXMLObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_LoadFromObjectList(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLObjectList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_Included)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOfficeXMLSignatureInfoV1_get_Included(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_Included)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_Included(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_ApplicationVersion)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_ApplicationVersion(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1605837511, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_ApplicationVersion)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_ApplicationVersion(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_ColorDepth)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLSignatureInfoV1_get_ColorDepth(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_ColorDepth)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_ColorDepth(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_DelegateSuggestedSigner)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_DelegateSuggestedSigner(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-857214124, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_DelegateSuggestedSigner)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_DelegateSuggestedSigner(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_DelegateSuggestedSigner2)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_DelegateSuggestedSigner2(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1541594210, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_DelegateSuggestedSigner2)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_DelegateSuggestedSigner2(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_DelegateSuggestedSignerEmail)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_DelegateSuggestedSignerEmail(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1926441544, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_DelegateSuggestedSignerEmail)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_DelegateSuggestedSignerEmail(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_HorizontalResolution)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLSignatureInfoV1_get_HorizontalResolution(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_HorizontalResolution)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_HorizontalResolution(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_ManifestHashAlgorithm)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_ManifestHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1641202620, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_ManifestHashAlgorithm)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_ManifestHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_Monitors)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLSignatureInfoV1_get_Monitors(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_Monitors)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_Monitors(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_OfficeVersion)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_OfficeVersion(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-366684934, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_OfficeVersion)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_OfficeVersion(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_SetupID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_SetupID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-338532916, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_SetupID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_SetupID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_SignatureComments)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_SignatureComments(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-953225723, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_SignatureComments)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_SignatureComments(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_SignatureImage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_SignatureImage(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1916885363, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_SignatureImage)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_SignatureImage(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_SignatureProviderDetails)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLSignatureInfoV1_get_SignatureProviderDetails(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_SignatureProviderDetails)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_SignatureProviderDetails(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_SignatureProviderId)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_SignatureProviderId(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(861831050, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_SignatureProviderId)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_SignatureProviderId(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_SignatureProviderUrl)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_SignatureProviderUrl(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1090451185, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_SignatureProviderUrl)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_SignatureProviderUrl(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_SignatureText)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_SignatureText(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-169820001, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_SignatureText)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_SignatureText(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_SignatureType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLSignatureInfoV1_get_SignatureType(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_SignatureType)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_SignatureType(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_VerticalResolution)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLSignatureInfoV1_get_VerticalResolution(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_VerticalResolution)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_VerticalResolution(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_WindowsVersion)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_WindowsVersion(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-115538176, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_WindowsVersion)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_WindowsVersion(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_ValidSignatureLnImage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_ValidSignatureLnImage(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1673339568, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_ValidSignatureLnImage)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_ValidSignatureLnImage(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, get_InvalidSignatureLnImage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOfficeXMLSignatureInfoV1_get_InvalidSignatureLnImage(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(517510345, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, set_InvalidSignatureLnImage)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOfficeXMLSignatureInfoV1_set_InvalidSignatureLnImage(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureInfoV1, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLSignatureInfoV1_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_CheckReferences, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Refs, TElXMLReferenceList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_CreateReferences, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Refs, TElXMLReferenceList, 1)
	ZEND_ARG_INFO(0, DigestMethod)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_CreateObjects, 0, 0, 4)
	ZEND_ARG_OBJ_INFO(0, Objects, TElXMLObjectList, 1)
	ZEND_ARG_INFO(0, Target)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_LoadFromObjectList, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElXMLObjectList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_Included, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_Included, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_ApplicationVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_ApplicationVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_ColorDepth, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_ColorDepth, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_DelegateSuggestedSigner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_DelegateSuggestedSigner, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_DelegateSuggestedSigner2, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_DelegateSuggestedSigner2, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_DelegateSuggestedSignerEmail, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_DelegateSuggestedSignerEmail, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_HorizontalResolution, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_HorizontalResolution, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_ManifestHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_ManifestHashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_Monitors, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_Monitors, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_OfficeVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_OfficeVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_SetupID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_SetupID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureComments, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureComments, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureImage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureImage, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureProviderDetails, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureProviderDetails, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureProviderId, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureProviderId, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureProviderUrl, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureProviderUrl, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureText, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureText, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_VerticalResolution, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_VerticalResolution, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_WindowsVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_WindowsVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_ValidSignatureLnImage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_ValidSignatureLnImage, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_get_InvalidSignatureLnImage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1_set_InvalidSignatureLnImage, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureInfoV1___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLSignatureInfoV1_methods[] = {
	PHP_ME(TElOfficeXMLSignatureInfoV1, Clear, arginfo_TElOfficeXMLSignatureInfoV1_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, CheckReferences, arginfo_TElOfficeXMLSignatureInfoV1_CheckReferences, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, CreateReferences, arginfo_TElOfficeXMLSignatureInfoV1_CreateReferences, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, CreateObjects, arginfo_TElOfficeXMLSignatureInfoV1_CreateObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, LoadFromObjectList, arginfo_TElOfficeXMLSignatureInfoV1_LoadFromObjectList, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_Included, arginfo_TElOfficeXMLSignatureInfoV1_get_Included, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_Included, arginfo_TElOfficeXMLSignatureInfoV1_set_Included, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_ApplicationVersion, arginfo_TElOfficeXMLSignatureInfoV1_get_ApplicationVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_ApplicationVersion, arginfo_TElOfficeXMLSignatureInfoV1_set_ApplicationVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_ColorDepth, arginfo_TElOfficeXMLSignatureInfoV1_get_ColorDepth, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_ColorDepth, arginfo_TElOfficeXMLSignatureInfoV1_set_ColorDepth, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_DelegateSuggestedSigner, arginfo_TElOfficeXMLSignatureInfoV1_get_DelegateSuggestedSigner, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_DelegateSuggestedSigner, arginfo_TElOfficeXMLSignatureInfoV1_set_DelegateSuggestedSigner, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_DelegateSuggestedSigner2, arginfo_TElOfficeXMLSignatureInfoV1_get_DelegateSuggestedSigner2, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_DelegateSuggestedSigner2, arginfo_TElOfficeXMLSignatureInfoV1_set_DelegateSuggestedSigner2, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_DelegateSuggestedSignerEmail, arginfo_TElOfficeXMLSignatureInfoV1_get_DelegateSuggestedSignerEmail, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_DelegateSuggestedSignerEmail, arginfo_TElOfficeXMLSignatureInfoV1_set_DelegateSuggestedSignerEmail, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_HorizontalResolution, arginfo_TElOfficeXMLSignatureInfoV1_get_HorizontalResolution, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_HorizontalResolution, arginfo_TElOfficeXMLSignatureInfoV1_set_HorizontalResolution, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_ManifestHashAlgorithm, arginfo_TElOfficeXMLSignatureInfoV1_get_ManifestHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_ManifestHashAlgorithm, arginfo_TElOfficeXMLSignatureInfoV1_set_ManifestHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_Monitors, arginfo_TElOfficeXMLSignatureInfoV1_get_Monitors, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_Monitors, arginfo_TElOfficeXMLSignatureInfoV1_set_Monitors, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_OfficeVersion, arginfo_TElOfficeXMLSignatureInfoV1_get_OfficeVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_OfficeVersion, arginfo_TElOfficeXMLSignatureInfoV1_set_OfficeVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_SetupID, arginfo_TElOfficeXMLSignatureInfoV1_get_SetupID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_SetupID, arginfo_TElOfficeXMLSignatureInfoV1_set_SetupID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_SignatureComments, arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureComments, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_SignatureComments, arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureComments, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_SignatureImage, arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureImage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_SignatureImage, arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureImage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_SignatureProviderDetails, arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureProviderDetails, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_SignatureProviderDetails, arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureProviderDetails, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_SignatureProviderId, arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureProviderId, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_SignatureProviderId, arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureProviderId, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_SignatureProviderUrl, arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureProviderUrl, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_SignatureProviderUrl, arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureProviderUrl, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_SignatureText, arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureText, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_SignatureText, arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureText, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_SignatureType, arginfo_TElOfficeXMLSignatureInfoV1_get_SignatureType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_SignatureType, arginfo_TElOfficeXMLSignatureInfoV1_set_SignatureType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_VerticalResolution, arginfo_TElOfficeXMLSignatureInfoV1_get_VerticalResolution, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_VerticalResolution, arginfo_TElOfficeXMLSignatureInfoV1_set_VerticalResolution, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_WindowsVersion, arginfo_TElOfficeXMLSignatureInfoV1_get_WindowsVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_WindowsVersion, arginfo_TElOfficeXMLSignatureInfoV1_set_WindowsVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_ValidSignatureLnImage, arginfo_TElOfficeXMLSignatureInfoV1_get_ValidSignatureLnImage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_ValidSignatureLnImage, arginfo_TElOfficeXMLSignatureInfoV1_set_ValidSignatureLnImage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, get_InvalidSignatureLnImage, arginfo_TElOfficeXMLSignatureInfoV1_get_InvalidSignatureLnImage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, set_InvalidSignatureLnImage, arginfo_TElOfficeXMLSignatureInfoV1_set_InvalidSignatureLnImage, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureInfoV1, __construct, arginfo_TElOfficeXMLSignatureInfoV1___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLSignatureInfoV1(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLSignatureInfoV1_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLSignatureInfoV1", TElOfficeXMLSignatureInfoV1_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElOfficeXMLSignatureInfoV1_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLSpotLocation_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLSpotLocation, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSpotLocation_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSpotLocation, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSpotLocation_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSpotLocation, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLSpotLocation_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLSpotLocation_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSpotLocation, get_PageURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSpotLocation_get_PageURI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(585057936, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSpotLocation, set_PageURI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSpotLocation_set_PageURI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSpotLocation, get_StartX)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOfficeXMLSpotLocation_get_StartX(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSpotLocation, set_StartX)
{
	double dValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dValue) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSpotLocation_set_StartX(SBGetObjectHandle(getThis() TSRMLS_CC), (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSpotLocation, get_StartY)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElOfficeXMLSpotLocation_get_StartY(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSpotLocation, set_StartY)
{
	double dValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dValue) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSpotLocation_set_StartY(SBGetObjectHandle(getThis() TSRMLS_CC), (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSpotLocation, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLSpotLocation_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSpotLocation_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSpotLocation_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSpotLocation_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSpotLocation_get_PageURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSpotLocation_set_PageURI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSpotLocation_get_StartX, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSpotLocation_set_StartX, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSpotLocation_get_StartY, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSpotLocation_set_StartY, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSpotLocation___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLSpotLocation_methods[] = {
	PHP_ME(TElOfficeXMLSpotLocation, Clear, arginfo_TElOfficeXMLSpotLocation_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSpotLocation, LoadFromXML, arginfo_TElOfficeXMLSpotLocation_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSpotLocation, SaveToXML, arginfo_TElOfficeXMLSpotLocation_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSpotLocation, get_PageURI, arginfo_TElOfficeXMLSpotLocation_get_PageURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSpotLocation, set_PageURI, arginfo_TElOfficeXMLSpotLocation_set_PageURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSpotLocation, get_StartX, arginfo_TElOfficeXMLSpotLocation_get_StartX, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSpotLocation, set_StartX, arginfo_TElOfficeXMLSpotLocation_set_StartX, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSpotLocation, get_StartY, arginfo_TElOfficeXMLSpotLocation_get_StartY, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSpotLocation, set_StartY, arginfo_TElOfficeXMLSpotLocation_set_StartY, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSpotLocation, __construct, arginfo_TElOfficeXMLSpotLocation___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLSpotLocation(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLSpotLocation_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLSpotLocation", TElOfficeXMLSpotLocation_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElOfficeXMLSpotLocation_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLSignatureDefinition_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureDefinition_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureDefinition_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLSignatureDefinition_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLSignatureDefinition_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, get_Intent)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureDefinition_get_Intent(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1859872542, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, set_Intent)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureDefinition_set_Intent(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, get_SignBy)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureDefinition_get_SignBy(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2010094196, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, set_SignBy)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureDefinition_set_SignBy(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, get_SignByUTC)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElOfficeXMLSignatureDefinition_get_SignByUTC(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, set_SignByUTC)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureDefinition_set_SignByUTC(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, get_SigningLocation)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureDefinition_get_SigningLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-655547144, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, set_SigningLocation)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureDefinition_set_SigningLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, get_SignerName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureDefinition_get_SignerName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1738159890, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, set_SignerName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureDefinition_set_SignerName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, get_SpotID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLSignatureDefinition_get_SpotID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1973875732, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, set_SpotID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLSignatureDefinition_set_SpotID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, get_SpotLocation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLSignatureDefinition_get_SpotLocation(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeXMLSpotLocation_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLSignatureDefinition, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLSignatureDefinition_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_get_Intent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_set_Intent, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_get_SignBy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_set_SignBy, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_get_SignByUTC, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_set_SignByUTC, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_get_SigningLocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_set_SigningLocation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_get_SignerName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_set_SignerName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_get_SpotID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_set_SpotID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition_get_SpotLocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLSignatureDefinition___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLSignatureDefinition_methods[] = {
	PHP_ME(TElOfficeXMLSignatureDefinition, Clear, arginfo_TElOfficeXMLSignatureDefinition_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, LoadFromXML, arginfo_TElOfficeXMLSignatureDefinition_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, SaveToXML, arginfo_TElOfficeXMLSignatureDefinition_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, get_Intent, arginfo_TElOfficeXMLSignatureDefinition_get_Intent, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, set_Intent, arginfo_TElOfficeXMLSignatureDefinition_set_Intent, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, get_SignBy, arginfo_TElOfficeXMLSignatureDefinition_get_SignBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, set_SignBy, arginfo_TElOfficeXMLSignatureDefinition_set_SignBy, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, get_SignByUTC, arginfo_TElOfficeXMLSignatureDefinition_get_SignByUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, set_SignByUTC, arginfo_TElOfficeXMLSignatureDefinition_set_SignByUTC, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, get_SigningLocation, arginfo_TElOfficeXMLSignatureDefinition_get_SigningLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, set_SigningLocation, arginfo_TElOfficeXMLSignatureDefinition_set_SigningLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, get_SignerName, arginfo_TElOfficeXMLSignatureDefinition_get_SignerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, set_SignerName, arginfo_TElOfficeXMLSignatureDefinition_set_SignerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, get_SpotID, arginfo_TElOfficeXMLSignatureDefinition_get_SpotID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, set_SpotID, arginfo_TElOfficeXMLSignatureDefinition_set_SpotID, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, get_SpotLocation, arginfo_TElOfficeXMLSignatureDefinition_get_SpotLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLSignatureDefinition, __construct, arginfo_TElOfficeXMLSignatureDefinition___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLSignatureDefinition(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLSignatureDefinition_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLSignatureDefinition", TElOfficeXMLSignatureDefinition_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElOfficeXMLSignatureDefinition_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLFixedDocumentSequence_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLFixedDocumentSequence, Add)
{
	char *sDocRef;
	int sDocRef_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDocRef, &sDocRef_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLFixedDocumentSequence_Add(SBGetObjectHandle(getThis() TSRMLS_CC), sDocRef, (int32_t)sDocRef_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocumentSequence, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLFixedDocumentSequence_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocumentSequence, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLFixedDocumentSequence_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocumentSequence, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLFixedDocumentSequence_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocumentSequence, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLFixedDocumentSequence_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLFixedDocumentSequence_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocumentSequence, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLFixedDocumentSequence_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocumentSequence, get_DocumentReferences)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLFixedDocumentSequence_get_DocumentReferences(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-625651289, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocumentSequence, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLFixedDocumentSequence_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocumentSequence_Add, 0, 0, 1)
	ZEND_ARG_INFO(0, DocRef)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocumentSequence_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocumentSequence_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocumentSequence_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocumentSequence_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocumentSequence_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocumentSequence_get_DocumentReferences, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocumentSequence___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLFixedDocumentSequence_methods[] = {
	PHP_ME(TElOfficeXMLFixedDocumentSequence, Add, arginfo_TElOfficeXMLFixedDocumentSequence_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocumentSequence, Delete, arginfo_TElOfficeXMLFixedDocumentSequence_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocumentSequence, Clear, arginfo_TElOfficeXMLFixedDocumentSequence_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocumentSequence, LoadFromXML, arginfo_TElOfficeXMLFixedDocumentSequence_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocumentSequence, SaveToXML, arginfo_TElOfficeXMLFixedDocumentSequence_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocumentSequence, get_Count, arginfo_TElOfficeXMLFixedDocumentSequence_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocumentSequence, get_DocumentReferences, arginfo_TElOfficeXMLFixedDocumentSequence_get_DocumentReferences, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocumentSequence, __construct, arginfo_TElOfficeXMLFixedDocumentSequence___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLFixedDocumentSequence(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLFixedDocumentSequence_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLFixedDocumentSequence", TElOfficeXMLFixedDocumentSequence_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElOfficeXMLFixedDocumentSequence_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLPageContent_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLPageContent, AddLinkTarget)
{
	char *sName;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLPageContent_AddLinkTarget(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, DeleteLinkTarget)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPageContent_DeleteLinkTarget(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPageContent_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPageContent_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLPageContent_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLPageContent_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, get_Source)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLPageContent_get_Source(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1662997969, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, set_Source)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPageContent_set_Source(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, get_Width)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLPageContent_get_Width(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, set_Width)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPageContent_set_Width(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, get_Height)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLPageContent_get_Height(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, set_Height)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLPageContent_set_Height(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, get_LinkTargetCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLPageContent_get_LinkTargetCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, get_LinkTargets)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOfficeXMLPageContent_get_LinkTargets(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(385774551, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLPageContent, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLPageContent_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_AddLinkTarget, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_DeleteLinkTarget, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_get_Source, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_set_Source, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_get_Width, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_set_Width, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_get_Height, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_set_Height, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_get_LinkTargetCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent_get_LinkTargets, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLPageContent___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLPageContent_methods[] = {
	PHP_ME(TElOfficeXMLPageContent, AddLinkTarget, arginfo_TElOfficeXMLPageContent_AddLinkTarget, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, DeleteLinkTarget, arginfo_TElOfficeXMLPageContent_DeleteLinkTarget, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, Clear, arginfo_TElOfficeXMLPageContent_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, LoadFromXML, arginfo_TElOfficeXMLPageContent_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, SaveToXML, arginfo_TElOfficeXMLPageContent_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, get_Source, arginfo_TElOfficeXMLPageContent_get_Source, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, set_Source, arginfo_TElOfficeXMLPageContent_set_Source, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, get_Width, arginfo_TElOfficeXMLPageContent_get_Width, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, set_Width, arginfo_TElOfficeXMLPageContent_set_Width, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, get_Height, arginfo_TElOfficeXMLPageContent_get_Height, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, set_Height, arginfo_TElOfficeXMLPageContent_set_Height, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, get_LinkTargetCount, arginfo_TElOfficeXMLPageContent_get_LinkTargetCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, get_LinkTargets, arginfo_TElOfficeXMLPageContent_get_LinkTargets, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLPageContent, __construct, arginfo_TElOfficeXMLPageContent___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLPageContent(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLPageContent_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLPageContent", TElOfficeXMLPageContent_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElOfficeXMLPageContent_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOfficeXMLFixedDocument_ce_ptr = NULL;

SB_PHP_METHOD(TElOfficeXMLFixedDocument, Add)
{
	zval *oPageContent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPageContent, TElOfficeXMLPageContent_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLFixedDocument_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPageContent TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeXMLPageContent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocument, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLFixedDocument_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocument, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOfficeXMLFixedDocument_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocument, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOfficeXMLFixedDocument_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocument, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLFixedDocument_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLFixedDocument_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocument, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOfficeXMLFixedDocument_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocument, get_PageContents)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLFixedDocument_get_PageContents(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOfficeXMLPageContent_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOfficeXMLFixedDocument, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOfficeXMLFixedDocument_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocument_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, PageContent, TElOfficeXMLPageContent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocument_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocument_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocument_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocument_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocument_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocument_get_PageContents, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOfficeXMLFixedDocument___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOfficeXMLFixedDocument_methods[] = {
	PHP_ME(TElOfficeXMLFixedDocument, Add, arginfo_TElOfficeXMLFixedDocument_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocument, Delete, arginfo_TElOfficeXMLFixedDocument_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocument, Clear, arginfo_TElOfficeXMLFixedDocument_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocument, LoadFromXML, arginfo_TElOfficeXMLFixedDocument_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocument, SaveToXML, arginfo_TElOfficeXMLFixedDocument_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocument, get_Count, arginfo_TElOfficeXMLFixedDocument_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocument, get_PageContents, arginfo_TElOfficeXMLFixedDocument_get_PageContents, ZEND_ACC_PUBLIC)
	PHP_ME(TElOfficeXMLFixedDocument, __construct, arginfo_TElOfficeXMLFixedDocument___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOfficeXMLFixedDocument(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOfficeXMLFixedDocument_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOfficeXMLFixedDocument", TElOfficeXMLFixedDocument_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElOfficeXMLFixedDocument_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOpenOfficeXMLManifestAlgorithm_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenOfficeXMLManifestAlgorithm, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestAlgorithm_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestAlgorithm, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestAlgorithm_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestAlgorithm, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestAlgorithm_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestAlgorithm_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestAlgorithm, get_AlgorithmName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeXMLManifestAlgorithm_get_AlgorithmName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(286051589, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestAlgorithm, set_AlgorithmName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestAlgorithm_set_AlgorithmName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestAlgorithm, get_IV)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOpenOfficeXMLManifestAlgorithm_get_IV(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1097412376, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestAlgorithm, set_IV)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOpenOfficeXMLManifestAlgorithm_set_IV(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestAlgorithm, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestAlgorithm_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestAlgorithm_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestAlgorithm_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestAlgorithm_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestAlgorithm_get_AlgorithmName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestAlgorithm_set_AlgorithmName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestAlgorithm_get_IV, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestAlgorithm_set_IV, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestAlgorithm___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenOfficeXMLManifestAlgorithm_methods[] = {
	PHP_ME(TElOpenOfficeXMLManifestAlgorithm, Clear, arginfo_TElOpenOfficeXMLManifestAlgorithm_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestAlgorithm, LoadFromXML, arginfo_TElOpenOfficeXMLManifestAlgorithm_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestAlgorithm, SaveToXML, arginfo_TElOpenOfficeXMLManifestAlgorithm_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestAlgorithm, get_AlgorithmName, arginfo_TElOpenOfficeXMLManifestAlgorithm_get_AlgorithmName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestAlgorithm, set_AlgorithmName, arginfo_TElOpenOfficeXMLManifestAlgorithm_set_AlgorithmName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestAlgorithm, get_IV, arginfo_TElOpenOfficeXMLManifestAlgorithm_get_IV, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestAlgorithm, set_IV, arginfo_TElOpenOfficeXMLManifestAlgorithm_set_IV, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestAlgorithm, __construct, arginfo_TElOpenOfficeXMLManifestAlgorithm___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenOfficeXMLManifestAlgorithm(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenOfficeXMLManifestAlgorithm_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenOfficeXMLManifestAlgorithm", TElOpenOfficeXMLManifestAlgorithm_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOpenOfficeXMLManifestAlgorithm_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOpenOfficeXMLManifestKeyDerivation_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenOfficeXMLManifestKeyDerivation, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestKeyDerivation_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestKeyDerivation, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestKeyDerivation_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestKeyDerivation, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestKeyDerivation_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestKeyDerivation_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestKeyDerivation, get_IterationCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOpenOfficeXMLManifestKeyDerivation_get_IterationCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestKeyDerivation, set_IterationCount)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestKeyDerivation_set_IterationCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestKeyDerivation, get_KeyDerivationName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeXMLManifestKeyDerivation_get_KeyDerivationName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1722159515, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestKeyDerivation, set_KeyDerivationName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestKeyDerivation_set_KeyDerivationName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestKeyDerivation, get_KeySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOpenOfficeXMLManifestKeyDerivation_get_KeySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestKeyDerivation, set_KeySize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestKeyDerivation_set_KeySize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestKeyDerivation, get_Salt)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOpenOfficeXMLManifestKeyDerivation_get_Salt(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2094983757, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestKeyDerivation, set_Salt)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOpenOfficeXMLManifestKeyDerivation_set_Salt(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestKeyDerivation, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestKeyDerivation_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestKeyDerivation_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestKeyDerivation_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestKeyDerivation_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestKeyDerivation_get_IterationCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestKeyDerivation_set_IterationCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestKeyDerivation_get_KeyDerivationName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestKeyDerivation_set_KeyDerivationName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestKeyDerivation_get_KeySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestKeyDerivation_set_KeySize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestKeyDerivation_get_Salt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestKeyDerivation_set_Salt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestKeyDerivation___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenOfficeXMLManifestKeyDerivation_methods[] = {
	PHP_ME(TElOpenOfficeXMLManifestKeyDerivation, Clear, arginfo_TElOpenOfficeXMLManifestKeyDerivation_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestKeyDerivation, LoadFromXML, arginfo_TElOpenOfficeXMLManifestKeyDerivation_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestKeyDerivation, SaveToXML, arginfo_TElOpenOfficeXMLManifestKeyDerivation_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestKeyDerivation, get_IterationCount, arginfo_TElOpenOfficeXMLManifestKeyDerivation_get_IterationCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestKeyDerivation, set_IterationCount, arginfo_TElOpenOfficeXMLManifestKeyDerivation_set_IterationCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestKeyDerivation, get_KeyDerivationName, arginfo_TElOpenOfficeXMLManifestKeyDerivation_get_KeyDerivationName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestKeyDerivation, set_KeyDerivationName, arginfo_TElOpenOfficeXMLManifestKeyDerivation_set_KeyDerivationName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestKeyDerivation, get_KeySize, arginfo_TElOpenOfficeXMLManifestKeyDerivation_get_KeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestKeyDerivation, set_KeySize, arginfo_TElOpenOfficeXMLManifestKeyDerivation_set_KeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestKeyDerivation, get_Salt, arginfo_TElOpenOfficeXMLManifestKeyDerivation_get_Salt, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestKeyDerivation, set_Salt, arginfo_TElOpenOfficeXMLManifestKeyDerivation_set_Salt, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestKeyDerivation, __construct, arginfo_TElOpenOfficeXMLManifestKeyDerivation___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenOfficeXMLManifestKeyDerivation(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenOfficeXMLManifestKeyDerivation_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenOfficeXMLManifestKeyDerivation", TElOpenOfficeXMLManifestKeyDerivation_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOpenOfficeXMLManifestKeyDerivation_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOpenOfficeXMLManifestStartKeyGeneration_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenOfficeXMLManifestStartKeyGeneration, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestStartKeyGeneration_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestStartKeyGeneration, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestStartKeyGeneration_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestStartKeyGeneration, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestStartKeyGeneration_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestStartKeyGeneration_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestStartKeyGeneration, get_KeySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOpenOfficeXMLManifestStartKeyGeneration_get_KeySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestStartKeyGeneration, set_KeySize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestStartKeyGeneration_set_KeySize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestStartKeyGeneration, get_StartKeyGenerationName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeXMLManifestStartKeyGeneration_get_StartKeyGenerationName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1899420940, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestStartKeyGeneration, set_StartKeyGenerationName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestStartKeyGeneration_set_StartKeyGenerationName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestStartKeyGeneration, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestStartKeyGeneration_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_get_KeySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_set_KeySize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_get_StartKeyGenerationName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_set_StartKeyGenerationName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestStartKeyGeneration___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenOfficeXMLManifestStartKeyGeneration_methods[] = {
	PHP_ME(TElOpenOfficeXMLManifestStartKeyGeneration, Clear, arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestStartKeyGeneration, LoadFromXML, arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestStartKeyGeneration, SaveToXML, arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestStartKeyGeneration, get_KeySize, arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_get_KeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestStartKeyGeneration, set_KeySize, arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_set_KeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestStartKeyGeneration, get_StartKeyGenerationName, arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_get_StartKeyGenerationName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestStartKeyGeneration, set_StartKeyGenerationName, arginfo_TElOpenOfficeXMLManifestStartKeyGeneration_set_StartKeyGenerationName, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestStartKeyGeneration, __construct, arginfo_TElOpenOfficeXMLManifestStartKeyGeneration___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenOfficeXMLManifestStartKeyGeneration(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenOfficeXMLManifestStartKeyGeneration_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenOfficeXMLManifestStartKeyGeneration", TElOpenOfficeXMLManifestStartKeyGeneration_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOpenOfficeXMLManifestStartKeyGeneration_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOpenOfficeXMLManifestEncryptionData_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenOfficeXMLManifestEncryptionData, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestEncryptionData_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestEncryptionData, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestEncryptionData_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestEncryptionData, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestEncryptionData_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestEncryptionData_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestEncryptionData, get_Checksum)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElOpenOfficeXMLManifestEncryptionData_get_Checksum(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1421802494, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestEncryptionData, set_Checksum)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElOpenOfficeXMLManifestEncryptionData_set_Checksum(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestEncryptionData, get_ChecksumType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeXMLManifestEncryptionData_get_ChecksumType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(147735416, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestEncryptionData, set_ChecksumType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestEncryptionData_set_ChecksumType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestEncryptionData, get_Algorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestEncryptionData_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOpenOfficeXMLManifestAlgorithm_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestEncryptionData, get_KeyDerivation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestEncryptionData_get_KeyDerivation(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOpenOfficeXMLManifestKeyDerivation_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestEncryptionData, get_StartKeyGeneration)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestEncryptionData_get_StartKeyGeneration(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOpenOfficeXMLManifestStartKeyGeneration_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestEncryptionData, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestEncryptionData_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestEncryptionData_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestEncryptionData_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestEncryptionData_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestEncryptionData_get_Checksum, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestEncryptionData_set_Checksum, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestEncryptionData_get_ChecksumType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestEncryptionData_set_ChecksumType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestEncryptionData_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestEncryptionData_get_KeyDerivation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestEncryptionData_get_StartKeyGeneration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestEncryptionData___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenOfficeXMLManifestEncryptionData_methods[] = {
	PHP_ME(TElOpenOfficeXMLManifestEncryptionData, Clear, arginfo_TElOpenOfficeXMLManifestEncryptionData_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestEncryptionData, LoadFromXML, arginfo_TElOpenOfficeXMLManifestEncryptionData_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestEncryptionData, SaveToXML, arginfo_TElOpenOfficeXMLManifestEncryptionData_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestEncryptionData, get_Checksum, arginfo_TElOpenOfficeXMLManifestEncryptionData_get_Checksum, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestEncryptionData, set_Checksum, arginfo_TElOpenOfficeXMLManifestEncryptionData_set_Checksum, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestEncryptionData, get_ChecksumType, arginfo_TElOpenOfficeXMLManifestEncryptionData_get_ChecksumType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestEncryptionData, set_ChecksumType, arginfo_TElOpenOfficeXMLManifestEncryptionData_set_ChecksumType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestEncryptionData, get_Algorithm, arginfo_TElOpenOfficeXMLManifestEncryptionData_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestEncryptionData, get_KeyDerivation, arginfo_TElOpenOfficeXMLManifestEncryptionData_get_KeyDerivation, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestEncryptionData, get_StartKeyGeneration, arginfo_TElOpenOfficeXMLManifestEncryptionData_get_StartKeyGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestEncryptionData, __construct, arginfo_TElOpenOfficeXMLManifestEncryptionData___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenOfficeXMLManifestEncryptionData(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenOfficeXMLManifestEncryptionData_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenOfficeXMLManifestEncryptionData", TElOpenOfficeXMLManifestEncryptionData_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOpenOfficeXMLManifestEncryptionData_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOpenOfficeXMLManifestFileEntry_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, get_IsEncrypted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_get_IsEncrypted(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, get_EncryptionData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_get_EncryptionData(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOpenOfficeXMLManifestEncryptionData_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, get_FullPath)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeXMLManifestFileEntry_get_FullPath(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1551237872, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, set_FullPath)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_set_FullPath(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, get_MediaType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeXMLManifestFileEntry_get_MediaType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-863833276, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, set_MediaType)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_set_MediaType(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, get_PreferredViewMode)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeXMLManifestFileEntry_get_PreferredViewMode(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1023042605, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, set_PreferredViewMode)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_set_PreferredViewMode(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, set_Size)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_set_Size(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, get_Version)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElOpenOfficeXMLManifestFileEntry_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1049693767, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, set_Version)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifestFileEntry, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifestFileEntry_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_get_IsEncrypted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_get_EncryptionData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_get_FullPath, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_set_FullPath, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_get_MediaType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_set_MediaType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_get_PreferredViewMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_set_PreferredViewMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_set_Size, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifestFileEntry___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenOfficeXMLManifestFileEntry_methods[] = {
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, Clear, arginfo_TElOpenOfficeXMLManifestFileEntry_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, LoadFromXML, arginfo_TElOpenOfficeXMLManifestFileEntry_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, SaveToXML, arginfo_TElOpenOfficeXMLManifestFileEntry_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, get_IsEncrypted, arginfo_TElOpenOfficeXMLManifestFileEntry_get_IsEncrypted, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, get_EncryptionData, arginfo_TElOpenOfficeXMLManifestFileEntry_get_EncryptionData, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, get_FullPath, arginfo_TElOpenOfficeXMLManifestFileEntry_get_FullPath, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, set_FullPath, arginfo_TElOpenOfficeXMLManifestFileEntry_set_FullPath, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, get_MediaType, arginfo_TElOpenOfficeXMLManifestFileEntry_get_MediaType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, set_MediaType, arginfo_TElOpenOfficeXMLManifestFileEntry_set_MediaType, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, get_PreferredViewMode, arginfo_TElOpenOfficeXMLManifestFileEntry_get_PreferredViewMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, set_PreferredViewMode, arginfo_TElOpenOfficeXMLManifestFileEntry_set_PreferredViewMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, get_Size, arginfo_TElOpenOfficeXMLManifestFileEntry_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, set_Size, arginfo_TElOpenOfficeXMLManifestFileEntry_set_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, get_Version, arginfo_TElOpenOfficeXMLManifestFileEntry_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, set_Version, arginfo_TElOpenOfficeXMLManifestFileEntry_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifestFileEntry, __construct, arginfo_TElOpenOfficeXMLManifestFileEntry___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenOfficeXMLManifestFileEntry(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenOfficeXMLManifestFileEntry_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenOfficeXMLManifestFileEntry", TElOpenOfficeXMLManifestFileEntry_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOpenOfficeXMLManifestFileEntry_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElOpenOfficeXMLManifest_ce_ptr = NULL;

SB_PHP_METHOD(TElOpenOfficeXMLManifest, Add)
{
	char *sFullPath;
	char *sMediaType;
	int sFullPath_len;
	int sMediaType_len;
	zval *oAFileEntry;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAFileEntry, TElOpenOfficeXMLManifestFileEntry_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOpenOfficeXMLManifest_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAFileEntry TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sFullPath, &sFullPath_len, &sMediaType, &sMediaType_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOpenOfficeXMLManifest_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFullPath, (int32_t)sFullPath_len, sMediaType, (int32_t)sMediaType_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElOpenOfficeXMLManifestFileEntry) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifest, Insert)
{
	long l4Index;
	zval *oAFileEntry;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAFileEntry, TElOpenOfficeXMLManifestFileEntry_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifest_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAFileEntry TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElOpenOfficeXMLManifestFileEntry)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifest, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifest_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifest, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifest_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifest, GetFileEntryByFullPath)
{
	char *sFullPath;
	int sFullPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFullPath, &sFullPath_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifest_GetFileEntryByFullPath(SBGetObjectHandle(getThis() TSRMLS_CC), sFullPath, (int32_t)sFullPath_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOpenOfficeXMLManifestFileEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifest, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElOpenOfficeXMLManifest_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifest, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifest_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifest_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifest, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElOpenOfficeXMLManifest_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifest, get_FileEntries)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifest_get_FileEntries(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElOpenOfficeXMLManifestFileEntry_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElOpenOfficeXMLManifest, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElOpenOfficeXMLManifest_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifest_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AFileEntry_or_FullPath, 0, 1)
	ZEND_ARG_INFO(0, MediaType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifest_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AFileEntry, TElOpenOfficeXMLManifestFileEntry, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifest_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifest_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifest_GetFileEntryByFullPath, 0, 0, 1)
	ZEND_ARG_INFO(0, FullPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifest_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifest_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifest_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifest_get_FileEntries, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElOpenOfficeXMLManifest___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElOpenOfficeXMLManifest_methods[] = {
	PHP_ME(TElOpenOfficeXMLManifest, Add, arginfo_TElOpenOfficeXMLManifest_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifest, Insert, arginfo_TElOpenOfficeXMLManifest_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifest, Delete, arginfo_TElOpenOfficeXMLManifest_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifest, Clear, arginfo_TElOpenOfficeXMLManifest_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifest, GetFileEntryByFullPath, arginfo_TElOpenOfficeXMLManifest_GetFileEntryByFullPath, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifest, LoadFromXML, arginfo_TElOpenOfficeXMLManifest_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifest, SaveToXML, arginfo_TElOpenOfficeXMLManifest_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifest, get_Count, arginfo_TElOpenOfficeXMLManifest_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifest, get_FileEntries, arginfo_TElOpenOfficeXMLManifest_get_FileEntries, ZEND_ACC_PUBLIC)
	PHP_ME(TElOpenOfficeXMLManifest, __construct, arginfo_TElOpenOfficeXMLManifest___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElOpenOfficeXMLManifest(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElOpenOfficeXMLManifest_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElOpenOfficeXMLManifest", TElOpenOfficeXMLManifest_methods);
	if (NULL == TElOfficeOpenXMLElement_ce_ptr)
		Register_TElOfficeOpenXMLElement(TSRMLS_C);
	TElOpenOfficeXMLManifest_ce_ptr = zend_register_internal_class_ex(&ce, TElOfficeOpenXMLElement_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBOfficeXMLCore, IsValidPartIRI)
{
	char *sIRI;
	int sIRI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sIRI, &sIRI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBOfficeXMLCore_IsValidPartIRI(sIRI, (int32_t)sIRI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, IsValidPartURI)
{
	char *sURI;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBOfficeXMLCore_IsValidPartURI(sURI, (int32_t)sURI_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, ConvertPartIRIToURI)
{
	char *sIRI;
	int sIRI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sIRI, &sIRI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_ConvertPartIRIToURI(sIRI, (int32_t)sIRI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(801477801, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, ConvertPartURIToIRI)
{
	char *sURI;
	int sURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_ConvertPartURIToIRI(sURI, (int32_t)sURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-9801094, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, ComparePartIRI)
{
	char *sX;
	char *sY;
	int sX_len;
	int sY_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sX, &sX_len, &sY, &sY_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBOfficeXMLCore_ComparePartIRI(sX, (int32_t)sX_len, sY, (int32_t)sY_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, ComparePartURI)
{
	char *sX;
	char *sY;
	int sX_len;
	int sY_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sX, &sX_len, &sY, &sY_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBOfficeXMLCore_ComparePartURI(sX, (int32_t)sX_len, sY, (int32_t)sY_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, NormalizePartIRI)
{
	char *sIRI;
	int sIRI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sIRI, &sIRI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_NormalizePartIRI(sIRI, (int32_t)sIRI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-37187060, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, NormalizePartURI)
{
	char *sURI;
	int sURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_NormalizePartURI(sURI, (int32_t)sURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1803625732, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, ResolveRelativePartIRI)
{
	char *sBaseIRI;
	char *sTargetIRI;
	int sBaseIRI_len;
	int sTargetIRI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sBaseIRI, &sBaseIRI_len, &sTargetIRI, &sTargetIRI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_ResolveRelativePartIRI(sBaseIRI, (int32_t)sBaseIRI_len, sTargetIRI, (int32_t)sTargetIRI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1132668677, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, ResolveRelativePartURI)
{
	char *sBaseURI;
	char *sTargetURI;
	int sBaseURI_len;
	int sTargetURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sBaseURI, &sBaseURI_len, &sTargetURI, &sTargetURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_ResolveRelativePartURI(sBaseURI, (int32_t)sBaseURI_len, sTargetURI, (int32_t)sTargetURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1291373468, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, GetRelativePartURI)
{
	char *sBaseURI;
	char *sURI;
	int sBaseURI_len;
	int sURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sURI, &sURI_len, &sBaseURI, &sBaseURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_GetRelativePartURI(sURI, (int32_t)sURI_len, sBaseURI, (int32_t)sBaseURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-506918966, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, GetRelationshipURI)
{
	char *sPartURI;
	int sPartURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPartURI, &sPartURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_GetRelationshipURI(sPartURI, (int32_t)sPartURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(854082343, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, GetPartURIExtension)
{
	char *sURI;
	int sURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_GetPartURIExtension(sURI, (int32_t)sURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1795341552, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, GetPartURIPath)
{
	char *sURI;
	int sURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_GetPartURIPath(sURI, (int32_t)sURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1261753645, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, GetPartURIName)
{
	char *sURI;
	int sURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_GetPartURIName(sURI, (int32_t)sURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1011110045, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, GetPartURIQueryComponent)
{
	char *sURI;
	int sURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_GetPartURIQueryComponent(sURI, (int32_t)sURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1837785038, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, RemovePartURIExtension)
{
	char *sURI;
	int sURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_RemovePartURIExtension(sURI, (int32_t)sURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1570077630, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, RemovePartIRIQueryComponent)
{
	char *sIRI;
	int sIRI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sIRI, &sIRI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_RemovePartIRIQueryComponent(sIRI, (int32_t)sIRI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1733538700, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, RemovePartURIQueryComponent)
{
	char *sURI;
	int sURI_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_RemovePartURIQueryComponent(sURI, (int32_t)sURI_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1249695014, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, GetValueFromQueryComponent)
{
	char *sKey;
	char *sQuery;
	int sKey_len;
	int sQuery_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sQuery, &sQuery_len, &sKey, &sKey_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_GetValueFromQueryComponent(sQuery, (int32_t)sQuery_len, sKey, (int32_t)sKey_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1202203801, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, IsLogicalItemSuffixName)
{
	char *sSuffixName;
	int sSuffixName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSuffixName, &sSuffixName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBOfficeXMLCore_IsLogicalItemSuffixName(sSuffixName, (int32_t)sSuffixName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, ParseLogicalItemSuffixName)
{
	char *sSuffixName;
	int sSuffixName_len;
	int8_t bIsLastRaw;
	zval *zbIsLast;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sSuffixName, &sSuffixName_len, &zbIsLast) == SUCCESS) && PZVAL_IS_REF(zbIsLast) && (IS_BOOL == Z_TYPE_P(zbIsLast)))
	{
		int32_t l4OutResultRaw = 0;
		bIsLastRaw = (int8_t)Z_BVAL_P(zbIsLast);
		SBCheckError(SBOfficeXMLCore_ParseLogicalItemSuffixName(sSuffixName, (int32_t)sSuffixName_len, &bIsLastRaw, &l4OutResultRaw) TSRMLS_CC);
		ZVAL_BOOL(zbIsLast, (zend_bool)bIsLastRaw);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, FormatLogicalItemSuffixName)
{
	long l4PieceNumber;
	uint32_t _err;
	zend_bool bIsLast;
	zend_bool bSkipSlash;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbb", &l4PieceNumber, &bIsLast, &bSkipSlash) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_FormatLogicalItemSuffixName((int32_t)l4PieceNumber, (int8_t)bIsLast, (int8_t)bSkipSlash, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1812580396, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, DecodeXMLEntities)
{
	char *sStr;
	int sStr_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_DecodeXMLEntities(sStr, (int32_t)sStr_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1747653219, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, EncodeXMLEntities)
{
	char *sStr;
	int sStr_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_EncodeXMLEntities(sStr, (int32_t)sStr_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-601103557, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, DecodeXMLName)
{
	char *sStr;
	int sStr_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_DecodeXMLName(sStr, (int32_t)sStr_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1816909424, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, EncodeXMLNameSimple)
{
	char *sStr;
	int sStr_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_EncodeXMLNameSimple(sStr, (int32_t)sStr_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1030837033, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, GenerateUniqueIdForRelationship)
{
	uint32_t _err;
	zval *oRelationships;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oRelationships, TElOfficeOpenXMLRelationships_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBOfficeXMLCore_GenerateUniqueIdForRelationship(SBGetObjectHandle(oRelationships TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(842750698, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElOfficeOpenXMLRelationships)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, GetOpenXMLDocumentTypeFromContentType)
{
	char *sContentType;
	int sContentType_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sContentType, &sContentType_len) == SUCCESS)
	{
		TSBOfficeOpenXMLDocumentTypeRaw fOutResultRaw = 0;
		SBCheckError(SBOfficeXMLCore_GetOpenXMLDocumentTypeFromContentType(sContentType, (int32_t)sContentType_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, GetOpenDocumentTypeFromMimeType)
{
	char *sMimeType;
	int sMimeType_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sMimeType, &sMimeType_len) == SUCCESS)
	{
		TSBOpenOfficeDocumentTypeRaw fOutResultRaw = 0;
		SBCheckError(SBOfficeXMLCore_GetOpenDocumentTypeFromMimeType(sMimeType, (int32_t)sMimeType_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBOfficeXMLCore, WideCompareStrOrdinal)
{
	char *sS1;
	char *sS2;
	int sS1_len;
	int sS2_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sS1, &sS1_len, &sS2, &sS2_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBOfficeXMLCore_WideCompareStrOrdinal(sS1, (int32_t)sS1_len, sS2, (int32_t)sS2_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

void Register_SBOfficeXMLCore_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlRelationshipsNamespace, SB_ooxmlRelationshipsNamespace, SB_ooxmlRelationshipsNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlOfficeRelationshipsNamespace, SB_ooxmlOfficeRelationshipsNamespace, SB_ooxmlOfficeRelationshipsNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlContentTypesNamespace, SB_ooxmlContentTypesNamespace, SB_ooxmlContentTypesNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlCorePropertiesNamespace, SB_ooxmlCorePropertiesNamespace, SB_ooxmlCorePropertiesNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlDigitalSignatureNamespace, SB_ooxmlDigitalSignatureNamespace, SB_ooxmlDigitalSignatureNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlMarkupCompatibilityNamespace, SB_ooxmlMarkupCompatibilityNamespace, SB_ooxmlMarkupCompatibilityNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlDublinCoreTermsNamespace, SB_ooxmlDublinCoreTermsNamespace, SB_ooxmlDublinCoreTermsNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlDublinCoreNamespace, SB_ooxmlDublinCoreNamespace, SB_ooxmlDublinCoreNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlOfficeEncryptionNamespace, SB_ooxmlOfficeEncryptionNamespace, SB_ooxmlOfficeEncryptionNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlKeyEncryptorPasswordNamespace, SB_ooxmlKeyEncryptorPasswordNamespace, SB_ooxmlKeyEncryptorPasswordNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlOfficeDigitalSignatureNamespace, SB_ooxmlOfficeDigitalSignatureNamespace, SB_ooxmlOfficeDigitalSignatureNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsNamespace_200506, SB_oxpsNamespace_200506, SB_oxpsNamespace_200506);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsNamespace_V1, SB_oxpsNamespace_V1, SB_oxpsNamespace_V1);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsNamespace_Latest, SB_oxpsNamespace_Latest, SB_oxpsNamespace_Latest);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsSignatureDefinitionsNamespace_200506, SB_oxpsSignatureDefinitionsNamespace_200506, SB_oxpsSignatureDefinitionsNamespace_200506);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsSignatureDefinitionsNamespace_V1, SB_oxpsSignatureDefinitionsNamespace_V1, SB_oxpsSignatureDefinitionsNamespace_V1);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsSignatureDefinitionsNamespace_Latest, SB_oxpsSignatureDefinitionsNamespace_Latest, SB_oxpsSignatureDefinitionsNamespace_Latest);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlMSVMLNamespace, SB_ooxmlMSVMLNamespace, SB_ooxmlMSVMLNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlMSOfficeNamespace, SB_ooxmlMSOfficeNamespace, SB_ooxmlMSOfficeNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlMSOfficeWordNamespace, SB_ooxmlMSOfficeWordNamespace, SB_ooxmlMSOfficeWordNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlMSOfficeExcelNamespace, SB_ooxmlMSOfficeExcelNamespace, SB_ooxmlMSOfficeExcelNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlMSOfficePowerpointNamespace, SB_ooxmlMSOfficePowerpointNamespace, SB_ooxmlMSOfficePowerpointNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfManifestNamespace, SB_odfManifestNamespace, SB_odfManifestNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfSignatureNamespace, SB_odfSignatureNamespace, SB_odfSignatureNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfPackageNamespace, SB_odfPackageNamespace, SB_odfPackageNamespace);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlDublinCoreTermsPrefix, SB_ooxmlDublinCoreTermsPrefix, SB_ooxmlDublinCoreTermsPrefix);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlDublinCorePrefix, SB_ooxmlDublinCorePrefix, SB_ooxmlDublinCorePrefix);
	SB_REGISTER_STRINGL_CONSTANT(SBOfficeXMLCore, ooxmlKeyEncryptorPasswordPrefix, SB_ooxmlKeyEncryptorPasswordPrefix, "" + SB_ooxmlKeyEncryptorPasswordPrefix, 1);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfManifestPrefix, SB_odfManifestPrefix, SB_odfManifestPrefix);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlOfficeDocumentRelationshipType, SB_ooxmlOfficeDocumentRelationshipType, SB_ooxmlOfficeDocumentRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlCorePropertiesRelationshipType, SB_ooxmlCorePropertiesRelationshipType, SB_ooxmlCorePropertiesRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlDigitalSignatureRelationshipType, SB_ooxmlDigitalSignatureRelationshipType, SB_ooxmlDigitalSignatureRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlDigitalSignatureOriginRelationshipType, SB_ooxmlDigitalSignatureOriginRelationshipType, SB_ooxmlDigitalSignatureOriginRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlDigitalSignatureCertificateRelationshipType, SB_ooxmlDigitalSignatureCertificateRelationshipType, SB_ooxmlDigitalSignatureCertificateRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlThumbnailRelationshipType, SB_ooxmlThumbnailRelationshipType, SB_ooxmlThumbnailRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlApplicationPropertiesRelationshipType, SB_ooxmlApplicationPropertiesRelationshipType, SB_ooxmlApplicationPropertiesRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlCustomXMLPropertiesRelationshipType, SB_ooxmlCustomXMLPropertiesRelationshipType, SB_ooxmlCustomXMLPropertiesRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlCustomXMLRelationshipType, SB_ooxmlCustomXMLRelationshipType, SB_ooxmlCustomXMLRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlCorePropertiesContentType, SB_ooxmlCorePropertiesContentType, SB_ooxmlCorePropertiesContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlApplicationPropertiesContentType, SB_ooxmlApplicationPropertiesContentType, SB_ooxmlApplicationPropertiesContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlDigitalSignatureCertificateContentType, SB_ooxmlDigitalSignatureCertificateContentType, SB_ooxmlDigitalSignatureCertificateContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlDigitalSignatureOriginContentType, SB_ooxmlDigitalSignatureOriginContentType, SB_ooxmlDigitalSignatureOriginContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlDigitalSignatureXMLSignatureContentType, SB_ooxmlDigitalSignatureXMLSignatureContentType, SB_ooxmlDigitalSignatureXMLSignatureContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlRelationshipsContentType, SB_ooxmlRelationshipsContentType, SB_ooxmlRelationshipsContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlCustomXMLPropertiesContentType, SB_ooxmlCustomXMLPropertiesContentType, SB_ooxmlCustomXMLPropertiesContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlWordprocessingMLContentType, SB_ooxmlWordprocessingMLContentType, SB_ooxmlWordprocessingMLContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlWordMacroEnabledContentType, SB_ooxmlWordMacroEnabledContentType, SB_ooxmlWordMacroEnabledContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlWordprocessingMLTemplateContentType, SB_ooxmlWordprocessingMLTemplateContentType, SB_ooxmlWordprocessingMLTemplateContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlWordTemplateMacroEnabledContentType, SB_ooxmlWordTemplateMacroEnabledContentType, SB_ooxmlWordTemplateMacroEnabledContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlSpreadsheetMLContentType, SB_ooxmlSpreadsheetMLContentType, SB_ooxmlSpreadsheetMLContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlSpreadsheetMLWorksheetContentType, SB_ooxmlSpreadsheetMLWorksheetContentType, SB_ooxmlSpreadsheetMLWorksheetContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlExcelMacroEnabledContentType, SB_ooxmlExcelMacroEnabledContentType, SB_ooxmlExcelMacroEnabledContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlSpreadsheetMLTemplateContentType, SB_ooxmlSpreadsheetMLTemplateContentType, SB_ooxmlSpreadsheetMLTemplateContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlExcelTemplateMacroEnabledContentType, SB_ooxmlExcelTemplateMacroEnabledContentType, SB_ooxmlExcelTemplateMacroEnabledContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlExcelBinaryMacroEnabledContentType, SB_ooxmlExcelBinaryMacroEnabledContentType, SB_ooxmlExcelBinaryMacroEnabledContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlExcelAddInMacroEnabledContentType, SB_ooxmlExcelAddInMacroEnabledContentType, SB_ooxmlExcelAddInMacroEnabledContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlPresentationMLContentType, SB_ooxmlPresentationMLContentType, SB_ooxmlPresentationMLContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlPowerPointMacroEnabledContentType, SB_ooxmlPowerPointMacroEnabledContentType, SB_ooxmlPowerPointMacroEnabledContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlPresentationMLTemplateContentType, SB_ooxmlPresentationMLTemplateContentType, SB_ooxmlPresentationMLTemplateContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlPowerPointTemplateMacroEnabledContentType, SB_ooxmlPowerPointTemplateMacroEnabledContentType, SB_ooxmlPowerPointTemplateMacroEnabledContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlPresentationMLSlideshowContentType, SB_ooxmlPresentationMLSlideshowContentType, SB_ooxmlPresentationMLSlideshowContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlPowerPointSlideshowMacroEnabledContentType, SB_ooxmlPowerPointSlideshowMacroEnabledContentType, SB_ooxmlPowerPointSlideshowMacroEnabledContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlPowerPointAddInMacroEnabledContentType, SB_ooxmlPowerPointAddInMacroEnabledContentType, SB_ooxmlPowerPointAddInMacroEnabledContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsSignatureDefinitionsContentType, SB_oxpsSignatureDefinitionsContentType, SB_oxpsSignatureDefinitionsContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsFixedDocumentContentType, SB_oxpsFixedDocumentContentType, SB_oxpsFixedDocumentContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsFixedDocumentSequenceContentType, SB_oxpsFixedDocumentSequenceContentType, SB_oxpsFixedDocumentSequenceContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsFixedPageContentType, SB_oxpsFixedPageContentType, SB_oxpsFixedPageContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsDiscardControlContentType, SB_oxpsDiscardControlContentType, SB_oxpsDiscardControlContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsDocumentStructureContentType, SB_oxpsDocumentStructureContentType, SB_oxpsDocumentStructureContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsFontContentType, SB_oxpsFontContentType, SB_oxpsFontContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsICCProfileContentType, SB_oxpsICCProfileContentType, SB_oxpsICCProfileContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsObfuscatedFontContentType, SB_oxpsObfuscatedFontContentType, SB_oxpsObfuscatedFontContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsStoryFragmentsContentType, SB_oxpsStoryFragmentsContentType, SB_oxpsStoryFragmentsContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsPrintTicketContentType, SB_oxpsPrintTicketContentType, SB_oxpsPrintTicketContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsDigitalSignatureDefinitionsRelationshipType, SB_oxpsDigitalSignatureDefinitionsRelationshipType, SB_oxpsDigitalSignatureDefinitionsRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsDiscardControlRelationshipType, SB_oxpsDiscardControlRelationshipType, SB_oxpsDiscardControlRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsDocumentStructureRelationshipType, SB_oxpsDocumentStructureRelationshipType, SB_oxpsDocumentStructureRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsPrintTicketRelationshipType, SB_oxpsPrintTicketRelationshipType, SB_oxpsPrintTicketRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsRequiredResourceRelationshipType, SB_oxpsRequiredResourceRelationshipType, SB_oxpsRequiredResourceRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsRestrictedFontRelationshipType, SB_oxpsRestrictedFontRelationshipType, SB_oxpsRestrictedFontRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsStartPartRelationshipType, SB_oxpsStartPartRelationshipType, SB_oxpsStartPartRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxpsStoryFragmentsRelationshipType, SB_oxpsStoryFragmentsRelationshipType, SB_oxpsStoryFragmentsRelationshipType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlTransformRelationship_2006, SB_ooxmlTransformRelationship_2006, SB_ooxmlTransformRelationship_2006);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlTransformRelationship_200506, SB_ooxmlTransformRelationship_200506, SB_ooxmlTransformRelationship_200506);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, ooxmlTransformRelationship_Latest, SB_ooxmlTransformRelationship_Latest, SB_ooxmlTransformRelationship_Latest);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxJPEGImageContentType, SB_oxJPEGImageContentType, SB_oxJPEGImageContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxPNGImageContentType, SB_oxPNGImageContentType, SB_oxPNGImageContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, oxTIFFImageContentType, SB_oxTIFFImageContentType, SB_oxTIFFImageContentType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentTextMimeType, SB_odfOpenDocumentTextMimeType, SB_odfOpenDocumentTextMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentTextTemplateMimeType, SB_odfOpenDocumentTextTemplateMimeType, SB_odfOpenDocumentTextTemplateMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentTextMasterMimeType, SB_odfOpenDocumentTextMasterMimeType, SB_odfOpenDocumentTextMasterMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentTextWebMimeType, SB_odfOpenDocumentTextWebMimeType, SB_odfOpenDocumentTextWebMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentSpreadsheetMimeType, SB_odfOpenDocumentSpreadsheetMimeType, SB_odfOpenDocumentSpreadsheetMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentSpreadsheetTemplateMimeType, SB_odfOpenDocumentSpreadsheetTemplateMimeType, SB_odfOpenDocumentSpreadsheetTemplateMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentDrawingMimeType, SB_odfOpenDocumentDrawingMimeType, SB_odfOpenDocumentDrawingMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentDrawingTemplateMimeType, SB_odfOpenDocumentDrawingTemplateMimeType, SB_odfOpenDocumentDrawingTemplateMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentPresentationMimeType, SB_odfOpenDocumentPresentationMimeType, SB_odfOpenDocumentPresentationMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentPresentationTemplateMimeType, SB_odfOpenDocumentPresentationTemplateMimeType, SB_odfOpenDocumentPresentationTemplateMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentChartMimeType, SB_odfOpenDocumentChartMimeType, SB_odfOpenDocumentChartMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentChartTemplateMimeType, SB_odfOpenDocumentChartTemplateMimeType, SB_odfOpenDocumentChartTemplateMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentImageMimeType, SB_odfOpenDocumentImageMimeType, SB_odfOpenDocumentImageMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentImageTemplateMimeType, SB_odfOpenDocumentImageTemplateMimeType, SB_odfOpenDocumentImageTemplateMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentFormulaMimeType, SB_odfOpenDocumentFormulaMimeType, SB_odfOpenDocumentFormulaMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentFormulaTemplateMimeType, SB_odfOpenDocumentFormulaTemplateMimeType, SB_odfOpenDocumentFormulaTemplateMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfOpenDocumentDatabaseMimeType, SB_odfOpenDocumentDatabaseMimeType, SB_odfOpenDocumentDatabaseMimeType);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfEncryptionMethodBlowfish, SB_odfEncryptionMethodBlowfish, SB_odfEncryptionMethodBlowfish);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfDigestMethodSHA1, SB_odfDigestMethodSHA1, SB_odfDigestMethodSHA1);
	SB_REGISTER_STRING_CONSTANT(SBOfficeXMLCore, odfDerivationMethodPBKDF2, SB_odfDerivationMethodPBKDF2, SB_odfDerivationMethodPBKDF2);
}

void Register_SBOfficeXMLCore_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBOfficeOpenXMLTargetMode", NULL);
	TSBOfficeOpenXMLTargetMode_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBOfficeOpenXMLTargetMode_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLTargetMode_ce_ptr, "tmInternal", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBOfficeOpenXMLTargetMode_ce_ptr, "tmExternal", 1)
}

