#include "sbpgpkeys.h"

zend_class_entry *TSBPGPUserCertificationType_ce_ptr = NULL;

zend_class_entry *TSBPGPKeyTrust_ce_ptr = NULL;

void SB_CALLBACK TSBPGPPasswordEventRaw(void * _ObjectData, TObjectHandle Sender, void * UserData, char * pcRes, int32_t * szRes)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zUserData;
	zval * zRes;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zUserData);
	SBInitPointerObject(zUserData, UserData TSRMLS_CC);
	MAKE_STD_ZVAL(zRes);
	ZVAL_STRINGL(zRes, pcRes, *szRes, 1);

	params[0] = &zSender;
	params[1] = &zUserData;
	params[2] = &zRes;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zUserData);
	SBCheckError(SBSetEventReturnStringA(3, Z_STRVAL_P(zRes), (int32_t)Z_STRLEN_P(zRes)) TSRMLS_CC);
	zval_ptr_dtor(&zRes);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBPGPBeforeSignEventRaw(void * _ObjectData, TObjectHandle Sender, TElPGPSignatureHandle Signature, TObjectHandle Subject)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zSignature;
	zval * zSubject;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSignature);
	SBInitObject(zSignature, TElPGPSignature_ce_ptr, Signature TSRMLS_CC);
	MAKE_STD_ZVAL(zSubject);
	SBInitObject(zSubject, TObject_ce_ptr, Subject TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSignature;
	params[2] = &zSubject;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSignature);
	zval_ptr_dtor(&zSubject);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElPGPCustomPublicKey_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPCustomPublicKey, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, AddSignature)
{
	zval *oSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_AddSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, RemoveSignature)
{
	long l4Index;
	zval *oSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_RemoveSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_RemoveSignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (TElPGPSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, ClearSignatures)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_ClearSignatures(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, Verify)
{
	zval *oHashFunction;
	zval *oKey;
	zval *oPublicKey;
	zval *oSignature;
	zval *oSubjectSignature;
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oPublicKey, TElPGPCustomPublicKey_ce_ptr, &oUser, TElPGPCustomUser_ce_ptr, &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_Verify(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPublicKey TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oKey, TElPGPCustomPublicKey_ce_ptr, &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_Verify_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oHashFunction, TElHashFunction_ce_ptr, &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_Verify_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHashFunction TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_Verify_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSubjectSignature, TElPGPSignature_ce_ptr, &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_Verify_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSubjectSignature TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPCustomPublicKey, TElPGPCustomUser, TElPGPSignature) or (TElPGPCustomPublicKey, TElPGPSignature) or (TElHashFunction, TElPGPSignature) or (TElPGPSignature) or (TElPGPSignature, TElPGPSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, DirectVerify)
{
	zval *oKey;
	zval *oSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oKey, TElPGPCustomPublicKey_ce_ptr, &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_DirectVerify(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPCustomPublicKey, TElPGPSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, RevocationVerify)
{
	zval *oKey;
	zval *oSignature;
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oKey, TElPGPCustomPublicKey_ce_ptr, &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_RevocationVerify(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oKey, TElPGPCustomPublicKey_ce_ptr, &oUser, TElPGPCustomUser_ce_ptr, &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_RevocationVerify_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPCustomPublicKey, TElPGPSignature) or (TElPGPCustomPublicKey, TElPGPCustomUser, TElPGPSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, DirectRevocationVerify)
{
	zval *oKey;
	zval *oSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oKey, TElPGPCustomPublicKey_ce_ptr, &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_DirectRevocationVerify(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPCustomPublicKey, TElPGPSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, ExportKeyMaterial)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPCustomPublicKey_ExportKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, ImportKeyMaterial)
{
	long l4Expires;
	long l4KeyVersion;
	zval *dtTimestamp;
	zval *oKeyMaterial;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeyMaterial, TElPublicKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_ImportKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyMaterial TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!Oll", &oKeyMaterial, TElPublicKeyMaterial_ce_ptr, &dtTimestamp, php_date_get_date_ce(), &l4KeyVersion, &l4Expires) == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_ImportKeyMaterial_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyMaterial TSRMLS_CC), SBGetDateTime(dtTimestamp TSRMLS_CC), (int32_t)l4KeyVersion, (int32_t)l4Expires) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyMaterial) or (TElPublicKeyMaterial, DateTime, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, Encrypt)
{
	SBArrayZValInfo aiData;
	zval *zaData;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaData) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaData)) || (IS_ARRAY == Z_TYPE_P(zaData)) || (IS_NULL == Z_TYPE_P(zaData))))
	{
		TSBPGPEncryptedSymmetricKey roOutResult;
		if (!SBGetByteArrayFromZVal(zaData, &aiData TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPCustomPublicKey_Encrypt(SBGetObjectHandle(getThis() TSRMLS_CC), aiData.data, aiData.len, &roOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiData);
		object_init_ex(return_value, TSBPGPEncryptedSymmetricKey_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBPGPEncryptedSymmetricKey) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, IsSigningKey)
{
	zend_bool bWithSubkeys;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bWithSubkeys) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_IsSigningKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bWithSubkeys, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, IsEncryptingKey)
{
	zend_bool bWithSubkeys;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bWithSubkeys) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_IsEncryptingKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bWithSubkeys, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, PrepareForEncryption)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_PrepareForEncryption(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, CancelPreparation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_CancelPreparation(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, AsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_AsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, AcquireLock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_AcquireLock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, ReleaseLock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_ReleaseLock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, KeyID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBKeyID roOutResult;
		SBCheckError(TElPGPCustomPublicKey_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBKeyID_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBKeyID) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, KeyFP)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPCustomPublicKey_KeyFP(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(97719037, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_Timestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_get_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, set_Timestamp)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_set_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_Expires)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_get_Expires(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, set_Expires)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_set_Expires(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_PublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_get_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_BitsInKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_get_BitsInKey(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_KeyHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_get_KeyHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, set_KeyHashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_set_KeyHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_QBits)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_get_QBits(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_Curve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_get_Curve(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_UseOldPackets)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_get_UseOldPackets(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, set_UseOldPackets)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_set_UseOldPackets(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_Signatures)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPCustomPublicKey_get_Signatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_SignatureCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_get_SignatureCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_Revoked)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_get_Revoked(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, get_Enabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomPublicKey_get_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, set_Enabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPCustomPublicKey_set_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomPublicKey, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPCustomPublicKey_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_AddSignature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Signature, TElPGPSignature, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_RemoveSignature, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Index_or_Signature, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_ClearSignatures, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_Verify, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, PublicKey_or_Key_or_HashFunction_or_Signature_or_SubjectSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, User_or_Signature, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Signature, TElPGPSignature, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_DirectVerify, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Key, TElPGPCustomPublicKey, 1)
	ZEND_ARG_OBJ_INFO(0, Signature, TElPGPSignature, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_RevocationVerify, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Key, TElPGPCustomPublicKey, 1)
	ZEND_ARG_TYPE_INFO(0, Signature_or_User, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Signature, TElPGPSignature, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_DirectRevocationVerify, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Key, TElPGPCustomPublicKey, 1)
	ZEND_ARG_OBJ_INFO(0, Signature, TElPGPSignature, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_ExportKeyMaterial, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_ImportKeyMaterial, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, KeyMaterial, TElPublicKeyMaterial, 1)
	ZEND_ARG_OBJ_INFO(0, Timestamp, DateTime, 0)
	ZEND_ARG_INFO(0, KeyVersion)
	ZEND_ARG_INFO(0, Expires)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_Encrypt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Data, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_IsSigningKey, 0, 0, 1)
	ZEND_ARG_INFO(0, WithSubkeys)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_IsEncryptingKey, 0, 0, 1)
	ZEND_ARG_INFO(0, WithSubkeys)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_PrepareForEncryption, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_CancelPreparation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_AsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_AcquireLock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_ReleaseLock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_KeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_KeyFP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_Timestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_set_Timestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_Expires, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_set_Expires, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_PublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_BitsInKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_KeyHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_set_KeyHashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_QBits, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_Curve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_UseOldPackets, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_set_UseOldPackets, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_Signatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_SignatureCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_Revoked, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_get_Enabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey_set_Enabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomPublicKey___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPCustomPublicKey_methods[] = {
	PHP_ME(TElPGPCustomPublicKey, Assign, arginfo_TElPGPCustomPublicKey_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, AssignTo, arginfo_TElPGPCustomPublicKey_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, AddSignature, arginfo_TElPGPCustomPublicKey_AddSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, RemoveSignature, arginfo_TElPGPCustomPublicKey_RemoveSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, ClearSignatures, arginfo_TElPGPCustomPublicKey_ClearSignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, Verify, arginfo_TElPGPCustomPublicKey_Verify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, DirectVerify, arginfo_TElPGPCustomPublicKey_DirectVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, RevocationVerify, arginfo_TElPGPCustomPublicKey_RevocationVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, DirectRevocationVerify, arginfo_TElPGPCustomPublicKey_DirectRevocationVerify, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, ExportKeyMaterial, arginfo_TElPGPCustomPublicKey_ExportKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, ImportKeyMaterial, arginfo_TElPGPCustomPublicKey_ImportKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, Encrypt, arginfo_TElPGPCustomPublicKey_Encrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, IsSigningKey, arginfo_TElPGPCustomPublicKey_IsSigningKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, IsEncryptingKey, arginfo_TElPGPCustomPublicKey_IsEncryptingKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, PrepareForEncryption, arginfo_TElPGPCustomPublicKey_PrepareForEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, CancelPreparation, arginfo_TElPGPCustomPublicKey_CancelPreparation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, AsyncOperationFinished, arginfo_TElPGPCustomPublicKey_AsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, AcquireLock, arginfo_TElPGPCustomPublicKey_AcquireLock, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, ReleaseLock, arginfo_TElPGPCustomPublicKey_ReleaseLock, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, KeyID, arginfo_TElPGPCustomPublicKey_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, KeyFP, arginfo_TElPGPCustomPublicKey_KeyFP, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_Timestamp, arginfo_TElPGPCustomPublicKey_get_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, set_Timestamp, arginfo_TElPGPCustomPublicKey_set_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_Expires, arginfo_TElPGPCustomPublicKey_get_Expires, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, set_Expires, arginfo_TElPGPCustomPublicKey_set_Expires, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_PublicKeyAlgorithm, arginfo_TElPGPCustomPublicKey_get_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_BitsInKey, arginfo_TElPGPCustomPublicKey_get_BitsInKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_KeyHashAlgorithm, arginfo_TElPGPCustomPublicKey_get_KeyHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, set_KeyHashAlgorithm, arginfo_TElPGPCustomPublicKey_set_KeyHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_QBits, arginfo_TElPGPCustomPublicKey_get_QBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_Curve, arginfo_TElPGPCustomPublicKey_get_Curve, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_Version, arginfo_TElPGPCustomPublicKey_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_UseOldPackets, arginfo_TElPGPCustomPublicKey_get_UseOldPackets, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, set_UseOldPackets, arginfo_TElPGPCustomPublicKey_set_UseOldPackets, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_Signatures, arginfo_TElPGPCustomPublicKey_get_Signatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_SignatureCount, arginfo_TElPGPCustomPublicKey_get_SignatureCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_Revoked, arginfo_TElPGPCustomPublicKey_get_Revoked, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, get_Enabled, arginfo_TElPGPCustomPublicKey_get_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, set_Enabled, arginfo_TElPGPCustomPublicKey_set_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomPublicKey, __construct, arginfo_TElPGPCustomPublicKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPCustomPublicKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPCustomPublicKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPCustomPublicKey", TElPGPCustomPublicKey_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElPGPCustomPublicKey_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPPublicSubkey_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPPublicSubkey, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicSubkey_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicSubkey, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicSubkey_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicSubkey, get_SecretKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicSubkey_get_SecretKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSecretSubkey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicSubkey, get_Supkey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicSubkey_get_Supkey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPPublicKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicSubkey, get_Trust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicSubkey_get_Trust(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPTrust_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicSubkey, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicSubkey_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicSubkey_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicSubkey_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicSubkey_get_SecretKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicSubkey_get_Supkey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicSubkey_get_Trust, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicSubkey___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPPublicSubkey_methods[] = {
	PHP_ME(TElPGPPublicSubkey, Assign, arginfo_TElPGPPublicSubkey_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicSubkey, AssignTo, arginfo_TElPGPPublicSubkey_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicSubkey, get_SecretKey, arginfo_TElPGPPublicSubkey_get_SecretKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicSubkey, get_Supkey, arginfo_TElPGPPublicSubkey_get_Supkey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicSubkey, get_Trust, arginfo_TElPGPPublicSubkey_get_Trust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicSubkey, __construct, arginfo_TElPGPPublicSubkey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPPublicSubkey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPPublicSubkey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPPublicSubkey", TElPGPPublicSubkey_methods);
	if (NULL == TElPGPCustomPublicKey_ce_ptr)
		Register_TElPGPCustomPublicKey(TSRMLS_C);
	TElPGPPublicSubkey_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPCustomPublicKey_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPPublicKey_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPPublicKey, RemoveSubkey)
{
	long l4Index;
	zval *oSubkey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_RemoveSubkey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSubkey, TElPGPPublicSubkey_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_RemoveSubkey_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSubkey TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (TElPGPPublicSubkey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, AssignFromX509)
{
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_AssignFromX509(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, LoadFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, LoadFromFile)
{
	char *sFilename;
	int sFilename_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_LoadFromFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, SaveToStream)
{
	zend_bool bArmor;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bArmor) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bArmor) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, SaveToFile)
{
	char *sFilename;
	int sFilename_len;
	zend_bool bArmor;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sFilename, &sFilename_len, &bArmor) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_SaveToFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, (int8_t)bArmor) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, AddSubkey)
{
	zval *oSubkey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSubkey, TElPGPPublicSubkey_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_AddSubkey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSubkey TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPPublicSubkey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, ClearSubkeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_ClearSubkeys(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, AddUserID)
{
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUser, TElPGPUserID_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_AddUserID(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPUserID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, AddUserAttr)
{
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUser, TElPGPUserAttr_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_AddUserAttr(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPUserAttr)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, RemoveUserID)
{
	long l4Index;
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_RemoveUserID(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUser, TElPGPUserID_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_RemoveUserID_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (TElPGPUserID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, RemoveUserAttr)
{
	long l4Index;
	zval *oUserAttr;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_RemoveUserAttr(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUserAttr, TElPGPUserAttr_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_RemoveUserAttr_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUserAttr TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (TElPGPUserAttr)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, ClearUserIDs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_ClearUserIDs(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, ClearUserAttrs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_ClearUserAttrs(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, PrepareForEncryption)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_PrepareForEncryption(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, CancelPreparation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_CancelPreparation(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, AsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_AsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_ArmorBoundary)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPPublicKey_get_ArmorBoundary(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1005579416, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, set_ArmorBoundary)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_set_ArmorBoundary(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_ArmorHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicKey_get_ArmorHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_Subkeys)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicKey_get_Subkeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPPublicSubkey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_UserIDs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicKey_get_UserIDs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPUserID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_UserAttrs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicKey_get_UserAttrs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPUserAttr_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_PreferredSymAlgs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_get_PreferredSymAlgs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_PreferredHashAlgs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_get_PreferredHashAlgs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_PreferredComprAlgs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_get_PreferredComprAlgs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_SubkeyCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_get_SubkeyCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_UserIDCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_get_UserIDCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_UserAttrCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_get_UserAttrCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_Trust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicKey_get_Trust(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPTrust_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_KeyTrust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPKeyTrustRaw fOutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_get_KeyTrust(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, set_KeyTrust)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_set_KeyTrust(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPKeyTrustRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_SecretKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicKey_get_SecretKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSecretKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_WriteOldPrefix)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_get_WriteOldPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, set_WriteOldPrefix)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPPublicKey_set_WriteOldPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_PreferredSymAlgCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_get_PreferredSymAlgCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_PreferredHashAlgCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_get_PreferredHashAlgCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, get_PreferredComprAlgCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPPublicKey_get_PreferredComprAlgCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPPublicKey, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPPublicKey_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_RemoveSubkey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Index_or_Subkey, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_AssignFromX509, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_LoadFromFile, 0, 0, 1)
	ZEND_ARG_INFO(0, Filename)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_SaveToStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Armor)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_SaveToFile, 0, 0, 2)
	ZEND_ARG_INFO(0, Filename)
	ZEND_ARG_INFO(0, Armor)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_AddSubkey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Subkey, TElPGPPublicSubkey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_ClearSubkeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_AddUserID, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, User, TElPGPUserID, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_AddUserAttr, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, User, TElPGPUserAttr, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_RemoveUserID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Index_or_User, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_RemoveUserAttr, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Index_or_UserAttr, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_ClearUserIDs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_ClearUserAttrs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_PrepareForEncryption, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_CancelPreparation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_AsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_ArmorBoundary, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_set_ArmorBoundary, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_ArmorHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_Subkeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_UserIDs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_UserAttrs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_PreferredSymAlgs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_PreferredHashAlgs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_PreferredComprAlgs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_SubkeyCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_UserIDCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_UserAttrCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_Trust, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_KeyTrust, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_set_KeyTrust, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_SecretKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_WriteOldPrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_set_WriteOldPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_PreferredSymAlgCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_PreferredHashAlgCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey_get_PreferredComprAlgCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPPublicKey___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPPublicKey_methods[] = {
	PHP_ME(TElPGPPublicKey, RemoveSubkey, arginfo_TElPGPPublicKey_RemoveSubkey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, Assign, arginfo_TElPGPPublicKey_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, AssignTo, arginfo_TElPGPPublicKey_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, AssignFromX509, arginfo_TElPGPPublicKey_AssignFromX509, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, LoadFromStream, arginfo_TElPGPPublicKey_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, LoadFromFile, arginfo_TElPGPPublicKey_LoadFromFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, SaveToStream, arginfo_TElPGPPublicKey_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, SaveToFile, arginfo_TElPGPPublicKey_SaveToFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, AddSubkey, arginfo_TElPGPPublicKey_AddSubkey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, ClearSubkeys, arginfo_TElPGPPublicKey_ClearSubkeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, AddUserID, arginfo_TElPGPPublicKey_AddUserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, AddUserAttr, arginfo_TElPGPPublicKey_AddUserAttr, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, RemoveUserID, arginfo_TElPGPPublicKey_RemoveUserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, RemoveUserAttr, arginfo_TElPGPPublicKey_RemoveUserAttr, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, ClearUserIDs, arginfo_TElPGPPublicKey_ClearUserIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, ClearUserAttrs, arginfo_TElPGPPublicKey_ClearUserAttrs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, PrepareForEncryption, arginfo_TElPGPPublicKey_PrepareForEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, CancelPreparation, arginfo_TElPGPPublicKey_CancelPreparation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, AsyncOperationFinished, arginfo_TElPGPPublicKey_AsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_ArmorBoundary, arginfo_TElPGPPublicKey_get_ArmorBoundary, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, set_ArmorBoundary, arginfo_TElPGPPublicKey_set_ArmorBoundary, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_ArmorHeaders, arginfo_TElPGPPublicKey_get_ArmorHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_Subkeys, arginfo_TElPGPPublicKey_get_Subkeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_UserIDs, arginfo_TElPGPPublicKey_get_UserIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_UserAttrs, arginfo_TElPGPPublicKey_get_UserAttrs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_PreferredSymAlgs, arginfo_TElPGPPublicKey_get_PreferredSymAlgs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_PreferredHashAlgs, arginfo_TElPGPPublicKey_get_PreferredHashAlgs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_PreferredComprAlgs, arginfo_TElPGPPublicKey_get_PreferredComprAlgs, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_SubkeyCount, arginfo_TElPGPPublicKey_get_SubkeyCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_UserIDCount, arginfo_TElPGPPublicKey_get_UserIDCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_UserAttrCount, arginfo_TElPGPPublicKey_get_UserAttrCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_Trust, arginfo_TElPGPPublicKey_get_Trust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_KeyTrust, arginfo_TElPGPPublicKey_get_KeyTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, set_KeyTrust, arginfo_TElPGPPublicKey_set_KeyTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_SecretKey, arginfo_TElPGPPublicKey_get_SecretKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_WriteOldPrefix, arginfo_TElPGPPublicKey_get_WriteOldPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, set_WriteOldPrefix, arginfo_TElPGPPublicKey_set_WriteOldPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_PreferredSymAlgCount, arginfo_TElPGPPublicKey_get_PreferredSymAlgCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_PreferredHashAlgCount, arginfo_TElPGPPublicKey_get_PreferredHashAlgCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, get_PreferredComprAlgCount, arginfo_TElPGPPublicKey_get_PreferredComprAlgCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPPublicKey, __construct, arginfo_TElPGPPublicKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPPublicKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPPublicKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPPublicKey", TElPGPPublicKey_methods);
	if (NULL == TElPGPCustomPublicKey_ce_ptr)
		Register_TElPGPCustomPublicKey(TSRMLS_C);
	TElPGPPublicKey_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPCustomPublicKey_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPCustomSecretKey_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPCustomSecretKey, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, Generate)
{
	char *sPassword;
	int sPassword_len;
	long l4Algorithm;
	long l4Bits;
	long l4Expires;
	zend_bool bUseOldFormat;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sllbl", &sPassword, &sPassword_len, &l4Bits, &l4Algorithm, &bUseOldFormat, &l4Expires) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), sPassword, (int32_t)sPassword_len, (int32_t)l4Bits, (int32_t)l4Algorithm, (int8_t)bUseOldFormat, (int32_t)l4Expires) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer, bool, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, BeginGenerate)
{
	long l4Algorithm;
	long l4Bits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Bits, &l4Algorithm) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_BeginGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, (int32_t)l4Algorithm) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, EndGenerate)
{
	char *sPassword;
	int sPassword_len;
	long l4Expires;
	zend_bool bUseOldFormat;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbl", &sPassword, &sPassword_len, &bUseOldFormat, &l4Expires) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_EndGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), sPassword, (int32_t)sPassword_len, (int8_t)bUseOldFormat, (int32_t)l4Expires) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, CancelGeneration)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_CancelGeneration(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, ChangePassphrase)
{
	char *sNewPassphrase;
	int sNewPassphrase_len;
	long fProtectionType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sNewPassphrase, &sNewPassphrase_len, &fProtectionType) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_ChangePassphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sNewPassphrase, (int32_t)sNewPassphrase_len, (TSBPGPProtectionTypeRaw)fProtectionType) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, ChangeProtection)
{
	char *sNewPassphrase;
	int sNewPassphrase_len;
	long fPrType;
	long l4EncAlgorithm;
	long l4HshAlgorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slll", &sNewPassphrase, &sNewPassphrase_len, &fPrType, &l4EncAlgorithm, &l4HshAlgorithm) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_ChangeProtection(SBGetObjectHandle(getThis() TSRMLS_CC), sNewPassphrase, (int32_t)sNewPassphrase_len, (TSBPGPProtectionTypeRaw)fPrType, (int32_t)l4EncAlgorithm, (int32_t)l4HshAlgorithm) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, Sign)
{
	long fCertType;
	long l4SignatureClass;
	zval *dtTimeStamp;
	zval *oEmbeddedSignature;
	zval *oHashFunction;
	zval *oKey;
	zval *oPublicKey;
	zval *oSignature;
	zval *oSubjectSignature;
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!l", &oPublicKey, TElPGPPublicKey_ce_ptr, &oUser, TElPGPCustomUser_ce_ptr, &oSignature, TElPGPSignature_ce_ptr, &fCertType) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_Sign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPublicKey TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), (TSBPGPUserCertificationTypeRaw)fCertType) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oKey, TElPGPCustomPublicKey_ce_ptr, &oSignature, TElPGPSignature_ce_ptr, &oEmbeddedSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_Sign_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), SBGetObjectHandle(oEmbeddedSignature TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO!", &dtTimeStamp, php_date_get_date_ce(), &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_Sign_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtTimeStamp TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSubjectSignature, TElPGPSignature_ce_ptr, &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_Sign_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSubjectSignature TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oHashFunction, TElHashFunction_ce_ptr, &oSignature, TElPGPSignature_ce_ptr, &l4SignatureClass) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_Sign_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oHashFunction TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), (int32_t)l4SignatureClass) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPPublicKey, TElPGPCustomUser, TElPGPSignature, integer) or (TElPGPCustomPublicKey, TElPGPSignature, TElPGPSignature) or (DateTime, TElPGPSignature) or (TElPGPSignature, TElPGPSignature) or (TElHashFunction, TElPGPSignature, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, DirectSign)
{
	zval *oKey;
	zval *oSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oKey, TElPGPCustomPublicKey_ce_ptr, &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_DirectSign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPCustomPublicKey, TElPGPSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, Revoke)
{
	zval *oKey;
	zval *oRevokedSignature;
	zval *oSignature;
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oKey, TElPGPCustomPublicKey_ce_ptr, &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_Revoke(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!", &oKey, TElPGPPublicKey_ce_ptr, &oUser, TElPGPCustomUser_ce_ptr, &oSignature, TElPGPSignature_ce_ptr, &oRevokedSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_Revoke_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), SBGetObjectHandle(oRevokedSignature TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPCustomPublicKey, TElPGPSignature) or (TElPGPPublicKey, TElPGPCustomUser, TElPGPSignature, TElPGPSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, DirectRevoke)
{
	zval *oKey;
	zval *oRevokedSignature;
	zval *oSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oKey, TElPGPCustomPublicKey_ce_ptr, &oSignature, TElPGPSignature_ce_ptr, &oRevokedSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_DirectRevoke(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), SBGetObjectHandle(oRevokedSignature TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPCustomPublicKey, TElPGPSignature, TElPGPSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, Decrypt)
{
	uint32_t _err;
	zval *oEncrData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oEncrData, TSBPGPEncryptedSymmetricKey_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPCustomSecretKey_Decrypt(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPEncryptedSymmetricKey *)SBGetStructPointer(oEncrData TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1238330986, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPEncryptedSymmetricKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, PassphraseValid)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_PassphraseValid(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, IsSigningKey)
{
	zend_bool bWithSubkeys;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bWithSubkeys) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_IsSigningKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bWithSubkeys, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, IsEncryptingKey)
{
	zend_bool bWithSubkeys;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bWithSubkeys) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_IsEncryptingKey(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bWithSubkeys, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, ExportKeyMaterial)
{
	zend_bool bPublicOnly;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bPublicOnly) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPCustomSecretKey_ExportKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bPublicOnly, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPublicKeyMaterial_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, ExportSecretKeyMaterial)
{
	zval *oKeyMaterial;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeyMaterial, TElPublicKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_ExportSecretKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyMaterial TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyMaterial)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, ImportKeyMaterial)
{
	long l4Expires;
	long l4KeyVersion;
	zval *dtTimestamp;
	zval *oKeyMaterial;
	zval *oPubKeyMaterial;
	zval *oSecKeyMaterial;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKeyMaterial, TElPublicKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_ImportKeyMaterial(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyMaterial TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSecKeyMaterial, TElPublicKeyMaterial_ce_ptr, &oPubKeyMaterial, TElPublicKeyMaterial_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_ImportKeyMaterial_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSecKeyMaterial TSRMLS_CC), SBGetObjectHandle(oPubKeyMaterial TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!Oll", &oKeyMaterial, TElPublicKeyMaterial_ce_ptr, &dtTimestamp, php_date_get_date_ce(), &l4KeyVersion, &l4Expires) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_ImportKeyMaterial_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKeyMaterial TSRMLS_CC), SBGetDateTime(dtTimestamp TSRMLS_CC), (int32_t)l4KeyVersion, (int32_t)l4Expires) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!Oll", &oSecKeyMaterial, TElPublicKeyMaterial_ce_ptr, &oPubKeyMaterial, TElPublicKeyMaterial_ce_ptr, &dtTimestamp, php_date_get_date_ce(), &l4KeyVersion, &l4Expires) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_ImportKeyMaterial_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSecKeyMaterial TSRMLS_CC), SBGetObjectHandle(oPubKeyMaterial TSRMLS_CC), SBGetDateTime(dtTimestamp TSRMLS_CC), (int32_t)l4KeyVersion, (int32_t)l4Expires) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPublicKeyMaterial) or (TElPublicKeyMaterial, TElPublicKeyMaterial) or (TElPublicKeyMaterial, DateTime, integer, integer) or (TElPublicKeyMaterial, TElPublicKeyMaterial, DateTime, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, KeyID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBKeyID roOutResult;
		SBCheckError(TElPGPCustomSecretKey_KeyID(SBGetObjectHandle(getThis() TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBKeyID_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBKeyID) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, KeyFP)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPCustomSecretKey_KeyFP(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1990483321, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, PrepareForSigning)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_PrepareForSigning(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, CancelPreparation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_CancelPreparation(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, AsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_AsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, AcquireLock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_AcquireLock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, ReleaseLock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_ReleaseLock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_UseOldPackets)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_UseOldPackets(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, set_UseOldPackets)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_set_UseOldPackets(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_Timestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, set_Timestamp)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_set_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_Expires)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_Expires(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, set_Expires)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_set_Expires(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_BitsInKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_BitsInKey(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_PublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_EncryptionAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_EncryptionAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_KeyHashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_KeyHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, set_KeyHashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_set_KeyHashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_QBits)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_QBits(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, set_QBits)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_set_QBits(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_Curve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_Curve(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, set_Curve)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_set_Curve(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_Protection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPProtectionTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_Protection(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_Passphrase)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPCustomSecretKey_get_Passphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(673341600, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, set_Passphrase)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_set_Passphrase(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_Trust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPCustomSecretKey_get_Trust(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPTrust_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, get_Enabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomSecretKey_get_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, set_Enabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPCustomSecretKey_set_Enabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomSecretKey, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPCustomSecretKey_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_Generate, 0, 0, 5)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_INFO(0, Algorithm)
	ZEND_ARG_INFO(0, UseOldFormat)
	ZEND_ARG_INFO(0, Expires)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_BeginGenerate, 0, 0, 2)
	ZEND_ARG_INFO(0, Bits)
	ZEND_ARG_INFO(0, Algorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_EndGenerate, 0, 0, 3)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_INFO(0, UseOldFormat)
	ZEND_ARG_INFO(0, Expires)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_CancelGeneration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_ChangePassphrase, 0, 0, 2)
	ZEND_ARG_INFO(0, NewPassphrase)
	ZEND_ARG_INFO(0, ProtectionType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_ChangeProtection, 0, 0, 4)
	ZEND_ARG_INFO(0, NewPassphrase)
	ZEND_ARG_INFO(0, PrType)
	ZEND_ARG_INFO(0, EncAlgorithm)
	ZEND_ARG_INFO(0, HshAlgorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_Sign, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, PublicKey_or_Key_or_TimeStamp_or_SubjectSignature_or_HashFunction, 0, 1)
	ZEND_ARG_TYPE_INFO(0, User_or_Signature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Signature_or_EmbeddedSignature_or_SignatureClass, 0, 1)
	ZEND_ARG_INFO(0, CertType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_DirectSign, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Key, TElPGPCustomPublicKey, 1)
	ZEND_ARG_OBJ_INFO(0, Signature, TElPGPSignature, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_Revoke, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Key, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Signature_or_User, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Signature, TElPGPSignature, 1)
	ZEND_ARG_OBJ_INFO(0, RevokedSignature, TElPGPSignature, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_DirectRevoke, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, Key, TElPGPCustomPublicKey, 1)
	ZEND_ARG_OBJ_INFO(0, Signature, TElPGPSignature, 1)
	ZEND_ARG_OBJ_INFO(0, RevokedSignature, TElPGPSignature, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_Decrypt, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, EncrData, TSBPGPEncryptedSymmetricKey, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_PassphraseValid, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_IsSigningKey, 0, 0, 1)
	ZEND_ARG_INFO(0, WithSubkeys)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_IsEncryptingKey, 0, 0, 1)
	ZEND_ARG_INFO(0, WithSubkeys)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_ExportKeyMaterial, 0, 0, 1)
	ZEND_ARG_INFO(0, PublicOnly)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_ExportSecretKeyMaterial, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, KeyMaterial, TElPublicKeyMaterial, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_ImportKeyMaterial, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, KeyMaterial_or_SecKeyMaterial, TElPublicKeyMaterial, 1)
	ZEND_ARG_TYPE_INFO(0, PubKeyMaterial_or_Timestamp, 0, 1)
	ZEND_ARG_INFO(0, KeyVersion_or_Timestamp)
	ZEND_ARG_INFO(0, Expires_or_KeyVersion)
	ZEND_ARG_INFO(0, Expires)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_KeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_KeyFP, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_PrepareForSigning, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_CancelPreparation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_AsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_AcquireLock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_ReleaseLock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_UseOldPackets, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_set_UseOldPackets, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_Timestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_set_Timestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_Expires, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_set_Expires, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_BitsInKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_PublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_EncryptionAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_KeyHashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_set_KeyHashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_QBits, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_set_QBits, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_Curve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_set_Curve, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_Protection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_Passphrase, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_set_Passphrase, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_Trust, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_get_Enabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey_set_Enabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomSecretKey___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPCustomSecretKey_methods[] = {
	PHP_ME(TElPGPCustomSecretKey, Assign, arginfo_TElPGPCustomSecretKey_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, AssignTo, arginfo_TElPGPCustomSecretKey_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, Generate, arginfo_TElPGPCustomSecretKey_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, BeginGenerate, arginfo_TElPGPCustomSecretKey_BeginGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, EndGenerate, arginfo_TElPGPCustomSecretKey_EndGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, CancelGeneration, arginfo_TElPGPCustomSecretKey_CancelGeneration, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, ChangePassphrase, arginfo_TElPGPCustomSecretKey_ChangePassphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, ChangeProtection, arginfo_TElPGPCustomSecretKey_ChangeProtection, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, Sign, arginfo_TElPGPCustomSecretKey_Sign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, DirectSign, arginfo_TElPGPCustomSecretKey_DirectSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, Revoke, arginfo_TElPGPCustomSecretKey_Revoke, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, DirectRevoke, arginfo_TElPGPCustomSecretKey_DirectRevoke, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, Decrypt, arginfo_TElPGPCustomSecretKey_Decrypt, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, PassphraseValid, arginfo_TElPGPCustomSecretKey_PassphraseValid, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, IsSigningKey, arginfo_TElPGPCustomSecretKey_IsSigningKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, IsEncryptingKey, arginfo_TElPGPCustomSecretKey_IsEncryptingKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, ExportKeyMaterial, arginfo_TElPGPCustomSecretKey_ExportKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, ExportSecretKeyMaterial, arginfo_TElPGPCustomSecretKey_ExportSecretKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, ImportKeyMaterial, arginfo_TElPGPCustomSecretKey_ImportKeyMaterial, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, KeyID, arginfo_TElPGPCustomSecretKey_KeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, KeyFP, arginfo_TElPGPCustomSecretKey_KeyFP, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, PrepareForSigning, arginfo_TElPGPCustomSecretKey_PrepareForSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, CancelPreparation, arginfo_TElPGPCustomSecretKey_CancelPreparation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, AsyncOperationFinished, arginfo_TElPGPCustomSecretKey_AsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, AcquireLock, arginfo_TElPGPCustomSecretKey_AcquireLock, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, ReleaseLock, arginfo_TElPGPCustomSecretKey_ReleaseLock, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_UseOldPackets, arginfo_TElPGPCustomSecretKey_get_UseOldPackets, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, set_UseOldPackets, arginfo_TElPGPCustomSecretKey_set_UseOldPackets, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_Timestamp, arginfo_TElPGPCustomSecretKey_get_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, set_Timestamp, arginfo_TElPGPCustomSecretKey_set_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_Version, arginfo_TElPGPCustomSecretKey_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_Expires, arginfo_TElPGPCustomSecretKey_get_Expires, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, set_Expires, arginfo_TElPGPCustomSecretKey_set_Expires, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_BitsInKey, arginfo_TElPGPCustomSecretKey_get_BitsInKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_PublicKeyAlgorithm, arginfo_TElPGPCustomSecretKey_get_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_EncryptionAlgorithm, arginfo_TElPGPCustomSecretKey_get_EncryptionAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_HashAlgorithm, arginfo_TElPGPCustomSecretKey_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_KeyHashAlgorithm, arginfo_TElPGPCustomSecretKey_get_KeyHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, set_KeyHashAlgorithm, arginfo_TElPGPCustomSecretKey_set_KeyHashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_QBits, arginfo_TElPGPCustomSecretKey_get_QBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, set_QBits, arginfo_TElPGPCustomSecretKey_set_QBits, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_Curve, arginfo_TElPGPCustomSecretKey_get_Curve, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, set_Curve, arginfo_TElPGPCustomSecretKey_set_Curve, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_Protection, arginfo_TElPGPCustomSecretKey_get_Protection, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_Passphrase, arginfo_TElPGPCustomSecretKey_get_Passphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, set_Passphrase, arginfo_TElPGPCustomSecretKey_set_Passphrase, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_Trust, arginfo_TElPGPCustomSecretKey_get_Trust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, get_Enabled, arginfo_TElPGPCustomSecretKey_get_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, set_Enabled, arginfo_TElPGPCustomSecretKey_set_Enabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomSecretKey, __construct, arginfo_TElPGPCustomSecretKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPCustomSecretKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPCustomSecretKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPCustomSecretKey", TElPGPCustomSecretKey_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElPGPCustomSecretKey_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPSecretSubkey_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPSecretSubkey, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSecretSubkey_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretSubkey, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSecretSubkey_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretSubkey, get_Supkey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSecretSubkey_get_Supkey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSecretKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretSubkey, get_PublicKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSecretSubkey_get_PublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPPublicSubkey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretSubkey, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSecretSubkey_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretSubkey_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretSubkey_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretSubkey_get_Supkey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretSubkey_get_PublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretSubkey___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPSecretSubkey_methods[] = {
	PHP_ME(TElPGPSecretSubkey, Assign, arginfo_TElPGPSecretSubkey_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretSubkey, AssignTo, arginfo_TElPGPSecretSubkey_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretSubkey, get_Supkey, arginfo_TElPGPSecretSubkey_get_Supkey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretSubkey, get_PublicKey, arginfo_TElPGPSecretSubkey_get_PublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretSubkey, __construct, arginfo_TElPGPSecretSubkey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPSecretSubkey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPSecretSubkey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPSecretSubkey", TElPGPSecretSubkey_methods);
	if (NULL == TElPGPCustomSecretKey_ce_ptr)
		Register_TElPGPCustomSecretKey(TSRMLS_C);
	TElPGPSecretSubkey_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPCustomSecretKey_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPSecretKey_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPSecretKey, RemoveSubkey)
{
	long l4Index;
	zval *oSubkey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSecretKey_RemoveSubkey(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSubkey, TElPGPSecretSubkey_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSecretKey_RemoveSubkey_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSubkey TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (TElPGPSecretSubkey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, AssignFromX509)
{
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_AssignFromX509(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, LoadFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, LoadFromFile)
{
	char *sFilename;
	int sFilename_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_LoadFromFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, SaveToStream)
{
	zend_bool bArmor;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bArmor) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bArmor) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, SaveToFile)
{
	char *sFilename;
	int sFilename_len;
	zend_bool bArmor;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sFilename, &sFilename_len, &bArmor) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_SaveToFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, (int8_t)bArmor) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, BindUser)
{
	zval *oUser;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oUser, TElPGPCustomUser_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_BindUser(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oUser TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPCustomUser)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, Generate)
{
	char *sPassword;
	char *sUserName;
	int sPassword_len;
	int sUserName_len;
	long l4Algorithm;
	long l4Bits;
	long l4Expires;
	long l4KeyAlgorithm;
	long l4KeyBits;
	long l4SubkeyAlgorithm;
	long l4SubkeyBits;
	zend_bool bUseOldFormat;
	zend_bool bUseOldStyle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sllllsl", &sPassword, &sPassword_len, &l4KeyBits, &l4KeyAlgorithm, &l4SubkeyBits, &l4SubkeyAlgorithm, &sUserName, &sUserName_len, &l4Expires) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), sPassword, (int32_t)sPassword_len, (int32_t)l4KeyBits, (int32_t)l4KeyAlgorithm, (int32_t)l4SubkeyBits, (int32_t)l4SubkeyAlgorithm, sUserName, (int32_t)sUserName_len, (int32_t)l4Expires) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sllsbl", &sPassword, &sPassword_len, &l4KeyBits, &l4KeyAlgorithm, &sUserName, &sUserName_len, &bUseOldStyle, &l4Expires) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_Generate_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPassword, (int32_t)sPassword_len, (int32_t)l4KeyBits, (int32_t)l4KeyAlgorithm, sUserName, (int32_t)sUserName_len, (int8_t)bUseOldStyle, (int32_t)l4Expires) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sllbl", &sPassword, &sPassword_len, &l4Bits, &l4Algorithm, &bUseOldFormat, &l4Expires) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_Generate_2(SBGetObjectHandle(getThis() TSRMLS_CC), sPassword, (int32_t)sPassword_len, (int32_t)l4Bits, (int32_t)l4Algorithm, (int8_t)bUseOldFormat, (int32_t)l4Expires) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer, integer, integer, string, integer) or (string, integer, integer, string, bool, integer) or (string, integer, integer, bool, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, BeginGenerate)
{
	long l4Algorithm;
	long l4Bits;
	long l4KeyAlgorithm;
	long l4KeyBits;
	long l4SubkeyAlgorithm;
	long l4SubkeyBits;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llll", &l4KeyBits, &l4KeyAlgorithm, &l4SubkeyBits, &l4SubkeyAlgorithm) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_BeginGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4KeyBits, (int32_t)l4KeyAlgorithm, (int32_t)l4SubkeyBits, (int32_t)l4SubkeyAlgorithm) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Bits, &l4Algorithm) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_BeginGenerate_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Bits, (int32_t)l4Algorithm) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, integer) or (integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, EndGenerate)
{
	char *sPassword;
	char *sUserName;
	int sPassword_len;
	int sUserName_len;
	long l4Expires;
	zend_bool bUseOldFormat;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslb", &sPassword, &sPassword_len, &sUserName, &sUserName_len, &l4Expires, &bUseOldFormat) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_EndGenerate(SBGetObjectHandle(getThis() TSRMLS_CC), sPassword, (int32_t)sPassword_len, sUserName, (int32_t)sUserName_len, (int32_t)l4Expires, (int8_t)bUseOldFormat) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbl", &sPassword, &sPassword_len, &bUseOldFormat, &l4Expires) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_EndGenerate_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPassword, (int32_t)sPassword_len, (int8_t)bUseOldFormat, (int32_t)l4Expires) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, integer, bool) or (string, bool, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, AddSubkey)
{
	zval *oSubkey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSubkey, TElPGPSecretSubkey_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSecretKey_AddSubkey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSubkey TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPSecretSubkey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, PrepareForSigning)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_PrepareForSigning(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, CancelPreparation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_CancelPreparation(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, AsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSecretKey_AsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, get_ArmorBoundary)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSecretKey_get_ArmorBoundary(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1446153542, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, set_ArmorBoundary)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_set_ArmorBoundary(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, get_ArmorHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSecretKey_get_ArmorHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, get_Subkeys)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSecretKey_get_Subkeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSecretSubkey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, get_SubkeyCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSecretKey_get_SubkeyCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, get_PublicKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSecretKey_get_PublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPPublicKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, get_WriteFlags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPSecretKey_get_WriteFlags(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, set_WriteFlags)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_set_WriteFlags(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, get_WriteOldPrefix)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSecretKey_get_WriteOldPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, set_WriteOldPrefix)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSecretKey_set_WriteOldPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, get_OnBeforeSign)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPBeforeSignEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPSecretKey_get_OnBeforeSign(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, set_OnBeforeSign)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPSecretKey_set_OnBeforeSign(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPBeforeSignEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPBeforeSignEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSecretKey, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSecretKey_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_RemoveSubkey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Index_or_Subkey, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_AssignFromX509, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_LoadFromFile, 0, 0, 1)
	ZEND_ARG_INFO(0, Filename)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_SaveToStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Armor)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_SaveToFile, 0, 0, 2)
	ZEND_ARG_INFO(0, Filename)
	ZEND_ARG_INFO(0, Armor)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_BindUser, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, User, TElPGPCustomUser, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_Generate, 0, 0, 5)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_INFO(0, KeyBits_or_Bits)
	ZEND_ARG_INFO(0, KeyAlgorithm_or_Algorithm)
	ZEND_ARG_INFO(0, SubkeyBits_or_UserName_or_UseOldFormat)
	ZEND_ARG_INFO(0, SubkeyAlgorithm_or_UseOldStyle_or_Expires)
	ZEND_ARG_INFO(0, UserName_or_Expires)
	ZEND_ARG_INFO(0, Expires)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_BeginGenerate, 0, 0, 2)
	ZEND_ARG_INFO(0, KeyBits_or_Bits)
	ZEND_ARG_INFO(0, KeyAlgorithm_or_Algorithm)
	ZEND_ARG_INFO(0, SubkeyBits)
	ZEND_ARG_INFO(0, SubkeyAlgorithm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_EndGenerate, 0, 0, 3)
	ZEND_ARG_INFO(0, Password)
	ZEND_ARG_INFO(0, UserName_or_UseOldFormat)
	ZEND_ARG_INFO(0, Expires)
	ZEND_ARG_INFO(0, UseOldFormat)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_AddSubkey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Subkey, TElPGPSecretSubkey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_PrepareForSigning, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_CancelPreparation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_AsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_get_ArmorBoundary, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_set_ArmorBoundary, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_get_ArmorHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_get_Subkeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_get_SubkeyCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_get_PublicKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_get_WriteFlags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_set_WriteFlags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_get_WriteOldPrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_set_WriteOldPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_get_OnBeforeSign, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey_set_OnBeforeSign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSecretKey___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPSecretKey_methods[] = {
	PHP_ME(TElPGPSecretKey, RemoveSubkey, arginfo_TElPGPSecretKey_RemoveSubkey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, Assign, arginfo_TElPGPSecretKey_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, AssignTo, arginfo_TElPGPSecretKey_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, AssignFromX509, arginfo_TElPGPSecretKey_AssignFromX509, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, LoadFromStream, arginfo_TElPGPSecretKey_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, LoadFromFile, arginfo_TElPGPSecretKey_LoadFromFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, SaveToStream, arginfo_TElPGPSecretKey_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, SaveToFile, arginfo_TElPGPSecretKey_SaveToFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, BindUser, arginfo_TElPGPSecretKey_BindUser, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, Generate, arginfo_TElPGPSecretKey_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, BeginGenerate, arginfo_TElPGPSecretKey_BeginGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, EndGenerate, arginfo_TElPGPSecretKey_EndGenerate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, AddSubkey, arginfo_TElPGPSecretKey_AddSubkey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, PrepareForSigning, arginfo_TElPGPSecretKey_PrepareForSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, CancelPreparation, arginfo_TElPGPSecretKey_CancelPreparation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, AsyncOperationFinished, arginfo_TElPGPSecretKey_AsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, get_ArmorBoundary, arginfo_TElPGPSecretKey_get_ArmorBoundary, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, set_ArmorBoundary, arginfo_TElPGPSecretKey_set_ArmorBoundary, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, get_ArmorHeaders, arginfo_TElPGPSecretKey_get_ArmorHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, get_Subkeys, arginfo_TElPGPSecretKey_get_Subkeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, get_SubkeyCount, arginfo_TElPGPSecretKey_get_SubkeyCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, get_PublicKey, arginfo_TElPGPSecretKey_get_PublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, get_WriteFlags, arginfo_TElPGPSecretKey_get_WriteFlags, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, set_WriteFlags, arginfo_TElPGPSecretKey_set_WriteFlags, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, get_WriteOldPrefix, arginfo_TElPGPSecretKey_get_WriteOldPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, set_WriteOldPrefix, arginfo_TElPGPSecretKey_set_WriteOldPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, get_OnBeforeSign, arginfo_TElPGPSecretKey_get_OnBeforeSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, set_OnBeforeSign, arginfo_TElPGPSecretKey_set_OnBeforeSign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSecretKey, __construct, arginfo_TElPGPSecretKey___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPSecretKey(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPSecretKey_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPSecretKey", TElPGPSecretKey_methods);
	if (NULL == TElPGPCustomSecretKey_ce_ptr)
		Register_TElPGPCustomSecretKey(TSRMLS_C);
	TElPGPSecretKey_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPCustomSecretKey_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPTrust_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPTrust, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPTrust_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPTrust_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, get_OwnerTrust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPTrust_get_OwnerTrust(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, set_OwnerTrust)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPTrust_set_OwnerTrust(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, get_Disabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPTrust_get_Disabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, set_Disabled)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPTrust_set_Disabled(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, get_BuckStop)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPTrust_get_BuckStop(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, set_BuckStop)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPTrust_set_BuckStop(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, get_KeyLegit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPTrust_get_KeyLegit(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, set_KeyLegit)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPTrust_set_KeyLegit(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, get_WarnOnly)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPTrust_get_WarnOnly(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, set_WarnOnly)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPTrust_set_WarnOnly(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, get_SigTrust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPTrust_get_SigTrust(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, set_SigTrust)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPTrust_set_SigTrust(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, get_Checked)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPTrust_get_Checked(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, set_Checked)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPTrust_set_Checked(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, get_Contiguous)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPTrust_get_Contiguous(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, set_Contiguous)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPTrust_set_Contiguous(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, get_Flags)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPTrust_get_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, set_Flags)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPTrust_set_Flags(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPTrust, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPTrust_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_get_OwnerTrust, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_set_OwnerTrust, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_get_Disabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_set_Disabled, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_get_BuckStop, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_set_BuckStop, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_get_KeyLegit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_set_KeyLegit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_get_WarnOnly, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_set_WarnOnly, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_get_SigTrust, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_set_SigTrust, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_get_Checked, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_set_Checked, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_get_Contiguous, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_set_Contiguous, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_get_Flags, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust_set_Flags, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPTrust___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPTrust_methods[] = {
	PHP_ME(TElPGPTrust, Assign, arginfo_TElPGPTrust_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, AssignTo, arginfo_TElPGPTrust_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, get_OwnerTrust, arginfo_TElPGPTrust_get_OwnerTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, set_OwnerTrust, arginfo_TElPGPTrust_set_OwnerTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, get_Disabled, arginfo_TElPGPTrust_get_Disabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, set_Disabled, arginfo_TElPGPTrust_set_Disabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, get_BuckStop, arginfo_TElPGPTrust_get_BuckStop, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, set_BuckStop, arginfo_TElPGPTrust_set_BuckStop, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, get_KeyLegit, arginfo_TElPGPTrust_get_KeyLegit, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, set_KeyLegit, arginfo_TElPGPTrust_set_KeyLegit, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, get_WarnOnly, arginfo_TElPGPTrust_get_WarnOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, set_WarnOnly, arginfo_TElPGPTrust_set_WarnOnly, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, get_SigTrust, arginfo_TElPGPTrust_get_SigTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, set_SigTrust, arginfo_TElPGPTrust_set_SigTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, get_Checked, arginfo_TElPGPTrust_get_Checked, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, set_Checked, arginfo_TElPGPTrust_set_Checked, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, get_Contiguous, arginfo_TElPGPTrust_get_Contiguous, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, set_Contiguous, arginfo_TElPGPTrust_set_Contiguous, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, get_Flags, arginfo_TElPGPTrust_get_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, set_Flags, arginfo_TElPGPTrust_set_Flags, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPTrust, __construct, arginfo_TElPGPTrust___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPTrust(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPTrust_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPTrust", TElPGPTrust_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElPGPTrust_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPSignature_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPSignature, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, LoadFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, SaveOnePass)
{
	zend_bool bNested;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bNested) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_SaveOnePass(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bNested) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, SaveOnePassToStream)
{
	zend_bool bNested;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oStream, TStream_ce_ptr, &bNested) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_SaveOnePassToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), (int8_t)bNested) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, IsKeyRevocation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_IsKeyRevocation(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, IsSubkeyRevocation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_IsSubkeyRevocation(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, IsUserRevocation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_IsUserRevocation(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, IsDocumentSignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_IsDocumentSignature(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, IsStandalone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_IsStandalone(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, IsUserCertification)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_IsUserCertification(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, IsSubkeyBinding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_IsSubkeyBinding(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, IsDirectKeySignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_IsDirectKeySignature(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, IsTimestampSignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_IsTimestampSignature(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, SignerKeyID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBKeyID roOutResult;
		SBCheckError(TElPGPSignature_SignerKeyID(SBGetObjectHandle(getThis() TSRMLS_CC), &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBKeyID_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(TSBKeyID) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, AddExtension)
{
	long fExtType;
	zend_bool bCritical;
	zend_bool bHashed;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lbb", &fExtType, &bHashed, &bCritical) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSignature_AddExtension(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPSignatureExtensionRaw)fExtType, (int8_t)bHashed, (int8_t)bCritical, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, RemoveExtension)
{
	long fExtType;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &fExtType, &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_RemoveExtension(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPSignatureExtensionRaw)fExtType, (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_RemoveExtension_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, GetExtensionByType)
{
	long fExtType;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &fExtType, &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignature_GetExtensionByType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPSignatureExtensionRaw)fExtType, (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSignatureSubpacket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, GetExtensionCount)
{
	long fExtType;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fExtType) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSignature_GetExtensionCount(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPSignatureExtensionRaw)fExtType, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, ClearExtensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPSignature_ClearExtensions(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_IsX509Certificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_IsX509Certificate(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_Extensions)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignature_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSignatureSubpacket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_RegularExpression)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSignature_get_RegularExpression(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-910936461, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_RegularExpression)
{
	char *sValue;
	int sValue_len;
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &l4Index, &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_RegularExpression(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_Version)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_Version(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_HashAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_HashAlgorithm)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_HashAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_UseOldPackets)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_UseOldPackets(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_UseOldPackets)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_UseOldPackets(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_X509Certificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignature_get_X509Certificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_Validated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_Validated(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_Validated)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_Validated(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_StrictlyValid)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_StrictlyValid(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_StrictlyValid)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_StrictlyValid(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_CreationTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_CreationTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_CreationTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_CreationTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_KeyExpirationTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_KeyExpirationTime(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_KeyExpirationTime)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_KeyExpirationTime(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_ExpirationTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_ExpirationTime(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_ExpirationTime)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_ExpirationTime(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_Exportable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_Exportable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_Exportable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_Exportable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_Revocable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_Revocable(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_Revocable)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_Revocable(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_TrustLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_TrustLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_TrustLevel)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_TrustLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_TrustAmount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_TrustAmount(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_TrustAmount)
{
	long u1Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_TrustAmount(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_Trust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignature_get_Trust(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPTrust_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_RegularExpressionCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_RegularExpressionCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_RegularExpressionCount)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_RegularExpressionCount(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_PrimaryUserID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_PrimaryUserID(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_PrimaryUserID)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_PrimaryUserID(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_PolicyURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSignature_get_PolicyURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-856682067, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_PolicyURL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_PolicyURL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_SignerUserID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSignature_get_SignerUserID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-555554824, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_SignerUserID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_SignerUserID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_ReasonForRevocation)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPSignature_get_ReasonForRevocation(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1210082997, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_ReasonForRevocation)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_ReasonForRevocation(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_SignatureClass)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_SignatureClass(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_CertificationType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPUserCertificationTypeRaw fOutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_CertificationType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, set_CertificationType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElPGPSignature_set_CertificationType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBPGPUserCertificationTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_Revocation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_Revocation(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, get_IsTextSignature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPSignature_get_IsTextSignature(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPSignature, __construct)
{
	zend_bool bCopySigMaterial;
	zval *oEntity;
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignature_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oEntity, TElPGPSignatureEntity_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignature_Create_1(SBGetObjectHandle(oEntity TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oSource, TElPGPSignature_ce_ptr, &bCopySigMaterial) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPSignature_Create_2(SBGetObjectHandle(oSource TSRMLS_CC), (int8_t)bCopySigMaterial, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPGPSignatureEntity) or (TElPGPSignature, bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_SaveOnePass, 0, 0, 1)
	ZEND_ARG_INFO(0, Nested)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_SaveOnePassToStream, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
	ZEND_ARG_INFO(0, Nested)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_IsKeyRevocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_IsSubkeyRevocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_IsUserRevocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_IsDocumentSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_IsStandalone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_IsUserCertification, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_IsSubkeyBinding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_IsDirectKeySignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_IsTimestampSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_SignerKeyID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_AddExtension, 0, 0, 3)
	ZEND_ARG_INFO(0, ExtType)
	ZEND_ARG_INFO(0, Hashed)
	ZEND_ARG_INFO(0, Critical)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_RemoveExtension, 0, 0, 1)
	ZEND_ARG_INFO(0, ExtType_or_Index)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_GetExtensionByType, 0, 0, 2)
	ZEND_ARG_INFO(0, ExtType)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_GetExtensionCount, 0, 0, 1)
	ZEND_ARG_INFO(0, ExtType)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_ClearExtensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_IsX509Certificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_Extensions, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_RegularExpression, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_RegularExpression, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_Version, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_HashAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_HashAlgorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_UseOldPackets, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_UseOldPackets, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_X509Certificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_Validated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_Validated, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_StrictlyValid, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_StrictlyValid, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_CreationTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_CreationTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_KeyExpirationTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_KeyExpirationTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_ExpirationTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_ExpirationTime, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_Exportable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_Exportable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_Revocable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_Revocable, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_TrustLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_TrustLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_TrustAmount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_TrustAmount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_Trust, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_RegularExpressionCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_RegularExpressionCount, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_PrimaryUserID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_PrimaryUserID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_PolicyURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_PolicyURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_SignerUserID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_SignerUserID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_ReasonForRevocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_ReasonForRevocation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_SignatureClass, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_CertificationType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_set_CertificationType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_Revocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature_get_IsTextSignature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPSignature___construct, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Entity_or_Source, 0, 1)
	ZEND_ARG_INFO(0, CopySigMaterial)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPSignature_methods[] = {
	PHP_ME(TElPGPSignature, Assign, arginfo_TElPGPSignature_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, AssignTo, arginfo_TElPGPSignature_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, LoadFromStream, arginfo_TElPGPSignature_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, SaveToStream, arginfo_TElPGPSignature_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, SaveOnePass, arginfo_TElPGPSignature_SaveOnePass, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, SaveOnePassToStream, arginfo_TElPGPSignature_SaveOnePassToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, IsKeyRevocation, arginfo_TElPGPSignature_IsKeyRevocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, IsSubkeyRevocation, arginfo_TElPGPSignature_IsSubkeyRevocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, IsUserRevocation, arginfo_TElPGPSignature_IsUserRevocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, IsDocumentSignature, arginfo_TElPGPSignature_IsDocumentSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, IsStandalone, arginfo_TElPGPSignature_IsStandalone, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, IsUserCertification, arginfo_TElPGPSignature_IsUserCertification, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, IsSubkeyBinding, arginfo_TElPGPSignature_IsSubkeyBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, IsDirectKeySignature, arginfo_TElPGPSignature_IsDirectKeySignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, IsTimestampSignature, arginfo_TElPGPSignature_IsTimestampSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, SignerKeyID, arginfo_TElPGPSignature_SignerKeyID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, AddExtension, arginfo_TElPGPSignature_AddExtension, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, RemoveExtension, arginfo_TElPGPSignature_RemoveExtension, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, GetExtensionByType, arginfo_TElPGPSignature_GetExtensionByType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, GetExtensionCount, arginfo_TElPGPSignature_GetExtensionCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, ClearExtensions, arginfo_TElPGPSignature_ClearExtensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_IsX509Certificate, arginfo_TElPGPSignature_get_IsX509Certificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_Extensions, arginfo_TElPGPSignature_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_RegularExpression, arginfo_TElPGPSignature_get_RegularExpression, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_RegularExpression, arginfo_TElPGPSignature_set_RegularExpression, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_Version, arginfo_TElPGPSignature_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_Version, arginfo_TElPGPSignature_set_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_HashAlgorithm, arginfo_TElPGPSignature_get_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_HashAlgorithm, arginfo_TElPGPSignature_set_HashAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_UseOldPackets, arginfo_TElPGPSignature_get_UseOldPackets, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_UseOldPackets, arginfo_TElPGPSignature_set_UseOldPackets, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_X509Certificate, arginfo_TElPGPSignature_get_X509Certificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_Validated, arginfo_TElPGPSignature_get_Validated, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_Validated, arginfo_TElPGPSignature_set_Validated, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_StrictlyValid, arginfo_TElPGPSignature_get_StrictlyValid, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_StrictlyValid, arginfo_TElPGPSignature_set_StrictlyValid, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_CreationTime, arginfo_TElPGPSignature_get_CreationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_CreationTime, arginfo_TElPGPSignature_set_CreationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_KeyExpirationTime, arginfo_TElPGPSignature_get_KeyExpirationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_KeyExpirationTime, arginfo_TElPGPSignature_set_KeyExpirationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_ExpirationTime, arginfo_TElPGPSignature_get_ExpirationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_ExpirationTime, arginfo_TElPGPSignature_set_ExpirationTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_Exportable, arginfo_TElPGPSignature_get_Exportable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_Exportable, arginfo_TElPGPSignature_set_Exportable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_Revocable, arginfo_TElPGPSignature_get_Revocable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_Revocable, arginfo_TElPGPSignature_set_Revocable, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_TrustLevel, arginfo_TElPGPSignature_get_TrustLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_TrustLevel, arginfo_TElPGPSignature_set_TrustLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_TrustAmount, arginfo_TElPGPSignature_get_TrustAmount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_TrustAmount, arginfo_TElPGPSignature_set_TrustAmount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_Trust, arginfo_TElPGPSignature_get_Trust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_RegularExpressionCount, arginfo_TElPGPSignature_get_RegularExpressionCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_RegularExpressionCount, arginfo_TElPGPSignature_set_RegularExpressionCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_PrimaryUserID, arginfo_TElPGPSignature_get_PrimaryUserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_PrimaryUserID, arginfo_TElPGPSignature_set_PrimaryUserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_PolicyURL, arginfo_TElPGPSignature_get_PolicyURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_PolicyURL, arginfo_TElPGPSignature_set_PolicyURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_SignerUserID, arginfo_TElPGPSignature_get_SignerUserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_SignerUserID, arginfo_TElPGPSignature_set_SignerUserID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_ReasonForRevocation, arginfo_TElPGPSignature_get_ReasonForRevocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_ReasonForRevocation, arginfo_TElPGPSignature_set_ReasonForRevocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_SignatureClass, arginfo_TElPGPSignature_get_SignatureClass, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_CertificationType, arginfo_TElPGPSignature_get_CertificationType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, set_CertificationType, arginfo_TElPGPSignature_set_CertificationType, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_Revocation, arginfo_TElPGPSignature_get_Revocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, get_IsTextSignature, arginfo_TElPGPSignature_get_IsTextSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPSignature, __construct, arginfo_TElPGPSignature___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPSignature(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPSignature_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPSignature", TElPGPSignature_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElPGPSignature_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPCustomUser_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPCustomUser, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomUser_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomUser, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPCustomUser_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomUser, AddSignature)
{
	zval *oSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomUser_AddSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomUser, ClearSignatures)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPCustomUser_ClearSignatures(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomUser, RemoveSignature)
{
	long l4Index;
	zval *oSignature;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomUser_RemoveSignature(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSignature, TElPGPSignature_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomUser_RemoveSignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSignature TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (TElPGPSignature)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomUser, get_Signatures)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPCustomUser_get_Signatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomUser, get_SignatureCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPCustomUser_get_SignatureCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomUser, get_Revoked)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPCustomUser_get_Revoked(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPCustomUser, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPCustomUser_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomUser_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomUser_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomUser_AddSignature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Signature, TElPGPSignature, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomUser_ClearSignatures, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomUser_RemoveSignature, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Index_or_Signature, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomUser_get_Signatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomUser_get_SignatureCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomUser_get_Revoked, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPCustomUser___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPCustomUser_methods[] = {
	PHP_ME(TElPGPCustomUser, Assign, arginfo_TElPGPCustomUser_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomUser, AssignTo, arginfo_TElPGPCustomUser_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomUser, AddSignature, arginfo_TElPGPCustomUser_AddSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomUser, ClearSignatures, arginfo_TElPGPCustomUser_ClearSignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomUser, RemoveSignature, arginfo_TElPGPCustomUser_RemoveSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomUser, get_Signatures, arginfo_TElPGPCustomUser_get_Signatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomUser, get_SignatureCount, arginfo_TElPGPCustomUser_get_SignatureCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomUser, get_Revoked, arginfo_TElPGPCustomUser_get_Revoked, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPCustomUser, __construct, arginfo_TElPGPCustomUser___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPCustomUser(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPCustomUser_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPCustomUser", TElPGPCustomUser_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElPGPCustomUser_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPUserID_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPUserID, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserID_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserID, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserID_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserID, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPUserID_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1768724961, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserID, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPUserID_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserID, get_Trust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPUserID_get_Trust(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPTrust_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserID, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPUserID_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserID_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserID_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserID_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserID_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserID_get_Trust, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserID___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPUserID_methods[] = {
	PHP_ME(TElPGPUserID, Assign, arginfo_TElPGPUserID_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserID, AssignTo, arginfo_TElPGPUserID_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserID, get_Name, arginfo_TElPGPUserID_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserID, set_Name, arginfo_TElPGPUserID_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserID, get_Trust, arginfo_TElPGPUserID_get_Trust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserID, __construct, arginfo_TElPGPUserID___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPUserID(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPUserID_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPUserID", TElPGPUserID_methods);
	if (NULL == TElPGPCustomUser_ce_ptr)
		Register_TElPGPCustomUser(TSRMLS_C);
	TElPGPUserID_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPCustomUser_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPUserAttr_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPUserAttr, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserAttr_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttr, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserAttr_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttr, AddImage)
{
	zval *oImage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oImage, TElPGPJpegImage_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPUserAttr_AddImage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oImage TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPJpegImage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttr, RemoveImage)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPUserAttr_RemoveImage(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttr, ClearImages)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPUserAttr_ClearImages(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttr, ImageCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPUserAttr_ImageCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttr, get_Trust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPUserAttr_get_Trust(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPTrust_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttr, get_Images)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPUserAttr_get_Images(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPJpegImage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttr, set_Images)
{
	long l4Index;
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oValue, TElPGPJpegImage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPUserAttr_set_Images(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElPGPJpegImage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPUserAttr, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPUserAttr_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttr_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttr_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttr_AddImage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Image, TElPGPJpegImage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttr_RemoveImage, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttr_ClearImages, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttr_ImageCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttr_get_Trust, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttr_get_Images, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttr_set_Images, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, Value, TElPGPJpegImage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPUserAttr___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPUserAttr_methods[] = {
	PHP_ME(TElPGPUserAttr, Assign, arginfo_TElPGPUserAttr_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttr, AssignTo, arginfo_TElPGPUserAttr_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttr, AddImage, arginfo_TElPGPUserAttr_AddImage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttr, RemoveImage, arginfo_TElPGPUserAttr_RemoveImage, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttr, ClearImages, arginfo_TElPGPUserAttr_ClearImages, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttr, ImageCount, arginfo_TElPGPUserAttr_ImageCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttr, get_Trust, arginfo_TElPGPUserAttr_get_Trust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttr, get_Images, arginfo_TElPGPUserAttr_get_Images, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttr, set_Images, arginfo_TElPGPUserAttr_set_Images, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPUserAttr, __construct, arginfo_TElPGPUserAttr___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPUserAttr(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPUserAttr_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPUserAttr", TElPGPUserAttr_methods);
	if (NULL == TElPGPCustomUser_ce_ptr)
		Register_TElPGPCustomUser(TSRMLS_C);
	TElPGPUserAttr_ce_ptr = zend_register_internal_class_ex(&ce, TElPGPCustomUser_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPKeyring_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPKeyring, Load)
{
	char *sPublicKeysFile;
	char *sSecretKeysFile;
	int sPublicKeysFile_len;
	int sSecretKeysFile_len;
	zend_bool bClear;
	zval *oAPublic;
	zval *oASecret;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oAPublic, TStream_ce_ptr, &oASecret, TStream_ce_ptr, &bClear) == SUCCESS)
	{
		SBCheckError(TElPGPKeyring_Load(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAPublic TSRMLS_CC), SBGetObjectHandle(oASecret TSRMLS_CC), (int8_t)bClear) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sPublicKeysFile, &sPublicKeysFile_len, &sSecretKeysFile, &sSecretKeysFile_len, &bClear) == SUCCESS)
	{
		SBCheckError(TElPGPKeyring_Load_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPublicKeysFile, (int32_t)sPublicKeysFile_len, sSecretKeysFile, (int32_t)sSecretKeysFile_len, (int8_t)bClear) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream, bool) or (string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, AddX509Certificate)
{
	zval *oCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCertificate, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPKeyring_AddX509Certificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCertificate TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, AddPublicKey)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElPGPPublicKey_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPKeyring_AddPublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPPublicKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, AddSecretKey)
{
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElPGPSecretKey_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPKeyring_AddSecretKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPSecretKey)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, RemovePublicKey)
{
	long l4Index;
	zend_bool bRemoveSecretKeyIfExists;
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!b", &oKey, TElPGPPublicKey_ce_ptr, &bRemoveSecretKeyIfExists) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyring_RemovePublicKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), (int8_t)bRemoveSecretKeyIfExists, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l4Index, &bRemoveSecretKeyIfExists) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyring_RemovePublicKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int8_t)bRemoveSecretKeyIfExists, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPPublicKey, bool) or (integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, RemoveSecretKey)
{
	long l4Index;
	zval *oKey;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oKey, TElPGPSecretKey_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyring_RemoveSecretKey(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oKey TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyring_RemoveSecretKey_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPSecretKey) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPKeyring_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, Save)
{
	char *sPublicKeysFile;
	char *sSecretKeysFile;
	int sPublicKeysFile_len;
	int sSecretKeysFile_len;
	zend_bool bArmor;
	zval *oAPublic;
	zval *oASecret;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!b", &oAPublic, TStream_ce_ptr, &oASecret, TStream_ce_ptr, &bArmor) == SUCCESS)
	{
		SBCheckError(TElPGPKeyring_Save(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAPublic TSRMLS_CC), SBGetObjectHandle(oASecret TSRMLS_CC), (int8_t)bArmor) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sPublicKeysFile, &sPublicKeysFile_len, &sSecretKeysFile, &sSecretKeysFile_len, &bArmor) == SUCCESS)
	{
		SBCheckError(TElPGPKeyring_Save_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPublicKeysFile, (int32_t)sPublicKeysFile_len, sSecretKeysFile, (int32_t)sSecretKeysFile_len, (int8_t)bArmor) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, TStream, bool) or (string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, ExportTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TElPGPKeyring_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPKeyring_ExportTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPGPKeyring)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, FindPublicKeyByID)
{
	char *sKeyID;
	int sKeyID_len;
	long l4StartIndex;
	TElClassHandle hoRes;
	zval *oKeyID;
	zval *oRes;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OOl", &oKeyID, TSBKeyID_ce_ptr, &oRes, TElPGPCustomPublicKey_ce_ptr, &l4StartIndex) == SUCCESS) && PZVAL_IS_REF(oRes) && (IS_OBJECT == Z_TYPE_P(oRes)))
	{
		int32_t l4OutResultRaw = 0;
		hoRes = SBGetObjectHandle(oRes TSRMLS_CC);
		SBCheckError(TElPGPKeyring_FindPublicKeyByID(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBKeyID *)SBGetStructPointer(oKeyID TSRMLS_CC), &hoRes, (int32_t)l4StartIndex, &l4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oRes, hoRes TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sOl", &sKeyID, &sKeyID_len, &oRes, TElPGPCustomPublicKey_ce_ptr, &l4StartIndex) == SUCCESS) && PZVAL_IS_REF(oRes) && (IS_OBJECT == Z_TYPE_P(oRes)))
	{
		int32_t l4OutResultRaw = 0;
		hoRes = SBGetObjectHandle(oRes TSRMLS_CC);
		SBCheckError(TElPGPKeyring_FindPublicKeyByID_1(SBGetObjectHandle(getThis() TSRMLS_CC), sKeyID, (int32_t)sKeyID_len, &hoRes, (int32_t)l4StartIndex, &l4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oRes, hoRes TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBKeyID, &TElPGPCustomPublicKey, integer) or (string, &TElPGPCustomPublicKey, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, FindSecretKeyByID)
{
	char *sKeyID;
	int sKeyID_len;
	long l4StartIndex;
	TElClassHandle hoRes;
	zval *oKeyID;
	zval *oRes;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OOl", &oKeyID, TSBKeyID_ce_ptr, &oRes, TElPGPCustomSecretKey_ce_ptr, &l4StartIndex) == SUCCESS) && PZVAL_IS_REF(oRes) && (IS_OBJECT == Z_TYPE_P(oRes)))
	{
		int32_t l4OutResultRaw = 0;
		hoRes = SBGetObjectHandle(oRes TSRMLS_CC);
		SBCheckError(TElPGPKeyring_FindSecretKeyByID(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBKeyID *)SBGetStructPointer(oKeyID TSRMLS_CC), &hoRes, (int32_t)l4StartIndex, &l4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oRes, hoRes TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sOl", &sKeyID, &sKeyID_len, &oRes, TElPGPCustomSecretKey_ce_ptr, &l4StartIndex) == SUCCESS) && PZVAL_IS_REF(oRes) && (IS_OBJECT == Z_TYPE_P(oRes)))
	{
		int32_t l4OutResultRaw = 0;
		hoRes = SBGetObjectHandle(oRes TSRMLS_CC);
		SBCheckError(TElPGPKeyring_FindSecretKeyByID_1(SBGetObjectHandle(getThis() TSRMLS_CC), sKeyID, (int32_t)sKeyID_len, &hoRes, (int32_t)l4StartIndex, &l4OutResultRaw) TSRMLS_CC);
		SBUpdateObjectHandle(oRes, hoRes TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBKeyID, &TElPGPCustomSecretKey, integer) or (string, &TElPGPCustomSecretKey, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, InternalFindPublicKeyByID)
{
	long l4StartIndex;
	SBArrayZValInfo aiKeyID;
	TElClassHandle hoRes;
	zval *oRes;
	zval *zaKeyID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zOl", &zaKeyID, &oRes, TElPGPCustomPublicKey_ce_ptr, &l4StartIndex) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKeyID)) || (IS_ARRAY == Z_TYPE_P(zaKeyID)) || (IS_NULL == Z_TYPE_P(zaKeyID))) && PZVAL_IS_REF(oRes) && (IS_OBJECT == Z_TYPE_P(oRes)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaKeyID, &aiKeyID TSRMLS_CC)) RETURN_FALSE;
		hoRes = SBGetObjectHandle(oRes TSRMLS_CC);
		SBCheckError(TElPGPKeyring_InternalFindPublicKeyByID(SBGetObjectHandle(getThis() TSRMLS_CC), aiKeyID.data, aiKeyID.len, &hoRes, (int32_t)l4StartIndex, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKeyID);
		SBUpdateObjectHandle(oRes, hoRes TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &TElPGPCustomPublicKey, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, InternalFindSecretKeyByID)
{
	long l4StartIndex;
	SBArrayZValInfo aiKeyID;
	TElClassHandle hoRes;
	zval *oRes;
	zval *zaKeyID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zOl", &zaKeyID, &oRes, TElPGPCustomSecretKey_ce_ptr, &l4StartIndex) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaKeyID)) || (IS_ARRAY == Z_TYPE_P(zaKeyID)) || (IS_NULL == Z_TYPE_P(zaKeyID))) && PZVAL_IS_REF(oRes) && (IS_OBJECT == Z_TYPE_P(oRes)))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaKeyID, &aiKeyID TSRMLS_CC)) RETURN_FALSE;
		hoRes = SBGetObjectHandle(oRes TSRMLS_CC);
		SBCheckError(TElPGPKeyring_InternalFindSecretKeyByID(SBGetObjectHandle(getThis() TSRMLS_CC), aiKeyID.data, aiKeyID.len, &hoRes, (int32_t)l4StartIndex, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiKeyID);
		SBUpdateObjectHandle(oRes, hoRes TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &TElPGPCustomSecretKey, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, FindPublicKeyByFP)
{
	SBArrayZValInfo aiFP;
	zval *zaFP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaFP) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaFP)) || (IS_ARRAY == Z_TYPE_P(zaFP)) || (IS_NULL == Z_TYPE_P(zaFP))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaFP, &aiFP TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPKeyring_FindPublicKeyByFP(SBGetObjectHandle(getThis() TSRMLS_CC), aiFP.data, aiFP.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiFP);
		SBInitObject(return_value, TElPGPCustomPublicKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, FindSecretKeyByFP)
{
	SBArrayZValInfo aiFP;
	zval *zaFP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaFP) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaFP)) || (IS_ARRAY == Z_TYPE_P(zaFP)) || (IS_NULL == Z_TYPE_P(zaFP))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaFP, &aiFP TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPKeyring_FindSecretKeyByFP(SBGetObjectHandle(getThis() TSRMLS_CC), aiFP.data, aiFP.len, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiFP);
		SBInitObject(return_value, TElPGPCustomSecretKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, FindPublicKeyByEmailAddress)
{
	char *sAddress;
	int sAddress_len;
	long l4StartIndex;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sAddress, &sAddress_len, &l4StartIndex) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPKeyring_FindPublicKeyByEmailAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sAddress, (int32_t)sAddress_len, (int32_t)l4StartIndex, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, FindSecretKeyByEmailAddress)
{
	char *sAddress;
	int sAddress_len;
	long l4StartIndex;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sAddress, &sAddress_len, &l4StartIndex) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPKeyring_FindSecretKeyByEmailAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sAddress, (int32_t)sAddress_len, (int32_t)l4StartIndex, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, ListKeys)
{
	char *sTemplate;
	int sTemplate_len;
	TElClassHandle hoListOfKeys;
	zend_bool bIncludeSubkeysMatchingUserIDTemplateInResult;
	zend_bool bIsAndCondition;
	zend_bool bPublicOnly;
	zval *oListOfKeys;
	zval *oTemplates;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bsO", &bPublicOnly, &sTemplate, &sTemplate_len, &oListOfKeys, TList_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oListOfKeys) && (IS_OBJECT == Z_TYPE_P(oListOfKeys)))
	{
		hoListOfKeys = SBGetObjectHandle(oListOfKeys TSRMLS_CC);
		SBCheckError(TElPGPKeyring_ListKeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bPublicOnly, sTemplate, (int32_t)sTemplate_len, &hoListOfKeys) TSRMLS_CC);
		SBUpdateObjectHandle(oListOfKeys, hoListOfKeys TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bsbO", &bPublicOnly, &sTemplate, &sTemplate_len, &bIncludeSubkeysMatchingUserIDTemplateInResult, &oListOfKeys, TList_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oListOfKeys) && (IS_OBJECT == Z_TYPE_P(oListOfKeys)))
	{
		hoListOfKeys = SBGetObjectHandle(oListOfKeys TSRMLS_CC);
		SBCheckError(TElPGPKeyring_ListKeys_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bPublicOnly, sTemplate, (int32_t)sTemplate_len, (int8_t)bIncludeSubkeysMatchingUserIDTemplateInResult, &hoListOfKeys) TSRMLS_CC);
		SBUpdateObjectHandle(oListOfKeys, hoListOfKeys TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!bO", &bPublicOnly, &oTemplates, TStringList_ce_ptr, &bIsAndCondition, &oListOfKeys, TList_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oListOfKeys) && (IS_OBJECT == Z_TYPE_P(oListOfKeys)))
	{
		hoListOfKeys = SBGetObjectHandle(oListOfKeys TSRMLS_CC);
		SBCheckError(TElPGPKeyring_ListKeys_2(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bPublicOnly, SBGetObjectHandle(oTemplates TSRMLS_CC), (int8_t)bIsAndCondition, &hoListOfKeys) TSRMLS_CC);
		SBUpdateObjectHandle(oListOfKeys, hoListOfKeys TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "bO!bbO", &bPublicOnly, &oTemplates, TStringList_ce_ptr, &bIsAndCondition, &bIncludeSubkeysMatchingUserIDTemplateInResult, &oListOfKeys, TList_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oListOfKeys) && (IS_OBJECT == Z_TYPE_P(oListOfKeys)))
	{
		hoListOfKeys = SBGetObjectHandle(oListOfKeys TSRMLS_CC);
		SBCheckError(TElPGPKeyring_ListKeys_3(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bPublicOnly, SBGetObjectHandle(oTemplates TSRMLS_CC), (int8_t)bIsAndCondition, (int8_t)bIncludeSubkeysMatchingUserIDTemplateInResult, &hoListOfKeys) TSRMLS_CC);
		SBUpdateObjectHandle(oListOfKeys, hoListOfKeys TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool, string, &TList) or (bool, string, bool, &TList) or (bool, TStringList, bool, &TList) or (bool, TStringList, bool, bool, &TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, PrepareForEncryption)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElPGPKeyring_PrepareForEncryption(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, PrepareForSigning)
{
	zend_bool bMultiUse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bMultiUse) == SUCCESS)
	{
		SBCheckError(TElPGPKeyring_PrepareForSigning(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bMultiUse) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, CancelPreparation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPKeyring_CancelPreparation(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, AsyncOperationFinished)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyring_AsyncOperationFinished(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, get_ArmorBoundary)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElPGPKeyring_get_ArmorBoundary(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-406594854, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, set_ArmorBoundary)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElPGPKeyring_set_ArmorBoundary(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, get_ArmorHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPKeyring_get_ArmorHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, get_PublicKeys)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPKeyring_get_PublicKeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPPublicKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, get_SecretKeys)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPKeyring_get_SecretKeys(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPGPSecretKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, get_PublicCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPKeyring_get_PublicCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, get_SecretCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElPGPKeyring_get_SecretCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, get_SaveSecretKeySignatures)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyring_get_SaveSecretKeySignatures(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, set_SaveSecretKeySignatures)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPKeyring_set_SaveSecretKeySignatures(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, get_WriteTrust)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElPGPKeyring_get_WriteTrust(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, set_WriteTrust)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElPGPKeyring_set_WriteTrust(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPKeyring, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPKeyring_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_Load, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, APublic_or_PublicKeysFile, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ASecret_or_SecretKeysFile, 0, 1)
	ZEND_ARG_INFO(0, Clear)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_AddX509Certificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certificate, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_AddPublicKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElPGPPublicKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_AddSecretKey, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Key, TElPGPSecretKey, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_RemovePublicKey, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Key_or_Index, 0, 1)
	ZEND_ARG_INFO(0, RemoveSecretKeyIfExists)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_RemoveSecretKey, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Key_or_Index, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_Save, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, APublic_or_PublicKeysFile, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ASecret_or_SecretKeysFile, 0, 1)
	ZEND_ARG_INFO(0, Armor)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_ExportTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TElPGPKeyring, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_FindPublicKeyByID, 0, 0, 3)
	ZEND_ARG_INFO(0, KeyID)
	ZEND_ARG_OBJ_INFO(1, Res, TElPGPCustomPublicKey, 0)
	ZEND_ARG_INFO(0, StartIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_FindSecretKeyByID, 0, 0, 3)
	ZEND_ARG_INFO(0, KeyID)
	ZEND_ARG_OBJ_INFO(1, Res, TElPGPCustomSecretKey, 0)
	ZEND_ARG_INFO(0, StartIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_InternalFindPublicKeyByID, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, KeyID, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Res, TElPGPCustomPublicKey, 0)
	ZEND_ARG_INFO(0, StartIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_InternalFindSecretKeyByID, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, KeyID, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Res, TElPGPCustomSecretKey, 0)
	ZEND_ARG_INFO(0, StartIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_FindPublicKeyByFP, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FP, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_FindSecretKeyByFP, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FP, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_FindPublicKeyByEmailAddress, 0, 0, 2)
	ZEND_ARG_INFO(0, Address)
	ZEND_ARG_INFO(0, StartIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_FindSecretKeyByEmailAddress, 0, 0, 2)
	ZEND_ARG_INFO(0, Address)
	ZEND_ARG_INFO(0, StartIndex)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_ListKeys, 0, 0, 3)
	ZEND_ARG_INFO(0, PublicOnly)
	ZEND_ARG_TYPE_INFO(0, Template_or_Templates, 0, 1)
	ZEND_ARG_INFO(1, ListOfKeys_or_IncludeSubkeysMatchingUserIDTemplateInResult_or_IsAndCondition)
	ZEND_ARG_INFO(1, ListOfKeys_or_IncludeSubkeysMatchingUserIDTemplateInResult)
	ZEND_ARG_OBJ_INFO(1, ListOfKeys, TList, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_PrepareForEncryption, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_PrepareForSigning, 0, 0, 1)
	ZEND_ARG_INFO(0, MultiUse)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_CancelPreparation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_AsyncOperationFinished, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_get_ArmorBoundary, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_set_ArmorBoundary, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_get_ArmorHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_get_PublicKeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_get_SecretKeys, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_get_PublicCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_get_SecretCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_get_SaveSecretKeySignatures, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_set_SaveSecretKeySignatures, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_get_WriteTrust, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring_set_WriteTrust, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPKeyring___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPKeyring_methods[] = {
	PHP_ME(TElPGPKeyring, Load, arginfo_TElPGPKeyring_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, AddX509Certificate, arginfo_TElPGPKeyring_AddX509Certificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, AddPublicKey, arginfo_TElPGPKeyring_AddPublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, AddSecretKey, arginfo_TElPGPKeyring_AddSecretKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, RemovePublicKey, arginfo_TElPGPKeyring_RemovePublicKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, RemoveSecretKey, arginfo_TElPGPKeyring_RemoveSecretKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, Clear, arginfo_TElPGPKeyring_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, Save, arginfo_TElPGPKeyring_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, ExportTo, arginfo_TElPGPKeyring_ExportTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, FindPublicKeyByID, arginfo_TElPGPKeyring_FindPublicKeyByID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, FindSecretKeyByID, arginfo_TElPGPKeyring_FindSecretKeyByID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, InternalFindPublicKeyByID, arginfo_TElPGPKeyring_InternalFindPublicKeyByID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, InternalFindSecretKeyByID, arginfo_TElPGPKeyring_InternalFindSecretKeyByID, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, FindPublicKeyByFP, arginfo_TElPGPKeyring_FindPublicKeyByFP, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, FindSecretKeyByFP, arginfo_TElPGPKeyring_FindSecretKeyByFP, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, FindPublicKeyByEmailAddress, arginfo_TElPGPKeyring_FindPublicKeyByEmailAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, FindSecretKeyByEmailAddress, arginfo_TElPGPKeyring_FindSecretKeyByEmailAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, ListKeys, arginfo_TElPGPKeyring_ListKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, PrepareForEncryption, arginfo_TElPGPKeyring_PrepareForEncryption, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, PrepareForSigning, arginfo_TElPGPKeyring_PrepareForSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, CancelPreparation, arginfo_TElPGPKeyring_CancelPreparation, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, AsyncOperationFinished, arginfo_TElPGPKeyring_AsyncOperationFinished, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, get_ArmorBoundary, arginfo_TElPGPKeyring_get_ArmorBoundary, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, set_ArmorBoundary, arginfo_TElPGPKeyring_set_ArmorBoundary, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, get_ArmorHeaders, arginfo_TElPGPKeyring_get_ArmorHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, get_PublicKeys, arginfo_TElPGPKeyring_get_PublicKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, get_SecretKeys, arginfo_TElPGPKeyring_get_SecretKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, get_PublicCount, arginfo_TElPGPKeyring_get_PublicCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, get_SecretCount, arginfo_TElPGPKeyring_get_SecretCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, get_SaveSecretKeySignatures, arginfo_TElPGPKeyring_get_SaveSecretKeySignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, set_SaveSecretKeySignatures, arginfo_TElPGPKeyring_set_SaveSecretKeySignatures, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, get_WriteTrust, arginfo_TElPGPKeyring_get_WriteTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, set_WriteTrust, arginfo_TElPGPKeyring_set_WriteTrust, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPKeyring, __construct, arginfo_TElPGPKeyring___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPKeyring(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPKeyring_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPKeyring", TElPGPKeyring_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElPGPKeyring_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElPGPJpegImage_ce_ptr = NULL;

SB_PHP_METHOD(TElPGPJpegImage, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPJpegImage_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, AssignTo)
{
	zval *oDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDest, TPersistent_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPJpegImage_AssignTo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDest TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TPersistent)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, Save)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPJpegImage_Save(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, Load)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElPGPJpegImage_Load(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, SaveToStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPJpegImage_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, LoadFromStream)
{
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElPGPJpegImage_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, SaveToFile)
{
	char *sFileName;
	int sFileName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TElPGPJpegImage_SaveToFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, LoadFromFile)
{
	char *sFileName;
	int sFileName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFileName, &sFileName_len) == SUCCESS)
	{
		SBCheckError(TElPGPJpegImage_LoadFromFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, get_JpegData)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElPGPJpegImage_get_JpegData(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1611324230, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, set_JpegData)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElPGPJpegImage_set_JpegData(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, get_OnRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPReadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPJpegImage_get_OnRead(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, set_OnRead)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPJpegImage_set_OnRead(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPReadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPReadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, get_OnWrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBPGPWriteEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElPGPJpegImage_get_OnWrite(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, set_OnWrite)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElPGPJpegImage_set_OnWrite(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBPGPWriteEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPGPWriteEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElPGPJpegImage, __construct)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPJpegImage_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElPGPUserAttrImageSubpacket_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElPGPJpegImage_Create_1(SBGetObjectHandle(oSource TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElPGPUserAttrImageSubpacket)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_Assign, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Source, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_AssignTo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Dest, TPersistent, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_Save, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_Load, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_SaveToFile, 0, 0, 1)
	ZEND_ARG_INFO(0, FileName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_LoadFromFile, 0, 0, 1)
	ZEND_ARG_INFO(0, FileName)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_get_JpegData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_set_JpegData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_get_OnRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_set_OnRead, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_get_OnWrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage_set_OnWrite, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElPGPJpegImage___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Source, TElPGPUserAttrImageSubpacket, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElPGPJpegImage_methods[] = {
	PHP_ME(TElPGPJpegImage, Assign, arginfo_TElPGPJpegImage_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, AssignTo, arginfo_TElPGPJpegImage_AssignTo, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, Save, arginfo_TElPGPJpegImage_Save, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, Load, arginfo_TElPGPJpegImage_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, SaveToStream, arginfo_TElPGPJpegImage_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, LoadFromStream, arginfo_TElPGPJpegImage_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, SaveToFile, arginfo_TElPGPJpegImage_SaveToFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, LoadFromFile, arginfo_TElPGPJpegImage_LoadFromFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, get_JpegData, arginfo_TElPGPJpegImage_get_JpegData, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, set_JpegData, arginfo_TElPGPJpegImage_set_JpegData, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, get_OnRead, arginfo_TElPGPJpegImage_get_OnRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, set_OnRead, arginfo_TElPGPJpegImage_set_OnRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, get_OnWrite, arginfo_TElPGPJpegImage_get_OnWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, set_OnWrite, arginfo_TElPGPJpegImage_set_OnWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElPGPJpegImage, __construct, arginfo_TElPGPJpegImage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElPGPJpegImage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElPGPJpegImage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElPGPJpegImage", TElPGPJpegImage_methods);
	if (NULL == TPersistent_ce_ptr)
		Register_TPersistent(TSRMLS_C);
	TElPGPJpegImage_ce_ptr = zend_register_internal_class_ex(&ce, TPersistent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBPGPKeys_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBPGPUserCertificationType", NULL);
	TSBPGPUserCertificationType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPUserCertificationType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPUserCertificationType_ce_ptr, "ctGeneric", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPUserCertificationType_ce_ptr, "ctPersona", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPUserCertificationType_ce_ptr, "ctCasual", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPUserCertificationType_ce_ptr, "ctPositive", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBPGPKeyTrust", NULL);
	TSBPGPKeyTrust_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBPGPKeyTrust_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPKeyTrust_ce_ptr, "ktUndefined", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPKeyTrust_ce_ptr, "ktNone", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPKeyTrust_ce_ptr, "ktMarginal", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPKeyTrust_ce_ptr, "ktTrusted", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBPGPKeyTrust_ce_ptr, "ktImplicit", 4)
}

void Register_SBPGPKeys_Aliases(TSRMLS_D)
{
	if (NULL == TElPGPCustomPublicKey_ce_ptr)
		Register_TElPGPCustomPublicKey(TSRMLS_C);
	zend_register_class_alias("ElPGPCustomPublicKey", TElPGPCustomPublicKey_ce_ptr);
	if (NULL == TElPGPPublicSubkey_ce_ptr)
		Register_TElPGPPublicSubkey(TSRMLS_C);
	zend_register_class_alias("ElPGPPublicSubkey", TElPGPPublicSubkey_ce_ptr);
	if (NULL == TElPGPPublicKey_ce_ptr)
		Register_TElPGPPublicKey(TSRMLS_C);
	zend_register_class_alias("ElPGPPublicKey", TElPGPPublicKey_ce_ptr);
	if (NULL == TElPGPCustomSecretKey_ce_ptr)
		Register_TElPGPCustomSecretKey(TSRMLS_C);
	zend_register_class_alias("ElPGPCustomSecretKey", TElPGPCustomSecretKey_ce_ptr);
	if (NULL == TElPGPSecretSubkey_ce_ptr)
		Register_TElPGPSecretSubkey(TSRMLS_C);
	zend_register_class_alias("ElPGPSecretSubkey", TElPGPSecretSubkey_ce_ptr);
	if (NULL == TElPGPSecretKey_ce_ptr)
		Register_TElPGPSecretKey(TSRMLS_C);
	zend_register_class_alias("ElPGPSecretKey", TElPGPSecretKey_ce_ptr);
	if (NULL == TElPGPTrust_ce_ptr)
		Register_TElPGPTrust(TSRMLS_C);
	zend_register_class_alias("ElPGPTrust", TElPGPTrust_ce_ptr);
	if (NULL == TElPGPSignature_ce_ptr)
		Register_TElPGPSignature(TSRMLS_C);
	zend_register_class_alias("ElPGPSignature", TElPGPSignature_ce_ptr);
	if (NULL == TElPGPCustomUser_ce_ptr)
		Register_TElPGPCustomUser(TSRMLS_C);
	zend_register_class_alias("ElPGPCustomUser", TElPGPCustomUser_ce_ptr);
	if (NULL == TElPGPUserID_ce_ptr)
		Register_TElPGPUserID(TSRMLS_C);
	zend_register_class_alias("ElPGPUserID", TElPGPUserID_ce_ptr);
	if (NULL == TElPGPUserAttr_ce_ptr)
		Register_TElPGPUserAttr(TSRMLS_C);
	zend_register_class_alias("ElPGPUserAttr", TElPGPUserAttr_ce_ptr);
	if (NULL == TElPGPKeyring_ce_ptr)
		Register_TElPGPKeyring(TSRMLS_C);
	zend_register_class_alias("ElPGPKeyring", TElPGPKeyring_ce_ptr);
}

