#include "sbsamlserviceprovider.h"

zend_class_entry *TSBSAMLSPStage_ce_ptr = NULL;

void SB_CALLBACK TSBSAMLChangeSPSessionStageEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLSPSessionHandle Session, TSBSAMLSPStageRaw Stage)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zSession;
	zval * zStage;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSession);
	SBInitObject(zSession, TElSAMLSPSession_ce_ptr, Session TSRMLS_CC);
	MAKE_STD_ZVAL(zStage);
	ZVAL_LONG(zStage, (long)Stage);

	params[0] = &zSender;
	params[1] = &zSession;
	params[2] = &zStage;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSession);
	zval_ptr_dtor(&zStage);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK SBSAMLServiceProvider_TSBSAMLSessionEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLSPSessionHandle Session)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zSession;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSession);
	SBInitObject(zSession, TElSAMLSPSession_ce_ptr, Session TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSession;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSession);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK SBSAMLServiceProvider_TSBSAMLLogoutEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLSPSessionHandle Session, TElHTTPServerResponseParamsHandle ResponseParams)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zSession;
	zval * zResponseParams;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSession);
	SBInitObject(zSession, TElSAMLSPSession_ce_ptr, Session TSRMLS_CC);
	MAKE_STD_ZVAL(zResponseParams);
	SBInitObject(zResponseParams, TElHTTPServerResponseParams_ce_ptr, ResponseParams TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSession;
	params[2] = &zResponseParams;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSession);
	zval_ptr_dtor(&zResponseParams);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSAMLChooseNameIDPolicyEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLSPSessionHandle Session, TElSAMLNameIDPolicyElementHandle NameIDPolicy)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zSession;
	zval * zNameIDPolicy;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSession);
	SBInitObject(zSession, TElSAMLSPSession_ce_ptr, Session TSRMLS_CC);
	MAKE_STD_ZVAL(zNameIDPolicy);
	SBInitObject(zNameIDPolicy, TElSAMLNameIDPolicyElement_ce_ptr, NameIDPolicy TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSession;
	params[2] = &zNameIDPolicy;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSession);
	zval_ptr_dtor(&zNameIDPolicy);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *SBSAMLServiceProvider_TSBSAMLAccessLevel_ce_ptr = NULL;

zend_class_entry *TElSAMLSPSession_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSPSession, Generate)
{
	long l4TTL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4TTL) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSession_Generate(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4TTL) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, get_Stage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLSPStageRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLSPSession_get_Stage(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, set_Stage)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSession_set_Stage(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLSPStageRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, get_SAMLSession)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSPSession_get_SAMLSession(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2027473726, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, set_SAMLSession)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSession_set_SAMLSession(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, get_AuthnRequestID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSPSession_get_AuthnRequestID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(383902417, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, set_AuthnRequestID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSession_set_AuthnRequestID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, get_LogoutRequestID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLSPSession_get_LogoutRequestID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-731126010, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, set_LogoutRequestID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSession_set_LogoutRequestID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, get_SAMLCookieSet)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSPSession_get_SAMLCookieSet(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, set_SAMLCookieSet)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSession_set_SAMLCookieSet(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, get_NameID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSPSession_get_NameID(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, set_NameID)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLID_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSession_set_NameID(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLID)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, get_SessionIndexes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSPSession_get_SessionIndexes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, get_Redirected)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSPSession_get_Redirected(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, set_Redirected)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSession_set_Redirected(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSession, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSPSession_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_Generate, 0, 0, 1)
	ZEND_ARG_INFO(0, TTL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_get_Stage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_set_Stage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_get_SAMLSession, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_set_SAMLSession, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_get_AuthnRequestID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_set_AuthnRequestID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_get_LogoutRequestID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_set_LogoutRequestID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_get_SAMLCookieSet, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_set_SAMLCookieSet, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_get_NameID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_set_NameID, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLID, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_get_SessionIndexes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_get_Redirected, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession_set_Redirected, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSession___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSPSession_methods[] = {
	PHP_ME(TElSAMLSPSession, Generate, arginfo_TElSAMLSPSession_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, get_Stage, arginfo_TElSAMLSPSession_get_Stage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, set_Stage, arginfo_TElSAMLSPSession_set_Stage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, get_SAMLSession, arginfo_TElSAMLSPSession_get_SAMLSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, set_SAMLSession, arginfo_TElSAMLSPSession_set_SAMLSession, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, get_AuthnRequestID, arginfo_TElSAMLSPSession_get_AuthnRequestID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, set_AuthnRequestID, arginfo_TElSAMLSPSession_set_AuthnRequestID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, get_LogoutRequestID, arginfo_TElSAMLSPSession_get_LogoutRequestID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, set_LogoutRequestID, arginfo_TElSAMLSPSession_set_LogoutRequestID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, get_SAMLCookieSet, arginfo_TElSAMLSPSession_get_SAMLCookieSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, set_SAMLCookieSet, arginfo_TElSAMLSPSession_set_SAMLCookieSet, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, get_NameID, arginfo_TElSAMLSPSession_get_NameID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, set_NameID, arginfo_TElSAMLSPSession_set_NameID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, get_SessionIndexes, arginfo_TElSAMLSPSession_get_SessionIndexes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, get_Redirected, arginfo_TElSAMLSPSession_get_Redirected, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, set_Redirected, arginfo_TElSAMLSPSession_set_Redirected, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSession, __construct, arginfo_TElSAMLSPSession___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSPSession(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSPSession_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSPSession", TElSAMLSPSession_methods);
	if (NULL == TElSAMLSession_ce_ptr)
		Register_TElSAMLSession(TSRMLS_C);
	TElSAMLSPSession_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLSession_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLRequestResult_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLRequestResult, get_Doc)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRequestResult_get_Doc(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMDocument_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRequestResult, get_Response)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRequestResult_get_Response(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLStatusResponseType_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRequestResult, __construct)
{
	zval *oDoc;
	zval *oResponse;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDoc, TElXMLDOMDocument_ce_ptr, &oResponse, TElSAMLStatusResponseType_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRequestResult_Create(SBGetObjectHandle(oDoc TSRMLS_CC), SBGetObjectHandle(oResponse TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElSAMLStatusResponseType)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRequestResult_get_Doc, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRequestResult_get_Response, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRequestResult___construct, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, Doc, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Response, TElSAMLStatusResponseType, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLRequestResult_methods[] = {
	PHP_ME(TElSAMLRequestResult, get_Doc, arginfo_TElSAMLRequestResult_get_Doc, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRequestResult, get_Response, arginfo_TElSAMLRequestResult_get_Response, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRequestResult, __construct, arginfo_TElSAMLRequestResult___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLRequestResult(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLRequestResult_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLRequestResult", TElSAMLRequestResult_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSAMLRequestResult_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLOneTimeUseRecord_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLOneTimeUseRecord, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLOneTimeUseRecord_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1213105755, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOneTimeUseRecord, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLOneTimeUseRecord_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOneTimeUseRecord, get_IssueInstant)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLOneTimeUseRecord_get_IssueInstant(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOneTimeUseRecord, set_IssueInstant)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSAMLOneTimeUseRecord_set_IssueInstant(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOneTimeUseRecord, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOneTimeUseRecord_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOneTimeUseRecord_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOneTimeUseRecord_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOneTimeUseRecord_get_IssueInstant, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOneTimeUseRecord_set_IssueInstant, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOneTimeUseRecord___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLOneTimeUseRecord_methods[] = {
	PHP_ME(TElSAMLOneTimeUseRecord, get_ID, arginfo_TElSAMLOneTimeUseRecord_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOneTimeUseRecord, set_ID, arginfo_TElSAMLOneTimeUseRecord_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOneTimeUseRecord, get_IssueInstant, arginfo_TElSAMLOneTimeUseRecord_get_IssueInstant, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOneTimeUseRecord, set_IssueInstant, arginfo_TElSAMLOneTimeUseRecord_set_IssueInstant, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOneTimeUseRecord, __construct, arginfo_TElSAMLOneTimeUseRecord___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLOneTimeUseRecord(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLOneTimeUseRecord_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLOneTimeUseRecord", TElSAMLOneTimeUseRecord_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSAMLOneTimeUseRecord_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLCustomOneTimeUseCache_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLCustomOneTimeUseCache, Lock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLCustomOneTimeUseCache_Lock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCustomOneTimeUseCache, Unlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLCustomOneTimeUseCache_Unlock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCustomOneTimeUseCache, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLCustomOneTimeUseCache_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCustomOneTimeUseCache, Add)
{
	zval *oAssertion;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAssertion, TElSAMLAssertionElement_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLCustomOneTimeUseCache_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAssertion TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLAssertionElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCustomOneTimeUseCache, Find)
{
	zval *oAssertion;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAssertion, TElSAMLAssertionElement_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLCustomOneTimeUseCache_Find(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAssertion TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLAssertionElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLCustomOneTimeUseCache, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLCustomOneTimeUseCache_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCustomOneTimeUseCache_Lock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCustomOneTimeUseCache_Unlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCustomOneTimeUseCache_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCustomOneTimeUseCache_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Assertion, TElSAMLAssertionElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCustomOneTimeUseCache_Find, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Assertion, TElSAMLAssertionElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLCustomOneTimeUseCache___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLCustomOneTimeUseCache_methods[] = {
	PHP_ME(TElSAMLCustomOneTimeUseCache, Lock, arginfo_TElSAMLCustomOneTimeUseCache_Lock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCustomOneTimeUseCache, Unlock, arginfo_TElSAMLCustomOneTimeUseCache_Unlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCustomOneTimeUseCache, Clear, arginfo_TElSAMLCustomOneTimeUseCache_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCustomOneTimeUseCache, Add, arginfo_TElSAMLCustomOneTimeUseCache_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCustomOneTimeUseCache, Find, arginfo_TElSAMLCustomOneTimeUseCache_Find, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLCustomOneTimeUseCache, __construct, arginfo_TElSAMLCustomOneTimeUseCache___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLCustomOneTimeUseCache(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLCustomOneTimeUseCache_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLCustomOneTimeUseCache", TElSAMLCustomOneTimeUseCache_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSAMLCustomOneTimeUseCache_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLMemoryOneTimeUseCache_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLMemoryOneTimeUseCache, Lock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLMemoryOneTimeUseCache_Lock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMemoryOneTimeUseCache, Unlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLMemoryOneTimeUseCache_Unlock(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMemoryOneTimeUseCache, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLMemoryOneTimeUseCache_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMemoryOneTimeUseCache, Add)
{
	zval *oAssertion;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAssertion, TElSAMLAssertionElement_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLMemoryOneTimeUseCache_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAssertion TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLAssertionElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMemoryOneTimeUseCache, Find)
{
	zval *oAssertion;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAssertion, TElSAMLAssertionElement_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLMemoryOneTimeUseCache_Find(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAssertion TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLAssertionElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMemoryOneTimeUseCache, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLMemoryOneTimeUseCache_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMemoryOneTimeUseCache_Lock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMemoryOneTimeUseCache_Unlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMemoryOneTimeUseCache_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMemoryOneTimeUseCache_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Assertion, TElSAMLAssertionElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMemoryOneTimeUseCache_Find, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Assertion, TElSAMLAssertionElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMemoryOneTimeUseCache___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLMemoryOneTimeUseCache_methods[] = {
	PHP_ME(TElSAMLMemoryOneTimeUseCache, Lock, arginfo_TElSAMLMemoryOneTimeUseCache_Lock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMemoryOneTimeUseCache, Unlock, arginfo_TElSAMLMemoryOneTimeUseCache_Unlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMemoryOneTimeUseCache, Clear, arginfo_TElSAMLMemoryOneTimeUseCache_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMemoryOneTimeUseCache, Add, arginfo_TElSAMLMemoryOneTimeUseCache_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMemoryOneTimeUseCache, Find, arginfo_TElSAMLMemoryOneTimeUseCache_Find, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMemoryOneTimeUseCache, __construct, arginfo_TElSAMLMemoryOneTimeUseCache___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLMemoryOneTimeUseCache(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLMemoryOneTimeUseCache_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLMemoryOneTimeUseCache", TElSAMLMemoryOneTimeUseCache_methods);
	if (NULL == TElSAMLCustomOneTimeUseCache_ce_ptr)
		Register_TElSAMLCustomOneTimeUseCache(TSRMLS_C);
	TElSAMLMemoryOneTimeUseCache_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLCustomOneTimeUseCache_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLServiceProvider_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLServiceProvider, LoadMetadata)
{
	char *sURI;
	int sURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sURI, &sURI_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_LoadMetadata(SBGetObjectHandle(getThis() TSRMLS_CC), sURI, (int32_t)sURI_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, SaveMetadata)
{
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_SaveMetadata(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, DataAvailable)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_DataAvailable(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, Close)
{
	zend_bool bSilent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSilent) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_Close(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bSilent) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, SendRequest)
{
	zval *oRequest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oRequest, TElSAMLRequestAbstractType_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_SendRequest(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oRequest TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLRequestResult_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLRequestAbstractType)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, AddIDPSingleSignOnService)
{
	zval *oEndpoint;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oEndpoint, TElSAMLEndpoint_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_AddIDPSingleSignOnService(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oEndpoint TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLEndpoint)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, AddIDPSingleLogoutService)
{
	zval *oEndpoint;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oEndpoint, TElSAMLEndpoint_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_AddIDPSingleLogoutService(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oEndpoint TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLEndpoint)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, AddIDPArtifactResolutionService)
{
	zval *oEndpoint;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oEndpoint, TElSAMLEndpoint_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_AddIDPArtifactResolutionService(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oEndpoint TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLEndpoint)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, AddIDPAttributeQueryService)
{
	zval *oEndpoint;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oEndpoint, TElSAMLEndpoint_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_AddIDPAttributeQueryService(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oEndpoint TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLEndpoint)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, RemoveIDPSingleSignOnService)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_RemoveIDPSingleSignOnService(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, RemoveIDPSingleLogoutService)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_RemoveIDPSingleLogoutService(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, RemoveIDPArtifactResolutionService)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_RemoveIDPArtifactResolutionService(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, RemoveIDPAttributeQueryService)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_RemoveIDPAttributeQueryService(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_Control)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_Control(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSServer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_ProtectedResources)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_ProtectedResources(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPSingleSignOnServices)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_IDPSingleSignOnServices(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLEndpoint_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPSingleLogoutServices)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_IDPSingleLogoutServices(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLEndpoint_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPArtifactResolutionServices)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_IDPArtifactResolutionServices(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLEndpoint_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPAttributeQueryServices)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_IDPAttributeQueryServices(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLEndpoint_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPSignleSignOnServiceCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_IDPSignleSignOnServiceCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPSingleLogoutServiceCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_IDPSingleLogoutServiceCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPArtifactResolutionServiceCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_IDPArtifactResolutionServiceCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPAttributeQueryServiceCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_IDPAttributeQueryServiceCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SourceID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSAMLServiceProvider_get_SourceID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-313494713, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SourceID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSAMLServiceProvider_set_SourceID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPSourceID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSAMLServiceProvider_get_IDPSourceID(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(763768788, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_IDPSourceID)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSAMLServiceProvider_set_IDPSourceID(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_AutoIDPSourceID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_AutoIDPSourceID(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_AutoIDPSourceID)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_AutoIDPSourceID(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SendBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_SendBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SendBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SendBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_ServerName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_ServerName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1473456000, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_ServerName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_ServerName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SessionManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_SessionManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomSessionManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SessionManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomSessionManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SessionManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomSessionManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_AssertionsOneTimeUseCache)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_AssertionsOneTimeUseCache(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLCustomOneTimeUseCache_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_AssertionsOneTimeUseCache)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLCustomOneTimeUseCache_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_AssertionsOneTimeUseCache(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLCustomOneTimeUseCache)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-546249886, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_URL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SPToIDPBinding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLBindingTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_SPToIDPBinding(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SPToIDPBinding)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SPToIDPBinding(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLBindingTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_PrefferedIDPToSPBinding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLBindingTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_PrefferedIDPToSPBinding(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_PrefferedIDPToSPBinding)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_PrefferedIDPToSPBinding(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLBindingTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SingleLogoutServiceBindings)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLBindingTypesRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_SingleLogoutServiceBindings(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SingleLogoutServiceBindings)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SingleLogoutServiceBindings(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLBindingTypesRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_AssertionConsumerServiceBindings)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLBindingTypesRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_AssertionConsumerServiceBindings(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_AssertionConsumerServiceBindings)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_AssertionConsumerServiceBindings(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLBindingTypesRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_ArtifactResolutionServiceBindings)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLBindingTypesRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_ArtifactResolutionServiceBindings(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_MetadataURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_MetadataURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(431635571, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_MetadataURL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_MetadataURL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_AssertionConsumerService)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_AssertionConsumerService(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(623889844, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_AssertionConsumerService)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_AssertionConsumerService(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SingleLogoutService)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_SingleLogoutService(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-533321819, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SingleLogoutService)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SingleLogoutService(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_ArtifactResolutionService)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_ArtifactResolutionService(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-947703476, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_ArtifactResolutionService)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_ArtifactResolutionService(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_LogoutPage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_LogoutPage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(351972916, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_LogoutPage)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_LogoutPage(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_Issuer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1169963160, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_Issuer)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_Issuer(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SessionCookieName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_SessionCookieName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1705694562, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SessionCookieName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SessionCookieName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SAMLSessionCookieName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_SAMLSessionCookieName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(640800212, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SAMLSessionCookieName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SAMLSessionCookieName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPSigningCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_IDPSigningCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_IDPSigningCertificate)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_IDPSigningCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPEncryptionCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_IDPEncryptionCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_IDPEncryptionCertificate)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_IDPEncryptionCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPMetaSigningCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_IDPMetaSigningCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_IDPMetaSigningCertificate)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_IDPMetaSigningCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPAllowCreateIdentifier)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_IDPAllowCreateIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_IDPAllowCreateIdentifier)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_IDPAllowCreateIdentifier(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPNameIDFormats)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_IDPNameIDFormats(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPNameIDFormatIndex)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_IDPNameIDFormatIndex(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_IDPNameIDFormatIndex)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_IDPNameIDFormatIndex(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPPrefferedNameIDFormat)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_IDPPrefferedNameIDFormat(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-776982876, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_IDPPrefferedNameIDFormat)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_IDPPrefferedNameIDFormat(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_AccessLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBSAMLServiceProvider_TSBSAMLAccessLevelRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_AccessLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_AccessLevel)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_AccessLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (SBSAMLServiceProvider_TSBSAMLAccessLevelRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SessionTTL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_SessionTTL(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SessionTTL)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SessionTTL(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_MaxIssueInstantTimeDiff)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_MaxIssueInstantTimeDiff(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_MaxIssueInstantTimeDiff)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_MaxIssueInstantTimeDiff(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SignAuthnRequests)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_SignAuthnRequests(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SignAuthnRequests)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SignAuthnRequests(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SignLogoutRequests)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_SignLogoutRequests(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SignLogoutRequests)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SignLogoutRequests(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SignArtifactResolveRequests)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_SignArtifactResolveRequests(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SignArtifactResolveRequests)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SignArtifactResolveRequests(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SigningCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_SigningCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SigningCertificate)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SigningCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_EncryptionCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_EncryptionCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_EncryptionCertificate)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_EncryptionCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_MetaSigningCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_MetaSigningCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_MetaSigningCertificate)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_MetaSigningCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_RedirectOnLogoutPage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_RedirectOnLogoutPage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1483970691, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_RedirectOnLogoutPage)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_RedirectOnLogoutPage(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_ArtifactStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_ArtifactStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomArtifactStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_ArtifactStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomArtifactStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_ArtifactStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomArtifactStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_RedirectToSuppliedResource)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_RedirectToSuppliedResource(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_RedirectToSuppliedResource)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_RedirectToSuppliedResource(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_SignMetadata)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLServiceProvider_get_SignMetadata(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_SignMetadata)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_SignMetadata(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_IDPEntityID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLServiceProvider_get_IDPEntityID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(901471432, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_IDPEntityID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLServiceProvider_set_IDPEntityID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnSessionCreate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBSAMLServiceProvider_TSBSAMLSessionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnSessionCreate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnSessionCreate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnSessionCreate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &SBSAMLServiceProvider_TSBSAMLSessionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLSessionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnSessionDestroy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBSAMLServiceProvider_TSBSAMLSessionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnSessionDestroy(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnSessionDestroy)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnSessionDestroy(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &SBSAMLServiceProvider_TSBSAMLSessionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLSessionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnLogout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBSAMLServiceProvider_TSBSAMLLogoutEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnLogout(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnLogout)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnLogout(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &SBSAMLServiceProvider_TSBSAMLLogoutEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLLogoutEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnBeforeHTTPSServerUse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBXMLSAMLCommon_TSBSAMLBeforeHTTPSServerUseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnBeforeHTTPSServerUse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnBeforeHTTPSServerUse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnBeforeHTTPSServerUse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &SBXMLSAMLCommon_TSBSAMLBeforeHTTPSServerUseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLBeforeHTTPSServerUseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnBeforeHTTPSClientUse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLBeforeHTTPSClientUseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnBeforeHTTPSClientUse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnBeforeHTTPSClientUse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnBeforeHTTPSClientUse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLBeforeHTTPSClientUseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLBeforeHTTPSClientUseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnRequestPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLRequestPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnRequestPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnRequestPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnRequestPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLRequestPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLRequestPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnResponsePrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLResponsePreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnResponsePrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnResponsePrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnResponsePrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLResponsePreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLResponsePreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnResponseReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLResponseReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnResponseReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnResponseReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnResponseReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLResponseReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLResponseReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnRequestReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLRequestReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnRequestReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnRequestReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnRequestReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLRequestReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLRequestReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnChangeSessionStage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLChangeSPSessionStageEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnChangeSessionStage(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnChangeSessionStage)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnChangeSessionStage(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLChangeSPSessionStageEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLChangeSPSessionStageEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnMetadataPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLMetadataPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnMetadataPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnMetadataPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnMetadataPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLMetadataPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLMetadataPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnResourceOpen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLResourceOpenEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnResourceOpen(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnResourceOpen)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnResourceOpen(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLResourceOpenEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLResourceOpenEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnResourceRead)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLResourceReadEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnResourceRead(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnResourceRead)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnResourceRead(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLResourceReadEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLResourceReadEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnResourceClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLResourceCloseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnResourceClose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnResourceClose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnResourceClose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLResourceCloseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLResourceCloseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnSend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSendEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnSend(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnSend)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnSend(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSendEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSendEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnReceive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBReceiveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnReceive(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnReceive)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnReceive(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBReceiveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBReceiveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnOpenConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOpenConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnOpenConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnOpenConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnOpenConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBOpenConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBOpenConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnSSLError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnSSLError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnSSLError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnSSLError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnCloseConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBCloseConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnCloseConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBCloseConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBCloseConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnBindingXMLPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLBindingXMLPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnBindingXMLPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnBindingXMLPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnBindingXMLPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLBindingXMLPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLBindingXMLPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnBeforeBindingUse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLBeforeBindingUseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnBeforeBindingUse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnBeforeBindingUse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnBeforeBindingUse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLBeforeBindingUseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLBeforeBindingUseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnChooseMetadataIDPDescriptor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLChooseMetadataDescriptorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnChooseMetadataIDPDescriptor(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnChooseMetadataIDPDescriptor)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnChooseMetadataIDPDescriptor(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLChooseMetadataDescriptorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLChooseMetadataDescriptorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnChooseNameIDPolicy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLChooseNameIDPolicyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnChooseNameIDPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnChooseNameIDPolicy)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnChooseNameIDPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLChooseNameIDPolicyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLChooseNameIDPolicyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnResponderError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLResponderErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnResponderError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnResponderError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnResponderError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLResponderErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLResponderErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, get_OnResponseStatusCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLResponseStatusCodeEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_get_OnResponseStatusCode(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, set_OnResponseStatusCode)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSAMLServiceProvider_set_OnResponseStatusCode(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSAMLResponseStatusCodeEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSAMLResponseStatusCodeEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLServiceProvider, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceProvider_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_LoadMetadata, 0, 0, 1)
	ZEND_ARG_INFO(0, URI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_SaveMetadata, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_DataAvailable, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_Close, 0, 0, 1)
	ZEND_ARG_INFO(0, Silent)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_SendRequest, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Request, TElSAMLRequestAbstractType, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_AddIDPSingleSignOnService, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Endpoint, TElSAMLEndpoint, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_AddIDPSingleLogoutService, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Endpoint, TElSAMLEndpoint, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_AddIDPArtifactResolutionService, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Endpoint, TElSAMLEndpoint, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_AddIDPAttributeQueryService, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Endpoint, TElSAMLEndpoint, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_RemoveIDPSingleSignOnService, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_RemoveIDPSingleLogoutService, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_RemoveIDPArtifactResolutionService, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_RemoveIDPAttributeQueryService, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_Control, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_ProtectedResources, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPSingleSignOnServices, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPSingleLogoutServices, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPArtifactResolutionServices, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPAttributeQueryServices, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPSignleSignOnServiceCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPSingleLogoutServiceCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPArtifactResolutionServiceCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPAttributeQueryServiceCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SourceID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SourceID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPSourceID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_IDPSourceID, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_AutoIDPSourceID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_AutoIDPSourceID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SendBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SendBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_ServerName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_ServerName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SessionManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SessionManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomSessionManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_AssertionsOneTimeUseCache, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_AssertionsOneTimeUseCache, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLCustomOneTimeUseCache, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_URL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SPToIDPBinding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SPToIDPBinding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_PrefferedIDPToSPBinding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_PrefferedIDPToSPBinding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SingleLogoutServiceBindings, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SingleLogoutServiceBindings, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_AssertionConsumerServiceBindings, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_AssertionConsumerServiceBindings, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_ArtifactResolutionServiceBindings, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_MetadataURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_MetadataURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_AssertionConsumerService, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_AssertionConsumerService, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SingleLogoutService, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SingleLogoutService, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_ArtifactResolutionService, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_ArtifactResolutionService, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_LogoutPage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_LogoutPage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_Issuer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_Issuer, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SessionCookieName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SessionCookieName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SAMLSessionCookieName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SAMLSessionCookieName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPSigningCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_IDPSigningCertificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPEncryptionCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_IDPEncryptionCertificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPMetaSigningCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_IDPMetaSigningCertificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPAllowCreateIdentifier, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_IDPAllowCreateIdentifier, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPNameIDFormats, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPNameIDFormatIndex, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_IDPNameIDFormatIndex, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPPrefferedNameIDFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_IDPPrefferedNameIDFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_AccessLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_AccessLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SessionTTL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SessionTTL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_MaxIssueInstantTimeDiff, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_MaxIssueInstantTimeDiff, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SignAuthnRequests, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SignAuthnRequests, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SignLogoutRequests, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SignLogoutRequests, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SignArtifactResolveRequests, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SignArtifactResolveRequests, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SigningCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SigningCertificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_EncryptionCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_EncryptionCertificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_MetaSigningCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_MetaSigningCertificate, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_RedirectOnLogoutPage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_RedirectOnLogoutPage, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_ArtifactStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_ArtifactStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomArtifactStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_RedirectToSuppliedResource, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_RedirectToSuppliedResource, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_SignMetadata, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_SignMetadata, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_IDPEntityID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_IDPEntityID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnSessionCreate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnSessionCreate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnSessionDestroy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnSessionDestroy, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnLogout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnLogout, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnBeforeHTTPSServerUse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnBeforeHTTPSServerUse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnBeforeHTTPSClientUse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnBeforeHTTPSClientUse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnRequestPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnRequestPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnResponsePrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnResponsePrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnResponseReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnResponseReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnRequestReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnRequestReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnChangeSessionStage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnChangeSessionStage, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnMetadataPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnMetadataPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnResourceOpen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnResourceOpen, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnResourceRead, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnResourceRead, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnResourceClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnResourceClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnSend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnSend, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnReceive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnReceive, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnOpenConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnOpenConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnSSLError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnSSLError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnCloseConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnCloseConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnBindingXMLPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnBindingXMLPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnBeforeBindingUse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnBeforeBindingUse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnChooseMetadataIDPDescriptor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnChooseMetadataIDPDescriptor, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnChooseNameIDPolicy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnChooseNameIDPolicy, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnResponderError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnResponderError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_get_OnResponseStatusCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider_set_OnResponseStatusCode, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceProvider___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLServiceProvider_methods[] = {
	PHP_ME(TElSAMLServiceProvider, LoadMetadata, arginfo_TElSAMLServiceProvider_LoadMetadata, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, SaveMetadata, arginfo_TElSAMLServiceProvider_SaveMetadata, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, Open, arginfo_TElSAMLServiceProvider_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, DataAvailable, arginfo_TElSAMLServiceProvider_DataAvailable, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, Close, arginfo_TElSAMLServiceProvider_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, SendRequest, arginfo_TElSAMLServiceProvider_SendRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, AddIDPSingleSignOnService, arginfo_TElSAMLServiceProvider_AddIDPSingleSignOnService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, AddIDPSingleLogoutService, arginfo_TElSAMLServiceProvider_AddIDPSingleLogoutService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, AddIDPArtifactResolutionService, arginfo_TElSAMLServiceProvider_AddIDPArtifactResolutionService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, AddIDPAttributeQueryService, arginfo_TElSAMLServiceProvider_AddIDPAttributeQueryService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, RemoveIDPSingleSignOnService, arginfo_TElSAMLServiceProvider_RemoveIDPSingleSignOnService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, RemoveIDPSingleLogoutService, arginfo_TElSAMLServiceProvider_RemoveIDPSingleLogoutService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, RemoveIDPArtifactResolutionService, arginfo_TElSAMLServiceProvider_RemoveIDPArtifactResolutionService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, RemoveIDPAttributeQueryService, arginfo_TElSAMLServiceProvider_RemoveIDPAttributeQueryService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_Control, arginfo_TElSAMLServiceProvider_get_Control, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_ProtectedResources, arginfo_TElSAMLServiceProvider_get_ProtectedResources, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPSingleSignOnServices, arginfo_TElSAMLServiceProvider_get_IDPSingleSignOnServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPSingleLogoutServices, arginfo_TElSAMLServiceProvider_get_IDPSingleLogoutServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPArtifactResolutionServices, arginfo_TElSAMLServiceProvider_get_IDPArtifactResolutionServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPAttributeQueryServices, arginfo_TElSAMLServiceProvider_get_IDPAttributeQueryServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPSignleSignOnServiceCount, arginfo_TElSAMLServiceProvider_get_IDPSignleSignOnServiceCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPSingleLogoutServiceCount, arginfo_TElSAMLServiceProvider_get_IDPSingleLogoutServiceCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPArtifactResolutionServiceCount, arginfo_TElSAMLServiceProvider_get_IDPArtifactResolutionServiceCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPAttributeQueryServiceCount, arginfo_TElSAMLServiceProvider_get_IDPAttributeQueryServiceCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SourceID, arginfo_TElSAMLServiceProvider_get_SourceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SourceID, arginfo_TElSAMLServiceProvider_set_SourceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPSourceID, arginfo_TElSAMLServiceProvider_get_IDPSourceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_IDPSourceID, arginfo_TElSAMLServiceProvider_set_IDPSourceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_AutoIDPSourceID, arginfo_TElSAMLServiceProvider_get_AutoIDPSourceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_AutoIDPSourceID, arginfo_TElSAMLServiceProvider_set_AutoIDPSourceID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_Active, arginfo_TElSAMLServiceProvider_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SendBufferSize, arginfo_TElSAMLServiceProvider_get_SendBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SendBufferSize, arginfo_TElSAMLServiceProvider_set_SendBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_ServerName, arginfo_TElSAMLServiceProvider_get_ServerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_ServerName, arginfo_TElSAMLServiceProvider_set_ServerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SessionManager, arginfo_TElSAMLServiceProvider_get_SessionManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SessionManager, arginfo_TElSAMLServiceProvider_set_SessionManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_AssertionsOneTimeUseCache, arginfo_TElSAMLServiceProvider_get_AssertionsOneTimeUseCache, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_AssertionsOneTimeUseCache, arginfo_TElSAMLServiceProvider_set_AssertionsOneTimeUseCache, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_URL, arginfo_TElSAMLServiceProvider_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_URL, arginfo_TElSAMLServiceProvider_set_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SPToIDPBinding, arginfo_TElSAMLServiceProvider_get_SPToIDPBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SPToIDPBinding, arginfo_TElSAMLServiceProvider_set_SPToIDPBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_PrefferedIDPToSPBinding, arginfo_TElSAMLServiceProvider_get_PrefferedIDPToSPBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_PrefferedIDPToSPBinding, arginfo_TElSAMLServiceProvider_set_PrefferedIDPToSPBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SingleLogoutServiceBindings, arginfo_TElSAMLServiceProvider_get_SingleLogoutServiceBindings, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SingleLogoutServiceBindings, arginfo_TElSAMLServiceProvider_set_SingleLogoutServiceBindings, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_AssertionConsumerServiceBindings, arginfo_TElSAMLServiceProvider_get_AssertionConsumerServiceBindings, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_AssertionConsumerServiceBindings, arginfo_TElSAMLServiceProvider_set_AssertionConsumerServiceBindings, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_ArtifactResolutionServiceBindings, arginfo_TElSAMLServiceProvider_get_ArtifactResolutionServiceBindings, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_MetadataURL, arginfo_TElSAMLServiceProvider_get_MetadataURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_MetadataURL, arginfo_TElSAMLServiceProvider_set_MetadataURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_AssertionConsumerService, arginfo_TElSAMLServiceProvider_get_AssertionConsumerService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_AssertionConsumerService, arginfo_TElSAMLServiceProvider_set_AssertionConsumerService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SingleLogoutService, arginfo_TElSAMLServiceProvider_get_SingleLogoutService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SingleLogoutService, arginfo_TElSAMLServiceProvider_set_SingleLogoutService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_ArtifactResolutionService, arginfo_TElSAMLServiceProvider_get_ArtifactResolutionService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_ArtifactResolutionService, arginfo_TElSAMLServiceProvider_set_ArtifactResolutionService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_LogoutPage, arginfo_TElSAMLServiceProvider_get_LogoutPage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_LogoutPage, arginfo_TElSAMLServiceProvider_set_LogoutPage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_Issuer, arginfo_TElSAMLServiceProvider_get_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_Issuer, arginfo_TElSAMLServiceProvider_set_Issuer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SessionCookieName, arginfo_TElSAMLServiceProvider_get_SessionCookieName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SessionCookieName, arginfo_TElSAMLServiceProvider_set_SessionCookieName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SAMLSessionCookieName, arginfo_TElSAMLServiceProvider_get_SAMLSessionCookieName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SAMLSessionCookieName, arginfo_TElSAMLServiceProvider_set_SAMLSessionCookieName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPSigningCertificate, arginfo_TElSAMLServiceProvider_get_IDPSigningCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_IDPSigningCertificate, arginfo_TElSAMLServiceProvider_set_IDPSigningCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPEncryptionCertificate, arginfo_TElSAMLServiceProvider_get_IDPEncryptionCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_IDPEncryptionCertificate, arginfo_TElSAMLServiceProvider_set_IDPEncryptionCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPMetaSigningCertificate, arginfo_TElSAMLServiceProvider_get_IDPMetaSigningCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_IDPMetaSigningCertificate, arginfo_TElSAMLServiceProvider_set_IDPMetaSigningCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPAllowCreateIdentifier, arginfo_TElSAMLServiceProvider_get_IDPAllowCreateIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_IDPAllowCreateIdentifier, arginfo_TElSAMLServiceProvider_set_IDPAllowCreateIdentifier, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPNameIDFormats, arginfo_TElSAMLServiceProvider_get_IDPNameIDFormats, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPNameIDFormatIndex, arginfo_TElSAMLServiceProvider_get_IDPNameIDFormatIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_IDPNameIDFormatIndex, arginfo_TElSAMLServiceProvider_set_IDPNameIDFormatIndex, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPPrefferedNameIDFormat, arginfo_TElSAMLServiceProvider_get_IDPPrefferedNameIDFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_IDPPrefferedNameIDFormat, arginfo_TElSAMLServiceProvider_set_IDPPrefferedNameIDFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_AccessLevel, arginfo_TElSAMLServiceProvider_get_AccessLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_AccessLevel, arginfo_TElSAMLServiceProvider_set_AccessLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SessionTTL, arginfo_TElSAMLServiceProvider_get_SessionTTL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SessionTTL, arginfo_TElSAMLServiceProvider_set_SessionTTL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_MaxIssueInstantTimeDiff, arginfo_TElSAMLServiceProvider_get_MaxIssueInstantTimeDiff, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_MaxIssueInstantTimeDiff, arginfo_TElSAMLServiceProvider_set_MaxIssueInstantTimeDiff, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SignAuthnRequests, arginfo_TElSAMLServiceProvider_get_SignAuthnRequests, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SignAuthnRequests, arginfo_TElSAMLServiceProvider_set_SignAuthnRequests, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SignLogoutRequests, arginfo_TElSAMLServiceProvider_get_SignLogoutRequests, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SignLogoutRequests, arginfo_TElSAMLServiceProvider_set_SignLogoutRequests, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SignArtifactResolveRequests, arginfo_TElSAMLServiceProvider_get_SignArtifactResolveRequests, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SignArtifactResolveRequests, arginfo_TElSAMLServiceProvider_set_SignArtifactResolveRequests, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_CertStorage, arginfo_TElSAMLServiceProvider_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_CertStorage, arginfo_TElSAMLServiceProvider_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SigningCertificate, arginfo_TElSAMLServiceProvider_get_SigningCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SigningCertificate, arginfo_TElSAMLServiceProvider_set_SigningCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_EncryptionCertificate, arginfo_TElSAMLServiceProvider_get_EncryptionCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_EncryptionCertificate, arginfo_TElSAMLServiceProvider_set_EncryptionCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_MetaSigningCertificate, arginfo_TElSAMLServiceProvider_get_MetaSigningCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_MetaSigningCertificate, arginfo_TElSAMLServiceProvider_set_MetaSigningCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_RedirectOnLogoutPage, arginfo_TElSAMLServiceProvider_get_RedirectOnLogoutPage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_RedirectOnLogoutPage, arginfo_TElSAMLServiceProvider_set_RedirectOnLogoutPage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_ArtifactStorage, arginfo_TElSAMLServiceProvider_get_ArtifactStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_ArtifactStorage, arginfo_TElSAMLServiceProvider_set_ArtifactStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_RedirectToSuppliedResource, arginfo_TElSAMLServiceProvider_get_RedirectToSuppliedResource, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_RedirectToSuppliedResource, arginfo_TElSAMLServiceProvider_set_RedirectToSuppliedResource, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_SignMetadata, arginfo_TElSAMLServiceProvider_get_SignMetadata, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_SignMetadata, arginfo_TElSAMLServiceProvider_set_SignMetadata, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_IDPEntityID, arginfo_TElSAMLServiceProvider_get_IDPEntityID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_IDPEntityID, arginfo_TElSAMLServiceProvider_set_IDPEntityID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnSessionCreate, arginfo_TElSAMLServiceProvider_get_OnSessionCreate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnSessionCreate, arginfo_TElSAMLServiceProvider_set_OnSessionCreate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnSessionDestroy, arginfo_TElSAMLServiceProvider_get_OnSessionDestroy, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnSessionDestroy, arginfo_TElSAMLServiceProvider_set_OnSessionDestroy, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnLogout, arginfo_TElSAMLServiceProvider_get_OnLogout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnLogout, arginfo_TElSAMLServiceProvider_set_OnLogout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnBeforeHTTPSServerUse, arginfo_TElSAMLServiceProvider_get_OnBeforeHTTPSServerUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnBeforeHTTPSServerUse, arginfo_TElSAMLServiceProvider_set_OnBeforeHTTPSServerUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnBeforeHTTPSClientUse, arginfo_TElSAMLServiceProvider_get_OnBeforeHTTPSClientUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnBeforeHTTPSClientUse, arginfo_TElSAMLServiceProvider_set_OnBeforeHTTPSClientUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnRequestPrepared, arginfo_TElSAMLServiceProvider_get_OnRequestPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnRequestPrepared, arginfo_TElSAMLServiceProvider_set_OnRequestPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnResponsePrepared, arginfo_TElSAMLServiceProvider_get_OnResponsePrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnResponsePrepared, arginfo_TElSAMLServiceProvider_set_OnResponsePrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnResponseReceived, arginfo_TElSAMLServiceProvider_get_OnResponseReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnResponseReceived, arginfo_TElSAMLServiceProvider_set_OnResponseReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnRequestReceived, arginfo_TElSAMLServiceProvider_get_OnRequestReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnRequestReceived, arginfo_TElSAMLServiceProvider_set_OnRequestReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnChangeSessionStage, arginfo_TElSAMLServiceProvider_get_OnChangeSessionStage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnChangeSessionStage, arginfo_TElSAMLServiceProvider_set_OnChangeSessionStage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnMetadataPrepared, arginfo_TElSAMLServiceProvider_get_OnMetadataPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnMetadataPrepared, arginfo_TElSAMLServiceProvider_set_OnMetadataPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnResourceOpen, arginfo_TElSAMLServiceProvider_get_OnResourceOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnResourceOpen, arginfo_TElSAMLServiceProvider_set_OnResourceOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnResourceRead, arginfo_TElSAMLServiceProvider_get_OnResourceRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnResourceRead, arginfo_TElSAMLServiceProvider_set_OnResourceRead, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnResourceClose, arginfo_TElSAMLServiceProvider_get_OnResourceClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnResourceClose, arginfo_TElSAMLServiceProvider_set_OnResourceClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnSend, arginfo_TElSAMLServiceProvider_get_OnSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnSend, arginfo_TElSAMLServiceProvider_set_OnSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnReceive, arginfo_TElSAMLServiceProvider_get_OnReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnReceive, arginfo_TElSAMLServiceProvider_set_OnReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnOpenConnection, arginfo_TElSAMLServiceProvider_get_OnOpenConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnOpenConnection, arginfo_TElSAMLServiceProvider_set_OnOpenConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnSSLError, arginfo_TElSAMLServiceProvider_get_OnSSLError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnSSLError, arginfo_TElSAMLServiceProvider_set_OnSSLError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnCloseConnection, arginfo_TElSAMLServiceProvider_get_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnCloseConnection, arginfo_TElSAMLServiceProvider_set_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnBindingXMLPrepared, arginfo_TElSAMLServiceProvider_get_OnBindingXMLPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnBindingXMLPrepared, arginfo_TElSAMLServiceProvider_set_OnBindingXMLPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnBeforeBindingUse, arginfo_TElSAMLServiceProvider_get_OnBeforeBindingUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnBeforeBindingUse, arginfo_TElSAMLServiceProvider_set_OnBeforeBindingUse, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnChooseMetadataIDPDescriptor, arginfo_TElSAMLServiceProvider_get_OnChooseMetadataIDPDescriptor, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnChooseMetadataIDPDescriptor, arginfo_TElSAMLServiceProvider_set_OnChooseMetadataIDPDescriptor, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnChooseNameIDPolicy, arginfo_TElSAMLServiceProvider_get_OnChooseNameIDPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnChooseNameIDPolicy, arginfo_TElSAMLServiceProvider_set_OnChooseNameIDPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnResponderError, arginfo_TElSAMLServiceProvider_get_OnResponderError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnResponderError, arginfo_TElSAMLServiceProvider_set_OnResponderError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, get_OnResponseStatusCode, arginfo_TElSAMLServiceProvider_get_OnResponseStatusCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, set_OnResponseStatusCode, arginfo_TElSAMLServiceProvider_set_OnResponseStatusCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLServiceProvider, __construct, arginfo_TElSAMLServiceProvider___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLServiceProvider(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLServiceProvider_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLServiceProvider", TElSAMLServiceProvider_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElSAMLServiceProvider_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSAMLServiceProvider_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBSAMLSPStage", NULL);
	TSBSAMLSPStage_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLSPStage_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLSPStage_ce_ptr, "spsStart", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLSPStage_ce_ptr, "spsAuthnRequestSent", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLSPStage_ce_ptr, "spsResponseReceived", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLSPStage_ce_ptr, "spsResourceSupplied", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLSPStage_ce_ptr, "spsLogoutRequestSent", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLSPStage_ce_ptr, "spsLogoutResponseReceived", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLSPStage_ce_ptr, "spsLogoutRequestRecv", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLSPStage_ce_ptr, "spsLogoutResponseSent", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLSPStage_ce_ptr, "spsArtifactResolveRecv", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLSPStage_ce_ptr, "spsArtifactResponseSent", 9)
	
	INIT_CLASS_ENTRY(ce, "SBSAMLServiceProvider_TSBSAMLAccessLevel", NULL);
	SBSAMLServiceProvider_TSBSAMLAccessLevel_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	SBSAMLServiceProvider_TSBSAMLAccessLevel_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(SBSAMLServiceProvider_TSBSAMLAccessLevel_ce_ptr, "salDomain", 0)
	SB_DECLARE_CLASS_LONG_CONST(SBSAMLServiceProvider_TSBSAMLAccessLevel_ce_ptr, "salExactURL", 1)
}
