#include "sbsimplesftp.h"

zend_class_entry *TElSimpleSFTPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElSimpleSFTPClient, ExtensionCmd)
{
	char *sExtension;
	int sExtension_len;
	long l4Size;
	SBArrayZValInfo piDataBuffer;
	zval *oResponseStream;
	zval *zpDataBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szlO!", &sExtension, &sExtension_len, &zpDataBuffer, &l4Size, &oResponseStream, TStream_ce_ptr) == SUCCESS) && ((Z_TYPE_P(zpDataBuffer) == IS_STRING) || (Z_TYPE_P(zpDataBuffer) == IS_ARRAY) || (Z_TYPE_P(zpDataBuffer) == IS_NULL) || ((Z_TYPE_P(zpDataBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpDataBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpDataBuffer, &piDataBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_ExtensionCmd(SBGetObjectHandle(getThis() TSRMLS_CC), sExtension, (int32_t)sExtension_len, piDataBuffer.data, (int32_t)l4Size, SBGetObjectHandle(oResponseStream TSRMLS_CC)) TSRMLS_CC);
		SBFreePointerZValInfo(&piDataBuffer);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sExtension, &sExtension_len, &oResponseStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_ExtensionCmd_1(SBGetObjectHandle(getThis() TSRMLS_CC), sExtension, (int32_t)sExtension_len, SBGetObjectHandle(oResponseStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TSBPointer|array of byte|string|NULL, integer, TStream) or (string, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, Block)
{
	long fLockMask;
	long l8Length;
	long l8Offset;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlll", &zaHandle, &l8Offset, &l8Length, &fLockMask) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_Block(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, (int64_t)l8Length, (TSBSftpFileOpenAccessRaw)fLockMask) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, Unblock)
{
	long l8Length;
	long l8Offset;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaHandle, &l8Offset, &l8Length) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_Unblock(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, (int64_t)l8Length) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, SendVendorID)
{
	zval *oVendorID;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oVendorID, TElSftpVendorIDExtension_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_SendVendorID(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oVendorID TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSftpVendorIDExtension)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, RequestFileHash)
{
	char *sFileName;
	int sFileName_len;
	long l8Length;
	long l8StartOffset;
	long u4BlockSize;
	zval *oFileHash;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slllO!", &sFileName, &sFileName_len, &l8StartOffset, &l8Length, &u4BlockSize, &oFileHash, TElSftpCheckFileReply_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_RequestFileHash(SBGetObjectHandle(getThis() TSRMLS_CC), sFileName, (int32_t)sFileName_len, (int64_t)l8StartOffset, (int64_t)l8Length, (uint32_t)u4BlockSize, SBGetObjectHandle(oFileHash TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, integer, integer, TElSftpCheckFileReply)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, RequestFileHashByHandle)
{
	long l8Length;
	long l8StartOffset;
	long u4BlockSize;
	SBArrayZValInfo aiHandle;
	zval *oFileHash;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlllO!", &zaHandle, &l8StartOffset, &l8Length, &u4BlockSize, &oFileHash, TElSftpCheckFileReply_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_RequestFileHashByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8StartOffset, (int64_t)l8Length, (uint32_t)u4BlockSize, SBGetObjectHandle(oFileHash TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, integer, TElSftpCheckFileReply)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, QueryAvailableSpace)
{
	char *sPath;
	int sPath_len;
	zval *oAvailSpace;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oAvailSpace, TElSftpSpaceAvailableReply_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_QueryAvailableSpace(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oAvailSpace TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElSftpSpaceAvailableReply)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, QueryStatVFS)
{
	char *sPath;
	int sPath_len;
	zval *oStatVFS;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oStatVFS, TElSftpStatVFSReply_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_QueryStatVFS(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oStatVFS TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElSftpStatVFSReply)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, QueryHomeDirectory)
{
	char *sUsername;
	int sUsername_len;
	zval *oHomeDir;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sUsername, &sUsername_len, &oHomeDir, TElSftpFileInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_QueryHomeDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sUsername, (int32_t)sUsername_len, SBGetObjectHandle(oHomeDir TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElSftpFileInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, CopyRemoteFile)
{
	char *sDestination;
	char *sSource;
	int sDestination_len;
	int sSource_len;
	zend_bool bOverwrite;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sSource, &sSource_len, &sDestination, &sDestination_len, &bOverwrite) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_CopyRemoteFile(SBGetObjectHandle(getThis() TSRMLS_CC), sSource, (int32_t)sSource_len, sDestination, (int32_t)sDestination_len, (int8_t)bOverwrite) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, CopyRemoteData)
{
	long l8DataLength;
	long l8ReadFromOffset;
	long l8WriteToOffset;
	SBArrayZValInfo aiReadFrom;
	SBArrayZValInfo aiWriteTo;
	zval *zaReadFrom;
	zval *zaWriteTo;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzll", &zaReadFrom, &l8ReadFromOffset, &zaWriteTo, &l8WriteToOffset, &l8DataLength) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaReadFrom)) || (IS_ARRAY == Z_TYPE_P(zaReadFrom)) || (IS_NULL == Z_TYPE_P(zaReadFrom))) && ((IS_STRING == Z_TYPE_P(zaWriteTo)) || (IS_ARRAY == Z_TYPE_P(zaWriteTo)) || (IS_NULL == Z_TYPE_P(zaWriteTo))))
	{
		if (!SBGetByteArrayFromZVal(zaReadFrom, &aiReadFrom TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaWriteTo, &aiWriteTo TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_CopyRemoteData(SBGetObjectHandle(getThis() TSRMLS_CC), aiReadFrom.data, aiReadFrom.len, (int64_t)l8ReadFromOffset, aiWriteTo.data, aiWriteTo.len, (int64_t)l8WriteToOffset, (int64_t)l8DataLength) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiReadFrom);
		SBFreeArrayZValInfo(&aiWriteTo);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, RequestTempFolder)
{
	zval *oTempFolder;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTempFolder, TElSftpFileInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_RequestTempFolder(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTempFolder TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSftpFileInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, MakeTempFolder)
{
	zval *oTempFolder;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTempFolder, TElSftpFileInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_MakeTempFolder(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTempFolder TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSftpFileInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, FileExists)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_FileExists(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, GetFileSize)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_GetFileSize(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, DirExists)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_DirExists(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, Interrupt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_Interrupt(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, Close)
{
	zend_bool bSilent;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bSilent) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_Close(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bSilent) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, CloseHandle)
{
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHandle) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_CloseHandle(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, CreateFile)
{
	char *sFilename;
	int sFilename_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSimpleSFTPClient_CreateFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1261218306, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, CreateSymLink)
{
	char *sLinkPath;
	char *sTargetPath;
	int sLinkPath_len;
	int sTargetPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sLinkPath, &sLinkPath_len, &sTargetPath, &sTargetPath_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_CreateSymLink(SBGetObjectHandle(getThis() TSRMLS_CC), sLinkPath, (int32_t)sLinkPath_len, sTargetPath, (int32_t)sTargetPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, CreateHardLink)
{
	char *sLinkPath;
	char *sTargetPath;
	int sLinkPath_len;
	int sTargetPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sLinkPath, &sLinkPath_len, &sTargetPath, &sTargetPath_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_CreateHardLink(SBGetObjectHandle(getThis() TSRMLS_CC), sLinkPath, (int32_t)sLinkPath_len, sTargetPath, (int32_t)sTargetPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, DownloadFiles)
{
	char *sLocalPath;
	char *sRemoteMask;
	char *sRemotePath;
	int sLocalPath_len;
	int sRemoteMask_len;
	int sRemotePath_len;
	long fCaseConversion;
	long fCopyMode;
	long fMode;
	zend_bool bCaseSensitive;
	zend_bool bDeleteFiles;
	zend_bool bRecursive;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssslblb", &sRemotePath, &sRemotePath_len, &sRemoteMask, &sRemoteMask_len, &sLocalPath, &sLocalPath_len, &fMode, &bCaseSensitive, &fCaseConversion, &bRecursive) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_DownloadFiles(SBGetObjectHandle(getThis() TSRMLS_CC), sRemotePath, (int32_t)sRemotePath_len, sRemoteMask, (int32_t)sRemoteMask_len, sLocalPath, (int32_t)sLocalPath_len, (TSBFileTransferModeRaw)fMode, (int8_t)bCaseSensitive, (TSBCaseConversionRaw)fCaseConversion, (int8_t)bRecursive) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssslblbb", &sRemotePath, &sRemotePath_len, &sRemoteMask, &sRemoteMask_len, &sLocalPath, &sLocalPath_len, &fMode, &bCaseSensitive, &fCaseConversion, &bRecursive, &bDeleteFiles) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_DownloadFiles_1(SBGetObjectHandle(getThis() TSRMLS_CC), sRemotePath, (int32_t)sRemotePath_len, sRemoteMask, (int32_t)sRemoteMask_len, sLocalPath, (int32_t)sLocalPath_len, (TSBFileTransferModeRaw)fMode, (int8_t)bCaseSensitive, (TSBCaseConversionRaw)fCaseConversion, (int8_t)bRecursive, (int8_t)bDeleteFiles) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssllblb", &sRemotePath, &sRemotePath_len, &sRemoteMask, &sRemoteMask_len, &sLocalPath, &sLocalPath_len, &fMode, &fCopyMode, &bCaseSensitive, &fCaseConversion, &bRecursive) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_DownloadFiles_2(SBGetObjectHandle(getThis() TSRMLS_CC), sRemotePath, (int32_t)sRemotePath_len, sRemoteMask, (int32_t)sRemoteMask_len, sLocalPath, (int32_t)sLocalPath_len, (TSBFileTransferModeRaw)fMode, (TSBFileCopyModeRaw)fCopyMode, (int8_t)bCaseSensitive, (TSBCaseConversionRaw)fCaseConversion, (int8_t)bRecursive) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, string, integer, bool, integer, bool) or (string, string, string, integer, bool, integer, bool, bool) or (string, string, string, integer, integer, bool, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, UploadFiles)
{
	char *sLocalMask;
	char *sLocalPath;
	char *sRemotePath;
	int sLocalMask_len;
	int sLocalPath_len;
	int sRemotePath_len;
	long fCaseConversion;
	long fCopyMode;
	long fMode;
	zend_bool bCaseSensitive;
	zend_bool bDeleteFiles;
	zend_bool bRecursive;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssslblb", &sLocalPath, &sLocalPath_len, &sLocalMask, &sLocalMask_len, &sRemotePath, &sRemotePath_len, &fMode, &bCaseSensitive, &fCaseConversion, &bRecursive) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_UploadFiles(SBGetObjectHandle(getThis() TSRMLS_CC), sLocalPath, (int32_t)sLocalPath_len, sLocalMask, (int32_t)sLocalMask_len, sRemotePath, (int32_t)sRemotePath_len, (TSBFileTransferModeRaw)fMode, (int8_t)bCaseSensitive, (TSBCaseConversionRaw)fCaseConversion, (int8_t)bRecursive) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssslblbb", &sLocalPath, &sLocalPath_len, &sLocalMask, &sLocalMask_len, &sRemotePath, &sRemotePath_len, &fMode, &bCaseSensitive, &fCaseConversion, &bRecursive, &bDeleteFiles) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_UploadFiles_1(SBGetObjectHandle(getThis() TSRMLS_CC), sLocalPath, (int32_t)sLocalPath_len, sLocalMask, (int32_t)sLocalMask_len, sRemotePath, (int32_t)sRemotePath_len, (TSBFileTransferModeRaw)fMode, (int8_t)bCaseSensitive, (TSBCaseConversionRaw)fCaseConversion, (int8_t)bRecursive, (int8_t)bDeleteFiles) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssllblb", &sLocalPath, &sLocalPath_len, &sLocalMask, &sLocalMask_len, &sRemotePath, &sRemotePath_len, &fMode, &fCopyMode, &bCaseSensitive, &fCaseConversion, &bRecursive) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_UploadFiles_2(SBGetObjectHandle(getThis() TSRMLS_CC), sLocalPath, (int32_t)sLocalPath_len, sLocalMask, (int32_t)sLocalMask_len, sRemotePath, (int32_t)sRemotePath_len, (TSBFileTransferModeRaw)fMode, (TSBFileCopyModeRaw)fCopyMode, (int8_t)bCaseSensitive, (TSBCaseConversionRaw)fCaseConversion, (int8_t)bRecursive) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, string, integer, bool, integer, bool) or (string, string, string, integer, bool, integer, bool, bool) or (string, string, string, integer, integer, bool, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, DownloadFile)
{
	char *sLocalFileName;
	char *sRemoteFileName;
	int sLocalFileName_len;
	int sRemoteFileName_len;
	long fMode;
	long l8RestartFrom;
	zend_bool bSuppressAdditionalOperations;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sRemoteFileName, &sRemoteFileName_len, &sLocalFileName, &sLocalFileName_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_DownloadFile(SBGetObjectHandle(getThis() TSRMLS_CC), sRemoteFileName, (int32_t)sRemoteFileName_len, sLocalFileName, (int32_t)sLocalFileName_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sRemoteFileName, &sRemoteFileName_len, &sLocalFileName, &sLocalFileName_len, &bSuppressAdditionalOperations) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_DownloadFile_1(SBGetObjectHandle(getThis() TSRMLS_CC), sRemoteFileName, (int32_t)sRemoteFileName_len, sLocalFileName, (int32_t)sLocalFileName_len, (int8_t)bSuppressAdditionalOperations) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssl", &sRemoteFileName, &sRemoteFileName_len, &sLocalFileName, &sLocalFileName_len, &fMode) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_DownloadFile_2(SBGetObjectHandle(getThis() TSRMLS_CC), sRemoteFileName, (int32_t)sRemoteFileName_len, sLocalFileName, (int32_t)sLocalFileName_len, (TSBFileTransferModeRaw)fMode) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssll", &sRemoteFileName, &sRemoteFileName_len, &sLocalFileName, &sLocalFileName_len, &fMode, &l8RestartFrom) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_DownloadFile_3(SBGetObjectHandle(getThis() TSRMLS_CC), sRemoteFileName, (int32_t)sRemoteFileName_len, sLocalFileName, (int32_t)sLocalFileName_len, (TSBFileTransferModeRaw)fMode, (int64_t)l8RestartFrom) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (string, string, bool) or (string, string, integer) or (string, string, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, UploadFile)
{
	char *sLocalFileName;
	char *sRemoteFileName;
	int sLocalFileName_len;
	int sRemoteFileName_len;
	long fMode;
	long l8RestartFrom;
	zend_bool bSuppressAdditionalOperations;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sLocalFileName, &sLocalFileName_len, &sRemoteFileName, &sRemoteFileName_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_UploadFile(SBGetObjectHandle(getThis() TSRMLS_CC), sLocalFileName, (int32_t)sLocalFileName_len, sRemoteFileName, (int32_t)sRemoteFileName_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sLocalFileName, &sLocalFileName_len, &sRemoteFileName, &sRemoteFileName_len, &bSuppressAdditionalOperations) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_UploadFile_1(SBGetObjectHandle(getThis() TSRMLS_CC), sLocalFileName, (int32_t)sLocalFileName_len, sRemoteFileName, (int32_t)sRemoteFileName_len, (int8_t)bSuppressAdditionalOperations) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssl", &sLocalFileName, &sLocalFileName_len, &sRemoteFileName, &sRemoteFileName_len, &fMode) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_UploadFile_2(SBGetObjectHandle(getThis() TSRMLS_CC), sLocalFileName, (int32_t)sLocalFileName_len, sRemoteFileName, (int32_t)sRemoteFileName_len, (TSBFileTransferModeRaw)fMode) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssll", &sLocalFileName, &sLocalFileName_len, &sRemoteFileName, &sRemoteFileName_len, &fMode, &l8RestartFrom) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_UploadFile_3(SBGetObjectHandle(getThis() TSRMLS_CC), sLocalFileName, (int32_t)sLocalFileName_len, sRemoteFileName, (int32_t)sRemoteFileName_len, (TSBFileTransferModeRaw)fMode, (int64_t)l8RestartFrom) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (string, string, bool) or (string, string, integer) or (string, string, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, DownloadStream)
{
	char *sRemoteFileName;
	int sRemoteFileName_len;
	long fMode;
	long l8RestartFrom;
	zend_bool bSuppressAdditionalOperations;
	zval *oLocalStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!l", &sRemoteFileName, &sRemoteFileName_len, &oLocalStream, TStream_ce_ptr, &fMode) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_DownloadStream(SBGetObjectHandle(getThis() TSRMLS_CC), sRemoteFileName, (int32_t)sRemoteFileName_len, SBGetObjectHandle(oLocalStream TSRMLS_CC), (TSBFileTransferModeRaw)fMode) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!ll", &sRemoteFileName, &sRemoteFileName_len, &oLocalStream, TStream_ce_ptr, &fMode, &l8RestartFrom) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_DownloadStream_1(SBGetObjectHandle(getThis() TSRMLS_CC), sRemoteFileName, (int32_t)sRemoteFileName_len, SBGetObjectHandle(oLocalStream TSRMLS_CC), (TSBFileTransferModeRaw)fMode, (int64_t)l8RestartFrom) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!b", &sRemoteFileName, &sRemoteFileName_len, &oLocalStream, TStream_ce_ptr, &bSuppressAdditionalOperations) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_DownloadStream_2(SBGetObjectHandle(getThis() TSRMLS_CC), sRemoteFileName, (int32_t)sRemoteFileName_len, SBGetObjectHandle(oLocalStream TSRMLS_CC), (int8_t)bSuppressAdditionalOperations) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TStream, integer) or (string, TStream, integer, integer) or (string, TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, UploadStream)
{
	char *sRemoteFileName;
	int sRemoteFileName_len;
	long fMode;
	long l8RestartFrom;
	zend_bool bSuppressAdditionalOperations;
	zval *oLocalStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oLocalStream, TStream_ce_ptr, &sRemoteFileName, &sRemoteFileName_len, &fMode) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_UploadStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLocalStream TSRMLS_CC), sRemoteFileName, (int32_t)sRemoteFileName_len, (TSBFileTransferModeRaw)fMode) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sll", &oLocalStream, TStream_ce_ptr, &sRemoteFileName, &sRemoteFileName_len, &fMode, &l8RestartFrom) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_UploadStream_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLocalStream TSRMLS_CC), sRemoteFileName, (int32_t)sRemoteFileName_len, (TSBFileTransferModeRaw)fMode, (int64_t)l8RestartFrom) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sb", &oLocalStream, TStream_ce_ptr, &sRemoteFileName, &sRemoteFileName_len, &bSuppressAdditionalOperations) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_UploadStream_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oLocalStream TSRMLS_CC), sRemoteFileName, (int32_t)sRemoteFileName_len, (int8_t)bSuppressAdditionalOperations) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream, string, integer) or (TStream, string, integer, integer) or (TStream, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, MakeDirectory)
{
	char *sPath;
	int sPath_len;
	zval *oAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_MakeDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oAttributes TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, CreateDirectoryPath)
{
	char *sPath;
	int sPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_CreateDirectoryPath(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, OpenDirectory)
{
	char *sPath;
	int sPath_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSimpleSFTPClient_OpenDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1506188162, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, OpenFile)
{
	char *sFilename;
	int sFilename_len;
	long fAccess;
	long fModes;
	uint32_t _err;
	zval *oAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sFilename, &sFilename_len, &fModes, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSimpleSFTPClient_OpenFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, (TSBSftpFileOpenModesRaw)fModes, SBGetObjectHandle(oAttributes TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1316307606, 4, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sllO!", &sFilename, &sFilename_len, &fModes, &fAccess, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSimpleSFTPClient_OpenFile_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, (TSBSftpFileOpenModesRaw)fModes, (TSBSftpFileOpenAccessRaw)fAccess, SBGetObjectHandle(oAttributes TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2032426615, 5, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, TElSftpFileAttributes) or (string, integer, integer, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, OpenStream)
{
	char *sFilename;
	int sFilename_len;
	long fModes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sFilename, &sFilename_len, &fModes) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_OpenStream(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, (TSBSftpFileOpenModesRaw)fModes, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSftpStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, ReadDirectory)
{
	char *sDirectoryMask;
	char *sMask;
	char *sPath;
	int sDirectoryMask_len;
	int sMask_len;
	int sPath_len;
	SBArrayZValInfo aiHandle;
	zend_bool bCaseSensitive;
	zend_bool bIncludeDirectories;
	zend_bool bIncludeFiles;
	zend_bool bRecursive;
	zval *oListing;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaHandle, &oListing, TList_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_ReadDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, SBGetObjectHandle(oListing TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!sbbb", &zaHandle, &oListing, TList_ce_ptr, &sMask, &sMask_len, &bCaseSensitive, &bIncludeFiles, &bIncludeDirectories) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_ReadDirectory_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, SBGetObjectHandle(oListing TSRMLS_CC), sMask, (int32_t)sMask_len, (int8_t)bCaseSensitive, (int8_t)bIncludeFiles, (int8_t)bIncludeDirectories) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!ssbbb", &zaHandle, &oListing, TList_ce_ptr, &sMask, &sMask_len, &sDirectoryMask, &sDirectoryMask_len, &bCaseSensitive, &bIncludeFiles, &bIncludeDirectories) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_ReadDirectory_2(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, SBGetObjectHandle(oListing TSRMLS_CC), sMask, (int32_t)sMask_len, sDirectoryMask, (int32_t)sDirectoryMask_len, (int8_t)bCaseSensitive, (int8_t)bIncludeFiles, (int8_t)bIncludeDirectories) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!ssbbbbs", &zaHandle, &oListing, TList_ce_ptr, &sMask, &sMask_len, &sDirectoryMask, &sDirectoryMask_len, &bCaseSensitive, &bIncludeFiles, &bIncludeDirectories, &bRecursive, &sPath, &sPath_len) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_ReadDirectory_3(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, SBGetObjectHandle(oListing TSRMLS_CC), sMask, (int32_t)sMask_len, sDirectoryMask, (int32_t)sDirectoryMask_len, (int8_t)bCaseSensitive, (int8_t)bIncludeFiles, (int8_t)bIncludeDirectories, (int8_t)bRecursive, sPath, (int32_t)sPath_len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TList) or (array of byte|string|NULL, TList, string, bool, bool, bool) or (array of byte|string|NULL, TList, string, string, bool, bool, bool) or (array of byte|string|NULL, TList, string, string, bool, bool, bool, bool, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, ListDirectory)
{
	char *sMask;
	char *sPath;
	int sMask_len;
	int sPath_len;
	zend_bool bCaseSensitive;
	zend_bool bIncludeDirectories;
	zend_bool bIncludeFiles;
	zend_bool bRecursive;
	zval *oListing;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oListing, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_ListDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oListing TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!b", &sPath, &sPath_len, &oListing, TList_ce_ptr, &bRecursive) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_ListDirectory_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oListing TSRMLS_CC), (int8_t)bRecursive) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sbbb", &sPath, &sPath_len, &oListing, TList_ce_ptr, &sMask, &sMask_len, &bCaseSensitive, &bIncludeFiles, &bIncludeDirectories) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_ListDirectory_2(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oListing TSRMLS_CC), sMask, (int32_t)sMask_len, (int8_t)bCaseSensitive, (int8_t)bIncludeFiles, (int8_t)bIncludeDirectories) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sbbbb", &sPath, &sPath_len, &oListing, TList_ce_ptr, &sMask, &sMask_len, &bCaseSensitive, &bIncludeFiles, &bIncludeDirectories, &bRecursive) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_ListDirectory_3(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oListing TSRMLS_CC), sMask, (int32_t)sMask_len, (int8_t)bCaseSensitive, (int8_t)bIncludeFiles, (int8_t)bIncludeDirectories, (int8_t)bRecursive) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TList) or (string, TList, bool) or (string, TList, string, bool, bool, bool) or (string, TList, string, bool, bool, bool, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, ReadSymLink)
{
	char *sPath;
	int sPath_len;
	zval *oInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oInfo, TElSftpFileInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_ReadSymLink(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oInfo TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElSftpFileInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, Read)
{
	long l4Length;
	long l8Offset;
	SBArrayZValInfo aiHandle;
	SBArrayZValInfo piBuffer;
	zval *zaHandle;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zaHandle, &l8Offset, &zpBuffer, &l4Length) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_Read(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, piBuffer.data, (int32_t)l4Length, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, RemoveDirectory)
{
	char *sPath;
	int sPath_len;
	zend_bool bRecursive;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_RemoveDirectory(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sPath, &sPath_len, &bRecursive) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_RemoveDirectory_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (int8_t)bRecursive) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, RemoveFile)
{
	char *sFilename;
	int sFilename_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_RemoveFile(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, RemoveFiles)
{
	char *sMask;
	char *sPath;
	int sMask_len;
	int sPath_len;
	zend_bool bCaseSensitive;
	zend_bool bRecursive;
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssbb", &sPath, &sPath_len, &sMask, &sMask_len, &bCaseSensitive, &bRecursive) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_RemoveFiles(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sMask, (int32_t)sMask_len, (int8_t)bCaseSensitive, (int8_t)bRecursive) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oList, TStrings_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_RemoveFiles_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, bool, bool) or (TStrings)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, RenameFile)
{
	char *sNewPath;
	char *sOldPath;
	int sNewPath_len;
	int sOldPath_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sOldPath, &sOldPath_len, &sNewPath, &sNewPath_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_RenameFile(SBGetObjectHandle(getThis() TSRMLS_CC), sOldPath, (int32_t)sOldPath_len, sNewPath, (int32_t)sNewPath_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, RequestAbsolutePath)
{
	char *sPath;
	int sPath_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_RequestAbsolutePath(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(678078979, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, RequestAbsolutePathEx)
{
	char *sPath;
	int sPath_len;
	long fControl;
	uint32_t _err;
	zval *oComposePath;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sPath, &sPath_len, &fControl, &oComposePath, TStringList_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_RequestAbsolutePathEx(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (TSBSftpRealpathControlRaw)fControl, SBGetObjectHandle(oComposePath TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1900426575, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer, TStringList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, RequestAttributes)
{
	char *sPath;
	int sPath_len;
	SBArrayZValInfo aiHandle;
	zend_bool bFollowSymLinks;
	zval *oAttributes;
	zval *zaHandle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sbO!", &sPath, &sPath_len, &bFollowSymLinks, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_RequestAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, (int8_t)bFollowSymLinks, SBGetObjectHandle(oAttributes TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaHandle, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_RequestAttributes_1(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, SBGetObjectHandle(oAttributes TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool, TElSftpFileAttributes) or (array of byte|string|NULL, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, SetAttributes)
{
	char *sPath;
	int sPath_len;
	zval *oAttributes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPath, &sPath_len, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_SetAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), sPath, (int32_t)sPath_len, SBGetObjectHandle(oAttributes TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, SetAttributesByHandle)
{
	SBArrayZValInfo aiHandle;
	zval *oAttributes;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO!", &zaHandle, &oAttributes, TElSftpFileAttributes_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_SetAttributesByHandle(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, SBGetObjectHandle(oAttributes TSRMLS_CC)) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, TElSftpFileAttributes)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, Write)
{
	long l4Size;
	long l8Offset;
	SBArrayZValInfo aiHandle;
	SBArrayZValInfo piBuffer;
	zval *zaHandle;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zaHandle, &l8Offset, &zpBuffer, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_Write(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8Offset, piBuffer.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
		SBFreePointerZValInfo(&piBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, FinalizeTextWrite)
{
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaHandle) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_FinalizeTextWrite(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, TextSeek)
{
	long l8LineNumber;
	SBArrayZValInfo aiHandle;
	zval *zaHandle;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaHandle, &l8LineNumber) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHandle)) || (IS_ARRAY == Z_TYPE_P(zaHandle)) || (IS_NULL == Z_TYPE_P(zaHandle))))
	{
		if (!SBGetByteArrayFromZVal(zaHandle, &aiHandle TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_TextSeek(SBGetObjectHandle(getThis() TSRMLS_CC), aiHandle.data, aiHandle.len, (int64_t)l8LineNumber) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHandle);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, RenegotiateCiphers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_RenegotiateCiphers(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, ExecuteSSHCommand)
{
	char *sCommand;
	int sCommand_len;
	SBArrayZValInfo aiStdErrData;
	uint32_t _err;
	zend_bool bRedirectStdErr;
	zval *zaStdErrData;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sCommand, &sCommand_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSimpleSFTPClient_ExecuteSSHCommand(SBGetObjectHandle(getThis() TSRMLS_CC), sCommand, (int32_t)sCommand_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2020387454, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sCommand, &sCommand_len, &bRedirectStdErr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSimpleSFTPClient_ExecuteSSHCommand_1(SBGetObjectHandle(getThis() TSRMLS_CC), sCommand, (int32_t)sCommand_len, (int8_t)bRedirectStdErr, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1793604571, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sCommand, &sCommand_len, &zaStdErrData) == SUCCESS) && PZVAL_IS_REF(zaStdErrData) && ((IS_STRING == Z_TYPE_P(zaStdErrData)) || (IS_ARRAY == Z_TYPE_P(zaStdErrData))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaStdErrData, &aiStdErrData TSRMLS_CC)) RETURN_FALSE;
		_err = TElSimpleSFTPClient_ExecuteSSHCommand_2(SBGetObjectHandle(getThis() TSRMLS_CC), sCommand, (int32_t)sCommand_len, aiStdErrData.data, &aiStdErrData.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaStdErrData, &aiStdErrData TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1437980405, 2, aiStdErrData.data, &aiStdErrData.len) TSRMLS_CC);
			((char *)aiStdErrData.data)[aiStdErrData.len] = 0;
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1437980405, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiStdErrData);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiStdErrData, zaStdErrData);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, bool) or (string, &array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_CompressionAlgorithms)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_CompressionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_CompressionAlgorithms)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_CompressionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_EncryptionAlgorithms)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_EncryptionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_EncryptionAlgorithms)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_EncryptionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_KexAlgorithms)
{
	long l1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_KexAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)l1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_KexAlgorithms)
{
	long l1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_KexAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)l1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_MacAlgorithms)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_MacAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_MacAlgorithms)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_MacAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_PublicKeyAlgorithms)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_PublicKeyAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_PublicKeyAlgorithms)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_PublicKeyAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_EncryptionAlgorithmPriorities)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_EncryptionAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_EncryptionAlgorithmPriorities)
{
	long l4Value;
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_EncryptionAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_CompressionAlgorithmPriorities)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_CompressionAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_CompressionAlgorithmPriorities)
{
	long l4Value;
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_CompressionAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_MacAlgorithmPriorities)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_MacAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_MacAlgorithmPriorities)
{
	long l4Value;
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_MacAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_KexAlgorithmPriorities)
{
	long l1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_KexAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)l1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_KexAlgorithmPriorities)
{
	long l1Index;
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_KexAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)l1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_PublicKeyAlgorithmPriorities)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_PublicKeyAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_PublicKeyAlgorithmPriorities)
{
	long l4Value;
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_PublicKeyAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_AuthTypePriorities)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_AuthTypePriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_AuthTypePriorities)
{
	long l4Index;
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_AuthTypePriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_CompressionAlgorithmClientToServer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_CompressionAlgorithmClientToServer(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_CompressionAlgorithmServerToClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_CompressionAlgorithmServerToClient(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_EncryptionAlgorithmClientToServer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_EncryptionAlgorithmClientToServer(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_EncryptionAlgorithmServerToClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_EncryptionAlgorithmServerToClient(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_KexAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t l1OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_KexAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_LastSyncComment)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_LastSyncComment(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1390759797, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_LastSyncError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_LastSyncError(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_MacAlgorithmClientToServer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_MacAlgorithmClientToServer(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_MacAlgorithmServerToClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_MacAlgorithmServerToClient(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SocketSettings)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_SocketSettings(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSocketSettings_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_NewLineConvention)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSimpleSFTPClient_get_NewLineConvention(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(489816535, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_NewLineConvention)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_set_NewLineConvention(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_LocalNewLineConvention)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSimpleSFTPClient_get_LocalNewLineConvention(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1968379760, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_LocalNewLineConvention)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_set_LocalNewLineConvention(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_PublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_ServerCloseReason)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_ServerCloseReason(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1203946763, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_ServerSoftwareName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_ServerSoftwareName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1836244913, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SFTPExt)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBArrayZValInfo aiOutResult;
		SBInitArrayZValInfo(&aiOutResult);
		_err = TElSimpleSFTPClient_get_SFTPExt(SBGetObjectHandle(getThis() TSRMLS_CC), aiOutResult.data, &aiOutResult.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			aiOutResult.data = emalloc(aiOutResult.len);
			SBCheckError(SBGetLastReturnBuffer(-479223378, 1, aiOutResult.data, &aiOutResult.len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiOutResult);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetObjectArrayToZVal(&aiOutResult, TSBSftpExtendedAttribute_ce_ptr, return_value TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SFTPExt)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue, TSBSftpExtendedAttribute_ce_ptr) == SUCCESS) && ((IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetObjectArrayFromZVal(zaValue, TSBSftpExtendedAttribute_ce_ptr, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSimpleSFTPClient_set_SFTPExt(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(&array of TSBSftpExtendedAttribute|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpVersionRaw fOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_ExtendedProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_ExtendedProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSftpExtendedProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_KbdIntName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_KbdIntName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1232390112, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_KbdIntInstruction)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_KbdIntInstruction(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1071225217, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_ServerKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_ServerKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_ProxyResult)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_ProxyResult(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_TotalBytesSent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_TotalBytesSent(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_TotalBytesReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_TotalBytesReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSimpleSFTPClient, get_UsingIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_UsingIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSimpleSFTPClient, get_GSSMechanism)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_GSSMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGSSBaseMechanism_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_GSSMechanism)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElGSSBaseMechanism_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_GSSMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSBaseMechanism)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_GSSHostName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_GSSHostName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1688256332, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_GSSHostName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_GSSHostName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_GSSDelegateCredentials)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_GSSDelegateCredentials(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_GSSDelegateCredentials)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_GSSDelegateCredentials(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_InternalSocket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_InternalSocket(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSocket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SecondaryChannelExitStatus)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_SecondaryChannelExitStatus(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SecondaryChannelExitSignal)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_SecondaryChannelExitSignal(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-816981197, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SecondaryChannelExitMessage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_SecondaryChannelExitMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(369359161, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SSHAuthOrder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHAuthOrderRaw fOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_SSHAuthOrder(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SSHAuthOrder)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SSHAuthOrder(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSSHAuthOrderRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1215472177, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_AutoAdjustCiphers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_AutoAdjustCiphers(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_AutoAdjustCiphers)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_AutoAdjustCiphers(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_AuthenticationTypes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_AuthenticationTypes(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_AuthenticationTypes)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_AuthenticationTypes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_ASCIIMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_ASCIIMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_ASCIIMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_ASCIIMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_ClientHostname)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_ClientHostname(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(650267726, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_ClientHostname)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_ClientHostname(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_ClientUsername)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_ClientUsername(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1003325992, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_ClientUsername)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_ClientUsername(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_CompressionLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_CompressionLevel)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_ForceCompression)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_ForceCompression(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_ForceCompression)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_ForceCompression(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_KeyStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_KeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHCustomKeyStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_KeyStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSSHCustomKeyStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_KeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHCustomKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_FileSystemAdapter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomFileSystemAdapter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_FileSystemAdapter)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomFileSystemAdapter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_FileSystemAdapter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomFileSystemAdapter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_PortKnock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_PortKnock(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPortKnock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_PortKnock)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPortKnock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_PortKnock(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPortKnock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_DefaultWindowSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_DefaultWindowSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_DefaultWindowSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_DefaultWindowSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_MinWindowSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_MinWindowSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_MinWindowSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_MinWindowSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_MaxSSHPacketSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_MaxSSHPacketSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_MaxSSHPacketSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_MaxSSHPacketSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_TrustedKeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_TrustedKeys(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHCustomKeyStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_TrustedKeys)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSSHCustomKeyStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_TrustedKeys(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHCustomKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_ObfuscateHandshake)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_ObfuscateHandshake(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_ObfuscateHandshake)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_ObfuscateHandshake(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_ObfuscationPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_ObfuscationPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-664817071, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_ObfuscationPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_ObfuscationPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_CopyEmptyDirs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_CopyEmptyDirs(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_CopyEmptyDirs)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_CopyEmptyDirs(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_DeleteFailedDownloads)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_DeleteFailedDownloads(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_DeleteFailedDownloads)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_DeleteFailedDownloads(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_Password)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1981679357, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_Password)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_Port)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SftpBufferSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_SftpBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SftpBufferSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SftpBufferSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SocketTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_SocketTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SocketTimeout)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SocketTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SocksAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSocksAuthenticationRaw fOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_SocksAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SocksAuthentication)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SocksAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSocksAuthenticationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SocksPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_SocksPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(558216578, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SocksPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SocksPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SocksPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_SocksPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SocksPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SocksPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SocksResolveAddress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_SocksResolveAddress(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SocksResolveAddress)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SocksResolveAddress(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SocksServer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_SocksServer(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1128562505, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SocksServer)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SocksServer(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SocksUserCode)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_SocksUserCode(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1708987520, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SocksUserCode)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SocksUserCode(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SocksVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSocksVersionRaw fOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_SocksVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SocksVersion)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SocksVersion(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSocksVersionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SoftwareName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_SoftwareName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(799202116, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SoftwareName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SoftwareName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_AutoAdjustTransferBlock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_AutoAdjustTransferBlock(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_AutoAdjustTransferBlock)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_AutoAdjustTransferBlock(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_UseInternalSocket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_UseInternalSocket(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_UseInternalSocket)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_UseInternalSocket(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_Username)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1149090209, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_Username)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSimpleSFTPClient, get_SocksUseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_SocksUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SocksUseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SocksUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_UseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_UseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSimpleSFTPClient, get_UseSocks)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_UseSocks(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_UseSocks)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_UseSocks(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSimpleSFTPClient, get_DNS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_DNS(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSSettings_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_DNS)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElDNSSettings_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_DNS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSSettings)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSimpleSFTPClient, get_UseWebTunneling)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_UseWebTunneling(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_UseWebTunneling)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_UseWebTunneling(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_Versions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpVersionsRaw fOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_Versions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSftpVersionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_WebTunnelAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_WebTunnelAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-717076631, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_WebTunnelAddress)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_WebTunnelAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_WebTunnelAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElWebTunnelAuthenticationRaw fOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_WebTunnelAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_WebTunnelAuthentication)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_WebTunnelAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (TElWebTunnelAuthenticationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_LocalAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_LocalAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-894247889, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_LocalAddress)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_LocalAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_LocalPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_LocalPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_LocalPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_LocalPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_PipelineLength)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_PipelineLength(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_PipelineLength)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_PipelineLength(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_DownloadBlockSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_DownloadBlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_DownloadBlockSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_DownloadBlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_UploadBlockSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_UploadBlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_UploadBlockSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_UploadBlockSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_UseUTF8)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_UseUTF8)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_UseUTF8OnV3)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_UseUTF8OnV3(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_UseUTF8OnV3)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_UseUTF8OnV3(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_NoCharacterEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_NoCharacterEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_NoCharacterEncoding)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_NoCharacterEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_LocalCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_LocalCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2019065275, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_LocalCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_LocalCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_RemoteCharset)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_RemoteCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-168812783, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_RemoteCharset)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_RemoteCharset(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_WebTunnelPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_WebTunnelPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1237962554, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_WebTunnelPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_WebTunnelPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_WebTunnelPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_WebTunnelPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_WebTunnelPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_WebTunnelPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_WebTunnelUserId)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_WebTunnelUserId(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1793003330, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_WebTunnelUserId)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_WebTunnelUserId(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_WebTunnelRequestHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_WebTunnelRequestHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_WebTunnelResponseHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_WebTunnelResponseHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_WebTunnelResponseBody)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSimpleSFTPClient_get_WebTunnelResponseBody(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-788976132, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OperationErrorHandling)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBOperationErrorHandlingRaw fOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_OperationErrorHandling(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OperationErrorHandling)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_OperationErrorHandling(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBOperationErrorHandlingRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_RequestPasswordChange)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_RequestPasswordChange(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_RequestPasswordChange)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_RequestPasswordChange(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_CertAuthMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHCertAuthModeRaw fOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_CertAuthMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_CertAuthMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_CertAuthMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSSHCertAuthModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_AuthAttempts)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_AuthAttempts(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_AuthAttempts)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_AuthAttempts(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_IncomingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_IncomingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OutgoingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OutgoingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SocketBinding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_SocketBinding(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientSocketBinding_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_SocketBinding)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElClientSocketBinding_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_SocketBinding(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientSocketBinding)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_KeepAlivePeriod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_KeepAlivePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_KeepAlivePeriod)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_KeepAlivePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_ThreadSafe)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_ThreadSafe(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_ThreadSafe)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_ThreadSafe(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_AdjustFileTimes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_AdjustFileTimes(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_AdjustFileTimes)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_AdjustFileTimes(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_PreserveExistingFileTimes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_PreserveExistingFileTimes(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_PreserveExistingFileTimes)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_PreserveExistingFileTimes(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_UseTruncateFlagOnUpload)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_UseTruncateFlagOnUpload(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_UseTruncateFlagOnUpload)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_UseTruncateFlagOnUpload(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_TreatZeroSizeAsUndefined)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_TreatZeroSizeAsUndefined(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_TreatZeroSizeAsUndefined)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_TreatZeroSizeAsUndefined(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_SFTPServerExecutableLocations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_SFTPServerExecutableLocations(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_CommandTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSimpleSFTPClient_get_CommandTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_CommandTimeout)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSimpleSFTPClient_set_CommandTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnAuthenticationFailed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthenticationFailedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnAuthenticationFailed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnAuthenticationFailed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnAuthenticationFailed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthenticationFailedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthenticationFailedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnAuthenticationKeyboard)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthenticationKeyboardEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnAuthenticationKeyboard(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnAuthenticationKeyboard)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnAuthenticationKeyboard(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthenticationKeyboardEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthenticationKeyboardEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnAuthenticationSuccess)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnAuthenticationSuccess(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnAuthenticationSuccess)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnAuthenticationSuccess(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnBanner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHBannerEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnBanner(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnBanner)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnBanner(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHBannerEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHBannerEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnCloseConnection)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHCloseConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnCloseConnection)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnCloseConnection(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHCloseConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHCloseConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnKeyValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHKeyValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnKeyValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHKeyValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHKeyValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnReceive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHReceiveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnReceive(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnReceive)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnReceive(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHReceiveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHReceiveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnSend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHSendEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnSend(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnSend)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnSend(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHSendEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHSendEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnProgress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBProgressEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnProgress)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnProgress(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBProgressEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBProgressEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnFileOperation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSftpFileOperationEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnFileOperation(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnFileOperation)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnFileOperation(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSftpFileOperationEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSftpFileOperationEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnFileOperationResult)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSftpFileOperationResultEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnFileOperationResult(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnFileOperationResult)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnFileOperationResult(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TElSftpFileOperationResultEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSftpFileOperationResultEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnBlockTransferPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpBlockTransferPreparedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnBlockTransferPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnBlockTransferPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnBlockTransferPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpBlockTransferPreparedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpBlockTransferPreparedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnCiphersNegotiated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnCiphersNegotiated(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnCiphersNegotiated)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnCiphersNegotiated(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnPasswordChangeRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHPasswordChangeRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnPasswordChangeRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnPasswordChangeRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnPasswordChangeRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHPasswordChangeRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHPasswordChangeRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnPrivateKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHPrivateKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnPrivateKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnPrivateKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnPrivateKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHPrivateKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHPrivateKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnAuthenticationStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthenticationStartEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnAuthenticationStart(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnAuthenticationStart)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnAuthenticationStart(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthenticationStartEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthenticationStartEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnAuthenticationAttempt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthenticationAttemptEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnAuthenticationAttempt(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnAuthenticationAttempt)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnAuthenticationAttempt(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthenticationAttemptEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthenticationAttemptEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_MessageLoop)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpMessageLoopEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_MessageLoop(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_MessageLoop)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_MessageLoop(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpMessageLoopEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpMessageLoopEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnTunnelOpenFailed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpTunnelOpenFailedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnTunnelOpenFailed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnTunnelOpenFailed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnTunnelOpenFailed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpTunnelOpenFailedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpTunnelOpenFailedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnSecondaryChannelPrepared)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpSecondaryChannelEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnSecondaryChannelPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnSecondaryChannelPrepared)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnSecondaryChannelPrepared(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpSecondaryChannelEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpSecondaryChannelEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnSecondaryChannelOpen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpSecondaryChannelEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnSecondaryChannelOpen(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnSecondaryChannelOpen)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnSecondaryChannelOpen(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpSecondaryChannelEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpSecondaryChannelEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnSecondaryChannelError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpSecondaryChannelErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnSecondaryChannelError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnSecondaryChannelError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnSecondaryChannelError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpSecondaryChannelErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpSecondaryChannelErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnFileNameChangeNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSftpFileNameChangeNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnFileNameChangeNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnFileNameChangeNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnFileNameChangeNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSftpFileNameChangeNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSftpFileNameChangeNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnKexInitReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHKexInitReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnKexInitReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnKexInitReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnKexInitReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHKexInitReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHKexInitReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSimpleSFTPClient, get_OnDNSKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnDNSKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnDNSKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnDNSKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnDNSKeyValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnDNSKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnDNSKeyValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnDNSKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, get_OnDNSResolve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResolveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_get_OnDNSResolve(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSimpleSFTPClient, set_OnDNSResolve)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSimpleSFTPClient_set_OnDNSResolve(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSResolveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSResolveEvent|callable|NULL)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSimpleSFTPClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSimpleSFTPClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_ExtensionCmd, 0, 0, 2)
	ZEND_ARG_INFO(0, Extension)
	ZEND_ARG_TYPE_INFO(0, DataBuffer_or_ResponseStream, 0, 1)
	ZEND_ARG_INFO(0, Size)
	ZEND_ARG_OBJ_INFO(0, ResponseStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_Block, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Length)
	ZEND_ARG_INFO(0, LockMask)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_Unblock, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_INFO(0, Length)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_SendVendorID, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, VendorID, TElSftpVendorIDExtension, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_RequestFileHash, 0, 0, 5)
	ZEND_ARG_INFO(0, FileName)
	ZEND_ARG_INFO(0, StartOffset)
	ZEND_ARG_INFO(0, Length)
	ZEND_ARG_INFO(0, BlockSize)
	ZEND_ARG_OBJ_INFO(0, FileHash, TElSftpCheckFileReply, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_RequestFileHashByHandle, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, StartOffset)
	ZEND_ARG_INFO(0, Length)
	ZEND_ARG_INFO(0, BlockSize)
	ZEND_ARG_OBJ_INFO(0, FileHash, TElSftpCheckFileReply, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_QueryAvailableSpace, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, AvailSpace, TElSftpSpaceAvailableReply, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_QueryStatVFS, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, StatVFS, TElSftpStatVFSReply, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_QueryHomeDirectory, 0, 0, 2)
	ZEND_ARG_INFO(0, Username)
	ZEND_ARG_OBJ_INFO(0, HomeDir, TElSftpFileInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_CopyRemoteFile, 0, 0, 3)
	ZEND_ARG_INFO(0, Source)
	ZEND_ARG_INFO(0, Destination)
	ZEND_ARG_INFO(0, Overwrite)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_CopyRemoteData, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, ReadFrom, 0, 1)
	ZEND_ARG_INFO(0, ReadFromOffset)
	ZEND_ARG_TYPE_INFO(0, WriteTo, 0, 1)
	ZEND_ARG_INFO(0, WriteToOffset)
	ZEND_ARG_INFO(0, DataLength)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_RequestTempFolder, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, TempFolder, TElSftpFileInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_MakeTempFolder, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, TempFolder, TElSftpFileInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_FileExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_GetFileSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_DirExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_Interrupt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_Close, 0, 0, 1)
	ZEND_ARG_INFO(0, Silent)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_CloseHandle, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_CreateFile, 0, 0, 1)
	ZEND_ARG_INFO(0, Filename)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_CreateSymLink, 0, 0, 2)
	ZEND_ARG_INFO(0, LinkPath)
	ZEND_ARG_INFO(0, TargetPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_CreateHardLink, 0, 0, 2)
	ZEND_ARG_INFO(0, LinkPath)
	ZEND_ARG_INFO(0, TargetPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_DownloadFiles, 0, 0, 7)
	ZEND_ARG_INFO(0, RemotePath)
	ZEND_ARG_INFO(0, RemoteMask)
	ZEND_ARG_INFO(0, LocalPath)
	ZEND_ARG_INFO(0, Mode)
	ZEND_ARG_INFO(0, CaseSensitive_or_CopyMode)
	ZEND_ARG_INFO(0, CaseConversion_or_CaseSensitive)
	ZEND_ARG_INFO(0, Recursive_or_CaseConversion)
	ZEND_ARG_INFO(0, DeleteFiles_or_Recursive)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_UploadFiles, 0, 0, 7)
	ZEND_ARG_INFO(0, LocalPath)
	ZEND_ARG_INFO(0, LocalMask)
	ZEND_ARG_INFO(0, RemotePath)
	ZEND_ARG_INFO(0, Mode)
	ZEND_ARG_INFO(0, CaseSensitive_or_CopyMode)
	ZEND_ARG_INFO(0, CaseConversion_or_CaseSensitive)
	ZEND_ARG_INFO(0, Recursive_or_CaseConversion)
	ZEND_ARG_INFO(0, DeleteFiles_or_Recursive)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_DownloadFile, 0, 0, 2)
	ZEND_ARG_INFO(0, RemoteFileName)
	ZEND_ARG_INFO(0, LocalFileName)
	ZEND_ARG_INFO(0, SuppressAdditionalOperations_or_Mode)
	ZEND_ARG_INFO(0, RestartFrom)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_UploadFile, 0, 0, 2)
	ZEND_ARG_INFO(0, LocalFileName)
	ZEND_ARG_INFO(0, RemoteFileName)
	ZEND_ARG_INFO(0, SuppressAdditionalOperations_or_Mode)
	ZEND_ARG_INFO(0, RestartFrom)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_DownloadStream, 0, 0, 3)
	ZEND_ARG_INFO(0, RemoteFileName)
	ZEND_ARG_OBJ_INFO(0, LocalStream, TStream, 1)
	ZEND_ARG_INFO(0, Mode_or_SuppressAdditionalOperations)
	ZEND_ARG_INFO(0, RestartFrom)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_UploadStream, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, LocalStream, TStream, 1)
	ZEND_ARG_INFO(0, RemoteFileName)
	ZEND_ARG_INFO(0, Mode_or_SuppressAdditionalOperations)
	ZEND_ARG_INFO(0, RestartFrom)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_MakeDirectory, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_CreateDirectoryPath, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_OpenDirectory, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_OpenFile, 0, 0, 3)
	ZEND_ARG_INFO(0, Filename)
	ZEND_ARG_INFO(0, Modes)
	ZEND_ARG_TYPE_INFO(0, Attributes_or_Access, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_OpenStream, 0, 0, 2)
	ZEND_ARG_INFO(0, Filename)
	ZEND_ARG_INFO(0, Modes)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_ReadDirectory, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Listing, TList, 1)
	ZEND_ARG_INFO(0, Mask)
	ZEND_ARG_INFO(0, CaseSensitive_or_DirectoryMask)
	ZEND_ARG_INFO(0, IncludeFiles_or_CaseSensitive)
	ZEND_ARG_INFO(0, IncludeDirectories_or_IncludeFiles)
	ZEND_ARG_INFO(0, IncludeDirectories)
	ZEND_ARG_INFO(0, Recursive)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_ListDirectory, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, Listing, TList, 1)
	ZEND_ARG_INFO(0, Recursive_or_Mask)
	ZEND_ARG_INFO(0, CaseSensitive)
	ZEND_ARG_INFO(0, IncludeFiles)
	ZEND_ARG_INFO(0, IncludeDirectories)
	ZEND_ARG_INFO(0, Recursive)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_ReadSymLink, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, Info, TElSftpFileInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_Read, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Length)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_RemoveDirectory, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, Recursive)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_RemoveFile, 0, 0, 1)
	ZEND_ARG_INFO(0, Filename)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_RemoveFiles, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Path_or_List, 0, 1)
	ZEND_ARG_INFO(0, Mask)
	ZEND_ARG_INFO(0, CaseSensitive)
	ZEND_ARG_INFO(0, Recursive)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_RenameFile, 0, 0, 2)
	ZEND_ARG_INFO(0, OldPath)
	ZEND_ARG_INFO(0, NewPath)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_RequestAbsolutePath, 0, 0, 1)
	ZEND_ARG_INFO(0, Path)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_RequestAbsolutePathEx, 0, 0, 3)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_INFO(0, Control)
	ZEND_ARG_OBJ_INFO(0, ComposePath, TStringList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_RequestAttributes, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Path_or_Handle, 0, 1)
	ZEND_ARG_TYPE_INFO(0, FollowSymLinks_or_Attributes, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_SetAttributes, 0, 0, 2)
	ZEND_ARG_INFO(0, Path)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_SetAttributesByHandle, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Attributes, TElSftpFileAttributes, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_Write, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, Offset)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, Size)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_FinalizeTextWrite, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_TextSeek, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Handle, 0, 1)
	ZEND_ARG_INFO(0, LineNumber)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_RenegotiateCiphers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_ExecuteSSHCommand, 0, 0, 1)
	ZEND_ARG_INFO(0, Command)
	ZEND_ARG_INFO(1, RedirectStdErr_or_StdErrData)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_CompressionAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_CompressionAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_EncryptionAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_EncryptionAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_KexAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_KexAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_MacAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_MacAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_PublicKeyAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_PublicKeyAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_EncryptionAlgorithmPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_EncryptionAlgorithmPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_CompressionAlgorithmPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_CompressionAlgorithmPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_MacAlgorithmPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_MacAlgorithmPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_KexAlgorithmPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_KexAlgorithmPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_PublicKeyAlgorithmPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_PublicKeyAlgorithmPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_AuthTypePriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_AuthTypePriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_CompressionAlgorithmClientToServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_CompressionAlgorithmServerToClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_EncryptionAlgorithmClientToServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_EncryptionAlgorithmServerToClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_KexAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_LastSyncComment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_LastSyncError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_MacAlgorithmClientToServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_MacAlgorithmServerToClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SocketSettings, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_NewLineConvention, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_NewLineConvention, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_LocalNewLineConvention, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_LocalNewLineConvention, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_PublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_ServerCloseReason, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_ServerSoftwareName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SFTPExt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SFTPExt, 0, 0, 1)
	ZEND_ARG_ARRAY_INFO(0, Value, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_ExtendedProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_KbdIntName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_KbdIntInstruction, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_ServerKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_ProxyResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_TotalBytesSent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_TotalBytesReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_UsingIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_GSSMechanism, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_GSSMechanism, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElGSSBaseMechanism, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_GSSHostName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_GSSHostName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_GSSDelegateCredentials, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_GSSDelegateCredentials, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_InternalSocket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SecondaryChannelExitStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SecondaryChannelExitSignal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SecondaryChannelExitMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SSHAuthOrder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SSHAuthOrder, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_AutoAdjustCiphers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_AutoAdjustCiphers, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_AuthenticationTypes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_AuthenticationTypes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_ASCIIMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_ASCIIMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_ClientHostname, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_ClientHostname, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_ClientUsername, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_ClientUsername, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_CompressionLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_CompressionLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_ForceCompression, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_ForceCompression, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_KeyStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_KeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSSHCustomKeyStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_FileSystemAdapter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_FileSystemAdapter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomFileSystemAdapter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_PortKnock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_PortKnock, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPortKnock, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_DefaultWindowSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_DefaultWindowSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_MinWindowSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_MinWindowSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_MaxSSHPacketSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_MaxSSHPacketSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_TrustedKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_TrustedKeys, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSSHCustomKeyStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_ObfuscateHandshake, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_ObfuscateHandshake, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_ObfuscationPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_ObfuscationPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_CopyEmptyDirs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_CopyEmptyDirs, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_DeleteFailedDownloads, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_DeleteFailedDownloads, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_Password, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_Password, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SftpBufferSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SftpBufferSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SocketTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SocketTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SocksAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SocksAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SocksPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SocksPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SocksPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SocksPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SocksResolveAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SocksResolveAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SocksServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SocksServer, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SocksUserCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SocksUserCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SocksVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SocksVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SoftwareName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SoftwareName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_AutoAdjustTransferBlock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_AutoAdjustTransferBlock, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_UseInternalSocket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_UseInternalSocket, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_Username, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_Username, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SocksUseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SocksUseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_UseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_UseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_UseSocks, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_UseSocks, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_DNS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_DNS, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElDNSSettings, 1)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_UseWebTunneling, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_UseWebTunneling, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_Versions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_Versions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_WebTunnelAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_WebTunnelAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_WebTunnelAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_WebTunnelAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_LocalAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_LocalAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_LocalPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_LocalPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_PipelineLength, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_PipelineLength, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_DownloadBlockSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_DownloadBlockSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_UploadBlockSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_UploadBlockSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_UseUTF8, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_UseUTF8, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_UseUTF8OnV3, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_UseUTF8OnV3, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_NoCharacterEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_NoCharacterEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_LocalCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_LocalCharset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_RemoteCharset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_RemoteCharset, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_WebTunnelPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_WebTunnelPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_WebTunnelPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_WebTunnelPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_WebTunnelUserId, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_WebTunnelUserId, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_WebTunnelRequestHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_WebTunnelResponseHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_WebTunnelResponseBody, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OperationErrorHandling, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OperationErrorHandling, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_RequestPasswordChange, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_RequestPasswordChange, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_CertAuthMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_CertAuthMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_AuthAttempts, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_AuthAttempts, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_IncomingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_IncomingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OutgoingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OutgoingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SocketBinding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_SocketBinding, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElClientSocketBinding, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_KeepAlivePeriod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_KeepAlivePeriod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_ThreadSafe, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_ThreadSafe, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_AdjustFileTimes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_AdjustFileTimes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_PreserveExistingFileTimes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_PreserveExistingFileTimes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_UseTruncateFlagOnUpload, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_UseTruncateFlagOnUpload, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_TreatZeroSizeAsUndefined, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_TreatZeroSizeAsUndefined, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_SFTPServerExecutableLocations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_CommandTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_CommandTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnAuthenticationFailed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnAuthenticationFailed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnAuthenticationKeyboard, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnAuthenticationKeyboard, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnAuthenticationSuccess, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnAuthenticationSuccess, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnBanner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnBanner, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnCloseConnection, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnCloseConnection, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnKeyValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnKeyValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnReceive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnReceive, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnSend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnSend, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnProgress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnProgress, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnFileOperation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnFileOperation, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnFileOperationResult, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnFileOperationResult, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnBlockTransferPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnBlockTransferPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnCiphersNegotiated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnCiphersNegotiated, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnPasswordChangeRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnPasswordChangeRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnPrivateKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnPrivateKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnAuthenticationStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnAuthenticationStart, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnAuthenticationAttempt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnAuthenticationAttempt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_MessageLoop, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_MessageLoop, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnTunnelOpenFailed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnTunnelOpenFailed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnSecondaryChannelPrepared, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnSecondaryChannelPrepared, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnSecondaryChannelOpen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnSecondaryChannelOpen, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnSecondaryChannelError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnSecondaryChannelError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnFileNameChangeNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnFileNameChangeNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnKexInitReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnKexInitReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnDNSKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnDNSKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnDNSKeyValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnDNSKeyValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_get_OnDNSResolve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient_set_OnDNSResolve, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSimpleSFTPClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSimpleSFTPClient_methods[] = {
	PHP_ME(TElSimpleSFTPClient, ExtensionCmd, arginfo_TElSimpleSFTPClient_ExtensionCmd, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, Block, arginfo_TElSimpleSFTPClient_Block, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, Unblock, arginfo_TElSimpleSFTPClient_Unblock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, SendVendorID, arginfo_TElSimpleSFTPClient_SendVendorID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, RequestFileHash, arginfo_TElSimpleSFTPClient_RequestFileHash, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, RequestFileHashByHandle, arginfo_TElSimpleSFTPClient_RequestFileHashByHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, QueryAvailableSpace, arginfo_TElSimpleSFTPClient_QueryAvailableSpace, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, QueryStatVFS, arginfo_TElSimpleSFTPClient_QueryStatVFS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, QueryHomeDirectory, arginfo_TElSimpleSFTPClient_QueryHomeDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, CopyRemoteFile, arginfo_TElSimpleSFTPClient_CopyRemoteFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, CopyRemoteData, arginfo_TElSimpleSFTPClient_CopyRemoteData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, RequestTempFolder, arginfo_TElSimpleSFTPClient_RequestTempFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, MakeTempFolder, arginfo_TElSimpleSFTPClient_MakeTempFolder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, FileExists, arginfo_TElSimpleSFTPClient_FileExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, GetFileSize, arginfo_TElSimpleSFTPClient_GetFileSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, DirExists, arginfo_TElSimpleSFTPClient_DirExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, Interrupt, arginfo_TElSimpleSFTPClient_Interrupt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, Close, arginfo_TElSimpleSFTPClient_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, CloseHandle, arginfo_TElSimpleSFTPClient_CloseHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, CreateFile, arginfo_TElSimpleSFTPClient_CreateFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, CreateSymLink, arginfo_TElSimpleSFTPClient_CreateSymLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, CreateHardLink, arginfo_TElSimpleSFTPClient_CreateHardLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, DownloadFiles, arginfo_TElSimpleSFTPClient_DownloadFiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, UploadFiles, arginfo_TElSimpleSFTPClient_UploadFiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, DownloadFile, arginfo_TElSimpleSFTPClient_DownloadFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, UploadFile, arginfo_TElSimpleSFTPClient_UploadFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, DownloadStream, arginfo_TElSimpleSFTPClient_DownloadStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, UploadStream, arginfo_TElSimpleSFTPClient_UploadStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, MakeDirectory, arginfo_TElSimpleSFTPClient_MakeDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, CreateDirectoryPath, arginfo_TElSimpleSFTPClient_CreateDirectoryPath, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, Open, arginfo_TElSimpleSFTPClient_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, OpenDirectory, arginfo_TElSimpleSFTPClient_OpenDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, OpenFile, arginfo_TElSimpleSFTPClient_OpenFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, OpenStream, arginfo_TElSimpleSFTPClient_OpenStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, ReadDirectory, arginfo_TElSimpleSFTPClient_ReadDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, ListDirectory, arginfo_TElSimpleSFTPClient_ListDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, ReadSymLink, arginfo_TElSimpleSFTPClient_ReadSymLink, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, Read, arginfo_TElSimpleSFTPClient_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, RemoveDirectory, arginfo_TElSimpleSFTPClient_RemoveDirectory, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, RemoveFile, arginfo_TElSimpleSFTPClient_RemoveFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, RemoveFiles, arginfo_TElSimpleSFTPClient_RemoveFiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, RenameFile, arginfo_TElSimpleSFTPClient_RenameFile, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, RequestAbsolutePath, arginfo_TElSimpleSFTPClient_RequestAbsolutePath, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, RequestAbsolutePathEx, arginfo_TElSimpleSFTPClient_RequestAbsolutePathEx, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, RequestAttributes, arginfo_TElSimpleSFTPClient_RequestAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, SetAttributes, arginfo_TElSimpleSFTPClient_SetAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, SetAttributesByHandle, arginfo_TElSimpleSFTPClient_SetAttributesByHandle, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, Write, arginfo_TElSimpleSFTPClient_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, FinalizeTextWrite, arginfo_TElSimpleSFTPClient_FinalizeTextWrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, TextSeek, arginfo_TElSimpleSFTPClient_TextSeek, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, RenegotiateCiphers, arginfo_TElSimpleSFTPClient_RenegotiateCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, ExecuteSSHCommand, arginfo_TElSimpleSFTPClient_ExecuteSSHCommand, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_CompressionAlgorithms, arginfo_TElSimpleSFTPClient_get_CompressionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_CompressionAlgorithms, arginfo_TElSimpleSFTPClient_set_CompressionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_EncryptionAlgorithms, arginfo_TElSimpleSFTPClient_get_EncryptionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_EncryptionAlgorithms, arginfo_TElSimpleSFTPClient_set_EncryptionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_KexAlgorithms, arginfo_TElSimpleSFTPClient_get_KexAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_KexAlgorithms, arginfo_TElSimpleSFTPClient_set_KexAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_MacAlgorithms, arginfo_TElSimpleSFTPClient_get_MacAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_MacAlgorithms, arginfo_TElSimpleSFTPClient_set_MacAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_PublicKeyAlgorithms, arginfo_TElSimpleSFTPClient_get_PublicKeyAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_PublicKeyAlgorithms, arginfo_TElSimpleSFTPClient_set_PublicKeyAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_EncryptionAlgorithmPriorities, arginfo_TElSimpleSFTPClient_get_EncryptionAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_EncryptionAlgorithmPriorities, arginfo_TElSimpleSFTPClient_set_EncryptionAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_CompressionAlgorithmPriorities, arginfo_TElSimpleSFTPClient_get_CompressionAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_CompressionAlgorithmPriorities, arginfo_TElSimpleSFTPClient_set_CompressionAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_MacAlgorithmPriorities, arginfo_TElSimpleSFTPClient_get_MacAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_MacAlgorithmPriorities, arginfo_TElSimpleSFTPClient_set_MacAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_KexAlgorithmPriorities, arginfo_TElSimpleSFTPClient_get_KexAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_KexAlgorithmPriorities, arginfo_TElSimpleSFTPClient_set_KexAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_PublicKeyAlgorithmPriorities, arginfo_TElSimpleSFTPClient_get_PublicKeyAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_PublicKeyAlgorithmPriorities, arginfo_TElSimpleSFTPClient_set_PublicKeyAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_AuthTypePriorities, arginfo_TElSimpleSFTPClient_get_AuthTypePriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_AuthTypePriorities, arginfo_TElSimpleSFTPClient_set_AuthTypePriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_Active, arginfo_TElSimpleSFTPClient_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_CompressionAlgorithmClientToServer, arginfo_TElSimpleSFTPClient_get_CompressionAlgorithmClientToServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_CompressionAlgorithmServerToClient, arginfo_TElSimpleSFTPClient_get_CompressionAlgorithmServerToClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_EncryptionAlgorithmClientToServer, arginfo_TElSimpleSFTPClient_get_EncryptionAlgorithmClientToServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_EncryptionAlgorithmServerToClient, arginfo_TElSimpleSFTPClient_get_EncryptionAlgorithmServerToClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_KexAlgorithm, arginfo_TElSimpleSFTPClient_get_KexAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_LastSyncComment, arginfo_TElSimpleSFTPClient_get_LastSyncComment, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_LastSyncError, arginfo_TElSimpleSFTPClient_get_LastSyncError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_MacAlgorithmClientToServer, arginfo_TElSimpleSFTPClient_get_MacAlgorithmClientToServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_MacAlgorithmServerToClient, arginfo_TElSimpleSFTPClient_get_MacAlgorithmServerToClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SocketSettings, arginfo_TElSimpleSFTPClient_get_SocketSettings, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_NewLineConvention, arginfo_TElSimpleSFTPClient_get_NewLineConvention, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_NewLineConvention, arginfo_TElSimpleSFTPClient_set_NewLineConvention, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_LocalNewLineConvention, arginfo_TElSimpleSFTPClient_get_LocalNewLineConvention, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_LocalNewLineConvention, arginfo_TElSimpleSFTPClient_set_LocalNewLineConvention, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_PublicKeyAlgorithm, arginfo_TElSimpleSFTPClient_get_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_ServerCloseReason, arginfo_TElSimpleSFTPClient_get_ServerCloseReason, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_ServerSoftwareName, arginfo_TElSimpleSFTPClient_get_ServerSoftwareName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SFTPExt, arginfo_TElSimpleSFTPClient_get_SFTPExt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SFTPExt, arginfo_TElSimpleSFTPClient_set_SFTPExt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_Version, arginfo_TElSimpleSFTPClient_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_ExtendedProperties, arginfo_TElSimpleSFTPClient_get_ExtendedProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_KbdIntName, arginfo_TElSimpleSFTPClient_get_KbdIntName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_KbdIntInstruction, arginfo_TElSimpleSFTPClient_get_KbdIntInstruction, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_ServerKey, arginfo_TElSimpleSFTPClient_get_ServerKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_ProxyResult, arginfo_TElSimpleSFTPClient_get_ProxyResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_TotalBytesSent, arginfo_TElSimpleSFTPClient_get_TotalBytesSent, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_TotalBytesReceived, arginfo_TElSimpleSFTPClient_get_TotalBytesReceived, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSimpleSFTPClient, get_UsingIPv6, arginfo_TElSimpleSFTPClient_get_UsingIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSimpleSFTPClient, get_GSSMechanism, arginfo_TElSimpleSFTPClient_get_GSSMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_GSSMechanism, arginfo_TElSimpleSFTPClient_set_GSSMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_GSSHostName, arginfo_TElSimpleSFTPClient_get_GSSHostName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_GSSHostName, arginfo_TElSimpleSFTPClient_set_GSSHostName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_GSSDelegateCredentials, arginfo_TElSimpleSFTPClient_get_GSSDelegateCredentials, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_GSSDelegateCredentials, arginfo_TElSimpleSFTPClient_set_GSSDelegateCredentials, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_InternalSocket, arginfo_TElSimpleSFTPClient_get_InternalSocket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SecondaryChannelExitStatus, arginfo_TElSimpleSFTPClient_get_SecondaryChannelExitStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SecondaryChannelExitSignal, arginfo_TElSimpleSFTPClient_get_SecondaryChannelExitSignal, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SecondaryChannelExitMessage, arginfo_TElSimpleSFTPClient_get_SecondaryChannelExitMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SSHAuthOrder, arginfo_TElSimpleSFTPClient_get_SSHAuthOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SSHAuthOrder, arginfo_TElSimpleSFTPClient_set_SSHAuthOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_Address, arginfo_TElSimpleSFTPClient_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_Address, arginfo_TElSimpleSFTPClient_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_AutoAdjustCiphers, arginfo_TElSimpleSFTPClient_get_AutoAdjustCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_AutoAdjustCiphers, arginfo_TElSimpleSFTPClient_set_AutoAdjustCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_AuthenticationTypes, arginfo_TElSimpleSFTPClient_get_AuthenticationTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_AuthenticationTypes, arginfo_TElSimpleSFTPClient_set_AuthenticationTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_ASCIIMode, arginfo_TElSimpleSFTPClient_get_ASCIIMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_ASCIIMode, arginfo_TElSimpleSFTPClient_set_ASCIIMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_ClientHostname, arginfo_TElSimpleSFTPClient_get_ClientHostname, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_ClientHostname, arginfo_TElSimpleSFTPClient_set_ClientHostname, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_ClientUsername, arginfo_TElSimpleSFTPClient_get_ClientUsername, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_ClientUsername, arginfo_TElSimpleSFTPClient_set_ClientUsername, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_CompressionLevel, arginfo_TElSimpleSFTPClient_get_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_CompressionLevel, arginfo_TElSimpleSFTPClient_set_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_ForceCompression, arginfo_TElSimpleSFTPClient_get_ForceCompression, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_ForceCompression, arginfo_TElSimpleSFTPClient_set_ForceCompression, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_KeyStorage, arginfo_TElSimpleSFTPClient_get_KeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_KeyStorage, arginfo_TElSimpleSFTPClient_set_KeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_CryptoProviderManager, arginfo_TElSimpleSFTPClient_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_CryptoProviderManager, arginfo_TElSimpleSFTPClient_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_FileSystemAdapter, arginfo_TElSimpleSFTPClient_get_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_FileSystemAdapter, arginfo_TElSimpleSFTPClient_set_FileSystemAdapter, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_PortKnock, arginfo_TElSimpleSFTPClient_get_PortKnock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_PortKnock, arginfo_TElSimpleSFTPClient_set_PortKnock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_DefaultWindowSize, arginfo_TElSimpleSFTPClient_get_DefaultWindowSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_DefaultWindowSize, arginfo_TElSimpleSFTPClient_set_DefaultWindowSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_MinWindowSize, arginfo_TElSimpleSFTPClient_get_MinWindowSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_MinWindowSize, arginfo_TElSimpleSFTPClient_set_MinWindowSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_MaxSSHPacketSize, arginfo_TElSimpleSFTPClient_get_MaxSSHPacketSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_MaxSSHPacketSize, arginfo_TElSimpleSFTPClient_set_MaxSSHPacketSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_TrustedKeys, arginfo_TElSimpleSFTPClient_get_TrustedKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_TrustedKeys, arginfo_TElSimpleSFTPClient_set_TrustedKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_ObfuscateHandshake, arginfo_TElSimpleSFTPClient_get_ObfuscateHandshake, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_ObfuscateHandshake, arginfo_TElSimpleSFTPClient_set_ObfuscateHandshake, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_ObfuscationPassword, arginfo_TElSimpleSFTPClient_get_ObfuscationPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_ObfuscationPassword, arginfo_TElSimpleSFTPClient_set_ObfuscationPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_CopyEmptyDirs, arginfo_TElSimpleSFTPClient_get_CopyEmptyDirs, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_CopyEmptyDirs, arginfo_TElSimpleSFTPClient_set_CopyEmptyDirs, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_DeleteFailedDownloads, arginfo_TElSimpleSFTPClient_get_DeleteFailedDownloads, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_DeleteFailedDownloads, arginfo_TElSimpleSFTPClient_set_DeleteFailedDownloads, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_Password, arginfo_TElSimpleSFTPClient_get_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_Password, arginfo_TElSimpleSFTPClient_set_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_Port, arginfo_TElSimpleSFTPClient_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_Port, arginfo_TElSimpleSFTPClient_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SftpBufferSize, arginfo_TElSimpleSFTPClient_get_SftpBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SftpBufferSize, arginfo_TElSimpleSFTPClient_set_SftpBufferSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SocketTimeout, arginfo_TElSimpleSFTPClient_get_SocketTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SocketTimeout, arginfo_TElSimpleSFTPClient_set_SocketTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SocksAuthentication, arginfo_TElSimpleSFTPClient_get_SocksAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SocksAuthentication, arginfo_TElSimpleSFTPClient_set_SocksAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SocksPassword, arginfo_TElSimpleSFTPClient_get_SocksPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SocksPassword, arginfo_TElSimpleSFTPClient_set_SocksPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SocksPort, arginfo_TElSimpleSFTPClient_get_SocksPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SocksPort, arginfo_TElSimpleSFTPClient_set_SocksPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SocksResolveAddress, arginfo_TElSimpleSFTPClient_get_SocksResolveAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SocksResolveAddress, arginfo_TElSimpleSFTPClient_set_SocksResolveAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SocksServer, arginfo_TElSimpleSFTPClient_get_SocksServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SocksServer, arginfo_TElSimpleSFTPClient_set_SocksServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SocksUserCode, arginfo_TElSimpleSFTPClient_get_SocksUserCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SocksUserCode, arginfo_TElSimpleSFTPClient_set_SocksUserCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SocksVersion, arginfo_TElSimpleSFTPClient_get_SocksVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SocksVersion, arginfo_TElSimpleSFTPClient_set_SocksVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SoftwareName, arginfo_TElSimpleSFTPClient_get_SoftwareName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SoftwareName, arginfo_TElSimpleSFTPClient_set_SoftwareName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_AutoAdjustTransferBlock, arginfo_TElSimpleSFTPClient_get_AutoAdjustTransferBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_AutoAdjustTransferBlock, arginfo_TElSimpleSFTPClient_set_AutoAdjustTransferBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_UseInternalSocket, arginfo_TElSimpleSFTPClient_get_UseInternalSocket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_UseInternalSocket, arginfo_TElSimpleSFTPClient_set_UseInternalSocket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_Username, arginfo_TElSimpleSFTPClient_get_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_Username, arginfo_TElSimpleSFTPClient_set_Username, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSimpleSFTPClient, get_SocksUseIPv6, arginfo_TElSimpleSFTPClient_get_SocksUseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SocksUseIPv6, arginfo_TElSimpleSFTPClient_set_SocksUseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_UseIPv6, arginfo_TElSimpleSFTPClient_get_UseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_UseIPv6, arginfo_TElSimpleSFTPClient_set_UseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSimpleSFTPClient, get_UseSocks, arginfo_TElSimpleSFTPClient_get_UseSocks, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_UseSocks, arginfo_TElSimpleSFTPClient_set_UseSocks, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSimpleSFTPClient, get_DNS, arginfo_TElSimpleSFTPClient_get_DNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_DNS, arginfo_TElSimpleSFTPClient_set_DNS, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSimpleSFTPClient, get_UseWebTunneling, arginfo_TElSimpleSFTPClient_get_UseWebTunneling, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_UseWebTunneling, arginfo_TElSimpleSFTPClient_set_UseWebTunneling, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_Versions, arginfo_TElSimpleSFTPClient_get_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_Versions, arginfo_TElSimpleSFTPClient_set_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_WebTunnelAddress, arginfo_TElSimpleSFTPClient_get_WebTunnelAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_WebTunnelAddress, arginfo_TElSimpleSFTPClient_set_WebTunnelAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_WebTunnelAuthentication, arginfo_TElSimpleSFTPClient_get_WebTunnelAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_WebTunnelAuthentication, arginfo_TElSimpleSFTPClient_set_WebTunnelAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_LocalAddress, arginfo_TElSimpleSFTPClient_get_LocalAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_LocalAddress, arginfo_TElSimpleSFTPClient_set_LocalAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_LocalPort, arginfo_TElSimpleSFTPClient_get_LocalPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_LocalPort, arginfo_TElSimpleSFTPClient_set_LocalPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_PipelineLength, arginfo_TElSimpleSFTPClient_get_PipelineLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_PipelineLength, arginfo_TElSimpleSFTPClient_set_PipelineLength, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_DownloadBlockSize, arginfo_TElSimpleSFTPClient_get_DownloadBlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_DownloadBlockSize, arginfo_TElSimpleSFTPClient_set_DownloadBlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_UploadBlockSize, arginfo_TElSimpleSFTPClient_get_UploadBlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_UploadBlockSize, arginfo_TElSimpleSFTPClient_set_UploadBlockSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_UseUTF8, arginfo_TElSimpleSFTPClient_get_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_UseUTF8, arginfo_TElSimpleSFTPClient_set_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_UseUTF8OnV3, arginfo_TElSimpleSFTPClient_get_UseUTF8OnV3, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_UseUTF8OnV3, arginfo_TElSimpleSFTPClient_set_UseUTF8OnV3, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_NoCharacterEncoding, arginfo_TElSimpleSFTPClient_get_NoCharacterEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_NoCharacterEncoding, arginfo_TElSimpleSFTPClient_set_NoCharacterEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_LocalCharset, arginfo_TElSimpleSFTPClient_get_LocalCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_LocalCharset, arginfo_TElSimpleSFTPClient_set_LocalCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_RemoteCharset, arginfo_TElSimpleSFTPClient_get_RemoteCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_RemoteCharset, arginfo_TElSimpleSFTPClient_set_RemoteCharset, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_WebTunnelPassword, arginfo_TElSimpleSFTPClient_get_WebTunnelPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_WebTunnelPassword, arginfo_TElSimpleSFTPClient_set_WebTunnelPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_WebTunnelPort, arginfo_TElSimpleSFTPClient_get_WebTunnelPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_WebTunnelPort, arginfo_TElSimpleSFTPClient_set_WebTunnelPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_WebTunnelUserId, arginfo_TElSimpleSFTPClient_get_WebTunnelUserId, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_WebTunnelUserId, arginfo_TElSimpleSFTPClient_set_WebTunnelUserId, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_WebTunnelRequestHeaders, arginfo_TElSimpleSFTPClient_get_WebTunnelRequestHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_WebTunnelResponseHeaders, arginfo_TElSimpleSFTPClient_get_WebTunnelResponseHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_WebTunnelResponseBody, arginfo_TElSimpleSFTPClient_get_WebTunnelResponseBody, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OperationErrorHandling, arginfo_TElSimpleSFTPClient_get_OperationErrorHandling, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OperationErrorHandling, arginfo_TElSimpleSFTPClient_set_OperationErrorHandling, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_RequestPasswordChange, arginfo_TElSimpleSFTPClient_get_RequestPasswordChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_RequestPasswordChange, arginfo_TElSimpleSFTPClient_set_RequestPasswordChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_CertAuthMode, arginfo_TElSimpleSFTPClient_get_CertAuthMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_CertAuthMode, arginfo_TElSimpleSFTPClient_set_CertAuthMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_AuthAttempts, arginfo_TElSimpleSFTPClient_get_AuthAttempts, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_AuthAttempts, arginfo_TElSimpleSFTPClient_set_AuthAttempts, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_IncomingSpeedLimit, arginfo_TElSimpleSFTPClient_get_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_IncomingSpeedLimit, arginfo_TElSimpleSFTPClient_set_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OutgoingSpeedLimit, arginfo_TElSimpleSFTPClient_get_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OutgoingSpeedLimit, arginfo_TElSimpleSFTPClient_set_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SocketBinding, arginfo_TElSimpleSFTPClient_get_SocketBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_SocketBinding, arginfo_TElSimpleSFTPClient_set_SocketBinding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_KeepAlivePeriod, arginfo_TElSimpleSFTPClient_get_KeepAlivePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_KeepAlivePeriod, arginfo_TElSimpleSFTPClient_set_KeepAlivePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_ThreadSafe, arginfo_TElSimpleSFTPClient_get_ThreadSafe, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_ThreadSafe, arginfo_TElSimpleSFTPClient_set_ThreadSafe, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_AdjustFileTimes, arginfo_TElSimpleSFTPClient_get_AdjustFileTimes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_AdjustFileTimes, arginfo_TElSimpleSFTPClient_set_AdjustFileTimes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_PreserveExistingFileTimes, arginfo_TElSimpleSFTPClient_get_PreserveExistingFileTimes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_PreserveExistingFileTimes, arginfo_TElSimpleSFTPClient_set_PreserveExistingFileTimes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_UseTruncateFlagOnUpload, arginfo_TElSimpleSFTPClient_get_UseTruncateFlagOnUpload, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_UseTruncateFlagOnUpload, arginfo_TElSimpleSFTPClient_set_UseTruncateFlagOnUpload, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_TreatZeroSizeAsUndefined, arginfo_TElSimpleSFTPClient_get_TreatZeroSizeAsUndefined, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_TreatZeroSizeAsUndefined, arginfo_TElSimpleSFTPClient_set_TreatZeroSizeAsUndefined, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_SFTPServerExecutableLocations, arginfo_TElSimpleSFTPClient_get_SFTPServerExecutableLocations, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_CommandTimeout, arginfo_TElSimpleSFTPClient_get_CommandTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_CommandTimeout, arginfo_TElSimpleSFTPClient_set_CommandTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnAuthenticationFailed, arginfo_TElSimpleSFTPClient_get_OnAuthenticationFailed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnAuthenticationFailed, arginfo_TElSimpleSFTPClient_set_OnAuthenticationFailed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnAuthenticationKeyboard, arginfo_TElSimpleSFTPClient_get_OnAuthenticationKeyboard, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnAuthenticationKeyboard, arginfo_TElSimpleSFTPClient_set_OnAuthenticationKeyboard, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnAuthenticationSuccess, arginfo_TElSimpleSFTPClient_get_OnAuthenticationSuccess, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnAuthenticationSuccess, arginfo_TElSimpleSFTPClient_set_OnAuthenticationSuccess, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnBanner, arginfo_TElSimpleSFTPClient_get_OnBanner, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnBanner, arginfo_TElSimpleSFTPClient_set_OnBanner, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnCloseConnection, arginfo_TElSimpleSFTPClient_get_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnCloseConnection, arginfo_TElSimpleSFTPClient_set_OnCloseConnection, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnError, arginfo_TElSimpleSFTPClient_get_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnError, arginfo_TElSimpleSFTPClient_set_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnKeyValidate, arginfo_TElSimpleSFTPClient_get_OnKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnKeyValidate, arginfo_TElSimpleSFTPClient_set_OnKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnReceive, arginfo_TElSimpleSFTPClient_get_OnReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnReceive, arginfo_TElSimpleSFTPClient_set_OnReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnSend, arginfo_TElSimpleSFTPClient_get_OnSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnSend, arginfo_TElSimpleSFTPClient_set_OnSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnProgress, arginfo_TElSimpleSFTPClient_get_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnProgress, arginfo_TElSimpleSFTPClient_set_OnProgress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnFileOperation, arginfo_TElSimpleSFTPClient_get_OnFileOperation, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnFileOperation, arginfo_TElSimpleSFTPClient_set_OnFileOperation, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnFileOperationResult, arginfo_TElSimpleSFTPClient_get_OnFileOperationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnFileOperationResult, arginfo_TElSimpleSFTPClient_set_OnFileOperationResult, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnBlockTransferPrepared, arginfo_TElSimpleSFTPClient_get_OnBlockTransferPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnBlockTransferPrepared, arginfo_TElSimpleSFTPClient_set_OnBlockTransferPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnCiphersNegotiated, arginfo_TElSimpleSFTPClient_get_OnCiphersNegotiated, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnCiphersNegotiated, arginfo_TElSimpleSFTPClient_set_OnCiphersNegotiated, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnPasswordChangeRequest, arginfo_TElSimpleSFTPClient_get_OnPasswordChangeRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnPasswordChangeRequest, arginfo_TElSimpleSFTPClient_set_OnPasswordChangeRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnPrivateKeyNeeded, arginfo_TElSimpleSFTPClient_get_OnPrivateKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnPrivateKeyNeeded, arginfo_TElSimpleSFTPClient_set_OnPrivateKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnAuthenticationStart, arginfo_TElSimpleSFTPClient_get_OnAuthenticationStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnAuthenticationStart, arginfo_TElSimpleSFTPClient_set_OnAuthenticationStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnAuthenticationAttempt, arginfo_TElSimpleSFTPClient_get_OnAuthenticationAttempt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnAuthenticationAttempt, arginfo_TElSimpleSFTPClient_set_OnAuthenticationAttempt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_MessageLoop, arginfo_TElSimpleSFTPClient_get_MessageLoop, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_MessageLoop, arginfo_TElSimpleSFTPClient_set_MessageLoop, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnTunnelOpenFailed, arginfo_TElSimpleSFTPClient_get_OnTunnelOpenFailed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnTunnelOpenFailed, arginfo_TElSimpleSFTPClient_set_OnTunnelOpenFailed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnSecondaryChannelPrepared, arginfo_TElSimpleSFTPClient_get_OnSecondaryChannelPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnSecondaryChannelPrepared, arginfo_TElSimpleSFTPClient_set_OnSecondaryChannelPrepared, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnSecondaryChannelOpen, arginfo_TElSimpleSFTPClient_get_OnSecondaryChannelOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnSecondaryChannelOpen, arginfo_TElSimpleSFTPClient_set_OnSecondaryChannelOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnSecondaryChannelError, arginfo_TElSimpleSFTPClient_get_OnSecondaryChannelError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnSecondaryChannelError, arginfo_TElSimpleSFTPClient_set_OnSecondaryChannelError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnFileNameChangeNeeded, arginfo_TElSimpleSFTPClient_get_OnFileNameChangeNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnFileNameChangeNeeded, arginfo_TElSimpleSFTPClient_set_OnFileNameChangeNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnKexInitReceived, arginfo_TElSimpleSFTPClient_get_OnKexInitReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnKexInitReceived, arginfo_TElSimpleSFTPClient_set_OnKexInitReceived, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSimpleSFTPClient, get_OnDNSKeyNeeded, arginfo_TElSimpleSFTPClient_get_OnDNSKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnDNSKeyNeeded, arginfo_TElSimpleSFTPClient_set_OnDNSKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnDNSKeyValidate, arginfo_TElSimpleSFTPClient_get_OnDNSKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnDNSKeyValidate, arginfo_TElSimpleSFTPClient_set_OnDNSKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, get_OnDNSResolve, arginfo_TElSimpleSFTPClient_get_OnDNSResolve, ZEND_ACC_PUBLIC)
	PHP_ME(TElSimpleSFTPClient, set_OnDNSResolve, arginfo_TElSimpleSFTPClient_set_OnDNSResolve, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSimpleSFTPClient, __construct, arginfo_TElSimpleSFTPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSimpleSFTPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSimpleSFTPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSimpleSFTPClient", TElSimpleSFTPClient_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElSimpleSFTPClient_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSimpleSftp_Aliases(TSRMLS_D)
{
	if (NULL == TElSimpleSFTPClient_ce_ptr)
		Register_TElSimpleSFTPClient(TSRMLS_C);
	zend_register_class_alias("ElSimpleSFTPClient", TElSimpleSFTPClient_ce_ptr);
}
