#include "sbsshforwarding.h"

void SB_CALLBACK TSBSSHConnectionEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHForwardedConnectionHandle Conn)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zConn;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConn);
	SBInitObject(zConn, TElSSHForwardedConnection_ce_ptr, Conn TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zConn;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConn);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHConnectionErrorEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHForwardedConnectionHandle Conn, int32_t ErrorCode)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zConn;
	zval * zErrorCode;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConn);
	SBInitObject(zConn, TElSSHForwardedConnection_ce_ptr, Conn TSRMLS_CC);
	MAKE_STD_ZVAL(zErrorCode);
	ZVAL_LONG(zErrorCode, (long)ErrorCode);

	params[0] = &zSender;
	params[1] = &zConn;
	params[2] = &zErrorCode;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConn);
	zval_ptr_dtor(&zErrorCode);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHTunnelEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHForwardingTunnelHandle Tunnel)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zTunnel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zTunnel);
	SBInitObject(zTunnel, TElSSHForwardingTunnel_ce_ptr, Tunnel TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zTunnel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zTunnel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHLPFAcceptEventRaw(void * _ObjectData, TObjectHandle Sender, TElSocketHandle Socket)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zSocket;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSocket);
	SBInitObject(zSocket, TElSocket_ce_ptr, Socket TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zSocket;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSocket);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHSocketAcceptEventRaw(void * _ObjectData, TObjectHandle Sender, TElSocketHandle Socket, int8_t * Reject)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zSocket;
	zval * zReject;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zSocket);
	SBInitObject(zSocket, TElSocket_ce_ptr, Socket TSRMLS_CC);
	MAKE_STD_ZVAL(zReject);
	ZVAL_BOOL(zReject, (zend_bool)*Reject);

	params[0] = &zSender;
	params[1] = &zSocket;
	params[2] = &zReject;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zSocket);
	*Reject = (int8_t)Z_BVAL_P(zReject);
	zval_ptr_dtor(&zReject);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHSocksAuthMethodChooseEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHForwardedConnectionHandle Conn, const TElSocksAuthenticationRaw pAuthMethods[], int32_t szAuthMethods, TElSocksAuthenticationRaw * AuthMethod, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zConn;
	zval * zAuthMethods;
	zval * zAuthMethod;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConn);
	SBInitObject(zConn, TElSSHForwardedConnection_ce_ptr, Conn TSRMLS_CC);
	MAKE_STD_ZVAL(zAuthMethods);
	SBSetByteArrayToZValP((uint8_t *)pAuthMethods, szAuthMethods, zAuthMethods);
	MAKE_STD_ZVAL(zAuthMethod);
	ZVAL_LONG(zAuthMethod, (long)*AuthMethod);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zConn;
	params[2] = &zAuthMethods;
	params[3] = &zAuthMethod;
	params[4] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConn);
	zval_ptr_dtor(&zAuthMethods);
	*AuthMethod = (TElSocksAuthenticationRaw)Z_LVAL_P(zAuthMethod);
	zval_ptr_dtor(&zAuthMethod);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHSocksAuthPasswordEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHForwardedConnectionHandle Conn, const char * pcUsername, int32_t szUsername, const char * pcPassword, int32_t szPassword, int8_t * Accept)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zConn;
	zval * zUsername;
	zval * zPassword;
	zval * zAccept;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConn);
	SBInitObject(zConn, TElSSHForwardedConnection_ce_ptr, Conn TSRMLS_CC);
	MAKE_STD_ZVAL(zUsername);
	ZVAL_STRINGL(zUsername, pcUsername, szUsername, 1);
	MAKE_STD_ZVAL(zPassword);
	ZVAL_STRINGL(zPassword, pcPassword, szPassword, 1);
	MAKE_STD_ZVAL(zAccept);
	ZVAL_BOOL(zAccept, (zend_bool)*Accept);

	params[0] = &zSender;
	params[1] = &zConn;
	params[2] = &zUsername;
	params[3] = &zPassword;
	params[4] = &zAccept;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConn);
	zval_ptr_dtor(&zUsername);
	zval_ptr_dtor(&zPassword);
	*Accept = (int8_t)Z_BVAL_P(zAccept);
	zval_ptr_dtor(&zAccept);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHSocksConnectEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHForwardedConnectionHandle Conn, const char * pcDestHost, int32_t szDestHost, int32_t DestPort, int8_t * Allow)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zConn;
	zval * zDestHost;
	zval * zDestPort;
	zval * zAllow;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zConn);
	SBInitObject(zConn, TElSSHForwardedConnection_ce_ptr, Conn TSRMLS_CC);
	MAKE_STD_ZVAL(zDestHost);
	ZVAL_STRINGL(zDestHost, pcDestHost, szDestHost, 1);
	MAKE_STD_ZVAL(zDestPort);
	ZVAL_LONG(zDestPort, (long)DestPort);
	MAKE_STD_ZVAL(zAllow);
	ZVAL_BOOL(zAllow, (zend_bool)*Allow);

	params[0] = &zSender;
	params[1] = &zConn;
	params[2] = &zDestHost;
	params[3] = &zDestPort;
	params[4] = &zAllow;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zConn);
	zval_ptr_dtor(&zDestHost);
	zval_ptr_dtor(&zDestPort);
	*Allow = (int8_t)Z_BVAL_P(zAllow);
	zval_ptr_dtor(&zAllow);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBSSHBeforeConnectingEventRaw(void * _ObjectData, TObjectHandle Sender, TElSSHClientHandle Client, TElSocketHandle Socket)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zClient;
	zval * zSocket;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zClient);
	SBInitObject(zClient, TElSSHClient_ce_ptr, Client TSRMLS_CC);
	MAKE_STD_ZVAL(zSocket);
	SBInitObject(zSocket, TElSocket_ce_ptr, Socket TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zClient;
	params[2] = &zSocket;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zClient);
	zval_ptr_dtor(&zSocket);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBSSHForwardingPriority_ce_ptr = NULL;

zend_class_entry *TSBSSHForwardingSocketState_ce_ptr = NULL;

zend_class_entry *TSBSSHForwardingChannelState_ce_ptr = NULL;

zend_class_entry *TElSSHForwardedConnection_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHForwardedConnection, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHForwardedConnection_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_AutoAdjustPriority)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_AutoAdjustPriority(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, set_AutoAdjustPriority)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHForwardedConnection_set_AutoAdjustPriority(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_Socket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHForwardedConnection_get_Socket(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSocket_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, set_Socket)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSocket_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHForwardedConnection_set_Socket(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSocket)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_ReceivedFromSocket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_ReceivedFromSocket(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_SentToSocket)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_SentToSocket(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_ReceivedFromChannel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_ReceivedFromChannel(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_SentToChannel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_SentToChannel(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_SocketState)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHForwardingSocketStateRaw fOutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_SocketState(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_ChannelState)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHForwardingChannelStateRaw fOutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_ChannelState(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_Data)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		void * poOutResult = NULL;
		SBCheckError(TElSSHForwardedConnection_get_Data(SBGetObjectHandle(getThis() TSRMLS_CC), &poOutResult) TSRMLS_CC);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, set_Data)
{
	SBArrayZValInfo piValue;
	zval *zpValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpValue) == SUCCESS) && ((Z_TYPE_P(zpValue) == IS_STRING) || (Z_TYPE_P(zpValue) == IS_ARRAY) || (Z_TYPE_P(zpValue) == IS_NULL) || ((Z_TYPE_P(zpValue) == IS_OBJECT) && (Z_OBJCE_P(zpValue) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpValue, &piValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSHForwardedConnection_set_Data(SBGetObjectHandle(getThis() TSRMLS_CC), piValue.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piValue);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_ForwardedHost)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHForwardedConnection_get_ForwardedHost(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(704683458, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_ForwardedPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_ForwardedPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_DestHost)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHForwardedConnection_get_DestHost(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(431025629, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_DestPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_DestPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_BoundPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_BoundPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_KeepAlivePeriod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_KeepAlivePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, set_KeepAlivePeriod)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHForwardedConnection_set_KeepAlivePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSSHForwardedConnection, get_DestUsingIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_DestUsingIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_ForwardedUsingIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_ForwardedUsingIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSSHForwardedConnection, get_SocketReadBufSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_SocketReadBufSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, set_SocketReadBufSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHForwardedConnection_set_SocketReadBufSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_SocketWriteBufSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_SocketWriteBufSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, set_SocketWriteBufSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHForwardedConnection_set_SocketWriteBufSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_MaxCacheSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_MaxCacheSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, set_MaxCacheSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHForwardedConnection_set_MaxCacheSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_ExitStatus)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardedConnection_get_ExitStatus(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_ExitSignal)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHForwardedConnection_get_ExitSignal(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1520285217, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, get_ExitMessage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHForwardedConnection_get_ExitMessage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1076528904, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardedConnection, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElSSHForwardingSession_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHForwardedConnection_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHForwardingSession)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_AutoAdjustPriority, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_set_AutoAdjustPriority, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_Socket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_set_Socket, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSocket, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_ReceivedFromSocket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_SentToSocket, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_ReceivedFromChannel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_SentToChannel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_SocketState, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_ChannelState, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_Data, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_set_Data, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_ForwardedHost, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_ForwardedPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_DestHost, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_DestPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_BoundPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_KeepAlivePeriod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_set_KeepAlivePeriod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_DestUsingIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_ForwardedUsingIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_SocketReadBufSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_set_SocketReadBufSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_SocketWriteBufSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_set_SocketWriteBufSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_MaxCacheSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_set_MaxCacheSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_ExitStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_ExitSignal, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection_get_ExitMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardedConnection___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElSSHForwardingSession, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHForwardedConnection_methods[] = {
	PHP_ME(TElSSHForwardedConnection, Close, arginfo_TElSSHForwardedConnection_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_AutoAdjustPriority, arginfo_TElSSHForwardedConnection_get_AutoAdjustPriority, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, set_AutoAdjustPriority, arginfo_TElSSHForwardedConnection_set_AutoAdjustPriority, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_Socket, arginfo_TElSSHForwardedConnection_get_Socket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, set_Socket, arginfo_TElSSHForwardedConnection_set_Socket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_ReceivedFromSocket, arginfo_TElSSHForwardedConnection_get_ReceivedFromSocket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_SentToSocket, arginfo_TElSSHForwardedConnection_get_SentToSocket, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_ReceivedFromChannel, arginfo_TElSSHForwardedConnection_get_ReceivedFromChannel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_SentToChannel, arginfo_TElSSHForwardedConnection_get_SentToChannel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_SocketState, arginfo_TElSSHForwardedConnection_get_SocketState, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_ChannelState, arginfo_TElSSHForwardedConnection_get_ChannelState, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_Data, arginfo_TElSSHForwardedConnection_get_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, set_Data, arginfo_TElSSHForwardedConnection_set_Data, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_ForwardedHost, arginfo_TElSSHForwardedConnection_get_ForwardedHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_ForwardedPort, arginfo_TElSSHForwardedConnection_get_ForwardedPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_DestHost, arginfo_TElSSHForwardedConnection_get_DestHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_DestPort, arginfo_TElSSHForwardedConnection_get_DestPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_BoundPort, arginfo_TElSSHForwardedConnection_get_BoundPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_KeepAlivePeriod, arginfo_TElSSHForwardedConnection_get_KeepAlivePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, set_KeepAlivePeriod, arginfo_TElSSHForwardedConnection_set_KeepAlivePeriod, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSSHForwardedConnection, get_DestUsingIPv6, arginfo_TElSSHForwardedConnection_get_DestUsingIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_ForwardedUsingIPv6, arginfo_TElSSHForwardedConnection_get_ForwardedUsingIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSSHForwardedConnection, get_SocketReadBufSize, arginfo_TElSSHForwardedConnection_get_SocketReadBufSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, set_SocketReadBufSize, arginfo_TElSSHForwardedConnection_set_SocketReadBufSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_SocketWriteBufSize, arginfo_TElSSHForwardedConnection_get_SocketWriteBufSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, set_SocketWriteBufSize, arginfo_TElSSHForwardedConnection_set_SocketWriteBufSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_MaxCacheSize, arginfo_TElSSHForwardedConnection_get_MaxCacheSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, set_MaxCacheSize, arginfo_TElSSHForwardedConnection_set_MaxCacheSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_ExitStatus, arginfo_TElSSHForwardedConnection_get_ExitStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_ExitSignal, arginfo_TElSSHForwardedConnection_get_ExitSignal, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, get_ExitMessage, arginfo_TElSSHForwardedConnection_get_ExitMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardedConnection, __construct, arginfo_TElSSHForwardedConnection___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHForwardedConnection(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHForwardedConnection_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHForwardedConnection", TElSSHForwardedConnection_methods);
	if (NULL == TThread_ce_ptr)
		Register_TThread(TSRMLS_C);
	TElSSHForwardedConnection_ce_ptr = zend_register_internal_class_ex(&ce, TThread_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHForwardingTunnel_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHForwardingTunnel, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, Close)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_BoundPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_BoundPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSSHForwardingTunnel, get_UsingIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_UsingIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSSHForwardingTunnel, get_ForwardedHost)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHForwardingTunnel_get_ForwardedHost(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1956104846, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_ForwardedHost)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_ForwardedHost(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_ForwardedPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_ForwardedPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_ForwardedPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_ForwardedPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_DestHost)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHForwardingTunnel_get_DestHost(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(24189985, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_DestHost)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_DestHost(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_DestPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_DestPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_DestPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_DestPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSSHForwardingTunnel, get_DestUseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_DestUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_DestUseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_DestUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_ForwardedUseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_ForwardedUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_ForwardedUseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_ForwardedUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSSHForwardingTunnel, get_UseProxySettingsForForwardedConnections)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_UseProxySettingsForForwardedConnections(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_UseProxySettingsForForwardedConnections)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_UseProxySettingsForForwardedConnections(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_AutoOpen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_AutoOpen(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_AutoOpen)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_AutoOpen(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_UseDefaultBindAddress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_UseDefaultBindAddress(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_UseDefaultBindAddress)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_UseDefaultBindAddress(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_UseDynamicForwarding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_UseDynamicForwarding(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_UseDynamicForwarding)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_UseDynamicForwarding(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_ResolveDynamicForwardingAddresses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_ResolveDynamicForwardingAddresses(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_ResolveDynamicForwardingAddresses)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_ResolveDynamicForwardingAddresses(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_SocketReadBufSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_SocketReadBufSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_SocketReadBufSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_SocketReadBufSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_SocketWriteBufSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_SocketWriteBufSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_SocketWriteBufSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_SocketWriteBufSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, get_MaxCacheSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardingTunnel_get_MaxCacheSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, set_MaxCacheSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingTunnel_set_MaxCacheSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingTunnel, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElSSHCustomForwarding_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHForwardingTunnel_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHCustomForwarding)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_Close, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_BoundPort, 0, 0, 0)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_UsingIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_ForwardedHost, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_ForwardedHost, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_ForwardedPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_ForwardedPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_DestHost, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_DestHost, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_DestPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_DestPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_DestUseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_DestUseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_ForwardedUseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_ForwardedUseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_UseProxySettingsForForwardedConnections, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_UseProxySettingsForForwardedConnections, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_AutoOpen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_AutoOpen, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_UseDefaultBindAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_UseDefaultBindAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_UseDynamicForwarding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_UseDynamicForwarding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_ResolveDynamicForwardingAddresses, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_ResolveDynamicForwardingAddresses, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_SocketReadBufSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_SocketReadBufSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_SocketWriteBufSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_SocketWriteBufSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_get_MaxCacheSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel_set_MaxCacheSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingTunnel___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElSSHCustomForwarding, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHForwardingTunnel_methods[] = {
	PHP_ME(TElSSHForwardingTunnel, Open, arginfo_TElSSHForwardingTunnel_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, Close, arginfo_TElSSHForwardingTunnel_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_Active, arginfo_TElSSHForwardingTunnel_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_BoundPort, arginfo_TElSSHForwardingTunnel_get_BoundPort, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSSHForwardingTunnel, get_UsingIPv6, arginfo_TElSSHForwardingTunnel_get_UsingIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSSHForwardingTunnel, get_ForwardedHost, arginfo_TElSSHForwardingTunnel_get_ForwardedHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_ForwardedHost, arginfo_TElSSHForwardingTunnel_set_ForwardedHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_ForwardedPort, arginfo_TElSSHForwardingTunnel_get_ForwardedPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_ForwardedPort, arginfo_TElSSHForwardingTunnel_set_ForwardedPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_DestHost, arginfo_TElSSHForwardingTunnel_get_DestHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_DestHost, arginfo_TElSSHForwardingTunnel_set_DestHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_DestPort, arginfo_TElSSHForwardingTunnel_get_DestPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_DestPort, arginfo_TElSSHForwardingTunnel_set_DestPort, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSSHForwardingTunnel, get_DestUseIPv6, arginfo_TElSSHForwardingTunnel_get_DestUseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_DestUseIPv6, arginfo_TElSSHForwardingTunnel_set_DestUseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_ForwardedUseIPv6, arginfo_TElSSHForwardingTunnel_get_ForwardedUseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_ForwardedUseIPv6, arginfo_TElSSHForwardingTunnel_set_ForwardedUseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSSHForwardingTunnel, get_UseProxySettingsForForwardedConnections, arginfo_TElSSHForwardingTunnel_get_UseProxySettingsForForwardedConnections, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_UseProxySettingsForForwardedConnections, arginfo_TElSSHForwardingTunnel_set_UseProxySettingsForForwardedConnections, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_AutoOpen, arginfo_TElSSHForwardingTunnel_get_AutoOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_AutoOpen, arginfo_TElSSHForwardingTunnel_set_AutoOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_UseDefaultBindAddress, arginfo_TElSSHForwardingTunnel_get_UseDefaultBindAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_UseDefaultBindAddress, arginfo_TElSSHForwardingTunnel_set_UseDefaultBindAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_UseDynamicForwarding, arginfo_TElSSHForwardingTunnel_get_UseDynamicForwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_UseDynamicForwarding, arginfo_TElSSHForwardingTunnel_set_UseDynamicForwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_ResolveDynamicForwardingAddresses, arginfo_TElSSHForwardingTunnel_get_ResolveDynamicForwardingAddresses, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_ResolveDynamicForwardingAddresses, arginfo_TElSSHForwardingTunnel_set_ResolveDynamicForwardingAddresses, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_SocketReadBufSize, arginfo_TElSSHForwardingTunnel_get_SocketReadBufSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_SocketReadBufSize, arginfo_TElSSHForwardingTunnel_set_SocketReadBufSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_SocketWriteBufSize, arginfo_TElSSHForwardingTunnel_get_SocketWriteBufSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_SocketWriteBufSize, arginfo_TElSSHForwardingTunnel_set_SocketWriteBufSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, get_MaxCacheSize, arginfo_TElSSHForwardingTunnel_get_MaxCacheSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, set_MaxCacheSize, arginfo_TElSSHForwardingTunnel_set_MaxCacheSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingTunnel, __construct, arginfo_TElSSHForwardingTunnel___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHForwardingTunnel(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHForwardingTunnel_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHForwardingTunnel", TElSSHForwardingTunnel_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSSHForwardingTunnel_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHForwardingSession_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHForwardingSession, get_Username)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHForwardingSession_get_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(369897355, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, set_Username)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingSession_set_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, get_Password)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHForwardingSession_get_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-611291351, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, set_Password)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingSession_set_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, get_ForwardedPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardingSession_get_ForwardedPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, set_ForwardedPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingSession_set_ForwardedPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, get_DestHost)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHForwardingSession_get_DestHost(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-907386583, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, set_DestHost)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingSession_set_DestHost(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, get_DestPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHForwardingSession_get_DestPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, set_DestPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHForwardingSession_set_DestPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, get_OnConnectionOpen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHForwardingSession_get_OnConnectionOpen(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, set_OnConnectionOpen)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHForwardingSession_set_OnConnectionOpen(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, get_OnConnectionChange)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHForwardingSession_get_OnConnectionChange(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, set_OnConnectionChange)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHForwardingSession_set_OnConnectionChange(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, get_OnConnectionRemove)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHForwardingSession_get_OnConnectionRemove(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, set_OnConnectionRemove)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHForwardingSession_set_OnConnectionRemove(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, get_OnReceive)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHReceiveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHForwardingSession_get_OnReceive(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, set_OnReceive)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHForwardingSession_set_OnReceive(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHReceiveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHReceiveEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, get_OnSend)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHSendEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHForwardingSession_get_OnSend(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, set_OnSend)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHForwardingSession_set_OnSend(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHSendEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHSendEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHForwardingSession, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElSSHCustomForwarding_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHForwardingSession_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHCustomForwarding)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_get_Username, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_set_Username, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_get_Password, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_set_Password, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_get_ForwardedPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_set_ForwardedPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_get_DestHost, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_set_DestHost, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_get_DestPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_set_DestPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_get_OnConnectionOpen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_set_OnConnectionOpen, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_get_OnConnectionChange, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_set_OnConnectionChange, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_get_OnConnectionRemove, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_set_OnConnectionRemove, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_get_OnReceive, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_set_OnReceive, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_get_OnSend, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession_set_OnSend, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingSession___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElSSHCustomForwarding, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHForwardingSession_methods[] = {
	PHP_ME(TElSSHForwardingSession, get_Username, arginfo_TElSSHForwardingSession_get_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, set_Username, arginfo_TElSSHForwardingSession_set_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, get_Password, arginfo_TElSSHForwardingSession_get_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, set_Password, arginfo_TElSSHForwardingSession_set_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, get_ForwardedPort, arginfo_TElSSHForwardingSession_get_ForwardedPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, set_ForwardedPort, arginfo_TElSSHForwardingSession_set_ForwardedPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, get_DestHost, arginfo_TElSSHForwardingSession_get_DestHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, set_DestHost, arginfo_TElSSHForwardingSession_set_DestHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, get_DestPort, arginfo_TElSSHForwardingSession_get_DestPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, set_DestPort, arginfo_TElSSHForwardingSession_set_DestPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, get_OnConnectionOpen, arginfo_TElSSHForwardingSession_get_OnConnectionOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, set_OnConnectionOpen, arginfo_TElSSHForwardingSession_set_OnConnectionOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, get_OnConnectionChange, arginfo_TElSSHForwardingSession_get_OnConnectionChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, set_OnConnectionChange, arginfo_TElSSHForwardingSession_set_OnConnectionChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, get_OnConnectionRemove, arginfo_TElSSHForwardingSession_get_OnConnectionRemove, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, set_OnConnectionRemove, arginfo_TElSSHForwardingSession_set_OnConnectionRemove, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, get_OnReceive, arginfo_TElSSHForwardingSession_get_OnReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, set_OnReceive, arginfo_TElSSHForwardingSession_set_OnReceive, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, get_OnSend, arginfo_TElSSHForwardingSession_get_OnSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, set_OnSend, arginfo_TElSSHForwardingSession_set_OnSend, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHForwardingSession, __construct, arginfo_TElSSHForwardingSession___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHForwardingSession(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHForwardingSession_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHForwardingSession", TElSSHForwardingSession_methods);
	if (NULL == TThread_ce_ptr)
		Register_TThread(TSRMLS_C);
	TElSSHForwardingSession_ce_ptr = zend_register_internal_class_ex(&ce, TThread_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHCustomForwarding_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHCustomForwarding, Open)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_Open(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, Close)
{
	zend_bool bWait;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_Close(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bWait) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_Close_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bWait) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, RenegotiateCiphers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_RenegotiateCiphers(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, SendIgnore)
{
	long l4Count;
	long l4StartIndex;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4StartIndex, &l4Count) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSHCustomForwarding_SendIgnore(SBGetObjectHandle(getThis() TSRMLS_CC), aiBuffer.data, aiBuffer.len, (int32_t)l4StartIndex, (int32_t)l4Count) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, AddTunnel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_AddTunnel(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, RemoveTunnel)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_RemoveTunnel(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, ClearTunnels)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_ClearTunnels(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_KexAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t l1OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_KexAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &l1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_PublicKeyAlgorithm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_PublicKeyAlgorithm(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_CompressionAlgorithms)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_CompressionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_CompressionAlgorithms)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_CompressionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_EncryptionAlgorithms)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_EncryptionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_EncryptionAlgorithms)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_EncryptionAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_KexAlgorithms)
{
	long l1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_KexAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)l1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_KexAlgorithms)
{
	long l1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &l1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_KexAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)l1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_MacAlgorithms)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_MacAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_MacAlgorithms)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_MacAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_PublicKeyAlgorithms)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_PublicKeyAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_PublicKeyAlgorithms)
{
	long u1Index;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lb", &u1Index, &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_PublicKeyAlgorithms(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_AuthTypePriorities)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_AuthTypePriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_AuthTypePriorities)
{
	long l4Index;
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l4Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_AuthTypePriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_PublicKeyAlgorithmPriorities)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_PublicKeyAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_PublicKeyAlgorithmPriorities)
{
	long l4Value;
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_PublicKeyAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_EncryptionAlgorithmPriorities)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_EncryptionAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_EncryptionAlgorithmPriorities)
{
	long l4Value;
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_EncryptionAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_CompressionAlgorithmPriorities)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_CompressionAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_CompressionAlgorithmPriorities)
{
	long l4Value;
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_CompressionAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_MacAlgorithmPriorities)
{
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_MacAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_MacAlgorithmPriorities)
{
	long l4Value;
	long u1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_MacAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (uint8_t)u1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_KexAlgorithmPriorities)
{
	long l1Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l1Index) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_KexAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)l1Index, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_KexAlgorithmPriorities)
{
	long l1Index;
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &l1Index, &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_KexAlgorithmPriorities(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)l1Index, (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_Tunnels)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_Tunnels(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHForwardingTunnel_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_Active)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_Active(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_CompressionAlgorithmServerToClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_CompressionAlgorithmServerToClient(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_CompressionAlgorithmClientToServer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_CompressionAlgorithmClientToServer(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_EncryptionAlgorithmServerToClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_EncryptionAlgorithmServerToClient(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_EncryptionAlgorithmClientToServer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_EncryptionAlgorithmClientToServer(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_MacAlgorithmServerToClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_MacAlgorithmServerToClient(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_MacAlgorithmClientToServer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t u1OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_MacAlgorithmClientToServer(SBGetObjectHandle(getThis() TSRMLS_CC), &u1OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u1OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_ServerCloseReason)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_ServerCloseReason(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-202344055, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_ServerSoftwareName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_ServerSoftwareName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-881471461, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_Version)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHVersionRaw fOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_Version(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_TunnelCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_TunnelCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_KbdIntName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_KbdIntName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1198643245, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_KbdIntInstruction)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_KbdIntInstruction(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1947523837, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_ServerKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_ServerKey(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHKey_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_BoundPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_BoundPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSSHCustomForwarding, get_UsingIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_UsingIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSSHCustomForwarding, get_TotalBytesSent)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_TotalBytesSent(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_TotalBytesReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_TotalBytesReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1812980240, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_Address)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_AuthenticationTypes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_AuthenticationTypes(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_AuthenticationTypes)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_AuthenticationTypes(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_AutoAdjustCiphers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_AutoAdjustCiphers(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_AutoAdjustCiphers)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_AutoAdjustCiphers(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_ClientHostname)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_ClientHostname(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1503891342, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_ClientHostname)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_ClientHostname(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_ClientUsername)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_ClientUsername(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1152141800, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_ClientUsername)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_ClientUsername(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_CompressionLevel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_CompressionLevel)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_CompressionLevel(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_DestHost)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_DestHost(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-769238912, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_DestHost)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_DestHost(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_DestPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_DestPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_DestPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_DestPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_ForceCompression)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_ForceCompression(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_ForceCompression)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_ForceCompression(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_ForwardedPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_ForwardedPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_ForwardedPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_ForwardedPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_ForwardedHost)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_ForwardedHost(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(297788119, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_ForwardedHost)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_ForwardedHost(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_KeepAlivePeriod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_KeepAlivePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_KeepAlivePeriod)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_KeepAlivePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_GlobalKeepAlivePeriod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_GlobalKeepAlivePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_GlobalKeepAlivePeriod)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_GlobalKeepAlivePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_KeyStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_KeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHCustomKeyStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_KeyStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSSHCustomKeyStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_KeyStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHCustomKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_Password)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1067690368, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_Password)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_Password(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_Port)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_Port(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_Port)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_Port(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SoftwareName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_SoftwareName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(973518475, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SoftwareName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SoftwareName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SynchronizeGUI)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_SynchronizeGUI(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SynchronizeGUI)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SynchronizeGUI(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_Username)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(230692386, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_Username)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_Username(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_Versions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHVersionsRaw fOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_Versions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_Versions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSSHVersionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SocketTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_SocketTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SocketTimeout)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SocketTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SessionTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_SessionTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SessionTimeout)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SessionTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSSHCustomForwarding, get_UseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_UseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_UseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_DNS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_DNS(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElDNSSettings_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_DNS)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElDNSSettings_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_DNS(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElDNSSettings)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSSHCustomForwarding, get_PortKnock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_PortKnock(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElPortKnock_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_PortKnock)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElPortKnock_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_PortKnock(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElPortKnock)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SocksAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSocksAuthenticationRaw fOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_SocksAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SocksAuthentication)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SocksAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSocksAuthenticationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SocksPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_SocksPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(713805518, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SocksPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SocksPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SocksPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_SocksPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SocksPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SocksPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SocksResolveAddress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_SocksResolveAddress(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SocksResolveAddress)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SocksResolveAddress(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SocksServer)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_SocksServer(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1023736084, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SocksServer)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SocksServer(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSSHCustomForwarding, get_SocksUseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_SocksUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SocksUseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SocksUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSSHCustomForwarding, get_SocksUserCode)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_SocksUserCode(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1846767564, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SocksUserCode)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SocksUserCode(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SocksVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElSocksVersionRaw fOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_SocksVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SocksVersion)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SocksVersion(SBGetObjectHandle(getThis() TSRMLS_CC), (TElSocksVersionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_UseSocks)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_UseSocks(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_UseSocks)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_UseSocks(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_UseWebTunneling)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_UseWebTunneling(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_UseWebTunneling)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_UseWebTunneling(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_WebTunnelAddress)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_WebTunnelAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(483753036, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_WebTunnelAddress)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_WebTunnelAddress(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_WebTunnelAuthentication)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElWebTunnelAuthenticationRaw fOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_WebTunnelAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_WebTunnelAuthentication)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_WebTunnelAuthentication(SBGetObjectHandle(getThis() TSRMLS_CC), (TElWebTunnelAuthenticationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_WebTunnelPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_WebTunnelPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(33852486, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_WebTunnelPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_WebTunnelPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_WebTunnelPort)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_WebTunnelPort(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_WebTunnelPort)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_WebTunnelPort(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_WebTunnelUserId)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_WebTunnelUserId(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-238769103, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_WebTunnelUserId)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_WebTunnelUserId(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_WebTunnelRequestHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_WebTunnelRequestHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SocketSettings)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_SocketSettings(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSocketSettings_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_Priority)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHForwardingPriorityRaw fOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_Priority(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_Priority)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_Priority(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSSHForwardingPriorityRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_Intercept)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_Intercept(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHForwardingIntercept_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_Intercept)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSSHForwardingIntercept_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_Intercept(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHForwardingIntercept)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_CloseIfNoActiveTunnels)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_CloseIfNoActiveTunnels(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_CloseIfNoActiveTunnels)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_CloseIfNoActiveTunnels(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_UseUTF8)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_UseUTF8)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_UseUTF8(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_RequestPasswordChange)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_RequestPasswordChange(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_RequestPasswordChange)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_RequestPasswordChange(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_CertAuthMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHCertAuthModeRaw fOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_CertAuthMode(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_CertAuthMode)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_CertAuthMode(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSSHCertAuthModeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_AutoAdjustPriority)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_AutoAdjustPriority(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_AutoAdjustPriority)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_AutoAdjustPriority(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_AuthAttempts)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_AuthAttempts(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_AuthAttempts)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_AuthAttempts(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SSHAuthOrder)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHAuthOrderRaw fOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_SSHAuthOrder(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SSHAuthOrder)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SSHAuthOrder(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSSHAuthOrderRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_TrustedKeys)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_TrustedKeys(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSSHCustomKeyStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_TrustedKeys)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSSHCustomKeyStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_TrustedKeys(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHCustomKeyStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_DefaultWindowSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_DefaultWindowSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_DefaultWindowSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_DefaultWindowSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_MinWindowSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_MinWindowSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_MinWindowSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_MinWindowSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_MaxSSHPacketSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_MaxSSHPacketSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_MaxSSHPacketSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_MaxSSHPacketSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_FlushCachedDataOnClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_FlushCachedDataOnClose(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_FlushCachedDataOnClose)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_FlushCachedDataOnClose(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_IncomingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_IncomingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_IncomingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OutgoingSpeedLimit)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OutgoingSpeedLimit)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_OutgoingSpeedLimit(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_EstablishShellChannel)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_EstablishShellChannel(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_EstablishShellChannel)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_EstablishShellChannel(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_ObfuscateHandshake)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_ObfuscateHandshake(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_ObfuscateHandshake)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_ObfuscateHandshake(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_ObfuscationPassword)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_ObfuscationPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1275011252, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_ObfuscationPassword)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_ObfuscationPassword(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SocketReadBufSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_SocketReadBufSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SocketReadBufSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SocketReadBufSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_SocketWriteBufSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_SocketWriteBufSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_SocketWriteBufSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_SocketWriteBufSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_MaxCacheSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_MaxCacheSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_MaxCacheSize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_MaxCacheSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_GSSMechanism)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_GSSMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElGSSBaseMechanism_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_GSSMechanism)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElGSSBaseMechanism_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_GSSMechanism(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElGSSBaseMechanism)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_GSSHostName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSSHCustomForwarding_get_GSSHostName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(450902289, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_GSSHostName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_GSSHostName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_GSSDelegateCredentials)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_GSSDelegateCredentials(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_GSSDelegateCredentials)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_GSSDelegateCredentials(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_InactivityPeriod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSSHCustomForwarding_get_InactivityPeriod(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_InactivityPeriod)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSSHCustomForwarding_set_InactivityPeriod(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnAuthenticationKeyboard)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthenticationKeyboardEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnAuthenticationKeyboard(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnAuthenticationKeyboard)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnAuthenticationKeyboard(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthenticationKeyboardEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthenticationKeyboardEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnAuthenticationFailed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthenticationFailedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnAuthenticationFailed(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnAuthenticationFailed)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnAuthenticationFailed(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthenticationFailedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthenticationFailedEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnAuthenticationSuccess)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnAuthenticationSuccess(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnAuthenticationSuccess)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnAuthenticationSuccess(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnAuthenticationStart)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthenticationStartEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnAuthenticationStart(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnAuthenticationStart)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnAuthenticationStart(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthenticationStartEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthenticationStartEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnAuthenticationAttempt)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHAuthenticationAttemptEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnAuthenticationAttempt(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnAuthenticationAttempt)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnAuthenticationAttempt(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHAuthenticationAttemptEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHAuthenticationAttemptEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnBanner)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHBannerEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnBanner(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnBanner)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnBanner(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHBannerEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHBannerEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnKeyValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHKeyValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnKeyValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHKeyValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHKeyValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnDebugData)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHDataEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnDebugData(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnDebugData)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnDebugData(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHDataEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHDataEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnPrivateKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHPrivateKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnPrivateKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnPrivateKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnPrivateKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHPrivateKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHPrivateKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnCiphersNegotiated)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnCiphersNegotiated(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnCiphersNegotiated)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnCiphersNegotiated(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnOpen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnOpen(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnOpen)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnOpen(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnClose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnClose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnClose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnConnectionOpen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnConnectionOpen(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnConnectionOpen)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnConnectionOpen(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnConnectionClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnConnectionClose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnConnectionClose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnConnectionClose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnConnectionChange)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnConnectionChange(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnConnectionChange)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnConnectionChange(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnConnectionError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHConnectionErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnConnectionError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnConnectionError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnConnectionError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHConnectionErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHConnectionErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnConnectionWork)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHConnectionEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnConnectionWork(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnConnectionWork)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnConnectionWork(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHConnectionEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHConnectionEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnTunnelOpen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHTunnelEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnTunnelOpen(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnTunnelOpen)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnTunnelOpen(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHTunnelEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHTunnelEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnTunnelClose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHTunnelEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnTunnelClose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnTunnelClose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnTunnelClose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHTunnelEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHTunnelEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnPasswordChangeRequest)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHPasswordChangeRequestEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnPasswordChangeRequest(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnPasswordChangeRequest)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnPasswordChangeRequest(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHPasswordChangeRequestEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHPasswordChangeRequestEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnBeforeConnecting)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHBeforeConnectingEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnBeforeConnecting(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnBeforeConnecting)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnBeforeConnecting(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHBeforeConnectingEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHBeforeConnectingEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnKexInitReceived)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHKexInitReceivedEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnKexInitReceived(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnKexInitReceived)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnKexInitReceived(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHKexInitReceivedEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHKexInitReceivedEvent|callable|NULL)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSSHCustomForwarding, get_OnDNSError)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSSHErrorEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnDNSError(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnDNSError)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnDNSError(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSSHErrorEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSSHErrorEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnDNSKeyNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnDNSKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnDNSKeyNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnDNSKeyNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnDNSKeyValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSKeyValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnDNSKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnDNSKeyValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnDNSKeyValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSKeyValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSKeyValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, get_OnDNSResolve)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBDNSResolveEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_get_OnDNSResolve(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHCustomForwarding, set_OnDNSResolve)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHCustomForwarding_set_OnDNSResolve(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBDNSResolveEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBDNSResolveEvent|callable|NULL)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSSHCustomForwarding, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHCustomForwarding_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_Open, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_Close, 0, 0, 0)
	ZEND_ARG_INFO(0, Wait)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_RenegotiateCiphers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_SendIgnore, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, StartIndex)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_AddTunnel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_RemoveTunnel, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_ClearTunnels, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_KexAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_PublicKeyAlgorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_CompressionAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_CompressionAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_EncryptionAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_EncryptionAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_KexAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_KexAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_MacAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_MacAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_PublicKeyAlgorithms, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_PublicKeyAlgorithms, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_AuthTypePriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_AuthTypePriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_PublicKeyAlgorithmPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_PublicKeyAlgorithmPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_EncryptionAlgorithmPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_EncryptionAlgorithmPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_CompressionAlgorithmPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_CompressionAlgorithmPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_MacAlgorithmPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_MacAlgorithmPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_KexAlgorithmPriorities, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_KexAlgorithmPriorities, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_Tunnels, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_Active, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_CompressionAlgorithmServerToClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_CompressionAlgorithmClientToServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_EncryptionAlgorithmServerToClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_EncryptionAlgorithmClientToServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_MacAlgorithmServerToClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_MacAlgorithmClientToServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_ServerCloseReason, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_ServerSoftwareName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_Version, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_TunnelCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_KbdIntName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_KbdIntInstruction, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_ServerKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_BoundPort, 0, 0, 0)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_UsingIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_TotalBytesSent, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_TotalBytesReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_Address, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_AuthenticationTypes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_AuthenticationTypes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_AutoAdjustCiphers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_AutoAdjustCiphers, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_ClientHostname, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_ClientHostname, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_ClientUsername, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_ClientUsername, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_CompressionLevel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_CompressionLevel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_DestHost, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_DestHost, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_DestPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_DestPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_ForceCompression, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_ForceCompression, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_ForwardedPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_ForwardedPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_ForwardedHost, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_ForwardedHost, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_KeepAlivePeriod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_KeepAlivePeriod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_GlobalKeepAlivePeriod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_GlobalKeepAlivePeriod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_KeyStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_KeyStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSSHCustomKeyStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_Password, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_Password, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_Port, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_Port, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SoftwareName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SoftwareName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SynchronizeGUI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SynchronizeGUI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_Username, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_Username, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_Versions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_Versions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SocketTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SocketTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SessionTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SessionTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_UseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_UseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_DNS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_DNS, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElDNSSettings, 1)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_PortKnock, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_PortKnock, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElPortKnock, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SocksAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SocksAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SocksPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SocksPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SocksPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SocksPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SocksResolveAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SocksResolveAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SocksServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SocksServer, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SocksUseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SocksUseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SocksUserCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SocksUserCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SocksVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SocksVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_UseSocks, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_UseSocks, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_UseWebTunneling, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_UseWebTunneling, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_WebTunnelAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_WebTunnelAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_WebTunnelAuthentication, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_WebTunnelAuthentication, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_WebTunnelPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_WebTunnelPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_WebTunnelPort, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_WebTunnelPort, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_WebTunnelUserId, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_WebTunnelUserId, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_WebTunnelRequestHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SocketSettings, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_Priority, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_Priority, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_Intercept, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_Intercept, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSSHForwardingIntercept, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_CloseIfNoActiveTunnels, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_CloseIfNoActiveTunnels, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_UseUTF8, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_UseUTF8, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_RequestPasswordChange, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_RequestPasswordChange, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_CertAuthMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_CertAuthMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_AutoAdjustPriority, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_AutoAdjustPriority, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_AuthAttempts, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_AuthAttempts, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SSHAuthOrder, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SSHAuthOrder, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_TrustedKeys, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_TrustedKeys, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSSHCustomKeyStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_DefaultWindowSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_DefaultWindowSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_MinWindowSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_MinWindowSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_MaxSSHPacketSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_MaxSSHPacketSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_FlushCachedDataOnClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_FlushCachedDataOnClose, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_IncomingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_IncomingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OutgoingSpeedLimit, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OutgoingSpeedLimit, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_EstablishShellChannel, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_EstablishShellChannel, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_ObfuscateHandshake, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_ObfuscateHandshake, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_ObfuscationPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_ObfuscationPassword, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SocketReadBufSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SocketReadBufSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_SocketWriteBufSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_SocketWriteBufSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_MaxCacheSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_MaxCacheSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_GSSMechanism, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_GSSMechanism, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElGSSBaseMechanism, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_GSSHostName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_GSSHostName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_GSSDelegateCredentials, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_GSSDelegateCredentials, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_InactivityPeriod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_InactivityPeriod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnAuthenticationKeyboard, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnAuthenticationKeyboard, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnAuthenticationFailed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnAuthenticationFailed, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnAuthenticationSuccess, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnAuthenticationSuccess, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnAuthenticationStart, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnAuthenticationStart, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnAuthenticationAttempt, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnAuthenticationAttempt, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnBanner, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnBanner, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnKeyValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnKeyValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnDebugData, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnDebugData, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnPrivateKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnPrivateKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnCiphersNegotiated, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnCiphersNegotiated, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnOpen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnOpen, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnConnectionOpen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnConnectionOpen, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnConnectionClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnConnectionClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnConnectionChange, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnConnectionChange, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnConnectionError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnConnectionError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnConnectionWork, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnConnectionWork, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnTunnelOpen, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnTunnelOpen, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnTunnelClose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnTunnelClose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnPasswordChangeRequest, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnPasswordChangeRequest, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnBeforeConnecting, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnBeforeConnecting, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnKexInitReceived, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnKexInitReceived, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnDNSError, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnDNSError, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnDNSKeyNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnDNSKeyNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnDNSKeyValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnDNSKeyValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_get_OnDNSResolve, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding_set_OnDNSResolve, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHCustomForwarding___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHCustomForwarding_methods[] = {
	PHP_ME(TElSSHCustomForwarding, Open, arginfo_TElSSHCustomForwarding_Open, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, Close, arginfo_TElSSHCustomForwarding_Close, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, RenegotiateCiphers, arginfo_TElSSHCustomForwarding_RenegotiateCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, SendIgnore, arginfo_TElSSHCustomForwarding_SendIgnore, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, AddTunnel, arginfo_TElSSHCustomForwarding_AddTunnel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, RemoveTunnel, arginfo_TElSSHCustomForwarding_RemoveTunnel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, ClearTunnels, arginfo_TElSSHCustomForwarding_ClearTunnels, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_KexAlgorithm, arginfo_TElSSHCustomForwarding_get_KexAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_PublicKeyAlgorithm, arginfo_TElSSHCustomForwarding_get_PublicKeyAlgorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_CompressionAlgorithms, arginfo_TElSSHCustomForwarding_get_CompressionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_CompressionAlgorithms, arginfo_TElSSHCustomForwarding_set_CompressionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_EncryptionAlgorithms, arginfo_TElSSHCustomForwarding_get_EncryptionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_EncryptionAlgorithms, arginfo_TElSSHCustomForwarding_set_EncryptionAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_KexAlgorithms, arginfo_TElSSHCustomForwarding_get_KexAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_KexAlgorithms, arginfo_TElSSHCustomForwarding_set_KexAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_MacAlgorithms, arginfo_TElSSHCustomForwarding_get_MacAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_MacAlgorithms, arginfo_TElSSHCustomForwarding_set_MacAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_PublicKeyAlgorithms, arginfo_TElSSHCustomForwarding_get_PublicKeyAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_PublicKeyAlgorithms, arginfo_TElSSHCustomForwarding_set_PublicKeyAlgorithms, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_AuthTypePriorities, arginfo_TElSSHCustomForwarding_get_AuthTypePriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_AuthTypePriorities, arginfo_TElSSHCustomForwarding_set_AuthTypePriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_PublicKeyAlgorithmPriorities, arginfo_TElSSHCustomForwarding_get_PublicKeyAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_PublicKeyAlgorithmPriorities, arginfo_TElSSHCustomForwarding_set_PublicKeyAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_EncryptionAlgorithmPriorities, arginfo_TElSSHCustomForwarding_get_EncryptionAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_EncryptionAlgorithmPriorities, arginfo_TElSSHCustomForwarding_set_EncryptionAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_CompressionAlgorithmPriorities, arginfo_TElSSHCustomForwarding_get_CompressionAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_CompressionAlgorithmPriorities, arginfo_TElSSHCustomForwarding_set_CompressionAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_MacAlgorithmPriorities, arginfo_TElSSHCustomForwarding_get_MacAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_MacAlgorithmPriorities, arginfo_TElSSHCustomForwarding_set_MacAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_KexAlgorithmPriorities, arginfo_TElSSHCustomForwarding_get_KexAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_KexAlgorithmPriorities, arginfo_TElSSHCustomForwarding_set_KexAlgorithmPriorities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_Tunnels, arginfo_TElSSHCustomForwarding_get_Tunnels, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_Active, arginfo_TElSSHCustomForwarding_get_Active, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_CompressionAlgorithmServerToClient, arginfo_TElSSHCustomForwarding_get_CompressionAlgorithmServerToClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_CompressionAlgorithmClientToServer, arginfo_TElSSHCustomForwarding_get_CompressionAlgorithmClientToServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_EncryptionAlgorithmServerToClient, arginfo_TElSSHCustomForwarding_get_EncryptionAlgorithmServerToClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_EncryptionAlgorithmClientToServer, arginfo_TElSSHCustomForwarding_get_EncryptionAlgorithmClientToServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_MacAlgorithmServerToClient, arginfo_TElSSHCustomForwarding_get_MacAlgorithmServerToClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_MacAlgorithmClientToServer, arginfo_TElSSHCustomForwarding_get_MacAlgorithmClientToServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_ServerCloseReason, arginfo_TElSSHCustomForwarding_get_ServerCloseReason, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_ServerSoftwareName, arginfo_TElSSHCustomForwarding_get_ServerSoftwareName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_Version, arginfo_TElSSHCustomForwarding_get_Version, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_TunnelCount, arginfo_TElSSHCustomForwarding_get_TunnelCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_KbdIntName, arginfo_TElSSHCustomForwarding_get_KbdIntName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_KbdIntInstruction, arginfo_TElSSHCustomForwarding_get_KbdIntInstruction, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_ServerKey, arginfo_TElSSHCustomForwarding_get_ServerKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_BoundPort, arginfo_TElSSHCustomForwarding_get_BoundPort, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSSHCustomForwarding, get_UsingIPv6, arginfo_TElSSHCustomForwarding_get_UsingIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSSHCustomForwarding, get_TotalBytesSent, arginfo_TElSSHCustomForwarding_get_TotalBytesSent, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_TotalBytesReceived, arginfo_TElSSHCustomForwarding_get_TotalBytesReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_Address, arginfo_TElSSHCustomForwarding_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_Address, arginfo_TElSSHCustomForwarding_set_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_AuthenticationTypes, arginfo_TElSSHCustomForwarding_get_AuthenticationTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_AuthenticationTypes, arginfo_TElSSHCustomForwarding_set_AuthenticationTypes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_AutoAdjustCiphers, arginfo_TElSSHCustomForwarding_get_AutoAdjustCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_AutoAdjustCiphers, arginfo_TElSSHCustomForwarding_set_AutoAdjustCiphers, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_ClientHostname, arginfo_TElSSHCustomForwarding_get_ClientHostname, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_ClientHostname, arginfo_TElSSHCustomForwarding_set_ClientHostname, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_ClientUsername, arginfo_TElSSHCustomForwarding_get_ClientUsername, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_ClientUsername, arginfo_TElSSHCustomForwarding_set_ClientUsername, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_CompressionLevel, arginfo_TElSSHCustomForwarding_get_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_CompressionLevel, arginfo_TElSSHCustomForwarding_set_CompressionLevel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_DestHost, arginfo_TElSSHCustomForwarding_get_DestHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_DestHost, arginfo_TElSSHCustomForwarding_set_DestHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_DestPort, arginfo_TElSSHCustomForwarding_get_DestPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_DestPort, arginfo_TElSSHCustomForwarding_set_DestPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_ForceCompression, arginfo_TElSSHCustomForwarding_get_ForceCompression, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_ForceCompression, arginfo_TElSSHCustomForwarding_set_ForceCompression, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_ForwardedPort, arginfo_TElSSHCustomForwarding_get_ForwardedPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_ForwardedPort, arginfo_TElSSHCustomForwarding_set_ForwardedPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_ForwardedHost, arginfo_TElSSHCustomForwarding_get_ForwardedHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_ForwardedHost, arginfo_TElSSHCustomForwarding_set_ForwardedHost, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_KeepAlivePeriod, arginfo_TElSSHCustomForwarding_get_KeepAlivePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_KeepAlivePeriod, arginfo_TElSSHCustomForwarding_set_KeepAlivePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_GlobalKeepAlivePeriod, arginfo_TElSSHCustomForwarding_get_GlobalKeepAlivePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_GlobalKeepAlivePeriod, arginfo_TElSSHCustomForwarding_set_GlobalKeepAlivePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_KeyStorage, arginfo_TElSSHCustomForwarding_get_KeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_KeyStorage, arginfo_TElSSHCustomForwarding_set_KeyStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_Password, arginfo_TElSSHCustomForwarding_get_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_Password, arginfo_TElSSHCustomForwarding_set_Password, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_Port, arginfo_TElSSHCustomForwarding_get_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_Port, arginfo_TElSSHCustomForwarding_set_Port, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SoftwareName, arginfo_TElSSHCustomForwarding_get_SoftwareName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SoftwareName, arginfo_TElSSHCustomForwarding_set_SoftwareName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SynchronizeGUI, arginfo_TElSSHCustomForwarding_get_SynchronizeGUI, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SynchronizeGUI, arginfo_TElSSHCustomForwarding_set_SynchronizeGUI, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_Username, arginfo_TElSSHCustomForwarding_get_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_Username, arginfo_TElSSHCustomForwarding_set_Username, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_Versions, arginfo_TElSSHCustomForwarding_get_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_Versions, arginfo_TElSSHCustomForwarding_set_Versions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SocketTimeout, arginfo_TElSSHCustomForwarding_get_SocketTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SocketTimeout, arginfo_TElSSHCustomForwarding_set_SocketTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SessionTimeout, arginfo_TElSSHCustomForwarding_get_SessionTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SessionTimeout, arginfo_TElSSHCustomForwarding_set_SessionTimeout, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSSHCustomForwarding, get_UseIPv6, arginfo_TElSSHCustomForwarding_get_UseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_UseIPv6, arginfo_TElSSHCustomForwarding_set_UseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_DNS, arginfo_TElSSHCustomForwarding_get_DNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_DNS, arginfo_TElSSHCustomForwarding_set_DNS, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSSHCustomForwarding, get_PortKnock, arginfo_TElSSHCustomForwarding_get_PortKnock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_PortKnock, arginfo_TElSSHCustomForwarding_set_PortKnock, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SocksAuthentication, arginfo_TElSSHCustomForwarding_get_SocksAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SocksAuthentication, arginfo_TElSSHCustomForwarding_set_SocksAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SocksPassword, arginfo_TElSSHCustomForwarding_get_SocksPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SocksPassword, arginfo_TElSSHCustomForwarding_set_SocksPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SocksPort, arginfo_TElSSHCustomForwarding_get_SocksPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SocksPort, arginfo_TElSSHCustomForwarding_set_SocksPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SocksResolveAddress, arginfo_TElSSHCustomForwarding_get_SocksResolveAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SocksResolveAddress, arginfo_TElSSHCustomForwarding_set_SocksResolveAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SocksServer, arginfo_TElSSHCustomForwarding_get_SocksServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SocksServer, arginfo_TElSSHCustomForwarding_set_SocksServer, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSSHCustomForwarding, get_SocksUseIPv6, arginfo_TElSSHCustomForwarding_get_SocksUseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SocksUseIPv6, arginfo_TElSSHCustomForwarding_set_SocksUseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSSHCustomForwarding, get_SocksUserCode, arginfo_TElSSHCustomForwarding_get_SocksUserCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SocksUserCode, arginfo_TElSSHCustomForwarding_set_SocksUserCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SocksVersion, arginfo_TElSSHCustomForwarding_get_SocksVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SocksVersion, arginfo_TElSSHCustomForwarding_set_SocksVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_UseSocks, arginfo_TElSSHCustomForwarding_get_UseSocks, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_UseSocks, arginfo_TElSSHCustomForwarding_set_UseSocks, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_UseWebTunneling, arginfo_TElSSHCustomForwarding_get_UseWebTunneling, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_UseWebTunneling, arginfo_TElSSHCustomForwarding_set_UseWebTunneling, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_WebTunnelAddress, arginfo_TElSSHCustomForwarding_get_WebTunnelAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_WebTunnelAddress, arginfo_TElSSHCustomForwarding_set_WebTunnelAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_WebTunnelAuthentication, arginfo_TElSSHCustomForwarding_get_WebTunnelAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_WebTunnelAuthentication, arginfo_TElSSHCustomForwarding_set_WebTunnelAuthentication, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_WebTunnelPassword, arginfo_TElSSHCustomForwarding_get_WebTunnelPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_WebTunnelPassword, arginfo_TElSSHCustomForwarding_set_WebTunnelPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_WebTunnelPort, arginfo_TElSSHCustomForwarding_get_WebTunnelPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_WebTunnelPort, arginfo_TElSSHCustomForwarding_set_WebTunnelPort, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_WebTunnelUserId, arginfo_TElSSHCustomForwarding_get_WebTunnelUserId, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_WebTunnelUserId, arginfo_TElSSHCustomForwarding_set_WebTunnelUserId, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_WebTunnelRequestHeaders, arginfo_TElSSHCustomForwarding_get_WebTunnelRequestHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SocketSettings, arginfo_TElSSHCustomForwarding_get_SocketSettings, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_Priority, arginfo_TElSSHCustomForwarding_get_Priority, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_Priority, arginfo_TElSSHCustomForwarding_set_Priority, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_Intercept, arginfo_TElSSHCustomForwarding_get_Intercept, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_Intercept, arginfo_TElSSHCustomForwarding_set_Intercept, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_CloseIfNoActiveTunnels, arginfo_TElSSHCustomForwarding_get_CloseIfNoActiveTunnels, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_CloseIfNoActiveTunnels, arginfo_TElSSHCustomForwarding_set_CloseIfNoActiveTunnels, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_UseUTF8, arginfo_TElSSHCustomForwarding_get_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_UseUTF8, arginfo_TElSSHCustomForwarding_set_UseUTF8, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_RequestPasswordChange, arginfo_TElSSHCustomForwarding_get_RequestPasswordChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_RequestPasswordChange, arginfo_TElSSHCustomForwarding_set_RequestPasswordChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_CertAuthMode, arginfo_TElSSHCustomForwarding_get_CertAuthMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_CertAuthMode, arginfo_TElSSHCustomForwarding_set_CertAuthMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_AutoAdjustPriority, arginfo_TElSSHCustomForwarding_get_AutoAdjustPriority, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_AutoAdjustPriority, arginfo_TElSSHCustomForwarding_set_AutoAdjustPriority, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_AuthAttempts, arginfo_TElSSHCustomForwarding_get_AuthAttempts, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_AuthAttempts, arginfo_TElSSHCustomForwarding_set_AuthAttempts, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SSHAuthOrder, arginfo_TElSSHCustomForwarding_get_SSHAuthOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SSHAuthOrder, arginfo_TElSSHCustomForwarding_set_SSHAuthOrder, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_TrustedKeys, arginfo_TElSSHCustomForwarding_get_TrustedKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_TrustedKeys, arginfo_TElSSHCustomForwarding_set_TrustedKeys, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_CryptoProviderManager, arginfo_TElSSHCustomForwarding_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_CryptoProviderManager, arginfo_TElSSHCustomForwarding_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_DefaultWindowSize, arginfo_TElSSHCustomForwarding_get_DefaultWindowSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_DefaultWindowSize, arginfo_TElSSHCustomForwarding_set_DefaultWindowSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_MinWindowSize, arginfo_TElSSHCustomForwarding_get_MinWindowSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_MinWindowSize, arginfo_TElSSHCustomForwarding_set_MinWindowSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_MaxSSHPacketSize, arginfo_TElSSHCustomForwarding_get_MaxSSHPacketSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_MaxSSHPacketSize, arginfo_TElSSHCustomForwarding_set_MaxSSHPacketSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_FlushCachedDataOnClose, arginfo_TElSSHCustomForwarding_get_FlushCachedDataOnClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_FlushCachedDataOnClose, arginfo_TElSSHCustomForwarding_set_FlushCachedDataOnClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_IncomingSpeedLimit, arginfo_TElSSHCustomForwarding_get_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_IncomingSpeedLimit, arginfo_TElSSHCustomForwarding_set_IncomingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OutgoingSpeedLimit, arginfo_TElSSHCustomForwarding_get_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OutgoingSpeedLimit, arginfo_TElSSHCustomForwarding_set_OutgoingSpeedLimit, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_EstablishShellChannel, arginfo_TElSSHCustomForwarding_get_EstablishShellChannel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_EstablishShellChannel, arginfo_TElSSHCustomForwarding_set_EstablishShellChannel, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_ObfuscateHandshake, arginfo_TElSSHCustomForwarding_get_ObfuscateHandshake, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_ObfuscateHandshake, arginfo_TElSSHCustomForwarding_set_ObfuscateHandshake, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_ObfuscationPassword, arginfo_TElSSHCustomForwarding_get_ObfuscationPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_ObfuscationPassword, arginfo_TElSSHCustomForwarding_set_ObfuscationPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SocketReadBufSize, arginfo_TElSSHCustomForwarding_get_SocketReadBufSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SocketReadBufSize, arginfo_TElSSHCustomForwarding_set_SocketReadBufSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_SocketWriteBufSize, arginfo_TElSSHCustomForwarding_get_SocketWriteBufSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_SocketWriteBufSize, arginfo_TElSSHCustomForwarding_set_SocketWriteBufSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_MaxCacheSize, arginfo_TElSSHCustomForwarding_get_MaxCacheSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_MaxCacheSize, arginfo_TElSSHCustomForwarding_set_MaxCacheSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_GSSMechanism, arginfo_TElSSHCustomForwarding_get_GSSMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_GSSMechanism, arginfo_TElSSHCustomForwarding_set_GSSMechanism, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_GSSHostName, arginfo_TElSSHCustomForwarding_get_GSSHostName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_GSSHostName, arginfo_TElSSHCustomForwarding_set_GSSHostName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_GSSDelegateCredentials, arginfo_TElSSHCustomForwarding_get_GSSDelegateCredentials, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_GSSDelegateCredentials, arginfo_TElSSHCustomForwarding_set_GSSDelegateCredentials, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_InactivityPeriod, arginfo_TElSSHCustomForwarding_get_InactivityPeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_InactivityPeriod, arginfo_TElSSHCustomForwarding_set_InactivityPeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnAuthenticationKeyboard, arginfo_TElSSHCustomForwarding_get_OnAuthenticationKeyboard, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnAuthenticationKeyboard, arginfo_TElSSHCustomForwarding_set_OnAuthenticationKeyboard, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnAuthenticationFailed, arginfo_TElSSHCustomForwarding_get_OnAuthenticationFailed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnAuthenticationFailed, arginfo_TElSSHCustomForwarding_set_OnAuthenticationFailed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnAuthenticationSuccess, arginfo_TElSSHCustomForwarding_get_OnAuthenticationSuccess, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnAuthenticationSuccess, arginfo_TElSSHCustomForwarding_set_OnAuthenticationSuccess, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnAuthenticationStart, arginfo_TElSSHCustomForwarding_get_OnAuthenticationStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnAuthenticationStart, arginfo_TElSSHCustomForwarding_set_OnAuthenticationStart, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnAuthenticationAttempt, arginfo_TElSSHCustomForwarding_get_OnAuthenticationAttempt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnAuthenticationAttempt, arginfo_TElSSHCustomForwarding_set_OnAuthenticationAttempt, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnBanner, arginfo_TElSSHCustomForwarding_get_OnBanner, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnBanner, arginfo_TElSSHCustomForwarding_set_OnBanner, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnError, arginfo_TElSSHCustomForwarding_get_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnError, arginfo_TElSSHCustomForwarding_set_OnError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnKeyValidate, arginfo_TElSSHCustomForwarding_get_OnKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnKeyValidate, arginfo_TElSSHCustomForwarding_set_OnKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnDebugData, arginfo_TElSSHCustomForwarding_get_OnDebugData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnDebugData, arginfo_TElSSHCustomForwarding_set_OnDebugData, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnPrivateKeyNeeded, arginfo_TElSSHCustomForwarding_get_OnPrivateKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnPrivateKeyNeeded, arginfo_TElSSHCustomForwarding_set_OnPrivateKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnCiphersNegotiated, arginfo_TElSSHCustomForwarding_get_OnCiphersNegotiated, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnCiphersNegotiated, arginfo_TElSSHCustomForwarding_set_OnCiphersNegotiated, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnOpen, arginfo_TElSSHCustomForwarding_get_OnOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnOpen, arginfo_TElSSHCustomForwarding_set_OnOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnClose, arginfo_TElSSHCustomForwarding_get_OnClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnClose, arginfo_TElSSHCustomForwarding_set_OnClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnConnectionOpen, arginfo_TElSSHCustomForwarding_get_OnConnectionOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnConnectionOpen, arginfo_TElSSHCustomForwarding_set_OnConnectionOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnConnectionClose, arginfo_TElSSHCustomForwarding_get_OnConnectionClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnConnectionClose, arginfo_TElSSHCustomForwarding_set_OnConnectionClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnConnectionChange, arginfo_TElSSHCustomForwarding_get_OnConnectionChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnConnectionChange, arginfo_TElSSHCustomForwarding_set_OnConnectionChange, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnConnectionError, arginfo_TElSSHCustomForwarding_get_OnConnectionError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnConnectionError, arginfo_TElSSHCustomForwarding_set_OnConnectionError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnConnectionWork, arginfo_TElSSHCustomForwarding_get_OnConnectionWork, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnConnectionWork, arginfo_TElSSHCustomForwarding_set_OnConnectionWork, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnTunnelOpen, arginfo_TElSSHCustomForwarding_get_OnTunnelOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnTunnelOpen, arginfo_TElSSHCustomForwarding_set_OnTunnelOpen, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnTunnelClose, arginfo_TElSSHCustomForwarding_get_OnTunnelClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnTunnelClose, arginfo_TElSSHCustomForwarding_set_OnTunnelClose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnPasswordChangeRequest, arginfo_TElSSHCustomForwarding_get_OnPasswordChangeRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnPasswordChangeRequest, arginfo_TElSSHCustomForwarding_set_OnPasswordChangeRequest, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnBeforeConnecting, arginfo_TElSSHCustomForwarding_get_OnBeforeConnecting, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnBeforeConnecting, arginfo_TElSSHCustomForwarding_set_OnBeforeConnecting, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnKexInitReceived, arginfo_TElSSHCustomForwarding_get_OnKexInitReceived, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnKexInitReceived, arginfo_TElSSHCustomForwarding_set_OnKexInitReceived, ZEND_ACC_PUBLIC)
#ifdef SB_WINDOWS
	PHP_ME(TElSSHCustomForwarding, get_OnDNSError, arginfo_TElSSHCustomForwarding_get_OnDNSError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnDNSError, arginfo_TElSSHCustomForwarding_set_OnDNSError, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnDNSKeyNeeded, arginfo_TElSSHCustomForwarding_get_OnDNSKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnDNSKeyNeeded, arginfo_TElSSHCustomForwarding_set_OnDNSKeyNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnDNSKeyValidate, arginfo_TElSSHCustomForwarding_get_OnDNSKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnDNSKeyValidate, arginfo_TElSSHCustomForwarding_set_OnDNSKeyValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, get_OnDNSResolve, arginfo_TElSSHCustomForwarding_get_OnDNSResolve, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHCustomForwarding, set_OnDNSResolve, arginfo_TElSSHCustomForwarding_set_OnDNSResolve, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSSHCustomForwarding, __construct, arginfo_TElSSHCustomForwarding___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHCustomForwarding(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHCustomForwarding_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHCustomForwarding", TElSSHCustomForwarding_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElSSHCustomForwarding_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHForwardingIntercept_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHForwardingIntercept, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHForwardingIntercept_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHForwardingIntercept___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHForwardingIntercept_methods[] = {
	PHP_ME(TElSSHForwardingIntercept, __construct, arginfo_TElSSHForwardingIntercept___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHForwardingIntercept(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHForwardingIntercept_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHForwardingIntercept", TElSSHForwardingIntercept_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElSSHForwardingIntercept_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHLocalPortForwarding_ce_ptr = NULL;

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSSHLocalPortForwarding, get_ForwardedUsingIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHLocalPortForwarding_get_ForwardedUsingIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, get_ForwardedUseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHLocalPortForwarding_get_ForwardedUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, set_ForwardedUseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHLocalPortForwarding_set_ForwardedUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSSHLocalPortForwarding, get_ReportRealClientLocationToServer)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHLocalPortForwarding_get_ReportRealClientLocationToServer(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, set_ReportRealClientLocationToServer)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHLocalPortForwarding_set_ReportRealClientLocationToServer(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, get_UseDynamicForwarding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHLocalPortForwarding_get_UseDynamicForwarding(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, set_UseDynamicForwarding)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHLocalPortForwarding_set_UseDynamicForwarding(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, get_ResolveDynamicForwardingAddresses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHLocalPortForwarding_get_ResolveDynamicForwardingAddresses(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, set_ResolveDynamicForwardingAddresses)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHLocalPortForwarding_set_ResolveDynamicForwardingAddresses(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, get_OnAccept)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHSocketAcceptEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHLocalPortForwarding_get_OnAccept(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, set_OnAccept)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHLocalPortForwarding_set_OnAccept(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHSocketAcceptEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHSocketAcceptEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, get_OnConnectionSocksAuthMethodChoose)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHSocksAuthMethodChooseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHLocalPortForwarding_get_OnConnectionSocksAuthMethodChoose(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, set_OnConnectionSocksAuthMethodChoose)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHLocalPortForwarding_set_OnConnectionSocksAuthMethodChoose(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHSocksAuthMethodChooseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHSocksAuthMethodChooseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, get_OnConnectionSocksAuthPassword)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHSocksAuthPasswordEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHLocalPortForwarding_get_OnConnectionSocksAuthPassword(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, set_OnConnectionSocksAuthPassword)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHLocalPortForwarding_set_OnConnectionSocksAuthPassword(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHSocksAuthPasswordEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHSocksAuthPasswordEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, get_OnConnectionSocksConnect)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHSocksConnectEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHLocalPortForwarding_get_OnConnectionSocksConnect(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, set_OnConnectionSocksConnect)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHLocalPortForwarding_set_OnConnectionSocksConnect(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHSocksConnectEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHSocksConnectEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLocalPortForwarding, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHLocalPortForwarding_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_get_ForwardedUsingIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_get_ForwardedUseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_set_ForwardedUseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_get_ReportRealClientLocationToServer, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_set_ReportRealClientLocationToServer, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_get_UseDynamicForwarding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_set_UseDynamicForwarding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_get_ResolveDynamicForwardingAddresses, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_set_ResolveDynamicForwardingAddresses, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_get_OnAccept, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_set_OnAccept, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_get_OnConnectionSocksAuthMethodChoose, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_set_OnConnectionSocksAuthMethodChoose, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_get_OnConnectionSocksAuthPassword, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_set_OnConnectionSocksAuthPassword, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_get_OnConnectionSocksConnect, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding_set_OnConnectionSocksConnect, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwarding___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHLocalPortForwarding_methods[] = {
#ifdef SB_WINDOWS
	PHP_ME(TElSSHLocalPortForwarding, get_ForwardedUsingIPv6, arginfo_TElSSHLocalPortForwarding_get_ForwardedUsingIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, get_ForwardedUseIPv6, arginfo_TElSSHLocalPortForwarding_get_ForwardedUseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, set_ForwardedUseIPv6, arginfo_TElSSHLocalPortForwarding_set_ForwardedUseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSSHLocalPortForwarding, get_ReportRealClientLocationToServer, arginfo_TElSSHLocalPortForwarding_get_ReportRealClientLocationToServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, set_ReportRealClientLocationToServer, arginfo_TElSSHLocalPortForwarding_set_ReportRealClientLocationToServer, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, get_UseDynamicForwarding, arginfo_TElSSHLocalPortForwarding_get_UseDynamicForwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, set_UseDynamicForwarding, arginfo_TElSSHLocalPortForwarding_set_UseDynamicForwarding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, get_ResolveDynamicForwardingAddresses, arginfo_TElSSHLocalPortForwarding_get_ResolveDynamicForwardingAddresses, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, set_ResolveDynamicForwardingAddresses, arginfo_TElSSHLocalPortForwarding_set_ResolveDynamicForwardingAddresses, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, get_OnAccept, arginfo_TElSSHLocalPortForwarding_get_OnAccept, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, set_OnAccept, arginfo_TElSSHLocalPortForwarding_set_OnAccept, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, get_OnConnectionSocksAuthMethodChoose, arginfo_TElSSHLocalPortForwarding_get_OnConnectionSocksAuthMethodChoose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, set_OnConnectionSocksAuthMethodChoose, arginfo_TElSSHLocalPortForwarding_set_OnConnectionSocksAuthMethodChoose, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, get_OnConnectionSocksAuthPassword, arginfo_TElSSHLocalPortForwarding_get_OnConnectionSocksAuthPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, set_OnConnectionSocksAuthPassword, arginfo_TElSSHLocalPortForwarding_set_OnConnectionSocksAuthPassword, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, get_OnConnectionSocksConnect, arginfo_TElSSHLocalPortForwarding_get_OnConnectionSocksConnect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, set_OnConnectionSocksConnect, arginfo_TElSSHLocalPortForwarding_set_OnConnectionSocksConnect, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLocalPortForwarding, __construct, arginfo_TElSSHLocalPortForwarding___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHLocalPortForwarding(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHLocalPortForwarding_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHLocalPortForwarding", TElSSHLocalPortForwarding_methods);
	if (NULL == TElSSHCustomForwarding_ce_ptr)
		Register_TElSSHCustomForwarding(TSRMLS_C);
	TElSSHLocalPortForwarding_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHCustomForwarding_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHRemotePortForwarding_ce_ptr = NULL;

#ifdef SB_WINDOWS
SB_PHP_METHOD(TElSSHRemotePortForwarding, get_DestUsingIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHRemotePortForwarding_get_DestUsingIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHRemotePortForwarding, get_DestUseDNS)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHRemotePortForwarding_get_DestUseDNS(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHRemotePortForwarding, set_DestUseDNS)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHRemotePortForwarding_set_DestUseDNS(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHRemotePortForwarding, get_DestUseIPv6)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHRemotePortForwarding_get_DestUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHRemotePortForwarding, set_DestUseIPv6)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHRemotePortForwarding_set_DestUseIPv6(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}
#endif

SB_PHP_METHOD(TElSSHRemotePortForwarding, get_UseDefaultBindAddress)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHRemotePortForwarding_get_UseDefaultBindAddress(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHRemotePortForwarding, set_UseDefaultBindAddress)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHRemotePortForwarding_set_UseDefaultBindAddress(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHRemotePortForwarding, get_UseProxySettingsForForwardedConnections)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSSHRemotePortForwarding_get_UseProxySettingsForForwardedConnections(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHRemotePortForwarding, set_UseProxySettingsForForwardedConnections)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSSHRemotePortForwarding_set_UseProxySettingsForForwardedConnections(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHRemotePortForwarding, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHRemotePortForwarding_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHRemotePortForwarding_get_DestUsingIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHRemotePortForwarding_get_DestUseDNS, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHRemotePortForwarding_set_DestUseDNS, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHRemotePortForwarding_get_DestUseIPv6, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHRemotePortForwarding_set_DestUseIPv6, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()
#endif

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHRemotePortForwarding_get_UseDefaultBindAddress, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHRemotePortForwarding_set_UseDefaultBindAddress, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHRemotePortForwarding_get_UseProxySettingsForForwardedConnections, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHRemotePortForwarding_set_UseProxySettingsForForwardedConnections, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHRemotePortForwarding___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHRemotePortForwarding_methods[] = {
#ifdef SB_WINDOWS
	PHP_ME(TElSSHRemotePortForwarding, get_DestUsingIPv6, arginfo_TElSSHRemotePortForwarding_get_DestUsingIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHRemotePortForwarding, get_DestUseDNS, arginfo_TElSSHRemotePortForwarding_get_DestUseDNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHRemotePortForwarding, set_DestUseDNS, arginfo_TElSSHRemotePortForwarding_set_DestUseDNS, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHRemotePortForwarding, get_DestUseIPv6, arginfo_TElSSHRemotePortForwarding_get_DestUseIPv6, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHRemotePortForwarding, set_DestUseIPv6, arginfo_TElSSHRemotePortForwarding_set_DestUseIPv6, ZEND_ACC_PUBLIC)
#endif
	PHP_ME(TElSSHRemotePortForwarding, get_UseDefaultBindAddress, arginfo_TElSSHRemotePortForwarding_get_UseDefaultBindAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHRemotePortForwarding, set_UseDefaultBindAddress, arginfo_TElSSHRemotePortForwarding_set_UseDefaultBindAddress, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHRemotePortForwarding, get_UseProxySettingsForForwardedConnections, arginfo_TElSSHRemotePortForwarding_get_UseProxySettingsForForwardedConnections, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHRemotePortForwarding, set_UseProxySettingsForForwardedConnections, arginfo_TElSSHRemotePortForwarding_set_UseProxySettingsForForwardedConnections, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHRemotePortForwarding, __construct, arginfo_TElSSHRemotePortForwarding___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHRemotePortForwarding(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHRemotePortForwarding_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHRemotePortForwarding", TElSSHRemotePortForwarding_methods);
	if (NULL == TElSSHCustomForwarding_ce_ptr)
		Register_TElSSHCustomForwarding(TSRMLS_C);
	TElSSHRemotePortForwarding_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHCustomForwarding_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHTunnelState_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHTunnelState, __construct)
{
	zval *oTunnel;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTunnel, TElSSHForwardingTunnel_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHTunnelState_Create(SBGetObjectHandle(oTunnel TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHForwardingTunnel)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHTunnelState___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tunnel, TElSSHForwardingTunnel, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHTunnelState_methods[] = {
	PHP_ME(TElSSHTunnelState, __construct, arginfo_TElSSHTunnelState___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHTunnelState(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHTunnelState_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHTunnelState", TElSSHTunnelState_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSSHTunnelState_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHLPFListeningThread_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHLPFListeningThread, get_OnAccept)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSSHLPFAcceptEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHLPFListeningThread_get_OnAccept(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLPFListeningThread, set_OnAccept)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHLPFListeningThread_set_OnAccept(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBSSHLPFAcceptEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBSSHLPFAcceptEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLPFListeningThread, get_OnListeningStarted)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TNotifyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElSSHLPFListeningThread_get_OnListeningStarted(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLPFListeningThread, set_OnListeningStarted)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElSSHLPFListeningThread_set_OnListeningStarted(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TNotifyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TNotifyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSSHLPFListeningThread, __construct)
{
	char *sAddress;
	int sAddress_len;
	long l4Port;
#ifdef SB_WINDOWS
	zend_bool bUseIPv6;
#endif
	zval *oOwner;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slb", &oOwner, TElSSHForwardingSession_ce_ptr, &sAddress, &sAddress_len, &l4Port, &bUseIPv6) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oOwner, TElSSHForwardingSession_ce_ptr, &sAddress, &sAddress_len, &l4Port) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
#ifdef SB_WINDOWS
		SBCheckError(TElSSHLPFListeningThread_Create(SBGetObjectHandle(oOwner TSRMLS_CC), sAddress, (int32_t)sAddress_len, (int32_t)l4Port, (int8_t)bUseIPv6, &hoOutResult) TSRMLS_CC);
#else
		SBCheckError(TElSSHLPFListeningThread_Create(SBGetObjectHandle(oOwner TSRMLS_CC), sAddress, (int32_t)sAddress_len, (int32_t)l4Port, &hoOutResult) TSRMLS_CC);
#endif
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TElSSHForwardingSession, string, integer, bool)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElSSHForwardingSession, string, integer)" TSRMLS_CC);
#endif
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLPFListeningThread_get_OnAccept, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLPFListeningThread_set_OnAccept, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLPFListeningThread_get_OnListeningStarted, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLPFListeningThread_set_OnListeningStarted, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

#ifdef SB_WINDOWS
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLPFListeningThread___construct, 0, 0, 4)
#else
ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLPFListeningThread___construct, 0, 0, 3)
#endif
	ZEND_ARG_OBJ_INFO(0, Owner, TElSSHForwardingSession, 1)
	ZEND_ARG_INFO(0, Address)
	ZEND_ARG_INFO(0, Port)
#ifdef SB_WINDOWS
	ZEND_ARG_INFO(0, UseIPv6)
#endif
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHLPFListeningThread_methods[] = {
	PHP_ME(TElSSHLPFListeningThread, get_OnAccept, arginfo_TElSSHLPFListeningThread_get_OnAccept, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLPFListeningThread, set_OnAccept, arginfo_TElSSHLPFListeningThread_set_OnAccept, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLPFListeningThread, get_OnListeningStarted, arginfo_TElSSHLPFListeningThread_get_OnListeningStarted, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLPFListeningThread, set_OnListeningStarted, arginfo_TElSSHLPFListeningThread_set_OnListeningStarted, ZEND_ACC_PUBLIC)
	PHP_ME(TElSSHLPFListeningThread, __construct, arginfo_TElSSHLPFListeningThread___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHLPFListeningThread(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHLPFListeningThread_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHLPFListeningThread", TElSSHLPFListeningThread_methods);
	if (NULL == TThread_ce_ptr)
		Register_TThread(TSRMLS_C);
	TElSSHLPFListeningThread_ce_ptr = zend_register_internal_class_ex(&ce, TThread_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHLocalTunnelState_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHLocalTunnelState, __construct)
{
	zval *oTunnel;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTunnel, TElSSHForwardingTunnel_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHLocalTunnelState_Create(SBGetObjectHandle(oTunnel TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHForwardingTunnel)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalTunnelState___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tunnel, TElSSHForwardingTunnel, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHLocalTunnelState_methods[] = {
	PHP_ME(TElSSHLocalTunnelState, __construct, arginfo_TElSSHLocalTunnelState___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHLocalTunnelState(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHLocalTunnelState_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHLocalTunnelState", TElSSHLocalTunnelState_methods);
	if (NULL == TElSSHTunnelState_ce_ptr)
		Register_TElSSHTunnelState(TSRMLS_C);
	TElSSHLocalTunnelState_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHTunnelState_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHRemoteTunnelState_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHRemoteTunnelState, __construct)
{
	zval *oTunnel;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oTunnel, TElSSHForwardingTunnel_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHRemoteTunnelState_Create(SBGetObjectHandle(oTunnel TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHForwardingTunnel)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHRemoteTunnelState___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Tunnel, TElSSHForwardingTunnel, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHRemoteTunnelState_methods[] = {
	PHP_ME(TElSSHRemoteTunnelState, __construct, arginfo_TElSSHRemoteTunnelState___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHRemoteTunnelState(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHRemoteTunnelState_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHRemoteTunnelState", TElSSHRemoteTunnelState_methods);
	if (NULL == TElSSHTunnelState_ce_ptr)
		Register_TElSSHTunnelState(TSRMLS_C);
	TElSSHRemoteTunnelState_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHTunnelState_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHLocalPortForwardingSession_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHLocalPortForwardingSession, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElSSHCustomForwarding_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHLocalPortForwardingSession_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHCustomForwarding)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHLocalPortForwardingSession___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElSSHCustomForwarding, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHLocalPortForwardingSession_methods[] = {
	PHP_ME(TElSSHLocalPortForwardingSession, __construct, arginfo_TElSSHLocalPortForwardingSession___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHLocalPortForwardingSession(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHLocalPortForwardingSession_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHLocalPortForwardingSession", TElSSHLocalPortForwardingSession_methods);
	if (NULL == TElSSHForwardingSession_ce_ptr)
		Register_TElSSHForwardingSession(TSRMLS_C);
	TElSSHLocalPortForwardingSession_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHForwardingSession_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHRemotePortForwardingSession_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHRemotePortForwardingSession, __construct)
{
	zval *oOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOwner, TElSSHCustomForwarding_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSSHRemotePortForwardingSession_Create(SBGetObjectHandle(oOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSSHCustomForwarding)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHRemotePortForwardingSession___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Owner, TElSSHCustomForwarding, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHRemotePortForwardingSession_methods[] = {
	PHP_ME(TElSSHRemotePortForwardingSession, __construct, arginfo_TElSSHRemotePortForwardingSession___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHRemotePortForwardingSession(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHRemotePortForwardingSession_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHRemotePortForwardingSession", TElSSHRemotePortForwardingSession_methods);
	if (NULL == TElSSHForwardingSession_ce_ptr)
		Register_TElSSHForwardingSession(TSRMLS_C);
	TElSSHRemotePortForwardingSession_ce_ptr = zend_register_internal_class_ex(&ce, TElSSHForwardingSession_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSSHScheduledSpecialMessage_ce_ptr = NULL;

SB_PHP_METHOD(TElSSHScheduledSpecialMessage, __construct)
{
	long l4Code;
	long l4Count;
	long l4StartIndex;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzll", &l4Code, &zaBuffer, &l4StartIndex, &l4Count) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		TElClassHandle hoOutResult = NULL;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSSHScheduledSpecialMessage_Create((int32_t)l4Code, aiBuffer.data, aiBuffer.len, (int32_t)l4StartIndex, (int32_t)l4Count, &hoOutResult) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSSHScheduledSpecialMessage___construct, 0, 0, 4)
	ZEND_ARG_INFO(0, Code)
	ZEND_ARG_TYPE_INFO(0, Buffer, 0, 1)
	ZEND_ARG_INFO(0, StartIndex)
	ZEND_ARG_INFO(0, Count)
ZEND_END_ARG_INFO()

static zend_function_entry TElSSHScheduledSpecialMessage_methods[] = {
	PHP_ME(TElSSHScheduledSpecialMessage, __construct, arginfo_TElSSHScheduledSpecialMessage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSSHScheduledSpecialMessage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSSHScheduledSpecialMessage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSSHScheduledSpecialMessage", TElSSHScheduledSpecialMessage_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSSHScheduledSpecialMessage_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBSSHForwarding_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_LONG_CONSTANT(SBSSHForwarding, ERROR_SSH_TCP_CONNECTION_FAILED, SB_ERROR_SSH_TCP_CONNECTION_FAILED, SB_ERROR_SSH_TCP_CONNECTION_FAILED);
	SB_REGISTER_LONG_CONSTANT(SBSSHForwarding, ERROR_SSH_TCP_BIND_FAILED, SB_ERROR_SSH_TCP_BIND_FAILED, SB_ERROR_SSH_TCP_BIND_FAILED);
}

void Register_SBSSHForwarding_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBSSHForwardingPriority", NULL);
	TSBSSHForwardingPriority_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSSHForwardingPriority_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHForwardingPriority_ce_ptr, "sfpLow", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHForwardingPriority_ce_ptr, "sfpNormal", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHForwardingPriority_ce_ptr, "sfpHigh", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBSSHForwardingSocketState", NULL);
	TSBSSHForwardingSocketState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSSHForwardingSocketState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHForwardingSocketState_ce_ptr, "fssEstablishing", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHForwardingSocketState_ce_ptr, "fssActive", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHForwardingSocketState_ce_ptr, "fssClosing", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHForwardingSocketState_ce_ptr, "fssClosed", 3)
	
	INIT_CLASS_ENTRY(ce, "TSBSSHForwardingChannelState", NULL);
	TSBSSHForwardingChannelState_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSSHForwardingChannelState_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHForwardingChannelState_ce_ptr, "fcsEstablishing", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHForwardingChannelState_ce_ptr, "fcsActive", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHForwardingChannelState_ce_ptr, "fcsClosing", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBSSHForwardingChannelState_ce_ptr, "fcsClosed", 3)
}

void Register_SBSSHForwarding_Aliases(TSRMLS_D)
{
	if (NULL == TElSSHForwardedConnection_ce_ptr)
		Register_TElSSHForwardedConnection(TSRMLS_C);
	zend_register_class_alias("ElSSHForwardedConnection", TElSSHForwardedConnection_ce_ptr);
	if (NULL == TElSSHForwardingSession_ce_ptr)
		Register_TElSSHForwardingSession(TSRMLS_C);
	zend_register_class_alias("ElSSHForwardingSession", TElSSHForwardingSession_ce_ptr);
	if (NULL == TElSSHCustomForwarding_ce_ptr)
		Register_TElSSHCustomForwarding(TSRMLS_C);
	zend_register_class_alias("ElSSHCustomForwarding", TElSSHCustomForwarding_ce_ptr);
	if (NULL == TElSSHLocalPortForwarding_ce_ptr)
		Register_TElSSHLocalPortForwarding(TSRMLS_C);
	zend_register_class_alias("ElSSHLocalPortForwarding", TElSSHLocalPortForwarding_ce_ptr);
	if (NULL == TElSSHRemotePortForwarding_ce_ptr)
		Register_TElSSHRemotePortForwarding(TSRMLS_C);
	zend_register_class_alias("ElSSHRemotePortForwarding", TElSSHRemotePortForwarding_ce_ptr);
	if (NULL == TElSSHLocalPortForwardingSession_ce_ptr)
		Register_TElSSHLocalPortForwardingSession(TSRMLS_C);
	zend_register_class_alias("ElSSHLocalPortForwardingSession", TElSSHLocalPortForwardingSession_ce_ptr);
	if (NULL == TElSSHRemotePortForwardingSession_ce_ptr)
		Register_TElSSHRemotePortForwardingSession(TSRMLS_C);
	zend_register_class_alias("ElSSHRemotePortForwardingSession", TElSSHRemotePortForwardingSession_ce_ptr);
}
