#include "sbutils.h"

void SB_CALLBACK TSBTextDataEventRaw(void * _ObjectData, TObjectHandle Sender, const uint8_t pTextLine[], int32_t szTextLine)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zTextLine;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zTextLine);
	ZVAL_STRINGL(zTextLine, pTextLine, szTextLine, 1);

	params[0] = &zSender;
	params[1] = &zTextLine;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zTextLine);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBProgressEventRaw(void * _ObjectData, TObjectHandle Sender, int64_t Total, int64_t Current, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zSender;
	zval * zTotal;
	zval * zCurrent;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zTotal);
	ZVAL_LONG(zTotal, (long)Total);
	MAKE_STD_ZVAL(zCurrent);
	ZVAL_LONG(zCurrent, (long)Current);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zSender;
	params[1] = &zTotal;
	params[2] = &zCurrent;
	params[3] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zTotal);
	zval_ptr_dtor(&zCurrent);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBProgressFuncRaw(void * _ObjectData, int64_t Total, int64_t Current, void * Data, int8_t * Cancel)
{
	zval *retval_ptr;
	zval **params[4];
	zval * zTotal;
	zval * zCurrent;
	zval * zData;
	zval * zCancel;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zTotal);
	ZVAL_LONG(zTotal, (long)Total);
	MAKE_STD_ZVAL(zCurrent);
	ZVAL_LONG(zCurrent, (long)Current);
	MAKE_STD_ZVAL(zData);
	SBInitPointerObject(zData, Data TSRMLS_CC);
	MAKE_STD_ZVAL(zCancel);
	ZVAL_BOOL(zCancel, (zend_bool)*Cancel);

	params[0] = &zTotal;
	params[1] = &zCurrent;
	params[2] = &zData;
	params[3] = &zCancel;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 4, params TSRMLS_CC);

	zval_ptr_dtor(&zTotal);
	zval_ptr_dtor(&zCurrent);
	zval_ptr_dtor(&zData);
	*Cancel = (int8_t)Z_BVAL_P(zCancel);
	zval_ptr_dtor(&zCancel);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TElMessageLoopEventRaw(void * _ObjectData, int8_t * OutResult)
{
	zval * pzOutResult = NULL;
	TSRMLS_FETCH();

	SBCallEvent((zval *)_ObjectData, &pzOutResult, 0, NULL TSRMLS_CC);

	if (pzOutResult)
	{
		*OutResult = (int8_t)Z_BVAL_P(pzOutResult);
		zval_ptr_dtor(&pzOutResult);
	}
}

zend_class_entry *TSBLicenseType_ce_ptr = NULL;

zend_class_entry *TSBLicenseTypes_ce_ptr = NULL;

zend_class_entry *TSBExceptionHandlerDestination_ce_ptr = NULL;

#ifndef SB_WINDOWS
zend_class_entry *TElStringList_ce_ptr = NULL;

SB_PHP_METHOD(TElStringList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElStringList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStringList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElStringList_methods[] = {
	PHP_ME(TElStringList, __construct, arginfo_TElStringList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElStringList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElStringList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElStringList", TElStringList_methods);
	if (NULL == TStringList_ce_ptr)
		Register_TStringList(TSRMLS_C);
	TElStringList_ce_ptr = zend_register_internal_class_ex(&ce, TStringList_ce_ptr, NULL TSRMLS_CC);
}
#endif

zend_class_entry *TElByteArrayList_ce_ptr = NULL;

SB_PHP_METHOD(TElByteArrayList, Add)
{
	SBArrayZValInfo aiS;
	zval *zaS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElByteArrayList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), aiS.data, aiS.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayList, AddRange)
{
	zval *oList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oList, TElByteArrayList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElByteArrayList_AddRange(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElByteArrayList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayList, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElByteArrayList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElByteArrayList_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElByteArrayList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayList, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElByteArrayList_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayList, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElByteArrayList_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayList, IndexOf)
{
	SBArrayZValInfo aiS;
	zval *zaS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElByteArrayList_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), aiS.data, aiS.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayList, Insert)
{
	long l4Index;
	SBArrayZValInfo aiS;
	zval *zaS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zaS) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaS)) || (IS_ARRAY == Z_TYPE_P(zaS)) || (IS_NULL == Z_TYPE_P(zaS))))
	{
		if (!SBGetByteArrayFromZVal(zaS, &aiS TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElByteArrayList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, aiS.data, aiS.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiS);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayList, get_Capacity)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElByteArrayList_get_Capacity(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayList, set_Capacity)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElByteArrayList_set_Capacity(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElByteArrayList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayList, get_Item)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElByteArrayList_get_Item(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1774379813, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayList, set_Item)
{
	long l4Index;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElByteArrayList_set_Item(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(integer, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElByteArrayList, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElByteArrayList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, S, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList_AddRange, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, List, TElByteArrayList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElByteArrayList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList_IndexOf, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, S, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, S, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList_get_Capacity, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList_set_Capacity, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList_get_Item, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList_set_Item, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElByteArrayList___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElByteArrayList_methods[] = {
	PHP_ME(TElByteArrayList, Add, arginfo_TElByteArrayList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayList, AddRange, arginfo_TElByteArrayList_AddRange, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayList, Assign, arginfo_TElByteArrayList_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayList, Clear, arginfo_TElByteArrayList_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayList, Delete, arginfo_TElByteArrayList_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayList, IndexOf, arginfo_TElByteArrayList_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayList, Insert, arginfo_TElByteArrayList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayList, get_Capacity, arginfo_TElByteArrayList_get_Capacity, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayList, set_Capacity, arginfo_TElByteArrayList_set_Capacity, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayList, get_Count, arginfo_TElByteArrayList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayList, get_Item, arginfo_TElByteArrayList_get_Item, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayList, set_Item, arginfo_TElByteArrayList_set_Item, ZEND_ACC_PUBLIC)
	PHP_ME(TElByteArrayList, __construct, arginfo_TElByteArrayList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElByteArrayList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElByteArrayList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElByteArrayList", TElByteArrayList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElByteArrayList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TSBObjectList_ce_ptr = NULL;

SB_PHP_METHOD(TSBObjectList, Add)
{
	SBArrayZValInfo piItem;
	zval *oAObject;
	zval *zpItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAObject, TObject_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TSBObjectList_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAObject TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpItem) == SUCCESS) && ((Z_TYPE_P(zpItem) == IS_STRING) || (Z_TYPE_P(zpItem) == IS_ARRAY) || (Z_TYPE_P(zpItem) == IS_NULL) || ((Z_TYPE_P(zpItem) == IS_OBJECT) && (Z_OBJCE_P(zpItem) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpItem, &piItem TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TSBObjectList_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), piItem.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piItem);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TObject) or (TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBObjectList, Remove)
{
	SBArrayZValInfo piItem;
	zval *oAObject;
	zval *zpItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAObject, TObject_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TSBObjectList_Remove(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAObject TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpItem) == SUCCESS) && ((Z_TYPE_P(zpItem) == IS_STRING) || (Z_TYPE_P(zpItem) == IS_ARRAY) || (Z_TYPE_P(zpItem) == IS_NULL) || ((Z_TYPE_P(zpItem) == IS_OBJECT) && (Z_OBJCE_P(zpItem) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpItem, &piItem TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TSBObjectList_Remove_1(SBGetObjectHandle(getThis() TSRMLS_CC), piItem.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piItem);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TObject) or (TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBObjectList, IndexOf)
{
	SBArrayZValInfo piItem;
	zval *oAObject;
	zval *zpItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAObject, TObject_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TSBObjectList_IndexOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAObject TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpItem) == SUCCESS) && ((Z_TYPE_P(zpItem) == IS_STRING) || (Z_TYPE_P(zpItem) == IS_ARRAY) || (Z_TYPE_P(zpItem) == IS_NULL) || ((Z_TYPE_P(zpItem) == IS_OBJECT) && (Z_OBJCE_P(zpItem) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpItem, &piItem TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TSBObjectList_IndexOf_1(SBGetObjectHandle(getThis() TSRMLS_CC), piItem.data, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piItem);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TObject) or (TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBObjectList, Insert)
{
	long l4Index;
	SBArrayZValInfo piItem;
	zval *oAObject;
	zval *zpItem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAObject, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TSBObjectList_Insert(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAObject TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &l4Index, &zpItem) == SUCCESS) && ((Z_TYPE_P(zpItem) == IS_STRING) || (Z_TYPE_P(zpItem) == IS_ARRAY) || (Z_TYPE_P(zpItem) == IS_NULL) || ((Z_TYPE_P(zpItem) == IS_OBJECT) && (Z_OBJCE_P(zpItem) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpItem, &piItem TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TSBObjectList_Insert_1(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, piItem.data) TSRMLS_CC);
		SBFreePointerZValInfo(&piItem);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TObject) or (integer, TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBObjectList, FindInstanceOf)
{
	long l4AStartAt;
	zend_bool bAExact;
	zval *oAClass;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bl", &oAClass, TClass_ce_ptr, &bAExact, &l4AStartAt) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TSBObjectList_FindInstanceOf(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAClass TSRMLS_CC), (int8_t)bAExact, (int32_t)l4AStartAt, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TClass, bool, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBObjectList, Extract)
{
	SBArrayZValInfo piitem;
	zval *oItem;
	zval *zpitem;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oItem, TObject_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBObjectList_Extract(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oItem TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpitem) == SUCCESS) && ((Z_TYPE_P(zpitem) == IS_STRING) || (Z_TYPE_P(zpitem) == IS_ARRAY) || (Z_TYPE_P(zpitem) == IS_NULL) || ((Z_TYPE_P(zpitem) == IS_OBJECT) && (Z_OBJCE_P(zpitem) == TSBPointer_ce_ptr))))
	{
		void * poOutResult = NULL;
		if (!SBGetPointerFromZVal(zpitem, &piitem TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TSBObjectList_Extract_1(SBGetObjectHandle(getThis() TSRMLS_CC), piitem.data, &poOutResult) TSRMLS_CC);
		SBFreePointerZValInfo(&piitem);
		object_init_ex(return_value, TSBPointer_ce_ptr);
		SBSetPointer(return_value, poOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject) or (TSBPointer|array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBObjectList, get_OwnsObjects)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TSBObjectList_get_OwnsObjects(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBObjectList, set_OwnsObjects)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TSBObjectList_set_OwnsObjects(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBObjectList, get_Items_TObject)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBObjectList_get_Items_TObject(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBObjectList, set_Items_TObject)
{
	long l4Index;
	zval *oAObject;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4Index, &oAObject, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TSBObjectList_set_Items_TObject(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, SBGetObjectHandle(oAObject TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TSBObjectList, __construct)
{
	zend_bool bAOwnsObjects;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBObjectList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bAOwnsObjects) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TSBObjectList_Create_1((int8_t)bAOwnsObjects, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBObjectList_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AObject_or_Item, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBObjectList_Remove, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AObject_or_Item, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBObjectList_IndexOf, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AObject_or_Item, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBObjectList_Insert, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_TYPE_INFO(0, AObject_or_Item, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBObjectList_FindInstanceOf, 0, 0, 3)
	ZEND_ARG_OBJ_INFO(0, AClass, TClass, 1)
	ZEND_ARG_INFO(0, AExact)
	ZEND_ARG_INFO(0, AStartAt)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBObjectList_Extract, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Item_or_item, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBObjectList_get_OwnsObjects, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBObjectList_set_OwnsObjects, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBObjectList_get_Items_TObject, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBObjectList_set_Items_TObject, 0, 0, 2)
	ZEND_ARG_INFO(0, Index)
	ZEND_ARG_OBJ_INFO(0, AObject, TObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TSBObjectList___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, AOwnsObjects)
ZEND_END_ARG_INFO()

static zend_function_entry TSBObjectList_methods[] = {
	PHP_ME(TSBObjectList, Add, arginfo_TSBObjectList_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TSBObjectList, Remove, arginfo_TSBObjectList_Remove, ZEND_ACC_PUBLIC)
	PHP_ME(TSBObjectList, IndexOf, arginfo_TSBObjectList_IndexOf, ZEND_ACC_PUBLIC)
	PHP_ME(TSBObjectList, Insert, arginfo_TSBObjectList_Insert, ZEND_ACC_PUBLIC)
	PHP_ME(TSBObjectList, FindInstanceOf, arginfo_TSBObjectList_FindInstanceOf, ZEND_ACC_PUBLIC)
	PHP_ME(TSBObjectList, Extract, arginfo_TSBObjectList_Extract, ZEND_ACC_PUBLIC)
	PHP_ME(TSBObjectList, get_OwnsObjects, arginfo_TSBObjectList_get_OwnsObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TSBObjectList, set_OwnsObjects, arginfo_TSBObjectList_set_OwnsObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TSBObjectList, get_Items_TObject, arginfo_TSBObjectList_get_Items_TObject, ZEND_ACC_PUBLIC)
	PHP_ME(TSBObjectList, set_Items_TObject, arginfo_TSBObjectList_set_Items_TObject, ZEND_ACC_PUBLIC)
	PHP_ME(TSBObjectList, __construct, arginfo_TSBObjectList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TSBObjectList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TSBObjectList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TSBObjectList", TSBObjectList_methods);
	if (NULL == TList_ce_ptr)
		Register_TList(TSRMLS_C);
	TSBObjectList_ce_ptr = zend_register_internal_class_ex(&ce, TList_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElCustomExceptionHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElCustomExceptionHandler, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElCustomExceptionHandler_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElCustomExceptionHandler___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElCustomExceptionHandler_methods[] = {
	PHP_ME(TElCustomExceptionHandler, __construct, arginfo_TElCustomExceptionHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElCustomExceptionHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElCustomExceptionHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElCustomExceptionHandler", TElCustomExceptionHandler_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElCustomExceptionHandler_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElStandardExceptionHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElStandardExceptionHandler, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElStandardExceptionHandler_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElStandardExceptionHandler___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElStandardExceptionHandler_methods[] = {
	PHP_ME(TElStandardExceptionHandler, __construct, arginfo_TElStandardExceptionHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElStandardExceptionHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElStandardExceptionHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElStandardExceptionHandler", TElStandardExceptionHandler_methods);
	if (NULL == TElCustomExceptionHandler_ce_ptr)
		Register_TElCustomExceptionHandler(TSRMLS_C);
	TElStandardExceptionHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomExceptionHandler_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElDebugExceptionHandler_ce_ptr = NULL;

SB_PHP_METHOD(TElDebugExceptionHandler, get_Destination)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBExceptionHandlerDestinationRaw fOutResultRaw = 0;
		SBCheckError(TElDebugExceptionHandler_get_Destination(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDebugExceptionHandler, set_Destination)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElDebugExceptionHandler_set_Destination(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBExceptionHandlerDestinationRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElDebugExceptionHandler, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElDebugExceptionHandler_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDebugExceptionHandler_get_Destination, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDebugExceptionHandler_set_Destination, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElDebugExceptionHandler___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElDebugExceptionHandler_methods[] = {
	PHP_ME(TElDebugExceptionHandler, get_Destination, arginfo_TElDebugExceptionHandler_get_Destination, ZEND_ACC_PUBLIC)
	PHP_ME(TElDebugExceptionHandler, set_Destination, arginfo_TElDebugExceptionHandler_set_Destination, ZEND_ACC_PUBLIC)
	PHP_ME(TElDebugExceptionHandler, __construct, arginfo_TElDebugExceptionHandler___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElDebugExceptionHandler(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElDebugExceptionHandler_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElDebugExceptionHandler", TElDebugExceptionHandler_methods);
	if (NULL == TElStandardExceptionHandler_ce_ptr)
		Register_TElStandardExceptionHandler(TSRMLS_C);
	TElDebugExceptionHandler_ce_ptr = zend_register_internal_class_ex(&ce, TElStandardExceptionHandler_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBUtils, DigestToStr)
{
	uint32_t _err;
	zend_bool bLowerCase;
	zval *oDigest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &oDigest, TMessageDigest128_ce_ptr, &bLowerCase) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DigestToStr((TMessageDigest128 *)SBGetStructPointer(oDigest TSRMLS_CC), (int8_t)bLowerCase, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(349878938, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &oDigest, TMessageDigest160_ce_ptr, &bLowerCase) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DigestToStr_1((TMessageDigest160 *)SBGetStructPointer(oDigest TSRMLS_CC), (int8_t)bLowerCase, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1678219117, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &oDigest, TMessageDigest224_ce_ptr, &bLowerCase) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DigestToStr_2((TMessageDigest224 *)SBGetStructPointer(oDigest TSRMLS_CC), (int8_t)bLowerCase, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-23844303, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &oDigest, TMessageDigest256_ce_ptr, &bLowerCase) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DigestToStr_3((TMessageDigest256 *)SBGetStructPointer(oDigest TSRMLS_CC), (int8_t)bLowerCase, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1572723429, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &oDigest, TMessageDigest320_ce_ptr, &bLowerCase) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DigestToStr_4((TMessageDigest320 *)SBGetStructPointer(oDigest TSRMLS_CC), (int8_t)bLowerCase, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1487821400, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &oDigest, TMessageDigest384_ce_ptr, &bLowerCase) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DigestToStr_5((TMessageDigest384 *)SBGetStructPointer(oDigest TSRMLS_CC), (int8_t)bLowerCase, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(680150778, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &oDigest, TMessageDigest512_ce_ptr, &bLowerCase) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DigestToStr_6((TMessageDigest512 *)SBGetStructPointer(oDigest TSRMLS_CC), (int8_t)bLowerCase, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1685064519, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest128, bool) or (TMessageDigest160, bool) or (TMessageDigest224, bool) or (TMessageDigest256, bool) or (TMessageDigest320, bool) or (TMessageDigest384, bool) or (TMessageDigest512, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, StrToDigest)
{
	char *sDigestStr;
	int sDigestStr_len;
	zval *oDigest;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO", &sDigestStr, &sDigestStr_len, &oDigest, TMessageDigest128_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oDigest))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_StrToDigest(sDigestStr, (int32_t)sDigestStr_len, (TMessageDigest128 *)SBGetStructPointer(oDigest TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO", &sDigestStr, &sDigestStr_len, &oDigest, TMessageDigest160_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oDigest))
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_StrToDigest_1(sDigestStr, (int32_t)sDigestStr_len, (TMessageDigest160 *)SBGetStructPointer(oDigest TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &TMessageDigest128) or (string, &TMessageDigest160)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DigestToBinary)
{
	uint32_t _err;
	zval *oDigest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oDigest, TMessageDigest128_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_DigestToBinary((TMessageDigest128 *)SBGetStructPointer(oDigest TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1094320686, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oDigest, TMessageDigest160_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_DigestToBinary_1((TMessageDigest160 *)SBGetStructPointer(oDigest TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(117450728, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest128) or (TMessageDigest160)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, BinaryToDigest)
{
	SBArrayZValInfo aiBinary;
	zval *oDigest;
	zval *zaBinary;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO", &zaBinary, &oDigest, TMessageDigest128_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBinary)) || (IS_ARRAY == Z_TYPE_P(zaBinary)) || (IS_NULL == Z_TYPE_P(zaBinary))) && PZVAL_IS_REF(oDigest))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBinary, &aiBinary TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_BinaryToDigest(aiBinary.data, aiBinary.len, (TMessageDigest128 *)SBGetStructPointer(oDigest TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBinary);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zO", &zaBinary, &oDigest, TMessageDigest160_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBinary)) || (IS_ARRAY == Z_TYPE_P(zaBinary)) || (IS_NULL == Z_TYPE_P(zaBinary))) && PZVAL_IS_REF(oDigest))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBinary, &aiBinary TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_BinaryToDigest_1(aiBinary.data, aiBinary.len, (TMessageDigest160 *)SBGetStructPointer(oDigest TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBinary);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, &TMessageDigest128) or (array of byte|string|NULL, &TMessageDigest160)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DigestToByteArray128)
{
	uint32_t _err;
	zval *oDigest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oDigest, TMessageDigest128_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_DigestToByteArray128((TMessageDigest128 *)SBGetStructPointer(oDigest TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1019061952, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest128)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DigestToByteArray160)
{
	uint32_t _err;
	zval *oDigest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oDigest, TMessageDigest160_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_DigestToByteArray160((TMessageDigest160 *)SBGetStructPointer(oDigest TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(634964728, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest160)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DigestToByteArray224)
{
	uint32_t _err;
	zval *oDigest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oDigest, TMessageDigest224_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_DigestToByteArray224((TMessageDigest224 *)SBGetStructPointer(oDigest TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1643628215, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest224)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DigestToByteArray256)
{
	uint32_t _err;
	zval *oDigest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oDigest, TMessageDigest256_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_DigestToByteArray256((TMessageDigest256 *)SBGetStructPointer(oDigest TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1043238281, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest256)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DigestToByteArray320)
{
	uint32_t _err;
	zval *oDigest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oDigest, TMessageDigest320_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_DigestToByteArray320((TMessageDigest320 *)SBGetStructPointer(oDigest TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1429333682, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest320)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DigestToByteArray384)
{
	uint32_t _err;
	zval *oDigest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oDigest, TMessageDigest384_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_DigestToByteArray384((TMessageDigest384 *)SBGetStructPointer(oDigest TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-403097491, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest384)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DigestToByteArray512)
{
	uint32_t _err;
	zval *oDigest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oDigest, TMessageDigest512_ce_ptr) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_DigestToByteArray512((TMessageDigest512 *)SBGetStructPointer(oDigest TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-2128132076, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest512)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ByteArrayToDigest128)
{
	long l4Position;
	SBArrayZValInfo aiBinary;
	zval *oDigest;
	zval *zaBinary;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO", &zaBinary, &l4Position, &oDigest, TMessageDigest128_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBinary)) || (IS_ARRAY == Z_TYPE_P(zaBinary)) || (IS_NULL == Z_TYPE_P(zaBinary))) && PZVAL_IS_REF(oDigest))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBinary, &aiBinary TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_ByteArrayToDigest128(aiBinary.data, aiBinary.len, (int32_t)l4Position, (TMessageDigest128 *)SBGetStructPointer(oDigest TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBinary);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, &TMessageDigest128)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ByteArrayToDigest160)
{
	long l4Position;
	SBArrayZValInfo aiBinary;
	zval *oDigest;
	zval *zaBinary;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO", &zaBinary, &l4Position, &oDigest, TMessageDigest160_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBinary)) || (IS_ARRAY == Z_TYPE_P(zaBinary)) || (IS_NULL == Z_TYPE_P(zaBinary))) && PZVAL_IS_REF(oDigest))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBinary, &aiBinary TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_ByteArrayToDigest160(aiBinary.data, aiBinary.len, (int32_t)l4Position, (TMessageDigest160 *)SBGetStructPointer(oDigest TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBinary);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, &TMessageDigest160)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ByteArrayToDigest224)
{
	long l4Position;
	SBArrayZValInfo aiBinary;
	zval *oDigest;
	zval *zaBinary;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO", &zaBinary, &l4Position, &oDigest, TMessageDigest224_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBinary)) || (IS_ARRAY == Z_TYPE_P(zaBinary)) || (IS_NULL == Z_TYPE_P(zaBinary))) && PZVAL_IS_REF(oDigest))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBinary, &aiBinary TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_ByteArrayToDigest224(aiBinary.data, aiBinary.len, (int32_t)l4Position, (TMessageDigest224 *)SBGetStructPointer(oDigest TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBinary);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, &TMessageDigest224)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ByteArrayToDigest256)
{
	long l4Position;
	SBArrayZValInfo aiBinary;
	zval *oDigest;
	zval *zaBinary;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO", &zaBinary, &l4Position, &oDigest, TMessageDigest256_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBinary)) || (IS_ARRAY == Z_TYPE_P(zaBinary)) || (IS_NULL == Z_TYPE_P(zaBinary))) && PZVAL_IS_REF(oDigest))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBinary, &aiBinary TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_ByteArrayToDigest256(aiBinary.data, aiBinary.len, (int32_t)l4Position, (TMessageDigest256 *)SBGetStructPointer(oDigest TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBinary);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, &TMessageDigest256)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ByteArrayToDigest320)
{
	long l4Position;
	SBArrayZValInfo aiBinary;
	zval *oDigest;
	zval *zaBinary;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO", &zaBinary, &l4Position, &oDigest, TMessageDigest320_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBinary)) || (IS_ARRAY == Z_TYPE_P(zaBinary)) || (IS_NULL == Z_TYPE_P(zaBinary))) && PZVAL_IS_REF(oDigest))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBinary, &aiBinary TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_ByteArrayToDigest320(aiBinary.data, aiBinary.len, (int32_t)l4Position, (TMessageDigest320 *)SBGetStructPointer(oDigest TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBinary);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, &TMessageDigest320)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ByteArrayToDigest384)
{
	long l4Position;
	SBArrayZValInfo aiBinary;
	zval *oDigest;
	zval *zaBinary;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO", &zaBinary, &l4Position, &oDigest, TMessageDigest384_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBinary)) || (IS_ARRAY == Z_TYPE_P(zaBinary)) || (IS_NULL == Z_TYPE_P(zaBinary))) && PZVAL_IS_REF(oDigest))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBinary, &aiBinary TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_ByteArrayToDigest384(aiBinary.data, aiBinary.len, (int32_t)l4Position, (TMessageDigest384 *)SBGetStructPointer(oDigest TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBinary);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, &TMessageDigest384)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ByteArrayToDigest512)
{
	long l4Position;
	SBArrayZValInfo aiBinary;
	zval *oDigest;
	zval *zaBinary;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlO", &zaBinary, &l4Position, &oDigest, TMessageDigest512_ce_ptr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBinary)) || (IS_ARRAY == Z_TYPE_P(zaBinary)) || (IS_NULL == Z_TYPE_P(zaBinary))) && PZVAL_IS_REF(oDigest))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBinary, &aiBinary TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_ByteArrayToDigest512(aiBinary.data, aiBinary.len, (int32_t)l4Position, (TMessageDigest512 *)SBGetStructPointer(oDigest TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBinary);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, &TMessageDigest512)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, PointerToLIntP)
{
	long l4Size;
	SBArrayZValInfo piP;
	TLInt * proB;
	zval *oB;
	zval *zpP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oB, TLInt_ce_ptr, &zpP, &l4Size) == SUCCESS) && PZVAL_IS_REF(oB) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))))
	{
		proB = (TLInt *)SBGetStructPointer(oB TSRMLS_CC);
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_PointerToLIntP(&proB, piP.data, (int32_t)l4Size) TSRMLS_CC);
		SBSetStructPointer(oB, proB, sizeof(TLInt) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, PointerToLInt)
{
	long l4Size;
	SBArrayZValInfo aiP;
	TLInt * proB;
	zval *oB;
	zval *zaP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ozl", &oB, TLInt_ce_ptr, &zaP, &l4Size) == SUCCESS) && PZVAL_IS_REF(oB) && ((IS_STRING == Z_TYPE_P(zaP)) || (IS_ARRAY == Z_TYPE_P(zaP)) || (IS_NULL == Z_TYPE_P(zaP))))
	{
		proB = (TLInt *)SBGetStructPointer(oB TSRMLS_CC);
		if (!SBGetByteArrayFromZVal(zaP, &aiP TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_PointerToLInt(&proB, aiP.data, aiP.len, (int32_t)l4Size) TSRMLS_CC);
		SBSetStructPointer(oB, proB, sizeof(TLInt) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiP);
	}
	else
	{
		SBErrorExpectsArguments("(&TLInt, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, LIntToPointerP)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piP;
	zval *oB;
	zval *zl4Size;
	zval *zpP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oB, TLInt_ce_ptr, &zpP, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(SBUtils_LIntToPointerP((TLInt *)SBGetStructPointer(oB TSRMLS_CC), piP.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, LIntToPointer)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo aiP;
	zval *oB;
	zval *zaP;
	zval *zl4Size;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oB, TLInt_ce_ptr, &zaP, &zl4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaP)) || (IS_ARRAY == Z_TYPE_P(zaP)) || (IS_NULL == Z_TYPE_P(zaP))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetByteArrayFromZVal(zaP, &aiP TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(SBUtils_LIntToPointer((TLInt *)SBGetStructPointer(oB TSRMLS_CC), aiP.data, aiP.len, &l4SizeRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiP);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, LIntToPointerTrunc)
{
	int32_t l4SizeRaw;
	SBArrayZValInfo piP;
	zval *oB;
	zval *zl4Size;
	zval *zpP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!zz", &oB, TLInt_ce_ptr, &zpP, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(SBUtils_LIntToPointerTrunc((TLInt *)SBGetStructPointer(oB TSRMLS_CC), piP.data, &l4SizeRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TLInt, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, BufferBitCount)
{
	long l4Size;
	SBArrayZValInfo piBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_BufferBitCount(piBuffer.data, (int32_t)l4Size, &l4OutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, BeautifyBinaryString)
{
	char *cSeparator;
	char *sStr;
	int cSeparator_len;
	int sStr_len;
	uint32_t _err;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sStr, &sStr_len, &cSeparator, &cSeparator_len) == SUCCESS) && (1 == cSeparator_len))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_BeautifyBinaryString(sStr, (int32_t)sStr_len, cSeparator[0], sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1377148697, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, char)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SwapUInt16)
{
	int32_t l4IndexRaw;
	long u2Value;
	long u4Offset;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Index;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &u2Value, &zaBuffer) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_SwapUInt16((uint16_t)u2Value, aiBuffer.data, &aiBuffer.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-2143185226, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &u2Value, &zaBuffer, &zl4Index) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Index) && (IS_LONG == Z_TYPE_P(zl4Index)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4IndexRaw = (int32_t)Z_LVAL_P(zl4Index);
		_err = SBUtils_SwapUInt16_1((uint16_t)u2Value, aiBuffer.data, &aiBuffer.len, &l4IndexRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1847419699, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Index, (long)l4IndexRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaBuffer, &u4Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint16_t u2OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_SwapUInt16_2(aiBuffer.data, aiBuffer.len, (uint32_t)u4Offset, &u2OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, &array of byte|string) or (integer, &array of byte|string, &integer) or (array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SwapInt32)
{
	long l4value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBUtils_SwapInt32((int32_t)l4value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SwapUInt32)
{
	int32_t l4IndexRaw;
	long u4Offset;
	long u4value;
	long u4Value;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zl4Index;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &u4Value, &zaBuffer) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_SwapUInt32((uint32_t)u4Value, aiBuffer.data, &aiBuffer.len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-834836930, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &u4Value, &zaBuffer, &zl4Index) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))) && PZVAL_IS_REF(zl4Index) && (IS_LONG == Z_TYPE_P(zl4Index)))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		l4IndexRaw = (int32_t)Z_LVAL_P(zl4Index);
		_err = SBUtils_SwapUInt32_1((uint32_t)u4Value, aiBuffer.data, &aiBuffer.len, &l4IndexRaw);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(295627799, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
		ZVAL_LONG(zl4Index, (long)l4IndexRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaBuffer, &u4Offset) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_SwapUInt32_2(aiBuffer.data, aiBuffer.len, (uint32_t)u4Offset, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4value) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBUtils_SwapUInt32_3((uint32_t)u4value, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, &array of byte|string) or (integer, &array of byte|string, &integer) or (array of byte|string|NULL, integer) or (integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SwapInt64)
{
	long l8value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8value) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(SBUtils_SwapInt64((int64_t)l8value, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SwapSomeInt)
{
	long l4Value;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_SwapSomeInt((int32_t)l4Value, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1256271529, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, RotateInteger)
{
	SBArrayZValInfo aiValue;
	uint32_t _err;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_RotateInteger(aiValue.data, aiValue.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-36907580, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiValue);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, TrimZeros)
{
	SBArrayZValInfo aiValue;
	uint32_t _err;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_TrimZeros(aiValue.data, aiValue.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-437078919, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiValue);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ZeroArray)
{
	long l4Size;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Size) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_ZeroArray((int32_t)l4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(855703600, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SubArray)
{
	long l4Index;
	long l4Size;
	SBArrayZValInfo aiArr;
	uint32_t _err;
	zval *zaArr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaArr, &l4Index, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaArr)) || (IS_ARRAY == Z_TYPE_P(zaArr)) || (IS_NULL == Z_TYPE_P(zaArr))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaArr, &aiArr TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_SubArray(aiArr.data, aiArr.len, (int32_t)l4Index, (int32_t)l4Size, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1643769167, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiArr);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SwapBigEndianWords)
{
	long l4Size;
	SBArrayZValInfo piP;
	zval *zpP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpP, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_SwapBigEndianWords(piP.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SwapBigEndianDWords)
{
	long l4Size;
	SBArrayZValInfo piP;
	zval *zpP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpP, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpP) == IS_STRING) || (Z_TYPE_P(zpP) == IS_ARRAY) || (Z_TYPE_P(zpP) == IS_NULL) || ((Z_TYPE_P(zpP) == IS_OBJECT) && (Z_OBJCE_P(zpP) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpP, &piP TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_SwapBigEndianDWords(piP.data, (int32_t)l4Size) TSRMLS_CC);
		SBFreePointerZValInfo(&piP);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, IsEmptyDateTime)
{
	zval *dtDT;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtDT, php_date_get_date_ce()) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_IsEmptyDateTime(SBGetDateTime(dtDT TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, EmptyDateTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_EmptyDateTime(&dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SBMove)
{
	long l4CopyCount;
	long l4DstOffset;
	long l4Size;
	long l4SrcOffset;
	SBArrayZValInfo aiDst;
	SBArrayZValInfo aiSrc;
	SBPointerZValInfo piDestinationPointer;
	SBPointerZValInfo piSourcePointer;
	zval *zaDst;
	zval *zaSrc;
	zval *zpDestinationPointer;
	zval *zpSourcePointer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zpSourcePointer, &zpDestinationPointer, &l4CopyCount) == SUCCESS) && ((Z_TYPE_P(zpSourcePointer) == IS_STRING) || (Z_TYPE_P(zpSourcePointer) == IS_ARRAY) || (Z_TYPE_P(zpSourcePointer) == IS_NULL) || ((Z_TYPE_P(zpSourcePointer) == IS_OBJECT) && (Z_OBJCE_P(zpSourcePointer) == TSBPointer_ce_ptr))) && ((PZVAL_IS_REF(zpDestinationPointer) && ((Z_TYPE_P(zpDestinationPointer) == IS_STRING) || (Z_TYPE_P(zpDestinationPointer) == IS_ARRAY))) || ((Z_TYPE_P(zpDestinationPointer) == IS_OBJECT) && (Z_OBJCE_P(zpDestinationPointer) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpSourcePointer, &piSourcePointer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpDestinationPointer, &piDestinationPointer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_SBMove(piSourcePointer.data, piDestinationPointer.data, (int32_t)l4CopyCount) TSRMLS_CC);
		SBFreePointerZValInfo(&piSourcePointer);
		SBSetPointerToZVal(&piDestinationPointer, zpDestinationPointer);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzll", &zaSrc, &l4SrcOffset, &zaDst, &l4DstOffset, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSrc)) || (IS_ARRAY == Z_TYPE_P(zaSrc)) || (IS_NULL == Z_TYPE_P(zaSrc))) && ((IS_STRING == Z_TYPE_P(zaDst)) || (IS_ARRAY == Z_TYPE_P(zaDst)) || (IS_NULL == Z_TYPE_P(zaDst))))
	{
		if (!SBGetByteArrayFromZVal(zaSrc, &aiSrc TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaDst, &aiDst TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_SBMove_1(aiSrc.data, aiSrc.len, (int32_t)l4SrcOffset, aiDst.data, aiDst.len, (int32_t)l4DstOffset, (int32_t)l4Size) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSrc);
		SBFreeArrayZValInfo(&aiDst);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string, integer) or (array of byte|string|NULL, integer, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, TrimLeadingZeros)
{
	SBArrayZValInfo aiV;
	uint32_t _err;
	zval *zaV;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaV) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaV)) || (IS_ARRAY == Z_TYPE_P(zaV)) || (IS_NULL == Z_TYPE_P(zaV))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaV, &aiV TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_TrimLeadingZeros(aiV.data, aiV.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1638168559, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiV);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, TrimTrailingZeros)
{
	SBArrayZValInfo aiV;
	uint32_t _err;
	zval *zaV;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaV) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaV)) || (IS_ARRAY == Z_TYPE_P(zaV)) || (IS_NULL == Z_TYPE_P(zaV))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaV, &aiV TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_TrimTrailingZeros(aiV.data, aiV.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1291610793, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiV);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, PrefixByteArray)
{
	long l4Count;
	long u1Value;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Count, &u1Value) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_PrefixByteArray(aiBuffer.data, aiBuffer.len, (int32_t)l4Count, (uint8_t)u1Value, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(179891833, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SuffixByteArray)
{
	long l4Count;
	long u1Value;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Count, &u1Value) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_SuffixByteArray(aiBuffer.data, aiBuffer.len, (int32_t)l4Count, (uint8_t)u1Value, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(154026450, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, FillByteArray)
{
	long l4Count;
	long l4SrcOffset;
	long u1Value;
	SBArrayZValInfo aiBuffer;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlll", &zaBuffer, &l4SrcOffset, &l4Count, &u1Value) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_FillByteArray(aiBuffer.data, aiBuffer.len, (int32_t)l4SrcOffset, (int32_t)l4Count, (uint8_t)u1Value) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaBuffer, &u1Value) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_FillByteArray_1(aiBuffer.data, aiBuffer.len, (uint8_t)u1Value) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer, integer) or (array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetBytes64)
{
	long l4Index;
	long l8X;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8X) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_GetBytes64((int64_t)l8X, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1489022411, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &l8X, &zaBuffer, &l4Index) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_GetBytes64_1((int64_t)l8X, aiBuffer.data, &aiBuffer.len, (int32_t)l4Index);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(191613255, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, &array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetBytes32)
{
	long l4Index;
	long u4X;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4X) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_GetBytes32((uint32_t)u4X, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(272747253, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &u4X, &zaBuffer, &l4Index) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_GetBytes32_1((uint32_t)u4X, aiBuffer.data, &aiBuffer.len, (int32_t)l4Index);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(1750216342, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, &array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetBytes16)
{
	long l4Index;
	long u2X;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2X) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_GetBytes16((uint16_t)u2X, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(247158414, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &u2X, &zaBuffer, &l4Index) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_GetBytes16_1((uint16_t)u2X, aiBuffer.data, &aiBuffer.len, (int32_t)l4Index);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-623268732, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, &array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetBytes8)
{
	long l4Index;
	long u1X;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1X) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_GetBytes8((uint8_t)u1X, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-990947127, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &u1X, &zaBuffer, &l4Index) == SUCCESS) && PZVAL_IS_REF(zaBuffer) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer))))
	{
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_GetBytes8_1((uint8_t)u1X, aiBuffer.data, &aiBuffer.len, (int32_t)l4Index);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			SBDetachDataFromZValAndResize(zaBuffer, &aiBuffer TSRMLS_CC);
			SBCheckError(SBGetLastReturnBuffer(-1660639562, 1, aiBuffer.data, &aiBuffer.len) TSRMLS_CC);
			((char *)aiBuffer.data)[aiBuffer.len] = 0;
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBFreeArrayZValInfo(&aiBuffer);
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBSetByteArrayToZVal(&aiBuffer, zaBuffer);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, &array of byte|string, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, LocalDateTimeToSystemDateTime)
{
	zval *dtADateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtADateTime, php_date_get_date_ce()) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_LocalDateTimeToSystemDateTime(SBGetDateTime(dtADateTime TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SystemDateTimeToLocalDateTime)
{
	zval *dtADateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtADateTime, php_date_get_date_ce()) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_SystemDateTimeToLocalDateTime(SBGetDateTime(dtADateTime TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeAddMillis)
{
	long l4Millis;
	zval *dtDateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &dtDateTime, php_date_get_date_ce(), &l4Millis) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeAddMillis(SBGetDateTime(dtDateTime TSRMLS_CC), (int32_t)l4Millis, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeAddDays)
{
	long l4Days;
	zval *dtDateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &dtDateTime, php_date_get_date_ce(), &l4Days) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeAddDays(SBGetDateTime(dtDateTime TSRMLS_CC), (int32_t)l4Days, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeAddHours)
{
	long l4Hours;
	zval *dtDateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &dtDateTime, php_date_get_date_ce(), &l4Hours) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeAddHours(SBGetDateTime(dtDateTime TSRMLS_CC), (int32_t)l4Hours, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeAddMinutes)
{
	long l4Minutes;
	zval *dtDateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &dtDateTime, php_date_get_date_ce(), &l4Minutes) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeAddMinutes(SBGetDateTime(dtDateTime TSRMLS_CC), (int32_t)l4Minutes, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeAddSeconds)
{
	long l4Seconds;
	zval *dtDateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &dtDateTime, php_date_get_date_ce(), &l4Seconds) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeAddSeconds(SBGetDateTime(dtDateTime TSRMLS_CC), (int32_t)l4Seconds, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeAddYears)
{
	long l4Years;
	zval *dtDateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ol", &dtDateTime, php_date_get_date_ce(), &l4Years) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeAddYears(SBGetDateTime(dtDateTime TSRMLS_CC), (int32_t)l4Years, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeAfter)
{
	zval *dtDT1;
	zval *dtDT2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &dtDT1, php_date_get_date_ce(), &dtDT2, php_date_get_date_ce()) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeAfter(SBGetDateTime(dtDT1 TSRMLS_CC), SBGetDateTime(dtDT2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeBefore)
{
	zval *dtDT1;
	zval *dtDT2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &dtDT1, php_date_get_date_ce(), &dtDT2, php_date_get_date_ce()) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeBefore(SBGetDateTime(dtDT1 TSRMLS_CC), SBGetDateTime(dtDT2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeClone)
{
	zval *dtDateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtDateTime, php_date_get_date_ce()) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeClone(SBGetDateTime(dtDateTime TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeCompare)
{
	zval *dtDT1;
	zval *dtDT2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &dtDT1, php_date_get_date_ce(), &dtDT2, php_date_get_date_ce()) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeCompare(SBGetDateTime(dtDT1 TSRMLS_CC), SBGetDateTime(dtDT2 TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeEquals)
{
	zval *dtDT1;
	zval *dtDT2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &dtDT1, php_date_get_date_ce(), &dtDT2, php_date_get_date_ce()) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeEquals(SBGetDateTime(dtDT1 TSRMLS_CC), SBGetDateTime(dtDT2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeGetMonth)
{
	zval *dtDT;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtDT, php_date_get_date_ce()) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeGetMonth(SBGetDateTime(dtDT TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeGetYear)
{
	zval *dtDT;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtDT, php_date_get_date_ce()) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeGetYear(SBGetDateTime(dtDT TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeIsLeapYear)
{
	long l4Year;
	zval *dtDT;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Year) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeIsLeapYear((int32_t)l4Year, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtDT, php_date_get_date_ce()) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeIsLeapYear_1(SBGetDateTime(dtDT TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeNow)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeNow(&dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeToString)
{
	uint32_t _err;
	zval *dtDateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtDateTime, php_date_get_date_ce()) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DateTimeToString(SBGetDateTime(dtDateTime TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1602861865, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeUtcNow)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeUtcNow(&dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareMem)
{
	long l4Offset1;
	long l4Offset2;
	long l4Size;
	SBArrayZValInfo aiMem1;
	SBArrayZValInfo aiMem2;
	SBArrayZValInfo piMem1;
	SBArrayZValInfo piMem2;
	zval *zaMem1;
	zval *zaMem2;
	zval *zpMem1;
	zval *zpMem2;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaMem1, &zaMem2) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMem1)) || (IS_ARRAY == Z_TYPE_P(zaMem1)) || (IS_NULL == Z_TYPE_P(zaMem1))) && ((IS_STRING == Z_TYPE_P(zaMem2)) || (IS_ARRAY == Z_TYPE_P(zaMem2)) || (IS_NULL == Z_TYPE_P(zaMem2))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMem1, &aiMem1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaMem2, &aiMem2 TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_CompareMem(aiMem1.data, aiMem1.len, aiMem2.data, aiMem2.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMem1);
		SBFreeArrayZValInfo(&aiMem2);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzl", &zaMem1, &l4Offset1, &zaMem2, &l4Offset2) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMem1)) || (IS_ARRAY == Z_TYPE_P(zaMem1)) || (IS_NULL == Z_TYPE_P(zaMem1))) && ((IS_STRING == Z_TYPE_P(zaMem2)) || (IS_ARRAY == Z_TYPE_P(zaMem2)) || (IS_NULL == Z_TYPE_P(zaMem2))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMem1, &aiMem1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaMem2, &aiMem2 TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_CompareMem_1(aiMem1.data, aiMem1.len, (int32_t)l4Offset1, aiMem2.data, aiMem2.len, (int32_t)l4Offset2, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMem1);
		SBFreeArrayZValInfo(&aiMem2);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzll", &zaMem1, &l4Offset1, &zaMem2, &l4Offset2, &l4Size) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaMem1)) || (IS_ARRAY == Z_TYPE_P(zaMem1)) || (IS_NULL == Z_TYPE_P(zaMem1))) && ((IS_STRING == Z_TYPE_P(zaMem2)) || (IS_ARRAY == Z_TYPE_P(zaMem2)) || (IS_NULL == Z_TYPE_P(zaMem2))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaMem1, &aiMem1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaMem2, &aiMem2 TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_CompareMem_2(aiMem1.data, aiMem1.len, (int32_t)l4Offset1, aiMem2.data, aiMem2.len, (int32_t)l4Offset2, (int32_t)l4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiMem1);
		SBFreeArrayZValInfo(&aiMem2);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzl", &zpMem1, &zpMem2, &l4Size) == SUCCESS) && ((Z_TYPE_P(zpMem1) == IS_STRING) || (Z_TYPE_P(zpMem1) == IS_ARRAY) || (Z_TYPE_P(zpMem1) == IS_NULL) || ((Z_TYPE_P(zpMem1) == IS_OBJECT) && (Z_OBJCE_P(zpMem1) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpMem2) == IS_STRING) || (Z_TYPE_P(zpMem2) == IS_ARRAY) || (Z_TYPE_P(zpMem2) == IS_NULL) || ((Z_TYPE_P(zpMem2) == IS_OBJECT) && (Z_OBJCE_P(zpMem2) == TSBPointer_ce_ptr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpMem1, &piMem1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpMem2, &piMem2 TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_CompareMem_3(piMem1.data, piMem2.data, (int32_t)l4Size, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piMem1);
		SBFreePointerZValInfo(&piMem2);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL) or (array of byte|string|NULL, integer, array of byte|string|NULL, integer) or (array of byte|string|NULL, integer, array of byte|string|NULL, integer, integer) or (TSBPointer|array of byte|string|NULL, TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareBuffers)
{
	SBArrayZValInfo aiBuf1;
	SBArrayZValInfo aiBuf2;
	zval *zaBuf1;
	zval *zaBuf2;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuf1, &zaBuf2) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf1)) || (IS_ARRAY == Z_TYPE_P(zaBuf1)) || (IS_NULL == Z_TYPE_P(zaBuf1))) && ((IS_STRING == Z_TYPE_P(zaBuf2)) || (IS_ARRAY == Z_TYPE_P(zaBuf2)) || (IS_NULL == Z_TYPE_P(zaBuf2))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuf1, &aiBuf1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaBuf2, &aiBuf2 TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_CompareBuffers(aiBuf1.data, aiBuf1.len, aiBuf2.data, aiBuf2.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuf1);
		SBFreeArrayZValInfo(&aiBuf2);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareMD128)
{
	zval *oM1;
	zval *oM2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oM1, TMessageDigest128_ce_ptr, &oM2, TMessageDigest128_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_CompareMD128((TMessageDigest128 *)SBGetStructPointer(oM1 TSRMLS_CC), (TMessageDigest128 *)SBGetStructPointer(oM2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest128, TMessageDigest128)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareMD160)
{
	zval *oM1;
	zval *oM2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oM1, TMessageDigest160_ce_ptr, &oM2, TMessageDigest160_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_CompareMD160((TMessageDigest160 *)SBGetStructPointer(oM1 TSRMLS_CC), (TMessageDigest160 *)SBGetStructPointer(oM2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest160, TMessageDigest160)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareMD224)
{
	zval *oM1;
	zval *oM2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oM1, TMessageDigest224_ce_ptr, &oM2, TMessageDigest224_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_CompareMD224((TMessageDigest224 *)SBGetStructPointer(oM1 TSRMLS_CC), (TMessageDigest224 *)SBGetStructPointer(oM2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest224, TMessageDigest224)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareMD256)
{
	zval *oM1;
	zval *oM2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oM1, TMessageDigest256_ce_ptr, &oM2, TMessageDigest256_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_CompareMD256((TMessageDigest256 *)SBGetStructPointer(oM1 TSRMLS_CC), (TMessageDigest256 *)SBGetStructPointer(oM2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest256, TMessageDigest256)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareMD320)
{
	zval *oM1;
	zval *oM2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oM1, TMessageDigest320_ce_ptr, &oM2, TMessageDigest320_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_CompareMD320((TMessageDigest320 *)SBGetStructPointer(oM1 TSRMLS_CC), (TMessageDigest320 *)SBGetStructPointer(oM2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest320, TMessageDigest320)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareMD384)
{
	zval *oM1;
	zval *oM2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oM1, TMessageDigest384_ce_ptr, &oM2, TMessageDigest384_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_CompareMD384((TMessageDigest384 *)SBGetStructPointer(oM1 TSRMLS_CC), (TMessageDigest384 *)SBGetStructPointer(oM2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest384, TMessageDigest384)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareMD512)
{
	zval *oM1;
	zval *oM2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oM1, TMessageDigest512_ce_ptr, &oM2, TMessageDigest512_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_CompareMD512((TMessageDigest512 *)SBGetStructPointer(oM1 TSRMLS_CC), (TMessageDigest512 *)SBGetStructPointer(oM2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TMessageDigest512, TMessageDigest512)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareHashes)
{
	long l4Count1;
	long l4Count2;
	long l4StartIndex1;
	long l4StartIndex2;
	SBArrayZValInfo aiHash1;
	SBArrayZValInfo aiHash2;
	zval *zaHash1;
	zval *zaHash2;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaHash1, &zaHash2) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHash1)) || (IS_ARRAY == Z_TYPE_P(zaHash1)) || (IS_NULL == Z_TYPE_P(zaHash1))) && ((IS_STRING == Z_TYPE_P(zaHash2)) || (IS_ARRAY == Z_TYPE_P(zaHash2)) || (IS_NULL == Z_TYPE_P(zaHash2))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHash1, &aiHash1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaHash2, &aiHash2 TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_CompareHashes(aiHash1.data, aiHash1.len, aiHash2.data, aiHash2.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHash1);
		SBFreeArrayZValInfo(&aiHash2);
		RETURN_BOOL(bOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllzll", &zaHash1, &l4StartIndex1, &l4Count1, &zaHash2, &l4StartIndex2, &l4Count2) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaHash1)) || (IS_ARRAY == Z_TYPE_P(zaHash1)) || (IS_NULL == Z_TYPE_P(zaHash1))) && ((IS_STRING == Z_TYPE_P(zaHash2)) || (IS_ARRAY == Z_TYPE_P(zaHash2)) || (IS_NULL == Z_TYPE_P(zaHash2))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaHash1, &aiHash1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaHash2, &aiHash2 TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_CompareHashes_1(aiHash1.data, aiHash1.len, (int32_t)l4StartIndex1, (int32_t)l4Count1, aiHash2.data, aiHash2.len, (int32_t)l4StartIndex2, (int32_t)l4Count2, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiHash1);
		SBFreeArrayZValInfo(&aiHash2);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL) or (array of byte|string|NULL, integer, integer, array of byte|string|NULL, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, FreeAndNil)
{
	SBPointerZValInfo piObj;
	zval *zpObj;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zpObj) == SUCCESS) && ((PZVAL_IS_REF(zpObj) && ((Z_TYPE_P(zpObj) == IS_STRING) || (Z_TYPE_P(zpObj) == IS_ARRAY))) || ((Z_TYPE_P(zpObj) == IS_OBJECT) && (Z_OBJCE_P(zpObj) == TSBPointer_ce_ptr))))
	{
		if (!SBGetPointerFromZVal(zpObj, &piObj TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_FreeAndNil(piObj.data) TSRMLS_CC);
		SBSetPointerToZVal(&piObj, zpObj);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetDigestSizeBits)
{
	long l4Algorithm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Algorithm) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBUtils_GetDigestSizeBits((int32_t)l4Algorithm, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, EncodeDSASignature)
{
	int32_t l4BlobSizeRaw;
	long l4RSize;
	long l4SSize;
	SBArrayZValInfo piBlob;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	zval *zl4BlobSize;
	zval *zpBlob;
	zval *zpR;
	zval *zpS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzlzz", &zpR, &l4RSize, &zpS, &l4SSize, &zpBlob, &zl4BlobSize) == SUCCESS) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4BlobSize) && (IS_LONG == Z_TYPE_P(zl4BlobSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		l4BlobSizeRaw = (int32_t)Z_LVAL_P(zl4BlobSize);
		SBCheckError(SBUtils_EncodeDSASignature(piR.data, (int32_t)l4RSize, piS.data, (int32_t)l4SSize, piBlob.data, &l4BlobSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piR);
		SBFreePointerZValInfo(&piS);
		SBFreePointerZValInfo(&piBlob);
		ZVAL_LONG(zl4BlobSize, (long)l4BlobSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DecodeDSASignature)
{
	int32_t l4RSizeRaw;
	int32_t l4SSizeRaw;
	long l4Size;
	SBArrayZValInfo piBlob;
	SBArrayZValInfo piR;
	SBArrayZValInfo piS;
	zval *zl4RSize;
	zval *zl4SSize;
	zval *zpBlob;
	zval *zpR;
	zval *zpS;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zlzzzz", &zpBlob, &l4Size, &zpR, &zl4RSize, &zpS, &zl4SSize) == SUCCESS) && ((Z_TYPE_P(zpBlob) == IS_STRING) || (Z_TYPE_P(zpBlob) == IS_ARRAY) || (Z_TYPE_P(zpBlob) == IS_NULL) || ((Z_TYPE_P(zpBlob) == IS_OBJECT) && (Z_OBJCE_P(zpBlob) == TSBPointer_ce_ptr))) && ((Z_TYPE_P(zpR) == IS_STRING) || (Z_TYPE_P(zpR) == IS_ARRAY) || (Z_TYPE_P(zpR) == IS_NULL) || ((Z_TYPE_P(zpR) == IS_OBJECT) && (Z_OBJCE_P(zpR) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4RSize) && (IS_LONG == Z_TYPE_P(zl4RSize)) && ((Z_TYPE_P(zpS) == IS_STRING) || (Z_TYPE_P(zpS) == IS_ARRAY) || (Z_TYPE_P(zpS) == IS_NULL) || ((Z_TYPE_P(zpS) == IS_OBJECT) && (Z_OBJCE_P(zpS) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4SSize) && (IS_LONG == Z_TYPE_P(zl4SSize)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBlob, &piBlob TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetPointerFromZVal(zpR, &piR TSRMLS_CC)) RETURN_FALSE;
		l4RSizeRaw = (int32_t)Z_LVAL_P(zl4RSize);
		if (!SBGetPointerFromZVal(zpS, &piS TSRMLS_CC)) RETURN_FALSE;
		l4SSizeRaw = (int32_t)Z_LVAL_P(zl4SSize);
		SBCheckError(SBUtils_DecodeDSASignature(piBlob.data, (int32_t)l4Size, piR.data, &l4RSizeRaw, piS.data, &l4SSizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBlob);
		SBFreePointerZValInfo(&piR);
		ZVAL_LONG(zl4RSize, (long)l4RSizeRaw);
		SBFreePointerZValInfo(&piS);
		ZVAL_LONG(zl4SSize, (long)l4SSizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TSBPointer|array of byte|string|NULL, integer, TSBPointer|array of byte|string|NULL, &integer, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareAnsiStr)
{
	char *sContent;
	char *sOID;
	int sContent_len;
	int sOID_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sContent, &sContent_len, &sOID, &sOID_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_CompareAnsiStr(sContent, (int32_t)sContent_len, sOID, (int32_t)sOID_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ChangeByteOrder)
{
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_ChangeByteOrder(aiBuffer.data, aiBuffer.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(311519772, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, BinaryToString)
{
	long l4BufSize;
	long l4Count;
	long l4Start;
	SBArrayZValInfo aiBuffer;
	SBArrayZValInfo piBuffer;
	uint32_t _err;
	zval *zaBuffer;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaBuffer) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_BinaryToString(aiBuffer.data, aiBuffer.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1305723702, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &l4Start, &l4Count) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_BinaryToString_1(aiBuffer.data, aiBuffer.len, (int32_t)l4Start, (int32_t)l4Count, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1122618405, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zpBuffer, &l4BufSize) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_BinaryToString_2(piBuffer.data, (int32_t)l4BufSize, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-470870463, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreePointerZValInfo(&piBuffer);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL) or (array of byte|string|NULL, integer, integer) or (TSBPointer|array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, StringToBinary)
{
	char *sS;
	int sS_len;
	int32_t l4SizeRaw;
	SBArrayZValInfo piBuffer;
	zval *zl4Size;
	zval *zpBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "szz", &sS, &sS_len, &zpBuffer, &zl4Size) == SUCCESS) && ((Z_TYPE_P(zpBuffer) == IS_STRING) || (Z_TYPE_P(zpBuffer) == IS_ARRAY) || (Z_TYPE_P(zpBuffer) == IS_NULL) || ((Z_TYPE_P(zpBuffer) == IS_OBJECT) && (Z_OBJCE_P(zpBuffer) == TSBPointer_ce_ptr))) && PZVAL_IS_REF(zl4Size) && (IS_LONG == Z_TYPE_P(zl4Size)))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetPointerFromZVal(zpBuffer, &piBuffer TSRMLS_CC)) RETURN_FALSE;
		l4SizeRaw = (int32_t)Z_LVAL_P(zl4Size);
		SBCheckError(SBUtils_StringToBinary(sS, (int32_t)sS_len, piBuffer.data, &l4SizeRaw, &bOutResultRaw) TSRMLS_CC);
		SBFreePointerZValInfo(&piBuffer);
		ZVAL_LONG(zl4Size, (long)l4SizeRaw);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, TSBPointer|array of byte|string|NULL, &integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareGUID)
{
	zval *oGuid1;
	zval *oGuid2;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &oGuid1, TGuid_ce_ptr, &oGuid2, TGuid_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_CompareGUID((TGuid *)SBGetStructPointer(oGuid1 TSRMLS_CC), (TGuid *)SBGetStructPointer(oGuid2 TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TGuid, TGuid)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, AnsiStringOfBytes)
{
	SBArrayZValInfo aiSrc;
	uint32_t _err;
	zval *zaSrc;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaSrc) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSrc)) || (IS_ARRAY == Z_TYPE_P(zaSrc)) || (IS_NULL == Z_TYPE_P(zaSrc))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaSrc, &aiSrc TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_AnsiStringOfBytes(aiSrc.data, aiSrc.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1378782394, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiSrc);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ArrayStartsWith)
{
	SBArrayZValInfo aiP;
	SBArrayZValInfo aiSubP;
	zval *zaP;
	zval *zaSubP;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaSubP, &zaP) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSubP)) || (IS_ARRAY == Z_TYPE_P(zaSubP)) || (IS_NULL == Z_TYPE_P(zaSubP))) && ((IS_STRING == Z_TYPE_P(zaP)) || (IS_ARRAY == Z_TYPE_P(zaP)) || (IS_NULL == Z_TYPE_P(zaP))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaSubP, &aiSubP TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaP, &aiP TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_ArrayStartsWith(aiSubP.data, aiSubP.len, aiP.data, aiP.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSubP);
		SBFreeArrayZValInfo(&aiP);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareArrays)
{
	SBArrayZValInfo aiBuf1;
	SBArrayZValInfo aiBuf2;
	zval *zaBuf1;
	zval *zaBuf2;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuf1, &zaBuf2) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf1)) || (IS_ARRAY == Z_TYPE_P(zaBuf1)) || (IS_NULL == Z_TYPE_P(zaBuf1))) && ((IS_STRING == Z_TYPE_P(zaBuf2)) || (IS_ARRAY == Z_TYPE_P(zaBuf2)) || (IS_NULL == Z_TYPE_P(zaBuf2))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuf1, &aiBuf1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaBuf2, &aiBuf2 TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_CompareArrays(aiBuf1.data, aiBuf1.len, aiBuf2.data, aiBuf2.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuf1);
		SBFreeArrayZValInfo(&aiBuf2);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CreateByteArrayConst)
{
	char *sSrc;
	int sSrc_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSrc, &sSrc_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_CreateByteArrayConst(sSrc, (int32_t)sSrc_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(700284479, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, AnsiStringOfString)
{
	char *sStr;
	int sStr_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_AnsiStringOfString(sStr, (int32_t)sStr_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2059271177, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, StringOfAnsiString)
{
	char *sStr;
	int sStr_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_StringOfAnsiString(sStr, (int32_t)sStr_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-131376200, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, BytesOfAnsiString)
{
	char *sStr;
	int sStr_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sStr, &sStr_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_BytesOfAnsiString(sStr, (int32_t)sStr_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1698864356, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetByteArrayFromByte)
{
	long l4Position;
	long u1Value;
	SBArrayZValInfo aiDest;
	uint32_t _err;
	zval *zaDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u1Value) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_GetByteArrayFromByte((uint8_t)u1Value, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(40203230, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &u1Value, &zaDest, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDest)) || (IS_ARRAY == Z_TYPE_P(zaDest)) || (IS_NULL == Z_TYPE_P(zaDest))))
	{
		if (!SBGetByteArrayFromZVal(zaDest, &aiDest TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetByteArrayFromByte_1((uint8_t)u1Value, aiDest.data, aiDest.len, (int32_t)l4Position) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDest);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetByteArrayFromWordLE)
{
	long l4Position;
	long u2Value;
	SBArrayZValInfo aiDest;
	uint32_t _err;
	zval *zaDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_GetByteArrayFromWordLE((uint16_t)u2Value, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1946958969, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &u2Value, &zaDest, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDest)) || (IS_ARRAY == Z_TYPE_P(zaDest)) || (IS_NULL == Z_TYPE_P(zaDest))))
	{
		if (!SBGetByteArrayFromZVal(zaDest, &aiDest TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetByteArrayFromWordLE_1((uint16_t)u2Value, aiDest.data, aiDest.len, (int32_t)l4Position) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDest);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetByteArrayFromWordBE)
{
	long l4Position;
	long u2Value;
	SBArrayZValInfo aiDest;
	uint32_t _err;
	zval *zaDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u2Value) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_GetByteArrayFromWordBE((uint16_t)u2Value, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(891864303, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &u2Value, &zaDest, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDest)) || (IS_ARRAY == Z_TYPE_P(zaDest)) || (IS_NULL == Z_TYPE_P(zaDest))))
	{
		if (!SBGetByteArrayFromZVal(zaDest, &aiDest TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetByteArrayFromWordBE_1((uint16_t)u2Value, aiDest.data, aiDest.len, (int32_t)l4Position) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDest);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetByteArrayFromDWordLE)
{
	long l4Position;
	long u4Value;
	SBArrayZValInfo aiDest;
	uint32_t _err;
	zval *zaDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_GetByteArrayFromDWordLE((uint32_t)u4Value, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(834427421, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &u4Value, &zaDest, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDest)) || (IS_ARRAY == Z_TYPE_P(zaDest)) || (IS_NULL == Z_TYPE_P(zaDest))))
	{
		if (!SBGetByteArrayFromZVal(zaDest, &aiDest TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetByteArrayFromDWordLE_1((uint32_t)u4Value, aiDest.data, aiDest.len, (int32_t)l4Position) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDest);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetByteArrayFromDWordBE)
{
	long l4Position;
	long u4Value;
	SBArrayZValInfo aiDest;
	uint32_t _err;
	zval *zaDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Value) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_GetByteArrayFromDWordBE((uint32_t)u4Value, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-495757651, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &u4Value, &zaDest, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDest)) || (IS_ARRAY == Z_TYPE_P(zaDest)) || (IS_NULL == Z_TYPE_P(zaDest))))
	{
		if (!SBGetByteArrayFromZVal(zaDest, &aiDest TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetByteArrayFromDWordBE_1((uint32_t)u4Value, aiDest.data, aiDest.len, (int32_t)l4Position) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDest);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetByteArrayFromInt64LE)
{
	long l4Position;
	long l8Value;
	SBArrayZValInfo aiDest;
	uint32_t _err;
	zval *zaDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_GetByteArrayFromInt64LE((int64_t)l8Value, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1222587545, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &l8Value, &zaDest, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDest)) || (IS_ARRAY == Z_TYPE_P(zaDest)) || (IS_NULL == Z_TYPE_P(zaDest))))
	{
		if (!SBGetByteArrayFromZVal(zaDest, &aiDest TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetByteArrayFromInt64LE_1((int64_t)l8Value, aiDest.data, aiDest.len, (int32_t)l4Position) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDest);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetByteArrayFromInt64BE)
{
	long l4Position;
	long l8Value;
	SBArrayZValInfo aiDest;
	uint32_t _err;
	zval *zaDest;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_GetByteArrayFromInt64BE((int64_t)l8Value, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1374823952, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzl", &l8Value, &zaDest, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaDest)) || (IS_ARRAY == Z_TYPE_P(zaDest)) || (IS_NULL == Z_TYPE_P(zaDest))))
	{
		if (!SBGetByteArrayFromZVal(zaDest, &aiDest TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetByteArrayFromInt64BE_1((int64_t)l8Value, aiDest.data, aiDest.len, (int32_t)l4Position) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiDest);
	}
	else
	{
		SBErrorExpectsArguments("(integer) or (integer, array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetWordLEFromByteArray)
{
	long l4Position;
	SBArrayZValInfo aiSource;
	zval *zaSource;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaSource, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSource)) || (IS_ARRAY == Z_TYPE_P(zaSource)) || (IS_NULL == Z_TYPE_P(zaSource))))
	{
		uint16_t u2OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaSource, &aiSource TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetWordLEFromByteArray(aiSource.data, aiSource.len, (int32_t)l4Position, &u2OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSource);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetWordBEFromByteArray)
{
	long l4Position;
	SBArrayZValInfo aiSource;
	zval *zaSource;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaSource, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSource)) || (IS_ARRAY == Z_TYPE_P(zaSource)) || (IS_NULL == Z_TYPE_P(zaSource))))
	{
		uint16_t u2OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaSource, &aiSource TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetWordBEFromByteArray(aiSource.data, aiSource.len, (int32_t)l4Position, &u2OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSource);
		RETURN_LONG((long)u2OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetDWordLEFromByteArray)
{
	long l4Position;
	SBArrayZValInfo aiSource;
	zval *zaSource;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaSource, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSource)) || (IS_ARRAY == Z_TYPE_P(zaSource)) || (IS_NULL == Z_TYPE_P(zaSource))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaSource, &aiSource TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetDWordLEFromByteArray(aiSource.data, aiSource.len, (int32_t)l4Position, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSource);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetDWordBEFromByteArray)
{
	long l4Position;
	SBArrayZValInfo aiSource;
	zval *zaSource;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaSource, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSource)) || (IS_ARRAY == Z_TYPE_P(zaSource)) || (IS_NULL == Z_TYPE_P(zaSource))))
	{
		uint32_t u4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaSource, &aiSource TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetDWordBEFromByteArray(aiSource.data, aiSource.len, (int32_t)l4Position, &u4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSource);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetInt64LEFromByteArray)
{
	long l4Position;
	SBArrayZValInfo aiSource;
	zval *zaSource;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaSource, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSource)) || (IS_ARRAY == Z_TYPE_P(zaSource)) || (IS_NULL == Z_TYPE_P(zaSource))))
	{
		int64_t l8OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaSource, &aiSource TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetInt64LEFromByteArray(aiSource.data, aiSource.len, (int32_t)l4Position, &l8OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSource);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetInt64BEFromByteArray)
{
	long l4Position;
	SBArrayZValInfo aiSource;
	zval *zaSource;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaSource, &l4Position) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaSource)) || (IS_ARRAY == Z_TYPE_P(zaSource)) || (IS_NULL == Z_TYPE_P(zaSource))))
	{
		int64_t l8OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaSource, &aiSource TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_GetInt64BEFromByteArray(aiSource.data, aiSource.len, (int32_t)l4Position, &l8OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiSource);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, WideStringOf)
{
	SBArrayZValInfo aiValue;
	uint32_t _err;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_WideStringOf(aiValue.data, aiValue.len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-768215152, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiValue);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, WideBytesOf)
{
	char *sValue;
	int sValue_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = SBUtils_WideBytesOf(sValue, (int32_t)sValue_len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(209870186, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, EmptyAnsiString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_EmptyAnsiString(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(370153900, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SBConcatArrays)
{
	long u1Buf1;
	long u1Buf2;
	SBArrayZValInfo aiBuf1;
	SBArrayZValInfo aiBuf2;
	SBArrayZValInfo aiBuf3;
	uint32_t _err;
	zval *zaBuf1;
	zval *zaBuf2;
	zval *zaBuf3;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuf1, &zaBuf2) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf1)) || (IS_ARRAY == Z_TYPE_P(zaBuf1)) || (IS_NULL == Z_TYPE_P(zaBuf1))) && ((IS_STRING == Z_TYPE_P(zaBuf2)) || (IS_ARRAY == Z_TYPE_P(zaBuf2)) || (IS_NULL == Z_TYPE_P(zaBuf2))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuf1, &aiBuf1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaBuf2, &aiBuf2 TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_SBConcatArrays(aiBuf1.data, aiBuf1.len, aiBuf2.data, aiBuf2.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-834541946, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf1);
		SBFreeArrayZValInfo(&aiBuf2);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zzz", &zaBuf1, &zaBuf2, &zaBuf3) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf1)) || (IS_ARRAY == Z_TYPE_P(zaBuf1)) || (IS_NULL == Z_TYPE_P(zaBuf1))) && ((IS_STRING == Z_TYPE_P(zaBuf2)) || (IS_ARRAY == Z_TYPE_P(zaBuf2)) || (IS_NULL == Z_TYPE_P(zaBuf2))) && ((IS_STRING == Z_TYPE_P(zaBuf3)) || (IS_ARRAY == Z_TYPE_P(zaBuf3)) || (IS_NULL == Z_TYPE_P(zaBuf3))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuf1, &aiBuf1 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaBuf2, &aiBuf2 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaBuf3, &aiBuf3 TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_SBConcatArrays_1(aiBuf1.data, aiBuf1.len, aiBuf2.data, aiBuf2.len, aiBuf3.data, aiBuf3.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1206072546, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf1);
		SBFreeArrayZValInfo(&aiBuf2);
		SBFreeArrayZValInfo(&aiBuf3);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zl", &zaBuf1, &u1Buf2) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf1)) || (IS_ARRAY == Z_TYPE_P(zaBuf1)) || (IS_NULL == Z_TYPE_P(zaBuf1))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuf1, &aiBuf1 TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_SBConcatArrays_2(aiBuf1.data, aiBuf1.len, (uint8_t)u1Buf2, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-993808878, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf1);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lz", &u1Buf1, &zaBuf2) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf2)) || (IS_ARRAY == Z_TYPE_P(zaBuf2)) || (IS_NULL == Z_TYPE_P(zaBuf2))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuf2, &aiBuf2 TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_SBConcatArrays_3((uint8_t)u1Buf1, aiBuf2.data, aiBuf2.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-184156563, 2, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf2);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "llz", &u1Buf1, &u1Buf2, &zaBuf3) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf3)) || (IS_ARRAY == Z_TYPE_P(zaBuf3)) || (IS_NULL == Z_TYPE_P(zaBuf3))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuf3, &aiBuf3 TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_SBConcatArrays_4((uint8_t)u1Buf1, (uint8_t)u1Buf2, aiBuf3.data, aiBuf3.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-569433315, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf3);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lzz", &u1Buf1, &zaBuf2, &zaBuf3) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuf2)) || (IS_ARRAY == Z_TYPE_P(zaBuf2)) || (IS_NULL == Z_TYPE_P(zaBuf2))) && ((IS_STRING == Z_TYPE_P(zaBuf3)) || (IS_ARRAY == Z_TYPE_P(zaBuf3)) || (IS_NULL == Z_TYPE_P(zaBuf3))))
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuf2, &aiBuf2 TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaBuf3, &aiBuf3 TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_SBConcatArrays_5((uint8_t)u1Buf1, aiBuf2.data, aiBuf2.len, aiBuf3.data, aiBuf3.len, u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(-1739972686, 3, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuf2);
		SBFreeArrayZValInfo(&aiBuf3);
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL) or (array of byte|string|NULL, array of byte|string|NULL, array of byte|string|NULL) or (array of byte|string|NULL, integer) or (integer, array of byte|string|NULL) or (integer, integer, array of byte|string|NULL) or (integer, array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ArrayEndsWith)
{
	SBArrayZValInfo aiBuffer;
	SBArrayZValInfo aiSubstr;
	zval *zaBuffer;
	zval *zaSubstr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaBuffer, &zaSubstr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))) && ((IS_STRING == Z_TYPE_P(zaSubstr)) || (IS_ARRAY == Z_TYPE_P(zaSubstr)) || (IS_NULL == Z_TYPE_P(zaSubstr))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaSubstr, &aiSubstr TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_ArrayEndsWith(aiBuffer.data, aiBuffer.len, aiSubstr.data, aiSubstr.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiBuffer);
		SBFreeArrayZValInfo(&aiSubstr);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateStrToDate)
{
	char *sTime;
	int sTime_len;
	int64_t dtADateTimeRaw;
	zval *dtADateTime;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO", &sTime, &sTime_len, &dtADateTime, php_date_get_date_ce()) == SUCCESS) && PZVAL_IS_REF(dtADateTime))
	{
		int8_t bOutResultRaw = 0;
		dtADateTimeRaw = SBGetDateTime(dtADateTime TSRMLS_CC);
		SBCheckError(SBUtils_DateStrToDate(sTime, (int32_t)sTime_len, &dtADateTimeRaw, &bOutResultRaw) TSRMLS_CC);
		SBSetDateTime(dtADateTime, dtADateTimeRaw TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ParseRFC822TimeString)
{
	char *sRFC822TimeString;
	int sRFC822TimeString_len;
	int64_t dtADateTimeRaw;
	zval *dtADateTime;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO", &sRFC822TimeString, &sRFC822TimeString_len, &dtADateTime, php_date_get_date_ce()) == SUCCESS) && PZVAL_IS_REF(dtADateTime))
	{
		int8_t bOutResultRaw = 0;
		dtADateTimeRaw = SBGetDateTime(dtADateTime TSRMLS_CC);
		SBCheckError(SBUtils_ParseRFC822TimeString(sRFC822TimeString, (int32_t)sRFC822TimeString_len, &dtADateTimeRaw, &bOutResultRaw) TSRMLS_CC);
		SBSetDateTime(dtADateTime, dtADateTimeRaw TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, RFC822TimeToDateTime)
{
	char *sRFC822Time;
	int sRFC822Time_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sRFC822Time, &sRFC822Time_len) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_RFC822TimeToDateTime(sRFC822Time, (int32_t)sRFC822Time_len, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, UTCTimeToDate)
{
	char *sUTCTime;
	int sUTCTime_len;
	zend_bool bFourDigitYear;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sUTCTime, &sUTCTime_len, &bFourDigitYear) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_UTCTimeToDate(sUTCTime, (int32_t)sUTCTime_len, (int8_t)bFourDigitYear, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, UTCTimeToTime)
{
	char *sUTCTime;
	int sUTCTime_len;
	zend_bool bFourDigitYear;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sUTCTime, &sUTCTime_len, &bFourDigitYear) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_UTCTimeToTime(sUTCTime, (int32_t)sUTCTime_len, (int8_t)bFourDigitYear, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, UTCTimeToDateTime)
{
	char *sUTCTime;
	int sUTCTime_len;
	zend_bool bFourDigitYear;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sUTCTime, &sUTCTime_len, &bFourDigitYear) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_UTCTimeToDateTime(sUTCTime, (int32_t)sUTCTime_len, (int8_t)bFourDigitYear, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GeneralizedTimeToDate)
{
	char *sGenTime;
	int sGenTime_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sGenTime, &sGenTime_len) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_GeneralizedTimeToDate(sGenTime, (int32_t)sGenTime_len, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GeneralizedTimeToTime)
{
	char *sGenTime;
	int sGenTime_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sGenTime, &sGenTime_len) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_GeneralizedTimeToTime(sGenTime, (int32_t)sGenTime_len, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GeneralizedTimeToDateTime)
{
	char *sGenTime;
	int sGenTime_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sGenTime, &sGenTime_len) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_GeneralizedTimeToDateTime(sGenTime, (int32_t)sGenTime_len, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeToUTCTime)
{
	uint32_t _err;
	zend_bool bFourDigitYear;
	zval *dtADateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &dtADateTime, php_date_get_date_ce(), &bFourDigitYear) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DateTimeToUTCTime(SBGetDateTime(dtADateTime TSRMLS_CC), (int8_t)bFourDigitYear, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1703632596, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeToGeneralizedTime)
{
	char *sDateTimeSplitPtn;
	int sDateTimeSplitPtn_len;
	uint32_t _err;
	zval *dtADateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtADateTime, php_date_get_date_ce()) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DateTimeToGeneralizedTime(SBGetDateTime(dtADateTime TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2132420721, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Os", &dtADateTime, php_date_get_date_ce(), &sDateTimeSplitPtn, &sDateTimeSplitPtn_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DateTimeToGeneralizedTime_1(SBGetDateTime(dtADateTime TSRMLS_CC), sDateTimeSplitPtn, (int32_t)sDateTimeSplitPtn_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(473367156, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime) or (DateTime, string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, UniversalDateTimeToRFC822DateTimeString)
{
	uint32_t _err;
	zval *dtDT;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtDT, php_date_get_date_ce()) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_UniversalDateTimeToRFC822DateTimeString(SBGetDateTime(dtDT TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(319177019, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, RFC822TimeStringToUniversalTime)
{
	char *sTS;
	int sTS_len;
	int64_t dtDTRaw;
	zval *dtDT;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO", &sTS, &sTS_len, &dtDT, php_date_get_date_ce()) == SUCCESS) && PZVAL_IS_REF(dtDT))
	{
		int8_t bOutResultRaw = 0;
		dtDTRaw = SBGetDateTime(dtDT TSRMLS_CC);
		SBCheckError(SBUtils_RFC822TimeStringToUniversalTime(sTS, (int32_t)sTS_len, &dtDTRaw, &bOutResultRaw) TSRMLS_CC);
		SBSetDateTime(dtDT, dtDTRaw TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, &DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, LocalDateTimeToRFC822DateTimeString)
{
	uint32_t _err;
	zval *dtADateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtADateTime, php_date_get_date_ce()) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_LocalDateTimeToRFC822DateTimeString(SBGetDateTime(dtADateTime TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-823938919, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SystemDateTimeToRFC822DateTimeString)
{
	uint32_t _err;
	zval *dtADateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtADateTime, php_date_get_date_ce()) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_SystemDateTimeToRFC822DateTimeString(SBGetDateTime(dtADateTime TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(671805795, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

#ifndef SB_WINDOWS
SB_PHP_FUNCTION(SBUtils, FileTimeToUnixTime)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oValue, _FILETIME_ce_ptr) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(SBUtils_FileTimeToUnixTime((_FILETIME *)SBGetStructPointer(oValue TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(_FILETIME)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, UnixTimeToFileTime)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		_FILETIME roOutResult;
		SBCheckError(SBUtils_UnixTimeToFileTime((int64_t)l8Value, &roOutResult) TSRMLS_CC);
		object_init_ex(return_value, _FILETIME_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(_FILETIME) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}
#endif

SB_PHP_FUNCTION(SBUtils, FileTimeToDateTime)
{
	zval *oValue;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oValue, windows_FILETIME_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oValue, _FILETIME_ce_ptr) == SUCCESS)
#endif
	{
		int64_t dtOutResultRaw = 0;
#ifdef SB_WINDOWS
		SBCheckError(SBUtils_FileTimeToDateTime((windows_FILETIME *)SBGetStructPointer(oValue TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
#else
		SBCheckError(SBUtils_FileTimeToDateTime((_FILETIME *)SBGetStructPointer(oValue TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
#endif
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(windows_FILETIME)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(_FILETIME)" TSRMLS_CC);
#endif
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeToFileTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
#ifdef SB_WINDOWS
		windows_FILETIME roOutResult;
#else
		_FILETIME roOutResult;
#endif
		SBCheckError(SBUtils_DateTimeToFileTime(SBGetDateTime(dtValue TSRMLS_CC), &roOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		object_init_ex(return_value, windows_FILETIME_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(windows_FILETIME) TSRMLS_CC);
#else
		object_init_ex(return_value, _FILETIME_ce_ptr);
		SBSetStruct(return_value, &roOutResult, sizeof(_FILETIME) TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, UnixTimeToDateTime)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_UnixTimeToDateTime((int64_t)l8Value, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeToUnixTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(SBUtils_DateTimeToUnixTime(SBGetDateTime(dtValue TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ConstLength)
{
	SBArrayZValInfo aiArr;
	zval *zaArr;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaArr) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaArr)) || (IS_ARRAY == Z_TYPE_P(zaArr)) || (IS_NULL == Z_TYPE_P(zaArr))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaArr, &aiArr TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_ConstLength(aiArr.data, aiArr.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiArr);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, TickDiff)
{
	long u4Current;
	long u4Previous;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ll", &u4Previous, &u4Current) == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBUtils_TickDiff((uint32_t)u4Previous, (uint32_t)u4Current, &u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GenerateGUID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_GenerateGUID(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1578346608, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, IsTextualOID)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_IsTextualOID(sS, (int32_t)sS_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

#ifndef SB_WINDOWS
SB_PHP_FUNCTION(SBUtils, GetTickCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBUtils_GetTickCount(&u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif

SB_PHP_FUNCTION(SBUtils, WaitFor)
{
#ifdef SB_WINDOWS
	long u4Handle;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &u4Handle) == SUCCESS)
#else
	zval *oThread;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oThread, TThread_ce_ptr) == SUCCESS)
#endif
	{
		uint32_t u4OutResultRaw = 0;
#ifdef SB_WINDOWS
		SBCheckError(SBUtils_WaitFor((uint32_t)u4Handle, &u4OutResultRaw) TSRMLS_CC);
#else
		SBCheckError(SBUtils_WaitFor(SBGetObjectHandle(oThread TSRMLS_CC), &u4OutResultRaw) TSRMLS_CC);
#endif
		RETURN_LONG((long)u4OutResultRaw);
#ifdef SB_WINDOWS
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

#else
	}
	else
	{
		SBErrorExpectsArguments("(TThread)" TSRMLS_CC);
	}
}
#endif

SB_PHP_FUNCTION(SBUtils, LocalTimeToUTCTime)
{
	zval *dtLocalTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtLocalTime, php_date_get_date_ce()) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_LocalTimeToUTCTime(SBGetDateTime(dtLocalTime TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, UTCTimeToLocalTime)
{
	zval *dtUtcTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtUtcTime, php_date_get_date_ce()) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_UTCTimeToLocalTime(SBGetDateTime(dtUtcTime TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, UTCNow)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_UTCNow(&dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, RegisterGlobalObject)
{
	zval *oO;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oO, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBUtils_RegisterGlobalObject(SBGetObjectHandle(oO TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, UnregisterGlobalObject)
{
	zval *oO;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oO, TObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBUtils_UnregisterGlobalObject(SBGetObjectHandle(oO TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TObject)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CleanupRegisteredGlobalObjects)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBUtils_CleanupRegisteredGlobalObjects() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, AcquireGlobalLock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBUtils_AcquireGlobalLock() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ReleaseGlobalLock)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBUtils_ReleaseGlobalLock() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, HexDump)
{
	long u4Len;
	long u4Offset;
	SBArrayZValInfo aiBuffer;
	uint32_t _err;
	zend_bool bAddChars;
	zval *zaBuffer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zll", &zaBuffer, &u4Offset, &u4Len) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_HexDump(aiBuffer.data, aiBuffer.len, (uint32_t)u4Offset, (uint32_t)u4Len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1874064255, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zllb", &zaBuffer, &u4Offset, &u4Len, &bAddChars) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaBuffer)) || (IS_ARRAY == Z_TYPE_P(zaBuffer)) || (IS_NULL == Z_TYPE_P(zaBuffer))))
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		if (!SBGetByteArrayFromZVal(zaBuffer, &aiBuffer TSRMLS_CC)) RETURN_FALSE;
		_err = SBUtils_HexDump_1(aiBuffer.data, aiBuffer.len, (uint32_t)u4Offset, (uint32_t)u4Len, (int8_t)bAddChars, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-865532511, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		SBFreeArrayZValInfo(&aiBuffer);
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, integer, integer) or (array of byte|string|NULL, integer, integer, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SBSameDateTime)
{
	zval *dtA;
	zval *dtB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &dtA, php_date_get_date_ce(), &dtB, php_date_get_date_ce()) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_SBSameDateTime(SBGetDateTime(dtA TSRMLS_CC), SBGetDateTime(dtB TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SBSameDate)
{
	zval *dtA;
	zval *dtB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &dtA, php_date_get_date_ce(), &dtB, php_date_get_date_ce()) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_SBSameDate(SBGetDateTime(dtA TSRMLS_CC), SBGetDateTime(dtB TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SBSameTime)
{
	zval *dtA;
	zval *dtB;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "OO", &dtA, php_date_get_date_ce(), &dtB, php_date_get_date_ce()) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_SBSameTime(SBGetDateTime(dtA TSRMLS_CC), SBGetDateTime(dtB TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SBEncodeDateTime)
{
	long l4Day;
	long l4Hour;
	long l4Millisecond;
	long l4Minute;
	long l4Month;
	long l4Second;
	long l4Year;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lllllll", &l4Year, &l4Month, &l4Day, &l4Hour, &l4Minute, &l4Second, &l4Millisecond) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_SBEncodeDateTime((int32_t)l4Year, (int32_t)l4Month, (int32_t)l4Day, (int32_t)l4Hour, (int32_t)l4Minute, (int32_t)l4Second, (int32_t)l4Millisecond, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, integer, integer, integer, integer, integer, integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetUTCOffsetDateTime)
{
	zval *dtADateTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_GetUTCOffsetDateTime(&dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtADateTime, php_date_get_date_ce()) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_GetUTCOffsetDateTime_1(SBGetDateTime(dtADateTime TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (DateTime)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CompareContent)
{
	SBArrayZValInfo aiContent;
	SBArrayZValInfo aiOID;
	zval *zaContent;
	zval *zaOID;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "zz", &zaContent, &zaOID) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaContent)) || (IS_ARRAY == Z_TYPE_P(zaContent)) || (IS_NULL == Z_TYPE_P(zaContent))) && ((IS_STRING == Z_TYPE_P(zaOID)) || (IS_ARRAY == Z_TYPE_P(zaOID)) || (IS_NULL == Z_TYPE_P(zaOID))))
	{
		int8_t bOutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaContent, &aiContent TSRMLS_CC)) RETURN_FALSE;
		if (!SBGetByteArrayFromZVal(zaOID, &aiOID TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(SBUtils_CompareContent(aiContent.data, aiContent.len, aiOID.data, aiOID.len, &bOutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiContent);
		SBFreeArrayZValInfo(&aiOID);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeToISO8601Time)
{
	uint32_t _err;
	zend_bool bEncodeMilliseconds;
	zval *dtTime;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &dtTime, php_date_get_date_ce(), &bEncodeMilliseconds) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DateTimeToISO8601Time(SBGetDateTime(dtTime TSRMLS_CC), (int8_t)bEncodeMilliseconds, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(474562419, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ISO8601TimeToDateTime)
{
	char *sEncodedTime;
	int sEncodedTime_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sEncodedTime, &sEncodedTime_len) == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(SBUtils_ISO8601TimeToDateTime(sEncodedTime, (int32_t)sEncodedTime_len, &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DateTimeToRFC3339)
{
	uint32_t _err;
	zend_bool bEncodeMilliseconds;
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Ob", &dtValue, php_date_get_date_ce(), &bEncodeMilliseconds) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_DateTimeToRFC3339(SBGetDateTime(dtValue TSRMLS_CC), (int8_t)bEncodeMilliseconds, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1455106995, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime, bool)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, SetLicenseKey)
{
	char *sKey;
	int sKey_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sKey, &sKey_len) == SUCCESS)
	{
		SBCheckError(SBUtils_SetLicenseKey(sKey, (int32_t)sKey_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, CheckLicenseKey)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBUtils_CheckLicenseKey() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetCompanyName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_GetCompanyName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1550285523, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetUserName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_GetUserName(sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1127740658, 0, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetLicense)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBLicenseTypesRaw fOutResultRaw = 0;
		SBCheckError(SBUtils_GetLicense(&fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBUtils_GetVersion(&l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetTimeLen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBUtils_GetTimeLen(&u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetRemainingDays)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(SBUtils_GetRemainingDays(&l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, IntCheckA)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBUtils_IntCheckA() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, IntCheckB)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBUtils_IntCheckB() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, ShowNagScreen)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(SBUtils_ShowNagScreen() TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, AppendSlash)
{
	char *sPath;
	int sPath_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPath, &sPath_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBUtils_AppendSlash(sPath, (int32_t)sPath_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(192340390, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, EnsureDirectoryExists)
{
	char *sDirName;
	int sDirName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDirName, &sDirName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_EnsureDirectoryExists(sDirName, (int32_t)sDirName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, DirectoryExists)
{
	char *sDirName;
	int sDirName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sDirName, &sDirName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(SBUtils_DirectoryExists(sDirName, (int32_t)sDirName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

#ifndef SB_WINDOWS
SB_PHP_FUNCTION(SBUtils, GetCurrentThreadID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint32_t u4OutResultRaw = 0;
		SBCheckError(SBUtils_GetCurrentThreadID(&u4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)u4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}
#endif

SB_PHP_FUNCTION(SBUtils, SetDefaultExceptionHandler)
{
	zval *oHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oHandler, TElCustomExceptionHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(SBUtils_SetDefaultExceptionHandler(SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomExceptionHandler)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBUtils, GetDefaultExceptionHandler)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBUtils_GetDefaultExceptionHandler(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomExceptionHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBUtils_Constants(int module_number TSRMLS_DC)
{
	SB_REGISTER_STRING_CONSTANT(SBUtils, SBB_VERSION_NUMBER, SBB_VERSION_NUMBER, SBB_VERSION_NUMBER);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SBB_VERSION_RELEASE_NUMBER, SBB_VERSION_RELEASE_NUMBER, SBB_VERSION_RELEASE_NUMBER);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SBB_HOMEPAGE, SBB_HOMEPAGE, SBB_HOMEPAGE);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_FACILITY_INTERNAL, SB_ERROR_FACILITY_INTERNAL, SB_ERROR_FACILITY_INTERNAL);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_FACILITY_CRYPTO_BASE, SB_ERROR_FACILITY_CRYPTO_BASE, SB_ERROR_FACILITY_CRYPTO_BASE);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_FACILITY_PDF, SB_ERROR_FACILITY_PDF, SB_ERROR_FACILITY_PDF);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_FACILITY_XML, SB_ERROR_FACILITY_XML, SB_ERROR_FACILITY_XML);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_FACILITY_SOAP, SB_ERROR_FACILITY_SOAP, SB_ERROR_FACILITY_SOAP);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_FACILITY_OFFICE, SB_ERROR_FACILITY_OFFICE, SB_ERROR_FACILITY_OFFICE);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_LICENSE_TRIAL_RESTRICTION, SB_ERROR_LICENSE_TRIAL_RESTRICTION, SB_ERROR_LICENSE_TRIAL_RESTRICTION);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_LICENSE_FUNCTION_NOT_LICENSED, SB_ERROR_LICENSE_FUNCTION_NOT_LICENSED, SB_ERROR_LICENSE_FUNCTION_NOT_LICENSED);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_LICENSE_KEY_EXPIRED, SB_ERROR_LICENSE_KEY_EXPIRED, SB_ERROR_LICENSE_KEY_EXPIRED);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_LICENSE_KEY_NOT_SET, SB_ERROR_LICENSE_KEY_NOT_SET, SB_ERROR_LICENSE_KEY_NOT_SET);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_LICENSE_KEY_INVALID, SB_ERROR_LICENSE_KEY_INVALID, SB_ERROR_LICENSE_KEY_INVALID);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_LICENSE_KEY_BIZCRYPTO, SB_ERROR_LICENSE_KEY_BIZCRYPTO, SB_ERROR_LICENSE_KEY_BIZCRYPTO);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_LICENSE_KEY_NOT_BIZCRYPTO, SB_ERROR_LICENSE_KEY_NOT_BIZCRYPTO, SB_ERROR_LICENSE_KEY_NOT_BIZCRYPTO);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_LICENSE_KEY_CANNOT_BE_USED_WITH_APP, SB_ERROR_LICENSE_KEY_CANNOT_BE_USED_WITH_APP, SB_ERROR_LICENSE_KEY_CANNOT_BE_USED_WITH_APP);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_CRYPTO_NOT_IMPLEMENTED, SB_ERROR_CRYPTO_NOT_IMPLEMENTED, SB_ERROR_CRYPTO_NOT_IMPLEMENTED);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_CRYPTO_RSA_ANTITIMING_NOT_INIT, SB_ERROR_CRYPTO_RSA_ANTITIMING_NOT_INIT, SB_ERROR_CRYPTO_RSA_ANTITIMING_NOT_INIT);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_CRYPTO_DSA_KEY_NOT_LOADED, SB_ERROR_CRYPTO_DSA_KEY_NOT_LOADED, SB_ERROR_CRYPTO_DSA_KEY_NOT_LOADED);
	SB_REGISTER_LONG_CONSTANT(SBUtils, ERROR_CRYPTO_DSA_KEY_FORMAT_INVALID, SB_ERROR_CRYPTO_DSA_KEY_FORMAT_INVALID, SB_ERROR_CRYPTO_DSA_KEY_FORMAT_INVALID);
	SB_REGISTER_STRING_CONSTANT(SBUtils, COREDLL, SB_COREDLL, SB_COREDLL);
	SB_REGISTER_STRING_CONSTANT(SBUtils, OLE32, SB_OLE32, SB_OLE32);
	SB_REGISTER_STRING_CONSTANT(SBUtils, KERNEL32, SB_KERNEL32, SB_KERNEL32);
	SB_REGISTER_STRING_CONSTANT(SBUtils, NTDLL, SB_NTDLL, SB_NTDLL);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SRegexUnsupported, SB_SRegexUnsupported, SB_SRegexUnsupported);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SInvalidInputSize, SB_SInvalidInputSize, SB_SInvalidInputSize);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SInvalidKeySize, SB_SInvalidKeySize, SB_SInvalidKeySize);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SInvalidUInt16BufferOffset, SB_SInvalidUInt16BufferOffset, SB_SInvalidUInt16BufferOffset);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SInvalidUInt32BufferOffset, SB_SInvalidUInt32BufferOffset, SB_SInvalidUInt32BufferOffset);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SInvalidOID, SB_SInvalidOID, SB_SInvalidOID);
	SB_REGISTER_STRING_CONSTANT(SBUtils, sOutputBufferTooSmall, SB_sOutputBufferTooSmall, SB_sOutputBufferTooSmall);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SUnicodeNotInitialized, SB_SUnicodeNotInitialized, SB_SUnicodeNotInitialized);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SUnsupportedCharset, SB_SUnsupportedCharset, SB_SUnsupportedCharset);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SOperationCancelled, SB_SOperationCancelled, SB_SOperationCancelled);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SArrayIndexOutOfBounds, SB_SArrayIndexOutOfBounds, SB_SArrayIndexOutOfBounds);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SStringIndexOutOfBounds, SB_SStringIndexOutOfBounds, SB_SStringIndexOutOfBounds);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SArrayLengthOutOfBounds, SB_SArrayLengthOutOfBounds, SB_SArrayLengthOutOfBounds);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SBufferCannotBeNull, SB_SBufferCannotBeNull, SB_SBufferCannotBeNull);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SStringCannotBeNull, SB_SStringCannotBeNull, SB_SStringCannotBeNull);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SLicenseKeyNotSet, SB_SLicenseKeyNotSet, SB_SLicenseKeyNotSet);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SInvalidDateToken, SB_SInvalidDateToken, SB_SInvalidDateToken);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SInvalidTimeToken, SB_SInvalidTimeToken, SB_SInvalidTimeToken);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SOldLicenseKey, SB_SOldLicenseKey, SB_SOldLicenseKey);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SUnknownLicenseKey, SB_SUnknownLicenseKey, SB_SUnknownLicenseKey);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SLicenseKeyExpired, SB_SLicenseKeyExpired, SB_SLicenseKeyExpired);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SLicenseTypeNotEnabled, SB_SLicenseTypeNotEnabled, SB_SLicenseTypeNotEnabled);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SBadOrOldLicenseKey, SB_SBadOrOldLicenseKey, SB_SBadOrOldLicenseKey);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SAutomaticKeyExpired, SB_SAutomaticKeyExpired, SB_SAutomaticKeyExpired);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SBadLicenseKeyFormat, SB_SBadLicenseKeyFormat, SB_SBadLicenseKeyFormat);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SLicenseKeyCannotBeUsedWithApp, SB_SLicenseKeyCannotBeUsedWithApp, SB_SLicenseKeyCannotBeUsedWithApp);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SSeekOffsetRangeError, SB_SSeekOffsetRangeError, SB_SSeekOffsetRangeError);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SBase32InvalidDataSize, SB_SBase32InvalidDataSize, SB_SBase32InvalidDataSize);
	SB_REGISTER_STRING_CONSTANT(SBUtils, SBase32InvalidData, SB_SBase32InvalidData, SB_SBase32InvalidData);
}

void Register_SBUtils_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBLicenseType", NULL);
	TSBLicenseType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBLicenseType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltPKI", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltSSLC", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltSSLS", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltSSHC", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltSSHS", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltSFTP", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltSFTPS", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltPGP", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltMIME", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltTrial", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltPDF", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltXML", 11)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltFTPSC", 12)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltHTTPC", 13)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltBizTalk", 14)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltZIP", 15)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltEDI", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltOffice", 17)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltEmpty", 18)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltDummy1", 19)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltDummy2", 20)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltCloud", 21)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltXMPP", 22)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltFTPSS", 23)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltHTTPS", 24)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltWebDAVCli", 25)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltDC", 26)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltMail", 27)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltWebDAVSrv", 28)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltLDAP", 29)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseType_ce_ptr, "ltSAML", 30)
	
	INIT_CLASS_ENTRY(ce, "TSBLicenseTypes", NULL);
	TSBLicenseTypes_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBLicenseTypes_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltPKI", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltSSLC", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltSSLS", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltSSHC", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltSSHS", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltSFTP", 32)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltSFTPS", 64)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltPGP", 128)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltMIME", 256)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltTrial", 512)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltPDF", 1024)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltXML", 2048)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltFTPSC", 4096)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltHTTPC", 8192)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltBizTalk", 16384)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltZIP", 32768)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltEDI", 65536)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltOffice", 131072)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltEmpty", 262144)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltDummy1", 524288)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltDummy2", 1048576)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltCloud", 2097152)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltXMPP", 4194304)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltFTPSS", 8388608)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltHTTPS", 16777216)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltWebDAVCli", 33554432)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltDC", 67108864)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltMail", 134217728)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltWebDAVSrv", 268435456)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltLDAP", 536870912)
	SB_DECLARE_CLASS_LONG_CONST(TSBLicenseTypes_ce_ptr, "ltSAML", 1073741824)
	
	INIT_CLASS_ENTRY(ce, "TSBExceptionHandlerDestination", NULL);
	TSBExceptionHandlerDestination_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBExceptionHandlerDestination_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBExceptionHandlerDestination_ce_ptr, "ehdDefault", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBExceptionHandlerDestination_ce_ptr, "ehdDebug", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBExceptionHandlerDestination_ce_ptr, "ehdTrace", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBExceptionHandlerDestination_ce_ptr, "ehdStdErr", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBExceptionHandlerDestination_ce_ptr, "ehdStdOut", 4)
}

void Register_SBUtils_Aliases(TSRMLS_D)
{
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	zend_register_class_alias("TSBComponentBase", TComponent_ce_ptr);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	zend_register_class_alias("TSBControlBase", TComponent_ce_ptr);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	zend_register_class_alias("TSBDisposableBase", TObject_ce_ptr);
	if (NULL == TList_ce_ptr)
		Register_TList(TSRMLS_C);
	zend_register_class_alias("TElList", TList_ce_ptr);
	if (NULL == TList_ce_ptr)
		Register_TList(TSRMLS_C);
	zend_register_class_alias("TElIntegerList", TList_ce_ptr);
#ifdef SB_WINDOWS
	if (NULL == TStringList_ce_ptr)
		Register_TStringList(TSRMLS_C);
	zend_register_class_alias("TElStringList", TStringList_ce_ptr);
#endif
}
