#include "sbwinazuredatastorage.h"

zend_class_entry *TSBWinAzureObjectAccessCondition_ce_ptr = NULL;

zend_class_entry *TSBWinAzureContainerAccessLevel_ce_ptr = NULL;

void SB_CALLBACK TSBWinAzureBeforeRequestSigningEventRaw(void * _ObjectData, TObjectHandle Sender, TElHTTPSClientHandle HttpClient)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zHttpClient;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zHttpClient);
	SBInitObject(zHttpClient, TElHTTPSClient_ce_ptr, HttpClient TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zHttpClient;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zHttpClient);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElWinAzureDataStorage_ce_ptr = NULL;

SB_PHP_METHOD(TElWinAzureDataStorage, AcquireObject)
{
	char *sContainerName;
	char *sObjName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sObjName_len;
	int sSharedAccessSignature_len;
	zval *oContainer;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_AcquireObject(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_AcquireObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &sObjName, &sObjName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_AcquireObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainer TSRMLS_CC), sObjName, (int32_t)sObjName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_AcquireObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &sObjName, &sObjName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_AcquireObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainer TSRMLS_CC), sObjName, (int32_t)sObjName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_AcquireObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_AcquireObject_6(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (string, string, TStringList) or (TElWinAzureDataStorageContainer, string) or (string, string, string) or (TElWinAzureDataStorageContainer, string, string) or (string, string, string, TStringList) or ()" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (string, string, TElStringList) or (TElWinAzureDataStorageContainer, string) or (string, string, string) or (TElWinAzureDataStorageContainer, string, string) or (string, string, string, TElStringList) or ()" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, List)
{
	char *sContainerName;
	char *sDelimiter;
	char *sPrefix;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sDelimiter_len;
	int sPrefix_len;
	int sSharedAccessSignature_len;
	long l4MaxCount;
	zend_bool bIncludeMetadata;
	zend_bool bIncludeSnapshots;
	zend_bool bIncludeUncommittedBlobs;
	zval *oContainer;
	zval *oHeaders;
	zval *oObjects;
	zval *oObjs;
	zval *oPrefixes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sContainerName, &sContainerName_len, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_List(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sContainerName, &sContainerName_len, &oObjects, TElDataStorageObjectList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sContainerName, &sContainerName_len, &oObjects, TElDataStorageObjectList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_List_1(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, SBGetObjectHandle(oObjects TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sslO!O!", &sContainerName, &sContainerName_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sslO!O!", &sContainerName, &sContainerName_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_List_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, SBGetObjectHandle(oObjects TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, (int32_t)l4MaxCount, SBGetObjectHandle(oPrefixes TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sslO!bbbO!", &sContainerName, &sContainerName_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sslO!bbbO!", &sContainerName, &sContainerName_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TElStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_List_3(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, SBGetObjectHandle(oObjects TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, (int32_t)l4MaxCount, SBGetObjectHandle(oPrefixes TSRMLS_CC), (int8_t)bIncludeSnapshots, (int8_t)bIncludeMetadata, (int8_t)bIncludeUncommittedBlobs, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_List_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainer TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oObjects, TElDataStorageObjectList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oObjects, TElDataStorageObjectList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_List_5(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oObjects TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sslO!O!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sslO!O!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_List_6(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oObjects TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, (int32_t)l4MaxCount, SBGetObjectHandle(oPrefixes TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sslO!bbbO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sslO!bbbO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TElStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_List_7(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oObjects TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, (int32_t)l4MaxCount, SBGetObjectHandle(oPrefixes TSRMLS_CC), (int8_t)bIncludeSnapshots, (int8_t)bIncludeMetadata, (int8_t)bIncludeUncommittedBlobs, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjs, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_List_8(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjs TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TElDataStorageObjectList) or (string, TElDataStorageObjectList, TStringList) or (string, TElDataStorageObjectList, string, string, integer, TStringList, TStringList) or (string, TElDataStorageObjectList, string, string, integer, TStringList, bool, bool, bool, TStringList) or (TElWinAzureDataStorageContainer, TElDataStorageObjectList) or (string, string, TElDataStorageObjectList, TStringList) or (string, string, TElDataStorageObjectList, string, string, integer, TStringList, TStringList) or (string, string, TElDataStorageObjectList, string, string, integer, TStringList, bool, bool, bool, TStringList) or (TElDataStorageObjectList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElDataStorageObjectList) or (string, TElDataStorageObjectList, TElStringList) or (string, TElDataStorageObjectList, string, string, integer, TElStringList, TElStringList) or (string, TElDataStorageObjectList, string, string, integer, TElStringList, bool, bool, bool, TElStringList) or (TElWinAzureDataStorageContainer, TElDataStorageObjectList) or (string, string, TElDataStorageObjectList, TElStringList) or (string, string, TElDataStorageObjectList, string, string, integer, TElStringList, TElStringList) or (string, string, TElDataStorageObjectList, string, string, integer, TElStringList, bool, bool, bool, TElStringList) or (TElDataStorageObjectList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, ListInit)
{
	char *sContainerName;
	char *sDelimiter;
	char *sPrefix;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sDelimiter_len;
	int sPrefix_len;
	int sSharedAccessSignature_len;
	zend_bool bIncludeMetadata;
	zend_bool bIncludeSnapshots;
	zend_bool bIncludeUncommittedBlobs;
	zval *oHeaders;
	zval *oPrefixes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sContainerName, &sContainerName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_ListInit(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!O!", &sContainerName, &sContainerName_len, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!O!", &sContainerName, &sContainerName_len, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_ListInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, SBGetObjectHandle(oPrefixes TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!bbbO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!bbbO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TElStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_ListInit_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, SBGetObjectHandle(oPrefixes TSRMLS_CC), (int8_t)bIncludeSnapshots, (int8_t)bIncludeMetadata, (int8_t)bIncludeUncommittedBlobs, SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (string, string, string, TStringList, TStringList) or (string, string, string, string, TStringList, bool, bool, bool, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (string, string, string, TElStringList, TElStringList) or (string, string, string, string, TElStringList, bool, bool, bool, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, ListNext)
{
	long l4MaxCount;
	zval *oObjects;
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oState, TElWinAzureDataStorageListState_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ListNext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oState, TElWinAzureDataStorageListState_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr, &l4MaxCount) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ListNext_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC), (int32_t)l4MaxCount) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWinAzureDataStorageListState, TElDataStorageObjectList) or (TElWinAzureDataStorageListState, TElDataStorageObjectList, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, ListFinal)
{
	TElClassHandle hoState;
	zval *oState;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oState, TElWinAzureDataStorageListState_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oState) && (IS_OBJECT == Z_TYPE_P(oState)))
	{
		hoState = SBGetObjectHandle(oState TSRMLS_CC);
		SBCheckError(TElWinAzureDataStorage_ListFinal(SBGetObjectHandle(getThis() TSRMLS_CC), &hoState) TSRMLS_CC);
		SBUpdateObjectHandle(oState, hoState TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElWinAzureDataStorageListState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, CreateObject)
{
	char *sContainerName;
	char *sContentEncoding;
	char *sContentLanguage;
	char *sContentMD5;
	char *sContentType;
	char *sObjName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sContentEncoding_len;
	int sContentLanguage_len;
	int sContentMD5_len;
	int sContentType_len;
	int sObjName_len;
	int sSharedAccessSignature_len;
	long l8InitialSize;
	zval *oContainer;
	zval *oHandler;
	zval *oHeaders;
	zval *oMetadata;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &sObjName, &sObjName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainer TSRMLS_CC), sObjName, (int32_t)sObjName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &sObjName, &sObjName_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainer TSRMLS_CC), sObjName, (int32_t)sObjName_len, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssl", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &l8InitialSize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sl", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &sObjName, &sObjName_len, &l8InitialSize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainer TSRMLS_CC), sObjName, (int32_t)sObjName_len, (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!l", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_6(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!l", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &sObjName, &sObjName_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_7(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainer TSRMLS_CC), sObjName, (int32_t)sObjName_len, SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!O!O!l", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!O!O!l", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_8(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssssO!O!l", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssssO!O!l", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_9(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_10(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_11(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssls", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &l8InitialSize, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_12(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, (int64_t)l8InitialSize, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!O!sO!l", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!O!sO!l", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_13(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssssO!O!sl", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssssO!O!sl", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &l8InitialSize) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateObject_14(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (TElWinAzureDataStorageContainer, string) or (string, string, TElCustomDataStorageSecurityHandler) or (TElWinAzureDataStorageContainer, string, TElCustomDataStorageSecurityHandler) or (string, string, integer) or (TElWinAzureDataStorageContainer, string, integer) or (string, string, TElCustomDataStorageSecurityHandler, integer) or (TElWinAzureDataStorageContainer, string, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, string, string, TStringList, TStringList, integer) or (string, string, string) or (string, string, string, TElCustomDataStorageSecurityHandler) or (string, string, integer, string) or (string, string, string, string, string, TStringList, TStringList, string, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, string, string, TStringList, TStringList, string, integer)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (TElWinAzureDataStorageContainer, string) or (string, string, TElCustomDataStorageSecurityHandler) or (TElWinAzureDataStorageContainer, string, TElCustomDataStorageSecurityHandler) or (string, string, integer) or (TElWinAzureDataStorageContainer, string, integer) or (string, string, TElCustomDataStorageSecurityHandler, integer) or (TElWinAzureDataStorageContainer, string, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, string, string, TElStringList, TElStringList, integer) or (string, string, string) or (string, string, string, TElCustomDataStorageSecurityHandler) or (string, string, integer, string) or (string, string, string, string, string, TElStringList, TElStringList, string, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, string, string, TElStringList, TElStringList, string, integer)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, DeleteObject)
{
	char *sContainerName;
	char *sName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sName_len;
	int sSharedAccessSignature_len;
	TElClassHandle hoObj;
	zval *oHeaders;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sContainerName, &sContainerName_len, &sName, &sName_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_DeleteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oObj, TElWinAzureDataStorageObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oObj) && (IS_OBJECT == Z_TYPE_P(oObj)))
	{
		hoObj = SBGetObjectHandle(oObj TSRMLS_CC);
		SBCheckError(TElWinAzureDataStorage_DeleteObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoObj) TSRMLS_CC);
		SBUpdateObjectHandle(oObj, hoObj TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_DeleteObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_DeleteObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Os", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS) && PZVAL_IS_REF(oObj) && (IS_OBJECT == Z_TYPE_P(oObj)))
	{
		hoObj = SBGetObjectHandle(oObj TSRMLS_CC);
		SBCheckError(TElWinAzureDataStorage_DeleteObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), &hoObj, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len) TSRMLS_CC);
		SBUpdateObjectHandle(oObj, hoObj TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_DeleteObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oObj, TElCustomDataStorageObject_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oObj) && (IS_OBJECT == Z_TYPE_P(oObj)))
	{
		hoObj = SBGetObjectHandle(oObj TSRMLS_CC);
		SBCheckError(TElWinAzureDataStorage_DeleteObject_6(SBGetObjectHandle(getThis() TSRMLS_CC), &hoObj) TSRMLS_CC);
		SBUpdateObjectHandle(oObj, hoObj TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (&TElWinAzureDataStorageObject) or (string, string, TStringList) or (string, string, string) or (&TElWinAzureDataStorageObject, string) or (string, string, string, TStringList) or (&TElCustomDataStorageObject)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (&TElWinAzureDataStorageObject) or (string, string, TElStringList) or (string, string, string) or (&TElWinAzureDataStorageObject, string) or (string, string, string, TElStringList) or (&TElCustomDataStorageObject)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, ObjectExists)
{
	char *sContainerName;
	char *sName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sName_len;
	int sSharedAccessSignature_len;
	zval *oHeaders;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sContainerName, &sContainerName_len, &sName, &sName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_ObjectExists(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElWinAzureDataStorageObject_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_ObjectExists_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_ObjectExists_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_ObjectExists_3(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_ObjectExists_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_ObjectExists_5(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (TElWinAzureDataStorageObject) or (string, string, TStringList) or (string, string, string) or (TElWinAzureDataStorageObject, string) or (string, string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (TElWinAzureDataStorageObject) or (string, string, TElStringList) or (string, string, string) or (TElWinAzureDataStorageObject, string) or (string, string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, RefreshObject)
{
	char *sSharedAccessSignature;
	int sSharedAccessSignature_len;
	zval *oHeaders;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElWinAzureDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_RefreshObject(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_RefreshObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_RefreshObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_RefreshObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TElWinAzureDataStorageObject) or (TElWinAzureDataStorageObject, string) or (TElWinAzureDataStorageObject, TStringList) or (TElWinAzureDataStorageObject, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElWinAzureDataStorageObject) or (TElWinAzureDataStorageObject, string) or (TElWinAzureDataStorageObject, TElStringList) or (TElWinAzureDataStorageObject, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, WriteObject)
{
	char *sContainerName;
	char *sContentEncoding;
	char *sContentLanguage;
	char *sContentMD5;
	char *sContentType;
	char *sLeaseID;
	char *sName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sContentEncoding_len;
	int sContentLanguage_len;
	int sContentMD5_len;
	int sContentType_len;
	int sLeaseID_len;
	int sName_len;
	int sSharedAccessSignature_len;
	long l8InitialSize;
	zval *oData;
	zval *oHandler;
	zval *oHeaders;
	zval *oMetadata;
	zval *oObj;
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sssO!O!O!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sssO!O!O!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sssO!O!O!s", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &sLeaseID, &sLeaseID_len) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sssO!O!O!s", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &sLeaseID, &sLeaseID_len) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), sLeaseID, (int32_t)sLeaseID_len) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!ssssO!O!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!ssssO!O!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!sssO!O!O!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!sssO!O!O!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ssssO!O!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ssssO!O!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!l", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_6(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sssO!O!O!l", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sssO!O!O!l", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_7(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!ssssO!O!l", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!ssssO!O!l", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_8(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), (int64_t)l8InitialSize) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!sssO!O!O!l", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!sssO!O!O!l", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_9(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ssssO!O!l", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!ssssO!O!l", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_10(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), (int64_t)l8InitialSize) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!O!", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_11(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!sssO!O!O!", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!sssO!O!O!", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_12(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!ssssO!O!", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!ssssO!O!", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_13(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!sssO!O!O!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!sssO!O!O!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_14(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!ssssO!O!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!ssssO!O!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_15(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!O!l", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_16(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!sssO!O!O!l", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!sssO!O!O!l", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_17(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!ssssO!O!l", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!ssssO!O!l", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_18(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), (int64_t)l8InitialSize) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!sssO!O!O!l", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!sssO!O!O!l", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_19(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!ssssO!O!l", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!ssssO!O!l", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_20(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), (int64_t)l8InitialSize) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sssO!O!O!ls", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize, &sLeaseID, &sLeaseID_len) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sssO!O!O!ls", &sContainerName, &sContainerName_len, &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize, &sLeaseID, &sLeaseID_len) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_21(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize, sLeaseID, (int32_t)sLeaseID_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_WriteObject_22(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, TStream, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler, string) or (string, string, TStream, string, string, string, string, TStringList, TStringList) or (TElWinAzureDataStorageObject, TStream, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler) or (TElWinAzureDataStorageObject, TStream, string, string, string, string, TStringList, TStringList) or (string, string, TStream, TElCustomDataStorageSecurityHandler, integer) or (string, string, TStream, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler, integer) or (string, string, TStream, string, string, string, string, TStringList, TStringList, integer) or (TElWinAzureDataStorageObject, TStream, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler, integer) or (TElWinAzureDataStorageObject, TStream, string, string, string, string, TStringList, TStringList, integer) or (string, string, string, TStream, TElCustomDataStorageSecurityHandler) or (string, string, string, TStream, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler) or (string, string, string, TStream, string, string, string, string, TStringList, TStringList) or (TElWinAzureDataStorageObject, string, TStream, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler) or (TElWinAzureDataStorageObject, string, TStream, string, string, string, string, TStringList, TStringList) or (string, string, string, TStream, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, TStream, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, TStream, string, string, string, string, TStringList, TStringList, integer) or (TElWinAzureDataStorageObject, string, TStream, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler, integer) or (TElWinAzureDataStorageObject, string, TStream, string, string, string, string, TStringList, TStringList, integer) or (string, string, TStream, string, string, string, TStringList, TStringList, TElCustomDataStorageSecurityHandler, integer, string) or (TElCustomDataStorageObject, TStream, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, TStream, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler, string) or (string, string, TStream, string, string, string, string, TElStringList, TElStringList) or (TElWinAzureDataStorageObject, TStream, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler) or (TElWinAzureDataStorageObject, TStream, string, string, string, string, TElStringList, TElStringList) or (string, string, TStream, TElCustomDataStorageSecurityHandler, integer) or (string, string, TStream, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler, integer) or (string, string, TStream, string, string, string, string, TElStringList, TElStringList, integer) or (TElWinAzureDataStorageObject, TStream, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler, integer) or (TElWinAzureDataStorageObject, TStream, string, string, string, string, TElStringList, TElStringList, integer) or (string, string, string, TStream, TElCustomDataStorageSecurityHandler) or (string, string, string, TStream, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler) or (string, string, string, TStream, string, string, string, string, TElStringList, TElStringList) or (TElWinAzureDataStorageObject, string, TStream, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler) or (TElWinAzureDataStorageObject, string, TStream, string, string, string, string, TElStringList, TElStringList) or (string, string, string, TStream, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, TStream, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, TStream, string, string, string, string, TElStringList, TElStringList, integer) or (TElWinAzureDataStorageObject, string, TStream, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler, integer) or (TElWinAzureDataStorageObject, string, TStream, string, string, string, string, TElStringList, TElStringList, integer) or (string, string, TStream, string, string, string, TElStringList, TElStringList, TElCustomDataStorageSecurityHandler, integer, string) or (TElCustomDataStorageObject, TStream, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, ReadObject)
{
	char *sContainerName;
	char *sETag;
	char *sName;
	char *sObjContentEncoding;
	char *sObjContentLanguage;
	char *sObjContentMD5;
	char *sObjContentType;
	char *sObjETag;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sETag_len;
	int sName_len;
	int sSharedAccessSignature_len;
	int32_t sObjContentEncoding_len;
	int32_t sObjContentLanguage_len;
	int32_t sObjContentMD5_len;
	int32_t sObjContentType_len;
	int32_t sObjETag_len;
	long fCondition;
	long l8SeqNum;
	uint32_t _err;
	zval *dtDateTime;
	zval *oHeaders;
	zval *oMetadata;
	zval *oObj;
	zval *oStrm;
	zval *zsObjContentEncoding;
	zval *zsObjContentLanguage;
	zval *zsObjContentMD5;
	zval *zsObjContentType;
	zval *zsObjETag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ReadObject(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOsl", &sContainerName, &sContainerName_len, &sName, &sName_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ReadObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lOsl", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ReadObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOslO!O!zzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOslO!O!zzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(2096733016, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(850246078, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(2096733016, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(850246078, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(2096733016, 12, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(850246078, 12, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(2096733016, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(850246078, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOslO!O!zzzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOslO!O!zzzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1206000800, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-798792180, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1206000800, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-798792180, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1206000800, 12, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-798792180, 12, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1206000800, 13, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-798792180, 13, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1206000800, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-798792180, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lOslO!O!zzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lOslO!O!zzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1073216985, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1011066192, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1073216985, 10, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1011066192, 10, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1073216985, 11, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1011066192, 11, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1073216985, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1011066192, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lOslO!O!zzzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lOslO!O!zzzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadObject_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(391253383, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2144126848, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(391253383, 10, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2144126848, 10, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(391253383, 11, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2144126848, 11, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(391253383, 12, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2144126848, 12, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(391253383, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2144126848, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ReadObject_7(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!lOsl", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ReadObject_8(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!lOsl", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ReadObject_9(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!lOslO!O!zzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!lOslO!O!zzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadObject_10(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1921897369, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(775847248, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1921897369, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(775847248, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1921897369, 13, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(775847248, 13, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1921897369, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(775847248, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!lOslO!O!zzzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!lOslO!O!zzzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadObject_11(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(309143727, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(209197801, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(309143727, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(209197801, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(309143727, 13, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(209197801, 13, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(309143727, 14, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(209197801, 14, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(309143727, 15, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(209197801, 15, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!lOslO!O!zzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!lOslO!O!zzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadObject_12(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(574472894, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-2121147172, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(574472894, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-2121147172, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(574472894, 12, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-2121147172, 12, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(574472894, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-2121147172, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!lOslO!O!zzzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!lOslO!O!zzzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadObject_13(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1759800182, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2137613379, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1759800182, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2137613379, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1759800182, 12, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2137613379, 12, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1759800182, 13, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2137613379, 13, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1759800182, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2137613379, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ReadObject_14(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, TStream) or (string, string, TStream, integer, DateTime, string, integer) or (TElWinAzureDataStorageObject, TStream, integer, DateTime, string, integer) or (string, string, TStream, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string) or (string, string, TStream, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, TStream, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, TStream, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string, &string) or (string, string, string, TStream) or (string, string, string, TStream, integer, DateTime, string, integer) or (TElWinAzureDataStorageObject, string, TStream, integer, DateTime, string, integer) or (string, string, string, TStream, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string) or (string, string, string, TStream, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, string, TStream, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, string, TStream, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string, &string) or (TElCustomDataStorageObject, TStream)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, TStream) or (string, string, TStream, integer, DateTime, string, integer) or (TElWinAzureDataStorageObject, TStream, integer, DateTime, string, integer) or (string, string, TStream, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string) or (string, string, TStream, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, TStream, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, TStream, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string, &string) or (string, string, string, TStream) or (string, string, string, TStream, integer, DateTime, string, integer) or (TElWinAzureDataStorageObject, string, TStream, integer, DateTime, string, integer) or (string, string, string, TStream, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string) or (string, string, string, TStream, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, string, TStream, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, string, TStream, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string, &string) or (TElCustomDataStorageObject, TStream)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, ReadBlock)
{
	char *sContainerName;
	char *sETag;
	char *sName;
	char *sObjContentEncoding;
	char *sObjContentLanguage;
	char *sObjContentMD5;
	char *sObjContentType;
	char *sObjETag;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sETag_len;
	int sName_len;
	int sSharedAccessSignature_len;
	int32_t sObjContentEncoding_len;
	int32_t sObjContentLanguage_len;
	int32_t sObjContentMD5_len;
	int32_t sObjContentType_len;
	int32_t sObjETag_len;
	int64_t l8ReadRaw;
	long fCondition;
	long l8Offset;
	long l8SeqNum;
	long l8Size;
	uint32_t _err;
	zval *dtDateTime;
	zval *oHeaders;
	zval *oMetadata;
	zval *oObj;
	zval *oStrm;
	zval *zl8Read;
	zval *zsObjContentEncoding;
	zval *zsObjContentLanguage;
	zval *zsObjContentMD5;
	zval *zsObjContentType;
	zval *zsObjETag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llz", &sContainerName, &sContainerName_len, &sName, &sName_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorage_ReadBlock(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOsl", &sContainerName, &sContainerName_len, &sName, &sName_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorage_ReadBlock_1(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llzlOsl", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorage_ReadBlock_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOslO!O!zzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOslO!O!zzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadBlock_3(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(190400745, 13, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2026521438, 13, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(190400745, 14, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2026521438, 14, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(190400745, 15, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2026521438, 15, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(190400745, 16, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2026521438, 16, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOslO!O!zzzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOslO!O!zzzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadBlock_4(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(804295628, 13, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1885858739, 13, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(804295628, 14, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1885858739, 14, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(804295628, 15, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1885858739, 15, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(804295628, 16, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1885858739, 16, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(804295628, 17, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1885858739, 17, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llzlOslO!O!zzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llzlOslO!O!zzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadBlock_5(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1366881981, 12, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1841044930, 12, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1366881981, 13, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1841044930, 13, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1366881981, 14, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1841044930, 14, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1366881981, 15, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1841044930, 15, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llzlOslO!O!zzzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llzlOslO!O!zzzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadBlock_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1932685021, 12, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1093692455, 12, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1932685021, 13, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1093692455, 13, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1932685021, 14, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1093692455, 14, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1932685021, 15, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1093692455, 15, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1932685021, 16, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1093692455, 16, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!llz", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorage_ReadBlock_7(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!llzlOsl", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorage_ReadBlock_8(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!llzlOsl", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorage_ReadBlock_9(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!llzlOslO!O!zzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!llzlOslO!O!zzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadBlock_10(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(838250439, 14, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2065245410, 14, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(838250439, 15, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2065245410, 15, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(838250439, 16, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2065245410, 16, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(838250439, 17, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2065245410, 17, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!llzlOslO!O!zzzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!llzlOslO!O!zzzzz", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadBlock_11(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(20194205, 14, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1245158687, 14, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(20194205, 15, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1245158687, 15, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(20194205, 16, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1245158687, 16, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(20194205, 17, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1245158687, 17, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(20194205, 18, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1245158687, 18, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!llzlOslO!O!zzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!llzlOslO!O!zzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadBlock_12(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1832145622, 13, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1246667640, 13, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1832145622, 14, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1246667640, 14, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1832145622, 15, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1246667640, 15, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1832145622, 16, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1246667640, 16, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!llzlOslO!O!zzzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!llzlOslO!O!zzzzz", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorage_ReadBlock_13(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(524743416, 13, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-763552576, 13, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(524743416, 14, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-763552576, 14, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(524743416, 15, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-763552576, 15, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(524743416, 16, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-763552576, 16, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(524743416, 17, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-763552576, 17, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!llz", &oObj, TElCustomDataStorageObject_ce_ptr, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorage_ReadBlock_14(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, TStream, integer, integer, &integer) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (TElWinAzureDataStorageObject, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string, &string) or (string, string, string, TStream, integer, integer, &integer) or (string, string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (TElWinAzureDataStorageObject, string, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (string, string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string) or (string, string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, TStringList, &string, &string, &string, &string, &string) or (TElCustomDataStorageObject, TStream, integer, integer, &integer)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, TStream, integer, integer, &integer) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (TElWinAzureDataStorageObject, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string, &string) or (string, string, string, TStream, integer, integer, &integer) or (string, string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (TElWinAzureDataStorageObject, string, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (string, string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string) or (string, string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string) or (TElWinAzureDataStorageObject, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, TElStringList, &string, &string, &string, &string, &string) or (TElCustomDataStorageObject, TStream, integer, integer, &integer)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, CopyObject)
{
	char *sDestContainerName;
	char *sDestETag;
	char *sDestName;
	char *sDestSharedAccessSignature;
	char *sETag;
	char *sLeaseID;
	char *sSharedAccessSignature;
	char *sSourceContainerName;
	char *sSourceName;
	int sDestContainerName_len;
	int sDestETag_len;
	int sDestName_len;
	int sDestSharedAccessSignature_len;
	int sETag_len;
	int sLeaseID_len;
	int sSharedAccessSignature_len;
	int sSourceContainerName_len;
	int sSourceName_len;
	long fCondition;
	long fDestCondition;
	zend_bool bPreserveMetadata;
	zend_bool bWait;
	zval *dtDateTime;
	zval *dtDestDateTime;
	zval *oHeaders;
	zval *oMetadata;
	zval *oNewHandler;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceContainerName, (int32_t)sSourceContainerName_len, sSourceName, (int32_t)sSourceName_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssO!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CopyObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssbO!", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssbO!", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CopyObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceContainerName, (int32_t)sSourceContainerName_len, sSourceName, (int32_t)sSourceName_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssslOslOsbO!O!", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssslOslOsbO!O!", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CopyObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceContainerName, (int32_t)sSourceContainerName_len, sSourceName, (int32_t)sSourceName_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (TSBWinAzureObjectAccessConditionRaw)fDestCondition, SBGetDateTime(dtDestDateTime TSRMLS_CC), sDestETag, (int32_t)sDestETag_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssslOslOsbO!O!sb", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &sLeaseID, &sLeaseID_len, &bWait) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssslOslOsbO!O!sb", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &sLeaseID, &sLeaseID_len, &bWait) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CopyObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceContainerName, (int32_t)sSourceContainerName_len, sSourceName, (int32_t)sSourceName_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (TSBWinAzureObjectAccessConditionRaw)fDestCondition, SBGetDateTime(dtDestDateTime TSRMLS_CC), sDestETag, (int32_t)sDestETag_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sLeaseID, (int32_t)sLeaseID_len, (int8_t)bWait, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssssO!", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CopyObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceContainerName, (int32_t)sSourceContainerName_len, sSourceName, (int32_t)sSourceName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, sDestSharedAccessSignature, (int32_t)sDestSharedAccessSignature_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ssssO!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CopyObject_6(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, sDestSharedAccessSignature, (int32_t)sDestSharedAccessSignature_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssssbO!", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssssbO!", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CopyObject_7(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceContainerName, (int32_t)sSourceContainerName_len, sSourceName, (int32_t)sSourceName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, sDestSharedAccessSignature, (int32_t)sDestSharedAccessSignature_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssslOslOsbO!O!", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssslOslOsbO!O!", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CopyObject_8(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceContainerName, (int32_t)sSourceContainerName_len, sSourceName, (int32_t)sSourceName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, sDestSharedAccessSignature, (int32_t)sDestSharedAccessSignature_len, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (TSBWinAzureObjectAccessConditionRaw)fDestCondition, SBGetDateTime(dtDestDateTime TSRMLS_CC), sDestETag, (int32_t)sDestETag_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssslOslOsbO!O!sb", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr, &sLeaseID, &sLeaseID_len, &bWait) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssslOslOsbO!O!sb", &sSourceContainerName, &sSourceContainerName_len, &sSourceName, &sSourceName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr, &sLeaseID, &sLeaseID_len, &bWait) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CopyObject_9(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceContainerName, (int32_t)sSourceContainerName_len, sSourceName, (int32_t)sSourceName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, sDestSharedAccessSignature, (int32_t)sDestSharedAccessSignature_len, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (TSBWinAzureObjectAccessConditionRaw)fDestCondition, SBGetDateTime(dtDestDateTime TSRMLS_CC), sDestETag, (int32_t)sDestETag_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), sLeaseID, (int32_t)sLeaseID_len, (int8_t)bWait, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElCustomDataStorageObject_ce_ptr, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CopyObject_10(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, string, string, TElCustomDataStorageSecurityHandler) or (TElWinAzureDataStorageObject, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, bool, TStringList) or (string, string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TStringList, TStringList) or (string, string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TStringList, TStringList, string, bool) or (string, string, string, string, string, string, TElCustomDataStorageSecurityHandler) or (TElWinAzureDataStorageObject, string, string, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, string, bool, TStringList) or (string, string, string, string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TStringList, TStringList) or (string, string, string, string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TStringList, TStringList, string, bool) or (TElCustomDataStorageObject, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, string, string, TElCustomDataStorageSecurityHandler) or (TElWinAzureDataStorageObject, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, bool, TElStringList) or (string, string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TElStringList, TElStringList) or (string, string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TElStringList, TElStringList, string, bool) or (string, string, string, string, string, string, TElCustomDataStorageSecurityHandler) or (TElWinAzureDataStorageObject, string, string, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, string, bool, TElStringList) or (string, string, string, string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TElStringList, TElStringList) or (string, string, string, string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TElStringList, TElStringList, string, bool) or (TElCustomDataStorageObject, TElCustomDataStorageSecurityHandler)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, GetObjectACL)
{
	char *sContainerName;
	char *sName;
	int sContainerName_len;
	int sName_len;
	uint32_t _err;
	zval *oHeaders;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sContainerName, &sContainerName_len, &sName, &sName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_GetObjectACL(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2101636731, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElWinAzureDataStorageObject_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_GetObjectACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1274908090, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_GetObjectACL_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1540563279, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(651981591, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (TElWinAzureDataStorageObject) or (string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (TElWinAzureDataStorageObject) or (string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, SetObjectACL)
{
	char *sACL;
	char *sContainerName;
	char *sName;
	int sACL_len;
	int sContainerName_len;
	int sName_len;
	zval *oHeaders;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sContainerName, &sContainerName_len, &sName, &sName_len, &sACL, &sACL_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_SetObjectACL(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sACL, (int32_t)sACL_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oObj, TElWinAzureDataStorageObject_ce_ptr, &sACL, &sACL_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_SetObjectACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sACL, (int32_t)sACL_len) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &sACL, &sACL_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &sACL, &sACL_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_SetObjectACL_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sACL, (int32_t)sACL_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, string) or (TElWinAzureDataStorageObject, string) or (string, string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, string) or (TElWinAzureDataStorageObject, string) or (string, string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, GetLocalETag)
{
	char *sFilename;
	int sFilename_len;
	uint32_t _err;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_GetLocalETag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1585892654, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_GetLocalETag_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1483668118, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, GetRemoteETag)
{
	char *sContainerName;
	char *sName;
	int sContainerName_len;
	int sName_len;
	uint32_t _err;
	zval *oHeaders;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sContainerName, &sContainerName_len, &sName, &sName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_GetRemoteETag(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-29835246, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElWinAzureDataStorageObject_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_GetRemoteETag_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1257512949, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sName, &sName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_GetRemoteETag_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-24199420, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(585563847, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
#endif
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string) or (TElWinAzureDataStorageObject) or (string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string) or (TElWinAzureDataStorageObject) or (string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, GetObjectAllocatedSize)
{
	char *sContainerName;
	char *sName;
	int sContainerName_len;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sContainerName, &sContainerName_len, &sName, &sName_len) == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_GetObjectAllocatedSize(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, SetObjectAllocatedSize)
{
	char *sContainerName;
	char *sName;
	int sContainerName_len;
	int sName_len;
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssl", &sContainerName, &sContainerName_len, &sName, &sName_len, &l8Value) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_SetObjectAllocatedSize(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, LockObject)
{
	char *sContainerName;
	char *sName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sName_len;
	int sSharedAccessSignature_len;
	long l4Seconds;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssls", &sContainerName, &sContainerName_len, &sName, &sName_len, &l4Seconds, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_LockObject(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, (int32_t)l4Seconds, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(339427358, 5, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, integer, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, RenewObjectLock)
{
	char *sContainerName;
	char *sLeaseID;
	char *sName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sLeaseID_len;
	int sName_len;
	int sSharedAccessSignature_len;
	long l4Seconds;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslss", &sContainerName, &sContainerName_len, &sName, &sName_len, &l4Seconds, &sSharedAccessSignature, &sSharedAccessSignature_len, &sLeaseID, &sLeaseID_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_RenewObjectLock(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, (int32_t)l4Seconds, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sLeaseID, (int32_t)sLeaseID_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, integer, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, UnlockObject)
{
	char *sContainerName;
	char *sLeaseID;
	char *sName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sLeaseID_len;
	int sName_len;
	int sSharedAccessSignature_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssss", &sContainerName, &sContainerName_len, &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sLeaseID, &sLeaseID_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_UnlockObject(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sLeaseID, (int32_t)sLeaseID_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, AcquireContainer)
{
	char *sContainerName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sSharedAccessSignature_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sContainerName, &sContainerName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_AcquireContainer(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageContainer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_AcquireContainer_1(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageContainer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, ReleaseContainer)
{
	TElClassHandle hoContainer;
	zval *oContainer;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContainer, TElWinAzureDataStorageContainer_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContainer) && (IS_OBJECT == Z_TYPE_P(oContainer)))
	{
		hoContainer = SBGetObjectHandle(oContainer TSRMLS_CC);
		SBCheckError(TElWinAzureDataStorage_ReleaseContainer(SBGetObjectHandle(getThis() TSRMLS_CC), &hoContainer) TSRMLS_CC);
		SBUpdateObjectHandle(oContainer, hoContainer TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElWinAzureDataStorageContainer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, CreateContainer)
{
	char *sContainerName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sSharedAccessSignature_len;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sContainerName, &sContainerName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateContainer(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageContainer_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sContainerName, &sContainerName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sContainerName, &sContainerName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateContainer_1(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageContainer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateContainer_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageContainer_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_CreateContainer_3(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageContainer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (string, TStringList) or (string, string) or (string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (string, TElStringList) or (string, string) or (string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, DeleteContainer)
{
	char *sContainerName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sSharedAccessSignature_len;
	TElClassHandle hoContainer;
	zval *oContainer;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sContainerName, &sContainerName_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_DeleteContainer(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oContainer, TElWinAzureDataStorageContainer_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oContainer) && (IS_OBJECT == Z_TYPE_P(oContainer)))
	{
		hoContainer = SBGetObjectHandle(oContainer TSRMLS_CC);
		SBCheckError(TElWinAzureDataStorage_DeleteContainer_1(SBGetObjectHandle(getThis() TSRMLS_CC), &hoContainer) TSRMLS_CC);
		SBUpdateObjectHandle(oContainer, hoContainer TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sContainerName, &sContainerName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sContainerName, &sContainerName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_DeleteContainer_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_DeleteContainer_3(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len) TSRMLS_CC);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "Os", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS) && PZVAL_IS_REF(oContainer) && (IS_OBJECT == Z_TYPE_P(oContainer)))
	{
		hoContainer = SBGetObjectHandle(oContainer TSRMLS_CC);
		SBCheckError(TElWinAzureDataStorage_DeleteContainer_4(SBGetObjectHandle(getThis() TSRMLS_CC), &hoContainer, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len) TSRMLS_CC);
		SBUpdateObjectHandle(oContainer, hoContainer TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_DeleteContainer_5(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (&TElWinAzureDataStorageContainer) or (string, TStringList) or (string, string) or (&TElWinAzureDataStorageContainer, string) or (string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (&TElWinAzureDataStorageContainer) or (string, TElStringList) or (string, string) or (&TElWinAzureDataStorageContainer, string) or (string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, ContainerExists)
{
	char *sContainerName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sSharedAccessSignature_len;
	zval *oHeaders;
	zval *oObj;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sContainerName, &sContainerName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_ContainerExists(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObj, TElWinAzureDataStorageContainer_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_ContainerExists_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sContainerName, &sContainerName_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sContainerName, &sContainerName_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_ContainerExists_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_ContainerExists_3(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!s", &oObj, TElWinAzureDataStorageContainer_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_ContainerExists_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_ContainerExists_5(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (TElWinAzureDataStorageContainer) or (string, TStringList) or (string, string) or (TElWinAzureDataStorageContainer, string) or (string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (TElWinAzureDataStorageContainer) or (string, TElStringList) or (string, string) or (TElWinAzureDataStorageContainer, string) or (string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, GetContainerACL)
{
	char *sContainerName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sSharedAccessSignature_len;
	zval *oContainer;
	zval *oHeaders;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sContainerName, &sContainerName_len, &oPolicy, TElWinAzureAccessPolicy_ce_ptr) == SUCCESS)
	{
		TSBWinAzureContainerAccessLevelRaw fOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_GetContainerACL(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, SBGetObjectHandle(oPolicy TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &oPolicy, TElWinAzureAccessPolicy_ce_ptr) == SUCCESS)
	{
		TSBWinAzureContainerAccessLevelRaw fOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_GetContainerACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainer TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sContainerName, &sContainerName_len, &oPolicy, TElWinAzureAccessPolicy_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sContainerName, &sContainerName_len, &oPolicy, TElWinAzureAccessPolicy_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TSBWinAzureContainerAccessLevelRaw fOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_GetContainerACL_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, SBGetObjectHandle(oPolicy TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oPolicy, TElWinAzureAccessPolicy_ce_ptr) == SUCCESS)
	{
		TSBWinAzureContainerAccessLevelRaw fOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_GetContainerACL_3(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oPolicy TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oPolicy, TElWinAzureAccessPolicy_ce_ptr) == SUCCESS)
	{
		TSBWinAzureContainerAccessLevelRaw fOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_GetContainerACL_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainer TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oPolicy TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oPolicy, TElWinAzureAccessPolicy_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oPolicy, TElWinAzureAccessPolicy_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TSBWinAzureContainerAccessLevelRaw fOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_GetContainerACL_5(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oPolicy TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TElWinAzureAccessPolicy) or (TElWinAzureDataStorageContainer, TElWinAzureAccessPolicy) or (string, TElWinAzureAccessPolicy, TStringList) or (string, string, TElWinAzureAccessPolicy) or (TElWinAzureDataStorageContainer, string, TElWinAzureAccessPolicy) or (string, string, TElWinAzureAccessPolicy, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TElWinAzureAccessPolicy) or (TElWinAzureDataStorageContainer, TElWinAzureAccessPolicy) or (string, TElWinAzureAccessPolicy, TElStringList) or (string, string, TElWinAzureAccessPolicy) or (TElWinAzureDataStorageContainer, string, TElWinAzureAccessPolicy) or (string, string, TElWinAzureAccessPolicy, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, SetContainerACL)
{
	char *sContainerName;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sSharedAccessSignature_len;
	long fAccessLevel;
	zval *oContainer;
	zval *oHeaders;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sContainerName, &sContainerName_len, &fAccessLevel, &oPolicy, TElWinAzureAccessPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_SetContainerACL(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, (TSBWinAzureContainerAccessLevelRaw)fAccessLevel, SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &fAccessLevel, &oPolicy, TElWinAzureAccessPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_SetContainerACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainer TSRMLS_CC), (TSBWinAzureContainerAccessLevelRaw)fAccessLevel, SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!O!", &sContainerName, &sContainerName_len, &fAccessLevel, &oPolicy, TElWinAzureAccessPolicy_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!O!", &sContainerName, &sContainerName_len, &fAccessLevel, &oPolicy, TElWinAzureAccessPolicy_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_SetContainerACL_2(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, (TSBWinAzureContainerAccessLevelRaw)fAccessLevel, SBGetObjectHandle(oPolicy TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &fAccessLevel, &oPolicy, TElWinAzureAccessPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_SetContainerACL_3(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, (TSBWinAzureContainerAccessLevelRaw)fAccessLevel, SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!slO!", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &fAccessLevel, &oPolicy, TElWinAzureAccessPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_SetContainerACL_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainer TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, (TSBWinAzureContainerAccessLevelRaw)fAccessLevel, SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslO!O!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &fAccessLevel, &oPolicy, TElWinAzureAccessPolicy_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslO!O!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &fAccessLevel, &oPolicy, TElWinAzureAccessPolicy_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_SetContainerACL_5(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, (TSBWinAzureContainerAccessLevelRaw)fAccessLevel, SBGetObjectHandle(oPolicy TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, integer, TElWinAzureAccessPolicy) or (TElWinAzureDataStorageContainer, integer, TElWinAzureAccessPolicy) or (string, integer, TElWinAzureAccessPolicy, TStringList) or (string, string, integer, TElWinAzureAccessPolicy) or (TElWinAzureDataStorageContainer, string, integer, TElWinAzureAccessPolicy) or (string, string, integer, TElWinAzureAccessPolicy, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, integer, TElWinAzureAccessPolicy) or (TElWinAzureDataStorageContainer, integer, TElWinAzureAccessPolicy) or (string, integer, TElWinAzureAccessPolicy, TElStringList) or (string, string, integer, TElWinAzureAccessPolicy) or (TElWinAzureDataStorageContainer, string, integer, TElWinAzureAccessPolicy) or (string, string, integer, TElWinAzureAccessPolicy, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, ListContainers)
{
	char *sPrefix;
	char *sSharedAccessSignature;
	int sPrefix_len;
	int sSharedAccessSignature_len;
	zval *oContainers;
	zval *oHeaders;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oContainers, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oContainers, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_ListContainers(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainers TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContainers, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContainers, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_ListContainers_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainers TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oContainers, TElWinAzureDataStorageContainerList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ListContainers_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainers TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContainers, TElWinAzureDataStorageContainerList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContainers, TElWinAzureDataStorageContainerList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_ListContainers_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainers TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oContainers, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oContainers, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_ListContainers_4(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oContainers TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oContainers, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oContainers, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_ListContainers_5(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oContainers TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oContainers, TElWinAzureDataStorageContainerList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ListContainers_6(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oContainers TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oContainers, TElWinAzureDataStorageContainerList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oContainers, TElWinAzureDataStorageContainerList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_ListContainers_7(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oContainers TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sPrefix, &sPrefix_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oContainers, TElWinAzureDataStorageContainerList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sPrefix, &sPrefix_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oContainers, TElWinAzureDataStorageContainerList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorage_ListContainers_8(SBGetObjectHandle(getThis() TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oContainers TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStringList) or (TStringList, TStringList) or (TElWinAzureDataStorageContainerList) or (TElWinAzureDataStorageContainerList, TStringList) or (string, TStringList) or (string, TStringList, TStringList) or (string, TElWinAzureDataStorageContainerList) or (string, TElWinAzureDataStorageContainerList, TStringList) or (string, string, TElWinAzureDataStorageContainerList, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElStringList) or (TElStringList, TElStringList) or (TElWinAzureDataStorageContainerList) or (TElWinAzureDataStorageContainerList, TElStringList) or (string, TElStringList) or (string, TElStringList, TElStringList) or (string, TElWinAzureDataStorageContainerList) or (string, TElWinAzureDataStorageContainerList, TElStringList) or (string, string, TElWinAzureDataStorageContainerList, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, ListContainersInit)
{
	char *sPrefix;
	char *sSharedAccessSignature;
	int sPrefix_len;
	int sSharedAccessSignature_len;
	zval *oHeaders;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_ListContainersInit(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sPrefix, &sPrefix_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_ListContainersInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sPrefix, &sPrefix_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_ListContainersInit_2(SBGetObjectHandle(getThis() TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sPrefix, &sPrefix_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sPrefix, &sPrefix_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_ListContainersInit_3(SBGetObjectHandle(getThis() TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("() or (string) or (string, string) or (string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("() or (string) or (string, string) or (string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, ListContainersNext)
{
	long l4MaxCount;
	zval *oContainers;
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oState, TElWinAzureDataStorageListState_ce_ptr, &oContainers, TElWinAzureDataStorageContainerList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ListContainersNext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC), SBGetObjectHandle(oContainers TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oState, TElWinAzureDataStorageListState_ce_ptr, &oContainers, TElWinAzureDataStorageContainerList_ce_ptr, &l4MaxCount) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_ListContainersNext_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC), SBGetObjectHandle(oContainers TSRMLS_CC), (int32_t)l4MaxCount) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWinAzureDataStorageListState, TElWinAzureDataStorageContainerList) or (TElWinAzureDataStorageListState, TElWinAzureDataStorageContainerList, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, CreateSharedAccessSignature)
{
	char *sContainerName;
	char *sObjName;
	int sContainerName_len;
	int sObjName_len;
	uint32_t _err;
	zval *oContainer;
	zval *oObj;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sContainerName, &sContainerName_len, &sObjName, &sObjName_len, &oPolicy, TElWinAzureSingleAccessPolicy_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_CreateSharedAccessSignature(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sObjName, (int32_t)sObjName_len, SBGetObjectHandle(oPolicy TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1888165035, 4, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sContainerName, &sContainerName_len, &oPolicy, TElWinAzureSingleAccessPolicy_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_CreateSharedAccessSignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, SBGetObjectHandle(oPolicy TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1956109520, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oObj, TElWinAzureDataStorageObject_ce_ptr, &oPolicy, TElWinAzureSingleAccessPolicy_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_CreateSharedAccessSignature_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObj TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1288301391, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oContainer, TElWinAzureDataStorageContainer_ce_ptr, &oPolicy, TElWinAzureSingleAccessPolicy_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_CreateSharedAccessSignature_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oContainer TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(975986831, 3, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, TElWinAzureSingleAccessPolicy) or (string, TElWinAzureSingleAccessPolicy) or (TElWinAzureDataStorageObject, TElWinAzureSingleAccessPolicy) or (TElWinAzureDataStorageContainer, TElWinAzureSingleAccessPolicy)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_AccountName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_get_AccountName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-86334626, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_AccountName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_AccountName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_AccountKey)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_get_AccountKey(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1377571095, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_AccountKey)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_AccountKey(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_DevMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_get_DevMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_DevMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_DevMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_UseSSL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_get_UseSSL(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_UseSSL)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_UseSSL(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_UseCRCCheck)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_get_UseCRCCheck(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_UseCRCCheck)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_UseCRCCheck(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_UsePadding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_get_UsePadding(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_UsePadding)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_UsePadding(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_UseURLEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_get_UseURLEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_UseURLEncoding)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_UseURLEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_HTTPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_get_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_HTTPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHTTPSClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_AzureHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_get_AzureHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_UseDelayedPut)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_get_UseDelayedPut(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_UseDelayedPut)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_UseDelayedPut(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_SecMetadataID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_get_SecMetadataID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1286527383, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_SecMetadataID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_SecMetadataID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_ContentLengthMetadataID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorage_get_ContentLengthMetadataID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-104228548, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_ContentLengthMetadataID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_ContentLengthMetadataID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_DefaultMaxBlobSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_get_DefaultMaxBlobSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_DefaultMaxBlobSize)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_DefaultMaxBlobSize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_CopyTimeout)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_get_CopyTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_CopyTimeout)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_CopyTimeout(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_Overwrite)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_get_Overwrite(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_Overwrite)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_Overwrite(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_PassthroughMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_get_PassthroughMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_PassthroughMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_PassthroughMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_EmbeddedMetadataMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorage_get_EmbeddedMetadataMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_EmbeddedMetadataMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorage_set_EmbeddedMetadataMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, get_OnBeforeRequestSigning)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBWinAzureBeforeRequestSigningEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_get_OnBeforeRequestSigning(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, set_OnBeforeRequestSigning)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElWinAzureDataStorage_set_OnBeforeRequestSigning(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBWinAzureBeforeRequestSigningEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBWinAzureBeforeRequestSigningEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorage, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorage_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_AcquireObject, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Container, 0, 1)
	ZEND_ARG_INFO(0, ObjName)
	ZEND_ARG_TYPE_INFO(0, Headers_or_SharedAccessSignature, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_List, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Container_or_Objs, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Objects_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_Prefix_or_Objects, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Delimiter_or_Headers_or_Prefix, 0, 1)
	ZEND_ARG_INFO(0, MaxCount_or_Delimiter)
	ZEND_ARG_TYPE_INFO(0, Prefixes_or_MaxCount, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_IncludeSnapshots_or_Prefixes, 0, 1)
	ZEND_ARG_TYPE_INFO(0, IncludeMetadata_or_Headers_or_IncludeSnapshots, 0, 1)
	ZEND_ARG_INFO(0, IncludeUncommittedBlobs_or_IncludeMetadata)
	ZEND_ARG_TYPE_INFO(0, Headers_or_IncludeUncommittedBlobs, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_ListInit, 0, 0, 1)
	ZEND_ARG_INFO(0, ContainerName)
	ZEND_ARG_INFO(0, Prefix_or_SharedAccessSignature)
	ZEND_ARG_INFO(0, Delimiter_or_Prefix)
	ZEND_ARG_TYPE_INFO(0, Prefixes_or_Delimiter, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers_or_Prefixes, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers_or_Prefixes, TElStringList, 1)
#endif
	ZEND_ARG_INFO(0, IncludeSnapshots)
	ZEND_ARG_INFO(0, IncludeMetadata)
	ZEND_ARG_INFO(0, IncludeUncommittedBlobs)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_ListNext, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, State, TElWinAzureDataStorageListState, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
	ZEND_ARG_INFO(0, MaxCount)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_ListFinal, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, State, TElWinAzureDataStorageListState, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_CreateObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Container, 0, 1)
	ZEND_ARG_INFO(0, ObjName)
	ZEND_ARG_TYPE_INFO(0, Handler_or_InitialSize_or_ContentType_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InitialSize_or_ContentEncoding_or_Handler_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_INFO(0, ContentLanguage)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_ContentMD5, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers_or_Metadata, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers_or_Metadata, TElStringList, 1)
#endif
	ZEND_ARG_TYPE_INFO(0, Handler_or_Headers_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InitialSize_or_Handler_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_INFO(0, InitialSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_DeleteObject, 0, 0, 1)
	ZEND_ARG_INFO(1, ContainerName_or_Obj)
	ZEND_ARG_INFO(0, Name_or_SharedAccessSignature)
	ZEND_ARG_TYPE_INFO(0, Headers_or_SharedAccessSignature, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_ObjectExists, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, Name_or_SharedAccessSignature)
	ZEND_ARG_TYPE_INFO(0, Headers_or_SharedAccessSignature, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_RefreshObject, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Obj, TElWinAzureDataStorageObject, 1)
	ZEND_ARG_TYPE_INFO(0, SharedAccessSignature_or_Headers, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_WriteObject, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Name_or_Data_or_SharedAccessSignature_or_Strm, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Data_or_ContentType_or_SharedAccessSignature_or_Handler, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_ContentType_or_ContentEncoding_or_Data, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ContentEncoding_or_ContentLanguage_or_InitialSize_or_Handler_or_ContentType, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ContentLanguage_or_Metadata_or_ContentMD5_or_ContentEncoding_or_InitialSize, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_ContentMD5_or_Headers_or_ContentLanguage, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_Metadata_or_Handler_or_ContentMD5, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Headers_or_InitialSize_or_Metadata, 0, 1)
	ZEND_ARG_TYPE_INFO(0, LeaseID_or_InitialSize_or_Handler_or_Headers, 0, 1)
	ZEND_ARG_INFO(0, InitialSize_or_LeaseID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_ReadObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Name_or_Strm_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Strm_or_Condition_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Condition_or_DateTime_or_Strm, 0, 1)
	ZEND_ARG_INFO(0, DateTime_or_ETag_or_Condition)
	ZEND_ARG_INFO(0, ETag_or_SeqNum_or_DateTime)
	ZEND_ARG_TYPE_INFO(0, SeqNum_or_Metadata_or_ETag, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_Headers_or_SeqNum, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Headers_or_ObjContentType_or_Metadata, 0, 1)
	ZEND_ARG_TYPE_INFO(1, ObjContentType_or_ObjContentEncoding_or_Headers, 0, 1)
	ZEND_ARG_INFO(1, ObjContentEncoding_or_ObjContentLanguage_or_ObjContentType)
	ZEND_ARG_INFO(1, ObjContentLanguage_or_ObjETag_or_ObjContentMD5_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentMD5_or_ObjContentLanguage)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentMD5)
	ZEND_ARG_INFO(1, ObjETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_ReadBlock, 0, 0, 5)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Name_or_Strm_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Strm_or_Offset_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Offset_or_Size_or_Strm, 0, 1)
	ZEND_ARG_INFO(1, Size_or_Read_or_Offset)
	ZEND_ARG_INFO(1, Read_or_Condition_or_Size)
	ZEND_ARG_INFO(1, Condition_or_DateTime_or_Read)
	ZEND_ARG_INFO(0, DateTime_or_ETag_or_Condition)
	ZEND_ARG_INFO(0, ETag_or_SeqNum_or_DateTime)
	ZEND_ARG_TYPE_INFO(0, SeqNum_or_Metadata_or_ETag, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_Headers_or_SeqNum, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Headers_or_ObjContentType_or_Metadata, 0, 1)
	ZEND_ARG_TYPE_INFO(1, ObjContentType_or_ObjContentEncoding_or_Headers, 0, 1)
	ZEND_ARG_INFO(1, ObjContentEncoding_or_ObjContentLanguage_or_ObjContentType)
	ZEND_ARG_INFO(1, ObjContentLanguage_or_ObjETag_or_ObjContentMD5_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentMD5_or_ObjContentLanguage)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentMD5)
	ZEND_ARG_INFO(1, ObjETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_CopyObject, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, SourceContainerName_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, SourceName_or_DestContainerName_or_SharedAccessSignature_or_NewHandler, 0, 1)
	ZEND_ARG_INFO(0, DestContainerName_or_DestName_or_SharedAccessSignature)
	ZEND_ARG_TYPE_INFO(0, DestName_or_NewHandler_or_DestContainerName, 0, 1)
	ZEND_ARG_TYPE_INFO(0, NewHandler_or_PreserveMetadata_or_Condition_or_DestName_or_DestSharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_DateTime_or_DestSharedAccessSignature_or_NewHandler, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ETag_or_NewHandler_or_PreserveMetadata_or_Condition, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DestCondition_or_Metadata_or_DateTime, 0, 1)
	ZEND_ARG_INFO(0, DestDateTime_or_ETag)
	ZEND_ARG_INFO(0, DestETag_or_DestCondition)
	ZEND_ARG_INFO(0, PreserveMetadata_or_DestDateTime)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_DestETag, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_PreserveMetadata, 0, 1)
	ZEND_ARG_TYPE_INFO(0, LeaseID_or_Metadata, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Wait_or_Headers, 0, 1)
	ZEND_ARG_INFO(0, LeaseID)
	ZEND_ARG_INFO(0, Wait)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_GetObjectACL, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, Name)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_SetObjectACL, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, Name_or_ACL)
	ZEND_ARG_INFO(0, ACL)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_GetLocalETag, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Stream_or_Filename, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_GetRemoteETag, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Obj, 0, 1)
	ZEND_ARG_INFO(0, Name)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_GetObjectAllocatedSize, 0, 0, 2)
	ZEND_ARG_INFO(0, ContainerName)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_SetObjectAllocatedSize, 0, 0, 3)
	ZEND_ARG_INFO(0, ContainerName)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_LockObject, 0, 0, 4)
	ZEND_ARG_INFO(0, ContainerName)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Seconds)
	ZEND_ARG_INFO(0, SharedAccessSignature)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_RenewObjectLock, 0, 0, 5)
	ZEND_ARG_INFO(0, ContainerName)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, Seconds)
	ZEND_ARG_INFO(0, SharedAccessSignature)
	ZEND_ARG_INFO(0, LeaseID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_UnlockObject, 0, 0, 4)
	ZEND_ARG_INFO(0, ContainerName)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, SharedAccessSignature)
	ZEND_ARG_INFO(0, LeaseID)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_AcquireContainer, 0, 0, 1)
	ZEND_ARG_INFO(0, ContainerName)
	ZEND_ARG_INFO(0, SharedAccessSignature)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_ReleaseContainer, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, Container, TElWinAzureDataStorageContainer, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_CreateContainer, 0, 0, 1)
	ZEND_ARG_INFO(0, ContainerName)
	ZEND_ARG_TYPE_INFO(0, Headers_or_SharedAccessSignature, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_DeleteContainer, 0, 0, 1)
	ZEND_ARG_INFO(1, ContainerName_or_Container)
	ZEND_ARG_TYPE_INFO(0, Headers_or_SharedAccessSignature, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_ContainerExists, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Obj, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_SharedAccessSignature, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_GetContainerACL, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Container, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Policy_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_Policy, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_SetContainerACL, 0, 0, 3)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Container, 0, 1)
	ZEND_ARG_INFO(0, AccessLevel_or_SharedAccessSignature)
	ZEND_ARG_TYPE_INFO(0, Policy_or_AccessLevel, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_Policy, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_ListContainers, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Containers_or_SharedAccessSignature_or_Prefix, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_Containers_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_Containers, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_ListContainersInit, 0, 0, 0)
	ZEND_ARG_INFO(0, Prefix)
	ZEND_ARG_INFO(0, SharedAccessSignature)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_ListContainersNext, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, State, TElWinAzureDataStorageListState, 1)
	ZEND_ARG_OBJ_INFO(0, Containers, TElWinAzureDataStorageContainerList, 1)
	ZEND_ARG_INFO(0, MaxCount)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_CreateSharedAccessSignature, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, ContainerName_or_Obj_or_Container, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ObjName_or_Policy, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Policy, TElWinAzureSingleAccessPolicy, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_AccountName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_AccountName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_AccountKey, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_AccountKey, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_DevMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_DevMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_UseSSL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_UseSSL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_UseCRCCheck, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_UseCRCCheck, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_UsePadding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_UsePadding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_UseURLEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_UseURLEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_HTTPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_HTTPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHTTPSClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_AzureHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_UseDelayedPut, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_UseDelayedPut, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_SecMetadataID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_SecMetadataID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_ContentLengthMetadataID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_ContentLengthMetadataID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_DefaultMaxBlobSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_DefaultMaxBlobSize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_CopyTimeout, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_CopyTimeout, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_Overwrite, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_Overwrite, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_PassthroughMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_PassthroughMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_EmbeddedMetadataMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_EmbeddedMetadataMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_get_OnBeforeRequestSigning, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage_set_OnBeforeRequestSigning, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorage___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWinAzureDataStorage_methods[] = {
	PHP_ME(TElWinAzureDataStorage, AcquireObject, arginfo_TElWinAzureDataStorage_AcquireObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, List, arginfo_TElWinAzureDataStorage_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, ListInit, arginfo_TElWinAzureDataStorage_ListInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, ListNext, arginfo_TElWinAzureDataStorage_ListNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, ListFinal, arginfo_TElWinAzureDataStorage_ListFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, CreateObject, arginfo_TElWinAzureDataStorage_CreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, DeleteObject, arginfo_TElWinAzureDataStorage_DeleteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, ObjectExists, arginfo_TElWinAzureDataStorage_ObjectExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, RefreshObject, arginfo_TElWinAzureDataStorage_RefreshObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, WriteObject, arginfo_TElWinAzureDataStorage_WriteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, ReadObject, arginfo_TElWinAzureDataStorage_ReadObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, ReadBlock, arginfo_TElWinAzureDataStorage_ReadBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, CopyObject, arginfo_TElWinAzureDataStorage_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, GetObjectACL, arginfo_TElWinAzureDataStorage_GetObjectACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, SetObjectACL, arginfo_TElWinAzureDataStorage_SetObjectACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, GetLocalETag, arginfo_TElWinAzureDataStorage_GetLocalETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, GetRemoteETag, arginfo_TElWinAzureDataStorage_GetRemoteETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, GetObjectAllocatedSize, arginfo_TElWinAzureDataStorage_GetObjectAllocatedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, SetObjectAllocatedSize, arginfo_TElWinAzureDataStorage_SetObjectAllocatedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, LockObject, arginfo_TElWinAzureDataStorage_LockObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, RenewObjectLock, arginfo_TElWinAzureDataStorage_RenewObjectLock, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, UnlockObject, arginfo_TElWinAzureDataStorage_UnlockObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, AcquireContainer, arginfo_TElWinAzureDataStorage_AcquireContainer, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, ReleaseContainer, arginfo_TElWinAzureDataStorage_ReleaseContainer, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, CreateContainer, arginfo_TElWinAzureDataStorage_CreateContainer, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, DeleteContainer, arginfo_TElWinAzureDataStorage_DeleteContainer, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, ContainerExists, arginfo_TElWinAzureDataStorage_ContainerExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, GetContainerACL, arginfo_TElWinAzureDataStorage_GetContainerACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, SetContainerACL, arginfo_TElWinAzureDataStorage_SetContainerACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, ListContainers, arginfo_TElWinAzureDataStorage_ListContainers, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, ListContainersInit, arginfo_TElWinAzureDataStorage_ListContainersInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, ListContainersNext, arginfo_TElWinAzureDataStorage_ListContainersNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, CreateSharedAccessSignature, arginfo_TElWinAzureDataStorage_CreateSharedAccessSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_AccountName, arginfo_TElWinAzureDataStorage_get_AccountName, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_AccountName, arginfo_TElWinAzureDataStorage_set_AccountName, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_AccountKey, arginfo_TElWinAzureDataStorage_get_AccountKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_AccountKey, arginfo_TElWinAzureDataStorage_set_AccountKey, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_DevMode, arginfo_TElWinAzureDataStorage_get_DevMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_DevMode, arginfo_TElWinAzureDataStorage_set_DevMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_UseSSL, arginfo_TElWinAzureDataStorage_get_UseSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_UseSSL, arginfo_TElWinAzureDataStorage_set_UseSSL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_UseCRCCheck, arginfo_TElWinAzureDataStorage_get_UseCRCCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_UseCRCCheck, arginfo_TElWinAzureDataStorage_set_UseCRCCheck, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_UsePadding, arginfo_TElWinAzureDataStorage_get_UsePadding, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_UsePadding, arginfo_TElWinAzureDataStorage_set_UsePadding, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_UseURLEncoding, arginfo_TElWinAzureDataStorage_get_UseURLEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_UseURLEncoding, arginfo_TElWinAzureDataStorage_set_UseURLEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_HTTPClient, arginfo_TElWinAzureDataStorage_get_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_HTTPClient, arginfo_TElWinAzureDataStorage_set_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_AzureHeaders, arginfo_TElWinAzureDataStorage_get_AzureHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_UseDelayedPut, arginfo_TElWinAzureDataStorage_get_UseDelayedPut, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_UseDelayedPut, arginfo_TElWinAzureDataStorage_set_UseDelayedPut, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_SecMetadataID, arginfo_TElWinAzureDataStorage_get_SecMetadataID, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_SecMetadataID, arginfo_TElWinAzureDataStorage_set_SecMetadataID, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_ContentLengthMetadataID, arginfo_TElWinAzureDataStorage_get_ContentLengthMetadataID, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_ContentLengthMetadataID, arginfo_TElWinAzureDataStorage_set_ContentLengthMetadataID, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_DefaultMaxBlobSize, arginfo_TElWinAzureDataStorage_get_DefaultMaxBlobSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_DefaultMaxBlobSize, arginfo_TElWinAzureDataStorage_set_DefaultMaxBlobSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_CopyTimeout, arginfo_TElWinAzureDataStorage_get_CopyTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_CopyTimeout, arginfo_TElWinAzureDataStorage_set_CopyTimeout, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_Overwrite, arginfo_TElWinAzureDataStorage_get_Overwrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_Overwrite, arginfo_TElWinAzureDataStorage_set_Overwrite, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_PassthroughMode, arginfo_TElWinAzureDataStorage_get_PassthroughMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_PassthroughMode, arginfo_TElWinAzureDataStorage_set_PassthroughMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_EmbeddedMetadataMode, arginfo_TElWinAzureDataStorage_get_EmbeddedMetadataMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_EmbeddedMetadataMode, arginfo_TElWinAzureDataStorage_set_EmbeddedMetadataMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, get_OnBeforeRequestSigning, arginfo_TElWinAzureDataStorage_get_OnBeforeRequestSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, set_OnBeforeRequestSigning, arginfo_TElWinAzureDataStorage_set_OnBeforeRequestSigning, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorage, __construct, arginfo_TElWinAzureDataStorage___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWinAzureDataStorage(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWinAzureDataStorage_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWinAzureDataStorage", TElWinAzureDataStorage_methods);
	if (NULL == TElCustomDataStorage_ce_ptr)
		Register_TElCustomDataStorage(TSRMLS_C);
	TElWinAzureDataStorage_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorage_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWinAzureDataStorageListState_ce_ptr = NULL;

SB_PHP_METHOD(TElWinAzureDataStorageListState, Completed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageListState_Completed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageListState, __construct)
{
	char *sContainerName;
	char *sDelimiter;
	char *sPrefix;
	char *sSharedAccessSignature;
	int sContainerName_len;
	int sDelimiter_len;
	int sPrefix_len;
	int sSharedAccessSignature_len;
	zend_bool bIncludeMetadata;
	zend_bool bIncludeSnapshots;
	zend_bool bIncludeUncommittedBlobs;
	zval *oHeaders;
	zval *oPrefixes;
#ifdef SB_WINDOWS
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!bbbO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!bbbO!", &sContainerName, &sContainerName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TElStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageListState_Create(sContainerName, (int32_t)sContainerName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, SBGetObjectHandle(oPrefixes TSRMLS_CC), (int8_t)bIncludeSnapshots, (int8_t)bIncludeMetadata, (int8_t)bIncludeUncommittedBlobs, SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, string, string, TStringList, bool, bool, bool, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, string, string, TElStringList, bool, bool, bool, TElStringList)" TSRMLS_CC);
#endif
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageListState_Completed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageListState___construct, 0, 0, 9)
	ZEND_ARG_INFO(0, ContainerName)
	ZEND_ARG_INFO(0, SharedAccessSignature)
	ZEND_ARG_INFO(0, Prefix)
	ZEND_ARG_INFO(0, Delimiter)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Prefixes, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Prefixes, TElStringList, 1)
#endif
	ZEND_ARG_INFO(0, IncludeSnapshots)
	ZEND_ARG_INFO(0, IncludeMetadata)
	ZEND_ARG_INFO(0, IncludeUncommittedBlobs)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

static zend_function_entry TElWinAzureDataStorageListState_methods[] = {
	PHP_ME(TElWinAzureDataStorageListState, Completed, arginfo_TElWinAzureDataStorageListState_Completed, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageListState, __construct, arginfo_TElWinAzureDataStorageListState___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWinAzureDataStorageListState(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWinAzureDataStorageListState_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWinAzureDataStorageListState", TElWinAzureDataStorageListState_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWinAzureDataStorageListState_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWinAzureSingleAccessPolicy_ce_ptr = NULL;

SB_PHP_METHOD(TElWinAzureSingleAccessPolicy, Reset)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWinAzureSingleAccessPolicy_Reset(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureSingleAccessPolicy, PrepareID)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWinAzureSingleAccessPolicy_PrepareID(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureSingleAccessPolicy, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureSingleAccessPolicy_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-504308252, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureSingleAccessPolicy, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureSingleAccessPolicy_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureSingleAccessPolicy, get_StartTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElWinAzureSingleAccessPolicy_get_StartTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureSingleAccessPolicy, set_StartTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElWinAzureSingleAccessPolicy_set_StartTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureSingleAccessPolicy, get_ExpiryTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElWinAzureSingleAccessPolicy_get_ExpiryTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureSingleAccessPolicy, set_ExpiryTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElWinAzureSingleAccessPolicy_set_ExpiryTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureSingleAccessPolicy, get_Permissions)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureSingleAccessPolicy_get_Permissions(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1190776016, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureSingleAccessPolicy, set_Permissions)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureSingleAccessPolicy_set_Permissions(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureSingleAccessPolicy, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureSingleAccessPolicy_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureSingleAccessPolicy_Reset, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureSingleAccessPolicy_PrepareID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureSingleAccessPolicy_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureSingleAccessPolicy_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureSingleAccessPolicy_get_StartTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureSingleAccessPolicy_set_StartTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureSingleAccessPolicy_get_ExpiryTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureSingleAccessPolicy_set_ExpiryTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureSingleAccessPolicy_get_Permissions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureSingleAccessPolicy_set_Permissions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureSingleAccessPolicy___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWinAzureSingleAccessPolicy_methods[] = {
	PHP_ME(TElWinAzureSingleAccessPolicy, Reset, arginfo_TElWinAzureSingleAccessPolicy_Reset, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureSingleAccessPolicy, PrepareID, arginfo_TElWinAzureSingleAccessPolicy_PrepareID, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureSingleAccessPolicy, get_ID, arginfo_TElWinAzureSingleAccessPolicy_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureSingleAccessPolicy, set_ID, arginfo_TElWinAzureSingleAccessPolicy_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureSingleAccessPolicy, get_StartTime, arginfo_TElWinAzureSingleAccessPolicy_get_StartTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureSingleAccessPolicy, set_StartTime, arginfo_TElWinAzureSingleAccessPolicy_set_StartTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureSingleAccessPolicy, get_ExpiryTime, arginfo_TElWinAzureSingleAccessPolicy_get_ExpiryTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureSingleAccessPolicy, set_ExpiryTime, arginfo_TElWinAzureSingleAccessPolicy_set_ExpiryTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureSingleAccessPolicy, get_Permissions, arginfo_TElWinAzureSingleAccessPolicy_get_Permissions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureSingleAccessPolicy, set_Permissions, arginfo_TElWinAzureSingleAccessPolicy_set_Permissions, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureSingleAccessPolicy, __construct, arginfo_TElWinAzureSingleAccessPolicy___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWinAzureSingleAccessPolicy(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWinAzureSingleAccessPolicy_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWinAzureSingleAccessPolicy", TElWinAzureSingleAccessPolicy_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWinAzureSingleAccessPolicy_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWinAzureAccessPolicy_ce_ptr = NULL;

SB_PHP_METHOD(TElWinAzureAccessPolicy, AddPolicy)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWinAzureAccessPolicy_AddPolicy(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureAccessPolicy, RemovePolicy)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElWinAzureAccessPolicy_RemovePolicy(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureAccessPolicy, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWinAzureAccessPolicy_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureAccessPolicy, LoadFromXml)
{
	char *sXml;
	int sXml_len;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sXml, &sXml_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureAccessPolicy_LoadFromXml(SBGetObjectHandle(getThis() TSRMLS_CC), sXml, (int32_t)sXml_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureAccessPolicy_LoadFromXml_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureAccessPolicy, SaveToXml)
{
	uint32_t _err;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureAccessPolicy_SaveToXml(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1082512868, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureAccessPolicy_SaveToXml_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureAccessPolicy, get_AccessPolicies)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureAccessPolicy_get_AccessPolicies(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureSingleAccessPolicy_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureAccessPolicy, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWinAzureAccessPolicy_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureAccessPolicy, get_UseURLEncoding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureAccessPolicy_get_UseURLEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureAccessPolicy, set_UseURLEncoding)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElWinAzureAccessPolicy_set_UseURLEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureAccessPolicy, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureAccessPolicy_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureAccessPolicy_AddPolicy, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureAccessPolicy_RemovePolicy, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureAccessPolicy_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureAccessPolicy_LoadFromXml, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Xml_or_Stream, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureAccessPolicy_SaveToXml, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Stream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureAccessPolicy_get_AccessPolicies, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureAccessPolicy_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureAccessPolicy_get_UseURLEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureAccessPolicy_set_UseURLEncoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureAccessPolicy___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElWinAzureAccessPolicy_methods[] = {
	PHP_ME(TElWinAzureAccessPolicy, AddPolicy, arginfo_TElWinAzureAccessPolicy_AddPolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureAccessPolicy, RemovePolicy, arginfo_TElWinAzureAccessPolicy_RemovePolicy, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureAccessPolicy, Clear, arginfo_TElWinAzureAccessPolicy_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureAccessPolicy, LoadFromXml, arginfo_TElWinAzureAccessPolicy_LoadFromXml, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureAccessPolicy, SaveToXml, arginfo_TElWinAzureAccessPolicy_SaveToXml, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureAccessPolicy, get_AccessPolicies, arginfo_TElWinAzureAccessPolicy_get_AccessPolicies, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureAccessPolicy, get_Count, arginfo_TElWinAzureAccessPolicy_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureAccessPolicy, get_UseURLEncoding, arginfo_TElWinAzureAccessPolicy_get_UseURLEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureAccessPolicy, set_UseURLEncoding, arginfo_TElWinAzureAccessPolicy_set_UseURLEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureAccessPolicy, __construct, arginfo_TElWinAzureAccessPolicy___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWinAzureAccessPolicy(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWinAzureAccessPolicy_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWinAzureAccessPolicy", TElWinAzureAccessPolicy_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWinAzureAccessPolicy_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWinAzureDataStorageObject_ce_ptr = NULL;

SB_PHP_METHOD(TElWinAzureDataStorageObject, Assign)
{
	zval *oSource;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSource, TElCustomDataStorageObject_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_Assign(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSource TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomDataStorageObject)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageObject_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, Delete)
{
	char *sSharedAccessSignature;
	int sSharedAccessSignature_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_Delete_1(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, Exists)
{
	char *sSharedAccessSignature;
	int sSharedAccessSignature_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageObject_Exists(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageObject_Exists_1(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, Refresh)
{
	char *sSharedAccessSignature;
	int sSharedAccessSignature_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_Refresh(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_Refresh_1(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, Write)
{
	char *sContentEncoding;
	char *sContentLanguage;
	char *sContentMD5;
	char *sContentType;
	char *sSharedAccessSignature;
	int sContentEncoding_len;
	int sContentLanguage_len;
	int sContentMD5_len;
	int sContentType_len;
	int sSharedAccessSignature_len;
	zval *oData;
	zval *oHandler;
	zval *oMetadata;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_Write(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sssO!O!", &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sssO!O!", &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorageObject_Write_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_Write_2(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sssO!O!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sssO!O!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorageObject_Write_3(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!ssssO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!ssssO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorageObject_Write_4(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStream, TElCustomDataStorageSecurityHandler) or (TStream, string, string, string, TStringList, TElCustomDataStorageSecurityHandler) or (string, TStream, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, string, TStringList, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TStream, TElCustomDataStorageSecurityHandler) or (TStream, string, string, string, TElStringList, TElCustomDataStorageSecurityHandler) or (string, TStream, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, string, TElStringList, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, Read)
{
	char *sETag;
	char *sObjContentEncoding;
	char *sObjContentLanguage;
	char *sObjContentMD5;
	char *sObjContentType;
	char *sObjETag;
	char *sSharedAccessSignature;
	int sETag_len;
	int sSharedAccessSignature_len;
	int32_t sObjContentEncoding_len;
	int32_t sObjContentLanguage_len;
	int32_t sObjContentMD5_len;
	int32_t sObjContentType_len;
	int32_t sObjETag_len;
	long fCondition;
	long l8SeqNum;
	uint32_t _err;
	zval *dtDateTime;
	zval *oMetadata;
	zval *oStrm;
	zval *zsObjContentEncoding;
	zval *zsObjContentLanguage;
	zval *zsObjContentMD5;
	zval *zsObjContentType;
	zval *zsObjETag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_Read(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lOsl", &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_Read_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lOslO!zzzz", &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lOslO!zzzz", &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageObject_Read_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-2010061447, 7, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1431383803, 7, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-2010061447, 8, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1431383803, 8, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-2010061447, 9, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1431383803, 9, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-2010061447, 10, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1431383803, 10, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lOslO!zzzzz", &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lOslO!zzzzz", &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageObject_Read_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-2026547649, 7, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1424930610, 7, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-2026547649, 8, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1424930610, 8, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-2026547649, 9, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1424930610, 9, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-2026547649, 10, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1424930610, 10, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-2026547649, 11, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1424930610, 11, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_Read_4(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOsl", &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_Read_5(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOslO!zzzz", &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOslO!zzzz", &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageObject_Read_6(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1038255740, 8, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(56795248, 8, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1038255740, 9, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(56795248, 9, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1038255740, 10, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(56795248, 10, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1038255740, 11, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(56795248, 11, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOslO!zzzzz", &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOslO!zzzzz", &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageObject_Read_7(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1750463602, 8, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-702655454, 8, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1750463602, 9, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-702655454, 9, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1750463602, 10, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-702655454, 10, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1750463602, 11, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-702655454, 11, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1750463602, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-702655454, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStream) or (TStream, integer, DateTime, string, integer) or (TStream, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string) or (TStream, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string, &string) or (string, TStream) or (string, TStream, integer, DateTime, string, integer) or (string, TStream, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string) or (string, TStream, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string, &string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TStream) or (TStream, integer, DateTime, string, integer) or (TStream, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string) or (TStream, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string, &string) or (string, TStream) or (string, TStream, integer, DateTime, string, integer) or (string, TStream, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string) or (string, TStream, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string, &string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, ReadBlock)
{
	char *sETag;
	char *sObjContentEncoding;
	char *sObjContentLanguage;
	char *sObjContentMD5;
	char *sObjContentType;
	char *sObjETag;
	char *sSharedAccessSignature;
	int sETag_len;
	int sSharedAccessSignature_len;
	int32_t sObjContentEncoding_len;
	int32_t sObjContentLanguage_len;
	int32_t sObjContentMD5_len;
	int32_t sObjContentType_len;
	int32_t sObjETag_len;
	int64_t l8ReadRaw;
	long fCondition;
	long l8Offset;
	long l8SeqNum;
	long l8Size;
	uint32_t _err;
	zval *dtDateTime;
	zval *oMetadata;
	zval *oStrm;
	zval *zl8Read;
	zval *zsObjContentEncoding;
	zval *zsObjContentLanguage;
	zval *zsObjContentMD5;
	zval *zsObjContentType;
	zval *zsObjETag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llz", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorageObject_ReadBlock(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzlOsl", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorageObject_ReadBlock_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzlOslO!zzzz", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzlOslO!zzzz", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageObject_ReadBlock_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-737523107, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(489673440, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-737523107, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(489673440, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-737523107, 12, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(489673440, 12, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-737523107, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(489673440, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzlOslO!zzzzz", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!llzlOslO!zzzzz", &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageObject_ReadBlock_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1354061811, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1151780966, 10, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1354061811, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1151780966, 11, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1354061811, 12, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1151780966, 12, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1354061811, 13, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1151780966, 13, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1354061811, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1151780966, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llz", &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorageObject_ReadBlock_4(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOsl", &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorageObject_ReadBlock_5(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOslO!zzzz", &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOslO!zzzz", &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageObject_ReadBlock_6(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-554831691, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1606616207, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-554831691, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1606616207, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-554831691, 13, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1606616207, 13, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-554831691, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1606616207, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOslO!zzzzz", &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOslO!zzzzz", &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageObject_ReadBlock_7(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1694433781, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-935949098, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1694433781, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-935949098, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1694433781, 13, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-935949098, 13, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1694433781, 14, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-935949098, 14, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1694433781, 15, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-935949098, 15, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TStream, integer, integer, &integer) or (TStream, integer, integer, &integer, integer, DateTime, string, integer) or (TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string) or (TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string, &string) or (string, TStream, integer, integer, &integer) or (string, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string) or (string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string, &string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TStream, integer, integer, &integer) or (TStream, integer, integer, &integer, integer, DateTime, string, integer) or (TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string) or (TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string, &string) or (string, TStream, integer, integer, &integer) or (string, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string) or (string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string, &string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, Copy)
{
	char *sDestContainerName;
	char *sDestETag;
	char *sDestName;
	char *sDestSharedAccessSignature;
	char *sETag;
	char *sSharedAccessSignature;
	int sDestContainerName_len;
	int sDestETag_len;
	int sDestName_len;
	int sDestSharedAccessSignature_len;
	int sETag_len;
	int sSharedAccessSignature_len;
	long fCondition;
	long fDestCondition;
	zend_bool bPreserveMetadata;
	zval *dtDateTime;
	zval *dtDestDateTime;
	zval *oMetadata;
	zval *oNewHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageObject_Copy(SBGetObjectHandle(getThis() TSRMLS_CC), sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssbO!", &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssbO!", &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageObject_Copy_1(SBGetObjectHandle(getThis() TSRMLS_CC), sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslOslOsbO!", &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sslOslOsbO!", &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageObject_Copy_2(SBGetObjectHandle(getThis() TSRMLS_CC), sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (TSBWinAzureObjectAccessConditionRaw)fDestCondition, SBGetDateTime(dtDestDateTime TSRMLS_CC), sDestETag, (int32_t)sDestETag_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageObject_Copy_3(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, sDestSharedAccessSignature, (int32_t)sDestSharedAccessSignature_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssbO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssbO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageObject_Copy_4(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, sDestSharedAccessSignature, (int32_t)sDestSharedAccessSignature_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssslOslOsbO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssslOslOsbO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageObject_Copy_5(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, sDestSharedAccessSignature, (int32_t)sDestSharedAccessSignature_len, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (TSBWinAzureObjectAccessConditionRaw)fDestCondition, SBGetDateTime(dtDestDateTime TSRMLS_CC), sDestETag, (int32_t)sDestETag_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, TElCustomDataStorageSecurityHandler) or (string, string, bool, TStringList) or (string, string, integer, DateTime, string, integer, DateTime, string, bool, TStringList) or (string, string, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, bool, TStringList) or (string, string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, TElCustomDataStorageSecurityHandler) or (string, string, bool, TElStringList) or (string, string, integer, DateTime, string, integer, DateTime, string, bool, TElStringList) or (string, string, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, bool, TElStringList) or (string, string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, GetACL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_GetACL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-153926513, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, SetACL)
{
	char *sACL;
	int sACL_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sACL, &sACL_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_SetACL(SBGetObjectHandle(getThis() TSRMLS_CC), sACL, (int32_t)sACL_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, GetLocalETag)
{
	char *sFilename;
	int sFilename_len;
	uint32_t _err;
	zval *oStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStream, TStream_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_GetLocalETag(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStream TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1907940698, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sFilename, &sFilename_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_GetLocalETag_1(SBGetObjectHandle(getThis() TSRMLS_CC), sFilename, (int32_t)sFilename_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2100449925, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TStream) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, GetRemoteETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_GetRemoteETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1225462835, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, Resize)
{
	long l8NewSize;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8NewSize) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_Resize(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8NewSize) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, CreateSharedAccessSignature)
{
	uint32_t _err;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPolicy, TElWinAzureSingleAccessPolicy_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_CreateSharedAccessSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-259430626, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElWinAzureSingleAccessPolicy)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_ContainerName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_get_ContainerName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-755533234, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_LastModified)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageObject_get_LastModified(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1469484567, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_Size)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageObject_get_Size(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_AllocatedSize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageObject_get_AllocatedSize(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_ContentType)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_get_ContentType(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(838735034, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_ContentEncoding)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_get_ContentEncoding(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1267617773, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_ContentLanguage)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_get_ContentLanguage(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(149043433, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_ContentMD5)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_get_ContentMD5(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-281857899, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, set_ContentMD5)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageObject_set_ContentMD5(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_SequenceNumber)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageObject_get_SequenceNumber(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_Locked)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageObject_get_Locked(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_CopyStatus)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_get_CopyStatus(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(171541370, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_LeaseStatus)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageObject_get_LeaseStatus(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1640859430, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_Metadata)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageObject_get_Metadata(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, get_CustomHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageObject_get_CustomHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageObject, __construct)
{
	char *sContainerName;
	char *sName;
	int sContainerName_len;
	int sName_len;
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElWinAzureDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageObject_Create(SBGetObjectHandle(oStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ss", &oStorage, TElWinAzureDataStorage_ce_ptr, &sContainerName, &sContainerName_len, &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageObject_Create_1(SBGetObjectHandle(oStorage TSRMLS_CC), sContainerName, (int32_t)sContainerName_len, sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWinAzureDataStorage) or (TElWinAzureDataStorage, string, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_Assign, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Source, TElCustomDataStorageObject, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_Delete, 0, 0, 0)
	ZEND_ARG_INFO(0, SharedAccessSignature)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_Exists, 0, 0, 0)
	ZEND_ARG_INFO(0, SharedAccessSignature)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_Refresh, 0, 0, 0)
	ZEND_ARG_INFO(0, SharedAccessSignature)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_Write, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, Data_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_ContentType_or_Data, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ContentEncoding_or_Handler_or_ContentType, 0, 1)
	ZEND_ARG_INFO(0, ContentLanguage_or_ContentEncoding)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_ContentLanguage, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Metadata_or_ContentMD5, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Metadata, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_Read, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Strm_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Condition_or_Strm, 0, 1)
	ZEND_ARG_INFO(0, DateTime_or_Condition)
	ZEND_ARG_INFO(0, ETag_or_DateTime)
	ZEND_ARG_INFO(0, SeqNum_or_ETag)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_SeqNum, 0, 1)
	ZEND_ARG_TYPE_INFO(1, ObjContentType_or_Metadata, 0, 1)
	ZEND_ARG_INFO(1, ObjContentEncoding_or_ObjContentType)
	ZEND_ARG_INFO(1, ObjContentLanguage_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentMD5_or_ObjContentLanguage)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentMD5)
	ZEND_ARG_INFO(1, ObjETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_ReadBlock, 0, 0, 4)
	ZEND_ARG_TYPE_INFO(0, Strm_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Offset_or_Strm, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Offset)
	ZEND_ARG_INFO(1, Read_or_Size)
	ZEND_ARG_INFO(1, Condition_or_Read)
	ZEND_ARG_INFO(0, DateTime_or_Condition)
	ZEND_ARG_INFO(0, ETag_or_DateTime)
	ZEND_ARG_INFO(0, SeqNum_or_ETag)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_SeqNum, 0, 1)
	ZEND_ARG_TYPE_INFO(1, ObjContentType_or_Metadata, 0, 1)
	ZEND_ARG_INFO(1, ObjContentEncoding_or_ObjContentType)
	ZEND_ARG_INFO(1, ObjContentLanguage_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentMD5_or_ObjContentLanguage)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentMD5)
	ZEND_ARG_INFO(1, ObjETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_Copy, 0, 0, 3)
	ZEND_ARG_INFO(0, DestContainerName_or_SharedAccessSignature)
	ZEND_ARG_INFO(0, DestName_or_DestContainerName)
	ZEND_ARG_TYPE_INFO(0, NewHandler_or_PreserveMetadata_or_Condition_or_DestName, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_DateTime_or_DestSharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ETag_or_NewHandler_or_PreserveMetadata_or_Condition, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DestCondition_or_Metadata_or_DateTime, 0, 1)
	ZEND_ARG_INFO(0, DestDateTime_or_ETag)
	ZEND_ARG_INFO(0, DestETag_or_DestCondition)
	ZEND_ARG_INFO(0, PreserveMetadata_or_DestDateTime)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_DestETag, 0, 1)
	ZEND_ARG_INFO(0, PreserveMetadata)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Metadata, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Metadata, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_GetACL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_SetACL, 0, 0, 1)
	ZEND_ARG_INFO(0, ACL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_GetLocalETag, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Stream_or_Filename, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_GetRemoteETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_Resize, 0, 0, 1)
	ZEND_ARG_INFO(0, NewSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_CreateSharedAccessSignature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Policy, TElWinAzureSingleAccessPolicy, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_ContainerName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_LastModified, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_Size, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_AllocatedSize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_ContentType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_ContentEncoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_ContentLanguage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_ContentMD5, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_set_ContentMD5, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_SequenceNumber, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_Locked, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_CopyStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_LeaseStatus, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_Metadata, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject_get_CustomHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageObject___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Storage, TElWinAzureDataStorage, 1)
	ZEND_ARG_INFO(0, ContainerName)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

static zend_function_entry TElWinAzureDataStorageObject_methods[] = {
	PHP_ME(TElWinAzureDataStorageObject, Assign, arginfo_TElWinAzureDataStorageObject_Assign, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, Clone, arginfo_TElWinAzureDataStorageObject_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, Delete, arginfo_TElWinAzureDataStorageObject_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, Exists, arginfo_TElWinAzureDataStorageObject_Exists, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, Refresh, arginfo_TElWinAzureDataStorageObject_Refresh, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, Write, arginfo_TElWinAzureDataStorageObject_Write, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, Read, arginfo_TElWinAzureDataStorageObject_Read, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, ReadBlock, arginfo_TElWinAzureDataStorageObject_ReadBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, Copy, arginfo_TElWinAzureDataStorageObject_Copy, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, GetACL, arginfo_TElWinAzureDataStorageObject_GetACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, SetACL, arginfo_TElWinAzureDataStorageObject_SetACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, GetLocalETag, arginfo_TElWinAzureDataStorageObject_GetLocalETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, GetRemoteETag, arginfo_TElWinAzureDataStorageObject_GetRemoteETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, Resize, arginfo_TElWinAzureDataStorageObject_Resize, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, CreateSharedAccessSignature, arginfo_TElWinAzureDataStorageObject_CreateSharedAccessSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_ContainerName, arginfo_TElWinAzureDataStorageObject_get_ContainerName, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_LastModified, arginfo_TElWinAzureDataStorageObject_get_LastModified, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_ETag, arginfo_TElWinAzureDataStorageObject_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_Size, arginfo_TElWinAzureDataStorageObject_get_Size, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_AllocatedSize, arginfo_TElWinAzureDataStorageObject_get_AllocatedSize, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_ContentType, arginfo_TElWinAzureDataStorageObject_get_ContentType, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_ContentEncoding, arginfo_TElWinAzureDataStorageObject_get_ContentEncoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_ContentLanguage, arginfo_TElWinAzureDataStorageObject_get_ContentLanguage, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_ContentMD5, arginfo_TElWinAzureDataStorageObject_get_ContentMD5, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, set_ContentMD5, arginfo_TElWinAzureDataStorageObject_set_ContentMD5, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_SequenceNumber, arginfo_TElWinAzureDataStorageObject_get_SequenceNumber, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_Locked, arginfo_TElWinAzureDataStorageObject_get_Locked, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_CopyStatus, arginfo_TElWinAzureDataStorageObject_get_CopyStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_LeaseStatus, arginfo_TElWinAzureDataStorageObject_get_LeaseStatus, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_Metadata, arginfo_TElWinAzureDataStorageObject_get_Metadata, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, get_CustomHeaders, arginfo_TElWinAzureDataStorageObject_get_CustomHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageObject, __construct, arginfo_TElWinAzureDataStorageObject___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWinAzureDataStorageObject(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWinAzureDataStorageObject_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWinAzureDataStorageObject", TElWinAzureDataStorageObject_methods);
	if (NULL == TElCustomDataStorageObject_ce_ptr)
		Register_TElCustomDataStorageObject(TSRMLS_C);
	TElWinAzureDataStorageObject_ce_ptr = zend_register_internal_class_ex(&ce, TElCustomDataStorageObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWinAzureDataStorageContainer_ce_ptr = NULL;

SB_PHP_METHOD(TElWinAzureDataStorageContainer, AcquireObject)
{
	char *sName;
	char *sSharedAccessSignature;
	int sName_len;
	int sSharedAccessSignature_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_AcquireObject(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_AcquireObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, List)
{
	char *sDelimiter;
	char *sPrefix;
	char *sSharedAccessSignature;
	int sDelimiter_len;
	int sPrefix_len;
	int sSharedAccessSignature_len;
	long l4MaxCount;
	zend_bool bIncludeMetadata;
	zend_bool bIncludeSnapshots;
	zend_bool bIncludeUncommittedBlobs;
	zval *oHeaders;
	zval *oObjects;
	zval *oPrefixes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_List(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sslO!O!", &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sslO!O!", &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorageContainer_List_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, (int32_t)l4MaxCount, SBGetObjectHandle(oPrefixes TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sslO!bbbO!", &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sslO!bbbO!", &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TElStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorageContainer_List_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, (int32_t)l4MaxCount, SBGetObjectHandle(oPrefixes TSRMLS_CC), (int8_t)bIncludeSnapshots, (int8_t)bIncludeMetadata, (int8_t)bIncludeUncommittedBlobs, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_List_3(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sslO!O!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sslO!O!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorageContainer_List_4(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oObjects TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, (int32_t)l4MaxCount, SBGetObjectHandle(oPrefixes TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sslO!bbbO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sslO!bbbO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oObjects, TElDataStorageObjectList_ce_ptr, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &l4MaxCount, &oPrefixes, TElStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorageContainer_List_5(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oObjects TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, (int32_t)l4MaxCount, SBGetObjectHandle(oPrefixes TSRMLS_CC), (int8_t)bIncludeSnapshots, (int8_t)bIncludeMetadata, (int8_t)bIncludeUncommittedBlobs, SBGetObjectHandle(oHeaders TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(TElDataStorageObjectList) or (TElDataStorageObjectList, string, string, integer, TStringList, TStringList) or (TElDataStorageObjectList, string, string, integer, TStringList, bool, bool, bool, TStringList) or (string, TElDataStorageObjectList) or (string, TElDataStorageObjectList, string, string, integer, TStringList, TStringList) or (string, TElDataStorageObjectList, string, string, integer, TStringList, bool, bool, bool, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(TElDataStorageObjectList) or (TElDataStorageObjectList, string, string, integer, TElStringList, TElStringList) or (TElDataStorageObjectList, string, string, integer, TElStringList, bool, bool, bool, TElStringList) or (string, TElDataStorageObjectList) or (string, TElDataStorageObjectList, string, string, integer, TElStringList, TElStringList) or (string, TElDataStorageObjectList, string, string, integer, TElStringList, bool, bool, bool, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, ListInit)
{
	char *sDelimiter;
	char *sPrefix;
	char *sSharedAccessSignature;
	int sDelimiter_len;
	int sPrefix_len;
	int sSharedAccessSignature_len;
	zend_bool bIncludeMetadata;
	zend_bool bIncludeSnapshots;
	zend_bool bIncludeUncommittedBlobs;
	zval *oHeaders;
	zval *oPrefixes;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_ListInit(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TStringList_ce_ptr, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TElStringList_ce_ptr, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_ListInit_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, SBGetObjectHandle(oPrefixes TSRMLS_CC), SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!bbbO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!bbbO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &sPrefix, &sPrefix_len, &sDelimiter, &sDelimiter_len, &oPrefixes, TElStringList_ce_ptr, &bIncludeSnapshots, &bIncludeMetadata, &bIncludeUncommittedBlobs, &oHeaders, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_ListInit_2(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sPrefix, (int32_t)sPrefix_len, sDelimiter, (int32_t)sDelimiter_len, SBGetObjectHandle(oPrefixes TSRMLS_CC), (int8_t)bIncludeSnapshots, (int8_t)bIncludeMetadata, (int8_t)bIncludeUncommittedBlobs, SBGetObjectHandle(oHeaders TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageListState_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("() or (string, string, TStringList, TStringList) or (string, string, string, TStringList, bool, bool, bool, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("() or (string, string, TElStringList, TElStringList) or (string, string, string, TElStringList, bool, bool, bool, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, ListNext)
{
	long l4MaxCount;
	zval *oObjects;
	zval *oState;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oState, TElWinAzureDataStorageListState_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_ListNext(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!l", &oState, TElWinAzureDataStorageListState_ce_ptr, &oObjects, TElDataStorageObjectList_ce_ptr, &l4MaxCount) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_ListNext_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oState TSRMLS_CC), SBGetObjectHandle(oObjects TSRMLS_CC), (int32_t)l4MaxCount) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElWinAzureDataStorageListState, TElDataStorageObjectList) or (TElWinAzureDataStorageListState, TElDataStorageObjectList, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, ListFinal)
{
	TElClassHandle hoState;
	zval *oState;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &oState, TElWinAzureDataStorageListState_ce_ptr) == SUCCESS) && PZVAL_IS_REF(oState) && (IS_OBJECT == Z_TYPE_P(oState)))
	{
		hoState = SBGetObjectHandle(oState TSRMLS_CC);
		SBCheckError(TElWinAzureDataStorageContainer_ListFinal(SBGetObjectHandle(getThis() TSRMLS_CC), &hoState) TSRMLS_CC);
		SBUpdateObjectHandle(oState, hoState TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(&TElWinAzureDataStorageListState)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, CreateObject)
{
	char *sContentEncoding;
	char *sContentLanguage;
	char *sContentMD5;
	char *sContentType;
	char *sName;
	char *sSharedAccessSignature;
	int sContentEncoding_len;
	int sContentLanguage_len;
	int sContentMD5_len;
	int sContentType_len;
	int sName_len;
	int sSharedAccessSignature_len;
	long l8InitialSize;
	zval *oHandler;
	zval *oMetadata;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sName, &sName_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!O!", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!O!", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sName, &sName_len, &l8InitialSize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!l", &sName, &sName_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!O!l", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!O!l", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_6(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!l", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!l", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_7(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_8(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_9(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!sO!", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!sO!", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_10(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!s", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!s", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_11(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssl", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &l8InitialSize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_12(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!l", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_13(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!sO!l", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssO!sO!l", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr, &l8InitialSize) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_14(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oHandler TSRMLS_CC), (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!sl", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &l8InitialSize) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!sl", &sName, &sName_len, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr, &sSharedAccessSignature, &sSharedAccessSignature_len, &l8InitialSize) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CreateObject_15(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, (int64_t)l8InitialSize, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string) or (string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, TStringList, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, TStringList) or (string, integer) or (string, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, TStringList, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, string, TStringList, integer) or (string, string) or (string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, TStringList, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, TStringList, string) or (string, string, integer) or (string, string, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, TStringList, string, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, string, TStringList, string, integer)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string) or (string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, TElStringList, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, TElStringList) or (string, integer) or (string, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, TElStringList, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, string, TElStringList, integer) or (string, string) or (string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, TElStringList, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, TElStringList, string) or (string, string, integer) or (string, string, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, TElStringList, string, TElCustomDataStorageSecurityHandler, integer) or (string, string, string, string, string, TElStringList, string, integer)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, DeleteObject)
{
	char *sName;
	char *sSharedAccessSignature;
	int sName_len;
	int sSharedAccessSignature_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_DeleteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_DeleteObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, ObjectExists)
{
	char *sName;
	char *sSharedAccessSignature;
	int sName_len;
	int sSharedAccessSignature_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageContainer_ObjectExists(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageContainer_ObjectExists_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, WriteObject)
{
	char *sContentEncoding;
	char *sContentLanguage;
	char *sContentMD5;
	char *sContentType;
	char *sName;
	char *sSharedAccessSignature;
	int sContentEncoding_len;
	int sContentLanguage_len;
	int sContentMD5_len;
	int sContentType_len;
	int sName_len;
	int sSharedAccessSignature_len;
	zval *oData;
	zval *oHandler;
	zval *oMetadata;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!O!", &sName, &sName_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_WriteObject(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sssO!O!", &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!sssO!O!", &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorageContainer_WriteObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!ssssO!", &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!ssssO!", &sName, &sName_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorageContainer_WriteObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!O!", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_WriteObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sssO!O!", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!sssO!O!", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &oMetadata, TElStringList_ce_ptr, &oHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorageContainer_WriteObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, SBGetObjectHandle(oMetadata TSRMLS_CC), SBGetObjectHandle(oHandler TSRMLS_CC)) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!ssssO!", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!ssssO!", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oData, TStream_ce_ptr, &sContentType, &sContentType_len, &sContentEncoding, &sContentEncoding_len, &sContentLanguage, &sContentLanguage_len, &sContentMD5, &sContentMD5_len, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		SBCheckError(TElWinAzureDataStorageContainer_WriteObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oData TSRMLS_CC), sContentType, (int32_t)sContentType_len, sContentEncoding, (int32_t)sContentEncoding_len, sContentLanguage, (int32_t)sContentLanguage_len, sContentMD5, (int32_t)sContentMD5_len, SBGetObjectHandle(oMetadata TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStream, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, string, TStringList, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, string, string, TStringList) or (string, string, TStream, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, TStringList, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, string, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TStream, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, string, TElStringList, TElCustomDataStorageSecurityHandler) or (string, TStream, string, string, string, string, TElStringList) or (string, string, TStream, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, TElStringList, TElCustomDataStorageSecurityHandler) or (string, string, TStream, string, string, string, string, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, ReadObject)
{
	char *sETag;
	char *sName;
	char *sObjContentEncoding;
	char *sObjContentLanguage;
	char *sObjContentMD5;
	char *sObjContentType;
	char *sObjETag;
	char *sSharedAccessSignature;
	int sETag_len;
	int sName_len;
	int sSharedAccessSignature_len;
	int32_t sObjContentEncoding_len;
	int32_t sObjContentLanguage_len;
	int32_t sObjContentMD5_len;
	int32_t sObjContentType_len;
	int32_t sObjETag_len;
	long fCondition;
	long l8SeqNum;
	uint32_t _err;
	zval *dtDateTime;
	zval *oMetadata;
	zval *oStrm;
	zval *zsObjContentEncoding;
	zval *zsObjContentLanguage;
	zval *zsObjContentMD5;
	zval *zsObjContentType;
	zval *zsObjETag;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sName, &sName_len, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_ReadObject(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOsl", &sName, &sName_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_ReadObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOslO!zzzz", &sName, &sName_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOslO!zzzz", &sName, &sName_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageContainer_ReadObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-275360272, 8, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1953618387, 8, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-275360272, 9, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1953618387, 9, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-275360272, 10, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1953618387, 10, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-275360272, 11, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1953618387, 11, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOslO!zzzzz", &sName, &sName_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!lOslO!zzzzz", &sName, &sName_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageContainer_ReadObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1224705240, 8, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-755805737, 8, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1224705240, 9, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-755805737, 9, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1224705240, 10, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-755805737, 10, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1224705240, 11, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-755805737, 11, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(1224705240, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-755805737, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_ReadObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOsl", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_ReadObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOslO!zzzz", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOslO!zzzz", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageContainer_ReadObject_6(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-232237925, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2055256425, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-232237925, 10, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2055256425, 10, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-232237925, 11, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2055256425, 11, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-232237925, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2055256425, 12, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOslO!zzzzz", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!lOslO!zzzzz", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageContainer_ReadObject_7(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1278164625, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2143365016, 9, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1278164625, 10, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2143365016, 10, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1278164625, 11, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2143365016, 11, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1278164625, 12, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2143365016, 12, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1278164625, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(2143365016, 13, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStream) or (string, TStream, integer, DateTime, string, integer) or (string, TStream, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string) or (string, TStream, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string, &string) or (string, string, TStream) or (string, string, TStream, integer, DateTime, string, integer) or (string, string, TStream, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string) or (string, string, TStream, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string, &string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TStream) or (string, TStream, integer, DateTime, string, integer) or (string, TStream, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string) or (string, TStream, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string, &string) or (string, string, TStream) or (string, string, TStream, integer, DateTime, string, integer) or (string, string, TStream, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string) or (string, string, TStream, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string, &string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, ReadBlock)
{
	char *sETag;
	char *sName;
	char *sObjContentEncoding;
	char *sObjContentLanguage;
	char *sObjContentMD5;
	char *sObjContentType;
	char *sObjETag;
	char *sSharedAccessSignature;
	int sETag_len;
	int sName_len;
	int sSharedAccessSignature_len;
	int32_t sObjContentEncoding_len;
	int32_t sObjContentLanguage_len;
	int32_t sObjContentMD5_len;
	int32_t sObjContentType_len;
	int32_t sObjETag_len;
	int64_t l8ReadRaw;
	long fCondition;
	long l8Offset;
	long l8SeqNum;
	long l8Size;
	uint32_t _err;
	zval *dtDateTime;
	zval *oMetadata;
	zval *oStrm;
	zval *zl8Read;
	zval *zsObjContentEncoding;
	zval *zsObjContentLanguage;
	zval *zsObjContentMD5;
	zval *zsObjContentType;
	zval *zsObjETag;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llz", &sName, &sName_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorageContainer_ReadBlock(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOsl", &sName, &sName_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorageContainer_ReadBlock_1(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOslO!zzzz", &sName, &sName_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOslO!zzzz", &sName, &sName_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageContainer_ReadBlock_2(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1704466891, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1869320929, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1704466891, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1869320929, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1704466891, 13, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1869320929, 13, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1704466891, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1869320929, 14, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOslO!zzzzz", &sName, &sName_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!llzlOslO!zzzzz", &sName, &sName_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageContainer_ReadBlock_3(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1728217859, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1989792996, 11, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1728217859, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1989792996, 12, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1728217859, 13, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1989792996, 13, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1728217859, 14, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1989792996, 14, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1728217859, 15, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1989792996, 15, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llz", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorageContainer_ReadBlock_4(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOsl", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)))
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		SBCheckError(TElWinAzureDataStorageContainer_ReadBlock_5(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum) TSRMLS_CC);
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOslO!zzzz", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOslO!zzzz", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageContainer_ReadBlock_6(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(379968443, 12, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1845237769, 12, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(379968443, 13, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1845237769, 13, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(379968443, 14, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1845237769, 14, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(379968443, 15, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(-1845237769, 15, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
#ifdef SB_WINDOWS
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOslO!zzzzz", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#else
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!llzlOslO!zzzzz", &sName, &sName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &oStrm, TStream_ce_ptr, &l8Offset, &l8Size, &zl8Read, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &l8SeqNum, &oMetadata, TElStringList_ce_ptr, &zsObjContentType, &zsObjContentEncoding, &zsObjContentLanguage, &zsObjContentMD5, &zsObjETag) == SUCCESS) && PZVAL_IS_REF(zl8Read) && (IS_LONG == Z_TYPE_P(zl8Read)) && PZVAL_IS_REF(zsObjContentType) && (IS_STRING == Z_TYPE_P(zsObjContentType)) && PZVAL_IS_REF(zsObjContentEncoding) && (IS_STRING == Z_TYPE_P(zsObjContentEncoding)) && PZVAL_IS_REF(zsObjContentLanguage) && (IS_STRING == Z_TYPE_P(zsObjContentLanguage)) && PZVAL_IS_REF(zsObjContentMD5) && (IS_STRING == Z_TYPE_P(zsObjContentMD5)) && PZVAL_IS_REF(zsObjETag) && (IS_STRING == Z_TYPE_P(zsObjETag)))
#endif
	{
		l8ReadRaw = (int64_t)Z_LVAL_P(zl8Read);
		sObjContentType = Z_STRVAL_P(zsObjContentType);
		sObjContentType_len = (int32_t)Z_STRLEN_P(zsObjContentType);
		sObjContentEncoding = Z_STRVAL_P(zsObjContentEncoding);
		sObjContentEncoding_len = (int32_t)Z_STRLEN_P(zsObjContentEncoding);
		sObjContentLanguage = Z_STRVAL_P(zsObjContentLanguage);
		sObjContentLanguage_len = (int32_t)Z_STRLEN_P(zsObjContentLanguage);
		sObjContentMD5 = Z_STRVAL_P(zsObjContentMD5);
		sObjContentMD5_len = (int32_t)Z_STRLEN_P(zsObjContentMD5);
		sObjETag = Z_STRVAL_P(zsObjETag);
		sObjETag_len = (int32_t)Z_STRLEN_P(zsObjETag);
		_err = TElWinAzureDataStorageContainer_ReadBlock_7(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oStrm TSRMLS_CC), (int64_t)l8Offset, (int64_t)l8Size, &l8ReadRaw, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (int64_t)l8SeqNum, SBGetObjectHandle(oMetadata TSRMLS_CC), sObjContentType, &sObjContentType_len, sObjContentEncoding, &sObjContentEncoding_len, sObjContentLanguage, &sObjContentLanguage_len, sObjContentMD5, &sObjContentMD5_len, sObjETag, &sObjETag_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sObjContentType = emalloc(sObjContentType_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1295855433, 12, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1552959855, 12, sObjContentType, &sObjContentType_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentType);
			sObjContentEncoding = emalloc(sObjContentEncoding_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1295855433, 13, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1552959855, 13, sObjContentEncoding, &sObjContentEncoding_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentEncoding);
			sObjContentLanguage = emalloc(sObjContentLanguage_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1295855433, 14, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1552959855, 14, sObjContentLanguage, &sObjContentLanguage_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentLanguage);
			sObjContentMD5 = emalloc(sObjContentMD5_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1295855433, 15, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1552959855, 15, sObjContentMD5, &sObjContentMD5_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjContentMD5);
			sObjETag = emalloc(sObjETag_len + 1);
#ifdef SB_WINDOWS
			SBCheckError(SBGetLastReturnStringA(-1295855433, 16, sObjETag, &sObjETag_len) TSRMLS_CC);
#else
			SBCheckError(SBGetLastReturnStringA(1552959855, 16, sObjETag, &sObjETag_len) TSRMLS_CC);
#endif
			zval_dtor(zsObjETag);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		ZVAL_LONG(zl8Read, (long)l8ReadRaw);
		sObjContentType[sObjContentType_len] = 0;
		ZVAL_STRINGL(zsObjContentType, sObjContentType, sObjContentType_len, 0);
		sObjContentEncoding[sObjContentEncoding_len] = 0;
		ZVAL_STRINGL(zsObjContentEncoding, sObjContentEncoding, sObjContentEncoding_len, 0);
		sObjContentLanguage[sObjContentLanguage_len] = 0;
		ZVAL_STRINGL(zsObjContentLanguage, sObjContentLanguage, sObjContentLanguage_len, 0);
		sObjContentMD5[sObjContentMD5_len] = 0;
		ZVAL_STRINGL(zsObjContentMD5, sObjContentMD5, sObjContentMD5_len, 0);
		sObjETag[sObjETag_len] = 0;
		ZVAL_STRINGL(zsObjETag, sObjETag, sObjETag_len, 0);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, TStream, integer, integer, &integer) or (string, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string) or (string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string, &string) or (string, string, TStream, integer, integer, &integer) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TStringList, &string, &string, &string, &string, &string)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, TStream, integer, integer, &integer) or (string, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string) or (string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string, &string) or (string, string, TStream, integer, integer, &integer) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string) or (string, string, TStream, integer, integer, &integer, integer, DateTime, string, integer, TElStringList, &string, &string, &string, &string, &string)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, CopyObject)
{
	char *sDestContainerName;
	char *sDestETag;
	char *sDestName;
	char *sDestSharedAccessSignature;
	char *sETag;
	char *sSharedAccessSignature;
	char *sSourceName;
	int sDestContainerName_len;
	int sDestETag_len;
	int sDestName_len;
	int sDestSharedAccessSignature_len;
	int sETag_len;
	int sSharedAccessSignature_len;
	int sSourceName_len;
	long fCondition;
	long fDestCondition;
	zend_bool bPreserveMetadata;
	zval *dtDateTime;
	zval *dtDestDateTime;
	zval *oMetadata;
	zval *oNewHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sSourceName, &sSourceName_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CopyObject(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceName, (int32_t)sSourceName_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssbO!", &sSourceName, &sSourceName_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssbO!", &sSourceName, &sSourceName_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CopyObject_1(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceName, (int32_t)sSourceName_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssslOslOsbO!", &sSourceName, &sSourceName_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssslOslOsbO!", &sSourceName, &sSourceName_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CopyObject_2(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceName, (int32_t)sSourceName_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (TSBWinAzureObjectAccessConditionRaw)fDestCondition, SBGetDateTime(dtDestDateTime TSRMLS_CC), sDestETag, (int32_t)sDestETag_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssO!", &sSourceName, &sSourceName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &oNewHandler, TElCustomDataStorageSecurityHandler_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CopyObject_3(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceName, (int32_t)sSourceName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, sDestSharedAccessSignature, (int32_t)sDestSharedAccessSignature_len, SBGetObjectHandle(oNewHandler TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssbO!", &sSourceName, &sSourceName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssssbO!", &sSourceName, &sSourceName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CopyObject_4(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceName, (int32_t)sSourceName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, sDestSharedAccessSignature, (int32_t)sDestSharedAccessSignature_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
#ifdef SB_WINDOWS
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssslOslOsbO!", &sSourceName, &sSourceName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TStringList_ce_ptr) == SUCCESS)
#else
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssssslOslOsbO!", &sSourceName, &sSourceName_len, &sSharedAccessSignature, &sSharedAccessSignature_len, &sDestContainerName, &sDestContainerName_len, &sDestName, &sDestName_len, &sDestSharedAccessSignature, &sDestSharedAccessSignature_len, &fCondition, &dtDateTime, php_date_get_date_ce(), &sETag, &sETag_len, &fDestCondition, &dtDestDateTime, php_date_get_date_ce(), &sDestETag, &sDestETag_len, &bPreserveMetadata, &oMetadata, TElStringList_ce_ptr) == SUCCESS)
#endif
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_CopyObject_5(SBGetObjectHandle(getThis() TSRMLS_CC), sSourceName, (int32_t)sSourceName_len, sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, sDestContainerName, (int32_t)sDestContainerName_len, sDestName, (int32_t)sDestName_len, sDestSharedAccessSignature, (int32_t)sDestSharedAccessSignature_len, (TSBWinAzureObjectAccessConditionRaw)fCondition, SBGetDateTime(dtDateTime TSRMLS_CC), sETag, (int32_t)sETag_len, (TSBWinAzureObjectAccessConditionRaw)fDestCondition, SBGetDateTime(dtDestDateTime TSRMLS_CC), sDestETag, (int32_t)sDestETag_len, (int8_t)bPreserveMetadata, SBGetObjectHandle(oMetadata TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomDataStorageObject_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
#ifdef SB_WINDOWS
		SBErrorExpectsArguments("(string, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, bool, TStringList) or (string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TStringList) or (string, string, string, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, bool, TStringList) or (string, string, string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TStringList)" TSRMLS_CC);
#else
		SBErrorExpectsArguments("(string, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, bool, TElStringList) or (string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TElStringList) or (string, string, string, string, string, TElCustomDataStorageSecurityHandler) or (string, string, string, string, string, bool, TElStringList) or (string, string, string, string, string, integer, DateTime, string, integer, DateTime, string, bool, TElStringList)" TSRMLS_CC);
#endif
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, GetObjectACL)
{
	char *sName;
	int sName_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageContainer_GetObjectACL(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1265298300, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, SetObjectACL)
{
	char *sACL;
	char *sName;
	int sACL_len;
	int sName_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sName, &sName_len, &sACL, &sACL_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_SetObjectACL(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sACL, (int32_t)sACL_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, GetRemoteETag)
{
	char *sName;
	int sName_len;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sName, &sName_len) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageContainer_GetRemoteETag(SBGetObjectHandle(getThis() TSRMLS_CC), sName, (int32_t)sName_len, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(76797302, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, Delete)
{
	char *sSharedAccessSignature;
	int sSharedAccessSignature_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_Delete(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_Delete_1(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, Exists)
{
	char *sSharedAccessSignature;
	int sSharedAccessSignature_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageContainer_Exists(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sSharedAccessSignature, &sSharedAccessSignature_len) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageContainer_Exists_1(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, GetACL)
{
	char *sSharedAccessSignature;
	int sSharedAccessSignature_len;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPolicy, TElWinAzureAccessPolicy_ce_ptr) == SUCCESS)
	{
		TSBWinAzureContainerAccessLevelRaw fOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageContainer_GetACL(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &oPolicy, TElWinAzureAccessPolicy_ce_ptr) == SUCCESS)
	{
		TSBWinAzureContainerAccessLevelRaw fOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageContainer_GetACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, SBGetObjectHandle(oPolicy TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElWinAzureAccessPolicy) or (string, TElWinAzureAccessPolicy)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, SetACL)
{
	char *sSharedAccessSignature;
	int sSharedAccessSignature_len;
	long fLevel;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &fLevel, &oPolicy, TElWinAzureAccessPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_SetACL(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBWinAzureContainerAccessLevelRaw)fLevel, SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "slO!", &sSharedAccessSignature, &sSharedAccessSignature_len, &fLevel, &oPolicy, TElWinAzureAccessPolicy_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElWinAzureDataStorageContainer_SetACL_1(SBGetObjectHandle(getThis() TSRMLS_CC), sSharedAccessSignature, (int32_t)sSharedAccessSignature_len, (TSBWinAzureContainerAccessLevelRaw)fLevel, SBGetObjectHandle(oPolicy TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TElWinAzureAccessPolicy) or (string, integer, TElWinAzureAccessPolicy)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, CreateSharedAccessSignature)
{
	uint32_t _err;
	zval *oPolicy;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oPolicy, TElWinAzureSingleAccessPolicy_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageContainer_CreateSharedAccessSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oPolicy TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(404513250, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElWinAzureSingleAccessPolicy)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageContainer_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(589433460, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, get_Address)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageContainer_get_Address(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1725004108, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, get_LastModified)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageContainer_get_LastModified(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, get_ETag)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElWinAzureDataStorageContainer_get_ETag(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1808235474, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, get_Metadata)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_get_Metadata(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, get_CustomHeaders)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_get_CustomHeaders(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainer, __construct)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElWinAzureDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainer_Create_1(SBGetObjectHandle(oStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElWinAzureDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_AcquireObject, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, SharedAccessSignature)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_List, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Objects_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Prefix_or_Objects, 0, 1)
	ZEND_ARG_INFO(0, Delimiter_or_Prefix)
	ZEND_ARG_INFO(0, MaxCount_or_Delimiter)
	ZEND_ARG_TYPE_INFO(0, Prefixes_or_MaxCount, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Headers_or_IncludeSnapshots_or_Prefixes, 0, 1)
	ZEND_ARG_TYPE_INFO(0, IncludeMetadata_or_Headers_or_IncludeSnapshots, 0, 1)
	ZEND_ARG_INFO(0, IncludeUncommittedBlobs_or_IncludeMetadata)
	ZEND_ARG_TYPE_INFO(0, Headers_or_IncludeUncommittedBlobs, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_ListInit, 0, 0, 0)
	ZEND_ARG_INFO(0, Prefix_or_SharedAccessSignature)
	ZEND_ARG_INFO(0, Delimiter_or_Prefix)
	ZEND_ARG_TYPE_INFO(0, Prefixes_or_Delimiter, 0, 1)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers_or_Prefixes, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers_or_Prefixes, TElStringList, 1)
#endif
	ZEND_ARG_INFO(0, IncludeSnapshots)
	ZEND_ARG_INFO(0, IncludeMetadata)
	ZEND_ARG_INFO(0, IncludeUncommittedBlobs)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Headers, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Headers, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_ListNext, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, State, TElWinAzureDataStorageListState, 1)
	ZEND_ARG_OBJ_INFO(0, Objects, TElDataStorageObjectList, 1)
	ZEND_ARG_INFO(0, MaxCount)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_ListFinal, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(1, State, TElWinAzureDataStorageListState, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_CreateObject, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_TYPE_INFO(0, Handler_or_ContentType_or_InitialSize_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ContentEncoding_or_InitialSize_or_Handler, 0, 1)
	ZEND_ARG_INFO(0, ContentLanguage_or_InitialSize)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_ContentMD5, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Metadata_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, InitialSize_or_Handler_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_INFO(0, InitialSize)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_DeleteObject, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, SharedAccessSignature)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_ObjectExists, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, SharedAccessSignature)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_WriteObject, 0, 0, 3)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_TYPE_INFO(0, Data_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_ContentType_or_Data, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ContentEncoding_or_Handler_or_ContentType, 0, 1)
	ZEND_ARG_INFO(0, ContentLanguage_or_ContentEncoding)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_ContentMD5_or_ContentLanguage, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Metadata_or_ContentMD5, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Handler_or_Metadata, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_ReadObject, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_TYPE_INFO(0, Strm_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Condition_or_Strm, 0, 1)
	ZEND_ARG_INFO(0, DateTime_or_Condition)
	ZEND_ARG_INFO(0, ETag_or_DateTime)
	ZEND_ARG_INFO(0, SeqNum_or_ETag)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_SeqNum, 0, 1)
	ZEND_ARG_TYPE_INFO(1, ObjContentType_or_Metadata, 0, 1)
	ZEND_ARG_INFO(1, ObjContentEncoding_or_ObjContentType)
	ZEND_ARG_INFO(1, ObjContentLanguage_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentMD5_or_ObjContentLanguage)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentMD5)
	ZEND_ARG_INFO(1, ObjETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_ReadBlock, 0, 0, 5)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_TYPE_INFO(0, Strm_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Offset_or_Strm, 0, 1)
	ZEND_ARG_INFO(0, Size_or_Offset)
	ZEND_ARG_INFO(1, Read_or_Size)
	ZEND_ARG_INFO(1, Condition_or_Read)
	ZEND_ARG_INFO(0, DateTime_or_Condition)
	ZEND_ARG_INFO(0, ETag_or_DateTime)
	ZEND_ARG_INFO(0, SeqNum_or_ETag)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_SeqNum, 0, 1)
	ZEND_ARG_TYPE_INFO(1, ObjContentType_or_Metadata, 0, 1)
	ZEND_ARG_INFO(1, ObjContentEncoding_or_ObjContentType)
	ZEND_ARG_INFO(1, ObjContentLanguage_or_ObjContentEncoding)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentMD5_or_ObjContentLanguage)
	ZEND_ARG_INFO(1, ObjETag_or_ObjContentMD5)
	ZEND_ARG_INFO(1, ObjETag)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_CopyObject, 0, 0, 4)
	ZEND_ARG_INFO(0, SourceName)
	ZEND_ARG_INFO(0, DestContainerName_or_SharedAccessSignature)
	ZEND_ARG_INFO(0, DestName_or_DestContainerName)
	ZEND_ARG_TYPE_INFO(0, NewHandler_or_PreserveMetadata_or_Condition_or_DestName, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_DateTime_or_DestSharedAccessSignature, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ETag_or_NewHandler_or_PreserveMetadata_or_Condition, 0, 1)
	ZEND_ARG_TYPE_INFO(0, DestCondition_or_Metadata_or_DateTime, 0, 1)
	ZEND_ARG_INFO(0, DestDateTime_or_ETag)
	ZEND_ARG_INFO(0, DestETag_or_DestCondition)
	ZEND_ARG_INFO(0, PreserveMetadata_or_DestDateTime)
	ZEND_ARG_TYPE_INFO(0, Metadata_or_DestETag, 0, 1)
	ZEND_ARG_INFO(0, PreserveMetadata)
#ifdef SB_WINDOWS
	ZEND_ARG_OBJ_INFO(0, Metadata, TStringList, 1)
#else
	ZEND_ARG_OBJ_INFO(0, Metadata, TElStringList, 1)
#endif
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_GetObjectACL, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_SetObjectACL, 0, 0, 2)
	ZEND_ARG_INFO(0, Name)
	ZEND_ARG_INFO(0, ACL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_GetRemoteETag, 0, 0, 1)
	ZEND_ARG_INFO(0, Name)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_Delete, 0, 0, 0)
	ZEND_ARG_INFO(0, SharedAccessSignature)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_Exists, 0, 0, 0)
	ZEND_ARG_INFO(0, SharedAccessSignature)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_GetACL, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Policy_or_SharedAccessSignature, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Policy, TElWinAzureAccessPolicy, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_SetACL, 0, 0, 2)
	ZEND_ARG_INFO(0, Level_or_SharedAccessSignature)
	ZEND_ARG_TYPE_INFO(0, Policy_or_Level, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Policy, TElWinAzureAccessPolicy, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_CreateSharedAccessSignature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Policy, TElWinAzureSingleAccessPolicy, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_get_Address, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_get_LastModified, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_get_ETag, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_get_Metadata, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer_get_CustomHeaders, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainer___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Storage, TElWinAzureDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWinAzureDataStorageContainer_methods[] = {
	PHP_ME(TElWinAzureDataStorageContainer, AcquireObject, arginfo_TElWinAzureDataStorageContainer_AcquireObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, List, arginfo_TElWinAzureDataStorageContainer_List, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, ListInit, arginfo_TElWinAzureDataStorageContainer_ListInit, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, ListNext, arginfo_TElWinAzureDataStorageContainer_ListNext, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, ListFinal, arginfo_TElWinAzureDataStorageContainer_ListFinal, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, CreateObject, arginfo_TElWinAzureDataStorageContainer_CreateObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, DeleteObject, arginfo_TElWinAzureDataStorageContainer_DeleteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, ObjectExists, arginfo_TElWinAzureDataStorageContainer_ObjectExists, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, WriteObject, arginfo_TElWinAzureDataStorageContainer_WriteObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, ReadObject, arginfo_TElWinAzureDataStorageContainer_ReadObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, ReadBlock, arginfo_TElWinAzureDataStorageContainer_ReadBlock, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, CopyObject, arginfo_TElWinAzureDataStorageContainer_CopyObject, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, GetObjectACL, arginfo_TElWinAzureDataStorageContainer_GetObjectACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, SetObjectACL, arginfo_TElWinAzureDataStorageContainer_SetObjectACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, GetRemoteETag, arginfo_TElWinAzureDataStorageContainer_GetRemoteETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, Delete, arginfo_TElWinAzureDataStorageContainer_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, Exists, arginfo_TElWinAzureDataStorageContainer_Exists, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, GetACL, arginfo_TElWinAzureDataStorageContainer_GetACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, SetACL, arginfo_TElWinAzureDataStorageContainer_SetACL, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, CreateSharedAccessSignature, arginfo_TElWinAzureDataStorageContainer_CreateSharedAccessSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, get_Name, arginfo_TElWinAzureDataStorageContainer_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, get_Address, arginfo_TElWinAzureDataStorageContainer_get_Address, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, get_LastModified, arginfo_TElWinAzureDataStorageContainer_get_LastModified, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, get_ETag, arginfo_TElWinAzureDataStorageContainer_get_ETag, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, get_Metadata, arginfo_TElWinAzureDataStorageContainer_get_Metadata, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, get_CustomHeaders, arginfo_TElWinAzureDataStorageContainer_get_CustomHeaders, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainer, __construct, arginfo_TElWinAzureDataStorageContainer___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWinAzureDataStorageContainer(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWinAzureDataStorageContainer_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWinAzureDataStorageContainer", TElWinAzureDataStorageContainer_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWinAzureDataStorageContainer_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElWinAzureDataStorageContainerList_ce_ptr = NULL;

SB_PHP_METHOD(TElWinAzureDataStorageContainerList, get_Containers)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainerList_get_Containers(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElWinAzureDataStorageContainer_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainerList, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElWinAzureDataStorageContainerList_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElWinAzureDataStorageContainerList, __construct)
{
	zval *oStorage;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainerList_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStorage, TElWinAzureDataStorage_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElWinAzureDataStorageContainerList_Create_1(SBGetObjectHandle(oStorage TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElWinAzureDataStorage)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainerList_get_Containers, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainerList_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElWinAzureDataStorageContainerList___construct, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, Storage, TElWinAzureDataStorage, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElWinAzureDataStorageContainerList_methods[] = {
	PHP_ME(TElWinAzureDataStorageContainerList, get_Containers, arginfo_TElWinAzureDataStorageContainerList_get_Containers, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainerList, get_Count, arginfo_TElWinAzureDataStorageContainerList_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElWinAzureDataStorageContainerList, __construct, arginfo_TElWinAzureDataStorageContainerList___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElWinAzureDataStorageContainerList(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElWinAzureDataStorageContainerList_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElWinAzureDataStorageContainerList", TElWinAzureDataStorageContainerList_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElWinAzureDataStorageContainerList_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBWinAzureDataStorage, GetNodeInnerXML)
{
	uint32_t _err;
	zval *oXmlNode;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oXmlNode, TElXMLDOMNode_ce_ptr) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBWinAzureDataStorage_GetNodeInnerXML(SBGetObjectHandle(oXmlNode TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1042628118, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMNode)" TSRMLS_CC);
	}
}

void Register_SBWinAzureDataStorage_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBWinAzureObjectAccessCondition", NULL);
	TSBWinAzureObjectAccessCondition_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBWinAzureObjectAccessCondition_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureObjectAccessCondition_ce_ptr, "msoaNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureObjectAccessCondition_ce_ptr, "msoaIfModifiedSince", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureObjectAccessCondition_ce_ptr, "msoaIfUnmodifiedSince", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureObjectAccessCondition_ce_ptr, "msoaIfMatch", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureObjectAccessCondition_ce_ptr, "msoaIfNoneMatch", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureObjectAccessCondition_ce_ptr, "msoaIfSequenceNumberIsLessThanOrEqual", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureObjectAccessCondition_ce_ptr, "msoaIfSequenceNumberIsLess", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureObjectAccessCondition_ce_ptr, "msoaIfSequenceNumberIsEqual", 7)
	
	INIT_CLASS_ENTRY(ce, "TSBWinAzureContainerAccessLevel", NULL);
	TSBWinAzureContainerAccessLevel_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBWinAzureContainerAccessLevel_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureContainerAccessLevel_ce_ptr, "calUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureContainerAccessLevel_ce_ptr, "calPrivate", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureContainerAccessLevel_ce_ptr, "calContainer", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureContainerAccessLevel_ce_ptr, "calBlob", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBWinAzureContainerAccessLevel_ce_ptr, "calTrue", 4)
}
