#include "sbxmladesintf.h"

zend_class_entry *TElXAdESIncludedProperty_ce_ptr = NULL;

zend_class_entry *TElXAdESIncludedProperties_ce_ptr = NULL;

zend_class_entry *TSBXAdESOption_ce_ptr = NULL;

zend_class_entry *TSBXAdESOptions_ce_ptr = NULL;

zend_class_entry *TSBXAdESValidity_ce_ptr = NULL;

zend_class_entry *TSBXAdESValidityReason_ce_ptr = NULL;

zend_class_entry *TSBXAdESValidityReasons_ce_ptr = NULL;

void SB_CALLBACK TSBXAdESCertificateNeededEventRaw(void * _ObjectData, TObjectHandle Sender, TElCertificateLookupHandle Lookup, TElX509CertificateHandle * Cert)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zLookup;
	zval * zCert;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zLookup);
	SBInitObject(zLookup, TElCertificateLookup_ce_ptr, Lookup TSRMLS_CC);
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, *Cert TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zLookup;
	params[2] = &zCert;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zLookup);
	*Cert = SBGetObjectHandleCE(zCert, TElX509Certificate_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zCert TSRMLS_CC);
	zval_ptr_dtor(&zCert);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBXAdESBeforeCertificateValidateEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Cert, TElX509CertificateValidatorHandle CertValidator)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zCert;
	zval * zCertValidator;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, Cert TSRMLS_CC);
	MAKE_STD_ZVAL(zCertValidator);
	SBInitObject(zCertValidator, TElX509CertificateValidator_ce_ptr, CertValidator TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zCert;
	params[2] = &zCertValidator;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCert);
	zval_ptr_dtor(&zCertValidator);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBXAdESAfterCertificateValidateEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Cert, TElX509CertificateValidatorHandle CertValidator, TSBCertificateValidityRaw Validity, TSBCertificateValidityReasonRaw Reason)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zCert;
	zval * zCertValidator;
	zval * zValidity;
	zval * zReason;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, Cert TSRMLS_CC);
	MAKE_STD_ZVAL(zCertValidator);
	SBInitObject(zCertValidator, TElX509CertificateValidator_ce_ptr, CertValidator TSRMLS_CC);
	MAKE_STD_ZVAL(zValidity);
	ZVAL_LONG(zValidity, (long)Validity);
	MAKE_STD_ZVAL(zReason);
	ZVAL_LONG(zReason, (long)Reason);

	params[0] = &zSender;
	params[1] = &zCert;
	params[2] = &zCertValidator;
	params[3] = &zValidity;
	params[4] = &zReason;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCert);
	zval_ptr_dtor(&zCertValidator);
	zval_ptr_dtor(&zValidity);
	zval_ptr_dtor(&zReason);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBXAdESStoreCertificateEventRaw(void * _ObjectData, TObjectHandle Sender, TElX509CertificateHandle Cert, char * pcURI, int32_t * szURI)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zCert;
	zval * zURI;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, Cert TSRMLS_CC);
	MAKE_STD_ZVAL(zURI);
	ZVAL_STRINGL(zURI, pcURI, *szURI, 1);

	params[0] = &zSender;
	params[1] = &zCert;
	params[2] = &zURI;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCert);
	SBCheckError(SBSetEventReturnStringA(3, Z_STRVAL_P(zURI), (int32_t)Z_STRLEN_P(zURI)) TSRMLS_CC);
	zval_ptr_dtor(&zURI);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBXAdESStoreCRLEventRaw(void * _ObjectData, TObjectHandle Sender, TElCertificateRevocationListHandle CRL, char * pcURI, int32_t * szURI)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zCRL;
	zval * zURI;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zCRL);
	SBInitObject(zCRL, TElCertificateRevocationList_ce_ptr, CRL TSRMLS_CC);
	MAKE_STD_ZVAL(zURI);
	ZVAL_STRINGL(zURI, pcURI, *szURI, 1);

	params[0] = &zSender;
	params[1] = &zCRL;
	params[2] = &zURI;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zCRL);
	SBCheckError(SBSetEventReturnStringA(3, Z_STRVAL_P(zURI), (int32_t)Z_STRLEN_P(zURI)) TSRMLS_CC);
	zval_ptr_dtor(&zURI);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBXAdESStoreOCSPResponseEventRaw(void * _ObjectData, TObjectHandle Sender, TElOCSPResponseHandle OCSPResponse, char * pcURI, int32_t * szURI)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zOCSPResponse;
	zval * zURI;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zOCSPResponse);
	SBInitObject(zOCSPResponse, TElOCSPResponse_ce_ptr, OCSPResponse TSRMLS_CC);
	MAKE_STD_ZVAL(zURI);
	ZVAL_STRINGL(zURI, pcURI, *szURI, 1);

	params[0] = &zSender;
	params[1] = &zOCSPResponse;
	params[2] = &zURI;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zOCSPResponse);
	SBCheckError(SBSetEventReturnStringA(3, Z_STRVAL_P(zURI), (int32_t)Z_STRLEN_P(zURI)) TSRMLS_CC);
	zval_ptr_dtor(&zURI);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBXAdESRetrieveCertificateEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURI, int32_t szURI, TElXMLCertIDHandle CertID, TElX509CertificateHandle * Cert, int8_t * ReleaseObj)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zURI;
	zval * zCertID;
	zval * zCert;
	zval * zReleaseObj;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURI);
	ZVAL_STRINGL(zURI, pcURI, szURI, 1);
	MAKE_STD_ZVAL(zCertID);
	SBInitObject(zCertID, TElXMLCertID_ce_ptr, CertID TSRMLS_CC);
	MAKE_STD_ZVAL(zCert);
	SBInitObject(zCert, TElX509Certificate_ce_ptr, *Cert TSRMLS_CC);
	MAKE_STD_ZVAL(zReleaseObj);
	ZVAL_BOOL(zReleaseObj, (zend_bool)*ReleaseObj);

	params[0] = &zSender;
	params[1] = &zURI;
	params[2] = &zCertID;
	params[3] = &zCert;
	params[4] = &zReleaseObj;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURI);
	zval_ptr_dtor(&zCertID);
	*Cert = SBGetObjectHandleCE(zCert, TElX509Certificate_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zCert TSRMLS_CC);
	zval_ptr_dtor(&zCert);
	*ReleaseObj = (int8_t)Z_BVAL_P(zReleaseObj);
	zval_ptr_dtor(&zReleaseObj);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBXAdESRetrieveCRLEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURI, int32_t szURI, TElXMLCRLRefHandle CRLRef, TElCertificateRevocationListHandle * CRL, int8_t * ReleaseObj)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zURI;
	zval * zCRLRef;
	zval * zCRL;
	zval * zReleaseObj;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURI);
	ZVAL_STRINGL(zURI, pcURI, szURI, 1);
	MAKE_STD_ZVAL(zCRLRef);
	SBInitObject(zCRLRef, TElXMLCRLRef_ce_ptr, CRLRef TSRMLS_CC);
	MAKE_STD_ZVAL(zCRL);
	SBInitObject(zCRL, TElCertificateRevocationList_ce_ptr, *CRL TSRMLS_CC);
	MAKE_STD_ZVAL(zReleaseObj);
	ZVAL_BOOL(zReleaseObj, (zend_bool)*ReleaseObj);

	params[0] = &zSender;
	params[1] = &zURI;
	params[2] = &zCRLRef;
	params[3] = &zCRL;
	params[4] = &zReleaseObj;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURI);
	zval_ptr_dtor(&zCRLRef);
	*CRL = SBGetObjectHandleCE(zCRL, TElCertificateRevocationList_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zCRL TSRMLS_CC);
	zval_ptr_dtor(&zCRL);
	*ReleaseObj = (int8_t)Z_BVAL_P(zReleaseObj);
	zval_ptr_dtor(&zReleaseObj);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBXAdESRetrieveOCSPResponseEventRaw(void * _ObjectData, TObjectHandle Sender, const char * pcURI, int32_t szURI, TElXMLOCSPRefHandle OCSPRef, TElOCSPResponseHandle * OCSPResponse, int8_t * ReleaseObj)
{
	zval *retval_ptr;
	zval **params[5];
	zval * zSender;
	zval * zURI;
	zval * zOCSPRef;
	zval * zOCSPResponse;
	zval * zReleaseObj;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zURI);
	ZVAL_STRINGL(zURI, pcURI, szURI, 1);
	MAKE_STD_ZVAL(zOCSPRef);
	SBInitObject(zOCSPRef, TElXMLOCSPRef_ce_ptr, OCSPRef TSRMLS_CC);
	MAKE_STD_ZVAL(zOCSPResponse);
	SBInitObject(zOCSPResponse, TElOCSPResponse_ce_ptr, *OCSPResponse TSRMLS_CC);
	MAKE_STD_ZVAL(zReleaseObj);
	ZVAL_BOOL(zReleaseObj, (zend_bool)*ReleaseObj);

	params[0] = &zSender;
	params[1] = &zURI;
	params[2] = &zOCSPRef;
	params[3] = &zOCSPResponse;
	params[4] = &zReleaseObj;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 5, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zURI);
	zval_ptr_dtor(&zOCSPRef);
	*OCSPResponse = SBGetObjectHandleCE(zOCSPResponse, TElOCSPResponse_ce_ptr TSRMLS_CC);
	SBDetachObjectHandleIfUniqueZVal(zOCSPResponse TSRMLS_CC);
	zval_ptr_dtor(&zOCSPResponse);
	*ReleaseObj = (int8_t)Z_BVAL_P(zReleaseObj);
	zval_ptr_dtor(&zReleaseObj);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

void SB_CALLBACK TSBXAdESBeforeSaveUnsignedPropertyEventRaw(void * _ObjectData, TObjectHandle Sender, TElXMLAdESElementHandle Element)
{
	zval *retval_ptr;
	zval **params[2];
	zval * zSender;
	zval * zElement;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zElement);
	SBInitObject(zElement, TElXMLAdESElement_ce_ptr, Element TSRMLS_CC);

	params[0] = &zSender;
	params[1] = &zElement;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 2, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zElement);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TElXAdESProcessor_ce_ptr = NULL;

SB_PHP_METHOD(TElXAdESProcessor, AddTimestampValidationData)
{
	char *sURI;
	int sURI_len;
	zval *oCerts;
	zval *oCRLs;
	zval *oFormatter;
	zval *oOCSPResponses;
	zval *oTSPInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddTimestampValidationData(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddTimestampValidationData_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!", &oTSPInfo, TElClientTSPInfo_ce_ptr, &sURI, &sURI_len, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddTimestampValidationData_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPInfo TSRMLS_CC), sURI, (int32_t)sURI_len, SBGetObjectHandle(oFormatter TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!", &oCerts, TElCustomCertStorage_ce_ptr, &oCRLs, TElCustomCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddTimestampValidationData_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!sO!", &oCerts, TElCustomCertStorage_ce_ptr, &oCRLs, TElCustomCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr, &sURI, &sURI_len, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddTimestampValidationData_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC), sURI, (int32_t)sURI_len, SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElXMLCustomFormatter) or (TElClientTSPInfo, string, TElXMLCustomFormatter) or (TElCustomCertStorage, TElCustomCRLStorage, TList, TElXMLCustomFormatter) or (TElCustomCertStorage, TElCustomCRLStorage, TList, string, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddCounterSignature)
{
	zval *oFormatter;
	zval *oSigner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSigner, TElXMLProcessor_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddCounterSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigner TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSigner, TElXMLProcessor_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddCounterSignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigner TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLProcessor) or (TElXMLProcessor, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddSignatureTimestamp)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddSignatureTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddSignatureTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient) or (TElCustomTSPClient, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddRefsOnlyTimestamp)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddRefsOnlyTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddRefsOnlyTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient) or (TElCustomTSPClient, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddSigAndRefsTimestamp)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddSigAndRefsTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddSigAndRefsTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient) or (TElCustomTSPClient, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddArchiveTimestamp)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddArchiveTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddArchiveTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient) or (TElCustomTSPClient, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddAttributeCertificateRefs)
{
	long fDigestMethod;
	zval *oCerts;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCerts, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddAttributeCertificateRefs(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!", &oCerts, TElCustomCertStorage_ce_ptr, &fDigestMethod, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddAttributeCertificateRefs_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC), (TElXMLDigestMethodRaw)fDigestMethod, SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage) or (TElCustomCertStorage, integer, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddCompleteCertificateRefs)
{
	long fDigestMethod;
	zval *oCerts;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCerts, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddCompleteCertificateRefs(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lO!", &oCerts, TElCustomCertStorage_ce_ptr, &fDigestMethod, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddCompleteCertificateRefs_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC), (TElXMLDigestMethodRaw)fDigestMethod, SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage) or (TElCustomCertStorage, integer, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddAttributeRevocationRefs)
{
	long fDigestMethod;
	zend_bool bResponderIdByKey;
	zval *oCRLs;
	zval *oFormatter;
	zval *oOCSPResponses;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oCRLs, TElCustomCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddAttributeRevocationRefs(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lbO!", &oCRLs, TElCustomCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr, &fDigestMethod, &bResponderIdByKey, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddAttributeRevocationRefs_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC), (TElXMLDigestMethodRaw)fDigestMethod, (int8_t)bResponderIdByKey, SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCRLStorage, TList) or (TElCustomCRLStorage, TList, integer, bool, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddCompleteRevocationRefs)
{
	long fDigestMethod;
	zend_bool bResponderIdByKey;
	zval *oCRLs;
	zval *oFormatter;
	zval *oOCSPResponses;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oCRLs, TElCustomCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddCompleteRevocationRefs(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lbO!", &oCRLs, TElCustomCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr, &fDigestMethod, &bResponderIdByKey, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddCompleteRevocationRefs_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC), (TElXMLDigestMethodRaw)fDigestMethod, (int8_t)bResponderIdByKey, SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCRLStorage, TList) or (TElCustomCRLStorage, TList, integer, bool, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddValidationDataRefs)
{
	long fDigestMethod;
	zend_bool bIncludeCRL;
	zend_bool bIncludeOCSP;
	zend_bool bResponderIdByKey;
	zval *oFormatter;
	zval *oSigningCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddValidationDataRefs(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!lbO!", &oSigningCertificate, TElX509Certificate_ce_ptr, &fDigestMethod, &bResponderIdByKey, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddValidationDataRefs_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigningCertificate TSRMLS_CC), (TElXMLDigestMethodRaw)fDigestMethod, (int8_t)bResponderIdByKey, SBGetObjectHandle(oFormatter TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bblbO!", &oSigningCertificate, TElX509Certificate_ce_ptr, &bIncludeCRL, &bIncludeOCSP, &fDigestMethod, &bResponderIdByKey, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddValidationDataRefs_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigningCertificate TSRMLS_CC), (int8_t)bIncludeCRL, (int8_t)bIncludeOCSP, (TElXMLDigestMethodRaw)fDigestMethod, (int8_t)bResponderIdByKey, SBGetObjectHandle(oFormatter TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElX509Certificate, integer, bool, TElXMLCustomFormatter) or (TElX509Certificate, bool, bool, integer, bool, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddAttrAuthoritiesCertValues)
{
	zval *oCerts;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCerts, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddAttrAuthoritiesCertValues(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oCerts, TElCustomCertStorage_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddAttrAuthoritiesCertValues_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage) or (TElCustomCertStorage, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddCertificateValues)
{
	zval *oCerts;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCerts, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddCertificateValues(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oCerts, TElCustomCertStorage_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddCertificateValues_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage) or (TElCustomCertStorage, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddAttributeRevocationValues)
{
	zval *oCRLs;
	zval *oFormatter;
	zval *oOCSPResponses;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oCRLs, TElCustomCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddAttributeRevocationValues(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oCRLs, TElCustomCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddAttributeRevocationValues_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCRLStorage, TList) or (TElCustomCRLStorage, TList, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddRevocationValues)
{
	zval *oCRLs;
	zval *oFormatter;
	zval *oOCSPResponses;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oCRLs, TElCustomCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddRevocationValues(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!", &oCRLs, TElCustomCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_AddRevocationValues_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCRLStorage, TList) or (TElCustomCRLStorage, TList, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, AddValidationDataValues)
{
	zend_bool bIncludeCRL;
	zend_bool bIncludeOCSP;
	zval *oFormatter;
	zval *oSigningCertificate;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddValidationDataValues(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSigningCertificate, TElX509Certificate_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddValidationDataValues_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigningCertificate TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!bbO!", &oSigningCertificate, TElX509Certificate_ce_ptr, &bIncludeCRL, &bIncludeOCSP, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_AddValidationDataValues_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigningCertificate TSRMLS_CC), (int8_t)bIncludeCRL, (int8_t)bIncludeOCSP, SBGetObjectHandle(oFormatter TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("() or (TElX509Certificate, TElXMLCustomFormatter) or (TElX509Certificate, bool, bool, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, GetSignerCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESProcessor_GetSignerCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509Certificate_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, ClearPKICache)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_ClearPKICache(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, ExtractAllCertificates)
{
	zval *oCerts;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCerts, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_ExtractAllCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, ExtractAllCRLs)
{
	zval *oCRLs;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCRLs, TElCustomCRLStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_ExtractAllCRLs(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCRLStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, ExtractAllOCSPResponses)
{
	zval *oOCSPResponses;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oOCSPResponses, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_ExtractAllOCSPResponses(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_GracePeriod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_get_GracePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_GracePeriod)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_set_GracePeriod(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_OfflineMode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_get_OfflineMode(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_OfflineMode)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_set_OfflineMode(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_TimestampCanonicalizationMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLCanonicalizationMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_get_TimestampCanonicalizationMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_TimestampCanonicalizationMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_set_TimestampCanonicalizationMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLCanonicalizationMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_XAdESOptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESOptionsRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_get_XAdESOptions(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_XAdESOptions)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_set_XAdESOptions(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXAdESOptionsRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_ValidationMoment)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_get_ValidationMoment(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_ValidationMoment)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_set_ValidationMoment(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_ForceCompleteChainValidation)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_get_ForceCompleteChainValidation(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_ForceCompleteChainValidation)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_set_ForceCompleteChainValidation(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_IgnoreChainValidationErrors)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXAdESProcessor_get_IgnoreChainValidationErrors(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_IgnoreChainValidationErrors)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_set_IgnoreChainValidationErrors(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_TrustedCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESProcessor_get_TrustedCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_TrustedCertificates)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_set_TrustedCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_CryptoProviderManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESProcessor_get_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCryptoProviderManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_CryptoProviderManager)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCryptoProviderManager_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_set_CryptoProviderManager(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCryptoProviderManager)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_CertificateValidator)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESProcessor_get_CertificateValidator(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElX509CertificateValidator_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_CertificateValidator)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElX509CertificateValidator_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESProcessor_set_CertificateValidator(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509CertificateValidator)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_OnBeforeSaveUnsignedProperty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESBeforeSaveUnsignedPropertyEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXAdESProcessor_get_OnBeforeSaveUnsignedProperty(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_OnBeforeSaveUnsignedProperty)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXAdESProcessor_set_OnBeforeSaveUnsignedProperty(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXAdESBeforeSaveUnsignedPropertyEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXAdESBeforeSaveUnsignedPropertyEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_OnBeforeCertificateValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESBeforeCertificateValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXAdESProcessor_get_OnBeforeCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_OnBeforeCertificateValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXAdESProcessor_set_OnBeforeCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXAdESBeforeCertificateValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXAdESBeforeCertificateValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_OnAfterCertificateValidate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESAfterCertificateValidateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXAdESProcessor_get_OnAfterCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_OnAfterCertificateValidate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXAdESProcessor_set_OnAfterCertificateValidate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXAdESAfterCertificateValidateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXAdESAfterCertificateValidateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_OnCertificateNeeded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESCertificateNeededEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXAdESProcessor_get_OnCertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_OnCertificateNeeded)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXAdESProcessor_set_OnCertificateNeeded(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXAdESCertificateNeededEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXAdESCertificateNeededEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_OnStoreCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESStoreCertificateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXAdESProcessor_get_OnStoreCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_OnStoreCertificate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXAdESProcessor_set_OnStoreCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXAdESStoreCertificateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXAdESStoreCertificateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_OnStoreCRL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESStoreCRLEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXAdESProcessor_get_OnStoreCRL(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_OnStoreCRL)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXAdESProcessor_set_OnStoreCRL(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXAdESStoreCRLEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXAdESStoreCRLEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, get_OnStoreOCSPResponse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESStoreOCSPResponseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXAdESProcessor_get_OnStoreOCSPResponse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, set_OnStoreOCSPResponse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXAdESProcessor_set_OnStoreOCSPResponse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXAdESStoreOCSPResponseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXAdESStoreOCSPResponseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESProcessor, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESProcessor_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddTimestampValidationData, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Formatter_or_TSPInfo_or_Certs, 0, 1)
	ZEND_ARG_TYPE_INFO(0, URI_or_CRLs, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Formatter_or_OCSPResponses, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Formatter_or_URI, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddCounterSignature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Signer, TElXMLProcessor, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddSignatureTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddRefsOnlyTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddSigAndRefsTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddArchiveTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddAttributeCertificateRefs, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certs, TElCustomCertStorage, 1)
	ZEND_ARG_INFO(0, DigestMethod)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddCompleteCertificateRefs, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certs, TElCustomCertStorage, 1)
	ZEND_ARG_INFO(0, DigestMethod)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddAttributeRevocationRefs, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, CRLs, TElCustomCRLStorage, 1)
	ZEND_ARG_OBJ_INFO(0, OCSPResponses, TList, 1)
	ZEND_ARG_INFO(0, DigestMethod)
	ZEND_ARG_INFO(0, ResponderIdByKey)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddCompleteRevocationRefs, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, CRLs, TElCustomCRLStorage, 1)
	ZEND_ARG_OBJ_INFO(0, OCSPResponses, TList, 1)
	ZEND_ARG_INFO(0, DigestMethod)
	ZEND_ARG_INFO(0, ResponderIdByKey)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddValidationDataRefs, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, SigningCertificate, TElX509Certificate, 1)
	ZEND_ARG_INFO(0, DigestMethod_or_IncludeCRL)
	ZEND_ARG_INFO(0, ResponderIdByKey_or_IncludeOCSP)
	ZEND_ARG_TYPE_INFO(0, Formatter_or_DigestMethod, 0, 1)
	ZEND_ARG_INFO(0, ResponderIdByKey)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddAttrAuthoritiesCertValues, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certs, TElCustomCertStorage, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddCertificateValues, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certs, TElCustomCertStorage, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddAttributeRevocationValues, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, CRLs, TElCustomCRLStorage, 1)
	ZEND_ARG_OBJ_INFO(0, OCSPResponses, TList, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddRevocationValues, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, CRLs, TElCustomCRLStorage, 1)
	ZEND_ARG_OBJ_INFO(0, OCSPResponses, TList, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_AddValidationDataValues, 0, 0, 0)
	ZEND_ARG_OBJ_INFO(0, SigningCertificate, TElX509Certificate, 1)
	ZEND_ARG_TYPE_INFO(0, Formatter_or_IncludeCRL, 0, 1)
	ZEND_ARG_INFO(0, IncludeOCSP)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_GetSignerCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_ClearPKICache, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_ExtractAllCertificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certs, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_ExtractAllCRLs, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, CRLs, TElCustomCRLStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_ExtractAllOCSPResponses, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, OCSPResponses, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_GracePeriod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_GracePeriod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_OfflineMode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_OfflineMode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_TimestampCanonicalizationMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_TimestampCanonicalizationMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_XAdESOptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_XAdESOptions, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_ValidationMoment, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_ValidationMoment, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_ForceCompleteChainValidation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_ForceCompleteChainValidation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_IgnoreChainValidationErrors, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_IgnoreChainValidationErrors, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_TrustedCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_TrustedCertificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_CryptoProviderManager, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_CryptoProviderManager, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCryptoProviderManager, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_CertificateValidator, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_CertificateValidator, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElX509CertificateValidator, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_OnBeforeSaveUnsignedProperty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_OnBeforeSaveUnsignedProperty, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_OnBeforeCertificateValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_OnBeforeCertificateValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_OnAfterCertificateValidate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_OnAfterCertificateValidate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_OnCertificateNeeded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_OnCertificateNeeded, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_OnStoreCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_OnStoreCertificate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_OnStoreCRL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_OnStoreCRL, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_get_OnStoreOCSPResponse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor_set_OnStoreOCSPResponse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESProcessor___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXAdESProcessor_methods[] = {
	PHP_ME(TElXAdESProcessor, AddTimestampValidationData, arginfo_TElXAdESProcessor_AddTimestampValidationData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddCounterSignature, arginfo_TElXAdESProcessor_AddCounterSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddSignatureTimestamp, arginfo_TElXAdESProcessor_AddSignatureTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddRefsOnlyTimestamp, arginfo_TElXAdESProcessor_AddRefsOnlyTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddSigAndRefsTimestamp, arginfo_TElXAdESProcessor_AddSigAndRefsTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddArchiveTimestamp, arginfo_TElXAdESProcessor_AddArchiveTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddAttributeCertificateRefs, arginfo_TElXAdESProcessor_AddAttributeCertificateRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddCompleteCertificateRefs, arginfo_TElXAdESProcessor_AddCompleteCertificateRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddAttributeRevocationRefs, arginfo_TElXAdESProcessor_AddAttributeRevocationRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddCompleteRevocationRefs, arginfo_TElXAdESProcessor_AddCompleteRevocationRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddValidationDataRefs, arginfo_TElXAdESProcessor_AddValidationDataRefs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddAttrAuthoritiesCertValues, arginfo_TElXAdESProcessor_AddAttrAuthoritiesCertValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddCertificateValues, arginfo_TElXAdESProcessor_AddCertificateValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddAttributeRevocationValues, arginfo_TElXAdESProcessor_AddAttributeRevocationValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddRevocationValues, arginfo_TElXAdESProcessor_AddRevocationValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, AddValidationDataValues, arginfo_TElXAdESProcessor_AddValidationDataValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, GetSignerCertificate, arginfo_TElXAdESProcessor_GetSignerCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, ClearPKICache, arginfo_TElXAdESProcessor_ClearPKICache, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, ExtractAllCertificates, arginfo_TElXAdESProcessor_ExtractAllCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, ExtractAllCRLs, arginfo_TElXAdESProcessor_ExtractAllCRLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, ExtractAllOCSPResponses, arginfo_TElXAdESProcessor_ExtractAllOCSPResponses, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_GracePeriod, arginfo_TElXAdESProcessor_get_GracePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_GracePeriod, arginfo_TElXAdESProcessor_set_GracePeriod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_OfflineMode, arginfo_TElXAdESProcessor_get_OfflineMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_OfflineMode, arginfo_TElXAdESProcessor_set_OfflineMode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_TimestampCanonicalizationMethod, arginfo_TElXAdESProcessor_get_TimestampCanonicalizationMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_TimestampCanonicalizationMethod, arginfo_TElXAdESProcessor_set_TimestampCanonicalizationMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_XAdESOptions, arginfo_TElXAdESProcessor_get_XAdESOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_XAdESOptions, arginfo_TElXAdESProcessor_set_XAdESOptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_ValidationMoment, arginfo_TElXAdESProcessor_get_ValidationMoment, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_ValidationMoment, arginfo_TElXAdESProcessor_set_ValidationMoment, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_ForceCompleteChainValidation, arginfo_TElXAdESProcessor_get_ForceCompleteChainValidation, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_ForceCompleteChainValidation, arginfo_TElXAdESProcessor_set_ForceCompleteChainValidation, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_IgnoreChainValidationErrors, arginfo_TElXAdESProcessor_get_IgnoreChainValidationErrors, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_IgnoreChainValidationErrors, arginfo_TElXAdESProcessor_set_IgnoreChainValidationErrors, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_TrustedCertificates, arginfo_TElXAdESProcessor_get_TrustedCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_TrustedCertificates, arginfo_TElXAdESProcessor_set_TrustedCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_CryptoProviderManager, arginfo_TElXAdESProcessor_get_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_CryptoProviderManager, arginfo_TElXAdESProcessor_set_CryptoProviderManager, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_CertificateValidator, arginfo_TElXAdESProcessor_get_CertificateValidator, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_CertificateValidator, arginfo_TElXAdESProcessor_set_CertificateValidator, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_OnBeforeSaveUnsignedProperty, arginfo_TElXAdESProcessor_get_OnBeforeSaveUnsignedProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_OnBeforeSaveUnsignedProperty, arginfo_TElXAdESProcessor_set_OnBeforeSaveUnsignedProperty, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_OnBeforeCertificateValidate, arginfo_TElXAdESProcessor_get_OnBeforeCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_OnBeforeCertificateValidate, arginfo_TElXAdESProcessor_set_OnBeforeCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_OnAfterCertificateValidate, arginfo_TElXAdESProcessor_get_OnAfterCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_OnAfterCertificateValidate, arginfo_TElXAdESProcessor_set_OnAfterCertificateValidate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_OnCertificateNeeded, arginfo_TElXAdESProcessor_get_OnCertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_OnCertificateNeeded, arginfo_TElXAdESProcessor_set_OnCertificateNeeded, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_OnStoreCertificate, arginfo_TElXAdESProcessor_get_OnStoreCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_OnStoreCertificate, arginfo_TElXAdESProcessor_set_OnStoreCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_OnStoreCRL, arginfo_TElXAdESProcessor_get_OnStoreCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_OnStoreCRL, arginfo_TElXAdESProcessor_set_OnStoreCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, get_OnStoreOCSPResponse, arginfo_TElXAdESProcessor_get_OnStoreOCSPResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, set_OnStoreOCSPResponse, arginfo_TElXAdESProcessor_set_OnStoreOCSPResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESProcessor, __construct, arginfo_TElXAdESProcessor___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXAdESProcessor(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXAdESProcessor_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXAdESProcessor", TElXAdESProcessor_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElXAdESProcessor_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXAdESSigner_ce_ptr = NULL;

SB_PHP_METHOD(TElXAdESSigner, TimestampDataObjects)
{
	zval *oAReferences;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oAReferences, TElXMLReferenceList_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESSigner_TimestampDataObjects(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAReferences TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLReferenceList, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, AddUnsignedObjects)
{
	zval *oAObjects;
	zval *oAReferences;
	zval *oFormatter;
	zval *oKeyInfo;
	zval *oSignatureValue;
	zval *oSignedInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!O!O!", &oSignedInfo, TElXMLDOMElement_ce_ptr, &oSignatureValue, TElXMLDOMElement_ce_ptr, &oKeyInfo, TElXMLKeyInfo_ce_ptr, &oAReferences, TElXMLReferenceList_ce_ptr, &oAObjects, TObject_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESSigner_AddUnsignedObjects(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSignedInfo TSRMLS_CC), SBGetObjectHandle(oSignatureValue TSRMLS_CC), SBGetObjectHandle(oKeyInfo TSRMLS_CC), SBGetObjectHandle(oAReferences TSRMLS_CC), SBGetObjectHandle(oAObjects TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement, TElXMLDOMElement, TElXMLKeyInfo, TElXMLReferenceList, TObject, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, SetSigningCertificates)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_SetSigningCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, SetTSPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_SetTSPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, SetXAdESForm)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_SetXAdESForm(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXAdESFormRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, SetXAdESVersion)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_SetXAdESVersion(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXAdESVersionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, Generate)
{
	long fAXAdESForm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_Generate(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fAXAdESForm) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_Generate_1(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXAdESFormRaw)fAXAdESForm) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, AddCounterSignature)
{
	zval *oFormatter;
	zval *oSigner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSigner, TElXMLProcessor_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_AddCounterSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigner TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSigner, TElXMLProcessor_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_AddCounterSignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigner TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLProcessor, TElXMLCustomFormatter) or (TElXMLProcessor)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, AddAllDataObjectsTimestamp)
{
	zval *oATSPClient;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_AddAllDataObjectsTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, AddSignatureTimestamp)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESSigner_AddSignatureTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESSigner_AddSignatureTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient, TElXMLCustomFormatter) or (TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, AddRefsOnlyTimestamp)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESSigner_AddRefsOnlyTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESSigner_AddRefsOnlyTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient, TElXMLCustomFormatter) or (TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, AddSigAndRefsTimestamp)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESSigner_AddSigAndRefsTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESSigner_AddSigAndRefsTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient, TElXMLCustomFormatter) or (TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, AddArchiveTimestamp)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESSigner_AddArchiveTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESSigner_AddArchiveTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient, TElXMLCustomFormatter) or (TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_PolicyId)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESSigner_get_PolicyId(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignaturePolicyId_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_PolicyId)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLSignaturePolicyId_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_PolicyId(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSignaturePolicyId)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_ProductionPlace)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESSigner_get_ProductionPlace(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignatureProductionPlace_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_ProductionPlace)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLSignatureProductionPlace_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_ProductionPlace(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSignatureProductionPlace)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_SignerRole)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESSigner_get_SignerRole(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignerRole_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_SignerRole)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLSignerRole_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_SignerRole(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSignerRole)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_QualifyingProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESSigner_get_QualifyingProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLQualifyingProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_QualifyingProperties)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLQualifyingProperties_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_QualifyingProperties(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLQualifyingProperties)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_QualifyingPropertiesReferences)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESSigner_get_QualifyingPropertiesReferences(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLQualifyingPropertiesReferenceList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_OwnSigningCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXAdESSigner_get_OwnSigningCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_OwnSigningCertificates)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_OwnSigningCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_SigningCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESSigner_get_SigningCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_SigningCertificates)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_SigningCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_SigningTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXAdESSigner_get_SigningTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_SigningTime)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_SigningTime(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_SigningCertificatesDigestMethod)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXMLDigestMethodRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESSigner_get_SigningCertificatesDigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_SigningCertificatesDigestMethod)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_SigningCertificatesDigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXMLDigestMethodRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_Included)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXAdESIncludedPropertiesRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESSigner_get_Included(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_Included)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_Included(SBGetObjectHandle(getThis() TSRMLS_CC), (TElXAdESIncludedPropertiesRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_TSPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESSigner_get_TSPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomTSPClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_TSPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_TSPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_IgnoreTimestampFailure)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXAdESSigner_get_IgnoreTimestampFailure(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_IgnoreTimestampFailure)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_IgnoreTimestampFailure(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_XAdESForm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESFormRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESSigner_get_XAdESForm(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_XAdESForm)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_XAdESForm(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXAdESFormRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, get_XAdESVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESVersionRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESSigner_get_XAdESVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, set_XAdESVersion)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXAdESSigner_set_XAdESVersion(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXAdESVersionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESSigner, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESSigner_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_TimestampDataObjects, 0, 0, 2)
	ZEND_ARG_OBJ_INFO(0, AReferences, TElXMLReferenceList, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_AddUnsignedObjects, 0, 0, 6)
	ZEND_ARG_OBJ_INFO(0, SignedInfo, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(0, SignatureValue, TElXMLDOMElement, 1)
	ZEND_ARG_OBJ_INFO(0, KeyInfo, TElXMLKeyInfo, 1)
	ZEND_ARG_OBJ_INFO(0, AReferences, TElXMLReferenceList, 1)
	ZEND_ARG_OBJ_INFO(0, AObjects, TObject, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_SetSigningCertificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_SetTSPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomTSPClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_SetXAdESForm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_SetXAdESVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_Generate, 0, 0, 0)
	ZEND_ARG_INFO(0, AXAdESForm)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_AddCounterSignature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Signer, TElXMLProcessor, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_AddAllDataObjectsTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_AddSignatureTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_AddRefsOnlyTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_AddSigAndRefsTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_AddArchiveTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_PolicyId, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_PolicyId, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLSignaturePolicyId, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_ProductionPlace, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_ProductionPlace, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLSignatureProductionPlace, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_SignerRole, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_SignerRole, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLSignerRole, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_QualifyingProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_QualifyingProperties, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLQualifyingProperties, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_QualifyingPropertiesReferences, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_OwnSigningCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_OwnSigningCertificates, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_SigningCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_SigningCertificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_SigningTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_SigningTime, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_SigningCertificatesDigestMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_SigningCertificatesDigestMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_Included, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_Included, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_TSPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_TSPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomTSPClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_IgnoreTimestampFailure, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_IgnoreTimestampFailure, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_XAdESForm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_XAdESForm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_get_XAdESVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner_set_XAdESVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESSigner___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXAdESSigner_methods[] = {
	PHP_ME(TElXAdESSigner, TimestampDataObjects, arginfo_TElXAdESSigner_TimestampDataObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, AddUnsignedObjects, arginfo_TElXAdESSigner_AddUnsignedObjects, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, SetSigningCertificates, arginfo_TElXAdESSigner_SetSigningCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, SetTSPClient, arginfo_TElXAdESSigner_SetTSPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, SetXAdESForm, arginfo_TElXAdESSigner_SetXAdESForm, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, SetXAdESVersion, arginfo_TElXAdESSigner_SetXAdESVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, Clear, arginfo_TElXAdESSigner_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, Generate, arginfo_TElXAdESSigner_Generate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, AddCounterSignature, arginfo_TElXAdESSigner_AddCounterSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, AddAllDataObjectsTimestamp, arginfo_TElXAdESSigner_AddAllDataObjectsTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, AddSignatureTimestamp, arginfo_TElXAdESSigner_AddSignatureTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, AddRefsOnlyTimestamp, arginfo_TElXAdESSigner_AddRefsOnlyTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, AddSigAndRefsTimestamp, arginfo_TElXAdESSigner_AddSigAndRefsTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, AddArchiveTimestamp, arginfo_TElXAdESSigner_AddArchiveTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_PolicyId, arginfo_TElXAdESSigner_get_PolicyId, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_PolicyId, arginfo_TElXAdESSigner_set_PolicyId, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_ProductionPlace, arginfo_TElXAdESSigner_get_ProductionPlace, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_ProductionPlace, arginfo_TElXAdESSigner_set_ProductionPlace, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_SignerRole, arginfo_TElXAdESSigner_get_SignerRole, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_SignerRole, arginfo_TElXAdESSigner_set_SignerRole, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_QualifyingProperties, arginfo_TElXAdESSigner_get_QualifyingProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_QualifyingProperties, arginfo_TElXAdESSigner_set_QualifyingProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_QualifyingPropertiesReferences, arginfo_TElXAdESSigner_get_QualifyingPropertiesReferences, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_OwnSigningCertificates, arginfo_TElXAdESSigner_get_OwnSigningCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_OwnSigningCertificates, arginfo_TElXAdESSigner_set_OwnSigningCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_SigningCertificates, arginfo_TElXAdESSigner_get_SigningCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_SigningCertificates, arginfo_TElXAdESSigner_set_SigningCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_SigningTime, arginfo_TElXAdESSigner_get_SigningTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_SigningTime, arginfo_TElXAdESSigner_set_SigningTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_SigningCertificatesDigestMethod, arginfo_TElXAdESSigner_get_SigningCertificatesDigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_SigningCertificatesDigestMethod, arginfo_TElXAdESSigner_set_SigningCertificatesDigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_Included, arginfo_TElXAdESSigner_get_Included, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_Included, arginfo_TElXAdESSigner_set_Included, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_TSPClient, arginfo_TElXAdESSigner_get_TSPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_TSPClient, arginfo_TElXAdESSigner_set_TSPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_IgnoreTimestampFailure, arginfo_TElXAdESSigner_get_IgnoreTimestampFailure, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_IgnoreTimestampFailure, arginfo_TElXAdESSigner_set_IgnoreTimestampFailure, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_XAdESForm, arginfo_TElXAdESSigner_get_XAdESForm, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_XAdESForm, arginfo_TElXAdESSigner_set_XAdESForm, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, get_XAdESVersion, arginfo_TElXAdESSigner_get_XAdESVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, set_XAdESVersion, arginfo_TElXAdESSigner_set_XAdESVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESSigner, __construct, arginfo_TElXAdESSigner___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXAdESSigner(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXAdESSigner_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXAdESSigner", TElXAdESSigner_methods);
	if (NULL == TElXAdESProcessor_ce_ptr)
		Register_TElXAdESProcessor(TSRMLS_C);
	TElXAdESSigner_ce_ptr = zend_register_internal_class_ex(&ce, TElXAdESProcessor_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXAdESVerifier_ce_ptr = NULL;

SB_PHP_METHOD(TElXAdESVerifier, Load)
{
	zval *oVerifier;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oVerifier, TElXMLProcessor_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESVerifier_Load(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oVerifier TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLProcessor)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, AddCounterSignature)
{
	zval *oFormatter;
	zval *oSigner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oSigner, TElXMLProcessor_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESVerifier_AddCounterSignature(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigner TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oSigner, TElXMLProcessor_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESVerifier_AddCounterSignature_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigner TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLProcessor, TElXMLCustomFormatter) or (TElXMLProcessor)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, AddSignatureTimestamp)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddSignatureTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddSignatureTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient, TElXMLCustomFormatter) or (TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, AddRefsOnlyTimestamp)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddRefsOnlyTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddRefsOnlyTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient, TElXMLCustomFormatter) or (TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, AddSigAndRefsTimestamp)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddSigAndRefsTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddSigAndRefsTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient, TElXMLCustomFormatter) or (TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, AddArchiveTimestamp)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddArchiveTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddArchiveTimestamp_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient, TElXMLCustomFormatter) or (TElCustomTSPClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, AddArchiveTimestampV141)
{
	zval *oATSPClient;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oATSPClient, TElCustomTSPClient_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddArchiveTimestampV141(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oATSPClient, TElCustomTSPClient_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddArchiveTimestampV141_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oATSPClient TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomTSPClient) or (TElCustomTSPClient, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, AddTimestampValidationData)
{
	char *sURI;
	int sURI_len;
	zval *oCerts;
	zval *oCRLs;
	zval *oFormatter;
	zval *oOCSPResponses;
	zval *oTSPInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddTimestampValidationData(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddTimestampValidationData_1(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!sO!", &oTSPInfo, TElClientTSPInfo_ce_ptr, &sURI, &sURI_len, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_AddTimestampValidationData_2(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oTSPInfo TSRMLS_CC), sURI, (int32_t)sURI_len, SBGetObjectHandle(oFormatter TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!O!", &oCerts, TElCustomCertStorage_ce_ptr, &oCRLs, TElCustomCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESVerifier_AddTimestampValidationData_3(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!O!sO!", &oCerts, TElCustomCertStorage_ce_ptr, &oCRLs, TElCustomCRLStorage_ce_ptr, &oOCSPResponses, TList_ce_ptr, &sURI, &sURI_len, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESVerifier_AddTimestampValidationData_4(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC), SBGetObjectHandle(oCRLs TSRMLS_CC), SBGetObjectHandle(oOCSPResponses TSRMLS_CC), sURI, (int32_t)sURI_len, SBGetObjectHandle(oFormatter TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLCustomFormatter) or () or (TElClientTSPInfo, string, TElXMLCustomFormatter) or (TElCustomCertStorage, TElCustomCRLStorage, TList, TElXMLCustomFormatter) or (TElCustomCertStorage, TElCustomCRLStorage, TList, string, TElXMLCustomFormatter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, CheckTimestamp)
{
	zval *oInfo;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oInfo, TElClientTSPInfo_ce_ptr) == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_CheckTimestamp(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oInfo TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElClientTSPInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, ExtractAllCertificates)
{
	zval *oCerts;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCerts, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESVerifier_ExtractAllCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCerts TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, UpgradeToXAdESv141)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXAdESVerifier_UpgradeToXAdESv141(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, Validate)
{
	TSBXAdESValidityReasonsRaw fReasonsRaw;
	zval *oSigningCertificate;
	zval *zfReasons;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zfReasons) == SUCCESS) && PZVAL_IS_REF(zfReasons) && (IS_LONG == Z_TYPE_P(zfReasons)))
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		fReasonsRaw = (TSBXAdESValidityReasonsRaw)Z_LVAL_P(zfReasons);
		SBCheckError(TElXAdESVerifier_Validate(SBGetObjectHandle(getThis() TSRMLS_CC), &fReasonsRaw, &fOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zfReasons, (long)fReasonsRaw);
		RETURN_LONG((long)fOutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!z", &oSigningCertificate, TElX509Certificate_ce_ptr, &zfReasons) == SUCCESS) && PZVAL_IS_REF(zfReasons) && (IS_LONG == Z_TYPE_P(zfReasons)))
	{
		TSBXAdESValidityRaw fOutResultRaw = 0;
		fReasonsRaw = (TSBXAdESValidityReasonsRaw)Z_LVAL_P(zfReasons);
		SBCheckError(TElXAdESVerifier_Validate_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oSigningCertificate TSRMLS_CC), &fReasonsRaw, &fOutResultRaw) TSRMLS_CC);
		ZVAL_LONG(zfReasons, (long)fReasonsRaw);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(&integer) or (TElX509Certificate, &integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_IsEnabled)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_IsEnabled(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_Included)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElXAdESIncludedPropertiesRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_Included(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_CertIDs)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_CertIDs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLCertID_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_CertIDCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_CertIDCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_PolicyId)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_PolicyId(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignaturePolicyId_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_ProductionPlace)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_ProductionPlace(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignatureProductionPlace_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_SignerRole)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_SignerRole(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignerRole_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_SigningCertificates)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_SigningCertificates(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_SigningTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_SigningTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_CertifiedSigningTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_CertifiedSigningTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_LastArchivalTime)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_LastArchivalTime(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_Timestamp)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_Timestamp(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_IndividualDataObjectsTimestampCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_IndividualDataObjectsTimestampCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_IndividualDataObjectsTimestamps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_IndividualDataObjectsTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_AllDataObjectsTimestampCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_AllDataObjectsTimestampCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_AllDataObjectsTimestamps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_AllDataObjectsTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_SignatureTimestampCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_SignatureTimestampCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_SignatureTimestamps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_SignatureTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_RefsOnlyTimestampCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_RefsOnlyTimestampCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_RefsOnlyTimestamps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_RefsOnlyTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_SigAndRefsTimestampCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_SigAndRefsTimestampCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_SigAndRefsTimestamps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_SigAndRefsTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_ArchiveTimestampCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_ArchiveTimestampCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_ArchiveTimestamps)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_ArchiveTimestamps(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElClientTSPInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_TimeStampValidationDataList)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_TimeStampValidationDataList(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLTimeStampValidationDataList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_QualifyingProperties)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_QualifyingProperties(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLQualifyingProperties_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_QualifyingPropertiesReferences)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_QualifyingPropertiesReferences(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLQualifyingPropertiesReferenceList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_XAdESForm)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESFormRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_XAdESForm(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_XAdESVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESVersionRaw fOutResultRaw = 0;
		SBCheckError(TElXAdESVerifier_get_XAdESVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_CertStorage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElCustomCertStorage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, set_CertStorage)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElCustomCertStorage_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXAdESVerifier_set_CertStorage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElCustomCertStorage)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_OnRetrieveCertificate)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESRetrieveCertificateEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_OnRetrieveCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, set_OnRetrieveCertificate)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXAdESVerifier_set_OnRetrieveCertificate(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXAdESRetrieveCertificateEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXAdESRetrieveCertificateEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_OnRetrieveCRL)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESRetrieveCRLEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_OnRetrieveCRL(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, set_OnRetrieveCRL)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXAdESVerifier_set_OnRetrieveCRL(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXAdESRetrieveCRLEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXAdESRetrieveCRLEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, get_OnRetrieveOCSPResponse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXAdESRetrieveOCSPResponseEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXAdESVerifier_get_OnRetrieveOCSPResponse(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, set_OnRetrieveOCSPResponse)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXAdESVerifier_set_OnRetrieveOCSPResponse(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXAdESRetrieveOCSPResponseEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXAdESRetrieveOCSPResponseEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXAdESVerifier, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXAdESVerifier_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_Load, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Verifier, TElXMLProcessor, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_AddCounterSignature, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Signer, TElXMLProcessor, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_AddSignatureTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_AddRefsOnlyTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_AddSigAndRefsTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_AddArchiveTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_AddArchiveTimestampV141, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, ATSPClient, TElCustomTSPClient, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_AddTimestampValidationData, 0, 0, 0)
	ZEND_ARG_TYPE_INFO(0, Formatter_or_TSPInfo_or_Certs, 0, 1)
	ZEND_ARG_TYPE_INFO(0, URI_or_CRLs, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Formatter_or_OCSPResponses, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Formatter_or_URI, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_CheckTimestamp, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Info, TElClientTSPInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_ExtractAllCertificates, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Certs, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_UpgradeToXAdESv141, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_Validate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(1, Reasons_or_SigningCertificate, 0, 1)
	ZEND_ARG_INFO(1, Reasons)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_IsEnabled, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_Included, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_CertIDs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_CertIDCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_PolicyId, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_ProductionPlace, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_SignerRole, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_SigningCertificates, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_SigningTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_CertifiedSigningTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_LastArchivalTime, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_Timestamp, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_IndividualDataObjectsTimestampCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_IndividualDataObjectsTimestamps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_AllDataObjectsTimestampCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_AllDataObjectsTimestamps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_SignatureTimestampCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_SignatureTimestamps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_RefsOnlyTimestampCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_RefsOnlyTimestamps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_SigAndRefsTimestampCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_SigAndRefsTimestamps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_ArchiveTimestampCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_ArchiveTimestamps, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_TimeStampValidationDataList, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_QualifyingProperties, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_QualifyingPropertiesReferences, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_XAdESForm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_XAdESVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_CertStorage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_set_CertStorage, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElCustomCertStorage, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_OnRetrieveCertificate, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_set_OnRetrieveCertificate, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_OnRetrieveCRL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_set_OnRetrieveCRL, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_get_OnRetrieveOCSPResponse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier_set_OnRetrieveOCSPResponse, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXAdESVerifier___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXAdESVerifier_methods[] = {
	PHP_ME(TElXAdESVerifier, Load, arginfo_TElXAdESVerifier_Load, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, AddCounterSignature, arginfo_TElXAdESVerifier_AddCounterSignature, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, AddSignatureTimestamp, arginfo_TElXAdESVerifier_AddSignatureTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, AddRefsOnlyTimestamp, arginfo_TElXAdESVerifier_AddRefsOnlyTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, AddSigAndRefsTimestamp, arginfo_TElXAdESVerifier_AddSigAndRefsTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, AddArchiveTimestamp, arginfo_TElXAdESVerifier_AddArchiveTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, AddArchiveTimestampV141, arginfo_TElXAdESVerifier_AddArchiveTimestampV141, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, AddTimestampValidationData, arginfo_TElXAdESVerifier_AddTimestampValidationData, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, CheckTimestamp, arginfo_TElXAdESVerifier_CheckTimestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, ExtractAllCertificates, arginfo_TElXAdESVerifier_ExtractAllCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, UpgradeToXAdESv141, arginfo_TElXAdESVerifier_UpgradeToXAdESv141, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, Validate, arginfo_TElXAdESVerifier_Validate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_IsEnabled, arginfo_TElXAdESVerifier_get_IsEnabled, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_Included, arginfo_TElXAdESVerifier_get_Included, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_CertIDs, arginfo_TElXAdESVerifier_get_CertIDs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_CertIDCount, arginfo_TElXAdESVerifier_get_CertIDCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_PolicyId, arginfo_TElXAdESVerifier_get_PolicyId, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_ProductionPlace, arginfo_TElXAdESVerifier_get_ProductionPlace, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_SignerRole, arginfo_TElXAdESVerifier_get_SignerRole, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_SigningCertificates, arginfo_TElXAdESVerifier_get_SigningCertificates, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_SigningTime, arginfo_TElXAdESVerifier_get_SigningTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_CertifiedSigningTime, arginfo_TElXAdESVerifier_get_CertifiedSigningTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_LastArchivalTime, arginfo_TElXAdESVerifier_get_LastArchivalTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_Timestamp, arginfo_TElXAdESVerifier_get_Timestamp, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_IndividualDataObjectsTimestampCount, arginfo_TElXAdESVerifier_get_IndividualDataObjectsTimestampCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_IndividualDataObjectsTimestamps, arginfo_TElXAdESVerifier_get_IndividualDataObjectsTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_AllDataObjectsTimestampCount, arginfo_TElXAdESVerifier_get_AllDataObjectsTimestampCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_AllDataObjectsTimestamps, arginfo_TElXAdESVerifier_get_AllDataObjectsTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_SignatureTimestampCount, arginfo_TElXAdESVerifier_get_SignatureTimestampCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_SignatureTimestamps, arginfo_TElXAdESVerifier_get_SignatureTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_RefsOnlyTimestampCount, arginfo_TElXAdESVerifier_get_RefsOnlyTimestampCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_RefsOnlyTimestamps, arginfo_TElXAdESVerifier_get_RefsOnlyTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_SigAndRefsTimestampCount, arginfo_TElXAdESVerifier_get_SigAndRefsTimestampCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_SigAndRefsTimestamps, arginfo_TElXAdESVerifier_get_SigAndRefsTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_ArchiveTimestampCount, arginfo_TElXAdESVerifier_get_ArchiveTimestampCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_ArchiveTimestamps, arginfo_TElXAdESVerifier_get_ArchiveTimestamps, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_TimeStampValidationDataList, arginfo_TElXAdESVerifier_get_TimeStampValidationDataList, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_QualifyingProperties, arginfo_TElXAdESVerifier_get_QualifyingProperties, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_QualifyingPropertiesReferences, arginfo_TElXAdESVerifier_get_QualifyingPropertiesReferences, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_XAdESForm, arginfo_TElXAdESVerifier_get_XAdESForm, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_XAdESVersion, arginfo_TElXAdESVerifier_get_XAdESVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_CertStorage, arginfo_TElXAdESVerifier_get_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, set_CertStorage, arginfo_TElXAdESVerifier_set_CertStorage, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_OnRetrieveCertificate, arginfo_TElXAdESVerifier_get_OnRetrieveCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, set_OnRetrieveCertificate, arginfo_TElXAdESVerifier_set_OnRetrieveCertificate, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_OnRetrieveCRL, arginfo_TElXAdESVerifier_get_OnRetrieveCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, set_OnRetrieveCRL, arginfo_TElXAdESVerifier_set_OnRetrieveCRL, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, get_OnRetrieveOCSPResponse, arginfo_TElXAdESVerifier_get_OnRetrieveOCSPResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, set_OnRetrieveOCSPResponse, arginfo_TElXAdESVerifier_set_OnRetrieveOCSPResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElXAdESVerifier, __construct, arginfo_TElXAdESVerifier___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXAdESVerifier(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXAdESVerifier_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXAdESVerifier", TElXAdESVerifier_methods);
	if (NULL == TElXAdESProcessor_ce_ptr)
		Register_TElXAdESProcessor(TSRMLS_C);
	TElXAdESVerifier_ce_ptr = zend_register_internal_class_ex(&ce, TElXAdESProcessor_ce_ptr, NULL TSRMLS_CC);
}

void Register_SBXMLAdESIntf_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TElXAdESIncludedProperty", NULL);
	TElXAdESIncludedProperty_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TElXAdESIncludedProperty_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXAdESIncludedProperty_ce_ptr, "xipSignerRole", 0)
	SB_DECLARE_CLASS_LONG_CONST(TElXAdESIncludedProperty_ce_ptr, "xipProductionPlace", 1)
	
	INIT_CLASS_ENTRY(ce, "TElXAdESIncludedProperties", NULL);
	TElXAdESIncludedProperties_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TElXAdESIncludedProperties_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TElXAdESIncludedProperties_ce_ptr, "xipSignerRole", 1)
	SB_DECLARE_CLASS_LONG_CONST(TElXAdESIncludedProperties_ce_ptr, "xipProductionPlace", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBXAdESOption", NULL);
	TSBXAdESOption_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXAdESOption_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESOption_ce_ptr, "xoUseHexSerialNumber", 0)
	
	INIT_CLASS_ENTRY(ce, "TSBXAdESOptions", NULL);
	TSBXAdESOptions_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBXAdESOptions_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESOptions_ce_ptr, "xoUseHexSerialNumber", 1)
	
	INIT_CLASS_ENTRY(ce, "TSBXAdESValidity", NULL);
	TSBXAdESValidity_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXAdESValidity_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidity_ce_ptr, "xsvInvalid", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidity_ce_ptr, "xsvIncomplete", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidity_ce_ptr, "xsvValid", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBXAdESValidityReason", NULL);
	TSBXAdESValidityReason_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXAdESValidityReason_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrInternalError", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrNotSigned", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrNoSigningCertificate", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrSigningCertificateNotSigned", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrSigningCertificateIncomplete", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrSigningCertificateInvalid", 5)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrIndividualDataObjectsTimestampInvalid", 6)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrIndividualDataObjectsTimestampIncomplete", 7)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrAllDataObjectsTimestampInvalid", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrAllDataObjectsTimestampIncomplete", 9)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrSignatureTimestampInvalid", 10)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrSignatureTimestampIncomplete", 11)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrRefsOnlyTimestampInvalid", 12)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrRefsOnlyTimestampIncomplete", 13)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrSigAndRefsTimestampInvalid", 14)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrSigAndRefsTimestampIncomplete", 15)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrArchiveTimestampInvalid", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrArchiveTimestampIncomplete", 17)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReason_ce_ptr, "xvrInconsistentSigningCertificate", 18)
	
	INIT_CLASS_ENTRY(ce, "TSBXAdESValidityReasons", NULL);
	TSBXAdESValidityReasons_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseFlags_ce_ptr, NULL TSRMLS_CC);
	TSBXAdESValidityReasons_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrInternalError", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrNotSigned", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrNoSigningCertificate", 4)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrSigningCertificateNotSigned", 8)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrSigningCertificateIncomplete", 16)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrSigningCertificateInvalid", 32)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrIndividualDataObjectsTimestampInvalid", 64)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrIndividualDataObjectsTimestampIncomplete", 128)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrAllDataObjectsTimestampInvalid", 256)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrAllDataObjectsTimestampIncomplete", 512)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrSignatureTimestampInvalid", 1024)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrSignatureTimestampIncomplete", 2048)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrRefsOnlyTimestampInvalid", 4096)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrRefsOnlyTimestampIncomplete", 8192)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrSigAndRefsTimestampInvalid", 16384)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrSigAndRefsTimestampIncomplete", 32768)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrArchiveTimestampInvalid", 65536)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrArchiveTimestampIncomplete", 131072)
	SB_DECLARE_CLASS_LONG_CONST(TSBXAdESValidityReasons_ce_ptr, "xvrInconsistentSigningCertificate", 262144)
}

void Register_SBXMLAdESIntf_Aliases(TSRMLS_D)
{
	if (NULL == TElXAdESProcessor_ce_ptr)
		Register_TElXAdESProcessor(TSRMLS_C);
	zend_register_class_alias("ElXAdESProcessor", TElXAdESProcessor_ce_ptr);
	if (NULL == TElXAdESSigner_ce_ptr)
		Register_TElXAdESSigner(TSRMLS_C);
	zend_register_class_alias("ElXAdESSigner", TElXAdESSigner_ce_ptr);
	if (NULL == TElXAdESVerifier_ce_ptr)
		Register_TElXAdESVerifier(TSRMLS_C);
	zend_register_class_alias("ElXAdESVerifier", TElXAdESVerifier_ce_ptr);
	if (NULL == TElXAdESIncludedProperty_ce_ptr)
		Register_SBXMLAdESIntf_Enum_Flags(TSRMLS_C);
	zend_register_class_alias("ElXAdESIncludedProperty", TElXAdESIncludedProperty_ce_ptr);
	if (NULL == TElXAdESIncludedProperties_ce_ptr)
		Register_SBXMLAdESIntf_Enum_Flags(TSRMLS_C);
	zend_register_class_alias("ElXAdESIncludedProperties", TElXAdESIncludedProperties_ce_ptr);
}

