#include "sbxmlsamlmetadata.h"

void SB_CALLBACK TSBSAMLChooseMetadataDescriptorEventRaw(void * _ObjectData, TObjectHandle Sender, TElSAMLEntityDescriptorElementHandle Descriptor, int8_t * Stop)
{
	zval *retval_ptr;
	zval **params[3];
	zval * zSender;
	zval * zDescriptor;
	zval * zStop;
	TSRMLS_FETCH();
	MAKE_STD_ZVAL(zSender);
	SBInitObject(zSender, TObject_ce_ptr, Sender TSRMLS_CC);
	MAKE_STD_ZVAL(zDescriptor);
	SBInitObject(zDescriptor, TElSAMLEntityDescriptorElement_ce_ptr, Descriptor TSRMLS_CC);
	MAKE_STD_ZVAL(zStop);
	ZVAL_BOOL(zStop, (zend_bool)*Stop);

	params[0] = &zSender;
	params[1] = &zDescriptor;
	params[2] = &zStop;
	SBCallEvent((zval *)_ObjectData, &retval_ptr, 3, params TSRMLS_CC);

	zval_ptr_dtor(&zSender);
	zval_ptr_dtor(&zDescriptor);
	*Stop = (int8_t)Z_BVAL_P(zStop);
	zval_ptr_dtor(&zStop);
	if (retval_ptr) zval_ptr_dtor(&retval_ptr);
}

zend_class_entry *TSBSAMLMetaRootElementType_ce_ptr = NULL;

zend_class_entry *TSBSAMLKeyUse_ce_ptr = NULL;

zend_class_entry *TSBSAMLContactType_ce_ptr = NULL;

zend_class_entry *TElSAMLMetadataRootElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLMetadataRootElement, DetectType_Inst)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TSBSAMLMetaRootElementTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLMetadataRootElement_DetectType_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMetadataRootElement, DetectType)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TSBSAMLMetaRootElementTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLMetadataRootElement_DetectType(SBGetObjectHandle(oElement TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMetadataRootElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLMetadataRootElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMetadataRootElement_DetectType_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMetadataRootElement_DetectType, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMetadataRootElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLMetadataRootElement_methods[] = {
	PHP_ME(TElSAMLMetadataRootElement, DetectType_Inst, arginfo_TElSAMLMetadataRootElement_DetectType_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMetadataRootElement, DetectType, arginfo_TElSAMLMetadataRootElement_DetectType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElSAMLMetadataRootElement, __construct, arginfo_TElSAMLMetadataRootElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLMetadataRootElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLMetadataRootElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLMetadataRootElement", TElSAMLMetadataRootElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLMetadataRootElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLLocalizedNameType_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLLocalizedNameType, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLLocalizedNameType_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLLocalizedNameType, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLLocalizedNameType_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLLocalizedNameType, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLLocalizedNameType_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLLocalizedNameType_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLLocalizedNameType, get_Lang)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLLocalizedNameType_get_Lang(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-760945008, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLLocalizedNameType, set_Lang)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLLocalizedNameType_set_Lang(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLLocalizedNameType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLLocalizedNameType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLLocalizedNameType_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLLocalizedNameType_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLLocalizedNameType_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLLocalizedNameType_get_Lang, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLLocalizedNameType_set_Lang, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLLocalizedNameType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLLocalizedNameType_methods[] = {
	PHP_ME(TElSAMLLocalizedNameType, Clear, arginfo_TElSAMLLocalizedNameType_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLLocalizedNameType, LoadFromXML, arginfo_TElSAMLLocalizedNameType_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLLocalizedNameType, SaveToXML, arginfo_TElSAMLLocalizedNameType_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLLocalizedNameType, get_Lang, arginfo_TElSAMLLocalizedNameType_get_Lang, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLLocalizedNameType, set_Lang, arginfo_TElSAMLLocalizedNameType_set_Lang, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLLocalizedNameType, __construct, arginfo_TElSAMLLocalizedNameType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLLocalizedNameType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLLocalizedNameType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLLocalizedNameType", TElSAMLLocalizedNameType_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLLocalizedNameType_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLLocalizedURIType_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLLocalizedURIType, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLLocalizedURIType_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLLocalizedURIType, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLLocalizedURIType_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLLocalizedURIType, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLLocalizedURIType_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLLocalizedURIType_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLLocalizedURIType, get_Lang)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLLocalizedURIType_get_Lang(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-178598613, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLLocalizedURIType, set_Lang)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLLocalizedURIType_set_Lang(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLLocalizedURIType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLLocalizedURIType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLLocalizedURIType_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLLocalizedURIType_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLLocalizedURIType_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLLocalizedURIType_get_Lang, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLLocalizedURIType_set_Lang, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLLocalizedURIType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLLocalizedURIType_methods[] = {
	PHP_ME(TElSAMLLocalizedURIType, Clear, arginfo_TElSAMLLocalizedURIType_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLLocalizedURIType, LoadFromXML, arginfo_TElSAMLLocalizedURIType_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLLocalizedURIType, SaveToXML, arginfo_TElSAMLLocalizedURIType_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLLocalizedURIType, get_Lang, arginfo_TElSAMLLocalizedURIType_get_Lang, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLLocalizedURIType, set_Lang, arginfo_TElSAMLLocalizedURIType_set_Lang, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLLocalizedURIType, __construct, arginfo_TElSAMLLocalizedURIType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLLocalizedURIType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLLocalizedURIType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLLocalizedURIType", TElSAMLLocalizedURIType_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLLocalizedURIType_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLEndpointType_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLEndpointType, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEndpointType_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpointType, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEndpointType_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpointType, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEndpointType_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEndpointType_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpointType, get_Binding)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEndpointType_get_Binding(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(12739884, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpointType, set_Binding)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEndpointType_set_Binding(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpointType, get_Location)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEndpointType_get_Location(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-183285072, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpointType, set_Location)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEndpointType_set_Location(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpointType, get_ResponseLocation)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEndpointType_get_ResponseLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1272040794, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpointType, set_ResponseLocation)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEndpointType_set_ResponseLocation(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpointType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEndpointType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpointType_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpointType_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpointType_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpointType_get_Binding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpointType_set_Binding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpointType_get_Location, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpointType_set_Location, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpointType_get_ResponseLocation, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpointType_set_ResponseLocation, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpointType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLEndpointType_methods[] = {
	PHP_ME(TElSAMLEndpointType, Clear, arginfo_TElSAMLEndpointType_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpointType, LoadFromXML, arginfo_TElSAMLEndpointType_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpointType, SaveToXML, arginfo_TElSAMLEndpointType_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpointType, get_Binding, arginfo_TElSAMLEndpointType_get_Binding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpointType, set_Binding, arginfo_TElSAMLEndpointType_set_Binding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpointType, get_Location, arginfo_TElSAMLEndpointType_get_Location, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpointType, set_Location, arginfo_TElSAMLEndpointType_set_Location, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpointType, get_ResponseLocation, arginfo_TElSAMLEndpointType_get_ResponseLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpointType, set_ResponseLocation, arginfo_TElSAMLEndpointType_set_ResponseLocation, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpointType, __construct, arginfo_TElSAMLEndpointType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLEndpointType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLEndpointType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLEndpointType", TElSAMLEndpointType_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLEndpointType_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLIndexedEndpointType_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLIndexedEndpointType, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLIndexedEndpointType_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIndexedEndpointType, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLIndexedEndpointType_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIndexedEndpointType, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLIndexedEndpointType_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLIndexedEndpointType_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIndexedEndpointType, get__Index)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLIndexedEndpointType_get__Index(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIndexedEndpointType, set__Index)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSAMLIndexedEndpointType_set__Index(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIndexedEndpointType, get_IsDefault)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLIndexedEndpointType_get_IsDefault(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIndexedEndpointType, set_IsDefault)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLIndexedEndpointType_set_IsDefault(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIndexedEndpointType, get_UseDefault)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLIndexedEndpointType_get_UseDefault(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIndexedEndpointType, set_UseDefault)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLIndexedEndpointType_set_UseDefault(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIndexedEndpointType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLIndexedEndpointType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIndexedEndpointType_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIndexedEndpointType_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIndexedEndpointType_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIndexedEndpointType_get__Index, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIndexedEndpointType_set__Index, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIndexedEndpointType_get_IsDefault, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIndexedEndpointType_set_IsDefault, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIndexedEndpointType_get_UseDefault, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIndexedEndpointType_set_UseDefault, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIndexedEndpointType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLIndexedEndpointType_methods[] = {
	PHP_ME(TElSAMLIndexedEndpointType, Clear, arginfo_TElSAMLIndexedEndpointType_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIndexedEndpointType, LoadFromXML, arginfo_TElSAMLIndexedEndpointType_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIndexedEndpointType, SaveToXML, arginfo_TElSAMLIndexedEndpointType_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIndexedEndpointType, get__Index, arginfo_TElSAMLIndexedEndpointType_get__Index, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIndexedEndpointType, set__Index, arginfo_TElSAMLIndexedEndpointType_set__Index, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIndexedEndpointType, get_IsDefault, arginfo_TElSAMLIndexedEndpointType_get_IsDefault, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIndexedEndpointType, set_IsDefault, arginfo_TElSAMLIndexedEndpointType_set_IsDefault, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIndexedEndpointType, get_UseDefault, arginfo_TElSAMLIndexedEndpointType_get_UseDefault, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIndexedEndpointType, set_UseDefault, arginfo_TElSAMLIndexedEndpointType_set_UseDefault, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIndexedEndpointType, __construct, arginfo_TElSAMLIndexedEndpointType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLIndexedEndpointType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLIndexedEndpointType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLIndexedEndpointType", TElSAMLIndexedEndpointType_methods);
	if (NULL == TElSAMLEndpointType_ce_ptr)
		Register_TElSAMLEndpointType(TSRMLS_C);
	TElSAMLIndexedEndpointType_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLEndpointType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLEntityDescriptorElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEntityDescriptorElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEntityDescriptorElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntityDescriptorElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntityDescriptorElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, get_Signed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLEntityDescriptorElement_get_Signed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, set_Signed)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLEntityDescriptorElement_set_Signed(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEntityDescriptorElement_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1027557691, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEntityDescriptorElement_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, get_ValidUntil)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLEntityDescriptorElement_get_ValidUntil(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, set_ValidUntil)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSAMLEntityDescriptorElement_set_ValidUntil(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, get_CacheDuration)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEntityDescriptorElement_get_CacheDuration(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(999304954, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, set_CacheDuration)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEntityDescriptorElement_set_CacheDuration(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, get_Signature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntityDescriptorElement_get_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntityDescriptorElement_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, get_EntityID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEntityDescriptorElement_get_EntityID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1747021765, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, set_EntityID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEntityDescriptorElement_set_EntityID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, get_AffiliationDescriptor)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntityDescriptorElement_get_AffiliationDescriptor(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLAffiliationDescriptorElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, set_AffiliationDescriptor)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLAffiliationDescriptorElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEntityDescriptorElement_set_AffiliationDescriptor(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLAffiliationDescriptorElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, get_Descriptors)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntityDescriptorElement_get_Descriptors(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, get_Organization)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntityDescriptorElement_get_Organization(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLOrganizationElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, set_Organization)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLOrganizationElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEntityDescriptorElement_set_Organization(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLOrganizationElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, get_ContactPersons)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntityDescriptorElement_get_ContactPersons(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, get_AdditionalMetadataLocations)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntityDescriptorElement_get_AdditionalMetadataLocations(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntityDescriptorElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntityDescriptorElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_get_Signed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_set_Signed, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_get_ValidUntil, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_set_ValidUntil, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_get_CacheDuration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_set_CacheDuration, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_get_Signature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_get_EntityID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_set_EntityID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_get_AffiliationDescriptor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_set_AffiliationDescriptor, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLAffiliationDescriptorElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_get_Descriptors, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_get_Organization, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_set_Organization, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLOrganizationElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_get_ContactPersons, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement_get_AdditionalMetadataLocations, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntityDescriptorElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLEntityDescriptorElement_methods[] = {
	PHP_ME(TElSAMLEntityDescriptorElement, Clear, arginfo_TElSAMLEntityDescriptorElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, LoadFromXML, arginfo_TElSAMLEntityDescriptorElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, SaveToXML, arginfo_TElSAMLEntityDescriptorElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, get_Signed, arginfo_TElSAMLEntityDescriptorElement_get_Signed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, set_Signed, arginfo_TElSAMLEntityDescriptorElement_set_Signed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, get_ID, arginfo_TElSAMLEntityDescriptorElement_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, set_ID, arginfo_TElSAMLEntityDescriptorElement_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, get_ValidUntil, arginfo_TElSAMLEntityDescriptorElement_get_ValidUntil, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, set_ValidUntil, arginfo_TElSAMLEntityDescriptorElement_set_ValidUntil, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, get_CacheDuration, arginfo_TElSAMLEntityDescriptorElement_get_CacheDuration, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, set_CacheDuration, arginfo_TElSAMLEntityDescriptorElement_set_CacheDuration, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, get_Signature, arginfo_TElSAMLEntityDescriptorElement_get_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, get_Extensions, arginfo_TElSAMLEntityDescriptorElement_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, get_EntityID, arginfo_TElSAMLEntityDescriptorElement_get_EntityID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, set_EntityID, arginfo_TElSAMLEntityDescriptorElement_set_EntityID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, get_AffiliationDescriptor, arginfo_TElSAMLEntityDescriptorElement_get_AffiliationDescriptor, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, set_AffiliationDescriptor, arginfo_TElSAMLEntityDescriptorElement_set_AffiliationDescriptor, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, get_Descriptors, arginfo_TElSAMLEntityDescriptorElement_get_Descriptors, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, get_Organization, arginfo_TElSAMLEntityDescriptorElement_get_Organization, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, set_Organization, arginfo_TElSAMLEntityDescriptorElement_set_Organization, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, get_ContactPersons, arginfo_TElSAMLEntityDescriptorElement_get_ContactPersons, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, get_AdditionalMetadataLocations, arginfo_TElSAMLEntityDescriptorElement_get_AdditionalMetadataLocations, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntityDescriptorElement, __construct, arginfo_TElSAMLEntityDescriptorElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLEntityDescriptorElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLEntityDescriptorElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLEntityDescriptorElement", TElSAMLEntityDescriptorElement_methods);
	if (NULL == TElSAMLMetadataRootElement_ce_ptr)
		Register_TElSAMLMetadataRootElement(TSRMLS_C);
	TElSAMLEntityDescriptorElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLMetadataRootElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLEntitiesDescriptorElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEntitiesDescriptorElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEntitiesDescriptorElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntitiesDescriptorElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntitiesDescriptorElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, get_Signed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLEntitiesDescriptorElement_get_Signed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, set_Signed)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLEntitiesDescriptorElement_set_Signed(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEntitiesDescriptorElement_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1633441119, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEntitiesDescriptorElement_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, get_ValidUntil)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLEntitiesDescriptorElement_get_ValidUntil(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, set_ValidUntil)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSAMLEntitiesDescriptorElement_set_ValidUntil(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, get_CacheDuration)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEntitiesDescriptorElement_get_CacheDuration(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-2123828786, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, set_CacheDuration)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEntitiesDescriptorElement_set_CacheDuration(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, get_Signature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntitiesDescriptorElement_get_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntitiesDescriptorElement_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, get_Name)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEntitiesDescriptorElement_get_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1761130803, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, set_Name)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEntitiesDescriptorElement_set_Name(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, get_Entities)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntitiesDescriptorElement_get_Entities(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEntitiesDescriptorElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEntitiesDescriptorElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_get_Signed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_set_Signed, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_get_ValidUntil, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_set_ValidUntil, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_get_CacheDuration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_set_CacheDuration, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_get_Signature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_get_Name, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_set_Name, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement_get_Entities, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEntitiesDescriptorElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLEntitiesDescriptorElement_methods[] = {
	PHP_ME(TElSAMLEntitiesDescriptorElement, Clear, arginfo_TElSAMLEntitiesDescriptorElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, LoadFromXML, arginfo_TElSAMLEntitiesDescriptorElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, SaveToXML, arginfo_TElSAMLEntitiesDescriptorElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, get_Signed, arginfo_TElSAMLEntitiesDescriptorElement_get_Signed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, set_Signed, arginfo_TElSAMLEntitiesDescriptorElement_set_Signed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, get_ID, arginfo_TElSAMLEntitiesDescriptorElement_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, set_ID, arginfo_TElSAMLEntitiesDescriptorElement_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, get_ValidUntil, arginfo_TElSAMLEntitiesDescriptorElement_get_ValidUntil, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, set_ValidUntil, arginfo_TElSAMLEntitiesDescriptorElement_set_ValidUntil, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, get_CacheDuration, arginfo_TElSAMLEntitiesDescriptorElement_get_CacheDuration, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, set_CacheDuration, arginfo_TElSAMLEntitiesDescriptorElement_set_CacheDuration, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, get_Signature, arginfo_TElSAMLEntitiesDescriptorElement_get_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, get_Extensions, arginfo_TElSAMLEntitiesDescriptorElement_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, get_Name, arginfo_TElSAMLEntitiesDescriptorElement_get_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, set_Name, arginfo_TElSAMLEntitiesDescriptorElement_set_Name, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, get_Entities, arginfo_TElSAMLEntitiesDescriptorElement_get_Entities, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEntitiesDescriptorElement, __construct, arginfo_TElSAMLEntitiesDescriptorElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLEntitiesDescriptorElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLEntitiesDescriptorElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLEntitiesDescriptorElement", TElSAMLEntitiesDescriptorElement_methods);
	if (NULL == TElSAMLMetadataRootElement_ce_ptr)
		Register_TElSAMLMetadataRootElement(TSRMLS_C);
	TElSAMLEntitiesDescriptorElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLMetadataRootElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLKeyDescriptorElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLKeyDescriptorElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLKeyDescriptorElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLKeyDescriptorElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLKeyDescriptorElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLKeyDescriptorElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLKeyDescriptorElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLKeyDescriptorElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLKeyDescriptorElement, Init)
{
	zval *oCert;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oCert, TElX509Certificate_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLKeyDescriptorElement_Init(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oCert TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElX509Certificate)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLKeyDescriptorElement, get_Use)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLKeyUseRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLKeyDescriptorElement_get_Use(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLKeyDescriptorElement, set_Use)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLKeyDescriptorElement_set_Use(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLKeyUseRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLKeyDescriptorElement, get_KeyInfo)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLKeyDescriptorElement_get_KeyInfo(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLKeyInfo_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLKeyDescriptorElement, set_KeyInfo)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElXMLKeyInfo_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLKeyDescriptorElement_set_KeyInfo(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLKeyInfo)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLKeyDescriptorElement, get_EncryptionMethods)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLKeyDescriptorElement_get_EncryptionMethods(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLKeyDescriptorElement, set_EncryptionMethods)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLKeyDescriptorElement_set_EncryptionMethods(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLKeyDescriptorElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLKeyDescriptorElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLKeyDescriptorElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLKeyDescriptorElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLKeyDescriptorElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLKeyDescriptorElement_Init, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Cert, TElX509Certificate, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLKeyDescriptorElement_get_Use, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLKeyDescriptorElement_set_Use, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLKeyDescriptorElement_get_KeyInfo, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLKeyDescriptorElement_set_KeyInfo, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElXMLKeyInfo, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLKeyDescriptorElement_get_EncryptionMethods, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLKeyDescriptorElement_set_EncryptionMethods, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLKeyDescriptorElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLKeyDescriptorElement_methods[] = {
	PHP_ME(TElSAMLKeyDescriptorElement, Clear, arginfo_TElSAMLKeyDescriptorElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLKeyDescriptorElement, LoadFromXML, arginfo_TElSAMLKeyDescriptorElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLKeyDescriptorElement, SaveToXML, arginfo_TElSAMLKeyDescriptorElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLKeyDescriptorElement, Init, arginfo_TElSAMLKeyDescriptorElement_Init, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLKeyDescriptorElement, get_Use, arginfo_TElSAMLKeyDescriptorElement_get_Use, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLKeyDescriptorElement, set_Use, arginfo_TElSAMLKeyDescriptorElement_set_Use, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLKeyDescriptorElement, get_KeyInfo, arginfo_TElSAMLKeyDescriptorElement_get_KeyInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLKeyDescriptorElement, set_KeyInfo, arginfo_TElSAMLKeyDescriptorElement_set_KeyInfo, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLKeyDescriptorElement, get_EncryptionMethods, arginfo_TElSAMLKeyDescriptorElement_get_EncryptionMethods, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLKeyDescriptorElement, set_EncryptionMethods, arginfo_TElSAMLKeyDescriptorElement_set_EncryptionMethods, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLKeyDescriptorElement, __construct, arginfo_TElSAMLKeyDescriptorElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLKeyDescriptorElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLKeyDescriptorElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLKeyDescriptorElement", TElSAMLKeyDescriptorElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLKeyDescriptorElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLOrganizationElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLOrganizationElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLOrganizationElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOrganizationElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLOrganizationElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOrganizationElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOrganizationElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOrganizationElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOrganizationElement, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOrganizationElement_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOrganizationElement, get_OrganizationNames)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOrganizationElement_get_OrganizationNames(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOrganizationElement, get_OrganizationDisplayNames)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOrganizationElement_get_OrganizationDisplayNames(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOrganizationElement, get_OrganizationURLs)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOrganizationElement_get_OrganizationURLs(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLOrganizationElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOrganizationElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOrganizationElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOrganizationElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOrganizationElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOrganizationElement_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOrganizationElement_get_OrganizationNames, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOrganizationElement_get_OrganizationDisplayNames, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOrganizationElement_get_OrganizationURLs, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOrganizationElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLOrganizationElement_methods[] = {
	PHP_ME(TElSAMLOrganizationElement, Clear, arginfo_TElSAMLOrganizationElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOrganizationElement, LoadFromXML, arginfo_TElSAMLOrganizationElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOrganizationElement, SaveToXML, arginfo_TElSAMLOrganizationElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOrganizationElement, get_Extensions, arginfo_TElSAMLOrganizationElement_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOrganizationElement, get_OrganizationNames, arginfo_TElSAMLOrganizationElement_get_OrganizationNames, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOrganizationElement, get_OrganizationDisplayNames, arginfo_TElSAMLOrganizationElement_get_OrganizationDisplayNames, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOrganizationElement, get_OrganizationURLs, arginfo_TElSAMLOrganizationElement_get_OrganizationURLs, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLOrganizationElement, __construct, arginfo_TElSAMLOrganizationElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLOrganizationElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLOrganizationElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLOrganizationElement", TElSAMLOrganizationElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLOrganizationElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLContactPersonElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLContactPersonElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLContactPersonElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLContactPersonElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLContactPersonElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLContactPersonElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, get_ContactType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLContactTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLContactPersonElement_get_ContactType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, set_ContactType)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLContactPersonElement_set_ContactType(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLContactTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLContactPersonElement_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, get_Company)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLContactPersonElement_get_Company(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1231702829, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, set_Company)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLContactPersonElement_set_Company(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, get_GivenName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLContactPersonElement_get_GivenName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(377757265, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, set_GivenName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLContactPersonElement_set_GivenName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, get_SurName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLContactPersonElement_get_SurName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1100052051, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, set_SurName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLContactPersonElement_set_SurName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, get_EmailAddresses)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLContactPersonElement_get_EmailAddresses(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, get_TelephoneNumbers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLContactPersonElement_get_TelephoneNumbers(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLContactPersonElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLContactPersonElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_get_ContactType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_set_ContactType, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_get_Company, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_set_Company, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_get_GivenName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_set_GivenName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_get_SurName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_set_SurName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_get_EmailAddresses, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement_get_TelephoneNumbers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLContactPersonElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLContactPersonElement_methods[] = {
	PHP_ME(TElSAMLContactPersonElement, Clear, arginfo_TElSAMLContactPersonElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, LoadFromXML, arginfo_TElSAMLContactPersonElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, SaveToXML, arginfo_TElSAMLContactPersonElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, get_ContactType, arginfo_TElSAMLContactPersonElement_get_ContactType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, set_ContactType, arginfo_TElSAMLContactPersonElement_set_ContactType, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, get_Extensions, arginfo_TElSAMLContactPersonElement_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, get_Company, arginfo_TElSAMLContactPersonElement_get_Company, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, set_Company, arginfo_TElSAMLContactPersonElement_set_Company, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, get_GivenName, arginfo_TElSAMLContactPersonElement_get_GivenName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, set_GivenName, arginfo_TElSAMLContactPersonElement_set_GivenName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, get_SurName, arginfo_TElSAMLContactPersonElement_get_SurName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, set_SurName, arginfo_TElSAMLContactPersonElement_set_SurName, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, get_EmailAddresses, arginfo_TElSAMLContactPersonElement_get_EmailAddresses, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, get_TelephoneNumbers, arginfo_TElSAMLContactPersonElement_get_TelephoneNumbers, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLContactPersonElement, __construct, arginfo_TElSAMLContactPersonElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLContactPersonElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLContactPersonElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLContactPersonElement", TElSAMLContactPersonElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLContactPersonElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLRoleDescriptorElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLRoleDescriptorElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLRoleDescriptorElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRoleDescriptorElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRoleDescriptorElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, get_Signed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLRoleDescriptorElement_get_Signed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, set_Signed)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLRoleDescriptorElement_set_Signed(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLRoleDescriptorElement_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(958938671, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLRoleDescriptorElement_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, get_ValidUntil)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLRoleDescriptorElement_get_ValidUntil(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, set_ValidUntil)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSAMLRoleDescriptorElement_set_ValidUntil(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, get_CacheDuration)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLRoleDescriptorElement_get_CacheDuration(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2109810192, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, set_CacheDuration)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLRoleDescriptorElement_set_CacheDuration(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, get_ProtocolSupportEnumeration)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRoleDescriptorElement_get_ProtocolSupportEnumeration(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, get_ErrorURL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLRoleDescriptorElement_get_ErrorURL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1004902298, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, set_ErrorURL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLRoleDescriptorElement_set_ErrorURL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, get_Signature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRoleDescriptorElement_get_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRoleDescriptorElement_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, get_KeyDescriptors)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRoleDescriptorElement_get_KeyDescriptors(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, get_Organization)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRoleDescriptorElement_get_Organization(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLOrganizationElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, set_Organization)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLOrganizationElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLRoleDescriptorElement_set_Organization(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLOrganizationElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, get_ContactPersons)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRoleDescriptorElement_get_ContactPersons(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRoleDescriptorElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRoleDescriptorElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_get_Signed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_set_Signed, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_get_ValidUntil, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_set_ValidUntil, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_get_CacheDuration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_set_CacheDuration, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_get_ProtocolSupportEnumeration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_get_ErrorURL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_set_ErrorURL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_get_Signature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_get_KeyDescriptors, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_get_Organization, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_set_Organization, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLOrganizationElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement_get_ContactPersons, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRoleDescriptorElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLRoleDescriptorElement_methods[] = {
	PHP_ME(TElSAMLRoleDescriptorElement, Clear, arginfo_TElSAMLRoleDescriptorElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, LoadFromXML, arginfo_TElSAMLRoleDescriptorElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, SaveToXML, arginfo_TElSAMLRoleDescriptorElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, get_Signed, arginfo_TElSAMLRoleDescriptorElement_get_Signed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, set_Signed, arginfo_TElSAMLRoleDescriptorElement_set_Signed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, get_ID, arginfo_TElSAMLRoleDescriptorElement_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, set_ID, arginfo_TElSAMLRoleDescriptorElement_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, get_ValidUntil, arginfo_TElSAMLRoleDescriptorElement_get_ValidUntil, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, set_ValidUntil, arginfo_TElSAMLRoleDescriptorElement_set_ValidUntil, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, get_CacheDuration, arginfo_TElSAMLRoleDescriptorElement_get_CacheDuration, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, set_CacheDuration, arginfo_TElSAMLRoleDescriptorElement_set_CacheDuration, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, get_ProtocolSupportEnumeration, arginfo_TElSAMLRoleDescriptorElement_get_ProtocolSupportEnumeration, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, get_ErrorURL, arginfo_TElSAMLRoleDescriptorElement_get_ErrorURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, set_ErrorURL, arginfo_TElSAMLRoleDescriptorElement_set_ErrorURL, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, get_Signature, arginfo_TElSAMLRoleDescriptorElement_get_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, get_Extensions, arginfo_TElSAMLRoleDescriptorElement_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, get_KeyDescriptors, arginfo_TElSAMLRoleDescriptorElement_get_KeyDescriptors, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, get_Organization, arginfo_TElSAMLRoleDescriptorElement_get_Organization, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, set_Organization, arginfo_TElSAMLRoleDescriptorElement_set_Organization, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, get_ContactPersons, arginfo_TElSAMLRoleDescriptorElement_get_ContactPersons, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRoleDescriptorElement, __construct, arginfo_TElSAMLRoleDescriptorElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLRoleDescriptorElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLRoleDescriptorElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLRoleDescriptorElement", TElSAMLRoleDescriptorElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLRoleDescriptorElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAuthnQueryServiceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAuthnQueryServiceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnQueryServiceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnQueryServiceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAuthnQueryServiceElement_methods[] = {
	PHP_ME(TElSAMLAuthnQueryServiceElement, __construct, arginfo_TElSAMLAuthnQueryServiceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAuthnQueryServiceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAuthnQueryServiceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAuthnQueryServiceElement", TElSAMLAuthnQueryServiceElement_methods);
	if (NULL == TElSAMLEndpointType_ce_ptr)
		Register_TElSAMLEndpointType(TSRMLS_C);
	TElSAMLAuthnQueryServiceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLEndpointType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAssertionIDRequestServiceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAssertionIDRequestServiceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionIDRequestServiceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionIDRequestServiceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAssertionIDRequestServiceElement_methods[] = {
	PHP_ME(TElSAMLAssertionIDRequestServiceElement, __construct, arginfo_TElSAMLAssertionIDRequestServiceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAssertionIDRequestServiceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAssertionIDRequestServiceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAssertionIDRequestServiceElement", TElSAMLAssertionIDRequestServiceElement_methods);
	if (NULL == TElSAMLEndpointType_ce_ptr)
		Register_TElSAMLEndpointType(TSRMLS_C);
	TElSAMLAssertionIDRequestServiceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLEndpointType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAuthnAuthorityDescriptorElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAuthnAuthorityDescriptorElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnAuthorityDescriptorElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnAuthorityDescriptorElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAuthnAuthorityDescriptorElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnAuthorityDescriptorElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnAuthorityDescriptorElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnAuthorityDescriptorElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnAuthorityDescriptorElement, get_AuthnQueryServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnAuthorityDescriptorElement_get_AuthnQueryServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnAuthorityDescriptorElement, get_AssertionIDRequestServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnAuthorityDescriptorElement_get_AssertionIDRequestServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnAuthorityDescriptorElement, get_NameIDFormats)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnAuthorityDescriptorElement_get_NameIDFormats(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAuthnAuthorityDescriptorElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthnAuthorityDescriptorElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnAuthorityDescriptorElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnAuthorityDescriptorElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnAuthorityDescriptorElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnAuthorityDescriptorElement_get_AuthnQueryServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnAuthorityDescriptorElement_get_AssertionIDRequestServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnAuthorityDescriptorElement_get_NameIDFormats, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthnAuthorityDescriptorElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAuthnAuthorityDescriptorElement_methods[] = {
	PHP_ME(TElSAMLAuthnAuthorityDescriptorElement, Clear, arginfo_TElSAMLAuthnAuthorityDescriptorElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnAuthorityDescriptorElement, LoadFromXML, arginfo_TElSAMLAuthnAuthorityDescriptorElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnAuthorityDescriptorElement, SaveToXML, arginfo_TElSAMLAuthnAuthorityDescriptorElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnAuthorityDescriptorElement, get_AuthnQueryServices, arginfo_TElSAMLAuthnAuthorityDescriptorElement_get_AuthnQueryServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnAuthorityDescriptorElement, get_AssertionIDRequestServices, arginfo_TElSAMLAuthnAuthorityDescriptorElement_get_AssertionIDRequestServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnAuthorityDescriptorElement, get_NameIDFormats, arginfo_TElSAMLAuthnAuthorityDescriptorElement_get_NameIDFormats, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAuthnAuthorityDescriptorElement, __construct, arginfo_TElSAMLAuthnAuthorityDescriptorElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAuthnAuthorityDescriptorElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAuthnAuthorityDescriptorElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAuthnAuthorityDescriptorElement", TElSAMLAuthnAuthorityDescriptorElement_methods);
	if (NULL == TElSAMLRoleDescriptorElement_ce_ptr)
		Register_TElSAMLRoleDescriptorElement(TSRMLS_C);
	TElSAMLAuthnAuthorityDescriptorElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLRoleDescriptorElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAttributeServiceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAttributeServiceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeServiceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeServiceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAttributeServiceElement_methods[] = {
	PHP_ME(TElSAMLAttributeServiceElement, __construct, arginfo_TElSAMLAttributeServiceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAttributeServiceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAttributeServiceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAttributeServiceElement", TElSAMLAttributeServiceElement_methods);
	if (NULL == TElSAMLEndpointType_ce_ptr)
		Register_TElSAMLEndpointType(TSRMLS_C);
	TElSAMLAttributeServiceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLEndpointType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAttributeAuthorityDescriptorElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAttributeAuthorityDescriptorElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeAuthorityDescriptorElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeAuthorityDescriptorElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeAuthorityDescriptorElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeAuthorityDescriptorElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeAuthorityDescriptorElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeAuthorityDescriptorElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeAuthorityDescriptorElement, get_AttributeServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeAuthorityDescriptorElement_get_AttributeServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeAuthorityDescriptorElement, get_AssertionIDRequestServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeAuthorityDescriptorElement_get_AssertionIDRequestServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeAuthorityDescriptorElement, get_NameIDFormats)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeAuthorityDescriptorElement_get_NameIDFormats(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeAuthorityDescriptorElement, get_AttributeProfiles)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeAuthorityDescriptorElement_get_AttributeProfiles(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeAuthorityDescriptorElement, get_Attributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeAuthorityDescriptorElement_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeAuthorityDescriptorElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeAuthorityDescriptorElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeAuthorityDescriptorElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeAuthorityDescriptorElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeAuthorityDescriptorElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeAuthorityDescriptorElement_get_AttributeServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeAuthorityDescriptorElement_get_AssertionIDRequestServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeAuthorityDescriptorElement_get_NameIDFormats, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeAuthorityDescriptorElement_get_AttributeProfiles, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeAuthorityDescriptorElement_get_Attributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeAuthorityDescriptorElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAttributeAuthorityDescriptorElement_methods[] = {
	PHP_ME(TElSAMLAttributeAuthorityDescriptorElement, Clear, arginfo_TElSAMLAttributeAuthorityDescriptorElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeAuthorityDescriptorElement, LoadFromXML, arginfo_TElSAMLAttributeAuthorityDescriptorElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeAuthorityDescriptorElement, SaveToXML, arginfo_TElSAMLAttributeAuthorityDescriptorElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeAuthorityDescriptorElement, get_AttributeServices, arginfo_TElSAMLAttributeAuthorityDescriptorElement_get_AttributeServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeAuthorityDescriptorElement, get_AssertionIDRequestServices, arginfo_TElSAMLAttributeAuthorityDescriptorElement_get_AssertionIDRequestServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeAuthorityDescriptorElement, get_NameIDFormats, arginfo_TElSAMLAttributeAuthorityDescriptorElement_get_NameIDFormats, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeAuthorityDescriptorElement, get_AttributeProfiles, arginfo_TElSAMLAttributeAuthorityDescriptorElement_get_AttributeProfiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeAuthorityDescriptorElement, get_Attributes, arginfo_TElSAMLAttributeAuthorityDescriptorElement_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeAuthorityDescriptorElement, __construct, arginfo_TElSAMLAttributeAuthorityDescriptorElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAttributeAuthorityDescriptorElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAttributeAuthorityDescriptorElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAttributeAuthorityDescriptorElement", TElSAMLAttributeAuthorityDescriptorElement_methods);
	if (NULL == TElSAMLRoleDescriptorElement_ce_ptr)
		Register_TElSAMLRoleDescriptorElement(TSRMLS_C);
	TElSAMLAttributeAuthorityDescriptorElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLRoleDescriptorElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAuthzServiceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAuthzServiceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAuthzServiceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAuthzServiceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAuthzServiceElement_methods[] = {
	PHP_ME(TElSAMLAuthzServiceElement, __construct, arginfo_TElSAMLAuthzServiceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAuthzServiceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAuthzServiceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAuthzServiceElement", TElSAMLAuthzServiceElement_methods);
	if (NULL == TElSAMLEndpointType_ce_ptr)
		Register_TElSAMLEndpointType(TSRMLS_C);
	TElSAMLAuthzServiceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLEndpointType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLPDPDescriptorElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLPDPDescriptorElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLPDPDescriptorElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPDPDescriptorElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLPDPDescriptorElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPDPDescriptorElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLPDPDescriptorElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLPDPDescriptorElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPDPDescriptorElement, get_AuthzServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLPDPDescriptorElement_get_AuthzServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPDPDescriptorElement, get_AssertionIDRequestServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLPDPDescriptorElement_get_AssertionIDRequestServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPDPDescriptorElement, get_NameIDFormats)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLPDPDescriptorElement_get_NameIDFormats(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLPDPDescriptorElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLPDPDescriptorElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPDPDescriptorElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPDPDescriptorElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPDPDescriptorElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPDPDescriptorElement_get_AuthzServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPDPDescriptorElement_get_AssertionIDRequestServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPDPDescriptorElement_get_NameIDFormats, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLPDPDescriptorElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLPDPDescriptorElement_methods[] = {
	PHP_ME(TElSAMLPDPDescriptorElement, Clear, arginfo_TElSAMLPDPDescriptorElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPDPDescriptorElement, LoadFromXML, arginfo_TElSAMLPDPDescriptorElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPDPDescriptorElement, SaveToXML, arginfo_TElSAMLPDPDescriptorElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPDPDescriptorElement, get_AuthzServices, arginfo_TElSAMLPDPDescriptorElement_get_AuthzServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPDPDescriptorElement, get_AssertionIDRequestServices, arginfo_TElSAMLPDPDescriptorElement_get_AssertionIDRequestServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPDPDescriptorElement, get_NameIDFormats, arginfo_TElSAMLPDPDescriptorElement_get_NameIDFormats, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLPDPDescriptorElement, __construct, arginfo_TElSAMLPDPDescriptorElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLPDPDescriptorElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLPDPDescriptorElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLPDPDescriptorElement", TElSAMLPDPDescriptorElement_methods);
	if (NULL == TElSAMLRoleDescriptorElement_ce_ptr)
		Register_TElSAMLRoleDescriptorElement(TSRMLS_C);
	TElSAMLPDPDescriptorElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLRoleDescriptorElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAffiliationDescriptorElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAffiliationDescriptorElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAffiliationDescriptorElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAffiliationDescriptorElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAffiliationDescriptorElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, get_Signed)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLAffiliationDescriptorElement_get_Signed(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, set_Signed)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLAffiliationDescriptorElement_set_Signed(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, get_AffiliationOwnerID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAffiliationDescriptorElement_get_AffiliationOwnerID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1708655831, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, set_AffiliationOwnerID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAffiliationDescriptorElement_set_AffiliationOwnerID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, get_ID)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAffiliationDescriptorElement_get_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(959808201, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, set_ID)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAffiliationDescriptorElement_set_ID(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, get_ValidUntil)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElSAMLAffiliationDescriptorElement_get_ValidUntil(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, set_ValidUntil)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElSAMLAffiliationDescriptorElement_set_ValidUntil(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, get_CacheDuration)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAffiliationDescriptorElement_get_CacheDuration(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(2063892837, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, set_CacheDuration)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAffiliationDescriptorElement_set_CacheDuration(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, get_Signature)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAffiliationDescriptorElement_get_Signature(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSignature_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, get_Extensions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAffiliationDescriptorElement_get_Extensions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, get_AffiliateMembers)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAffiliationDescriptorElement_get_AffiliateMembers(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, get_KeyDescriptors)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAffiliationDescriptorElement_get_KeyDescriptors(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAffiliationDescriptorElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAffiliationDescriptorElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_get_Signed, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_set_Signed, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_get_AffiliationOwnerID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_set_AffiliationOwnerID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_get_ID, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_set_ID, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_get_ValidUntil, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_set_ValidUntil, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_get_CacheDuration, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_set_CacheDuration, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_get_Signature, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_get_Extensions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_get_AffiliateMembers, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement_get_KeyDescriptors, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAffiliationDescriptorElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAffiliationDescriptorElement_methods[] = {
	PHP_ME(TElSAMLAffiliationDescriptorElement, Clear, arginfo_TElSAMLAffiliationDescriptorElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, LoadFromXML, arginfo_TElSAMLAffiliationDescriptorElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, SaveToXML, arginfo_TElSAMLAffiliationDescriptorElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, get_Signed, arginfo_TElSAMLAffiliationDescriptorElement_get_Signed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, set_Signed, arginfo_TElSAMLAffiliationDescriptorElement_set_Signed, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, get_AffiliationOwnerID, arginfo_TElSAMLAffiliationDescriptorElement_get_AffiliationOwnerID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, set_AffiliationOwnerID, arginfo_TElSAMLAffiliationDescriptorElement_set_AffiliationOwnerID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, get_ID, arginfo_TElSAMLAffiliationDescriptorElement_get_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, set_ID, arginfo_TElSAMLAffiliationDescriptorElement_set_ID, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, get_ValidUntil, arginfo_TElSAMLAffiliationDescriptorElement_get_ValidUntil, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, set_ValidUntil, arginfo_TElSAMLAffiliationDescriptorElement_set_ValidUntil, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, get_CacheDuration, arginfo_TElSAMLAffiliationDescriptorElement_get_CacheDuration, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, set_CacheDuration, arginfo_TElSAMLAffiliationDescriptorElement_set_CacheDuration, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, get_Signature, arginfo_TElSAMLAffiliationDescriptorElement_get_Signature, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, get_Extensions, arginfo_TElSAMLAffiliationDescriptorElement_get_Extensions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, get_AffiliateMembers, arginfo_TElSAMLAffiliationDescriptorElement_get_AffiliateMembers, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, get_KeyDescriptors, arginfo_TElSAMLAffiliationDescriptorElement_get_KeyDescriptors, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAffiliationDescriptorElement, __construct, arginfo_TElSAMLAffiliationDescriptorElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAffiliationDescriptorElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAffiliationDescriptorElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAffiliationDescriptorElement", TElSAMLAffiliationDescriptorElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLAffiliationDescriptorElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLOrganizationNameElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLOrganizationNameElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOrganizationNameElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOrganizationNameElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLOrganizationNameElement_methods[] = {
	PHP_ME(TElSAMLOrganizationNameElement, __construct, arginfo_TElSAMLOrganizationNameElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLOrganizationNameElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLOrganizationNameElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLOrganizationNameElement", TElSAMLOrganizationNameElement_methods);
	if (NULL == TElSAMLLocalizedNameType_ce_ptr)
		Register_TElSAMLLocalizedNameType(TSRMLS_C);
	TElSAMLOrganizationNameElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLLocalizedNameType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLOrganizationDisplayNameElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLOrganizationDisplayNameElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOrganizationDisplayNameElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOrganizationDisplayNameElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLOrganizationDisplayNameElement_methods[] = {
	PHP_ME(TElSAMLOrganizationDisplayNameElement, __construct, arginfo_TElSAMLOrganizationDisplayNameElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLOrganizationDisplayNameElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLOrganizationDisplayNameElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLOrganizationDisplayNameElement", TElSAMLOrganizationDisplayNameElement_methods);
	if (NULL == TElSAMLLocalizedNameType_ce_ptr)
		Register_TElSAMLLocalizedNameType(TSRMLS_C);
	TElSAMLOrganizationDisplayNameElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLLocalizedNameType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLOrganizationURLElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLOrganizationURLElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLOrganizationURLElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLOrganizationURLElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLOrganizationURLElement_methods[] = {
	PHP_ME(TElSAMLOrganizationURLElement, __construct, arginfo_TElSAMLOrganizationURLElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLOrganizationURLElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLOrganizationURLElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLOrganizationURLElement", TElSAMLOrganizationURLElement_methods);
	if (NULL == TElSAMLLocalizedURIType_ce_ptr)
		Register_TElSAMLLocalizedURIType(TSRMLS_C);
	TElSAMLOrganizationURLElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLLocalizedURIType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAdditionalMetadataLocationElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAdditionalMetadataLocationElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAdditionalMetadataLocationElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdditionalMetadataLocationElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAdditionalMetadataLocationElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdditionalMetadataLocationElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAdditionalMetadataLocationElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAdditionalMetadataLocationElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdditionalMetadataLocationElement, get__Namespace)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAdditionalMetadataLocationElement_get__Namespace(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(253120150, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdditionalMetadataLocationElement, set__Namespace)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLAdditionalMetadataLocationElement_set__Namespace(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdditionalMetadataLocationElement, get_URI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLAdditionalMetadataLocationElement_get_URI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1810730174, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAdditionalMetadataLocationElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAdditionalMetadataLocationElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdditionalMetadataLocationElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdditionalMetadataLocationElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdditionalMetadataLocationElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdditionalMetadataLocationElement_get__Namespace, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdditionalMetadataLocationElement_set__Namespace, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdditionalMetadataLocationElement_get_URI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAdditionalMetadataLocationElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAdditionalMetadataLocationElement_methods[] = {
	PHP_ME(TElSAMLAdditionalMetadataLocationElement, Clear, arginfo_TElSAMLAdditionalMetadataLocationElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdditionalMetadataLocationElement, LoadFromXML, arginfo_TElSAMLAdditionalMetadataLocationElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdditionalMetadataLocationElement, SaveToXML, arginfo_TElSAMLAdditionalMetadataLocationElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdditionalMetadataLocationElement, get__Namespace, arginfo_TElSAMLAdditionalMetadataLocationElement_get__Namespace, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdditionalMetadataLocationElement, set__Namespace, arginfo_TElSAMLAdditionalMetadataLocationElement_set__Namespace, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdditionalMetadataLocationElement, get_URI, arginfo_TElSAMLAdditionalMetadataLocationElement_get_URI, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAdditionalMetadataLocationElement, __construct, arginfo_TElSAMLAdditionalMetadataLocationElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAdditionalMetadataLocationElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAdditionalMetadataLocationElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAdditionalMetadataLocationElement", TElSAMLAdditionalMetadataLocationElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLAdditionalMetadataLocationElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLArtifactResolutionServiceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLArtifactResolutionServiceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLArtifactResolutionServiceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLArtifactResolutionServiceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLArtifactResolutionServiceElement_methods[] = {
	PHP_ME(TElSAMLArtifactResolutionServiceElement, __construct, arginfo_TElSAMLArtifactResolutionServiceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLArtifactResolutionServiceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLArtifactResolutionServiceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLArtifactResolutionServiceElement", TElSAMLArtifactResolutionServiceElement_methods);
	if (NULL == TElSAMLIndexedEndpointType_ce_ptr)
		Register_TElSAMLIndexedEndpointType(TSRMLS_C);
	TElSAMLArtifactResolutionServiceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLIndexedEndpointType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLSingleLogoutServiceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSingleLogoutServiceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSingleLogoutServiceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSingleLogoutServiceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSingleLogoutServiceElement_methods[] = {
	PHP_ME(TElSAMLSingleLogoutServiceElement, __construct, arginfo_TElSAMLSingleLogoutServiceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSingleLogoutServiceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSingleLogoutServiceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSingleLogoutServiceElement", TElSAMLSingleLogoutServiceElement_methods);
	if (NULL == TElSAMLEndpointType_ce_ptr)
		Register_TElSAMLEndpointType(TSRMLS_C);
	TElSAMLSingleLogoutServiceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLEndpointType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLManageNameIDServiceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLManageNameIDServiceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLManageNameIDServiceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLManageNameIDServiceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLManageNameIDServiceElement_methods[] = {
	PHP_ME(TElSAMLManageNameIDServiceElement, __construct, arginfo_TElSAMLManageNameIDServiceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLManageNameIDServiceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLManageNameIDServiceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLManageNameIDServiceElement", TElSAMLManageNameIDServiceElement_methods);
	if (NULL == TElSAMLEndpointType_ce_ptr)
		Register_TElSAMLEndpointType(TSRMLS_C);
	TElSAMLManageNameIDServiceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLEndpointType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLSingleSignOnServiceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSingleSignOnServiceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSingleSignOnServiceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSingleSignOnServiceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSingleSignOnServiceElement_methods[] = {
	PHP_ME(TElSAMLSingleSignOnServiceElement, __construct, arginfo_TElSAMLSingleSignOnServiceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSingleSignOnServiceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSingleSignOnServiceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSingleSignOnServiceElement", TElSAMLSingleSignOnServiceElement_methods);
	if (NULL == TElSAMLEndpointType_ce_ptr)
		Register_TElSAMLEndpointType(TSRMLS_C);
	TElSAMLSingleSignOnServiceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLEndpointType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLNameIDMappingServiceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLNameIDMappingServiceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLNameIDMappingServiceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLNameIDMappingServiceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLNameIDMappingServiceElement_methods[] = {
	PHP_ME(TElSAMLNameIDMappingServiceElement, __construct, arginfo_TElSAMLNameIDMappingServiceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLNameIDMappingServiceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLNameIDMappingServiceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLNameIDMappingServiceElement", TElSAMLNameIDMappingServiceElement_methods);
	if (NULL == TElSAMLEndpointType_ce_ptr)
		Register_TElSAMLEndpointType(TSRMLS_C);
	TElSAMLNameIDMappingServiceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLEndpointType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLSSODescriptorType_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSSODescriptorType, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLSSODescriptorType_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSSODescriptorType, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSSODescriptorType_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSSODescriptorType, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSSODescriptorType_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSSODescriptorType_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSSODescriptorType, get_ArtifactResolutionServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSSODescriptorType_get_ArtifactResolutionServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSSODescriptorType, get_SingleLogoutServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSSODescriptorType_get_SingleLogoutServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSSODescriptorType, get_ManageNameIDService)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSSODescriptorType_get_ManageNameIDService(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSSODescriptorType, get_NameIDFormats)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSSODescriptorType_get_NameIDFormats(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSSODescriptorType, get_AutoAssignIndexes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSSODescriptorType_get_AutoAssignIndexes(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSSODescriptorType, set_AutoAssignIndexes)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSSODescriptorType_set_AutoAssignIndexes(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSSODescriptorType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSSODescriptorType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSSODescriptorType_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSSODescriptorType_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSSODescriptorType_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSSODescriptorType_get_ArtifactResolutionServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSSODescriptorType_get_SingleLogoutServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSSODescriptorType_get_ManageNameIDService, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSSODescriptorType_get_NameIDFormats, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSSODescriptorType_get_AutoAssignIndexes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSSODescriptorType_set_AutoAssignIndexes, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSSODescriptorType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSSODescriptorType_methods[] = {
	PHP_ME(TElSAMLSSODescriptorType, Clear, arginfo_TElSAMLSSODescriptorType_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSSODescriptorType, LoadFromXML, arginfo_TElSAMLSSODescriptorType_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSSODescriptorType, SaveToXML, arginfo_TElSAMLSSODescriptorType_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSSODescriptorType, get_ArtifactResolutionServices, arginfo_TElSAMLSSODescriptorType_get_ArtifactResolutionServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSSODescriptorType, get_SingleLogoutServices, arginfo_TElSAMLSSODescriptorType_get_SingleLogoutServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSSODescriptorType, get_ManageNameIDService, arginfo_TElSAMLSSODescriptorType_get_ManageNameIDService, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSSODescriptorType, get_NameIDFormats, arginfo_TElSAMLSSODescriptorType_get_NameIDFormats, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSSODescriptorType, get_AutoAssignIndexes, arginfo_TElSAMLSSODescriptorType_get_AutoAssignIndexes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSSODescriptorType, set_AutoAssignIndexes, arginfo_TElSAMLSSODescriptorType_set_AutoAssignIndexes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSSODescriptorType, __construct, arginfo_TElSAMLSSODescriptorType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSSODescriptorType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSSODescriptorType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSSODescriptorType", TElSAMLSSODescriptorType_methods);
	if (NULL == TElSAMLRoleDescriptorElement_ce_ptr)
		Register_TElSAMLRoleDescriptorElement(TSRMLS_C);
	TElSAMLSSODescriptorType_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLRoleDescriptorElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLIDPSSODescriptorElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLIDPSSODescriptorElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLIDPSSODescriptorElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLIDPSSODescriptorElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLIDPSSODescriptorElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, get_WantAuthnRequestsSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLIDPSSODescriptorElement_get_WantAuthnRequestsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, set_WantAuthnRequestsSigned)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLIDPSSODescriptorElement_set_WantAuthnRequestsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, get_UseWantAuthnRequestsSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLIDPSSODescriptorElement_get_UseWantAuthnRequestsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, set_UseWantAuthnRequestsSigned)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLIDPSSODescriptorElement_set_UseWantAuthnRequestsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, get_SingleSignOnServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLIDPSSODescriptorElement_get_SingleSignOnServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, get_NameIDMappingServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLIDPSSODescriptorElement_get_NameIDMappingServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, get_AssertionIDRequestServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLIDPSSODescriptorElement_get_AssertionIDRequestServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, get_AttributeProfiles)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLIDPSSODescriptorElement_get_AttributeProfiles(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
#ifdef SB_WINDOWS
		SBInitObject(return_value, TStringList_ce_ptr, hoOutResult TSRMLS_CC);
#else
		SBInitObject(return_value, TElStringList_ce_ptr, hoOutResult TSRMLS_CC);
#endif
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, get_Attributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLIDPSSODescriptorElement_get_Attributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLIDPSSODescriptorElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLIDPSSODescriptorElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement_get_WantAuthnRequestsSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement_set_WantAuthnRequestsSigned, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement_get_UseWantAuthnRequestsSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement_set_UseWantAuthnRequestsSigned, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement_get_SingleSignOnServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement_get_NameIDMappingServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement_get_AssertionIDRequestServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement_get_AttributeProfiles, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement_get_Attributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLIDPSSODescriptorElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLIDPSSODescriptorElement_methods[] = {
	PHP_ME(TElSAMLIDPSSODescriptorElement, Clear, arginfo_TElSAMLIDPSSODescriptorElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIDPSSODescriptorElement, LoadFromXML, arginfo_TElSAMLIDPSSODescriptorElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIDPSSODescriptorElement, SaveToXML, arginfo_TElSAMLIDPSSODescriptorElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIDPSSODescriptorElement, get_WantAuthnRequestsSigned, arginfo_TElSAMLIDPSSODescriptorElement_get_WantAuthnRequestsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIDPSSODescriptorElement, set_WantAuthnRequestsSigned, arginfo_TElSAMLIDPSSODescriptorElement_set_WantAuthnRequestsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIDPSSODescriptorElement, get_UseWantAuthnRequestsSigned, arginfo_TElSAMLIDPSSODescriptorElement_get_UseWantAuthnRequestsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIDPSSODescriptorElement, set_UseWantAuthnRequestsSigned, arginfo_TElSAMLIDPSSODescriptorElement_set_UseWantAuthnRequestsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIDPSSODescriptorElement, get_SingleSignOnServices, arginfo_TElSAMLIDPSSODescriptorElement_get_SingleSignOnServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIDPSSODescriptorElement, get_NameIDMappingServices, arginfo_TElSAMLIDPSSODescriptorElement_get_NameIDMappingServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIDPSSODescriptorElement, get_AssertionIDRequestServices, arginfo_TElSAMLIDPSSODescriptorElement_get_AssertionIDRequestServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIDPSSODescriptorElement, get_AttributeProfiles, arginfo_TElSAMLIDPSSODescriptorElement_get_AttributeProfiles, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIDPSSODescriptorElement, get_Attributes, arginfo_TElSAMLIDPSSODescriptorElement_get_Attributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLIDPSSODescriptorElement, __construct, arginfo_TElSAMLIDPSSODescriptorElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLIDPSSODescriptorElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLIDPSSODescriptorElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLIDPSSODescriptorElement", TElSAMLIDPSSODescriptorElement_methods);
	if (NULL == TElSAMLSSODescriptorType_ce_ptr)
		Register_TElSAMLSSODescriptorType(TSRMLS_C);
	TElSAMLIDPSSODescriptorElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLSSODescriptorType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAssertionConsumerServiceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAssertionConsumerServiceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAssertionConsumerServiceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAssertionConsumerServiceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAssertionConsumerServiceElement_methods[] = {
	PHP_ME(TElSAMLAssertionConsumerServiceElement, __construct, arginfo_TElSAMLAssertionConsumerServiceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAssertionConsumerServiceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAssertionConsumerServiceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAssertionConsumerServiceElement", TElSAMLAssertionConsumerServiceElement_methods);
	if (NULL == TElSAMLIndexedEndpointType_ce_ptr)
		Register_TElSAMLIndexedEndpointType(TSRMLS_C);
	TElSAMLAssertionConsumerServiceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLIndexedEndpointType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLRequestedAttributeElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLRequestedAttributeElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLRequestedAttributeElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRequestedAttributeElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLRequestedAttributeElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRequestedAttributeElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRequestedAttributeElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRequestedAttributeElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRequestedAttributeElement, get_IsRequired)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLRequestedAttributeElement_get_IsRequired(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRequestedAttributeElement, set_IsRequired)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLRequestedAttributeElement_set_IsRequired(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRequestedAttributeElement, get_UseIsRequired)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLRequestedAttributeElement_get_UseIsRequired(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRequestedAttributeElement, set_UseIsRequired)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLRequestedAttributeElement_set_UseIsRequired(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLRequestedAttributeElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLRequestedAttributeElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRequestedAttributeElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRequestedAttributeElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRequestedAttributeElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRequestedAttributeElement_get_IsRequired, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRequestedAttributeElement_set_IsRequired, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRequestedAttributeElement_get_UseIsRequired, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRequestedAttributeElement_set_UseIsRequired, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLRequestedAttributeElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLRequestedAttributeElement_methods[] = {
	PHP_ME(TElSAMLRequestedAttributeElement, Clear, arginfo_TElSAMLRequestedAttributeElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRequestedAttributeElement, LoadFromXML, arginfo_TElSAMLRequestedAttributeElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRequestedAttributeElement, SaveToXML, arginfo_TElSAMLRequestedAttributeElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRequestedAttributeElement, get_IsRequired, arginfo_TElSAMLRequestedAttributeElement_get_IsRequired, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRequestedAttributeElement, set_IsRequired, arginfo_TElSAMLRequestedAttributeElement_set_IsRequired, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRequestedAttributeElement, get_UseIsRequired, arginfo_TElSAMLRequestedAttributeElement_get_UseIsRequired, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRequestedAttributeElement, set_UseIsRequired, arginfo_TElSAMLRequestedAttributeElement_set_UseIsRequired, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLRequestedAttributeElement, __construct, arginfo_TElSAMLRequestedAttributeElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLRequestedAttributeElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLRequestedAttributeElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLRequestedAttributeElement", TElSAMLRequestedAttributeElement_methods);
	if (NULL == TElSAMLAttributeType_ce_ptr)
		Register_TElSAMLAttributeType(TSRMLS_C);
	TElSAMLRequestedAttributeElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLAttributeType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLServiceNameElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLServiceNameElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceNameElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceNameElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLServiceNameElement_methods[] = {
	PHP_ME(TElSAMLServiceNameElement, __construct, arginfo_TElSAMLServiceNameElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLServiceNameElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLServiceNameElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLServiceNameElement", TElSAMLServiceNameElement_methods);
	if (NULL == TElSAMLLocalizedNameType_ce_ptr)
		Register_TElSAMLLocalizedNameType(TSRMLS_C);
	TElSAMLServiceNameElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLLocalizedNameType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLServiceDescriptionElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLServiceDescriptionElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLServiceDescriptionElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLServiceDescriptionElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLServiceDescriptionElement_methods[] = {
	PHP_ME(TElSAMLServiceDescriptionElement, __construct, arginfo_TElSAMLServiceDescriptionElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLServiceDescriptionElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLServiceDescriptionElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLServiceDescriptionElement", TElSAMLServiceDescriptionElement_methods);
	if (NULL == TElSAMLLocalizedNameType_ce_ptr)
		Register_TElSAMLLocalizedNameType(TSRMLS_C);
	TElSAMLServiceDescriptionElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLLocalizedNameType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLAttributeConsumingServiceElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeConsumingServiceElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeConsumingServiceElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeConsumingServiceElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeConsumingServiceElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, get_Index)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLAttributeConsumingServiceElement_get_Index(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, set_Index)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeConsumingServiceElement_set_Index(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, get_IsDefault)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLAttributeConsumingServiceElement_get_IsDefault(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, set_IsDefault)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeConsumingServiceElement_set_IsDefault(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, get_UseIsDefault)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLAttributeConsumingServiceElement_get_UseIsDefault(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, set_UseIsDefault)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLAttributeConsumingServiceElement_set_UseIsDefault(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, get_ServiceNames)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeConsumingServiceElement_get_ServiceNames(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, get_ServiceDescriptions)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeConsumingServiceElement_get_ServiceDescriptions(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, get_RequestedAttributes)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeConsumingServiceElement_get_RequestedAttributes(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLAttributeConsumingServiceElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLAttributeConsumingServiceElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement_get_Index, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement_set_Index, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement_get_IsDefault, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement_set_IsDefault, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement_get_UseIsDefault, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement_set_UseIsDefault, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement_get_ServiceNames, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement_get_ServiceDescriptions, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement_get_RequestedAttributes, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLAttributeConsumingServiceElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLAttributeConsumingServiceElement_methods[] = {
	PHP_ME(TElSAMLAttributeConsumingServiceElement, Clear, arginfo_TElSAMLAttributeConsumingServiceElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeConsumingServiceElement, LoadFromXML, arginfo_TElSAMLAttributeConsumingServiceElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeConsumingServiceElement, SaveToXML, arginfo_TElSAMLAttributeConsumingServiceElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeConsumingServiceElement, get_Index, arginfo_TElSAMLAttributeConsumingServiceElement_get_Index, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeConsumingServiceElement, set_Index, arginfo_TElSAMLAttributeConsumingServiceElement_set_Index, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeConsumingServiceElement, get_IsDefault, arginfo_TElSAMLAttributeConsumingServiceElement_get_IsDefault, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeConsumingServiceElement, set_IsDefault, arginfo_TElSAMLAttributeConsumingServiceElement_set_IsDefault, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeConsumingServiceElement, get_UseIsDefault, arginfo_TElSAMLAttributeConsumingServiceElement_get_UseIsDefault, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeConsumingServiceElement, set_UseIsDefault, arginfo_TElSAMLAttributeConsumingServiceElement_set_UseIsDefault, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeConsumingServiceElement, get_ServiceNames, arginfo_TElSAMLAttributeConsumingServiceElement_get_ServiceNames, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeConsumingServiceElement, get_ServiceDescriptions, arginfo_TElSAMLAttributeConsumingServiceElement_get_ServiceDescriptions, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeConsumingServiceElement, get_RequestedAttributes, arginfo_TElSAMLAttributeConsumingServiceElement_get_RequestedAttributes, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLAttributeConsumingServiceElement, __construct, arginfo_TElSAMLAttributeConsumingServiceElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLAttributeConsumingServiceElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLAttributeConsumingServiceElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLAttributeConsumingServiceElement", TElSAMLAttributeConsumingServiceElement_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLAttributeConsumingServiceElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLSPSSODescriptorElement_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLSPSSODescriptorElement_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSSODescriptorElement_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSPSSODescriptorElement_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSPSSODescriptorElement_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, get_AuthnRequestsSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSPSSODescriptorElement_get_AuthnRequestsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, set_AuthnRequestsSigned)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSSODescriptorElement_set_AuthnRequestsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, get_UseAuthnRequestsSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSPSSODescriptorElement_get_UseAuthnRequestsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, set_UseAuthnRequestsSigned)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSSODescriptorElement_set_UseAuthnRequestsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, get_WantAssertionsSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSPSSODescriptorElement_get_WantAssertionsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, set_WantAssertionsSigned)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSSODescriptorElement_set_WantAssertionsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, get_UseWantAssertionsSigned)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLSPSSODescriptorElement_get_UseWantAssertionsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, set_UseWantAssertionsSigned)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLSPSSODescriptorElement_set_UseWantAssertionsSigned(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, get_AssertionConsumerServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSPSSODescriptorElement_get_AssertionConsumerServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, get_AttributeConsumingServices)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSPSSODescriptorElement_get_AttributeConsumingServices(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TList_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLSPSSODescriptorElement, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLSPSSODescriptorElement_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_get_AuthnRequestsSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_set_AuthnRequestsSigned, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_get_UseAuthnRequestsSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_set_UseAuthnRequestsSigned, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_get_WantAssertionsSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_set_WantAssertionsSigned, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_get_UseWantAssertionsSigned, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_set_UseWantAssertionsSigned, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_get_AssertionConsumerServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement_get_AttributeConsumingServices, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLSPSSODescriptorElement___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLSPSSODescriptorElement_methods[] = {
	PHP_ME(TElSAMLSPSSODescriptorElement, Clear, arginfo_TElSAMLSPSSODescriptorElement_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, LoadFromXML, arginfo_TElSAMLSPSSODescriptorElement_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, SaveToXML, arginfo_TElSAMLSPSSODescriptorElement_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, get_AuthnRequestsSigned, arginfo_TElSAMLSPSSODescriptorElement_get_AuthnRequestsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, set_AuthnRequestsSigned, arginfo_TElSAMLSPSSODescriptorElement_set_AuthnRequestsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, get_UseAuthnRequestsSigned, arginfo_TElSAMLSPSSODescriptorElement_get_UseAuthnRequestsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, set_UseAuthnRequestsSigned, arginfo_TElSAMLSPSSODescriptorElement_set_UseAuthnRequestsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, get_WantAssertionsSigned, arginfo_TElSAMLSPSSODescriptorElement_get_WantAssertionsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, set_WantAssertionsSigned, arginfo_TElSAMLSPSSODescriptorElement_set_WantAssertionsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, get_UseWantAssertionsSigned, arginfo_TElSAMLSPSSODescriptorElement_get_UseWantAssertionsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, set_UseWantAssertionsSigned, arginfo_TElSAMLSPSSODescriptorElement_set_UseWantAssertionsSigned, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, get_AssertionConsumerServices, arginfo_TElSAMLSPSSODescriptorElement_get_AssertionConsumerServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, get_AttributeConsumingServices, arginfo_TElSAMLSPSSODescriptorElement_get_AttributeConsumingServices, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLSPSSODescriptorElement, __construct, arginfo_TElSAMLSPSSODescriptorElement___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLSPSSODescriptorElement(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLSPSSODescriptorElement_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLSPSSODescriptorElement", TElSAMLSPSSODescriptorElement_methods);
	if (NULL == TElSAMLSSODescriptorType_ce_ptr)
		Register_TElSAMLSSODescriptorType(TSRMLS_C);
	TElSAMLSPSSODescriptorElement_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLSSODescriptorType_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLEncryptionMethodType_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLEncryptionMethodType, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptionMethodType_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionMethodType, IsEmpty)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLEncryptionMethodType_IsEmpty(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionMethodType, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptionMethodType_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionMethodType, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptionMethodType_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptionMethodType_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionMethodType, get_Algorithm)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEncryptionMethodType_get_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1147186348, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionMethodType, set_Algorithm)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptionMethodType_set_Algorithm(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionMethodType, get_KeySize)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLEncryptionMethodType_get_KeySize(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionMethodType, set_KeySize)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptionMethodType_set_KeySize(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionMethodType, get_OAEPparams)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElSAMLEncryptionMethodType_get_OAEPparams(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(2059157878, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionMethodType, set_OAEPparams)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElSAMLEncryptionMethodType_set_OAEPparams(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionMethodType, get_DigestMethod)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEncryptionMethodType_get_DigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(878733497, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionMethodType, set_DigestMethod)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEncryptionMethodType_set_DigestMethod(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEncryptionMethodType, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEncryptionMethodType_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType_IsEmpty, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType_get_Algorithm, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType_set_Algorithm, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType_get_KeySize, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType_set_KeySize, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType_get_OAEPparams, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType_set_OAEPparams, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType_get_DigestMethod, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType_set_DigestMethod, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEncryptionMethodType___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLEncryptionMethodType_methods[] = {
	PHP_ME(TElSAMLEncryptionMethodType, Clear, arginfo_TElSAMLEncryptionMethodType_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionMethodType, IsEmpty, arginfo_TElSAMLEncryptionMethodType_IsEmpty, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionMethodType, LoadFromXML, arginfo_TElSAMLEncryptionMethodType_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionMethodType, SaveToXML, arginfo_TElSAMLEncryptionMethodType_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionMethodType, get_Algorithm, arginfo_TElSAMLEncryptionMethodType_get_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionMethodType, set_Algorithm, arginfo_TElSAMLEncryptionMethodType_set_Algorithm, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionMethodType, get_KeySize, arginfo_TElSAMLEncryptionMethodType_get_KeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionMethodType, set_KeySize, arginfo_TElSAMLEncryptionMethodType_set_KeySize, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionMethodType, get_OAEPparams, arginfo_TElSAMLEncryptionMethodType_get_OAEPparams, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionMethodType, set_OAEPparams, arginfo_TElSAMLEncryptionMethodType_set_OAEPparams, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionMethodType, get_DigestMethod, arginfo_TElSAMLEncryptionMethodType_get_DigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionMethodType, set_DigestMethod, arginfo_TElSAMLEncryptionMethodType_set_DigestMethod, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEncryptionMethodType, __construct, arginfo_TElSAMLEncryptionMethodType___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLEncryptionMethodType(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLEncryptionMethodType_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLEncryptionMethodType", TElSAMLEncryptionMethodType_methods);
	if (NULL == TElSAMLElement_ce_ptr)
		Register_TElSAMLElement(TSRMLS_C);
	TElSAMLEncryptionMethodType_ce_ptr = zend_register_internal_class_ex(&ce, TElSAMLElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLMetadata_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLMetadata, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElSAMLMetadata_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMetadata, LoadFromStream)
{
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLMetadata_LoadFromStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMetadata, SaveToStream)
{
	zval *oStrm;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oStrm, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLMetadata_SaveToStream(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oStrm TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMetadata, get_Handler)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLMetadata_get_Handler(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLSecurityHandler_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMetadata, set_Handler)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLSecurityHandler_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLMetadata_set_Handler(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLSecurityHandler)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMetadata, get_Loaded)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLMetadata_get_Loaded(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMetadata, get_RootElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLMetadata_get_RootElement(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElSAMLMetadataRootElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMetadata, set_RootElement)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElSAMLMetadataRootElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElSAMLMetadata_set_RootElement(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElSAMLMetadataRootElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLMetadata, __construct)
{
	zend_bool bOwnHandler;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLMetadata_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bOwnHandler) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLMetadata_Create_1((int8_t)bOwnHandler, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("() or (bool)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMetadata_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMetadata_LoadFromStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMetadata_SaveToStream, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Strm, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMetadata_get_Handler, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMetadata_set_Handler, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLSecurityHandler, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMetadata_get_Loaded, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMetadata_get_RootElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMetadata_set_RootElement, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElSAMLMetadataRootElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLMetadata___construct, 0, 0, 0)
	ZEND_ARG_INFO(0, OwnHandler)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLMetadata_methods[] = {
	PHP_ME(TElSAMLMetadata, Clear, arginfo_TElSAMLMetadata_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMetadata, LoadFromStream, arginfo_TElSAMLMetadata_LoadFromStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMetadata, SaveToStream, arginfo_TElSAMLMetadata_SaveToStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMetadata, get_Handler, arginfo_TElSAMLMetadata_get_Handler, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMetadata, set_Handler, arginfo_TElSAMLMetadata_set_Handler, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMetadata, get_Loaded, arginfo_TElSAMLMetadata_get_Loaded, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMetadata, get_RootElement, arginfo_TElSAMLMetadata_get_RootElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMetadata, set_RootElement, arginfo_TElSAMLMetadata_set_RootElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLMetadata, __construct, arginfo_TElSAMLMetadata___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLMetadata(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLMetadata_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLMetadata", TElSAMLMetadata_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSAMLMetadata_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElSAMLEndpoint_ce_ptr = NULL;

SB_PHP_METHOD(TElSAMLEndpoint, get_Binding)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBSAMLBindingTypeRaw fOutResultRaw = 0;
		SBCheckError(TElSAMLEndpoint_get_Binding(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpoint, set_Binding)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElSAMLEndpoint_set_Binding(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBSAMLBindingTypeRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpoint, get_Location)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElSAMLEndpoint_get_Location(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-679681551, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpoint, set_Location)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElSAMLEndpoint_set_Location(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpoint, get__Index)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElSAMLEndpoint_get__Index(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpoint, set__Index)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElSAMLEndpoint_set__Index(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpoint, get_IsDefault)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElSAMLEndpoint_get_IsDefault(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpoint, set_IsDefault)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElSAMLEndpoint_set_IsDefault(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElSAMLEndpoint, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElSAMLEndpoint_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpoint_get_Binding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpoint_set_Binding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpoint_get_Location, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpoint_set_Location, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpoint_get__Index, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpoint_set__Index, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpoint_get_IsDefault, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpoint_set_IsDefault, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElSAMLEndpoint___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElSAMLEndpoint_methods[] = {
	PHP_ME(TElSAMLEndpoint, get_Binding, arginfo_TElSAMLEndpoint_get_Binding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpoint, set_Binding, arginfo_TElSAMLEndpoint_set_Binding, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpoint, get_Location, arginfo_TElSAMLEndpoint_get_Location, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpoint, set_Location, arginfo_TElSAMLEndpoint_set_Location, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpoint, get__Index, arginfo_TElSAMLEndpoint_get__Index, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpoint, set__Index, arginfo_TElSAMLEndpoint_set__Index, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpoint, get_IsDefault, arginfo_TElSAMLEndpoint_get_IsDefault, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpoint, set_IsDefault, arginfo_TElSAMLEndpoint_set_IsDefault, ZEND_ACC_PUBLIC)
	PHP_ME(TElSAMLEndpoint, __construct, arginfo_TElSAMLEndpoint___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElSAMLEndpoint(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElSAMLEndpoint_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElSAMLEndpoint", TElSAMLEndpoint_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElSAMLEndpoint_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBXMLSAMLMetadata, ContactTypeToStr)
{
	long fT;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fT) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSAMLMetadata_ContactTypeToStr((TSBSAMLContactTypeRaw)fT, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1052130470, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLMetadata, StrToContactType)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		TSBSAMLContactTypeRaw fOutResultRaw = 0;
		SBCheckError(SBXMLSAMLMetadata_StrToContactType(sS, (int32_t)sS_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLMetadata, KeyUsageToStr)
{
	long fU;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fU) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = SBXMLSAMLMetadata_KeyUsageToStr((TSBSAMLKeyUseRaw)fU, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1994162178, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_FUNCTION(SBXMLSAMLMetadata, StrToKeyUsage)
{
	char *sS;
	int sS_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sS, &sS_len) == SUCCESS)
	{
		TSBSAMLKeyUseRaw fOutResultRaw = 0;
		SBCheckError(SBXMLSAMLMetadata_StrToKeyUsage(sS, (int32_t)sS_len, &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

void Register_SBXMLSAMLMetadata_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBSAMLMetaRootElementType", NULL);
	TSBSAMLMetaRootElementType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLMetaRootElementType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLMetaRootElementType_ce_ptr, "mretUnknown", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLMetaRootElementType_ce_ptr, "mretSingleEntity", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLMetaRootElementType_ce_ptr, "mretMultipleEntities", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBSAMLKeyUse", NULL);
	TSBSAMLKeyUse_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLKeyUse_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLKeyUse_ce_ptr, "skuNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLKeyUse_ce_ptr, "skuEncryption", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLKeyUse_ce_ptr, "skuSigning", 2)
	
	INIT_CLASS_ENTRY(ce, "TSBSAMLContactType", NULL);
	TSBSAMLContactType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBSAMLContactType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLContactType_ce_ptr, "sctTechnical", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLContactType_ce_ptr, "sctSupport", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLContactType_ce_ptr, "sctAdministrative", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLContactType_ce_ptr, "sctBilling", 3)
	SB_DECLARE_CLASS_LONG_CONST(TSBSAMLContactType_ce_ptr, "sctOther", 4)
}
