#include "sbxmlsoapclient.h"

zend_class_entry *TElXMLSOAPParameterClass_ce_ptr = NULL;

zend_class_entry *TSBXMLSOAPResponseType_ce_ptr = NULL;

zend_class_entry *TElXMLSOAPClient_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPClient, ProcessReply)
{
	long l4AHTTPStatusCode;
	zval *oAResponseStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lO!", &l4AHTTPStatusCode, &oAResponseStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_ProcessReply(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4AHTTPStatusCode, SBGetObjectHandle(oAResponseStream TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, TStream)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, ClearResponse)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_ClearResponse(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, GenerateMessage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_GenerateMessage(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, LoadMessage)
{
	char *sAFileName;
	int sAFileName_len;
	zval *oADocument;
	zval *oAStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oADocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_LoadMessage(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oADocument TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAStream, TStream_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_LoadMessage_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAStream TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sAFileName, &sAFileName_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_LoadMessage_2(SBGetObjectHandle(getThis() TSRMLS_CC), sAFileName, (int32_t)sAFileName_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument) or (TStream) or (string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, SendMessage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_SendMessage(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, SendMessageWithAttachment)
{
	char *sContentID;
	char *sContentType;
	char *sPrimaryMessageID;
	int sContentID_len;
	int sContentType_len;
	int sPrimaryMessageID_len;
	zend_bool bCloseStream;
	zval *oContentStream;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!b", &sPrimaryMessageID, &sPrimaryMessageID_len, &sContentID, &sContentID_len, &sContentType, &sContentType_len, &oContentStream, TStream_ce_ptr, &bCloseStream) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_SendMessageWithAttachment(SBGetObjectHandle(getThis() TSRMLS_CC), sPrimaryMessageID, (int32_t)sPrimaryMessageID_len, sContentID, (int32_t)sContentID_len, sContentType, (int32_t)sContentType_len, SBGetObjectHandle(oContentStream TSRMLS_CC), (int8_t)bCloseStream) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, string, string, TStream, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, SendMessageWithAttachments)
{
	char *sPrimaryMessageID;
	char *sRelatedStartInfo;
	char *sRelatedType;
	int sPrimaryMessageID_len;
	int sRelatedStartInfo_len;
	int sRelatedType_len;
	zval *oPartsList;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO!", &sPrimaryMessageID, &sPrimaryMessageID_len, &oPartsList, TElHTTPMultipartList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_SendMessageWithAttachments(SBGetObjectHandle(getThis() TSRMLS_CC), sPrimaryMessageID, (int32_t)sPrimaryMessageID_len, SBGetObjectHandle(oPartsList TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssO!", &sPrimaryMessageID, &sPrimaryMessageID_len, &sRelatedStartInfo, &sRelatedStartInfo_len, &sRelatedType, &sRelatedType_len, &oPartsList, TElHTTPMultipartList_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_SendMessageWithAttachments_1(SBGetObjectHandle(getThis() TSRMLS_CC), sPrimaryMessageID, (int32_t)sPrimaryMessageID_len, sRelatedStartInfo, (int32_t)sRelatedStartInfo_len, sRelatedType, (int32_t)sRelatedType_len, SBGetObjectHandle(oPartsList TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string, TElHTTPMultipartList) or (string, string, string, TElHTTPMultipartList)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, AddParameter)
{
	zval *oParam;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParam, TElXMLSOAPBaseParameter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddParameter(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParam TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSOAPBaseParameter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, AddStringParameter)
{
	char *sParamName;
	char *sParamNamespaceURI;
	char *sValue;
	int sParamName_len;
	int sParamNamespaceURI_len;
	int sValue_len;
	zend_bool bNormalizeNEL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sParamName, &sParamName_len, &sValue, &sValue_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddStringParameter(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sValue, (int32_t)sValue_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sParamName, &sParamName_len, &sValue, &sValue_len, &bNormalizeNEL) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddStringParameter_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sValue, (int32_t)sValue_len, (int8_t)bNormalizeNEL, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &sValue, &sValue_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddStringParameter_2(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, sValue, (int32_t)sValue_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssb", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &sValue, &sValue_len, &bNormalizeNEL) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddStringParameter_3(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, sValue, (int32_t)sValue_len, (int8_t)bNormalizeNEL, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (string, string, bool) or (string, string, string) or (string, string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, AddBooleanParameter)
{
	char *sParamName;
	char *sParamNamespaceURI;
	int sParamName_len;
	int sParamNamespaceURI_len;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sParamName, &sParamName_len, &bValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddBooleanParameter(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, (int8_t)bValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &bValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddBooleanParameter_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, (int8_t)bValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool) or (string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, AddIntegerParameter)
{
	char *sParamName;
	char *sParamNamespaceURI;
	int sParamName_len;
	int sParamNamespaceURI_len;
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sParamName, &sParamName_len, &l4Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddIntegerParameter(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, (int32_t)l4Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssl", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &l4Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddIntegerParameter_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, (int32_t)l4Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer) or (string, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, AddInt64Parameter)
{
	char *sParamName;
	char *sParamNamespaceURI;
	int sParamName_len;
	int sParamNamespaceURI_len;
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sParamName, &sParamName_len, &l8Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddInt64Parameter(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, (int64_t)l8Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssl", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &l8Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddInt64Parameter_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, (int64_t)l8Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer) or (string, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, AddDoubleParameter)
{
	char *sParamName;
	char *sParamNamespaceURI;
	double dValue;
	int sParamName_len;
	int sParamNamespaceURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sd", &sParamName, &sParamName_len, &dValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddDoubleParameter(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, (double)dValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssd", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &dValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddDoubleParameter_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, (double)dValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, double) or (string, string, double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, AddDateTimeParameter)
{
	char *sParamName;
	char *sParamNamespaceURI;
	int sParamName_len;
	int sParamNamespaceURI_len;
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO", &sParamName, &sParamName_len, &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddDateTimeParameter(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, SBGetDateTime(dtValue TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddDateTimeParameter_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, SBGetDateTime(dtValue TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, DateTime) or (string, string, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, AddBase64BinaryParameter)
{
	char *sParamName;
	char *sParamNamespaceURI;
	int sParamName_len;
	int sParamNamespaceURI_len;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sParamName, &sParamName_len, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLSOAPClient_AddBase64BinaryParameter(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, aiValue.data, aiValue.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssz", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLSOAPClient_AddBase64BinaryParameter_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, aiValue.data, aiValue.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, array of byte|string|NULL) or (string, string, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, AddCompoundParameter)
{
	char *sParamName;
	char *sParamNamespaceURI;
	int sParamName_len;
	int sParamNamespaceURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sParamName, &sParamName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddCompoundParameter(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_AddCompoundParameter_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, DeleteParameter)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_DeleteParameter(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_XMLDocument)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_XMLDocument(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMDocument_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_SOAPMessage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_SOAPMessage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_SOAPVersion)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLSOAPVersionRaw fOutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_get_SOAPVersion(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, set_SOAPVersion)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_set_SOAPVersion(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXMLSOAPVersionRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_SOAPPrefix)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_SOAPPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(486049253, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, set_SOAPPrefix)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_set_SOAPPrefix(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_MessageNamespaces)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_MessageNamespaces(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLNamespaceMap_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_OperationName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_OperationName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1289608842, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, set_OperationName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_set_OperationName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_OperationNamespaceURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_OperationNamespaceURI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(746178164, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, set_OperationNamespaceURI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_set_OperationNamespaceURI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_OperationResponseName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_OperationResponseName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1451354747, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, set_OperationResponseName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_set_OperationResponseName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_OperationResponseNamespaceURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_OperationResponseNamespaceURI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1353519923, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, set_OperationResponseNamespaceURI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_set_OperationResponseNamespaceURI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_Encoding)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1048648140, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, set_Encoding)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_set_Encoding(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_SOAPAction)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_SOAPAction(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-930770951, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, set_SOAPAction)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_set_SOAPAction(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_RootParameter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_RootParameter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCompoundParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_ParameterCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_get_ParameterCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_Parameters)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_Parameters(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_ParameterNames)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_ParameterNames(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1803679385, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_ParameterValues)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_ParameterValues(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1601101375, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_HTTPStatusCode)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_get_HTTPStatusCode(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_ResponseType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLSOAPResponseTypeRaw fOutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_get_ResponseType(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_ResponseStream)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_ResponseStream(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TMemoryStream_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_ResponseXMLDocument)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_ResponseXMLDocument(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMDocument_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_ResponseSOAPMessage)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_ResponseSOAPMessage(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPMessage_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_OperationResponseXMLElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_OperationResponseXMLElement(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_ResponseRootParameter)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_ResponseRootParameter(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCompoundParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_ResponseParameterCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_get_ResponseParameterCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_ResponseParameters)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_ResponseParameters(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_ResponseParameterNames)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_ResponseParameterNames(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(645936781, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_ResponseParameterValues)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_ResponseParameterValues(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1173949316, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_FaultCount)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPClient_get_FaultCount(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_Faults)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_Faults(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPFault_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_FaultActor)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_FaultActor(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(267577333, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_FaultCode)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_FaultCode(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-82179173, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_FaultString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_FaultString(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1161926334, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_HTTPClient)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElHTTPSClient_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, set_HTTPClient)
{
	zval *oValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oValue, TElHTTPSClient_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_set_HTTPClient(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElHTTPSClient)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_URL)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPClient_get_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1027062817, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, set_URL)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPClient_set_URL(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_OnFormatElement)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLFormatElementEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_OnFormatElement(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, set_OnFormatElement)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXMLSOAPClient_set_OnFormatElement(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXMLFormatElementEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXMLFormatElementEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, get_OnFormatText)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLFormatTextEvent pMethodOutResult = NULL;
		void * pDataOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_get_OnFormatText(SBGetObjectHandle(getThis() TSRMLS_CC), &pMethodOutResult, &pDataOutResult) TSRMLS_CC);
		if (NULL != pDataOutResult)
		{
			INIT_PZVAL_COPY(return_value, (zval *)pDataOutResult);
			zval_copy_ctor(return_value);
		}
		else
			ZVAL_NULL(return_value);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, set_OnFormatText)
{
	void *pzValue;
	zval *zValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zValue)) || (IS_ARRAY == Z_TYPE_P(zValue)) || (IS_CALLABLE == Z_TYPE_P(zValue)) || (IS_NULL == Z_TYPE_P(zValue))))
	{
		pzValue = SBSetEventData(zValue TSRMLS_CC);
		SBCheckError(TElXMLSOAPClient_set_OnFormatText(SBGetObjectHandle(getThis() TSRMLS_CC), pzValue ? &TSBXMLFormatTextEventRaw : NULL, pzValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TSBXMLFormatTextEvent|callable|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPClient, __construct)
{
	zval *oAOwner;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAOwner, TComponent_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPClient_Create(SBGetObjectHandle(oAOwner TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TComponent)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_ProcessReply, 0, 0, 2)
	ZEND_ARG_INFO(0, AHTTPStatusCode)
	ZEND_ARG_OBJ_INFO(0, AResponseStream, TStream, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_ClearResponse, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_GenerateMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_LoadMessage, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ADocument_or_AStream_or_AFileName, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_SendMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_SendMessageWithAttachment, 0, 0, 5)
	ZEND_ARG_INFO(0, PrimaryMessageID)
	ZEND_ARG_INFO(0, ContentID)
	ZEND_ARG_INFO(0, ContentType)
	ZEND_ARG_OBJ_INFO(0, ContentStream, TStream, 1)
	ZEND_ARG_INFO(0, CloseStream)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_SendMessageWithAttachments, 0, 0, 2)
	ZEND_ARG_INFO(0, PrimaryMessageID)
	ZEND_ARG_TYPE_INFO(0, PartsList_or_RelatedStartInfo, 0, 1)
	ZEND_ARG_INFO(0, RelatedType)
	ZEND_ARG_OBJ_INFO(0, PartsList, TElHTTPMultipartList, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_AddParameter, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Param, TElXMLSOAPBaseParameter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_AddStringParameter, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, Value_or_ParamNamespaceURI)
	ZEND_ARG_INFO(0, NormalizeNEL_or_Value)
	ZEND_ARG_INFO(0, NormalizeNEL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_AddBooleanParameter, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, Value_or_ParamNamespaceURI)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_AddIntegerParameter, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, Value_or_ParamNamespaceURI)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_AddInt64Parameter, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, Value_or_ParamNamespaceURI)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_AddDoubleParameter, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, Value_or_ParamNamespaceURI)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_AddDateTimeParameter, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, Value_or_ParamNamespaceURI)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_AddBase64BinaryParameter, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_TYPE_INFO(0, Value_or_ParamNamespaceURI, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_AddCompoundParameter, 0, 0, 1)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, ParamNamespaceURI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_DeleteParameter, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_XMLDocument, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_SOAPMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_SOAPVersion, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_set_SOAPVersion, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_SOAPPrefix, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_set_SOAPPrefix, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_MessageNamespaces, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_OperationName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_set_OperationName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_OperationNamespaceURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_set_OperationNamespaceURI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_OperationResponseName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_set_OperationResponseName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_OperationResponseNamespaceURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_set_OperationResponseNamespaceURI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_Encoding, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_set_Encoding, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_SOAPAction, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_set_SOAPAction, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_RootParameter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_ParameterCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_Parameters, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_ParameterNames, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_ParameterValues, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_HTTPStatusCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_ResponseType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_ResponseStream, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_ResponseXMLDocument, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_ResponseSOAPMessage, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_OperationResponseXMLElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_ResponseRootParameter, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_ResponseParameterCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_ResponseParameters, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_ResponseParameterNames, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_ResponseParameterValues, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_FaultCount, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_Faults, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_FaultActor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_FaultCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_FaultString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_HTTPClient, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_set_HTTPClient, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, TElHTTPSClient, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_URL, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_set_URL, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_OnFormatElement, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_set_OnFormatElement, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_get_OnFormatText, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient_set_OnFormatText, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPClient___construct, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, AOwner, TComponent, 1)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPClient_methods[] = {
	PHP_ME(TElXMLSOAPClient, ProcessReply, arginfo_TElXMLSOAPClient_ProcessReply, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, Clear, arginfo_TElXMLSOAPClient_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, ClearResponse, arginfo_TElXMLSOAPClient_ClearResponse, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, GenerateMessage, arginfo_TElXMLSOAPClient_GenerateMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, LoadMessage, arginfo_TElXMLSOAPClient_LoadMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, SendMessage, arginfo_TElXMLSOAPClient_SendMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, SendMessageWithAttachment, arginfo_TElXMLSOAPClient_SendMessageWithAttachment, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, SendMessageWithAttachments, arginfo_TElXMLSOAPClient_SendMessageWithAttachments, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, AddParameter, arginfo_TElXMLSOAPClient_AddParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, AddStringParameter, arginfo_TElXMLSOAPClient_AddStringParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, AddBooleanParameter, arginfo_TElXMLSOAPClient_AddBooleanParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, AddIntegerParameter, arginfo_TElXMLSOAPClient_AddIntegerParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, AddInt64Parameter, arginfo_TElXMLSOAPClient_AddInt64Parameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, AddDoubleParameter, arginfo_TElXMLSOAPClient_AddDoubleParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, AddDateTimeParameter, arginfo_TElXMLSOAPClient_AddDateTimeParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, AddBase64BinaryParameter, arginfo_TElXMLSOAPClient_AddBase64BinaryParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, AddCompoundParameter, arginfo_TElXMLSOAPClient_AddCompoundParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, DeleteParameter, arginfo_TElXMLSOAPClient_DeleteParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_XMLDocument, arginfo_TElXMLSOAPClient_get_XMLDocument, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_SOAPMessage, arginfo_TElXMLSOAPClient_get_SOAPMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_SOAPVersion, arginfo_TElXMLSOAPClient_get_SOAPVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, set_SOAPVersion, arginfo_TElXMLSOAPClient_set_SOAPVersion, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_SOAPPrefix, arginfo_TElXMLSOAPClient_get_SOAPPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, set_SOAPPrefix, arginfo_TElXMLSOAPClient_set_SOAPPrefix, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_MessageNamespaces, arginfo_TElXMLSOAPClient_get_MessageNamespaces, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_OperationName, arginfo_TElXMLSOAPClient_get_OperationName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, set_OperationName, arginfo_TElXMLSOAPClient_set_OperationName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_OperationNamespaceURI, arginfo_TElXMLSOAPClient_get_OperationNamespaceURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, set_OperationNamespaceURI, arginfo_TElXMLSOAPClient_set_OperationNamespaceURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_OperationResponseName, arginfo_TElXMLSOAPClient_get_OperationResponseName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, set_OperationResponseName, arginfo_TElXMLSOAPClient_set_OperationResponseName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_OperationResponseNamespaceURI, arginfo_TElXMLSOAPClient_get_OperationResponseNamespaceURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, set_OperationResponseNamespaceURI, arginfo_TElXMLSOAPClient_set_OperationResponseNamespaceURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_Encoding, arginfo_TElXMLSOAPClient_get_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, set_Encoding, arginfo_TElXMLSOAPClient_set_Encoding, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_SOAPAction, arginfo_TElXMLSOAPClient_get_SOAPAction, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, set_SOAPAction, arginfo_TElXMLSOAPClient_set_SOAPAction, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_RootParameter, arginfo_TElXMLSOAPClient_get_RootParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_ParameterCount, arginfo_TElXMLSOAPClient_get_ParameterCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_Parameters, arginfo_TElXMLSOAPClient_get_Parameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_ParameterNames, arginfo_TElXMLSOAPClient_get_ParameterNames, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_ParameterValues, arginfo_TElXMLSOAPClient_get_ParameterValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_HTTPStatusCode, arginfo_TElXMLSOAPClient_get_HTTPStatusCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_ResponseType, arginfo_TElXMLSOAPClient_get_ResponseType, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_ResponseStream, arginfo_TElXMLSOAPClient_get_ResponseStream, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_ResponseXMLDocument, arginfo_TElXMLSOAPClient_get_ResponseXMLDocument, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_ResponseSOAPMessage, arginfo_TElXMLSOAPClient_get_ResponseSOAPMessage, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_OperationResponseXMLElement, arginfo_TElXMLSOAPClient_get_OperationResponseXMLElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_ResponseRootParameter, arginfo_TElXMLSOAPClient_get_ResponseRootParameter, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_ResponseParameterCount, arginfo_TElXMLSOAPClient_get_ResponseParameterCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_ResponseParameters, arginfo_TElXMLSOAPClient_get_ResponseParameters, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_ResponseParameterNames, arginfo_TElXMLSOAPClient_get_ResponseParameterNames, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_ResponseParameterValues, arginfo_TElXMLSOAPClient_get_ResponseParameterValues, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_FaultCount, arginfo_TElXMLSOAPClient_get_FaultCount, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_Faults, arginfo_TElXMLSOAPClient_get_Faults, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_FaultActor, arginfo_TElXMLSOAPClient_get_FaultActor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_FaultCode, arginfo_TElXMLSOAPClient_get_FaultCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_FaultString, arginfo_TElXMLSOAPClient_get_FaultString, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_HTTPClient, arginfo_TElXMLSOAPClient_get_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, set_HTTPClient, arginfo_TElXMLSOAPClient_set_HTTPClient, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_URL, arginfo_TElXMLSOAPClient_get_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, set_URL, arginfo_TElXMLSOAPClient_set_URL, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_OnFormatElement, arginfo_TElXMLSOAPClient_get_OnFormatElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, set_OnFormatElement, arginfo_TElXMLSOAPClient_set_OnFormatElement, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, get_OnFormatText, arginfo_TElXMLSOAPClient_get_OnFormatText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, set_OnFormatText, arginfo_TElXMLSOAPClient_set_OnFormatText, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPClient, __construct, arginfo_TElXMLSOAPClient___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPClient(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPClient_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPClient", TElXMLSOAPClient_methods);
	if (NULL == TComponent_ce_ptr)
		Register_TComponent(TSRMLS_C);
	TElXMLSOAPClient_ce_ptr = zend_register_internal_class_ex(&ce, TComponent_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPCustomParameter_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPCustomParameter, CreateFromXML_Inst)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCustomParameter_CreateFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomParameter, CreateFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCustomParameter_CreateFromXML(SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomParameter, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCustomParameter_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomParameter, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPCustomParameter_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomParameter, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPCustomParameter_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomParameter, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCustomParameter_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCustomParameter_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomParameter, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCustomParameter_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomParameter, get_ParameterName)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPCustomParameter_get_ParameterName(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1923093934, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomParameter, set_ParameterName)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPCustomParameter_set_ParameterName(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomParameter, get_ParameterNamespaceURI)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPCustomParameter_get_ParameterNamespaceURI(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(580935204, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomParameter, set_ParameterNamespaceURI)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPCustomParameter_set_ParameterNamespaceURI(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCustomParameter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCustomParameter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomParameter_CreateFromXML_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomParameter_CreateFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomParameter_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomParameter_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomParameter_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomParameter_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomParameter_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomParameter_get_ParameterName, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomParameter_set_ParameterName, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomParameter_get_ParameterNamespaceURI, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomParameter_set_ParameterNamespaceURI, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCustomParameter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPCustomParameter_methods[] = {
	PHP_ME(TElXMLSOAPCustomParameter, CreateFromXML_Inst, arginfo_TElXMLSOAPCustomParameter_CreateFromXML_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomParameter, CreateFromXML, arginfo_TElXMLSOAPCustomParameter_CreateFromXML, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPCustomParameter, Clone, arginfo_TElXMLSOAPCustomParameter_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomParameter, Clear, arginfo_TElXMLSOAPCustomParameter_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomParameter, LoadFromXML, arginfo_TElXMLSOAPCustomParameter_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomParameter, SaveToXML, arginfo_TElXMLSOAPCustomParameter_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomParameter, ClassType, arginfo_TElXMLSOAPCustomParameter_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPCustomParameter, get_ParameterName, arginfo_TElXMLSOAPCustomParameter_get_ParameterName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomParameter, set_ParameterName, arginfo_TElXMLSOAPCustomParameter_set_ParameterName, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomParameter, get_ParameterNamespaceURI, arginfo_TElXMLSOAPCustomParameter_get_ParameterNamespaceURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomParameter, set_ParameterNamespaceURI, arginfo_TElXMLSOAPCustomParameter_set_ParameterNamespaceURI, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCustomParameter, __construct, arginfo_TElXMLSOAPCustomParameter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPCustomParameter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPCustomParameter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPCustomParameter", TElXMLSOAPCustomParameter_methods);
	if (NULL == TElXMLCustomElement_ce_ptr)
		Register_TElXMLCustomElement(TSRMLS_C);
	TElXMLSOAPCustomParameter_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLCustomElement_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPBaseParameter_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPBaseParameter, CreateFromXML_Inst)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseParameter_CreateFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseParameter, CreateFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseParameter_CreateFromXML(SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseParameter, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseParameter_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseParameter, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseParameter_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseParameter, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseParameter_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseParameter, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseParameter_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseParameter_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseParameter, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseParameter_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseParameter, get_StringValue)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPBaseParameter_get_StringValue(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-979675507, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseParameter, set_StringValue)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBaseParameter_set_StringValue(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBaseParameter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBaseParameter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseParameter_CreateFromXML_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseParameter_CreateFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseParameter_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseParameter_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseParameter_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseParameter_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseParameter_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseParameter_get_StringValue, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseParameter_set_StringValue, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBaseParameter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPBaseParameter_methods[] = {
	PHP_ME(TElXMLSOAPBaseParameter, CreateFromXML_Inst, arginfo_TElXMLSOAPBaseParameter_CreateFromXML_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseParameter, CreateFromXML, arginfo_TElXMLSOAPBaseParameter_CreateFromXML, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPBaseParameter, Clone, arginfo_TElXMLSOAPBaseParameter_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseParameter, Clear, arginfo_TElXMLSOAPBaseParameter_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseParameter, LoadFromXML, arginfo_TElXMLSOAPBaseParameter_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseParameter, SaveToXML, arginfo_TElXMLSOAPBaseParameter_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseParameter, ClassType, arginfo_TElXMLSOAPBaseParameter_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPBaseParameter, get_StringValue, arginfo_TElXMLSOAPBaseParameter_get_StringValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseParameter, set_StringValue, arginfo_TElXMLSOAPBaseParameter_set_StringValue, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBaseParameter, __construct, arginfo_TElXMLSOAPBaseParameter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPBaseParameter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPBaseParameter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPBaseParameter", TElXMLSOAPBaseParameter_methods);
	if (NULL == TElXMLSOAPCustomParameter_ce_ptr)
		Register_TElXMLSOAPCustomParameter(TSRMLS_C);
	TElXMLSOAPBaseParameter_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPCustomParameter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPStringParameter_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPStringParameter, CreateFromXML_Inst)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPStringParameter_CreateFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPStringParameter, CreateFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPStringParameter_CreateFromXML(SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPStringParameter, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPStringParameter_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPStringParameter, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPStringParameter_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPStringParameter, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPStringParameter_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1113256555, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPStringParameter, set_Value)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPStringParameter_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPStringParameter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPStringParameter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPStringParameter_CreateFromXML_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPStringParameter_CreateFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPStringParameter_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPStringParameter_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPStringParameter_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPStringParameter_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPStringParameter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPStringParameter_methods[] = {
	PHP_ME(TElXMLSOAPStringParameter, CreateFromXML_Inst, arginfo_TElXMLSOAPStringParameter_CreateFromXML_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPStringParameter, CreateFromXML, arginfo_TElXMLSOAPStringParameter_CreateFromXML, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPStringParameter, Clone, arginfo_TElXMLSOAPStringParameter_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPStringParameter, ClassType, arginfo_TElXMLSOAPStringParameter_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPStringParameter, get_Value, arginfo_TElXMLSOAPStringParameter_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPStringParameter, set_Value, arginfo_TElXMLSOAPStringParameter_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPStringParameter, __construct, arginfo_TElXMLSOAPStringParameter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPStringParameter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPStringParameter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPStringParameter", TElXMLSOAPStringParameter_methods);
	if (NULL == TElXMLSOAPBaseParameter_ce_ptr)
		Register_TElXMLSOAPBaseParameter(TSRMLS_C);
	TElXMLSOAPStringParameter_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPBaseParameter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPBooleanParameter_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPBooleanParameter, CreateFromXML_Inst)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBooleanParameter_CreateFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBooleanParameter, CreateFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBooleanParameter_CreateFromXML(SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBooleanParameter, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBooleanParameter_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBooleanParameter, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBooleanParameter_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBooleanParameter, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBooleanParameter_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBooleanParameter, get_Value)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSOAPBooleanParameter_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBooleanParameter, set_Value)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPBooleanParameter_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBooleanParameter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBooleanParameter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBooleanParameter_CreateFromXML_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBooleanParameter_CreateFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBooleanParameter_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBooleanParameter_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBooleanParameter_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBooleanParameter_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBooleanParameter_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBooleanParameter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPBooleanParameter_methods[] = {
	PHP_ME(TElXMLSOAPBooleanParameter, CreateFromXML_Inst, arginfo_TElXMLSOAPBooleanParameter_CreateFromXML_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBooleanParameter, CreateFromXML, arginfo_TElXMLSOAPBooleanParameter_CreateFromXML, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPBooleanParameter, Clone, arginfo_TElXMLSOAPBooleanParameter_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBooleanParameter, LoadFromXML, arginfo_TElXMLSOAPBooleanParameter_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBooleanParameter, ClassType, arginfo_TElXMLSOAPBooleanParameter_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPBooleanParameter, get_Value, arginfo_TElXMLSOAPBooleanParameter_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBooleanParameter, set_Value, arginfo_TElXMLSOAPBooleanParameter_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBooleanParameter, __construct, arginfo_TElXMLSOAPBooleanParameter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPBooleanParameter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPBooleanParameter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPBooleanParameter", TElXMLSOAPBooleanParameter_methods);
	if (NULL == TElXMLSOAPBaseParameter_ce_ptr)
		Register_TElXMLSOAPBaseParameter(TSRMLS_C);
	TElXMLSOAPBooleanParameter_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPBaseParameter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPIntegerParameter_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPIntegerParameter, CreateFromXML_Inst)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPIntegerParameter_CreateFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPIntegerParameter, CreateFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPIntegerParameter_CreateFromXML(SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPIntegerParameter, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPIntegerParameter_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPIntegerParameter, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPIntegerParameter_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPIntegerParameter, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPIntegerParameter_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPIntegerParameter, get_Value)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPIntegerParameter_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPIntegerParameter, set_Value)
{
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Value) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPIntegerParameter_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPIntegerParameter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPIntegerParameter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPIntegerParameter_CreateFromXML_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPIntegerParameter_CreateFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPIntegerParameter_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPIntegerParameter_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPIntegerParameter_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPIntegerParameter_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPIntegerParameter_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPIntegerParameter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPIntegerParameter_methods[] = {
	PHP_ME(TElXMLSOAPIntegerParameter, CreateFromXML_Inst, arginfo_TElXMLSOAPIntegerParameter_CreateFromXML_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPIntegerParameter, CreateFromXML, arginfo_TElXMLSOAPIntegerParameter_CreateFromXML, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPIntegerParameter, Clone, arginfo_TElXMLSOAPIntegerParameter_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPIntegerParameter, LoadFromXML, arginfo_TElXMLSOAPIntegerParameter_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPIntegerParameter, ClassType, arginfo_TElXMLSOAPIntegerParameter_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPIntegerParameter, get_Value, arginfo_TElXMLSOAPIntegerParameter_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPIntegerParameter, set_Value, arginfo_TElXMLSOAPIntegerParameter_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPIntegerParameter, __construct, arginfo_TElXMLSOAPIntegerParameter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPIntegerParameter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPIntegerParameter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPIntegerParameter", TElXMLSOAPIntegerParameter_methods);
	if (NULL == TElXMLSOAPBaseParameter_ce_ptr)
		Register_TElXMLSOAPBaseParameter(TSRMLS_C);
	TElXMLSOAPIntegerParameter_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPBaseParameter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPInt64Parameter_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPInt64Parameter, CreateFromXML_Inst)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPInt64Parameter_CreateFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPInt64Parameter, CreateFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPInt64Parameter_CreateFromXML(SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPInt64Parameter, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPInt64Parameter_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPInt64Parameter, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPInt64Parameter_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPInt64Parameter, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPInt64Parameter_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPInt64Parameter, get_Value)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t l8OutResultRaw = 0;
		SBCheckError(TElXMLSOAPInt64Parameter_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), &l8OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l8OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPInt64Parameter, set_Value)
{
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l8Value) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPInt64Parameter_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), (int64_t)l8Value) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPInt64Parameter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPInt64Parameter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPInt64Parameter_CreateFromXML_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPInt64Parameter_CreateFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPInt64Parameter_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPInt64Parameter_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPInt64Parameter_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPInt64Parameter_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPInt64Parameter_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPInt64Parameter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPInt64Parameter_methods[] = {
	PHP_ME(TElXMLSOAPInt64Parameter, CreateFromXML_Inst, arginfo_TElXMLSOAPInt64Parameter_CreateFromXML_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPInt64Parameter, CreateFromXML, arginfo_TElXMLSOAPInt64Parameter_CreateFromXML, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPInt64Parameter, Clone, arginfo_TElXMLSOAPInt64Parameter_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPInt64Parameter, LoadFromXML, arginfo_TElXMLSOAPInt64Parameter_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPInt64Parameter, ClassType, arginfo_TElXMLSOAPInt64Parameter_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPInt64Parameter, get_Value, arginfo_TElXMLSOAPInt64Parameter_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPInt64Parameter, set_Value, arginfo_TElXMLSOAPInt64Parameter_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPInt64Parameter, __construct, arginfo_TElXMLSOAPInt64Parameter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPInt64Parameter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPInt64Parameter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPInt64Parameter", TElXMLSOAPInt64Parameter_methods);
	if (NULL == TElXMLSOAPBaseParameter_ce_ptr)
		Register_TElXMLSOAPBaseParameter(TSRMLS_C);
	TElXMLSOAPInt64Parameter_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPBaseParameter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPDoubleParameter_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPDoubleParameter, CreateFromXML_Inst)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPDoubleParameter_CreateFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDoubleParameter, CreateFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPDoubleParameter_CreateFromXML(SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDoubleParameter, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPDoubleParameter_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDoubleParameter, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPDoubleParameter_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDoubleParameter, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPDoubleParameter_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDoubleParameter, get_Value)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		double dOutResult = 0.0;
		SBCheckError(TElXMLSOAPDoubleParameter_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), &dOutResult) TSRMLS_CC);
		RETURN_DOUBLE(dOutResult);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDoubleParameter, set_Value)
{
	double dValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "d", &dValue) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPDoubleParameter_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), (double)dValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDoubleParameter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPDoubleParameter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDoubleParameter_CreateFromXML_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDoubleParameter_CreateFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDoubleParameter_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDoubleParameter_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDoubleParameter_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDoubleParameter_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDoubleParameter_set_Value, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDoubleParameter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPDoubleParameter_methods[] = {
	PHP_ME(TElXMLSOAPDoubleParameter, CreateFromXML_Inst, arginfo_TElXMLSOAPDoubleParameter_CreateFromXML_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDoubleParameter, CreateFromXML, arginfo_TElXMLSOAPDoubleParameter_CreateFromXML, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPDoubleParameter, Clone, arginfo_TElXMLSOAPDoubleParameter_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDoubleParameter, LoadFromXML, arginfo_TElXMLSOAPDoubleParameter_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDoubleParameter, ClassType, arginfo_TElXMLSOAPDoubleParameter_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPDoubleParameter, get_Value, arginfo_TElXMLSOAPDoubleParameter_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDoubleParameter, set_Value, arginfo_TElXMLSOAPDoubleParameter_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDoubleParameter, __construct, arginfo_TElXMLSOAPDoubleParameter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPDoubleParameter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPDoubleParameter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPDoubleParameter", TElXMLSOAPDoubleParameter_methods);
	if (NULL == TElXMLSOAPBaseParameter_ce_ptr)
		Register_TElXMLSOAPBaseParameter(TSRMLS_C);
	TElXMLSOAPDoubleParameter_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPBaseParameter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPDateTimeParameter_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPDateTimeParameter, CreateFromXML_Inst)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPDateTimeParameter_CreateFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDateTimeParameter, CreateFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPDateTimeParameter_CreateFromXML(SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDateTimeParameter, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPDateTimeParameter_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDateTimeParameter, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPDateTimeParameter_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDateTimeParameter, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPDateTimeParameter_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDateTimeParameter, get_Value)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int64_t dtOutResultRaw = 0;
		SBCheckError(TElXMLSOAPDateTimeParameter_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), &dtOutResultRaw) TSRMLS_CC);
		object_init_ex(return_value, php_date_get_date_ce());
		SBSetDateTime(return_value, dtOutResultRaw TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDateTimeParameter, set_Value)
{
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O", &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPDateTimeParameter_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetDateTime(dtValue TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDateTimeParameter, get_DateTimeFormat)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TSBXMLDateTimeFormatRaw fOutResultRaw = 0;
		SBCheckError(TElXMLSOAPDateTimeParameter_get_DateTimeFormat(SBGetObjectHandle(getThis() TSRMLS_CC), &fOutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)fOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDateTimeParameter, set_DateTimeFormat)
{
	long fValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &fValue) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPDateTimeParameter_set_DateTimeFormat(SBGetObjectHandle(getThis() TSRMLS_CC), (TSBXMLDateTimeFormatRaw)fValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDateTimeParameter, get_IncludeTimeZone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int8_t bOutResultRaw = 0;
		SBCheckError(TElXMLSOAPDateTimeParameter_get_IncludeTimeZone(SBGetObjectHandle(getThis() TSRMLS_CC), &bOutResultRaw) TSRMLS_CC);
		RETURN_BOOL(bOutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDateTimeParameter, set_IncludeTimeZone)
{
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "b", &bValue) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPDateTimeParameter_set_IncludeTimeZone(SBGetObjectHandle(getThis() TSRMLS_CC), (int8_t)bValue) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPDateTimeParameter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPDateTimeParameter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDateTimeParameter_CreateFromXML_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDateTimeParameter_CreateFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDateTimeParameter_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDateTimeParameter_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDateTimeParameter_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDateTimeParameter_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDateTimeParameter_set_Value, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDateTimeParameter_get_DateTimeFormat, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDateTimeParameter_set_DateTimeFormat, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDateTimeParameter_get_IncludeTimeZone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDateTimeParameter_set_IncludeTimeZone, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPDateTimeParameter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPDateTimeParameter_methods[] = {
	PHP_ME(TElXMLSOAPDateTimeParameter, CreateFromXML_Inst, arginfo_TElXMLSOAPDateTimeParameter_CreateFromXML_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDateTimeParameter, CreateFromXML, arginfo_TElXMLSOAPDateTimeParameter_CreateFromXML, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPDateTimeParameter, Clone, arginfo_TElXMLSOAPDateTimeParameter_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDateTimeParameter, LoadFromXML, arginfo_TElXMLSOAPDateTimeParameter_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDateTimeParameter, ClassType, arginfo_TElXMLSOAPDateTimeParameter_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPDateTimeParameter, get_Value, arginfo_TElXMLSOAPDateTimeParameter_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDateTimeParameter, set_Value, arginfo_TElXMLSOAPDateTimeParameter_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDateTimeParameter, get_DateTimeFormat, arginfo_TElXMLSOAPDateTimeParameter_get_DateTimeFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDateTimeParameter, set_DateTimeFormat, arginfo_TElXMLSOAPDateTimeParameter_set_DateTimeFormat, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDateTimeParameter, get_IncludeTimeZone, arginfo_TElXMLSOAPDateTimeParameter_get_IncludeTimeZone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDateTimeParameter, set_IncludeTimeZone, arginfo_TElXMLSOAPDateTimeParameter_set_IncludeTimeZone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPDateTimeParameter, __construct, arginfo_TElXMLSOAPDateTimeParameter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPDateTimeParameter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPDateTimeParameter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPDateTimeParameter", TElXMLSOAPDateTimeParameter_methods);
	if (NULL == TElXMLSOAPBaseParameter_ce_ptr)
		Register_TElXMLSOAPBaseParameter(TSRMLS_C);
	TElXMLSOAPDateTimeParameter_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPBaseParameter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPBase64BinaryParameter_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPBase64BinaryParameter, CreateFromXML_Inst)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBase64BinaryParameter_CreateFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBase64BinaryParameter, CreateFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBase64BinaryParameter_CreateFromXML(SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBase64BinaryParameter, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBase64BinaryParameter_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBase64BinaryParameter, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBase64BinaryParameter_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBase64BinaryParameter, get_Value)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		uint8_t *u8OutResult = NULL;
		int32_t u8OutResult_len = 0;
		_err = TElXMLSOAPBase64BinaryParameter_get_Value(SBGetObjectHandle(getThis() TSRMLS_CC), u8OutResult, &u8OutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			u8OutResult = emalloc(u8OutResult_len + 1);
			SBCheckError(SBGetLastReturnBuffer(1138675766, 1, u8OutResult, &u8OutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == u8OutResult) u8OutResult = emalloc(1);
		u8OutResult[u8OutResult_len] = 0;
		RETURN_STRINGL(u8OutResult, u8OutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBase64BinaryParameter, set_Value)
{
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "z", &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLSOAPBase64BinaryParameter_set_Value(SBGetObjectHandle(getThis() TSRMLS_CC), aiValue.data, aiValue.len) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
	}
	else
	{
		SBErrorExpectsArguments("(array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPBase64BinaryParameter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPBase64BinaryParameter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBase64BinaryParameter_CreateFromXML_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBase64BinaryParameter_CreateFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBase64BinaryParameter_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBase64BinaryParameter_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBase64BinaryParameter_get_Value, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBase64BinaryParameter_set_Value, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPBase64BinaryParameter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPBase64BinaryParameter_methods[] = {
	PHP_ME(TElXMLSOAPBase64BinaryParameter, CreateFromXML_Inst, arginfo_TElXMLSOAPBase64BinaryParameter_CreateFromXML_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBase64BinaryParameter, CreateFromXML, arginfo_TElXMLSOAPBase64BinaryParameter_CreateFromXML, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPBase64BinaryParameter, Clone, arginfo_TElXMLSOAPBase64BinaryParameter_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBase64BinaryParameter, ClassType, arginfo_TElXMLSOAPBase64BinaryParameter_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPBase64BinaryParameter, get_Value, arginfo_TElXMLSOAPBase64BinaryParameter_get_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBase64BinaryParameter, set_Value, arginfo_TElXMLSOAPBase64BinaryParameter_set_Value, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPBase64BinaryParameter, __construct, arginfo_TElXMLSOAPBase64BinaryParameter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPBase64BinaryParameter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPBase64BinaryParameter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPBase64BinaryParameter", TElXMLSOAPBase64BinaryParameter_methods);
	if (NULL == TElXMLSOAPBaseParameter_ce_ptr)
		Register_TElXMLSOAPBaseParameter(TSRMLS_C);
	TElXMLSOAPBase64BinaryParameter_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPBaseParameter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPCompoundParameter_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, CreateFromXML_Inst)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCompoundParameter_CreateFromXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, CreateFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCompoundParameter_CreateFromXML(SBGetObjectHandle(oElement TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, Clone)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCompoundParameter_Clone(SBGetObjectHandle(getThis() TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, Add)
{
	zval *oParam;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oParam, TElXMLSOAPCustomParameter_ce_ptr) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oParam TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSOAPCustomParameter)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, AddString)
{
	char *sParamName;
	char *sParamNamespaceURI;
	char *sValue;
	int sParamName_len;
	int sParamNamespaceURI_len;
	int sValue_len;
	zend_bool bNormalizeNEL;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sParamName, &sParamName_len, &sValue, &sValue_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddString(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sValue, (int32_t)sValue_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sParamName, &sParamName_len, &sValue, &sValue_len, &bNormalizeNEL) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddString_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sValue, (int32_t)sValue_len, (int8_t)bNormalizeNEL, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sss", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &sValue, &sValue_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddString_2(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, sValue, (int32_t)sValue_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sssb", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &sValue, &sValue_len, &bNormalizeNEL) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddString_3(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, sValue, (int32_t)sValue_len, (int8_t)bNormalizeNEL, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, string) or (string, string, bool) or (string, string, string) or (string, string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, AddBoolean)
{
	char *sParamName;
	char *sParamNamespaceURI;
	int sParamName_len;
	int sParamNamespaceURI_len;
	zend_bool bValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sb", &sParamName, &sParamName_len, &bValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddBoolean(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, (int8_t)bValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssb", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &bValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddBoolean_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, (int8_t)bValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, bool) or (string, string, bool)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, AddInteger)
{
	char *sParamName;
	char *sParamNamespaceURI;
	int sParamName_len;
	int sParamNamespaceURI_len;
	long l4Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sParamName, &sParamName_len, &l4Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddInteger(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, (int32_t)l4Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssl", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &l4Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddInteger_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, (int32_t)l4Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer) or (string, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, AddInt64)
{
	char *sParamName;
	char *sParamNamespaceURI;
	int sParamName_len;
	int sParamNamespaceURI_len;
	long l8Value;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sl", &sParamName, &sParamName_len, &l8Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddInt64(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, (int64_t)l8Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssl", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &l8Value) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddInt64_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, (int64_t)l8Value, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, integer) or (string, string, integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, AddDouble)
{
	char *sParamName;
	char *sParamNamespaceURI;
	double dValue;
	int sParamName_len;
	int sParamNamespaceURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sd", &sParamName, &sParamName_len, &dValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddDouble(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, (double)dValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssd", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &dValue) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddDouble_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, (double)dValue, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, double) or (string, string, double)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, AddDateTime)
{
	char *sParamName;
	char *sParamNamespaceURI;
	int sParamName_len;
	int sParamNamespaceURI_len;
	zval *dtValue;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sO", &sParamName, &sParamName_len, &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddDateTime(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, SBGetDateTime(dtValue TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &dtValue, php_date_get_date_ce()) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddDateTime_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, SBGetDateTime(dtValue TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, DateTime) or (string, string, DateTime)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, AddBase64Binary)
{
	char *sParamName;
	char *sParamNamespaceURI;
	int sParamName_len;
	int sParamNamespaceURI_len;
	SBArrayZValInfo aiValue;
	zval *zaValue;
	if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "sz", &sParamName, &sParamName_len, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLSOAPCompoundParameter_AddBase64Binary(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, aiValue.data, aiValue.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if ((zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssz", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len, &zaValue) == SUCCESS) && ((IS_STRING == Z_TYPE_P(zaValue)) || (IS_ARRAY == Z_TYPE_P(zaValue)) || (IS_NULL == Z_TYPE_P(zaValue))))
	{
		int32_t l4OutResultRaw = 0;
		if (!SBGetByteArrayFromZVal(zaValue, &aiValue TSRMLS_CC)) RETURN_FALSE;
		SBCheckError(TElXMLSOAPCompoundParameter_AddBase64Binary_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, aiValue.data, aiValue.len, &l4OutResultRaw) TSRMLS_CC);
		SBFreeArrayZValInfo(&aiValue);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string, array of byte|string|NULL) or (string, string, array of byte|string|NULL)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, AddCompound)
{
	char *sParamName;
	char *sParamNamespaceURI;
	int sParamName_len;
	int sParamNamespaceURI_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sParamName, &sParamName_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddCompound(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ss", &sParamName, &sParamName_len, &sParamNamespaceURI, &sParamNamespaceURI_len) == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_AddCompound_1(SBGetObjectHandle(getThis() TSRMLS_CC), sParamName, (int32_t)sParamName_len, sParamNamespaceURI, (int32_t)sParamNamespaceURI_len, &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("(string) or (string, string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, Delete)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPCompoundParameter_Delete(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPCompoundParameter_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPCompoundParameter_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCompoundParameter_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCompoundParameter_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, ClassType)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCompoundParameter_ClassType(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPCompoundParameter_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, get_Items)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCompoundParameter_get_Items(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPCustomParameter_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPCompoundParameter, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPCompoundParameter_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_CreateFromXML_Inst, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_CreateFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_Clone, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_Add, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Param, TElXMLSOAPCustomParameter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_AddString, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, Value_or_ParamNamespaceURI)
	ZEND_ARG_INFO(0, NormalizeNEL_or_Value)
	ZEND_ARG_INFO(0, NormalizeNEL)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_AddBoolean, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, Value_or_ParamNamespaceURI)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_AddInteger, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, Value_or_ParamNamespaceURI)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_AddInt64, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, Value_or_ParamNamespaceURI)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_AddDouble, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, Value_or_ParamNamespaceURI)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_AddDateTime, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, Value_or_ParamNamespaceURI)
	ZEND_ARG_OBJ_INFO(0, Value, DateTime, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_AddBase64Binary, 0, 0, 2)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_TYPE_INFO(0, Value_or_ParamNamespaceURI, 0, 1)
	ZEND_ARG_TYPE_INFO(0, Value, 0, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_AddCompound, 0, 0, 1)
	ZEND_ARG_INFO(0, ParamName)
	ZEND_ARG_INFO(0, ParamNamespaceURI)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_Delete, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_ClassType, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter_get_Items, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPCompoundParameter___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPCompoundParameter_methods[] = {
	PHP_ME(TElXMLSOAPCompoundParameter, CreateFromXML_Inst, arginfo_TElXMLSOAPCompoundParameter_CreateFromXML_Inst, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, CreateFromXML, arginfo_TElXMLSOAPCompoundParameter_CreateFromXML, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPCompoundParameter, Clone, arginfo_TElXMLSOAPCompoundParameter_Clone, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, Add, arginfo_TElXMLSOAPCompoundParameter_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, AddString, arginfo_TElXMLSOAPCompoundParameter_AddString, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, AddBoolean, arginfo_TElXMLSOAPCompoundParameter_AddBoolean, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, AddInteger, arginfo_TElXMLSOAPCompoundParameter_AddInteger, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, AddInt64, arginfo_TElXMLSOAPCompoundParameter_AddInt64, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, AddDouble, arginfo_TElXMLSOAPCompoundParameter_AddDouble, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, AddDateTime, arginfo_TElXMLSOAPCompoundParameter_AddDateTime, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, AddBase64Binary, arginfo_TElXMLSOAPCompoundParameter_AddBase64Binary, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, AddCompound, arginfo_TElXMLSOAPCompoundParameter_AddCompound, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, Delete, arginfo_TElXMLSOAPCompoundParameter_Delete, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, Clear, arginfo_TElXMLSOAPCompoundParameter_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, LoadFromXML, arginfo_TElXMLSOAPCompoundParameter_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, SaveToXML, arginfo_TElXMLSOAPCompoundParameter_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, ClassType, arginfo_TElXMLSOAPCompoundParameter_ClassType, ZEND_ACC_PUBLIC | ZEND_ACC_STATIC)
	PHP_ME(TElXMLSOAPCompoundParameter, get_Count, arginfo_TElXMLSOAPCompoundParameter_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, get_Items, arginfo_TElXMLSOAPCompoundParameter_get_Items, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPCompoundParameter, __construct, arginfo_TElXMLSOAPCompoundParameter___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPCompoundParameter(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPCompoundParameter_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPCompoundParameter", TElXMLSOAPCompoundParameter_methods);
	if (NULL == TElXMLSOAPCustomParameter_ce_ptr)
		Register_TElXMLSOAPCustomParameter(TSRMLS_C);
	TElXMLSOAPCompoundParameter_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPCustomParameter_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPParametersManager_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPParametersManager, Add)
{
	char *sAParamName;
	char *sAParamNamespaceURI;
	int sAParamName_len;
	int sAParamNamespaceURI_len;
	zval *oAParamClass;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oAParamClass, TElXMLSOAPParameterClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPParametersManager_Add(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oAParamClass TSRMLS_CC)) TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ssO!", &sAParamName, &sAParamName_len, &sAParamNamespaceURI, &sAParamNamespaceURI_len, &oAParamClass, TElXMLSOAPParameterClass_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPParametersManager_Add_1(SBGetObjectHandle(getThis() TSRMLS_CC), sAParamName, (int32_t)sAParamName_len, sAParamNamespaceURI, (int32_t)sAParamNamespaceURI_len, SBGetObjectHandle(oAParamClass TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLSOAPParameterClass) or (string, string, TElXMLSOAPParameterClass)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPParametersManager, RemoveAt)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPParametersManager_RemoveAt(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPParametersManager, get_Count)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		int32_t l4OutResultRaw = 0;
		SBCheckError(TElXMLSOAPParametersManager_get_Count(SBGetObjectHandle(getThis() TSRMLS_CC), &l4OutResultRaw) TSRMLS_CC);
		RETURN_LONG((long)l4OutResultRaw);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPParametersManager, get_ParamNames)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPParametersManager_get_ParamNames(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-601338353, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPParametersManager, get_ParamNamespaceURIs)
{
	long l4Index;
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPParametersManager_get_ParamNamespaceURIs(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-966225287, 2, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPParametersManager, get_ParamClasses)
{
	long l4Index;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "l", &l4Index) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPParametersManager_get_ParamClasses(SBGetObjectHandle(getThis() TSRMLS_CC), (int32_t)l4Index, &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPParameterClass_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPParametersManager, __construct)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPParametersManager_Create(&hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPParametersManager_Add, 0, 0, 1)
	ZEND_ARG_TYPE_INFO(0, AParamClass_or_AParamName, 0, 1)
	ZEND_ARG_INFO(0, AParamNamespaceURI)
	ZEND_ARG_OBJ_INFO(0, AParamClass, TElXMLSOAPParameterClass, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPParametersManager_RemoveAt, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPParametersManager_get_Count, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPParametersManager_get_ParamNames, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPParametersManager_get_ParamNamespaceURIs, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPParametersManager_get_ParamClasses, 0, 0, 1)
	ZEND_ARG_INFO(0, Index)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPParametersManager___construct, 0, 0, 0)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPParametersManager_methods[] = {
	PHP_ME(TElXMLSOAPParametersManager, Add, arginfo_TElXMLSOAPParametersManager_Add, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPParametersManager, RemoveAt, arginfo_TElXMLSOAPParametersManager_RemoveAt, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPParametersManager, get_Count, arginfo_TElXMLSOAPParametersManager_get_Count, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPParametersManager, get_ParamNames, arginfo_TElXMLSOAPParametersManager_get_ParamNames, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPParametersManager, get_ParamNamespaceURIs, arginfo_TElXMLSOAPParametersManager_get_ParamNamespaceURIs, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPParametersManager, get_ParamClasses, arginfo_TElXMLSOAPParametersManager_get_ParamClasses, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPParametersManager, __construct, arginfo_TElXMLSOAPParametersManager___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPParametersManager(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPParametersManager_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPParametersManager", TElXMLSOAPParametersManager_methods);
	if (NULL == TObject_ce_ptr)
		Register_TObject(TSRMLS_C);
	TElXMLSOAPParametersManager_ce_ptr = zend_register_internal_class_ex(&ce, TObject_ce_ptr, NULL TSRMLS_CC);
}

zend_class_entry *TElXMLSOAPFault_ce_ptr = NULL;

SB_PHP_METHOD(TElXMLSOAPFault, Clear)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		SBCheckError(TElXMLSOAPFault_Clear(SBGetObjectHandle(getThis() TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPFault, LoadFromXML)
{
	zval *oElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oElement, TElXMLDOMElement_ce_ptr) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPFault_LoadFromXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oElement TSRMLS_CC)) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMElement)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPFault, SaveToXML)
{
	zval *oDocument;
	zval *oFormatter;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!", &oDocument, TElXMLDOMDocument_ce_ptr, &oFormatter, TElXMLCustomFormatter_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPFault_SaveToXML(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), SBGetObjectHandle(oFormatter TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!", &oDocument, TElXMLDOMDocument_ce_ptr) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPFault_SaveToXML_1(SBGetObjectHandle(getThis() TSRMLS_CC), SBGetObjectHandle(oDocument TSRMLS_CC), &hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLDOMElement_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(TElXMLDOMDocument, TElXMLCustomFormatter) or (TElXMLDOMDocument)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPFault, get_FaultActor)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPFault_get_FaultActor(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(-1822930881, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPFault, set_FaultActor)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPFault_set_FaultActor(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPFault, get_FaultCode)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPFault_get_FaultCode(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1488152671, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPFault, set_FaultCode)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPFault_set_FaultCode(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPFault, get_FaultString)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPFault_get_FaultString(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1047271359, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPFault, set_FaultString)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPFault_set_FaultString(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPFault, get_Detail)
{
	uint32_t _err;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		char *sOutResult = NULL;
		int32_t sOutResult_len = 0;
		_err = TElXMLSOAPFault_get_Detail(SBGetObjectHandle(getThis() TSRMLS_CC), sOutResult, &sOutResult_len);
		if (SB_ERROR_INSUFFICIENT_BUFFER_SIZE == _err)
		{
			sOutResult = emalloc(sOutResult_len + 1);
			SBCheckError(SBGetLastReturnStringA(1694189969, 1, sOutResult, &sOutResult_len) TSRMLS_CC);
		}
		else
		if (_err != SB_ERROR_OK)
		{
			SBThrowException(_err TSRMLS_CC);
			RETURN_FALSE;
		}
	
		if (NULL == sOutResult) sOutResult = emalloc(1);
		sOutResult[sOutResult_len] = 0;
		RETURN_STRINGL(sOutResult, sOutResult_len, 0);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPFault, set_Detail)
{
	char *sValue;
	int sValue_len;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "s", &sValue, &sValue_len) == SUCCESS)
	{
		SBCheckError(TElXMLSOAPFault_set_Detail(SBGetObjectHandle(getThis() TSRMLS_CC), sValue, (int32_t)sValue_len) TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(string)" TSRMLS_CC);
	}
}

SB_PHP_METHOD(TElXMLSOAPFault, __construct)
{
	char *sAName;
	char *sANamespaceURI;
	int sAName_len;
	int sANamespaceURI_len;
	long fAVersion;
	zval *oBeforeChild;
	zval *oParentElement;
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "ls", &fAVersion, &sANamespaceURI, &sANamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPFault_Create((TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "lss", &fAVersion, &sANamespaceURI, &sANamespaceURI_len, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPFault_Create_1((TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!ls", &oParentElement, TElXMLDOMElement_ce_ptr, &fAVersion, &sANamespaceURI, &sANamespaceURI_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPFault_Create_2(SBGetObjectHandle(oParentElement TSRMLS_CC), (TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "O!O!lss", &oParentElement, TElXMLDOMElement_ce_ptr, &oBeforeChild, TElXMLDOMElement_ce_ptr, &fAVersion, &sANamespaceURI, &sANamespaceURI_len, &sAName, &sAName_len) == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(TElXMLSOAPFault_Create_3(SBGetObjectHandle(oParentElement TSRMLS_CC), SBGetObjectHandle(oBeforeChild TSRMLS_CC), (TSBXMLSOAPVersionRaw)fAVersion, sANamespaceURI, (int32_t)sANamespaceURI_len, sAName, (int32_t)sAName_len, &hoOutResult) TSRMLS_CC);
		SBSetObjectHandle(getThis(), hoOutResult, ohTrue TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("(integer, string) or (integer, string, string) or (TElXMLDOMElement, integer, string) or (TElXMLDOMElement, TElXMLDOMElement, integer, string, string)" TSRMLS_CC);
	}
}

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPFault_Clear, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPFault_LoadFromXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Element, TElXMLDOMElement, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPFault_SaveToXML, 0, 0, 1)
	ZEND_ARG_OBJ_INFO(0, Document, TElXMLDOMDocument, 1)
	ZEND_ARG_OBJ_INFO(0, Formatter, TElXMLCustomFormatter, 1)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPFault_get_FaultActor, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPFault_set_FaultActor, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPFault_get_FaultCode, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPFault_set_FaultCode, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPFault_get_FaultString, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPFault_set_FaultString, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPFault_get_Detail, 0, 0, 0)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPFault_set_Detail, 0, 0, 1)
	ZEND_ARG_INFO(0, Value)
ZEND_END_ARG_INFO()

ZEND_BEGIN_ARG_INFO_EX(arginfo_TElXMLSOAPFault___construct, 0, 0, 2)
	ZEND_ARG_TYPE_INFO(0, AVersion_or_ParentElement, 0, 1)
	ZEND_ARG_TYPE_INFO(0, ANamespaceURI_or_AVersion_or_BeforeChild, 0, 1)
	ZEND_ARG_INFO(0, AName_or_ANamespaceURI_or_AVersion)
	ZEND_ARG_INFO(0, ANamespaceURI)
	ZEND_ARG_INFO(0, AName)
ZEND_END_ARG_INFO()

static zend_function_entry TElXMLSOAPFault_methods[] = {
	PHP_ME(TElXMLSOAPFault, Clear, arginfo_TElXMLSOAPFault_Clear, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPFault, LoadFromXML, arginfo_TElXMLSOAPFault_LoadFromXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPFault, SaveToXML, arginfo_TElXMLSOAPFault_SaveToXML, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPFault, get_FaultActor, arginfo_TElXMLSOAPFault_get_FaultActor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPFault, set_FaultActor, arginfo_TElXMLSOAPFault_set_FaultActor, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPFault, get_FaultCode, arginfo_TElXMLSOAPFault_get_FaultCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPFault, set_FaultCode, arginfo_TElXMLSOAPFault_set_FaultCode, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPFault, get_FaultString, arginfo_TElXMLSOAPFault_get_FaultString, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPFault, set_FaultString, arginfo_TElXMLSOAPFault_set_FaultString, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPFault, get_Detail, arginfo_TElXMLSOAPFault_get_Detail, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPFault, set_Detail, arginfo_TElXMLSOAPFault_set_Detail, ZEND_ACC_PUBLIC)
	PHP_ME(TElXMLSOAPFault, __construct, arginfo_TElXMLSOAPFault___construct, ZEND_ACC_CTOR | ZEND_ACC_PUBLIC)
	PHP_FE_END
};

void Register_TElXMLSOAPFault(TSRMLS_D)
{
	zend_class_entry ce;
	if (TElXMLSOAPFault_ce_ptr != NULL)
		return;

	INIT_CLASS_ENTRY(ce, "TElXMLSOAPFault", TElXMLSOAPFault_methods);
	if (NULL == TElXMLSOAPElement_ce_ptr)
		Register_TElXMLSOAPElement(TSRMLS_C);
	TElXMLSOAPFault_ce_ptr = zend_register_internal_class_ex(&ce, TElXMLSOAPElement_ce_ptr, NULL TSRMLS_CC);
}

SB_PHP_FUNCTION(SBXMLSOAPClient, SOAPParametersManager)
{
	if (zend_parse_parameters_ex(ZEND_PARSE_PARAMS_QUIET, ZEND_NUM_ARGS() TSRMLS_CC, "") == SUCCESS)
	{
		TElClassHandle hoOutResult = NULL;
		SBCheckError(SBXMLSOAPClient_SOAPParametersManager(&hoOutResult) TSRMLS_CC);
		SBInitObject(return_value, TElXMLSOAPParametersManager_ce_ptr, hoOutResult TSRMLS_CC);
	}
	else
	{
		SBErrorExpectsArguments("()" TSRMLS_CC);
	}
}

void Register_SBXMLSOAPClient_Enum_Flags(TSRMLS_D)
{
	zend_class_entry ce;
	INIT_CLASS_ENTRY(ce, "TSBXMLSOAPResponseType", NULL);
	TSBXMLSOAPResponseType_ce_ptr = zend_register_internal_class_ex(&ce, TSBBaseEnum_ce_ptr, NULL TSRMLS_CC);
	TSBXMLSOAPResponseType_ce_ptr->ce_flags |= ZEND_ACC_FINAL_CLASS;
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLSOAPResponseType_ce_ptr, "srtNone", 0)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLSOAPResponseType_ce_ptr, "srtStream", 1)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLSOAPResponseType_ce_ptr, "srtXMLDocument", 2)
	SB_DECLARE_CLASS_LONG_CONST(TSBXMLSOAPResponseType_ce_ptr, "srtSOAPMessage", 3)
}

void Register_SBXMLSOAPClient_Aliases(TSRMLS_D)
{
	if (NULL == TElXMLSOAPClient_ce_ptr)
		Register_TElXMLSOAPClient(TSRMLS_C);
	zend_register_class_alias("ElXMLSOAPClient", TElXMLSOAPClient_ce_ptr);
	TElXMLSOAPParameterClass_ce_ptr = TObject_ce_ptr;
	zend_register_class_alias("TElXMLSOAPParameterClass", TElXMLSOAPParameterClass_ce_ptr);
}

